﻿(()=>{
//REPLACE_ITEMS_START//
//version=1.5.6//
class RIF {
    static Match(string, replaceMatch, rString) {
        return ((replaceMatch === 'full' && string === rString) || (replaceMatch === 'inc' && string.includes(rString)) || false)
    }
    constructor(input = {}) {
        this.items = [document]
        this.mode = input.mode || 'text'
        this.match = input.match || 'full'
        this.replaceFunctions = input.func || []
        this.fullReplace = input.full || false
    }
    st = (obj) => {
        this.mode = obj.mode || this.mode
        this.match = obj.match || this.match
        this.replaceFunctions = obj.func ? [...this.replaceFunctions, ...obj.func] : this.replaceFunctions
        this.fullReplace = obj.full || this.fullReplace
    }
    get before() {
        this.items = this.items
            .filter(item => item && item.previousElementSibling)
            .map(item => item.previousElementSibling);
        return this
    }
    get next() {
        this.items = this.items
            .filter(item => item && item.nextElementSibling)
            .map(item => item.nextElementSibling);
        return this
    }
    get first() {
        this.items = this.items
            .filter(item => item && item.firstElementChild)
            .map(item => item.firstElementChild);
        return this
    }
    get all() {
        this.items = this.items
            .filter(item => item && item.children && item.children.length)
            .map(item => Array.from(item.children))
            .reduce((acc, children) => acc.concat(children), []);
        return this
    }
    index = (index) => {
        this.items = this.items
            .filter(item => item && item.children && item.children.length)
            .map(item => item.children[index]);
        return this
    }
    haveStyle = (styles) => {
        this.items = this.items
            .filter(item => { try { let style_ = item.getAttribute("style"); return style_ && style_.includes(styles) } catch { return false } });
        return this
    }
    isStyle = (styles) => {
        this.items = this.items
            .filter(item => { try { let style_ = item.getAttribute("style"); return style_ && (style_ === styles) } catch { return false } });
        return this
    }
    isClass = (ClassList) => {
        this.items = this.items
            .filter(item => item && item.classList === ClassList);
        return this
    }
    isId = (Id) => {
        this.items = this.items
            .filter(item => item && item.id === Id);
        return this
    }
    class = (className) => {
        this.items = this.items
            .filter(item => (item))
            .map(item => Array.from(item.querySelectorAll(`.${className}`)))
            .reduce((acc, children) => acc.concat(children), []);
        return this
    }
    id = (idValue) => {
        this.items = this.items
            .filter(item => (item))
            .map(item => Array.from(item.querySelectorAll(`#${idValue}`)))
            .reduce((acc, children) => acc.concat(children), []);
        return this
    }
    hasHtml = (html) => {
        if (html === '*') { return this }

        this.items = this.items
            .filter(item => (item.innerHTML.includes(html)))
        return this
    }
    isHtml = (html) => {
        this.items = this.items
            .filter(item => (item.innerHTML === html))
        return this
    }
    get fontCN() {
        this.replaceFunctions.push((div) => {
            div.style.fontFamily = "Noto Sans SC"
        })
        return this
    }


    REPLACE = (replaceObject) => {
        let mode = (
            (this.mode === 'html') ? 'innerHTML' :
                (this.mode === 'text') ? 'textContent' :
                    'error'
        )
        if (mode == 'error') { console.log('mode错误:', this.mode) }

        for (const [key, value] of Object.entries(replaceObject)) {
            this.items.forEach(item => {
                if (item && RIF.Match(item[mode], this.match, key)) {
                    if (this.match === 'full') {
                        item[mode] = value
                    } else if (this.match === 'inc') {
                        if (this.fullReplace) { item[mode] = value } else {
                            item[mode] = item[mode].replace(new RegExp(`${key}`, 'g'), value)
                        }
                    }
                    this.replaceFunctions.forEach(func => func(item))
                    window.__LOGGING__ += 1
                }
            })
        }
    }
    get click() {
        this.items.forEach(item => {
            const allProps = Object.keys(item);
            for (const prop of allProps) {
                if (prop.startsWith('__reactProps')) {
                    try { item[prop].onClick() } catch { }
                }
            }
        })
    }
    get enable() {
        this.items = this.items.forEach(item => {
            if (!(item.classList.contains(this.STATE))) { this.click }
        })
        return this
    }
    get disable() {
        this.items = this.items.forEach(item => {
            if (item.classList.contains(this.STATE)) { this.click }
        })
        return this
    }
    state = (STATE) => {
        this.STATE = STATE
        return this
    }
    get q() {
        const self = this
        return {
            to: (html) => {
                return {
                    get select() {
                        return self.class('button_KVN.button_KVN.multi-select_Roq').hasHtml(html).state('selected');
                    },
                    get CGE_chicked() {
                        return self.class('title_vqR').hasHtml(html).before.class('toggle_cca.item-mouse-states_Fmi.toggle_CGE').state('checked')
                    },
                    CGE_value: (value) => {
                        self.class('title_vqR').hasHtml(html).next.class('input_JvC.item-states_QjV')
                        self.items = self.items.forEach(item => {
                            item.value = value
                        })
                        return self
                    },
                    get obj() {
                        self.class('editor-item_VnW.editor-item-base_sYx.editor-widget_QQl').first.first.isHtml(html).next.state('checked')
                        return self
                    },
                    get clear() {
                        return self.class('button_WPv.button_dLA').hasHtml(html)
                    },
                    get picker() {
                        return self.class('picker-toggle_d6k')
                    }
                };
            }
        };
    }
}

function rif(...args) { return new RIF(...args) }
function RE(...args) {
    return args.reduce((result, value, index, array) => {
        if (index % 2 === 0) {
            const key = array[index];
            const val = array[index + 1];
            result.set(key, val);
        }
        return result;
    }, new Map());
}
function replaceContent() {
    window.__LOGGING__ = 0
    let addinfo = ''

    let time1 = new Date().getTime()
    try {
        const MAIN = {
            主界面: {
                版本: rif({ match: 'inc' }).class('version_VJt')
            },
            悬浮框: {
                标题: rif().class('balloon_qJY.balloon_H23.up_ehW.center_hug.anchored-balloon_AYp.up_el0').class('title_lCJ'),
                内容: rif().class('balloon_qJY.balloon_H23.up_ehW.center_hug.anchored-balloon_AYp.up_el0').class('paragraphs_nbD.description_dNa').first,
                提示: rif().class('tooltip-fade-in_S9n'),
                提示2: rif().class('value_uLz')
            },
            工具框: {
                标签: rif().class('tool-options-panel_Se6').class('label_RZX'),
                值: rif().class('tool-options-panel_Se6').class('number-field__Hd')
            },
            设置: {
                选项: rif().class('menu_hb1.child-opacity-transition_nkS').class('item_pq7.primary_Q54').first,
                标签: rif().class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('content_gqa').class('label_DGc.label_ZLb'),
                分类: rif().class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('breadcrumbs_xcd').class('label_sAz.label-level-1'),
                标题: rif().class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-title_a3p'),
                描述: rif().class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-description_wwd'),
                TAB: rif().class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('tab_P7S')
            },
            下拉框: {
                标签: rif().class('dropdown-item_sZT'),
                值: rif().class('dropdown-toggle_V9z').class('label_l_4')
            },
            按钮: rif().class('button_WWa.button_SH8'),
            工具栏: {
                资产详情: {
                    标题: rif().class('asset-detail-panel_hf8.detail-panel_izf').class('title-bar_I7O.child-opacity-transition_nkS').class('title_qub'),
                    描述: rif().class('asset-detail-panel_hf8.detail-panel_izf').class('content_rep.row_H0d.child-opacity-transition_nkS').class('column_dTT').class('paragraphs_nbD.description_ZQn').first
                }
            }
        }
        const 开发者模式 = {
            顶栏: {
                按钮: rif().class('tab-bar_b_c').class('button_BNH').fontCN
            },

            内容: {
                标签: rif().class('content_gqa').class('label_KyX').fontCN,
                按钮: rif().class('content_gqa').class('button_k8s').fontCN,
                标题: rif().class('content_gqa').class('title_Xkf').fontCN,
                值: rif().class('content_gqa').class('value_fMT').fontCN,
                折叠: rif().class('content_gqa').class('label_qS_').fontCN,
                控制值: rif().class('content_gqa').class('control_b3l').fontCN,
            }
        }
        const HOOKUI = {
            顶栏: {
                名称: rif({ mode: 'html', match: 'inc' }).class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_B8G')
            },
            面板: {
                标题: rif().class('title-bar_PF4').class('title_SVH.title_zQN'),
                内容: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS'),
                标签: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('label_DGc.label_ZLb'),
                标签2: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_S2v'),
                标签_p: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_S2v').all,
                头: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('header_Ld7'),
                头描述: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('header_MP_.header_8H_'),
                项目: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('header-content_SqG.header-content_wUX').all,
            }
        }
        const REPLACE_ITEM_NEW = {
            开发者模式_模拟: RE(
                [开发者模式.内容.标签], {
                'Active tool': '激活工具',
                'Selected': '选中',
                'Taxi Starting Fee': '出租车起步价',
                'High-Speed Highways': '高速公路',
                'Advanced Pollution Management': '高级污染管理',
                'PreRelease Programs': '释前教育',
                'City Promotion': '城市宣传',
                'Allow gameplay manipulation': '允许游戏中操控',
                'Debug toggle': '调试选中',
                'Bypass validation results': '无碰撞',
                'Sim speed': '模拟速度',
                'Smooth speed': '平滑速度',
                'Interpolation offset': '插值偏移',
                'Step Time (ms)': '步进时间 (ms)',
                'Disable trips': '禁用行程',
                'Debug Lifepath Chirps ': '调试生命周期轨迹',
                'Birth Chance': '出生几率',

                'Atmosphere': '大气层',
                'Biome': '生态群落',
                'Water sim speed': '水模拟速度',
                'Time step override': '时间步长',
                'Time Step': '时间步长',
                'Current Time Step': '当前时间步长',
                'Max Velocity': '最大速度',
                'Use Active Cells Culling': '使用活动单元剔除',
                'Water Grid Size Multiplier': '水格大小',
                'Water grid size': '水格大小',
                'Flow number of Downscale': '流动降尺度数量',
                'Blur flow': '流动模糊',
                'Flow limiter for render': '流动渲染限制器',
                'Max Water Flow Length for render': '最大渲染水流长度',
                'Water Flow Render Multiplier': '水流渲染倍增',
                'Climate time': '气候时间',
                'Override Climate time': '气候时间 覆盖',
                'Current climate': '当前气候',
                'Current season': '当前季节',
                'Temperature': '温度',
                'Override Temperature': '覆盖 温度',
                'Snow sim speed': '雪模拟速度',
                'Cloudiness': '云',
                'Override Cloudiness': '云 覆盖',
                'Aurora': '极光',
                'Override Aurora': '极光 覆盖',
                'Precipitation volume scale': '降水量比例',
                'Global VFX time from Simulation time': '全局视觉效果时间与模拟时间关联',
                'Weather VFX time from Simulation time': '天气视觉效果时间与模拟时间关联',
                'Temperature Electricity Consumption Multiplier': '气温电力消耗倍增',
                'Time/Date': '时间/日期',
                'Latitude': '纬度',
                'Longitude': '经度',
                'Day of year': '天 (年)',
                'Day of year (Moon)': '天 (日夜)',
                'Time of day': '时间',
                'Time of day multiplier': '时间流速倍增',
                'Number of lunar cycles per year': '每年的月球周期数',
                'Override time for debug': '时间 覆盖',
                'Superfast building spawning': '超快速建筑生成',
                'Superfast area-prop spawning': '超快速区域道具生成',
                'Superfast leveling': '超快速平整',
                'Select entity': '选择实体',
                'Water Pipe Fluid Flow': '水管液体流动',
                'Disable Water consumption': '禁用水消耗',
                'Disable Sewage generation': '禁用污水生成',
                'Ground Multiplier': '地面污染',
                'Ground Radius': '地面污染范围',
                'Air Radius': '空气污染范围',
                'Noise Radius': '噪音污染范围',
                'Net Noise Radius': '道路 噪音污染范围',
                'Net Noise Multiplier': '道路 噪音污染',
                'Net Air Multiplier': '道路 空气污染',
                'Air Multiplier': '空气污染',
                'Noise Multiplier': '噪音污染',
                'Wind Advection Speed': '风平流速度',
                'Air Fade': '空气污染消退',
                'Ground Fade': '地面污染消退',
                'Plant Air Multiplier': '植物 空气污染倍增',
                'Plant Ground Multiplier': '植物 地面污染倍增',
                'Plant Fade': '植物 消退',
                'Fertility Ground Multiplier': '沃土 地面污染',
                'Distance Expotent': '距离指数',
                'Danger Level': '危险等级',
                'Precipitation': '降水',
                'Override Precipitation': '降水 覆盖',
                'Average temperature': '平均温度',
                'Average precipitation': '平均降水量',
                'Average cloudiness': '平均多云程度',
                'Yearly average temperature': '年均温度',
                'Freezing temperature': '冰点温度',
                'Temperature base height': '温度基准',
                'Snap existing geometry': '对齐现有物体',
                'Snap 90 degree angles': '对齐90度角',
                'Snap road side': '对齐道路两侧',
                'Snap building side': '对齐建筑两侧',
                'Bypass confirmation': '跳过确认',
                'Type': '类别',
                'Mode': '模式',
                'Overwrite existing zone': '覆盖现有区域',
                'Snap cell length': '对齐单元格长度',

            },
                [开发者模式.内容.标题], {
                'Climate time': '气候时间',
                'Temperature': '温度',
                'Precipitation': '降水',
                'Cloudiness': '云',
                'Aurora': '极光'
            },
                [开发者模式.内容.按钮], {
                'Save game': '保存游戏',
                'Load game': '加载游戏',
                'Remove residents/vehicles': '移除居民/车辆',
                'Cleanup obsolete entities': '清理过时实体',

                'Save water': '保存水',
                'Load water': '加载水',
                'Restart water': '重启水',
                'Water to sealevel': '水位调整为海平面(危险)',
                'Reload Water Sources': '重新加载水源(危险)',
                'Override Temperature': '气温',
                'Advance time 1h': '提前1小时',
                'Advance time 12h': '提前12小时',
                'Advance time 6d': '提前6天',
                'Give max resource': '获取最大资源',
                'Print age debug': '打印年龄调试信息',
                'Print school debug': '打印学校调试信息',
                'Print company debug': '打印公司调试信息',
                'Print trade debug': '打印贸易调试信息',
                'Remove extra companies': '移除额外的公司',
                'Print null households': '打印空户调试信息',
                'Calc customers': '计算顾客',
                'Calc eligible': '计算符合条件者',
                'Calc students from OC': '计算OC中的学生',
                'Happiness factors': '幸福因素',
                'Reset land value': '重置土地价值',
                'Reset rents': '重置租金',
                'Reset services': '重置服务',
                'Reset trade costs': '重置贸易成本',
                'Reset transfers': '重置转账',
                'Reset trip neededs': '重置行程需求',
                'Reset storages': '重置存储',
                'Follow selected citizen': '跟随选定居民',
                'Age selected citizen': '年龄调整选定居民',
                'Trigger Test Life Event': '触发测试生活事件',
                'Discard statistics': '丢弃统计信息',
                'Print commuter distribution': '打印通勤分布',
                'Reset Electricity': '重置电力',
                'Reset pollution': '重置污染',
                'Traveling': '旅行中',
                'VisitAttractions': '参观景点',
                'Sightseeing': '观光',
                'Lightning Strike': '雷击',
                'Valentines Day': '情人节',
                'Flood': '洪水',
                'Tsunami': '海啸',
                'Tornado': '龙卷风',
                'Rocket Launch': '火箭发射',
                'Building Collapse': '建筑倒塌',
                'Robbery': '抢劫',
                'Generic Sickness': '一般疾病',
                'Sudden Death': '突然死亡',
                'Severe Injury': '严重伤害',
                'Hail Storm': '冰雹风暴',
                'Lose Control Accident': '失控事故',
                'Forest Fire': '森林火灾',
                'Building Fire': '建筑火灾',
                'Export heightmap': '导出高程图',
                'Create Chirps': '创建轨迹',
                'Check property rent errors': '检查租金错误',
                'Fix property rent errors': '修复租金错误',
                'Fix invalid Enabled Effects': '修复无效的启用效果',
                'Remove snow': '移除雪',
                'Save Wind': '保存风',
                'Load Wind': '加载风',
                'Reset Wind': '重置风',
                'Select next': '选择下一个',
            },
                [开发者模式.内容.值], {
                'Default Tool': '默认工具',
                'Area Tool': '区域工具',
                'Bulldoze Tool': '推土机',
                'Upgrade Tool': '升级工具',
                'Anarchy Tool': '无碰撞工具',
                'Tree 控制ler Tool': '树木控制器',
                'Line Tool': '条形工具',
                'Zone Tool': '功能区工具',
                'Water Tool': '水源工具',
                'Flood Fill': '填充',
                'Marquee': '滚动',
                'Paint': '涂刷'
            },
                [开发者模式.内容.折叠], {
                'Policies': '政策',
                'Diversity': '多样性',
                'Water': '水',
                'Weather & climate': '天气 与 气候',
                'Electricty & Water': '电力 与 水资源',
                'Time': '时间',
                'Economy': '经济',
                'Pollution': '污染',
                'Start event': '开始事件',
                'Terrain': '地形',
                'Triggers': '触发器',
                'Error Check': '错误检查',
                'Season stats': '季节统计',
                'Temperature stats': '温度统计'
            },
                [开发者模式.内容.控制值], {
                'Atmosphere1Prefab': '大气层1预制体',
                'GrasslandBiomePrefab': '草原生态群落预制体',
                'ContinentalCorralRichesClimate': '大陆牧场富饶气候',
                'TemperateSanFranciscoClimate': '温和的旧金山气候',
                'TemperateArchipelagoHavenClimate': '温和的群岛避风港气候',
                'TemperateRiverDeltaClimate': '温带河口气候',
                'SeasonSummer': '夏季季节',
                'Oil Lot - Navigation': '石油地块 - 导航',
                'Ore Lot - Navigation': '矿石地块 - 导航',
                'Agriculture Lot - Field': '农业地块 - 田地',
                'Oil Lot': '石油区域',
                'Ore Lot': '矿石区域',
                'Agriculture Lot': '农业区域',
                'Forestry Lot': '林业区域',
                'Extractor Lot': '提取器区域',
                'District Area': '市辖区域',
                'Clear Area': '清除区域',
                'Clip Surface': '裁剪地面',
                'Walking Area': '行走区域',
                'Map Tile': '地图瓦片',
                'Water Tile': '水瓦片',
                'Hangaround Area': '待遇区域',
                'Park Area': '公园区域',
                'Gympark Area': '健身公园区域',
                'Placeholder': ' 占位符',
                'Oil Surface Placeholder': '石油地面',
                'Ore Surface Placeholder': '矿石地面',
                'Agriculture Surface': '农业地面',
                'Concrete Surface': '混凝土地面',
                'Grass Surface': '草地地面',
                'Pavement Surface': '人行道地面',
                'Sand Surface': '沙地地面',
                'Tiles Surface': '瓷砖地面',
                'Forestry Surface': '林业地面',
                'Landfill Surface': '垃圾填埋地面',
                'Oil Surface 01': '石油地面',
                'Ore Surface 01': '矿石地面',
                'Landfill Site Lot': '垃圾填埋场区域',
            }
            ),
            开发者模式_游戏玩法: RE(
                [开发者模式.内容.标签], {
                'Tutorials enabled': '启用教程',
                'Freeze tutorials': '冻结教程',
                'Active tutorial list': '当前教程列表',
                'Active tutorial': '当前教程',
                'Show developer info': '显示开发者信息',
                'Show unspawned objects': '显示未生成的对象',
                'Show markers': '显示标记',
                'Lefthand traffic': '靠左行驶',
                'Default theme': '默认主题',
                'Hospital service fee': '医院服务费',
                'Basic education service fee': '基础教育服务费',
                'Secondary education service fee': '中等教育服务费',
                'Higher education service fee': '高等教育服务费',
                'Water usage fee': '水费',
                'Garbage collection fee': '垃圾清理费',
                'Electricity fee': '电费',
                'Public transport fee': '公共交通费'
            },
                [开发者模式.内容.按钮], {
                'Skip tutorial phase': '跳过教程阶段',
                'Show all tutorials in advisor': '在顾问中显示所有教程',
                'Skip active tutorial list': '跳过当前教程列表',
                'Select next theme': '选择下一个主题',
                'Unlock all': '解锁全部',
                'Get 200 XP': '获取200经验值',
                'Next MS': '下一个MS',
                'Get 500k money': '获得500,000钱',
            },
                [开发者模式.内容.控制值], {
                'North American': '北美',
                'European': '欧洲'
            }
            ),
            开发者模式_渲染: RE(
                [开发者模式.内容.标签], {
                'Fullscreen Debug Mode': '全屏调试模式',
                'Max Overdraw Count': '最大过度绘制计数',
                'Max Quad Cost': '最大四边形成本',
                'Max Vertex Density': '最大顶点密度',
                'Min Motion Vector Length (in pixels)': '运动矢量长度（以像素为单位）',
                'Mip Maps': 'Mip贴图',
                'Terrain Texture': '地形纹理',
                'False Color Mode': '伪彩模式',
                'Freeze Camera For Culling': '冻结摄像头以进行剔除',
                'Waveform': '波形',
                'Exposure': '曝光',
                'Parade mode': '巡游模式',
                'Vectorscope': '矢量范围',
                'Size': '大小',
                'NVUnityPlugin Version': 'NVUnity插件版本',
                'NGX API Version': 'NGX API版本',
                'Device Status': '设备状态',
                'DLSS Supported': 'DLSS支持',
                'DLSS Injection Point': 'DLSS注入点',
                'Clear Render Targets At Creation': '在创建时清除渲染目标',
                'Disable Pass Culling': '禁用通行剔除',
                'Immediate Mode': '即时模式',
                'Enable Logging': '启用日志记录',
            },
                [开发者模式.内容.值], {
                'Control': '控制',
                'No Visible Camera': '无可见摄像头'
            },
                [开发者模式.内容.标题], {
                'Color Monitors': '色彩监视器',
                '#WaveformContainer': '波形容器',
                '#VectorscopeContainer': '矢量范围容器',
                'NVIDIA device debug view': 'NVIDIA设备调试视图',
                'HDRP Render Graph': 'HDRP渲染图',
                'DLSS Slot ID': 'DLSS 槽位 ID',
                'Status': '状态',
                'Input resolution': '输入分辨率',
                'Output resolution': '输出分辨率',
                'Quality': '质量',
            },
                [开发者模式.内容.按钮], {
                'Log Frame Information': '记录帧信息',
                'Log Resources': '记录资源'
            },
            ),
            开发者模式_游戏渲染: RE(
                [开发者模式.内容.标签], {
                'Texture Debug Mode': '纹理调试模式',
                'Entity culling': '实体剔除',
                'Effect culling': '效果剔除',
                'Batch allocation': '批量分配',
                'Batch upload': '批量上传',
                'Batch groups': '批量分组',
                'Batch renderers': '批量渲染器',
                'Batch materials': '批量材质',
                'Batch meshes': '批量网格',
                'Area triangle buffer': '区域三角形缓冲',
                'Procedural skeleton buffer': '程序骨架缓冲',
                'Procedural skeleton upload': '程序骨架上传',
                'Procedural emissive buffer': '程序自发光缓冲',
                'Procedural emissive upload': '程序自发光上传',
                'Animation shape buffer': '动画形状缓冲',
                'Animation bone buffer': '动画骨骼缓冲',
                'Animation frame buffer': '动画帧缓冲',
                'Animation index buffer': '动画索引缓冲',
                'Animation meta buffer': '动画元数据缓冲',
                'Level of detail': '细节级别',
                'Disable lod models': '禁用LOD模型',
                'Disable mesh loading': '禁用网格加载',
                'Force mesh unloading': '强制卸载网格',
                'Strict mesh memory budget': '严格的网格内存限制',
                'Long cross fade': '淡入淡出',
                'Debug': '调试',
                'Punctual Lights': '点光源',
                'Max Punctual Lights': '最大 点光源 数量',
                'Punctual Lights Cookies': '点光源 Cookies',
                'Enable Min-Max light culling optim': '启用最小-最大点光源光照剔除优化',
                'Max Distance Culling Scale': '最大距离剔除比例',
                'Min Distance Culling Scale': '最小距离剔除比例',
                'Number of punctual lights': '点光源数量',
                'Tri count': '三角形数量',
                'Foliage': '植被',
                'DebugBlit': '调试Blit',
                'Tunnel Pass': '隧道通道',
                'Outlines Pass': '轮廓通道',
                'Dynamic Resolution': '动态分辨率',
                'Upscale Filter': '升采样滤镜',
                'Auto Adaptive': '自适应',
                'CBT Max Depth': 'CBT最大深度',

                'All': '全部',
                'Shader Graphs/AreaDecalShader': 'SG/区域标贴',
                'BH/SG_CurvedShader': 'BH/SG_曲线',
                'BH/Overlay/CurvedOverlayShader': 'BH/覆盖/曲线覆盖',
                'BH/Decals/CurvedDecalShader': 'BH/标贴/曲线标贴',
                'BH/Decals/CurvedDecalDeteriorationShader': 'BH/标贴/曲线标贴退化',
                'BH/Pipeline/CurvedPipelineShader': 'BH/管道/曲线管道',
                'BH/SG_DefaultShader': 'BH/SG_默认',
                'BH/SG_BaseShader': 'BH/SG_基础',
                'BH/NetCompositionMeshLitShader': 'BH/网络组合网格光照',
                'BH/Pipeline/DefaultPipelineShader': 'BH/管道/默认管道',
                'BH/Decals/DefaultDecalShader': 'BH/标贴/默认标贴',
                'BH/Impostors/Render/SG_ImpostorTree': 'BH/冒牌/渲染/SG_冒牌树',
                'BH/SG_VegRootShader': 'BH/SG_植被根',
                'BH/SG_VegLeavesShader': 'BH/SG_植被叶',
                'Shader Graphs/ZoneBlock': 'SG/功能区',
                'BH/SG_WinShader': 'BH/SG_窗户',
                'BH/WinShader': 'BH/玻璃',
                'BH/WatShader': 'BH/水',

                'Didimo/HDRP/SG_CharacterSkin': 'Didimo/HDRP/SG_角色皮肤',
                'Didimo/HDRP/HDRPGenericCrowd': 'Didimo/HDRP/HDRP通用群体',
                'Didimo/HDRP/SG_CharacterCloth': 'Didimo/HDRP/SG_角色布料',
                'Didimo/HDRP/SG_CharacterGeneric': 'Didimo/HDRP/SG_角色通用',
                'BH/Characters/SG_HairCardsDyed': 'BH/角色/SG_染色发卡',
                'BH/GraShader': 'BH/GraShader',

                'Scale': '渲染精度'
            },
                [开发者模式.内容.值], {
                'Catmull Rom': 'Catmull-Rom',
            },
                [开发者模式.内容.按钮], {
                'Refresh splatmap': '刷新地表纹理图',
            },
                [开发者模式.内容.折叠], {
                'Scale': '缩放',
                'Shaders': '着色器',
                'Custom passes': '自定义通道',
            },
                [开发者模式.内容.控制值], {
                'Scale': '渲染精度',
                'Unknown': '未知',
                'False': '否',
                'BeforePost': '后处理前'
            }
            ),
            开发者模式_工具: RE(
                [开发者模式.内容.标签], {
                'Physical Objects': '物理对象',
                'Marker Objects': '标记对象',
                'Interpolated Positions': '插值位置',
                'Net Connections': '网络连接',
                'Group Connections': '组连接',
                'District Connections': '区域连接',
                'Lot Heights': '地块高度',
                'Draw Nodes': '绘制节点',
                'Draw Edges': '绘制边缘',
                'Draw Outlines': '绘制轮廓',
                'Standalone Lanes': '独立车道',
                'Slave Lanes': '从属车道',
                'Master Lanes': '主车道',
                'Connection Lanes': '连接车道',
                'Draw Overlaps': '绘制重叠',
                'Draw Reserved': '绘制保留',
                'Draw Blocked': '绘制阻塞',
                'Draw Condition': '绘制条件',
                'Draw Signals': '绘制信号',
                'Draw Priorities': '绘制优先级',
                'Show positions': '显示位置',
                'Spot Lights Cones': '聚光灯锥形',
                'Show active water cell': '显示活动水格',
                'Fixed Height': '固定高度',
                'Draw Pivots': '绘制枢轴',
                'Draw Grids': '绘制网格',
                'Vacant Lots': '空地块',
                'Lots': '地块',
                'Districts': '区域',
                'Map Tiles': '地图瓦片',
                'Spaces': '空间',
                'Surfaces': '表面',
                'Lane Connections': '车道连接',
                'Humans': '人类',
                'Animals': '动物',
                'Cars': '汽车',
                'Trains': '火车',
                'Ships': '船只',
                'Aircrafts': '飞机',
                'Workplaces': '工作场所',
                'Services': '服务',
                'UneducatedCitizens': '未受教育的市民',
                'EducatedCitizens': '受过教育的市民',
                'OutsideConnection': '外部连接',
                'ConvenienceFoodStore': '便利食品店',
                'GrainSupply': '谷物供应',
                'VegetableSupply': '蔬菜供应',
                'WoodSupply': '木材供应',
                'TextilesSupply': '纺织品供应',
                'ConvenienceFoodSupply': '便利食品供应',
                'PaperSupply': '纸张供应',
                'VehiclesSupply': '车辆供应',
                'OilSupply': '石油供应',
                'PetrochemicalsSupply': '石化产品供应',
                'OreSupply': '矿石供应',
                'MetalsSupply': '金属供应',
                'ElectronicsSupply': '电子产品供应',
                'Attractiveness': '吸引力',
                'PlasticsSupply': '塑料供应',
                'CoalSupply': '煤炭供应',
                'StoneSupply': '石材供应',
                'LivestockSupply': '牲畜供应',
                'CottonSupply': '棉花供应',
                'SteelSupply': '钢铁供应',
                'MineralSupply': '矿物供应',
                'ChemicalSupply': '化学品供应',
                'MachinerySupply': '机械设备供应',
                'BeveragesSupply': '饮料供应',
                'TimberSupply': '木材供应',
                'Taxi': '出租车',
                'Healthcare': '医疗保健',
                'FireRescue': '消防救援',
                'Police': '警察',
                'Park': '公园',
                'PostService': '邮政服务',
                'Education': '教育',
                'EmergencyShelter': '紧急避难所',
                'Welfare': '福利',
                'Draw Graph': '绘制图表',
                'Show Restrictions': '显示限制',
                'Show time cost': '显示时间成本',
                'Show behavior cost': '显示行为成本',
                'Show money cost': '显示金钱成本',
                'Show comfort cost': '显示舒适度成本',
                'Visualize Queries': '可视化查询',
                'Static Objects': '静态对象',
                'Moving Objects': '移动对象',
                'Nets': '网络',
                'Lanes': '车道',
                'Zones': '区域',
                'Areas': '地区',
                'Routes': '路径',
                'Effects': '效果',
                'Local Effects': '局部效应',
                'Land value': '土地价值',
                'StorageLeveling': '存储水准',
                'Leveling': '水准',
                'Buildings': '建筑物',
                'Residential worth': '住宅价值',
                'Commercial worth': '商业价值',
                'Industrial worth': '工业价值',
                'Untaxed income': '免税收入',
                'Storage used': '存储使用',
                'Ground pollution': '地面污染',
                'Air pollution': '空气污染',
                'Noise pollution': '噪音污染',
                'Forest': '森林',
                'Accumulated Garbage': '累积垃圾',
                'Produce Garbage': '产生垃圾',
                'Show Surface Boxes': '显示表面框',
                'Show Culling Boxes': '显示裁剪框',

                'Object Debug System': '物件 调试系统',
                'Net Debug System': '道路 调试系统',
                'Lane Debug System': '车道 调试系统',
                'Light Debug System': '光照 调试系统',
                'Water Culling Debug System': '水裁剪 调试系统',
                'Zone Debug System': '功能区 调试系统',
                'Area Debug System': '区域 调试系统',
                'Route Debug System': '路径 调试系统',
                'Navigation Debug System': '导航 调试系统',
                'Audio Grouping Debug System': '音频分组 调试系统',
                'Availability Debug System': '可用率 调试系统',
                'Density Debug System': '密度 调试系统',
                'Coverage Debug System': '覆盖 调试系统',
                'Path Debug System': '路径 调试系统',
                'Pathfinding Debug System': '路径规划 调试系统',
                'Search Tree Debug System': '搜索树 调试系统',
                'Terrain Attractiveness Debug System': '地形吸引力 调试系统',
                'Land Value Debug System': '土地价值 调试系统',
                'Economy Debug System': '经济 调试系统',
                'Pollution Debug System': '污染 调试系统',
                'Ground Water Debug System': '地下水 调试系统',
                'Soil Water Debug System': '土壤水分 调试系统',
                'Natural Resource Debug System': '自然资源 调试系统',
                'Garbage Debug System': '垃圾 调试系统',
                'Terrain Debug System': '地形 调试系统',
                'Water Debug System': '水 调试系统',
                'Wind Debug System': '风 调试系统',
                'Event Debug System': '事件 调试系统',

                'Tradecost Debug System': '(危险) 贸易成本 调试系统',
                'Buildable Area Debug System': '可建造区域 调试系统'
            }
            ),
            开发者模式_main: RE(
                [开发者模式.顶栏.按钮], {
                'Display Stats': '显示数据',
                'Thumbnails': '缩略图',
                'Asset database': '数据',
                'Notifications': '通知',
                'ECS Components': 'ECS 组件',
                'Scene Flow': '场景流程',
                'GameRendering': '游戏渲染',
                'Gameplay': '游戏玩法',
                'Localization': '本地化',
                'UI Bindings': 'UI 绑定',
                'Watches': '监视器',
                'Radio': '无线电',
                'Climate': '气候',
                'Simulation': '模拟',
                'Pathfind': '寻路',
                'Serialization': '序列化',
                'Gizmos': '工具',
                'Camera': '摄像机',
                'Input': '输入',
                'Decals': '标贴',
                'Material': '材质',
                'Lighting': '光照',
                'Rendering': '渲染',
                'Profiler Metrics': '性能分析指标',
                'Main Camera': '主摄像机',
                'Virtual Texturing': '虚拟纹理',
                'Volume': '音量',
            },
                [开发者模式.内容.标签], {
                'Fullscreen Debug': '全屏调试'
            },
                [开发者模式.内容.值], {
                'Disabled': '关闭',
                'Enabled': '开启',
                'None': '无',
            },
            ),
            信息隐现: RE(
                [HOOKUI.顶栏.名称], {
                'InfoLoom: Demographics': '信息隐现: 人口分布',
                'InfoLoom: Workforce': '信息隐现: 劳动力结构',
                'InfoLoom: Workplaces': '信息隐现: 工作场所',
                'InfoLoom: Demand Factors': '信息隐现: 建筑需求',
                'InfoLoom: Commercial Data': '信息隐现: 商业信息',
                'InfoLoom: Residential Data': '信息隐现: 住宅数据'
            },
                [HOOKUI.面板.标题], {
                'Demographics': '人口统计',
                'Demand': '需求',
                'Workforce Structure': '劳动力结构',
                'Workplace Distribution': '工作场所分布',
                'Commercial Data': '商业数据',
                'Residential Data': '住宅数据'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_S2v').isStyle('width: 60.000000%; justify-content: center; ')], {
                'All Citizens': '所有市民',
                '- Locals': '- 本地居民',
                '- Tourists': '- 游客',
                '- Commuters': '- 通勤者',
                '- Moving Away': '- 搬离中',
                'Population': '人口',
                'Oldest citizen': '最年长市民',
                'Students': '学生',
                'Workers': '工人',
                'Homeless': '无家可归',
                'Dead': '死亡'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').index(2).all], {
                'Work': '工作',
                'Elementary': '小学',
                'High school': '中学',
                'College': '学院制大学',
                'University': '综合性大学',
                'Other': '其他'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('symbol_aAH').next], {
                'Education': '教育',
                'Uneducated': '无学历',
                'Poorly Educated': '低学历',
                'Highly Educated': '极高学历',
                'Well Educated': '高学历',
                'Educated': '普通学历',
                'TOTAL': '总计',
                'Companies':'公司'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('labels_L7Q.row_S2v').class('row_S2v').haveStyle('justify-content: center')], {
                'Total': '总计',
                'Workers': '工人',
                'Unemployed': '失业',
                'Under': '在读',
                'Outside': '在外',
                'Homeless': '无家可归',

                'City': '服务',
                'Sales': '销售',
                'Leisure': '休闲',
                'Extract': '开采',
                'Industry': '工业',
                'Office': '办公',
                'Employees': '员工',
                'Open': '招聘',
                'Commute':'通勤'
            },
                [rif().class('infoview-panel-section_RXJ').class('left_Lgw.row_S2v')], {
                'BUILDING DEMAND': '建筑需求',
                'Residential Low': '低密度住宅',
                'Residential Medium': '中密度住宅',
                'Residential High': '高密度住宅',
                'Commercial': '商业',
                'Industrial': '工业',
                'Storage': '仓储',
                'Office': '办公',

                'RESIDENTIAL LOW': '低密度住宅',
                'RESIDENTIAL MEDIUM': '中密度住宅',
                'RESIDENTIAL HIGH': '高密度住宅',
                'COMMERCIAL': '商业',
                'INDUSTRIAL': '工业',
                'OFFICE': '办公',

                'EmptyBuildings': '空置建筑',
                'Happiness': '幸福度',
                'Taxes': '税收',
                'Unemployment': '失业率',
                'UneducatedWorkforce': '未受教育劳动力',
                'EducatedWorkforce': '受教育劳动力',
                'LocalDemand': '本地需求',
                'LocalInputs': '本地资源',
                'Homelessness': '无家可归',
                'Students': '学生',
                'Warehouses': '仓库',
                'PetrolDemand': '汽油需求',
                'TouristDemand': '游客需求'
            }, [HOOKUI.面板.标签2], {
                'PROPERTYLESS COMPANIES': '破产公司',
                'EMPTY BUILDINGS': '空置建筑',
                'Standard': '标准',
                'Educated': '受过教育的',
                'Uneducated': '未受教育的',
                'No demand for:': '没有需求:',
                'conv.food': '方便食品',
                'food': '食物',
                'meals': '餐饮',
                'paper': '纸张',
                'furniture': '家具',
                'vehicles': '车辆',
                'lodging': '住宿',
                'petrochemicals': '石油化工',
                'plastics': '塑料',
                'electronics': '电子产品',
                'chemicals': '化学品',
                'pharmaceuticals': '药品',
                'beverages': '饮料',
                'textiles': '纺织品',
                'entertainment': '娱乐',
                'recreation': '休闲',
                'LOW': '低密度',
                'MEDIUM': '中密度',
                'HIGH': '高密度',

                'Total properties': '总财产',
                '- Occupied properties': '- 已占用财产',
                '= Empty properties': '= 空财产',
                "No demand at 10%": '无需求时为10%',
                'BUILDING DEMAND': '建筑需求',
                'STUDY POSITIONS': '学习位置',
                'HOUSEHOLDS': '家庭'


            },
                [HOOKUI.面板.标签_p], {
                'AVERAGE TAX RATE': '平均税率',
                '10% is the neutral rate': '正常为10%',
                'SERVICE UTILIZATION': '服务利用率',
                '30% is the neutral ratio': '正常为30%',
                'SALES CAPACITY': '销售能力',
                '100% when capacity = consumption': '当销售=消费时为100%',
                'EMPLOYEE CAPACITY RATIO': '员工容量',
                '75% is the neutral ratio': '正常为75%',
                'HAPPINESS': '幸福度',
                '50 is neutral': '正常为50%',
                'UNEMPLOYMENT': '失业率',
                '10% is neutral': '正常为10%',
                'HOMELESS': '无家可归',
                '0 is neutral': '正常为0%',

                "TAX RATE (weighted)": '税率（加权）',
                '10 % is neutral': '正常为10%'

            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first.first.index(11).first], {
                'AVAILABLE WORKFORCE': '可用劳动力'
            }
            ),
            失业监视器: RE(
                [HOOKUI.面板.标题], {
                'Unemployment': '失业监视器'
            },
                [HOOKUI.顶栏.名称], {
                'Unemployment Data': '失业监视器',
                'Unemployment Monitor': '失业监视器',
            },
                [rif().class('panel_YqS').index(1).first.all.first.haveStyle('flex: 1.000000')], {
                'Unemployed': '失业',
                'Under Employed': '低收入就业',
                'Homeless Households': '无家可归家庭'
            },
                [rif().class('panel_YqS').index(1).index(1).all.first.haveStyle('font-weight')], {
                'TO': '总',
                'UN': '无',
                'PO': '低',
                'ED': '中',
                'WE': '高',
                'HI': '极高',
            },
                [rif().class('panel_YqS').index(1).index(1).index(6)], {
                'Total': '所有',
                'Uneducated': '无学历',
                'Poorly Educated': '低学历',
                'Well Educated': '高学历',
                'Highly Educated': '极高学历',
                'Educated': '普通学历',
            }
            ),
            城市监视器: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'City Monitor': '城市监视器',
            },
                [rif().class('content_1xS.focusable_GEc.item-focused_FuT').class('labels_L7Q.row_S2v').class('uppercase_RJI.left_Lgw.row_S2v'), rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('label_VSW.label_T__')], {
                'Electricity Availability': '电力资源可用性',
                'Water Availability': '水资源可用率',
                'Sewage': '污水处理',
                'Landfill Usage': '垃圾填埋使用率',
                'Healthcare Availability': '医疗资源可用率',
                'Average Health': '平均健康状况',
                'Cemetery Availability': '公墓资源可用率',
                'Fire Hazard': '火灾危险',
                'Crime Rate': '犯罪率',
                'Jail Availability': '监狱资源可用率',
                'Elementary School Availability': '小学资源可用率',
                'High School Availability': '中学资源可用率',
                'College Availability': '学院制大学资源可用率',
                'University Availability': '综合性大学资源可用率'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('button_WWa')], {
                'Settings': '设置',
                'Meters': '完成'
            }
            ),
            条形工具: RE(
                [rif().class('tool-options-panel_Se6').id('line-tool-title')], {//
                'Line Tool': '条形工具',//
            },
                [MAIN.工具框.标签], {
                'Options': '设置',
                'Rotation': '旋转'
            },
                [MAIN.悬浮框.标题], {
                'Single item': '放置单个物件'
            },
                [MAIN.悬浮框.内容], {
                'Place one object at a time using the standard game tool.': '使用标准游戏工具一次放置一个对象。'

            },
                [rif().id('line-tool-title')], {
                'Line tool': '条形工具'
            }


            ),
            树木控制器: RE(
                [MAIN.悬浮框.提示], {
                'Right Click to Apply.': '右键以应用'

            },
                [MAIN.工具框.标签], {
                'Age': '树木年龄',
                'Selection': '选择',
                'Radius': '范围',
                'Tool Mode': '工具模式',
                'Sets': '集合',
            },
                [MAIN.设置.选项], {
                'Tree Controller': '树木控制器'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Deciduous trees use Dead Model during Winter': '在冬季:落叶树使用枯木模型',
                'Disable Tree Growth': '禁用树木自然生长',
                'Age Selection Technique': '树木年龄随机方法',
                'Color Variation Set': '颜色变化集'
            },
                [MAIN.设置.描述], {
                'Will temporarily make all non-lumber industry deciduous trees use the dead model and pause growth during winter.':
                    '会暂时性的把所有 (非林场) 的落叶树转换为枯木模型',

                'Disable tree growth for the entire map except for lumber industry.':
                    '禁用整个地图的 (非林场) 树木的自然生长',

                '"When multiple Tree Ages are selected, one will be selected using this option. Random: Equal Weight is just a random selection. Random: Weighted randomly selected using game\'s editor weights. Sequential: does selected ages in order."':
                    '当选择多个树木年龄时，可以使用此选项选择树木年龄的随机方式。【随机：完全随机】【随机：按游戏编辑器中的权重随机选择】【顺序：按顺序选择所选的树木年龄】',

                'Sets of seasonal colors for Trees and Wild bushes. Vanilla is the base game. Yenyang\'s is my curated colors. Custom uses CSV files in the mod folder.': '树木和野生灌木的季节性颜色集。【原版】 是基础游戏的颜色。【Yenyang的颜色集】 是我策划的颜色。【自定义】 使用模组文件夹中的 CSV 文件',

                'After confirmation this will reload CSV files.':
                    '确认后，将重新加载 CSV 文件。',

                'Removes Tree Controller mod components and resets tree and bush model states. Only necessary during Winter and very end of Autumn. Must use reset button to undo setting change.':
                    '移除树木控制器模组的组件并重置树木和灌木模型状态。仅在冬季和秋季末尾非常需要。必须使用重置按钮来撤销设置更改。',

                'After confirmation this will reset Tree Controller Settings.':
                    '确认后，将重置树木控制器设置。'

            },
                [MAIN.下拉框.标签, MAIN.下拉框.值], {
                'Random: Equal Weight': '随机：完全随机',
                'Random: Weighted': '随机：按游戏编辑器',
                'Vanilla': '原版',
                'Yenyang\'s': 'Yenyang的颜色集',
                'Custom': '自定义'
            },
                [MAIN.按钮, MAIN.设置.标题], {
                'Reload CSVs': '重载CSV颜色集',
                'Safely Remove': '安全移除',
                'Reset Tree Controller Settings': '重置 树木控制器 模组设置'
            }
            ),
            车辆计数器: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Vehicle Counter': '车辆计数器'
            },
                [HOOKUI.面板.标签], {
                'Active vehicles': '激活的车辆'
            },
                [MAIN.按钮], {
                'Remove vehicles': '移除车辆'
            }
            ),
            传统风味: RE(
                [HOOKUI.顶栏.名称], {
                'Legacy Flavour': '传统风味'
            }
            ),
            限速模组: RE(
                [HOOKUI.顶栏.名称], {
                'Speed Limit': '限速模组',
            },
                [HOOKUI.面板.标题], {
                'Speed Limit Editor': '限速模组:修改器'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first], {
                'No Road Selected': '没有道路被选择'
            }
            ),
            出行解锁: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Traffic Unlocker': '出行解锁'
            },
                [HOOKUI.面板.标签], {
                'Population': '人口',
                'Traffic Reduction': '交通抑制系数',
                'Work Probability': '工作概率',
                'School Probability': '上学概率',
                'Leisure Probability': '休闲概率'
            }
            ),
            道路扩展升级: RE(
                [MAIN.工具栏.资产详情.标题], {
                'Quay': '护坡',
                'Retaining Wall': '护墙',
                'Elevated': '高架',
                'Tunnel': '隧道'
            },
                [MAIN.工具栏.资产详情.描述], {
                'A quay, if you installed this mod you know what it is :)': '护坡，如果你安装了这个模组，你知道它是什么:)',
                'A retaining wall, if you installed this mod you know what it is :)': '护墙，如果你安装了这个模组，你知道它是什么:)',
                'Elevated mode, kind of similar to bridges': '高架模式，有点类似于桥梁',
                'Tunnel mode, it might not look perfect but it works.': '隧道模式，它可能看起来不完美，但它能工作。'
            }
            ),
            更难的经济: RE(
                [MAIN.设置.选项], {
                'Economy Fixer': '难度更高的经济'
            },
                [MAIN.设置.分类], {
                'Gameplay Options': '游戏中设置'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Economy Difficulty': '经济难度',
                'Bulldozing Building Costs Money': '拆除建筑需要拆迁费',
                'Bulldoze & De-zoning Causes Demolition': '推土机或取消功能区会导致建筑变成废墟'
            },
                [MAIN.设置.描述], {
                'Higher difficulty results in decreased subsidies, milestone rewards, income & higher expenses.': '更高的难度会导致减少补贴、里程碑奖励、收入和增加开支。',
                'Adds a monthly maintenance fee for demolition buildings. This fee is based on how many residents are getting evicted, how high the land value is, and how large is the building itself.': '为拆迁建筑添加了一个月度维护费用。该费用基于有多少居民被驱逐、土地价值有多高以及建筑本身有多大。',
                'Bulldozing a building or de-zoning an area will cause the buildings to collapse instead of disappearing, collapsed buildings take time to be cleaned up and affect nearby happiness. You can pay a small fee to immediately raze collapsed buildings.': '推倒建筑或取消区域划分将导致建筑物崩溃而不是消失，崩溃的建筑需要时间清理，并影响附近的幸福度。你可以支付一小笔费用立即夷平崩溃的建筑物。'
            },
                [MAIN.下拉框.值, MAIN.下拉框.标签], {
                'Easy': '简单',
                'Medium': '普通',
                'Hard': '困难',
                'Good Luck': '祝你好运',
            }
            ),
            图像叠加: RE(
                [MAIN.设置.选项], {
                'Image Overlay': '图像叠加'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Overlay X-position': '图像X坐标',
                'Overlay Z-position': "图像Y坐标"
            },
                [MAIN.设置.描述], {
                'The X (east-west) coordinate of the center of the overlay image projection, in meters.  This can also be changed in-game using the left and right arrow keys while holding down control (for 1m increments) or shift (for 10m increments).': '覆盖图像投影中心的X坐标（东西方向），以米为单位。这也可以在游戏中使用左右箭头键进行更改，同时按住Control键（以1m为增量）或Shift键（以10m为增量）。',
                'The Z (north-south) coordinate of the center of the overlay image projection, in meters.  This can also be changed in-game using the up and down arrow keys while holding down control (for 1m increments) or shift (for 10m increments).': '覆盖图像投影中心的Z坐标（南北方向），以米为单位。这也可以在游戏中使用上下箭头键进行更改，同时按住Control键（以1m为增量）或Shift键（以10m为增量）',
                'Resets the overlay position to the center of the map.': '将覆盖位置重置为地图中心。'
            },
                [MAIN.下拉框.值, MAIN.下拉框.标签], {
                'None': '无',
            },
                [MAIN.按钮, MAIN.设置.标题], {
                'Reset overlay position': "重置覆盖位置"
            }
            ),
            无碰撞: RE(
                [MAIN.工具框.标签], {
                'Anarchy': '无碰撞'
            },
                [MAIN.设置.选项], {
                'Anarchy': '无碰撞'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Always enable Anarchy with Bulldoze Tool': '始终启用推土机无碰撞',
                'Show Tooltip': '显示工具提示框',
                'Flaming Chirper': '燃烧小鸟',
                'Tool Icon': '工具图标',
                'Prevent Accidental Prop Culling': '防止意外的道具遗失',
                'Prop Refresh Frequency': '道具刷新频率',
                'Allow Placing Multiple Unique Buildings':'允许放置多个独特建筑'
            },
                [MAIN.设置.描述], {
                'With this option enabled the Bulldoze Tool will always have anarchy enabled.': '启用此选项后，清障工具将始终启用无碰撞状态。',
                'With this option enabled a tooltip with Ⓐ will be shown when Anarchy is active for appropriate tools.': '启用此选项后，对适当的工具启用无碰撞时将显示带有Ⓐ的工具提示。',
                'With this option enabled the Chirper will be on fire when Anarchy is active for appropriate tools. Image Credit: Bad Peanut.': '微谈小鸟 将着火。 图片来源：Bad Peanut。  ',
                'With this option enabled a icon row with a single button for Anarchy will show up when using appropriate tools.': '启用此选项后，使用适当的工具时将显示一个包含单个无碰撞按  钮的图标显示。',
                'Upon confirmation this will reset the settings for Anarchy mod.': '确认后，这将重置 无碰撞模组 的设置。',
                'This will routinely trigger a graphical refresh to props placed with Anarchy that have been culled to prevent accidental culling of props. This affects performance.': '这将定期触发对使用 无碰撞 放置的被剔除的道具进行图形刷新，以防止意外的道具遗失。这会影响性能。',
                'This is number of frames between graphical refreshes to props placed with Anarchy to prevent accidental culling. Higher numbers will have better performance, but longer possible time that props may be missing.': '这是在 Anarchy 下放置的道具之间的图形刷新之间的帧数，以防止意外的剔除。数字越大，性能越好，但可能遗失道具的时间越长。',
                "If props placed with Anarchy have been accidently culled, you can press this button to bring them back now. This doesn't negatively effect performance.": '如果使用 无碰撞 放置的道具被意外剔除，您可以按下此按钮立即将它们恢复。这不会对性能产生负面影响。',
                'This allows you to place multiple copies of unique buildings using the normal UI menu with or without Anarchy enabled. The effects of these buildings stack!':'这允许您使用正常的 UI 菜单放置多个独特建筑，无论是否启用 Anarchy。这些建筑的效果叠加！'
            },
                [MAIN.按钮, MAIN.设置.标题], {
                'Reset Anarchy Settings': '重置 无碰撞模组 设置',
                'Refresh Props': '刷新道具',
            },
                [MAIN.悬浮框.标题], {
                'Anarchy': '无碰撞',
                'Gameplay Manipulation': '游戏中操纵',
                'Bypass Confirmation': '绕过确认',
                'Target Markers': '标记',
                'Target Surfaces': '地面/表面'
            },
                [MAIN.悬浮框.内容], {
                "Disables error checks for tools and does not display errors. When applicable, you can place vegetation and props (with DevUI 'Add Object' menu) overlapping or inside the boundaries of other objects and close together.":
                    '禁用工具错误检查，不显示错误。在适用的情况下，您可以将植被和道具（使用DevUI的“添加对象”菜单）放置在其他对象的边界重叠或内部并靠近一起。',
                "Allows you to use the bulldozer on moving objects such as vehicles or cims.":
                    '许在移动对象（如车辆或市民）上使用推土机。',
                "Disables the prompt for whether you are sure you want to demolish a building.":
                    '禁用是否确定要拆除建筑物的提示。',
                "Shows and EXCLUSIVELY targets markers and invisible roads. With this and anarchy enabled you can demolish invisible roads, but SAVE FIRST! You cannot demolish invisible roads within buildings.":
                    '同时启用这个和无碰撞时，您可以拆除不可见道路，但记得先保存游戏！您不能在建筑物内拆除不可见的道路。',
                "Makes the bulldozer EXCLUSIVELY target surfaces so you can remove them in one click. With Anarchy on you can bulldoze surfaces within buidings. You must turn this off to bulldoze anything else.":
                    '启用无碰撞后，您可以在建筑物内使用推土机清理地面/表面。您必须关闭此选项以回归正常推土机功能。'
            }

            ),
            建筑尺寸自定义: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Zone Spawn Custom': '建筑尺寸自定义'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS.content_BIL').class('toggle_cca.toggle_ATa').next], {
                'Residential': '住宅区',
                'Commercial': '商业区',
                'Industrial': '工业区',
                'Office': '办公区'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS.content_BIL').class('toggle_cca.toggle_ATa').next.next.first], {
                'Detail': '细节'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS.content_BIL').class('info-section_I7V').class('field_vGA')], {
                'Min': '最小',
                'Max': '最大'
            }
            ),
            地图纹理替换: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Map Texture Replacer': '地图纹理替换'
            },
                [rif({ match: 'inc' }).class('content_XD5.content_AD7.child-opacity-transition_nkS').class('label_DGc.label_ZLb')], {
                'Pack Loaded': '加载的纹理包',
                'None': '无',
                'Grass Diffuse': '草地漫反射',
                'Grass Normal': '草地法线',
                'Dirt Diffuse': '泥土漫反射',
                'Dirt Normal': '泥土法线',
                'Cliff Diffuse': '悬崖漫反射',
                'Cliff Normal': '悬崖法线'
            },
                [MAIN.按钮], {
                'Load Texture Pack': '加载纹理包',
                'Select Image': '选择图像',
                'Reset': '重置'
            }
            ),
            全部区块解锁: RE(
                [MAIN.设置.选项], {
                '529 Tiles': '全部区块解锁'
            },
            ),
            无限刷子尺寸: RE(
                [MAIN.设置.选项], {
                    'Brush Size Unlimiter': '无限刷子尺寸'
                },
                [MAIN.设置.标签, MAIN.设置.标题], {
                    'Maximum Brush Size': '最大刷子大小',
                    'Hide Object Placement Preview With Large Brush Sizes': '巨型刷子下隐藏预览',
                },
                [rif({ match: 'inc', full: true }).class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-description_wwd')], {
                    'Sets the maximum size the brush can be set to in the game/dev UI.':
                    '设置最大刷子大小限制  注意:刷子越大，性能消耗越高',

                    'Warning: Disabling this will make large object brushes with high strengths extremely laggy.':
                    '-启用此选项可大幅提高在使用大型对象刷子(≥2500大小)时的性能，通过在悬停时临时将刷子强度设置为0  警告：禁用此选项将使具有高强度的大型对象刷子非常卡顿。  如果存在兼容性问题，请禁用',
                }
            ),
            额外景观工具: RE(
                [MAIN.工具框.标签], {
                'Brush': '笔刷',
                'Brush Rotation': '笔刷角度',
                'Show Markers':'显示标记'
            },
                [MAIN.工具框.值], {
                'Custom 01': '自定义 01',
                'Mountain 01': '山脉 01',
                'Mountain 02': '山脉 02',
                'Mountain 03': '山脉 03',
                'Default Brush': '默认',
                'Mountain02Brush': '山脉 02',
                'TriangleBrush': '三角',
                'Mountain01Brush': '山脉 01',
                'Mesa01Brush': '台地 01',
                'RectangleBrush': '矩形',
                'PeakBrush': '峰',
                'TendrilBrush01': '卷曲 01',
                'TendrilBrush02': '卷曲 02',
                'MountainsBrush': '山脉',
                'Mountain03Brush': '山脉 03',
                'Mountain04Brush': '山脉 04',
                'TendrilBrush03': '卷曲 03',
                'River01Brush': '河流 01'
            },
                [MAIN.工具栏.资产详情.标题], {
                'SubServices.NAME[Surfaces]': '地面'
            },
                [MAIN.工具栏.资产详情.描述], {
                'Assets.SUB_SERVICE_DESCRIPTION[Surfaces]': '一些地面/地表,无碰撞体积'
            }
            ),
            扩展热键: RE(
                [HOOKUI.顶栏.名称], {
                'ExtendedHotkeys': '扩展热键'
            },
                [HOOKUI.面板.标题], {
                'Extended Hotkeys': '扩展热键'
            },
                [HOOKUI.面板.头], {
                'General': '常规',
                'Mouse Wheel': '鼠标滚轮',
                'Hotkeys': '快捷键'
            },
                [HOOKUI.面板.头描述], {

                'Extended actions with your mouse wheel while in net tool placing roads.': '在网工具放置道路时，使用鼠标滚轮进行扩展操作。',
                'Awesome actions with your keyboard.': '使用键盘进行出色的操作。'
            },
                [HOOKUI.面板.项目], {
                '升降步进卷轴': '高度阶段',
                '海拔重置': '高度重置',
                'Scroll elevation step level.': '高度阶段调整。',
                'Tool Modes': '工具模式',
                'Straight': '直线',
                'Curve': '曲线',
                'Complex Curve': '复杂曲线',
                'Continuous': '连续曲线',
                'Grid': '网格'
            }
            ),
            扩展提示框: RE(
                [HOOKUI.顶栏.名称], {
                'ExtendedTooltip': '扩展提示框'
            },
                [HOOKUI.面板.标题], {
                'Extended Tooltip': '扩展提示框'
            },
                [HOOKUI.面板.项目], {
                '无政府状态': '无碰撞状态',
                '如果启用了无政府模式，则会显示一个指示器。': '如果启用了无碰撞，则会显示一个指示器。',
            }
            ),
            随处开采: RE(
                [MAIN.设置.选项], {
                    'Extract Anywhere': '随处开采'
                },
                [MAIN.设置.标签, MAIN.设置.标题],{
                    "Can all extractors extract anywhere?":'可随处开采',
                    "Extraction radius multiplier": "采集半径倍增器",
                    'Textile Fibres': '棉花',
                    'Grain': '粮食',
                    'Vegetables': '蔬菜',
                    'Oil': '石油',
                    'Coal': '煤炭',
                    'Ore': '矿石'
                },
                [MAIN.设置.描述],{
                    "Toggle all extractors' abilities to extract resources without the need for a natural resource deposit.": 
                    '切换所有开采专门产业无需自然资源即可提取资源的能力。',

                    'Set the multiplier for the area sizes of all extractors.': 
                    '设置所有开采专门产业区域大小倍增。',

                    'Toggle whether or not textile fibres can be extracted without requiring fertile land. Turning this on means that extraction does not require fertile land.':
                    '切换棉花是否可以在不需要沃土的情况下种植。启用此选项表示不需要沃土。',

                    'Toggle whether or not grain can be extracted without requiring fertile land. Turning this on means that extraction does not require fertile land.':
                    '切换谷物是否可以在不需要沃土的情况下种植。启用此选项表示不需要沃土。',

                    'Toggle whether or not vegetables can be extracted without requiring fertile land. Turning this on means that extraction does not require fertile land.':
                    '切换蔬菜是否可以在不需要沃土的情况下种植。启用此选项表示不需要沃土。',

                    "Set the multiplier for the area size of the extractors. The default is 1 (base area size is 300). This will affect the following resource extractors: textile fibres, grain, livestock, vegetables.":
                    '设置专门产业区域大小的倍增。默认值为1（基础区域大小为300）。这将影响以下专门产业：棉花、谷物、牲畜、蔬菜。',

                    "Set the multiplier for the area size of the extractors. The default is 1 (base area size is 400). This will affect the following resource extractors: forestry.":
                    '设置专门产业区域大小的倍增。默认值为1（基础区域大小为400）。这将影响以下专门产业：林业。',

                    'Toggle whether or not oil can be extracted without requiring an oil deposit. Turning this on means that extraction does not require an oil deposit.':
                    '切换是否可以在不需要石油资源的情况下提取石油。启用此选项表示不需要石油资源。',

                    'Set the multiplier for the area size of the extractors. The default is 1 (base area size is 300). This will affect the following resource extractors: oil.':
                    '设置专门产业区域大小的倍增。默认值为1（基础区域大小为300）。这将影响以下专门产业：石油。',

                    'Toggle whether or not coal can be extracted without requiring an ore deposit. Turning this on means that extraction does not require an ore deposit.':
                    '切换是否可以在不需要矿脉的情况下开采煤炭。启用此选项表示不需要矿脉。',

                    'Toggle whether or not ore can be extracted without requiring an ore deposit. Turning this on means that extraction does not require an ore deposit.':
                    '切换是否可以在不需要矿脉的情况下开采矿石。启用此选项表示不需要矿脉。',

                    'Set the multiplier for the area size of the extractors. The default is 1 (base area size is 400). This will affect the following resource extractors: coal, ore, stone.':
                    '设置提取器区域大小的倍增器。默认值为1（基础区域大小为400）。这将影响以下专门产业：煤炭、矿石、石头。'

                },
                [MAIN.按钮, MAIN.设置.标题], {
                    'Reset to default': '重置为默认'
                },
                [MAIN.设置.TAB],{
                    'General': '常规',
                    'Fertile Land': '沃土',
                    'Forest': '林业',
                    'Oil': '石油',
                    'Ore': '矿石'
                },
                [MAIN.设置.分类],{
                    'Extract Anywhere': '随处开采'
                }


            ),
            RICO: RE(
                [MAIN.工具栏.资产详情.描述,MAIN.工具栏.资产详情.标题],{
                    'Residential Low Ploppable':'低密度住宅',
                    'Residential Med Ploppable':'中密度住宅',
                    'Residential High Ploppable':'高密度住宅',
                    'Residential Row Ploppable':'中密度联排住宅',
                    'Residential Low Rent Ploppable':'廉租公寓',
                    'Mixed Ploppable':'混合型住宅',
                    'Commercial Low Ploppable':'低密度商业',
                    'Commercial High Ploppable':'高密度商业',
                    'Office Low Ploppable':'低密度办公',
                    'Office High Ploppable':'高密度办公',
                    'Manufacturing Ploppable':'工厂',
                    'Warehouse Ploppable':'仓库'
                },
                [rif({match:'inc',fullReplace:false}).class('asset-detail-panel_hf8.detail-panel_izf').class('title-bar_I7O.child-opacity-transition_nkS').class('title_qub')],{
                    'EU_':'欧洲',
                    'NA_':'北美',
                    'ResidentialLowRent':'廉租公寓',
                    'ResidentialLow':'低密度住宅 ',
                    'ResidentialMed':'中密度住宅 ',
                    'ResidentialHigh':'高密度住宅 ',
                    'ResidentialRow':'中密度联排住宅',
                    'MixedRight':'混合型住宅',
                    'CommercialLow':'低密度商业',
                    'CommercialHigh':'高密度商业',
                    'Commercial':'商业',
                    'GasStation':'加油站',
                    'Motel':"旅馆",
                    'OfficeLow':'低密度办公',
                    'OfficeHigh':'高密度办公',
                    'IndustrialManufacturingWarehouse':'仓库',
                    'IndustrialManufacturing':'工厂',

                    '_L':' 等级',
                    '_ploppable':'',
                    'Assets.NAME':''
                }
            ),
            交通自定义: RE(
                [MAIN.设置.选项], {
                    'CityPlayer Traffic Custom': '交通自定义'
                },
                [MAIN.设置.标签, MAIN.设置.标题],{
                    'Use Rush Hour': '开启高峰时间',
                    'Rush Hour Traffic Strength': '高峰交通强度',
                    'Randomly Dummy Traffic - Car (On/Off)': '随机虚拟交通 - 汽车（开/关）',
                    'Randomly Dummy Traffic - Train (On/Off)': '随机虚拟交通 - 火车（开/关）',
                    'Randomly Dummy Traffic - Airplane (On/Off)': '随机虚拟交通 - 飞机（开/关）',
                    'Randomly Dummy Traffic - Watercraft (On/Off)': '随机虚拟交通 - 水上交通工具（开/关）',
                    'Taxi Preference': '出租车偏好',
                    'PublicTransport Preference': '公共交通偏好',
                    'PersonalCar Preference': '私家车偏好',
                    'Buying PersonalCar Preference': '购买私家车偏好'

                },
                [MAIN.设置.分类],{
                    'CityPlayer Traffic Custom': '交通自定义',
                    'RUSH HOUR CUSTOM MOD': '高峰时间定制',
                    'RANDOM TRAFFIC CUSTOM MOD': '随机虚拟交通定制',
                    'CITIZEN TRANSPORTAION PREFERENCE CUSTOM MOD': '居民交通偏好定制',
                    'EXPERIMAENTAL MOD': '实验性模组'
                },
                [MAIN.按钮, MAIN.设置.标题],{
                    'RESET SETTINGS':'重置设置'

                },
                [MAIN.下拉框.值,MAIN.下拉框.标签],{
                    'Very Low':'非常低',
                    'Low':'低',
                    'High':'高',
                    'Very High':'非常高'
                },
                [MAIN.设置.描述],{
                    "Reset 'CityPlayer Traffic Custom Mod' settings.":'重置城市玩家交通定制模组设置',
                    "Creates Rush Hours for Cars and Trucks between Outside-Cities. This option can make game more difficult. (Rush hour varies in severity depending on the size of the city)":'在城市之间为汽车和卡车创建高峰时间。此选项可能使游戏更加困难。（高峰时间的严重程度取决于城市的大小）',
                    "Control Strength of Rush Hour. (Default:3,  Min:1 Max:5)":'控制高峰时间的强度。（默认值：3，最小值：1 最大值：5）',
                    "Turn On/Off randomly generated dummy Car Vehicles.":'打开/关闭随机生成的虚拟汽车交通。',
                    "Turn On/Off randomly generated dummy Train Vehicles.":'打开/关闭随机生成的虚拟火车交通。',
                    "Turn On/Off randomly generated dummy Airplane Vehicles.":'打开/关闭随机生成的虚拟飞机交通。',
                    "Turn On/Off randomly generated dummy Watercraft Vehicles.":'打开/关闭随机生成的虚拟水上交通。',
                    "Control Taxi preferences.(If set up to 'None', citizens don't use Taxi.)":"控制出租车偏好。（如果设置为“无”，市民不使用出租车。）",
                    "Control PublicTransport preferences.":'控制公共交通偏好。',
                    "Control Personal Car preferences.(If citizens not have own car, they don't use Personal Car)":'控制个人汽车偏好。（如果市民没有自己的汽车，他们不使用个人汽车。）',
                    "Control Buying Personal Car preferences.(The higher preference, the more likely to buy a Personal Car.)":'控制购买个人汽车的偏好。（偏好值越高，购买个人汽车的可能性越大。）'
                }
            ),
            TWEAKUI: RE(
                [HOOKUI.顶栏.名称,HOOKUI.面板.标题],{
                    'TweakUI':'调整 UI',
                },
                [rif().class('label_VSW').all],{
                    'Transportation Overview Height': '交通总览高度',
                    'Asset Menu Rows': '资产菜单行数'
                },
                [rif().class('description_VWf').class('paragraphs_nbD').all],{
                    'Change the height of the transportation overview.': '更改交通总览的高度。',
                    'Change the number of rows on the tool asset menu.': '更改工具资产菜单上的行数。'
                },
                [rif().class('tab-bar_oPw').class('tab_Hrb')],{
                    'Settings':'设置'
                }

            ),
            色彩调整: RE(
                [MAIN.设置.选项],{
                    'ColorAdjustments':'色彩调整'
                }
            ),
            水景工具:RE(
                [MAIN.设置.选项],{
                    'Water Features':'水景工具'
                },
                [MAIN.设置.标签,MAIN.设置.标题],{
                    'Enable Seasonal Streams': '启用季节性河流',
                    'Simulate Snow Melt': '模拟雪融化',
                    'Constant Flow Rate': '恒定流速',
                    'Seasonality': '季节性',
                    'Stormwater Effects': '雨水效果',
                    'Minimum Multiplier': '最小倍增器',
                    'Maximum Multiplier': '最大倍增器',

                    'Try Smaller Radii': '尝试较小的半径',
                    'Add Detention Basins (Restart Required)': '添加滞留池（需要重新启动）',
                    'Add Retention Basins (Restart Required)': '添加保留池（需要重新启动）',
                    'Evaporation Rate': '蒸发率',

                    'Enable Waves and Tides': '启用波浪和潮汐'
                },
                [MAIN.设置.TAB],{
                    'Seasonal Streams': '季节性溪流',
                    'Water Tool': '水工具',
                    'Waves and Tides': '波浪和潮汐'
                },
                [MAIN.按钮,MAIN.设置.标题],{
                    'Reset Seasonal Streams Settings': '重置季节性溪流设置',
                    'Water Clean Up Cycle': '水清理周期',
                    'Reset Water Tool Settings': '重置水工具设置',
                    'Reset Waves and Tides Settings': '重置波浪和潮汐设置'
                },
                [MAIN.设置.描述],{
                    "Seasonal streams takes Streams (Modified Constant Rate Water Sources) and ties them to the climate and weather for the map. For example, if your map features a dry summer, then these water sources will decrease during the summer. Seasonal streams by it-self should not cause flooding since it treats the map's default water source amount as a maximum unless you change it. All aspects are optional and adjustable in the mod's settings.":
                    '季节性河流将水流（修改后的常定流水源）与地图的气候和天气联系起来。例如，如果你的地图有一个干燥的夏天，那么这些水源在夏天会减少。季节性河流本身不应该引起洪水，因为它将地图的默认水源量视为最大值，除非你进行更改。所有方面都可以在模组的设置中进行选择和调整。',

                    "Simulate snow accumulation and snow melt. Snow melt is not currently tied to snow visuals. This affects Constant Rate Water Sources, Detention and Retention basins.":
                    '模拟雪的积累和融化。目前，雪融化与雪的视觉效果没有直接关联。这会影响常定流水源、蓄水和保水盆地。',

                    "Constant flow rate from  Streams (Modified Constant Rate Water Sources) unaffected by season or weather.":
                    '来自水流（修改后的常定流水源）的常定流速，不受季节或天气的影响。',

                    "Streams (Modified Constant Rate Water Sources) flowrates will increase by this percentage during the season with the highest mean seasonal precipitation. Other seasons will be proportional.":
                    '在具有最高季节降水平均值的季节，水流（修改后的常定流水源）的流速将增加这个百分比。其他季节将成比例增加。',

                    "Streams (Modified Constant Rate Water Sources) flowrates will increase by this percentage when current precipitation (rain) is at a maximum. Less precipitation is proportional.":
                    '在当前降水（雨）达到最大值时，水流（修改后的常定流水源）的流速将增加这个百分比。降水较少时成比例增加。',

                    "Minimum multiplier applied to stream flowrates.":
                    '应用于流速的最小倍增器。',

                    "Maximum multiplier applied to stream flowrates.":
                    '应用于流速的最大倍增器。',

                    "On confirmation, resets Seasonal Streams Settings.":
                    '确认后，将重置季节性河流设置。',

                    "Lets you try to make a water source with a radius smaller than 5m. It will not always work, but will be increased to a radius that does work.":
                    '允许你尝试制作半径小于5米的水源。它不总是有效的，但会增加到有效的半径。',

                    "Custom modded water source that rises with precipitation and snowmelt and slowly drains when the weather is dry. They have a maximum water surface elevation but no minimum water surface elevation. You may need to adjust the global evaporation rate in the settings for desirable infiltration of the pond water.":
                    '自定义修改的水源，随着降水和融雪而上涨，在天气干燥时缓慢排水。它们具有最大水面高度，但没有最小水面高度。你可能需要在设置中调整全局蒸发速率，以便池塘水的渗透效果理想。',

                    "Custom modded water source that rises with precipitation and snowmelt and slowly drains when the weather is dry. They have a maximum water surface elevation and a minimum water surface elevation. You may need to adjust the global evaporation rate in the settings for desirable infiltration of the pond water.":
                    '自定义修改的水源，随着降水和融雪而上涨，在天气干燥时缓慢排水。它们具有最大水面高度和最小水面高度。你可能需要在设置中调整全局蒸发速率，以便池塘水的渗透效果理想。',

                    "Should probably leave at default unless you are using detention or retention basins. Actual evaporation rate is 1000x smaller but this gives you control over the rate. This is global and you may want to rebalance and increase flows of water sources after increasing it.":
                    '除非你正在使用蓄水池或保水池，否则最好保持默认值。实际蒸发速率要小1000倍，但这使你能够控制速率。这是全局的，你可能想在增加后重新平衡和增加水源的流量。',

                    "This will increase the rate of evaporation by 1000x FOR THE WHOLE MAP for a short amount of time before returning to normal. For cleaning up water messes but USE AT YOUR OWN RISK! Lakes with an target elevation below the ground level are a safer way to remove water.":
                    '这将在整个地图上短时间内将蒸发速率提高1000倍，然后恢复正常。用于清理水的混乱，但使用需谨慎！具有目标高程低于地面水平的湖泊是更安全的排水方式。',

                    "On confirmation, resets Water Tool Settings.":
                    '点击确认后，将重置水工具设置。',

                    "This feature is dependent on map design. Maps with a sea water source and a single shoreline work best. The point of the waves feature is to make the shore move in and out and make sand along the shoreline. A better way to make beaches is to just paint them with surface painter instead. Waves exacerbate the magnitude of the water surface. Tides happen once or twice a day. Waves and tides are always lower than the original sea level and do not cause flooding.":
                    '此功能依赖于地图设计。具有海水源和单个海岸线的地图效果最佳。波浪功能的目的是使海岸线进出，并在沿海形成沙滩。更好的制作海滩的方式是使用表面绘图工具直接绘制。波浪加剧了水面的幅度。潮汐每天发生一到两次。波浪和潮汐始终低于原始海平面，不会引起洪水。',

                    "On confirmation, resets Waves and Tides Settings.":
                    '点击确认后，将重置波浪和潮汐设置。',
                },
                [MAIN.工具框.标签],{
                    "Flow":"流量",
                    'Depth':'深度'
                },
                [MAIN.悬浮框.标题],{
                    "Reduce Flow/Depth/Elevation": '减少流量/深度/高程',
                    'Increase Flow/Depth/Elevation': '增加流量/深度/高程',
                    'Flow/Depth/Elevation Rate of Change': '流量/深度/高程变化率',
                    'Reduce Radius': '减小半径',
                    'Increase Radius': '增加半径',
                    'Radius Rate of Change': '半径变化率'

                },
                [MAIN.悬浮框.内容],{
                    "Reduces the flow for Streams. Decreases the depth or elevation for rivers, seas, and lakes. Reduces the max depth for retention and detention basins.":
                    '减小河流的流量。减小河流、海洋和湖泊的深度或高程。减小蓄水和滞水池的最大深度。',

                    "Increases the flow for Streams. Increases the depth or elevation for rivers, seas, and lakes. Increases the max depth for retention and detention basins.":
                    '增加河流的流量。增加河流、海洋和湖泊的深度或高程。增加蓄水和滞水池的最大深度。',

                    "Changes the rate in which the increase and decrease buttons work for Flow, Depth and Elevation.":
                    '改变流量、深度和高程的增加和减少按钮的工作速率。',

                    "Reduces the radius.":'减小半径。',
                    "Increases the radius..":'增加半径。',
                    'Changes the rate in which the increase and decrease buttons work for Radius.':'改变增加和减少按钮在半径上的工作速率。'
                },
                [MAIN.工具栏.资产详情.标题],{
                    'Stream - Constant or Variable Rate Water Source': '小溪 - 恒定或可变速水源',
                    'River - Border River Water Source': '河流 - 边界河水源',
                    'Lake - Constant Level Water Source': '湖泊 - 恒定水平水源',
                    'Sea - Border Sea Water Source': '海洋 - 边界海水源'
                },
                [MAIN.工具栏.资产详情.描述],{
                    'Emits water depending on the settings for this mod. With Seasonal Streams disabled, the flow rate will be constant. With Seasonal Streams enabled the flow rate will vary with season, precipitation, and snowmelt depending on your settings. Left click to place within playable area. Hover over and right click to remove.':
                    '根据此mod的设置释放水。如果禁用了季节性流，流量将保持恒定。启用季节性流时，流量将根据您的设置随季节、降水和融雪而变化。左键单击以放置在可玩区域内。悬停并右键单击以移除。',
                    'Has a constant level and controls water flowing into or out of the border. While near the border, the source will snap to the border. Right click to designate the target elevation. Left click to place. Hover over and right click to remove.':
                    '具有恒定水平并控制流入或流出边界的水。靠近边界时，水源会捕捉到边界。右键单击以指定目标高程。左键单击以放置。悬停并右键单击以移除。',
                    'Fills quickly until it gets to the desired level and then maintains that level. If it has a target elevation below the ground level, it can drain water faster than evaporation. Right click to designate the target elevation. Left click to place within playable area. Hover over and right click to remove.':
                    '快速填充直到达到所需水平，然后保持该水平。如果目标高程低于地面水平，它可以比蒸发更快地排水。右键单击以指定目标高程。左键单击以放置在可玩区域内。悬停并右键单击以移除。',
                    'Controls water flowing into or out of the border and the lowest sea controls sea level. With Waves and Tides disabled, it will maintain constant level. With Waves and Tides enabled the sea level rises and falls below the original sea level. Right click to designate the elevation. Left click to place if the radius touches a border. Hover over and right click to remove.':
                    '控制流入或流出边界的水，最低海域控制海平面。如果禁用了波浪和潮汐，它将保持恒定水平。启用波浪和潮汐时，海平面将在原始海平面以下升降。右键单击以指定高程。如果半径触及边界，则左键单击以放置。悬停并右键单击以移除。'
                },
                [MAIN.悬浮框.提示2],{
                    "Rivers must be placed near map border.":
                    "河流必须靠近地图边界。",
                    "Right click to designate the water surface elevation.":
                    "右键单击以指定水面高程。",
                    "Sea water sources must touch the map border.":
                    "海水源必须接触地图边界。",
                    'This water source must be placed inside the playable map.':
                    '水源必须在地图内'
                }
            ),
            报错翻译: RE(
                [rif({match:'inc',full:'ture',mode:'html'}).class('panel_YqS.error-dialog_iaV').class('error-message_r4_')],{
                    [e_="Can not write to queue when system isn't running"]:e_+"<p>可能的报错模组: </p> <p>·信息隐现 InfoLoom</p>",
                    [e_='URL: coui://linetool']:e_+"<p>可能的报错模组: </p> <p>·条形工具 LineTool</p><p></p><p>原因: </p> <p>缺少前置模组 统一图标库</p>",
                    [e_='System update error during Deserialize']:e_+"<p>可能的报错模组: </p> <p>·现实密度 RealisticDensity</p><p></p><p>原因: </p> <p>反序列化过程中的系统更新错误</p>",
                    [e_='URL: coui://uil/Colored/AnarchyChirper.svg']:e_+"<p>可能的报错模组: </p> <p>·无碰撞 Anarchy</p><p></p><p>原因: </p> <p>缺少前置模组 统一图标库</p>",
                    [e_='URL: coui://gameui/Media/Menu/OverlayBackground.png']:e_+"<p>可能的报错模组: </p> <p>·未知</p><p></p><p>原因: </p> <p>无法加载背景图片</p>",
                    [e_='System update error during GameSimulation System.ArgumentException: Allocator index into TryFunction delegate table exceeds maximum.']:e_+"<p>可能的报错模组: </p> <p>·原版</p><p></p><p>原因: </p> <p>模拟异常-实体内存分配异常</p>",
                    'Anarchy.svg':"<p>可能的报错模组: </p> <p>·无碰撞 Anarchy</p><p></p><p>原因: </p> <p>缺少前置模组 统一图标库</p>"
                },
                [rif({match:'inc',full:'ture',mode:'html'}).class('panel_YqS.error-dialog_iaV').class('content_gqa')],{
                    'RealisticDensity':"<p>可能的报错模组: </p> <p>·现实密度 RealisticDensity</p>"
                }
            )
        }
        for (const [ObjName, ObjReItems] of Object.entries(REPLACE_ITEM_NEW)) {
            for (const [ReFunc, ReStrs] of ObjReItems) {
                ReFunc.forEach(func => func.REPLACE(ReStrs))
            }
        }
        

        

    } catch (err) { addinfo += err ; console.log(err)}
    let time2 = new Date().getTime()
    if (window.__LOGGING__ && document.getElementsByClassName('fps-display_t30').length) {
        if (!document.getElementById('I18loginfo')) {
            let targetDiv = document.getElementsByClassName('fps-display_t30')[0]
            let infoDiv = document.createElement("div")
            infoDiv.innerHTML = `全局汉化: ${window.__LOGGING__} 段字符 , 耗时 ${time2 - time1} ms`
            infoDiv.id = 'I18loginfo'
            infoDiv.style.fontFamily = "Noto Sans SC"
            targetDiv.appendChild(infoDiv);
        } else {
            document.getElementById('I18loginfo').innerHTML = `全局汉化: ${window.__LOGGING__} 段字符 , 耗时 ${time2 - time1} ms`

        }
    }
    try{
    if(rif().class('header_IuN.header_Bpo.child-opacity-transition_nkS').class('title-bar_PF4').items.length){
        let E = rif().class('header_IuN.header_Bpo.child-opacity-transition_nkS').class('title-bar_PF4').items[0]
        let child = E.children[4]
        E.removeChild(child)
        }
    }catch{}

}


setInterval(replaceContent, 150);

const testi18 = async (Func) => {
    function delay(ms) { return new Promise(resolve => setTimeout(resolve, ms)); }
    let clearTime = 0
    while (clearTime < 20) {
        await delay(200)
        try {
            Func()
        } catch { }
        clearTime +=1
    }
}
//REPLACE_ITEMS_END//
var e={431:e=>{var t=.1,n="function"==typeof Float32Array;function r(e,t){return 1-3*t+3*e}function i(e,t){return 3*t-6*e}function o(e){return 3*e}function a(e,t,n){return((r(t,n)*e+i(t,n))*e+o(t))*e}function l(e,t,n){return 3*r(t,n)*e*e+2*i(t,n)*e+o(t)}function s(e){return e}e.exports=function(e,r,i,o){if(!(0<=e&&e<=1&&0<=i&&i<=1))throw new Error("bezier x values must be in [0, 1] range");if(e===r&&i===o)return s;for(var c=n?new Float32Array(11):new Array(11),u=0;u<11;++u)c[u]=a(u*t,e,i);function d(n){for(var r=0,o=1;10!==o&&c[o]<=n;++o)r+=t;--o;var s=r+(n-c[o])/(c[o+1]-c[o])*t,u=l(s,e,i);return u>=.001?function(e,t,n,r){for(var i=0;i<4;++i){var o=l(t,n,r);if(0===o)return t;t-=(a(t,n,r)-e)/o}return t}(n,s,e,i):0===u?s:function(e,t,n,r,i){var o,l,s=0;do{(o=a(l=t+(n-t)/2,r,i)-e)>0?n=l:t=l}while(Math.abs(o)>1e-7&&++s<10);return l}(n,r,r+t,e,i)}return function(e){return 0===e?0:1===e?1:a(d(e),r,o)}}},184:(e,t)=>{var n;!function(){"use strict";var r={}.hasOwnProperty;function i(){for(var e=[],t=0;t<arguments.length;t++){var n=arguments[t];if(n){var o=typeof n;if("string"===o||"number"===o)e.push(n);else if(Array.isArray(n)){if(n.length){var a=i.apply(null,n);a&&e.push(a)}}else if("object"===o){if(n.toString!==Object.prototype.toString&&!n.toString.toString().includes("[native code]")){e.push(n.toString());continue}for(var l in n)r.call(n,l)&&n[l]&&e.push(l)}}}return e.join(" ")}e.exports?(i.default=i,e.exports=i):void 0===(n=function(){return i}.apply(t,[]))||(e.exports=n)}()},448:(e,t,n)=>{"use strict";var r=n(294),i=n(840);function o(e){for(var t="https://reactjs.org/docs/error-decoder.html?invariant="+e,n=1;n<arguments.length;n++)t+="&args[]="+encodeURIComponent(arguments[n]);return"Minified React error #"+e+"; visit "+t+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}var a=new Set,l={};function s(e,t){c(e,t),c(e+"Capture",t)}function c(e,t){for(l[e]=t,e=0;e<t.length;e++)a.add(t[e])}var u=!("undefined"==typeof window||void 0===window.document||void 0===window.document.createElement),d=Object.prototype.hasOwnProperty,f=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,h={},m={};function p(e,t,n,r,i,o,a){this.acceptsBooleans=2===t||3===t||4===t,this.attributeName=r,this.attributeNamespace=i,this.mustUseProperty=n,this.propertyName=e,this.type=t,this.sanitizeURL=o,this.removeEmptyString=a}var v={};"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach((function(e){v[e]=new p(e,0,!1,e,null,!1,!1)})),[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach((function(e){var t=e[0];v[t]=new p(t,1,!1,e[1],null,!1,!1)})),["contentEditable","draggable","spellCheck","value"].forEach((function(e){v[e]=new p(e,2,!1,e.toLowerCase(),null,!1,!1)})),["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach((function(e){v[e]=new p(e,2,!1,e,null,!1,!1)})),"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach((function(e){v[e]=new p(e,3,!1,e.toLowerCase(),null,!1,!1)})),["checked","multiple","muted","selected"].forEach((function(e){v[e]=new p(e,3,!0,e,null,!1,!1)})),["capture","download"].forEach((function(e){v[e]=new p(e,4,!1,e,null,!1,!1)})),["cols","rows","size","span"].forEach((function(e){v[e]=new p(e,6,!1,e,null,!1,!1)})),["rowSpan","start"].forEach((function(e){v[e]=new p(e,5,!1,e.toLowerCase(),null,!1,!1)}));var g=/[\-:]([a-z])/g;function y(e){return e[1].toUpperCase()}function b(e,t,n,r){var i=v.hasOwnProperty(t)?v[t]:null;(null!==i?0!==i.type:r||!(2<t.length)||"o"!==t[0]&&"O"!==t[0]||"n"!==t[1]&&"N"!==t[1])&&(function(e,t,n,r){if(null==t||function(e,t,n,r){if(null!==n&&0===n.type)return!1;switch(typeof t){case"function":case"symbol":return!0;case"boolean":return!r&&(null!==n?!n.acceptsBooleans:"data-"!==(e=e.toLowerCase().slice(0,5))&&"aria-"!==e);default:return!1}}(e,t,n,r))return!0;if(r)return!1;if(null!==n)switch(n.type){case 3:return!t;case 4:return!1===t;case 5:return isNaN(t);case 6:return isNaN(t)||1>t}return!1}(t,n,i,r)&&(n=null),r||null===i?function(e){return!!d.call(m,e)||!d.call(h,e)&&(f.test(e)?m[e]=!0:(h[e]=!0,!1))}(t)&&(null===n?e.removeAttribute(t):e.setAttribute(t,""+n)):i.mustUseProperty?e[i.propertyName]=null===n?3!==i.type&&"":n:(t=i.attributeName,r=i.attributeNamespace,null===n?e.removeAttribute(t):(n=3===(i=i.type)||4===i&&!0===n?"":""+n,r?e.setAttributeNS(r,t,n):e.setAttribute(t,n))))}"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach((function(e){var t=e.replace(g,y);v[t]=new p(t,1,!1,e,null,!1,!1)})),"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach((function(e){var t=e.replace(g,y);v[t]=new p(t,1,!1,e,"http://www.w3.org/1999/xlink",!1,!1)})),["xml:base","xml:lang","xml:space"].forEach((function(e){var t=e.replace(g,y);v[t]=new p(t,1,!1,e,"http://www.w3.org/XML/1998/namespace",!1,!1)})),["tabIndex","crossOrigin"].forEach((function(e){v[e]=new p(e,1,!1,e.toLowerCase(),null,!1,!1)})),v.xlinkHref=new p("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1),["src","href","action","formAction"].forEach((function(e){v[e]=new p(e,1,!1,e.toLowerCase(),null,!0,!0)}));var x=r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,_=Symbol.for("react.element"),j=Symbol.for("react.portal"),E=Symbol.for("react.fragment"),O=Symbol.for("react.strict_mode"),T=Symbol.for("react.profiler"),I=Symbol.for("react.provider"),S=Symbol.for("react.context"),w=Symbol.for("react.forward_ref"),N=Symbol.for("react.suspense"),P=Symbol.for("react.suspense_list"),C=Symbol.for("react.memo"),A=Symbol.for("react.lazy");Symbol.for("react.scope"),Symbol.for("react.debug_trace_mode");var L=Symbol.for("react.offscreen");Symbol.for("react.legacy_hidden"),Symbol.for("react.cache"),Symbol.for("react.tracing_marker");var M=Symbol.iterator;function R(e){return null===e||"object"!=typeof e?null:"function"==typeof(e=M&&e[M]||e["@@iterator"])?e:null}var k,D=Object.assign;function U(e){if(void 0===k)try{throw Error()}catch(e){var t=e.stack.trim().match(/\n( *(at )?)/);k=t&&t[1]||""}return"\n"+k+e}var F=!1;function G(e,t){if(!e||F)return"";F=!0;var n=Error.prepareStackTrace;Error.prepareStackTrace=void 0;try{if(t)if(t=function(){throw Error()},Object.defineProperty(t.prototype,"props",{set:function(){throw Error()}}),"object"==typeof Reflect&&Reflect.construct){try{Reflect.construct(t,[])}catch(e){var r=e}Reflect.construct(e,[],t)}else{try{t.call()}catch(e){r=e}e.call(t.prototype)}else{try{throw Error()}catch(e){r=e}e()}}catch(t){if(t&&r&&"string"==typeof t.stack){for(var i=t.stack.split("\n"),o=r.stack.split("\n"),a=i.length-1,l=o.length-1;1<=a&&0<=l&&i[a]!==o[l];)l--;for(;1<=a&&0<=l;a--,l--)if(i[a]!==o[l]){if(1!==a||1!==l)do{if(a--,0>--l||i[a]!==o[l]){var s="\n"+i[a].replace(" at new "," at ");return e.displayName&&s.includes("<anonymous>")&&(s=s.replace("<anonymous>",e.displayName)),s}}while(1<=a&&0<=l);break}}}finally{F=!1,Error.prepareStackTrace=n}return(e=e?e.displayName||e.name:"")?U(e):""}function V(e){switch(e.tag){case 5:return U(e.type);case 16:return U("Lazy");case 13:return U("Suspense");case 19:return U("SuspenseList");case 0:case 2:case 15:return e=G(e.type,!1);case 11:return e=G(e.type.render,!1);case 1:return e=G(e.type,!0);default:return""}}function B(e){if(null==e)return null;if("function"==typeof e)return e.displayName||e.name||null;if("string"==typeof e)return e;switch(e){case E:return"Fragment";case j:return"Portal";case T:return"Profiler";case O:return"StrictMode";case N:return"Suspense";case P:return"SuspenseList"}if("object"==typeof e)switch(e.$$typeof){case S:return(e.displayName||"Context")+".Consumer";case I:return(e._context.displayName||"Context")+".Provider";case w:var t=e.render;return(e=e.displayName)||(e=""!==(e=t.displayName||t.name||"")?"ForwardRef("+e+")":"ForwardRef"),e;case C:return null!==(t=e.displayName||null)?t:B(e.type)||"Memo";case A:t=e._payload,e=e._init;try{return B(e(t))}catch(e){}}return null}function H(e){var t=e.type;switch(e.tag){case 24:return"Cache";case 9:return(t.displayName||"Context")+".Consumer";case 10:return(t._context.displayName||"Context")+".Provider";case 18:return"DehydratedFragment";case 11:return e=(e=t.render).displayName||e.name||"",t.displayName||(""!==e?"ForwardRef("+e+")":"ForwardRef");case 7:return"Fragment";case 5:return t;case 4:return"Portal";case 3:return"Root";case 6:return"Text";case 16:return B(t);case 8:return t===O?"StrictMode":"Mode";case 22:return"Offscreen";case 12:return"Profiler";case 21:return"Scope";case 13:return"Suspense";case 19:return"SuspenseList";case 25:return"TracingMarker";case 1:case 0:case 17:case 2:case 14:case 15:if("function"==typeof t)return t.displayName||t.name||null;if("string"==typeof t)return t}return null}function K(e){switch(typeof e){case"boolean":case"number":case"string":case"undefined":case"object":return e;default:return""}}function W(e){var t=e.type;return(e=e.nodeName)&&"input"===e.toLowerCase()&&("checkbox"===t||"radio"===t)}function z(e){e._valueTracker||(e._valueTracker=function(e){var t=W(e)?"checked":"value",n=Object.getOwnPropertyDescriptor(e.constructor.prototype,t),r=""+e[t];if(!e.hasOwnProperty(t)&&void 0!==n&&"function"==typeof n.get&&"function"==typeof n.set){var i=n.get,o=n.set;return Object.defineProperty(e,t,{configurable:!0,get:function(){return i.call(this)},set:function(e){r=""+e,o.call(this,e)}}),Object.defineProperty(e,t,{enumerable:n.enumerable}),{getValue:function(){return r},setValue:function(e){r=""+e},stopTracking:function(){e._valueTracker=null,delete e[t]}}}}(e))}function Y(e){if(!e)return!1;var t=e._valueTracker;if(!t)return!0;var n=t.getValue(),r="";return e&&(r=W(e)?e.checked?"true":"false":e.value),(e=r)!==n&&(t.setValue(e),!0)}function X(e){if(void 0===(e=e||("undefined"!=typeof document?document:void 0)))return null;try{return e.activeElement||e.body}catch(t){return e.body}}function q(e,t){var n=t.checked;return D({},t,{defaultChecked:void 0,defaultValue:void 0,value:void 0,checked:null!=n?n:e._wrapperState.initialChecked})}function $(e,t){var n=null==t.defaultValue?"":t.defaultValue,r=null!=t.checked?t.checked:t.defaultChecked;n=K(null!=t.value?t.value:n),e._wrapperState={initialChecked:r,initialValue:n,controlled:"checkbox"===t.type||"radio"===t.type?null!=t.checked:null!=t.value}}function Q(e,t){null!=(t=t.checked)&&b(e,"checked",t,!1)}function Z(e,t){Q(e,t);var n=K(t.value),r=t.type;if(null!=n)"number"===r?(0===n&&""===e.value||e.value!=n)&&(e.value=""+n):e.value!==""+n&&(e.value=""+n);else if("submit"===r||"reset"===r)return void e.removeAttribute("value");t.hasOwnProperty("value")?ee(e,t.type,n):t.hasOwnProperty("defaultValue")&&ee(e,t.type,K(t.defaultValue)),null==t.checked&&null!=t.defaultChecked&&(e.defaultChecked=!!t.defaultChecked)}function J(e,t,n){if(t.hasOwnProperty("value")||t.hasOwnProperty("defaultValue")){var r=t.type;if(!("submit"!==r&&"reset"!==r||void 0!==t.value&&null!==t.value))return;t=""+e._wrapperState.initialValue,n||t===e.value||(e.value=t),e.defaultValue=t}""!==(n=e.name)&&(e.name=""),e.defaultChecked=!!e._wrapperState.initialChecked,""!==n&&(e.name=n)}function ee(e,t,n){"number"===t&&X(e.ownerDocument)===e||(null==n?e.defaultValue=""+e._wrapperState.initialValue:e.defaultValue!==""+n&&(e.defaultValue=""+n))}var te=Array.isArray;function ne(e,t,n,r){if(e=e.options,t){t={};for(var i=0;i<n.length;i++)t["$"+n[i]]=!0;for(n=0;n<e.length;n++)i=t.hasOwnProperty("$"+e[n].value),e[n].selected!==i&&(e[n].selected=i),i&&r&&(e[n].defaultSelected=!0)}else{for(n=""+K(n),t=null,i=0;i<e.length;i++){if(e[i].value===n)return e[i].selected=!0,void(r&&(e[i].defaultSelected=!0));null!==t||e[i].disabled||(t=e[i])}null!==t&&(t.selected=!0)}}function re(e,t){if(null!=t.dangerouslySetInnerHTML)throw Error(o(91));return D({},t,{value:void 0,defaultValue:void 0,children:""+e._wrapperState.initialValue})}function ie(e,t){var n=t.value;if(null==n){if(n=t.children,t=t.defaultValue,null!=n){if(null!=t)throw Error(o(92));if(te(n)){if(1<n.length)throw Error(o(93));n=n[0]}t=n}null==t&&(t=""),n=t}e._wrapperState={initialValue:K(n)}}function oe(e,t){var n=K(t.value),r=K(t.defaultValue);null!=n&&((n=""+n)!==e.value&&(e.value=n),null==t.defaultValue&&e.defaultValue!==n&&(e.defaultValue=n)),null!=r&&(e.defaultValue=""+r)}function ae(e){var t=e.textContent;t===e._wrapperState.initialValue&&""!==t&&null!==t&&(e.value=t)}function le(e){switch(e){case"svg":return"http://www.w3.org/2000/svg";case"math":return"http://www.w3.org/1998/Math/MathML";default:return"http://www.w3.org/1999/xhtml"}}function se(e,t){return null==e||"http://www.w3.org/1999/xhtml"===e?le(t):"http://www.w3.org/2000/svg"===e&&"foreignObject"===t?"http://www.w3.org/1999/xhtml":e}var ce,ue,de=(ue=function(e,t){if("http://www.w3.org/2000/svg"!==e.namespaceURI||"innerHTML"in e)e.innerHTML=t;else{for((ce=ce||document.createElement("div")).innerHTML="<svg>"+t.valueOf().toString()+"</svg>",t=ce.firstChild;e.firstChild;)e.removeChild(e.firstChild);for(;t.firstChild;)e.appendChild(t.firstChild)}},"undefined"!=typeof MSApp&&MSApp.execUnsafeLocalFunction?function(e,t,n,r){MSApp.execUnsafeLocalFunction((function(){return ue(e,t)}))}:ue);function fe(e,t){if(t){var n=e.firstChild;if(n&&n===e.lastChild&&3===n.nodeType)return void(n.nodeValue=t)}e.textContent=t}var he={animationIterationCount:!0,aspectRatio:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},me=["Webkit","ms","Moz","O"];function pe(e,t,n){return null==t||"boolean"==typeof t||""===t?"":n||"number"!=typeof t||0===t||he.hasOwnProperty(e)&&he[e]?(""+t).trim():t+"px"}function ve(e,t){for(var n in e=e.style,t)if(t.hasOwnProperty(n)){var r=0===n.indexOf("--"),i=pe(n,t[n],r);"float"===n&&(n="cssFloat"),r?e.setProperty(n,i):e[n]=i}}Object.keys(he).forEach((function(e){me.forEach((function(t){t=t+e.charAt(0).toUpperCase()+e.substring(1),he[t]=he[e]}))}));var ge=D({menuitem:!0},{area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0});function ye(e,t){if(t){if(ge[e]&&(null!=t.children||null!=t.dangerouslySetInnerHTML))throw Error(o(137,e));if(null!=t.dangerouslySetInnerHTML){if(null!=t.children)throw Error(o(60));if("object"!=typeof t.dangerouslySetInnerHTML||!("__html"in t.dangerouslySetInnerHTML))throw Error(o(61))}if(null!=t.style&&"object"!=typeof t.style)throw Error(o(62))}}function be(e,t){if(-1===e.indexOf("-"))return"string"==typeof t.is;switch(e){case"annotation-xml":case"color-profile":case"font-face":case"font-face-src":case"font-face-uri":case"font-face-format":case"font-face-name":case"missing-glyph":return!1;default:return!0}}var xe=null;function _e(e){return(e=e.target||e.srcElement||window).correspondingUseElement&&(e=e.correspondingUseElement),3===e.nodeType?e.parentNode:e}var je=null,Ee=null,Oe=null;function Te(e){if(e=bi(e)){if("function"!=typeof je)throw Error(o(280));var t=e.stateNode;t&&(t=_i(t),je(e.stateNode,e.type,t))}}function Ie(e){Ee?Oe?Oe.push(e):Oe=[e]:Ee=e}function Se(){if(Ee){var e=Ee,t=Oe;if(Oe=Ee=null,Te(e),t)for(e=0;e<t.length;e++)Te(t[e])}}function we(e,t){return e(t)}function Ne(){}var Pe=!1;function Ce(e,t,n){if(Pe)return e(t,n);Pe=!0;try{return we(e,t,n)}finally{Pe=!1,(null!==Ee||null!==Oe)&&(Ne(),Se())}}function Ae(e,t){var n=e.stateNode;if(null===n)return null;var r=_i(n);if(null===r)return null;n=r[t];e:switch(t){case"onClick":case"onClickCapture":case"onDoubleClick":case"onDoubleClickCapture":case"onMouseDown":case"onMouseDownCapture":case"onMouseMove":case"onMouseMoveCapture":case"onMouseUp":case"onMouseUpCapture":case"onMouseEnter":(r=!r.disabled)||(r=!("button"===(e=e.type)||"input"===e||"select"===e||"textarea"===e)),e=!r;break e;default:e=!1}if(e)return null;if(n&&"function"!=typeof n)throw Error(o(231,t,typeof n));return n}var Le=!1;if(u)try{var Me={};Object.defineProperty(Me,"passive",{get:function(){Le=!0}}),window.addEventListener("test",Me,Me),window.removeEventListener("test",Me,Me)}catch(ue){Le=!1}function Re(e,t,n,r,i,o,a,l,s){var c=Array.prototype.slice.call(arguments,3);try{t.apply(n,c)}catch(e){this.onError(e)}}var ke=!1,De=null,Ue=!1,Fe=null,Ge={onError:function(e){ke=!0,De=e}};function Ve(e,t,n,r,i,o,a,l,s){ke=!1,De=null,Re.apply(Ge,arguments)}function Be(e){var t=e,n=e;if(e.alternate)for(;t.return;)t=t.return;else{e=t;do{0!=(4098&(t=e).flags)&&(n=t.return),e=t.return}while(e)}return 3===t.tag?n:null}function He(e){if(13===e.tag){var t=e.memoizedState;if(null===t&&(null!==(e=e.alternate)&&(t=e.memoizedState)),null!==t)return t.dehydrated}return null}function Ke(e){if(Be(e)!==e)throw Error(o(188))}function We(e){return null!==(e=function(e){var t=e.alternate;if(!t){if(null===(t=Be(e)))throw Error(o(188));return t!==e?null:e}for(var n=e,r=t;;){var i=n.return;if(null===i)break;var a=i.alternate;if(null===a){if(null!==(r=i.return)){n=r;continue}break}if(i.child===a.child){for(a=i.child;a;){if(a===n)return Ke(i),e;if(a===r)return Ke(i),t;a=a.sibling}throw Error(o(188))}if(n.return!==r.return)n=i,r=a;else{for(var l=!1,s=i.child;s;){if(s===n){l=!0,n=i,r=a;break}if(s===r){l=!0,r=i,n=a;break}s=s.sibling}if(!l){for(s=a.child;s;){if(s===n){l=!0,n=a,r=i;break}if(s===r){l=!0,r=a,n=i;break}s=s.sibling}if(!l)throw Error(o(189))}}if(n.alternate!==r)throw Error(o(190))}if(3!==n.tag)throw Error(o(188));return n.stateNode.current===n?e:t}(e))?ze(e):null}function ze(e){if(5===e.tag||6===e.tag)return e;for(e=e.child;null!==e;){var t=ze(e);if(null!==t)return t;e=e.sibling}return null}var Ye=i.unstable_scheduleCallback,Xe=i.unstable_cancelCallback,qe=i.unstable_shouldYield,$e=i.unstable_requestPaint,Qe=i.unstable_now,Ze=i.unstable_getCurrentPriorityLevel,Je=i.unstable_ImmediatePriority,et=i.unstable_UserBlockingPriority,tt=i.unstable_NormalPriority,nt=i.unstable_LowPriority,rt=i.unstable_IdlePriority,it=null,ot=null;var at=Math.clz32?Math.clz32:function(e){return 0===(e>>>=0)?32:31-(lt(e)/st|0)|0},lt=Math.log,st=Math.LN2;var ct=64,ut=4194304;function dt(e){switch(e&-e){case 1:return 1;case 2:return 2;case 4:return 4;case 8:return 8;case 16:return 16;case 32:return 32;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return 4194240&e;case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:return 130023424&e;case 134217728:return 134217728;case 268435456:return 268435456;case 536870912:return 536870912;case 1073741824:return 1073741824;default:return e}}function ft(e,t){var n=e.pendingLanes;if(0===n)return 0;var r=0,i=e.suspendedLanes,o=e.pingedLanes,a=268435455&n;if(0!==a){var l=a&~i;0!==l?r=dt(l):0!==(o&=a)&&(r=dt(o))}else 0!==(a=n&~i)?r=dt(a):0!==o&&(r=dt(o));if(0===r)return 0;if(0!==t&&t!==r&&0==(t&i)&&((i=r&-r)>=(o=t&-t)||16===i&&0!=(4194240&o)))return t;if(0!=(4&r)&&(r|=16&n),0!==(t=e.entangledLanes))for(e=e.entanglements,t&=r;0<t;)i=1<<(n=31-at(t)),r|=e[n],t&=~i;return r}function ht(e,t){switch(e){case 1:case 2:case 4:return t+250;case 8:case 16:case 32:case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return t+5e3;default:return-1}}function mt(e){return 0!==(e=-1073741825&e.pendingLanes)?e:1073741824&e?1073741824:0}function pt(){var e=ct;return 0==(4194240&(ct<<=1))&&(ct=64),e}function vt(e){for(var t=[],n=0;31>n;n++)t.push(e);return t}function gt(e,t,n){e.pendingLanes|=t,536870912!==t&&(e.suspendedLanes=0,e.pingedLanes=0),(e=e.eventTimes)[t=31-at(t)]=n}function yt(e,t){var n=e.entangledLanes|=t;for(e=e.entanglements;n;){var r=31-at(n),i=1<<r;i&t|e[r]&t&&(e[r]|=t),n&=~i}}var bt=0;function xt(e){return 1<(e&=-e)?4<e?0!=(268435455&e)?16:536870912:4:1}var _t,jt,Et,Ot,Tt,It=!1,St=[],wt=null,Nt=null,Pt=null,Ct=new Map,At=new Map,Lt=[],Mt="mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");function Rt(e,t){switch(e){case"focusin":case"focusout":wt=null;break;case"dragenter":case"dragleave":Nt=null;break;case"mouseover":case"mouseout":Pt=null;break;case"pointerover":case"pointerout":Ct.delete(t.pointerId);break;case"gotpointercapture":case"lostpointercapture":At.delete(t.pointerId)}}function kt(e,t,n,r,i,o){return null===e||e.nativeEvent!==o?(e={blockedOn:t,domEventName:n,eventSystemFlags:r,nativeEvent:o,targetContainers:[i]},null!==t&&(null!==(t=bi(t))&&jt(t)),e):(e.eventSystemFlags|=r,t=e.targetContainers,null!==i&&-1===t.indexOf(i)&&t.push(i),e)}function Dt(e){var t=yi(e.target);if(null!==t){var n=Be(t);if(null!==n)if(13===(t=n.tag)){if(null!==(t=He(n)))return e.blockedOn=t,void Tt(e.priority,(function(){Et(n)}))}else if(3===t&&n.stateNode.current.memoizedState.isDehydrated)return void(e.blockedOn=3===n.tag?n.stateNode.containerInfo:null)}e.blockedOn=null}function Ut(e){if(null!==e.blockedOn)return!1;for(var t=e.targetContainers;0<t.length;){var n=qt(e.domEventName,e.eventSystemFlags,t[0],e.nativeEvent);if(null!==n)return null!==(t=bi(n))&&jt(t),e.blockedOn=n,!1;var r=new(n=e.nativeEvent).constructor(n.type,n);xe=r,n.target.dispatchEvent(r),xe=null,t.shift()}return!0}function Ft(e,t,n){Ut(e)&&n.delete(t)}function Gt(){It=!1,null!==wt&&Ut(wt)&&(wt=null),null!==Nt&&Ut(Nt)&&(Nt=null),null!==Pt&&Ut(Pt)&&(Pt=null),Ct.forEach(Ft),At.forEach(Ft)}function Vt(e,t){e.blockedOn===t&&(e.blockedOn=null,It||(It=!0,i.unstable_scheduleCallback(i.unstable_NormalPriority,Gt)))}function Bt(e){function t(t){return Vt(t,e)}if(0<St.length){Vt(St[0],e);for(var n=1;n<St.length;n++){var r=St[n];r.blockedOn===e&&(r.blockedOn=null)}}for(null!==wt&&Vt(wt,e),null!==Nt&&Vt(Nt,e),null!==Pt&&Vt(Pt,e),Ct.forEach(t),At.forEach(t),n=0;n<Lt.length;n++)(r=Lt[n]).blockedOn===e&&(r.blockedOn=null);for(;0<Lt.length&&null===(n=Lt[0]).blockedOn;)Dt(n),null===n.blockedOn&&Lt.shift()}var Ht=x.ReactCurrentBatchConfig,Kt=!0;function Wt(e,t,n,r){var i=bt,o=Ht.transition;Ht.transition=null;try{bt=1,Yt(e,t,n,r)}finally{bt=i,Ht.transition=o}}function zt(e,t,n,r){var i=bt,o=Ht.transition;Ht.transition=null;try{bt=4,Yt(e,t,n,r)}finally{bt=i,Ht.transition=o}}function Yt(e,t,n,r){if(Kt){var i=qt(e,t,n,r);if(null===i)Kr(e,t,r,Xt,n),Rt(e,r);else if(function(e,t,n,r,i){switch(t){case"focusin":return wt=kt(wt,e,t,n,r,i),!0;case"dragenter":return Nt=kt(Nt,e,t,n,r,i),!0;case"mouseover":return Pt=kt(Pt,e,t,n,r,i),!0;case"pointerover":var o=i.pointerId;return Ct.set(o,kt(Ct.get(o)||null,e,t,n,r,i)),!0;case"gotpointercapture":return o=i.pointerId,At.set(o,kt(At.get(o)||null,e,t,n,r,i)),!0}return!1}(i,e,t,n,r))r.stopPropagation();else if(Rt(e,r),4&t&&-1<Mt.indexOf(e)){for(;null!==i;){var o=bi(i);if(null!==o&&_t(o),null===(o=qt(e,t,n,r))&&Kr(e,t,r,Xt,n),o===i)break;i=o}null!==i&&r.stopPropagation()}else Kr(e,t,r,null,n)}}var Xt=null;function qt(e,t,n,r){if(Xt=null,null!==(e=yi(e=_e(r))))if(null===(t=Be(e)))e=null;else if(13===(n=t.tag)){if(null!==(e=He(t)))return e;e=null}else if(3===n){if(t.stateNode.current.memoizedState.isDehydrated)return 3===t.tag?t.stateNode.containerInfo:null;e=null}else t!==e&&(e=null);return Xt=e,null}function $t(e){switch(e){case"cancel":case"click":case"close":case"contextmenu":case"copy":case"cut":case"auxclick":case"dblclick":case"dragend":case"dragstart":case"drop":case"focusin":case"focusout":case"input":case"invalid":case"keydown":case"keypress":case"keyup":case"mousedown":case"mouseup":case"paste":case"pause":case"play":case"pointercancel":case"pointerdown":case"pointerup":case"ratechange":case"reset":case"resize":case"seeked":case"submit":case"touchcancel":case"touchend":case"touchstart":case"volumechange":case"change":case"selectionchange":case"textInput":case"compositionstart":case"compositionend":case"compositionupdate":case"beforeblur":case"afterblur":case"beforeinput":case"blur":case"fullscreenchange":case"focus":case"hashchange":case"popstate":case"select":case"selectstart":return 1;case"drag":case"dragenter":case"dragexit":case"dragleave":case"dragover":case"mousemove":case"mouseout":case"mouseover":case"pointermove":case"pointerout":case"pointerover":case"scroll":case"toggle":case"touchmove":case"wheel":case"mouseenter":case"mouseleave":case"pointerenter":case"pointerleave":return 4;case"message":switch(Ze()){case Je:return 1;case et:return 4;case tt:case nt:return 16;case rt:return 536870912;default:return 16}default:return 16}}var Qt=null,Zt=null,Jt=null;function en(){if(Jt)return Jt;var e,t,n=Zt,r=n.length,i="value"in Qt?Qt.value:Qt.textContent,o=i.length;for(e=0;e<r&&n[e]===i[e];e++);var a=r-e;for(t=1;t<=a&&n[r-t]===i[o-t];t++);return Jt=i.slice(e,1<t?1-t:void 0)}function tn(e){var t=e.keyCode;return"charCode"in e?0===(e=e.charCode)&&13===t&&(e=13):e=t,10===e&&(e=13),32<=e||13===e?e:0}function nn(){return!0}function rn(){return!1}function on(e){function t(t,n,r,i,o){for(var a in this._reactName=t,this._targetInst=r,this.type=n,this.nativeEvent=i,this.target=o,this.currentTarget=null,e)e.hasOwnProperty(a)&&(t=e[a],this[a]=t?t(i):i[a]);return this.isDefaultPrevented=(null!=i.defaultPrevented?i.defaultPrevented:!1===i.returnValue)?nn:rn,this.isPropagationStopped=rn,this}return D(t.prototype,{preventDefault:function(){this.defaultPrevented=!0;var e=this.nativeEvent;e&&(e.preventDefault?e.preventDefault():"unknown"!=typeof e.returnValue&&(e.returnValue=!1),this.isDefaultPrevented=nn)},stopPropagation:function(){var e=this.nativeEvent;e&&(e.stopPropagation?e.stopPropagation():"unknown"!=typeof e.cancelBubble&&(e.cancelBubble=!0),this.isPropagationStopped=nn)},persist:function(){},isPersistent:nn}),t}var an,ln,sn,cn={eventPhase:0,bubbles:0,cancelable:0,timeStamp:function(e){return e.timeStamp||Date.now()},defaultPrevented:0,isTrusted:0},un=on(cn),dn=D({},cn,{view:0,detail:0}),fn=on(dn),hn=D({},dn,{screenX:0,screenY:0,clientX:0,clientY:0,pageX:0,pageY:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,getModifierState:Tn,button:0,buttons:0,relatedTarget:function(e){return void 0===e.relatedTarget?e.fromElement===e.srcElement?e.toElement:e.fromElement:e.relatedTarget},movementX:function(e){return"movementX"in e?e.movementX:(e!==sn&&(sn&&"mousemove"===e.type?(an=e.screenX-sn.screenX,ln=e.screenY-sn.screenY):ln=an=0,sn=e),an)},movementY:function(e){return"movementY"in e?e.movementY:ln}}),mn=on(hn),pn=on(D({},hn,{dataTransfer:0})),vn=on(D({},dn,{relatedTarget:0})),gn=on(D({},cn,{animationName:0,elapsedTime:0,pseudoElement:0})),yn=D({},cn,{clipboardData:function(e){return"clipboardData"in e?e.clipboardData:window.clipboardData}}),bn=on(yn),xn=on(D({},cn,{data:0})),_n={Esc:"Escape",Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},jn={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"},En={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};function On(e){var t=this.nativeEvent;return t.getModifierState?t.getModifierState(e):!!(e=En[e])&&!!t[e]}function Tn(){return On}var In=D({},dn,{key:function(e){if(e.key){var t=_n[e.key]||e.key;if("Unidentified"!==t)return t}return"keypress"===e.type?13===(e=tn(e))?"Enter":String.fromCharCode(e):"keydown"===e.type||"keyup"===e.type?jn[e.keyCode]||"Unidentified":""},code:0,location:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,repeat:0,locale:0,getModifierState:Tn,charCode:function(e){return"keypress"===e.type?tn(e):0},keyCode:function(e){return"keydown"===e.type||"keyup"===e.type?e.keyCode:0},which:function(e){return"keypress"===e.type?tn(e):"keydown"===e.type||"keyup"===e.type?e.keyCode:0}}),Sn=on(In),wn=on(D({},hn,{pointerId:0,width:0,height:0,pressure:0,tangentialPressure:0,tiltX:0,tiltY:0,twist:0,pointerType:0,isPrimary:0})),Nn=on(D({},dn,{touches:0,targetTouches:0,changedTouches:0,altKey:0,metaKey:0,ctrlKey:0,shiftKey:0,getModifierState:Tn})),Pn=on(D({},cn,{propertyName:0,elapsedTime:0,pseudoElement:0})),Cn=D({},hn,{deltaX:function(e){return"deltaX"in e?e.deltaX:"wheelDeltaX"in e?-e.wheelDeltaX:0},deltaY:function(e){return"deltaY"in e?e.deltaY:"wheelDeltaY"in e?-e.wheelDeltaY:"wheelDelta"in e?-e.wheelDelta:0},deltaZ:0,deltaMode:0}),An=on(Cn),Ln=[9,13,27,32],Mn=u&&"CompositionEvent"in window,Rn=null;u&&"documentMode"in document&&(Rn=document.documentMode);var kn=u&&"TextEvent"in window&&!Rn,Dn=u&&(!Mn||Rn&&8<Rn&&11>=Rn),Un=String.fromCharCode(32),Fn=!1;function Gn(e,t){switch(e){case"keyup":return-1!==Ln.indexOf(t.keyCode);case"keydown":return 229!==t.keyCode;case"keypress":case"mousedown":case"focusout":return!0;default:return!1}}function Vn(e){return"object"==typeof(e=e.detail)&&"data"in e?e.data:null}var Bn=!1;var Hn={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};function Kn(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return"input"===t?!!Hn[e.type]:"textarea"===t}function Wn(e,t,n,r){Ie(r),0<(t=zr(t,"onChange")).length&&(n=new un("onChange","change",null,n,r),e.push({event:n,listeners:t}))}var zn=null,Yn=null;function Xn(e){Ur(e,0)}function qn(e){if(Y(xi(e)))return e}function $n(e,t){if("change"===e)return t}var Qn=!1;if(u){var Zn;if(u){var Jn="oninput"in document;if(!Jn){var er=document.createElement("div");er.setAttribute("oninput","return;"),Jn="function"==typeof er.oninput}Zn=Jn}else Zn=!1;Qn=Zn&&(!document.documentMode||9<document.documentMode)}function tr(){zn&&(zn.detachEvent("onpropertychange",nr),Yn=zn=null)}function nr(e){if("value"===e.propertyName&&qn(Yn)){var t=[];Wn(t,Yn,e,_e(e)),Ce(Xn,t)}}function rr(e,t,n){"focusin"===e?(tr(),Yn=n,(zn=t).attachEvent("onpropertychange",nr)):"focusout"===e&&tr()}function ir(e){if("selectionchange"===e||"keyup"===e||"keydown"===e)return qn(Yn)}function or(e,t){if("click"===e)return qn(t)}function ar(e,t){if("input"===e||"change"===e)return qn(t)}var lr="function"==typeof Object.is?Object.is:function(e,t){return e===t&&(0!==e||1/e==1/t)||e!=e&&t!=t};function sr(e,t){if(lr(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var n=Object.keys(e),r=Object.keys(t);if(n.length!==r.length)return!1;for(r=0;r<n.length;r++){var i=n[r];if(!d.call(t,i)||!lr(e[i],t[i]))return!1}return!0}function cr(e){for(;e&&e.firstChild;)e=e.firstChild;return e}function ur(e,t){var n,r=cr(e);for(e=0;r;){if(3===r.nodeType){if(n=e+r.textContent.length,e<=t&&n>=t)return{node:r,offset:t-e};e=n}e:{for(;r;){if(r.nextSibling){r=r.nextSibling;break e}r=r.parentNode}r=void 0}r=cr(r)}}function dr(e,t){return!(!e||!t)&&(e===t||(!e||3!==e.nodeType)&&(t&&3===t.nodeType?dr(e,t.parentNode):"contains"in e?e.contains(t):!!e.compareDocumentPosition&&!!(16&e.compareDocumentPosition(t))))}function fr(){for(var e=window,t=X();t instanceof e.HTMLIFrameElement;){try{var n="string"==typeof t.contentWindow.location.href}catch(e){n=!1}if(!n)break;t=X((e=t.contentWindow).document)}return t}function hr(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return t&&("input"===t&&("text"===e.type||"search"===e.type||"tel"===e.type||"url"===e.type||"password"===e.type)||"textarea"===t||"true"===e.contentEditable)}function mr(e){var t=fr(),n=e.focusedElem,r=e.selectionRange;if(t!==n&&n&&n.ownerDocument&&dr(n.ownerDocument.documentElement,n)){if(null!==r&&hr(n))if(t=r.start,void 0===(e=r.end)&&(e=t),"selectionStart"in n)n.selectionStart=t,n.selectionEnd=Math.min(e,n.value.length);else if((e=(t=n.ownerDocument||document)&&t.defaultView||window).getSelection){e=e.getSelection();var i=n.textContent.length,o=Math.min(r.start,i);r=void 0===r.end?o:Math.min(r.end,i),!e.extend&&o>r&&(i=r,r=o,o=i),i=ur(n,o);var a=ur(n,r);i&&a&&(1!==e.rangeCount||e.anchorNode!==i.node||e.anchorOffset!==i.offset||e.focusNode!==a.node||e.focusOffset!==a.offset)&&((t=t.createRange()).setStart(i.node,i.offset),e.removeAllRanges(),o>r?(e.addRange(t),e.extend(a.node,a.offset)):(t.setEnd(a.node,a.offset),e.addRange(t)))}for(t=[],e=n;e=e.parentNode;)1===e.nodeType&&t.push({element:e,left:e.scrollLeft,top:e.scrollTop});for("function"==typeof n.focus&&n.focus(),n=0;n<t.length;n++)(e=t[n]).element.scrollLeft=e.left,e.element.scrollTop=e.top}}var pr=u&&"documentMode"in document&&11>=document.documentMode,vr=null,gr=null,yr=null,br=!1;function xr(e,t,n){var r=n.window===n?n.document:9===n.nodeType?n:n.ownerDocument;br||null==vr||vr!==X(r)||("selectionStart"in(r=vr)&&hr(r)?r={start:r.selectionStart,end:r.selectionEnd}:r={anchorNode:(r=(r.ownerDocument&&r.ownerDocument.defaultView||window).getSelection()).anchorNode,anchorOffset:r.anchorOffset,focusNode:r.focusNode,focusOffset:r.focusOffset},yr&&sr(yr,r)||(yr=r,0<(r=zr(gr,"onSelect")).length&&(t=new un("onSelect","select",null,t,n),e.push({event:t,listeners:r}),t.target=vr)))}function _r(e,t){var n={};return n[e.toLowerCase()]=t.toLowerCase(),n["Webkit"+e]="webkit"+t,n["Moz"+e]="moz"+t,n}var jr={animationend:_r("Animation","AnimationEnd"),animationiteration:_r("Animation","AnimationIteration"),animationstart:_r("Animation","AnimationStart"),transitionend:_r("Transition","TransitionEnd")},Er={},Or={};function Tr(e){if(Er[e])return Er[e];if(!jr[e])return e;var t,n=jr[e];for(t in n)if(n.hasOwnProperty(t)&&t in Or)return Er[e]=n[t];return e}u&&(Or=document.createElement("div").style,"AnimationEvent"in window||(delete jr.animationend.animation,delete jr.animationiteration.animation,delete jr.animationstart.animation),"TransitionEvent"in window||delete jr.transitionend.transition);var Ir=Tr("animationend"),Sr=Tr("animationiteration"),wr=Tr("animationstart"),Nr=Tr("transitionend"),Pr=new Map,Cr="abort auxClick cancel canPlay canPlayThrough click close contextMenu copy cut drag dragEnd dragEnter dragExit dragLeave dragOver dragStart drop durationChange emptied encrypted ended error gotPointerCapture input invalid keyDown keyPress keyUp load loadedData loadedMetadata loadStart lostPointerCapture mouseDown mouseMove mouseOut mouseOver mouseUp paste pause play playing pointerCancel pointerDown pointerMove pointerOut pointerOver pointerUp progress rateChange reset resize seeked seeking stalled submit suspend timeUpdate touchCancel touchEnd touchStart volumeChange scroll toggle touchMove waiting wheel".split(" ");function Ar(e,t){Pr.set(e,t),s(t,[e])}for(var Lr=0;Lr<Cr.length;Lr++){var Mr=Cr[Lr];Ar(Mr.toLowerCase(),"on"+(Mr[0].toUpperCase()+Mr.slice(1)))}Ar(Ir,"onAnimationEnd"),Ar(Sr,"onAnimationIteration"),Ar(wr,"onAnimationStart"),Ar("dblclick","onDoubleClick"),Ar("focusin","onFocus"),Ar("focusout","onBlur"),Ar(Nr,"onTransitionEnd"),c("onMouseEnter",["mouseout","mouseover"]),c("onMouseLeave",["mouseout","mouseover"]),c("onPointerEnter",["pointerout","pointerover"]),c("onPointerLeave",["pointerout","pointerover"]),s("onChange","change click focusin focusout input keydown keyup selectionchange".split(" ")),s("onSelect","focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" ")),s("onBeforeInput",["compositionend","keypress","textInput","paste"]),s("onCompositionEnd","compositionend focusout keydown keypress keyup mousedown".split(" ")),s("onCompositionStart","compositionstart focusout keydown keypress keyup mousedown".split(" ")),s("onCompositionUpdate","compositionupdate focusout keydown keypress keyup mousedown".split(" "));var Rr="abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange resize seeked seeking stalled suspend timeupdate volumechange waiting".split(" "),kr=new Set("cancel close invalid load scroll toggle".split(" ").concat(Rr));function Dr(e,t,n){var r=e.type||"unknown-event";e.currentTarget=n,function(e,t,n,r,i,a,l,s,c){if(Ve.apply(this,arguments),ke){if(!ke)throw Error(o(198));var u=De;ke=!1,De=null,Ue||(Ue=!0,Fe=u)}}(r,t,void 0,e),e.currentTarget=null}function Ur(e,t){t=0!=(4&t);for(var n=0;n<e.length;n++){var r=e[n],i=r.event;r=r.listeners;e:{var o=void 0;if(t)for(var a=r.length-1;0<=a;a--){var l=r[a],s=l.instance,c=l.currentTarget;if(l=l.listener,s!==o&&i.isPropagationStopped())break e;Dr(i,l,c),o=s}else for(a=0;a<r.length;a++){if(s=(l=r[a]).instance,c=l.currentTarget,l=l.listener,s!==o&&i.isPropagationStopped())break e;Dr(i,l,c),o=s}}}if(Ue)throw e=Fe,Ue=!1,Fe=null,e}function Fr(e,t){var n=t[pi];void 0===n&&(n=t[pi]=new Set);var r=e+"__bubble";n.has(r)||(Hr(t,e,2,!1),n.add(r))}function Gr(e,t,n){var r=0;t&&(r|=4),Hr(n,e,r,t)}var Vr="_reactListening"+Math.random().toString(36).slice(2);function Br(e){if(!e[Vr]){e[Vr]=!0,a.forEach((function(t){"selectionchange"!==t&&(kr.has(t)||Gr(t,!1,e),Gr(t,!0,e))}));var t=9===e.nodeType?e:e.ownerDocument;null===t||t[Vr]||(t[Vr]=!0,Gr("selectionchange",!1,t))}}function Hr(e,t,n,r){switch($t(t)){case 1:var i=Wt;break;case 4:i=zt;break;default:i=Yt}n=i.bind(null,t,n,e),i=void 0,!Le||"touchstart"!==t&&"touchmove"!==t&&"wheel"!==t||(i=!0),r?void 0!==i?e.addEventListener(t,n,{capture:!0,passive:i}):e.addEventListener(t,n,!0):void 0!==i?e.addEventListener(t,n,{passive:i}):e.addEventListener(t,n,!1)}function Kr(e,t,n,r,i){var o=r;if(0==(1&t)&&0==(2&t)&&null!==r)e:for(;;){if(null===r)return;var a=r.tag;if(3===a||4===a){var l=r.stateNode.containerInfo;if(l===i||8===l.nodeType&&l.parentNode===i)break;if(4===a)for(a=r.return;null!==a;){var s=a.tag;if((3===s||4===s)&&((s=a.stateNode.containerInfo)===i||8===s.nodeType&&s.parentNode===i))return;a=a.return}for(;null!==l;){if(null===(a=yi(l)))return;if(5===(s=a.tag)||6===s){r=o=a;continue e}l=l.parentNode}}r=r.return}Ce((function(){var r=o,i=_e(n),a=[];e:{var l=Pr.get(e);if(void 0!==l){var s=un,c=e;switch(e){case"keypress":if(0===tn(n))break e;case"keydown":case"keyup":s=Sn;break;case"focusin":c="focus",s=vn;break;case"focusout":c="blur",s=vn;break;case"beforeblur":case"afterblur":s=vn;break;case"click":if(2===n.button)break e;case"auxclick":case"dblclick":case"mousedown":case"mousemove":case"mouseup":case"mouseout":case"mouseover":case"contextmenu":s=mn;break;case"drag":case"dragend":case"dragenter":case"dragexit":case"dragleave":case"dragover":case"dragstart":case"drop":s=pn;break;case"touchcancel":case"touchend":case"touchmove":case"touchstart":s=Nn;break;case Ir:case Sr:case wr:s=gn;break;case Nr:s=Pn;break;case"scroll":s=fn;break;case"wheel":s=An;break;case"copy":case"cut":case"paste":s=bn;break;case"gotpointercapture":case"lostpointercapture":case"pointercancel":case"pointerdown":case"pointermove":case"pointerout":case"pointerover":case"pointerup":s=wn}var u=0!=(4&t),d=!u&&"scroll"===e,f=u?null!==l?l+"Capture":null:l;u=[];for(var h,m=r;null!==m;){var p=(h=m).stateNode;if(5===h.tag&&null!==p&&(h=p,null!==f&&(null!=(p=Ae(m,f))&&u.push(Wr(m,p,h)))),d)break;m=m.return}0<u.length&&(l=new s(l,c,null,n,i),a.push({event:l,listeners:u}))}}if(0==(7&t)){if(s="mouseout"===e||"pointerout"===e,(!(l="mouseover"===e||"pointerover"===e)||n===xe||!(c=n.relatedTarget||n.fromElement)||!yi(c)&&!c[mi])&&(s||l)&&(l=i.window===i?i:(l=i.ownerDocument)?l.defaultView||l.parentWindow:window,s?(s=r,null!==(c=(c=n.relatedTarget||n.toElement)?yi(c):null)&&(c!==(d=Be(c))||5!==c.tag&&6!==c.tag)&&(c=null)):(s=null,c=r),s!==c)){if(u=mn,p="onMouseLeave",f="onMouseEnter",m="mouse","pointerout"!==e&&"pointerover"!==e||(u=wn,p="onPointerLeave",f="onPointerEnter",m="pointer"),d=null==s?l:xi(s),h=null==c?l:xi(c),(l=new u(p,m+"leave",s,n,i)).target=d,l.relatedTarget=h,p=null,yi(i)===r&&((u=new u(f,m+"enter",c,n,i)).target=h,u.relatedTarget=d,p=u),d=p,s&&c)e:{for(f=c,m=0,h=u=s;h;h=Yr(h))m++;for(h=0,p=f;p;p=Yr(p))h++;for(;0<m-h;)u=Yr(u),m--;for(;0<h-m;)f=Yr(f),h--;for(;m--;){if(u===f||null!==f&&u===f.alternate)break e;u=Yr(u),f=Yr(f)}u=null}else u=null;null!==s&&Xr(a,l,s,u,!1),null!==c&&null!==d&&Xr(a,d,c,u,!0)}if("select"===(s=(l=r?xi(r):window).nodeName&&l.nodeName.toLowerCase())||"input"===s&&"file"===l.type)var v=$n;else if(Kn(l))if(Qn)v=ar;else{v=ir;var g=rr}else(s=l.nodeName)&&"input"===s.toLowerCase()&&("checkbox"===l.type||"radio"===l.type)&&(v=or);switch(v&&(v=v(e,r))?Wn(a,v,n,i):(g&&g(e,l,r),"focusout"===e&&(g=l._wrapperState)&&g.controlled&&"number"===l.type&&ee(l,"number",l.value)),g=r?xi(r):window,e){case"focusin":(Kn(g)||"true"===g.contentEditable)&&(vr=g,gr=r,yr=null);break;case"focusout":yr=gr=vr=null;break;case"mousedown":br=!0;break;case"contextmenu":case"mouseup":case"dragend":br=!1,xr(a,n,i);break;case"selectionchange":if(pr)break;case"keydown":case"keyup":xr(a,n,i)}var y;if(Mn)e:{switch(e){case"compositionstart":var b="onCompositionStart";break e;case"compositionend":b="onCompositionEnd";break e;case"compositionupdate":b="onCompositionUpdate";break e}b=void 0}else Bn?Gn(e,n)&&(b="onCompositionEnd"):"keydown"===e&&229===n.keyCode&&(b="onCompositionStart");b&&(Dn&&"ko"!==n.locale&&(Bn||"onCompositionStart"!==b?"onCompositionEnd"===b&&Bn&&(y=en()):(Zt="value"in(Qt=i)?Qt.value:Qt.textContent,Bn=!0)),0<(g=zr(r,b)).length&&(b=new xn(b,e,null,n,i),a.push({event:b,listeners:g}),y?b.data=y:null!==(y=Vn(n))&&(b.data=y))),(y=kn?function(e,t){switch(e){case"compositionend":return Vn(t);case"keypress":return 32!==t.which?null:(Fn=!0,Un);case"textInput":return(e=t.data)===Un&&Fn?null:e;default:return null}}(e,n):function(e,t){if(Bn)return"compositionend"===e||!Mn&&Gn(e,t)?(e=en(),Jt=Zt=Qt=null,Bn=!1,e):null;switch(e){case"paste":default:return null;case"keypress":if(!(t.ctrlKey||t.altKey||t.metaKey)||t.ctrlKey&&t.altKey){if(t.char&&1<t.char.length)return t.char;if(t.which)return String.fromCharCode(t.which)}return null;case"compositionend":return Dn&&"ko"!==t.locale?null:t.data}}(e,n))&&(0<(r=zr(r,"onBeforeInput")).length&&(i=new xn("onBeforeInput","beforeinput",null,n,i),a.push({event:i,listeners:r}),i.data=y))}Ur(a,t)}))}function Wr(e,t,n){return{instance:e,listener:t,currentTarget:n}}function zr(e,t){for(var n=t+"Capture",r=[];null!==e;){var i=e,o=i.stateNode;5===i.tag&&null!==o&&(i=o,null!=(o=Ae(e,n))&&r.unshift(Wr(e,o,i)),null!=(o=Ae(e,t))&&r.push(Wr(e,o,i))),e=e.return}return r}function Yr(e){if(null===e)return null;do{e=e.return}while(e&&5!==e.tag);return e||null}function Xr(e,t,n,r,i){for(var o=t._reactName,a=[];null!==n&&n!==r;){var l=n,s=l.alternate,c=l.stateNode;if(null!==s&&s===r)break;5===l.tag&&null!==c&&(l=c,i?null!=(s=Ae(n,o))&&a.unshift(Wr(n,s,l)):i||null!=(s=Ae(n,o))&&a.push(Wr(n,s,l))),n=n.return}0!==a.length&&e.push({event:t,listeners:a})}var qr=/\r\n?/g,$r=/\u0000|\uFFFD/g;function Qr(e){return("string"==typeof e?e:""+e).replace(qr,"\n").replace($r,"")}function Zr(e,t,n){if(t=Qr(t),Qr(e)!==t&&n)throw Error(o(425))}function Jr(){}var ei=null,ti=null;function ni(e,t){return"textarea"===e||"noscript"===e||"string"==typeof t.children||"number"==typeof t.children||"object"==typeof t.dangerouslySetInnerHTML&&null!==t.dangerouslySetInnerHTML&&null!=t.dangerouslySetInnerHTML.__html}var ri="function"==typeof setTimeout?setTimeout:void 0,ii="function"==typeof clearTimeout?clearTimeout:void 0,oi="function"==typeof Promise?Promise:void 0,ai="function"==typeof queueMicrotask?queueMicrotask:void 0!==oi?function(e){return oi.resolve(null).then(e).catch(li)}:ri;function li(e){setTimeout((function(){throw e}))}function si(e,t){var n=t,r=0;do{var i=n.nextSibling;if(e.removeChild(n),i&&8===i.nodeType)if("/$"===(n=i.data)){if(0===r)return e.removeChild(i),void Bt(t);r--}else"$"!==n&&"$?"!==n&&"$!"!==n||r++;n=i}while(n);Bt(t)}function ci(e){for(;null!=e;e=e.nextSibling){var t=e.nodeType;if(1===t||3===t)break;if(8===t){if("$"===(t=e.data)||"$!"===t||"$?"===t)break;if("/$"===t)return null}}return e}function ui(e){e=e.previousSibling;for(var t=0;e;){if(8===e.nodeType){var n=e.data;if("$"===n||"$!"===n||"$?"===n){if(0===t)return e;t--}else"/$"===n&&t++}e=e.previousSibling}return null}var di=Math.random().toString(36).slice(2),fi="__reactFiber$"+di,hi="__reactProps$"+di,mi="__reactContainer$"+di,pi="__reactEvents$"+di,vi="__reactListeners$"+di,gi="__reactHandles$"+di;function yi(e){var t=e[fi];if(t)return t;for(var n=e.parentNode;n;){if(t=n[mi]||n[fi]){if(n=t.alternate,null!==t.child||null!==n&&null!==n.child)for(e=ui(e);null!==e;){if(n=e[fi])return n;e=ui(e)}return t}n=(e=n).parentNode}return null}function bi(e){return!(e=e[fi]||e[mi])||5!==e.tag&&6!==e.tag&&13!==e.tag&&3!==e.tag?null:e}function xi(e){if(5===e.tag||6===e.tag)return e.stateNode;throw Error(o(33))}function _i(e){return e[hi]||null}var ji=[],Ei=-1;function Oi(e){return{current:e}}function Ti(e){0>Ei||(e.current=ji[Ei],ji[Ei]=null,Ei--)}function Ii(e,t){Ei++,ji[Ei]=e.current,e.current=t}var Si={},wi=Oi(Si),Ni=Oi(!1),Pi=Si;function Ci(e,t){var n=e.type.contextTypes;if(!n)return Si;var r=e.stateNode;if(r&&r.__reactInternalMemoizedUnmaskedChildContext===t)return r.__reactInternalMemoizedMaskedChildContext;var i,o={};for(i in n)o[i]=t[i];return r&&((e=e.stateNode).__reactInternalMemoizedUnmaskedChildContext=t,e.__reactInternalMemoizedMaskedChildContext=o),o}function Ai(e){return null!=(e=e.childContextTypes)}function Li(){Ti(Ni),Ti(wi)}function Mi(e,t,n){if(wi.current!==Si)throw Error(o(168));Ii(wi,t),Ii(Ni,n)}function Ri(e,t,n){var r=e.stateNode;if(t=t.childContextTypes,"function"!=typeof r.getChildContext)return n;for(var i in r=r.getChildContext())if(!(i in t))throw Error(o(108,H(e)||"Unknown",i));return D({},n,r)}function ki(e){return e=(e=e.stateNode)&&e.__reactInternalMemoizedMergedChildContext||Si,Pi=wi.current,Ii(wi,e),Ii(Ni,Ni.current),!0}function Di(e,t,n){var r=e.stateNode;if(!r)throw Error(o(169));n?(e=Ri(e,t,Pi),r.__reactInternalMemoizedMergedChildContext=e,Ti(Ni),Ti(wi),Ii(wi,e)):Ti(Ni),Ii(Ni,n)}var Ui=null,Fi=!1,Gi=!1;function Vi(e){null===Ui?Ui=[e]:Ui.push(e)}function Bi(){if(!Gi&&null!==Ui){Gi=!0;var e=0,t=bt;try{var n=Ui;for(bt=1;e<n.length;e++){var r=n[e];do{r=r(!0)}while(null!==r)}Ui=null,Fi=!1}catch(t){throw null!==Ui&&(Ui=Ui.slice(e+1)),Ye(Je,Bi),t}finally{bt=t,Gi=!1}}return null}var Hi=[],Ki=0,Wi=null,zi=0,Yi=[],Xi=0,qi=null,$i=1,Qi="";function Zi(e,t){Hi[Ki++]=zi,Hi[Ki++]=Wi,Wi=e,zi=t}function Ji(e,t,n){Yi[Xi++]=$i,Yi[Xi++]=Qi,Yi[Xi++]=qi,qi=e;var r=$i;e=Qi;var i=32-at(r)-1;r&=~(1<<i),n+=1;var o=32-at(t)+i;if(30<o){var a=i-i%5;o=(r&(1<<a)-1).toString(32),r>>=a,i-=a,$i=1<<32-at(t)+i|n<<i|r,Qi=o+e}else $i=1<<o|n<<i|r,Qi=e}function eo(e){null!==e.return&&(Zi(e,1),Ji(e,1,0))}function to(e){for(;e===Wi;)Wi=Hi[--Ki],Hi[Ki]=null,zi=Hi[--Ki],Hi[Ki]=null;for(;e===qi;)qi=Yi[--Xi],Yi[Xi]=null,Qi=Yi[--Xi],Yi[Xi]=null,$i=Yi[--Xi],Yi[Xi]=null}var no=null,ro=null,io=!1,oo=null;function ao(e,t){var n=Cc(5,null,null,0);n.elementType="DELETED",n.stateNode=t,n.return=e,null===(t=e.deletions)?(e.deletions=[n],e.flags|=16):t.push(n)}function lo(e,t){switch(e.tag){case 5:var n=e.type;return null!==(t=1!==t.nodeType||n.toLowerCase()!==t.nodeName.toLowerCase()?null:t)&&(e.stateNode=t,no=e,ro=ci(t.firstChild),!0);case 6:return null!==(t=""===e.pendingProps||3!==t.nodeType?null:t)&&(e.stateNode=t,no=e,ro=null,!0);case 13:return null!==(t=8!==t.nodeType?null:t)&&(n=null!==qi?{id:$i,overflow:Qi}:null,e.memoizedState={dehydrated:t,treeContext:n,retryLane:1073741824},(n=Cc(18,null,null,0)).stateNode=t,n.return=e,e.child=n,no=e,ro=null,!0);default:return!1}}function so(e){return 0!=(1&e.mode)&&0==(128&e.flags)}function co(e){if(io){var t=ro;if(t){var n=t;if(!lo(e,t)){if(so(e))throw Error(o(418));t=ci(n.nextSibling);var r=no;t&&lo(e,t)?ao(r,n):(e.flags=-4097&e.flags|2,io=!1,no=e)}}else{if(so(e))throw Error(o(418));e.flags=-4097&e.flags|2,io=!1,no=e}}}function uo(e){for(e=e.return;null!==e&&5!==e.tag&&3!==e.tag&&13!==e.tag;)e=e.return;no=e}function fo(e){if(e!==no)return!1;if(!io)return uo(e),io=!0,!1;var t;if((t=3!==e.tag)&&!(t=5!==e.tag)&&(t="head"!==(t=e.type)&&"body"!==t&&!ni(e.type,e.memoizedProps)),t&&(t=ro)){if(so(e))throw ho(),Error(o(418));for(;t;)ao(e,t),t=ci(t.nextSibling)}if(uo(e),13===e.tag){if(!(e=null!==(e=e.memoizedState)?e.dehydrated:null))throw Error(o(317));e:{for(e=e.nextSibling,t=0;e;){if(8===e.nodeType){var n=e.data;if("/$"===n){if(0===t){ro=ci(e.nextSibling);break e}t--}else"$"!==n&&"$!"!==n&&"$?"!==n||t++}e=e.nextSibling}ro=null}}else ro=no?ci(e.stateNode.nextSibling):null;return!0}function ho(){for(var e=ro;e;)e=ci(e.nextSibling)}function mo(){ro=no=null,io=!1}function po(e){null===oo?oo=[e]:oo.push(e)}var vo=x.ReactCurrentBatchConfig;function go(e,t){if(e&&e.defaultProps){for(var n in t=D({},t),e=e.defaultProps)void 0===t[n]&&(t[n]=e[n]);return t}return t}var yo=Oi(null),bo=null,xo=null,_o=null;function jo(){_o=xo=bo=null}function Eo(e){var t=yo.current;Ti(yo),e._currentValue=t}function Oo(e,t,n){for(;null!==e;){var r=e.alternate;if((e.childLanes&t)!==t?(e.childLanes|=t,null!==r&&(r.childLanes|=t)):null!==r&&(r.childLanes&t)!==t&&(r.childLanes|=t),e===n)break;e=e.return}}function To(e,t){bo=e,_o=xo=null,null!==(e=e.dependencies)&&null!==e.firstContext&&(0!=(e.lanes&t)&&(xl=!0),e.firstContext=null)}function Io(e){var t=e._currentValue;if(_o!==e)if(e={context:e,memoizedValue:t,next:null},null===xo){if(null===bo)throw Error(o(308));xo=e,bo.dependencies={lanes:0,firstContext:e}}else xo=xo.next=e;return t}var So=null;function wo(e){null===So?So=[e]:So.push(e)}function No(e,t,n,r){var i=t.interleaved;return null===i?(n.next=n,wo(t)):(n.next=i.next,i.next=n),t.interleaved=n,Po(e,r)}function Po(e,t){e.lanes|=t;var n=e.alternate;for(null!==n&&(n.lanes|=t),n=e,e=e.return;null!==e;)e.childLanes|=t,null!==(n=e.alternate)&&(n.childLanes|=t),n=e,e=e.return;return 3===n.tag?n.stateNode:null}var Co=!1;function Ao(e){e.updateQueue={baseState:e.memoizedState,firstBaseUpdate:null,lastBaseUpdate:null,shared:{pending:null,interleaved:null,lanes:0},effects:null}}function Lo(e,t){e=e.updateQueue,t.updateQueue===e&&(t.updateQueue={baseState:e.baseState,firstBaseUpdate:e.firstBaseUpdate,lastBaseUpdate:e.lastBaseUpdate,shared:e.shared,effects:e.effects})}function Mo(e,t){return{eventTime:e,lane:t,tag:0,payload:null,callback:null,next:null}}function Ro(e,t,n){var r=e.updateQueue;if(null===r)return null;if(r=r.shared,0!=(2&ws)){var i=r.pending;return null===i?t.next=t:(t.next=i.next,i.next=t),r.pending=t,Po(e,n)}return null===(i=r.interleaved)?(t.next=t,wo(r)):(t.next=i.next,i.next=t),r.interleaved=t,Po(e,n)}function ko(e,t,n){if(null!==(t=t.updateQueue)&&(t=t.shared,0!=(4194240&n))){var r=t.lanes;n|=r&=e.pendingLanes,t.lanes=n,yt(e,n)}}function Do(e,t){var n=e.updateQueue,r=e.alternate;if(null!==r&&n===(r=r.updateQueue)){var i=null,o=null;if(null!==(n=n.firstBaseUpdate)){do{var a={eventTime:n.eventTime,lane:n.lane,tag:n.tag,payload:n.payload,callback:n.callback,next:null};null===o?i=o=a:o=o.next=a,n=n.next}while(null!==n);null===o?i=o=t:o=o.next=t}else i=o=t;return n={baseState:r.baseState,firstBaseUpdate:i,lastBaseUpdate:o,shared:r.shared,effects:r.effects},void(e.updateQueue=n)}null===(e=n.lastBaseUpdate)?n.firstBaseUpdate=t:e.next=t,n.lastBaseUpdate=t}function Uo(e,t,n,r){var i=e.updateQueue;Co=!1;var o=i.firstBaseUpdate,a=i.lastBaseUpdate,l=i.shared.pending;if(null!==l){i.shared.pending=null;var s=l,c=s.next;s.next=null,null===a?o=c:a.next=c,a=s;var u=e.alternate;null!==u&&((l=(u=u.updateQueue).lastBaseUpdate)!==a&&(null===l?u.firstBaseUpdate=c:l.next=c,u.lastBaseUpdate=s))}if(null!==o){var d=i.baseState;for(a=0,u=c=s=null,l=o;;){var f=l.lane,h=l.eventTime;if((r&f)===f){null!==u&&(u=u.next={eventTime:h,lane:0,tag:l.tag,payload:l.payload,callback:l.callback,next:null});e:{var m=e,p=l;switch(f=t,h=n,p.tag){case 1:if("function"==typeof(m=p.payload)){d=m.call(h,d,f);break e}d=m;break e;case 3:m.flags=-65537&m.flags|128;case 0:if(null==(f="function"==typeof(m=p.payload)?m.call(h,d,f):m))break e;d=D({},d,f);break e;case 2:Co=!0}}null!==l.callback&&0!==l.lane&&(e.flags|=64,null===(f=i.effects)?i.effects=[l]:f.push(l))}else h={eventTime:h,lane:f,tag:l.tag,payload:l.payload,callback:l.callback,next:null},null===u?(c=u=h,s=d):u=u.next=h,a|=f;if(null===(l=l.next)){if(null===(l=i.shared.pending))break;l=(f=l).next,f.next=null,i.lastBaseUpdate=f,i.shared.pending=null}}if(null===u&&(s=d),i.baseState=s,i.firstBaseUpdate=c,i.lastBaseUpdate=u,null!==(t=i.shared.interleaved)){i=t;do{a|=i.lane,i=i.next}while(i!==t)}else null===o&&(i.shared.lanes=0);ks|=a,e.lanes=a,e.memoizedState=d}}function Fo(e,t,n){if(e=t.effects,t.effects=null,null!==e)for(t=0;t<e.length;t++){var r=e[t],i=r.callback;if(null!==i){if(r.callback=null,r=n,"function"!=typeof i)throw Error(o(191,i));i.call(r)}}}var Go=(new r.Component).refs;function Vo(e,t,n,r){n=null==(n=n(r,t=e.memoizedState))?t:D({},t,n),e.memoizedState=n,0===e.lanes&&(e.updateQueue.baseState=n)}var Bo={isMounted:function(e){return!!(e=e._reactInternals)&&Be(e)===e},enqueueSetState:function(e,t,n){e=e._reactInternals;var r=ec(),i=tc(e),o=Mo(r,i);o.payload=t,null!=n&&(o.callback=n),null!==(t=Ro(e,o,i))&&(nc(t,e,i,r),ko(t,e,i))},enqueueReplaceState:function(e,t,n){e=e._reactInternals;var r=ec(),i=tc(e),o=Mo(r,i);o.tag=1,o.payload=t,null!=n&&(o.callback=n),null!==(t=Ro(e,o,i))&&(nc(t,e,i,r),ko(t,e,i))},enqueueForceUpdate:function(e,t){e=e._reactInternals;var n=ec(),r=tc(e),i=Mo(n,r);i.tag=2,null!=t&&(i.callback=t),null!==(t=Ro(e,i,r))&&(nc(t,e,r,n),ko(t,e,r))}};function Ho(e,t,n,r,i,o,a){return"function"==typeof(e=e.stateNode).shouldComponentUpdate?e.shouldComponentUpdate(r,o,a):!t.prototype||!t.prototype.isPureReactComponent||(!sr(n,r)||!sr(i,o))}function Ko(e,t,n){var r=!1,i=Si,o=t.contextType;return"object"==typeof o&&null!==o?o=Io(o):(i=Ai(t)?Pi:wi.current,o=(r=null!=(r=t.contextTypes))?Ci(e,i):Si),t=new t(n,o),e.memoizedState=null!==t.state&&void 0!==t.state?t.state:null,t.updater=Bo,e.stateNode=t,t._reactInternals=e,r&&((e=e.stateNode).__reactInternalMemoizedUnmaskedChildContext=i,e.__reactInternalMemoizedMaskedChildContext=o),t}function Wo(e,t,n,r){e=t.state,"function"==typeof t.componentWillReceiveProps&&t.componentWillReceiveProps(n,r),"function"==typeof t.UNSAFE_componentWillReceiveProps&&t.UNSAFE_componentWillReceiveProps(n,r),t.state!==e&&Bo.enqueueReplaceState(t,t.state,null)}function zo(e,t,n,r){var i=e.stateNode;i.props=n,i.state=e.memoizedState,i.refs=Go,Ao(e);var o=t.contextType;"object"==typeof o&&null!==o?i.context=Io(o):(o=Ai(t)?Pi:wi.current,i.context=Ci(e,o)),i.state=e.memoizedState,"function"==typeof(o=t.getDerivedStateFromProps)&&(Vo(e,t,o,n),i.state=e.memoizedState),"function"==typeof t.getDerivedStateFromProps||"function"==typeof i.getSnapshotBeforeUpdate||"function"!=typeof i.UNSAFE_componentWillMount&&"function"!=typeof i.componentWillMount||(t=i.state,"function"==typeof i.componentWillMount&&i.componentWillMount(),"function"==typeof i.UNSAFE_componentWillMount&&i.UNSAFE_componentWillMount(),t!==i.state&&Bo.enqueueReplaceState(i,i.state,null),Uo(e,n,i,r),i.state=e.memoizedState),"function"==typeof i.componentDidMount&&(e.flags|=4194308)}function Yo(e,t,n){if(null!==(e=n.ref)&&"function"!=typeof e&&"object"!=typeof e){if(n._owner){if(n=n._owner){if(1!==n.tag)throw Error(o(309));var r=n.stateNode}if(!r)throw Error(o(147,e));var i=r,a=""+e;return null!==t&&null!==t.ref&&"function"==typeof t.ref&&t.ref._stringRef===a?t.ref:(t=function(e){var t=i.refs;t===Go&&(t=i.refs={}),null===e?delete t[a]:t[a]=e},t._stringRef=a,t)}if("string"!=typeof e)throw Error(o(284));if(!n._owner)throw Error(o(290,e))}return e}function Xo(e,t){throw e=Object.prototype.toString.call(t),Error(o(31,"[object Object]"===e?"object with keys {"+Object.keys(t).join(", ")+"}":e))}function qo(e){return(0,e._init)(e._payload)}function $o(e){function t(t,n){if(e){var r=t.deletions;null===r?(t.deletions=[n],t.flags|=16):r.push(n)}}function n(n,r){if(!e)return null;for(;null!==r;)t(n,r),r=r.sibling;return null}function r(e,t){for(e=new Map;null!==t;)null!==t.key?e.set(t.key,t):e.set(t.index,t),t=t.sibling;return e}function i(e,t){return(e=Lc(e,t)).index=0,e.sibling=null,e}function a(t,n,r){return t.index=r,e?null!==(r=t.alternate)?(r=r.index)<n?(t.flags|=2,n):r:(t.flags|=2,n):(t.flags|=1048576,n)}function l(t){return e&&null===t.alternate&&(t.flags|=2),t}function s(e,t,n,r){return null===t||6!==t.tag?((t=Dc(n,e.mode,r)).return=e,t):((t=i(t,n)).return=e,t)}function c(e,t,n,r){var o=n.type;return o===E?d(e,t,n.props.children,r,n.key):null!==t&&(t.elementType===o||"object"==typeof o&&null!==o&&o.$$typeof===A&&qo(o)===t.type)?((r=i(t,n.props)).ref=Yo(e,t,n),r.return=e,r):((r=Mc(n.type,n.key,n.props,null,e.mode,r)).ref=Yo(e,t,n),r.return=e,r)}function u(e,t,n,r){return null===t||4!==t.tag||t.stateNode.containerInfo!==n.containerInfo||t.stateNode.implementation!==n.implementation?((t=Uc(n,e.mode,r)).return=e,t):((t=i(t,n.children||[])).return=e,t)}function d(e,t,n,r,o){return null===t||7!==t.tag?((t=Rc(n,e.mode,r,o)).return=e,t):((t=i(t,n)).return=e,t)}function f(e,t,n){if("string"==typeof t&&""!==t||"number"==typeof t)return(t=Dc(""+t,e.mode,n)).return=e,t;if("object"==typeof t&&null!==t){switch(t.$$typeof){case _:return(n=Mc(t.type,t.key,t.props,null,e.mode,n)).ref=Yo(e,null,t),n.return=e,n;case j:return(t=Uc(t,e.mode,n)).return=e,t;case A:return f(e,(0,t._init)(t._payload),n)}if(te(t)||R(t))return(t=Rc(t,e.mode,n,null)).return=e,t;Xo(e,t)}return null}function h(e,t,n,r){var i=null!==t?t.key:null;if("string"==typeof n&&""!==n||"number"==typeof n)return null!==i?null:s(e,t,""+n,r);if("object"==typeof n&&null!==n){switch(n.$$typeof){case _:return n.key===i?c(e,t,n,r):null;case j:return n.key===i?u(e,t,n,r):null;case A:return h(e,t,(i=n._init)(n._payload),r)}if(te(n)||R(n))return null!==i?null:d(e,t,n,r,null);Xo(e,n)}return null}function m(e,t,n,r,i){if("string"==typeof r&&""!==r||"number"==typeof r)return s(t,e=e.get(n)||null,""+r,i);if("object"==typeof r&&null!==r){switch(r.$$typeof){case _:return c(t,e=e.get(null===r.key?n:r.key)||null,r,i);case j:return u(t,e=e.get(null===r.key?n:r.key)||null,r,i);case A:return m(e,t,n,(0,r._init)(r._payload),i)}if(te(r)||R(r))return d(t,e=e.get(n)||null,r,i,null);Xo(t,r)}return null}function p(i,o,l,s){for(var c=null,u=null,d=o,p=o=0,v=null;null!==d&&p<l.length;p++){d.index>p?(v=d,d=null):v=d.sibling;var g=h(i,d,l[p],s);if(null===g){null===d&&(d=v);break}e&&d&&null===g.alternate&&t(i,d),o=a(g,o,p),null===u?c=g:u.sibling=g,u=g,d=v}if(p===l.length)return n(i,d),io&&Zi(i,p),c;if(null===d){for(;p<l.length;p++)null!==(d=f(i,l[p],s))&&(o=a(d,o,p),null===u?c=d:u.sibling=d,u=d);return io&&Zi(i,p),c}for(d=r(i,d);p<l.length;p++)null!==(v=m(d,i,p,l[p],s))&&(e&&null!==v.alternate&&d.delete(null===v.key?p:v.key),o=a(v,o,p),null===u?c=v:u.sibling=v,u=v);return e&&d.forEach((function(e){return t(i,e)})),io&&Zi(i,p),c}function v(i,l,s,c){var u=R(s);if("function"!=typeof u)throw Error(o(150));if(null==(s=u.call(s)))throw Error(o(151));for(var d=u=null,p=l,v=l=0,g=null,y=s.next();null!==p&&!y.done;v++,y=s.next()){p.index>v?(g=p,p=null):g=p.sibling;var b=h(i,p,y.value,c);if(null===b){null===p&&(p=g);break}e&&p&&null===b.alternate&&t(i,p),l=a(b,l,v),null===d?u=b:d.sibling=b,d=b,p=g}if(y.done)return n(i,p),io&&Zi(i,v),u;if(null===p){for(;!y.done;v++,y=s.next())null!==(y=f(i,y.value,c))&&(l=a(y,l,v),null===d?u=y:d.sibling=y,d=y);return io&&Zi(i,v),u}for(p=r(i,p);!y.done;v++,y=s.next())null!==(y=m(p,i,v,y.value,c))&&(e&&null!==y.alternate&&p.delete(null===y.key?v:y.key),l=a(y,l,v),null===d?u=y:d.sibling=y,d=y);return e&&p.forEach((function(e){return t(i,e)})),io&&Zi(i,v),u}return function e(r,o,a,s){if("object"==typeof a&&null!==a&&a.type===E&&null===a.key&&(a=a.props.children),"object"==typeof a&&null!==a){switch(a.$$typeof){case _:e:{for(var c=a.key,u=o;null!==u;){if(u.key===c){if((c=a.type)===E){if(7===u.tag){n(r,u.sibling),(o=i(u,a.props.children)).return=r,r=o;break e}}else if(u.elementType===c||"object"==typeof c&&null!==c&&c.$$typeof===A&&qo(c)===u.type){n(r,u.sibling),(o=i(u,a.props)).ref=Yo(r,u,a),o.return=r,r=o;break e}n(r,u);break}t(r,u),u=u.sibling}a.type===E?((o=Rc(a.props.children,r.mode,s,a.key)).return=r,r=o):((s=Mc(a.type,a.key,a.props,null,r.mode,s)).ref=Yo(r,o,a),s.return=r,r=s)}return l(r);case j:e:{for(u=a.key;null!==o;){if(o.key===u){if(4===o.tag&&o.stateNode.containerInfo===a.containerInfo&&o.stateNode.implementation===a.implementation){n(r,o.sibling),(o=i(o,a.children||[])).return=r,r=o;break e}n(r,o);break}t(r,o),o=o.sibling}(o=Uc(a,r.mode,s)).return=r,r=o}return l(r);case A:return e(r,o,(u=a._init)(a._payload),s)}if(te(a))return p(r,o,a,s);if(R(a))return v(r,o,a,s);Xo(r,a)}return"string"==typeof a&&""!==a||"number"==typeof a?(a=""+a,null!==o&&6===o.tag?(n(r,o.sibling),(o=i(o,a)).return=r,r=o):(n(r,o),(o=Dc(a,r.mode,s)).return=r,r=o),l(r)):n(r,o)}}var Qo=$o(!0),Zo=$o(!1),Jo={},ea=Oi(Jo),ta=Oi(Jo),na=Oi(Jo);function ra(e){if(e===Jo)throw Error(o(174));return e}function ia(e,t){switch(Ii(na,t),Ii(ta,e),Ii(ea,Jo),e=t.nodeType){case 9:case 11:t=(t=t.documentElement)?t.namespaceURI:se(null,"");break;default:t=se(t=(e=8===e?t.parentNode:t).namespaceURI||null,e=e.tagName)}Ti(ea),Ii(ea,t)}function oa(){Ti(ea),Ti(ta),Ti(na)}function aa(e){ra(na.current);var t=ra(ea.current),n=se(t,e.type);t!==n&&(Ii(ta,e),Ii(ea,n))}function la(e){ta.current===e&&(Ti(ea),Ti(ta))}var sa=Oi(0);function ca(e){for(var t=e;null!==t;){if(13===t.tag){var n=t.memoizedState;if(null!==n&&(null===(n=n.dehydrated)||"$?"===n.data||"$!"===n.data))return t}else if(19===t.tag&&void 0!==t.memoizedProps.revealOrder){if(0!=(128&t.flags))return t}else if(null!==t.child){t.child.return=t,t=t.child;continue}if(t===e)break;for(;null===t.sibling;){if(null===t.return||t.return===e)return null;t=t.return}t.sibling.return=t.return,t=t.sibling}return null}var ua=[];function da(){for(var e=0;e<ua.length;e++)ua[e]._workInProgressVersionPrimary=null;ua.length=0}var fa=x.ReactCurrentDispatcher,ha=x.ReactCurrentBatchConfig,ma=0,pa=null,va=null,ga=null,ya=!1,ba=!1,xa=0,_a=0;function ja(){throw Error(o(321))}function Ea(e,t){if(null===t)return!1;for(var n=0;n<t.length&&n<e.length;n++)if(!lr(e[n],t[n]))return!1;return!0}function Oa(e,t,n,r,i,a){if(ma=a,pa=t,t.memoizedState=null,t.updateQueue=null,t.lanes=0,fa.current=null===e||null===e.memoizedState?ll:sl,e=n(r,i),ba){a=0;do{if(ba=!1,xa=0,25<=a)throw Error(o(301));a+=1,ga=va=null,t.updateQueue=null,fa.current=cl,e=n(r,i)}while(ba)}if(fa.current=al,t=null!==va&&null!==va.next,ma=0,ga=va=pa=null,ya=!1,t)throw Error(o(300));return e}function Ta(){var e=0!==xa;return xa=0,e}function Ia(){var e={memoizedState:null,baseState:null,baseQueue:null,queue:null,next:null};return null===ga?pa.memoizedState=ga=e:ga=ga.next=e,ga}function Sa(){if(null===va){var e=pa.alternate;e=null!==e?e.memoizedState:null}else e=va.next;var t=null===ga?pa.memoizedState:ga.next;if(null!==t)ga=t,va=e;else{if(null===e)throw Error(o(310));e={memoizedState:(va=e).memoizedState,baseState:va.baseState,baseQueue:va.baseQueue,queue:va.queue,next:null},null===ga?pa.memoizedState=ga=e:ga=ga.next=e}return ga}function wa(e,t){return"function"==typeof t?t(e):t}function Na(e){var t=Sa(),n=t.queue;if(null===n)throw Error(o(311));n.lastRenderedReducer=e;var r=va,i=r.baseQueue,a=n.pending;if(null!==a){if(null!==i){var l=i.next;i.next=a.next,a.next=l}r.baseQueue=i=a,n.pending=null}if(null!==i){a=i.next,r=r.baseState;var s=l=null,c=null,u=a;do{var d=u.lane;if((ma&d)===d)null!==c&&(c=c.next={lane:0,action:u.action,hasEagerState:u.hasEagerState,eagerState:u.eagerState,next:null}),r=u.hasEagerState?u.eagerState:e(r,u.action);else{var f={lane:d,action:u.action,hasEagerState:u.hasEagerState,eagerState:u.eagerState,next:null};null===c?(s=c=f,l=r):c=c.next=f,pa.lanes|=d,ks|=d}u=u.next}while(null!==u&&u!==a);null===c?l=r:c.next=s,lr(r,t.memoizedState)||(xl=!0),t.memoizedState=r,t.baseState=l,t.baseQueue=c,n.lastRenderedState=r}if(null!==(e=n.interleaved)){i=e;do{a=i.lane,pa.lanes|=a,ks|=a,i=i.next}while(i!==e)}else null===i&&(n.lanes=0);return[t.memoizedState,n.dispatch]}function Pa(e){var t=Sa(),n=t.queue;if(null===n)throw Error(o(311));n.lastRenderedReducer=e;var r=n.dispatch,i=n.pending,a=t.memoizedState;if(null!==i){n.pending=null;var l=i=i.next;do{a=e(a,l.action),l=l.next}while(l!==i);lr(a,t.memoizedState)||(xl=!0),t.memoizedState=a,null===t.baseQueue&&(t.baseState=a),n.lastRenderedState=a}return[a,r]}function Ca(){}function Aa(e,t){var n=pa,r=Sa(),i=t(),a=!lr(r.memoizedState,i);if(a&&(r.memoizedState=i,xl=!0),r=r.queue,Ka(Ra.bind(null,n,r,e),[e]),r.getSnapshot!==t||a||null!==ga&&1&ga.memoizedState.tag){if(n.flags|=2048,Fa(9,Ma.bind(null,n,r,i,t),void 0,null),null===Ns)throw Error(o(349));0!=(30&ma)||La(n,t,i)}return i}function La(e,t,n){e.flags|=16384,e={getSnapshot:t,value:n},null===(t=pa.updateQueue)?(t={lastEffect:null,stores:null},pa.updateQueue=t,t.stores=[e]):null===(n=t.stores)?t.stores=[e]:n.push(e)}function Ma(e,t,n,r){t.value=n,t.getSnapshot=r,ka(t)&&Da(e)}function Ra(e,t,n){return n((function(){ka(t)&&Da(e)}))}function ka(e){var t=e.getSnapshot;e=e.value;try{var n=t();return!lr(e,n)}catch(e){return!0}}function Da(e){var t=Po(e,1);null!==t&&nc(t,e,1,-1)}function Ua(e){var t=Ia();return"function"==typeof e&&(e=e()),t.memoizedState=t.baseState=e,e={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:wa,lastRenderedState:e},t.queue=e,e=e.dispatch=nl.bind(null,pa,e),[t.memoizedState,e]}function Fa(e,t,n,r){return e={tag:e,create:t,destroy:n,deps:r,next:null},null===(t=pa.updateQueue)?(t={lastEffect:null,stores:null},pa.updateQueue=t,t.lastEffect=e.next=e):null===(n=t.lastEffect)?t.lastEffect=e.next=e:(r=n.next,n.next=e,e.next=r,t.lastEffect=e),e}function Ga(){return Sa().memoizedState}function Va(e,t,n,r){var i=Ia();pa.flags|=e,i.memoizedState=Fa(1|t,n,void 0,void 0===r?null:r)}function Ba(e,t,n,r){var i=Sa();r=void 0===r?null:r;var o=void 0;if(null!==va){var a=va.memoizedState;if(o=a.destroy,null!==r&&Ea(r,a.deps))return void(i.memoizedState=Fa(t,n,o,r))}pa.flags|=e,i.memoizedState=Fa(1|t,n,o,r)}function Ha(e,t){return Va(8390656,8,e,t)}function Ka(e,t){return Ba(2048,8,e,t)}function Wa(e,t){return Ba(4,2,e,t)}function za(e,t){return Ba(4,4,e,t)}function Ya(e,t){return"function"==typeof t?(e=e(),t(e),function(){t(null)}):null!=t?(e=e(),t.current=e,function(){t.current=null}):void 0}function Xa(e,t,n){return n=null!=n?n.concat([e]):null,Ba(4,4,Ya.bind(null,t,e),n)}function qa(){}function $a(e,t){var n=Sa();t=void 0===t?null:t;var r=n.memoizedState;return null!==r&&null!==t&&Ea(t,r[1])?r[0]:(n.memoizedState=[e,t],e)}function Qa(e,t){var n=Sa();t=void 0===t?null:t;var r=n.memoizedState;return null!==r&&null!==t&&Ea(t,r[1])?r[0]:(e=e(),n.memoizedState=[e,t],e)}function Za(e,t,n){return 0==(21&ma)?(e.baseState&&(e.baseState=!1,xl=!0),e.memoizedState=n):(lr(n,t)||(n=pt(),pa.lanes|=n,ks|=n,e.baseState=!0),t)}function Ja(e,t){var n=bt;bt=0!==n&&4>n?n:4,e(!0);var r=ha.transition;ha.transition={};try{e(!1),t()}finally{bt=n,ha.transition=r}}function el(){return Sa().memoizedState}function tl(e,t,n){var r=tc(e);if(n={lane:r,action:n,hasEagerState:!1,eagerState:null,next:null},rl(e))il(t,n);else if(null!==(n=No(e,t,n,r))){nc(n,e,r,ec()),ol(n,t,r)}}function nl(e,t,n){var r=tc(e),i={lane:r,action:n,hasEagerState:!1,eagerState:null,next:null};if(rl(e))il(t,i);else{var o=e.alternate;if(0===e.lanes&&(null===o||0===o.lanes)&&null!==(o=t.lastRenderedReducer))try{var a=t.lastRenderedState,l=o(a,n);if(i.hasEagerState=!0,i.eagerState=l,lr(l,a)){var s=t.interleaved;return null===s?(i.next=i,wo(t)):(i.next=s.next,s.next=i),void(t.interleaved=i)}}catch(e){}null!==(n=No(e,t,i,r))&&(nc(n,e,r,i=ec()),ol(n,t,r))}}function rl(e){var t=e.alternate;return e===pa||null!==t&&t===pa}function il(e,t){ba=ya=!0;var n=e.pending;null===n?t.next=t:(t.next=n.next,n.next=t),e.pending=t}function ol(e,t,n){if(0!=(4194240&n)){var r=t.lanes;n|=r&=e.pendingLanes,t.lanes=n,yt(e,n)}}var al={readContext:Io,useCallback:ja,useContext:ja,useEffect:ja,useImperativeHandle:ja,useInsertionEffect:ja,useLayoutEffect:ja,useMemo:ja,useReducer:ja,useRef:ja,useState:ja,useDebugValue:ja,useDeferredValue:ja,useTransition:ja,useMutableSource:ja,useSyncExternalStore:ja,useId:ja,unstable_isNewReconciler:!1},ll={readContext:Io,useCallback:function(e,t){return Ia().memoizedState=[e,void 0===t?null:t],e},useContext:Io,useEffect:Ha,useImperativeHandle:function(e,t,n){return n=null!=n?n.concat([e]):null,Va(4194308,4,Ya.bind(null,t,e),n)},useLayoutEffect:function(e,t){return Va(4194308,4,e,t)},useInsertionEffect:function(e,t){return Va(4,2,e,t)},useMemo:function(e,t){var n=Ia();return t=void 0===t?null:t,e=e(),n.memoizedState=[e,t],e},useReducer:function(e,t,n){var r=Ia();return t=void 0!==n?n(t):t,r.memoizedState=r.baseState=t,e={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:e,lastRenderedState:t},r.queue=e,e=e.dispatch=tl.bind(null,pa,e),[r.memoizedState,e]},useRef:function(e){return e={current:e},Ia().memoizedState=e},useState:Ua,useDebugValue:qa,useDeferredValue:function(e){return Ia().memoizedState=e},useTransition:function(){var e=Ua(!1),t=e[0];return e=Ja.bind(null,e[1]),Ia().memoizedState=e,[t,e]},useMutableSource:function(){},useSyncExternalStore:function(e,t,n){var r=pa,i=Ia();if(io){if(void 0===n)throw Error(o(407));n=n()}else{if(n=t(),null===Ns)throw Error(o(349));0!=(30&ma)||La(r,t,n)}i.memoizedState=n;var a={value:n,getSnapshot:t};return i.queue=a,Ha(Ra.bind(null,r,a,e),[e]),r.flags|=2048,Fa(9,Ma.bind(null,r,a,n,t),void 0,null),n},useId:function(){var e=Ia(),t=Ns.identifierPrefix;if(io){var n=Qi;t=":"+t+"R"+(n=($i&~(1<<32-at($i)-1)).toString(32)+n),0<(n=xa++)&&(t+="H"+n.toString(32)),t+=":"}else t=":"+t+"r"+(n=_a++).toString(32)+":";return e.memoizedState=t},unstable_isNewReconciler:!1},sl={readContext:Io,useCallback:$a,useContext:Io,useEffect:Ka,useImperativeHandle:Xa,useInsertionEffect:Wa,useLayoutEffect:za,useMemo:Qa,useReducer:Na,useRef:Ga,useState:function(){return Na(wa)},useDebugValue:qa,useDeferredValue:function(e){return Za(Sa(),va.memoizedState,e)},useTransition:function(){return[Na(wa)[0],Sa().memoizedState]},useMutableSource:Ca,useSyncExternalStore:Aa,useId:el,unstable_isNewReconciler:!1},cl={readContext:Io,useCallback:$a,useContext:Io,useEffect:Ka,useImperativeHandle:Xa,useInsertionEffect:Wa,useLayoutEffect:za,useMemo:Qa,useReducer:Pa,useRef:Ga,useState:function(){return Pa(wa)},useDebugValue:qa,useDeferredValue:function(e){var t=Sa();return null===va?t.memoizedState=e:Za(t,va.memoizedState,e)},useTransition:function(){return[Pa(wa)[0],Sa().memoizedState]},useMutableSource:Ca,useSyncExternalStore:Aa,useId:el,unstable_isNewReconciler:!1};function ul(e,t){try{var n="",r=t;do{n+=V(r),r=r.return}while(r);var i=n}catch(e){i="\nError generating stack: "+e.message+"\n"+e.stack}return{value:e,source:t,stack:i,digest:null}}function dl(e,t,n){return{value:e,source:null,stack:null!=n?n:null,digest:null!=t?t:null}}function fl(e,t){try{console.error(t.value)}catch(e){setTimeout((function(){throw e}))}}var hl="function"==typeof WeakMap?WeakMap:Map;function ml(e,t,n){(n=Mo(-1,n)).tag=3,n.payload={element:null};var r=t.value;return n.callback=function(){Ks||(Ks=!0,Ws=r),fl(0,t)},n}function pl(e,t,n){(n=Mo(-1,n)).tag=3;var r=e.type.getDerivedStateFromError;if("function"==typeof r){var i=t.value;n.payload=function(){return r(i)},n.callback=function(){fl(0,t)}}var o=e.stateNode;return null!==o&&"function"==typeof o.componentDidCatch&&(n.callback=function(){fl(0,t),"function"!=typeof r&&(null===zs?zs=new Set([this]):zs.add(this));var e=t.stack;this.componentDidCatch(t.value,{componentStack:null!==e?e:""})}),n}function vl(e,t,n){var r=e.pingCache;if(null===r){r=e.pingCache=new hl;var i=new Set;r.set(t,i)}else void 0===(i=r.get(t))&&(i=new Set,r.set(t,i));i.has(n)||(i.add(n),e=Tc.bind(null,e,t,n),t.then(e,e))}function gl(e){do{var t;if((t=13===e.tag)&&(t=null===(t=e.memoizedState)||null!==t.dehydrated),t)return e;e=e.return}while(null!==e);return null}function yl(e,t,n,r,i){return 0==(1&e.mode)?(e===t?e.flags|=65536:(e.flags|=128,n.flags|=131072,n.flags&=-52805,1===n.tag&&(null===n.alternate?n.tag=17:((t=Mo(-1,1)).tag=2,Ro(n,t,1))),n.lanes|=1),e):(e.flags|=65536,e.lanes=i,e)}var bl=x.ReactCurrentOwner,xl=!1;function _l(e,t,n,r){t.child=null===e?Zo(t,null,n,r):Qo(t,e.child,n,r)}function jl(e,t,n,r,i){n=n.render;var o=t.ref;return To(t,i),r=Oa(e,t,n,r,o,i),n=Ta(),null===e||xl?(io&&n&&eo(t),t.flags|=1,_l(e,t,r,i),t.child):(t.updateQueue=e.updateQueue,t.flags&=-2053,e.lanes&=~i,Kl(e,t,i))}function El(e,t,n,r,i){if(null===e){var o=n.type;return"function"!=typeof o||Ac(o)||void 0!==o.defaultProps||null!==n.compare||void 0!==n.defaultProps?((e=Mc(n.type,null,r,t,t.mode,i)).ref=t.ref,e.return=t,t.child=e):(t.tag=15,t.type=o,Ol(e,t,o,r,i))}if(o=e.child,0==(e.lanes&i)){var a=o.memoizedProps;if((n=null!==(n=n.compare)?n:sr)(a,r)&&e.ref===t.ref)return Kl(e,t,i)}return t.flags|=1,(e=Lc(o,r)).ref=t.ref,e.return=t,t.child=e}function Ol(e,t,n,r,i){if(null!==e){var o=e.memoizedProps;if(sr(o,r)&&e.ref===t.ref){if(xl=!1,t.pendingProps=r=o,0==(e.lanes&i))return t.lanes=e.lanes,Kl(e,t,i);0!=(131072&e.flags)&&(xl=!0)}}return Sl(e,t,n,r,i)}function Tl(e,t,n){var r=t.pendingProps,i=r.children,o=null!==e?e.memoizedState:null;if("hidden"===r.mode)if(0==(1&t.mode))t.memoizedState={baseLanes:0,cachePool:null,transitions:null},Ii(Ls,As),As|=n;else{if(0==(1073741824&n))return e=null!==o?o.baseLanes|n:n,t.lanes=t.childLanes=1073741824,t.memoizedState={baseLanes:e,cachePool:null,transitions:null},t.updateQueue=null,Ii(Ls,As),As|=e,null;t.memoizedState={baseLanes:0,cachePool:null,transitions:null},r=null!==o?o.baseLanes:n,Ii(Ls,As),As|=r}else null!==o?(r=o.baseLanes|n,t.memoizedState=null):r=n,Ii(Ls,As),As|=r;return _l(e,t,i,n),t.child}function Il(e,t){var n=t.ref;(null===e&&null!==n||null!==e&&e.ref!==n)&&(t.flags|=512,t.flags|=2097152)}function Sl(e,t,n,r,i){var o=Ai(n)?Pi:wi.current;return o=Ci(t,o),To(t,i),n=Oa(e,t,n,r,o,i),r=Ta(),null===e||xl?(io&&r&&eo(t),t.flags|=1,_l(e,t,n,i),t.child):(t.updateQueue=e.updateQueue,t.flags&=-2053,e.lanes&=~i,Kl(e,t,i))}function wl(e,t,n,r,i){if(Ai(n)){var o=!0;ki(t)}else o=!1;if(To(t,i),null===t.stateNode)Hl(e,t),Ko(t,n,r),zo(t,n,r,i),r=!0;else if(null===e){var a=t.stateNode,l=t.memoizedProps;a.props=l;var s=a.context,c=n.contextType;"object"==typeof c&&null!==c?c=Io(c):c=Ci(t,c=Ai(n)?Pi:wi.current);var u=n.getDerivedStateFromProps,d="function"==typeof u||"function"==typeof a.getSnapshotBeforeUpdate;d||"function"!=typeof a.UNSAFE_componentWillReceiveProps&&"function"!=typeof a.componentWillReceiveProps||(l!==r||s!==c)&&Wo(t,a,r,c),Co=!1;var f=t.memoizedState;a.state=f,Uo(t,r,a,i),s=t.memoizedState,l!==r||f!==s||Ni.current||Co?("function"==typeof u&&(Vo(t,n,u,r),s=t.memoizedState),(l=Co||Ho(t,n,l,r,f,s,c))?(d||"function"!=typeof a.UNSAFE_componentWillMount&&"function"!=typeof a.componentWillMount||("function"==typeof a.componentWillMount&&a.componentWillMount(),"function"==typeof a.UNSAFE_componentWillMount&&a.UNSAFE_componentWillMount()),"function"==typeof a.componentDidMount&&(t.flags|=4194308)):("function"==typeof a.componentDidMount&&(t.flags|=4194308),t.memoizedProps=r,t.memoizedState=s),a.props=r,a.state=s,a.context=c,r=l):("function"==typeof a.componentDidMount&&(t.flags|=4194308),r=!1)}else{a=t.stateNode,Lo(e,t),l=t.memoizedProps,c=t.type===t.elementType?l:go(t.type,l),a.props=c,d=t.pendingProps,f=a.context,"object"==typeof(s=n.contextType)&&null!==s?s=Io(s):s=Ci(t,s=Ai(n)?Pi:wi.current);var h=n.getDerivedStateFromProps;(u="function"==typeof h||"function"==typeof a.getSnapshotBeforeUpdate)||"function"!=typeof a.UNSAFE_componentWillReceiveProps&&"function"!=typeof a.componentWillReceiveProps||(l!==d||f!==s)&&Wo(t,a,r,s),Co=!1,f=t.memoizedState,a.state=f,Uo(t,r,a,i);var m=t.memoizedState;l!==d||f!==m||Ni.current||Co?("function"==typeof h&&(Vo(t,n,h,r),m=t.memoizedState),(c=Co||Ho(t,n,c,r,f,m,s)||!1)?(u||"function"!=typeof a.UNSAFE_componentWillUpdate&&"function"!=typeof a.componentWillUpdate||("function"==typeof a.componentWillUpdate&&a.componentWillUpdate(r,m,s),"function"==typeof a.UNSAFE_componentWillUpdate&&a.UNSAFE_componentWillUpdate(r,m,s)),"function"==typeof a.componentDidUpdate&&(t.flags|=4),"function"==typeof a.getSnapshotBeforeUpdate&&(t.flags|=1024)):("function"!=typeof a.componentDidUpdate||l===e.memoizedProps&&f===e.memoizedState||(t.flags|=4),"function"!=typeof a.getSnapshotBeforeUpdate||l===e.memoizedProps&&f===e.memoizedState||(t.flags|=1024),t.memoizedProps=r,t.memoizedState=m),a.props=r,a.state=m,a.context=s,r=c):("function"!=typeof a.componentDidUpdate||l===e.memoizedProps&&f===e.memoizedState||(t.flags|=4),"function"!=typeof a.getSnapshotBeforeUpdate||l===e.memoizedProps&&f===e.memoizedState||(t.flags|=1024),r=!1)}return Nl(e,t,n,r,o,i)}function Nl(e,t,n,r,i,o){Il(e,t);var a=0!=(128&t.flags);if(!r&&!a)return i&&Di(t,n,!1),Kl(e,t,o);r=t.stateNode,bl.current=t;var l=a&&"function"!=typeof n.getDerivedStateFromError?null:r.render();return t.flags|=1,null!==e&&a?(t.child=Qo(t,e.child,null,o),t.child=Qo(t,null,l,o)):_l(e,t,l,o),t.memoizedState=r.state,i&&Di(t,n,!0),t.child}function Pl(e){var t=e.stateNode;t.pendingContext?Mi(0,t.pendingContext,t.pendingContext!==t.context):t.context&&Mi(0,t.context,!1),ia(e,t.containerInfo)}function Cl(e,t,n,r,i){return mo(),po(i),t.flags|=256,_l(e,t,n,r),t.child}var Al,Ll,Ml,Rl={dehydrated:null,treeContext:null,retryLane:0};function kl(e){return{baseLanes:e,cachePool:null,transitions:null}}function Dl(e,t,n){var r,i=t.pendingProps,a=sa.current,l=!1,s=0!=(128&t.flags);if((r=s)||(r=(null===e||null!==e.memoizedState)&&0!=(2&a)),r?(l=!0,t.flags&=-129):null!==e&&null===e.memoizedState||(a|=1),Ii(sa,1&a),null===e)return co(t),null!==(e=t.memoizedState)&&null!==(e=e.dehydrated)?(0==(1&t.mode)?t.lanes=1:"$!"===e.data?t.lanes=8:t.lanes=1073741824,null):(s=i.children,e=i.fallback,l?(i=t.mode,l=t.child,s={mode:"hidden",children:s},0==(1&i)&&null!==l?(l.childLanes=0,l.pendingProps=s):l=kc(s,i,0,null),e=Rc(e,i,n,null),l.return=t,e.return=t,l.sibling=e,t.child=l,t.child.memoizedState=kl(n),t.memoizedState=Rl,e):Ul(t,s));if(null!==(a=e.memoizedState)&&null!==(r=a.dehydrated))return function(e,t,n,r,i,a,l){if(n)return 256&t.flags?(t.flags&=-257,Fl(e,t,l,r=dl(Error(o(422))))):null!==t.memoizedState?(t.child=e.child,t.flags|=128,null):(a=r.fallback,i=t.mode,r=kc({mode:"visible",children:r.children},i,0,null),(a=Rc(a,i,l,null)).flags|=2,r.return=t,a.return=t,r.sibling=a,t.child=r,0!=(1&t.mode)&&Qo(t,e.child,null,l),t.child.memoizedState=kl(l),t.memoizedState=Rl,a);if(0==(1&t.mode))return Fl(e,t,l,null);if("$!"===i.data){if(r=i.nextSibling&&i.nextSibling.dataset)var s=r.dgst;return r=s,Fl(e,t,l,r=dl(a=Error(o(419)),r,void 0))}if(s=0!=(l&e.childLanes),xl||s){if(null!==(r=Ns)){switch(l&-l){case 4:i=2;break;case 16:i=8;break;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:i=32;break;case 536870912:i=268435456;break;default:i=0}0!==(i=0!=(i&(r.suspendedLanes|l))?0:i)&&i!==a.retryLane&&(a.retryLane=i,Po(e,i),nc(r,e,i,-1))}return pc(),Fl(e,t,l,r=dl(Error(o(421))))}return"$?"===i.data?(t.flags|=128,t.child=e.child,t=Sc.bind(null,e),i._reactRetry=t,null):(e=a.treeContext,ro=ci(i.nextSibling),no=t,io=!0,oo=null,null!==e&&(Yi[Xi++]=$i,Yi[Xi++]=Qi,Yi[Xi++]=qi,$i=e.id,Qi=e.overflow,qi=t),(t=Ul(t,r.children)).flags|=4096,t)}(e,t,s,i,r,a,n);if(l){l=i.fallback,s=t.mode,r=(a=e.child).sibling;var c={mode:"hidden",children:i.children};return 0==(1&s)&&t.child!==a?((i=t.child).childLanes=0,i.pendingProps=c,t.deletions=null):(i=Lc(a,c)).subtreeFlags=14680064&a.subtreeFlags,null!==r?l=Lc(r,l):(l=Rc(l,s,n,null)).flags|=2,l.return=t,i.return=t,i.sibling=l,t.child=i,i=l,l=t.child,s=null===(s=e.child.memoizedState)?kl(n):{baseLanes:s.baseLanes|n,cachePool:null,transitions:s.transitions},l.memoizedState=s,l.childLanes=e.childLanes&~n,t.memoizedState=Rl,i}return e=(l=e.child).sibling,i=Lc(l,{mode:"visible",children:i.children}),0==(1&t.mode)&&(i.lanes=n),i.return=t,i.sibling=null,null!==e&&(null===(n=t.deletions)?(t.deletions=[e],t.flags|=16):n.push(e)),t.child=i,t.memoizedState=null,i}function Ul(e,t){return(t=kc({mode:"visible",children:t},e.mode,0,null)).return=e,e.child=t}function Fl(e,t,n,r){return null!==r&&po(r),Qo(t,e.child,null,n),(e=Ul(t,t.pendingProps.children)).flags|=2,t.memoizedState=null,e}function Gl(e,t,n){e.lanes|=t;var r=e.alternate;null!==r&&(r.lanes|=t),Oo(e.return,t,n)}function Vl(e,t,n,r,i){var o=e.memoizedState;null===o?e.memoizedState={isBackwards:t,rendering:null,renderingStartTime:0,last:r,tail:n,tailMode:i}:(o.isBackwards=t,o.rendering=null,o.renderingStartTime=0,o.last=r,o.tail=n,o.tailMode=i)}function Bl(e,t,n){var r=t.pendingProps,i=r.revealOrder,o=r.tail;if(_l(e,t,r.children,n),0!=(2&(r=sa.current)))r=1&r|2,t.flags|=128;else{if(null!==e&&0!=(128&e.flags))e:for(e=t.child;null!==e;){if(13===e.tag)null!==e.memoizedState&&Gl(e,n,t);else if(19===e.tag)Gl(e,n,t);else if(null!==e.child){e.child.return=e,e=e.child;continue}if(e===t)break e;for(;null===e.sibling;){if(null===e.return||e.return===t)break e;e=e.return}e.sibling.return=e.return,e=e.sibling}r&=1}if(Ii(sa,r),0==(1&t.mode))t.memoizedState=null;else switch(i){case"forwards":for(n=t.child,i=null;null!==n;)null!==(e=n.alternate)&&null===ca(e)&&(i=n),n=n.sibling;null===(n=i)?(i=t.child,t.child=null):(i=n.sibling,n.sibling=null),Vl(t,!1,i,n,o);break;case"backwards":for(n=null,i=t.child,t.child=null;null!==i;){if(null!==(e=i.alternate)&&null===ca(e)){t.child=i;break}e=i.sibling,i.sibling=n,n=i,i=e}Vl(t,!0,n,null,o);break;case"together":Vl(t,!1,null,null,void 0);break;default:t.memoizedState=null}return t.child}function Hl(e,t){0==(1&t.mode)&&null!==e&&(e.alternate=null,t.alternate=null,t.flags|=2)}function Kl(e,t,n){if(null!==e&&(t.dependencies=e.dependencies),ks|=t.lanes,0==(n&t.childLanes))return null;if(null!==e&&t.child!==e.child)throw Error(o(153));if(null!==t.child){for(n=Lc(e=t.child,e.pendingProps),t.child=n,n.return=t;null!==e.sibling;)e=e.sibling,(n=n.sibling=Lc(e,e.pendingProps)).return=t;n.sibling=null}return t.child}function Wl(e,t){if(!io)switch(e.tailMode){case"hidden":t=e.tail;for(var n=null;null!==t;)null!==t.alternate&&(n=t),t=t.sibling;null===n?e.tail=null:n.sibling=null;break;case"collapsed":n=e.tail;for(var r=null;null!==n;)null!==n.alternate&&(r=n),n=n.sibling;null===r?t||null===e.tail?e.tail=null:e.tail.sibling=null:r.sibling=null}}function zl(e){var t=null!==e.alternate&&e.alternate.child===e.child,n=0,r=0;if(t)for(var i=e.child;null!==i;)n|=i.lanes|i.childLanes,r|=14680064&i.subtreeFlags,r|=14680064&i.flags,i.return=e,i=i.sibling;else for(i=e.child;null!==i;)n|=i.lanes|i.childLanes,r|=i.subtreeFlags,r|=i.flags,i.return=e,i=i.sibling;return e.subtreeFlags|=r,e.childLanes=n,t}function Yl(e,t,n){var r=t.pendingProps;switch(to(t),t.tag){case 2:case 16:case 15:case 0:case 11:case 7:case 8:case 12:case 9:case 14:return zl(t),null;case 1:case 17:return Ai(t.type)&&Li(),zl(t),null;case 3:return r=t.stateNode,oa(),Ti(Ni),Ti(wi),da(),r.pendingContext&&(r.context=r.pendingContext,r.pendingContext=null),null!==e&&null!==e.child||(fo(t)?t.flags|=4:null===e||e.memoizedState.isDehydrated&&0==(256&t.flags)||(t.flags|=1024,null!==oo&&(ac(oo),oo=null))),zl(t),null;case 5:la(t);var i=ra(na.current);if(n=t.type,null!==e&&null!=t.stateNode)Ll(e,t,n,r),e.ref!==t.ref&&(t.flags|=512,t.flags|=2097152);else{if(!r){if(null===t.stateNode)throw Error(o(166));return zl(t),null}if(e=ra(ea.current),fo(t)){r=t.stateNode,n=t.type;var a=t.memoizedProps;switch(r[fi]=t,r[hi]=a,e=0!=(1&t.mode),n){case"dialog":Fr("cancel",r),Fr("close",r);break;case"iframe":case"object":case"embed":Fr("load",r);break;case"video":case"audio":for(i=0;i<Rr.length;i++)Fr(Rr[i],r);break;case"source":Fr("error",r);break;case"img":case"image":case"link":Fr("error",r),Fr("load",r);break;case"details":Fr("toggle",r);break;case"input":$(r,a),Fr("invalid",r);break;case"select":r._wrapperState={wasMultiple:!!a.multiple},Fr("invalid",r);break;case"textarea":ie(r,a),Fr("invalid",r)}for(var s in ye(n,a),i=null,a)if(a.hasOwnProperty(s)){var c=a[s];"children"===s?"string"==typeof c?r.textContent!==c&&(!0!==a.suppressHydrationWarning&&Zr(r.textContent,c,e),i=["children",c]):"number"==typeof c&&r.textContent!==""+c&&(!0!==a.suppressHydrationWarning&&Zr(r.textContent,c,e),i=["children",""+c]):l.hasOwnProperty(s)&&null!=c&&"onScroll"===s&&Fr("scroll",r)}switch(n){case"input":z(r),J(r,a,!0);break;case"textarea":z(r),ae(r);break;case"select":case"option":break;default:"function"==typeof a.onClick&&(r.onclick=Jr)}r=i,t.updateQueue=r,null!==r&&(t.flags|=4)}else{s=9===i.nodeType?i:i.ownerDocument,"http://www.w3.org/1999/xhtml"===e&&(e=le(n)),"http://www.w3.org/1999/xhtml"===e?"script"===n?((e=s.createElement("div")).innerHTML="<script><\/script>",e=e.removeChild(e.firstChild)):"string"==typeof r.is?e=s.createElement(n,{is:r.is}):(e=s.createElement(n),"select"===n&&(s=e,r.multiple?s.multiple=!0:r.size&&(s.size=r.size))):e=s.createElementNS(e,n),e[fi]=t,e[hi]=r,Al(e,t),t.stateNode=e;e:{switch(s=be(n,r),n){case"dialog":Fr("cancel",e),Fr("close",e),i=r;break;case"iframe":case"object":case"embed":Fr("load",e),i=r;break;case"video":case"audio":for(i=0;i<Rr.length;i++)Fr(Rr[i],e);i=r;break;case"source":Fr("error",e),i=r;break;case"img":case"image":case"link":Fr("error",e),Fr("load",e),i=r;break;case"details":Fr("toggle",e),i=r;break;case"input":$(e,r),i=q(e,r),Fr("invalid",e);break;case"option":default:i=r;break;case"select":e._wrapperState={wasMultiple:!!r.multiple},i=D({},r,{value:void 0}),Fr("invalid",e);break;case"textarea":ie(e,r),i=re(e,r),Fr("invalid",e)}for(a in ye(n,i),c=i)if(c.hasOwnProperty(a)){var u=c[a];"style"===a?ve(e,u):"dangerouslySetInnerHTML"===a?null!=(u=u?u.__html:void 0)&&de(e,u):"children"===a?"string"==typeof u?("textarea"!==n||""!==u)&&fe(e,u):"number"==typeof u&&fe(e,""+u):"suppressContentEditableWarning"!==a&&"suppressHydrationWarning"!==a&&"autoFocus"!==a&&(l.hasOwnProperty(a)?null!=u&&"onScroll"===a&&Fr("scroll",e):null!=u&&b(e,a,u,s))}switch(n){case"input":z(e),J(e,r,!1);break;case"textarea":z(e),ae(e);break;case"option":null!=r.value&&e.setAttribute("value",""+K(r.value));break;case"select":e.multiple=!!r.multiple,null!=(a=r.value)?ne(e,!!r.multiple,a,!1):null!=r.defaultValue&&ne(e,!!r.multiple,r.defaultValue,!0);break;default:"function"==typeof i.onClick&&(e.onclick=Jr)}switch(n){case"button":case"input":case"select":case"textarea":r=!!r.autoFocus;break e;case"img":r=!0;break e;default:r=!1}}r&&(t.flags|=4)}null!==t.ref&&(t.flags|=512,t.flags|=2097152)}return zl(t),null;case 6:if(e&&null!=t.stateNode)Ml(0,t,e.memoizedProps,r);else{if("string"!=typeof r&&null===t.stateNode)throw Error(o(166));if(n=ra(na.current),ra(ea.current),fo(t)){if(r=t.stateNode,n=t.memoizedProps,r[fi]=t,(a=r.nodeValue!==n)&&null!==(e=no))switch(e.tag){case 3:Zr(r.nodeValue,n,0!=(1&e.mode));break;case 5:!0!==e.memoizedProps.suppressHydrationWarning&&Zr(r.nodeValue,n,0!=(1&e.mode))}a&&(t.flags|=4)}else(r=(9===n.nodeType?n:n.ownerDocument).createTextNode(r))[fi]=t,t.stateNode=r}return zl(t),null;case 13:if(Ti(sa),r=t.memoizedState,null===e||null!==e.memoizedState&&null!==e.memoizedState.dehydrated){if(io&&null!==ro&&0!=(1&t.mode)&&0==(128&t.flags))ho(),mo(),t.flags|=98560,a=!1;else if(a=fo(t),null!==r&&null!==r.dehydrated){if(null===e){if(!a)throw Error(o(318));if(!(a=null!==(a=t.memoizedState)?a.dehydrated:null))throw Error(o(317));a[fi]=t}else mo(),0==(128&t.flags)&&(t.memoizedState=null),t.flags|=4;zl(t),a=!1}else null!==oo&&(ac(oo),oo=null),a=!0;if(!a)return 65536&t.flags?t:null}return 0!=(128&t.flags)?(t.lanes=n,t):((r=null!==r)!==(null!==e&&null!==e.memoizedState)&&r&&(t.child.flags|=8192,0!=(1&t.mode)&&(null===e||0!=(1&sa.current)?0===Ms&&(Ms=3):pc())),null!==t.updateQueue&&(t.flags|=4),zl(t),null);case 4:return oa(),null===e&&Br(t.stateNode.containerInfo),zl(t),null;case 10:return Eo(t.type._context),zl(t),null;case 19:if(Ti(sa),null===(a=t.memoizedState))return zl(t),null;if(r=0!=(128&t.flags),null===(s=a.rendering))if(r)Wl(a,!1);else{if(0!==Ms||null!==e&&0!=(128&e.flags))for(e=t.child;null!==e;){if(null!==(s=ca(e))){for(t.flags|=128,Wl(a,!1),null!==(r=s.updateQueue)&&(t.updateQueue=r,t.flags|=4),t.subtreeFlags=0,r=n,n=t.child;null!==n;)e=r,(a=n).flags&=14680066,null===(s=a.alternate)?(a.childLanes=0,a.lanes=e,a.child=null,a.subtreeFlags=0,a.memoizedProps=null,a.memoizedState=null,a.updateQueue=null,a.dependencies=null,a.stateNode=null):(a.childLanes=s.childLanes,a.lanes=s.lanes,a.child=s.child,a.subtreeFlags=0,a.deletions=null,a.memoizedProps=s.memoizedProps,a.memoizedState=s.memoizedState,a.updateQueue=s.updateQueue,a.type=s.type,e=s.dependencies,a.dependencies=null===e?null:{lanes:e.lanes,firstContext:e.firstContext}),n=n.sibling;return Ii(sa,1&sa.current|2),t.child}e=e.sibling}null!==a.tail&&Qe()>Bs&&(t.flags|=128,r=!0,Wl(a,!1),t.lanes=4194304)}else{if(!r)if(null!==(e=ca(s))){if(t.flags|=128,r=!0,null!==(n=e.updateQueue)&&(t.updateQueue=n,t.flags|=4),Wl(a,!0),null===a.tail&&"hidden"===a.tailMode&&!s.alternate&&!io)return zl(t),null}else 2*Qe()-a.renderingStartTime>Bs&&1073741824!==n&&(t.flags|=128,r=!0,Wl(a,!1),t.lanes=4194304);a.isBackwards?(s.sibling=t.child,t.child=s):(null!==(n=a.last)?n.sibling=s:t.child=s,a.last=s)}return null!==a.tail?(t=a.tail,a.rendering=t,a.tail=t.sibling,a.renderingStartTime=Qe(),t.sibling=null,n=sa.current,Ii(sa,r?1&n|2:1&n),t):(zl(t),null);case 22:case 23:return dc(),r=null!==t.memoizedState,null!==e&&null!==e.memoizedState!==r&&(t.flags|=8192),r&&0!=(1&t.mode)?0!=(1073741824&As)&&(zl(t),6&t.subtreeFlags&&(t.flags|=8192)):zl(t),null;case 24:case 25:return null}throw Error(o(156,t.tag))}function Xl(e,t){switch(to(t),t.tag){case 1:return Ai(t.type)&&Li(),65536&(e=t.flags)?(t.flags=-65537&e|128,t):null;case 3:return oa(),Ti(Ni),Ti(wi),da(),0!=(65536&(e=t.flags))&&0==(128&e)?(t.flags=-65537&e|128,t):null;case 5:return la(t),null;case 13:if(Ti(sa),null!==(e=t.memoizedState)&&null!==e.dehydrated){if(null===t.alternate)throw Error(o(340));mo()}return 65536&(e=t.flags)?(t.flags=-65537&e|128,t):null;case 19:return Ti(sa),null;case 4:return oa(),null;case 10:return Eo(t.type._context),null;case 22:case 23:return dc(),null;default:return null}}Al=function(e,t){for(var n=t.child;null!==n;){if(5===n.tag||6===n.tag)e.appendChild(n.stateNode);else if(4!==n.tag&&null!==n.child){n.child.return=n,n=n.child;continue}if(n===t)break;for(;null===n.sibling;){if(null===n.return||n.return===t)return;n=n.return}n.sibling.return=n.return,n=n.sibling}},Ll=function(e,t,n,r){var i=e.memoizedProps;if(i!==r){e=t.stateNode,ra(ea.current);var o,a=null;switch(n){case"input":i=q(e,i),r=q(e,r),a=[];break;case"select":i=D({},i,{value:void 0}),r=D({},r,{value:void 0}),a=[];break;case"textarea":i=re(e,i),r=re(e,r),a=[];break;default:"function"!=typeof i.onClick&&"function"==typeof r.onClick&&(e.onclick=Jr)}for(u in ye(n,r),n=null,i)if(!r.hasOwnProperty(u)&&i.hasOwnProperty(u)&&null!=i[u])if("style"===u){var s=i[u];for(o in s)s.hasOwnProperty(o)&&(n||(n={}),n[o]="")}else"dangerouslySetInnerHTML"!==u&&"children"!==u&&"suppressContentEditableWarning"!==u&&"suppressHydrationWarning"!==u&&"autoFocus"!==u&&(l.hasOwnProperty(u)?a||(a=[]):(a=a||[]).push(u,null));for(u in r){var c=r[u];if(s=null!=i?i[u]:void 0,r.hasOwnProperty(u)&&c!==s&&(null!=c||null!=s))if("style"===u)if(s){for(o in s)!s.hasOwnProperty(o)||c&&c.hasOwnProperty(o)||(n||(n={}),n[o]="");for(o in c)c.hasOwnProperty(o)&&s[o]!==c[o]&&(n||(n={}),n[o]=c[o])}else n||(a||(a=[]),a.push(u,n)),n=c;else"dangerouslySetInnerHTML"===u?(c=c?c.__html:void 0,s=s?s.__html:void 0,null!=c&&s!==c&&(a=a||[]).push(u,c)):"children"===u?"string"!=typeof c&&"number"!=typeof c||(a=a||[]).push(u,""+c):"suppressContentEditableWarning"!==u&&"suppressHydrationWarning"!==u&&(l.hasOwnProperty(u)?(null!=c&&"onScroll"===u&&Fr("scroll",e),a||s===c||(a=[])):(a=a||[]).push(u,c))}n&&(a=a||[]).push("style",n);var u=a;(t.updateQueue=u)&&(t.flags|=4)}},Ml=function(e,t,n,r){n!==r&&(t.flags|=4)};var ql=!1,$l=!1,Ql="function"==typeof WeakSet?WeakSet:Set,Zl=null;function Jl(e,t){var n=e.ref;if(null!==n)if("function"==typeof n)try{n(null)}catch(n){Oc(e,t,n)}else n.current=null}function es(e,t,n){try{n()}catch(n){Oc(e,t,n)}}var ts=!1;function ns(e,t,n){var r=t.updateQueue;if(null!==(r=null!==r?r.lastEffect:null)){var i=r=r.next;do{if((i.tag&e)===e){var o=i.destroy;i.destroy=void 0,void 0!==o&&es(t,n,o)}i=i.next}while(i!==r)}}function rs(e,t){if(null!==(t=null!==(t=t.updateQueue)?t.lastEffect:null)){var n=t=t.next;do{if((n.tag&e)===e){var r=n.create;n.destroy=r()}n=n.next}while(n!==t)}}function is(e){var t=e.ref;if(null!==t){var n=e.stateNode;e.tag,e=n,"function"==typeof t?t(e):t.current=e}}function os(e){var t=e.alternate;null!==t&&(e.alternate=null,os(t)),e.child=null,e.deletions=null,e.sibling=null,5===e.tag&&(null!==(t=e.stateNode)&&(delete t[fi],delete t[hi],delete t[pi],delete t[vi],delete t[gi])),e.stateNode=null,e.return=null,e.dependencies=null,e.memoizedProps=null,e.memoizedState=null,e.pendingProps=null,e.stateNode=null,e.updateQueue=null}function as(e){return 5===e.tag||3===e.tag||4===e.tag}function ls(e){e:for(;;){for(;null===e.sibling;){if(null===e.return||as(e.return))return null;e=e.return}for(e.sibling.return=e.return,e=e.sibling;5!==e.tag&&6!==e.tag&&18!==e.tag;){if(2&e.flags)continue e;if(null===e.child||4===e.tag)continue e;e.child.return=e,e=e.child}if(!(2&e.flags))return e.stateNode}}function ss(e,t,n){var r=e.tag;if(5===r||6===r)e=e.stateNode,t?8===n.nodeType?n.parentNode.insertBefore(e,t):n.insertBefore(e,t):(8===n.nodeType?(t=n.parentNode).insertBefore(e,n):(t=n).appendChild(e),null!=(n=n._reactRootContainer)||null!==t.onclick||(t.onclick=Jr));else if(4!==r&&null!==(e=e.child))for(ss(e,t,n),e=e.sibling;null!==e;)ss(e,t,n),e=e.sibling}function cs(e,t,n){var r=e.tag;if(5===r||6===r)e=e.stateNode,t?n.insertBefore(e,t):n.appendChild(e);else if(4!==r&&null!==(e=e.child))for(cs(e,t,n),e=e.sibling;null!==e;)cs(e,t,n),e=e.sibling}var us=null,ds=!1;function fs(e,t,n){for(n=n.child;null!==n;)hs(e,t,n),n=n.sibling}function hs(e,t,n){if(ot&&"function"==typeof ot.onCommitFiberUnmount)try{ot.onCommitFiberUnmount(it,n)}catch(e){}switch(n.tag){case 5:$l||Jl(n,t);case 6:var r=us,i=ds;us=null,fs(e,t,n),ds=i,null!==(us=r)&&(ds?(e=us,n=n.stateNode,8===e.nodeType?e.parentNode.removeChild(n):e.removeChild(n)):us.removeChild(n.stateNode));break;case 18:null!==us&&(ds?(e=us,n=n.stateNode,8===e.nodeType?si(e.parentNode,n):1===e.nodeType&&si(e,n),Bt(e)):si(us,n.stateNode));break;case 4:r=us,i=ds,us=n.stateNode.containerInfo,ds=!0,fs(e,t,n),us=r,ds=i;break;case 0:case 11:case 14:case 15:if(!$l&&(null!==(r=n.updateQueue)&&null!==(r=r.lastEffect))){i=r=r.next;do{var o=i,a=o.destroy;o=o.tag,void 0!==a&&(0!=(2&o)||0!=(4&o))&&es(n,t,a),i=i.next}while(i!==r)}fs(e,t,n);break;case 1:if(!$l&&(Jl(n,t),"function"==typeof(r=n.stateNode).componentWillUnmount))try{r.props=n.memoizedProps,r.state=n.memoizedState,r.componentWillUnmount()}catch(e){Oc(n,t,e)}fs(e,t,n);break;case 21:fs(e,t,n);break;case 22:1&n.mode?($l=(r=$l)||null!==n.memoizedState,fs(e,t,n),$l=r):fs(e,t,n);break;default:fs(e,t,n)}}function ms(e){var t=e.updateQueue;if(null!==t){e.updateQueue=null;var n=e.stateNode;null===n&&(n=e.stateNode=new Ql),t.forEach((function(t){var r=wc.bind(null,e,t);n.has(t)||(n.add(t),t.then(r,r))}))}}function ps(e,t){var n=t.deletions;if(null!==n)for(var r=0;r<n.length;r++){var i=n[r];try{var a=e,l=t,s=l;e:for(;null!==s;){switch(s.tag){case 5:us=s.stateNode,ds=!1;break e;case 3:case 4:us=s.stateNode.containerInfo,ds=!0;break e}s=s.return}if(null===us)throw Error(o(160));hs(a,l,i),us=null,ds=!1;var c=i.alternate;null!==c&&(c.return=null),i.return=null}catch(e){Oc(i,t,e)}}if(12854&t.subtreeFlags)for(t=t.child;null!==t;)vs(t,e),t=t.sibling}function vs(e,t){var n=e.alternate,r=e.flags;switch(e.tag){case 0:case 11:case 14:case 15:if(ps(t,e),gs(e),4&r){try{ns(3,e,e.return),rs(3,e)}catch(t){Oc(e,e.return,t)}try{ns(5,e,e.return)}catch(t){Oc(e,e.return,t)}}break;case 1:ps(t,e),gs(e),512&r&&null!==n&&Jl(n,n.return);break;case 5:if(ps(t,e),gs(e),512&r&&null!==n&&Jl(n,n.return),32&e.flags){var i=e.stateNode;try{fe(i,"")}catch(t){Oc(e,e.return,t)}}if(4&r&&null!=(i=e.stateNode)){var a=e.memoizedProps,l=null!==n?n.memoizedProps:a,s=e.type,c=e.updateQueue;if(e.updateQueue=null,null!==c)try{"input"===s&&"radio"===a.type&&null!=a.name&&Q(i,a),be(s,l);var u=be(s,a);for(l=0;l<c.length;l+=2){var d=c[l],f=c[l+1];"style"===d?ve(i,f):"dangerouslySetInnerHTML"===d?de(i,f):"children"===d?fe(i,f):b(i,d,f,u)}switch(s){case"input":Z(i,a);break;case"textarea":oe(i,a);break;case"select":var h=i._wrapperState.wasMultiple;i._wrapperState.wasMultiple=!!a.multiple;var m=a.value;null!=m?ne(i,!!a.multiple,m,!1):h!==!!a.multiple&&(null!=a.defaultValue?ne(i,!!a.multiple,a.defaultValue,!0):ne(i,!!a.multiple,a.multiple?[]:"",!1))}i[hi]=a}catch(t){Oc(e,e.return,t)}}break;case 6:if(ps(t,e),gs(e),4&r){if(null===e.stateNode)throw Error(o(162));i=e.stateNode,a=e.memoizedProps;try{i.nodeValue=a}catch(t){Oc(e,e.return,t)}}break;case 3:if(ps(t,e),gs(e),4&r&&null!==n&&n.memoizedState.isDehydrated)try{Bt(t.containerInfo)}catch(t){Oc(e,e.return,t)}break;case 4:default:ps(t,e),gs(e);break;case 13:ps(t,e),gs(e),8192&(i=e.child).flags&&(a=null!==i.memoizedState,i.stateNode.isHidden=a,!a||null!==i.alternate&&null!==i.alternate.memoizedState||(Vs=Qe())),4&r&&ms(e);break;case 22:if(d=null!==n&&null!==n.memoizedState,1&e.mode?($l=(u=$l)||d,ps(t,e),$l=u):ps(t,e),gs(e),8192&r){if(u=null!==e.memoizedState,(e.stateNode.isHidden=u)&&!d&&0!=(1&e.mode))for(Zl=e,d=e.child;null!==d;){for(f=Zl=d;null!==Zl;){switch(m=(h=Zl).child,h.tag){case 0:case 11:case 14:case 15:ns(4,h,h.return);break;case 1:Jl(h,h.return);var p=h.stateNode;if("function"==typeof p.componentWillUnmount){r=h,n=h.return;try{t=r,p.props=t.memoizedProps,p.state=t.memoizedState,p.componentWillUnmount()}catch(e){Oc(r,n,e)}}break;case 5:Jl(h,h.return);break;case 22:if(null!==h.memoizedState){_s(f);continue}}null!==m?(m.return=h,Zl=m):_s(f)}d=d.sibling}e:for(d=null,f=e;;){if(5===f.tag){if(null===d){d=f;try{i=f.stateNode,u?"function"==typeof(a=i.style).setProperty?a.setProperty("display","none","important"):a.display="none":(s=f.stateNode,l=null!=(c=f.memoizedProps.style)&&c.hasOwnProperty("display")?c.display:null,s.style.display=pe("display",l))}catch(t){Oc(e,e.return,t)}}}else if(6===f.tag){if(null===d)try{f.stateNode.nodeValue=u?"":f.memoizedProps}catch(t){Oc(e,e.return,t)}}else if((22!==f.tag&&23!==f.tag||null===f.memoizedState||f===e)&&null!==f.child){f.child.return=f,f=f.child;continue}if(f===e)break e;for(;null===f.sibling;){if(null===f.return||f.return===e)break e;d===f&&(d=null),f=f.return}d===f&&(d=null),f.sibling.return=f.return,f=f.sibling}}break;case 19:ps(t,e),gs(e),4&r&&ms(e);case 21:}}function gs(e){var t=e.flags;if(2&t){try{e:{for(var n=e.return;null!==n;){if(as(n)){var r=n;break e}n=n.return}throw Error(o(160))}switch(r.tag){case 5:var i=r.stateNode;32&r.flags&&(fe(i,""),r.flags&=-33),cs(e,ls(e),i);break;case 3:case 4:var a=r.stateNode.containerInfo;ss(e,ls(e),a);break;default:throw Error(o(161))}}catch(t){Oc(e,e.return,t)}e.flags&=-3}4096&t&&(e.flags&=-4097)}function ys(e,t,n){Zl=e,bs(e,t,n)}function bs(e,t,n){for(var r=0!=(1&e.mode);null!==Zl;){var i=Zl,o=i.child;if(22===i.tag&&r){var a=null!==i.memoizedState||ql;if(!a){var l=i.alternate,s=null!==l&&null!==l.memoizedState||$l;l=ql;var c=$l;if(ql=a,($l=s)&&!c)for(Zl=i;null!==Zl;)s=(a=Zl).child,22===a.tag&&null!==a.memoizedState?js(i):null!==s?(s.return=a,Zl=s):js(i);for(;null!==o;)Zl=o,bs(o,t,n),o=o.sibling;Zl=i,ql=l,$l=c}xs(e)}else 0!=(8772&i.subtreeFlags)&&null!==o?(o.return=i,Zl=o):xs(e)}}function xs(e){for(;null!==Zl;){var t=Zl;if(0!=(8772&t.flags)){var n=t.alternate;try{if(0!=(8772&t.flags))switch(t.tag){case 0:case 11:case 15:$l||rs(5,t);break;case 1:var r=t.stateNode;if(4&t.flags&&!$l)if(null===n)r.componentDidMount();else{var i=t.elementType===t.type?n.memoizedProps:go(t.type,n.memoizedProps);r.componentDidUpdate(i,n.memoizedState,r.__reactInternalSnapshotBeforeUpdate)}var a=t.updateQueue;null!==a&&Fo(t,a,r);break;case 3:var l=t.updateQueue;if(null!==l){if(n=null,null!==t.child)switch(t.child.tag){case 5:case 1:n=t.child.stateNode}Fo(t,l,n)}break;case 5:var s=t.stateNode;if(null===n&&4&t.flags){n=s;var c=t.memoizedProps;switch(t.type){case"button":case"input":case"select":case"textarea":c.autoFocus&&n.focus();break;case"img":c.src&&(n.src=c.src)}}break;case 6:case 4:case 12:case 19:case 17:case 21:case 22:case 23:case 25:break;case 13:if(null===t.memoizedState){var u=t.alternate;if(null!==u){var d=u.memoizedState;if(null!==d){var f=d.dehydrated;null!==f&&Bt(f)}}}break;default:throw Error(o(163))}$l||512&t.flags&&is(t)}catch(e){Oc(t,t.return,e)}}if(t===e){Zl=null;break}if(null!==(n=t.sibling)){n.return=t.return,Zl=n;break}Zl=t.return}}function _s(e){for(;null!==Zl;){var t=Zl;if(t===e){Zl=null;break}var n=t.sibling;if(null!==n){n.return=t.return,Zl=n;break}Zl=t.return}}function js(e){for(;null!==Zl;){var t=Zl;try{switch(t.tag){case 0:case 11:case 15:var n=t.return;try{rs(4,t)}catch(e){Oc(t,n,e)}break;case 1:var r=t.stateNode;if("function"==typeof r.componentDidMount){var i=t.return;try{r.componentDidMount()}catch(e){Oc(t,i,e)}}var o=t.return;try{is(t)}catch(e){Oc(t,o,e)}break;case 5:var a=t.return;try{is(t)}catch(e){Oc(t,a,e)}}}catch(e){Oc(t,t.return,e)}if(t===e){Zl=null;break}var l=t.sibling;if(null!==l){l.return=t.return,Zl=l;break}Zl=t.return}}var Es,Os=Math.ceil,Ts=x.ReactCurrentDispatcher,Is=x.ReactCurrentOwner,Ss=x.ReactCurrentBatchConfig,ws=0,Ns=null,Ps=null,Cs=0,As=0,Ls=Oi(0),Ms=0,Rs=null,ks=0,Ds=0,Us=0,Fs=null,Gs=null,Vs=0,Bs=1/0,Hs=null,Ks=!1,Ws=null,zs=null,Ys=!1,Xs=null,qs=0,$s=0,Qs=null,Zs=-1,Js=0;function ec(){return 0!=(6&ws)?Qe():-1!==Zs?Zs:Zs=Qe()}function tc(e){return 0==(1&e.mode)?1:0!=(2&ws)&&0!==Cs?Cs&-Cs:null!==vo.transition?(0===Js&&(Js=pt()),Js):0!==(e=bt)?e:e=void 0===(e=window.event)?16:$t(e.type)}function nc(e,t,n,r){if(50<$s)throw $s=0,Qs=null,Error(o(185));gt(e,n,r),0!=(2&ws)&&e===Ns||(e===Ns&&(0==(2&ws)&&(Ds|=n),4===Ms&&lc(e,Cs)),rc(e,r),1===n&&0===ws&&0==(1&t.mode)&&(Bs=Qe()+500,Fi&&Bi()))}function rc(e,t){var n=e.callbackNode;!function(e,t){for(var n=e.suspendedLanes,r=e.pingedLanes,i=e.expirationTimes,o=e.pendingLanes;0<o;){var a=31-at(o),l=1<<a,s=i[a];-1===s?0!=(l&n)&&0==(l&r)||(i[a]=ht(l,t)):s<=t&&(e.expiredLanes|=l),o&=~l}}(e,t);var r=ft(e,e===Ns?Cs:0);if(0===r)null!==n&&Xe(n),e.callbackNode=null,e.callbackPriority=0;else if(t=r&-r,e.callbackPriority!==t){if(null!=n&&Xe(n),1===t)0===e.tag?function(e){Fi=!0,Vi(e)}(sc.bind(null,e)):Vi(sc.bind(null,e)),ai((function(){0==(6&ws)&&Bi()})),n=null;else{switch(xt(r)){case 1:n=Je;break;case 4:n=et;break;case 16:default:n=tt;break;case 536870912:n=rt}n=Nc(n,ic.bind(null,e))}e.callbackPriority=t,e.callbackNode=n}}function ic(e,t){if(Zs=-1,Js=0,0!=(6&ws))throw Error(o(327));var n=e.callbackNode;if(jc()&&e.callbackNode!==n)return null;var r=ft(e,e===Ns?Cs:0);if(0===r)return null;if(0!=(30&r)||0!=(r&e.expiredLanes)||t)t=vc(e,r);else{t=r;var i=ws;ws|=2;var a=mc();for(Ns===e&&Cs===t||(Hs=null,Bs=Qe()+500,fc(e,t));;)try{yc();break}catch(t){hc(e,t)}jo(),Ts.current=a,ws=i,null!==Ps?t=0:(Ns=null,Cs=0,t=Ms)}if(0!==t){if(2===t&&(0!==(i=mt(e))&&(r=i,t=oc(e,i))),1===t)throw n=Rs,fc(e,0),lc(e,r),rc(e,Qe()),n;if(6===t)lc(e,r);else{if(i=e.current.alternate,0==(30&r)&&!function(e){for(var t=e;;){if(16384&t.flags){var n=t.updateQueue;if(null!==n&&null!==(n=n.stores))for(var r=0;r<n.length;r++){var i=n[r],o=i.getSnapshot;i=i.value;try{if(!lr(o(),i))return!1}catch(e){return!1}}}if(n=t.child,16384&t.subtreeFlags&&null!==n)n.return=t,t=n;else{if(t===e)break;for(;null===t.sibling;){if(null===t.return||t.return===e)return!0;t=t.return}t.sibling.return=t.return,t=t.sibling}}return!0}(i)&&(2===(t=vc(e,r))&&(0!==(a=mt(e))&&(r=a,t=oc(e,a))),1===t))throw n=Rs,fc(e,0),lc(e,r),rc(e,Qe()),n;switch(e.finishedWork=i,e.finishedLanes=r,t){case 0:case 1:throw Error(o(345));case 2:case 5:_c(e,Gs,Hs);break;case 3:if(lc(e,r),(130023424&r)===r&&10<(t=Vs+500-Qe())){if(0!==ft(e,0))break;if(((i=e.suspendedLanes)&r)!==r){ec(),e.pingedLanes|=e.suspendedLanes&i;break}e.timeoutHandle=ri(_c.bind(null,e,Gs,Hs),t);break}_c(e,Gs,Hs);break;case 4:if(lc(e,r),(4194240&r)===r)break;for(t=e.eventTimes,i=-1;0<r;){var l=31-at(r);a=1<<l,(l=t[l])>i&&(i=l),r&=~a}if(r=i,10<(r=(120>(r=Qe()-r)?120:480>r?480:1080>r?1080:1920>r?1920:3e3>r?3e3:4320>r?4320:1960*Os(r/1960))-r)){e.timeoutHandle=ri(_c.bind(null,e,Gs,Hs),r);break}_c(e,Gs,Hs);break;default:throw Error(o(329))}}}return rc(e,Qe()),e.callbackNode===n?ic.bind(null,e):null}function oc(e,t){var n=Fs;return e.current.memoizedState.isDehydrated&&(fc(e,t).flags|=256),2!==(e=vc(e,t))&&(t=Gs,Gs=n,null!==t&&ac(t)),e}function ac(e){null===Gs?Gs=e:Gs.push.apply(Gs,e)}function lc(e,t){for(t&=~Us,t&=~Ds,e.suspendedLanes|=t,e.pingedLanes&=~t,e=e.expirationTimes;0<t;){var n=31-at(t),r=1<<n;e[n]=-1,t&=~r}}function sc(e){if(0!=(6&ws))throw Error(o(327));jc();var t=ft(e,0);if(0==(1&t))return rc(e,Qe()),null;var n=vc(e,t);if(0!==e.tag&&2===n){var r=mt(e);0!==r&&(t=r,n=oc(e,r))}if(1===n)throw n=Rs,fc(e,0),lc(e,t),rc(e,Qe()),n;if(6===n)throw Error(o(345));return e.finishedWork=e.current.alternate,e.finishedLanes=t,_c(e,Gs,Hs),rc(e,Qe()),null}function cc(e,t){var n=ws;ws|=1;try{return e(t)}finally{0===(ws=n)&&(Bs=Qe()+500,Fi&&Bi())}}function uc(e){null!==Xs&&0===Xs.tag&&0==(6&ws)&&jc();var t=ws;ws|=1;var n=Ss.transition,r=bt;try{if(Ss.transition=null,bt=1,e)return e()}finally{bt=r,Ss.transition=n,0==(6&(ws=t))&&Bi()}}function dc(){As=Ls.current,Ti(Ls)}function fc(e,t){e.finishedWork=null,e.finishedLanes=0;var n=e.timeoutHandle;if(-1!==n&&(e.timeoutHandle=-1,ii(n)),null!==Ps)for(n=Ps.return;null!==n;){var r=n;switch(to(r),r.tag){case 1:null!=(r=r.type.childContextTypes)&&Li();break;case 3:oa(),Ti(Ni),Ti(wi),da();break;case 5:la(r);break;case 4:oa();break;case 13:case 19:Ti(sa);break;case 10:Eo(r.type._context);break;case 22:case 23:dc()}n=n.return}if(Ns=e,Ps=e=Lc(e.current,null),Cs=As=t,Ms=0,Rs=null,Us=Ds=ks=0,Gs=Fs=null,null!==So){for(t=0;t<So.length;t++)if(null!==(r=(n=So[t]).interleaved)){n.interleaved=null;var i=r.next,o=n.pending;if(null!==o){var a=o.next;o.next=i,r.next=a}n.pending=r}So=null}return e}function hc(e,t){for(;;){var n=Ps;try{if(jo(),fa.current=al,ya){for(var r=pa.memoizedState;null!==r;){var i=r.queue;null!==i&&(i.pending=null),r=r.next}ya=!1}if(ma=0,ga=va=pa=null,ba=!1,xa=0,Is.current=null,null===n||null===n.return){Ms=1,Rs=t,Ps=null;break}e:{var a=e,l=n.return,s=n,c=t;if(t=Cs,s.flags|=32768,null!==c&&"object"==typeof c&&"function"==typeof c.then){var u=c,d=s,f=d.tag;if(0==(1&d.mode)&&(0===f||11===f||15===f)){var h=d.alternate;h?(d.updateQueue=h.updateQueue,d.memoizedState=h.memoizedState,d.lanes=h.lanes):(d.updateQueue=null,d.memoizedState=null)}var m=gl(l);if(null!==m){m.flags&=-257,yl(m,l,s,0,t),1&m.mode&&vl(a,u,t),c=u;var p=(t=m).updateQueue;if(null===p){var v=new Set;v.add(c),t.updateQueue=v}else p.add(c);break e}if(0==(1&t)){vl(a,u,t),pc();break e}c=Error(o(426))}else if(io&&1&s.mode){var g=gl(l);if(null!==g){0==(65536&g.flags)&&(g.flags|=256),yl(g,l,s,0,t),po(ul(c,s));break e}}a=c=ul(c,s),4!==Ms&&(Ms=2),null===Fs?Fs=[a]:Fs.push(a),a=l;do{switch(a.tag){case 3:a.flags|=65536,t&=-t,a.lanes|=t,Do(a,ml(0,c,t));break e;case 1:s=c;var y=a.type,b=a.stateNode;if(0==(128&a.flags)&&("function"==typeof y.getDerivedStateFromError||null!==b&&"function"==typeof b.componentDidCatch&&(null===zs||!zs.has(b)))){a.flags|=65536,t&=-t,a.lanes|=t,Do(a,pl(a,s,t));break e}}a=a.return}while(null!==a)}xc(n)}catch(e){t=e,Ps===n&&null!==n&&(Ps=n=n.return);continue}break}}function mc(){var e=Ts.current;return Ts.current=al,null===e?al:e}function pc(){0!==Ms&&3!==Ms&&2!==Ms||(Ms=4),null===Ns||0==(268435455&ks)&&0==(268435455&Ds)||lc(Ns,Cs)}function vc(e,t){var n=ws;ws|=2;var r=mc();for(Ns===e&&Cs===t||(Hs=null,fc(e,t));;)try{gc();break}catch(t){hc(e,t)}if(jo(),ws=n,Ts.current=r,null!==Ps)throw Error(o(261));return Ns=null,Cs=0,Ms}function gc(){for(;null!==Ps;)bc(Ps)}function yc(){for(;null!==Ps&&!qe();)bc(Ps)}function bc(e){var t=Es(e.alternate,e,As);e.memoizedProps=e.pendingProps,null===t?xc(e):Ps=t,Is.current=null}function xc(e){var t=e;do{var n=t.alternate;if(e=t.return,0==(32768&t.flags)){if(null!==(n=Yl(n,t,As)))return void(Ps=n)}else{if(null!==(n=Xl(n,t)))return n.flags&=32767,void(Ps=n);if(null===e)return Ms=6,void(Ps=null);e.flags|=32768,e.subtreeFlags=0,e.deletions=null}if(null!==(t=t.sibling))return void(Ps=t);Ps=t=e}while(null!==t);0===Ms&&(Ms=5)}function _c(e,t,n){var r=bt,i=Ss.transition;try{Ss.transition=null,bt=1,function(e,t,n,r){do{jc()}while(null!==Xs);if(0!=(6&ws))throw Error(o(327));n=e.finishedWork;var i=e.finishedLanes;if(null===n)return null;if(e.finishedWork=null,e.finishedLanes=0,n===e.current)throw Error(o(177));e.callbackNode=null,e.callbackPriority=0;var a=n.lanes|n.childLanes;if(function(e,t){var n=e.pendingLanes&~t;e.pendingLanes=t,e.suspendedLanes=0,e.pingedLanes=0,e.expiredLanes&=t,e.mutableReadLanes&=t,e.entangledLanes&=t,t=e.entanglements;var r=e.eventTimes;for(e=e.expirationTimes;0<n;){var i=31-at(n),o=1<<i;t[i]=0,r[i]=-1,e[i]=-1,n&=~o}}(e,a),e===Ns&&(Ps=Ns=null,Cs=0),0==(2064&n.subtreeFlags)&&0==(2064&n.flags)||Ys||(Ys=!0,Nc(tt,(function(){return jc(),null}))),a=0!=(15990&n.flags),0!=(15990&n.subtreeFlags)||a){a=Ss.transition,Ss.transition=null;var l=bt;bt=1;var s=ws;ws|=4,Is.current=null,function(e,t){if(ei=Kt,hr(e=fr())){if("selectionStart"in e)var n={start:e.selectionStart,end:e.selectionEnd};else e:{var r=(n=(n=e.ownerDocument)&&n.defaultView||window).getSelection&&n.getSelection();if(r&&0!==r.rangeCount){n=r.anchorNode;var i=r.anchorOffset,a=r.focusNode;r=r.focusOffset;try{n.nodeType,a.nodeType}catch(e){n=null;break e}var l=0,s=-1,c=-1,u=0,d=0,f=e,h=null;t:for(;;){for(var m;f!==n||0!==i&&3!==f.nodeType||(s=l+i),f!==a||0!==r&&3!==f.nodeType||(c=l+r),3===f.nodeType&&(l+=f.nodeValue.length),null!==(m=f.firstChild);)h=f,f=m;for(;;){if(f===e)break t;if(h===n&&++u===i&&(s=l),h===a&&++d===r&&(c=l),null!==(m=f.nextSibling))break;h=(f=h).parentNode}f=m}n=-1===s||-1===c?null:{start:s,end:c}}else n=null}n=n||{start:0,end:0}}else n=null;for(ti={focusedElem:e,selectionRange:n},Kt=!1,Zl=t;null!==Zl;)if(e=(t=Zl).child,0!=(1028&t.subtreeFlags)&&null!==e)e.return=t,Zl=e;else for(;null!==Zl;){t=Zl;try{var p=t.alternate;if(0!=(1024&t.flags))switch(t.tag){case 0:case 11:case 15:case 5:case 6:case 4:case 17:break;case 1:if(null!==p){var v=p.memoizedProps,g=p.memoizedState,y=t.stateNode,b=y.getSnapshotBeforeUpdate(t.elementType===t.type?v:go(t.type,v),g);y.__reactInternalSnapshotBeforeUpdate=b}break;case 3:var x=t.stateNode.containerInfo;1===x.nodeType?x.textContent="":9===x.nodeType&&x.documentElement&&x.removeChild(x.documentElement);break;default:throw Error(o(163))}}catch(e){Oc(t,t.return,e)}if(null!==(e=t.sibling)){e.return=t.return,Zl=e;break}Zl=t.return}p=ts,ts=!1}(e,n),vs(n,e),mr(ti),Kt=!!ei,ti=ei=null,e.current=n,ys(n,e,i),$e(),ws=s,bt=l,Ss.transition=a}else e.current=n;if(Ys&&(Ys=!1,Xs=e,qs=i),0===(a=e.pendingLanes)&&(zs=null),function(e){if(ot&&"function"==typeof ot.onCommitFiberRoot)try{ot.onCommitFiberRoot(it,e,void 0,128==(128&e.current.flags))}catch(e){}}(n.stateNode),rc(e,Qe()),null!==t)for(r=e.onRecoverableError,n=0;n<t.length;n++)i=t[n],r(i.value,{componentStack:i.stack,digest:i.digest});if(Ks)throw Ks=!1,e=Ws,Ws=null,e;0!=(1&qs)&&0!==e.tag&&jc(),0!=(1&(a=e.pendingLanes))?e===Qs?$s++:($s=0,Qs=e):$s=0,Bi()}(e,t,n,r)}finally{Ss.transition=i,bt=r}return null}function jc(){if(null!==Xs){var e=xt(qs),t=Ss.transition,n=bt;try{if(Ss.transition=null,bt=16>e?16:e,null===Xs)var r=!1;else{if(e=Xs,Xs=null,qs=0,0!=(6&ws))throw Error(o(331));var i=ws;for(ws|=4,Zl=e.current;null!==Zl;){var a=Zl,l=a.child;if(0!=(16&Zl.flags)){var s=a.deletions;if(null!==s){for(var c=0;c<s.length;c++){var u=s[c];for(Zl=u;null!==Zl;){var d=Zl;switch(d.tag){case 0:case 11:case 15:ns(8,d,a)}var f=d.child;if(null!==f)f.return=d,Zl=f;else for(;null!==Zl;){var h=(d=Zl).sibling,m=d.return;if(os(d),d===u){Zl=null;break}if(null!==h){h.return=m,Zl=h;break}Zl=m}}}var p=a.alternate;if(null!==p){var v=p.child;if(null!==v){p.child=null;do{var g=v.sibling;v.sibling=null,v=g}while(null!==v)}}Zl=a}}if(0!=(2064&a.subtreeFlags)&&null!==l)l.return=a,Zl=l;else e:for(;null!==Zl;){if(0!=(2048&(a=Zl).flags))switch(a.tag){case 0:case 11:case 15:ns(9,a,a.return)}var y=a.sibling;if(null!==y){y.return=a.return,Zl=y;break e}Zl=a.return}}var b=e.current;for(Zl=b;null!==Zl;){var x=(l=Zl).child;if(0!=(2064&l.subtreeFlags)&&null!==x)x.return=l,Zl=x;else e:for(l=b;null!==Zl;){if(0!=(2048&(s=Zl).flags))try{switch(s.tag){case 0:case 11:case 15:rs(9,s)}}catch(e){Oc(s,s.return,e)}if(s===l){Zl=null;break e}var _=s.sibling;if(null!==_){_.return=s.return,Zl=_;break e}Zl=s.return}}if(ws=i,Bi(),ot&&"function"==typeof ot.onPostCommitFiberRoot)try{ot.onPostCommitFiberRoot(it,e)}catch(e){}r=!0}return r}finally{bt=n,Ss.transition=t}}return!1}function Ec(e,t,n){e=Ro(e,t=ml(0,t=ul(n,t),1),1),t=ec(),null!==e&&(gt(e,1,t),rc(e,t))}function Oc(e,t,n){if(3===e.tag)Ec(e,e,n);else for(;null!==t;){if(3===t.tag){Ec(t,e,n);break}if(1===t.tag){var r=t.stateNode;if("function"==typeof t.type.getDerivedStateFromError||"function"==typeof r.componentDidCatch&&(null===zs||!zs.has(r))){t=Ro(t,e=pl(t,e=ul(n,e),1),1),e=ec(),null!==t&&(gt(t,1,e),rc(t,e));break}}t=t.return}}function Tc(e,t,n){var r=e.pingCache;null!==r&&r.delete(t),t=ec(),e.pingedLanes|=e.suspendedLanes&n,Ns===e&&(Cs&n)===n&&(4===Ms||3===Ms&&(130023424&Cs)===Cs&&500>Qe()-Vs?fc(e,0):Us|=n),rc(e,t)}function Ic(e,t){0===t&&(0==(1&e.mode)?t=1:(t=ut,0==(130023424&(ut<<=1))&&(ut=4194304)));var n=ec();null!==(e=Po(e,t))&&(gt(e,t,n),rc(e,n))}function Sc(e){var t=e.memoizedState,n=0;null!==t&&(n=t.retryLane),Ic(e,n)}function wc(e,t){var n=0;switch(e.tag){case 13:var r=e.stateNode,i=e.memoizedState;null!==i&&(n=i.retryLane);break;case 19:r=e.stateNode;break;default:throw Error(o(314))}null!==r&&r.delete(t),Ic(e,n)}function Nc(e,t){return Ye(e,t)}function Pc(e,t,n,r){this.tag=e,this.key=n,this.sibling=this.child=this.return=this.stateNode=this.type=this.elementType=null,this.index=0,this.ref=null,this.pendingProps=t,this.dependencies=this.memoizedState=this.updateQueue=this.memoizedProps=null,this.mode=r,this.subtreeFlags=this.flags=0,this.deletions=null,this.childLanes=this.lanes=0,this.alternate=null}function Cc(e,t,n,r){return new Pc(e,t,n,r)}function Ac(e){return!(!(e=e.prototype)||!e.isReactComponent)}function Lc(e,t){var n=e.alternate;return null===n?((n=Cc(e.tag,t,e.key,e.mode)).elementType=e.elementType,n.type=e.type,n.stateNode=e.stateNode,n.alternate=e,e.alternate=n):(n.pendingProps=t,n.type=e.type,n.flags=0,n.subtreeFlags=0,n.deletions=null),n.flags=14680064&e.flags,n.childLanes=e.childLanes,n.lanes=e.lanes,n.child=e.child,n.memoizedProps=e.memoizedProps,n.memoizedState=e.memoizedState,n.updateQueue=e.updateQueue,t=e.dependencies,n.dependencies=null===t?null:{lanes:t.lanes,firstContext:t.firstContext},n.sibling=e.sibling,n.index=e.index,n.ref=e.ref,n}function Mc(e,t,n,r,i,a){var l=2;if(r=e,"function"==typeof e)Ac(e)&&(l=1);else if("string"==typeof e)l=5;else e:switch(e){case E:return Rc(n.children,i,a,t);case O:l=8,i|=8;break;case T:return(e=Cc(12,n,t,2|i)).elementType=T,e.lanes=a,e;case N:return(e=Cc(13,n,t,i)).elementType=N,e.lanes=a,e;case P:return(e=Cc(19,n,t,i)).elementType=P,e.lanes=a,e;case L:return kc(n,i,a,t);default:if("object"==typeof e&&null!==e)switch(e.$$typeof){case I:l=10;break e;case S:l=9;break e;case w:l=11;break e;case C:l=14;break e;case A:l=16,r=null;break e}throw Error(o(130,null==e?e:typeof e,""))}return(t=Cc(l,n,t,i)).elementType=e,t.type=r,t.lanes=a,t}function Rc(e,t,n,r){return(e=Cc(7,e,r,t)).lanes=n,e}function kc(e,t,n,r){return(e=Cc(22,e,r,t)).elementType=L,e.lanes=n,e.stateNode={isHidden:!1},e}function Dc(e,t,n){return(e=Cc(6,e,null,t)).lanes=n,e}function Uc(e,t,n){return(t=Cc(4,null!==e.children?e.children:[],e.key,t)).lanes=n,t.stateNode={containerInfo:e.containerInfo,pendingChildren:null,implementation:e.implementation},t}function Fc(e,t,n,r,i){this.tag=t,this.containerInfo=e,this.finishedWork=this.pingCache=this.current=this.pendingChildren=null,this.timeoutHandle=-1,this.callbackNode=this.pendingContext=this.context=null,this.callbackPriority=0,this.eventTimes=vt(0),this.expirationTimes=vt(-1),this.entangledLanes=this.finishedLanes=this.mutableReadLanes=this.expiredLanes=this.pingedLanes=this.suspendedLanes=this.pendingLanes=0,this.entanglements=vt(0),this.identifierPrefix=r,this.onRecoverableError=i,this.mutableSourceEagerHydrationData=null}function Gc(e,t,n,r,i,o,a,l,s){return e=new Fc(e,t,n,l,s),1===t?(t=1,!0===o&&(t|=8)):t=0,o=Cc(3,null,null,t),e.current=o,o.stateNode=e,o.memoizedState={element:r,isDehydrated:n,cache:null,transitions:null,pendingSuspenseBoundaries:null},Ao(o),e}function Vc(e,t,n){var r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null;return{$$typeof:j,key:null==r?null:""+r,children:e,containerInfo:t,implementation:n}}function Bc(e){if(!e)return Si;e:{if(Be(e=e._reactInternals)!==e||1!==e.tag)throw Error(o(170));var t=e;do{switch(t.tag){case 3:t=t.stateNode.context;break e;case 1:if(Ai(t.type)){t=t.stateNode.__reactInternalMemoizedMergedChildContext;break e}}t=t.return}while(null!==t);throw Error(o(171))}if(1===e.tag){var n=e.type;if(Ai(n))return Ri(e,n,t)}return t}function Hc(e,t,n,r,i,o,a,l,s){return(e=Gc(n,r,!0,e,0,o,0,l,s)).context=Bc(null),n=e.current,(o=Mo(r=ec(),i=tc(n))).callback=null!=t?t:null,Ro(n,o,i),e.current.lanes=i,gt(e,i,r),rc(e,r),e}function Kc(e,t,n,r){var i=t.current,o=ec(),a=tc(i);return n=Bc(n),null===t.context?t.context=n:t.pendingContext=n,(t=Mo(o,a)).payload={element:e},null!==(r=void 0===r?null:r)&&(t.callback=r),null!==(e=Ro(i,t,a))&&(nc(e,i,a,o),ko(e,i,a)),a}function Wc(e){return(e=e.current).child?(e.child.tag,e.child.stateNode):null}function zc(e,t){if(null!==(e=e.memoizedState)&&null!==e.dehydrated){var n=e.retryLane;e.retryLane=0!==n&&n<t?n:t}}function Yc(e,t){zc(e,t),(e=e.alternate)&&zc(e,t)}Es=function(e,t,n){if(null!==e)if(e.memoizedProps!==t.pendingProps||Ni.current)xl=!0;else{if(0==(e.lanes&n)&&0==(128&t.flags))return xl=!1,function(e,t,n){switch(t.tag){case 3:Pl(t),mo();break;case 5:aa(t);break;case 1:Ai(t.type)&&ki(t);break;case 4:ia(t,t.stateNode.containerInfo);break;case 10:var r=t.type._context,i=t.memoizedProps.value;Ii(yo,r._currentValue),r._currentValue=i;break;case 13:if(null!==(r=t.memoizedState))return null!==r.dehydrated?(Ii(sa,1&sa.current),t.flags|=128,null):0!=(n&t.child.childLanes)?Dl(e,t,n):(Ii(sa,1&sa.current),null!==(e=Kl(e,t,n))?e.sibling:null);Ii(sa,1&sa.current);break;case 19:if(r=0!=(n&t.childLanes),0!=(128&e.flags)){if(r)return Bl(e,t,n);t.flags|=128}if(null!==(i=t.memoizedState)&&(i.rendering=null,i.tail=null,i.lastEffect=null),Ii(sa,sa.current),r)break;return null;case 22:case 23:return t.lanes=0,Tl(e,t,n)}return Kl(e,t,n)}(e,t,n);xl=0!=(131072&e.flags)}else xl=!1,io&&0!=(1048576&t.flags)&&Ji(t,zi,t.index);switch(t.lanes=0,t.tag){case 2:var r=t.type;Hl(e,t),e=t.pendingProps;var i=Ci(t,wi.current);To(t,n),i=Oa(null,t,r,e,i,n);var a=Ta();return t.flags|=1,"object"==typeof i&&null!==i&&"function"==typeof i.render&&void 0===i.$$typeof?(t.tag=1,t.memoizedState=null,t.updateQueue=null,Ai(r)?(a=!0,ki(t)):a=!1,t.memoizedState=null!==i.state&&void 0!==i.state?i.state:null,Ao(t),i.updater=Bo,t.stateNode=i,i._reactInternals=t,zo(t,r,e,n),t=Nl(null,t,r,!0,a,n)):(t.tag=0,io&&a&&eo(t),_l(null,t,i,n),t=t.child),t;case 16:r=t.elementType;e:{switch(Hl(e,t),e=t.pendingProps,r=(i=r._init)(r._payload),t.type=r,i=t.tag=function(e){if("function"==typeof e)return Ac(e)?1:0;if(null!=e){if((e=e.$$typeof)===w)return 11;if(e===C)return 14}return 2}(r),e=go(r,e),i){case 0:t=Sl(null,t,r,e,n);break e;case 1:t=wl(null,t,r,e,n);break e;case 11:t=jl(null,t,r,e,n);break e;case 14:t=El(null,t,r,go(r.type,e),n);break e}throw Error(o(306,r,""))}return t;case 0:return r=t.type,i=t.pendingProps,Sl(e,t,r,i=t.elementType===r?i:go(r,i),n);case 1:return r=t.type,i=t.pendingProps,wl(e,t,r,i=t.elementType===r?i:go(r,i),n);case 3:e:{if(Pl(t),null===e)throw Error(o(387));r=t.pendingProps,i=(a=t.memoizedState).element,Lo(e,t),Uo(t,r,null,n);var l=t.memoizedState;if(r=l.element,a.isDehydrated){if(a={element:r,isDehydrated:!1,cache:l.cache,pendingSuspenseBoundaries:l.pendingSuspenseBoundaries,transitions:l.transitions},t.updateQueue.baseState=a,t.memoizedState=a,256&t.flags){t=Cl(e,t,r,n,i=ul(Error(o(423)),t));break e}if(r!==i){t=Cl(e,t,r,n,i=ul(Error(o(424)),t));break e}for(ro=ci(t.stateNode.containerInfo.firstChild),no=t,io=!0,oo=null,n=Zo(t,null,r,n),t.child=n;n;)n.flags=-3&n.flags|4096,n=n.sibling}else{if(mo(),r===i){t=Kl(e,t,n);break e}_l(e,t,r,n)}t=t.child}return t;case 5:return aa(t),null===e&&co(t),r=t.type,i=t.pendingProps,a=null!==e?e.memoizedProps:null,l=i.children,ni(r,i)?l=null:null!==a&&ni(r,a)&&(t.flags|=32),Il(e,t),_l(e,t,l,n),t.child;case 6:return null===e&&co(t),null;case 13:return Dl(e,t,n);case 4:return ia(t,t.stateNode.containerInfo),r=t.pendingProps,null===e?t.child=Qo(t,null,r,n):_l(e,t,r,n),t.child;case 11:return r=t.type,i=t.pendingProps,jl(e,t,r,i=t.elementType===r?i:go(r,i),n);case 7:return _l(e,t,t.pendingProps,n),t.child;case 8:case 12:return _l(e,t,t.pendingProps.children,n),t.child;case 10:e:{if(r=t.type._context,i=t.pendingProps,a=t.memoizedProps,l=i.value,Ii(yo,r._currentValue),r._currentValue=l,null!==a)if(lr(a.value,l)){if(a.children===i.children&&!Ni.current){t=Kl(e,t,n);break e}}else for(null!==(a=t.child)&&(a.return=t);null!==a;){var s=a.dependencies;if(null!==s){l=a.child;for(var c=s.firstContext;null!==c;){if(c.context===r){if(1===a.tag){(c=Mo(-1,n&-n)).tag=2;var u=a.updateQueue;if(null!==u){var d=(u=u.shared).pending;null===d?c.next=c:(c.next=d.next,d.next=c),u.pending=c}}a.lanes|=n,null!==(c=a.alternate)&&(c.lanes|=n),Oo(a.return,n,t),s.lanes|=n;break}c=c.next}}else if(10===a.tag)l=a.type===t.type?null:a.child;else if(18===a.tag){if(null===(l=a.return))throw Error(o(341));l.lanes|=n,null!==(s=l.alternate)&&(s.lanes|=n),Oo(l,n,t),l=a.sibling}else l=a.child;if(null!==l)l.return=a;else for(l=a;null!==l;){if(l===t){l=null;break}if(null!==(a=l.sibling)){a.return=l.return,l=a;break}l=l.return}a=l}_l(e,t,i.children,n),t=t.child}return t;case 9:return i=t.type,r=t.pendingProps.children,To(t,n),r=r(i=Io(i)),t.flags|=1,_l(e,t,r,n),t.child;case 14:return i=go(r=t.type,t.pendingProps),El(e,t,r,i=go(r.type,i),n);case 15:return Ol(e,t,t.type,t.pendingProps,n);case 17:return r=t.type,i=t.pendingProps,i=t.elementType===r?i:go(r,i),Hl(e,t),t.tag=1,Ai(r)?(e=!0,ki(t)):e=!1,To(t,n),Ko(t,r,i),zo(t,r,i,n),Nl(null,t,r,!0,e,n);case 19:return Bl(e,t,n);case 22:return Tl(e,t,n)}throw Error(o(156,t.tag))};var Xc="function"==typeof reportError?reportError:function(e){console.error(e)};function qc(e){this._internalRoot=e}function $c(e){this._internalRoot=e}function Qc(e){return!(!e||1!==e.nodeType&&9!==e.nodeType&&11!==e.nodeType)}function Zc(e){return!(!e||1!==e.nodeType&&9!==e.nodeType&&11!==e.nodeType&&(8!==e.nodeType||" react-mount-point-unstable "!==e.nodeValue))}function Jc(){}function eu(e,t,n,r,i){var o=n._reactRootContainer;if(o){var a=o;if("function"==typeof i){var l=i;i=function(){var e=Wc(a);l.call(e)}}Kc(t,a,e,i)}else a=function(e,t,n,r,i){if(i){if("function"==typeof r){var o=r;r=function(){var e=Wc(a);o.call(e)}}var a=Hc(t,r,e,0,null,!1,0,"",Jc);return e._reactRootContainer=a,e[mi]=a.current,Br(8===e.nodeType?e.parentNode:e),uc(),a}for(;i=e.lastChild;)e.removeChild(i);if("function"==typeof r){var l=r;r=function(){var e=Wc(s);l.call(e)}}var s=Gc(e,0,!1,null,0,!1,0,"",Jc);return e._reactRootContainer=s,e[mi]=s.current,Br(8===e.nodeType?e.parentNode:e),uc((function(){Kc(t,s,n,r)})),s}(n,t,e,i,r);return Wc(a)}$c.prototype.render=qc.prototype.render=function(e){var t=this._internalRoot;if(null===t)throw Error(o(409));Kc(e,t,null,null)},$c.prototype.unmount=qc.prototype.unmount=function(){var e=this._internalRoot;if(null!==e){this._internalRoot=null;var t=e.containerInfo;uc((function(){Kc(null,e,null,null)})),t[mi]=null}},$c.prototype.unstable_scheduleHydration=function(e){if(e){var t=Ot();e={blockedOn:null,target:e,priority:t};for(var n=0;n<Lt.length&&0!==t&&t<Lt[n].priority;n++);Lt.splice(n,0,e),0===n&&Dt(e)}},_t=function(e){switch(e.tag){case 3:var t=e.stateNode;if(t.current.memoizedState.isDehydrated){var n=dt(t.pendingLanes);0!==n&&(yt(t,1|n),rc(t,Qe()),0==(6&ws)&&(Bs=Qe()+500,Bi()))}break;case 13:uc((function(){var t=Po(e,1);if(null!==t){var n=ec();nc(t,e,1,n)}})),Yc(e,1)}},jt=function(e){if(13===e.tag){var t=Po(e,134217728);if(null!==t)nc(t,e,134217728,ec());Yc(e,134217728)}},Et=function(e){if(13===e.tag){var t=tc(e),n=Po(e,t);if(null!==n)nc(n,e,t,ec());Yc(e,t)}},Ot=function(){return bt},Tt=function(e,t){var n=bt;try{return bt=e,t()}finally{bt=n}},je=function(e,t,n){switch(t){case"input":if(Z(e,n),t=n.name,"radio"===n.type&&null!=t){for(n=e;n.parentNode;)n=n.parentNode;for(n=n.querySelectorAll("input[name="+JSON.stringify(""+t)+'][type="radio"]'),t=0;t<n.length;t++){var r=n[t];if(r!==e&&r.form===e.form){var i=_i(r);if(!i)throw Error(o(90));Y(r),Z(r,i)}}}break;case"textarea":oe(e,n);break;case"select":null!=(t=n.value)&&ne(e,!!n.multiple,t,!1)}},we=cc,Ne=uc;var tu={usingClientEntryPoint:!1,Events:[bi,xi,_i,Ie,Se,cc]},nu={findFiberByHostInstance:yi,bundleType:0,version:"18.2.0",rendererPackageName:"react-dom"},ru={bundleType:nu.bundleType,version:nu.version,rendererPackageName:nu.rendererPackageName,rendererConfig:nu.rendererConfig,overrideHookState:null,overrideHookStateDeletePath:null,overrideHookStateRenamePath:null,overrideProps:null,overridePropsDeletePath:null,overridePropsRenamePath:null,setErrorHandler:null,setSuspenseHandler:null,scheduleUpdate:null,currentDispatcherRef:x.ReactCurrentDispatcher,findHostInstanceByFiber:function(e){return null===(e=We(e))?null:e.stateNode},findFiberByHostInstance:nu.findFiberByHostInstance||function(){return null},findHostInstancesForRefresh:null,scheduleRefresh:null,scheduleRoot:null,setRefreshHandler:null,getCurrentFiber:null,reconcilerVersion:"18.2.0-next-9e3b772b8-20220608"};if("undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__){var iu=__REACT_DEVTOOLS_GLOBAL_HOOK__;if(!iu.isDisabled&&iu.supportsFiber)try{it=iu.inject(ru),ot=iu}catch(ue){}}t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=tu,t.createPortal=function(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!Qc(t))throw Error(o(200));return Vc(e,t,null,n)},t.createRoot=function(e,t){if(!Qc(e))throw Error(o(299));var n=!1,r="",i=Xc;return null!=t&&(!0===t.unstable_strictMode&&(n=!0),void 0!==t.identifierPrefix&&(r=t.identifierPrefix),void 0!==t.onRecoverableError&&(i=t.onRecoverableError)),t=Gc(e,1,!1,null,0,n,0,r,i),e[mi]=t.current,Br(8===e.nodeType?e.parentNode:e),new qc(t)},t.findDOMNode=function(e){if(null==e)return null;if(1===e.nodeType)return e;var t=e._reactInternals;if(void 0===t){if("function"==typeof e.render)throw Error(o(188));throw e=Object.keys(e).join(","),Error(o(268,e))}return e=null===(e=We(t))?null:e.stateNode},t.flushSync=function(e){return uc(e)},t.hydrate=function(e,t,n){if(!Zc(t))throw Error(o(200));return eu(null,e,t,!0,n)},t.hydrateRoot=function(e,t,n){if(!Qc(e))throw Error(o(405));var r=null!=n&&n.hydratedSources||null,i=!1,a="",l=Xc;if(null!=n&&(!0===n.unstable_strictMode&&(i=!0),void 0!==n.identifierPrefix&&(a=n.identifierPrefix),void 0!==n.onRecoverableError&&(l=n.onRecoverableError)),t=Hc(t,null,e,1,null!=n?n:null,i,0,a,l),e[mi]=t.current,Br(e),r)for(e=0;e<r.length;e++)i=(i=(n=r[e])._getVersion)(n._source),null==t.mutableSourceEagerHydrationData?t.mutableSourceEagerHydrationData=[n,i]:t.mutableSourceEagerHydrationData.push(n,i);return new $c(t)},t.render=function(e,t,n){if(!Zc(t))throw Error(o(200));return eu(null,e,t,!1,n)},t.unmountComponentAtNode=function(e){if(!Zc(e))throw Error(o(40));return!!e._reactRootContainer&&(uc((function(){eu(null,null,e,!1,(function(){e._reactRootContainer=null,e[mi]=null}))})),!0)},t.unstable_batchedUpdates=cc,t.unstable_renderSubtreeIntoContainer=function(e,t,n,r){if(!Zc(n))throw Error(o(200));if(null==e||void 0===e._reactInternals)throw Error(o(38));return eu(e,t,n,!1,r)},t.version="18.2.0-next-9e3b772b8-20220608"},745:(e,t,n)=>{"use strict";var r=n(935);t.s=r.createRoot,r.hydrateRoot},935:(e,t,n)=>{"use strict";!function e(){if("undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__&&"function"==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE)try{__REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(e)}catch(e){console.error(e)}}(),e.exports=n(448)},251:(e,t,n)=>{"use strict";var r=n(294),i=Symbol.for("react.element"),o=Symbol.for("react.fragment"),a=Object.prototype.hasOwnProperty,l=r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,s={key:!0,ref:!0,__self:!0,__source:!0};function c(e,t,n){var r,o={},c=null,u=null;for(r in void 0!==n&&(c=""+n),void 0!==t.key&&(c=""+t.key),void 0!==t.ref&&(u=t.ref),t)a.call(t,r)&&!s.hasOwnProperty(r)&&(o[r]=t[r]);if(e&&e.defaultProps)for(r in t=e.defaultProps)void 0===o[r]&&(o[r]=t[r]);return{$$typeof:i,type:e,key:c,ref:u,props:o,_owner:l.current}}t.Fragment=o,t.jsx=c,t.jsxs=c},408:(e,t)=>{"use strict";var n=Symbol.for("react.element"),r=Symbol.for("react.portal"),i=Symbol.for("react.fragment"),o=Symbol.for("react.strict_mode"),a=Symbol.for("react.profiler"),l=Symbol.for("react.provider"),s=Symbol.for("react.context"),c=Symbol.for("react.forward_ref"),u=Symbol.for("react.suspense"),d=Symbol.for("react.memo"),f=Symbol.for("react.lazy"),h=Symbol.iterator;var m={isMounted:function(){return!1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},p=Object.assign,v={};function g(e,t,n){this.props=e,this.context=t,this.refs=v,this.updater=n||m}function y(){}function b(e,t,n){this.props=e,this.context=t,this.refs=v,this.updater=n||m}g.prototype.isReactComponent={},g.prototype.setState=function(e,t){if("object"!=typeof e&&"function"!=typeof e&&null!=e)throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");this.updater.enqueueSetState(this,e,t,"setState")},g.prototype.forceUpdate=function(e){this.updater.enqueueForceUpdate(this,e,"forceUpdate")},y.prototype=g.prototype;var x=b.prototype=new y;x.constructor=b,p(x,g.prototype),x.isPureReactComponent=!0;var _=Array.isArray,j=Object.prototype.hasOwnProperty,E={current:null},O={key:!0,ref:!0,__self:!0,__source:!0};function T(e,t,r){var i,o={},a=null,l=null;if(null!=t)for(i in void 0!==t.ref&&(l=t.ref),void 0!==t.key&&(a=""+t.key),t)j.call(t,i)&&!O.hasOwnProperty(i)&&(o[i]=t[i]);var s=arguments.length-2;if(1===s)o.children=r;else if(1<s){for(var c=Array(s),u=0;u<s;u++)c[u]=arguments[u+2];o.children=c}if(e&&e.defaultProps)for(i in s=e.defaultProps)void 0===o[i]&&(o[i]=s[i]);return{$$typeof:n,type:e,key:a,ref:l,props:o,_owner:E.current}}function I(e){return"object"==typeof e&&null!==e&&e.$$typeof===n}var S=/\/+/g;function w(e,t){return"object"==typeof e&&null!==e&&null!=e.key?function(e){var t={"=":"=0",":":"=2"};return"$"+e.replace(/[=:]/g,(function(e){return t[e]}))}(""+e.key):t.toString(36)}function N(e,t,i,o,a){var l=typeof e;"undefined"!==l&&"boolean"!==l||(e=null);var s=!1;if(null===e)s=!0;else switch(l){case"string":case"number":s=!0;break;case"object":switch(e.$$typeof){case n:case r:s=!0}}if(s)return a=a(s=e),e=""===o?"."+w(s,0):o,_(a)?(i="",null!=e&&(i=e.replace(S,"$&/")+"/"),N(a,t,i,"",(function(e){return e}))):null!=a&&(I(a)&&(a=function(e,t){return{$$typeof:n,type:e.type,key:t,ref:e.ref,props:e.props,_owner:e._owner}}(a,i+(!a.key||s&&s.key===a.key?"":(""+a.key).replace(S,"$&/")+"/")+e)),t.push(a)),1;if(s=0,o=""===o?".":o+":",_(e))for(var c=0;c<e.length;c++){var u=o+w(l=e[c],c);s+=N(l,t,i,u,a)}else if(u=function(e){return null===e||"object"!=typeof e?null:"function"==typeof(e=h&&e[h]||e["@@iterator"])?e:null}(e),"function"==typeof u)for(e=u.call(e),c=0;!(l=e.next()).done;)s+=N(l=l.value,t,i,u=o+w(l,c++),a);else if("object"===l)throw t=String(e),Error("Objects are not valid as a React child (found: "+("[object Object]"===t?"object with keys {"+Object.keys(e).join(", ")+"}":t)+"). If you meant to render a collection of children, use an array instead.");return s}function P(e,t,n){if(null==e)return e;var r=[],i=0;return N(e,r,"","",(function(e){return t.call(n,e,i++)})),r}function C(e){if(-1===e._status){var t=e._result;(t=t()).then((function(t){0!==e._status&&-1!==e._status||(e._status=1,e._result=t)}),(function(t){0!==e._status&&-1!==e._status||(e._status=2,e._result=t)})),-1===e._status&&(e._status=0,e._result=t)}if(1===e._status)return e._result.default;throw e._result}var A={current:null},L={transition:null},M={ReactCurrentDispatcher:A,ReactCurrentBatchConfig:L,ReactCurrentOwner:E};t.Children={map:P,forEach:function(e,t,n){P(e,(function(){t.apply(this,arguments)}),n)},count:function(e){var t=0;return P(e,(function(){t++})),t},toArray:function(e){return P(e,(function(e){return e}))||[]},only:function(e){if(!I(e))throw Error("React.Children.only expected to receive a single React element child.");return e}},t.Component=g,t.Fragment=i,t.Profiler=a,t.PureComponent=b,t.StrictMode=o,t.Suspense=u,t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=M,t.cloneElement=function(e,t,r){if(null==e)throw Error("React.cloneElement(...): The argument must be a React element, but you passed "+e+".");var i=p({},e.props),o=e.key,a=e.ref,l=e._owner;if(null!=t){if(void 0!==t.ref&&(a=t.ref,l=E.current),void 0!==t.key&&(o=""+t.key),e.type&&e.type.defaultProps)var s=e.type.defaultProps;for(c in t)j.call(t,c)&&!O.hasOwnProperty(c)&&(i[c]=void 0===t[c]&&void 0!==s?s[c]:t[c])}var c=arguments.length-2;if(1===c)i.children=r;else if(1<c){s=Array(c);for(var u=0;u<c;u++)s[u]=arguments[u+2];i.children=s}return{$$typeof:n,type:e.type,key:o,ref:a,props:i,_owner:l}},t.createContext=function(e){return(e={$$typeof:s,_currentValue:e,_currentValue2:e,_threadCount:0,Provider:null,Consumer:null,_defaultValue:null,_globalName:null}).Provider={$$typeof:l,_context:e},e.Consumer=e},t.createElement=T,t.createFactory=function(e){var t=T.bind(null,e);return t.type=e,t},t.createRef=function(){return{current:null}},t.forwardRef=function(e){return{$$typeof:c,render:e}},t.isValidElement=I,t.lazy=function(e){return{$$typeof:f,_payload:{_status:-1,_result:e},_init:C}},t.memo=function(e,t){return{$$typeof:d,type:e,compare:void 0===t?null:t}},t.startTransition=function(e){var t=L.transition;L.transition={};try{e()}finally{L.transition=t}},t.unstable_act=function(){throw Error("act(...) is not supported in production builds of React.")},t.useCallback=function(e,t){return A.current.useCallback(e,t)},t.useContext=function(e){return A.current.useContext(e)},t.useDebugValue=function(){},t.useDeferredValue=function(e){return A.current.useDeferredValue(e)},t.useEffect=function(e,t){return A.current.useEffect(e,t)},t.useId=function(){return A.current.useId()},t.useImperativeHandle=function(e,t,n){return A.current.useImperativeHandle(e,t,n)},t.useInsertionEffect=function(e,t){return A.current.useInsertionEffect(e,t)},t.useLayoutEffect=function(e,t){return A.current.useLayoutEffect(e,t)},t.useMemo=function(e,t){return A.current.useMemo(e,t)},t.useReducer=function(e,t,n){return A.current.useReducer(e,t,n)},t.useRef=function(e){return A.current.useRef(e)},t.useState=function(e){return A.current.useState(e)},t.useSyncExternalStore=function(e,t,n){return A.current.useSyncExternalStore(e,t,n)},t.useTransition=function(){return A.current.useTransition()},t.version="18.2.0"},294:(e,t,n)=>{"use strict";e.exports=n(408)},893:(e,t,n)=>{"use strict";e.exports=n(251)},233:function(e){e.exports=function(){"use strict";var e=void 0;"undefined"!=typeof window&&(e=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame),e||"undefined"==typeof process||"node"!==process.title||(e=setImmediate);var t=e=e||function(e){window.setTimeout(e,1e3/60)},n=Array.prototype.concat,r=Array.prototype.slice;function i(e,t){for(var i=arguments.length,o=Array(i>2?i-2:0),a=2;a<i;a++)o[a-2]=arguments[a];return function(){for(var i=arguments.length,a=Array(i),l=0;l<i;l++)a[l]=arguments[l];e.apply(t,n.call(o,r.call(a)))}}function o(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])}function a(e){return t(e)}function l(e,t){var n=e.indexOf(t);-1!==n&&e.splice(n,1)}var s={};function c(e){if(s[e])return s[e];var t=e.replace("#","");3===t.length&&(t=t[0]+t[0]+t[1]+t[1]+t[2]+t[2]);var n=t.match(/.{2}/g);if(!n||n.length<3)throw new Error("Expected a color string of format #rrggbb");var r={r:parseInt(n[0],16),g:parseInt(n[1],16),b:parseInt(n[2],16)};return s[e]=r,r}function u(e,t,n){var r=e.toString(16),i=t.toString(16),o=n.toString(16);return"#"+(r=r.length<2?"0"+r:r)+(i=i.length<2?"0"+i:i)+(o=o.length<2?"0"+o:o)}var d=Object.freeze({bind:i,extend:o,onFrame:a,removeFirst:l,hexToRGB:c,rgbToHex:u});function f(e,t,n,r,i){return r+(e-t)/(n-t)*(i-r)}function h(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=arguments[5],a=c(t),l=c(n),s=Math.floor(f(e,r,i,a.r,l.r)),d=Math.floor(f(e,r,i,a.g,l.g)),h=Math.floor(f(e,r,i,a.b,l.b));return o?"rgb("+s+","+d+","+h+")":u(s,d,h)}function m(e){return e*Math.PI/180}function p(e){return 180*e/Math.PI}var v=Object.freeze({mapValueInRange:f,interpolateColor:h,degreesToRadians:m,radiansToDegrees:p});function g(e){return 3.62*(e-30)+194}function y(e){return(e-194)/3.62+30}function b(e){return 3*(e-8)+25}function x(e){return(e-25)/3+8}var _=Object.freeze({tensionFromOrigamiValue:g,origamiValueFromTension:y,frictionFromOrigamiValue:b,origamiFromFriction:x}),j=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},E=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},O=function(){function e(){j(this,e),this.springSystem=null}return e.prototype.run=function(){var e=S.call(this);a((function(){e.loop(Date.now())}))},e}(),T=function(){function e(t){j(this,e),this.springSystem=null,this.time=0,this.running=!1,this.timestep=t||16.667}return e.prototype.run=function(){var e=S.call(this);if(!this.running){for(this.running=!0;!e.getIsIdle();)e.loop(this.time+=this.timestep);this.running=!1}},e}(),I=function(){function e(){j(this,e),this.springSystem=null,this.time=0,this.running=!1}return e.prototype.run=function(){},e.prototype.step=function(e){S.call(this).loop(this.time+=e)},e}();function S(){if(null==this.springSystem)throw new Error("cannot run looper without a springSystem");return this.springSystem}var w=Object.freeze({AnimationLooper:O,SimulationLooper:T,SteppingSimulationLooper:I}),N=function(){function e(t,n){j(this,e),this.bounciness=t,this.speed=n;var r=this.normalize(t/1.7,0,20);r=this.projectNormal(r,0,.8);var i=this.normalize(n/1.7,0,20);this.bouncyTension=this.projectNormal(i,.5,200),this.bouncyFriction=this.quadraticOutInterpolation(r,this.b3Nobounce(this.bouncyTension),.01)}return e.prototype.normalize=function(e,t,n){return(e-t)/(n-t)},e.prototype.projectNormal=function(e,t,n){return t+e*(n-t)},e.prototype.linearInterpolation=function(e,t,n){return e*n+(1-e)*t},e.prototype.quadraticOutInterpolation=function(e,t,n){return this.linearInterpolation(2*e-e*e,t,n)},e.prototype.b3Friction1=function(e){return 7e-4*Math.pow(e,3)-.031*Math.pow(e,2)+.64*e+1.28},e.prototype.b3Friction2=function(e){return 44e-6*Math.pow(e,3)-.006*Math.pow(e,2)+.36*e+2},e.prototype.b3Friction3=function(e){return 45e-8*Math.pow(e,3)-332e-6*Math.pow(e,2)+.1078*e+5.84},e.prototype.b3Nobounce=function(e){return e<=18?this.b3Friction1(e):e>18&&e<=44?this.b3Friction2(e):this.b3Friction3(e)},e}(),P=function(){function e(t,n){j(this,e),this.tension=t,this.friction=n}return e.fromOrigamiTensionAndFriction=function(t,n){return new e(g(t),b(n))},e.fromBouncinessAndSpeed=function(t,n){var r=new N(t,n);return e.fromOrigamiTensionAndFriction(r.bouncyTension,r.bouncyFriction)},e.coastingConfigWithOrigamiFriction=function(t){return new e(0,b(t))},e}();P.DEFAULT_ORIGAMI_SPRING_CONFIG=P.fromOrigamiTensionAndFriction(40,7);var C=function e(){j(this,e),this.position=0,this.velocity=0},A=function(){function e(t){j(this,e),this.listeners=[],this._startValue=0,this._currentState=new C,this._displacementFromRestThreshold=.001,this._endValue=0,this._overshootClampingEnabled=!1,this._previousState=new C,this._restSpeedThreshold=.001,this._tempState=new C,this._timeAccumulator=0,this._wasAtRest=!0,this._id="s"+e._ID++,this._springSystem=t}return e.prototype.destroy=function(){this.listeners=[],this._springSystem.deregisterSpring(this)},e.prototype.getId=function(){return this._id},e.prototype.setSpringConfig=function(e){return this._springConfig=e,this},e.prototype.getSpringConfig=function(){return this._springConfig},e.prototype.setCurrentValue=function(e,t){return this._startValue=e,this._currentState.position=e,t||this.setAtRest(),this.notifyPositionUpdated(!1,!1),this},e.prototype.getStartValue=function(){return this._startValue},e.prototype.getCurrentValue=function(){return this._currentState.position},e.prototype.getCurrentDisplacementDistance=function(){return this.getDisplacementDistanceForState(this._currentState)},e.prototype.getDisplacementDistanceForState=function(e){return Math.abs(this._endValue-e.position)},e.prototype.setEndValue=function(e){if(this._endValue===e&&this.isAtRest())return this;this._startValue=this.getCurrentValue(),this._endValue=e,this._springSystem.activateSpring(this.getId());for(var t=0,n=this.listeners.length;t<n;t++){var r=this.listeners[t].onSpringEndStateChange;r&&r(this)}return this},e.prototype.getEndValue=function(){return this._endValue},e.prototype.setVelocity=function(e){return e===this._currentState.velocity||(this._currentState.velocity=e,this._springSystem.activateSpring(this.getId())),this},e.prototype.getVelocity=function(){return this._currentState.velocity},e.prototype.setRestSpeedThreshold=function(e){return this._restSpeedThreshold=e,this},e.prototype.getRestSpeedThreshold=function(){return this._restSpeedThreshold},e.prototype.setRestDisplacementThreshold=function(e){this._displacementFromRestThreshold=e},e.prototype.getRestDisplacementThreshold=function(){return this._displacementFromRestThreshold},e.prototype.setOvershootClampingEnabled=function(e){return this._overshootClampingEnabled=e,this},e.prototype.isOvershootClampingEnabled=function(){return this._overshootClampingEnabled},e.prototype.isOvershooting=function(){var e=this._startValue,t=this._endValue;return this._springConfig.tension>0&&(e<t&&this.getCurrentValue()>t||e>t&&this.getCurrentValue()<t)},e.prototype.advance=function(t,n){var r=this.isAtRest();if(!r||!this._wasAtRest){var i=n;n>e.MAX_DELTA_TIME_SEC&&(i=e.MAX_DELTA_TIME_SEC),this._timeAccumulator+=i;for(var o=this._springConfig.tension,a=this._springConfig.friction,l=this._currentState.position,s=this._currentState.velocity,c=this._tempState.position,u=this._tempState.velocity,d=void 0,f=void 0,h=void 0,m=void 0,p=void 0,v=void 0,g=void 0,y=void 0;this._timeAccumulator>=e.SOLVER_TIMESTEP_SEC;)this._timeAccumulator-=e.SOLVER_TIMESTEP_SEC,this._timeAccumulator<e.SOLVER_TIMESTEP_SEC&&(this._previousState.position=l,this._previousState.velocity=s),d=s,f=o*(this._endValue-c)-a*s,c=l+d*e.SOLVER_TIMESTEP_SEC*.5,h=u=s+f*e.SOLVER_TIMESTEP_SEC*.5,m=o*(this._endValue-c)-a*u,c=l+h*e.SOLVER_TIMESTEP_SEC*.5,p=u=s+m*e.SOLVER_TIMESTEP_SEC*.5,v=o*(this._endValue-c)-a*u,c=l+p*e.SOLVER_TIMESTEP_SEC,g=u=s+v*e.SOLVER_TIMESTEP_SEC,y=1/6*(f+2*(m+v)+(o*(this._endValue-c)-a*u)),l+=1/6*(d+2*(h+p)+g)*e.SOLVER_TIMESTEP_SEC,s+=y*e.SOLVER_TIMESTEP_SEC;this._tempState.position=c,this._tempState.velocity=u,this._currentState.position=l,this._currentState.velocity=s,this._timeAccumulator>0&&this._interpolate(this._timeAccumulator/e.SOLVER_TIMESTEP_SEC),(this.isAtRest()||this._overshootClampingEnabled&&this.isOvershooting())&&(this._springConfig.tension>0?(this._startValue=this._endValue,this._currentState.position=this._endValue):(this._endValue=this._currentState.position,this._startValue=this._endValue),this.setVelocity(0),r=!0);var b=!1;this._wasAtRest&&(this._wasAtRest=!1,b=!0);var x=!1;r&&(this._wasAtRest=!0,x=!0),this.notifyPositionUpdated(b,x)}},e.prototype.notifyPositionUpdated=function(e,t){for(var n=0,r=this.listeners.length;n<r;n++){var i=this.listeners[n];e&&i.onSpringActivate&&i.onSpringActivate(this),i.onSpringUpdate&&i.onSpringUpdate(this),t&&i.onSpringAtRest&&i.onSpringAtRest(this)}},e.prototype.systemShouldAdvance=function(){return!this.isAtRest()||!this.wasAtRest()},e.prototype.wasAtRest=function(){return this._wasAtRest},e.prototype.isAtRest=function(){return Math.abs(this._currentState.velocity)<this._restSpeedThreshold&&(this.getDisplacementDistanceForState(this._currentState)<=this._displacementFromRestThreshold||0===this._springConfig.tension)},e.prototype.setAtRest=function(){return this._endValue=this._currentState.position,this._tempState.position=this._currentState.position,this._currentState.velocity=0,this},e.prototype._interpolate=function(e){this._currentState.position=this._currentState.position*e+this._previousState.position*(1-e),this._currentState.velocity=this._currentState.velocity*e+this._previousState.velocity*(1-e)},e.prototype.getListeners=function(){return this.listeners},e.prototype.addListener=function(e){return this.listeners.push(e),this},e.prototype.removeListener=function(e){return l(this.listeners,e),this},e.prototype.removeAllListeners=function(){return this.listeners=[],this},e.prototype.currentValueIsApproximately=function(e){return Math.abs(this.getCurrentValue()-e)<=this.getRestDisplacementThreshold()},e}();A._ID=0,A.MAX_DELTA_TIME_SEC=.064,A.SOLVER_TIMESTEP_SEC=.001;var L=function(){function e(t){j(this,e),this.listeners=[],this._activeSprings=[],this._idleSpringIndices=[],this._isIdle=!0,this._lastTimeMillis=-1,this._springRegistry={},this.looper=t||new O,this.looper.springSystem=this}return e.prototype.setLooper=function(e){this.looper=e,e.springSystem=this},e.prototype.createSpring=function(e,t){var n=void 0;return n=void 0===e||void 0===t?P.DEFAULT_ORIGAMI_SPRING_CONFIG:P.fromOrigamiTensionAndFriction(e,t),this.createSpringWithConfig(n)},e.prototype.createSpringWithBouncinessAndSpeed=function(e,t){var n=void 0;return n=void 0===e||void 0===t?P.DEFAULT_ORIGAMI_SPRING_CONFIG:P.fromBouncinessAndSpeed(e,t),this.createSpringWithConfig(n)},e.prototype.createSpringWithConfig=function(e){var t=new A(this);return this.registerSpring(t),t.setSpringConfig(e),t},e.prototype.getIsIdle=function(){return this._isIdle},e.prototype.getSpringById=function(e){return this._springRegistry[e]},e.prototype.getAllSprings=function(){var e=[];for(var t in this._springRegistry)this._springRegistry.hasOwnProperty(t)&&e.push(this._springRegistry[t]);return e},e.prototype.registerSpring=function(e){this._springRegistry[e.getId()]=e},e.prototype.deregisterSpring=function(e){l(this._activeSprings,e),delete this._springRegistry[e.getId()]},e.prototype.advance=function(e,t){for(;this._idleSpringIndices.length>0;)this._idleSpringIndices.pop();for(var n=0,r=this._activeSprings.length;n<r;n++){var i=this._activeSprings[n];i.systemShouldAdvance()?i.advance(e/1e3,t/1e3):this._idleSpringIndices.push(this._activeSprings.indexOf(i))}for(;this._idleSpringIndices.length>0;){var o=this._idleSpringIndices.pop();o>=0&&this._activeSprings.splice(o,1)}},e.prototype.loop=function(e){var t=void 0;-1===this._lastTimeMillis&&(this._lastTimeMillis=e-1);var n=e-this._lastTimeMillis;this._lastTimeMillis=e;var r=0,i=this.listeners.length;for(r=0;r<i;r++)(t=this.listeners[r]).onBeforeIntegrate&&t.onBeforeIntegrate(this);for(this.advance(e,n),0===this._activeSprings.length&&(this._isIdle=!0,this._lastTimeMillis=-1),r=0;r<i;r++)(t=this.listeners[r]).onAfterIntegrate&&t.onAfterIntegrate(this);this._isIdle||this.looper.run()},e.prototype.activateSpring=function(e){var t=this._springRegistry[e];-1===this._activeSprings.indexOf(t)&&this._activeSprings.push(t),this.getIsIdle()&&(this._isIdle=!1,this.looper.run())},e.prototype.addListener=function(e){this.listeners.push(e)},e.prototype.removeListener=function(e){l(this.listeners,e)},e.prototype.removeAllListeners=function(){this.listeners=[]},e}();return E({},w,{OrigamiValueConverter:_,MathUtil:v,Spring:A,SpringConfig:P,SpringSystem:L,util:E({},d,v)})}()},53:(e,t)=>{"use strict";function n(e,t){var n=e.length;e.push(t);e:for(;0<n;){var r=n-1>>>1,i=e[r];if(!(0<o(i,t)))break e;e[r]=t,e[n]=i,n=r}}function r(e){return 0===e.length?null:e[0]}function i(e){if(0===e.length)return null;var t=e[0],n=e.pop();if(n!==t){e[0]=n;e:for(var r=0,i=e.length,a=i>>>1;r<a;){var l=2*(r+1)-1,s=e[l],c=l+1,u=e[c];if(0>o(s,n))c<i&&0>o(u,s)?(e[r]=u,e[c]=n,r=c):(e[r]=s,e[l]=n,r=l);else{if(!(c<i&&0>o(u,n)))break e;e[r]=u,e[c]=n,r=c}}}return t}function o(e,t){var n=e.sortIndex-t.sortIndex;return 0!==n?n:e.id-t.id}if("object"==typeof performance&&"function"==typeof performance.now){var a=performance;t.unstable_now=function(){return a.now()}}else{var l=Date,s=l.now();t.unstable_now=function(){return l.now()-s}}var c=[],u=[],d=1,f=null,h=3,m=!1,p=!1,v=!1,g="function"==typeof setTimeout?setTimeout:null,y="function"==typeof clearTimeout?clearTimeout:null,b="undefined"!=typeof setImmediate?setImmediate:null;function x(e){for(var t=r(u);null!==t;){if(null===t.callback)i(u);else{if(!(t.startTime<=e))break;i(u),t.sortIndex=t.expirationTime,n(c,t)}t=r(u)}}function _(e){if(v=!1,x(e),!p)if(null!==r(c))p=!0,L(j);else{var t=r(u);null!==t&&M(_,t.startTime-e)}}function j(e,n){p=!1,v&&(v=!1,y(I),I=-1),m=!0;var o=h;try{for(x(n),f=r(c);null!==f&&(!(f.expirationTime>n)||e&&!N());){var a=f.callback;if("function"==typeof a){f.callback=null,h=f.priorityLevel;var l=a(f.expirationTime<=n);n=t.unstable_now(),"function"==typeof l?f.callback=l:f===r(c)&&i(c),x(n)}else i(c);f=r(c)}if(null!==f)var s=!0;else{var d=r(u);null!==d&&M(_,d.startTime-n),s=!1}return s}finally{f=null,h=o,m=!1}}"undefined"!=typeof navigator&&void 0!==navigator.scheduling&&void 0!==navigator.scheduling.isInputPending&&navigator.scheduling.isInputPending.bind(navigator.scheduling);var E,O=!1,T=null,I=-1,S=5,w=-1;function N(){return!(t.unstable_now()-w<S)}function P(){if(null!==T){var e=t.unstable_now();w=e;var n=!0;try{n=T(!0,e)}finally{n?E():(O=!1,T=null)}}else O=!1}if("function"==typeof b)E=function(){b(P)};else if("undefined"!=typeof MessageChannel){var C=new MessageChannel,A=C.port2;C.port1.onmessage=P,E=function(){A.postMessage(null)}}else E=function(){g(P,0)};function L(e){T=e,O||(O=!0,E())}function M(e,n){I=g((function(){e(t.unstable_now())}),n)}t.unstable_IdlePriority=5,t.unstable_ImmediatePriority=1,t.unstable_LowPriority=4,t.unstable_NormalPriority=3,t.unstable_Profiling=null,t.unstable_UserBlockingPriority=2,t.unstable_cancelCallback=function(e){e.callback=null},t.unstable_continueExecution=function(){p||m||(p=!0,L(j))},t.unstable_forceFrameRate=function(e){0>e||125<e?console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported"):S=0<e?Math.floor(1e3/e):5},t.unstable_getCurrentPriorityLevel=function(){return h},t.unstable_getFirstCallbackNode=function(){return r(c)},t.unstable_next=function(e){switch(h){case 1:case 2:case 3:var t=3;break;default:t=h}var n=h;h=t;try{return e()}finally{h=n}},t.unstable_pauseExecution=function(){},t.unstable_requestPaint=function(){},t.unstable_runWithPriority=function(e,t){switch(e){case 1:case 2:case 3:case 4:case 5:break;default:e=3}var n=h;h=e;try{return t()}finally{h=n}},t.unstable_scheduleCallback=function(e,i,o){var a=t.unstable_now();switch("object"==typeof o&&null!==o?o="number"==typeof(o=o.delay)&&0<o?a+o:a:o=a,e){case 1:var l=-1;break;case 2:l=250;break;case 5:l=1073741823;break;case 4:l=1e4;break;default:l=5e3}return e={id:d++,callback:i,priorityLevel:e,startTime:o,expirationTime:l=o+l,sortIndex:-1},o>a?(e.sortIndex=o,n(u,e),null===r(c)&&e===r(u)&&(v?(y(I),I=-1):v=!0,M(_,o-a))):(e.sortIndex=l,n(c,e),p||m||(p=!0,L(j))),e},t.unstable_shouldYield=N,t.unstable_wrapCallback=function(e){var t=h;return function(){var n=h;h=t;try{return e.apply(this,arguments)}finally{h=n}}}},840:(e,t,n)=>{"use strict";e.exports=n(53)},205:(e,t,n)=>{var r;r=function(e,t,n){"use strict";var r=function(){this.events={}},i=function(e,t){this.code=e,this.context=t},o=void 0!==t;if((t=t||{})._Initialized)return t;var a=[2,0,2,0];for(var l in r.prototype._createClear=function(e,n,r,i){return function(){var o=e.events[n];if(o){var a=-1;if(void 0===r){for(var l=0;l<o.length;++l)if(void 0!==o[l].wasInCPP){a=l;break}}else a=o.indexOf(r);-1!=a&&(o.splice(a,1),0===o.length&&delete e.events[n])}else void 0!==t.RemoveOnHandler&&t.RemoveOnHandler(n,r,i||t)}},r.prototype.on=function(e,t,n){var r=this.events[e];void 0===r&&(r=this.events[e]=[]);var o=new i(t,n||this);return r.push(o),{clear:this._createClear(this,e,o,n)}},r.prototype.off=function(e,n,r){var i=this.events[e];if(void 0!==i){var o;r=r||this;var a=i.length;for(o=0;o<a;++o){var l=i[o];if(l.code==n&&l.context==r)break}o<a&&(i.splice(o,1),0===i.length&&delete this.events[e])}else t.RemoveOnHandler(e,n,r||this)},r.prototype.trigger=function(e){var t=this.events[e];if(void 0!==t){var n=Array.prototype.slice.call(arguments,1);return t.forEach((function(e){e.code.apply(e.context,n)})),!0}return!1},t.isAttached=o,t.isAttached||(r.prototype.on=function(e,t,n){var r=this.events[e];this.browserCallbackOn&&this.browserCallbackOn(e,t,n),void 0===r&&(r=this.events[e]=[]);var o=new i(t,n||this);return r.push(o),{clear:this._createClear(this,e,o)}},r.prototype.off=function(e,t,n){var r=this.events[e];if(void 0!==r){var i;n=n||this;var o=r.length;for(i=0;i<o;++i){var a=r[i];if(a.code==t&&a.context==n)break}i<o&&(r.splice(i,1),0===r.length&&(delete this.events[e],this.browserCallbackOff&&this.browserCallbackOff(e,t,n)))}},t.SendMessage=function(e,n){var r=Array.prototype.slice.call(arguments,2),i=t._ActiveRequests[n];delete t._ActiveRequests[n];var o=function(){var n=t._mocks[e];void 0!==n&&i.resolve(n.apply(t,r))};window.setTimeout(o,16)},t.TriggerEvent=function(){var e=Array.prototype.slice.call(arguments),n=function(){var n=t._mocks[e[0]];void 0!==n&&n.apply(t,e.slice(1))};return window.setTimeout(n,16),void 0!==t._mocks[e[0]]},t.BindingsReady=function(){t._OnReady()},t.createJSModel=function(t,n){e[t]=n},t.updateWholeModel=function(){},t.synchronizeModels=function(){},t.enableImmediateLayout=function(){},t.isImmediateLayoutEnabled=function(){return!0},t.executeImmediateLayoutSync=function(){},t._mocks={},t._mockImpl=function(e,t,n,r){t&&(this._mocks[e]=t);var i=t.toString().replace("function "+t.name+"(",""),o=i.indexOf(")"),a=i.substr(0,o);this.browserCallbackMock&&this.browserCallbackMock(e,a,n,Boolean(r))},t.mock=function(e,t,n){this._mockImpl(e,t,!0,n)}),t.events={},r.prototype)t[l]=r.prototype[l];return t.isAttached&&(t.on=function(e,n,r){return n?(t.AddOrRemoveOnHandler(e,n,r||t),{clear:this._createClear(this,e,n,r)}):(console.error("No handler specified for engine.on"),{clear:function(){}})}),t.whenReady=new Promise((function(e){t.on("Ready",e)})),t._trigger=r.prototype.trigger,t.trigger=function(){this._trigger.apply(this,arguments)||this.TriggerEvent.apply(this,arguments)},t.isAttached&&(t.mock=function(){}),t._BindingsReady=!1,t._WindowLoaded=!1,t._RequestId=0,t._ActiveRequests={},t.call=function(){t._RequestId++;var e=t._RequestId,n=Array.prototype.slice.call(arguments);n.splice(1,0,e);var r=new Promise((function(r,i){t._ActiveRequests[e]={resolve:r,reject:i},t.SendMessage.apply(t,n)}));return r},t._Result=function(e){var n=t._ActiveRequests[e];if(void 0!==n){delete t._ActiveRequests[e];var r=Array.prototype.slice.call(arguments);r.shift(),n.resolve.apply(n,r)}},t._Reject=function(e){var n=t._ActiveRequests[e];void 0!==n&&(delete t._ActiveRequests[e],requestAnimationFrame((function(){return n.reject("No handler registered")})))},t._ForEachError=function(e,t){for(var n=e.length,r=0;r<n;++r)t(e[r].first,e[r].second)},t._TriggerError=function(e){t.trigger("Error",e)},t._OnError=function(e,n){if(null===e||0===e)t._ForEachError(n,t._TriggerError);else{var r=t._ActiveRequests[e];delete t._ActiveRequests[e],r.reject(new Error(n[0].second))}if(n.length)throw new Error(n[0].second)},t._OnReady=function(){t._BindingsReady=!0,t._WindowLoaded&&t.trigger("Ready")},t._OnWindowLoaded=function(){t._WindowLoaded=!0,t._BindingsReady&&t.trigger("Ready")},n?e.addEventListener("load",(function(){t._OnWindowLoaded()})):t._WindowLoaded=!0,t.on("_Result",t._Result,t),t.on("_Reject",t._Reject,t),t.on("_OnReady",t._OnReady,t),t.on("_OnError",t._OnError,t),t.dependency=new WeakMap,t.hasAttachedUpdateListner=!1,t.onUpdateWholeModel=function(e){(t.dependency.get(e)||[]).forEach((function(e){return t.updateWholeModel(e)}))},t.createObservableModel=function(e){var n={set:function(n,r,i){t.updateWholeModel(window[e]),n[r]=i}};t.createJSModel(e,new Proxy({},n))},t.addSynchronizationDependency=function(e,n){t.hasAttachedUpdateListner||(t.addDataBindEventListner("updateWholeModel",t.onUpdateWholeModel),t.hasAttachedUpdateListner=!0);var r=t.dependency.get(e);r||(r=[],t.dependency.set(e,r)),r.push(n)},t.removeSynchronizationDependency=function(e,n){var r=t.dependency.get(e)||[];r.splice(r.indexOf(n),1)},t.BindingsReady(a[0],a[1],a[2],a[3]),t._Initialized=!0,t},e.exports?e.exports=r(n.g,n.g.engine,!1):engine=r(window,window.engine,!0)},666:()=>{function e(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function t(t){return function(t){if(Array.isArray(t))return e(t)}(t)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(t)||function(t,n){if(!t)return;if("string"==typeof t)return e(t,n);var r=Object.prototype.toString.call(t).slice(8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Array.from(r);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return e(t,n)}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var n,r;document&&document.location&&document.location.hostname||document.location||Object.defineProperty(document,"location",{get:function(){return{hostname:""}}}),void 0===document.body.clientWidth&&(Object.defineProperty(Element.prototype,"clientHeight",{get:function(){return this.offsetHeight}}),Object.defineProperty(Element.prototype,"clientWidth",{get:function(){return this.offsetWidth}})),CanvasRenderingContext2D.prototype.resetTransform||(CanvasRenderingContext2D.prototype.resetTransform=function(){this.setTransform(1,0,0,1,0,0)}),CanvasRenderingContext2D.prototype.setLineDash||(CanvasRenderingContext2D.prototype.setLineDash=function(){}),window.addEventListener=(n=window.addEventListener,function(e){for(var r=arguments.length,i=new Array(r>1?r-1:0),o=1;o<r;o++)i[o-1]=arguments[o];"test"!=e&&n.apply(void 0,[e].concat(t(i)))}),window.removeEventListener=(r=window.removeEventListener,function(e){for(var n=arguments.length,i=new Array(n>1?n-1:0),o=1;o<n;o++)i[o-1]=arguments[o];"test"!=e&&r.apply(void 0,[e].concat(t(i)))})}},t={};function n(r){var i=t[r];if(void 0!==i)return i.exports;var o=t[r]={exports:{}};return e[r].call(o.exports,o,o.exports,n),o.exports}n.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return n.d(t,{a:t}),t},n.d=(e,t)=>{for(var r in t)n.o(t,r)&&!n.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},n.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),n.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),(()=>{"use strict";var e=n(893),t=n(745);const r="app-container_Y5l";n(666);var i=n(294),o=n(205),a=n.n(o);function l(e){var t=e.index,n=e.version;return"".concat(t.toFixed(0),":").concat(n.toFixed(0))}function s(e){if("string"==typeof e){var t=e.split(":");if(2===t.length){var n=parseInt(t[0]),r=parseInt(t[1]);if(!isNaN(n)&&!isNaN(r))return{index:n,version:r}}}}function c(e,t){return e===t||null!=e&&null!=t&&e.index===t.index&&e.version===t.version}function u(e){return null==e||0===e.trim().length}var d=Object.prototype.hasOwnProperty;function f(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1;if(Object.is(e,t))return!0;if(n<=0||"object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var r=Object.keys(e),i=Object.keys(t);if(r.length!==i.length)return!1;for(var o=0;o<r.length;o++)if(!d.call(t,r[o])||!f(e[r[o]],t[r[o]],n-1))return!1;return!0}function h(e){if("object"==typeof e&&null!=e){var t=e.length||0===e.length?[]:{},n=!0,r=!1,i=void 0;try{for(var o,a=Object.keys(e).sort((function(e,t){return e.localeCompare(t)}))[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var l=o.value;t[l]=h(e[l])}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return JSON.stringify(t)}return e}function m(e){if("object"==typeof e&&null!=e){var t=e.length||0===e.length?[]:{},n=!0,r=!1,i=void 0;try{for(var o,a=Object.keys(e).sort((function(e,t){return e.localeCompare(t)}))[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var l=o.value;"__Type"!==l&&(t[l]=h(e[l]))}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return JSON.stringify(t)}return e}function p(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function v(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function g(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function y(e,t,n){return t&&g(e.prototype,t),n&&g(e,n),e}function b(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function x(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||j(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _(e){return function(e){if(Array.isArray(e))return p(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||j(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function j(e,t){if(e){if("string"==typeof e)return p(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?p(e,t):void 0}}function E(e,t,n){return new R("".concat(e,".").concat(t),n)}function O(e){return new k(e)}function T(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:m;return new D("".concat(e,".").concat(t),n)}function I(e,t){return new K("".concat(e,".").concat(t))}function S(e,t){var n="".concat(e,".").concat(t);return function(){return a().trigger(n)}}function w(e,t){var n,r="".concat(e,".").concat(t);return function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];return(n=a()).trigger.apply(n,[r].concat(_(t)))}}function N(e,t){for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];var o;(o=a()).trigger.apply(o,["".concat(e,".").concat(t)].concat(_(r)))}function P(e,t){for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];var o;return(o=a()).call.apply(o,["".concat(e,".").concat(t)].concat(_(r)))}function C(e){var t=(0,i.useMemo)((function(){return e.subscribe()}),[e]),n=x((0,i.useState)(t.value),2),r=n[0],o=n[1];return(0,i.useEffect)((function(){return o(t.value),t.setChangeListener(o),function(){return t.dispose()}}),[t]),r}function A(e,t,n){var r=(0,i.useMemo)((function(){return e.subscribe()}),[e]),o=x((0,i.useReducer)(t,t(n,r.value)),2),a=o[0],l=o[1];return(0,i.useEffect)((function(){return l(r.value),r.setChangeListener(l),function(){return r.dispose()}}),[r,t]),a}function L(e){var t=(0,i.useMemo)((function(){return e.subscribe()}),[e]),n=(0,i.useRef)(t.value);return(0,i.useEffect)((function(){return n.current=t.value,t.setChangeListener((function(e){n.current=e})),function(){return t.dispose()}}),[t]),n}function M(e,t){var n=(0,i.useMemo)((function(){return e.subscribe(t)}),[e,t]),r=x((0,i.useState)(n.value),2),o=r[0],a=r[1];return(0,i.useEffect)((function(){return a(n.value),n.setChangeListener(a),function(){return n.dispose()}}),[n]),o}var R=function(){function e(t,n){var r=this;v(this,e),this.fallbackValue=n,this.listeners=[],this.connections=null,this.disposed=!1,this._value=void 0,this.subscribe=function(e){if(r.disposed)throw new Error("cannot subscribe to a disposed binding!");r.connect();var t=new U(e);r.listeners.push(t);var n=r;return{get value(){return n.getValueUnsafe()},setChangeListener:t.set,dispose:function(){var e=n.listeners.indexOf(t);-1!==e&&(n.listeners.splice(e,1),0===n.listeners.length&&n.disconnect())}}},this.dispose=function(){r.disposed=!0,r.listeners.splice(0,r.listeners.length),r.disconnect()},this.onUpdate=function(e){if(e!==r._value){r._value=e;var t=!0,n=!1,i=void 0;try{for(var o,a=r.listeners[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){o.value.call(e)}}catch(e){n=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(n)throw i}}}},this.onPatch=function(e,t){if(0===e.length)r.onUpdate(t);else{if(!G(r._value))throw new Error("cannot patch object of type ".concat(null!=r._value?(s=r._value)&&"undefined"!=typeof Symbol&&s.constructor===Symbol?"symbol":typeof s:r._value,"!"));for(var n=F(r._value),i=n,o=0;o<e.length-1;o++){var a=e[o],l=i[a];if(!G(l))throw new Error("'".concat(e.slice(0,o+1).join("->"),"' is not a container"));i[a]=F(l),i=i[a]}i[e[e.length-1]]=t,r.onUpdate(n)}var s},this.subscribeTrigger="".concat(t,".subscribe"),this.unsubscribeTrigger="".concat(t,".unsubscribe"),this.updateTrigger="".concat(t,".update"),this.patchTrigger="".concat(t,".patch"),this._value=n}var t=e.prototype;return t.connect=function(){if(null==this.connections&&(this.connections=[a().on(this.updateTrigger,this.onUpdate),a().on(this.patchTrigger,this.onPatch)],a().trigger(this.subscribeTrigger),void 0===this._value))throw new Error("'".concat(this.updateTrigger,"' was not called after subscribe!\nDid you forget to add the binding on the C# side?"))},t.disconnect=function(){if(null!=this.connections){var e=!0,t=!1,n=void 0;try{for(var r,i=this.connections[Symbol.iterator]();!(e=(r=i.next()).done);e=!0){r.value.clear()}}catch(e){t=!0,n=e}finally{try{e||null==i.return||i.return()}finally{if(t)throw n}}this.connections=null,a().trigger(this.unsubscribeTrigger),this._value=this.fallbackValue}},t.getValueUnsafe=function(){if(void 0===this._value)throw new Error("'".concat(this.updateTrigger,"' was not called before getValueUnsafe!"));return this._value},y(e,[{key:"value",get:function(){if(null!=this.connections)return this.getValueUnsafe();this.connect();var e=this.getValueUnsafe();return this.disconnect(),e}}]),e}(),k=function(){function e(t){var n=this;v(this,e),this.listeners=[],this.disposed=!1,this.subscribe=function(e){if(n.disposed)throw new Error("cannot subscribe to a disposed binding!");var t=new U(e);n.listeners.push(t);var r=n;return{get value(){return r._value},setChangeListener:t.set,dispose:function(){var e=r.listeners.indexOf(t);-1!==e&&r.listeners.splice(e,1)}}},this.dispose=function(){n.disposed=!0,n.listeners.splice(0,n.listeners.length)},this.update=function(e){if(e!==n._value){n._value=e;var t=!0,r=!1,i=void 0;try{for(var o,a=n.listeners[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){o.value.call(e)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}}},this._value=t}return y(e,[{key:"registered",get:function(){return!0}},{key:"value",get:function(){return this._value}}]),e}(),D=function(){function e(t,n){var r=this;v(this,e),this.keyStringifier=n,this.entries=new Map,this.updateConnection=null,this.disposed=!1,this.getValue=function(e){var t=r.getConnection(e);if(null!=t)return r.getValueUnsafe(t);var n=r.connect(e),i=r.getValueUnsafe(n);return r.disconnect(e),i},this.subscribe=function(e,t){if(r.disposed)throw new Error("cannot subscribe to a disposed binding!");var n=r.connect(e),i=new U(t);n.listeners.push(i);var o=r;return{get value(){return o.getValueUnsafe(n)},setChangeListener:i.set,dispose:function(){var t=n.listeners.indexOf(i);-1!==t&&(n.listeners.splice(t,1),0===n.listeners.length&&o.disconnect(e))}}},this.dispose=function(){r.disposed=!0,r.disconnectAll()},this.onUpdate=function(e,t){var n=r.getConnection(e);if(null!=n){if(t!==n.value){n.value=t;var i=!0,o=!1,a=void 0;try{for(var l,s=n.listeners[Symbol.iterator]();!(i=(l=s.next()).done);i=!0){l.value.call(t)}}catch(e){o=!0,a=e}finally{try{i||null==s.return||s.return()}finally{if(o)throw a}}}}else console.warn("'".concat(r.updateTrigger,"' was called on already unsubscribed key!"))},this.subscribeTrigger="".concat(t,".subscribeMapEntry"),this.unsubscribeTrigger="".concat(t,".unsubscribeMapEntry"),this.updateTrigger="".concat(t,".updateMapEntry")}var t=e.prototype;return t.getConnection=function(e){var t=this.keyStringifier(e);return this.entries.get(t)},t.connect=function(e){var t=this.keyStringifier(e),n=this.entries.get(t);if(null!=n)return n;if(null==this.updateConnection&&(this.updateConnection=a().on(this.updateTrigger,this.onUpdate)),n={key:e,value:void 0,listeners:[]},this.entries.set(t,n),a().trigger(this.subscribeTrigger,e),void 0===n.value)throw new Error("'".concat(this.updateTrigger,"' was not called after subscribing the key '").concat(t,"'!\nDid you forget to add the binding on the C# side?"));return n},t.disconnectAll=function(){var e=!0,t=!1,n=void 0;try{for(var r,i=this.entries.values()[Symbol.iterator]();!(e=(r=i.next()).done);e=!0){var o=r.value;a().trigger(this.unsubscribeTrigger,o.key)}}catch(e){t=!0,n=e}finally{try{e||null==i.return||i.return()}finally{if(t)throw n}}this.entries.clear(),null!=this.updateConnection&&(this.updateConnection.clear(),this.updateConnection=null)},t.disconnect=function(e){var t=this.keyStringifier(e);null!=this.entries.get(t)&&(this.entries.delete(t),0===this.entries.size&&null!=this.updateConnection&&(this.updateConnection.clear(),this.updateConnection=null),a().trigger(this.unsubscribeTrigger,e))},t.getValueUnsafe=function(e){if(void 0===e.value)throw new Error("'".concat(this.updateTrigger,"' was not called before getValueUnsafe!"));return e.value},e}(),U=function e(t){var n=this;v(this,e),this.listener=t,this.set=function(e){n.listener=e},this.call=function(e){null!=n.listener&&n.listener(e)}};function F(e){return Array.isArray(e)?_(e):function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){b(e,t,n[t])}))}return e}({},e)}function G(e){return null!=e&&"object"==typeof e}var V,B,H,K=function(){function e(t){var n=this;v(this,e),this.listeners=[],this.updateConnection=null,this.disposed=!1,this.subscribe=function(e){if(n.disposed)throw new Error("cannot subscribe to a disposed binding!");return n.listeners.includes(e)||n.listeners.push(e),n.subscribeValue(),{dispose:function(){var t=n.listeners.indexOf(e);-1!==t&&(n.listeners.splice(t,1),0===n.listeners.length&&n.unsubscribeValue())}}},this.dispose=function(){n.disposed=!0,n.listeners.splice(0,n.listeners.length),n.unsubscribeValue()},this.onUpdate=function(e){var t=!0,r=!1,i=void 0;try{for(var o,a=n.listeners[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){(0,o.value)(e)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}},this.subscribeTrigger="".concat(t,".subscribe"),this.unsubscribeTrigger="".concat(t,".unsubscribe"),this.updateTrigger="".concat(t,".update")}var t=e.prototype;return t.subscribeValue=function(){null==this.updateConnection&&(this.updateConnection=a().on(this.updateTrigger,this.onUpdate),a().trigger(this.subscribeTrigger))},t.unsubscribeValue=function(){null!=this.updateConnection&&(this.updateConnection.clear(),this.updateConnection=null,a().trigger(this.unsubscribeTrigger))},e}(),W="app";!function(e){e[e.Off=0]="Off",e[e.Simple=1]="Simple",e[e.Advanced=2]="Advanced",e[e.Precise=3]="Precise"}(V||(V={})),function(e){e[e.Warning=0]="Warning",e[e.Error=1]="Error"}(B||(B={})),function(e){e[e.Quit=1]="Quit",e[e.SaveAndQuit=2]="SaveAndQuit"}(H||(H={}));var z=E(W,"ready"),Y=E(W,"activeUI"),X=E(W,"bodyClassNames",""),q=E(W,"fpsMode"),$=E(W,"frameStats"),Q=E(W,"activeLocale","en-US"),Z=E(W,"currentError"),J=E(W,"backgroundProcessMessage",null),ee=I(W,"confirmationDialog");function te(){N(W,"exitApplication")}function ne(){N(W,"saveBackupAndExitApplication")}var re="input",ie=E(re,"actionNames"),oe=I(re,"onActionPerformed"),ae=I(re,"onActionReleased");function le(e,t){N(re,"setActionPriority",e,t)}function se(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function ce(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var ue={attachChild:function(){},detachChild:function(){},transformStack:function(){},setDirty:function(){}},de=i.createContext(ue);function fe(e,t){var n=(0,i.useContext)(de),r=(0,i.useMemo)((function(){return new he}),[]);return(0,i.useEffect)((function(){r.transformer=t}),[r,t]),(0,i.useEffect)((function(){if(e)return r.attachTo(n),function(){return r.detach()}}),[e,r,n]),r}var he=function(){function e(){se(this,e),this._parent=null,this._child=null,this._transformer=null}var t,n,r,i=e.prototype;return i.attachTo=function(e){this._parent=e,this._parent.attachChild(this)},i.detach=function(){null!=this._parent?(this._parent.detachChild(this),this._parent=null):console.error("The input controller is not attached to parent!")},i.attachChild=function(e){this._child!==e&&(this._child=e,this.setDirty())},i.detachChild=function(e){this._child===e&&(this._child=null,this.setDirty())},i.transformStack=function(e){null!=this._transformer&&this._transformer(e),null!=this._child&&this._child.transformStack(e)},i.setDirty=function(){null!=this._parent&&this._parent.setDirty()},t=e,n=[{key:"transformer",get:function(){return this._transformer},set:function(e){this._transformer!==e&&(this._transformer=e,this.setDirty())}}],n&&ce(t.prototype,n),r&&ce(t,r),e}(),me=function(){function e(t,n){se(this,e),this.stack=t,this.onStackChanged=n,this._child=null}var t=e.prototype;return t.attachChild=function(e){this._child!==e&&(this._child=e,this.setDirty())},t.detachChild=function(e){this._child===e&&(this._child=null,this.setDirty())},t.transformStack=function(){},t.setDirty=function(){this.stack.clear(),null!=this._child&&this._child.transformStack(this.stack),this.onStackChanged()},e}();function pe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ve(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function ge(e){return function(e){if(Array.isArray(e))return pe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return pe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ye=function(){function e(){ve(this,e),this._items=[]}var t=e.prototype;return t.contains=function(e){return-1!==this.indexOf(e)},t.indexOf=function(e){return this._items.findIndex((function(t){return t.action===e}))},t.push=function(e,t){this._items=ge(this._items).concat([new be(e,t)])},t.removeWhere=function(e){this._items=this._items.filter((function(t){return!e(t.action)}))},t.clear=function(){this._items=[]},t.dispatchInputEvent=function(e,t){for(var n=this._items.length-1;n>=0;n--){var r=this._items[n];if(r.action===e)if(!1!==r.callback(t))return!0}return!1},t.debugPrint=function(){console.log("Input Stack:\n".concat(this._items.map((function(e){return e.action})).join("\n")))},e}(),be=function e(t,n){ve(this,e),this.action=t,this.callback=n};function xe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _e(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return xe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var je=function(t){var n=t.children,r=(0,i.useMemo)((function(){return new ye}),[]),o=C(ie),a=(0,i.useRef)(o);a.current=o;var l=_e((0,i.useState)([]),2),s=(l[0],l[1],(0,i.useCallback)((function(){for(var e=a.current,t=0;t<e.length;t++)le(t,r.indexOf(e[t]))}),[r]));(0,i.useEffect)((function(){s()}),[o,s]);var c=(0,i.useMemo)((function(){return new me(r,s)}),[r,s]);return(0,i.useEffect)((function(){var e=oe.subscribe((function(e){r.dispatchInputEvent(e.action,e.value)}));return function(){return e.dispose()}}),[r]),(0,i.useEffect)((function(){var e=ae.subscribe((function(e){r.dispatchInputEvent(e.action,e.value)}));return function(){return e.dispose()}}),[r]),(0,e.jsxs)(de.Provider,{value:c,children:[n,false]})},Ee=n(184),Oe=n.n(Ee);var Te=Symbol("FOCUS_DISABLED"),Ie=Symbol("FOCUS_AUTO"),Se=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.debugName=t,this.r=Math.floor(1e6*Math.random())}return e.prototype.toString=function(){return"".concat(this.debugName,":").concat(this.r)},e}();function we(e,t){return(0,i.useMemo)((function(){return e===Te?null:e===Ie?new Se(t):e}),[e,t])}function Ne(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Pe(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var Ce=function(){function e(){var t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],n=this;Ne(this,e),this.propagateCurrent=t,this._parentController=null,this._enabled=!1,this._focusKey=null,this._lastFocused=!1,this.callbacks=[],this.isChildFocused=function(e){return n.focused&&n.isChildFocusedImpl(e)},this.attachCallback=function(e){n.callbacks.includes(e)?console.error("".concat(n.constructor.name,": Focus callback already attached to controller!\n").concat(n.debugTrace())):(n.callbacks.push(e),n._lastFocused&&e(!0,n.propagateCurrent?n:null))},this.detachCallback=function(e){var t=n.callbacks.indexOf(e);-1!==t?(n.callbacks.splice(t,1),n._lastFocused&&e(!1,n.propagateCurrent?n:null)):console.error("".concat(n.constructor.name,": Focus callback not attached to controller!\n").concat(n.debugTrace()))},this.updateChildren=function(e){if(n._lastFocused){var t=!0,r=!1,i=void 0;try{for(var o,a=n.callbacks[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){(0,o.value)(!0,e)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}}},this.onFocusUpdate=function(e,t){var r=e&&n.focused;if(r!==n._lastFocused){n._lastFocused=r;var i=!0,o=!1,a=void 0;try{for(var l,s=n.callbacks[Symbol.iterator]();!(i=(l=s.next()).done);i=!0){(0,l.value)(n._lastFocused,n.propagateCurrent?t:null)}}catch(e){o=!0,a=e}finally{try{i||null==s.return||s.return()}finally{if(o)throw a}}r&&n.onFocusEnterImpl(t)}}}var t,n,r,i=e.prototype;return i.attachTo=function(e){null==this._parentController?(this._parentController=e,this._tryAttach()):console.error("".concat(this.constructor.name,": The controller has already been attached to a parent!\n").concat(this.debugTrace()))},i.detach=function(){null!=this._parentController?(this._tryDetach(),this._parentController=null):console.error("".concat(this.constructor.name,": The controller is not attached to parent!\n").concat(this.debugTrace()))},i.onFocusEnterImpl=function(e){},i._tryAttach=function(){this._enabled&&null!=this._parentController&&null!=this._focusKey&&(this._parentController.registerChild(this._focusKey,this),this._parentController.attachCallback(this.onFocusUpdate))},i._tryDetach=function(){this._enabled&&null!=this._parentController&&null!=this._focusKey&&(this._parentController.detachCallback(this.onFocusUpdate),this._parentController.unregisterChild(this._focusKey))},i.debugTrace=function(){var e="<-- ".concat(this.debugName);return null!=this._parentController&&(e+="\n",e+=this._parentController.debugTrace()),e},i.deepDebugTrace=function(){var e="--\x3e ".concat(this.debugName);return null!=this.debugFocusedChild&&(e+="\n",e+=this.debugFocusedChild.deepDebugTrace()),e},t=e,n=[{key:"focused",get:function(){return this._enabled&&null!=this._parentController&&null!=this._focusKey&&this._parentController.isChildFocused(this._focusKey)}},{key:"enabled",get:function(){return this._enabled},set:function(e){e!==this._enabled&&(this._tryDetach(),this._enabled=e,this._tryAttach())}},{key:"focusKey",get:function(){return this._focusKey},set:function(e){e!==this._focusKey&&(this._tryDetach(),this._focusKey=e,this._tryAttach())}},{key:"debugName",get:function(){var e,t;return null!==(t=null===(e=this._focusKey)||void 0===e?void 0:e.toString())&&void 0!==t?t:"<no-key>"}}],n&&Pe(t.prototype,n),r&&Pe(t,r),e}();function Ae(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function Le(e){return Le=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},Le(e)}function Me(e,t){return!t||"object"!==ke(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function Re(e,t){return Re=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},Re(e,t)}var ke=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function De(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=Le(e);if(t){var i=Le(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return Me(this,n)}}var Ue,Fe=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Re(e,t)}(o,e);var t,n,r,i=De(o);function o(e){var t;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(t=i.call(this)).childFocusKey=null,t.childElement=null,t.isChildFocusedImpl=function(e){return e===t.childFocusKey},t.registerChild=function(e,n){null==t.childFocusKey?(t.childFocusKey=e,t.childElement=n,t.enabled=!0):console.error("Cannot register second focus key '".concat(e,"'! KeyFocusControllers can only host a single child.\nRegistered key: ").concat(t.childFocusKey,"\n").concat(t.debugTrace()))},t.unregisterChild=function(e){t.childFocusKey===e?(t.enabled=!1,t.childFocusKey=null,t.childElement=null):console.error("Attempted to unregister mismatching focus key '".concat(e,"' from a KeyFocusController!\nRegistered key: ").concat(t.childFocusKey,"\n").concat(t.debugTrace()))},t.getBounds=function(){var e,n;return null!==(n=null===(e=t.childElement)||void 0===e?void 0:e.getBounds())&&void 0!==n?n:null},t.focusKey=e,t}return o.prototype.getFocusedBounds=function(){var e,t;return null!==(t=null===(e=this.childElement)||void 0===e?void 0:e.getFocusedBounds())&&void 0!==t?t:null},t=o,(n=[{key:"debugFocusedChild",get:function(){return this.childElement}}])&&Ae(t.prototype,n),r&&Ae(t,r),o}(Ce);!function(e){e.Always="always",e.AnyChildren="anyChildren",e.FocusedChild="focusedChild"}(Ue||(Ue={}));var Ge=i.createContext({isChildFocused:function(){return!0},registerChild:function(){},unregisterChild:function(){},attachCallback:function(e){return e(!0,null)},detachCallback:function(e){return e(!1,null)},attachTo:function(){},detach:function(){},getBounds:function(){return null},getFocusedBounds:function(){return null},debugTrace:function(){return"<-- ROOT"},deepDebugTrace:function(){return"ROOT"}}),Ve={isChildFocused:function(){return!1},registerChild:function(){},unregisterChild:function(){},attachCallback:function(){},detachCallback:function(){},attachTo:function(){},detach:function(){},getBounds:function(){return null},getFocusedBounds:function(){return null},debugTrace:function(){return"<-- DISABLED"},deepDebugTrace:function(){return"ROOT"}},Be=function(t){var n=t.controller,r=t.children,o=(0,i.useContext)(Ge);return(0,i.useEffect)((function(){n.attachTo(o)}),[n,o]),(0,i.useLayoutEffect)((function(){return function(){return n.detach()}}),[n,o]),(0,e.jsx)(Ge.Provider,{value:n,children:r})},He=function(t){var n=t.focusKey,r=void 0===n?Ie:n,o=t.children,a=function(e){return(0,i.useMemo)((function(){return new Fe(e)}),[e])}(we(r,"FocusKeyOverride"));return(0,e.jsx)(Be,{controller:a,children:o})};function Ke(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function We(e){return We=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},We(e)}function ze(e,t){return!t||"object"!==Xe(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function Ye(e,t){return Ye=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},Ye(e,t)}var Xe=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function qe(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=We(e);if(t){var i=We(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return ze(this,n)}}function $e(e,t){return(0,i.useMemo)((function(){return new Qe(e,t)}),[e,t])}var Qe=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Ye(e,t)}(n,e);var t=qe(n);function n(e,r){var i;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,n),(i=t.call(this)).activation=r,i.children=new Map,i._focusedChildKey=null,i.onRefocus=null,i.isChildFocusedImpl=function(e){return e===i._focusedChildKey&&i.children.has(i._focusedChildKey)},i.registerChild=function(e,t){i.children.has(e)?console.error("The focus key '".concat(String(e),"' has already been registered in this MultiChildFocusController!\n").concat(i.debugTrace())):(i.children.set(e,t),i.enabled||(i.activation===Ue.FocusedChild?i.enabled=i._focusedChildKey===e:i.activation===Ue.AnyChildren&&(i.enabled=!0)),!i.onRefocus||!i.focused||null!=i._focusedChildKey&&i.children.has(i._focusedChildKey)||i.onRefocus(null))},i.unregisterChild=function(e){var t=i.children.get(e);null!=t?(i.enabled&&(i.activation===Ue.FocusedChild?i.enabled=i._focusedChildKey!==e:i.activation===Ue.AnyChildren&&(i.enabled=i.children.size>0)),i.children.delete(e),i.onRefocus&&i.focused&&e===i.focusedChildKey&&i.onRefocus(t)):console.error("Attempted to unregister mismatching focus key '".concat(String(e),"' from a MultiChildFocusController!\n").concat(i.debugTrace()))},i.enabled=r===Ue.Always,i.focusKey=e,i}var r,i,o,a=n.prototype;return a.has=function(e){return this.children.has(e)},a.get=function(e){return this.children.get(e)},a.entries=function(){return this.children},a.getBounds=function(){var e=0,t=0,n=0,r=0,i=!1,o=!0,a=!1,l=void 0;try{for(var s,c=this.children.values()[Symbol.iterator]();!(o=(s=c.next()).done);o=!0){var u=s.value.getBounds();null!=u&&(i?(e=Math.min(u.left,e),t=Math.min(u.top,t),n=Math.max(u.right,n),r=Math.max(u.bottom,r)):(e=u.left,t=u.top,n=u.right,r=u.bottom,i=!0))}}catch(e){a=!0,l=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw l}}return i?{left:e,top:t,right:n,bottom:r,width:n-e,height:r-t}:null},a.getFocusedBounds=function(){if(null!=this._focusedChildKey){var e=this.children.get(this._focusedChildKey);if(null!=e)return e.getFocusedBounds()}return null},a.onFocusEnterImpl=function(e){null!=this.onRefocus&&this.onRefocus(e)},r=n,(i=[{key:"focusedChildKey",get:function(){return this._focusedChildKey},set:function(e){if(e!==this._focusedChildKey){var t=null!=this._focusedChildKey?this.children.get(this._focusedChildKey):void 0,n=null!=e&&this.children.has(e);n||(this.enabled=this.activation!==Ue.FocusedChild),this._focusedChildKey=e,n?this.enabled?this.updateChildren(null!=t?t:null):this.enabled=!0:(null!=this.onRefocus&&this.onRefocus(null!=t?t:null),null!=t&&this.updateChildren(null!=t?t:null))}}},{key:"debugFocusedChild",get:function(){var e;return null!=this._focusedChildKey&&null!==(e=this.children.get(this._focusedChildKey))&&void 0!==e?e:null}}])&&Ke(r.prototype,i),o&&Ke(r,o),n}(Ce),Ze=function(t){var n=t.focusKey,r=void 0===n?Ie:n,o=t.debugName,a=void 0===o?"FocusScope":o,l=t.focused,s=t.activation,c=void 0===s?Ue.FocusedChild:s,u=t.children,d=$e(we(r,a),c);return(0,i.useEffect)((function(){d.focusedChildKey=l}),[d,l]),(0,e.jsx)(Be,{controller:d,children:u})};function Je(e,t){return(0,i.useCallback)((function(n){et(e,n),et(t,n)}),[e,t])}function et(e,t){"function"==typeof e?e(t):null!=e&&(e.current=t)}var tt=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._callback=null}var t=e.prototype;return t.complete=function(){this._callback=null},t.cancel=function(){this._callback&&(this._callback(),this._callback=null)},t.onCancel=function(e){this._callback&&this._callback(),this._callback=e},e}();var nt=-2147483648,rt=2147483647,it=-3402823e32,ot=3402823e32;function at(e,t,n){return e<=t?t:e>=n?n:e}function lt(e,t,n){return e+(t-e)*n}function st(e,t){var n=Math.pow(10,t);return Math.round((e+Number.EPSILON)*n)/n}var ct={x:0,y:0};function ut(e,t){return e.x===t.x&&e.y===t.y}function dt(e,t,n){return{x:e.x+(t.x-e.x)*n,y:e.y+(t.y-e.y)*n}}function ft(e){return{x:Math.trunc(e.x),y:Math.trunc(e.y)}}function ht(e){return Math.sqrt(function(e){return e.x*e.x+e.y*e.y}(e))}function mt(e,t){var n=e.x,r=e.y;return"(".concat(st(n,t),", ").concat(st(r,t),")")}function pt(e){return{x:e.clientX,y:e.clientY}}function vt(e,t){var n=e.x,r=e.y,i=e.z;return"(".concat(st(n,t),", ").concat(st(r,t),", ").concat(st(i,t),")")}function gt(e,t){var n=e.x,r=e.y,i=e.z,o=e.w;return"(".concat(st(n,t),", ").concat(st(r,t),", ").concat(st(i,t),", ").concat(st(o,t),")")}function yt(e,t){return e.min===t.min&&e.max===t.max}var bt,xt=[0,0];function _t(e,t){return e[0]===t[0]&&e[1]===t[1]}function jt(e){return BigInt(e[1])<<32n|BigInt(e[0])}function Et(e){return[Number(0xffffffffn&e),Number(e>>32n&0xffffffffn)]}function Ot(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Tt(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function It(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function St(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Tt(e,t,n[t])}))}return e}function wt(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Nt(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ot(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ot(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Pt(e){if(!It(e,Element))return 0;var t=window.getComputedStyle(e),n=t.transitionDuration.split(/,\s?/),r=t.transitionDelay.split(/,\s?/);if(n.length<=1&&r.length<=1)return Mt(Lt(n,0))+Mt(Lt(r,0));for(var i=0,o=Math.max(n.length,r.length),a=0;a<o;a++){var l=Mt(Lt(n,a)),s=Mt(Lt(r,a));i=Math.max(i,l+s)}return i}function Ct(e,t){if(!It(e,Element))return null;var n=window.getComputedStyle(e),r=n.transitionProperty.split(/,\s?/),i=n.transitionDuration.split(/,\s?/),o=n.transitionDelay.split(/,\s?/),a=n.transitionTimingFunction.split(/,(?![^(]*\))\s?/),l=r.indexOf(t);if(-1===l)return null;var s=function(e){if(null==e)return null;if("linear"===e)return[0,0,1,1];if("ease"===e)return[.25,.1,.25,1];if("ease-in"===e)return[.42,0,1,1];if("ease-out"===e)return[0,0,.58,1];if("ease-in-out"===e)return[.42,0,.58,1];var t=e.match(/^cubic-bezier\((-?[0-9]*\.?[0-9]*),\s?(-?[0-9]*\.?[0-9]*),\s?(-?[0-9]*\.?[0-9]*),\s?(-?[0-9]*\.?[0-9]*)\)$/);if(null!=t)return[parseFloat(t[1]),parseFloat(t[2]),parseFloat(t[3]),parseFloat(t[4])];return null}(Lt(a,l));return null==s?null:{duration:Mt(Lt(i,l)),delay:Mt(Lt(o,l)),timingFunction:s}}function At(e,t,n){if(!It(e,Element))return{};var r=window.getComputedStyle(e),i=r.transitionProperty.split(/,\s?/),o=r.transitionDuration.split(/,\s?/),a=r.transitionDelay.split(/,\s?/),l=r.transitionTimingFunction.split(/,(?![^(]*\))\s?/),s=i.indexOf(t);return-1===s?{}:{transitionProperty:r.transitionProperty,transitionDuration:i.map((function(e,t){var r;return t===s?n.duration+"ms":null!==(r=Lt(o,t))&&void 0!==r?r:"0ms"})).join(", "),transitionDelay:i.map((function(e,t){var r;return t===s?n.delay+"ms":null!==(r=Lt(a,t))&&void 0!==r?r:"0ms"})).join(", "),transitionTimingFunction:i.map((function(e,t){var r,i,o,a,c,u,d;return t===s?(i=n.timingFunction,o=Nt(i,4),a=o[0],c=o[1],u=o[2],d=o[3],"cubic-bezier(".concat(a,", ").concat(c,", ").concat(u,", ").concat(d,")")):null!==(r=Lt(l,t))&&void 0!==r?r:"ease"})).join(", ")}}function Lt(e,t){return 1===e.length?e[0]:e.length>t?e[t]:void 0}function Mt(e){if(null==e)return 0;if(e.endsWith("ms")){var t=parseFloat(e.substr(0,e.length-2));return isNaN(t)?0:t}if(e.endsWith("s")){var n=1e3*parseFloat(e.substr(0,e.length-1));return isNaN(n)?0:n}var r=parseFloat(e);return isNaN(r)?0:r}function Rt(e,t){var n=Nt(e,4),r=n[0],i=n[1],o={x:n[2],y:n[3]},a=dt({x:r,y:i},o,t),l=dt(o,{x:1,y:1},t),s=dt(a,l,t);return[s.x,s.y,l.x,l.y]}function kt(e,t){return new Promise((function(n,r){var i=window.setTimeout((function(){t.complete(),n(!0)}),e);t.onCancel((function(){window.clearTimeout(i),n(!1)}))}))}function Dt(e){return new Promise((function(t,n){var r=window.requestAnimationFrame((function(n){e.complete(),t(!0)}));e.onCancel((function(){window.cancelAnimationFrame(r),t(!1)}))}))}function Ut(e){return i.isValidElement(e)}!function(e){e[e.in=0]="in",e[e.enter=1]="enter",e[e.exit=2]="exit"}(bt||(bt={}));var Ft={state:bt.in,onMount:function(){},onUnmount:function(){}},Gt=i.createContext(Ft),Vt=i.createContext(!1);function Bt(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Ht(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function Kt(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Wt(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Kt(e,t,n[t])}))}return e}function zt(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Yt(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Bt(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Bt(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Xt=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},qt={},$t=function(t){var n=t.styles,r=t.enterDuration,o=t.exitDuration,a=t.children;if(!Ut(a))throw new Error("ClassNameTransition requires a single child react element!");var l=null!=n?n:qt,s=(0,i.useContext)(Gt),c=s.state,u=s.onMount,d=s.onUnmount,f=(0,i.useRef)(null),h=Je(a.ref,f),m=(0,i.useRef)(!1),p=Yt((0,i.useState)(function(e,t){switch(e){case bt.enter:return t.enter;case bt.exit:return t.exit;default:return null}}(c,l)),2),v=p[0],g=p[1],y=(0,i.useCallback)((function(e){m.current&&g(e)}),[]),b=(0,i.useRef)(v);return b.current=v,(0,i.useEffect)((function(){return m.current||(m.current=!0,u()),function(){m.current&&(m.current=!1,d())}}),[u,d]),(0,i.useEffect)((function(){var e,t=new tt;return(e=function(){return Xt(this,(function(e){switch(e.label){case 0:return c!==bt.enter?[3,5]:(y(l.enter),[4,Dt(t)]);case 1:return e.sent()?[4,Dt(t)]:[2];case 2:return e.sent()?(y(l.enterActive),[4,Dt(t)]):[2];case 3:return e.sent()?[4,kt(null!=r?r:Pt(f.current),t)]:[2];case 4:return e.sent()?(y(null),[3,11]):[2];case 5:return c!==bt.exit?[3,11]:null!=b.current?[3,8]:(y(l.exit),[4,Dt(t)]);case 6:return e.sent()?[4,Dt(t)]:[2];case 7:if(!e.sent())return[2];e.label=8;case 8:return y(l.exitActive),[4,Dt(t)];case 9:return e.sent()?[4,kt(null!=o?o:Pt(f.current),t)]:[2];case 10:if(!e.sent())return[2];m.current&&(m.current=!1,d()),e.label=11;case 11:return[2]}}))},function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){Ht(o,r,i,a,l,"next",e)}function l(e){Ht(o,r,i,a,l,"throw",e)}a(void 0)}))})(),function(){t.cancel(),y(null)}}),[r,o,d,c,l.enter,l.enterActive,l.exit,l.exitActive,y]),(0,e.jsx)(Gt.Provider,{value:Ft,children:i.cloneElement(a,zt(Wt({},a.props),{ref:h,className:Oe()(a.props.className,l.base,v)}))})};var Qt,Zt="audio";function Jt(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1;null!=e&&N(Zt,"playSound",e,t)}!function(e){e.selectItem="select-item",e.dragSlider="drag-slider",e.hoverItem="hover-item",e.expandPanel="expand-panel",e.grabSlider="grabSlider",e.selectDropdown="select-dropdown",e.selectToggle="select-toggle",e.focusInputField="focus-input-field",e.signatureBuildingEvent="signature-building-event",e.bulldoze="bulldoze",e.bulldozeEnd="bulldoze-end",e.relocateBuilding="relocate-building",e.mapTilePurchaseMode="map-tile-purchase-mode",e.mapTilePurchaseModeEnd="map-tile-purchase-mode-end",e.xpEvent="xp-event",e.milestoneEvent="milestone-event",e.economy="economy",e.chirpEvent="chirp-event",e.likeChirp="like-chirp",e.chirper="chirper",e.purchase="purchase",e.enableBuilding="enable-building",e.disableBuilding="disable-building",e.pauseSimulation="pause-simulation",e.resumeSimulation="resume-simulation",e.simulationSpeed1="simulation-speed-1",e.simulationSpeed2="simulation-speed-2",e.simulationSpeed3="simulation-speed-3",e.togglePolicy="toggle-policy",e.takeLoan="take-loan",e.removeItem="remove-item",e.toggleInfoMode="toggle-info-mode",e.takePhoto="take-photo",e.tutorialTriggerCompleteEvent="tutorial-trigger-complete-event",e.selectRadioNetwork="select-radio-network",e.selectRadioStation="select-radio-station",e.generateRandomName="generate-random-name",e.decreaseElevation="decrease-elevation",e.increaseElevation="increase-elevation",e.selectPreviousItem="select-previous-item",e.selectNextItem="select-next-item",e.openPanel="open-panel",e.closePanel="close-panel",e.openMenu="open-menu",e.closeMenu="close-menu"}(Qt||(Qt={}));var en={enter:Qt.openPanel,exit:Qt.closePanel},tn={enter:Qt.openMenu,exit:Qt.closeMenu};function nn(e){var t=(0,i.useContext)(Gt).state;(0,i.useEffect)((function(){t===bt.enter?Jt(null==e?void 0:e.enter):t===bt.exit&&Jt(null==e?void 0:e.exit)}),[t,null==e?void 0:e.enter,null==e?void 0:e.exit])}function rn(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function on(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function an(e,t,n){return an="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var r=fn(e,t);if(r){var i=Object.getOwnPropertyDescriptor(r,t);return i.get?i.get.call(n):i.value}},an(e,t,n||e)}function ln(e){return ln=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},ln(e)}function sn(e,t){return!t||"object"!==hn(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function cn(e,t,n,r){return cn="undefined"!=typeof Reflect&&Reflect.set?Reflect.set:function(e,t,n,r){var i,o=fn(e,t);if(o){if((i=Object.getOwnPropertyDescriptor(o,t)).set)return i.set.call(r,n),!0;if(!i.writable)return!1}if(i=Object.getOwnPropertyDescriptor(r,t)){if(!i.writable)return!1;i.value=n,Object.defineProperty(r,t,i)}else!function(e,t,n){t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n}(r,t,n);return!0},cn(e,t,n,r)}function un(e,t,n,r,i){if(!cn(e,t,n,r||e)&&i)throw new Error("failed to set property");return n}function dn(e,t){return dn=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},dn(e,t)}function fn(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=ln(e)););return e}var hn=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function mn(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=ln(e);if(t){var i=ln(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return sn(this,n)}}function pn(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=(0,i.useMemo)((function(){return new vn}),[]);return(0,i.useEffect)((function(){r.debugName=e}),[r,e]),(0,i.useEffect)((function(){r.childFocused=n}),[r,n]),(0,i.useEffect)((function(){r.enabled=t}),[r,t]),r}var vn=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&dn(e,t)}(o,e);var t,n,r,i=mn(o);function o(){var e;return rn(this,o),(e=i.apply(this,arguments)).childElement=null,e._childFocused=!1,e._debugName="PassThroughFocusController",e.isChildFocusedImpl=function(t){return e._childFocused&&t===e.focusKey},e.registerChild=function(t,n){null==e.focusKey?(e.childElement=n,e.focusKey=t):console.error("Cannot register second focus key '".concat(t,"'! PassThroughFocusControllers can only host a single child.\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace()))},e.unregisterChild=function(t){e.focusKey===t?(e.focusKey=null,e.childElement=null):console.error("Attempted to unregister mismatching focus key '".concat(t,"' from a PassThroughFocusController!\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace(),")"))},e.getBounds=function(){var t,n;return null!==(n=null===(t=e.childElement)||void 0===t?void 0:t.getBounds())&&void 0!==n?n:null},e}return o.prototype.getFocusedBounds=function(){var e,t;return null!==(t=null===(e=this.childElement)||void 0===e?void 0:e.getFocusedBounds())&&void 0!==t?t:null},t=o,n=[{key:"enabled",get:function(){return an(ln(o.prototype),"enabled",this)},set:function(e){un(ln(o.prototype),"enabled",e,this,!0)}},{key:"childFocused",get:function(){return this._childFocused},set:function(e){e!==this._childFocused&&(this._childFocused=e,this.updateChildren(this))}},{key:"debugName",get:function(){return this._debugName},set:function(e){this._debugName=e}},{key:"debugFocusedChild",get:function(){return this.childElement}}],n&&on(t.prototype,n),r&&on(t,r),o}(Ce);function gn(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yn(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gn(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gn(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function bn(e){var t=yn((0,i.useState)(!1),2),n=t[0],r=t[1];return(0,i.useEffect)((function(){return e.attachCallback(r),function(){return e.detachCallback(r)}}),[e]),n}function xn(e,t){(0,i.useEffect)((function(){if(null!=t)return e.attachCallback(t),function(){return e.detachCallback(t)}}),[t,e])}function _n(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jn(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function En(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return _n(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _n(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var On,Tn=i.memo((function(t){var n=t.actions,r=t.disabled,o=t.children,a=pn("InputActionConsumer"),l=bn(a),s=(0,i.useCallback)((function(e){if(null!=n)for(var t=Object.entries(n),r=t.length-1;r>=0;r--){var i=En(t[r],2),o=i[0],a=i[1];null!=a&&e.push(o,a)}}),[n]),c=fe(l,r?null:s);return(0,e.jsx)(Be,{controller:a,children:(0,e.jsx)(de.Provider,{value:c,children:o})})}),(function(e,t){e.actions;var n=jn(e,["actions"]);t.actions;return f(n,jn(t,["actions"]))&&f(e.actions,t.actions)})),In=function(t){var n=t.disabled,r=t.children,o=t.onAction,a=(0,i.useMemo)((function(){return{Select:o}}),[o]);return(0,e.jsx)(Tn,{actions:a,disabled:n,children:r})},Sn=function(t){var n=t.expanded,r=t.expandable,o=t.disabled,a=t.children,l=t.onAction,s=(0,i.useMemo)((function(){return function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({},n?"Collapse Group":"Expand Group",r?l:null)}),[r,n,l]);return(0,e.jsx)(Tn,{actions:s,disabled:o,children:a})},wn=function(t){var n=t.disabled,r=t.children,o=t.onAction,a=(0,i.useMemo)((function(){return{Back:o}}),[o]);return(0,e.jsx)(Tn,{actions:a,disabled:n,children:r})};function Nn(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Pn(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Nn(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Nn(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Cn(e,t,n){var r=Number.MAX_VALUE,i=null,o=!0,a=!1,l=void 0;try{for(var s,c=e.entries()[Symbol.iterator]();!(o=(s=c.next()).done);o=!0){var u=Pn(s.value,2),d=u[0],f=Ln(u[1].getBounds(),n);if(null!=f){var h=f.x-t.x,m=f.y-t.y,p=h*h+m*m;p<r&&(r=p,i=d)}}}catch(e){a=!0,l=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw l}}return i}!function(e){e.Horizontal="horizontal",e.Vertical="vertical",e.Both="both",e.None="none"}(On||(On={}));var An={x:.5,y:.5};function Ln(e,t){return null!=e?{x:e.left*(1-t.x)+e.right*t.x,y:e.top*(1-t.y)+e.bottom*t.y}:null}var Mn=function(t){var n=t.focusKey,r=void 0===n?Ie:n,o=t.debugName,a=void 0===o?"NavigationScope":o,l=t.focused,s=t.direction,c=void 0===s?On.Both:s,u=t.activation,d=void 0===u?Ue.AnyChildren:u,f=t.children,h=t.onChange,m=t.onRefocus,p=$e(we(r,a),d);(0,i.useEffect)((function(){p.focusedChildKey=l}),[p,l]),(0,i.useEffect)((function(){if(null!=m)return!p.focused||null!=p.focusedChildKey&&p.has(p.focusedChildKey)||h(m(p,null)),p.onRefocus=function(e){h(m(p,e))},function(){p.onRefocus=null}}),[p,h,m]);var v=(0,i.useCallback)((function(e){var t=null!==p.focusedChildKey&&p.get(p.focusedChildKey);if(null===p.focusedChildKey||!t){var n=Cn(p,ct,An);return null!=n&&(h(n),!0)}var r={x:.5+.5*e.x,y:.5-.5*e.y},i=Ln(t.getFocusedBounds(),r);if(null!=i){var o=function(e,t,n,r,i){var o=null,a=Number.MAX_VALUE,l=!0,s=!1,c=void 0;try{for(var u,d=e.entries()[Symbol.iterator]();!(l=(u=d.next()).done);l=!0){var f=Pn(u.value,2),h=f[0],m=f[1];if(h!==i){var p=m.getBounds();if(null!=p){var v=Ln(p,r);if(null!=v){var g=v.x-t.x,y=v.y-t.y;if(!(g*n.x-y*n.y<=0)){var b={x:at(t.x,p.left,p.right),y:at(t.y,p.top,p.bottom)},x=b.x-t.x,_=b.y-t.y,j=x*n.x-_*n.y,E=_*n.x+x*n.y,O=1*j+5*Math.abs(E);O<a&&(o=h,a=O)}}}}}}catch(e){s=!0,c=e}finally{try{l||null==d.return||d.return()}finally{if(s)throw c}}return o}(p,i,e,An,p.focusedChildKey);return null!=o&&(h(o),!0)}}),[p,h]),g=c===On.Both||c===On.Horizontal,y=c===On.Both||c===On.Vertical,b=(0,i.useMemo)((function(){return{"Move Horizontal":g?function(e){return v({x:e,y:0})}:null,"Move Vertical":y?function(e){return v({x:0,y:e})}:null}}),[g,y,v]);return(0,e.jsx)(Tn,{actions:b,children:(0,e.jsx)(Be,{controller:p,children:f})})};function Rn(e,t){return null!=e.focusedChildKey&&e.has(e.focusedChildKey)?e.focusedChildKey:kn(e,t)}function kn(e,t){if(null==t&&null!=e.focusedChildKey&&e.has(e.focusedChildKey))return e.focusedChildKey;var n,r=ct;null!=t&&(r=null!==(n=Ln(t.getFocusedBounds(),An))&&void 0!==n?n:ct);return Cn(e,r,An)}function Dn(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Un(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Dn(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Dn(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Fn=function(t){var n=t.focusKey,r=void 0===n?Ie:n,o=t.initialFocused,a=t.direction,l=t.activation,s=t.children,c=t.onRefocus,u=void 0===c?kn:c,d=Un((0,i.useState)(null!=o?o:null),2),f=d[0],h=d[1];return(0,e.jsx)(Mn,{focusKey:r,focused:f,direction:a,activation:l,debugName:"AutoNavigationScope",onChange:h,onRefocus:u,children:s})};function Gn(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Vn(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Gn(e,t,n[t])}))}return e}function Bn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Hn(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Kn=i.createContext(null),Wn=function(t){var n=t.children;if(!Ut(n))throw new Error("DOMNodeProvider requires a single child react element!");var r=(0,i.useContext)(Kn),o=Je(n.ref,null==r?void 0:r.ref),a=Vn({},n.props.style,null==r?void 0:r.style),l=Oe()(n.props.className,null==r?void 0:r.className),s=Bn(Vn({},n.props),{className:l,style:a,ref:o});return(0,e.jsx)(Kn.Provider,{value:null,children:i.cloneElement(n,s)})},zn=i.memo(i.forwardRef((function(t,n){var r=t.style,o=t.className,a=t.children;if(!Ut(a))throw new Error("DOMNodeModifier requires a single child react element!");var l,s=(0,i.useContext)(Kn),c=(0,i.useMemo)((function(){return{ref:function(e){et(a.ref,e),et(n,e),null!=(null==s?void 0:s.ref)&&s.ref(e)},style:Vn({},null==s?void 0:s.style,r),className:Oe()(null==s?void 0:s.className,o)}}),[a.ref,o,s,n,r]);return(0,e.jsx)(Kn.Provider,{value:c,children:(l=a,"object"!=typeof l||"function"!=typeof l.type?(0,e.jsx)(Wn,{children:a}):a)})})),(function(e,t){var n=e.style,r=Hn(e,["style"]),i=t.style;return f(r,Hn(t,["style"]))&&f(n,i)}));var Yn,Xn,qn="input";!function(e){e[e.keyboardAndMouse=0]="keyboardAndMouse",e[e.gamepad=1]="gamepad"}(Yn||(Yn={})),function(e){e[e.Xbox=0]="Xbox",e[e.PS=1]="PS"}(Xn||(Xn={}));var $n=E(qn,"mouseOverUI",!0),Qn=E(qn,"controlScheme",Yn.gamepad),Zn=E(qn,"gamepadPointerPosition"),Jn=E(qn,"cameraMoving",!1),er=I(qn,"cameraBarrier"),tr=I(qn,"toolBarrier"),nr=E(qn,"hints"),rr=w(qn,"onInputHintPerformed"),ir=T(qn,"tutorialHints"),or=E(qn,"gamepadType"),ar=w(qn,"setActiveTextFieldRect"),lr=E(qn,"useTextFieldInputBarrier");function sr(e,t){return t===Yn.keyboardAndMouse}function cr(){return A(Qn,ur,!1)}function ur(e,t){return t===Yn.gamepad}var dr=i.createContext({scrollTo:function(){},scrollBy:function(){},smoothScrollTo:function(){},scrollIntoView:function(){},updateThumbs:function(){}});function fr(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function hr(e){return hr=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},hr(e)}function mr(e,t){return!t||"object"!==vr(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function pr(e,t){return pr=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},pr(e,t)}var vr=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function gr(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=hr(e);if(t){var i=hr(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return mr(this,n)}}function yr(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:Ue.Always,r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=(0,i.useCallback)((function(){var e;return(null===(e=t.current)||void 0===e?void 0:e.getBoundingClientRect())||null}),[t]),a=(0,i.useMemo)((function(){return new br(e,o,n,r)}),[e,o,n,r]),l=(0,i.useContext)(dr),s=L(Qn);return xn(a,(0,i.useCallback)((function(e){e&&s.current===Yn.gamepad&&null!=t.current&&l.scrollIntoView(t.current)}),[s,t,l])),a}var br=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&pr(e,t)}(o,e);var t,n,r,i=gr(o);function o(e,t,n,r){var a;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(a=i.call(this)).getBounds=t,a.activation=n,a.allowChildren=r,a.childFocusKey=null,a.childElement=null,a.isChildFocusedImpl=function(e){return e===a.childFocusKey},a.registerChild=function(e,t){a.allowChildren?null==a.childFocusKey?(a.childFocusKey=e,a.childElement=t,a.activation!==Ue.Always&&(a.enabled=!0)):console.error("Cannot register second child '".concat(e,"'. This focus node can only host a single child!\nRegistered key: ").concat(a.childFocusKey,"\n").concat(a.debugTrace())):console.error("".concat(a.focusKey,": Cannot register child '").concat(e,"'. Children are not allowed in this focus node!"))},a.unregisterChild=function(e){a.childFocusKey===e?(a.childFocusKey=null,a.childElement=null,a.activation!==Ue.Always&&(a.enabled=!1)):console.error("Attempted to unregister mismatching focus key '".concat(e,"'!\nRegistered key: ").concat(a.childFocusKey,"\n").concat(a.debugTrace()))},a.enabled=a.activation===Ue.Always,a.focusKey=e,a}return o.prototype.getFocusedBounds=function(){var e,t;return null!==(t=null===(e=this.childElement)||void 0===e?void 0:e.getFocusedBounds())&&void 0!==t?t:this.getBounds()},t=o,(n=[{key:"debugFocusedChild",get:function(){return this.childElement}}])&&fr(t.prototype,n),r&&fr(t,r),o}(Ce);function xr(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _r(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xr(e,t,n[t])}))}return e}function jr(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Er(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Or=i.forwardRef((function(t,n){var r=t.className,o=t.focusSound,a=t.children,l=t.onFocusChange,s=Er(t,["className","focusSound","children","onFocusChange"]),c=pn("PassiveFocusDiv");xn(c,l);var u=bn(c),d=cr();return(0,i.useEffect)((function(){u&&d&&Jt(o)}),[o,u,d]),(0,e.jsx)(Be,{controller:c,children:(0,e.jsx)(Wn,{children:(0,e.jsx)("div",jr(_r({},s),{ref:n,className:Oe()(r,u&&d&&"focused"),children:a}))})})})),Tr=i.forwardRef((function(t,n){var r=t.focusKey,o=void 0===r?Ie:r,a=t.debugName,l=void 0===a?"ActiveFocusDiv":a,s=t.activation,c=void 0===s?Ue.Always:s,u=t.focusSound,d=t.className,f=t.children,h=t.onFocusChange,m=Er(t,["focusKey","debugName","activation","focusSound","className","children","onFocusChange"]),p=(0,i.useRef)(null),v=Je(n,p),g=yr(we(o,l),p,c,!0);xn(g,h);var y=bn(g),b=cr();return(0,i.useEffect)((function(){y&&b&&Jt(u)}),[u,y,b]),(0,e.jsx)(Be,{controller:g,children:(0,e.jsx)(Wn,{children:(0,e.jsx)("div",jr(_r({},m),{ref:v,className:Oe()(d,y&&b&&"focused"),children:f}))})})}));function Ir(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function Sr(e){return Sr=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},Sr(e)}function wr(e,t){return!t||"object"!==Pr(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function Nr(e,t){return Nr=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},Nr(e,t)}var Pr=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function Cr(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=Sr(e);if(t){var i=Sr(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return wr(this,n)}}var Ar=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Nr(e,t)}(o,e);var t,n,r,i=Cr(o);function o(){var e;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(e=i.call(this,!1)).childElement=null,e.isChildFocusedImpl=function(t){return t===e.focusKey},e.registerChild=function(t,n){null==e.focusKey?(e.focusKey=t,e.childElement=n):console.error("Cannot register second focus key '".concat(t,"'! RootFocusControllers can only host a single child.\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace()))},e.unregisterChild=function(t){e.focusKey===t?(e.focusKey=null,e.childElement=null):console.error("Attempted to unregister mismatching focus key '".concat(t,"' from a RootFocusController!\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace(),")"))},e.getBounds=function(){return null},e.enabled=!0,e}return o.prototype.getFocusedBounds=function(){return null},t=o,(n=[{key:"debugName",get:function(){return"<root>"}},{key:"debugFocusedChild",get:function(){return this.childElement}}])&&Ir(t.prototype,n),r&&Ir(t,r),o}(Ce),Lr=function(t){var n=t.children,r=(0,i.useMemo)((function(){return new Ar}),[]);return(0,e.jsx)(Be,{controller:r,children:n})};function Mr(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,n=(0,i.useRef)(e);return f(e,n.current,t)||(n.current=e),n.current}function Rr(e){var t=!0,n=!1,r=void 0;try{for(var i,o=Object.values(e)[Symbol.iterator]();!(t=(i=o.next()).done);t=!0){var a=i.value;(new Image).src=a.replaceAll('"',"")}}catch(e){n=!0,r=e}finally{try{t||null==o.return||o.return()}finally{if(n)throw r}}return e}const kr={closeIcon:'"Media/Glyphs/Close.svg"',toggleIcon:'"Media/Glyphs/ThickStrokeArrowRight.svg"',toggleIconExpanded:'"Media/Glyphs/ThickStrokeArrowDown.svg"',panel:"panel_YqS",header:"header_Bpo child-opacity-transition_nkS",content:"content_AD7 child-opacity-transition_nkS",footer:"footer_pD5 child-opacity-transition_nkS","title-bar":"title-bar_PF4",titleBar:"title-bar_PF4",title:"title_zQN",icon:"icon_OVK","icon-space":"icon-space_h_f",iconSpace:"icon-space_h_f","close-button":"close-button_wKK",closeButton:"close-button_wKK",toggle:"toggle_Q44"};Rr([kr.closeIcon,kr.toggleIcon,kr.toggleIconExpanded]);var Dr=i.createContext({theme:kr}),Ur=i.createContext({expanded:!0,toggleExpanded:function(){},theme:kr});function Fr(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Gr(e){return(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Fr(e,t,n[t])}))}return e}({},kr,e)}),[e])}const Vr={header:"header_H_U header_Bpo child-opacity-transition_nkS",content:"content_XD5 content_AD7 child-opacity-transition_nkS",footer:"footer_Pa9 footer_pD5 child-opacity-transition_nkS",title:"title_SVH title_zQN"},Br={enter:"enter__zh enter_kO6","enter-active":"enter-active_YAb enter-active_lrI",enterActive:"enter-active_YAb enter-active_lrI",exit:"exit_KiP exit_Von","exit-active":"exit-active_g0a exit-active_jtN",exitActive:"exit-active_g0a exit-active_jtN"};function Hr(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Kr(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Hr(e,t,n[t])}))}return e}function Wr(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function zr(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Yr=new Se("PanelHeader"),Xr=new Se("PanelContent"),qr=new Se("PanelFooter"),$r=i.forwardRef((function(t,n){var r=t.focusKey,o=t.header,a=t.footer,l=t.theme,s=void 0===l?Vr:l,c=t.transition,u=void 0===c?Br:c,d=t.transitionSounds,f=t.className,h=t.contentClassName,m=t.children,p=t.onClose,v=t.allowFocusExit,g=zr(t,["focusKey","header","footer","theme","transition","transitionSounds","className","contentClassName","children","onClose","allowFocusExit"]);nn(d);var y=Gr(s),b=i.Children.count(o)>0,x=i.Children.count(m)>0,_=i.Children.count(a)>0,j=(0,i.useMemo)((function(){return{theme:y,onClose:p}}),[y,p]),E=(0,e.jsx)(wn,{onAction:p,children:(0,e.jsx)(Dr.Provider,{value:j,children:(0,e.jsx)($t,{styles:u,children:(0,e.jsx)(Tr,Wr(Kr({ref:n,focusKey:r,className:Oe()(y.panel,f)},g),{children:(0,e.jsxs)(Fn,{initialFocused:Xr,children:[b&&(0,e.jsx)(He,{focusKey:Yr,children:(0,e.jsx)("div",{className:y.header,children:o})}),x&&(0,e.jsx)(He,{focusKey:Xr,children:(0,e.jsx)("div",{className:Oe()(y.content,h),children:m})}),_&&(0,e.jsx)(He,{focusKey:qr,children:(0,e.jsx)("div",{className:y.footer,children:a})})]})}))})})});return v?E:(0,e.jsx)(Lr,{children:E})}));const Qr={header:"header_jAe header_Bpo child-opacity-transition_nkS",content:"content_VBF content_AD7 child-opacity-transition_nkS",footer:"footer_CZr footer_pD5 child-opacity-transition_nkS",title:"title_ctd title_zQN"};function Zr(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,i.useEffect)((function(){if(!e){var t=er.subscribe((function(){}));return function(){return null==t?void 0:t.dispose()}}}),[e])}function Jr(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,i.useEffect)((function(){if(!e){var t=tr.subscribe((function(){}));return function(){return null==t?void 0:t.dispose()}}}),[e])}function ei(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ti(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function ni(e,t){if(null==e)return!1;var n=e.__Type;return"string"==typeof n&&(n===t||n.startsWith(t+","))}function ri(e,t){return ti(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ei(e,t,n[t])}))}return e}({},e),{__Type:t})}var ii=ri({index:0,version:0},"Unity.Entities.Entity"),oi=E("infoviews","infoviews"),ai=E("infoviews","activeInfoview");function li(e){N("infoviews","setActiveInfoview",e)}function si(){li(ii)}var ci=E("electricityInfo","electricityConsumption"),ui=E("electricityInfo","electricityProduction"),di=(E("electricityInfo","electricityTransmitted"),E("electricityInfo","electricityExport")),fi=E("electricityInfo","electricityImport"),hi=E("electricityInfo","electricityAvailability"),mi=(E("electricityInfo","electricityTransmission"),E("electricityInfo","electricityTrade")),pi=E("electricityInfo","batteryCharge"),vi=E("waterInfo","waterCapacity"),gi=E("waterInfo","waterConsumption"),yi=E("waterInfo","sewageCapacity"),bi=E("waterInfo","sewageConsumption"),xi=E("waterInfo","waterExport"),_i=E("waterInfo","waterImport"),ji=E("waterInfo","sewageExport"),Ei=E("waterInfo","sewageAvailability"),Oi=E("waterInfo","waterAvailability"),Ti=E("waterInfo","waterTrade"),Ii=E("educationInfo","elementaryEligible"),Si=E("educationInfo","highSchoolEligible"),wi=E("educationInfo","collegeEligible"),Ni=E("educationInfo","universityEligible"),Pi=E("educationInfo","elementaryCapacity"),Ci=E("educationInfo","highSchoolCapacity"),Ai=E("educationInfo","collegeCapacity"),Li=E("educationInfo","universityCapacity"),Mi=E("educationInfo","educationData"),Ri=E("educationInfo","elementaryStudentCount"),ki=E("educationInfo","highSchoolStudentCount"),Di=E("educationInfo","collegeStudentCount"),Ui=E("educationInfo","universityStudentCount"),Fi=E("educationInfo","elementaryAvailability"),Gi=E("educationInfo","highSchoolAvailability"),Vi=E("educationInfo","collegeAvailability"),Bi=E("educationInfo","universityAvailability"),Hi=E("transportInfo","summaries"),Ki=E("healthcareInfo","averageHealth"),Wi=E("healthcareInfo","cemeteryUse"),zi=E("healthcareInfo","cemeteryCapacity"),Yi=E("healthcareInfo","deathRate"),Xi=E("healthcareInfo","processingRate"),qi=E("healthcareInfo","sickCount"),$i=E("healthcareInfo","patientCount"),Qi=E("healthcareInfo","patientCapacity"),Zi=E("healthcareInfo","healthcareAvailability"),Ji=E("healthcareInfo","deathcareAvailability"),eo=E("healthcareInfo","cemeteryAvailability"),to=E("garbageInfo","processingRate"),no=E("garbageInfo","capacity"),ro=E("garbageInfo","processingAvailability"),io=E("garbageInfo","landfillAvailability"),oo=E("garbageInfo","productionRate"),ao=E("garbageInfo","storedGarbage"),lo=E("roadsInfo","parkingCapacity"),so=E("roadsInfo","parkingIncome"),co=E("roadsInfo","parkedCars"),uo=E("roadsInfo","parkingAvailability"),fo=E("trafficInfo","trafficFlow"),ho=E("pollutionInfo","averageGroundPollution"),mo=E("pollutionInfo","averageAirPollution"),po=E("pollutionInfo","averageWaterPollution"),vo=E("pollutionInfo","averageNoisePollution"),go=E("fireAndRescueInfo","averageFireHazard"),yo=E("policeInfo","averageCrimeProbability"),bo=E("policeInfo","jailAvailability"),xo=E("policeInfo","prisonAvailability"),_o=(E("policeInfo","crimeProducers"),E("policeInfo","crimeProbability"),E("policeInfo","jailCapacity")),jo=E("policeInfo","arrestedCriminals"),Eo=E("policeInfo","inJail"),Oo=E("policeInfo","prisonCapacity"),To=E("policeInfo","prisoners"),Io=E("policeInfo","inPrison"),So=E("policeInfo","criminals"),wo=E("policeInfo","crimePerMonth"),No=E("policeInfo","escapedRate"),Po=E("landValueInfo","averageLandValue"),Co=E("levelInfo","residential"),Ao=E("levelInfo","commercial"),Lo=E("levelInfo","industrial"),Mo=E("levelInfo","office"),Ro=E("disasterInfo","shelteredCount"),ko=E("disasterInfo","shelterCapacity"),Do=E("disasterInfo","shelterAvailability"),Uo=E("tourismInfo","attractiveness"),Fo=E("tourismInfo","averageHotelPrice"),Go=E("tourismInfo","tourismRate"),Vo=E("tourismInfo","weatherEffect"),Bo=E("postInfo","mailProductionRate"),Ho=E("postInfo","collectedMail"),Ko=E("postInfo","deliveredMail"),Wo=E("postInfo","postServiceAvailability"),zo=E("populationInfo","population"),Yo=E("populationInfo","employed"),Xo=E("populationInfo","jobs"),qo=E("populationInfo","unemployment"),$o=E("populationInfo","birthRate"),Qo=E("populationInfo","movedIn"),Zo=E("populationInfo","movedAway"),Jo=E("populationInfo","ageData"),ea=E("companyInfoview","commercialProfitability"),ta=E("companyInfoview","industrialProfitability"),na=E("companyInfoview","officeProfitability"),ra=E("outsideInfo","topImportNames"),ia=E("outsideInfo","topImportColors"),oa=E("outsideInfo","topImportData"),aa=E("outsideInfo","topExportNames"),la=E("outsideInfo","topExportColors"),sa=E("outsideInfo","topExportData"),ca=E("naturalResourceInfo","availableOil"),ua=E("naturalResourceInfo","availableOre"),da=E("naturalResourceInfo","availableForest"),fa=E("naturalResourceInfo","availableFertility"),ha=E("naturalResourceInfo","oilExtractionRate"),ma=E("naturalResourceInfo","oreExtractionRate"),pa=E("naturalResourceInfo","forestExtractionRate"),va=E("naturalResourceInfo","fertilityExtractionRate"),ga=E("naturalResourceInfo","forestRenewalRate"),ya=E("naturalResourceInfo","fertilityRenewalRate"),ba=E("workplaces","workplacesData"),xa=E("workplaces","employeesData"),_a=E("workplaces","workplaces"),ja=E("workplaces","employees");function Ea(e){var t=C(ai),n=C(oi),r=(0,i.useMemo)((function(){return n.find((function(t){return t.id===e}))}),[e,n]),o=(0,i.useMemo)((function(){return!!r&&c(r.entity,null==t?void 0:t.entity)}),[null==t?void 0:t.entity,r]),a=(0,i.useMemo)((function(){return!r||r.locked}),[r]),l=(0,i.useCallback)((function(){r&&li(o?ii:r.entity)}),[r,o]);if(!a&&r)return l}var Oa,Ta="game";!function(e){e[e.main=0]="main",e[e.freeCamera=1]="freeCamera",e[e.pauseMenu=10]="pauseMenu",e[e.saveGame=11]="saveGame",e[e.newGame=12]="newGame",e[e.loadGame=13]="loadGame",e[e.options=14]="options"}(Oa||(Oa={}));var Ia,Sa=E(Ta,"activeScreen"),wa=w(Ta,"setActiveScreen"),Na=E(Ta,"canUseSaveSystem");function Pa(){wa(Oa.main)}function Ca(){wa(Oa.pauseMenu)}function Aa(){wa(Oa.freeCamera)}!function(e){e[e.Undefined=0]="Undefined",e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=3]="Right"}(Ia||(Ia={}));var La,Ma,Ra=E(Ta,"activePanel"),ka=E(Ta,"blockingPanelActive"),Da=E(Ta,"activePanelPosition"),Ua=w(Ta,"togglePanel"),Fa=w(Ta,"showPanel"),Ga=w(Ta,"closePanel"),Va=S(Ta,"closeActivePanel");!function(e){e.InfoviewMenu="Game.UI.InGame.InfoviewMenu",e.Progression="Game.UI.InGame.ProgressionPanel",e.Economy="Game.UI.InGame.EconomyPanel",e.CityInfo="Game.UI.InGame.CityInfoPanel",e.Statistics="Game.UI.InGame.StatisticsPanel",e.TransportationOverview="Game.UI.InGame.TransportationOverviewPanel",e.Chirper="Game.UI.InGame.ChirperPanel",e.LifePath="Game.UI.InGame.LifePathPanel",e.Journal="Game.UI.InGame.JournalPanel",e.Radio="Game.UI.InGame.RadioPanel",e.PhotoMode="Game.UI.InGame.PhotoModePanel",e.CinematicCamera="Game.UI.InGame.CinematicCameraPanel",e.Notifications="Game.UI.InGame.NotificationsPanel"}(La||(La={})),function(e){e[e.Development=0]="Development",e[e.Milestones=1]="Milestones",e[e.Achievements=2]="Achievements"}(Ma||(Ma={}));var Ba,Ha=w(Ta,"showProgressionPanel");!function(e){e[e.Budget=0]="Budget",e[e.Loan=1]="Loan",e[e.Taxation=2]="Taxation",e[e.Services=3]="Services",e[e.Production=4]="Production"}(Ba||(Ba={}));var Ka,Wa=w(Ta,"showEconomyPanel");!function(e){e[e.Demand=0]="Demand",e[e.Policies=1]="Policies"}(Ka||(Ka={}));var za,Ya=w(Ta,"showCityInfoPanel"),Xa=w(Ta,"showTransportationOverviewPanel");function qa(){Fa(La.LifePath)}!function(e){e[e.PublicTransport=0]="PublicTransport",e[e.Cargo=1]="Cargo"}(za||(za={}));var $a=w(Ta,"showLifePathDetail");function Qa(){Ua(La.Radio)}function Za(){Ua(La.TransportationOverview)}const Ja="panel-backdrop_HbC";var el=function(t){var n=t.className,r=t.children,o=t.onMouseDown,a=C(Sa);Jr(),Zr(a===Oa.freeCamera);var l=(0,i.useCallback)((function(e){e.target===e.currentTarget&&o&&o()}),[o]);return(0,e.jsx)("div",{className:Oe()(Ja,n),onMouseDown:l,children:r})};const tl=function(e){return e.currentTarget.src="Media/Placeholder.svg"},nl="tinted-icon_iKo";function rl(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function il(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){rl(e,t,n[t])}))}return e}function ol(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function al(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var ll=i.forwardRef((function(t,n){var r=t.src,i=t.className,o=t.style,a=al(t,["src","className","style"]);return(0,e.jsx)("div",ol(il({},a),{ref:n,className:Oe()(r&&nl,i),style:ol(il({},o),{maskImage:r?"url(".concat(r,")"):void 0})}))}));function sl(e,t,n){if(e.current){var r=window.getComputedStyle(e.current).getPropertyValue(t),i=window.getComputedStyle(e.current).getPropertyValue(n);r&&"none"!==r&&i&&(e.current.style.animation="",window.requestAnimationFrame((function(){return window.requestAnimationFrame((function(){e.current&&(e.current.style.animationName=r,e.current.style.animationDuration=i)}))})))}}function cl(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ul(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){cl(e,t,n[t])}))}return e}function dl(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function fl(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var hl={select:Qt.selectItem,hover:Qt.hoverItem,focus:Qt.hoverItem},ml=i.forwardRef((function(t,n){var r=t.focusKey,o=t.debugName,a=void 0===o?"Button":o,l=t.selected,s=t.disabled,c=t.theme,u=t.sounds,d=void 0===u?hl:u,f=t.selectAction,h=void 0===f?"Select":f,m=t.selectSound,p=t.className,v=t.onClick,g=t.onMouseEnter,y=t.onSelect,b=t.children,x=fl(t,["focusKey","debugName","selected","disabled","theme","sounds","selectAction","selectSound","className","onClick","onMouseEnter","onSelect","children"]),_=(0,i.useRef)(null),j=Je(n,_),E=yr(we(null!=r?r:s?Te:Ie,a),_),O=bn(E),T=cr(),I=(0,i.useMemo)((function(){return void 0!==m?dl(ul({},d),{select:m}):d}),[m,d]),S=(0,i.useMemo)((function(){return null!=y?cl({},h,(function(){sl(_,"--selectAnimation","--selectDuration"),Jt(null==I?void 0:I.select),y()})):null}),[y,h,null==I?void 0:I.select]),w=(0,i.useCallback)((function(e){(y||v)&&(s||Jt(null==I?void 0:I.select),y&&y(),v&&v(e),e.stopPropagation())}),[s,v,y,null==I?void 0:I.select]),N=(0,i.useCallback)((function(e){s||Jt(null==I?void 0:I.hover),g&&g(e)}),[s,null==I?void 0:I.hover,g]);return(0,i.useEffect)((function(){O&&T&&Jt(null==I?void 0:I.focus)}),[O,T,null==I?void 0:I.focus]),(0,e.jsx)(Tn,{actions:S,disabled:s,children:(0,e.jsx)(Be,{controller:E,children:(0,e.jsx)(Wn,{children:(0,e.jsx)("button",dl(ul({},x),{ref:j,disabled:s,className:Oe()(null==c?void 0:c.button,l&&"selected",O&&T&&"focused",p),onClick:w,onMouseEnter:N,children:b}))})})})}));const pl={button:"button_M6C",icon:"icon_PhD"};function vl(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function gl(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){vl(e,t,n[t])}))}return e}function yl(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function bl(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var xl=i.forwardRef((function(t,n){var r=t.src,o=t.tinted,a=t.theme,l=t.className,s=t.children,c=bl(t,["src","tinted","theme","className","children"]),u=(0,i.useMemo)((function(){return gl({},pl,a)}),[a]);return(0,e.jsxs)(ml,yl(gl({ref:n},c),{className:Oe()(u.button,l),theme:u,children:[o?(0,e.jsx)(ll,{src:r,className:u.icon}):(0,e.jsx)("img",{src:r,className:u.icon,onError:tl}),s]}))}));const _l={button:"button_bvQ"};function jl(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function El(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Ol(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Tl=function(t){var n=t.icon,r=t.theme,o=t.className,a=t.children,l=t.onCloseOverride,s=Ol(t,["icon","theme","className","children","onCloseOverride"]),c=(0,i.useContext)(Dr),u=cr(),d=null!=l?l:c.onClose,f=!u&&null!=d,h=null!=r?r:c.theme;return(0,e.jsxs)("div",El(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){jl(e,t,n[t])}))}return e}({},s),{className:Oe()(h.titleBar,o),children:[null!=n?(0,e.jsx)("img",{src:n,className:h.icon}):f&&(0,e.jsx)("div",{className:h.iconSpace}),(0,e.jsx)("div",{className:h.title,children:a}),f?(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:h.closeIcon,theme:_l,className:h.closeButton,onSelect:d}):null!=n&&(0,e.jsx)("div",{className:h.iconSpace})]}))};const Il={dialog:"dialog_E8_",wide:"wide_XFu",row:"row_L6K","pdx-title":"pdx-title_qXw",pdxTitle:"pdx-title_qXw","pdx-button-row":"pdx-button-row_Dor",pdxButtonRow:"pdx-button-row_Dor",message:"message_SFv row_L6K","error-message":"error-message_r4_",errorMessage:"error-message_r4_",paragraphs:"paragraphs_MnN paragraphs_nbD",buttons:"buttons_lZi row_L6K",button:"button_gJo",footer:"footer_Q7P row_L6K","footer-label":"footer-label_AHF",footerLabel:"footer-label_AHF","buttons-vertical":"buttons-vertical_Zha row_L6K",buttonsVertical:"buttons-vertical_Zha row_L6K","button-ok":"button-ok_IS9 button_gJo",buttonOk:"button-ok_IS9 button_gJo","error-dialog":"error-dialog_iaV",errorDialog:"error-dialog_iaV","icon-layout":"icon-layout_cZT row_L6K",iconLayout:"icon-layout_cZT row_L6K",icon:"icon_JQd","main-column":"main-column_Jzk",mainColumn:"main-column_Jzk","error-details":"error-details_RaN row_L6K",errorDetails:"error-details_RaN row_L6K",content:"content_Aju","copy-button":"copy-button_V8I",copyButton:"copy-button_V8I"};function Sl(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function wl(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||Pl(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Nl(e){return function(e){if(Array.isArray(e))return Sl(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||Pl(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Pl(e,t){if(e){if("string"==typeof e)return Sl(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Sl(e,t):void 0}}var Cl,Al=function(t){var n=t.wide,r=t.title,i=t.buttons,o=t.theme,a=void 0===o?Qr:o,l=t.onClose,s=t.children;return(0,e.jsx)(el,{children:(0,e.jsxs)($r,{theme:a,header:r&&(0,e.jsx)(Tl,{children:r}),className:Oe()(Il.dialog,n&&Il.wide),onClose:l,children:[(0,e.jsx)("div",{className:Il.message,children:s}),i]})})},Ll=new Se("CHILDREN_KEY"),Ml=new Se("DIALOG_KEY"),Rl=i.createContext({showDialog:function(){},closeAll:function(){}}),kl=i.createContext({onClose:function(){}}),Dl=function(t){var n=t.children,r=wl((0,i.useState)([]),2),o=r[0],a=r[1],l=(0,i.useMemo)((function(){return{showDialog:function(e){return a((function(t){return Nl(t).concat([e])}))},closeAll:function(){return a([])}}}),[]),s=(0,i.useMemo)((function(){return{onClose:function(){return a((function(e){return e.slice(0,e.length-1)}))}}}),[]);return(0,e.jsx)(Rl.Provider,{value:l,children:(0,e.jsxs)(Ze,{focused:o.length>0?Ml:Ll,children:[(0,e.jsx)(He,{focusKey:Ll,children:n}),(0,e.jsx)(He,{focusKey:Ml,children:(0,e.jsx)(kl.Provider,{value:s,children:o.length>0&&o[o.length-1]})})]})})};function Ul(e,t){return e.replace(/{((?!\d)[\w$]+)}/g,(function(e,n){var r=t[n];return"string"==typeof r?r:e}))}!function(e){e.ButtonWithConfirmation="Game.UI.Menu.ButtonWithConfirmation",e.InputBindingField="Game.UI.Menu.InputBindingField",e.ModdingToolchainButton="Game.UI.Menu.ModdingToolchainButton",e.ScreenResolutionDropdownField="Game.UI.Menu.ScreenResolutionDropdownField",e.DropdownField="Game.UI.Widgets.DropdownField"}(Cl||(Cl={}));var Fl,Gl,Vl,Bl,Hl="options",Kl=E(Hl,"pages"),Wl=E(Hl,"children"),zl=E(Hl,"activePage"),Yl=E(Hl,"activeSection"),Xl=E(Hl,"displayConfirmationVisible"),ql=E(Hl,"displayConfirmationTime"),$l=E(Hl,"interfaceStyle"),Ql=E(Hl,"interfaceTransparency"),Zl=E(Hl,"interfaceScaling",!0),Jl=E(Hl,"textScale"),es=E(Hl,"unlockHighlightsEnabled"),ts=E(Hl,"chirperPopupsEnabled"),ns=E(Hl,"inputHintsType"),rs=(E(Hl,"radioVolume"),E(Hl,"progress")),is=E(Hl,"progressType"),os=E(Hl,"moddingToolState"),as=E(Hl,"buttonState"),ls=E(Hl,"unitSettings");function ss(e){N(e.group,"rebindInput",e.path)}function cs(e){N(e.group,"unsetInputBinding",e.path)}function us(e,t){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];N(Hl,"selectPage",e,t,n)}function ds(e,t){N(Hl,"filteredWidgets",e,t||null)}!function(e){e[e.Off=0]="Off",e[e.Bar=1]="Bar",e[e.Spin=2]="Spin"}(Fl||(Fl={})),function(e){e[e.AutoDetect=0]="AutoDetect",e[e.Xbox=1]="Xbox",e[e.PS=2]="PS"}(Gl||(Gl={})),function(e){e[e.Idle=0]="Idle",e[e.Downloading=1]="Downloading",e[e.Installing=2]="Installing",e[e.WaitingForLicense=3]="WaitingForLicense",e[e.WaitingForClose=4]="WaitingForClose",e[e.Updating=5]="Updating",e[e.Uninstalling=6]="Uninstalling",e[e.NotEnoughSpaceError=7]="NotEnoughSpaceError",e[e.DownloadError=8]="DownloadError",e[e.InstallError=9]="InstallError",e[e.GetLicenseError=10]="GetLicenseError",e[e.CloseError=11]="CloseError",e[e.DeployError=12]="DeployError",e[e.UnistallError=13]="UnistallError"}(Vl||(Vl={})),function(e){e[e.Install=0]="Install",e[e.Uninstall=1]="Uninstall",e[e.Update=2]="Update",e[e.Repair=3]="Repair",e[e.Cancel=4]="Cancel"}(Bl||(Bl={}));var fs,hs,ms,ps=S(Hl,"confirmDisplay"),vs=S(Hl,"revertDisplay");!function(e){e[e.TwentyFourHours=0]="TwentyFourHours",e[e.TwelveHours=1]="TwelveHours"}(fs||(fs={})),function(e){e[e.Celsius=0]="Celsius",e[e.Fahrenheit=1]="Fahrenheit",e[e.Kelvin=2]="Kelvin"}(hs||(hs={})),function(e){e[e.Metric=0]="Metric",e[e.Freedom=1]="Freedom"}(ms||(ms={}));var gs={timeFormat:fs.TwentyFourHours,temperatureUnit:hs.Celsius,unitSystem:ms.Metric},ys=i.createContext({translate:function(){return null},unitSettings:gs});function bs(){var e=(0,i.useContext)(ys),t=(0,i.useRef)(!0);return t.current=!0,(0,i.useMemo)((function(){var n=new Map;return{translate:function(r,i){var o=n.get(r);return void 0===o&&(t.current&&(t.current=!1,n.clear()),o=e.translate(r,i),n.set(r,o)),o},unitSettings:e.unitSettings}}),[e])}function xs(e){var t=bs(),n=function(e,t){var n=(0,i.useRef)(e);return t(e,n.current)||(n.current=e),n.current}(e,js);return(0,i.useMemo)((function(){return _s(t,n)}),[t,n])}function _s(e,t,n){return null==t?"":(0,i.isValidElement)(t)?Es(t.type)?t.type.renderString(e,t.props):function(e){return e.type===i.Fragment}(t)?i.Children.toArray(t.props.children).map((function(t){return _s(e,t,n)})).join(n):"[".concat((r=t.type,null!==(a=null!==(o=r.displayName)&&void 0!==o?o:r.name)&&void 0!==a?a:String(r)),"/]"):String(t);var r,o,a}function js(e,t){return(0,i.isValidElement)(e)&&(0,i.isValidElement)(t)&&Es(e.type)&&Es(t.type)?e.type.propsAreEqual(e.props,t.props):Object.is(e,t)}function Es(e){return"function"==typeof e.renderString&&"function"==typeof e.propsAreEqual}function Os(t,n,r){var o=function(t){var r=bs(),o=(0,i.useMemo)((function(){return n(r,t)}),[r,t]);return(0,e.jsx)(e.Fragment,{children:o})};return Object.assign((0,i.memo)(o,r),{displayName:t,renderString:n,propsAreEqual:r})}function Ts(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Is(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ts(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ts(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ss=Os("LocalizedString",(function(e,t){return ws(e,t.id,t.fallback,t.args)}),(function(e,t){return e.id===t.id&&e.fallback===t.fallback&&function(e,t){if(Object.is(e,t))return!0;if(null==e||null==t)return e===t;var n=Object.keys(e),r=Object.keys(t);if(n.length!==r.length)return!1;return n.every((function(n){return Object.prototype.hasOwnProperty.call(t,n)&&js(e[n],t[n])}))}(e.args,t.args)}));function ws(e,t,n,r){var i,o=null!=t?null!==(i=e.translate(t,n))&&void 0!==i?i:t:null!=n?n:"";if(null!=r){var a=function(e,t){return Object.fromEntries(Object.entries(t).map((function(t){var n=Is(t,2),r=n[0],i=n[1];return[r,_s(e,i)]})))}(e,r);return Ul(o,a)}return o}function Ns(e,t,n){return!!Object.is(t,n)||e.every((function(e){return js(t[e],n[e])}))}const Ps="theme-icon_YTM",Cs="icon_QMC";var As=function(t){var n=t.src,r=t.className;return(0,e.jsx)("div",{className:Oe()(Ps,r),children:(0,e.jsx)("img",{src:n,className:Cs})})};function Ls(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Ms(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Rs(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function ks(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ls(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ls(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Ds(e,t){var n=Object.entries(t).map((function(t){var n=ks(t,2),r=n[0],i=n[1],o="".concat(e,".").concat(r);return[r,Os(o,i.create(o),i.propsAreEqual.bind(i))]}));return Object.fromEntries(n)}var Us,Fs,Gs=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Ms(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.fallback,i=Rs(n,["fallback"]);return ws(t,e,r,i)}},t.propsAreEqual=function(e,t){return void 0!==e&&void 0!==t?Ns(this.argNames,e,t):e===t},e}(),Vs=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Ms(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.hash,i=n.fallback,o=Rs(n,["hash","fallback"]);return ws(t,"".concat(e,"[").concat(r,"]"),i,o)}},t.propsAreEqual=function(e,t){return e.hash===t.hash&&Ns(this.argNames,e,t)},e}(),Bs=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Ms(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.index,i=n.fallback,o=Rs(n,["index","fallback"]);return ws(t,"".concat(e,":").concat(r),i,o)}},t.propsAreEqual=function(e,t){return e.index===t.index&&Ns(this.argNames,e,t)},e}(),Hs=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Ms(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.hash,i=n.index,o=n.fallback,a=Rs(n,["hash","index","fallback"]);return ws(t,"".concat(e,"[").concat(r,"]:").concat(i),o,a)}},t.propsAreEqual=function(e,t){return e.hash===t.hash&&e.index===t.index&&Ns(this.argNames,e,t)},e}(),Ks=(Us={Achievements:{DESCRIPTION:new Vs,TITLE:new Vs},AirPollutionInfoPanel:{AVERAGE_AIR_POLLUTION:new Gs},AnimationCurve:{TIME_LABEL:new Gs,VALUE_LABEL:new Gs},Asset:{DESCRIPTION:new Vs,NAME:new Vs},Assets:{ADDRESS_NAME_FORMAT:new Gs("NUMBER","ROAD"),ALLEY_NAME:new Bs,ANIMAL_NAME_DOG:new Bs,BIOME:new Vs,BRIDGE_NAME:new Bs,CITIZEN_NAME_FEMALE:new Bs,CITIZEN_NAME_FORMAT:new Gs("FIRST_NAME","LAST_NAME"),CITIZEN_NAME_MALE:new Bs,CITIZEN_SURNAME_FEMALE:new Bs,CITIZEN_SURNAME_HOUSEHOLD:new Bs,CITIZEN_SURNAME_MALE:new Bs,CITY_NAME:new Bs,CLIMATE:new Vs,DAM_NAME:new Bs,DESCRIPTION:new Vs,DISTRICT_NAME:new Bs,DISTRICT_NAME_NEW:new Gs,HIGHWAY_NAME:new Bs,NAME:new Vs,NAMED_ADDRESS_NAME_FORMAT:new Gs("NAME","NUMBER","ROAD"),ROUTE_NAME:new Vs("NUMBER"),STREET_NAME:new Bs,SUB_SERVICE_DESCRIPTION:new Vs,THEME:new Vs,UPGRADE_DESCRIPTION:new Vs,UPGRADE_NAME:new Vs},Budget:{TOOLTIP_DESCRIPTION:new Vs,TOOLTIP_DESCRIPTION_TAX:new Vs,TOOLTIP_DESCRIPTION_TAX_RATE:new Gs,TOOLTIP_TITLE:new Vs,TOOLTIP_TITLE_TAX:new Vs,TOOLTIP_TITLE_TAX_RATE:new Gs,TOOLTIP_UPKEEPS_PIECHART:new Gs},Chirper:{AIR_POLLUTION_HIGH:new Bs,AIR_POLLUTION_NEGATIVE:new Bs,AURORA_BOREALIS:new Bs,BIRTH_RATE_DOWN:new Bs,BIRTH_RATE_UP:new Bs,BRAND:new Hs,BRAND_RENTED_AGRICULTURE:new Bs("LINK_1"),BRAND_RENTED_BANK:new Bs("LINK_1"),BRAND_RENTED_BAR:new Bs("LINK_1"),BRAND_RENTED_FACTORY:new Bs("LINK_1"),BRAND_RENTED_FORESTRY:new Bs("LINK_1"),BRAND_RENTED_GAS_STATION:new Bs("LINK_1"),BRAND_RENTED_HOTEL:new Bs("LINK_1"),BRAND_RENTED_MINE:new Bs("LINK_1"),BRAND_RENTED_OFFICE:new Bs("LINK_1"),BRAND_RENTED_OIL:new Bs("LINK_1"),BRAND_RENTED_RESTAURANT:new Bs("LINK_1"),BRAND_RENTED_STORE:new Bs("LINK_1"),BRAND_RENTED_WAREHOUSE:new Bs("LINK_1"),CITY_SERVICE_EDUCATION_EXPORT:new Bs,CITY_SERVICE_EDUCATION_IMPORT:new Bs,CITY_SERVICE_ELECTRICITY_EXPORT:new Bs,CITY_SERVICE_ELECTRICITY_IMPORT:new Bs,CITY_SERVICE_FIRE_RESCUE_EXPORT:new Bs,CITY_SERVICE_FIRE_RESCUE_IMPORT:new Bs,CITY_SERVICE_GARBAGE_IMPORT:new Bs,CITY_SERVICE_HEALTHCARE_EXPORT:new Bs,CITY_SERVICE_HEALTHCARE_IMPORT:new Bs,CITY_SERVICE_POLICE_EXPORT:new Bs,CITY_SERVICE_POLICE_IMPORT:new Bs,CITY_SERVICE_POST_EXPORT:new Bs,CITY_SERVICE_POST_IMPORT:new Bs,CITY_SERVICE_WATER_SEWAGE_EXPORT:new Bs,CITY_SERVICE_WATER_SEWAGE_IMPORT:new Bs,COMMERCIAL_LEVEL_DOWN:new Bs,COMMERCIAL_LEVEL_UP:new Bs,CRIME_NEGATIVE:new Bs,CRIME_RATE_HIGH:new Bs,DIRTY_WATER:new Bs,ELECTRICITY_BLACKOUTS:new Bs,FIRST_POWER_PLANT:new Bs("LINK_TARGET_0"),GARBAGE_PILING_UP:new Bs,GOOD_EDUCATION_SERVICE:new Bs,GOOD_WELFARE_SERVICE_COVERAGE:new Bs,GROUND_POLLUTION_NEGATIVE:new Bs,HIGHEST_TEMP_15:new Bs,HIGHEST_TEMP_NEG_15:new Bs,HIGH_DEATH_RATE:new Bs,HOUSING_SHORTAGE:new Bs,INDUSTRIAL_LEVEL_DOWN:new Bs,INDUSTRIAL_LEVEL_UP:new Bs,LEISURE_TIME_NEGATIVE:new Bs,LEISURE_TIME_POSITIVE:new Bs,LOWEST_TEMP_15:new Bs,LOWEST_TEMP_20:new Bs,LOW_DEATH_RATE:new Bs,LOW_HEALTH:new Bs,LOW_NUMBER_OF_WORKERS:new Bs,LOW_WELLBEING:new Bs,MOSTLY_CLOUDY_WEATHER:new Bs,MOSTLY_RAINY_WEATHER:new Bs,MOSTLY_SNOWY_WEATHER:new Bs,MOSTLY_STORMY_WEATHER:new Bs,MOSTLY_SUNNY_WEATHER:new Bs,NOISE_POLLUTION:new Bs,NOISE_POLLUTION_NEGATIVE:new Bs,NO_ELECTRICITY:new Bs,NO_WATER:new Bs,NO_WATER_SERVICE:new Bs,OFFICE_LEVEL_DOWN:new Bs,OFFICE_LEVEL_UP:new Bs,OPENING_MESSAGE:new Gs,PANEL_TITLE:new Gs,PARK_COVERAGE:new Bs,POLICE_CRIME_RATE_HIGH:new Bs,POLICIES:new Hs,POLICIES_SERVICE:new Hs,POOR_EDUCATION_SERVICE:new Bs,RELIABLE_ELECTRICITY_SUPPLY:new Bs,RELIABLE_HEALTHCARE:new Bs,RELIABLE_INTERNET_SERVICE:new Bs,RELIABLE_POST_SERVICE:new Bs,RESIDENTIAL_LEVEL_DOWN:new Bs,RESIDENTIAL_LEVEL_UP:new Bs,SERVICES_CITIZEN:new Hs,SERVICES_COMMUNICATIONS:new Hs,SERVICES_ELECTRICITY:new Hs,SERVICES_GARBAGE:new Hs,SERVICES_ROADS:new Hs,SERVICES_TRANSPORTATION:new Hs,SERVICES_WATER:new Hs,SEWAGE_NEGATIVE:new Bs,SMALL_HOME:new Bs,STORAGES_FILLING_UP:new Bs,TEMPERATURE_COLDER:new Bs,TOURISM_DOWN_20:new Bs,TOURISM_UP_20:new Bs,TRAFFIC_ACCIDENT_NEARBY:new Bs,TRAFFIC_JAMS:new Bs,UNCONNECTED_CITY:new Bs,UNEMPLOYMENT_RATE_HIGH:new Bs,UNPAID_LOAN:new Bs,UNRELIABLE_ELECTRICITY_SUPPLY:new Bs,UNRELIABLE_HEALTHCARE:new Bs,UNRELIABLE_INTERNET_SERVICE:new Bs,UNRELIABLE_POST_SERVICE:new Bs,VALENTINE_DAY:new Bs,WATER_NEGATIVE_SERVICE_COVERAGE:new Bs,WATER_POLLUTION_NEGATIVE:new Bs},CinematicCamera:{CAPTURE:new Gs,DELETE_DISCLAIMER:new Gs("NAME"),DELETE_KEY:new Gs,DELETE_TOOLTIP:new Gs,FOCAL_LENGTH:new Gs,HIDE_UI:new Gs,KEY_FORMAT:new Gs("KEY"),LOAD:new Gs,LOAD_TOOLTIP:new Gs,LOOP:new Gs,NEW_SEQUENCE_PLACEHOLDER:new Gs,OVERRIDE_DISCLAIMER:new Gs("NAME"),PLAYBACK_DURATION:new Gs,RESET_TOOLTIP:new Gs,SAVE:new Gs,SAVE_LOAD_TOOLTIP:new Gs,SAVE_TOOLTIP:new Gs,SEGMENT_DURATION:new Gs,SIMULATION_SPEED:new Gs,TITLE:new Gs,UNSAVED_DISCLAIMER:new Gs},CityInfoPanel:{DEMAND_DESCRIPTION:new Vs,DEMAND_FACTOR:new Vs,DEMAND_FACTOR_NEGATIVE:new Vs,DEMAND_FACTOR_POSITIVE:new Vs,DEMAND_TITLE:new Vs,HAPPINESS:new Gs,TAB:new Vs,TITLE:new Gs,TOOLTIP_DESCRIPTION_DEMAND:new Vs,TOOLTIP_HAPPINESS_DESCRIPTION:new Gs,TOOLTIP_HAPPINESS_TITLE:new Gs,TOOLTIP_POLICIES_DESCRIPTION:new Gs,TOOLTIP_POLICIES_TITLE:new Gs,TOOLTIP_TITLE_DEMAND:new Vs},Climate:{SEASON:new Vs},Common:{ACTION:new Vs,BOUNDS_CELSIUS:new Gs("MIN","MAX"),BOUNDS_FAHRENHEIT:new Gs("MIN","MAX"),BOUNDS_KELVIN:new Gs("MIN","MAX"),BOUNDS_KILOWATT:new Gs("MIN","MAX"),BOUNDS_MEGAWATT:new Gs("MIN","MAX"),BOUNDS_PERCENT:new Gs("MIN","MAX"),BOUNDS_TEMPERATURE:new Gs("MIN","MAX"),CANCEL:new Gs,CLEAR_SEARCH_TOOLTIP:new Gs,CLOSE:new Gs,CONFIRMATION:new Gs,CONTINUE:new Gs,DATE_TIME_FORMAT:new Gs("MONTH","YEAR","HOUR","MINUTE"),DECIMAL_SEPARATOR:new Gs,DELETE_TOOLTIP:new Gs,DIALOG_ACTION:new Vs,DIALOG_MESSAGE:new Vs,DIALOG_TITLE:new Vs,DISABLE:new Gs,DONT_SHOW_AGAIN:new Gs,ENABLE:new Gs,ERROR:new Gs,ERROR_DIALOG_CONTINUE:new Gs,ERROR_DIALOG_COPY_DETAILS:new Gs,ERROR_DIALOG_QUIT_GAME:new Gs,ERROR_DIALOG_SAVE_QUIT_GAME:new Gs,ERROR_DIALOG_TITLE:new Gs,EXIT_DIALOG_TEXT:new Gs,EXIT_DIALOG_TITLE:new Gs,EXIT_TO_DESKTOP:new Gs,EXIT_TO_MENU:new Gs,FOCUS:new Gs,FRACTION_BODIES_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_CUBIC_METER:new Gs("VALUE","TOTAL"),FRACTION_CUBIC_METER_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_GALLON:new Gs("VALUE","TOTAL"),FRACTION_GALLON_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_INTEGER:new Gs("VALUE","TOTAL"),FRACTION_INTEGER_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_KG:new Gs("VALUE","TOTAL"),FRACTION_KG_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_KILOWATT:new Gs("VALUE","TOTAL"),FRACTION_KILOWATT_HOURS:new Gs("VALUE","TOTAL"),FRACTION_MEGAWATT:new Gs("VALUE","TOTAL"),FRACTION_MEGAWATT_HOURS:new Gs("VALUE","TOTAL"),FRACTION_POUND:new Gs("VALUE","TOTAL"),FRACTION_POUND_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_SHORT_TON:new Gs("VALUE","TOTAL"),FRACTION_SHORT_TON_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_TON:new Gs("VALUE","TOTAL"),FRACTION_TON_PER_MONTH:new Gs("VALUE","TOTAL"),FRACTION_XP:new Gs("VALUE","TOTAL"),GO_BACK_TOOLTIP:new Gs,HAPPINESS_FACTORS:new Gs,HAPPINESS_FACTOR_NEGATIVE:new Vs,HAPPINESS_FACTOR_POSITIVE:new Vs,INFORMATION:new Gs,INFOVIEW_MENU_TOGGLE_TOOLTIP:new Gs,LANGUAGE_NAME:new Gs,LOCKED:new Gs,MEDIUM_DATE_FORMAT:new Gs("MONTH","YEAR"),MONTH:new Bs,MONTH_SHORT:new Bs,NO:new Gs,NONE:new Gs,OK:new Gs,PAUSE_MENU_TOGGLE_TOOLTIP:new Gs,SAVEABILITY_REASON:new Vs,SELECT:new Gs,SUBMIT:new Gs,THOUSANDS_SEPARATOR:new Gs,TIMESTAMP_FORMAT:new Gs,TIMESTAMP_FORMAT_12:new Gs,TIME_FORMAT:new Gs("HOUR","MINUTE"),TIME_FORMAT_12:new Gs("HOUR","MINUTE","PERIOD"),TIME_PERIOD_AM:new Gs,TIME_PERIOD_PM:new Gs,UNLOCKED:new Gs,VALUE_ACRE:new Gs("SIGN","VALUE"),VALUE_ANGLE:new Gs("SIGN","VALUE"),VALUE_BYTE:new Gs("SIGN","VALUE"),VALUE_CELSIUS:new Gs("SIGN","VALUE"),VALUE_CUBIC_METER:new Gs("SIGN","VALUE"),VALUE_CUBIC_METER_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_FAHRENHEIT:new Gs("SIGN","VALUE"),VALUE_FOOT:new Gs("SIGN","VALUE"),VALUE_GALLON:new Gs("SIGN","VALUE"),VALUE_GALLON_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_GIGABIT_PER_SECOND:new Gs("SIGN","VALUE"),VALUE_GIGABYTE:new Gs("SIGN","VALUE"),VALUE_KELVIN:new Gs("SIGN","VALUE"),VALUE_KG_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_KILOBYTE:new Gs("SIGN","VALUE"),VALUE_KILOGRAM:new Gs("SIGN","VALUE"),VALUE_KILOMETER:new Gs("SIGN","VALUE"),VALUE_KILOTON:new Gs("SIGN","VALUE"),VALUE_KILOWATT:new Gs("SIGN","VALUE"),VALUE_MEGABYTE:new Gs("SIGN","VALUE"),VALUE_MEGAWATT:new Gs("SIGN","VALUE"),VALUE_MEGAWATT_HOURS:new Gs("SIGN","VALUE"),VALUE_METER:new Gs("SIGN","VALUE"),VALUE_MILE:new Gs("SIGN","VALUE"),VALUE_MILLION:new Gs("SIGN","VALUE"),VALUE_MONEY:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_CELL:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_HOUR:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_KILOMETER:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_KILOMETER_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_MILE:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_MILE_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_MONEY_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_MONTH:new Gs("VALUE"),VALUE_MONTHS:new Gs("VALUE"),VALUE_PERCENT:new Gs("SIGN","VALUE"),VALUE_PER_HOUR:new Gs("SIGN","VALUE"),VALUE_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_PER_SQUARE_METER:new Gs("SIGN","VALUE"),VALUE_POUND:new Gs("SIGN","VALUE"),VALUE_POUND_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_SHORT_KILOTON:new Gs("SIGN","VALUE"),VALUE_SHORT_TON:new Gs("SIGN","VALUE"),VALUE_SHORT_TON_PER_CELL:new Gs("SIGN","VALUE"),VALUE_SHORT_TON_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_SQUARE_FOOT:new Gs("SIGN","VALUE"),VALUE_SQUARE_KILOMETER:new Gs("SIGN","VALUE"),VALUE_SQUARE_METER:new Gs("SIGN","VALUE"),VALUE_TEMPERATURE:new Gs("SIGN","VALUE"),VALUE_TERABYTE:new Gs("SIGN","VALUE"),VALUE_THOUSAND:new Gs("SIGN","VALUE"),VALUE_TON:new Gs("SIGN","VALUE"),VALUE_TON_PER_CELL:new Gs("SIGN","VALUE"),VALUE_TON_PER_MONTH:new Gs("SIGN","VALUE"),VALUE_XP:new Gs("SIGN","VALUE"),VALUE_YARD:new Gs("SIGN","VALUE"),VALUE_YEAR:new Gs("VALUE"),VALUE_YEARS:new Gs("VALUE"),WARNING:new Gs,YES:new Gs},CompanyInfoPanel:{COMMERCIAL_PROFITABILITY:new Gs,INDUSTRIAL_PROFITABILITY:new Gs,OFFICE_PROFITABILITY:new Gs},DisasterInfoPanel:{CAPACITY:new Gs,EVACUATED:new Gs,SHELTER_AVAILABILITY:new Gs},EconomyPanel:{BUDGET_BALANCE_LABEL:new Vs,BUDGET_ITEM:new Vs,BUDGET_ITEM_DESCRIPTION:new Vs,BUDGET_LOANS_BUTTON_ACCEPT:new Gs,BUDGET_LOANS_LABEL_AMOUNT:new Gs,BUDGET_LOANS_LABEL_CURRENT_INTEREST:new Gs,BUDGET_LOANS_LABEL_DAILY_INTEREST:new Gs,BUDGET_LOANS_LABEL_DAILY_PAYMENT:new Gs,BUDGET_LOANS_LABEL_DAYS_REMAINING:new Gs,BUDGET_LOANS_LABEL_GET_MORE:new Gs,BUDGET_LOANS_LABEL_NEW_LOAN:new Gs,BUDGET_LOANS_LABEL_PAY_BACK:new Gs,BUDGET_SUB_ITEM:new Vs,BUDGET_TITLE_LOANS:new Gs,EXPENSES_SECTION_TITLE:new Gs,INCOME_SECTION_TITLE:new Gs,LOAN_CHART_BUDGET_WARNING:new Gs,LOAN_CHART_BUDGET_WARNING_MODIFIED:new Gs,LOAN_CHART_DEFICIT:new Gs("TOTAL"),LOAN_CHART_LEGEND_EXPENSES:new Gs,LOAN_CHART_LEGEND_INCOME:new Gs,LOAN_CHART_LEGEND_LOAN_INTEREST:new Gs,LOAN_CHART_RELATIVE_COST:new Gs("RELATIVE_LOAN_COST"),LOAN_CHART_REMAINING_SURPLUS:new Gs("TOTAL"),LOAN_CHART_SURPLUS:new Gs("TOTAL"),LOAN_FORM_ACCEPT:new Gs,LOAN_FORM_LESS_LABEL:new Gs,LOAN_FORM_LIMIT:new Gs("LOAN_LIMIT"),LOAN_FORM_MORE_LABEL:new Gs,LOAN_FORM_RESET:new Gs,LOAN_PAGE_DESCRIPTION:new Gs,LOAN_PAGE_TITLE:new Gs,LOAN_TABLE_AMOUNT:new Gs,LOAN_TABLE_INTEREST_RATE:new Gs,LOAN_TABLE_MONTHLY_COST:new Gs,MONTHLY_BALANCE:new Gs,PRODUCTION_LABEL_EXPORT:new Gs,PRODUCTION_LABEL_IMPORT:new Gs,PRODUCTION_LABEL_INTERNAL:new Gs,PRODUCTION_LABEL_TOTAL:new Gs,PRODUCTION_PAGE_DEFICIT:new Gs,PRODUCTION_PAGE_EXPORT:new Gs,PRODUCTION_PAGE_IMPORT:new Gs,PRODUCTION_PAGE_PRODUCTION:new Gs,PRODUCTION_PAGE_PRODUCTIONLINK:new Vs,PRODUCTION_PAGE_SURPLUS:new Gs,PRODUCTION_TAB_IMMATERIAL:new Gs,PRODUCTION_TAB_MATERIAL:new Gs,PRODUCTION_TOOLTIP_COMMERCIAL_CONSUMPTION:new Gs,PRODUCTION_TOOLTIP_COMMERCIAL_WEALTH:new Gs,PRODUCTION_TOOLTIP_INDUSTRIAL_CONSUMPTION:new Gs,PRODUCTION_TOOLTIP_INDUSTRIAL_PRODUCTION:new Gs,PRODUCTION_TOOLTIP_INDUSTRIAL_WEALTH:new Gs,PRODUCTION_TOOLTIP_OFFICE_CONSUMPTION:new Gs,PRODUCTION_TOOLTIP_OFFICE_WEALTH:new Gs,RESOURCE_CATEGORY:new Vs,SERVICES_BUILDING_EMPLOYMENT_LABEL:new Gs,SERVICES_FEES_LABEL_DAILY_EXPENSES:new Gs,SERVICES_FEES_LABEL_DAILY_INCOME:new Gs,SERVICES_FEES_LABEL_EXPORT:new Gs,SERVICES_FEES_LABEL_FEES:new Gs,SERVICES_FEES_LABEL_IMPORT:new Gs,SERVICES_FEES_LABEL_SERVICE_FEE:new Gs,SERVICES_LABEL_TOTAL:new Gs,SERVICES_LABEL_UPKEEP:new Gs,SERVICES_LABEL_WAGES:new Gs,SERVICES_RESOURCE_FEE_CONSUMPTION:new Vs,SERVICES_RESOURCE_FEE_DESCRIPTION:new Vs,SERVICES_RESOURCE_FEE_EFFICIENCY:new Gs,SERVICES_RESOURCE_FEE_HAPPINESS:new Gs,SERVICES_RESOURCE_FEE_LABEL:new Vs,SERVICES_RESOURCE_LABEL:new Vs,SERVICES_TITLE_BUDGET:new Gs,SERVICES_TITLE_BUDGETS:new Gs,SERVICES_TITLE_BUILDINGS:new Gs,SERVICES_TITLE_EXPENSES:new Gs,SERVICES_TITLE_IMPORT_BUDGET:new Gs,SERVICES_TITLE_INCOME:new Gs,SERVICES_TITLE_INFO:new Gs,SERVICES_TITLE_QUALITY:new Gs,SERVICE_BUDGET_EFFICIENCY:new Gs,SERVICE_BUDGET_SLIDER_DESCRIPTION:new Vs,SERVICE_BUDGET_SLIDER_TITLE:new Vs,SERVICE_DESCRIPTION:new Vs,SERVICE_EXPORT_REVENUE_DESCRIPTION:new Gs,SERVICE_FEES_REVENUE_DESCRIPTION:new Gs,SERVICE_IMPORT_EXPENSE_DESCRIPTION:new Gs,SERVICE_UPKEEP_EXPENSE_DESCRIPTION:new Gs,TAB:new Vs,TAXATION_COMMERCIAL_TITLE:new Gs,TAXATION_INDUSTRIAL_TITLE:new Gs,TAXATION_OFFICE_TITLE:new Gs,TAXATION_RESIDENTIAL_LABEL_JOBLEVEL:new Gs,TAXATION_RESIDENTIAL_SLIDER_JOBLEVEL:new Bs,TAXATION_RESIDENTIAL_TITLE:new Gs,TAXATION_TAX_GROUP:new Vs,TAX_AREA_COLUMN_TITLE:new Gs,TAX_AREA_DESCRIPTION:new Vs,TAX_AREA_TITLE:new Vs,TAX_INCOME_ESTIMATE_TITLE:new Gs,TAX_INCOME_TOTAL_TITLE:new Gs,TAX_RANGE:new Gs("MIN","MAX"),TAX_RATE_TITLE:new Gs,TITLE:new Gs},Editor:{ACTIVE_TOOLTIP:new Gs,ADD_COMPONENT:new Gs,ADD_FAVORITE:new Gs,ADD_TRANSLATION:new Gs,ASSETS:new Gs,BACK_TO_EDITOR:new Gs,BORDER_RIVER_WATER_SOURCES:new Gs,BORDER_SEA_WATER_SOURCES:new Gs,CAMERA_ANGLE:new Gs,CAMERA_PIVOT:new Gs,CAMERA_STARTING_POSITION:new Gs,CAMERA_ZOOM:new Gs,CAPTURE_CAMERA_POSITION:new Gs,CHANGE_PREFAB_TYPE:new Gs,CHECKLIST:new Gs,CHECKLIST_AIR_CONNECTION:new Gs,CHECKLIST_ELECTRICITY_CONNECTION:new Gs,CHECKLIST_FERTILE:new Gs,CHECKLIST_FOREST:new Gs,CHECKLIST_OIL:new Gs,CHECKLIST_OPTIONAL:new Gs,CHECKLIST_ORE:new Gs,CHECKLIST_REQUIRED:new Gs,CHECKLIST_ROAD_CONNECTION:new Gs,CHECKLIST_STARTING_TILES:new Gs,CHECKLIST_TRAIN_CONNECTION:new Gs,CHECKLIST_WATER:new Gs,CLEAR_ALL:new Gs,CLEAR_RESOURCE:new Vs,CLIMATE:new Gs,CLIMATE_SETTINGS:new Gs,CLOUDINESS:new Gs,CONSTANT_LEVEL_WATER_SOURCES:new Gs,CONSTANT_RATE_WATER_SOURCES:new Gs,CURRENT_YEAR_AS_DEFAULT:new Gs,DELETE_COMPONENT:new Gs,DRIVES:new Gs,ELEMENT_COUNT:new Gs("COUNT"),EXPORT_HEIGHTMAP:new Gs,EXPORT_WORLDMAP:new Gs,FILE_NAME:new Gs,FILTERS:new Gs,FLOOD_HEIGHT:new Gs,HEIGHT:new Gs,HEIGHTMAPS:new Gs,HEIGHT_OFFSET:new Gs,HEIGHT_SCALE:new Gs,IMPORT:new Gs,IMPORT_HEIGHTMAP:new Gs,IMPORT_RESOURCE:new Vs,IMPORT_WORLDMAP:new Gs,INCORRECT_HEIGHTMAP_MESSAGE:new Gs("WIDTH","HEIGHT"),INCORRECT_HEIGHTMAP_TITLE:new Gs,LIST_ADD_ITEM:new Gs,LIST_COUNT:new Gs("COUNT"),LIST_ITEM_COLLAPSE:new Gs,LIST_ITEM_DELETE:new Gs,LIST_ITEM_DUPLICATE:new Gs,LIST_ITEM_EXPAND:new Gs,LIST_ITEM_MOVE_DOWN:new Gs,LIST_ITEM_MOVE_UP:new Gs,LOAD:new Gs,LOAD_MAP:new Gs,LOCATE:new Gs,MAP:new Gs,MAP_DESCRIPTION:new Gs,MAP_NAME:new Gs,MAP_NAME_AS_DEFAULT:new Gs,MAP_OFFSET:new Gs,MAP_SETTINGS:new Gs,MAP_SIZE:new Gs,MATERIALS:new Gs,NEW_MAP:new Gs,NEXT_PAGE:new Gs,NONE_VALUE:new Gs,OBJECTCONTAINER:new Gs,OPEN_DIRECTORY:new Gs,PAGE_FORMAT:new Gs("CURRENT","TOTAL"),POLLUTION:new Gs,POSITION:new Gs,PREVIEW:new Gs,PREVIOUS_PAGE:new Gs,PROCESSING:new Gs,RADIUS:new Gs,REMOVE_FAVORITE:new Gs,REMOVE_WORLDMAP:new Gs,RESET_CLOUDINESS:new Gs,RESET_TIME_OF_DAY:new Gs,RESET_TIME_OF_YEAR:new Gs,RESOURCES:new Gs,RESOURCE_TEXTURE_LABEL:new Gs,RESOURCE_TOOLS:new Gs,SAVE:new Gs,SAVE_MAP:new Gs,SEARCH_PLACEHOLDER:new Gs,SELECT_DIRECTORY:new Gs,SELECT_STARTING_TILES:new Gs,STARTING_MONTH:new Gs,STARTING_TIME:new Gs,STARTING_YEAR:new Gs,STOP_SELECTING_STARTING_TILES:new Gs,TERRAIN_TOOLS:new Gs,THEME:new Gs,THUMBNAIL:new Gs,TIME_OF_DAY:new Gs,TIME_OF_YEAR:new Gs,TOOL:new Vs,UNIQUE_MAP_ID:new Gs,WATER:new Gs,WATER_RATE:new Gs,WATER_SETTINGS:new Gs,WATER_SIMULATION_SPEED:new Gs,WIDGETS:new Vs,WORKSPACE:new Gs,WORLD_OFFSET:new Gs,WORLD_SIZE:new Gs},EducationInfoPanel:{AVAILABILITY:new Vs,EDUCATION_DISTRIBUTION:new Gs,EDUCATION_LEVEL:new Vs,ELIGIBLE:new Gs,LEVEL:new Vs,STUDENTS:new Vs,STUDENT_COUNT:new Gs},ElectricityInfoPanel:{BATTERY_CHARGE:new Gs,ELECTRICITY_AVAILABILITY:new Gs,ELECTRICITY_EXPORT:new Gs,ELECTRICITY_IMPORT:new Gs,ELECTRICITY_TRADE:new Gs,ELECTRICITY_TRANSMISSION:new Gs,ELECTRICITY_TRANSMITTED:new Gs,TEMPERATURE_EFFECT:new Gs},EventJournal:{EFFECT:new Vs,EVENT_TITLE:new Vs,OPENING_MESSAGE:new Gs,PANEL_TITLE:new Gs},FireAndRescueInfoPanel:{AVERAGE_FIRE_HAZARD:new Gs},GameListScreen:{BIOME_LABEL:new Gs,BUILDABLE_AREA_LABEL:new Gs,CITY_DETAILS_SECTION:new Gs,CLIMATE_LABEL:new Gs,CONFIRM_OVERWRITE_MESSAGE:new Gs,CONFIRM_UNSAVED_MESSAGE:new Gs,CONNECTIONS_LABEL:new Gs,EQUATOR:new Gs,GAME_OPTION:new Vs,GAME_OPTIONS_SECTION:new Gs,GAME_OPTION_DESCRIPTION:new Vs,HEMISPHERE_N:new Gs,HEMISPHERE_S:new Gs,INVALID_NAME_MESSAGE:new Gs,LAST_MODIFIED_LABEL:new Gs,LATITUDE_LABEL:new Gs,LOAD_GAME_BUTTON:new Gs,LOAD_GAME_SCREEN_TITLE:new Gs,MAP_DETAILS_SECTION:new Gs,MAP_FILTER:new Vs,MAP_LABEL:new Gs,MONEY_LABEL:new Gs,NEW_GAME_SCREEN_TITLE:new Gs,POPULATION_LABEL:new Gs,RESOURCES_LABEL:new Gs,SAVE_GAME_BUTTON:new Gs,SAVE_GAME_SCREEN_TITLE:new Gs,SAVE_NAME_LABEL:new Gs,START_GAME_BUTTON:new Gs,THEME_LABEL:new Gs,TUTORIAL_OPTIONS:new Gs,WATER_AVAILABILITY_LABEL:new Gs,XP_LABEL:new Gs},GarbageInfoPanel:{GARBAGE_RATE:new Gs,LANDFILL_AVAILABILITY:new Gs,PROCESSING_STATUS:new Gs,STORED_GARBAGE:new Gs},GroundPollutionInfoPanel:{AVERAGE_GROUND_POLLUTION:new Gs},HealthcareInfoPanel:{AVERAGE_HEALTH:new Gs,CEMETERY_AVAILABILITY:new Gs,CREMATORIUM_AVAILABILITY:new Gs,DEATH_RATE:new Gs,HEALTHCARE_AVAILABILITY:new Gs,N_A:new Gs,OCCUPIED:new Gs,PATIENTS:new Gs,PROCESSING_RATE:new Gs,SICK_OR_INJURED:new Gs},ISO:{COUNTRY:new Vs},InfoPanels:{CAPACITY:new Gs,CONSUMPTION:new Gs,OUTPUT:new Gs,PROCESSING:new Gs,PRODUCTION:new Gs,STORED:new Gs},Infoviews:{AVAILABILITY:new Gs,AVERAGE_AIR_POLLUTION_TOOLTIP:new Gs,AVERAGE_COMMERCIAL_PROFIT_TOOLTIP:new Gs,AVERAGE_FIRE_HAZARD_TOOLTIP:new Gs,AVERAGE_GROUND_POLLUTION_TOOLTIP:new Gs,AVERAGE_INDUSTRIAL_PROFIT_TOOLTIP:new Gs,AVERAGE_LAND_VALUE_TOOLTIP:new Gs,AVERAGE_NOISE_POLLUTION_TOOLTIP:new Gs,AVERAGE_OFFICE_PROFIT_TOOLTIP:new Gs,AVERAGE_WATER_POLLUTION_TOOLTIP:new Gs,BATTERY_CHARGE_TOOLTIP:new Gs,CEMETERY_AVAILABILITY_TOOLTIP:new Gs,CITY_ATTRACTIVENESS_TOOLTIP:new Gs,CLOSE_INFO_VIEW:new Gs,COLLEGE_AVAILABILITY_TOOLTIP:new Gs,COMMERCIAL_LEVEL_TOOLTIP:new Gs,CREMATORIUM_AVAILABILITY_TOOLTIP:new Gs,CRIME_PROBABILITY_TOOLTIP:new Gs,EDUCATION_DISTRIBUTION_TOOLTIP:new Gs,ELECTRICITY_AVAILABILITY_TOOLTIP:new Gs,ELECTRICITY_TRADE_TOOLTIP:new Gs,ELECTRICITY_TRANSMISSION_TOOLTIP:new Gs,ELEMENTARY_SCHOOL_AVAILABILITY_TOOLTIP:new Gs,EXPORT_DISTRIBUTION_TOOLTIP:new Gs,FERTILE_LAND_RESOURCE_TOOLTIP:new Gs,GARBAGE_PROCESSING_STATUS_TOOLTIP:new Gs,HAPPINESS_FACTORS_TOOLTIP:new Gs,HEALTHCARE_AVAILABILITY_TOOLTIP:new Gs,HIGH_SCHOOL_AVAILABILITY_TOOLTIP:new Gs,IMPORT_DISTRIBUTION_TOOLTIP:new Gs,INDUSTRIAL_LEVEL_TOOLTIP:new Gs,INFOMODE:new Vs,INFOMODE_TOOLTIP:new Vs,INFOMODE_TYPE:new Vs,INFOVIEW:new Vs,JAIL_AVAILABILITY_TOOLTIP:new Gs,LABEL:new Vs,LABEL_VALUE_FORMAT:new Gs("LABEL","VALUE"),LANDFILL_AVAILABILITY_TOOLTIP:new Gs,MAIL_SERVICE_AVAILABILITY_TOOLTIP:new Gs,MAP_LEGEND:new Gs,OFFICE_LEVEL_TOOLTIP:new Gs,OIL_RESOURCE_TOOLTIP:new Gs,ORE_RESOURCE_TOOLTIP:new Gs,PARKING_AVAILABILITY_TOOLTIP:new Gs,POPULATION_DISTRIBUTION_TOOLTIP:new Gs,POPULATION_STATISTICS_TOOLTIP:new Gs,PRISON_AVAILABILITY_TOOLTIP:new Gs,REMOVE_USER_INFOVIEW_BUTTON_TOOLTIP:new Gs,RESIDENTIAL_LEVEL_TOOLTIP:new Gs,SEWAGE_TRADE_TOOLTIP:new Gs,SEWAGE_TREATMENT_TOOLTIP:new Gs,SHELTER_AVAILABILITY_TOOLTIP:new Gs,TITLE_INFOVIEWS:new Gs,TRAFFIC_FLOW:new Gs,UNIVERSITY_AVAILABILITY_TOOLTIP:new Gs,USER_INFOMODE_SELECTOR_TOOLTIP:new Gs,WATER_AVAILABILITY_TOOLTIP:new Gs,WATER_STORAGE_TOOLTIP:new Gs,WATER_TRADE_TOOLTIP:new Gs,WOOD_RESOURCE_TOOLTIP:new Gs,WORKPLACE_DISTRIBUTION_TOOLTIP:new Gs},LandValueInfoPanel:{AVERAGE_LAND_VALUE:new Gs},LevelInfoPanel:{COMMERCIAL:new Gs,INDUSTRIAL:new Gs,LEVEL1:new Gs,LEVEL2:new Gs,LEVEL3:new Gs,LEVEL4:new Gs,LEVEL5:new Gs,OFFICE:new Gs,RESIDENTIAL:new Gs},LifePath:{BACK_BUTTON_TOOLTIP:new Gs,CITIZEN_BECAME_UNEMPLOYED:new Bs("LINK_1"),CITIZEN_BIRTH:new Gs,CITIZEN_COMMITED_ROBBERY:new Bs,CITIZEN_DIED:new Bs,CITIZEN_FAILED_SCHOOL:new Bs("LINK_1"),CITIZEN_GOT_ARRESTED:new Bs,CITIZEN_GOT_INJURED:new Bs,CITIZEN_GOT_INJURED_BY_EVENT:new Bs("LINK_1"),CITIZEN_GOT_IN_DANGER_BY_EVENT:new Bs("LINK_1"),CITIZEN_GOT_SICK:new Bs,CITIZEN_GOT_SICK_BY_EVENT:new Bs("LINK_1"),CITIZEN_GOT_TRAPPED:new Bs,CITIZEN_GOT_TRAPPED_BY_EVENT:new Bs("LINK_1"),CITIZEN_GRADUATED:new Bs("LINK_1"),CITIZEN_IN_DANGER:new Bs,CITIZEN_LOST_FAMILY_MEMBER:new Bs("LINK_1"),CITIZEN_MADE_BABY_COUPLE:new Bs("LINK_1","LINK_2"),CITIZEN_MADE_BABY_SINGLE:new Bs("LINK_1"),CITIZEN_MOVED_HOUSE:new Bs("LINK_1"),CITIZEN_MOVED_OUT_OF_CITY:new Bs("LINK_1"),CITIZEN_PARTNERED_UP:new Bs("LINK_1"),CITIZEN_SENTENCED_TO_PRISON:new Bs,CITIZEN_SEPARATED:new Bs("LINK_1"),CITIZEN_STARTED_SCHOOL:new Bs("LINK_1"),CITIZEN_STARTED_WORKING:new Bs("LINK_1"),DETAIL_PANEL_TITLE:new Gs("NAME"),LIST_PANEL_TITLE:new Gs,MAX_EXCEEDED_WARNING:new Gs,OCCUPATION:new Gs("OCCUPATION","WORKPLACE_LINK","WORKPLACE_NAME"),OPENING_MESSAGE:new Gs,TOURIST_LEFT_CITY:new Bs("LINK_1"),UNFOLLOW_BUTTON_TOOLTIP:new Gs},Loading:{HINTMESSAGE:new Bs,LOADING_TITLE:new Gs},Main:{TOOLTIP_DESCRIPTION_ADVISOR:new Gs,TOOLTIP_DESCRIPTION_CAMERA_MODES:new Gs,TOOLTIP_DESCRIPTION_CHIRPER:new Gs,TOOLTIP_DESCRIPTION_CINEMATIC_CAMERA:new Gs,TOOLTIP_DESCRIPTION_CITY_ECONOMY:new Gs,TOOLTIP_DESCRIPTION_CITY_INFO:new Gs,TOOLTIP_DESCRIPTION_CITY_NAME:new Gs,TOOLTIP_DESCRIPTION_CITY_STATISTICS:new Gs,TOOLTIP_DESCRIPTION_CURRENT_MILESTONE:new Gs,TOOLTIP_DESCRIPTION_DATE:new Gs,TOOLTIP_DESCRIPTION_DEMAND:new Gs,TOOLTIP_DESCRIPTION_ELEVATION_LOWER:new Gs,TOOLTIP_DESCRIPTION_ELEVATION_RAISE:new Gs,TOOLTIP_DESCRIPTION_EVENT_JOURNAL:new Gs,TOOLTIP_DESCRIPTION_FOLLOWED_CITIZENS:new Gs,TOOLTIP_DESCRIPTION_FREE_CAMERA:new Gs,TOOLTIP_DESCRIPTION_GAME_SPEED:new Gs,TOOLTIP_DESCRIPTION_INFO_VIEWS:new Gs,TOOLTIP_DESCRIPTION_LINES_OVERVIEW:new Gs,TOOLTIP_DESCRIPTION_MAP_TILES:new Gs,TOOLTIP_DESCRIPTION_MAX_MILESTONE:new Gs,TOOLTIP_DESCRIPTION_MONEY:new Gs,TOOLTIP_DESCRIPTION_NOTIFICATIONS:new Gs,TOOLTIP_DESCRIPTION_PAUSE:new Gs,TOOLTIP_DESCRIPTION_PAUSE_MENU:new Gs,TOOLTIP_DESCRIPTION_PHOTO_MODE:new Gs,TOOLTIP_DESCRIPTION_PLAY:new Gs,TOOLTIP_DESCRIPTION_POPULATION:new Gs,TOOLTIP_DESCRIPTION_PROGRESSION:new Gs,TOOLTIP_DESCRIPTION_RADIO:new Gs,TOOLTIP_DESCRIPTION_UNDERGROUND:new Gs,TOOLTIP_DESCRIPTION_UNLIMITED_MONEY:new Gs,TOOLTIP_DESCRIPTION_WEATHER:new Gs,TOOLTIP_DESCRIPTION_XP:new Gs,TOOLTIP_TITLE_ADVISOR:new Gs,TOOLTIP_TITLE_CAMERA_MODES:new Gs,TOOLTIP_TITLE_CHIRPER:new Gs,TOOLTIP_TITLE_CINEMATIC_CAMERA:new Gs,TOOLTIP_TITLE_CITY_ECONOMY:new Gs,TOOLTIP_TITLE_CITY_INFO:new Gs,TOOLTIP_TITLE_CITY_NAME:new Gs,TOOLTIP_TITLE_CITY_STATISTICS:new Gs,TOOLTIP_TITLE_CURRENT_MILESTONE:new Gs,TOOLTIP_TITLE_DATE:new Gs,TOOLTIP_TITLE_DEMAND:new Gs,TOOLTIP_TITLE_ELEVATION_LOWER:new Gs,TOOLTIP_TITLE_ELEVATION_RAISE:new Gs,TOOLTIP_TITLE_EVENT_JOURNAL:new Gs,TOOLTIP_TITLE_FOLLOWED_CITIZENS:new Gs,TOOLTIP_TITLE_FREE_CAMERA:new Gs,TOOLTIP_TITLE_GAME_SPEED:new Gs,TOOLTIP_TITLE_INFO_VIEWS:new Gs,TOOLTIP_TITLE_LINES_OVERVIEW:new Gs,TOOLTIP_TITLE_MAP_TILES:new Gs,TOOLTIP_TITLE_MONEY:new Gs,TOOLTIP_TITLE_NOTIFICATIONS:new Gs,TOOLTIP_TITLE_PAUSE:new Gs,TOOLTIP_TITLE_PAUSE_MENU:new Gs,TOOLTIP_TITLE_PHOTO_MODE:new Gs,TOOLTIP_TITLE_PLAY:new Gs,TOOLTIP_TITLE_POPULATION:new Gs,TOOLTIP_TITLE_PROGRESSION:new Gs,TOOLTIP_TITLE_RADIO:new Gs,TOOLTIP_TITLE_UNDERGROUND:new Gs,TOOLTIP_TITLE_WEATHER:new Gs,TOOLTIP_TITLE_XP:new Gs},MapTilePurchase:{AVAILABLE_EXPANSION_PERMITS:new Gs("VALUE"),AVAILABLE_WATER:new Gs,BUILDABLE_AREA:new Gs,COST:new Gs,PERMITS_USED:new Gs,PURCHASE_STATUS:new Vs,PURCHASE_STATUS_TOOLTIP:new Vs,RESOURCE:new Vs,RESOURCES:new Gs,TITLE:new Gs,TOOLTIP_COST:new Gs,TOOLTIP_RESOURCE:new Vs,TOOLTIP_TILES:new Gs,TOOLTIP_TITLE_COST:new Gs,TOOLTIP_TITLE_RESOURCE:new Vs,TOOLTIP_TITLE_TILES:new Gs},Maps:{MAP_DESCRIPTION:new Vs,MAP_TITLE:new Vs,OUTSIDE_CONNECTIONS:new Vs,RESOURCE:new Vs},Menu:{ACHIEVEMENTS_WARNING_GAME_OPTIONS:new Gs,ACHIEVEMENTS_WARNING_MODS:new Gs,APPLICATION_QUIT_MESSAGE:new Gs,ASSET_ADD_LINK:new Gs,ASSET_ADD_PREVIEW_SCREENSHOT:new Gs,ASSET_COMPLETE:new Gs,ASSET_ERROR_DESCRIPTION:new Gs,ASSET_ERROR_LINK:new Gs,ASSET_ERROR_NAME:new Gs,ASSET_FAILURE:new Gs,ASSET_FORUM_LINK:new Gs("INDEX"),ASSET_FORUM_LINKS:new Gs,ASSET_LONG_DESCRIPTION:new Gs,ASSET_NAME:new Gs,ASSET_PREPARING:new Gs,ASSET_PREVIEW_SCREENSHOTS:new Gs,ASSET_REMOVE_PREVIEW_SCREENSHOT:new Gs,ASSET_SCREENSHOT_EMPTY_SUBTITLE:new Gs,ASSET_SCREENSHOT_EMPTY_TITLE:new Gs,ASSET_SHORT_DESCRIPTION:new Gs,ASSET_SUBMITTING:new Gs,ASSET_TYPE:new Vs,ASSET_UPLOAD:new Gs,BACK:new Gs,CITY_NAME_LABEL:new Gs,CLOUD_TARGET:new Vs,CLOUD_TARGET_LABEL:new Gs,CONFIRM_DELETE_SAVE_WARNING:new Gs,CONTINUE_GAME:new Gs,CREDITS:new Gs,DLC_TAB:new Gs,EDITOR:new Gs,EMPTY_SLOT:new Gs,EXIT_APPLICATION:new Gs,EXIT_GAME:new Gs,GDKCLOUD_SAVE:new Gs,LOAD_GAME:new Gs,LOAD_GAME_BUTTON:new Gs,MAP_OPTIONS:new Gs,MODS_TAB:new Gs,NAME_FIELD_PLACEHOLDER:new Gs,NEWS_PANEL_TITLE:new Gs,NEW_GAME:new Gs,NOTIFICATIONS_OPENING_MESSAGE:new Gs,NOTIFICATIONS_TITLE:new Gs,NOTIFICATION_DESCRIPTION:new Vs,NOTIFICATION_TITLE:new Vs,OPTIONS:new Gs,PARADOXCLOUD_SAVE:new Gs,PDX_MODS:new Gs,RANDOM_CITY_NAME_BUTTON_TOOLTIP:new Gs,READONLY_SAVE:new Gs,RESUME_GAME:new Gs,SAVE_GAME:new Gs,SAVE_LIST:new Gs,SAVE_OPTIONS:new Gs,SAVE_ORDERING:new Vs,SAVE_ORDERING_LABEL:new Gs,SELECT_MAP_BUTTON:new Gs,SIMULATION_DATE_LABEL:new Gs,START_GAME_BUTTON:new Gs,STEAMCLOUD_SAVE:new Gs,SWITCH_USER:new Gs,UNLIMITED_MONEY_LABEL:new Gs},NaturalResourcesInfoPanel:{AVAILABLE:new Gs,FERTILITY:new Gs,FOREST:new Gs,OIL:new Gs,ORE:new Gs,RATE:new Gs,RENEWAL_RATE:new Gs},NoisePollutionInfoPanel:{AVERAGE_NOISE_POLLUTION:new Gs},Notifications:{DESCRIPTION:new Vs,TITLE:new Vs},Options:{ANTIALIASINGMETHOD:new Vs,AUTORELOADMODE:new Vs,AUTOSAVECOUNT:new Vs,AUTOSAVEINTERVAL:new Vs,CURSORMODE:new Vs,DEPTHOFFIELDMODE:new Vs,DEPTHOFFIELDRESOLUTION:new Vs,DESCRIPTION_BOX_TITLE:new Gs,DISPLAYMODE:new Vs,DISPLAY_MODE:new Vs,DISPLAY_SETTINGS_CONFIRM:new Gs,DISPLAY_SETTINGS_PROMPT:new Gs,DISPLAY_SETTINGS_REVERT:new Gs("TIME"),DLSSQUALITY:new Vs,DYNRESUPSCALEFILTER:new Vs,ERROR_TOOLCHAIN:new Gs,ERROR_TOOLCHAIN_DEPENDENCY_DOWNLOAD:new Gs("DEPENDENCY_NAME"),ERROR_TOOLCHAIN_DEPENDENCY_DOWNLOAD_DETAILS:new Gs("DEPENDENCY_NAME","DETAILS"),ERROR_TOOLCHAIN_DEPENDENCY_INSTALL:new Gs("DEPENDENCY_NAME"),ERROR_TOOLCHAIN_DEPENDENCY_INSTALL_DETAILS:new Gs("DEPENDENCY_NAME","DETAILS"),ERROR_TOOLCHAIN_DEPENDENCY_UNINSTALL:new Gs("DEPENDENCY_NAME"),ERROR_TOOLCHAIN_DEPENDENCY_UNINSTALL_DETAILS:new Gs("DEPENDENCY_NAME","DETAILS"),ERROR_TOOLCHAIN_INSTALL_UNKNOWN:new Gs,ERROR_TOOLCHAIN_NO_SPACE:new Gs,ERROR_TOOLCHAIN_NO_SPACE_DETAILS:new Gs("DETAILS"),ERROR_TOOLCHAIN_UNINSTALL_UNKNOWN:new Gs,FILTERMODE:new Vs,FPSMODE:new Vs,GROUP:new Vs,INPUTHINTSTYPE:new Vs,INPUT_CONFLICT_NO_RESOLUTION:new Gs("CONTROL","BINDING"),INPUT_CONFLICT_PROMPT:new Gs("CONTROL","BINDING"),INPUT_CONFLICT_TITLE:new Gs,INPUT_CONTROL:new Vs,INPUT_CONTROL_PS:new Vs,INPUT_CONTROL_UNSET:new Gs,INPUT_MODIFIER_SEPARATOR:new Gs,INPUT_REBIND_PROMPT:new Vs,INPUT_REBIND_PROMPT_PS:new Vs,INPUT_REBIND_TITLE:new Gs("BINDING"),INTERFACE_STYLE:new Vs,LEVEL:new Vs,MOD_TOOLCHAIN_STATUS:new Vs,MSAASAMPLES:new Vs,OPTION:new Vs,OPTION_DESCRIPTION:new Vs,PERFORMANCEPREFERENCE:new Vs,SCREEN_RESOLUTION_FORMAT:new Gs("WIDTH","HEIGHT","REFRESH_RATE"),SCREEN_TITLE:new Gs,SEARCH:new Vs,SECTION:new Vs,SKINNING:new Vs,SMAAQUALITYLEVEL:new Vs,STATE_TOOLCHAIN:new Vs,SWAP_BINDINGS:new Gs,TAB:new Vs,TEMPERATUREUNIT:new Vs,TIMEFORMAT:new Vs,UNITSYSTEM:new Vs,UNSET_BINDINGS:new Gs,UNSET_BINDING_TOOLTIP:new Gs,WARNING:new Vs,WARN_TOOLCHAIN_DEPENDENCY_UNINSTALL:new Gs("DEPENDENCY_NAME"),WARN_TOOLCHAIN_DOTNET_UNINSTALL:new Gs("DOTNET_VERSION"),WARN_TOOLCHAIN_INSTALL:new Gs("UNITY_VERSION","HOST"),WARN_TOOLCHAIN_UNINSTALL:new Gs("UNITY_VERSION"),WARN_TOOLCHAIN_UNITY_LICENSE_RETURN:new Gs,WARN_TOOLCHAIN_UNITY_UNINSTALL:new Gs("UNITY_VERSION")},OutsideConnectionsInfoPanel:{TOP_EXPORTS:new Gs,TOP_IMPORTS:new Gs},Overlay:{BACK_ACTION:new Gs,CHANGE_USER_ACTION:new Gs,CONTROLLER_DISCONNECTED:new Gs,CONTROLLER_PAIRING_CHANGED:new Gs,CORRUPT_SAVE_DATA:new Gs,DELETED_ITEMS:new Gs,ENGAGEMENT_PROMPT_GAMEPAD:new Gs,ENGAGEMENT_PROMPT_KEYBOARD:new Gs,PLEASE_LOG_IN:new Gs,PLEASE_WAIT:new Gs,PRESS_ANY_KEY_ACTION:new Gs,PROCEED_ACTION:new Gs,QUIT_ACTION:new Gs,START_GAME_ACTION:new Gs,SWITCH_USER:new Gs,USER_LOGGED_OUT:new Gs,VALIDATION:new Gs},Paradox:{ACCOUNT_LINK_CONFIRMATION_TEXT:new Vs,ACCOUNT_LINK_OVERWRITE_TITLE:new Gs,ACCOUNT_LINK_PROMPT_SHORT:new Vs,ACCOUNT_LINK_PROMPT_TEXT:new Vs,ACCOUNT_LINK_PROMPT_TITLE:new Gs,BIRTH_DATE_DAY_FIELD_LABEL:new Gs,BIRTH_DATE_FIELD_LABEL:new Gs,BIRTH_DATE_MONTH_FIELD_LABEL:new Gs,BIRTH_DATE_YEAR_FIELD_LABEL:new Gs,COUNTRY_FIELD_LABEL:new Gs,EMAIL_FIELD_LABEL:new Gs,ERROR:new Vs,FORGOT_PASSWORD_LINK:new Gs,LINK_ACCOUNT_BUTTON:new Gs,LOADING:new Gs,LOGIN_BUTTON:new Gs,LOGIN_FORM_TITLE:new Gs,LOGIN_FROM_REGISTRATION_LINK:new Gs,LOGIN_INCENTIVE:new Gs,LOGOUT_BUTTON:new Gs,MARKETING_PERMISSION_TOGGLE_LABEL:new Gs,MODS_NEED_INTERNET:new Gs,NO_INTERNET_CONNECTION:new Gs,PARADOX_ACCOUNT:new Gs,PASSWORD_FIELD_LABEL:new Gs,PASSWORD_RESET_CONFIRMATION_TEXT:new Gs("EMAIL"),PDX_ACCOUNT_LINK_OVERWRITE_PROMPT_TEXT:new Vs,PDX_MODS_BUTTON:new Gs,PDX_PLATFORM_ACCOUNT_LINK_OVERWRITE_PROMPT_TEXT:new Vs,PLATFORM_ACCOUNT_LINK_OVERWRITE_PROMPT_TEXT:new Vs,PRIVACY_POLICY:new Gs,REGISTRATION_CONFIRMATION_TEXT:new Gs,REGISTRATION_CONFIRMATION_TITLE:new Gs,REGISTRATION_FORM_TITLE:new Gs,REGISTRATION_FROM_LOGIN_LINK:new Gs,REGISTRATION_HINT:new Gs,REMEMBER_ME_TOGGLE_LABEL:new Gs,SDK_DISABLED:new Gs,SKIP_BUTTON:new Gs,SUBMIT_REGISTRATION_BUTTON:new Gs,TERMS_OF_USE:new Gs,TERMS_PRIVACY_NOTICE:new Gs,UGC_DISABLED:new Gs,UNKNOWN_ERROR:new Gs,UNLINK_ACCOUNT_BUTTON:new Gs},PhotoMode:{CAPTURE_PROPERTY_TOOLTIP:new Gs,CLOUDEROSIONNOISE:new Vs,DEPTHOFFIELDMODE:new Vs,ENABLE_PROPERTY_TOOLTIP:new Gs,ENVIRONMENT_DISCLAIMER:new Gs,FILMGRAINLOOKUP:new Vs,GATEFITMODE:new Vs,HIDE_UI:new Gs,PROPERTY_LIMIT_MAX:new Gs,PROPERTY_LIMIT_MIN:new Gs,PROPERTY_TITLE:new Vs,PROPERTY_TOOLTIP:new Vs,RESET_PROPERTY_TOOLTIP:new Gs,SENSORTYPE:new Vs,TAB:new Vs,TAKE_PHOTO:new Gs,TITLE:new Gs,TOGGLE_FIRST_PERSON_MODE:new Gs,TOGGLE_ORBIT_MODE:new Gs},PoliceInfoPanel:{ARRESTED_CRIMINALS:new Gs,AVERAGE_CRIME_PROBABILITY:new Gs,CRIME_SUCCESS_RATE:new Gs,CURRENT_NUMBER_OF_CRIMINALS:new Gs,IN_JAIL:new Gs,IN_PRISON:new Gs,JAIL_AVAILABILITY:new Gs,NUMBER_OF_CRIMES_PER_MONTH:new Gs,PRISONERS:new Gs,PRISON_AVAILABILITY:new Gs},Policy:{DESCRIPTION:new Vs,TITLE:new Vs},PopulationInfoPanel:{ADULTS:new Gs,AGE_DISTRIBUTION:new Gs,BIRTH_RATE:new Gs,CHILDREN:new Gs,DEATH_RATE:new Gs,EMPLOYED:new Gs,JOBS:new Gs,MOVED_AWAY:new Gs,MOVED_IN:new Gs,POPULATION:new Gs,SENIORS:new Gs,TEENS:new Gs,UNEMPLOYMENT:new Gs},PostInfoPanel:{COLLECTED_MAIL:new Gs,DELIVERED_MAIL:new Gs,MAIL_RATE:new Gs,MAIL_SERVICE_AVAILABILITY:new Gs},Progression:{AVAILABLE_DEV_POINTS:new Gs("VALUE"),BUILDING_UNLOCK_EVENT_PANEL_TITLE:new Gs,BUILD_LATER_BUTTON:new Gs,BUILD_NOW_BUTTON:new Gs,DEVELOPMENT_POINTS_FIELD_LABEL:new Gs,DEV_TREE_UNLOCK_BADGE:new Gs,HAPPINESS_REQUIREMENT:new Gs("VALUE"),INCLUDES_LABEL:new Gs,LOAN_LIMIT:new Gs,MAP_TILES_FIELD_LABEL:new Gs,MAX_MILESTONE_FIELD_LABEL:new Gs,MILESTONE_DESCRIPTION:new Bs,MILESTONE_DETAIL_SUBTITLE:new Gs("INDEX"),MILESTONE_NAME:new Bs,MILESTONE_PROGRESS:new Gs("CURRENT","TARGET"),MILESTONE_REWARDS_LABEL:new Gs,MILESTONE_UNLOCK_PANEL_TITLE_PRIMARY:new Gs("INDEX"),MILESTONE_UNLOCK_PANEL_TITLE_SECONDARY:new Gs,MILESTONE_UNLOCK_REQUIREMENT:new Gs("INDEX","NAME"),NODE_DESCRIPTION:new Vs,NODE_DEV_POINTS_REQUIREMENT:new Gs,NODE_LOCKED:new Gs,NODE_MILESTONE_REQUIREMENT:new Gs("INDEX"),NODE_NAME:new Vs,NODE_PARENT_REQUIREMENT:new Gs,NODE_UNLOCKED:new Gs,NODE_UNLOCK_REQUIREMENT:new Gs("NAME"),OBJECT_BUILT_REQUIREMENT:new Vs("CURRENT","TARGET"),PANEL_TITLE:new Gs,POINTS_LABEL:new Gs("POINTS"),POPULATION_REQUIREMENT:new Gs("VALUE"),PROCESSING_REQUIREMENT:new Gs("RESOURCE","CURRENT","TARGET"),PROGRESSION_PANEL_BUTTON:new Gs,PURCHASE_BUTTON_AVAILABLE:new Gs,PURCHASE_BUTTON_LOCKED:new Gs,PURCHASE_BUTTON_MILESTONE:new Gs("MILESTONE"),PURCHASE_BUTTON_POINTS:new Gs,PURCHASE_BUTTON_UNLOCKED:new Gs,PURCHASE_COST:new Gs("COST"),RADIO_MAST_REQUIREMENT:new Gs("CURRENT","TARGET"),REQUIREMENT:new Gs,REQUIREMENTS:new Gs,REQUIRES_ALL:new Gs,REQUIRES_ANY:new Gs,REWARD_FIELD_LABEL:new Gs,STRICT_OBJECT_BUILT_REQUIREMENT:new Gs("NAME","CURRENT","TARGET"),TAB_TITLE:new Vs,TOOLTIP_DESCRIPTION_EXPANSION_PERMITS:new Gs,TOOLTIP_DESCRIPTION_MONEY:new Gs,TOOLTIP_DESCRIPTION_POINTS:new Gs,TOOLTIP_DESCRIPTION_POINTS_COST:new Gs,TOOLTIP_DESCRIPTION_TAB:new Vs,TOOLTIP_TITLE_EXPANSION_PERMITS:new Gs,TOOLTIP_TITLE_MONEY:new Gs,TOOLTIP_TITLE_POINTS:new Gs,TOOLTIP_TITLE_POINTS_COST:new Gs,TOOLTIP_TITLE_TAB:new Vs,TUTORIAL_REQUIREMENT:new Gs,UNLOCK_NODE_BUTTON:new Gs,XP_REASON:new Vs,ZONE_BUILT_REQUIREMENT_CELLS:new Gs("ZONE","CURRENT","TARGET"),ZONE_BUILT_REQUIREMENT_CELLS_LEVEL:new Gs("LEVEL","ZONE","CURRENT","TARGET"),ZONE_BUILT_REQUIREMENT_COUNT:new Gs("ZONE","CURRENT","TARGET"),ZONE_BUILT_REQUIREMENT_COUNT_LEVEL:new Gs("LEVEL","ZONE","CURRENT","TARGET")},Properties:{ADJUST_HAPPINESS_MODIFIER_EFFECT:new Gs("DELTA","TYPE","TARGET"),ADJUST_HAPPINESS_MODIFIER_TARGET:new Vs,ADJUST_HAPPINESS_MODIFIER_TYPE:new Vs,AMBULANCE_COUNT:new Gs,ATTRACTION_EFFECT:new Gs("VALUE"),ATTRACTIVENESS:new Gs,BATTERY_CAPACITY:new Gs,BATTERY_POWER_OUTPUT:new Gs,CARGO_CAPACITY:new Gs,CITY_MODIFIER:new Vs,CITY_MODIFIER_EFFECT:new Gs("DELTA","TYPE"),COMFORT:new Gs,CONSTRUCTION_COST:new Gs,DECEASED_PROCESSING_CAPACITY:new Gs,DECEASED_STORAGE:new Gs,ELECTRICITY_CONSUMPTION:new Gs,EVACUATION_BUS_COUNT:new Gs,FIRE_ENGINE_COUNT:new Gs,FIRE_HELICOPTER_COUNT:new Gs,GARBAGE_ACCUMULATION:new Gs,GARBAGE_PROCESSING_CAPACITY:new Gs,GARBAGE_STORAGE:new Gs,GARBAGE_TRUCK_COUNT:new Gs,HEARSE_COUNT:new Gs,JAIL_CAPACITY:new Gs,LEISURE_PROVIDER_EFFECT:new Gs("EFFICIENCY","TYPE"),LEISURE_TYPE:new Vs,LOCAL_MODIFIER:new Vs,LOCAL_MODIFIER_EFFECT:new Gs("DELTA","TYPE","RADIUS"),MAIL_BOX_CAPACITY:new Gs,MAIL_SORTING_RATE:new Gs,MAIL_STORAGE_CAPACITY:new Gs,MAINTENANCE_VEHICLES:new Gs,MAP_RESOURCE:new Vs,MAX_UPKEEP:new Gs,MEDICAL_HELICOPTER_COUNT:new Gs,NETWORK_CAPACITY:new Gs,NETWORK_RANGE:new Gs,PATIENT_CAPACITY:new Gs,PATROL_CAR_COUNT:new Gs,POLICE_HELICOPTER_COUNT:new Gs,POST_TRUCK_COUNT:new Gs,POST_VAN_COUNT:new Gs,POWER_LINE_CAPACITY:new Gs,POWER_PLANT_OUTPUT:new Gs,POWER_VOLTAGE_FORMAT:new Gs("VALUE","VOLTAGE"),PRISON_VAN_COUNT:new Gs,REQUIRED_RESOURCE:new Gs,RESOURCE_CONSUMPTION:new Gs,SEWAGE_CAPACITY:new Gs,SEWAGE_PIPE_CAPACITY:new Gs,SEWAGE_PURIFICATION_RATE:new Gs,SHELTER_CAPACITY:new Gs,STUDENT_CAPACITY:new Gs,TRANSFORMER_CAPACITY:new Gs,TRANSFORMER_INPUT:new Gs,TRANSFORMER_OUTPUT:new Gs,TRANSPORT_STOP_COUNT:new Vs,TRANSPORT_VEHICLE_COUNT:new Gs,UPKEEP:new Gs,VOLTAGE:new Bs,WATER_CAPACITY:new Gs,WATER_CONSUMPTION:new Gs,WATER_PIPES:new Gs,WATER_PIPE_CAPACITY:new Gs,WATER_PIPE_TYPE:new Vs,WATER_PURIFICATION_RATE:new Gs,WATER_STORAGE:new Gs},Radio:{ADS_BUTTON_TOOLTIP:new Gs,EMERGENCY_MESSAGE:new Vs,FOCUS_EMERGENCY:new Gs,MUTE:new Gs,NETWORK_DESCRIPTION:new Vs,NETWORK_TITLE:new Vs,NEXT_BUTTON_TOOLTIP:new Gs,PANEL_TITLE:new Gs,PAUSE_BUTTON_TOOLTIP:new Gs,PLAY_BUTTON_TOOLTIP:new Gs,PREVIOUS_BUTTON_TOOLTIP:new Gs,PROGRAM_TITLE:new Gs,UNMUTE:new Gs,VOLUME_BUTTON_TOOLTIP:new Gs},Resources:{TITLE:new Vs},RoadsInfoPanel:{PARKED_CARS:new Gs,PARKING_AVAILABILITY:new Gs,PARKING_INCOME:new Gs,TRAFFIC_FLOW:new Gs},SelectedInfoPanel:{ACTIVE_VEHICLES:new Gs,ADVISER:new Gs,AIR_POLLUTION:new Gs,ALL_IS_WELL:new Gs,ANIMAL_TITLE:new Vs,ANIMAL_TYPE:new Vs,ATTRACTIVENESS:new Gs,ATTRACTIVENESS_BASE:new Gs,ATTRACTIVENESS_FACTORS:new Vs,AVERAGE_HOUSEHOLD_WEALTH:new Gs,BATTERY_STATE_CHARGING:new Gs,BATTERY_STATE_DISCHARGING:new Gs,BATTERY_STATE_IDLE:new Gs,BEGIN_EMPTYING:new Gs,BUILDING_FOR_RENT:new Gs,CARGO_TITLE:new Vs,CARGO_TOOLTIP:new Gs,CARGO_TRANSPORT_ROUTE:new Gs,CARGO_TRANSPORT_VEHICLE_TITLE:new Gs,CITIZEN_AGE:new Vs,CITIZEN_AGE_FEMALE:new Vs,CITIZEN_AGE_MALE:new Vs,CITIZEN_AGE_TITLE:new Gs,CITIZEN_CONDITION:new Gs,CITIZEN_CONDITION_DESCRIPTION:new Vs,CITIZEN_CONDITION_TITLE:new Vs,CITIZEN_CONDITION_TITLE_FEMALE:new Vs,CITIZEN_CONDITION_TITLE_MALE:new Vs,CITIZEN_DESTINATION:new Vs,CITIZEN_EDUCATION:new Vs,CITIZEN_EDUCATION_FEMALE:new Vs,CITIZEN_EDUCATION_MALE:new Vs,CITIZEN_EDUCATION_TITLE:new Gs,CITIZEN_HAPPINESS:new Gs,CITIZEN_HAPPINESS_DESCRIPTION:new Vs,CITIZEN_HAPPINESS_TITLE:new Vs,CITIZEN_HAPPINESS_TITLE_FEMALE:new Vs,CITIZEN_HAPPINESS_TITLE_MALE:new Vs,CITIZEN_HOUSEHOLD:new Gs,CITIZEN_JOB_LEVEL:new Vs,CITIZEN_JOB_TITLE:new Gs,CITIZEN_OCCUPATION:new Vs,CITIZEN_OCCUPATION_FEMALE:new Vs,CITIZEN_OCCUPATION_MALE:new Vs,CITIZEN_OCCUPATION_TITLE:new Gs,CITIZEN_RESIDENCE:new Vs,CITIZEN_SCHOOL_TITLE:new Bs,CITIZEN_STATE:new Vs,CITIZEN_STATE_FEMALE:new Vs,CITIZEN_STATE_MALE:new Vs,CITIZEN_TYPE:new Vs,CITIZEN_TYPE_FEMALE:new Vs,CITIZEN_TYPE_MALE:new Vs,CITIZEN_WEALTH:new Vs,CITIZEN_WEALTH_FEMALE:new Vs,CITIZEN_WEALTH_MALE:new Vs,CITIZEN_WEALTH_TITLE:new Gs,CITIZEN_WORKPLACE:new Vs,CLOSE:new Gs,COLOR:new Gs,COMPANY:new Gs,COMPANY_EXTRACTED:new Vs,COMPANY_PRODUCES:new Gs,COMPANY_PROFITABILITY_TITLE:new Vs,COMPANY_REQUIRES:new Gs,COMPANY_SELLS:new Gs,COMPANY_STORES:new Gs,CONFIRM_DELETE_WARNING:new Gs,CREATE_DISTRICT:new Gs,DEATHCARE_BODIES:new Gs,DEATHCARE_PROCESSING_SPEED:new Gs,DEATHCARE_TITLE:new Gs,DEATHCARE_VEHICLES:new Vs,DEATHCARE_VEHICLE_DEAD:new Gs,DEATHCARE_VEHICLE_TITLE:new Gs,DELETE:new Gs,DELIVERY_VEHICLE_TITLE:new Vs,DESTINATION:new Gs,DESTROYED:new Gs,DESTROYED_DESCRIPTION:new Vs,DESTROYED_STATUS:new Vs,DESTROYED_TREE:new Gs,DESTROYED_TREE_DESCRIPTION:new Vs,DETAILS:new Gs,DEVELOPER_INFO_TITLE:new Gs,DISPATCHED_VEHICLES:new Gs,DRIVER:new Gs,DURATION_GREATER_YEAR:new Gs,EDUCATED:new Gs,EDUCATION:new Gs,EDUCATION_DROPOUT_RATE:new Gs,EDUCATION_GRADUATION_TIME:new Gs,EDUCATION_LEVELS:new Vs,EDUCATION_NO_GRADUATIONS:new Gs,EDUCATION_STUDENTS:new Gs,EFFICIENCY:new Gs,EFFICIENCY_FACTORS:new Vs,ELECTRICITY_BATTERY_CAPACITY:new Gs,ELECTRICITY_BATTERY_CHARGE:new Gs,ELECTRICITY_BATTERY_FLOW:new Gs,ELECTRICITY_BATTERY_STATE:new Gs,ELECTRICITY_POWER_PRODUCTION:new Gs,ELECTRICITY_POWER_USAGE:new Gs,ELECTRICITY_TITLE:new Gs,ELECTRICITY_TRANSFORMER_CAPACITY:new Gs,EMPLOYEES:new Gs,EMPLOYEE_COUNT:new Gs("AMOUNT"),EMPTY_IN:new Gs("DURATION"),EXPENSES:new Gs,FIRE_TITLE:new Gs,FIRE_VEHICLES:new Vs,FIRE_VEHICLE_TITLE:new Vs,FOCUS:new Gs,FOLLOW_CITIZEN:new Gs,FULL_IN:new Gs("DURATION"),GARBAGE_MANAGEMENT_PROCESSING_SPEED:new Gs,GARBAGE_MANAGEMENT_STORAGE_LABEL:new Vs,GARBAGE_MANAGEMENT_STORED_GARBAGE:new Gs,GARBAGE_MANAGEMENT_TITLE:new Gs,GARBAGE_MANAGEMENT_VEHICLES:new Vs,GARBAGE_VEHICLE_TITLE:new Vs,GRAVES_IN_USE:new Gs,GROUND_POLLUTION:new Gs,HEALTHCARE_PATIENTS:new Gs,HEALTHCARE_TITLE:new Gs,HEALTHCARE_VEHICLES:new Vs,HEALTHCARE_VEHICLE_PATIENT:new Gs,HEALTHCARE_VEHICLE_TITLE:new Vs,HIGHTLY_EDUCATED:new Gs,HOUSEHOLDS:new Gs,HOUSEHOLD_MEMBERS:new Gs,LEVEL:new Gs,LEVEL_MAX:new Gs,LEVEL_PROGRESS:new Gs,LINE:new Gs,LINES:new Gs,LINE_USAGE:new Gs,LINE_VISUALIZER_LENGTH:new Gs,LINE_VISUALIZER_STOPS:new Gs,LINE_VISUALIZER_TITLE:new Gs,LINE_VISUALIZER_VEHICLES:new Gs,LOAD_TITLE:new Vs,LOCAL_SERVICES_NONE_ASSIGNED:new Gs,LOCAL_SERVICES_TITLE:new Gs,LOT_TOOL_TOOLTIP:new Gs,MAIL_PROCESSING_SPEED:new Gs,MAIL_SORTING_SPEED:new Gs,MAIL_STORED_MAIL:new Vs,MAIL_TITLE:new Gs,MAIL_VEHICLES:new Vs,MAINTENANCED_VEHICLES:new Gs,MAINTENANCE_VEHICLE_TITLE:new Gs,MAX_FOLLOWED_CITIZENS_REACHED:new Gs,NEXT_STOP:new Gs,NOISE_POLLUTION:new Gs,NOTIFICATIONS:new Gs,NO_ACTIVE_POLICIES:new Gs,OPEN_POSITIONS:new Gs,OPERATING_DISTRICTS:new Gs,ORIGIN:new Gs,OUTSIDE_CONNECTION:new Gs,OUT_OF_SERVICE:new Gs,OWNED_BY:new Gs,PARKING_FEE:new Gs,PARKING_PARKED:new Gs,PARKING_TITLE:new Gs,PARK_MAINTENANCE:new Gs,PARK_TITLE:new Gs,PASSENGERS:new Vs,PASSENGERS_TITLE:new Gs,PASSENGERS_TOOLTIP:new Gs,POLICE_PRISONERS:new Gs,POLICE_TITLE:new Gs,POLICE_VEHICLES:new Vs,POLICE_VEHICLE_CRIMINAL:new Gs,POLICE_VEHICLE_TITLE:new Vs,POLICIES:new Gs,POLLUTION:new Gs,POLLUTION_LEVELS:new Bs,POLLUTION_LEVELS_AIR:new Gs,POLLUTION_LEVELS_GROUND:new Gs,POLLUTION_LEVELS_NOISE:new Gs,POORLY_EDUCATED:new Gs,POST_VEHICLE_TITLE:new Gs,PRISON_PRISONERS:new Gs,PRISON_TITLE:new Gs,PRISON_VEHICLES:new Vs,PRIVATE_VEHICLE_TITLE:new Vs,PRODUCTION:new Gs,PUBLIC_TRANSPORT_LINE:new Gs,PUBLIC_TRANSPORT_VEHICLE_TITLE:new Vs,REBUILD:new Gs,RELOCATE:new Gs,REMOVE_OPERATING_DISTRICT:new Gs,RESIDENTS:new Gs,RESOURCE:new Vs,ROAD_CONDITION:new Gs,ROAD_CONDITION_FORMAT:new Gs("WORST","BEST","AVG"),ROAD_LENGTH:new Gs,ROAD_TRAFFIC_FLOW:new Gs,ROAD_TRAFFIC_VOLUME:new Gs,ROAD_UPKEEP:new Gs,ROUTE:new Gs,SCHEDULE:new Gs,SCHEDULE_CONTINUOUS_TOOLTIP:new Vs,SCHEDULE_DAY_TOOLTIP:new Vs,SCHEDULE_NIGHT_TOOLTIP:new Vs,SELECT_OPERATING_DISTRICT:new Gs,SELECT_VEHICLE:new Gs,SELECT_VEHICLE_SECONDARY:new Vs,SEWAGE_OUTLET_USAGE:new Gs,SEWAGE_PROCESSING_CAPACITY:new Gs,SEWAGE_PURIFICATION_RATE:new Gs,SEWAGE_STORAGE:new Gs,SEWAGE_TITLE:new Gs,SHELTER_OCCUPANTS:new Gs,SHELTER_TITLE:new Gs,SHELTER_VEHICLES:new Vs,STOP_EMPTYING:new Gs,TICKET_PRICE:new Gs,TICKET_PRICE_FREE:new Gs,TOOLTIP:new Vs,TOOLTIP_TITLE:new Vs,TRAFFIC_ACCIDENT:new Gs,UNDER_CONSTRUCTION:new Gs,UNEDUCATED:new Gs,UNFOCUS:new Gs,UNFOLLOW_CITIZEN:new Gs,UPGRADE:new Gs,UPGRADES:new Gs,UPGRADE_ALREADY_BUILT:new Gs,UPGRADE_LOCKED:new Gs,UPGRADE_LOCKED_LABEL:new Gs,UPGRADE_NO_MONEY_LABEL:new Gs,UPGRADE_PURCHASED_LABEL:new Gs,UPGRADE_TYPE_LABEL:new Vs,UPKEEP:new Gs,UPKEEPFORMAT:new Gs("RESOURCE","AMOUNT"),UPKEEP_MAINTENANCE:new Gs("BUILDING"),UPKEEP_MAINTENANCE_INACTIVE:new Gs("BUILDING"),UPKEEP_TOTAL:new Gs,VEHICLES:new Vs,VEHICLE_COUNT:new Gs,VEHICLE_STATE:new Gs,VEHICLE_STATES:new Vs,WAGES:new Gs,WAITING_PASSENGERS:new Gs,WAREHOUSE_STORAGE:new Gs,WATER_OUTPUT:new Gs,WATER_PUMPING_CAPACITY:new Gs,WATER_PUMP_POLLUTION:new Gs,WATER_PUMP_USAGE:new Gs,WATER_STORAGE:new Gs,WATER_STORAGE_CHANGE:new Gs("TIME","CHANGE"),WATER_STORAGE_FULL_IN:new Gs,WATER_STORAGE_LASTS:new Gs,WATER_TITLE:new Gs,WELL_EDUCATED:new Gs,WORKPLACES:new Gs,WORKPLACE_COUNT:new Gs("AMOUNT"),WORK_SHIFT:new Gs},Services:{DESCRIPTION:new Vs,NAME:new Vs},Statistics:{PANEL_TITLE:new Gs,STATISTIC:new Vs},StatisticsPanel:{STAT_TITLE:new Vs,TIME_SCALE:new Bs,TIME_SCALE_NOW:new Gs,TIME_SCALE_TITLE:new Gs},SubServices:{NAME:new Vs},ToolOptions:{COLOR_TITLE:new Vs,COLOR_TOOLTIP:new Vs,TOOLTIP:new Vs,TOOLTIP_DECREASE_BRUSH_SIZE:new Gs,TOOLTIP_DECREASE_BRUSH_STRENGTH:new Gs,TOOLTIP_DECREASE_ELEVATION:new Gs,TOOLTIP_DESCRIPTION:new Vs,TOOLTIP_ELEVATION_STEP:new Gs,TOOLTIP_INCREASE_BRUSH_SIZE:new Gs,TOOLTIP_INCREASE_BRUSH_STRENGTH:new Gs,TOOLTIP_INCREASE_ELEVATION:new Gs,TOOLTIP_SNAP_ALL:new Gs,TOOLTIP_TITLE:new Vs},Toolbar:{ASSET_ALREADY_BUILT:new Gs,BRUSH_SIZE:new Gs,BRUSH_STRENGTH:new Gs,CALENDAR_PANEL_TOGGLE_TOOLTIP:new Gs,CHIRPER_PANEL_TOGGLE_TOOLTIP:new Gs,CITY_INFO_PANEL_TOGGLE_TOOLTIP:new Gs,CITY_NAME_FIELD_TOOLTIP:new Gs,CURRENT_TREND:new Gs,DECREASE_PARALLEL_OFFSET:new Gs,ECONOMY_PANEL_TOGGLE_TOOLTIP:new Gs,ELEVATION_TITLE:new Gs,INCREASE_PARALLEL_OFFSET:new Gs,JOURNAL_PANEL_TOGGLE_TOOLTIP:new Gs,LIFEPATH_PANEL_TOGGLE_TOOLTIP:new Gs,MAP_TILE_PURCHASE_TOGGLE_TOOLTIP:new Gs,MONEY_FIELD_TOOLTIP:new Gs,PARALLEL_MODE_TITLE:new Gs,PARALLEL_OFFSET_TITLE:new Gs,PARALLEL_ROAD_TITLE:new Gs,PAUSE_BUTTON_TOOLTIP:new Gs,PHOTO_MODE_TOGGLE_TOOLTIP:new Gs,PLAY_BUTTON_TOOLTIP:new Gs,POPULATION_FIELD_TOOLTIP:new Gs,PROGRESSION_PANEL_TOGGLE_TOOLTIP:new Gs,SIMULATION_PAUSED:new Gs,SNAPPING_TITLE:new Gs,SPEED_BUTTON_TOOLTIP:new Gs,STATISTICS_PANEL_TOGGLE_TOOLTIP:new Gs,THEME_PANEL_TITLE:new Gs,TOGGLE_PARALLEL_MODE:new Gs,TOGGLE_UNDERGROUND_MODE:new Gs,TOOL_MODE_TITLE:new Gs,TOOL_OPTIONS_PANEL_TITLE:new Gs,UNDERGROUND_MODE_TITLE:new Gs,XP_MESSAGE:new Gs("XP","REASON"),XP_PROGRESS:new Gs("CURRENT","NEXT")},Tools:{BATTERY_CHARGE:new Gs,BATTERY_FLOW:new Gs,CONFIRM_BULLDOZE_WARNING:new Gs,CONSTRUCTION_COST_LABEL:new Gs,ELECTRICITY_CONSUMPTION_LABEL:new Gs,ELECTRICITY_FLOW_LABEL:new Gs,ELECTRICITY_PRODUCTION_LABEL:new Gs,EXTRACTOR_CLIMATE_REQUIRED_AVAILABLE:new Gs,EXTRACTOR_CLIMATE_REQUIRED_UNAVAILABLE:new Gs,EXTRACTOR_MAP_FEATURE_REQUIRED_AVAILABLE:new Gs,EXTRACTOR_MAP_FEATURE_REQUIRED_MISSING:new Gs,EXTRACTOR_PRODUCTION_DEFICIT:new Gs,EXTRACTOR_PRODUCTION_SURPLUS:new Gs,GROUNDWATER_VOLUME:new Gs,GROUND_WATER_RESERVOIR_USAGE:new Gs,INFO:new Vs,MOVING_OBJECT:new Gs("OBJECT"),REFUND_AMOUNT_LABEL:new Gs,RESOURCES_LABEL:new Gs,SELECTING_DISTRICTS:new Gs,SEWAGE_CONSUMPTION_LABEL:new Gs,SEWAGE_FLOW_LABEL:new Gs,STORAGECAPACITY_LABEL:new Gs,TOOL_MODE:new Vs,WARNING:new Vs,WATER_CONSUMPTION_LABEL:new Gs,WATER_FLOW_LABEL:new Gs,WATER_OUTPUT_LABEL:new Gs,WATER_REFRESH_RATE_LABEL:new Gs},TourismInfoPanel:{ATTRACTIVENESS:new Gs,AVERAGE_HOTEL_PRICE:new Gs,TOURISM_RATE:new Gs,WEATHER_EFFECT:new Gs},Transport:{LEGEND_ACTIVE:new Gs,LEGEND_ACTIVITY:new Gs,LEGEND_CARGO:new Gs,LEGEND_COLOR:new Gs,LEGEND_DELETE:new Gs,LEGEND_FOCUS:new Gs,LEGEND_LENGTH:new Gs,LEGEND_NAME:new Gs,LEGEND_PASSENGERS:new Vs,LEGEND_SHOW:new Gs,LEGEND_STOPS:new Vs,LEGEND_USAGE:new Gs,LEGEND_VEHICLES:new Vs,LEGEND_VISIBLE:new Gs,LINES:new Vs,LINES_OVERVIEW_BUTTON:new Gs,LINES_OVERVIEW_TITLE:new Gs,NO_LINES:new Gs,NO_ROUTES:new Gs,ROUTES:new Vs,TAB:new Vs,TOOLTIP_ACTIVE:new Vs,TOOLTIP_COLOR:new Vs,TOOLTIP_DELETE:new Vs,TOOLTIP_DETAILS:new Vs,TOOLTIP_SCHEDULE:new Vs,TOOLTIP_VISIBLE:new Vs},TransportInfoPanel:{CARGO_LABEL:new Gs,CARGO_TRANSPORT_TITLE:new Gs,CITIZENS:new Gs,LINES:new Gs,PUBLIC_TRANSPORT_TITLE:new Gs,ROUTES_LABEL:new Gs,SUMMARY_TOOLTIP_CARGO:new Vs,SUMMARY_TOOLTIP_PUBLICTRANSPORT:new Vs,TOTAL:new Gs,TOURISTS:new Gs},Tutorials:{ADVISOR_TITLE:new Gs,BEFORE_STARTING:new Gs,BEFORE_STARTING_CONFIRM:new Gs,BEGIN_WITH_TUTORIALS:new Gs,BUTTON_TOOLTIP_DONE:new Gs,BUTTON_TOOLTIP_NEXT:new Gs,BUTTON_TOOLTIP_PREVIOUS:new Gs,DESCRIPTION:new Vs,DESCRIPTION_GAMEPAD:new Vs,DESCRIPTION_KEYBOARD:new Vs,DISABLE_CONFIRMATION_TEXT:new Gs,DISABLE_CONFIRMATION_TEXT_GAMEPAD:new Gs,ENABLE_TUTORIALS_CONFIRM:new Gs,HINTS_TITLE:new Gs,INTRO:new Gs,INTRO_SUBTITLE:new Gs,INTRO_TITLE:new Gs,LIST_REMINDER_DESCRIPTION:new Gs,LIST_REMINDER_TITLE:new Gs,TASKS:new Gs,TITLE:new Vs,TODO_INTRO:new Gs,TODO_INTRO_CONFIRM:new Gs,TODO_OUTRO:new Gs,TODO_OUTRO_CONTINUE:new Gs,TODO_OUTRO_GAMEPAD:new Gs,TODO_OUTRO_NEW_CITY:new Gs,TRIGGER:new Vs},UpgradesMenu:{TITLE:new Gs},VirtualKeyboard:{TITLE:new Vs},WaterInfoPanel:{SEWAGE_TRADE:new Gs,SEWAGE_TREATMENT:new Gs,STORMWATER_TREATMENT:new Gs,WATER_AVAILABILITY:new Gs,WATER_EXPORT:new Gs,WATER_IMPORT:new Gs,WATER_STORAGE:new Gs,WATER_TRADE:new Gs},WaterPollutionInfoPanel:{AVERAGE_WATER_POLLUTION:new Gs},WorkplacesInfoPanel:{AVAILABILITY:new Gs,WORKERS:new Gs,WORKPLACES:new Gs,WORKPLACE_DISTRIBUTION:new Gs},ZoningFactors:{NEGATIVE:new Vs,PANEL_TITLE:new Gs,POSITIVE:new Vs}},Fs=Object.entries(Us).map((function(e){var t=ks(e,2),n=t[0];return[n,Ds(n,t[1])]})),Object.fromEntries(Fs));function Ws(e){return e.toFixed(0)}function zs(e,t){return e.toFixed(0).padStart(t,"0").substr(0,t)}var Ys=Os("LocalizedDate",(function(e,t){return qs(e,t.value)}),(function(e,t){return e.value.month===t.value.month&&e.value.year===t.value.year}));function Xs(){var e=bs();return(0,i.useCallback)((function(t){return qs(e,t)}),[e])}function qs(e,t){var n=t.year,r=t.month;return Ks.Common.MEDIUM_DATE_FORMAT.renderString(e,{MONTH:ec(e,r),YEAR:n.toFixed()})}var $s=Os("LocalizedTime",(function(e,t){return Zs(e,t.value)}),(function(e,t){return e.value.hour===t.value.hour&&e.value.minute===t.value.minute}));function Qs(){var e=bs();return(0,i.useCallback)((function(t){return Zs(e,t)}),[e])}function Zs(e,t){var n=t.hour,r=t.minute;return e.unitSettings.timeFormat===fs.TwentyFourHours?Ks.Common.TIME_FORMAT.renderString(e,{HOUR:zs(n,2),MINUTE:zs(r,2)}):Ks.Common.TIME_FORMAT_12.renderString(e,{HOUR:zs(n%12||12,2),MINUTE:zs(r,2),PERIOD:rc(e,n)})}var Js=Os("LocalizedDateTime",(function(e,t){return function(e,t){return"".concat(qs(e,t)," ").concat(Zs(e,t))}(e,t.value)}),(function(e,t){return e.value.month===t.value.month&&e.value.year===t.value.year&&e.value.hour===t.value.hour&&e.value.minute===t.value.minute}));function ec(e,t){return Ks.Common.MONTH_SHORT.renderString(e,{index:t})}var tc,nc=Os("LocalizedTimestamp",(function(e,t){return function(e,t){return(e.unitSettings.timeFormat===fs.TwentyFourHours?Ks.Common.TIMESTAMP_FORMAT.renderString(e,{}):Ks.Common.TIMESTAMP_FORMAT_12.renderString(e,{})).replace(/(yyyy|MM|M|dd|d|HH|H|hh|h|mm|aa)/g,(function(n){var r=new Date(t);switch(n){case"yyyy":return Ws(r.getFullYear());case"MM":return zs(r.getMonth()+1,2);case"M":return Ws(r.getMonth()+1);case"dd":return zs(r.getDate(),2);case"d":return Ws(r.getDate());case"HH":return zs(r.getHours(),2);case"H":return Ws(r.getHours());case"hh":return zs(r.getHours()%12||12,2);case"h":return Ws(r.getHours()%12||12);case"mm":return zs(r.getMinutes(),2);case"aa":return rc(e,r.getHours());default:return n}}))}(e,t.value)}),(function(e,t){return e.value===t.value}));function rc(e,t){return t<12?Ks.Common.TIME_PERIOD_AM.renderString(e,{}):Ks.Common.TIME_PERIOD_PM.renderString(e,{})}function ic(e){return 9*e/5+32}function oc(e){return e+273.16}function ac(e){return 264.172*e}function lc(e){return e/.45359237}function sc(e){return e/907.18474}function cc(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}!function(e){e.Integer="integer",e.IntegerRounded="integerRounded",e.IntegerPerMonth="integerPerMonth",e.IntegerPerHour="integerPerHour",e.FloatSingleFraction="floatSingleFraction",e.FloatTwoFractions="floatTwoFractions",e.FloatThreeFractions="floatThreeFractions",e.Percentage="percentage",e.PercentageSingleFraction="percentageSingleFraction",e.Angle="angle",e.Length="length",e.Area="area",e.Volume="volume",e.VolumePerMonth="volumePerMonth",e.Weight="weight",e.WeightPerCell="weightPerCell",e.WeightPerMonth="weightPerMonth",e.Power="power",e.Energy="energy",e.DataRate="dataRate",e.DataBytes="dataBytes",e.DataMegabytes="dataMegabytes",e.Money="money",e.MoneyPerCell="moneyPerCell",e.MoneyPerMonth="moneyPerMonth",e.MoneyPerHour="moneyPerHour",e.MoneyPerDistance="moneyPerDistance",e.MoneyPerDistancePerMonth="moneyPerDistancePerMonth",e.BodiesPerMonth="bodiesPerMonth",e.XP="xp",e.Temperature="temperature",e.NetElevation="netElevation"}(tc||(tc={}));var uc,dc=Os("LocalizedNumber",(function(e,t){var n=t.value,r=t.unit,i=void 0===r?tc.Integer:r,o=t.signed,a=void 0!==o&&o;return hc(i)(e,n,a)}),(function(e,t){return e.value===t.value&&e.unit===t.unit&&e.signed===t.signed}));function fc(e,t){var n=bs();return(0,i.useMemo)((function(){var r=hc(e);return function(e){return r(n,e,t)}}),[n,t,e])}function hc(e){var t;return null!==(t=mc[e])&&void 0!==t?t:function(t,n){return"".concat(n," <").concat(e,">")}}var mc=(cc(uc={},tc.Integer,(function(e,t,n){return pc(e,t,n,!0)})),cc(uc,tc.IntegerRounded,(function(e,t,n){return Math.abs(t)<1e3?pc(e,t,n,!0):Math.abs(t)<1e6?bc(e,t/1e3,Ks.Common.VALUE_THOUSAND,n,1):bc(e,t/1e6,Ks.Common.VALUE_MILLION,n,1)})),cc(uc,tc.IntegerPerMonth,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_PER_MONTH,n)})),cc(uc,tc.IntegerPerHour,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_PER_HOUR,n)})),cc(uc,tc.FloatSingleFraction,(function(e,t,n){return yc(e,t,n,1)})),cc(uc,tc.FloatTwoFractions,(function(e,t,n){return yc(e,t,n,2)})),cc(uc,tc.FloatThreeFractions,(function(e,t,n){return yc(e,t,n,3)})),cc(uc,tc.Percentage,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_PERCENT,n,!1)})),cc(uc,tc.PercentageSingleFraction,(function(e,t,n){return bc(e,t,Ks.Common.VALUE_PERCENT,n,1,!1)})),cc(uc,tc.Length,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?Math.abs(t)<1e3?vc(e,t,Ks.Common.VALUE_METER,n):bc(e,t/1e3,Ks.Common.VALUE_KILOMETER,n,1):Math.abs(t)<1609?vc(e,t/.9144,Ks.Common.VALUE_YARD,n):bc(e,t/1e3/1.609344,Ks.Common.VALUE_MILE,n,1)})),cc(uc,tc.NetElevation,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?bc(e,t,Ks.Common.VALUE_METER,n,2):bc(e,3*t,Ks.Common.VALUE_FOOT,n,2)})),cc(uc,tc.Area,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?Math.abs(t)<1e5?vc(e,t,Ks.Common.VALUE_SQUARE_METER,n):bc(e,t/1e6,Ks.Common.VALUE_SQUARE_KILOMETER,n,1):Math.abs(t)<1e5?vc(e,t/.092903,Ks.Common.VALUE_SQUARE_FOOT,n):bc(e,function(e){return e/4046.873}(t),Ks.Common.VALUE_ACRE,n,1)})),cc(uc,tc.Volume,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?bc(e,t,Ks.Common.VALUE_CUBIC_METER,n,1):vc(e,ac(t),Ks.Common.VALUE_GALLON,n)})),cc(uc,tc.VolumePerMonth,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?bc(e,t,Ks.Common.VALUE_CUBIC_METER_PER_MONTH,n,1):bc(e,ac(t),Ks.Common.VALUE_GALLON_PER_MONTH,n,1)})),cc(uc,tc.Weight,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?Math.abs(t)<100?vc(e,t,Ks.Common.VALUE_KILOGRAM,n):Math.abs(t)<1e7?bc(e,t/1e3,Ks.Common.VALUE_TON,n,1):bc(e,t/1e6,Ks.Common.VALUE_KILOTON,n,1):Math.abs(t)<100?vc(e,lc(t),Ks.Common.VALUE_POUND,n):Math.abs(t)<9071847.4?bc(e,sc(t),Ks.Common.VALUE_SHORT_TON,n,1):bc(e,sc(t)/1e6,Ks.Common.VALUE_SHORT_KILOTON,n,1)})),cc(uc,tc.WeightPerCell,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?bc(e,t/1e3,Ks.Common.VALUE_TON_PER_CELL,n,1):bc(e,sc(t),Ks.Common.VALUE_SHORT_TON_PER_CELL,n,1)})),cc(uc,tc.WeightPerMonth,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?Math.abs(t)<100?bc(e,t,Ks.Common.VALUE_KG_PER_MONTH,n,1):bc(e,t/1e3,Ks.Common.VALUE_TON_PER_MONTH,n,1):Math.abs(t)<100?bc(e,lc(t),Ks.Common.VALUE_POUND_PER_MONTH,n,1):bc(e,sc(t),Ks.Common.VALUE_SHORT_TON_PER_MONTH,n,1)})),cc(uc,tc.Power,(function(e,t,n){return Math.abs(t)<1e4?bc(e,t/10,Ks.Common.VALUE_KILOWATT,n,1):bc(e,t/1e4,Ks.Common.VALUE_MEGAWATT,n,2)})),cc(uc,tc.Energy,(function(e,t,n){return bc(e,t/1e4,Ks.Common.VALUE_MEGAWATT_HOURS,n,1)})),cc(uc,tc.DataRate,(function(e,t,n){return bc(e,t,Ks.Common.VALUE_GIGABIT_PER_SECOND,n,1)})),cc(uc,tc.DataBytes,(function(e,t,n){return jc(e,t,xc,n,1)})),cc(uc,tc.DataMegabytes,(function(e,t,n){return jc(e,1024*t*1024,_c,n,1)})),cc(uc,tc.Money,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_MONEY,n)})),cc(uc,tc.MoneyPerCell,(function(e,t,n){return bc(e,t,Ks.Common.VALUE_MONEY_PER_CELL,n,1)})),cc(uc,tc.MoneyPerMonth,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_MONEY_PER_MONTH,n)})),cc(uc,tc.MoneyPerHour,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_MONEY_PER_HOUR,n)})),cc(uc,tc.MoneyPerDistance,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?vc(e,t,Ks.Common.VALUE_MONEY_PER_KILOMETER,n):vc(e,t/1.6,Ks.Common.VALUE_MONEY_PER_MILE,n)})),cc(uc,tc.MoneyPerDistancePerMonth,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?vc(e,t,Ks.Common.VALUE_MONEY_PER_KILOMETER_PER_MONTH,n):vc(e,t/1.6,Ks.Common.VALUE_MONEY_PER_MILE_PER_MONTH,n)})),cc(uc,tc.XP,(function(e,t,n){return vc(e,t,Ks.Common.VALUE_XP,n)})),cc(uc,tc.Temperature,(function(e,t,n){switch(e.unitSettings.temperatureUnit){case hs.Celsius:return vc(e,t,Ks.Common.VALUE_CELSIUS,n);case hs.Fahrenheit:return vc(e,ic(t),Ks.Common.VALUE_FAHRENHEIT,n);case hs.Kelvin:return vc(e,oc(t),Ks.Common.VALUE_KELVIN,n)}})),cc(uc,tc.Angle,(function(e,t,n){return bc(e,t,Ks.Common.VALUE_ANGLE,n,1)})),uc);function pc(e,t){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return Oc(t,n)+gc(e,t,r)}function vc(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];return n.renderString(e,{SIGN:Oc(t,r),VALUE:gc(e,t,i)})}function gc(e,t,n){if(n){var r=Ks.Common.THOUSANDS_SEPARATOR.renderString(e,{});return Math.abs(t).toFixed(0).replace(/\B(?=(\d{3})+(?!\d))/g,r)}return Math.abs(t).toFixed(0)}function yc(e,t){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5];return Oc(t,n)+Ec(e,t,r,i,o)}function bc(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6];return n.renderString(e,{SIGN:Oc(t,r),VALUE:Ec(e,t,i,o,a)})}var xc=[[0,Ks.Common.VALUE_BYTE],[1,Ks.Common.VALUE_KILOBYTE],[2,Ks.Common.VALUE_MEGABYTE],[3,Ks.Common.VALUE_GIGABYTE],[4,Ks.Common.VALUE_TERABYTE]],_c=[[2,Ks.Common.VALUE_MEGABYTE],[3,Ks.Common.VALUE_GIGABYTE],[4,Ks.Common.VALUE_TERABYTE]];function jc(e,t,n){for(var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6],l=n[n.length-1][1],s=t/Math.pow(1024,n[n.length-1][0]),c=0;c<n.length;++c){var u=Math.pow(1024,n[c][0]);if(Math.abs(t)<512*u){l=n[c][1],s=t/u;break}}return l.renderString(e,{SIGN:Oc(t,r),VALUE:Ec(e,s,i,o,a)})}function Ec(e,t,n,r,i){t=Math.abs(t);var o,a=Ks.Common.DECIMAL_SEPARATOR.renderString(e,{});if(t<100){var l=Math.pow(10,-n);0!==t&&t<l&&(t=l),o=t.toFixed(n),i&&(o=o.replace(/\.0+$|(\.\d*?[1-9])0+$/g,"$1")),o=o.replace(".",a)}else o=t.toFixed(0);if(r){var s=Ks.Common.THOUSANDS_SEPARATOR.renderString(e,{});o=o.replace(/\B(?=(\d{3})+(?!\d))/g,s)}return o}function Oc(e,t){return e<0?"-":e>0?t?"+":"":t?"±":""}const Tc="full-width-digits_dns",Ic="digits_a1g",Sc="blind_u0R";var wc=/([\d:-]+)|([^\d:-]+)/g,Nc=/\d/g,Pc=function(t){var n=t.className,r=xs(t.children),o=(0,i.useMemo)((function(){var t;return null===(t=r.match(wc))||void 0===t?void 0:t.map((function(t,n){return Nc.test(t)?(0,e.jsxs)("div",{className:Ic,children:[t,(0,e.jsx)("div",{className:Sc,children:t.replace(Nc,"0")})]},n):t}))}),[r]);return(0,e.jsx)("div",{className:Oe()(Tc,n),children:o})},Cc=n(935);function Ac(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Lc(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ac(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ac(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Mc=i.createContext(document.body),Rc=function(t){var n=t.children;if(!Ut(n))throw new Error("PortalContainerProvider requires a single child react element!");var r=(0,i.useContext)(Mc),o=Lc((0,i.useState)(null),2),a=o[0],l=o[1];return(0,e.jsx)(Mc.Provider,{value:null!=a?a:r,children:(0,e.jsx)(zn,{ref:l,children:n})})},kc=function(e){var t=e.children,n=(0,i.useContext)(Mc);return Cc.createPortal(t,n)};var Dc="tutorials",Uc=E(Dc,"tutorialsEnabled"),Fc=E(Dc,"introActive"),Gc=E(Dc,"activeList"),Vc=E(Dc,"next"),Bc=E(Dc,"pending"),Hc=E(Dc,"categories"),Kc=(T(Dc,"groups"),O(!1)),Wc=function(e){Kc.update(e)},zc=T(Dc,"tutorials"),Yc=E(Dc,"activeTutorial"),Xc=E(Dc,"activeTutorialPhase"),qc=E(Dc,"listIntroActive"),$c=E(Dc,"listOutroActive"),Qc=w(Dc,"activateTutorial"),Zc=w(Dc,"activateTutorialPhase"),Jc=w(Dc,"forceTutorial"),eu=function(){return Wc(!Kc.value)},tu=S(Dc,"completeActiveTutorialPhase"),nu=S(Dc,"completeActiveTutorial"),ru=w(Dc,"completeIntro"),iu=S(Dc,"completeListIntro"),ou=S(Dc,"completeListOutro"),au=w(Dc,"setTutorialTagActive"),lu=w(Dc,"activateTutorialTrigger"),su=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,i.useEffect)((function(){if(e&&t)return au(e,!0),function(){au(e,!1)}}),[t,e])},cu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,i.useEffect)((function(){e&&t&&lu(e)}),[e,t])};function uu(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,i.useEffect)((function(){if(e&&t)return lu(e),au(e,!0),function(){au(e,!1)}}),[t,e])}var du,fu,hu=O(!1);function mu(){hu.update(!hu.value)}function pu(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vu(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return pu(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pu(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e[e.Tutorial=0]="Tutorial",e[e.Group=1]="Group"}(du||(du={})),function(e){e[e.Balloon=0]="Balloon",e[e.Card=1]="Card",e[e.CenterCard=2]="CenterCard"}(fu||(fu={}));var gu=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.activeBlinkTags=new Array,this.activeBalloonTags=new Array,this.mountedBlinkComponents=new Map,this.mountedBalloonComponents=new Map,this.blinkTagsDirty=!0,this.balloonTagsDirty=!0}var t=e.prototype;return t.activateTags=function(e,t){var n=this;this.activeBlinkTags.length=0,this.activeBalloonTags.length=0,null!==e&&e.forEach((function(e){return n.activeBlinkTags.push(e.map((function(e){return e.toLowerCase()})))})),null!==t&&t.forEach((function(e){return n.activeBalloonTags.push(e.toLowerCase())})),this.refreshBlinkTags(),this.refreshBalloonTags()},t.mountBlinkListener=function(e,t){this.mountedBlinkComponents.set(e.toLowerCase(),t),this.blinkTagsDirty=!0},t.mountBalloonListener=function(e,t,n,r){this.mountedBalloonComponents.set(e.toLowerCase(),[t,n,r]),this.balloonTagsDirty=!0},t.unmountBlinkListener=function(e){this.mountedBlinkComponents.delete(e.toLowerCase()),this.blinkTagsDirty=!0},t.unmountBalloonListener=function(e){this.mountedBalloonComponents.delete(e.toLowerCase()),this.balloonTagsDirty=!0},t.refreshBlinkTags=function(){var e=this.FindTopBlinkTags();this.mountedBlinkComponents.forEach((function(t,n){return t(null!=e&&void 0!==e.find((function(e){return e.split("|").map((function(e){return e.trim()})).includes(n)})))})),this.blinkTagsDirty=!1},t.refreshBalloonTags=function(){var e=this,t=vu(this.FindTopBalloonTag(),2),n=t[0],r=t[1];this.mountedBalloonComponents.forEach((function(t,i){var o=vu(t,3),a=o[0],l=o[1],s=o[2],c=!1,u=null==n?void 0:n.split("|").map((function(e){return e.trim()}));if(void 0!==u){var d=u.indexOf(i);if(d>0){for(var f=!0,h=d-1;h>=0;h--)e.mountedBalloonComponents.has(u[h])&&(f=!1);c=f}else c=0===d}a(c),l(c&&n!==e.activeBalloonTags[0]),s(r)})),this.balloonTagsDirty=!1},t.isBlinkTagsDirty=function(){return this.blinkTagsDirty},t.isBalloonTagsDirty=function(){return this.balloonTagsDirty},t.FindTopBlinkTags=function(){for(var e=0;e<this.activeBlinkTags.length;++e)for(var t=0;t<this.activeBlinkTags[e].length;t++)if(this.mountedBlinkComponents.has(this.activeBlinkTags[e][t]))return this.activeBlinkTags[e];return null},t.FindTopBalloonTag=function(){for(var e,t=this,n=function(e){for(var n=t.activeBalloonTags[e].split("|").map((function(e){return e.trim()})),r=0;r<n.length;r++)if(t.mountedBalloonComponents.has(n[r]))return{v:[t.activeBalloonTags[e],e]}},r=0;r<this.activeBalloonTags.length;++r){var i=n(r);if("object"==((e=i)&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e))return i.v}return[null,-1]},e}(),yu=new gu,bu=i.createContext(yu),xu=i.createContext(!1),_u=function(t){var n,r=t.children,i=C(Xc),o=null!=i&&i.type===fu.Balloon?i.balloonTargets.map((function(e){return e.uiTag})):null,a=(null==i||null===(n=i.trigger)||void 0===n?void 0:n.active)?i.trigger.blinkTags:null;return ju(a,o),(0,e.jsx)(bu.Provider,{value:yu,children:r})},ju=function(e,t){var n=(0,i.useContext)(bu);(0,i.useEffect)((function(){return n.activateTags(e,t),function(){return n.activateTags(null,null)}}),[n,e,t]),(0,i.useEffect)((function(){var e=0,t=function(){n.isBalloonTagsDirty()&&n.refreshBalloonTags(),n.isBlinkTagsDirty()&&n.refreshBlinkTags(),e=window.requestAnimationFrame(t)};return t(),function(){return window.cancelAnimationFrame(e)}}),[n])};const Eu={"tooltip-base":"tooltip-base_zwi",tooltipBase:"tooltip-base_zwi","tooltip-fade-in":"tooltip-fade-in_S9n",tooltipFadeIn:"tooltip-fade-in_S9n",fadeIn:"fadeIn_VY9",tooltip:"tooltip_xe4 tooltip-base_zwi tooltip-fade-in_S9n"};function Ou(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Tu(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Iu(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ou(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ou(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Su=0,wu=16,Nu=function(t){var n=t.tooltip,r=t.disabled,o=t.theme,a=t.alwaysVisible,l=void 0!==a&&a,s=t.screenSpacePosition,c=void 0!==s&&s,u=t.style,d=t.className,f=t.children;if(!c&&!i.isValidElement(f))throw new Error("Tooltip requires a single child react element!");var h=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Tu(e,t,n[t])}))}return e}({},Eu,o)}),[o]),m=Iu((0,i.useState)(l),2),p=m[0],v=m[1],g=(0,i.useRef)(ct),y=(0,i.useRef)(null),b=(0,i.useCallback)((function(e){y.current=e,null!=e&&Pu(e,g.current)}),[]),x=(0,i.useCallback)((function(e){g.current=pt(e),v(l||!0)}),[l]),_=(0,i.useCallback)((function(e){g.current=pt(e),null!=y.current&&Pu(y.current,g.current,c)}),[c]),j=(0,i.useCallback)((function(e){return v(l||!1)}),[l]),E=(0,i.useCallback)((function(e){return v(l||!1)}),[l]),O=(0,i.useRef)(null),T=(0,i.useCallback)((function(e){O.current!==e&&(null!=O.current&&(O.current.removeEventListener("mouseover",x),O.current.removeEventListener("mousemove",_),O.current.removeEventListener("mouseleave",j),O.current.removeEventListener("mousedown",E)),null!=e&&(e.addEventListener("mouseover",x),e.addEventListener("mousemove",_),e.addEventListener("mouseleave",j),e.addEventListener("mousedown",E)),O.current=e)}),[E,j,_,x]);(0,i.useEffect)((function(){c&&T(document.body)}),[c]);var I=!!n&&(c||i.Children.count(f)>0),S=(0,i.useContext)(xu);return(0,e.jsxs)(e.Fragment,{children:[!c&&(0,e.jsx)(zn,{ref:T,children:f}),I&&!r&&p&&!S&&(0,e.jsx)(kc,{children:(0,e.jsx)("div",{className:Oe()(h.tooltip,d),style:u,ref:b,children:n})})]})};function Pu(e,t,n){var r=t.x+Su,i=t.y+wu;if(n)return e.style.left="".concat(r,"px"),void(e.style.top="".concat(i,"px"));e.style.left="".concat(r,"px"),e.style.top="".concat(i,"px"),requestAnimationFrame((function(){var t=e.getBoundingClientRect(),n=window.innerWidth-t.width,o=window.innerHeight-t.height;r>n&&(e.style.left="".concat(n,"px")),i>o&&(e.style.top="".concat(o,"px"))}))}var Cu,Au,Lu="menu";!function(e){e[e.Menu=0]="Menu",e[e.NewGame=1]="NewGame",e[e.LoadGame=2]="LoadGame",e[e.Options=3]="Options",e[e.Credits=4]="Credits"}(Cu||(Cu={})),function(e){e[e.None=-1]="None",e[e.Default=0]="Default",e[e.Custom=1]="Custom"}(Au||(Au={}));var Mu,Ru=E(Lu,"activeScreen"),ku=E(Lu,"gameVersion"),Du=E(Lu,"canContinueGame"),Uu=E(Lu,"hasCompletedTutorials"),Fu=E(Lu,"showTutorials"),Gu=E(Lu,"modsEnabled"),Vu=E(Lu,"pdxModsUIEnabled"),Bu=E(Lu,"hideEditorButton"),Hu=E(Lu,"hideModsUIButton"),Ku=E(Lu,"savePreview"),Wu=E(Lu,"mapName"),zu=E(Lu,"lastSaveName"),Yu=E(Lu,"defaultGameOptions"),Xu=E(Lu,"canExitGame"),qu=E(Lu,"saveGameSlots"),$u=E(Lu,"isModsUIActive"),Qu=E(Lu,"themes"),Zu=E(Lu,"maps"),Ju=E(Lu,"availableMapFilters"),ed=E(Lu,"selectedMapFilter"),td=E(Lu,"saves"),nd=E(Lu,"creditFiles"),rd=E(Lu,"saveabilityStatus");function id(e){N(Lu,"setActiveScreen",e)}function od(){N(Lu,"continueGame")}function ad(){N(Lu,"startEditor")}function ld(){N(Lu,"showPdxModsUI")}function sd(e){N(Lu,"onSaveGameScreenVisibilityChanged",e)}function cd(e){N(Lu,"applyTutorialSettings",e===Mu.Continue||e===Mu.Reset,e===Mu.Reset)}function ud(){var e=C(Fu);return(0,i.useState)(e?Mu.Continue:Mu.Disable)}!function(e){e[e.Continue=0]="Continue",e[e.Reset=1]="Reset",e[e.Disable=2]="Disable"}(Mu||(Mu={}));var dd=S(Lu,"quicksave"),fd=w(Lu,"quickload"),hd=E(Lu,"availableCloudTargets"),md=E(Lu,"selectedCloudTarget"),pd=E(Lu,"dismissLoadGameConfirmation"),vd=w(Lu,"selectCloudTarget"),gd=w(Lu,"selectMapFilter");const yd="item_OsC",bd="locked_Yoi",xd="theme-icon_yUd",_d="title_qyE",jd="population-value_yQT",Ed="population-icon_PF9",Od="date_OyK",Td="state-icon_YfD",Id="title-inner_io2",Sd="tooltip_cZx";var wd=function(t){var n,r=t.save,o=t.selected,a=t.locked,l=t.tooltipsInactive,s=t.onClick,c=(0,i.useCallback)((function(){return s(r)}),[r,s]),u=C(Qu).find((function(e){return e.id===r.theme})),d=Nd(r.cloudTarget,r.isReadonly);return(0,e.jsxs)(ml,{focusKey:r.id,selected:o,className:Oe()(yd,a&&bd),onClick:c,children:[(0,e.jsx)(As,{src:null!==(n=null==u?void 0:u.icon)&&void 0!==n?n:"",className:xd}),null!=d&&(0,e.jsx)(Nu,{tooltip:Pd(r),disabled:l,className:Sd,children:(0,e.jsx)(ll,{src:d,className:Td})}),(0,e.jsx)("div",{className:_d,children:(0,e.jsx)(Nu,{tooltip:Cd(r.path),disabled:l,className:Sd,style:{maxWidth:screen.availWidth},children:(0,e.jsx)("div",{className:Id,children:r.displayName})})}),(0,e.jsx)("div",{className:jd,children:(0,e.jsx)(dc,{value:r.population,unit:tc.Integer})}),(0,e.jsx)(ll,{src:"Media/Game/Icons/Citizen.svg",className:Ed}),(0,e.jsx)(Pc,{className:Od,children:(0,e.jsx)(nc,{value:r.lastModified})})]})};function Nd(e,t){return t?"Media/Glyphs/Lock.svg":"PdxSdk"===e?"Media/Glyphs/PDXCloud.svg":"Steamworks"===e?"Media/Glyphs/SteamCloud.svg":"Gdk"===e?"Media/Glyphs/GdkCloud.svg":null}function Pd(t){return t.isReadonly?(0,e.jsx)(Ks.Menu.READONLY_SAVE,{}):"PdxSdk"===t.cloudTarget?(0,e.jsx)(Ks.Menu.PARADOXCLOUD_SAVE,{}):"Steamworks"===t.cloudTarget?(0,e.jsx)(Ks.Menu.STEAMCLOUD_SAVE,{}):"Gdk"===t.cloudTarget?(0,e.jsx)(Ks.Menu.GDKCLOUD_SAVE,{}):null}function Cd(e){return null==e?void 0:e.replaceAll(/([/\\])/g,"$1​")}const Ad={button:"button_HeP",negative:"negative_ocn"};var Ld=n(431);function Md(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Rd(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function kd(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Md(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Md(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Dd(e){return{x:e.offsetWidth,y:e.offsetHeight}}function Ud(e){return{x:e.clientWidth,y:e.clientHeight}}function Fd(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Dd,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=kd((0,i.useState)(null),2),o=r[0],a=r[1],l=(0,i.useCallback)((function(){if(null!=e.current){var n=t(e.current);a((function(e){return null!=e&&ut(n,e)?e:n}))}else a(null)}),[e,t]);return Hd(l,n),(0,i.useEffect)((function(){if(n){var e=window.requestAnimationFrame((function(){e=window.requestAnimationFrame((function(){e=0,l()})),l()}));return function(){return window.cancelAnimationFrame(e)}}a(null)}),[n,l]),o}function Gd(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=kd((0,i.useState)(null),2),r=n[0],o=n[1],a=(0,i.useCallback)((function(){if(null!=e.current){var t=e.current.getBoundingClientRect();o((function(e){return null!=e&&Vd(t,e)?e:t}))}else o(null)}),[e]);return Hd(a,t),(0,i.useEffect)((function(){if(t){var e=window.requestAnimationFrame((function(){e=window.requestAnimationFrame((function(){e=0,a()})),a()}));return function(){window.cancelAnimationFrame(e)}}o(null)}),[t,a]),r}function Vd(e,t){return Math.abs(e.top-t.top)<.1&&Math.abs(e.bottom-t.bottom)<.1&&Math.abs(e.left-t.left)<.1&&Math.abs(e.right-t.right)<.1&&Math.abs(e.width-t.width)<.1&&Math.abs(e.height-t.height)<.1}var Bd=["top","right","bottom","left","width","height","size","weight"];function Hd(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=(0,i.useRef)(!1);(0,i.useEffect)((function(){if(t){n.current=!0;var r=0,i=function(){n.current&&0===r&&(r=window.requestAnimationFrame((function(){r=window.requestAnimationFrame((function(){r=0,e()}))})))},o=new MutationObserver(i);o.observe(document,{attributes:!0,childList:!0,characterData:!0,subtree:!0});var a=function(e){if(Rd(e.target,HTMLElement)){var t=window.getComputedStyle(e.target).transitionProperty;Bd.some((function(e){return t.includes(e)}))&&i()}};document.addEventListener("transitionend",a);var l=function(){n.current&&(window.cancelAnimationFrame(r),r=window.requestAnimationFrame((function(){r=window.requestAnimationFrame((function(){r=0,e()}))})))};return window.addEventListener("resize",l),function(){n.current=!1,o.disconnect(),document.removeEventListener("transitionend",a),window.removeEventListener("resize",l),window.cancelAnimationFrame(r)}}}),[t,e])}function Kd(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Wd(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Kd(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Kd(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}const zd=function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],t=Wd((0,i.useState)({x:window.innerWidth,y:window.innerHeight}),2),n=t[0],r=t[1];return(0,i.useEffect)((function(){if(e){var t=function(){var e={x:window.innerWidth,y:window.innerHeight};r((function(t){return ut(e,t)?t:e}))};return t(),window.addEventListener("resize",t),function(){return window.removeEventListener("resize",t)}}}),[e,r]),n};function Yd(){var e=zd();return C(Zl)?e.y>.5625*e.x?e.x/1920:e.y/1080:1}function Xd(e){var t=Yd();if(e.endsWith("rem"))return parseFloat(e.substring(0,e.length-3))*t;if(e.endsWith("px"))return parseFloat(e.substring(0,e.length-2));throw Error("Unsupport length syntax: ".concat(e))}const qd=Yd;function $d(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Qd(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return $d(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $d(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Zd(e,t,n){var r=Qd((0,i.useState)(!1),2),o=r[0],a=r[1],l=Qd((0,i.useState)(),2),s=l[0],c=l[1],u=(0,i.useCallback)((function(t){e(t)&&(c(t.currentTarget),t.preventDefault(),a(!0))}),[e,c]),d=(0,i.useCallback)((function(e){e.preventDefault(),t({clientX:e.clientX,clientY:e.clientY,currentTarget:s})}),[t,s]),f=(0,i.useCallback)((function(e){e.preventDefault(),a(!1),n({clientX:e.clientX,clientY:e.clientY,currentTarget:s})}),[n,s]);return(0,i.useEffect)((function(){if(o)return document.addEventListener("mousemove",d),document.addEventListener("mouseup",f),function(){document.removeEventListener("mousemove",d),document.removeEventListener("mouseup",f)}}),[o,d,f]),[o,u]}const Jd="scrollable_DXr",ef="content_gqa",tf="x_TNK",nf="y_SMM",rf="track-visible-y_RCA",of="track_e3O",af="track-visible-x_qNT",lf="thumb_Cib",sf="pressed_iMJ",cf="bottom-padding_JS3";function uf(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function df(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return uf(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uf(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ff=n.n(Ld)()(.445,.05,.55,.95),hf={speed:20,delay:3e3,repeat:!0,minOverflow:8},mf=i.forwardRef((function(t,n){var r=t.horizontal,o=void 0!==r&&r,a=t.vertical,l=void 0===a||a,s=t.trackVisibility,c=void 0===s?"scrollable":s,u=t.overshootX,d=void 0===u?.05:u,f=t.overshootY,h=void 0===f?.05:f,m=t.smooth,p=void 0===m||m,v=t.controller,g=t.className,y=t.style,b=t.children,x=t.onScroll,_=t.autoScroll,j=void 0!==_&&_,E=t.autoScrollSettings,O=void 0===E?hf:E,T=df((0,i.useState)(j),2),I=T[0],S=T[1],w=df((0,i.useState)(!1),2),N=w[0],P=w[1],C=df((0,i.useState)(!1),2),A=C[0],L=C[1],M=(0,i.useRef)(null),R=Je(n,M),k=(0,i.useRef)(null),D=(0,i.useRef)(null),U=(0,i.useRef)(null),F=(0,i.useRef)(null),G=(0,i.useCallback)((function(){if(M.current&&k.current&&D.current){var e=M.current.offsetWidth,t=M.current.scrollWidth,n=at(M.current.scrollLeft,0,t-e),r=k.current.offsetWidth;if(0!==e&&0!==t&&0!==r){var i=t-1>e;if(P(i),i){var o=at(r*e/t,Math.min(20,r/2),r),a=n/(t-e)*(r-o);D.current.style.width="".concat(o,"px"),D.current.style.left="".concat(a,"px")}}}}),[]),V=(0,i.useCallback)((function(){if(M.current&&U.current&&F.current){var e=M.current.offsetHeight,t=M.current.scrollHeight,n=at(M.current.scrollTop,0,t-e),r=U.current.offsetHeight;if(0!==e&&0!==t&&0!==r){var i=t-1>e;if(L(i),i){var o=at(r*e/t,Math.min(20,r/2),r),a=n/(t-e)*(r-o);F.current.style.height="".concat(o,"px"),F.current.style.top="".concat(a,"px")}}}}),[]),B=(0,i.useCallback)((function(){o&&G(),l&&V()}),[o,G,V,l]),H=(0,i.useCallback)((function(){S(!1)}),[]),K=(0,i.useCallback)((function(){S(!0)}),[]),W=(0,i.useCallback)((function(){x&&x(),B()}),[x,B]),z=(0,i.useRef)(0),Y=(0,i.useRef)(0),X=(0,i.useCallback)((function(e){var t=e.clientX;if(S(!1),!D.current)return!1;var n=D.current.getBoundingClientRect(),r=n.width,i=n.left;return 0!==r&&(z.current=(t-i)/r,!0)}),[]),q=(0,i.useCallback)((function(e){var t=e.clientY;if(S(!1),!F.current)return!1;var n=F.current.getBoundingClientRect(),r=n.height,i=n.top;return 0!==r&&(Y.current=(t-i)/r,!0)}),[]),$=(0,i.useCallback)((function(e){var t=e.clientX;if(M.current&&k.current&&D.current){var n=M.current.offsetWidth,r=M.current.scrollWidth,i=k.current.getBoundingClientRect(),o=D.current.getBoundingClientRect();if(0!==n&&0!==r&&0!==i.width){var a=i.width-o.width;if(0!==a){var l=M.current.scrollLeft,s=at((t-i.left-o.width*z.current)/a,0,1)*(r-n);l!==s&&(M.current.scrollLeft=s,x&&x(),G())}}}}),[x,G]),Q=(0,i.useCallback)((function(e){var t=e.clientY;if(M.current&&U.current&&F.current){var n=M.current.offsetHeight,r=M.current.scrollHeight,i=U.current.getBoundingClientRect(),o=F.current.getBoundingClientRect();if(0!==n&&0!==r&&0!==i.height){var a=i.height-o.height;if(0!==a){var l=M.current.scrollTop,s=at((t-i.top-o.height*Y.current)/a,0,1)*(r-n);l!==s&&(M.current.scrollTop=s,x&&x(),V())}}}}),[x,V]),Z=(0,i.useCallback)((function(){S(!0)}),[]),J=df(Zd(X,$,Z),2),ee=J[0],te=J[1],ne=df(Zd(q,Q,Z),2),re=ne[0],ie=ne[1];Hd(B),(0,i.useEffect)((function(){var e=window.requestAnimationFrame((function(){e=window.requestAnimationFrame((function(){e=0,B()}))}));return function(){window.cancelAnimationFrame(e)}}),[B]);var oe=(0,i.useRef)(0),ae=(0,i.useCallback)((function(e,t){M.current&&(window.cancelAnimationFrame(oe.current),e=at(e,0,M.current.scrollWidth-M.current.offsetWidth),t=at(t,0,M.current.scrollHeight-M.current.offsetHeight),e===M.current.scrollLeft&&t===M.current.scrollTop||(M.current.scrollLeft=e,M.current.scrollTop=t,x&&x()),B())}),[x,B]),le=(0,i.useCallback)((function(e,t){if(M.current){window.cancelAnimationFrame(oe.current);var n=performance.now(),r=M.current.scrollLeft,i=M.current.scrollTop,o=function(a){if(M.current){var l=(a-n)/175;if(l<1){var s=ff(l),c=at(Math.round(r+(e-r)*s),0,M.current.scrollWidth-M.current.offsetWidth),u=at(Math.round(i+(t-i)*s),0,M.current.scrollHeight-M.current.offsetHeight);u===i&&c===r||x&&x(),M.current.scrollLeft=c,M.current.scrollTop=u,B(),oe.current=window.requestAnimationFrame(o)}else M.current.scrollLeft=e,M.current.scrollTop=t,B()}};oe.current=window.requestAnimationFrame(o)}}),[x,B]);(0,i.useEffect)((function(){return function(){return window.cancelAnimationFrame(oe.current)}}),[]);var se=(0,i.useMemo)((function(){return{updateThumbs:function(){window.requestAnimationFrame((function(){window.requestAnimationFrame(B)}))},scrollTo:function(e,t){ae(e,t)},scrollBy:function(e,t){M.current&&ae(M.current.scrollLeft+e,M.current.scrollTop+t)},smoothScrollTo:function(e,t){le(e,t)},scrollIntoView:function(e){if(M.current){var t=M.current.getBoundingClientRect(),n=e.getBoundingClientRect(),r=M.current.scrollLeft,i=M.current.scrollTop;if(o){var a=t.width*d;n.left<t.left+a?r=Math.floor(M.current.scrollLeft+n.left-t.left-a):n.right>t.right-a&&(r=Math.ceil(M.current.scrollLeft+n.right-t.right+a)),r=at(r,0,Math.ceil(M.current.scrollWidth-t.width))}if(l){var s=t.height*h;n.top<t.top+s?i=Math.floor(M.current.scrollTop+n.top-t.top-s):n.bottom>t.bottom-s&&(i=Math.ceil(M.current.scrollTop+n.bottom-t.bottom+s)),i=at(i,0,Math.ceil(M.current.scrollHeight-t.height))}r===M.current.scrollLeft&&i===M.current.scrollTop||(p?le(r,i):ae(r,i))}}}}),[B,ae,le,o,l,d,h,p]);return(0,i.useEffect)((function(){if(v)return v._attachCallback(se),function(){return v._detachCallback(se)}}),[v,se]),(0,i.useEffect)((function(){return S(j)}),[j]),function(e,t,n,r,o,a){var l=qd();(0,i.useEffect)((function(){var i,s,c=(null==a?void 0:a.current)||0,u=!1;if(window.cancelAnimationFrame(c),e&&t.current&&o){var d=function(f){if(e&&t.current&&o){if(void 0===i&&(i=f),f-i<o.delay)return c=window.requestAnimationFrame(d),void(void 0!==a&&(a.current=c));void 0===s&&(s=f);var h=(f-s)/1e3,m=Math.round(o.speed*h*l),p="Vertical"===n?t.current.scrollHeight-t.current.offsetHeight:t.current.scrollWidth-t.current.offsetWidth;if(p<o.minOverflow*l)return t.current.scrollTop=0,void r();var v=u?p-m:m;"Vertical"===n?v!==t.current.scrollTop&&(t.current.scrollTop=v,r()):v!==t.current.scrollLeft&&(t.current.scrollLeft=v,r()),!u&&v<p||u&&v>0?(c=window.requestAnimationFrame(d),void 0!==a&&(a.current=c)):o.repeat&&(u=!u,i=void 0,s=void 0,c=window.requestAnimationFrame(d),void 0!==a&&(a.current=c))}};return c=window.requestAnimationFrame(d),void 0!==a&&(a.current=c),function(){return window.cancelAnimationFrame(c)}}}),[a,t,n,e,r,l,o])}(j&&I,M,l?"Vertical":"Horizontal",B,O,oe),(0,e.jsxs)("div",{className:Oe()(Jd,o&&tf,l&&nf,o&&(N||"always"===c)&&af,l&&(A||"always"===c)&&rf,g),style:y,onMouseEnter:H,onMouseLeave:K,children:[(0,e.jsx)("div",{ref:R,className:ef,onScroll:W,onMouseOver:B,children:(0,e.jsxs)(dr.Provider,{value:se,children:[b,null!=b&&(0,e.jsx)("div",{className:cf})]})}),o&&(0,e.jsx)("div",{ref:k,className:Oe()(of,tf),children:(0,e.jsx)("div",{ref:D,className:Oe()(lf,tf,ee&&sf),onMouseDown:te})}),l&&(0,e.jsx)("div",{ref:U,className:Oe()(of,nf),children:(0,e.jsx)("div",{ref:F,className:Oe()(lf,nf,re&&sf),onMouseDown:ie})})]})})),pf=new Se("CONTINUE_KEY"),vf=function(t){var n=t.severity,r=void 0===n?B.Error:n,o=t.title,a=t.message,l=t.errorDetails,s=t.canQuit,c=void 0===s||s,u=t.canSaveAndQuit,d=void 0===u||u,f=(0,i.useContext)(kl),h=(0,i.useCallback)((function(){N(W,"setClipboard",(null!=a?a:"")+"\n"+(null!=l?l:""))}),[a,l]);return(0,e.jsx)(el,{children:(0,e.jsx)($r,{theme:Qr,header:(0,e.jsx)(Tl,{children:null!=o?o:(0,e.jsx)(Ks.Common.ERROR_DIALOG_TITLE,{})}),className:Il.errorDialog,onClose:f.onClose,children:(0,e.jsxs)(Fn,{initialFocused:pf,children:[(0,e.jsxs)("div",{className:Il.iconLayout,children:[(0,e.jsx)("img",{src:gf(r),className:Il.icon}),(0,e.jsxs)("div",{className:Il.mainColumn,children:[(0,e.jsx)("div",{className:Il.errorMessage,style:{maxHeight:.5*screen.availHeight},children:a}),null!=l&&(0,e.jsxs)("div",{className:Il.errorDetails,children:[(0,e.jsx)(mf,{className:Il.content,children:l}),(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Copy.svg",className:Il.copyButton,onSelect:h})]})]})]}),(0,e.jsxs)("div",{className:Il.buttons,children:[(0,e.jsx)(ml,{focusKey:pf,theme:Ad,className:Il.button,onSelect:f.onClose,children:(0,e.jsx)(Ks.Common.ERROR_DIALOG_CONTINUE,{})}),c&&(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:te,children:(0,e.jsx)(Ks.Common.ERROR_DIALOG_QUIT_GAME,{})}),d&&(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:ne,children:(0,e.jsx)(Ks.Common.ERROR_DIALOG_SAVE_QUIT_GAME,{})})]})]})})})};function gf(e){return e===B.Warning?"Media/Misc/Warning.svg":"Media/Misc/Error.svg"}var yf=new Se("CHILDREN_KEY"),bf=new Se("DIALOG_KEY"),xf=function(t){var n=t.children,r=C(Z),o=(0,i.useMemo)((function(){return{onClose:function(){N(W,"dismissCurrentError")}}}),[]);return(0,e.jsxs)(Ze,{focused:null!=r?bf:yf,children:[(0,e.jsx)(He,{focusKey:yf,children:n}),(0,e.jsx)(He,{focusKey:bf,children:(0,e.jsx)(kl.Provider,{value:o,children:null!=r&&(0,e.jsx)(vf,{severity:r.severity,title:_f(r),message:jf(r),errorDetails:r.errorDetails,canQuit:0!=(r.actions&H.Quit),canSaveAndQuit:0!=(r.actions&H.SaveAndQuit)})})})]})};function _f(t){return null!=t.title?t.title:null!=t.titleId?(0,e.jsx)(Ss,{id:t.titleId}):null}function jf(t){return null!=t.message?Cd(t.message):null!=t.messageId?(0,e.jsx)(Ss,{id:t.messageId}):null}function Ef(e,t){return t>0?e.positive:t<0?e.negative:void 0}function Of(e){If(document.documentElement,e)}function Tf(e){If(document.body,e)}function If(e,t){(0,i.useInsertionEffect)((function(){if(null!=t){var n=t.split(" "),r=!0,i=!1,o=void 0;try{for(var a,l=n[Symbol.iterator]();!(r=(a=l.next()).done);r=!0){var s=a.value;e.classList.add(s)}}catch(e){i=!0,o=e}finally{try{r||null==l.return||l.return()}finally{if(i)throw o}}return function(){var t=!0,r=!1,i=void 0;try{for(var o,a=n[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){var l=o.value;e.classList.remove(l)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}}}}),[e,t])}var Sf,wf,Nf="debug",Pf=E(Nf,"enabled"),Cf=E(Nf,"visible"),Af=E(Nf,"panels"),Lf=E(Nf,"selectedIndex"),Mf=E(Nf,"selectedPanel"),Rf=E(Nf,"children"),kf=E(Nf,"observedBinding"),Df=I(Nf,"bindingTriggered"),Uf=E(Nf,"developerInfoVisible"),Ff=E(Nf,"watches");function Gf(){N(Nf,"hide")}function Vf(){N(Nf,"selectPreviousPanel")}function Bf(){N(Nf,"selectNextPanel")}!function(e){e[e.Unknown=0]="Unknown",e[e.Trigger=1]="Trigger",e[e.Event=2]="Event",e[e.Value=3]="Value"}(Sf||(Sf={})),function(e){e.History="debug.HistoryWatch",e.Distribution="debug.DistributionWatch"}(wf||(wf={}));const Hf={button:"button_BNH"};var Kf,Wf="l10n";!function(e){e[e.None=0]="None",e[e.Id=1]="Id",e[e.Fallback=2]="Fallback"}(Kf||(Kf={}));var zf,Yf=E(Wf,"locales"),Xf=E(Wf,"debugMode",Kf.None),qf=I(Wf,"activeDictionaryChanged"),$f=T(Wf,"indexCounts");function Qf(e){return{__Type:zf.String,id:null,value:e,args:null}}function Zf(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}!function(e){e.Bounds="Game.UI.Localization.LocalizedBounds",e.Fraction="Game.UI.Localization.LocalizedFraction",e.Number="Game.UI.Localization.LocalizedNumber",e.String="Game.UI.Localization.LocalizedString"}(zf||(zf={}));var Jf,eh=Os("LocalizedBounds",(function(e,t){var n=t.min,r=t.max,i=t.unit,o=void 0===i?tc.Integer:i;return n!==r?function(e){var t;return null!==(t=th[e])&&void 0!==t?t:function(t,n,r){return"".concat(n,"–").concat(r," <").concat(e,">")}}(o)(e,n,r):dc.renderString(e,{value:r,unit:o})}),(function(e,t){return e.min===t.min&&e.max===t.max&&e.unit===t.unit}));var th=(Zf(Jf={},tc.Power,(function(e,t,n){return Math.abs(n)<1e4?rh(e,t/10,n/10,Ks.Common.BOUNDS_KILOWATT,1):rh(e,t/1e4,n/1e4,Ks.Common.BOUNDS_MEGAWATT,1)})),Zf(Jf,tc.PercentageSingleFraction,(function(e,t,n){return rh(e,t,n,Ks.Common.BOUNDS_PERCENT,1)})),Zf(Jf,tc.Temperature,(function(e,t,n){switch(e.unitSettings.temperatureUnit){case hs.Celsius:return nh(e,t,n,Ks.Common.BOUNDS_CELSIUS);case hs.Fahrenheit:return nh(e,ic(t),ic(n),Ks.Common.BOUNDS_FAHRENHEIT);case hs.Kelvin:return nh(e,oc(t),oc(n),Ks.Common.BOUNDS_KELVIN)}})),Jf);function nh(e,t,n,r){var i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];return r.renderString(e,{MIN:pc(e,t,!1,i),MAX:pc(e,n,!1,i)})}function rh(e,t,n,r){var i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6];return r.renderString(e,{MIN:yc(e,t,!1,i,o,a),MAX:yc(e,n,!1,i,o,a)})}function ih(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var oh,ah=Os("LocalizedFraction",(function(e,t){var n=t.value,r=t.total,i=t.unit;return function(e){var t;return null!==(t=lh[e])&&void 0!==t?t:function(t,n,r){return"".concat(n," / ").concat(r," <").concat(e,">")}}(void 0===i?tc.Integer:i)(e,n,r)}),(function(e,t){return e.value===t.value&&e.total===t.total&&e.unit===t.unit}));var lh=(ih(oh={},tc.Volume,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?ch(e,t,n,Ks.Common.FRACTION_CUBIC_METER,1):ch(e,ac(t),ac(n),Ks.Common.FRACTION_GALLON,1)})),ih(oh,tc.VolumePerMonth,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?ch(e,t,n,Ks.Common.FRACTION_CUBIC_METER_PER_MONTH,1):ch(e,ac(t),ac(n),Ks.Common.FRACTION_GALLON_PER_MONTH,1)})),ih(oh,tc.Weight,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?Math.abs(n)<100?sh(e,t,n,Ks.Common.FRACTION_KG):ch(e,t/1e3,n/1e3,Ks.Common.FRACTION_TON,2):Math.abs(n)<100?sh(e,lc(t),lc(n),Ks.Common.FRACTION_POUND):ch(e,sc(t),sc(n),Ks.Common.FRACTION_SHORT_TON,2)})),ih(oh,tc.WeightPerMonth,(function(e,t,n){return e.unitSettings.unitSystem===ms.Metric?Math.abs(n)<100?sh(e,t,n,Ks.Common.FRACTION_KG_PER_MONTH):ch(e,t/1e3,n/1e3,Ks.Common.FRACTION_TON_PER_MONTH,2):Math.abs(n)<100?sh(e,lc(t),lc(n),Ks.Common.FRACTION_POUND_PER_MONTH):ch(e,sc(t),sc(n),Ks.Common.FRACTION_SHORT_TON_PER_MONTH,2)})),ih(oh,tc.Power,(function(e,t,n){return Math.abs(n)<1e4?ch(e,t/10,n/10,Ks.Common.FRACTION_KILOWATT,1):ch(e,t/1e4,n/1e4,Ks.Common.FRACTION_MEGAWATT,2)})),ih(oh,tc.Energy,(function(e,t,n){return Math.abs(n)<1e4?ch(e,t/10,n/10,Ks.Common.FRACTION_KILOWATT_HOURS,1):ch(e,t/1e4,n/1e4,Ks.Common.FRACTION_MEGAWATT_HOURS,2)})),ih(oh,tc.BodiesPerMonth,(function(e,t,n){return sh(e,t,n,Ks.Common.FRACTION_BODIES_PER_MONTH)})),ih(oh,tc.XP,(function(e,t,n){return sh(e,t,n,Ks.Common.FRACTION_XP)})),ih(oh,tc.Integer,(function(e,t,n){return sh(e,t,n,Ks.Common.FRACTION_INTEGER)})),ih(oh,tc.IntegerPerMonth,(function(e,t,n){return sh(e,t,n,Ks.Common.FRACTION_INTEGER_PER_MONTH)})),oh);function sh(e,t,n,r){var i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];return r.renderString(e,{VALUE:pc(e,t,!1,i),TOTAL:pc(e,n,!1,i)})}function ch(e,t,n,r){var i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6];return r.renderString(e,{VALUE:yc(e,t,!1,i,o,a),TOTAL:yc(e,n,!1,i,o,a)})}function uh(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dh(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return uh(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uh(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var fh,hh,mh,ph=Os("Localized",(function(e,t){return vh(e,t.value)}),(function(e,t){return gh(e.value,t.value)}));function vh(e,t){switch(t.__Type){case zf.Bounds:return eh.renderString(e,t);case zf.Fraction:return ah.renderString(e,t);case zf.Number:return dc.renderString(e,t);case zf.String:return function(e,t,n,r){var i,o=null!=t?null!==(i=e.translate(t,n))&&void 0!==i?i:t:null!=n?n:"";if(null!=r){var a=function(e,t){return Object.fromEntries(Object.entries(t).map((function(t){var n=dh(t,2),r=n[0],i=n[1];return[r,vh(e,i)]})))}(e,r);return Ul(o,a)}return o}(e,t.id,t.value,t.args);default:return"<INVALID TYPE>"}}function gh(e,t){if(e.__Type!==t.__Type)return!1;switch(e.__Type){case zf.Bounds:return eh.propsAreEqual(e,t);case zf.Fraction:return ah.propsAreEqual(e,t);case zf.Number:return dc.propsAreEqual(e,t);case zf.String:return function(e,t){return e.id===t.id&&e.value===t.value&&function(e,t){if(Object.is(e,t))return!0;if(null==e||null==t)return e===t;var n=Object.keys(e),r=Object.keys(t);if(n.length!==r.length)return!1;return n.every((function(n){return Object.prototype.hasOwnProperty.call(t,n)&&gh(e[n],t[n])}))}(e.args,t.args)}(e,t);default:return!0}}function yh(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bh(e){return function(e){if(Array.isArray(e))return yh(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return yh(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yh(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function xh(e,t){return(0,i.useCallback)((function(){for(var n=arguments.length,r=new Array(n),i=0;i<n;i++)r[i]=arguments[i];return e.apply(void 0,[t].concat(bh(r)))}),[e,t])}function _h(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jh(e){return function(e){if(Array.isArray(e))return _h(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return _h(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _h(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Eh(e,t){return jh(e).concat([t])}function Oh(e){var t=e.displayName,n=e.value,r=e.disabled;return{displayName:t,value:jt(n),disabled:r}}function Th(e){N(e.group,"invoke",e.path)}function Ih(e,t){N(e.group,"setValue",e.path,t)}function Sh(e,t){N(e.group,"setExpanded",e.path,t)}function wh(e){N(e.group,"invoke",e.path)}function Nh(e){N(e.group,"addListElement",e.path)}function Ph(e,t,n){N(e.group,"moveListElement",e.path,t,n)}function Ch(e){N(e.group,"clearList",e.path)}function Ah(e,t){N(e.group,"setCurrentPageIndex",e.path,t)}function Lh(e){return(0,i.useMemo)((function(){return{group:e,path:[]}}),[e])}function Mh(e,t){return(0,i.useMemo)((function(){return{group:e.group,path:Eh(e.path,t)}}),[e.group,e.path,t])}function Rh(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function kh(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Rh(e,t,n[t])}))}return e}function Dh(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Uh(e,t){return t}function Fh(e){return l(e.entity)}function Gh(t){var n=t.components,r=t.data,o=t.props,a=n[r.__Type];return null!=a?i.createElement(a,kh({},r,null!=o?o:{})):(0,e.jsx)(Bh,{typeName:r.__Type})}function Vh(t){var n=t.components,r=t.data,o=t.props,a=t.keyProvider,l=void 0===a?Uh:a;return(0,e.jsx)(e.Fragment,{children:r.map((function(t,r){if(null!=t){var a=l(t,r),s=n[t.__Type];return null!=s?i.createElement(s,Dh(kh({},t,null!=o?o:{}),{key:a})):(0,e.jsx)(Bh,{typeName:t.__Type},a)}}))})}!function(e){e.IntArrowField="Game.UI.Debug.IntArrowField",e.UIntArrowField="Game.UI.Debug.UIntArrowField",e.FloatArrowField="Game.UI.Debug.FloatArrowField",e.Image="Game.UI.Debug.Image"}(fh||(fh={})),function(e){e.Column="Game.UI.Widgets.Column",e.Scrollable="Game.UI.Widgets.Scrollable",e.PageView="Game.UI.Widgets.PageView",e.PageLayout="Game.UI.Widgets.PageLayout",e.Divider="Game.UI.Widgets.Divider",e.Label="Game.UI.Widgets.Label",e.Breadcrumbs="Game.UI.Widgets.Breadcrumbs",e.Button="Game.UI.Widgets.Button",e.ButtonRow="Game.UI.Widgets.ButtonRow",e.IconButton="Game.UI.Widgets.IconButton",e.IconButtonGroup="Game.UI.Widgets.IconButtonGroup",e.Group="Game.UI.Widgets.Group",e.ExpandableGroup="Game.UI.Widgets.ExpandableGroup",e.PagedList="Game.UI.Widgets.PagedList",e.ValueField="Game.UI.Widgets.ValueField",e.ToggleField="Game.UI.Widgets.ToggleField",e.IntInputField="Game.UI.Widgets.IntInputField",e.IntSliderField="Game.UI.Widgets.IntSliderField",e.Int2InputField="Game.UI.Widgets.Int2InputField",e.Int3InputField="Game.UI.Widgets.Int3InputField",e.Int4InputField="Game.UI.Widgets.Int4InputField",e.UIntInputField="Game.UI.Widgets.UIntInputField",e.UIntSliderField="Game.UI.Widgets.UIntSliderField",e.TimeSliderField="Game.UI.Widgets.TimeSliderField",e.TimeBoundsSliderField="Game.UI.Widgets.TimeBoundsSliderField",e.FloatInputField="Game.UI.Widgets.FloatInputField",e.FloatSliderField="Game.UI.Widgets.FloatSliderField",e.Float2InputField="Game.UI.Widgets.Float2InputField",e.Float2SliderField="Game.UI.Widgets.Float2SliderField",e.Float3InputField="Game.UI.Widgets.Float3InputField",e.Float3SliderField="Game.UI.Widgets.Float3SliderField",e.EulerAnglesField="Game.UI.Widgets.EulerAnglesField",e.Float4InputField="Game.UI.Widgets.Float4InputField",e.Float4SliderField="Game.UI.Widgets.Float4SliderField",e.Bounds1SliderField="Game.UI.Widgets.Bounds1SliderField",e.Bounds1InputField="Game.UI.Widgets.Bounds1InputField",e.Bounds2InputField="Game.UI.Widgets.Bounds2InputField",e.Bounds3InputField="Game.UI.Widgets.Bounds3InputField",e.Bezier4x3Field="Game.UI.Widgets.Bezier4x3Field",e.StringInputField="Game.UI.Widgets.StringInputField",e.ColorField="Game.UI.Widgets.ColorField",e.AnimationCurveField="Game.UI.Widgets.AnimationCurveField",e.EnumField="Game.UI.Widgets.EnumField",e.FlagsField="Game.UI.Widgets.FlagsField",e.PopupValueField="Game.UI.Widgets.PopupValueField",e.DropdownField="Game.UI.Widgets.DropdownField",e.DirectoryPickerButton="Game.UI.Widgets.DirectoryPickerButton"}(hh||(hh={})),function(e){e[e.Title=0]="Title",e[e.Cotnainer=1]="Cotnainer"}(mh||(mh={}));var Bh=function(t){var n=t.typeName;return(0,e.jsx)("div",{style:{backgroundColor:"red",color:"yellow"},children:"Unknown element type ".concat(n)})};function Hh(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Kh(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Hh(e,t,n[t])}))}return e}function Wh(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function zh(t){var n=t.parent,r=t.components,o=t.data,a=o.props.__Type,l=r[a];return null!=l?(0,e.jsx)(Xh.Provider,{value:r,children:i.createElement(l,Wh(Kh({},o),{parent:n}))}):(0,e.jsx)(Bh,{typeName:a})}function Yh(t){var n=t.parent,r=t.components,o=t.data;return(0,e.jsx)(Xh.Provider,{value:r,children:null!=(null==o?void 0:o.map)?o.map((function(t){if(null!=t&&!t.props.hidden){var o=t.path,a=t.props.__Type,l=r[a];return null!=l?i.createElement(l,Wh(Kh({},t),{key:o,parent:n})):(0,e.jsx)(Bh,{typeName:a},o)}})):JSON.stringify(o)})}var Xh=i.createContext({});const qh={button:"button_hxl button_k8s"};function $h(t){var n=t.focusKey,r=t.children,i=t.onSelect;return(0,e.jsx)(ml,{focusKey:n,theme:qh,onSelect:i,children:r||" "})}const Qh={title:"title_Xkf",children:"children_HxX"};var Zh=function(t){var n=t.title,r=t.children;return(0,e.jsxs)("div",{className:Qh.container,children:[n&&(0,e.jsx)("div",{className:Qh.title,children:n}),(0,e.jsx)("div",{className:Qh.children,children:r})]})},Jh=function(t){var n=t.disabled,r=t.children,i=t.onFocusChange,o=pn("FocusBoundary",!n);return xn(o,i),(0,e.jsx)(Be,{controller:o,children:r})};const em="button__Wn",tm="value_fMT";function nm(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rm(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return nm(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return nm(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var im=function(t){var n=t.onSelectLeft,r=t.onSelectRight,o=t.children,a=(0,i.useRef)(!1),l=rm((0,i.useState)(!1),2),s=l[0],c=l[1];(0,i.useEffect)((function(){s||(a.current=!1)}),[s]);var u=(0,i.useMemo)((function(){return{"Debug Change Field":function(e){e<0?n(a.current):r(a.current)},"Debug Multiplier":function(e){a.current=e>0}}}),[n,r]),d=(0,i.useCallback)((function(){return n(a.current)}),[n]),f=(0,i.useCallback)((function(){return r(a.current)}),[r]);return(0,e.jsx)(Jh,{onFocusChange:c,children:(0,e.jsxs)(Tn,{actions:u,children:[(0,e.jsx)(ml,{focusKey:Te,className:em,onSelect:d,children:"<"}),(0,e.jsx)(Tr,{className:tm,children:o}),(0,e.jsx)(ml,{focusKey:Te,className:em,onSelect:f,children:">"})]})})};const om="field_vGA",am="label_KyX",lm="control_b3l";var sm=function(t){var n=t.label,r=t.children;return(0,e.jsxs)(Tr,{className:om,children:[(0,e.jsx)("div",{className:am,children:n||" "}),(0,e.jsx)("div",{className:lm,children:r})]})},cm=function(t){var n=t.label,r=t.value,o=t.min,a=t.max,l=t.step,s=void 0===l?1:l,c=t.stepMultiplier,u=void 0===c?10:c,d=t.onChange,f=(0,i.useCallback)((function(e){var t=r-(e?u:s);null!=o&&(t=Math.max(o,t)),null!=a&&(t=Math.min(t,a)),t!==r&&d(t)}),[s,u,a,o,d,r]),h=(0,i.useCallback)((function(e){var t=r+(e?u:s);null!=o&&(t=Math.max(o,t)),null!=a&&(t=Math.min(t,a)),t!==r&&d(t)}),[s,u,a,o,d,r]);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(im,{onSelectLeft:f,onSelectRight:h,children:"".concat(r)})})};function um(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function dm(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var fm={r:0,g:0,b:0,a:1};function hm(e,t,n,r){return{r:e/255,g:t/255,b:n/255,a:r}}function mm(e,t){return dm(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){um(e,t,n[t])}))}return e}({},e),{a:t})}function pm(e){var t=e.r,n=e.g,r=e.b,i=e.a;return"rgba(".concat(Math.round(255*t),",").concat(Math.round(255*n),",").concat(Math.round(255*r),",").concat(i.toString().replace(",","."),")")}function vm(e){var t=Math.round(255*e).toString(16).toUpperCase();return 1===t.length?"0"+t:t}function gm(e){e=e.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,(function(e,t,n,r){return t+t+n+n+r+r}));var t=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?$/i.exec(e);if(!t)return null;var n=t.length>3&&parseInt(t[4],16)?parseInt(t[4],16)/255:1;return{r:parseInt(t[1],16)/255,g:parseInt(t[2],16)/255,b:parseInt(t[3],16)/255,a:n}}function ym(e){var t=e.h,n=e.s,r=e.v,i=e.a,o=0,a=0,l=0,s=Math.floor(6*t),c=6*t-s,u=r*(1-n),d=r*(1-c*n),f=r*(1-(1-c)*n);switch(s%6){case 0:o=r,a=f,l=u;break;case 1:o=d,a=r,l=u;break;case 2:o=u,a=r,l=f;break;case 3:o=u,a=d,l=r;break;case 4:o=f,a=u,l=r;break;case 5:o=r,a=u,l=d}return{r:o,g:a,b:l,a:i}}function bm(e){var t=e.r,n=e.g,r=e.b,i=e.a,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,a=Math.max(t,n,r),l=Math.min(t,n,r),s=a-l,c=o,u=0===a?0:s/a,d=a;if(a!==l){switch(a){case t:c=(n-r)/s+(n<r?6:0);break;case n:c=(r-t)/s+2;break;case r:c=(t-n)/s+4}c/=6}return{h:c,s:u,v:d,a:i}}function xm(e,t,n){return{r:lt(e.r,t.r,n),g:lt(e.g,t.g,n),b:lt(e.b,t.b,n),a:lt(e.a,t.a,n)}}function _m(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"to right";return"linear-gradient(".concat(t,", ").concat(e.stops.map((function(e){return"".concat("string"==typeof e.color?e.color:pm(e.color)," ").concat(100*e.offset,"%")})).join(","),")")}const jm="foldout-button_Ugi",Em="arrow_wFy",Om="expanded_S2V",Tm="label_qS_",Im="value_ypy";function Sm(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function wm(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Sm(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Sm(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Nm=function(t){var n=t.title,r=t.value,o=t.opened,a=t.children,l=t.onOpenedChange,s=(0,i.useCallback)((function(){return l(!o)}),[l,o]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)(ml,{onSelect:s,className:Oe()(jm,o&&Om),children:[(0,e.jsx)("div",{className:Em}),(0,e.jsx)("div",{className:Tm,children:n}),r&&(0,e.jsx)("div",{className:Im,children:r})]}),o&&(0,e.jsx)(Zh,{title:null,children:a})]})},Pm=function(t){var n=t.title,r=t.value,o=t.children,a=wm((0,i.useState)(!1),2),l=a[0],s=a[1];return(0,e.jsx)(Nm,{title:n,value:r,opened:l,onOpenedChange:s,children:o})};function Cm(e){e.stopPropagation()}const Am={slider:"slider_pUS","track-bounds":"track-bounds_H8_",trackBounds:"track-bounds_H8_","range-bounds":"range-bounds_lNt",rangeBounds:"range-bounds_lNt",range:"range_iUN","thumb-container":"thumb-container_aso",thumbContainer:"thumb-container_aso"},Lm={slider:"slider_g0V slider_pUS",compact:"compact_pTl",thumb:"thumb_WZt",range:"range_K3G range_iUN"};function Mm(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Rm(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function km(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Mm(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Mm(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Dm={dragStart:Qt.grabSlider,drag:Qt.dragSlider},Um={dragStart:Qt.grabSlider,drag:Qt.dragSlider,scaleDragVolume:!0},Fm=i.forwardRef((function(t,n){var r=t.focusKey,o=t.debugName,a=void 0===o?"Slider":o,l=t.value,s=t.start,c=t.end,u=t.gamepadStep,d=t.disabled,f=t.vertical,h=void 0!==f&&f,m=t.sounds,p=void 0===m?Dm:m,v=t.thumb,g=t.theme,y=void 0===g?Lm:g,b=t.className,x=t.style,_=t.children,j=t.noFill,E=t.valueTransformer,O=void 0===E?Gm:E,T=t.onChange,I=t.onDragStart,S=t.onDragEnd,w=t.onMouseOver,N=t.onMouseLeave,P=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Rm(e,t,n[t])}))}return e}({},Am,y)}),[y]),C=null!=v?v:P.thumb?(0,e.jsx)("div",{className:P.thumb}):void 0,A=(0,i.useRef)(null),L=Je(n,A),M=yr(we(null!=r?r:d?Te:Ie,a),A),R=bn(M),k=cr(),D=c-s,U=0!==D?(l-s)/D:0,F=null!=u&&u>0?u/D:.05,G=(0,i.useMemo)((function(){return{"Change Slider Value":null!=T?function(e){if(0!==e){var t=O(s,c,U+e*F);t!==l&&(T(t),Jt(null==p?void 0:p.drag,(null==p?void 0:p.scaleDragVolume)&&0!==D?(l-s)/D:1))}}:null}}),[T,O,s,c,U,F,l,null==p?void 0:p.drag,null==p?void 0:p.scaleDragVolume,D]),V=(0,i.useRef)(null),B=(0,i.useRef)(0),H=(0,i.useCallback)((function(e){var t=e.clientX,n=e.clientY;if(d||!V.current)return!1;if(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),Jt(null==p?void 0:p.dragStart),I&&I(),T){var r=O(s,c,Hm(V.current,t,n,B.current,h));r!==l&&T(r)}return!0}),[d,c,T,I,s,null==p?void 0:p.dragStart,l,O,h]),K=(0,i.useCallback)((function(e){var t=e.clientX,n=e.clientY;if(!d&&T&&V.current){var r=O(s,c,Hm(V.current,t,n,B.current,h));r!==l&&(T(r),Jt(null==p?void 0:p.drag,(null==p?void 0:p.scaleDragVolume)&&0!==D?(l-s)/D:1))}}),[d,T,O,s,c,h,l,null==p?void 0:p.drag,null==p?void 0:p.scaleDragVolume,D]),W=km(Zd(H,K,(0,i.useCallback)((function(){B.current=0,S&&S()}),[S])),2),z=W[0],Y=W[1],X=(0,i.useCallback)((function(e){if(V.current)if(h){var t=V.current.getBoundingClientRect(),n=t.top+t.height*(1-U);B.current=e.clientY-n}else{var r=V.current.getBoundingClientRect(),i=r.left+r.width*U;B.current=e.clientX-i}}),[U,h]),q="".concat(100*at(U,0,1),"%");return(0,e.jsx)(Tn,{actions:G,disabled:d,children:(0,e.jsx)(Be,{controller:M,children:(0,e.jsxs)("div",{ref:L,className:Oe()(P.slider,h?"vertical":"horizontal",d&&"disabled",R&&k&&"focused",z&&"dragging",b),style:x,onMouseDown:d?void 0:Y,children:[_,(0,e.jsx)("div",{ref:V,className:P.trackBounds,onMouseOver:w,onMouseLeave:N,children:(0,e.jsxs)("div",{className:P.rangeBounds,style:Rm({},h?"height":"width",q),children:[!j&&(0,e.jsx)("div",{className:P.range}),C&&(0,e.jsx)("div",{className:P.thumbContainer,onClick:d?void 0:Cm,onMouseDown:d?void 0:X,onMouseOver:w,onMouseLeave:N,children:C})]})})]})})})}));function Gm(e,t,n){return at(e+n*(t-e),Math.min(e,t),Math.max(e,t))}function Vm(e,t,n){return at(Math.round(e+n*(t-e)),Math.min(e,t),Math.max(e,t))}function Bm(e){return(0,i.useCallback)((function(t,n,r){return at(t+Math.round(r*(n-t)/e)*e,Math.min(t,n),Math.max(t,n))}),[e])}function Hm(e,t,n,r,i){var o=e.getBoundingClientRect(),a=o.top,l=o.left,s=o.width,c=o.height;return i?(c-(n-a-r))/c:(t-l-r)/s}const Km={slider:"slider_HvX slider_pUS",value:"value_Ob7",range:"range_LNR range_iUN"};function Wm(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zm(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Wm(e,t,n[t])}))}return e}function Ym(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var Xm=function(t){var n=t.label,r=t.value,i=t.min,o=t.max,a=t.step,l=void 0===a?1:a,s=t.onChange,c=Bm(l);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(Fm,{value:r,start:i,end:o,valueTransformer:c,theme:Km,onChange:s,children:(0,e.jsx)("div",{className:Km.value,children:"".concat(r)})})})},qm=function(t){var n=t.label,r=t.value,i=t.min,o=t.max,a=t.step,l=t.fractionDigits,s=t.onChange,c=Bm(a||1);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(Fm,{value:r,start:i,end:o,valueTransformer:c,theme:Km,onChange:s,children:(0,e.jsx)("div",{className:Km.value,children:"".concat(r.toFixed(l))})})})};const $m="swatch-title_d15",Qm="swatch-alpha_MYB",Zm="swatch_OaZ",Jm="label_FVu";function ep(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function tp(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ep(e,t,n[t])}))}return e}function np(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function rp(e,t){return null==e||0===e.length||null==e[0]?null:e[0][t]}function ip(e,t,n){var r=op(t,e.length,n);return null!=r?e[r]:null}function op(e,t,n){return 0===t?null:-1===e?0:e===t-1?n?0:e:e+1}function ap(e,t,n){var r=lp(t,e.length,n);return null!=r?e[r]:null}function lp(e,t,n){return 0===t?null:-1===e?0:0===e?n?t-1:0:e-1}function sp(e){return null!=e}var cp=i.forwardRef((function(t,n){var r=t.focusKey,o=t.debugName,a=void 0===o?"Toggle":o,l=t.checked,s=t.disabled,c=void 0!==s&&s,u=t.style,d=t.toggleSound,f=void 0===d?Qt.selectToggle:d,h=t.className,m=t.children,p=t.onChange,v=t.onMouseOver,g=t.onMouseLeave,y=(0,i.useCallback)((function(){p&&(Jt(f),p(!l))}),[l,p,f]),b=(0,i.useCallback)((function(e){y(),p&&!c&&Cm(e)}),[c,y,p]),x=(0,i.useRef)(null),_=Je(n,x),j=yr(we(null!=r?r:c?Te:Ie,a),x),E=bn(j),O=cr();return(0,e.jsx)(In,{onAction:c?void 0:y,children:(0,e.jsx)(Be,{controller:j,children:(0,e.jsx)("div",{ref:_,onClick:c?void 0:b,onMouseOver:v,onMouseLeave:g,style:u,className:Oe()(h,l?"checked":"unchecked",c&&"disabled",E&&O&&"focused"),children:m})})})}));const up={toggle:"toggle_cca item-mouse-states_Fmi",checkmark:"checkmark_NXV"};function dp(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fp(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){dp(e,t,n[t])}))}return e}function hp(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function mp(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var pp=function(t){var n=t.checked,r=t.disabled,o=t.theme,a=t.className,l=mp(t,["checked","disabled","theme","className"]),s=(0,i.useMemo)((function(){return fp({},up,o)}),[o]);return(0,e.jsx)(cp,hp(fp({},l),{checked:n,disabled:r,className:Oe()(s.toggle,a),children:(0,e.jsx)("div",{className:Oe()(s.checkmark,n&&"checked",r&&"disabled")})}))};const vp="toggle_x2y";var gp=function(t){var n=t.label,r=t.value,i=t.onChange;return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(pp,{checked:r,className:vp,onChange:i})})},yp=function(t){var n=t.enumMember,r=t.checked,o=t.onChange,a=(0,i.useCallback)((function(e){return o(n,e)}),[n,o]);return(0,e.jsx)(gp,{label:(0,e.jsx)(ph,{value:n.displayName}),value:r,onChange:a})},bp=["Debug UI"],xp=["Move Horizontal","Move Vertical","Select","Back","Switch Tab"],_p=i.memo((function(t){var n=t.includes,r=t.excludes,o=void 0===r?bp:r,a=t.disabled,l=t.children,s=pn("InputActionBarrier"),c=bn(s),u=(0,i.useCallback)((function(e){null!=n?e.removeWhere((function(e){return n.includes(e)})):null!=o?e.removeWhere((function(e){return!o.includes(e)})):e.clear()}),[n,o]),d=fe(c,a?null:u);return(0,e.jsx)(Be,{controller:s,children:(0,e.jsx)(de.Provider,{value:d,children:l})})}),(function(e,t){return f(e,t)&&f(e.includes,t.includes)&&f(e.excludes,t.excludes)}));function jp(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Ep(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Op(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Ep(e,t,n[t])}))}return e}function Tp(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Ip(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jp(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jp(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Sp=i.forwardRef((function(t,n){var r=t.focusKey,o=t.debugName,a=void 0===o?"TextInput":o,l=t.type,s=void 0===l?"text":l,c=t.value,u=void 0===c?"":c,d=t.selectAllOnFocus,f=void 0===d||d,h=t.placeholder,m=void 0===h?"":h,p=t.vkTitle,v=void 0===p?"":p,g=t.vkDescription,y=void 0===g?"":g,b=t.disabled,x=t.className,_=t.multiline,j=t.onFocus,E=t.onBlur,O=t.onKeyDown,T=t.onChange,I=t.onMouseUp,S=Tp(t,["focusKey","debugName","type","value","selectAllOnFocus","placeholder","vkTitle","vkDescription","disabled","className","multiline","onFocus","onBlur","onKeyDown","onChange","onMouseUp"]),w=(0,i.useRef)(null),N=Je(n,w),P=yr(we(null!=r?r:b?Te:Ie,a),w),A=bn(P),L=cr(),M=C(lr),R=Ip((0,i.useState)(!1),2),k=R[0],D=R[1],U=(0,i.useMemo)((function(){return k?{Back:function(){null!=w.current&&document.activeElement===w.current&&w.current.blur()}}:{Select:function(){if(null!=w.current){var e=w.current.getBoundingClientRect();ar(e.x,e.y,e.width,e.height),sl(w,"--selectAnimation","--selectDuration"),w.current.focus();var t=w.current.value.length;w.current.setSelectionRange(f?0:t,t)}}}}),[k,f]),F=(0,i.useCallback)((function(e){G.current=!1,(!_&&13===e.keyCode||27===e.keyCode)&&e.currentTarget.blur(),e.stopPropagation(),O&&O(e)}),[_,O]),G=(0,i.useRef)(!1),V=(0,i.useCallback)((function(e){G.current=!1,T&&T(e)}),[T]),B=(0,i.useCallback)((function(e){D(!0),G.current=!0,j&&j(e),Jt(Qt.focusInputField)}),[j]),H=(0,i.useCallback)((function(){return Jt(Qt.hoverItem)}),[]),K=(0,i.useCallback)((function(e){G.current&&(null!=w.current&&w.current.selectionStart===w.current.selectionEnd&&w.current.select(),G.current=!1),I&&I(e)}),[I]),W=(0,i.useCallback)((function(e){D(!1),E&&E(e)}),[E]);(0,i.useEffect)((function(){L&&!A&&w.current&&w.current.blur()}),[A,L]);var z=xs(m),Y=!k&&!u&&z,X=xs(v),q=xs(y),$=void 0!==_?"textarea":"input",Q=(0,e.jsx)(Tn,{actions:U,children:(0,e.jsx)(Be,{controller:P,children:(0,e.jsx)($,Op({ref:N,type:"password"===s&&Y?"text":s,value:Y?z:u,disabled:b,className:Oe()(x,A&&L&&"focused",Y&&"placeholder"),"vk-title":X,"vk-description":q,"vk-type":s,rows:"number"==typeof _?_:5,onFocus:B,onBlur:W,onKeyDown:F,onChange:V,onMouseUp:K,onMouseEnter:H},S))})});return M&&L?(0,e.jsx)(_p,{disabled:!k||!L,children:Q}):Q}));const wp="text-input_Y20";function Np(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Pp(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Np(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Np(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}const Cp="image_BEo";function Ap(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Lp(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var Mp,Rp=function(t){var n=t.parent,r=t.data;return(0,e.jsx)(Yh,{parent:n,components:kp,data:r})},kp=(Ap(Mp={},hh.Group,(function(t){var n=t.parent,r=t.path,o=t.children,a=t.props,l=Mh(n,r),s=(0,i.useContext)(Xh);return(0,e.jsx)(Zh,{title:(0,e.jsx)(ph,{value:a.displayName}),children:(0,e.jsx)(Yh,{parent:l,components:s,data:o})})})),Ap(Mp,hh.ExpandableGroup,(function(t){var n=t.parent,r=t.path,o=t.children,a=t.props,l=Mh(n,r),s=(0,i.useContext)(Xh),c=xh(Sh,l);return(0,e.jsx)(Nm,{title:(0,e.jsx)(ph,{value:a.displayName}),opened:a.expanded,onOpenedChange:c,children:(0,e.jsx)(Yh,{parent:l,components:s,data:o})})})),Ap(Mp,hh.Button,(function(t){var n=t.parent,r=t.path,o=t.props,a=Mh(n,r),l=xh(Th,a),s=function(e){return(0,i.useMemo)((function(){return e.join(".")}),[e])}(a.path);return(0,e.jsx)($h,{onSelect:l,focusKey:s,children:(0,e.jsx)(ph,{value:o.displayName})})})),Ap(Mp,hh.ValueField,(function(t){var n=t.props;return(0,e.jsx)(sm,{label:(0,e.jsx)(ph,{value:n.displayName}),children:n.value})})),Ap(Mp,hh.ToggleField,Dp(gp)),Ap(Mp,hh.IntSliderField,Dp(Xm)),Ap(Mp,fh.IntArrowField,Dp(cm)),Ap(Mp,hh.IntInputField,Dp((function(t){var n=t.label,r=t.value,o=t.onChange,a=Pp((0,i.useState)(r.toString()),2),l=a[0],s=a[1];(0,i.useEffect)((function(){return s(r.toString())}),[r]);var c=(0,i.useCallback)((function(){var e=Number(l);isNaN(e)||o(e)}),[o,l]),u=(0,i.useCallback)((function(e){""!==e.target.value&&isNaN(Number(e.target.value))||s(e.target.value)}),[]);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(Sp,{value:l,className:wp,onChange:u,onBlur:c})})}))),Ap(Mp,hh.UIntSliderField,Dp(Xm)),Ap(Mp,fh.UIntArrowField,Dp(cm)),Ap(Mp,hh.FloatSliderField,Dp(qm)),Ap(Mp,fh.FloatArrowField,Dp((function(t){var n=t.label,r=t.value,o=t.min,a=t.max,l=t.step,s=void 0===l?1:l,c=t.stepMultiplier,u=void 0===c?10:c,d=t.fractionDigits,f=void 0===d?0:d,h=t.onChange,m=(0,i.useCallback)((function(e){var t=r-(e?u:s);null!=o&&(t=Math.max(o,t)),null!=a&&(t=Math.min(t,a)),t!==r&&h(t)}),[s,u,a,o,h,r]),p=(0,i.useCallback)((function(e){var t=r+(e?u:s);null!=o&&(t=Math.max(o,t)),null!=a&&(t=Math.min(t,a)),t!==r&&h(t)}),[s,u,a,o,h,r]);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(im,{onSelectLeft:m,onSelectRight:p,children:"".concat(r.toFixed(f))})})}))),Ap(Mp,hh.Float2SliderField,Dp((function(t){var n=t.label,r=t.value,o=t.step,a=t.fractionDigits,l=t.min,s=t.max,c=t.onChange,u=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{x:e}))}),[c,r]),d=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{y:e}))}),[c,r]);return(0,e.jsxs)(Pm,{title:n,value:mt(r,null!=a?a:1),children:[(0,e.jsx)(qm,{label:"X",value:r.x,min:l,max:s,onChange:u,step:o,fractionDigits:a}),(0,e.jsx)(qm,{label:"Y",value:r.y,min:l,max:s,onChange:d,step:o,fractionDigits:a})]})}))),Ap(Mp,hh.Float3SliderField,Dp((function(t){var n=t.label,r=t.value,o=t.step,a=t.fractionDigits,l=t.min,s=t.max,c=t.onChange,u=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{x:e}))}),[c,r]),d=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{y:e}))}),[c,r]),f=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{z:e}))}),[c,r]);return(0,e.jsxs)(Pm,{title:n,value:vt(r,null!=a?a:1),children:[(0,e.jsx)(qm,{label:"X",value:r.x,min:l,max:s,onChange:u,step:o,fractionDigits:a}),(0,e.jsx)(qm,{label:"Y",value:r.y,min:l,max:s,onChange:d,step:o,fractionDigits:a}),(0,e.jsx)(qm,{label:"Z",value:r.z,min:l,max:s,onChange:f,step:o,fractionDigits:a})]})}))),Ap(Mp,hh.Float4SliderField,Dp((function(t){var n=t.label,r=t.value,o=t.step,a=t.fractionDigits,l=t.min,s=t.max,c=t.onChange,u=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{x:e}))}),[c,r]),d=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{y:e}))}),[c,r]),f=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{z:e}))}),[c,r]),h=(0,i.useCallback)((function(e){return c(Ym(zm({},r),{w:e}))}),[c,r]);return(0,e.jsxs)(Pm,{title:n,value:gt(r,null!=a?a:1),children:[(0,e.jsx)(qm,{label:"X",value:r.x,min:l,max:s,onChange:u,step:o,fractionDigits:a}),(0,e.jsx)(qm,{label:"Y",value:r.y,min:l,max:s,onChange:d,step:o,fractionDigits:a}),(0,e.jsx)(qm,{label:"Z",value:r.z,min:l,max:s,onChange:f,step:o,fractionDigits:a}),(0,e.jsx)(qm,{label:"W",value:r.w,min:l,max:s,onChange:h,step:o,fractionDigits:a})]})}))),Ap(Mp,hh.EnumField,Dp((function(t){var n=t.label,r=t.value,o=t.enumMembers,a=t.onChange,l=(0,i.useMemo)((function(){return o.findIndex((function(e){return _t(e.value,r)}))}),[o,r]),s=(0,i.useCallback)((function(){var e=ap(o,l,!0);null!=e&&a(e.value)}),[o,a,l]),c=(0,i.useCallback)((function(){var e=ip(o,l,!0);null!=e&&a(e.value)}),[o,a,l]);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(im,{onSelectLeft:s,onSelectRight:c,children:-1!==l?(0,e.jsx)(ph,{value:o[l].displayName}):"".concat(l)})})}))),Ap(Mp,hh.FlagsField,Dp((function(t){var n=t.label,r=t.value,o=t.enumMembers,a=t.onChange,l=(0,i.useCallback)((function(e,t){a(Et(t?jt(r)|jt(e.value):jt(r)&~jt(e.value)))}),[a,r]);return(0,e.jsx)(Pm,{title:n,children:o.filter((function(e){return!_t(e.value,xt)})).map((function(t,n){return(0,e.jsx)(yp,{enumMember:t,checked:(jt(r)&jt(t.value))===jt(t.value),onChange:l},n)}))})}))),Ap(Mp,hh.ColorField,Dp((function(t){var n=t.label,r=t.value,o=t.showAlpha,a=t.onChange,l=(0,i.useCallback)((function(e){return a(np(tp({},r),{r:e}))}),[a,r]),s=(0,i.useCallback)((function(e){return a(np(tp({},r),{g:e}))}),[a,r]),c=(0,i.useCallback)((function(e){return a(np(tp({},r),{b:e}))}),[a,r]),u=(0,i.useCallback)((function(e){return a(np(tp({},r),{a:e}))}),[a,r]);return(0,e.jsxs)(Pm,{title:(0,e.jsxs)("div",{className:$m,children:[(0,e.jsx)("div",{className:Qm,children:(0,e.jsx)("div",{className:Zm,style:{backgroundColor:pm(r)}})}),(0,e.jsx)("div",{className:Jm,children:n})]}),children:[(0,e.jsx)(qm,{label:"Red",value:r.r,onChange:l,min:0,max:1,step:.001,fractionDigits:3}),(0,e.jsx)(qm,{label:"Green",value:r.g,onChange:s,min:0,max:1,step:.001,fractionDigits:3}),(0,e.jsx)(qm,{label:"Blue",value:r.b,onChange:c,min:0,max:1,step:.001,fractionDigits:3}),o&&(0,e.jsx)(qm,{label:"Alpha",value:r.a,onChange:u,min:0,max:1,step:.001,fractionDigits:3})]})}))),Ap(Mp,hh.StringInputField,Dp((function(t){var n=t.label,r=t.value,o=t.onChange,a=Pp((0,i.useState)(r),2),l=a[0],s=a[1];(0,i.useEffect)((function(){return s(r)}),[r]);var c=(0,i.useCallback)((function(){o(l)}),[o,l]),u=(0,i.useCallback)((function(e){s(e.target.value)}),[]);return(0,e.jsx)(sm,{label:n,children:(0,e.jsx)(Sp,{value:l,className:wp,onChange:u,onBlur:c})})}))),Ap(Mp,fh.Image,(function(t){var n=t.props;return(0,e.jsx)(sm,{label:(0,e.jsx)(ph,{value:n.displayName}),children:(0,e.jsx)("img",{src:n.uri,className:Cp})})})),Mp);function Dp(t){var n,r=function(n){var r=n.parent,i=n.path,o=n.props,a=xh(Ih,Mh(r,i));return(0,e.jsx)(t,Lp(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Ap(e,t,n[t])}))}return e}({},o),{label:(0,e.jsx)(ph,{value:o.displayName}),onChange:a}))};return r.displayName=null!==(n=t.displayName)&&void 0!==n?n:t.name,r}var Up,Fp="time",Gp=E(Fp,"timeSettings"),Vp=E(Fp,"ticks"),Bp=E(Fp,"day"),Hp=E(Fp,"lightingState"),Kp=E(Fp,"simulationPaused"),Wp=E(Fp,"simulationSpeed"),zp=I(Fp,"simulationPausedBarrier");function Yp(e){N(Fp,"setSimulationPaused",e)}function Xp(e){N(Fp,"setSimulationSpeed",e)}function qp(e,t){return e.year===t.year&&e.month===t.month}function $p(e,t){return Qp(e,t*e.ticksPerDay)}function Qp(e,t){var n=e.epochTicks+t,r=Math.floor(n/e.ticksPerDay);return{year:e.epochYear+Math.floor(r/e.daysPerYear),month:Jp(r,e.daysPerYear)}}function Zp(e,t){var n=e.epochTicks+t,r=Math.floor(n/e.ticksPerDay),i=e.epochYear+Math.floor(r/e.daysPerYear),o=Jp(r,e.daysPerYear),a=Jp(n,e.ticksPerDay);return{year:i,month:o,hour:Math.trunc(a/e.ticksPerDay*24),minute:Math.trunc(Jp(a/e.ticksPerDay*1440,60))}}function Jp(e,t){return(e%t+t)%t}!function(e){e[e.Dawn=0]="Dawn",e[e.Sunrise=1]="Sunrise",e[e.Day=2]="Day",e[e.Sunset=3]="Sunset",e[e.Dusk=4]="Dusk",e[e.Night=5]="Night"}(Up||(Up={}));const ev={title:"title_f1a",value:"value_bvH"};function tv(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function nv(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return tv(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return tv(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var rv=function(t){var n=t.binding,r=t.className,o=nv((0,i.useState)(0),2),a=o[0],l=o[1],s=nv((0,i.useState)(""),2),c=s[0],u=s[1];return(0,i.useEffect)((function(){var e=function(e){u(JSON.stringify(e,null,2)),l((function(e){return e+1}))};if(n.debugType===Sf.Event){var t=I(n.group,n.name),r=t.subscribe(e);return function(){r.dispose(),t.dispose()}}if(n.debugType===Sf.Value){var i=E(n.group,n.name,"undefined"),o=i.subscribe();return u(JSON.stringify(o.value,null,2)),l(0),o.setChangeListener(e),function(){o.dispose(),i.dispose()}}}),[n.group,n.name,n.debugType]),(0,e.jsxs)("div",{className:Oe()(ev.debugBindingOutput,r),children:[(0,e.jsx)("div",{className:ev.title,children:"".concat(n.group,".").concat(n.name,", Update Count: ").concat(a)}),(0,e.jsx)("div",{className:ev.value,children:c})]})};const iv="fps-display_t30",ov="value_vNu",av="graph_EEa";var lv=function(){switch(C(q)){case V.Simple:return(0,e.jsx)(sv,{});case V.Advanced:return(0,e.jsx)(dv,{});case V.Precise:return(0,e.jsx)(fv,{});default:return null}},sv=function(){var t=C($);return(0,e.jsx)("div",{className:iv,children:(0,e.jsx)("div",{className:ov,children:"".concat(t.fps.toFixed(0).padStart(3," ")," FPS")})})},cv=250,uv=50,dv=function(){var t=C($),n=t.fps>0?1e3/t.fps:0,r=L($),o=(0,i.useRef)(null);return(0,i.useEffect)((function(){for(var e=new Array(cv),t=e.length-1,n=30,i=0;i<e.length;i++)e[i]=0;var a=0;return function i(){var l;t=(t+1)%e.length,e[t]=r.current.fps,n=Math.max(r.current.fps,n);var s=null===(l=o.current)||void 0===l?void 0:l.getContext("2d");if(null!=s){s.fillStyle="rgb(0, 0, 0)",s.fillRect(0,0,s.canvas.width,s.canvas.height);for(var c=0;c<e.length;c++){var u=e[(e.length+t-c)%e.length],d=u/n*uv;s.fillStyle=pm(vv(u)),s.fillRect(cv-c-1,uv-d,1,d)}}a=window.requestAnimationFrame(i)}(),function(){return window.cancelAnimationFrame(a)}}),[r]),(0,e.jsx)(e.Fragment,{children:(0,e.jsxs)("div",{className:iv,children:[(0,e.jsx)("canvas",{ref:o,className:av,width:cv,height:uv}),(0,e.jsxs)("div",{className:ov,children:["Frame: ".concat(n.toFixed(2).padStart(7," "),"ms"),"".concat(t.fps.toFixed(2)," FPS")]})]})})},fv=function(){var t=C($),n=L($),r=(0,i.useRef)(null);return(0,i.useEffect)((function(){for(var e=new Array(cv),t=e.length-1,i=30,o=0;o<e.length;o++)e[o]=0;var a=0;return function o(){var l;t=(t+1)%e.length,e[t]=n.current.fps,i=Math.max(n.current.fps,i);var s=null===(l=r.current)||void 0===l?void 0:l.getContext("2d");if(null!=s){s.fillStyle="rgb(0, 0, 0)",s.fillRect(0,0,s.canvas.width,s.canvas.height);for(var c=0;c<e.length;c++){var u=e[(e.length+t-c)%e.length],d=u/i*uv;s.fillStyle=pm(vv(u)),s.fillRect(cv-c-1,uv-d,1,d)}}a=window.requestAnimationFrame(o)}(),function(){return window.cancelAnimationFrame(a)}}),[n]),(0,e.jsx)(e.Fragment,{children:(0,e.jsxs)("div",{className:iv,children:[(0,e.jsx)("canvas",{ref:r,className:av,width:cv,height:uv}),(0,e.jsxs)("div",{className:ov,children:["CPU Main: ".concat(t.cpuMainThreadTime.toFixed(2).padStart(5," "),"ms    Render: ").concat(t.cpuRenderThreadTime.toFixed(2).padStart(5," "),"ms"),"GPU: ".concat(t.gpuTime.toFixed(2).padStart(5," "),"ms     Total: ").concat(t.fullFameTime.toFixed(2).padStart(5," "),"ms"),"".concat(t.fps.toFixed(2)," FPS")]})]})})},hv={r:0,g:1,b:0,a:1},mv={r:1,g:1,b:0,a:1},pv={r:1,g:0,b:0,a:1};function vv(e){var t=at((e-4)/16,0,1);return t<.5?xm(pv,mv,2*t):xm(mv,hv,2*t-1)}const gv={"color-legend":"color-legend_Bzi",colorLegend:"color-legend_Bzi",symbol:"symbol_aAH",value:"value_rfe"};var yv=function(t){var n=t.color,r=t.label,o=t.className,a=t.children;return(0,e.jsxs)("div",{className:Oe()(gv.colorLegend,o),children:[(0,e.jsx)(bv,{color:n}),(0,e.jsx)("div",{className:gv.label,children:r}),i.Children.count(a)>0&&(0,e.jsx)("div",{className:gv.value,children:a})]})},bv=function(t){var n=t.color,r=t.className;return(0,e.jsx)("div",{className:Oe()(gv.symbol,r),style:{backgroundColor:n}})};function xv(){}const _v=(()=>{let e=0;return()=>e++})();function jv(e){return null==e}function Ev(e){if(Array.isArray&&Array.isArray(e))return!0;const t=Object.prototype.toString.call(e);return"[object"===t.slice(0,7)&&"Array]"===t.slice(-6)}function Ov(e){return null!==e&&"[object Object]"===Object.prototype.toString.call(e)}function Tv(e){return("number"==typeof e||e instanceof Number)&&isFinite(+e)}function Iv(e,t){return Tv(e)?e:t}function Sv(e,t){return void 0===e?t:e}const wv=(e,t)=>"string"==typeof e&&e.endsWith("%")?parseFloat(e)/100*t:+e;function Nv(e,t,n){if(e&&"function"==typeof e.call)return e.apply(n,t)}function Pv(e,t,n,r){let i,o,a;if(Ev(e))if(o=e.length,r)for(i=o-1;i>=0;i--)t.call(n,e[i],i);else for(i=0;i<o;i++)t.call(n,e[i],i);else if(Ov(e))for(a=Object.keys(e),o=a.length,i=0;i<o;i++)t.call(n,e[a[i]],a[i])}function Cv(e,t){let n,r,i,o;if(!e||!t||e.length!==t.length)return!1;for(n=0,r=e.length;n<r;++n)if(i=e[n],o=t[n],i.datasetIndex!==o.datasetIndex||i.index!==o.index)return!1;return!0}function Av(e){if(Ev(e))return e.map(Av);if(Ov(e)){const t=Object.create(null),n=Object.keys(e),r=n.length;let i=0;for(;i<r;++i)t[n[i]]=Av(e[n[i]]);return t}return e}function Lv(e){return-1===["__proto__","prototype","constructor"].indexOf(e)}function Mv(e,t,n,r){if(!Lv(e))return;const i=t[e],o=n[e];Ov(i)&&Ov(o)?Rv(i,o,r):t[e]=Av(o)}function Rv(e,t,n){const r=Ev(t)?t:[t],i=r.length;if(!Ov(e))return e;const o=(n=n||{}).merger||Mv;let a;for(let t=0;t<i;++t){if(a=r[t],!Ov(a))continue;const i=Object.keys(a);for(let t=0,r=i.length;t<r;++t)o(i[t],e,a,n)}return e}function kv(e,t){return Rv(e,t,{merger:Dv})}function Dv(e,t,n){if(!Lv(e))return;const r=t[e],i=n[e];Ov(r)&&Ov(i)?kv(r,i):Object.prototype.hasOwnProperty.call(t,e)||(t[e]=Av(i))}const Uv={"":e=>e,x:e=>e.x,y:e=>e.y};function Fv(e,t){const n=Uv[t]||(Uv[t]=function(e){const t=function(e){const t=e.split("."),n=[];let r="";for(const e of t)r+=e,r.endsWith("\\")?r=r.slice(0,-1)+".":(n.push(r),r="");return n}(e);return e=>{for(const n of t){if(""===n)break;e=e&&e[n]}return e}}(t));return n(e)}function Gv(e){return e.charAt(0).toUpperCase()+e.slice(1)}const Vv=e=>void 0!==e,Bv=e=>"function"==typeof e,Hv=(e,t)=>{if(e.size!==t.size)return!1;for(const n of e)if(!t.has(n))return!1;return!0};const Kv=Math.PI,Wv=2*Kv,zv=Wv+Kv,Yv=Number.POSITIVE_INFINITY,Xv=Kv/180,qv=Kv/2,$v=Kv/4,Qv=2*Kv/3,Zv=Math.log10,Jv=Math.sign;function eg(e,t,n){return Math.abs(e-t)<n}function tg(e){const t=Math.round(e);e=eg(e,t,e/1e3)?t:e;const n=Math.pow(10,Math.floor(Zv(e))),r=e/n;return(r<=1?1:r<=2?2:r<=5?5:10)*n}function ng(e){return!isNaN(parseFloat(e))&&isFinite(e)}function rg(e,t,n){let r,i,o;for(r=0,i=e.length;r<i;r++)o=e[r][n],isNaN(o)||(t.min=Math.min(t.min,o),t.max=Math.max(t.max,o))}function ig(e){return e*(Kv/180)}function og(e){return e*(180/Kv)}function ag(e){if(!Tv(e))return;let t=1,n=0;for(;Math.round(e*t)/t!==e;)t*=10,n++;return n}function lg(e,t){const n=t.x-e.x,r=t.y-e.y,i=Math.sqrt(n*n+r*r);let o=Math.atan2(r,n);return o<-.5*Kv&&(o+=Wv),{angle:o,distance:i}}function sg(e,t){return Math.sqrt(Math.pow(t.x-e.x,2)+Math.pow(t.y-e.y,2))}function cg(e,t){return(e-t+zv)%Wv-Kv}function ug(e){return(e%Wv+Wv)%Wv}function dg(e,t,n,r){const i=ug(e),o=ug(t),a=ug(n),l=ug(o-i),s=ug(a-i),c=ug(i-o),u=ug(i-a);return i===o||i===a||r&&o===a||l>s&&c<u}function fg(e,t,n){return Math.max(t,Math.min(n,e))}function hg(e,t,n,r=1e-6){return e>=Math.min(t,n)-r&&e<=Math.max(t,n)+r}function mg(e,t,n){n=n||(n=>e[n]<t);let r,i=e.length-1,o=0;for(;i-o>1;)r=o+i>>1,n(r)?o=r:i=r;return{lo:o,hi:i}}const pg=(e,t,n,r)=>mg(e,n,r?r=>{const i=e[r][t];return i<n||i===n&&e[r+1][t]===n}:r=>e[r][t]<n),vg=(e,t,n)=>mg(e,n,(r=>e[r][t]>=n));const gg=["push","pop","shift","splice","unshift"];function yg(e,t){const n=e._chartjs;if(!n)return;const r=n.listeners,i=r.indexOf(t);-1!==i&&r.splice(i,1),r.length>0||(gg.forEach((t=>{delete e[t]})),delete e._chartjs)}function bg(e){const t=new Set;let n,r;for(n=0,r=e.length;n<r;++n)t.add(e[n]);return t.size===r?e:Array.from(t)}const xg="undefined"==typeof window?function(e){return e()}:window.requestAnimationFrame;function _g(e,t){let n=!1;return function(...r){n||(n=!0,xg.call(window,(()=>{n=!1,e.apply(t,r)})))}}const jg=e=>"start"===e?"left":"end"===e?"right":"center",Eg=(e,t,n)=>"start"===e?t:"end"===e?n:(t+n)/2;function Og(e,t,n){const r=t.length;let i=0,o=r;if(e._sorted){const{iScale:a,_parsed:l}=e,s=a.axis,{min:c,max:u,minDefined:d,maxDefined:f}=a.getUserBounds();d&&(i=fg(Math.min(pg(l,a.axis,c).lo,n?r:pg(t,s,a.getPixelForValue(c)).lo),0,r-1)),o=f?fg(Math.max(pg(l,a.axis,u,!0).hi+1,n?0:pg(t,s,a.getPixelForValue(u),!0).hi+1),i,r)-i:r-i}return{start:i,count:o}}function Tg(e){const{xScale:t,yScale:n,_scaleRanges:r}=e,i={xmin:t.min,xmax:t.max,ymin:n.min,ymax:n.max};if(!r)return e._scaleRanges=i,!0;const o=r.xmin!==t.min||r.xmax!==t.max||r.ymin!==n.min||r.ymax!==n.max;return Object.assign(r,i),o}const Ig=e=>0===e||1===e,Sg=(e,t,n)=>-Math.pow(2,10*(e-=1))*Math.sin((e-t)*Wv/n),wg=(e,t,n)=>Math.pow(2,-10*e)*Math.sin((e-t)*Wv/n)+1,Ng={linear:e=>e,easeInQuad:e=>e*e,easeOutQuad:e=>-e*(e-2),easeInOutQuad:e=>(e/=.5)<1?.5*e*e:-.5*(--e*(e-2)-1),easeInCubic:e=>e*e*e,easeOutCubic:e=>(e-=1)*e*e+1,easeInOutCubic:e=>(e/=.5)<1?.5*e*e*e:.5*((e-=2)*e*e+2),easeInQuart:e=>e*e*e*e,easeOutQuart:e=>-((e-=1)*e*e*e-1),easeInOutQuart:e=>(e/=.5)<1?.5*e*e*e*e:-.5*((e-=2)*e*e*e-2),easeInQuint:e=>e*e*e*e*e,easeOutQuint:e=>(e-=1)*e*e*e*e+1,easeInOutQuint:e=>(e/=.5)<1?.5*e*e*e*e*e:.5*((e-=2)*e*e*e*e+2),easeInSine:e=>1-Math.cos(e*qv),easeOutSine:e=>Math.sin(e*qv),easeInOutSine:e=>-.5*(Math.cos(Kv*e)-1),easeInExpo:e=>0===e?0:Math.pow(2,10*(e-1)),easeOutExpo:e=>1===e?1:1-Math.pow(2,-10*e),easeInOutExpo:e=>Ig(e)?e:e<.5?.5*Math.pow(2,10*(2*e-1)):.5*(2-Math.pow(2,-10*(2*e-1))),easeInCirc:e=>e>=1?e:-(Math.sqrt(1-e*e)-1),easeOutCirc:e=>Math.sqrt(1-(e-=1)*e),easeInOutCirc:e=>(e/=.5)<1?-.5*(Math.sqrt(1-e*e)-1):.5*(Math.sqrt(1-(e-=2)*e)+1),easeInElastic:e=>Ig(e)?e:Sg(e,.075,.3),easeOutElastic:e=>Ig(e)?e:wg(e,.075,.3),easeInOutElastic(e){const t=.1125;return Ig(e)?e:e<.5?.5*Sg(2*e,t,.45):.5+.5*wg(2*e-1,t,.45)},easeInBack(e){const t=1.70158;return e*e*((t+1)*e-t)},easeOutBack(e){const t=1.70158;return(e-=1)*e*((t+1)*e+t)+1},easeInOutBack(e){let t=1.70158;return(e/=.5)<1?e*e*((1+(t*=1.525))*e-t)*.5:.5*((e-=2)*e*((1+(t*=1.525))*e+t)+2)},easeInBounce:e=>1-Ng.easeOutBounce(1-e),easeOutBounce(e){const t=7.5625,n=2.75;return e<1/n?t*e*e:e<2/n?t*(e-=1.5/n)*e+.75:e<2.5/n?t*(e-=2.25/n)*e+.9375:t*(e-=2.625/n)*e+.984375},easeInOutBounce:e=>e<.5?.5*Ng.easeInBounce(2*e):.5*Ng.easeOutBounce(2*e-1)+.5};var Pg=Ng;function Cg(e){return e+.5|0}const Ag=(e,t,n)=>Math.max(Math.min(e,n),t);function Lg(e){return Ag(Cg(2.55*e),0,255)}function Mg(e){return Ag(Cg(255*e),0,255)}function Rg(e){return Ag(Cg(e/2.55)/100,0,1)}function kg(e){return Ag(Cg(100*e),0,100)}const Dg={0:0,1:1,2:2,3:3,4:4,5:5,6:6,7:7,8:8,9:9,A:10,B:11,C:12,D:13,E:14,F:15,a:10,b:11,c:12,d:13,e:14,f:15},Ug=[..."0123456789ABCDEF"],Fg=e=>Ug[15&e],Gg=e=>Ug[(240&e)>>4]+Ug[15&e],Vg=e=>(240&e)>>4==(15&e);function Bg(e){var t=(e=>Vg(e.r)&&Vg(e.g)&&Vg(e.b)&&Vg(e.a))(e)?Fg:Gg;return e?"#"+t(e.r)+t(e.g)+t(e.b)+((e,t)=>e<255?t(e):"")(e.a,t):void 0}const Hg=/^(hsla?|hwb|hsv)\(\s*([-+.e\d]+)(?:deg)?[\s,]+([-+.e\d]+)%[\s,]+([-+.e\d]+)%(?:[\s,]+([-+.e\d]+)(%)?)?\s*\)$/;function Kg(e,t,n){const r=t*Math.min(n,1-n),i=(t,i=(t+e/30)%12)=>n-r*Math.max(Math.min(i-3,9-i,1),-1);return[i(0),i(8),i(4)]}function Wg(e,t,n){const r=(r,i=(r+e/60)%6)=>n-n*t*Math.max(Math.min(i,4-i,1),0);return[r(5),r(3),r(1)]}function zg(e,t,n){const r=Kg(e,1,.5);let i;for(t+n>1&&(i=1/(t+n),t*=i,n*=i),i=0;i<3;i++)r[i]*=1-t-n,r[i]+=t;return r}function Yg(e){const t=e.r/255,n=e.g/255,r=e.b/255,i=Math.max(t,n,r),o=Math.min(t,n,r),a=(i+o)/2;let l,s,c;return i!==o&&(c=i-o,s=a>.5?c/(2-i-o):c/(i+o),l=function(e,t,n,r,i){return e===i?(t-n)/r+(t<n?6:0):t===i?(n-e)/r+2:(e-t)/r+4}(t,n,r,c,i),l=60*l+.5),[0|l,s||0,a]}function Xg(e,t,n,r){return(Array.isArray(t)?e(t[0],t[1],t[2]):e(t,n,r)).map(Mg)}function qg(e,t,n){return Xg(Kg,e,t,n)}function $g(e){return(e%360+360)%360}function Qg(e){const t=Hg.exec(e);let n,r=255;if(!t)return;t[5]!==n&&(r=t[6]?Lg(+t[5]):Mg(+t[5]));const i=$g(+t[2]),o=+t[3]/100,a=+t[4]/100;return n="hwb"===t[1]?function(e,t,n){return Xg(zg,e,t,n)}(i,o,a):"hsv"===t[1]?function(e,t,n){return Xg(Wg,e,t,n)}(i,o,a):qg(i,o,a),{r:n[0],g:n[1],b:n[2],a:r}}const Zg={x:"dark",Z:"light",Y:"re",X:"blu",W:"gr",V:"medium",U:"slate",A:"ee",T:"ol",S:"or",B:"ra",C:"lateg",D:"ights",R:"in",Q:"turquois",E:"hi",P:"ro",O:"al",N:"le",M:"de",L:"yello",F:"en",K:"ch",G:"arks",H:"ea",I:"ightg",J:"wh"},Jg={OiceXe:"f0f8ff",antiquewEte:"faebd7",aqua:"ffff",aquamarRe:"7fffd4",azuY:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"0",blanKedOmond:"ffebcd",Xe:"ff",XeviTet:"8a2be2",bPwn:"a52a2a",burlywood:"deb887",caMtXe:"5f9ea0",KartYuse:"7fff00",KocTate:"d2691e",cSO:"ff7f50",cSnflowerXe:"6495ed",cSnsilk:"fff8dc",crimson:"dc143c",cyan:"ffff",xXe:"8b",xcyan:"8b8b",xgTMnPd:"b8860b",xWay:"a9a9a9",xgYF:"6400",xgYy:"a9a9a9",xkhaki:"bdb76b",xmagFta:"8b008b",xTivegYF:"556b2f",xSange:"ff8c00",xScEd:"9932cc",xYd:"8b0000",xsOmon:"e9967a",xsHgYF:"8fbc8f",xUXe:"483d8b",xUWay:"2f4f4f",xUgYy:"2f4f4f",xQe:"ced1",xviTet:"9400d3",dAppRk:"ff1493",dApskyXe:"bfff",dimWay:"696969",dimgYy:"696969",dodgerXe:"1e90ff",fiYbrick:"b22222",flSOwEte:"fffaf0",foYstWAn:"228b22",fuKsia:"ff00ff",gaRsbSo:"dcdcdc",ghostwEte:"f8f8ff",gTd:"ffd700",gTMnPd:"daa520",Way:"808080",gYF:"8000",gYFLw:"adff2f",gYy:"808080",honeyMw:"f0fff0",hotpRk:"ff69b4",RdianYd:"cd5c5c",Rdigo:"4b0082",ivSy:"fffff0",khaki:"f0e68c",lavFMr:"e6e6fa",lavFMrXsh:"fff0f5",lawngYF:"7cfc00",NmoncEffon:"fffacd",ZXe:"add8e6",ZcSO:"f08080",Zcyan:"e0ffff",ZgTMnPdLw:"fafad2",ZWay:"d3d3d3",ZgYF:"90ee90",ZgYy:"d3d3d3",ZpRk:"ffb6c1",ZsOmon:"ffa07a",ZsHgYF:"20b2aa",ZskyXe:"87cefa",ZUWay:"778899",ZUgYy:"778899",ZstAlXe:"b0c4de",ZLw:"ffffe0",lime:"ff00",limegYF:"32cd32",lRF:"faf0e6",magFta:"ff00ff",maPon:"800000",VaquamarRe:"66cdaa",VXe:"cd",VScEd:"ba55d3",VpurpN:"9370db",VsHgYF:"3cb371",VUXe:"7b68ee",VsprRggYF:"fa9a",VQe:"48d1cc",VviTetYd:"c71585",midnightXe:"191970",mRtcYam:"f5fffa",mistyPse:"ffe4e1",moccasR:"ffe4b5",navajowEte:"ffdead",navy:"80",Tdlace:"fdf5e6",Tive:"808000",TivedBb:"6b8e23",Sange:"ffa500",SangeYd:"ff4500",ScEd:"da70d6",pOegTMnPd:"eee8aa",pOegYF:"98fb98",pOeQe:"afeeee",pOeviTetYd:"db7093",papayawEp:"ffefd5",pHKpuff:"ffdab9",peru:"cd853f",pRk:"ffc0cb",plum:"dda0dd",powMrXe:"b0e0e6",purpN:"800080",YbeccapurpN:"663399",Yd:"ff0000",Psybrown:"bc8f8f",PyOXe:"4169e1",saddNbPwn:"8b4513",sOmon:"fa8072",sandybPwn:"f4a460",sHgYF:"2e8b57",sHshell:"fff5ee",siFna:"a0522d",silver:"c0c0c0",skyXe:"87ceeb",UXe:"6a5acd",UWay:"708090",UgYy:"708090",snow:"fffafa",sprRggYF:"ff7f",stAlXe:"4682b4",tan:"d2b48c",teO:"8080",tEstN:"d8bfd8",tomato:"ff6347",Qe:"40e0d0",viTet:"ee82ee",JHt:"f5deb3",wEte:"ffffff",wEtesmoke:"f5f5f5",Lw:"ffff00",LwgYF:"9acd32"};let ey;function ty(e){ey||(ey=function(){const e={},t=Object.keys(Jg),n=Object.keys(Zg);let r,i,o,a,l;for(r=0;r<t.length;r++){for(a=l=t[r],i=0;i<n.length;i++)o=n[i],l=l.replace(o,Zg[o]);o=parseInt(Jg[a],16),e[l]=[o>>16&255,o>>8&255,255&o]}return e}(),ey.transparent=[0,0,0,0]);const t=ey[e.toLowerCase()];return t&&{r:t[0],g:t[1],b:t[2],a:4===t.length?t[3]:255}}const ny=/^rgba?\(\s*([-+.\d]+)(%)?[\s,]+([-+.e\d]+)(%)?[\s,]+([-+.e\d]+)(%)?(?:[\s,/]+([-+.e\d]+)(%)?)?\s*\)$/;const ry=e=>e<=.0031308?12.92*e:1.055*Math.pow(e,1/2.4)-.055,iy=e=>e<=.04045?e/12.92:Math.pow((e+.055)/1.055,2.4);function oy(e,t,n){if(e){let r=Yg(e);r[t]=Math.max(0,Math.min(r[t]+r[t]*n,0===t?360:1)),r=qg(r),e.r=r[0],e.g=r[1],e.b=r[2]}}function ay(e,t){return e?Object.assign(t||{},e):e}function ly(e){var t={r:0,g:0,b:0,a:255};return Array.isArray(e)?e.length>=3&&(t={r:e[0],g:e[1],b:e[2],a:255},e.length>3&&(t.a=Mg(e[3]))):(t=ay(e,{r:0,g:0,b:0,a:1})).a=Mg(t.a),t}function sy(e){return"r"===e.charAt(0)?function(e){const t=ny.exec(e);let n,r,i,o=255;if(t){if(t[7]!==n){const e=+t[7];o=t[8]?Lg(e):Ag(255*e,0,255)}return n=+t[1],r=+t[3],i=+t[5],n=255&(t[2]?Lg(n):Ag(n,0,255)),r=255&(t[4]?Lg(r):Ag(r,0,255)),i=255&(t[6]?Lg(i):Ag(i,0,255)),{r:n,g:r,b:i,a:o}}}(e):Qg(e)}class cy{constructor(e){if(e instanceof cy)return e;const t=typeof e;let n;var r,i,o;"object"===t?n=ly(e):"string"===t&&(o=(r=e).length,"#"===r[0]&&(4===o||5===o?i={r:255&17*Dg[r[1]],g:255&17*Dg[r[2]],b:255&17*Dg[r[3]],a:5===o?17*Dg[r[4]]:255}:7!==o&&9!==o||(i={r:Dg[r[1]]<<4|Dg[r[2]],g:Dg[r[3]]<<4|Dg[r[4]],b:Dg[r[5]]<<4|Dg[r[6]],a:9===o?Dg[r[7]]<<4|Dg[r[8]]:255})),n=i||ty(e)||sy(e)),this._rgb=n,this._valid=!!n}get valid(){return this._valid}get rgb(){var e=ay(this._rgb);return e&&(e.a=Rg(e.a)),e}set rgb(e){this._rgb=ly(e)}rgbString(){return this._valid?(e=this._rgb)&&(e.a<255?`rgba(${e.r}, ${e.g}, ${e.b}, ${Rg(e.a)})`:`rgb(${e.r}, ${e.g}, ${e.b})`):void 0;var e}hexString(){return this._valid?Bg(this._rgb):void 0}hslString(){return this._valid?function(e){if(!e)return;const t=Yg(e),n=t[0],r=kg(t[1]),i=kg(t[2]);return e.a<255?`hsla(${n}, ${r}%, ${i}%, ${Rg(e.a)})`:`hsl(${n}, ${r}%, ${i}%)`}(this._rgb):void 0}mix(e,t){if(e){const n=this.rgb,r=e.rgb;let i;const o=t===i?.5:t,a=2*o-1,l=n.a-r.a,s=((a*l==-1?a:(a+l)/(1+a*l))+1)/2;i=1-s,n.r=255&s*n.r+i*r.r+.5,n.g=255&s*n.g+i*r.g+.5,n.b=255&s*n.b+i*r.b+.5,n.a=o*n.a+(1-o)*r.a,this.rgb=n}return this}interpolate(e,t){return e&&(this._rgb=function(e,t,n){const r=iy(Rg(e.r)),i=iy(Rg(e.g)),o=iy(Rg(e.b));return{r:Mg(ry(r+n*(iy(Rg(t.r))-r))),g:Mg(ry(i+n*(iy(Rg(t.g))-i))),b:Mg(ry(o+n*(iy(Rg(t.b))-o))),a:e.a+n*(t.a-e.a)}}(this._rgb,e._rgb,t)),this}clone(){return new cy(this.rgb)}alpha(e){return this._rgb.a=Mg(e),this}clearer(e){return this._rgb.a*=1-e,this}greyscale(){const e=this._rgb,t=Cg(.3*e.r+.59*e.g+.11*e.b);return e.r=e.g=e.b=t,this}opaquer(e){return this._rgb.a*=1+e,this}negate(){const e=this._rgb;return e.r=255-e.r,e.g=255-e.g,e.b=255-e.b,this}lighten(e){return oy(this._rgb,2,e),this}darken(e){return oy(this._rgb,2,-e),this}saturate(e){return oy(this._rgb,1,e),this}desaturate(e){return oy(this._rgb,1,-e),this}rotate(e){return function(e,t){var n=Yg(e);n[0]=$g(n[0]+t),n=qg(n),e.r=n[0],e.g=n[1],e.b=n[2]}(this._rgb,e),this}}function uy(e){return new cy(e)}function dy(e){if(e&&"object"==typeof e){const t=e.toString();return"[object CanvasPattern]"===t||"[object CanvasGradient]"===t}return!1}function fy(e){return dy(e)?e:uy(e)}function hy(e){return dy(e)?e:uy(e).saturate(.5).darken(.1).hexString()}const my=["x","y","borderWidth","radius","tension"],py=["color","borderColor","backgroundColor"];const vy=new Map;function gy(e,t,n){return function(e,t){t=t||{};const n=e+JSON.stringify(t);let r=vy.get(n);return r||(r=new Intl.NumberFormat(e,t),vy.set(n,r)),r}(t,n).format(e)}const yy={values:e=>Ev(e)?e:""+e,numeric(e,t,n){if(0===e)return"0";const r=this.chart.options.locale;let i,o=e;if(n.length>1){const t=Math.max(Math.abs(n[0].value),Math.abs(n[n.length-1].value));(t<1e-4||t>1e15)&&(i="scientific"),o=function(e,t){let n=t.length>3?t[2].value-t[1].value:t[1].value-t[0].value;Math.abs(n)>=1&&e!==Math.floor(e)&&(n=e-Math.floor(e));return n}(e,n)}const a=Zv(Math.abs(o)),l=Math.max(Math.min(-1*Math.floor(a),20),0),s={notation:i,minimumFractionDigits:l,maximumFractionDigits:l};return Object.assign(s,this.options.ticks.format),gy(e,r,s)},logarithmic(e,t,n){if(0===e)return"0";const r=n[t].significand||e/Math.pow(10,Math.floor(Zv(e)));return[1,2,3,5,10,15].includes(r)||t>.8*n.length?yy.numeric.call(this,e,t,n):""}};var by={formatters:yy};const xy=Object.create(null),_y=Object.create(null);function jy(e,t){if(!t)return e;const n=t.split(".");for(let t=0,r=n.length;t<r;++t){const r=n[t];e=e[r]||(e[r]=Object.create(null))}return e}function Ey(e,t,n){return"string"==typeof t?Rv(jy(e,t),n):Rv(jy(e,""),t)}class Oy{constructor(e,t){this.animation=void 0,this.backgroundColor="rgba(0,0,0,0.1)",this.borderColor="rgba(0,0,0,0.1)",this.color="#666",this.datasets={},this.devicePixelRatio=e=>e.chart.platform.getDevicePixelRatio(),this.elements={},this.events=["mousemove","mouseout","click","touchstart","touchmove"],this.font={family:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",size:12,style:"normal",lineHeight:1.2,weight:null},this.hover={},this.hoverBackgroundColor=(e,t)=>hy(t.backgroundColor),this.hoverBorderColor=(e,t)=>hy(t.borderColor),this.hoverColor=(e,t)=>hy(t.color),this.indexAxis="x",this.interaction={mode:"nearest",intersect:!0,includeInvisible:!1},this.maintainAspectRatio=!0,this.onHover=null,this.onClick=null,this.parsing=!0,this.plugins={},this.responsive=!0,this.scale=void 0,this.scales={},this.showLine=!0,this.drawActiveElementsOnTop=!0,this.describe(e),this.apply(t)}set(e,t){return Ey(this,e,t)}get(e){return jy(this,e)}describe(e,t){return Ey(_y,e,t)}override(e,t){return Ey(xy,e,t)}route(e,t,n,r){const i=jy(this,e),o=jy(this,n),a="_"+t;Object.defineProperties(i,{[a]:{value:i[t],writable:!0},[t]:{enumerable:!0,get(){const e=this[a],t=o[r];return Ov(e)?Object.assign({},t,e):Sv(e,t)},set(e){this[a]=e}}})}apply(e){e.forEach((e=>e(this)))}}var Ty=new Oy({_scriptable:e=>!e.startsWith("on"),_indexable:e=>"events"!==e,hover:{_fallback:"interaction"},interaction:{_scriptable:!1,_indexable:!1}},[function(e){e.set("animation",{delay:void 0,duration:1e3,easing:"easeOutQuart",fn:void 0,from:void 0,loop:void 0,to:void 0,type:void 0}),e.describe("animation",{_fallback:!1,_indexable:!1,_scriptable:e=>"onProgress"!==e&&"onComplete"!==e&&"fn"!==e}),e.set("animations",{colors:{type:"color",properties:py},numbers:{type:"number",properties:my}}),e.describe("animations",{_fallback:"animation"}),e.set("transitions",{active:{animation:{duration:400}},resize:{animation:{duration:0}},show:{animations:{colors:{from:"transparent"},visible:{type:"boolean",duration:0}}},hide:{animations:{colors:{to:"transparent"},visible:{type:"boolean",easing:"linear",fn:e=>0|e}}}})},function(e){e.set("layout",{autoPadding:!0,padding:{top:0,right:0,bottom:0,left:0}})},function(e){e.set("scale",{display:!0,offset:!1,reverse:!1,beginAtZero:!1,bounds:"ticks",grace:0,grid:{display:!0,lineWidth:1,drawOnChartArea:!0,drawTicks:!0,tickLength:8,tickWidth:(e,t)=>t.lineWidth,tickColor:(e,t)=>t.color,offset:!1},border:{display:!0,dash:[],dashOffset:0,width:1},title:{display:!1,text:"",padding:{top:4,bottom:4}},ticks:{minRotation:0,maxRotation:50,mirror:!1,textStrokeWidth:0,textStrokeColor:"",padding:3,display:!0,autoSkip:!0,autoSkipPadding:3,labelOffset:0,callback:by.formatters.values,minor:{},major:{},align:"center",crossAlign:"near",showLabelBackdrop:!1,backdropColor:"rgba(255, 255, 255, 0.75)",backdropPadding:2}}),e.route("scale.ticks","color","","color"),e.route("scale.grid","color","","borderColor"),e.route("scale.border","color","","borderColor"),e.route("scale.title","color","","color"),e.describe("scale",{_fallback:!1,_scriptable:e=>!e.startsWith("before")&&!e.startsWith("after")&&"callback"!==e&&"parser"!==e,_indexable:e=>"borderDash"!==e&&"tickBorderDash"!==e&&"dash"!==e}),e.describe("scales",{_fallback:"scale"}),e.describe("scale.ticks",{_scriptable:e=>"backdropPadding"!==e&&"callback"!==e,_indexable:e=>"backdropPadding"!==e})}]);function Iy(e,t,n,r,i){let o=t[i];return o||(o=t[i]=e.measureText(i).width,n.push(i)),o>r&&(r=o),r}function Sy(e,t,n){const r=e.currentDevicePixelRatio,i=0!==n?Math.max(n/2,.5):0;return Math.round((t-i)*r)/r+i}function wy(e,t){(t=t||e.getContext("2d")).save(),t.resetTransform(),t.clearRect(0,0,e.width,e.height),t.restore()}function Ny(e,t,n,r){Py(e,t,n,r,null)}function Py(e,t,n,r,i){let o,a,l,s,c,u,d,f;const h=t.pointStyle,m=t.rotation,p=t.radius;let v=(m||0)*Xv;if(h&&"object"==typeof h&&(o=h.toString(),"[object HTMLImageElement]"===o||"[object HTMLCanvasElement]"===o))return e.save(),e.translate(n,r),e.rotate(v),e.drawImage(h,-h.width/2,-h.height/2,h.width,h.height),void e.restore();if(!(isNaN(p)||p<=0)){switch(e.beginPath(),h){default:i?e.ellipse(n,r,i/2,p,0,0,Wv):e.arc(n,r,p,0,Wv),e.closePath();break;case"triangle":u=i?i/2:p,e.moveTo(n+Math.sin(v)*u,r-Math.cos(v)*p),v+=Qv,e.lineTo(n+Math.sin(v)*u,r-Math.cos(v)*p),v+=Qv,e.lineTo(n+Math.sin(v)*u,r-Math.cos(v)*p),e.closePath();break;case"rectRounded":c=.516*p,s=p-c,a=Math.cos(v+$v)*s,d=Math.cos(v+$v)*(i?i/2-c:s),l=Math.sin(v+$v)*s,f=Math.sin(v+$v)*(i?i/2-c:s),e.arc(n-d,r-l,c,v-Kv,v-qv),e.arc(n+f,r-a,c,v-qv,v),e.arc(n+d,r+l,c,v,v+qv),e.arc(n-f,r+a,c,v+qv,v+Kv),e.closePath();break;case"rect":if(!m){s=Math.SQRT1_2*p,u=i?i/2:s,e.rect(n-u,r-s,2*u,2*s);break}v+=$v;case"rectRot":d=Math.cos(v)*(i?i/2:p),a=Math.cos(v)*p,l=Math.sin(v)*p,f=Math.sin(v)*(i?i/2:p),e.moveTo(n-d,r-l),e.lineTo(n+f,r-a),e.lineTo(n+d,r+l),e.lineTo(n-f,r+a),e.closePath();break;case"crossRot":v+=$v;case"cross":d=Math.cos(v)*(i?i/2:p),a=Math.cos(v)*p,l=Math.sin(v)*p,f=Math.sin(v)*(i?i/2:p),e.moveTo(n-d,r-l),e.lineTo(n+d,r+l),e.moveTo(n+f,r-a),e.lineTo(n-f,r+a);break;case"star":d=Math.cos(v)*(i?i/2:p),a=Math.cos(v)*p,l=Math.sin(v)*p,f=Math.sin(v)*(i?i/2:p),e.moveTo(n-d,r-l),e.lineTo(n+d,r+l),e.moveTo(n+f,r-a),e.lineTo(n-f,r+a),v+=$v,d=Math.cos(v)*(i?i/2:p),a=Math.cos(v)*p,l=Math.sin(v)*p,f=Math.sin(v)*(i?i/2:p),e.moveTo(n-d,r-l),e.lineTo(n+d,r+l),e.moveTo(n+f,r-a),e.lineTo(n-f,r+a);break;case"line":a=i?i/2:Math.cos(v)*p,l=Math.sin(v)*p,e.moveTo(n-a,r-l),e.lineTo(n+a,r+l);break;case"dash":e.moveTo(n,r),e.lineTo(n+Math.cos(v)*(i?i/2:p),r+Math.sin(v)*p)}e.fill(),t.borderWidth>0&&e.stroke()}}function Cy(e,t,n){return n=n||.5,!t||e&&e.x>t.left-n&&e.x<t.right+n&&e.y>t.top-n&&e.y<t.bottom+n}function Ay(e,t){e.save(),e.beginPath(),e.rect(t.left,t.top,t.right-t.left,t.bottom-t.top),e.clip()}function Ly(e){e.restore()}function My(e,t,n,r,i){if(!t)return e.lineTo(n.x,n.y);if("middle"===i){const r=(t.x+n.x)/2;e.lineTo(r,t.y),e.lineTo(r,n.y)}else"after"===i!=!!r?e.lineTo(t.x,n.y):e.lineTo(n.x,t.y);e.lineTo(n.x,n.y)}function Ry(e,t,n,r){if(!t)return e.lineTo(n.x,n.y);e.bezierCurveTo(r?t.cp1x:t.cp2x,r?t.cp1y:t.cp2y,r?n.cp2x:n.cp1x,r?n.cp2y:n.cp1y,n.x,n.y)}function ky(e,t,n,r,i,o={}){const a=Ev(t)?t:[t],l=o.strokeWidth>0&&""!==o.strokeColor;let s,c;for(e.save(),e.font=i.string,function(e,t){t.translation&&e.translate(t.translation[0],t.translation[1]);jv(t.rotation)||e.rotate(t.rotation);t.color&&(e.fillStyle=t.color);t.textAlign&&(e.textAlign=t.textAlign);t.textBaseline&&(e.textBaseline=t.textBaseline)}(e,o),s=0;s<a.length;++s)c=a[s],o.backdrop&&Uy(e,o.backdrop),l&&(o.strokeColor&&(e.strokeStyle=o.strokeColor),jv(o.strokeWidth)||(e.lineWidth=o.strokeWidth),e.strokeText(c,n,r,o.maxWidth)),e.fillText(c,n,r,o.maxWidth),Dy(e,n,r,c,o),r+=i.lineHeight;e.restore()}function Dy(e,t,n,r,i){if(i.strikethrough||i.underline){const o=e.measureText(r),a=t-o.actualBoundingBoxLeft,l=t+o.actualBoundingBoxRight,s=n-o.actualBoundingBoxAscent,c=n+o.actualBoundingBoxDescent,u=i.strikethrough?(s+c)/2:c;e.strokeStyle=e.fillStyle,e.beginPath(),e.lineWidth=i.decorationWidth||2,e.moveTo(a,u),e.lineTo(l,u),e.stroke()}}function Uy(e,t){const n=e.fillStyle;e.fillStyle=t.color,e.fillRect(t.left,t.top,t.width,t.height),e.fillStyle=n}function Fy(e,t){const{x:n,y:r,w:i,h:o,radius:a}=t;e.arc(n+a.topLeft,r+a.topLeft,a.topLeft,-qv,Kv,!0),e.lineTo(n,r+o-a.bottomLeft),e.arc(n+a.bottomLeft,r+o-a.bottomLeft,a.bottomLeft,Kv,qv,!0),e.lineTo(n+i-a.bottomRight,r+o),e.arc(n+i-a.bottomRight,r+o-a.bottomRight,a.bottomRight,qv,0,!0),e.lineTo(n+i,r+a.topRight),e.arc(n+i-a.topRight,r+a.topRight,a.topRight,0,-qv,!0),e.lineTo(n+a.topLeft,r)}const Gy=/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/,Vy=/^(normal|italic|initial|inherit|unset|(oblique( -?[0-9]?[0-9]deg)?))$/;function By(e,t){const n=(""+e).match(Gy);if(!n||"normal"===n[1])return 1.2*t;switch(e=+n[2],n[3]){case"px":return e;case"%":e/=100}return t*e}function Hy(e,t){const n={},r=Ov(t),i=r?Object.keys(t):t,o=Ov(e)?r?n=>Sv(e[n],e[t[n]]):t=>e[t]:()=>e;for(const e of i)n[e]=+o(e)||0;return n}function Ky(e){return Hy(e,{top:"y",right:"x",bottom:"y",left:"x"})}function Wy(e){return Hy(e,["topLeft","topRight","bottomLeft","bottomRight"])}function zy(e){const t=Ky(e);return t.width=t.left+t.right,t.height=t.top+t.bottom,t}function Yy(e,t){e=e||{},t=t||Ty.font;let n=Sv(e.size,t.size);"string"==typeof n&&(n=parseInt(n,10));let r=Sv(e.style,t.style);r&&!(""+r).match(Vy)&&(console.warn('Invalid font style specified: "'+r+'"'),r=void 0);const i={family:Sv(e.family,t.family),lineHeight:By(Sv(e.lineHeight,t.lineHeight),n),size:n,style:r,weight:Sv(e.weight,t.weight),string:""};return i.string=function(e){return!e||jv(e.size)||jv(e.family)?null:(e.style?e.style+" ":"")+(e.weight?e.weight+" ":"")+e.size+"px "+e.family}(i),i}function Xy(e,t,n,r){let i,o,a,l=!0;for(i=0,o=e.length;i<o;++i)if(a=e[i],void 0!==a&&(void 0!==t&&"function"==typeof a&&(a=a(t),l=!1),void 0!==n&&Ev(a)&&(a=a[n%a.length],l=!1),void 0!==a))return r&&!l&&(r.cacheable=!1),a}function qy(e,t){return Object.assign(Object.create(e),t)}function $y(e,t=[""],n=e,r,i=(()=>e[0])){Vv(r)||(r=lb("_fallback",e));const o={[Symbol.toStringTag]:"Object",_cacheable:!0,_scopes:e,_rootScopes:n,_fallback:r,_getTarget:i,override:i=>$y([i,...e],t,n,r)};return new Proxy(o,{deleteProperty:(t,n)=>(delete t[n],delete t._keys,delete e[0][n],!0),get:(n,r)=>tb(n,r,(()=>function(e,t,n,r){let i;for(const o of t)if(i=lb(Jy(o,e),n),Vv(i))return eb(e,i)?ob(n,r,e,i):i}(r,t,e,n))),getOwnPropertyDescriptor:(e,t)=>Reflect.getOwnPropertyDescriptor(e._scopes[0],t),getPrototypeOf:()=>Reflect.getPrototypeOf(e[0]),has:(e,t)=>sb(e).includes(t),ownKeys:e=>sb(e),set(e,t,n){const r=e._storage||(e._storage=i());return e[t]=r[t]=n,delete e._keys,!0}})}function Qy(e,t,n,r){const i={_cacheable:!1,_proxy:e,_context:t,_subProxy:n,_stack:new Set,_descriptors:Zy(e,r),setContext:t=>Qy(e,t,n,r),override:i=>Qy(e.override(i),t,n,r)};return new Proxy(i,{deleteProperty:(t,n)=>(delete t[n],delete e[n],!0),get:(e,t,n)=>tb(e,t,(()=>function(e,t,n){const{_proxy:r,_context:i,_subProxy:o,_descriptors:a}=e;let l=r[t];Bv(l)&&a.isScriptable(t)&&(l=function(e,t,n,r){const{_proxy:i,_context:o,_subProxy:a,_stack:l}=n;if(l.has(e))throw new Error("Recursion detected: "+Array.from(l).join("->")+"->"+e);l.add(e),t=t(o,a||r),l.delete(e),eb(e,t)&&(t=ob(i._scopes,i,e,t));return t}(t,l,e,n));Ev(l)&&l.length&&(l=function(e,t,n,r){const{_proxy:i,_context:o,_subProxy:a,_descriptors:l}=n;if(Vv(o.index)&&r(e))t=t[o.index%t.length];else if(Ov(t[0])){const n=t,r=i._scopes.filter((e=>e!==n));t=[];for(const s of n){const n=ob(r,i,e,s);t.push(Qy(n,o,a&&a[e],l))}}return t}(t,l,e,a.isIndexable));eb(t,l)&&(l=Qy(l,i,o&&o[t],a));return l}(e,t,n))),getOwnPropertyDescriptor:(t,n)=>t._descriptors.allKeys?Reflect.has(e,n)?{enumerable:!0,configurable:!0}:void 0:Reflect.getOwnPropertyDescriptor(e,n),getPrototypeOf:()=>Reflect.getPrototypeOf(e),has:(t,n)=>Reflect.has(e,n),ownKeys:()=>Reflect.ownKeys(e),set:(t,n,r)=>(e[n]=r,delete t[n],!0)})}function Zy(e,t={scriptable:!0,indexable:!0}){const{_scriptable:n=t.scriptable,_indexable:r=t.indexable,_allKeys:i=t.allKeys}=e;return{allKeys:i,scriptable:n,indexable:r,isScriptable:Bv(n)?n:()=>n,isIndexable:Bv(r)?r:()=>r}}const Jy=(e,t)=>e?e+Gv(t):t,eb=(e,t)=>Ov(t)&&"adapters"!==e&&(null===Object.getPrototypeOf(t)||t.constructor===Object);function tb(e,t,n){if(Object.prototype.hasOwnProperty.call(e,t))return e[t];const r=n();return e[t]=r,r}function nb(e,t,n){return Bv(e)?e(t,n):e}const rb=(e,t)=>!0===e?t:"string"==typeof e?Fv(t,e):void 0;function ib(e,t,n,r,i){for(const o of t){const t=rb(n,o);if(t){e.add(t);const o=nb(t._fallback,n,i);if(Vv(o)&&o!==n&&o!==r)return o}else if(!1===t&&Vv(r)&&n!==r)return null}return!1}function ob(e,t,n,r){const i=t._rootScopes,o=nb(t._fallback,n,r),a=[...e,...i],l=new Set;l.add(r);let s=ab(l,a,n,o||n,r);return null!==s&&((!Vv(o)||o===n||(s=ab(l,a,o,s,r),null!==s))&&$y(Array.from(l),[""],i,o,(()=>function(e,t,n){const r=e._getTarget();t in r||(r[t]={});const i=r[t];if(Ev(i)&&Ov(n))return n;return i||{}}(t,n,r))))}function ab(e,t,n,r,i){for(;n;)n=ib(e,t,n,r,i);return n}function lb(e,t){for(const n of t){if(!n)continue;const t=n[e];if(Vv(t))return t}}function sb(e){let t=e._keys;return t||(t=e._keys=function(e){const t=new Set;for(const n of e)for(const e of Object.keys(n).filter((e=>!e.startsWith("_"))))t.add(e);return Array.from(t)}(e._scopes)),t}const cb=Number.EPSILON||1e-14,ub=(e,t)=>t<e.length&&!e[t].skip&&e[t],db=e=>"x"===e?"y":"x";function fb(e,t,n,r){const i=e.skip?t:e,o=t,a=n.skip?t:n,l=sg(o,i),s=sg(a,o);let c=l/(l+s),u=s/(l+s);c=isNaN(c)?0:c,u=isNaN(u)?0:u;const d=r*c,f=r*u;return{previous:{x:o.x-d*(a.x-i.x),y:o.y-d*(a.y-i.y)},next:{x:o.x+f*(a.x-i.x),y:o.y+f*(a.y-i.y)}}}function hb(e,t="x"){const n=db(t),r=e.length,i=Array(r).fill(0),o=Array(r);let a,l,s,c=ub(e,0);for(a=0;a<r;++a)if(l=s,s=c,c=ub(e,a+1),s){if(c){const e=c[t]-s[t];i[a]=0!==e?(c[n]-s[n])/e:0}o[a]=l?c?Jv(i[a-1])!==Jv(i[a])?0:(i[a-1]+i[a])/2:i[a-1]:i[a]}!function(e,t,n){const r=e.length;let i,o,a,l,s,c=ub(e,0);for(let u=0;u<r-1;++u)s=c,c=ub(e,u+1),s&&c&&(eg(t[u],0,cb)?n[u]=n[u+1]=0:(i=n[u]/t[u],o=n[u+1]/t[u],l=Math.pow(i,2)+Math.pow(o,2),l<=9||(a=3/Math.sqrt(l),n[u]=i*a*t[u],n[u+1]=o*a*t[u])))}(e,i,o),function(e,t,n="x"){const r=db(n),i=e.length;let o,a,l,s=ub(e,0);for(let c=0;c<i;++c){if(a=l,l=s,s=ub(e,c+1),!l)continue;const i=l[n],u=l[r];a&&(o=(i-a[n])/3,l[`cp1${n}`]=i-o,l[`cp1${r}`]=u-o*t[c]),s&&(o=(s[n]-i)/3,l[`cp2${n}`]=i+o,l[`cp2${r}`]=u+o*t[c])}}(e,o,t)}function mb(e,t,n){return Math.max(Math.min(e,n),t)}function pb(e,t,n,r,i){let o,a,l,s;if(t.spanGaps&&(e=e.filter((e=>!e.skip))),"monotone"===t.cubicInterpolationMode)hb(e,i);else{let n=r?e[e.length-1]:e[0];for(o=0,a=e.length;o<a;++o)l=e[o],s=fb(n,l,e[Math.min(o+1,a-(r?0:1))%a],t.tension),l.cp1x=s.previous.x,l.cp1y=s.previous.y,l.cp2x=s.next.x,l.cp2y=s.next.y,n=l}t.capBezierPoints&&function(e,t){let n,r,i,o,a,l=Cy(e[0],t);for(n=0,r=e.length;n<r;++n)a=o,o=l,l=n<r-1&&Cy(e[n+1],t),o&&(i=e[n],a&&(i.cp1x=mb(i.cp1x,t.left,t.right),i.cp1y=mb(i.cp1y,t.top,t.bottom)),l&&(i.cp2x=mb(i.cp2x,t.left,t.right),i.cp2y=mb(i.cp2y,t.top,t.bottom)))}(e,n)}function vb(){return"undefined"!=typeof window&&"undefined"!=typeof document}function gb(e){let t=e.parentNode;return t&&"[object ShadowRoot]"===t.toString()&&(t=t.host),t}function yb(e,t,n){let r;return"string"==typeof e?(r=parseInt(e,10),-1!==e.indexOf("%")&&(r=r/100*t.parentNode[n])):r=e,r}const bb=e=>e.ownerDocument.defaultView.getComputedStyle(e,null);const xb=["top","right","bottom","left"];function _b(e,t,n){const r={};n=n?"-"+n:"";for(let i=0;i<4;i++){const o=xb[i];r[o]=parseFloat(e[t+"-"+o+n])||0}return r.width=r.left+r.right,r.height=r.top+r.bottom,r}function jb(e,t){if("native"in e)return e;const{canvas:n,currentDevicePixelRatio:r}=t,i=bb(n),o="border-box"===i.boxSizing,a=_b(i,"padding"),l=_b(i,"border","width"),{x:s,y:c,box:u}=function(e,t){const n=e.touches,r=n&&n.length?n[0]:e,{offsetX:i,offsetY:o}=r;let a,l,s=!1;if(((e,t,n)=>(e>0||t>0)&&(!n||!n.shadowRoot))(i,o,e.target))a=i,l=o;else{const e=t.getBoundingClientRect();a=r.clientX-e.left,l=r.clientY-e.top,s=!0}return{x:a,y:l,box:s}}(e,n),d=a.left+(u&&l.left),f=a.top+(u&&l.top);let{width:h,height:m}=t;return o&&(h-=a.width+l.width,m-=a.height+l.height),{x:Math.round((s-d)/h*n.width/r),y:Math.round((c-f)/m*n.height/r)}}const Eb=e=>Math.round(10*e)/10;function Ob(e,t,n,r){const i=bb(e),o=_b(i,"margin"),a=yb(i.maxWidth,e,"clientWidth")||Yv,l=yb(i.maxHeight,e,"clientHeight")||Yv,s=function(e,t,n){let r,i;if(void 0===t||void 0===n){const o=gb(e);if(o){const e=o.getBoundingClientRect(),a=bb(o),l=_b(a,"border","width"),s=_b(a,"padding");t=e.width-s.width-l.width,n=e.height-s.height-l.height,r=yb(a.maxWidth,o,"clientWidth"),i=yb(a.maxHeight,o,"clientHeight")}else t=e.clientWidth,n=e.clientHeight}return{width:t,height:n,maxWidth:r||Yv,maxHeight:i||Yv}}(e,t,n);let{width:c,height:u}=s;if("content-box"===i.boxSizing){const e=_b(i,"border","width"),t=_b(i,"padding");c-=t.width+e.width,u-=t.height+e.height}c=Math.max(0,c-o.width),u=Math.max(0,r?Math.floor(c/r):u-o.height),c=Eb(Math.min(c,a,s.maxWidth)),u=Eb(Math.min(u,l,s.maxHeight)),c&&!u&&(u=Eb(c/2));return(void 0!==t||void 0!==n)&&r&&s.height&&u>s.height&&(u=s.height,c=Eb(Math.floor(u*r))),{width:c,height:u}}function Tb(e,t,n){const r=t||1,i=Math.floor(e.height*r),o=Math.floor(e.width*r);e.height=i/r,e.width=o/r;const a=e.canvas;return a.style&&(n||!a.style.height&&!a.style.width)&&(a.style.height=`${e.height}px`,a.style.width=`${e.width}px`),(e.currentDevicePixelRatio!==r||a.height!==i||a.width!==o)&&(e.currentDevicePixelRatio=r,a.height=i,a.width=o,e.ctx.setTransform(r,0,0,r,0,0),!0)}const Ib=function(){let e=!1;try{const t={get passive(){return e=!0,!1}};window.addEventListener("test",null,t),window.removeEventListener("test",null,t)}catch(e){}return e}();function Sb(e,t){const n=function(e,t){return bb(e).getPropertyValue(t)}(e,t),r=n&&n.match(/^(\d+)(\.\d+)?px$/);return r?+r[1]:void 0}function wb(e,t,n,r){return{x:e.x+n*(t.x-e.x),y:e.y+n*(t.y-e.y)}}function Nb(e,t,n,r){return{x:e.x+n*(t.x-e.x),y:"middle"===r?n<.5?e.y:t.y:"after"===r?n<1?e.y:t.y:n>0?t.y:e.y}}function Pb(e,t,n,r){const i={x:e.cp2x,y:e.cp2y},o={x:t.cp1x,y:t.cp1y},a=wb(e,i,n),l=wb(i,o,n),s=wb(o,t,n),c=wb(a,l,n),u=wb(l,s,n);return wb(c,u,n)}function Cb(e,t,n){return e?function(e,t){return{x:n=>e+e+t-n,setWidth(e){t=e},textAlign:e=>"center"===e?e:"right"===e?"left":"right",xPlus:(e,t)=>e-t,leftForLtr:(e,t)=>e-t}}(t,n):{x:e=>e,setWidth(e){},textAlign:e=>e,xPlus:(e,t)=>e+t,leftForLtr:(e,t)=>e}}function Ab(e,t){let n,r;"ltr"!==t&&"rtl"!==t||(n=e.canvas.style,r=[n.getPropertyValue("direction"),n.getPropertyPriority("direction")],n.setProperty("direction",t,"important"),e.prevTextDirection=r)}function Lb(e,t){void 0!==t&&(delete e.prevTextDirection,e.canvas.style.setProperty("direction",t[0],t[1]))}function Mb(e){return"angle"===e?{between:dg,compare:cg,normalize:ug}:{between:hg,compare:(e,t)=>e-t,normalize:e=>e}}function Rb({start:e,end:t,count:n,loop:r,style:i}){return{start:e%n,end:t%n,loop:r&&(t-e+1)%n==0,style:i}}function kb(e,t,n){if(!n)return[e];const{property:r,start:i,end:o}=n,a=t.length,{compare:l,between:s,normalize:c}=Mb(r),{start:u,end:d,loop:f,style:h}=function(e,t,n){const{property:r,start:i,end:o}=n,{between:a,normalize:l}=Mb(r),s=t.length;let c,u,{start:d,end:f,loop:h}=e;if(h){for(d+=s,f+=s,c=0,u=s;c<u&&a(l(t[d%s][r]),i,o);++c)d--,f--;d%=s,f%=s}return f<d&&(f+=s),{start:d,end:f,loop:h,style:e.style}}(e,t,n),m=[];let p,v,g,y=!1,b=null;const x=()=>y||s(i,g,p)&&0!==l(i,g),_=()=>!y||0===l(o,p)||s(o,g,p);for(let e=u,n=u;e<=d;++e)v=t[e%a],v.skip||(p=c(v[r]),p!==g&&(y=s(p,i,o),null===b&&x()&&(b=0===l(p,i)?e:n),null!==b&&_()&&(m.push(Rb({start:b,end:e,loop:f,count:a,style:h})),b=null),n=e,g=p));return null!==b&&m.push(Rb({start:b,end:d,loop:f,count:a,style:h})),m}function Db(e,t){const n=[],r=e.segments;for(let i=0;i<r.length;i++){const o=kb(r[i],e.points,t);o.length&&n.push(...o)}return n}function Ub(e,t,n,r){return r&&r.setContext&&n?function(e,t,n,r){const i=e._chart.getContext(),o=Fb(e.options),{_datasetIndex:a,options:{spanGaps:l}}=e,s=n.length,c=[];let u=o,d=t[0].start,f=d;function h(e,t,r,i){const o=l?-1:1;if(e!==t){for(e+=s;n[e%s].skip;)e-=o;for(;n[t%s].skip;)t+=o;e%s!=t%s&&(c.push({start:e%s,end:t%s,loop:r,style:i}),u=i,d=t%s)}}for(const e of t){d=l?d:e.start;let t,o=n[d%s];for(f=d+1;f<=e.end;f++){const l=n[f%s];t=Fb(r.setContext(qy(i,{type:"segment",p0:o,p1:l,p0DataIndex:(f-1)%s,p1DataIndex:f%s,datasetIndex:a}))),Gb(t,u)&&h(d,f-1,e.loop,u),o=l,u=t}d<f-1&&h(d,f-1,e.loop,u)}return c}(e,t,n,r):t}function Fb(e){return{backgroundColor:e.backgroundColor,borderCapStyle:e.borderCapStyle,borderDash:e.borderDash,borderDashOffset:e.borderDashOffset,borderJoinStyle:e.borderJoinStyle,borderWidth:e.borderWidth,borderColor:e.borderColor}}function Gb(e,t){return t&&JSON.stringify(e)!==JSON.stringify(t)}class Vb{constructor(){this._request=null,this._charts=new Map,this._running=!1,this._lastDate=void 0}_notify(e,t,n,r){const i=t.listeners[r],o=t.duration;i.forEach((r=>r({chart:e,initial:t.initial,numSteps:o,currentStep:Math.min(n-t.start,o)})))}_refresh(){this._request||(this._running=!0,this._request=xg.call(window,(()=>{this._update(),this._request=null,this._running&&this._refresh()})))}_update(e=Date.now()){let t=0;this._charts.forEach(((n,r)=>{if(!n.running||!n.items.length)return;const i=n.items;let o,a=i.length-1,l=!1;for(;a>=0;--a)o=i[a],o._active?(o._total>n.duration&&(n.duration=o._total),o.tick(e),l=!0):(i[a]=i[i.length-1],i.pop());l&&(r.draw(),this._notify(r,n,e,"progress")),i.length||(n.running=!1,this._notify(r,n,e,"complete"),n.initial=!1),t+=i.length})),this._lastDate=e,0===t&&(this._running=!1)}_getAnims(e){const t=this._charts;let n=t.get(e);return n||(n={running:!1,initial:!0,items:[],listeners:{complete:[],progress:[]}},t.set(e,n)),n}listen(e,t,n){this._getAnims(e).listeners[t].push(n)}add(e,t){t&&t.length&&this._getAnims(e).items.push(...t)}has(e){return this._getAnims(e).items.length>0}start(e){const t=this._charts.get(e);t&&(t.running=!0,t.start=Date.now(),t.duration=t.items.reduce(((e,t)=>Math.max(e,t._duration)),0),this._refresh())}running(e){if(!this._running)return!1;const t=this._charts.get(e);return!!(t&&t.running&&t.items.length)}stop(e){const t=this._charts.get(e);if(!t||!t.items.length)return;const n=t.items;let r=n.length-1;for(;r>=0;--r)n[r].cancel();t.items=[],this._notify(e,t,Date.now(),"complete")}remove(e){return this._charts.delete(e)}}var Bb=new Vb;const Hb="transparent",Kb={boolean:(e,t,n)=>n>.5?t:e,color(e,t,n){const r=fy(e||Hb),i=r.valid&&fy(t||Hb);return i&&i.valid?i.mix(r,n).hexString():t},number:(e,t,n)=>e+(t-e)*n};class Wb{constructor(e,t,n,r){const i=t[n];r=Xy([e.to,r,i,e.from]);const o=Xy([e.from,i,r]);this._active=!0,this._fn=e.fn||Kb[e.type||typeof o],this._easing=Pg[e.easing]||Pg.linear,this._start=Math.floor(Date.now()+(e.delay||0)),this._duration=this._total=Math.floor(e.duration),this._loop=!!e.loop,this._target=t,this._prop=n,this._from=o,this._to=r,this._promises=void 0}active(){return this._active}update(e,t,n){if(this._active){this._notify(!1);const r=this._target[this._prop],i=n-this._start,o=this._duration-i;this._start=n,this._duration=Math.floor(Math.max(o,e.duration)),this._total+=i,this._loop=!!e.loop,this._to=Xy([e.to,t,r,e.from]),this._from=Xy([e.from,r,t])}}cancel(){this._active&&(this.tick(Date.now()),this._active=!1,this._notify(!1))}tick(e){const t=e-this._start,n=this._duration,r=this._prop,i=this._from,o=this._loop,a=this._to;let l;if(this._active=i!==a&&(o||t<n),!this._active)return this._target[r]=a,void this._notify(!0);t<0?this._target[r]=i:(l=t/n%2,l=o&&l>1?2-l:l,l=this._easing(Math.min(1,Math.max(0,l))),this._target[r]=this._fn(i,a,l))}wait(){const e=this._promises||(this._promises=[]);return new Promise(((t,n)=>{e.push({res:t,rej:n})}))}_notify(e){const t=e?"res":"rej",n=this._promises||[];for(let e=0;e<n.length;e++)n[e][t]()}}class zb{constructor(e,t){this._chart=e,this._properties=new Map,this.configure(t)}configure(e){if(!Ov(e))return;const t=Object.keys(Ty.animation),n=this._properties;Object.getOwnPropertyNames(e).forEach((r=>{const i=e[r];if(!Ov(i))return;const o={};for(const e of t)o[e]=i[e];(Ev(i.properties)&&i.properties||[r]).forEach((e=>{e!==r&&n.has(e)||n.set(e,o)}))}))}_animateOptions(e,t){const n=t.options,r=function(e,t){if(!t)return;let n=e.options;if(!n)return void(e.options=t);n.$shared&&(e.options=n=Object.assign({},n,{$shared:!1,$animations:{}}));return n}(e,n);if(!r)return[];const i=this._createAnimations(r,n);return n.$shared&&function(e,t){const n=[],r=Object.keys(t);for(let t=0;t<r.length;t++){const i=e[r[t]];i&&i.active()&&n.push(i.wait())}return Promise.all(n)}(e.options.$animations,n).then((()=>{e.options=n}),(()=>{})),i}_createAnimations(e,t){const n=this._properties,r=[],i=e.$animations||(e.$animations={}),o=Object.keys(t),a=Date.now();let l;for(l=o.length-1;l>=0;--l){const s=o[l];if("$"===s.charAt(0))continue;if("options"===s){r.push(...this._animateOptions(e,t));continue}const c=t[s];let u=i[s];const d=n.get(s);if(u){if(d&&u.active()){u.update(d,c,a);continue}u.cancel()}d&&d.duration?(i[s]=u=new Wb(d,e,s,c),r.push(u)):e[s]=c}return r}update(e,t){if(0===this._properties.size)return void Object.assign(e,t);const n=this._createAnimations(e,t);return n.length?(Bb.add(this._chart,n),!0):void 0}}function Yb(e,t){const n=e&&e.options||{},r=n.reverse,i=void 0===n.min?t:0,o=void 0===n.max?t:0;return{start:r?o:i,end:r?i:o}}function Xb(e,t){const n=[],r=e._getSortedDatasetMetas(t);let i,o;for(i=0,o=r.length;i<o;++i)n.push(r[i].index);return n}function qb(e,t,n,r={}){const i=e.keys,o="single"===r.mode;let a,l,s,c;if(null!==t){for(a=0,l=i.length;a<l;++a){if(s=+i[a],s===n){if(r.all)continue;break}c=e.values[s],Tv(c)&&(o||0===t||Jv(t)===Jv(c))&&(t+=c)}return t}}function $b(e,t){const n=e&&e.options.stacked;return n||void 0===n&&void 0!==t.stack}function Qb(e,t,n){const r=e[t]||(e[t]={});return r[n]||(r[n]={})}function Zb(e,t,n,r){for(const i of t.getMatchingVisibleMetas(r).reverse()){const t=e[i.index];if(n&&t>0||!n&&t<0)return i.index}return null}function Jb(e,t){const{chart:n,_cachedMeta:r}=e,i=n._stacks||(n._stacks={}),{iScale:o,vScale:a,index:l}=r,s=o.axis,c=a.axis,u=function(e,t,n){return`${e.id}.${t.id}.${n.stack||n.type}`}(o,a,r),d=t.length;let f;for(let e=0;e<d;++e){const n=t[e],{[s]:o,[c]:d}=n;f=(n._stacks||(n._stacks={}))[c]=Qb(i,u,o),f[l]=d,f._top=Zb(f,a,!0,r.type),f._bottom=Zb(f,a,!1,r.type)}}function ex(e,t){const n=e.scales;return Object.keys(n).filter((e=>n[e].axis===t)).shift()}function tx(e,t){const n=e.controller.index,r=e.vScale&&e.vScale.axis;if(r){t=t||e._parsed;for(const e of t){const t=e._stacks;if(!t||void 0===t[r]||void 0===t[r][n])return;delete t[r][n]}}}const nx=e=>"reset"===e||"none"===e,rx=(e,t)=>t?e:Object.assign({},e);class ix{static defaults={};static datasetElementType=null;static dataElementType=null;constructor(e,t){this.chart=e,this._ctx=e.ctx,this.index=t,this._cachedDataOpts={},this._cachedMeta=this.getMeta(),this._type=this._cachedMeta.type,this.options=void 0,this._parsing=!1,this._data=void 0,this._objectData=void 0,this._sharedOptions=void 0,this._drawStart=void 0,this._drawCount=void 0,this.enableOptionSharing=!1,this.supportsDecimation=!1,this.$context=void 0,this._syncList=[],this.datasetElementType=new.target.datasetElementType,this.dataElementType=new.target.dataElementType,this.initialize()}initialize(){const e=this._cachedMeta;this.configure(),this.linkScales(),e._stacked=$b(e.vScale,e),this.addElements(),this.options.fill&&!this.chart.isPluginEnabled("filler")&&console.warn("Tried to use the 'fill' option without the 'Filler' plugin enabled. Please import and register the 'Filler' plugin and make sure it is not disabled in the options")}updateIndex(e){this.index!==e&&tx(this._cachedMeta),this.index=e}linkScales(){const e=this.chart,t=this._cachedMeta,n=this.getDataset(),r=(e,t,n,r)=>"x"===e?t:"r"===e?r:n,i=t.xAxisID=Sv(n.xAxisID,ex(e,"x")),o=t.yAxisID=Sv(n.yAxisID,ex(e,"y")),a=t.rAxisID=Sv(n.rAxisID,ex(e,"r")),l=t.indexAxis,s=t.iAxisID=r(l,i,o,a),c=t.vAxisID=r(l,o,i,a);t.xScale=this.getScaleForId(i),t.yScale=this.getScaleForId(o),t.rScale=this.getScaleForId(a),t.iScale=this.getScaleForId(s),t.vScale=this.getScaleForId(c)}getDataset(){return this.chart.data.datasets[this.index]}getMeta(){return this.chart.getDatasetMeta(this.index)}getScaleForId(e){return this.chart.scales[e]}_getOtherScale(e){const t=this._cachedMeta;return e===t.iScale?t.vScale:t.iScale}reset(){this._update("reset")}_destroy(){const e=this._cachedMeta;this._data&&yg(this._data,this),e._stacked&&tx(e)}_dataCheck(){const e=this.getDataset(),t=e.data||(e.data=[]),n=this._data;if(Ov(t))this._data=function(e){const t=Object.keys(e),n=new Array(t.length);let r,i,o;for(r=0,i=t.length;r<i;++r)o=t[r],n[r]={x:o,y:e[o]};return n}(t);else if(n!==t){if(n){yg(n,this);const e=this._cachedMeta;tx(e),e._parsed=[]}t&&Object.isExtensible(t)&&function(e,t){e._chartjs?e._chartjs.listeners.push(t):(Object.defineProperty(e,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[t]}}),gg.forEach((t=>{const n="_onData"+Gv(t),r=e[t];Object.defineProperty(e,t,{configurable:!0,enumerable:!1,value(...t){const i=r.apply(this,t);return e._chartjs.listeners.forEach((e=>{"function"==typeof e[n]&&e[n](...t)})),i}})})))}(t,this),this._syncList=[],this._data=t}}addElements(){const e=this._cachedMeta;this._dataCheck(),this.datasetElementType&&(e.dataset=new this.datasetElementType)}buildOrUpdateElements(e){const t=this._cachedMeta,n=this.getDataset();let r=!1;this._dataCheck();const i=t._stacked;t._stacked=$b(t.vScale,t),t.stack!==n.stack&&(r=!0,tx(t),t.stack=n.stack),this._resyncElements(e),(r||i!==t._stacked)&&Jb(this,t._parsed)}configure(){const e=this.chart.config,t=e.datasetScopeKeys(this._type),n=e.getOptionScopes(this.getDataset(),t,!0);this.options=e.createResolver(n,this.getContext()),this._parsing=this.options.parsing,this._cachedDataOpts={}}parse(e,t){const{_cachedMeta:n,_data:r}=this,{iScale:i,_stacked:o}=n,a=i.axis;let l,s,c,u=0===e&&t===r.length||n._sorted,d=e>0&&n._parsed[e-1];if(!1===this._parsing)n._parsed=r,n._sorted=!0,c=r;else{c=Ev(r[e])?this.parseArrayData(n,r,e,t):Ov(r[e])?this.parseObjectData(n,r,e,t):this.parsePrimitiveData(n,r,e,t);const i=()=>null===s[a]||d&&s[a]<d[a];for(l=0;l<t;++l)n._parsed[l+e]=s=c[l],u&&(i()&&(u=!1),d=s);n._sorted=u}o&&Jb(this,c)}parsePrimitiveData(e,t,n,r){const{iScale:i,vScale:o}=e,a=i.axis,l=o.axis,s=i.getLabels(),c=i===o,u=new Array(r);let d,f,h;for(d=0,f=r;d<f;++d)h=d+n,u[d]={[a]:c||i.parse(s[h],h),[l]:o.parse(t[h],h)};return u}parseArrayData(e,t,n,r){const{xScale:i,yScale:o}=e,a=new Array(r);let l,s,c,u;for(l=0,s=r;l<s;++l)c=l+n,u=t[c],a[l]={x:i.parse(u[0],c),y:o.parse(u[1],c)};return a}parseObjectData(e,t,n,r){const{xScale:i,yScale:o}=e,{xAxisKey:a="x",yAxisKey:l="y"}=this._parsing,s=new Array(r);let c,u,d,f;for(c=0,u=r;c<u;++c)d=c+n,f=t[d],s[c]={x:i.parse(Fv(f,a),d),y:o.parse(Fv(f,l),d)};return s}getParsed(e){return this._cachedMeta._parsed[e]}getDataElement(e){return this._cachedMeta.data[e]}applyStack(e,t,n){const r=this.chart,i=this._cachedMeta,o=t[e.axis];return qb({keys:Xb(r,!0),values:t._stacks[e.axis]},o,i.index,{mode:n})}updateRangeFromParsed(e,t,n,r){const i=n[t.axis];let o=null===i?NaN:i;const a=r&&n._stacks[t.axis];r&&a&&(r.values=a,o=qb(r,i,this._cachedMeta.index)),e.min=Math.min(e.min,o),e.max=Math.max(e.max,o)}getMinMax(e,t){const n=this._cachedMeta,r=n._parsed,i=n._sorted&&e===n.iScale,o=r.length,a=this._getOtherScale(e),l=((e,t,n)=>e&&!t.hidden&&t._stacked&&{keys:Xb(n,!0),values:null})(t,n,this.chart),s={min:Number.POSITIVE_INFINITY,max:Number.NEGATIVE_INFINITY},{min:c,max:u}=function(e){const{min:t,max:n,minDefined:r,maxDefined:i}=e.getUserBounds();return{min:r?t:Number.NEGATIVE_INFINITY,max:i?n:Number.POSITIVE_INFINITY}}(a);let d,f;function h(){f=r[d];const t=f[a.axis];return!Tv(f[e.axis])||c>t||u<t}for(d=0;d<o&&(h()||(this.updateRangeFromParsed(s,e,f,l),!i));++d);if(i)for(d=o-1;d>=0;--d)if(!h()){this.updateRangeFromParsed(s,e,f,l);break}return s}getAllParsedValues(e){const t=this._cachedMeta._parsed,n=[];let r,i,o;for(r=0,i=t.length;r<i;++r)o=t[r][e.axis],Tv(o)&&n.push(o);return n}getMaxOverflow(){return!1}getLabelAndValue(e){const t=this._cachedMeta,n=t.iScale,r=t.vScale,i=this.getParsed(e);return{label:n?""+n.getLabelForValue(i[n.axis]):"",value:r?""+r.getLabelForValue(i[r.axis]):""}}_update(e){const t=this._cachedMeta;this.update(e||"default"),t._clip=function(e){let t,n,r,i;return Ov(e)?(t=e.top,n=e.right,r=e.bottom,i=e.left):t=n=r=i=e,{top:t,right:n,bottom:r,left:i,disabled:!1===e}}(Sv(this.options.clip,function(e,t,n){if(!1===n)return!1;const r=Yb(e,n),i=Yb(t,n);return{top:i.end,right:r.end,bottom:i.start,left:r.start}}(t.xScale,t.yScale,this.getMaxOverflow())))}update(e){}draw(){const e=this._ctx,t=this.chart,n=this._cachedMeta,r=n.data||[],i=t.chartArea,o=[],a=this._drawStart||0,l=this._drawCount||r.length-a,s=this.options.drawActiveElementsOnTop;let c;for(n.dataset&&n.dataset.draw(e,i,a,l),c=a;c<a+l;++c){const t=r[c];t.hidden||(t.active&&s?o.push(t):t.draw(e,i))}for(c=0;c<o.length;++c)o[c].draw(e,i)}getStyle(e,t){const n=t?"active":"default";return void 0===e&&this._cachedMeta.dataset?this.resolveDatasetElementOptions(n):this.resolveDataElementOptions(e||0,n)}getContext(e,t,n){const r=this.getDataset();let i;if(e>=0&&e<this._cachedMeta.data.length){const t=this._cachedMeta.data[e];i=t.$context||(t.$context=function(e,t,n){return qy(e,{active:!1,dataIndex:t,parsed:void 0,raw:void 0,element:n,index:t,mode:"default",type:"data"})}(this.getContext(),e,t)),i.parsed=this.getParsed(e),i.raw=r.data[e],i.index=i.dataIndex=e}else i=this.$context||(this.$context=function(e,t){return qy(e,{active:!1,dataset:void 0,datasetIndex:t,index:t,mode:"default",type:"dataset"})}(this.chart.getContext(),this.index)),i.dataset=r,i.index=i.datasetIndex=this.index;return i.active=!!t,i.mode=n,i}resolveDatasetElementOptions(e){return this._resolveElementOptions(this.datasetElementType.id,e)}resolveDataElementOptions(e,t){return this._resolveElementOptions(this.dataElementType.id,t,e)}_resolveElementOptions(e,t="default",n){const r="active"===t,i=this._cachedDataOpts,o=e+"-"+t,a=i[o],l=this.enableOptionSharing&&Vv(n);if(a)return rx(a,l);const s=this.chart.config,c=s.datasetElementScopeKeys(this._type,e),u=r?[`${e}Hover`,"hover",e,""]:[e,""],d=s.getOptionScopes(this.getDataset(),c),f=Object.keys(Ty.elements[e]),h=s.resolveNamedOptions(d,f,(()=>this.getContext(n,r)),u);return h.$shared&&(h.$shared=l,i[o]=Object.freeze(rx(h,l))),h}_resolveAnimations(e,t,n){const r=this.chart,i=this._cachedDataOpts,o=`animation-${t}`,a=i[o];if(a)return a;let l;if(!1!==r.options.animation){const r=this.chart.config,i=r.datasetAnimationScopeKeys(this._type,t),o=r.getOptionScopes(this.getDataset(),i);l=r.createResolver(o,this.getContext(e,n,t))}const s=new zb(r,l&&l.animations);return l&&l._cacheable&&(i[o]=Object.freeze(s)),s}getSharedOptions(e){if(e.$shared)return this._sharedOptions||(this._sharedOptions=Object.assign({},e))}includeOptions(e,t){return!t||nx(e)||this.chart._animationsDisabled}_getSharedOptions(e,t){const n=this.resolveDataElementOptions(e,t),r=this._sharedOptions,i=this.getSharedOptions(n),o=this.includeOptions(t,i)||i!==r;return this.updateSharedOptions(i,t,n),{sharedOptions:i,includeOptions:o}}updateElement(e,t,n,r){nx(r)?Object.assign(e,n):this._resolveAnimations(t,r).update(e,n)}updateSharedOptions(e,t,n){e&&!nx(t)&&this._resolveAnimations(void 0,t).update(e,n)}_setStyle(e,t,n,r){e.active=r;const i=this.getStyle(t,r);this._resolveAnimations(t,n,r).update(e,{options:!r&&this.getSharedOptions(i)||i})}removeHoverStyle(e,t,n){this._setStyle(e,n,"active",!1)}setHoverStyle(e,t,n){this._setStyle(e,n,"active",!0)}_removeDatasetHoverStyle(){const e=this._cachedMeta.dataset;e&&this._setStyle(e,void 0,"active",!1)}_setDatasetHoverStyle(){const e=this._cachedMeta.dataset;e&&this._setStyle(e,void 0,"active",!0)}_resyncElements(e){const t=this._data,n=this._cachedMeta.data;for(const[e,t,n]of this._syncList)this[e](t,n);this._syncList=[];const r=n.length,i=t.length,o=Math.min(i,r);o&&this.parse(0,o),i>r?this._insertElements(r,i-r,e):i<r&&this._removeElements(i,r-i)}_insertElements(e,t,n=!0){const r=this._cachedMeta,i=r.data,o=e+t;let a;const l=e=>{for(e.length+=t,a=e.length-1;a>=o;a--)e[a]=e[a-t]};for(l(i),a=e;a<o;++a)i[a]=new this.dataElementType;this._parsing&&l(r._parsed),this.parse(e,t),n&&this.updateElements(i,e,t,"reset")}updateElements(e,t,n,r){}_removeElements(e,t){const n=this._cachedMeta;if(this._parsing){const r=n._parsed.splice(e,t);n._stacked&&tx(n,r)}n.data.splice(e,t)}_sync(e){if(this._parsing)this._syncList.push(e);else{const[t,n,r]=e;this[t](n,r)}this.chart._dataChanges.push([this.index,...e])}_onDataPush(){const e=arguments.length;this._sync(["_insertElements",this.getDataset().data.length-e,e])}_onDataPop(){this._sync(["_removeElements",this._cachedMeta.data.length-1,1])}_onDataShift(){this._sync(["_removeElements",0,1])}_onDataSplice(e,t){t&&this._sync(["_removeElements",e,t]);const n=arguments.length-2;n&&this._sync(["_insertElements",e,n])}_onDataUnshift(){this._sync(["_insertElements",0,arguments.length])}}function ox(e){const t=e.iScale,n=function(e,t){if(!e._cache.$bar){const n=e.getMatchingVisibleMetas(t);let r=[];for(let t=0,i=n.length;t<i;t++)r=r.concat(n[t].controller.getAllParsedValues(e));e._cache.$bar=bg(r.sort(((e,t)=>e-t)))}return e._cache.$bar}(t,e.type);let r,i,o,a,l=t._length;const s=()=>{32767!==o&&-32768!==o&&(Vv(a)&&(l=Math.min(l,Math.abs(o-a)||l)),a=o)};for(r=0,i=n.length;r<i;++r)o=t.getPixelForValue(n[r]),s();for(a=void 0,r=0,i=t.ticks.length;r<i;++r)o=t.getPixelForTick(r),s();return l}function ax(e,t,n,r){return Ev(e)?function(e,t,n,r){const i=n.parse(e[0],r),o=n.parse(e[1],r),a=Math.min(i,o),l=Math.max(i,o);let s=a,c=l;Math.abs(a)>Math.abs(l)&&(s=l,c=a),t[n.axis]=c,t._custom={barStart:s,barEnd:c,start:i,end:o,min:a,max:l}}(e,t,n,r):t[n.axis]=n.parse(e,r),t}function lx(e,t,n,r){const i=e.iScale,o=e.vScale,a=i.getLabels(),l=i===o,s=[];let c,u,d,f;for(c=n,u=n+r;c<u;++c)f=t[c],d={},d[i.axis]=l||i.parse(a[c],c),s.push(ax(f,d,o,c));return s}function sx(e){return e&&void 0!==e.barStart&&void 0!==e.barEnd}function cx(e,t,n,r){let i=t.borderSkipped;const o={};if(!i)return void(e.borderSkipped=o);if(!0===i)return void(e.borderSkipped={top:!0,right:!0,bottom:!0,left:!0});const{start:a,end:l,reverse:s,top:c,bottom:u}=function(e){let t,n,r,i,o;return e.horizontal?(t=e.base>e.x,n="left",r="right"):(t=e.base<e.y,n="bottom",r="top"),t?(i="end",o="start"):(i="start",o="end"),{start:n,end:r,reverse:t,top:i,bottom:o}}(e);"middle"===i&&n&&(e.enableBorderRadius=!0,(n._top||0)===r?i=c:(n._bottom||0)===r?i=u:(o[ux(u,a,l,s)]=!0,i=c)),o[ux(i,a,l,s)]=!0,e.borderSkipped=o}function ux(e,t,n,r){var i,o,a;return r?(a=n,e=dx(e=(i=e)===(o=t)?a:i===a?o:i,n,t)):e=dx(e,t,n),e}function dx(e,t,n){return"start"===e?t:"end"===e?n:e}function fx(e,{inflateAmount:t},n){e.inflateAmount="auto"===t?1===n?.33:0:t}class hx extends ix{static id="bar";static defaults={datasetElementType:!1,dataElementType:"bar",categoryPercentage:.8,barPercentage:.9,grouped:!0,animations:{numbers:{type:"number",properties:["x","y","base","width","height"]}}};static overrides={scales:{_index_:{type:"category",offset:!0,grid:{offset:!0}},_value_:{type:"linear",beginAtZero:!0}}};parsePrimitiveData(e,t,n,r){return lx(e,t,n,r)}parseArrayData(e,t,n,r){return lx(e,t,n,r)}parseObjectData(e,t,n,r){const{iScale:i,vScale:o}=e,{xAxisKey:a="x",yAxisKey:l="y"}=this._parsing,s="x"===i.axis?a:l,c="x"===o.axis?a:l,u=[];let d,f,h,m;for(d=n,f=n+r;d<f;++d)m=t[d],h={},h[i.axis]=i.parse(Fv(m,s),d),u.push(ax(Fv(m,c),h,o,d));return u}updateRangeFromParsed(e,t,n,r){super.updateRangeFromParsed(e,t,n,r);const i=n._custom;i&&t===this._cachedMeta.vScale&&(e.min=Math.min(e.min,i.min),e.max=Math.max(e.max,i.max))}getMaxOverflow(){return 0}getLabelAndValue(e){const t=this._cachedMeta,{iScale:n,vScale:r}=t,i=this.getParsed(e),o=i._custom,a=sx(o)?"["+o.start+", "+o.end+"]":""+r.getLabelForValue(i[r.axis]);return{label:""+n.getLabelForValue(i[n.axis]),value:a}}initialize(){this.enableOptionSharing=!0,super.initialize();this._cachedMeta.stack=this.getDataset().stack}update(e){const t=this._cachedMeta;this.updateElements(t.data,0,t.data.length,e)}updateElements(e,t,n,r){const i="reset"===r,{index:o,_cachedMeta:{vScale:a}}=this,l=a.getBasePixel(),s=a.isHorizontal(),c=this._getRuler(),{sharedOptions:u,includeOptions:d}=this._getSharedOptions(t,r);for(let f=t;f<t+n;f++){const t=this.getParsed(f),n=i||jv(t[a.axis])?{base:l,head:l}:this._calculateBarValuePixels(f),h=this._calculateBarIndexPixels(f,c),m=(t._stacks||{})[a.axis],p={horizontal:s,base:n.base,enableBorderRadius:!m||sx(t._custom)||o===m._top||o===m._bottom,x:s?n.head:h.center,y:s?h.center:n.head,height:s?h.size:Math.abs(n.size),width:s?Math.abs(n.size):h.size};d&&(p.options=u||this.resolveDataElementOptions(f,e[f].active?"active":r));const v=p.options||e[f].options;cx(p,v,m,o),fx(p,v,c.ratio),this.updateElement(e[f],f,p,r)}}_getStacks(e,t){const{iScale:n}=this._cachedMeta,r=n.getMatchingVisibleMetas(this._type).filter((e=>e.controller.options.grouped)),i=n.options.stacked,o=[],a=e=>{const n=e.controller.getParsed(t),r=n&&n[e.vScale.axis];if(jv(r)||isNaN(r))return!0};for(const n of r)if((void 0===t||!a(n))&&((!1===i||-1===o.indexOf(n.stack)||void 0===i&&void 0===n.stack)&&o.push(n.stack),n.index===e))break;return o.length||o.push(void 0),o}_getStackCount(e){return this._getStacks(void 0,e).length}_getStackIndex(e,t,n){const r=this._getStacks(e,n),i=void 0!==t?r.indexOf(t):-1;return-1===i?r.length-1:i}_getRuler(){const e=this.options,t=this._cachedMeta,n=t.iScale,r=[];let i,o;for(i=0,o=t.data.length;i<o;++i)r.push(n.getPixelForValue(this.getParsed(i)[n.axis],i));const a=e.barThickness;return{min:a||ox(t),pixels:r,start:n._startPixel,end:n._endPixel,stackCount:this._getStackCount(),scale:n,grouped:e.grouped,ratio:a?1:e.categoryPercentage*e.barPercentage}}_calculateBarValuePixels(e){const{_cachedMeta:{vScale:t,_stacked:n},options:{base:r,minBarLength:i}}=this,o=r||0,a=this.getParsed(e),l=a._custom,s=sx(l);let c,u,d=a[t.axis],f=0,h=n?this.applyStack(t,a,n):d;h!==d&&(f=h-d,h=d),s&&(d=l.barStart,h=l.barEnd-l.barStart,0!==d&&Jv(d)!==Jv(l.barEnd)&&(f=0),f+=d);const m=jv(r)||s?f:r;let p=t.getPixelForValue(m);if(c=this.chart.getDataVisibility(e)?t.getPixelForValue(f+h):p,u=c-p,Math.abs(u)<i){u=function(e,t,n){return 0!==e?Jv(e):(t.isHorizontal()?1:-1)*(t.min>=n?1:-1)}(u,t,o)*i,d===o&&(p-=u/2);const e=t.getPixelForDecimal(0),n=t.getPixelForDecimal(1),r=Math.min(e,n),a=Math.max(e,n);p=Math.max(Math.min(p,a),r),c=p+u}if(p===t.getPixelForValue(o)){const e=Jv(u)*t.getLineWidthForValue(o)/2;p+=e,u-=e}return{size:u,base:p,head:c,center:c+u/2}}_calculateBarIndexPixels(e,t){const n=t.scale,r=this.options,i=r.skipNull,o=Sv(r.maxBarThickness,1/0);let a,l;if(t.grouped){const n=i?this._getStackCount(e):t.stackCount,s="flex"===r.barThickness?function(e,t,n,r){const i=t.pixels,o=i[e];let a=e>0?i[e-1]:null,l=e<i.length-1?i[e+1]:null;const s=n.categoryPercentage;null===a&&(a=o-(null===l?t.end-t.start:l-o)),null===l&&(l=o+o-a);const c=o-(o-Math.min(a,l))/2*s;return{chunk:Math.abs(l-a)/2*s/r,ratio:n.barPercentage,start:c}}(e,t,r,n):function(e,t,n,r){const i=n.barThickness;let o,a;return jv(i)?(o=t.min*n.categoryPercentage,a=n.barPercentage):(o=i*r,a=1),{chunk:o/r,ratio:a,start:t.pixels[e]-o/2}}(e,t,r,n),c=this._getStackIndex(this.index,this._cachedMeta.stack,i?e:void 0);a=s.start+s.chunk*c+s.chunk/2,l=Math.min(o,s.chunk*s.ratio)}else a=n.getPixelForValue(this.getParsed(e)[n.axis],e),l=Math.min(o,t.min*t.ratio);return{base:a-l/2,head:a+l/2,center:a,size:l}}draw(){const e=this._cachedMeta,t=e.vScale,n=e.data,r=n.length;let i=0;for(;i<r;++i)null!==this.getParsed(i)[t.axis]&&n[i].draw(this._ctx)}}class mx extends ix{static id="line";static defaults={datasetElementType:"line",dataElementType:"point",showLine:!0,spanGaps:!1};static overrides={scales:{_index_:{type:"category"},_value_:{type:"linear"}}};initialize(){this.enableOptionSharing=!0,this.supportsDecimation=!0,super.initialize()}update(e){const t=this._cachedMeta,{dataset:n,data:r=[],_dataset:i}=t,o=this.chart._animationsDisabled;let{start:a,count:l}=Og(t,r,o);this._drawStart=a,this._drawCount=l,Tg(t)&&(a=0,l=r.length),n._chart=this.chart,n._datasetIndex=this.index,n._decimated=!!i._decimated,n.points=r;const s=this.resolveDatasetElementOptions(e);this.options.showLine||(s.borderWidth=0),s.segment=this.options.segment,this.updateElement(n,void 0,{animated:!o,options:s},e),this.updateElements(r,a,l,e)}updateElements(e,t,n,r){const i="reset"===r,{iScale:o,vScale:a,_stacked:l,_dataset:s}=this._cachedMeta,{sharedOptions:c,includeOptions:u}=this._getSharedOptions(t,r),d=o.axis,f=a.axis,{spanGaps:h,segment:m}=this.options,p=ng(h)?h:Number.POSITIVE_INFINITY,v=this.chart._animationsDisabled||i||"none"===r,g=t+n,y=e.length;let b=t>0&&this.getParsed(t-1);for(let n=0;n<y;++n){const h=e[n],y=v?h:{};if(n<t||n>=g){y.skip=!0;continue}const x=this.getParsed(n),_=jv(x[f]),j=y[d]=o.getPixelForValue(x[d],n),E=y[f]=i||_?a.getBasePixel():a.getPixelForValue(l?this.applyStack(a,x,l):x[f],n);y.skip=isNaN(j)||isNaN(E)||_,y.stop=n>0&&Math.abs(x[d]-b[d])>p,m&&(y.parsed=x,y.raw=s.data[n]),u&&(y.options=c||this.resolveDataElementOptions(n,h.active?"active":r)),v||this.updateElement(h,n,y,r),b=x}}getMaxOverflow(){const e=this._cachedMeta,t=e.dataset,n=t.options&&t.options.borderWidth||0,r=e.data||[];if(!r.length)return n;const i=r[0].size(this.resolveDataElementOptions(0)),o=r[r.length-1].size(this.resolveDataElementOptions(r.length-1));return Math.max(n,i,o)/2}draw(){const e=this._cachedMeta;e.dataset.updateControlPoints(this.chart.chartArea,e.iScale.axis),super.draw()}}class px extends ix{static id="scatter";static defaults={datasetElementType:!1,dataElementType:"point",showLine:!1,fill:!1};static overrides={interaction:{mode:"point"},scales:{x:{type:"linear"},y:{type:"linear"}}};getLabelAndValue(e){const t=this._cachedMeta,n=this.chart.data.labels||[],{xScale:r,yScale:i}=t,o=this.getParsed(e),a=r.getLabelForValue(o.x),l=i.getLabelForValue(o.y);return{label:n[e]||"",value:"("+a+", "+l+")"}}update(e){const t=this._cachedMeta,{data:n=[]}=t,r=this.chart._animationsDisabled;let{start:i,count:o}=Og(t,n,r);if(this._drawStart=i,this._drawCount=o,Tg(t)&&(i=0,o=n.length),this.options.showLine){const{dataset:i,_dataset:o}=t;i._chart=this.chart,i._datasetIndex=this.index,i._decimated=!!o._decimated,i.points=n;const a=this.resolveDatasetElementOptions(e);a.segment=this.options.segment,this.updateElement(i,void 0,{animated:!r,options:a},e)}this.updateElements(n,i,o,e)}addElements(){const{showLine:e}=this.options;!this.datasetElementType&&e&&(this.datasetElementType=this.chart.registry.getElement("line")),super.addElements()}updateElements(e,t,n,r){const i="reset"===r,{iScale:o,vScale:a,_stacked:l,_dataset:s}=this._cachedMeta,c=this.resolveDataElementOptions(t,r),u=this.getSharedOptions(c),d=this.includeOptions(r,u),f=o.axis,h=a.axis,{spanGaps:m,segment:p}=this.options,v=ng(m)?m:Number.POSITIVE_INFINITY,g=this.chart._animationsDisabled||i||"none"===r;let y=t>0&&this.getParsed(t-1);for(let c=t;c<t+n;++c){const t=e[c],n=this.getParsed(c),m=g?t:{},b=jv(n[h]),x=m[f]=o.getPixelForValue(n[f],c),_=m[h]=i||b?a.getBasePixel():a.getPixelForValue(l?this.applyStack(a,n,l):n[h],c);m.skip=isNaN(x)||isNaN(_)||b,m.stop=c>0&&Math.abs(n[f]-y[f])>v,p&&(m.parsed=n,m.raw=s.data[c]),d&&(m.options=u||this.resolveDataElementOptions(c,t.active?"active":r)),g||this.updateElement(t,c,m,r),y=n}this.updateSharedOptions(u,r,c)}getMaxOverflow(){const e=this._cachedMeta,t=e.data||[];if(!this.options.showLine){let e=0;for(let n=t.length-1;n>=0;--n)e=Math.max(e,t[n].size(this.resolveDataElementOptions(n))/2);return e>0&&e}const n=e.dataset,r=n.options&&n.options.borderWidth||0;if(!t.length)return r;const i=t[0].size(this.resolveDataElementOptions(0)),o=t[t.length-1].size(this.resolveDataElementOptions(t.length-1));return Math.max(r,i,o)/2}}function vx(e,t,n,r){const{controller:i,data:o,_sorted:a}=e,l=i._cachedMeta.iScale;if(l&&t===l.axis&&"r"!==t&&a&&o.length){const e=l._reversePixels?vg:pg;if(!r)return e(o,t,n);if(i._sharedOptions){const r=o[0],i="function"==typeof r.getRange&&r.getRange(t);if(i){const r=e(o,t,n-i),a=e(o,t,n+i);return{lo:r.lo,hi:a.hi}}}}return{lo:0,hi:o.length-1}}function gx(e,t,n,r,i){const o=e.getSortedVisibleDatasetMetas(),a=n[t];for(let e=0,n=o.length;e<n;++e){const{index:n,data:l}=o[e],{lo:s,hi:c}=vx(o[e],t,a,i);for(let e=s;e<=c;++e){const t=l[e];t.skip||r(t,n,e)}}}function yx(e,t,n,r,i){const o=[];if(!i&&!e.isPointInArea(t))return o;return gx(e,n,t,(function(n,a,l){(i||Cy(n,e.chartArea,0))&&n.inRange(t.x,t.y,r)&&o.push({element:n,datasetIndex:a,index:l})}),!0),o}function bx(e,t,n,r,i,o){let a=[];const l=function(e){const t=-1!==e.indexOf("x"),n=-1!==e.indexOf("y");return function(e,r){const i=t?Math.abs(e.x-r.x):0,o=n?Math.abs(e.y-r.y):0;return Math.sqrt(Math.pow(i,2)+Math.pow(o,2))}}(n);let s=Number.POSITIVE_INFINITY;return gx(e,n,t,(function(n,c,u){const d=n.inRange(t.x,t.y,i);if(r&&!d)return;const f=n.getCenterPoint(i);if(!(!!o||e.isPointInArea(f))&&!d)return;const h=l(t,f);h<s?(a=[{element:n,datasetIndex:c,index:u}],s=h):h===s&&a.push({element:n,datasetIndex:c,index:u})})),a}function xx(e,t,n,r,i,o){return o||e.isPointInArea(t)?"r"!==n||r?bx(e,t,n,r,i,o):function(e,t,n,r){let i=[];return gx(e,n,t,(function(e,n,o){const{startAngle:a,endAngle:l}=e.getProps(["startAngle","endAngle"],r),{angle:s}=lg(e,{x:t.x,y:t.y});dg(s,a,l)&&i.push({element:e,datasetIndex:n,index:o})})),i}(e,t,n,i):[]}function _x(e,t,n,r,i){const o=[],a="x"===n?"inXRange":"inYRange";let l=!1;return gx(e,n,t,((e,r,s)=>{e[a](t[n],i)&&(o.push({element:e,datasetIndex:r,index:s}),l=l||e.inRange(t.x,t.y,i))})),r&&!l?[]:o}var jx={evaluateInteractionItems:gx,modes:{index(e,t,n,r){const i=jb(t,e),o=n.axis||"x",a=n.includeInvisible||!1,l=n.intersect?yx(e,i,o,r,a):xx(e,i,o,!1,r,a),s=[];return l.length?(e.getSortedVisibleDatasetMetas().forEach((e=>{const t=l[0].index,n=e.data[t];n&&!n.skip&&s.push({element:n,datasetIndex:e.index,index:t})})),s):[]},dataset(e,t,n,r){const i=jb(t,e),o=n.axis||"xy",a=n.includeInvisible||!1;let l=n.intersect?yx(e,i,o,r,a):xx(e,i,o,!1,r,a);if(l.length>0){const t=l[0].datasetIndex,n=e.getDatasetMeta(t).data;l=[];for(let e=0;e<n.length;++e)l.push({element:n[e],datasetIndex:t,index:e})}return l},point:(e,t,n,r)=>yx(e,jb(t,e),n.axis||"xy",r,n.includeInvisible||!1),nearest(e,t,n,r){const i=jb(t,e),o=n.axis||"xy",a=n.includeInvisible||!1;return xx(e,i,o,n.intersect,r,a)},x:(e,t,n,r)=>_x(e,jb(t,e),"x",n.intersect,r),y:(e,t,n,r)=>_x(e,jb(t,e),"y",n.intersect,r)}};const Ex=["left","top","right","bottom"];function Ox(e,t){return e.filter((e=>e.pos===t))}function Tx(e,t){return e.filter((e=>-1===Ex.indexOf(e.pos)&&e.box.axis===t))}function Ix(e,t){return e.sort(((e,n)=>{const r=t?n:e,i=t?e:n;return r.weight===i.weight?r.index-i.index:r.weight-i.weight}))}function Sx(e,t){const n=function(e){const t={};for(const n of e){const{stack:e,pos:r,stackWeight:i}=n;if(!e||!Ex.includes(r))continue;const o=t[e]||(t[e]={count:0,placed:0,weight:0,size:0});o.count++,o.weight+=i}return t}(e),{vBoxMaxWidth:r,hBoxMaxHeight:i}=t;let o,a,l;for(o=0,a=e.length;o<a;++o){l=e[o];const{fullSize:a}=l.box,s=n[l.stack],c=s&&l.stackWeight/s.weight;l.horizontal?(l.width=c?c*r:a&&t.availableWidth,l.height=i):(l.width=r,l.height=c?c*i:a&&t.availableHeight)}return n}function wx(e,t,n,r){return Math.max(e[n],t[n])+Math.max(e[r],t[r])}function Nx(e,t){e.top=Math.max(e.top,t.top),e.left=Math.max(e.left,t.left),e.bottom=Math.max(e.bottom,t.bottom),e.right=Math.max(e.right,t.right)}function Px(e,t,n,r){const{pos:i,box:o}=n,a=e.maxPadding;if(!Ov(i)){n.size&&(e[i]-=n.size);const t=r[n.stack]||{size:0,count:1};t.size=Math.max(t.size,n.horizontal?o.height:o.width),n.size=t.size/t.count,e[i]+=n.size}o.getPadding&&Nx(a,o.getPadding());const l=Math.max(0,t.outerWidth-wx(a,e,"left","right")),s=Math.max(0,t.outerHeight-wx(a,e,"top","bottom")),c=l!==e.w,u=s!==e.h;return e.w=l,e.h=s,n.horizontal?{same:c,other:u}:{same:u,other:c}}function Cx(e,t){const n=t.maxPadding;function r(e){const r={left:0,top:0,right:0,bottom:0};return e.forEach((e=>{r[e]=Math.max(t[e],n[e])})),r}return r(e?["left","right"]:["top","bottom"])}function Ax(e,t,n,r){const i=[];let o,a,l,s,c,u;for(o=0,a=e.length,c=0;o<a;++o){l=e[o],s=l.box,s.update(l.width||t.w,l.height||t.h,Cx(l.horizontal,t));const{same:a,other:d}=Px(t,n,l,r);c|=a&&i.length,u=u||d,s.fullSize||i.push(l)}return c&&Ax(i,t,n,r)||u}function Lx(e,t,n,r,i){e.top=n,e.left=t,e.right=t+r,e.bottom=n+i,e.width=r,e.height=i}function Mx(e,t,n,r){const i=n.padding;let{x:o,y:a}=t;for(const l of e){const e=l.box,s=r[l.stack]||{count:1,placed:0,weight:1},c=l.stackWeight/s.weight||1;if(l.horizontal){const r=t.w*c,o=s.size||e.height;Vv(s.start)&&(a=s.start),e.fullSize?Lx(e,i.left,a,n.outerWidth-i.right-i.left,o):Lx(e,t.left+s.placed,a,r,o),s.start=a,s.placed+=r,a=e.bottom}else{const r=t.h*c,a=s.size||e.width;Vv(s.start)&&(o=s.start),e.fullSize?Lx(e,o,i.top,a,n.outerHeight-i.bottom-i.top):Lx(e,o,t.top+s.placed,a,r),s.start=o,s.placed+=r,o=e.right}}t.x=o,t.y=a}var Rx={addBox(e,t){e.boxes||(e.boxes=[]),t.fullSize=t.fullSize||!1,t.position=t.position||"top",t.weight=t.weight||0,t._layers=t._layers||function(){return[{z:0,draw(e){t.draw(e)}}]},e.boxes.push(t)},removeBox(e,t){const n=e.boxes?e.boxes.indexOf(t):-1;-1!==n&&e.boxes.splice(n,1)},configure(e,t,n){t.fullSize=n.fullSize,t.position=n.position,t.weight=n.weight},update(e,t,n,r){if(!e)return;const i=zy(e.options.layout.padding),o=Math.max(t-i.width,0),a=Math.max(n-i.height,0),l=function(e){const t=function(e){const t=[];let n,r,i,o,a,l;for(n=0,r=(e||[]).length;n<r;++n)i=e[n],({position:o,options:{stack:a,stackWeight:l=1}}=i),t.push({index:n,box:i,pos:o,horizontal:i.isHorizontal(),weight:i.weight,stack:a&&o+a,stackWeight:l});return t}(e),n=Ix(t.filter((e=>e.box.fullSize)),!0),r=Ix(Ox(t,"left"),!0),i=Ix(Ox(t,"right")),o=Ix(Ox(t,"top"),!0),a=Ix(Ox(t,"bottom")),l=Tx(t,"x"),s=Tx(t,"y");return{fullSize:n,leftAndTop:r.concat(o),rightAndBottom:i.concat(s).concat(a).concat(l),chartArea:Ox(t,"chartArea"),vertical:r.concat(i).concat(s),horizontal:o.concat(a).concat(l)}}(e.boxes),s=l.vertical,c=l.horizontal;Pv(e.boxes,(e=>{"function"==typeof e.beforeLayout&&e.beforeLayout()}));const u=s.reduce(((e,t)=>t.box.options&&!1===t.box.options.display?e:e+1),0)||1,d=Object.freeze({outerWidth:t,outerHeight:n,padding:i,availableWidth:o,availableHeight:a,vBoxMaxWidth:o/2/u,hBoxMaxHeight:a/2}),f=Object.assign({},i);Nx(f,zy(r));const h=Object.assign({maxPadding:f,w:o,h:a,x:i.left,y:i.top},i),m=Sx(s.concat(c),d);Ax(l.fullSize,h,d,m),Ax(s,h,d,m),Ax(c,h,d,m)&&Ax(s,h,d,m),function(e){const t=e.maxPadding;function n(n){const r=Math.max(t[n]-e[n],0);return e[n]+=r,r}e.y+=n("top"),e.x+=n("left"),n("right"),n("bottom")}(h),Mx(l.leftAndTop,h,d,m),h.x+=h.w,h.y+=h.h,Mx(l.rightAndBottom,h,d,m),e.chartArea={left:h.left,top:h.top,right:h.left+h.w,bottom:h.top+h.h,height:h.h,width:h.w},Pv(l.chartArea,(t=>{const n=t.box;Object.assign(n,e.chartArea),n.update(h.w,h.h,{left:0,top:0,right:0,bottom:0})}))}};class kx{acquireContext(e,t){}releaseContext(e){return!1}addEventListener(e,t,n){}removeEventListener(e,t,n){}getDevicePixelRatio(){return 1}getMaximumSize(e,t,n,r){return t=Math.max(0,t||e.width),n=n||e.height,{width:t,height:Math.max(0,r?Math.floor(t/r):n)}}isAttached(e){return!0}updateConfig(e){}}class Dx extends kx{acquireContext(e){return e&&e.getContext&&e.getContext("2d")||null}updateConfig(e){e.options.animation=!1}}const Ux={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",pointerenter:"mouseenter",pointerdown:"mousedown",pointermove:"mousemove",pointerup:"mouseup",pointerleave:"mouseout",pointerout:"mouseout"},Fx=e=>null===e||""===e;const Gx=!!Ib&&{passive:!0};function Vx(e,t,n){e.canvas.removeEventListener(t,n,Gx)}function Bx(e,t){for(const n of e)if(n===t||n.contains(t))return!0}function Hx(e,t,n){const r=e.canvas,i=new MutationObserver((e=>{let t=!1;for(const n of e)t=t||Bx(n.addedNodes,r),t=t&&!Bx(n.removedNodes,r);t&&n()}));return i.observe(document,{childList:!0,subtree:!0}),i}function Kx(e,t,n){const r=e.canvas,i=new MutationObserver((e=>{let t=!1;for(const n of e)t=t||Bx(n.removedNodes,r),t=t&&!Bx(n.addedNodes,r);t&&n()}));return i.observe(document,{childList:!0,subtree:!0}),i}const Wx=new Map;let zx=0;function Yx(){const e=window.devicePixelRatio;e!==zx&&(zx=e,Wx.forEach(((t,n)=>{n.currentDevicePixelRatio!==e&&t()})))}function Xx(e,t,n){const r=e.canvas,i=r&&gb(r);if(!i)return;const o=_g(((e,t)=>{const r=i.clientWidth;n(e,t),r<i.clientWidth&&n()}),window),a=new ResizeObserver((e=>{const t=e[0],n=t.contentRect.width,r=t.contentRect.height;0===n&&0===r||o(n,r)}));return a.observe(i),function(e,t){Wx.size||window.addEventListener("resize",Yx),Wx.set(e,t)}(e,o),a}function qx(e,t,n){n&&n.disconnect(),"resize"===t&&function(e){Wx.delete(e),Wx.size||window.removeEventListener("resize",Yx)}(e)}function $x(e,t,n){const r=e.canvas,i=_g((t=>{null!==e.ctx&&n(function(e,t){const n=Ux[e.type]||e.type,{x:r,y:i}=jb(e,t);return{type:n,chart:t,native:e,x:void 0!==r?r:null,y:void 0!==i?i:null}}(t,e))}),e);return function(e,t,n){e.addEventListener(t,n,Gx)}(r,t,i),i}class Qx extends kx{acquireContext(e,t){const n=e&&e.getContext&&e.getContext("2d");return n&&n.canvas===e?(function(e,t){const n=e.style,r=e.getAttribute("height"),i=e.getAttribute("width");if(e.$chartjs={initial:{height:r,width:i,style:{display:n.display,height:n.height,width:n.width}}},n.display=n.display||"block",n.boxSizing=n.boxSizing||"border-box",Fx(i)){const t=Sb(e,"width");void 0!==t&&(e.width=t)}if(Fx(r))if(""===e.style.height)e.height=e.width/(t||2);else{const t=Sb(e,"height");void 0!==t&&(e.height=t)}}(e,t),n):null}releaseContext(e){const t=e.canvas;if(!t.$chartjs)return!1;const n=t.$chartjs.initial;["height","width"].forEach((e=>{const r=n[e];jv(r)?t.removeAttribute(e):t.setAttribute(e,r)}));const r=n.style||{};return Object.keys(r).forEach((e=>{t.style[e]=r[e]})),t.width=t.width,delete t.$chartjs,!0}addEventListener(e,t,n){this.removeEventListener(e,t);const r=e.$proxies||(e.$proxies={}),i={attach:Hx,detach:Kx,resize:Xx}[t]||$x;r[t]=i(e,t,n)}removeEventListener(e,t){const n=e.$proxies||(e.$proxies={}),r=n[t];if(!r)return;({attach:qx,detach:qx,resize:qx}[t]||Vx)(e,t,r),n[t]=void 0}getDevicePixelRatio(){return window.devicePixelRatio}getMaximumSize(e,t,n,r){return Ob(e,t,n,r)}isAttached(e){const t=gb(e);return!(!t||!t.isConnected)}}class Zx{static defaults={};static defaultRoutes=void 0;active=!1;tooltipPosition(e){const{x:t,y:n}=this.getProps(["x","y"],e);return{x:t,y:n}}hasValue(){return ng(this.x)&&ng(this.y)}getProps(e,t){const n=this.$animations;if(!t||!n)return this;const r={};return e.forEach((e=>{r[e]=n[e]&&n[e].active()?n[e]._to:this[e]})),r}}function Jx(e,t){const n=e.options.ticks,r=function(e){const t=e.options.offset,n=e._tickSize(),r=e._length/n+(t?0:1),i=e._maxLength/n;return Math.floor(Math.min(r,i))}(e),i=Math.min(n.maxTicksLimit||r,r),o=n.major.enabled?function(e){const t=[];let n,r;for(n=0,r=e.length;n<r;n++)e[n].major&&t.push(n);return t}(t):[],a=o.length,l=o[0],s=o[a-1],c=[];if(a>i)return function(e,t,n,r){let i,o=0,a=n[0];for(r=Math.ceil(r),i=0;i<e.length;i++)i===a&&(t.push(e[i]),o++,a=n[o*r])}(t,c,o,a/i),c;const u=function(e,t,n){const r=function(e){const t=e.length;let n,r;if(t<2)return!1;for(r=e[0],n=1;n<t;++n)if(e[n]-e[n-1]!==r)return!1;return r}(e),i=t.length/n;if(!r)return Math.max(i,1);const o=function(e){const t=[],n=Math.sqrt(e);let r;for(r=1;r<n;r++)e%r==0&&(t.push(r),t.push(e/r));return n===(0|n)&&t.push(n),t.sort(((e,t)=>e-t)).pop(),t}(r);for(let e=0,t=o.length-1;e<t;e++){const t=o[e];if(t>i)return t}return Math.max(i,1)}(o,t,i);if(a>0){let e,n;const r=a>1?Math.round((s-l)/(a-1)):null;for(e_(t,c,u,jv(r)?0:l-r,l),e=0,n=a-1;e<n;e++)e_(t,c,u,o[e],o[e+1]);return e_(t,c,u,s,jv(r)?t.length:s+r),c}return e_(t,c,u),c}function e_(e,t,n,r,i){const o=Sv(r,0),a=Math.min(Sv(i,e.length),e.length);let l,s,c,u=0;for(n=Math.ceil(n),i&&(l=i-r,n=l/Math.floor(l/n)),c=o;c<0;)u++,c=Math.round(o+u*n);for(s=Math.max(o,0);s<a;s++)s===c&&(t.push(e[s]),u++,c=Math.round(o+u*n))}const t_=(e,t,n)=>"top"===t||"left"===t?e[t]+n:e[t]-n;function n_(e,t){const n=[],r=e.length/t,i=e.length;let o=0;for(;o<i;o+=r)n.push(e[Math.floor(o)]);return n}function r_(e,t,n){const r=e.ticks.length,i=Math.min(t,r-1),o=e._startPixel,a=e._endPixel,l=1e-6;let s,c=e.getPixelForTick(i);if(!(n&&(s=1===r?Math.max(c-o,a-c):0===t?(e.getPixelForTick(1)-c)/2:(c-e.getPixelForTick(i-1))/2,c+=i<t?s:-s,c<o-l||c>a+l)))return c}function i_(e){return e.drawTicks?e.tickLength:0}function o_(e,t){if(!e.display)return 0;const n=Yy(e.font,t),r=zy(e.padding);return(Ev(e.text)?e.text.length:1)*n.lineHeight+r.height}function a_(e,t,n){let r=jg(e);return(n&&"right"!==t||!n&&"right"===t)&&(r=(e=>"left"===e?"right":"right"===e?"left":e)(r)),r}class l_ extends Zx{constructor(e){super(),this.id=e.id,this.type=e.type,this.options=void 0,this.ctx=e.ctx,this.chart=e.chart,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.width=void 0,this.height=void 0,this._margins={left:0,right:0,top:0,bottom:0},this.maxWidth=void 0,this.maxHeight=void 0,this.paddingTop=void 0,this.paddingBottom=void 0,this.paddingLeft=void 0,this.paddingRight=void 0,this.axis=void 0,this.labelRotation=void 0,this.min=void 0,this.max=void 0,this._range=void 0,this.ticks=[],this._gridLineItems=null,this._labelItems=null,this._labelSizes=null,this._length=0,this._maxLength=0,this._longestTextCache={},this._startPixel=void 0,this._endPixel=void 0,this._reversePixels=!1,this._userMax=void 0,this._userMin=void 0,this._suggestedMax=void 0,this._suggestedMin=void 0,this._ticksLength=0,this._borderValue=0,this._cache={},this._dataLimitsCached=!1,this.$context=void 0}init(e){this.options=e.setContext(this.getContext()),this.axis=e.axis,this._userMin=this.parse(e.min),this._userMax=this.parse(e.max),this._suggestedMin=this.parse(e.suggestedMin),this._suggestedMax=this.parse(e.suggestedMax)}parse(e,t){return e}getUserBounds(){let{_userMin:e,_userMax:t,_suggestedMin:n,_suggestedMax:r}=this;return e=Iv(e,Number.POSITIVE_INFINITY),t=Iv(t,Number.NEGATIVE_INFINITY),n=Iv(n,Number.POSITIVE_INFINITY),r=Iv(r,Number.NEGATIVE_INFINITY),{min:Iv(e,n),max:Iv(t,r),minDefined:Tv(e),maxDefined:Tv(t)}}getMinMax(e){let t,{min:n,max:r,minDefined:i,maxDefined:o}=this.getUserBounds();if(i&&o)return{min:n,max:r};const a=this.getMatchingVisibleMetas();for(let l=0,s=a.length;l<s;++l)t=a[l].controller.getMinMax(this,e),i||(n=Math.min(n,t.min)),o||(r=Math.max(r,t.max));return n=o&&n>r?r:n,r=i&&n>r?n:r,{min:Iv(n,Iv(r,n)),max:Iv(r,Iv(n,r))}}getPadding(){return{left:this.paddingLeft||0,top:this.paddingTop||0,right:this.paddingRight||0,bottom:this.paddingBottom||0}}getTicks(){return this.ticks}getLabels(){const e=this.chart.data;return this.options.labels||(this.isHorizontal()?e.xLabels:e.yLabels)||e.labels||[]}beforeLayout(){this._cache={},this._dataLimitsCached=!1}beforeUpdate(){Nv(this.options.beforeUpdate,[this])}update(e,t,n){const{beginAtZero:r,grace:i,ticks:o}=this.options,a=o.sampleSize;this.beforeUpdate(),this.maxWidth=e,this.maxHeight=t,this._margins=n=Object.assign({left:0,right:0,top:0,bottom:0},n),this.ticks=null,this._labelSizes=null,this._gridLineItems=null,this._labelItems=null,this.beforeSetDimensions(),this.setDimensions(),this.afterSetDimensions(),this._maxLength=this.isHorizontal()?this.width+n.left+n.right:this.height+n.top+n.bottom,this._dataLimitsCached||(this.beforeDataLimits(),this.determineDataLimits(),this.afterDataLimits(),this._range=function(e,t,n){const{min:r,max:i}=e,o=wv(t,(i-r)/2),a=(e,t)=>n&&0===e?0:e+t;return{min:a(r,-Math.abs(o)),max:a(i,o)}}(this,i,r),this._dataLimitsCached=!0),this.beforeBuildTicks(),this.ticks=this.buildTicks()||[],this.afterBuildTicks();const l=a<this.ticks.length;this._convertTicksToLabels(l?n_(this.ticks,a):this.ticks),this.configure(),this.beforeCalculateLabelRotation(),this.calculateLabelRotation(),this.afterCalculateLabelRotation(),o.display&&(o.autoSkip||"auto"===o.source)&&(this.ticks=Jx(this,this.ticks),this._labelSizes=null,this.afterAutoSkip()),l&&this._convertTicksToLabels(this.ticks),this.beforeFit(),this.fit(),this.afterFit(),this.afterUpdate()}configure(){let e,t,n=this.options.reverse;this.isHorizontal()?(e=this.left,t=this.right):(e=this.top,t=this.bottom,n=!n),this._startPixel=e,this._endPixel=t,this._reversePixels=n,this._length=t-e,this._alignToPixels=this.options.alignToPixels}afterUpdate(){Nv(this.options.afterUpdate,[this])}beforeSetDimensions(){Nv(this.options.beforeSetDimensions,[this])}setDimensions(){this.isHorizontal()?(this.width=this.maxWidth,this.left=0,this.right=this.width):(this.height=this.maxHeight,this.top=0,this.bottom=this.height),this.paddingLeft=0,this.paddingTop=0,this.paddingRight=0,this.paddingBottom=0}afterSetDimensions(){Nv(this.options.afterSetDimensions,[this])}_callHooks(e){this.chart.notifyPlugins(e,this.getContext()),Nv(this.options[e],[this])}beforeDataLimits(){this._callHooks("beforeDataLimits")}determineDataLimits(){}afterDataLimits(){this._callHooks("afterDataLimits")}beforeBuildTicks(){this._callHooks("beforeBuildTicks")}buildTicks(){return[]}afterBuildTicks(){this._callHooks("afterBuildTicks")}beforeTickToLabelConversion(){Nv(this.options.beforeTickToLabelConversion,[this])}generateTickLabels(e){const t=this.options.ticks;let n,r,i;for(n=0,r=e.length;n<r;n++)i=e[n],i.label=Nv(t.callback,[i.value,n,e],this)}afterTickToLabelConversion(){Nv(this.options.afterTickToLabelConversion,[this])}beforeCalculateLabelRotation(){Nv(this.options.beforeCalculateLabelRotation,[this])}calculateLabelRotation(){const e=this.options,t=e.ticks,n=this.ticks.length,r=t.minRotation||0,i=t.maxRotation;let o,a,l,s=r;if(!this._isVisible()||!t.display||r>=i||n<=1||!this.isHorizontal())return void(this.labelRotation=r);const c=this._getLabelSizes(),u=c.widest.width,d=c.highest.height,f=fg(this.chart.width-u,0,this.maxWidth);o=e.offset?this.maxWidth/n:f/(n-1),u+6>o&&(o=f/(n-(e.offset?.5:1)),a=this.maxHeight-i_(e.grid)-t.padding-o_(e.title,this.chart.options.font),l=Math.sqrt(u*u+d*d),s=og(Math.min(Math.asin(fg((c.highest.height+6)/o,-1,1)),Math.asin(fg(a/l,-1,1))-Math.asin(fg(d/l,-1,1)))),s=Math.max(r,Math.min(i,s))),this.labelRotation=s}afterCalculateLabelRotation(){Nv(this.options.afterCalculateLabelRotation,[this])}afterAutoSkip(){}beforeFit(){Nv(this.options.beforeFit,[this])}fit(){const e={width:0,height:0},{chart:t,options:{ticks:n,title:r,grid:i}}=this,o=this._isVisible(),a=this.isHorizontal();if(o){const o=o_(r,t.options.font);if(a?(e.width=this.maxWidth,e.height=i_(i)+o):(e.height=this.maxHeight,e.width=i_(i)+o),n.display&&this.ticks.length){const{first:t,last:r,widest:i,highest:o}=this._getLabelSizes(),l=2*n.padding,s=ig(this.labelRotation),c=Math.cos(s),u=Math.sin(s);if(a){const t=n.mirror?0:u*i.width+c*o.height;e.height=Math.min(this.maxHeight,e.height+t+l)}else{const t=n.mirror?0:c*i.width+u*o.height;e.width=Math.min(this.maxWidth,e.width+t+l)}this._calculatePadding(t,r,u,c)}}this._handleMargins(),a?(this.width=this._length=t.width-this._margins.left-this._margins.right,this.height=e.height):(this.width=e.width,this.height=this._length=t.height-this._margins.top-this._margins.bottom)}_calculatePadding(e,t,n,r){const{ticks:{align:i,padding:o},position:a}=this.options,l=0!==this.labelRotation,s="top"!==a&&"x"===this.axis;if(this.isHorizontal()){const a=this.getPixelForTick(0)-this.left,c=this.right-this.getPixelForTick(this.ticks.length-1);let u=0,d=0;l?s?(u=r*e.width,d=n*t.height):(u=n*e.height,d=r*t.width):"start"===i?d=t.width:"end"===i?u=e.width:"inner"!==i&&(u=e.width/2,d=t.width/2),this.paddingLeft=Math.max((u-a+o)*this.width/(this.width-a),0),this.paddingRight=Math.max((d-c+o)*this.width/(this.width-c),0)}else{let n=t.height/2,r=e.height/2;"start"===i?(n=0,r=e.height):"end"===i&&(n=t.height,r=0),this.paddingTop=n+o,this.paddingBottom=r+o}}_handleMargins(){this._margins&&(this._margins.left=Math.max(this.paddingLeft,this._margins.left),this._margins.top=Math.max(this.paddingTop,this._margins.top),this._margins.right=Math.max(this.paddingRight,this._margins.right),this._margins.bottom=Math.max(this.paddingBottom,this._margins.bottom))}afterFit(){Nv(this.options.afterFit,[this])}isHorizontal(){const{axis:e,position:t}=this.options;return"top"===t||"bottom"===t||"x"===e}isFullSize(){return this.options.fullSize}_convertTicksToLabels(e){let t,n;for(this.beforeTickToLabelConversion(),this.generateTickLabels(e),t=0,n=e.length;t<n;t++)jv(e[t].label)&&(e.splice(t,1),n--,t--);this.afterTickToLabelConversion()}_getLabelSizes(){let e=this._labelSizes;if(!e){const t=this.options.ticks.sampleSize;let n=this.ticks;t<n.length&&(n=n_(n,t)),this._labelSizes=e=this._computeLabelSizes(n,n.length)}return e}_computeLabelSizes(e,t){const{ctx:n,_longestTextCache:r}=this,i=[],o=[];let a,l,s,c,u,d,f,h,m,p,v,g=0,y=0;for(a=0;a<t;++a){if(c=e[a].label,u=this._resolveTickFontOptions(a),n.font=d=u.string,f=r[d]=r[d]||{data:{},gc:[]},h=u.lineHeight,m=p=0,jv(c)||Ev(c)){if(Ev(c))for(l=0,s=c.length;l<s;++l)v=c[l],jv(v)||Ev(v)||(m=Iy(n,f.data,f.gc,m,v),p+=h)}else m=Iy(n,f.data,f.gc,m,c),p=h;i.push(m),o.push(p),g=Math.max(m,g),y=Math.max(p,y)}!function(e,t){Pv(e,(e=>{const n=e.gc,r=n.length/2;let i;if(r>t){for(i=0;i<r;++i)delete e.data[n[i]];n.splice(0,r)}}))}(r,t);const b=i.indexOf(g),x=o.indexOf(y),_=e=>({width:i[e]||0,height:o[e]||0});return{first:_(0),last:_(t-1),widest:_(b),highest:_(x),widths:i,heights:o}}getLabelForValue(e){return e}getPixelForValue(e,t){return NaN}getValueForPixel(e){}getPixelForTick(e){const t=this.ticks;return e<0||e>t.length-1?null:this.getPixelForValue(t[e].value)}getPixelForDecimal(e){this._reversePixels&&(e=1-e);const t=this._startPixel+e*this._length;return function(e){return fg(e,-32768,32767)}(this._alignToPixels?Sy(this.chart,t,0):t)}getDecimalForPixel(e){const t=(e-this._startPixel)/this._length;return this._reversePixels?1-t:t}getBasePixel(){return this.getPixelForValue(this.getBaseValue())}getBaseValue(){const{min:e,max:t}=this;return e<0&&t<0?t:e>0&&t>0?e:0}getContext(e){const t=this.ticks||[];if(e>=0&&e<t.length){const n=t[e];return n.$context||(n.$context=function(e,t,n){return qy(e,{tick:n,index:t,type:"tick"})}(this.getContext(),e,n))}return this.$context||(this.$context=qy(this.chart.getContext(),{scale:this,type:"scale"}))}_tickSize(){const e=this.options.ticks,t=ig(this.labelRotation),n=Math.abs(Math.cos(t)),r=Math.abs(Math.sin(t)),i=this._getLabelSizes(),o=e.autoSkipPadding||0,a=i?i.widest.width+o:0,l=i?i.highest.height+o:0;return this.isHorizontal()?l*n>a*r?a/n:l/r:l*r<a*n?l/n:a/r}_isVisible(){const e=this.options.display;return"auto"!==e?!!e:this.getMatchingVisibleMetas().length>0}_computeGridLineItems(e){const t=this.axis,n=this.chart,r=this.options,{grid:i,position:o,border:a}=r,l=i.offset,s=this.isHorizontal(),c=this.ticks.length+(l?1:0),u=i_(i),d=[],f=a.setContext(this.getContext()),h=f.display?f.width:0,m=h/2,p=function(e){return Sy(n,e,h)};let v,g,y,b,x,_,j,E,O,T,I,S;if("top"===o)v=p(this.bottom),_=this.bottom-u,E=v-m,T=p(e.top)+m,S=e.bottom;else if("bottom"===o)v=p(this.top),T=e.top,S=p(e.bottom)-m,_=v+m,E=this.top+u;else if("left"===o)v=p(this.right),x=this.right-u,j=v-m,O=p(e.left)+m,I=e.right;else if("right"===o)v=p(this.left),O=e.left,I=p(e.right)-m,x=v+m,j=this.left+u;else if("x"===t){if("center"===o)v=p((e.top+e.bottom)/2+.5);else if(Ov(o)){const e=Object.keys(o)[0],t=o[e];v=p(this.chart.scales[e].getPixelForValue(t))}T=e.top,S=e.bottom,_=v+m,E=_+u}else if("y"===t){if("center"===o)v=p((e.left+e.right)/2);else if(Ov(o)){const e=Object.keys(o)[0],t=o[e];v=p(this.chart.scales[e].getPixelForValue(t))}x=v-m,j=x-u,O=e.left,I=e.right}const w=Sv(r.ticks.maxTicksLimit,c),N=Math.max(1,Math.ceil(c/w));for(g=0;g<c;g+=N){const e=this.getContext(g),t=i.setContext(e),r=a.setContext(e),o=t.lineWidth,c=t.color,u=r.dash||[],f=r.dashOffset,h=t.tickWidth,m=t.tickColor,p=t.tickBorderDash||[],v=t.tickBorderDashOffset;y=r_(this,g,l),void 0!==y&&(b=Sy(n,y,o),s?x=j=O=I=b:_=E=T=S=b,d.push({tx1:x,ty1:_,tx2:j,ty2:E,x1:O,y1:T,x2:I,y2:S,width:o,color:c,borderDash:u,borderDashOffset:f,tickWidth:h,tickColor:m,tickBorderDash:p,tickBorderDashOffset:v}))}return this._ticksLength=c,this._borderValue=v,d}_computeLabelItems(e){const t=this.axis,n=this.options,{position:r,ticks:i}=n,o=this.isHorizontal(),a=this.ticks,{align:l,crossAlign:s,padding:c,mirror:u}=i,d=i_(n.grid),f=d+c,h=u?-c:f,m=-ig(this.labelRotation),p=[];let v,g,y,b,x,_,j,E,O,T,I,S,w="middle";if("top"===r)_=this.bottom-h,j=this._getXAxisLabelAlignment();else if("bottom"===r)_=this.top+h,j=this._getXAxisLabelAlignment();else if("left"===r){const e=this._getYAxisLabelAlignment(d);j=e.textAlign,x=e.x}else if("right"===r){const e=this._getYAxisLabelAlignment(d);j=e.textAlign,x=e.x}else if("x"===t){if("center"===r)_=(e.top+e.bottom)/2+f;else if(Ov(r)){const e=Object.keys(r)[0],t=r[e];_=this.chart.scales[e].getPixelForValue(t)+f}j=this._getXAxisLabelAlignment()}else if("y"===t){if("center"===r)x=(e.left+e.right)/2-f;else if(Ov(r)){const e=Object.keys(r)[0],t=r[e];x=this.chart.scales[e].getPixelForValue(t)}j=this._getYAxisLabelAlignment(d).textAlign}"y"===t&&("start"===l?w="top":"end"===l&&(w="bottom"));const N=this._getLabelSizes();for(v=0,g=a.length;v<g;++v){y=a[v],b=y.label;const e=i.setContext(this.getContext(v));E=this.getPixelForTick(v)+i.labelOffset,O=this._resolveTickFontOptions(v),T=O.lineHeight,I=Ev(b)?b.length:1;const t=I/2,n=e.color,l=e.textStrokeColor,c=e.textStrokeWidth;let d,f=j;if(o?(x=E,"inner"===j&&(f=v===g-1?this.options.reverse?"left":"right":0===v?this.options.reverse?"right":"left":"center"),S="top"===r?"near"===s||0!==m?-I*T+T/2:"center"===s?-N.highest.height/2-t*T+T:-N.highest.height+T/2:"near"===s||0!==m?T/2:"center"===s?N.highest.height/2-t*T:N.highest.height-I*T,u&&(S*=-1),0===m||e.showLabelBackdrop||(x+=T/2*Math.sin(m))):(_=E,S=(1-I)*T/2),e.showLabelBackdrop){const t=zy(e.backdropPadding),n=N.heights[v],r=N.widths[v];let i=S-t.top,o=0-t.left;switch(w){case"middle":i-=n/2;break;case"bottom":i-=n}switch(j){case"center":o-=r/2;break;case"right":o-=r}d={left:o,top:i,width:r+t.width,height:n+t.height,color:e.backdropColor}}p.push({rotation:m,label:b,font:O,color:n,strokeColor:l,strokeWidth:c,textOffset:S,textAlign:f,textBaseline:w,translation:[x,_],backdrop:d})}return p}_getXAxisLabelAlignment(){const{position:e,ticks:t}=this.options;if(-ig(this.labelRotation))return"top"===e?"left":"right";let n="center";return"start"===t.align?n="left":"end"===t.align?n="right":"inner"===t.align&&(n="inner"),n}_getYAxisLabelAlignment(e){const{position:t,ticks:{crossAlign:n,mirror:r,padding:i}}=this.options,o=e+i,a=this._getLabelSizes().widest.width;let l,s;return"left"===t?r?(s=this.right+i,"near"===n?l="left":"center"===n?(l="center",s+=a/2):(l="right",s+=a)):(s=this.right-o,"near"===n?l="right":"center"===n?(l="center",s-=a/2):(l="left",s=this.left)):"right"===t?r?(s=this.left+i,"near"===n?l="right":"center"===n?(l="center",s-=a/2):(l="left",s-=a)):(s=this.left+o,"near"===n?l="left":"center"===n?(l="center",s+=a/2):(l="right",s=this.right)):l="right",{textAlign:l,x:s}}_computeLabelArea(){if(this.options.ticks.mirror)return;const e=this.chart,t=this.options.position;return"left"===t||"right"===t?{top:0,left:this.left,bottom:e.height,right:this.right}:"top"===t||"bottom"===t?{top:this.top,left:0,bottom:this.bottom,right:e.width}:void 0}drawBackground(){const{ctx:e,options:{backgroundColor:t},left:n,top:r,width:i,height:o}=this;t&&(e.save(),e.fillStyle=t,e.fillRect(n,r,i,o),e.restore())}getLineWidthForValue(e){const t=this.options.grid;if(!this._isVisible()||!t.display)return 0;const n=this.ticks.findIndex((t=>t.value===e));if(n>=0){return t.setContext(this.getContext(n)).lineWidth}return 0}drawGrid(e){const t=this.options.grid,n=this.ctx,r=this._gridLineItems||(this._gridLineItems=this._computeGridLineItems(e));let i,o;const a=(e,t,r)=>{r.width&&r.color&&(n.save(),n.lineWidth=r.width,n.strokeStyle=r.color,n.setLineDash(r.borderDash||[]),n.lineDashOffset=r.borderDashOffset,n.beginPath(),n.moveTo(e.x,e.y),n.lineTo(t.x,t.y),n.stroke(),n.restore())};if(t.display)for(i=0,o=r.length;i<o;++i){const e=r[i];t.drawOnChartArea&&a({x:e.x1,y:e.y1},{x:e.x2,y:e.y2},e),t.drawTicks&&a({x:e.tx1,y:e.ty1},{x:e.tx2,y:e.ty2},{color:e.tickColor,width:e.tickWidth,borderDash:e.tickBorderDash,borderDashOffset:e.tickBorderDashOffset})}}drawBorder(){const{chart:e,ctx:t,options:{border:n,grid:r}}=this,i=n.setContext(this.getContext()),o=n.display?i.width:0;if(!o)return;const a=r.setContext(this.getContext(0)).lineWidth,l=this._borderValue;let s,c,u,d;this.isHorizontal()?(s=Sy(e,this.left,o)-o/2,c=Sy(e,this.right,a)+a/2,u=d=l):(u=Sy(e,this.top,o)-o/2,d=Sy(e,this.bottom,a)+a/2,s=c=l),t.save(),t.lineWidth=i.width,t.strokeStyle=i.color,t.beginPath(),t.moveTo(s,u),t.lineTo(c,d),t.stroke(),t.restore()}drawLabels(e){if(!this.options.ticks.display)return;const t=this.ctx,n=this._computeLabelArea();n&&Ay(t,n);const r=this._labelItems||(this._labelItems=this._computeLabelItems(e));let i,o;for(i=0,o=r.length;i<o;++i){const e=r[i],n=e.font;ky(t,e.label,0,e.textOffset,n,e)}n&&Ly(t)}drawTitle(){const{ctx:e,options:{position:t,title:n,reverse:r}}=this;if(!n.display)return;const i=Yy(n.font),o=zy(n.padding),a=n.align;let l=i.lineHeight/2;"bottom"===t||"center"===t||Ov(t)?(l+=o.bottom,Ev(n.text)&&(l+=i.lineHeight*(n.text.length-1))):l+=o.top;const{titleX:s,titleY:c,maxWidth:u,rotation:d}=function(e,t,n,r){const{top:i,left:o,bottom:a,right:l,chart:s}=e,{chartArea:c,scales:u}=s;let d,f,h,m=0;const p=a-i,v=l-o;if(e.isHorizontal()){if(f=Eg(r,o,l),Ov(n)){const e=Object.keys(n)[0],r=n[e];h=u[e].getPixelForValue(r)+p-t}else h="center"===n?(c.bottom+c.top)/2+p-t:t_(e,n,t);d=l-o}else{if(Ov(n)){const e=Object.keys(n)[0],r=n[e];f=u[e].getPixelForValue(r)-v+t}else f="center"===n?(c.left+c.right)/2-v+t:t_(e,n,t);h=Eg(r,a,i),m="left"===n?-qv:qv}return{titleX:f,titleY:h,maxWidth:d,rotation:m}}(this,l,t,a);ky(e,n.text,0,0,i,{color:n.color,maxWidth:u,rotation:d,textAlign:a_(a,t,r),textBaseline:"middle",translation:[s,c]})}draw(e){this._isVisible()&&(this.drawBackground(),this.drawGrid(e),this.drawBorder(),this.drawTitle(),this.drawLabels(e))}_layers(){const e=this.options,t=e.ticks&&e.ticks.z||0,n=Sv(e.grid&&e.grid.z,-1),r=Sv(e.border&&e.border.z,0);return this._isVisible()&&this.draw===l_.prototype.draw?[{z:n,draw:e=>{this.drawBackground(),this.drawGrid(e),this.drawTitle()}},{z:r,draw:()=>{this.drawBorder()}},{z:t,draw:e=>{this.drawLabels(e)}}]:[{z:t,draw:e=>{this.draw(e)}}]}getMatchingVisibleMetas(e){const t=this.chart.getSortedVisibleDatasetMetas(),n=this.axis+"AxisID",r=[];let i,o;for(i=0,o=t.length;i<o;++i){const o=t[i];o[n]!==this.id||e&&o.type!==e||r.push(o)}return r}_resolveTickFontOptions(e){return Yy(this.options.ticks.setContext(this.getContext(e)).font)}_maxDigits(){const e=this._resolveTickFontOptions(0).lineHeight;return(this.isHorizontal()?this.width:this.height)/e}}class s_{constructor(e,t,n){this.type=e,this.scope=t,this.override=n,this.items=Object.create(null)}isForType(e){return Object.prototype.isPrototypeOf.call(this.type.prototype,e.prototype)}register(e){const t=Object.getPrototypeOf(e);let n;(function(e){return"id"in e&&"defaults"in e})(t)&&(n=this.register(t));const r=this.items,i=e.id,o=this.scope+"."+i;if(!i)throw new Error("class does not have id: "+e);return i in r||(r[i]=e,function(e,t,n){const r=Rv(Object.create(null),[n?Ty.get(n):{},Ty.get(t),e.defaults]);Ty.set(t,r),e.defaultRoutes&&function(e,t){Object.keys(t).forEach((n=>{const r=n.split("."),i=r.pop(),o=[e].concat(r).join("."),a=t[n].split("."),l=a.pop(),s=a.join(".");Ty.route(o,i,s,l)}))}(t,e.defaultRoutes);e.descriptors&&Ty.describe(t,e.descriptors)}(e,o,n),this.override&&Ty.override(e.id,e.overrides)),o}get(e){return this.items[e]}unregister(e){const t=this.items,n=e.id,r=this.scope;n in t&&delete t[n],r&&n in Ty[r]&&(delete Ty[r][n],this.override&&delete xy[n])}}class c_{constructor(){this.controllers=new s_(ix,"datasets",!0),this.elements=new s_(Zx,"elements"),this.plugins=new s_(Object,"plugins"),this.scales=new s_(l_,"scales"),this._typedRegistries=[this.controllers,this.scales,this.elements]}add(...e){this._each("register",e)}remove(...e){this._each("unregister",e)}addControllers(...e){this._each("register",e,this.controllers)}addElements(...e){this._each("register",e,this.elements)}addPlugins(...e){this._each("register",e,this.plugins)}addScales(...e){this._each("register",e,this.scales)}getController(e){return this._get(e,this.controllers,"controller")}getElement(e){return this._get(e,this.elements,"element")}getPlugin(e){return this._get(e,this.plugins,"plugin")}getScale(e){return this._get(e,this.scales,"scale")}removeControllers(...e){this._each("unregister",e,this.controllers)}removeElements(...e){this._each("unregister",e,this.elements)}removePlugins(...e){this._each("unregister",e,this.plugins)}removeScales(...e){this._each("unregister",e,this.scales)}_each(e,t,n){[...t].forEach((t=>{const r=n||this._getRegistryForType(t);n||r.isForType(t)||r===this.plugins&&t.id?this._exec(e,r,t):Pv(t,(t=>{const r=n||this._getRegistryForType(t);this._exec(e,r,t)}))}))}_exec(e,t,n){const r=Gv(e);Nv(n["before"+r],[],n),t[e](n),Nv(n["after"+r],[],n)}_getRegistryForType(e){for(let t=0;t<this._typedRegistries.length;t++){const n=this._typedRegistries[t];if(n.isForType(e))return n}return this.plugins}_get(e,t,n){const r=t.get(e);if(void 0===r)throw new Error('"'+e+'" is not a registered '+n+".");return r}}var u_=new c_;class d_{constructor(){this._init=[]}notify(e,t,n,r){"beforeInit"===t&&(this._init=this._createDescriptors(e,!0),this._notify(this._init,e,"install"));const i=r?this._descriptors(e).filter(r):this._descriptors(e),o=this._notify(i,e,t,n);return"afterDestroy"===t&&(this._notify(i,e,"stop"),this._notify(this._init,e,"uninstall")),o}_notify(e,t,n,r){r=r||{};for(const i of e){const e=i.plugin;if(!1===Nv(e[n],[t,r,i.options],e)&&r.cancelable)return!1}return!0}invalidate(){jv(this._cache)||(this._oldCache=this._cache,this._cache=void 0)}_descriptors(e){if(this._cache)return this._cache;const t=this._cache=this._createDescriptors(e);return this._notifyStateChanges(e),t}_createDescriptors(e,t){const n=e&&e.config,r=Sv(n.options&&n.options.plugins,{}),i=function(e){const t={},n=[],r=Object.keys(u_.plugins.items);for(let e=0;e<r.length;e++)n.push(u_.getPlugin(r[e]));const i=e.plugins||[];for(let e=0;e<i.length;e++){const r=i[e];-1===n.indexOf(r)&&(n.push(r),t[r.id]=!0)}return{plugins:n,localIds:t}}(n);return!1!==r||t?function(e,{plugins:t,localIds:n},r,i){const o=[],a=e.getContext();for(const l of t){const t=l.id,s=f_(r[t],i);null!==s&&o.push({plugin:l,options:h_(e.config,{plugin:l,local:n[t]},s,a)})}return o}(e,i,r,t):[]}_notifyStateChanges(e){const t=this._oldCache||[],n=this._cache,r=(e,t)=>e.filter((e=>!t.some((t=>e.plugin.id===t.plugin.id))));this._notify(r(t,n),e,"stop"),this._notify(r(n,t),e,"start")}}function f_(e,t){return t||!1!==e?!0===e?{}:e:null}function h_(e,{plugin:t,local:n},r,i){const o=e.pluginScopeKeys(t),a=e.getOptionScopes(r,o);return n&&t.defaults&&a.push(t.defaults),e.createResolver(a,i,[""],{scriptable:!1,indexable:!1,allKeys:!0})}function m_(e,t){const n=Ty.datasets[e]||{};return((t.datasets||{})[e]||{}).indexAxis||t.indexAxis||n.indexAxis||"x"}function p_(e,t){if("x"===e||"y"===e||"r"===e)return e;var n;if(e=t.axis||("top"===(n=t.position)||"bottom"===n?"x":"left"===n||"right"===n?"y":void 0)||e.length>1&&p_(e[0].toLowerCase(),t))return e;throw new Error(`Cannot determine type of '${name}' axis. Please provide 'axis' or 'position' option.`)}function v_(e){const t=e.options||(e.options={});t.plugins=Sv(t.plugins,{}),t.scales=function(e,t){const n=xy[e.type]||{scales:{}},r=t.scales||{},i=m_(e.type,t),o=Object.create(null);return Object.keys(r).forEach((e=>{const t=r[e];if(!Ov(t))return console.error(`Invalid scale configuration for scale: ${e}`);if(t._proxy)return console.warn(`Ignoring resolver passed as options for scale: ${e}`);const a=p_(e,t),l=function(e,t){return e===t?"_index_":"_value_"}(a,i),s=n.scales||{};o[e]=kv(Object.create(null),[{axis:a},t,s[a],s[l]])})),e.data.datasets.forEach((n=>{const i=n.type||e.type,a=n.indexAxis||m_(i,t),l=(xy[i]||{}).scales||{};Object.keys(l).forEach((e=>{const t=function(e,t){let n=e;return"_index_"===e?n=t:"_value_"===e&&(n="x"===t?"y":"x"),n}(e,a),i=n[t+"AxisID"]||t;o[i]=o[i]||Object.create(null),kv(o[i],[{axis:t},r[i],l[e]])}))})),Object.keys(o).forEach((e=>{const t=o[e];kv(t,[Ty.scales[t.type],Ty.scale])})),o}(e,t)}function g_(e){return(e=e||{}).datasets=e.datasets||[],e.labels=e.labels||[],e}const y_=new Map,b_=new Set;function x_(e,t){let n=y_.get(e);return n||(n=t(),y_.set(e,n),b_.add(n)),n}const __=(e,t,n)=>{const r=Fv(t,n);void 0!==r&&e.add(r)};class j_{constructor(e){this._config=function(e){return(e=e||{}).data=g_(e.data),v_(e),e}(e),this._scopeCache=new Map,this._resolverCache=new Map}get platform(){return this._config.platform}get type(){return this._config.type}set type(e){this._config.type=e}get data(){return this._config.data}set data(e){this._config.data=g_(e)}get options(){return this._config.options}set options(e){this._config.options=e}get plugins(){return this._config.plugins}update(){const e=this._config;this.clearCache(),v_(e)}clearCache(){this._scopeCache.clear(),this._resolverCache.clear()}datasetScopeKeys(e){return x_(e,(()=>[[`datasets.${e}`,""]]))}datasetAnimationScopeKeys(e,t){return x_(`${e}.transition.${t}`,(()=>[[`datasets.${e}.transitions.${t}`,`transitions.${t}`],[`datasets.${e}`,""]]))}datasetElementScopeKeys(e,t){return x_(`${e}-${t}`,(()=>[[`datasets.${e}.elements.${t}`,`datasets.${e}`,`elements.${t}`,""]]))}pluginScopeKeys(e){const t=e.id;return x_(`${this.type}-plugin-${t}`,(()=>[[`plugins.${t}`,...e.additionalOptionScopes||[]]]))}_cachedScopes(e,t){const n=this._scopeCache;let r=n.get(e);return r&&!t||(r=new Map,n.set(e,r)),r}getOptionScopes(e,t,n){const{options:r,type:i}=this,o=this._cachedScopes(e,n),a=o.get(t);if(a)return a;const l=new Set;t.forEach((t=>{e&&(l.add(e),t.forEach((t=>__(l,e,t)))),t.forEach((e=>__(l,r,e))),t.forEach((e=>__(l,xy[i]||{},e))),t.forEach((e=>__(l,Ty,e))),t.forEach((e=>__(l,_y,e)))}));const s=Array.from(l);return 0===s.length&&s.push(Object.create(null)),b_.has(t)&&o.set(t,s),s}chartOptionScopes(){const{options:e,type:t}=this;return[e,xy[t]||{},Ty.datasets[t]||{},{type:t},Ty,_y]}resolveNamedOptions(e,t,n,r=[""]){const i={$shared:!0},{resolver:o,subPrefixes:a}=E_(this._resolverCache,e,r);let l=o;if(function(e,t){const{isScriptable:n,isIndexable:r}=Zy(e);for(const i of t){const t=n(i),o=r(i),a=(o||t)&&e[i];if(t&&(Bv(a)||O_(a))||o&&Ev(a))return!0}return!1}(o,t)){i.$shared=!1;l=Qy(o,n=Bv(n)?n():n,this.createResolver(e,n,a))}for(const e of t)i[e]=l[e];return i}createResolver(e,t,n=[""],r){const{resolver:i}=E_(this._resolverCache,e,n);return Ov(t)?Qy(i,t,void 0,r):i}}function E_(e,t,n){let r=e.get(t);r||(r=new Map,e.set(t,r));const i=n.join();let o=r.get(i);if(!o){o={resolver:$y(t,n),subPrefixes:n.filter((e=>!e.toLowerCase().includes("hover")))},r.set(i,o)}return o}const O_=e=>Ov(e)&&Object.getOwnPropertyNames(e).reduce(((t,n)=>t||Bv(e[n])),!1);const T_=["top","bottom","left","right","chartArea"];function I_(e,t){return"top"===e||"bottom"===e||-1===T_.indexOf(e)&&"x"===t}function S_(e,t){return function(n,r){return n[e]===r[e]?n[t]-r[t]:n[e]-r[e]}}function w_(e){const t=e.chart,n=t.options.animation;t.notifyPlugins("afterRender"),Nv(n&&n.onComplete,[e],t)}function N_(e){const t=e.chart,n=t.options.animation;Nv(n&&n.onProgress,[e],t)}function P_(e){return vb()&&"string"==typeof e?e=document.getElementById(e):e&&e.length&&(e=e[0]),e&&e.canvas&&(e=e.canvas),e}const C_={},A_=e=>{const t=P_(e);return Object.values(C_).filter((e=>e.canvas===t)).pop()};function L_(e,t,n){const r=Object.keys(e);for(const i of r){const r=+i;if(r>=t){const o=e[i];delete e[i],(n>0||r>t)&&(e[r+n]=o)}}}class M_{static defaults=Ty;static instances=C_;static overrides=xy;static registry=u_;static version="4.0.1";static getChart=A_;static register(...e){u_.add(...e),R_()}static unregister(...e){u_.remove(...e),R_()}constructor(e,t){const n=this.config=new j_(t),r=P_(e),i=A_(r);if(i)throw new Error("Canvas is already in use. Chart with ID '"+i.id+"' must be destroyed before the canvas with ID '"+i.canvas.id+"' can be reused.");const o=n.createResolver(n.chartOptionScopes(),this.getContext());this.platform=new(n.platform||function(e){return!vb()||"undefined"!=typeof OffscreenCanvas&&e instanceof OffscreenCanvas?Dx:Qx}(r)),this.platform.updateConfig(n);const a=this.platform.acquireContext(r,o.aspectRatio),l=a&&a.canvas,s=l&&l.height,c=l&&l.width;this.id=_v(),this.ctx=a,this.canvas=l,this.width=c,this.height=s,this._options=o,this._aspectRatio=this.aspectRatio,this._layers=[],this._metasets=[],this._stacks=void 0,this.boxes=[],this.currentDevicePixelRatio=void 0,this.chartArea=void 0,this._active=[],this._lastEvent=void 0,this._listeners={},this._responsiveListeners=void 0,this._sortedMetasets=[],this.scales={},this._plugins=new d_,this.$proxies={},this._hiddenIndices={},this.attached=!1,this._animationsDisabled=void 0,this.$context=void 0,this._doResize=function(e,t){let n;return function(...r){return t?(clearTimeout(n),n=setTimeout(e,t,r)):e.apply(this,r),t}}((e=>this.update(e)),o.resizeDelay||0),this._dataChanges=[],C_[this.id]=this,a&&l?(Bb.listen(this,"complete",w_),Bb.listen(this,"progress",N_),this._initialize(),this.attached&&this.update()):console.error("Failed to create chart: can't acquire context from the given item")}get aspectRatio(){const{options:{aspectRatio:e,maintainAspectRatio:t},width:n,height:r,_aspectRatio:i}=this;return jv(e)?t&&i?i:r?n/r:null:e}get data(){return this.config.data}set data(e){this.config.data=e}get options(){return this._options}set options(e){this.config.options=e}get registry(){return u_}_initialize(){return this.notifyPlugins("beforeInit"),this.options.responsive?this.resize():Tb(this,this.options.devicePixelRatio),this.bindEvents(),this.notifyPlugins("afterInit"),this}clear(){return wy(this.canvas,this.ctx),this}stop(){return Bb.stop(this),this}resize(e,t){Bb.running(this)?this._resizeBeforeDraw={width:e,height:t}:this._resize(e,t)}_resize(e,t){const n=this.options,r=this.canvas,i=n.maintainAspectRatio&&this.aspectRatio,o=this.platform.getMaximumSize(r,e,t,i),a=n.devicePixelRatio||this.platform.getDevicePixelRatio(),l=this.width?"resize":"attach";this.width=o.width,this.height=o.height,this._aspectRatio=this.aspectRatio,Tb(this,a,!0)&&(this.notifyPlugins("resize",{size:o}),Nv(n.onResize,[this,o],this),this.attached&&this._doResize(l)&&this.render())}ensureScalesHaveIDs(){Pv(this.options.scales||{},((e,t)=>{e.id=t}))}buildOrUpdateScales(){const e=this.options,t=e.scales,n=this.scales,r=Object.keys(n).reduce(((e,t)=>(e[t]=!1,e)),{});let i=[];t&&(i=i.concat(Object.keys(t).map((e=>{const n=t[e],r=p_(e,n),i="r"===r,o="x"===r;return{options:n,dposition:i?"chartArea":o?"bottom":"left",dtype:i?"radialLinear":o?"category":"linear"}})))),Pv(i,(t=>{const i=t.options,o=i.id,a=p_(o,i),l=Sv(i.type,t.dtype);void 0!==i.position&&I_(i.position,a)===I_(t.dposition)||(i.position=t.dposition),r[o]=!0;let s=null;if(o in n&&n[o].type===l)s=n[o];else{s=new(u_.getScale(l))({id:o,type:l,ctx:this.ctx,chart:this}),n[s.id]=s}s.init(i,e)})),Pv(r,((e,t)=>{e||delete n[t]})),Pv(n,(e=>{Rx.configure(this,e,e.options),Rx.addBox(this,e)}))}_updateMetasets(){const e=this._metasets,t=this.data.datasets.length,n=e.length;if(e.sort(((e,t)=>e.index-t.index)),n>t){for(let e=t;e<n;++e)this._destroyDatasetMeta(e);e.splice(t,n-t)}this._sortedMetasets=e.slice(0).sort(S_("order","index"))}_removeUnreferencedMetasets(){const{_metasets:e,data:{datasets:t}}=this;e.length>t.length&&delete this._stacks,e.forEach(((e,n)=>{0===t.filter((t=>t===e._dataset)).length&&this._destroyDatasetMeta(n)}))}buildOrUpdateControllers(){const e=[],t=this.data.datasets;let n,r;for(this._removeUnreferencedMetasets(),n=0,r=t.length;n<r;n++){const r=t[n];let i=this.getDatasetMeta(n);const o=r.type||this.config.type;if(i.type&&i.type!==o&&(this._destroyDatasetMeta(n),i=this.getDatasetMeta(n)),i.type=o,i.indexAxis=r.indexAxis||m_(o,this.options),i.order=r.order||0,i.index=n,i.label=""+r.label,i.visible=this.isDatasetVisible(n),i.controller)i.controller.updateIndex(n),i.controller.linkScales();else{const t=u_.getController(o),{datasetElementType:r,dataElementType:a}=Ty.datasets[o];Object.assign(t,{dataElementType:u_.getElement(a),datasetElementType:r&&u_.getElement(r)}),i.controller=new t(this,n),e.push(i.controller)}}return this._updateMetasets(),e}_resetElements(){Pv(this.data.datasets,((e,t)=>{this.getDatasetMeta(t).controller.reset()}),this)}reset(){this._resetElements(),this.notifyPlugins("reset")}update(e){const t=this.config;t.update();const n=this._options=t.createResolver(t.chartOptionScopes(),this.getContext()),r=this._animationsDisabled=!n.animation;if(this._updateScales(),this._checkEventBindings(),this._updateHiddenIndices(),this._plugins.invalidate(),!1===this.notifyPlugins("beforeUpdate",{mode:e,cancelable:!0}))return;const i=this.buildOrUpdateControllers();this.notifyPlugins("beforeElementsUpdate");let o=0;for(let e=0,t=this.data.datasets.length;e<t;e++){const{controller:t}=this.getDatasetMeta(e),n=!r&&-1===i.indexOf(t);t.buildOrUpdateElements(n),o=Math.max(+t.getMaxOverflow(),o)}o=this._minPadding=n.layout.autoPadding?o:0,this._updateLayout(o),r||Pv(i,(e=>{e.reset()})),this._updateDatasets(e),this.notifyPlugins("afterUpdate",{mode:e}),this._layers.sort(S_("z","_idx"));const{_active:a,_lastEvent:l}=this;l?this._eventHandler(l,!0):a.length&&this._updateHoverStyles(a,a,!0),this.render()}_updateScales(){Pv(this.scales,(e=>{Rx.removeBox(this,e)})),this.ensureScalesHaveIDs(),this.buildOrUpdateScales()}_checkEventBindings(){const e=this.options,t=new Set(Object.keys(this._listeners)),n=new Set(e.events);Hv(t,n)&&!!this._responsiveListeners===e.responsive||(this.unbindEvents(),this.bindEvents())}_updateHiddenIndices(){const{_hiddenIndices:e}=this,t=this._getUniformDataChanges()||[];for(const{method:n,start:r,count:i}of t){L_(e,r,"_removeElements"===n?-i:i)}}_getUniformDataChanges(){const e=this._dataChanges;if(!e||!e.length)return;this._dataChanges=[];const t=this.data.datasets.length,n=t=>new Set(e.filter((e=>e[0]===t)).map(((e,t)=>t+","+e.splice(1).join(",")))),r=n(0);for(let e=1;e<t;e++)if(!Hv(r,n(e)))return;return Array.from(r).map((e=>e.split(","))).map((e=>({method:e[1],start:+e[2],count:+e[3]})))}_updateLayout(e){if(!1===this.notifyPlugins("beforeLayout",{cancelable:!0}))return;Rx.update(this,this.width,this.height,e);const t=this.chartArea,n=t.width<=0||t.height<=0;this._layers=[],Pv(this.boxes,(e=>{n&&"chartArea"===e.position||(e.configure&&e.configure(),this._layers.push(...e._layers()))}),this),this._layers.forEach(((e,t)=>{e._idx=t})),this.notifyPlugins("afterLayout")}_updateDatasets(e){if(!1!==this.notifyPlugins("beforeDatasetsUpdate",{mode:e,cancelable:!0})){for(let e=0,t=this.data.datasets.length;e<t;++e)this.getDatasetMeta(e).controller.configure();for(let t=0,n=this.data.datasets.length;t<n;++t)this._updateDataset(t,Bv(e)?e({datasetIndex:t}):e);this.notifyPlugins("afterDatasetsUpdate",{mode:e})}}_updateDataset(e,t){const n=this.getDatasetMeta(e),r={meta:n,index:e,mode:t,cancelable:!0};!1!==this.notifyPlugins("beforeDatasetUpdate",r)&&(n.controller._update(t),r.cancelable=!1,this.notifyPlugins("afterDatasetUpdate",r))}render(){!1!==this.notifyPlugins("beforeRender",{cancelable:!0})&&(Bb.has(this)?this.attached&&!Bb.running(this)&&Bb.start(this):(this.draw(),w_({chart:this})))}draw(){let e;if(this._resizeBeforeDraw){const{width:e,height:t}=this._resizeBeforeDraw;this._resize(e,t),this._resizeBeforeDraw=null}if(this.clear(),this.width<=0||this.height<=0)return;if(!1===this.notifyPlugins("beforeDraw",{cancelable:!0}))return;const t=this._layers;for(e=0;e<t.length&&t[e].z<=0;++e)t[e].draw(this.chartArea);for(this._drawDatasets();e<t.length;++e)t[e].draw(this.chartArea);this.notifyPlugins("afterDraw")}_getSortedDatasetMetas(e){const t=this._sortedMetasets,n=[];let r,i;for(r=0,i=t.length;r<i;++r){const i=t[r];e&&!i.visible||n.push(i)}return n}getSortedVisibleDatasetMetas(){return this._getSortedDatasetMetas(!0)}_drawDatasets(){if(!1===this.notifyPlugins("beforeDatasetsDraw",{cancelable:!0}))return;const e=this.getSortedVisibleDatasetMetas();for(let t=e.length-1;t>=0;--t)this._drawDataset(e[t]);this.notifyPlugins("afterDatasetsDraw")}_drawDataset(e){const t=this.ctx,n=e._clip,r=!n.disabled,i=function(e){const{xScale:t,yScale:n}=e;if(t&&n)return{left:t.left,right:t.right,top:n.top,bottom:n.bottom}}(e)||this.chartArea,o={meta:e,index:e.index,cancelable:!0};!1!==this.notifyPlugins("beforeDatasetDraw",o)&&(r&&Ay(t,{left:!1===n.left?0:i.left-n.left,right:!1===n.right?this.width:i.right+n.right,top:!1===n.top?0:i.top-n.top,bottom:!1===n.bottom?this.height:i.bottom+n.bottom}),e.controller.draw(),r&&Ly(t),o.cancelable=!1,this.notifyPlugins("afterDatasetDraw",o))}isPointInArea(e){return Cy(e,this.chartArea,this._minPadding)}getElementsAtEventForMode(e,t,n,r){const i=jx.modes[t];return"function"==typeof i?i(this,e,n,r):[]}getDatasetMeta(e){const t=this.data.datasets[e],n=this._metasets;let r=n.filter((e=>e&&e._dataset===t)).pop();return r||(r={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null,order:t&&t.order||0,index:e,_dataset:t,_parsed:[],_sorted:!1},n.push(r)),r}getContext(){return this.$context||(this.$context=qy(null,{chart:this,type:"chart"}))}getVisibleDatasetCount(){return this.getSortedVisibleDatasetMetas().length}isDatasetVisible(e){const t=this.data.datasets[e];if(!t)return!1;const n=this.getDatasetMeta(e);return"boolean"==typeof n.hidden?!n.hidden:!t.hidden}setDatasetVisibility(e,t){this.getDatasetMeta(e).hidden=!t}toggleDataVisibility(e){this._hiddenIndices[e]=!this._hiddenIndices[e]}getDataVisibility(e){return!this._hiddenIndices[e]}_updateVisibility(e,t,n){const r=n?"show":"hide",i=this.getDatasetMeta(e),o=i.controller._resolveAnimations(void 0,r);Vv(t)?(i.data[t].hidden=!n,this.update()):(this.setDatasetVisibility(e,n),o.update(i,{visible:n}),this.update((t=>t.datasetIndex===e?r:void 0)))}hide(e,t){this._updateVisibility(e,t,!1)}show(e,t){this._updateVisibility(e,t,!0)}_destroyDatasetMeta(e){const t=this._metasets[e];t&&t.controller&&t.controller._destroy(),delete this._metasets[e]}_stop(){let e,t;for(this.stop(),Bb.remove(this),e=0,t=this.data.datasets.length;e<t;++e)this._destroyDatasetMeta(e)}destroy(){this.notifyPlugins("beforeDestroy");const{canvas:e,ctx:t}=this;this._stop(),this.config.clearCache(),e&&(this.unbindEvents(),wy(e,t),this.platform.releaseContext(t),this.canvas=null,this.ctx=null),delete C_[this.id],this.notifyPlugins("afterDestroy")}toBase64Image(...e){return this.canvas.toDataURL(...e)}bindEvents(){this.bindUserEvents(),this.options.responsive?this.bindResponsiveEvents():this.attached=!0}bindUserEvents(){const e=this._listeners,t=this.platform,n=(n,r)=>{t.addEventListener(this,n,r),e[n]=r},r=(e,t,n)=>{e.offsetX=t,e.offsetY=n,this._eventHandler(e)};Pv(this.options.events,(e=>n(e,r)))}bindResponsiveEvents(){this._responsiveListeners||(this._responsiveListeners={});const e=this._responsiveListeners,t=this.platform,n=(n,r)=>{t.addEventListener(this,n,r),e[n]=r},r=(n,r)=>{e[n]&&(t.removeEventListener(this,n,r),delete e[n])},i=(e,t)=>{this.canvas&&this.resize(e,t)};let o;const a=()=>{r("attach",a),this.attached=!0,this.resize(),n("resize",i),n("detach",o)};o=()=>{this.attached=!1,r("resize",i),this._stop(),this._resize(0,0),n("attach",a)},t.isAttached(this.canvas)?a():o()}unbindEvents(){Pv(this._listeners,((e,t)=>{this.platform.removeEventListener(this,t,e)})),this._listeners={},Pv(this._responsiveListeners,((e,t)=>{this.platform.removeEventListener(this,t,e)})),this._responsiveListeners=void 0}updateHoverStyle(e,t,n){const r=n?"set":"remove";let i,o,a,l;for("dataset"===t&&(i=this.getDatasetMeta(e[0].datasetIndex),i.controller["_"+r+"DatasetHoverStyle"]()),a=0,l=e.length;a<l;++a){o=e[a];const t=o&&this.getDatasetMeta(o.datasetIndex).controller;t&&t[r+"HoverStyle"](o.element,o.datasetIndex,o.index)}}getActiveElements(){return this._active||[]}setActiveElements(e){const t=this._active||[],n=e.map((({datasetIndex:e,index:t})=>{const n=this.getDatasetMeta(e);if(!n)throw new Error("No dataset found at index "+e);return{datasetIndex:e,element:n.data[t],index:t}}));!Cv(n,t)&&(this._active=n,this._lastEvent=null,this._updateHoverStyles(n,t))}notifyPlugins(e,t,n){return this._plugins.notify(this,e,t,n)}isPluginEnabled(e){return 1===this._plugins._cache.filter((t=>t.plugin.id===e)).length}_updateHoverStyles(e,t,n){const r=this.options.hover,i=(e,t)=>e.filter((e=>!t.some((t=>e.datasetIndex===t.datasetIndex&&e.index===t.index)))),o=i(t,e),a=n?e:i(e,t);o.length&&this.updateHoverStyle(o,r.mode,!1),a.length&&r.mode&&this.updateHoverStyle(a,r.mode,!0)}_eventHandler(e,t){const n={event:e,replay:t,cancelable:!0,inChartArea:this.isPointInArea(e)},r=t=>(t.options.events||this.options.events).includes(e.native.type);if(!1===this.notifyPlugins("beforeEvent",n,r))return;const i=this._handleEvent(e,t,n.inChartArea);return n.cancelable=!1,this.notifyPlugins("afterEvent",n,r),(i||n.changed)&&this.render(),this}_handleEvent(e,t,n){const{_active:r=[],options:i}=this,o=t,a=this._getActiveElements(e,r,n,o),l=function(e){return"mouseup"===e.type||"click"===e.type||"contextmenu"===e.type}(e),s=function(e,t,n,r){return n&&"mouseout"!==e.type?r?t:e:null}(e,this._lastEvent,n,l);n&&(this._lastEvent=null,Nv(i.onHover,[e,a,this],this),l&&Nv(i.onClick,[e,a,this],this));const c=!Cv(a,r);return(c||t)&&(this._active=a,this._updateHoverStyles(a,r,t)),this._lastEvent=s,c}_getActiveElements(e,t,n,r){if("mouseout"===e.type)return[];if(!n)return t;const i=this.options.hover;return this.getElementsAtEventForMode(e,i.mode,i,r)}}function R_(){return Pv(M_.instances,(e=>e._plugins.invalidate()))}var k_=M_;function D_(e,t,n=t){e.lineCap=Sv(n.borderCapStyle,t.borderCapStyle),e.setLineDash(Sv(n.borderDash,t.borderDash)),e.lineDashOffset=Sv(n.borderDashOffset,t.borderDashOffset),e.lineJoin=Sv(n.borderJoinStyle,t.borderJoinStyle),e.lineWidth=Sv(n.borderWidth,t.borderWidth),e.strokeStyle=Sv(n.borderColor,t.borderColor)}function U_(e,t,n){e.lineTo(n.x,n.y)}function F_(e,t,n={}){const r=e.length,{start:i=0,end:o=r-1}=n,{start:a,end:l}=t,s=Math.max(i,a),c=Math.min(o,l),u=i<a&&o<a||i>l&&o>l;return{count:r,start:s,loop:t.loop,ilen:c<s&&!u?r+c-s:c-s}}function G_(e,t,n,r){const{points:i,options:o}=t,{count:a,start:l,loop:s,ilen:c}=F_(i,n,r),u=function(e){return e.stepped?My:e.tension||"monotone"===e.cubicInterpolationMode?Ry:U_}(o);let d,f,h,{move:m=!0,reverse:p}=r||{};for(d=0;d<=c;++d)f=i[(l+(p?c-d:d))%a],f.skip||(m?(e.moveTo(f.x,f.y),m=!1):u(e,h,f,p,o.stepped),h=f);return s&&(f=i[(l+(p?c:0))%a],u(e,h,f,p,o.stepped)),!!s}function V_(e,t,n,r){const i=t.points,{count:o,start:a,ilen:l}=F_(i,n,r),{move:s=!0,reverse:c}=r||{};let u,d,f,h,m,p,v=0,g=0;const y=e=>(a+(c?l-e:e))%o,b=()=>{h!==m&&(e.lineTo(v,m),e.lineTo(v,h),e.lineTo(v,p))};for(s&&(d=i[y(0)],e.moveTo(d.x,d.y)),u=0;u<=l;++u){if(d=i[y(u)],d.skip)continue;const t=d.x,n=d.y,r=0|t;r===f?(n<h?h=n:n>m&&(m=n),v=(g*v+t)/++g):(b(),e.lineTo(t,n),f=r,g=0,h=m=n),p=n}b()}function B_(e){const t=e.options,n=t.borderDash&&t.borderDash.length;return!(e._decimated||e._loop||t.tension||"monotone"===t.cubicInterpolationMode||t.stepped||n)?V_:G_}const H_="function"==typeof Path2D;function K_(e,t,n,r){H_&&!t.options.segment?function(e,t,n,r){let i=t._path;i||(i=t._path=new Path2D,t.path(i,n,r)&&i.closePath()),D_(e,t.options),e.stroke(i)}(e,t,n,r):function(e,t,n,r){const{segments:i,options:o}=t,a=B_(t);for(const l of i)D_(e,o,l.style),e.beginPath(),a(e,t,l,{start:n,end:n+r-1})&&e.closePath(),e.stroke()}(e,t,n,r)}class W_ extends Zx{static id="line";static defaults={borderCapStyle:"butt",borderDash:[],borderDashOffset:0,borderJoinStyle:"miter",borderWidth:3,capBezierPoints:!0,cubicInterpolationMode:"default",fill:!1,spanGaps:!1,stepped:!1,tension:0};static defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};static descriptors={_scriptable:!0,_indexable:e=>"borderDash"!==e&&"fill"!==e};constructor(e){super(),this.animated=!0,this.options=void 0,this._chart=void 0,this._loop=void 0,this._fullLoop=void 0,this._path=void 0,this._points=void 0,this._segments=void 0,this._decimated=!1,this._pointsUpdated=!1,this._datasetIndex=void 0,e&&Object.assign(this,e)}updateControlPoints(e,t){const n=this.options;if((n.tension||"monotone"===n.cubicInterpolationMode)&&!n.stepped&&!this._pointsUpdated){const r=n.spanGaps?this._loop:this._fullLoop;pb(this._points,n,e,r,t),this._pointsUpdated=!0}}set points(e){this._points=e,delete this._segments,delete this._path,this._pointsUpdated=!1}get points(){return this._points}get segments(){return this._segments||(this._segments=function(e,t){const n=e.points,r=e.options.spanGaps,i=n.length;if(!i)return[];const o=!!e._loop,{start:a,end:l}=function(e,t,n,r){let i=0,o=t-1;if(n&&!r)for(;i<t&&!e[i].skip;)i++;for(;i<t&&e[i].skip;)i++;for(i%=t,n&&(o+=i);o>i&&e[o%t].skip;)o--;return o%=t,{start:i,end:o}}(n,i,o,r);return Ub(e,!0===r?[{start:a,end:l,loop:o}]:function(e,t,n,r){const i=e.length,o=[];let a,l=t,s=e[t];for(a=t+1;a<=n;++a){const n=e[a%i];n.skip||n.stop?s.skip||(r=!1,o.push({start:t%i,end:(a-1)%i,loop:r}),t=l=n.stop?a:null):(l=a,s.skip&&(t=a)),s=n}return null!==l&&o.push({start:t%i,end:l%i,loop:r}),o}(n,a,l<a?l+i:l,!!e._fullLoop&&0===a&&l===i-1),n,t)}(this,this.options.segment))}first(){const e=this.segments,t=this.points;return e.length&&t[e[0].start]}last(){const e=this.segments,t=this.points,n=e.length;return n&&t[e[n-1].end]}interpolate(e,t){const n=this.options,r=e[t],i=this.points,o=Db(this,{property:t,start:r,end:r});if(!o.length)return;const a=[],l=function(e){return e.stepped?Nb:e.tension||"monotone"===e.cubicInterpolationMode?Pb:wb}(n);let s,c;for(s=0,c=o.length;s<c;++s){const{start:c,end:u}=o[s],d=i[c],f=i[u];if(d===f){a.push(d);continue}const h=l(d,f,Math.abs((r-d[t])/(f[t]-d[t])),n.stepped);h[t]=e[t],a.push(h)}return 1===a.length?a[0]:a}pathSegment(e,t,n){return B_(this)(e,this,t,n)}path(e,t,n){const r=this.segments,i=B_(this);let o=this._loop;t=t||0,n=n||this.points.length-t;for(const a of r)o&=i(e,this,a,{start:t,end:t+n-1});return!!o}draw(e,t,n,r){const i=this.options||{};(this.points||[]).length&&i.borderWidth&&(e.save(),K_(e,this,n,r),e.restore()),this.animated&&(this._pointsUpdated=!1,this._path=void 0)}}function z_(e,t,n,r){const i=e.options,{[n]:o}=e.getProps([n],r);return Math.abs(t-o)<i.radius+i.hitRadius}class Y_ extends Zx{static id="point";static defaults={borderWidth:1,hitRadius:1,hoverBorderWidth:1,hoverRadius:4,pointStyle:"circle",radius:3,rotation:0};static defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};constructor(e){super(),this.options=void 0,this.parsed=void 0,this.skip=void 0,this.stop=void 0,e&&Object.assign(this,e)}inRange(e,t,n){const r=this.options,{x:i,y:o}=this.getProps(["x","y"],n);return Math.pow(e-i,2)+Math.pow(t-o,2)<Math.pow(r.hitRadius+r.radius,2)}inXRange(e,t){return z_(this,e,"x",t)}inYRange(e,t){return z_(this,e,"y",t)}getCenterPoint(e){const{x:t,y:n}=this.getProps(["x","y"],e);return{x:t,y:n}}size(e){let t=(e=e||this.options||{}).radius||0;t=Math.max(t,t&&e.hoverRadius||0);return 2*(t+(t&&e.borderWidth||0))}draw(e,t){const n=this.options;this.skip||n.radius<.1||!Cy(this,t,this.size(n)/2)||(e.strokeStyle=n.borderColor,e.lineWidth=n.borderWidth,e.fillStyle=n.backgroundColor,Ny(e,n,this.x,this.y))}getRange(){const e=this.options||{};return e.radius+e.hitRadius}}function X_(e,t){const{x:n,y:r,base:i,width:o,height:a}=e.getProps(["x","y","base","width","height"],t);let l,s,c,u,d;return e.horizontal?(d=a/2,l=Math.min(n,i),s=Math.max(n,i),c=r-d,u=r+d):(d=o/2,l=n-d,s=n+d,c=Math.min(r,i),u=Math.max(r,i)),{left:l,top:c,right:s,bottom:u}}function q_(e,t,n,r){return e?0:fg(t,n,r)}function $_(e){const t=X_(e),n=t.right-t.left,r=t.bottom-t.top,i=function(e,t,n){const r=e.options.borderWidth,i=e.borderSkipped,o=Ky(r);return{t:q_(i.top,o.top,0,n),r:q_(i.right,o.right,0,t),b:q_(i.bottom,o.bottom,0,n),l:q_(i.left,o.left,0,t)}}(e,n/2,r/2),o=function(e,t,n){const{enableBorderRadius:r}=e.getProps(["enableBorderRadius"]),i=e.options.borderRadius,o=Wy(i),a=Math.min(t,n),l=e.borderSkipped,s=r||Ov(i);return{topLeft:q_(!s||l.top||l.left,o.topLeft,0,a),topRight:q_(!s||l.top||l.right,o.topRight,0,a),bottomLeft:q_(!s||l.bottom||l.left,o.bottomLeft,0,a),bottomRight:q_(!s||l.bottom||l.right,o.bottomRight,0,a)}}(e,n/2,r/2);return{outer:{x:t.left,y:t.top,w:n,h:r,radius:o},inner:{x:t.left+i.l,y:t.top+i.t,w:n-i.l-i.r,h:r-i.t-i.b,radius:{topLeft:Math.max(0,o.topLeft-Math.max(i.t,i.l)),topRight:Math.max(0,o.topRight-Math.max(i.t,i.r)),bottomLeft:Math.max(0,o.bottomLeft-Math.max(i.b,i.l)),bottomRight:Math.max(0,o.bottomRight-Math.max(i.b,i.r))}}}}function Q_(e,t,n,r){const i=null===t,o=null===n,a=e&&!(i&&o)&&X_(e,r);return a&&(i||hg(t,a.left,a.right))&&(o||hg(n,a.top,a.bottom))}function Z_(e,t){e.rect(t.x,t.y,t.w,t.h)}function J_(e,t,n={}){const r=e.x!==n.x?-t:0,i=e.y!==n.y?-t:0,o=(e.x+e.w!==n.x+n.w?t:0)-r,a=(e.y+e.h!==n.y+n.h?t:0)-i;return{x:e.x+r,y:e.y+i,w:e.w+o,h:e.h+a,radius:e.radius}}class ej extends Zx{static id="bar";static defaults={borderSkipped:"start",borderWidth:0,borderRadius:0,inflateAmount:"auto",pointStyle:void 0};static defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};constructor(e){super(),this.options=void 0,this.horizontal=void 0,this.base=void 0,this.width=void 0,this.height=void 0,this.inflateAmount=void 0,e&&Object.assign(this,e)}draw(e){const{inflateAmount:t,options:{borderColor:n,backgroundColor:r}}=this,{inner:i,outer:o}=$_(this),a=(l=o.radius).topLeft||l.topRight||l.bottomLeft||l.bottomRight?Fy:Z_;var l;e.save(),o.w===i.w&&o.h===i.h||(e.beginPath(),a(e,J_(o,t,i)),e.clip(),a(e,J_(i,-t,o)),e.fillStyle=n,e.fill("evenodd")),e.beginPath(),a(e,J_(i,t)),e.fillStyle=r,e.fill(),e.restore()}inRange(e,t,n){return Q_(this,e,t,n)}inXRange(e,t){return Q_(this,e,null,t)}inYRange(e,t){return Q_(this,null,e,t)}getCenterPoint(e){const{x:t,y:n,base:r,horizontal:i}=this.getProps(["x","y","base","horizontal"],e);return{x:i?(t+r)/2:t,y:i?n:(n+r)/2}}getRange(e){return"x"===e?this.width/2:this.height/2}}function tj(e,t,n,r){if(r)return;let i=t[e],o=n[e];return"angle"===e&&(i=ug(i),o=ug(o)),{property:e,start:i,end:o}}function nj(e,t,n){for(;t>e;t--){const e=n[t];if(!isNaN(e.x)&&!isNaN(e.y))break}return t}function rj(e,t,n,r){return e&&t?r(e[n],t[n]):e?e[n]:t?t[n]:0}function ij(e,t){let n=[],r=!1;return Ev(e)?(r=!0,n=e):n=function(e,t){const{x:n=null,y:r=null}=e||{},i=t.points,o=[];return t.segments.forEach((({start:e,end:t})=>{t=nj(e,t,i);const a=i[e],l=i[t];null!==r?(o.push({x:a.x,y:r}),o.push({x:l.x,y:r})):null!==n&&(o.push({x:n,y:a.y}),o.push({x:n,y:l.y}))})),o}(e,t),n.length?new W_({points:n,options:{tension:0},_loop:r,_fullLoop:r}):null}function oj(e){return e&&!1!==e.fill}function aj(e,t,n){let r=e[t].fill;const i=[t];let o;if(!n)return r;for(;!1!==r&&-1===i.indexOf(r);){if(!Tv(r))return r;if(o=e[r],!o)return!1;if(o.visible)return r;i.push(r),r=o.fill}return!1}function lj(e,t,n){const r=function(e){const t=e.options,n=t.fill;let r=Sv(n&&n.target,n);void 0===r&&(r=!!t.backgroundColor);if(!1===r||null===r)return!1;if(!0===r)return"origin";return r}(e);if(Ov(r))return!isNaN(r.value)&&r;let i=parseFloat(r);return Tv(i)&&Math.floor(i)===i?function(e,t,n,r){"-"!==e&&"+"!==e||(n=t+n);if(n===t||n<0||n>=r)return!1;return n}(r[0],t,i,n):["origin","start","end","stack","shape"].indexOf(r)>=0&&r}function sj(e,t,n){const r=[];for(let i=0;i<n.length;i++){const o=n[i],{first:a,last:l,point:s}=cj(o,t,"x");if(!(!s||a&&l))if(a)r.unshift(s);else if(e.push(s),!l)break}e.push(...r)}function cj(e,t,n){const r=e.interpolate(t,n);if(!r)return{};const i=r[n],o=e.segments,a=e.points;let l=!1,s=!1;for(let e=0;e<o.length;e++){const t=o[e],r=a[t.start][n],c=a[t.end][n];if(hg(i,r,c)){l=i===r,s=i===c;break}}return{first:l,last:s,point:r}}class uj{constructor(e){this.x=e.x,this.y=e.y,this.radius=e.radius}pathSegment(e,t,n){const{x:r,y:i,radius:o}=this;return t=t||{start:0,end:Wv},e.arc(r,i,o,t.end,t.start,!0),!n.bounds}interpolate(e){const{x:t,y:n,radius:r}=this,i=e.angle;return{x:t+Math.cos(i)*r,y:n+Math.sin(i)*r,angle:i}}}function dj(e){const{chart:t,fill:n,line:r}=e;if(Tv(n))return function(e,t){const n=e.getDatasetMeta(t);return n&&e.isDatasetVisible(t)?n.dataset:null}(t,n);if("stack"===n)return function(e){const{scale:t,index:n,line:r}=e,i=[],o=r.segments,a=r.points,l=function(e,t){const n=[],r=e.getMatchingVisibleMetas("line");for(let e=0;e<r.length;e++){const i=r[e];if(i.index===t)break;i.hidden||n.unshift(i.dataset)}return n}(t,n);l.push(ij({x:null,y:t.bottom},r));for(let e=0;e<o.length;e++){const t=o[e];for(let e=t.start;e<=t.end;e++)sj(i,a[e],l)}return new W_({points:i,options:{}})}(e);if("shape"===n)return!0;const i=function(e){if((e.scale||{}).getPointPositionForValue)return function(e){const{scale:t,fill:n}=e,r=t.options,i=t.getLabels().length,o=r.reverse?t.max:t.min,a=function(e,t,n){let r;return r="start"===e?n:"end"===e?t.options.reverse?t.min:t.max:Ov(e)?e.value:t.getBaseValue(),r}(n,t,o),l=[];if(r.grid.circular){const e=t.getPointPositionForValue(0,o);return new uj({x:e.x,y:e.y,radius:t.getDistanceFromCenterForValue(a)})}for(let e=0;e<i;++e)l.push(t.getPointPositionForValue(e,a));return l}(e);return function(e){const{scale:t={},fill:n}=e,r=function(e,t){let n=null;return"start"===e?n=t.bottom:"end"===e?n=t.top:Ov(e)?n=t.getPixelForValue(e.value):t.getBasePixel&&(n=t.getBasePixel()),n}(n,t);if(Tv(r)){const e=t.isHorizontal();return{x:e?r:null,y:e?null:r}}return null}(e)}(e);return i instanceof uj?i:ij(i,r)}function fj(e,t,n){const r=dj(t),{line:i,scale:o,axis:a}=t,l=i.options,s=l.fill,c=l.backgroundColor,{above:u=c,below:d=c}=s||{};r&&i.points.length&&(Ay(e,n),function(e,t){const{line:n,target:r,above:i,below:o,area:a,scale:l}=t,s=n._loop?"angle":t.axis;e.save(),"x"===s&&o!==i&&(hj(e,r,a.top),mj(e,{line:n,target:r,color:i,scale:l,property:s}),e.restore(),e.save(),hj(e,r,a.bottom));mj(e,{line:n,target:r,color:o,scale:l,property:s}),e.restore()}(e,{line:i,target:r,above:u,below:d,area:n,scale:o,axis:a}),Ly(e))}function hj(e,t,n){const{segments:r,points:i}=t;let o=!0,a=!1;e.beginPath();for(const l of r){const{start:r,end:s}=l,c=i[r],u=i[nj(r,s,i)];o?(e.moveTo(c.x,c.y),o=!1):(e.lineTo(c.x,n),e.lineTo(c.x,c.y)),a=!!t.pathSegment(e,l,{move:a}),a?e.closePath():e.lineTo(u.x,n)}e.lineTo(t.first().x,n),e.closePath(),e.clip()}function mj(e,t){const{line:n,target:r,property:i,color:o,scale:a}=t,l=function(e,t,n){const r=e.segments,i=e.points,o=t.points,a=[];for(const e of r){let{start:r,end:l}=e;l=nj(r,l,i);const s=tj(n,i[r],i[l],e.loop);if(!t.segments){a.push({source:e,target:s,start:i[r],end:i[l]});continue}const c=Db(t,s);for(const t of c){const r=tj(n,o[t.start],o[t.end],t.loop),l=kb(e,i,r);for(const e of l)a.push({source:e,target:t,start:{[n]:rj(s,r,"start",Math.max)},end:{[n]:rj(s,r,"end",Math.min)}})}}return a}(n,r,i);for(const{source:t,target:s,start:c,end:u}of l){const{style:{backgroundColor:l=o}={}}=t,d=!0!==r;e.save(),e.fillStyle=l,pj(e,a,d&&tj(i,c,u)),e.beginPath();const f=!!n.pathSegment(e,t);let h;if(d){f?e.closePath():vj(e,r,u,i);const t=!!r.pathSegment(e,s,{move:f,reverse:!0});h=f&&t,h||vj(e,r,c,i)}e.closePath(),e.fill(h?"evenodd":"nonzero"),e.restore()}}function pj(e,t,n){const{top:r,bottom:i}=t.chart.chartArea,{property:o,start:a,end:l}=n||{};"x"===o&&(e.beginPath(),e.rect(a,r,l-a,i-r),e.clip())}function vj(e,t,n,r){const i=t.interpolate(n,r);i&&e.lineTo(i.x,i.y)}var gj={id:"filler",afterDatasetsUpdate(e,t,n){const r=(e.data.datasets||[]).length,i=[];let o,a,l,s;for(a=0;a<r;++a)o=e.getDatasetMeta(a),l=o.dataset,s=null,l&&l.options&&l instanceof W_&&(s={visible:e.isDatasetVisible(a),index:a,fill:lj(l,a,r),chart:e,axis:o.controller.options.indexAxis,scale:o.vScale,line:l}),o.$filler=s,i.push(s);for(a=0;a<r;++a)s=i[a],s&&!1!==s.fill&&(s.fill=aj(i,a,n.propagate))},beforeDraw(e,t,n){const r="beforeDraw"===n.drawTime,i=e.getSortedVisibleDatasetMetas(),o=e.chartArea;for(let t=i.length-1;t>=0;--t){const n=i[t].$filler;n&&(n.line.updateControlPoints(o,n.axis),r&&n.fill&&fj(e.ctx,n,o))}},beforeDatasetsDraw(e,t,n){if("beforeDatasetsDraw"!==n.drawTime)return;const r=e.getSortedVisibleDatasetMetas();for(let t=r.length-1;t>=0;--t){const n=r[t].$filler;oj(n)&&fj(e.ctx,n,e.chartArea)}},beforeDatasetDraw(e,t,n){const r=t.meta.$filler;oj(r)&&"beforeDatasetDraw"===n.drawTime&&fj(e.ctx,r,e.chartArea)},defaults:{propagate:!0,drawTime:"beforeDatasetDraw"}};const yj=(e,t)=>{let{boxHeight:n=t,boxWidth:r=t}=e;return e.usePointStyle&&(n=Math.min(n,t),r=e.pointStyleWidth||Math.min(r,t)),{boxWidth:r,boxHeight:n,itemHeight:Math.max(t,n)}};class bj extends Zx{constructor(e){super(),this._added=!1,this.legendHitBoxes=[],this._hoveredItem=null,this.doughnutMode=!1,this.chart=e.chart,this.options=e.options,this.ctx=e.ctx,this.legendItems=void 0,this.columnSizes=void 0,this.lineWidths=void 0,this.maxHeight=void 0,this.maxWidth=void 0,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.height=void 0,this.width=void 0,this._margins=void 0,this.position=void 0,this.weight=void 0,this.fullSize=void 0}update(e,t,n){this.maxWidth=e,this.maxHeight=t,this._margins=n,this.setDimensions(),this.buildLabels(),this.fit()}setDimensions(){this.isHorizontal()?(this.width=this.maxWidth,this.left=this._margins.left,this.right=this.width):(this.height=this.maxHeight,this.top=this._margins.top,this.bottom=this.height)}buildLabels(){const e=this.options.labels||{};let t=Nv(e.generateLabels,[this.chart],this)||[];e.filter&&(t=t.filter((t=>e.filter(t,this.chart.data)))),e.sort&&(t=t.sort(((t,n)=>e.sort(t,n,this.chart.data)))),this.options.reverse&&t.reverse(),this.legendItems=t}fit(){const{options:e,ctx:t}=this;if(!e.display)return void(this.width=this.height=0);const n=e.labels,r=Yy(n.font),i=r.size,o=this._computeTitleHeight(),{boxWidth:a,itemHeight:l}=yj(n,i);let s,c;t.font=r.string,this.isHorizontal()?(s=this.maxWidth,c=this._fitRows(o,i,a,l)+10):(c=this.maxHeight,s=this._fitCols(o,r,a,l)+10),this.width=Math.min(s,e.maxWidth||this.maxWidth),this.height=Math.min(c,e.maxHeight||this.maxHeight)}_fitRows(e,t,n,r){const{ctx:i,maxWidth:o,options:{labels:{padding:a}}}=this,l=this.legendHitBoxes=[],s=this.lineWidths=[0],c=r+a;let u=e;i.textAlign="left",i.textBaseline="middle";let d=-1,f=-c;return this.legendItems.forEach(((e,h)=>{const m=n+t/2+i.measureText(e.text).width;(0===h||s[s.length-1]+m+2*a>o)&&(u+=c,s[s.length-(h>0?0:1)]=0,f+=c,d++),l[h]={left:0,top:f,row:d,width:m,height:r},s[s.length-1]+=m+a})),u}_fitCols(e,t,n,r){const{ctx:i,maxHeight:o,options:{labels:{padding:a}}}=this,l=this.legendHitBoxes=[],s=this.columnSizes=[],c=o-e;let u=a,d=0,f=0,h=0,m=0;return this.legendItems.forEach(((e,o)=>{const{itemWidth:p,itemHeight:v}=function(e,t,n,r,i){const o=function(e,t,n,r){let i=e.text;i&&"string"!=typeof i&&(i=i.reduce(((e,t)=>e.length>t.length?e:t)));return t+n.size/2+r.measureText(i).width}(r,e,t,n),a=function(e,t,n){let r=e;"string"!=typeof t.text&&(r=xj(t,n));return r}(i,r,t.lineHeight);return{itemWidth:o,itemHeight:a}}(n,t,i,e,r);o>0&&f+v+2*a>c&&(u+=d+a,s.push({width:d,height:f}),h+=d+a,m++,d=f=0),l[o]={left:h,top:f,col:m,width:p,height:v},d=Math.max(d,p),f+=v+a})),u+=d,s.push({width:d,height:f}),u}adjustHitBoxes(){if(!this.options.display)return;const e=this._computeTitleHeight(),{legendHitBoxes:t,options:{align:n,labels:{padding:r},rtl:i}}=this,o=Cb(i,this.left,this.width);if(this.isHorizontal()){let i=0,a=Eg(n,this.left+r,this.right-this.lineWidths[i]);for(const l of t)i!==l.row&&(i=l.row,a=Eg(n,this.left+r,this.right-this.lineWidths[i])),l.top+=this.top+e+r,l.left=o.leftForLtr(o.x(a),l.width),a+=l.width+r}else{let i=0,a=Eg(n,this.top+e+r,this.bottom-this.columnSizes[i].height);for(const l of t)l.col!==i&&(i=l.col,a=Eg(n,this.top+e+r,this.bottom-this.columnSizes[i].height)),l.top=a,l.left+=this.left+r,l.left=o.leftForLtr(o.x(l.left),l.width),a+=l.height+r}}isHorizontal(){return"top"===this.options.position||"bottom"===this.options.position}draw(){if(this.options.display){const e=this.ctx;Ay(e,this),this._draw(),Ly(e)}}_draw(){const{options:e,columnSizes:t,lineWidths:n,ctx:r}=this,{align:i,labels:o}=e,a=Ty.color,l=Cb(e.rtl,this.left,this.width),s=Yy(o.font),{padding:c}=o,u=s.size,d=u/2;let f;this.drawTitle(),r.textAlign=l.textAlign("left"),r.textBaseline="middle",r.lineWidth=.5,r.font=s.string;const{boxWidth:h,boxHeight:m,itemHeight:p}=yj(o,u),v=this.isHorizontal(),g=this._computeTitleHeight();f=v?{x:Eg(i,this.left+c,this.right-n[0]),y:this.top+c+g,line:0}:{x:this.left+c,y:Eg(i,this.top+g+c,this.bottom-t[0].height),line:0},Ab(this.ctx,e.textDirection);const y=p+c;this.legendItems.forEach(((b,x)=>{r.strokeStyle=b.fontColor,r.fillStyle=b.fontColor;const _=r.measureText(b.text).width,j=l.textAlign(b.textAlign||(b.textAlign=o.textAlign)),E=h+d+_;let O=f.x,T=f.y;l.setWidth(this.width),v?x>0&&O+E+c>this.right&&(T=f.y+=y,f.line++,O=f.x=Eg(i,this.left+c,this.right-n[f.line])):x>0&&T+y>this.bottom&&(O=f.x=O+t[f.line].width+c,f.line++,T=f.y=Eg(i,this.top+g+c,this.bottom-t[f.line].height));if(function(e,t,n){if(isNaN(h)||h<=0||isNaN(m)||m<0)return;r.save();const i=Sv(n.lineWidth,1);if(r.fillStyle=Sv(n.fillStyle,a),r.lineCap=Sv(n.lineCap,"butt"),r.lineDashOffset=Sv(n.lineDashOffset,0),r.lineJoin=Sv(n.lineJoin,"miter"),r.lineWidth=i,r.strokeStyle=Sv(n.strokeStyle,a),r.setLineDash(Sv(n.lineDash,[])),o.usePointStyle){const a={radius:m*Math.SQRT2/2,pointStyle:n.pointStyle,rotation:n.rotation,borderWidth:i},s=l.xPlus(e,h/2);Py(r,a,s,t+d,o.pointStyleWidth&&h)}else{const o=t+Math.max((u-m)/2,0),a=l.leftForLtr(e,h),s=Wy(n.borderRadius);r.beginPath(),Object.values(s).some((e=>0!==e))?Fy(r,{x:a,y:o,w:h,h:m,radius:s}):r.rect(a,o,h,m),r.fill(),0!==i&&r.stroke()}r.restore()}(l.x(O),T,b),O=((e,t,n,r)=>e===(r?"left":"right")?n:"center"===e?(t+n)/2:t)(j,O+h+d,v?O+E:this.right,e.rtl),function(e,t,n){ky(r,n.text,e,t+p/2,s,{strikethrough:n.hidden,textAlign:l.textAlign(n.textAlign)})}(l.x(O),T,b),v)f.x+=E+c;else if("string"!=typeof b.text){const e=s.lineHeight;f.y+=xj(b,e)}else f.y+=y})),Lb(this.ctx,e.textDirection)}drawTitle(){const e=this.options,t=e.title,n=Yy(t.font),r=zy(t.padding);if(!t.display)return;const i=Cb(e.rtl,this.left,this.width),o=this.ctx,a=t.position,l=n.size/2,s=r.top+l;let c,u=this.left,d=this.width;if(this.isHorizontal())d=Math.max(...this.lineWidths),c=this.top+s,u=Eg(e.align,u,this.right-d);else{const t=this.columnSizes.reduce(((e,t)=>Math.max(e,t.height)),0);c=s+Eg(e.align,this.top,this.bottom-t-e.labels.padding-this._computeTitleHeight())}const f=Eg(a,u,u+d);o.textAlign=i.textAlign(jg(a)),o.textBaseline="middle",o.strokeStyle=t.color,o.fillStyle=t.color,o.font=n.string,ky(o,t.text,f,c,n)}_computeTitleHeight(){const e=this.options.title,t=Yy(e.font),n=zy(e.padding);return e.display?t.lineHeight+n.height:0}_getLegendItemAt(e,t){let n,r,i;if(hg(e,this.left,this.right)&&hg(t,this.top,this.bottom))for(i=this.legendHitBoxes,n=0;n<i.length;++n)if(r=i[n],hg(e,r.left,r.left+r.width)&&hg(t,r.top,r.top+r.height))return this.legendItems[n];return null}handleEvent(e){const t=this.options;if(!function(e,t){if(("mousemove"===e||"mouseout"===e)&&(t.onHover||t.onLeave))return!0;if(t.onClick&&("click"===e||"mouseup"===e))return!0;return!1}(e.type,t))return;const n=this._getLegendItemAt(e.x,e.y);if("mousemove"===e.type||"mouseout"===e.type){const o=this._hoveredItem,a=(i=n,null!==(r=o)&&null!==i&&r.datasetIndex===i.datasetIndex&&r.index===i.index);o&&!a&&Nv(t.onLeave,[e,o,this],this),this._hoveredItem=n,n&&!a&&Nv(t.onHover,[e,n,this],this)}else n&&Nv(t.onClick,[e,n,this],this);var r,i}}function xj(e,t){return t*(e.text?e.text.length+.5:0)}var _j={id:"legend",_element:bj,start(e,t,n){const r=e.legend=new bj({ctx:e.ctx,options:n,chart:e});Rx.configure(e,r,n),Rx.addBox(e,r)},stop(e){Rx.removeBox(e,e.legend),delete e.legend},beforeUpdate(e,t,n){const r=e.legend;Rx.configure(e,r,n),r.options=n},afterUpdate(e){const t=e.legend;t.buildLabels(),t.adjustHitBoxes()},afterEvent(e,t){t.replay||e.legend.handleEvent(t.event)},defaults:{display:!0,position:"top",align:"center",fullSize:!0,reverse:!1,weight:1e3,onClick(e,t,n){const r=t.datasetIndex,i=n.chart;i.isDatasetVisible(r)?(i.hide(r),t.hidden=!0):(i.show(r),t.hidden=!1)},onHover:null,onLeave:null,labels:{color:e=>e.chart.options.color,boxWidth:40,padding:10,generateLabels(e){const t=e.data.datasets,{labels:{usePointStyle:n,pointStyle:r,textAlign:i,color:o,useBorderRadius:a,borderRadius:l}}=e.legend.options;return e._getSortedDatasetMetas().map((e=>{const s=e.controller.getStyle(n?0:void 0),c=zy(s.borderWidth);return{text:t[e.index].label,fillStyle:s.backgroundColor,fontColor:o,hidden:!e.visible,lineCap:s.borderCapStyle,lineDash:s.borderDash,lineDashOffset:s.borderDashOffset,lineJoin:s.borderJoinStyle,lineWidth:(c.width+c.height)/4,strokeStyle:s.borderColor,pointStyle:r||s.pointStyle,rotation:s.rotation,textAlign:i||s.textAlign,borderRadius:a&&(l||s.borderRadius),datasetIndex:e.index}}),this)}},title:{color:e=>e.chart.options.color,display:!1,position:"center",text:""}},descriptors:{_scriptable:e=>!e.startsWith("on"),labels:{_scriptable:e=>!["generateLabels","filter","sort"].includes(e)}}};new WeakMap;const jj={average(e){if(!e.length)return!1;let t,n,r=0,i=0,o=0;for(t=0,n=e.length;t<n;++t){const n=e[t].element;if(n&&n.hasValue()){const e=n.tooltipPosition();r+=e.x,i+=e.y,++o}}return{x:r/o,y:i/o}},nearest(e,t){if(!e.length)return!1;let n,r,i,o=t.x,a=t.y,l=Number.POSITIVE_INFINITY;for(n=0,r=e.length;n<r;++n){const r=e[n].element;if(r&&r.hasValue()){const e=sg(t,r.getCenterPoint());e<l&&(l=e,i=r)}}if(i){const e=i.tooltipPosition();o=e.x,a=e.y}return{x:o,y:a}}};function Ej(e,t){return t&&(Ev(t)?Array.prototype.push.apply(e,t):e.push(t)),e}function Oj(e){return("string"==typeof e||e instanceof String)&&e.indexOf("\n")>-1?e.split("\n"):e}function Tj(e,t){const{element:n,datasetIndex:r,index:i}=t,o=e.getDatasetMeta(r).controller,{label:a,value:l}=o.getLabelAndValue(i);return{chart:e,label:a,parsed:o.getParsed(i),raw:e.data.datasets[r].data[i],formattedValue:l,dataset:o.getDataset(),dataIndex:i,datasetIndex:r,element:n}}function Ij(e,t){const n=e.chart.ctx,{body:r,footer:i,title:o}=e,{boxWidth:a,boxHeight:l}=t,s=Yy(t.bodyFont),c=Yy(t.titleFont),u=Yy(t.footerFont),d=o.length,f=i.length,h=r.length,m=zy(t.padding);let p=m.height,v=0,g=r.reduce(((e,t)=>e+t.before.length+t.lines.length+t.after.length),0);if(g+=e.beforeBody.length+e.afterBody.length,d&&(p+=d*c.lineHeight+(d-1)*t.titleSpacing+t.titleMarginBottom),g){p+=h*(t.displayColors?Math.max(l,s.lineHeight):s.lineHeight)+(g-h)*s.lineHeight+(g-1)*t.bodySpacing}f&&(p+=t.footerMarginTop+f*u.lineHeight+(f-1)*t.footerSpacing);let y=0;const b=function(e){v=Math.max(v,n.measureText(e).width+y)};return n.save(),n.font=c.string,Pv(e.title,b),n.font=s.string,Pv(e.beforeBody.concat(e.afterBody),b),y=t.displayColors?a+2+t.boxPadding:0,Pv(r,(e=>{Pv(e.before,b),Pv(e.lines,b),Pv(e.after,b)})),y=0,n.font=u.string,Pv(e.footer,b),n.restore(),v+=m.width,{width:v,height:p}}function Sj(e,t,n,r){const{x:i,width:o}=n,{width:a,chartArea:{left:l,right:s}}=e;let c="center";return"center"===r?c=i<=(l+s)/2?"left":"right":i<=o/2?c="left":i>=a-o/2&&(c="right"),function(e,t,n,r){const{x:i,width:o}=r,a=n.caretSize+n.caretPadding;return"left"===e&&i+o+a>t.width||"right"===e&&i-o-a<0||void 0}(c,e,t,n)&&(c="center"),c}function wj(e,t,n){const r=n.yAlign||t.yAlign||function(e,t){const{y:n,height:r}=t;return n<r/2?"top":n>e.height-r/2?"bottom":"center"}(e,n);return{xAlign:n.xAlign||t.xAlign||Sj(e,t,n,r),yAlign:r}}function Nj(e,t,n,r){const{caretSize:i,caretPadding:o,cornerRadius:a}=e,{xAlign:l,yAlign:s}=n,c=i+o,{topLeft:u,topRight:d,bottomLeft:f,bottomRight:h}=Wy(a);let m=function(e,t){let{x:n,width:r}=e;return"right"===t?n-=r:"center"===t&&(n-=r/2),n}(t,l);const p=function(e,t,n){let{y:r,height:i}=e;return"top"===t?r+=n:r-="bottom"===t?i+n:i/2,r}(t,s,c);return"center"===s?"left"===l?m+=c:"right"===l&&(m-=c):"left"===l?m-=Math.max(u,f)+i:"right"===l&&(m+=Math.max(d,h)+i),{x:fg(m,0,r.width-t.width),y:fg(p,0,r.height-t.height)}}function Pj(e,t,n){const r=zy(n.padding);return"center"===t?e.x+e.width/2:"right"===t?e.x+e.width-r.right:e.x+r.left}function Cj(e){return Ej([],Oj(e))}function Aj(e,t){const n=t&&t.dataset&&t.dataset.tooltip&&t.dataset.tooltip.callbacks;return n?e.override(n):e}const Lj={beforeTitle:xv,title(e){if(e.length>0){const t=e[0],n=t.chart.data.labels,r=n?n.length:0;if(this&&this.options&&"dataset"===this.options.mode)return t.dataset.label||"";if(t.label)return t.label;if(r>0&&t.dataIndex<r)return n[t.dataIndex]}return""},afterTitle:xv,beforeBody:xv,beforeLabel:xv,label(e){if(this&&this.options&&"dataset"===this.options.mode)return e.label+": "+e.formattedValue||e.formattedValue;let t=e.dataset.label||"";t&&(t+=": ");const n=e.formattedValue;return jv(n)||(t+=n),t},labelColor(e){const t=e.chart.getDatasetMeta(e.datasetIndex).controller.getStyle(e.dataIndex);return{borderColor:t.borderColor,backgroundColor:t.backgroundColor,borderWidth:t.borderWidth,borderDash:t.borderDash,borderDashOffset:t.borderDashOffset,borderRadius:0}},labelTextColor(){return this.options.bodyColor},labelPointStyle(e){const t=e.chart.getDatasetMeta(e.datasetIndex).controller.getStyle(e.dataIndex);return{pointStyle:t.pointStyle,rotation:t.rotation}},afterLabel:xv,afterBody:xv,beforeFooter:xv,footer:xv,afterFooter:xv};function Mj(e,t,n,r){const i=e[t].call(n,r);return void 0===i?Lj[t].call(n,r):i}class Rj extends Zx{static positioners=jj;constructor(e){super(),this.opacity=0,this._active=[],this._eventPosition=void 0,this._size=void 0,this._cachedAnimations=void 0,this._tooltipItems=[],this.$animations=void 0,this.$context=void 0,this.chart=e.chart,this.options=e.options,this.dataPoints=void 0,this.title=void 0,this.beforeBody=void 0,this.body=void 0,this.afterBody=void 0,this.footer=void 0,this.xAlign=void 0,this.yAlign=void 0,this.x=void 0,this.y=void 0,this.height=void 0,this.width=void 0,this.caretX=void 0,this.caretY=void 0,this.labelColors=void 0,this.labelPointStyles=void 0,this.labelTextColors=void 0}initialize(e){this.options=e,this._cachedAnimations=void 0,this.$context=void 0}_resolveAnimations(){const e=this._cachedAnimations;if(e)return e;const t=this.chart,n=this.options.setContext(this.getContext()),r=n.enabled&&t.options.animation&&n.animations,i=new zb(this.chart,r);return r._cacheable&&(this._cachedAnimations=Object.freeze(i)),i}getContext(){return this.$context||(this.$context=(e=this.chart.getContext(),t=this,n=this._tooltipItems,qy(e,{tooltip:t,tooltipItems:n,type:"tooltip"})));var e,t,n}getTitle(e,t){const{callbacks:n}=t,r=Mj(n,"beforeTitle",this,e),i=Mj(n,"title",this,e),o=Mj(n,"afterTitle",this,e);let a=[];return a=Ej(a,Oj(r)),a=Ej(a,Oj(i)),a=Ej(a,Oj(o)),a}getBeforeBody(e,t){return Cj(Mj(t.callbacks,"beforeBody",this,e))}getBody(e,t){const{callbacks:n}=t,r=[];return Pv(e,(e=>{const t={before:[],lines:[],after:[]},i=Aj(n,e);Ej(t.before,Oj(Mj(i,"beforeLabel",this,e))),Ej(t.lines,Mj(i,"label",this,e)),Ej(t.after,Oj(Mj(i,"afterLabel",this,e))),r.push(t)})),r}getAfterBody(e,t){return Cj(Mj(t.callbacks,"afterBody",this,e))}getFooter(e,t){const{callbacks:n}=t,r=Mj(n,"beforeFooter",this,e),i=Mj(n,"footer",this,e),o=Mj(n,"afterFooter",this,e);let a=[];return a=Ej(a,Oj(r)),a=Ej(a,Oj(i)),a=Ej(a,Oj(o)),a}_createItems(e){const t=this._active,n=this.chart.data,r=[],i=[],o=[];let a,l,s=[];for(a=0,l=t.length;a<l;++a)s.push(Tj(this.chart,t[a]));return e.filter&&(s=s.filter(((t,r,i)=>e.filter(t,r,i,n)))),e.itemSort&&(s=s.sort(((t,r)=>e.itemSort(t,r,n)))),Pv(s,(t=>{const n=Aj(e.callbacks,t);r.push(Mj(n,"labelColor",this,t)),i.push(Mj(n,"labelPointStyle",this,t)),o.push(Mj(n,"labelTextColor",this,t))})),this.labelColors=r,this.labelPointStyles=i,this.labelTextColors=o,this.dataPoints=s,s}update(e,t){const n=this.options.setContext(this.getContext()),r=this._active;let i,o=[];if(r.length){const e=jj[n.position].call(this,r,this._eventPosition);o=this._createItems(n),this.title=this.getTitle(o,n),this.beforeBody=this.getBeforeBody(o,n),this.body=this.getBody(o,n),this.afterBody=this.getAfterBody(o,n),this.footer=this.getFooter(o,n);const t=this._size=Ij(this,n),a=Object.assign({},e,t),l=wj(this.chart,n,a),s=Nj(n,a,l,this.chart);this.xAlign=l.xAlign,this.yAlign=l.yAlign,i={opacity:1,x:s.x,y:s.y,width:t.width,height:t.height,caretX:e.x,caretY:e.y}}else 0!==this.opacity&&(i={opacity:0});this._tooltipItems=o,this.$context=void 0,i&&this._resolveAnimations().update(this,i),e&&n.external&&n.external.call(this,{chart:this.chart,tooltip:this,replay:t})}drawCaret(e,t,n,r){const i=this.getCaretPosition(e,n,r);t.lineTo(i.x1,i.y1),t.lineTo(i.x2,i.y2),t.lineTo(i.x3,i.y3)}getCaretPosition(e,t,n){const{xAlign:r,yAlign:i}=this,{caretSize:o,cornerRadius:a}=n,{topLeft:l,topRight:s,bottomLeft:c,bottomRight:u}=Wy(a),{x:d,y:f}=e,{width:h,height:m}=t;let p,v,g,y,b,x;return"center"===i?(b=f+m/2,"left"===r?(p=d,v=p-o,y=b+o,x=b-o):(p=d+h,v=p+o,y=b-o,x=b+o),g=p):(v="left"===r?d+Math.max(l,c)+o:"right"===r?d+h-Math.max(s,u)-o:this.caretX,"top"===i?(y=f,b=y-o,p=v-o,g=v+o):(y=f+m,b=y+o,p=v+o,g=v-o),x=y),{x1:p,x2:v,x3:g,y1:y,y2:b,y3:x}}drawTitle(e,t,n){const r=this.title,i=r.length;let o,a,l;if(i){const s=Cb(n.rtl,this.x,this.width);for(e.x=Pj(this,n.titleAlign,n),t.textAlign=s.textAlign(n.titleAlign),t.textBaseline="middle",o=Yy(n.titleFont),a=n.titleSpacing,t.fillStyle=n.titleColor,t.font=o.string,l=0;l<i;++l)t.fillText(r[l],s.x(e.x),e.y+o.lineHeight/2),e.y+=o.lineHeight+a,l+1===i&&(e.y+=n.titleMarginBottom-a)}}_drawColorBox(e,t,n,r,i){const o=this.labelColors[n],a=this.labelPointStyles[n],{boxHeight:l,boxWidth:s,boxPadding:c}=i,u=Yy(i.bodyFont),d=Pj(this,"left",i),f=r.x(d),h=l<u.lineHeight?(u.lineHeight-l)/2:0,m=t.y+h;if(i.usePointStyle){const t={radius:Math.min(s,l)/2,pointStyle:a.pointStyle,rotation:a.rotation,borderWidth:1},n=r.leftForLtr(f,s)+s/2,c=m+l/2;e.strokeStyle=i.multiKeyBackground,e.fillStyle=i.multiKeyBackground,Ny(e,t,n,c),e.strokeStyle=o.borderColor,e.fillStyle=o.backgroundColor,Ny(e,t,n,c)}else{e.lineWidth=Ov(o.borderWidth)?Math.max(...Object.values(o.borderWidth)):o.borderWidth||1,e.strokeStyle=o.borderColor,e.setLineDash(o.borderDash||[]),e.lineDashOffset=o.borderDashOffset||0;const t=r.leftForLtr(f,s-c),n=r.leftForLtr(r.xPlus(f,1),s-c-2),a=Wy(o.borderRadius);Object.values(a).some((e=>0!==e))?(e.beginPath(),e.fillStyle=i.multiKeyBackground,Fy(e,{x:t,y:m,w:s,h:l,radius:a}),e.fill(),e.stroke(),e.fillStyle=o.backgroundColor,e.beginPath(),Fy(e,{x:n,y:m+1,w:s-2,h:l-2,radius:a}),e.fill()):(e.fillStyle=i.multiKeyBackground,e.fillRect(t,m,s,l),e.strokeRect(t,m,s,l),e.fillStyle=o.backgroundColor,e.fillRect(n,m+1,s-2,l-2))}e.fillStyle=this.labelTextColors[n]}drawBody(e,t,n){const{body:r}=this,{bodySpacing:i,bodyAlign:o,displayColors:a,boxHeight:l,boxWidth:s,boxPadding:c}=n,u=Yy(n.bodyFont);let d=u.lineHeight,f=0;const h=Cb(n.rtl,this.x,this.width),m=function(n){t.fillText(n,h.x(e.x+f),e.y+d/2),e.y+=d+i},p=h.textAlign(o);let v,g,y,b,x,_,j;for(t.textAlign=o,t.textBaseline="middle",t.font=u.string,e.x=Pj(this,p,n),t.fillStyle=n.bodyColor,Pv(this.beforeBody,m),f=a&&"right"!==p?"center"===o?s/2+c:s+2+c:0,b=0,_=r.length;b<_;++b){for(v=r[b],g=this.labelTextColors[b],t.fillStyle=g,Pv(v.before,m),y=v.lines,a&&y.length&&(this._drawColorBox(t,e,b,h,n),d=Math.max(u.lineHeight,l)),x=0,j=y.length;x<j;++x)m(y[x]),d=u.lineHeight;Pv(v.after,m)}f=0,d=u.lineHeight,Pv(this.afterBody,m),e.y-=i}drawFooter(e,t,n){const r=this.footer,i=r.length;let o,a;if(i){const l=Cb(n.rtl,this.x,this.width);for(e.x=Pj(this,n.footerAlign,n),e.y+=n.footerMarginTop,t.textAlign=l.textAlign(n.footerAlign),t.textBaseline="middle",o=Yy(n.footerFont),t.fillStyle=n.footerColor,t.font=o.string,a=0;a<i;++a)t.fillText(r[a],l.x(e.x),e.y+o.lineHeight/2),e.y+=o.lineHeight+n.footerSpacing}}drawBackground(e,t,n,r){const{xAlign:i,yAlign:o}=this,{x:a,y:l}=e,{width:s,height:c}=n,{topLeft:u,topRight:d,bottomLeft:f,bottomRight:h}=Wy(r.cornerRadius);t.fillStyle=r.backgroundColor,t.strokeStyle=r.borderColor,t.lineWidth=r.borderWidth,t.beginPath(),t.moveTo(a+u,l),"top"===o&&this.drawCaret(e,t,n,r),t.lineTo(a+s-d,l),t.quadraticCurveTo(a+s,l,a+s,l+d),"center"===o&&"right"===i&&this.drawCaret(e,t,n,r),t.lineTo(a+s,l+c-h),t.quadraticCurveTo(a+s,l+c,a+s-h,l+c),"bottom"===o&&this.drawCaret(e,t,n,r),t.lineTo(a+f,l+c),t.quadraticCurveTo(a,l+c,a,l+c-f),"center"===o&&"left"===i&&this.drawCaret(e,t,n,r),t.lineTo(a,l+u),t.quadraticCurveTo(a,l,a+u,l),t.closePath(),t.fill(),r.borderWidth>0&&t.stroke()}_updateAnimationTarget(e){const t=this.chart,n=this.$animations,r=n&&n.x,i=n&&n.y;if(r||i){const n=jj[e.position].call(this,this._active,this._eventPosition);if(!n)return;const o=this._size=Ij(this,e),a=Object.assign({},n,this._size),l=wj(t,e,a),s=Nj(e,a,l,t);r._to===s.x&&i._to===s.y||(this.xAlign=l.xAlign,this.yAlign=l.yAlign,this.width=o.width,this.height=o.height,this.caretX=n.x,this.caretY=n.y,this._resolveAnimations().update(this,s))}}_willRender(){return!!this.opacity}draw(e){const t=this.options.setContext(this.getContext());let n=this.opacity;if(!n)return;this._updateAnimationTarget(t);const r={width:this.width,height:this.height},i={x:this.x,y:this.y};n=Math.abs(n)<.001?0:n;const o=zy(t.padding),a=this.title.length||this.beforeBody.length||this.body.length||this.afterBody.length||this.footer.length;t.enabled&&a&&(e.save(),e.globalAlpha=n,this.drawBackground(i,e,r,t),Ab(e,t.textDirection),i.y+=o.top,this.drawTitle(i,e,t),this.drawBody(i,e,t),this.drawFooter(i,e,t),Lb(e,t.textDirection),e.restore())}getActiveElements(){return this._active||[]}setActiveElements(e,t){const n=this._active,r=e.map((({datasetIndex:e,index:t})=>{const n=this.chart.getDatasetMeta(e);if(!n)throw new Error("Cannot find a dataset at index "+e);return{datasetIndex:e,element:n.data[t],index:t}})),i=!Cv(n,r),o=this._positionChanged(r,t);(i||o)&&(this._active=r,this._eventPosition=t,this._ignoreReplayEvents=!0,this.update(!0))}handleEvent(e,t,n=!0){if(t&&this._ignoreReplayEvents)return!1;this._ignoreReplayEvents=!1;const r=this.options,i=this._active||[],o=this._getActiveElements(e,i,t,n),a=this._positionChanged(o,e),l=t||!Cv(o,i)||a;return l&&(this._active=o,(r.enabled||r.external)&&(this._eventPosition={x:e.x,y:e.y},this.update(!0,t))),l}_getActiveElements(e,t,n,r){const i=this.options;if("mouseout"===e.type)return[];if(!r)return t;const o=this.chart.getElementsAtEventForMode(e,i.mode,i,n);return i.reverse&&o.reverse(),o}_positionChanged(e,t){const{caretX:n,caretY:r,options:i}=this,o=jj[i.position].call(this,e,t);return!1!==o&&(n!==o.x||r!==o.y)}}var kj={id:"tooltip",_element:Rj,positioners:jj,afterInit(e,t,n){n&&(e.tooltip=new Rj({chart:e,options:n}))},beforeUpdate(e,t,n){e.tooltip&&e.tooltip.initialize(n)},reset(e,t,n){e.tooltip&&e.tooltip.initialize(n)},afterDraw(e){const t=e.tooltip;if(t&&t._willRender()){const n={tooltip:t};if(!1===e.notifyPlugins("beforeTooltipDraw",{...n,cancelable:!0}))return;t.draw(e.ctx),e.notifyPlugins("afterTooltipDraw",n)}},afterEvent(e,t){if(e.tooltip){const n=t.replay;e.tooltip.handleEvent(t.event,n,t.inChartArea)&&(t.changed=!0)}},defaults:{enabled:!0,external:null,position:"average",backgroundColor:"rgba(0,0,0,0.8)",titleColor:"#fff",titleFont:{weight:"bold"},titleSpacing:2,titleMarginBottom:6,titleAlign:"left",bodyColor:"#fff",bodySpacing:2,bodyFont:{},bodyAlign:"left",footerColor:"#fff",footerSpacing:2,footerMarginTop:6,footerFont:{weight:"bold"},footerAlign:"left",padding:6,caretPadding:2,caretSize:5,cornerRadius:6,boxHeight:(e,t)=>t.bodyFont.size,boxWidth:(e,t)=>t.bodyFont.size,multiKeyBackground:"#fff",displayColors:!0,boxPadding:0,borderColor:"rgba(0,0,0,0)",borderWidth:0,animation:{duration:400,easing:"easeOutQuart"},animations:{numbers:{type:"number",properties:["x","y","width","height","caretX","caretY"]},opacity:{easing:"linear",duration:200}},callbacks:Lj},defaultRoutes:{bodyFont:"font",footerFont:"font",titleFont:"font"},descriptors:{_scriptable:e=>"filter"!==e&&"itemSort"!==e&&"external"!==e,_indexable:!1,callbacks:{_scriptable:!1,_indexable:!1},animation:{_fallback:!1},animations:{_fallback:"animation"}},additionalOptionScopes:["interaction"]};function Dj(e,t,n,r){const i=e.indexOf(t);if(-1===i)return((e,t,n,r)=>("string"==typeof t?(n=e.push(t)-1,r.unshift({index:n,label:t})):isNaN(t)&&(n=null),n))(e,t,n,r);return i!==e.lastIndexOf(t)?n:i}function Uj(e){const t=this.getLabels();return e>=0&&e<t.length?t[e]:e}class Fj extends l_{static id="category";static defaults={ticks:{callback:Uj}};constructor(e){super(e),this._startValue=void 0,this._valueRange=0,this._addedLabels=[]}init(e){const t=this._addedLabels;if(t.length){const e=this.getLabels();for(const{index:n,label:r}of t)e[n]===r&&e.splice(n,1);this._addedLabels=[]}super.init(e)}parse(e,t){if(jv(e))return null;const n=this.getLabels();return((e,t)=>null===e?null:fg(Math.round(e),0,t))(t=isFinite(t)&&n[t]===e?t:Dj(n,e,Sv(t,e),this._addedLabels),n.length-1)}determineDataLimits(){const{minDefined:e,maxDefined:t}=this.getUserBounds();let{min:n,max:r}=this.getMinMax(!0);"ticks"===this.options.bounds&&(e||(n=0),t||(r=this.getLabels().length-1)),this.min=n,this.max=r}buildTicks(){const e=this.min,t=this.max,n=this.options.offset,r=[];let i=this.getLabels();i=0===e&&t===i.length-1?i:i.slice(e,t+1),this._valueRange=Math.max(i.length-(n?0:1),1),this._startValue=this.min-(n?.5:0);for(let n=e;n<=t;n++)r.push({value:n});return r}getLabelForValue(e){return Uj.call(this,e)}configure(){super.configure(),this.isHorizontal()||(this._reversePixels=!this._reversePixels)}getPixelForValue(e){return"number"!=typeof e&&(e=this.parse(e)),null===e?NaN:this.getPixelForDecimal((e-this._startValue)/this._valueRange)}getPixelForTick(e){const t=this.ticks;return e<0||e>t.length-1?null:this.getPixelForValue(t[e].value)}getValueForPixel(e){return Math.round(this._startValue+this.getDecimalForPixel(e)*this._valueRange)}getBasePixel(){return this.bottom}}function Gj(e,t){const n=[],{bounds:r,step:i,min:o,max:a,precision:l,count:s,maxTicks:c,maxDigits:u,includeBounds:d}=e,f=i||1,h=c-1,{min:m,max:p}=t,v=!jv(o),g=!jv(a),y=!jv(s),b=(p-m)/(u+1);let x,_,j,E,O=tg((p-m)/h/f)*f;if(O<1e-14&&!v&&!g)return[{value:m},{value:p}];E=Math.ceil(p/O)-Math.floor(m/O),E>h&&(O=tg(E*O/h/f)*f),jv(l)||(x=Math.pow(10,l),O=Math.ceil(O*x)/x),"ticks"===r?(_=Math.floor(m/O)*O,j=Math.ceil(p/O)*O):(_=m,j=p),v&&g&&i&&function(e,t){const n=Math.round(e);return n-t<=e&&n+t>=e}((a-o)/i,O/1e3)?(E=Math.round(Math.min((a-o)/O,c)),O=(a-o)/E,_=o,j=a):y?(_=v?o:_,j=g?a:j,E=s-1,O=(j-_)/E):(E=(j-_)/O,E=eg(E,Math.round(E),O/1e3)?Math.round(E):Math.ceil(E));const T=Math.max(ag(O),ag(_));x=Math.pow(10,jv(l)?T:l),_=Math.round(_*x)/x,j=Math.round(j*x)/x;let I=0;for(v&&(d&&_!==o?(n.push({value:o}),_<o&&I++,eg(Math.round((_+I*O)*x)/x,o,Vj(o,b,e))&&I++):_<o&&I++);I<E;++I)n.push({value:Math.round((_+I*O)*x)/x});return g&&d&&j!==a?n.length&&eg(n[n.length-1].value,a,Vj(a,b,e))?n[n.length-1].value=a:n.push({value:a}):g&&j!==a||n.push({value:j}),n}function Vj(e,t,{horizontal:n,minRotation:r}){const i=ig(r),o=(n?Math.sin(i):Math.cos(i))||.001,a=.75*t*(""+e).length;return Math.min(t/o,a)}class Bj extends l_{constructor(e){super(e),this.start=void 0,this.end=void 0,this._startValue=void 0,this._endValue=void 0,this._valueRange=0}parse(e,t){return jv(e)||("number"==typeof e||e instanceof Number)&&!isFinite(+e)?null:+e}handleTickRangeOptions(){const{beginAtZero:e}=this.options,{minDefined:t,maxDefined:n}=this.getUserBounds();let{min:r,max:i}=this;const o=e=>r=t?r:e,a=e=>i=n?i:e;if(e){const e=Jv(r),t=Jv(i);e<0&&t<0?a(0):e>0&&t>0&&o(0)}if(r===i){let t=0===i?1:Math.abs(.05*i);a(i+t),e||o(r-t)}this.min=r,this.max=i}getTickLimit(){const e=this.options.ticks;let t,{maxTicksLimit:n,stepSize:r}=e;return r?(t=Math.ceil(this.max/r)-Math.floor(this.min/r)+1,t>1e3&&(console.warn(`scales.${this.id}.ticks.stepSize: ${r} would result generating up to ${t} ticks. Limiting to 1000.`),t=1e3)):(t=this.computeTickLimit(),n=n||11),n&&(t=Math.min(n,t)),t}computeTickLimit(){return Number.POSITIVE_INFINITY}buildTicks(){const e=this.options,t=e.ticks;let n=this.getTickLimit();n=Math.max(2,n);const r=Gj({maxTicks:n,bounds:e.bounds,min:e.min,max:e.max,precision:t.precision,step:t.stepSize,count:t.count,maxDigits:this._maxDigits(),horizontal:this.isHorizontal(),minRotation:t.minRotation||0,includeBounds:!1!==t.includeBounds},this._range||this);return"ticks"===e.bounds&&rg(r,this,"value"),e.reverse?(r.reverse(),this.start=this.max,this.end=this.min):(this.start=this.min,this.end=this.max),r}configure(){const e=this.ticks;let t=this.min,n=this.max;if(super.configure(),this.options.offset&&e.length){const r=(n-t)/Math.max(e.length-1,1)/2;t-=r,n+=r}this._startValue=t,this._endValue=n,this._valueRange=n-t}getLabelForValue(e){return gy(e,this.chart.options.locale,this.options.ticks.format)}}class Hj extends Bj{static id="linear";static defaults={ticks:{callback:by.formatters.numeric}};determineDataLimits(){const{min:e,max:t}=this.getMinMax(!0);this.min=Tv(e)?e:0,this.max=Tv(t)?t:1,this.handleTickRangeOptions()}computeTickLimit(){const e=this.isHorizontal(),t=e?this.width:this.height,n=ig(this.options.ticks.minRotation),r=(e?Math.sin(n):Math.cos(n))||.001,i=this._resolveTickFontOptions(0);return Math.ceil(t/Math.min(40,i.lineHeight/r))}getPixelForValue(e){return null===e?NaN:this.getPixelForDecimal((e-this._startValue)/this._valueRange)}getValueForPixel(e){return this._startValue+this.getDecimalForPixel(e)*this._valueRange}}class Kj extends l_{static id="logarithmic";static defaults={ticks:{callback:by.formatters.logarithmic,major:{enabled:!0}}};constructor(e){super(e),this.start=void 0,this.end=void 0,this._startValue=void 0,this._valueRange=0}parse(e,t){const n=Bj.prototype.parse.apply(this,[e,t]);if(0!==n)return Tv(n)&&n>0?n:null;this._zero=!0}determineDataLimits(){const{min:e,max:t}=this.getMinMax(!0);this.min=Tv(e)?Math.max(0,e):null,this.max=Tv(t)?Math.max(0,t):null,this.options.beginAtZero&&(this._zero=!0),this._zero&&this.min!==this._suggestedMin&&!Tv(this._userMin)&&(this.min=e===changeExponent(this.min,0)?changeExponent(this.min,-1):changeExponent(this.min,0)),this.handleTickRangeOptions()}handleTickRangeOptions(){const{minDefined:e,maxDefined:t}=this.getUserBounds();let n=this.min,r=this.max;const i=t=>e?n:t,o=e=>t?r:e;n===r&&(n<=0?(i(1),o(10)):(i(changeExponent(n,-1)),o(changeExponent(r,1)))),n<=0&&i(changeExponent(r,-1)),r<=0&&o(changeExponent(n,1)),this.min=n,this.max=r}buildTicks(){const e=this.options,t=generateTicks({min:this._userMin,max:this._userMax},this);return"ticks"===e.bounds&&rg(t,this,"value"),e.reverse?(t.reverse(),this.start=this.max,this.end=this.min):(this.start=this.min,this.end=this.max),t}getLabelForValue(e){return void 0===e?"0":gy(e,this.chart.options.locale,this.options.ticks.format)}configure(){const e=this.min;super.configure(),this._startValue=Zv(e),this._valueRange=Zv(this.max)-Zv(e)}getPixelForValue(e){return void 0!==e&&0!==e||this.min,null===e||isNaN(e)?NaN:this.getPixelForDecimal(e===this.min?0:(Zv(e)-this._startValue)/this._valueRange)}getValueForPixel(e){const t=this.getDecimalForPixel(e);return Math.pow(10,this._startValue+t*this._valueRange)}}class Wj extends Bj{static id="radialLinear";static defaults={display:!0,animate:!0,position:"chartArea",angleLines:{display:!0,lineWidth:1,borderDash:[],borderDashOffset:0},grid:{circular:!1},startAngle:0,ticks:{showLabelBackdrop:!0,callback:by.formatters.numeric},pointLabels:{backdropColor:void 0,backdropPadding:2,display:!0,font:{size:10},callback:e=>e,padding:5,centerPointLabels:!1}};static defaultRoutes={"angleLines.color":"borderColor","pointLabels.color":"color","ticks.color":"color"};static descriptors={angleLines:{_fallback:"grid"}};constructor(e){super(e),this.xCenter=void 0,this.yCenter=void 0,this.drawingArea=void 0,this._pointLabels=[],this._pointLabelItems=[]}setDimensions(){const e=this._padding=zy(getTickBackdropHeight(this.options)/2),t=this.width=this.maxWidth-e.width,n=this.height=this.maxHeight-e.height;this.xCenter=Math.floor(this.left+t/2+e.left),this.yCenter=Math.floor(this.top+n/2+e.top),this.drawingArea=Math.floor(Math.min(t,n)/2)}determineDataLimits(){const{min:e,max:t}=this.getMinMax(!1);this.min=Tv(e)&&!isNaN(e)?e:0,this.max=Tv(t)&&!isNaN(t)?t:0,this.handleTickRangeOptions()}computeTickLimit(){return Math.ceil(this.drawingArea/getTickBackdropHeight(this.options))}generateTickLabels(e){Bj.prototype.generateTickLabels.call(this,e),this._pointLabels=this.getLabels().map(((e,t)=>{const n=Nv(this.options.pointLabels.callback,[e,t],this);return n||0===n?n:""})).filter(((e,t)=>this.chart.getDataVisibility(t)))}fit(){const e=this.options;e.display&&e.pointLabels.display?fitWithPointLabels(this):this.setCenterPoint(0,0,0,0)}setCenterPoint(e,t,n,r){this.xCenter+=Math.floor((e-t)/2),this.yCenter+=Math.floor((n-r)/2),this.drawingArea-=Math.min(this.drawingArea/2,Math.max(e,t,n,r))}getIndexAngle(e){return ug(e*(Wv/(this._pointLabels.length||1))+ig(this.options.startAngle||0))}getDistanceFromCenterForValue(e){if(jv(e))return NaN;const t=this.drawingArea/(this.max-this.min);return this.options.reverse?(this.max-e)*t:(e-this.min)*t}getValueForDistanceFromCenter(e){if(jv(e))return NaN;const t=e/(this.drawingArea/(this.max-this.min));return this.options.reverse?this.max-t:this.min+t}getPointLabelContext(e){const t=this._pointLabels||[];if(e>=0&&e<t.length){const n=t[e];return function(e,t,n){return qy(e,{label:n,index:t,type:"pointLabel"})}(this.getContext(),e,n)}}getPointPosition(e,t,n=0){const r=this.getIndexAngle(e)-qv+n;return{x:Math.cos(r)*t+this.xCenter,y:Math.sin(r)*t+this.yCenter,angle:r}}getPointPositionForValue(e,t){return this.getPointPosition(e,this.getDistanceFromCenterForValue(t))}getBasePosition(e){return this.getPointPositionForValue(e||0,this.getBaseValue())}getPointLabelPosition(e){const{left:t,top:n,right:r,bottom:i}=this._pointLabelItems[e];return{left:t,top:n,right:r,bottom:i}}drawBackground(){const{backgroundColor:e,grid:{circular:t}}=this.options;if(e){const n=this.ctx;n.save(),n.beginPath(),pathRadiusLine(this,this.getDistanceFromCenterForValue(this._endValue),t,this._pointLabels.length),n.closePath(),n.fillStyle=e,n.fill(),n.restore()}}drawGrid(){const e=this.ctx,t=this.options,{angleLines:n,grid:r,border:i}=t,o=this._pointLabels.length;let a,l,s;if(t.pointLabels.display&&function(e,t){const{ctx:n,options:{pointLabels:r}}=e;for(let i=t-1;i>=0;i--){const t=r.setContext(e.getPointLabelContext(i)),o=Yy(t.font),{x:a,y:l,textAlign:s,left:c,top:u,right:d,bottom:f}=e._pointLabelItems[i],{backdropColor:h}=t;if(!jv(h)){const e=Wy(t.borderRadius),r=zy(t.backdropPadding);n.fillStyle=h;const i=c-r.left,o=u-r.top,a=d-c+r.width,l=f-u+r.height;Object.values(e).some((e=>0!==e))?(n.beginPath(),Fy(n,{x:i,y:o,w:a,h:l,radius:e}),n.fill()):n.fillRect(i,o,a,l)}ky(n,e._pointLabels[i],a,l+o.lineHeight/2,o,{color:t.color,textAlign:s,textBaseline:"middle"})}}(this,o),r.display&&this.ticks.forEach(((e,t)=>{if(0!==t){this.getDistanceFromCenterForValue(e.value);const n=this.getContext(t),a=r.setContext(n),s=i.setContext(n);!function(e,t,n,r,i){const o=e.ctx,a=t.circular,{color:l,lineWidth:s}=t;!a&&!r||!l||!s||n<0||(o.save(),o.strokeStyle=l,o.lineWidth=s,o.setLineDash(i.dash),o.lineDashOffset=i.dashOffset,o.beginPath(),pathRadiusLine(e,n,a,r),o.closePath(),o.stroke(),o.restore())}(this,a,l,o,s)}})),n.display){for(e.save(),o-1;a>=0;a--){const r=n.setContext(this.getPointLabelContext(a)),{color:i,lineWidth:o}=r;o&&i&&(e.lineWidth=o,e.strokeStyle=i,e.setLineDash(r.borderDash),e.lineDashOffset=r.borderDashOffset,this.getDistanceFromCenterForValue(t.ticks.reverse?this.min:this.max),this.getPointPosition(a,l),e.beginPath(),e.moveTo(this.xCenter,this.yCenter),e.lineTo(s.x,s.y),e.stroke())}e.restore()}}drawBorder(){}drawLabels(){const e=this.ctx,t=this.options,n=t.ticks;if(!n.display)return;const r=this.getIndexAngle(0);let i,o;e.save(),e.translate(this.xCenter,this.yCenter),e.rotate(r),e.textAlign="center",e.textBaseline="middle",this.ticks.forEach(((r,a)=>{if(0===a&&!t.reverse)return;const l=n.setContext(this.getContext(a)),s=Yy(l.font);if(this.getDistanceFromCenterForValue(this.ticks[a].value),l.showLabelBackdrop){e.font=s.string,e.measureText(r.label).width,e.fillStyle=l.backdropColor;const t=zy(l.backdropPadding);e.fillRect(-o/2-t.left,-i-s.size/2-t.top,o+t.width,s.size+t.height)}ky(e,r.label,0,-i,s,{color:l.color})})),e.restore()}drawTitle(){}}function zj(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Yj(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Xj(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Yj(e,t,n[t])}))}return e}function qj(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function $j(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Qj(e){return function(e){if(Array.isArray(e))return zj(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return zj(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zj(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Zj(t){var n,r=t.type,o=t.data,a=t.options,l=t.mergeCallback,s=void 0===l?eE:l,c=$j(t,["type","data","options","mergeCallback"]),u=(0,i.useRef)(null),d=(0,i.useRef)(null),f=(0,i.useRef)(null),h=null!==(n=Fd(f))&&void 0!==n?n:ct,m=h.x>0&&h.y>0,p=qd(),v=(0,i.useCallback)((function(e){e.canvas.style.width=100*Math.trunc(h.x)/h.x+"%",e.canvas.style.height=100*Math.trunc(h.y)/h.y+"%"}),[h]),g=(0,i.useMemo)((function(){return qj(Xj({},a),{responsive:!1,maintainAspectRatio:!1,devicePixelRatio:p,onResize:v})}),[p,v,a]);return(0,i.useEffect)((function(){if(m)if(null!=d.current&&(d.current.canvas===u.current&&d.current.config.type===r||(d.current.destroy(),d.current=null)),null==d.current){if(null==u.current)return;var e={datasets:[]};Jj(e,o,s),d.current=new k_(u.current,{type:r,data:e,options:g})}else Jj(d.current.data,o,s),d.current.options=g,d.current.update()}),[m,r,o,g,s]),(0,i.useEffect)((function(){null!=d.current&&m&&(d.current.resize(h.x/p,h.y/p),d.current.update("none"),v(d.current))}),[m,h,p,v]),(0,i.useEffect)((function(){return function(){null!=d.current&&d.current.destroy()}}),[]),(0,e.jsx)("div",qj(Xj({ref:f},c),{children:(0,e.jsx)("canvas",{ref:u})}))}function Jj(e,t,n){t!==e&&Object.assign(e,qj(Xj({},t),{datasets:t.datasets.map((function(t){var r=e.datasets.find((function(e){return e.label===t.label&&e.type===t.type}));if(null!=r){if(t!==r){var i=n(r.data,t.data);Object.assign(r,qj(Xj({},t),{mergedData:i}))}return r}return qj(Xj({},t),{data:Qj(t.data)})}))}))}function eE(e,t){var n=new Array(t.length);return Object.assign(n,e,t),n}k_.register(W_,ej,Y_,hx,mx,px,Fj,Hj,gj,kj,_j),k_.defaults.font.family="Overpass",k_.defaults.responsive=!1,k_.defaults.maintainAspectRatio=!1,k_.defaults.animation=!1,k_.defaults.plugins.tooltip.enabled=!1,k_.defaults.plugins.legend.display=!1,k_.defaults.events=[],k_.defaults.transitions.resize.animation.duration=0,k_.defaults.scales.linear.ticks.callback=function(e){return e.toString()};const tE="watches-output_GMe",nE="chart_u1n",rE="legend_obt",iE="legend-item_Osn";var oE=function(t){var n=t.watches,r=t.className,i=n.filter((function(e){return e.__Type===wf.History})),o=n.filter((function(e){return e.__Type===wf.Distribution}));return(0,e.jsxs)("div",{className:Oe()(tE,r),children:[i.length>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(aE,{watches:i}),(0,e.jsx)("div",{className:rE,children:i.map((function(t,n){return(0,e.jsx)(yv,{color:t.color,label:t.name,className:iE},n)}))})]}),o.length>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(lE,{watches:o}),(0,e.jsx)("div",{className:rE,children:o.map((function(t,n){return(0,e.jsx)(yv,{color:t.color,label:t.name,className:iE},n)}))})]})]})},aE=function(t){var n,r=t.watches,o=(0,i.useMemo)((function(){return{datasets:r.map((function(e,t){return{label:e.name,showLine:!0,data:e.history.filter((function(e){return 0!==e.x})),borderColor:e.color}}))}}),[r]),a=(n=C(Jl),(0,i.useMemo)((function(){return{layout:{padding:{top:15,right:30,left:30,bottom:30}},elements:{line:{tension:0,borderWidth:2,backgroundColor:"transparent"},point:{radius:0}},scales:{x:{type:"linear",beginAtZero:!1,grid:{display:!1},ticks:{display:!1}},y:{beginAtZero:!0,ticks:{font:{size:10*n},color:"white",maxTicksLimit:10,callback:function(e){return Ws(e)}}}}}}),[n]));return(0,e.jsx)(Zj,{type:"scatter",data:o,options:a,className:nE})},lE=function(t){var n,r=t.watches,o=(0,i.useMemo)((function(){return{datasets:r.map((function(e,t){return{label:e.name,showLine:!0,data:e.buckets.map((function(e){return{x:lt(e.min,e.max,.5),y:e.count}})),borderColor:e.color,stepped:"middle"}}))}}),[r]),a=(n=C(Jl),(0,i.useMemo)((function(){return{layout:{padding:{top:15,right:30,left:30,bottom:30}},elements:{line:{tension:0,borderWidth:2,backgroundColor:"transparent"},point:{radius:0}},scales:{x:{type:"linear",beginAtZero:!1,ticks:{font:{size:10*n},color:"white",maxTicksLimit:25,callback:function(e){return Ws(e)}}},y:{beginAtZero:!0,ticks:{font:{size:10*n},color:"white",maxTicksLimit:10,callback:function(e){return Ws(e)}}}}}}),[n]));return(0,e.jsx)(Zj,{type:"scatter",data:o,options:a,className:nE})};const sE="debug-ui_M_y",cE="inspector_GbW",uE="output-column_py9",dE="output_NHr",fE="tab-bar_b_c",hE="scrollable_ivK";var mE=new Se("CHILDREN"),pE=new Se("DEBUG_UI"),vE=function(t){var n=t.children,r=C(Pf),o=C(Cf),a=(0,i.useMemo)((function(){return{"Debug UI":function(){o?Gf():N(Nf,"show")}}}),[o]),l=(0,i.useCallback)((function(){return Gf()}),[]);return(0,e.jsxs)(e.Fragment,{children:[r?(0,e.jsx)(Tn,{actions:a,children:(0,e.jsxs)(Ze,{focused:o?pE:mE,children:[(0,e.jsx)(He,{focusKey:mE,children:n}),o&&(0,e.jsx)(gE,{onClose:l})]})}):n,(0,e.jsx)(lv,{})]})},gE=function(t){var n=t.onClose,r=C(Af),o=C(Lf),a=C(Mf),l=C(Rf),s=C(Kp),c=(0,i.useMemo)((function(){return{Back:function(){return n()},"Switch Tab":function(e){e<0?Vf():Bf()},"Pause Simulation":s?null:function(){Jt(Qt.pauseSimulation),Yp(!0)},"Resume Simulation":s?function(){Jt(Qt.resumeSimulation),Yp(!1)}:null}}),[n,s]);(0,i.useEffect)((function(){var e=function(e){e.repeat||(37===e.keyCode?(Vf(),e.preventDefault()):39===e.keyCode&&(Bf(),e.preventDefault()))};return document.addEventListener("keydown",e),function(){return document.removeEventListener("keydown",e)}}),[]),(0,i.useEffect)((function(){var e=Df.subscribe((function(e){e.debugType===Sf.Trigger&&N(e.group,e.name)}));return function(){return e.dispose()}}),[]);var u=C(kf),d=C(Ff),f=Lh("debug");return(0,e.jsx)(Tn,{actions:c,children:(0,e.jsxs)(Tr,{focusKey:pE,className:sE,children:[(0,e.jsxs)("div",{className:cE,children:[(0,e.jsx)("div",{className:fE,children:r.map((function(t,n){return(0,e.jsx)(yE,{index:n,name:t,selected:n===o},n)}))}),(0,e.jsx)(mf,{smooth:!1,className:hE,children:(0,e.jsx)(Fn,{children:null!=l&&(0,e.jsx)(Rp,{parent:f,data:l})})},null==a?void 0:a.displayName)]}),(0,e.jsxs)(mf,{className:uE,children:[null!=u&&(0,e.jsx)(rv,{binding:u,className:dE}),d.length>0&&(0,e.jsx)(oE,{watches:d,className:dE})]})]})})},yE=function(t){var n=t.index,r=t.name,o=t.selected,a=(0,i.useCallback)((function(){return function(e){N(Nf,"selectPanel",e)}(n)}),[n]);return(0,e.jsx)(ml,{focusKey:Te,selected:o,theme:Hf,onSelect:a,children:r})};function bE(e,t){return-t*e*e+(1+t)*e}function xE(e){document.documentElement.style.setProperty("--fontScale",e.toString().replace(",","."))}var _E,jE="assetUploadPanel",EE=E(jE,"visible"),OE=E(jE,"state"),TE=E(jE,"assetType"),IE=E(jE,"image"),SE=E(jE,"allScreenshots"),wE=E(jE,"selectedScreenshots"),NE=E(jE,"defaultArgs"),PE=E(jE,"error"),CE=w(jE,"submit"),AE=S(jE,"close"),LE=function(e){return N(jE,"toggleScreenshot",e)},ME=function(e){return N(jE,"removeScreenshot",e)};!function(e){e[e.Preparing=0]="Preparing",e[e.Form=1]="Form",e[e.Submitting=2]="Submitting",e[e.Complete=3]="Complete",e[e.Failure=4]="Failure"}(_E||(_E={}));const RE="fixed-ratio-image_XTW",kE="ratio_xCj",DE="image_EBv";function UE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function FE(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){UE(e,t,n[t])}))}return e}function GE(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function VE(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var BE=function(t){var n=t.src,r=t.className,i=t.onError,o=VE(t,["src","className","onError"]);return(0,e.jsxs)("div",GE(FE({},o),{className:Oe()(RE,r),children:[(0,e.jsx)("div",{className:kE}),(0,e.jsx)("img",{src:n,className:DE,onError:i})]}))},HE=function(t){var n=t.src,r=t.className,i=t.onImageError,o=VE(t,["src","className","onImageError"]);return(0,e.jsxs)(ml,GE(FE({},o),{className:Oe()(RE,r),children:[(0,e.jsx)("div",{className:kE}),(0,e.jsx)("img",{src:n,className:DE,onError:i})]}))};const KE={strokeWidth:"5","progress-circle":"progress-circle_OLN",progressCircle:"progress-circle_OLN",indeterminate:"indeterminate_UIQ",rotate:"rotate_UME",image:"image_AKd",progress:"progress_mlv"};function WE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var zE=function(t){var n=t.progress,r=t.max,o=t.indeterminate,a=t.theme,l=t.className,s=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){WE(e,t,n[t])}))}return e}({},KE,a)}),[a]),c=50,u=parseFloat(s.strokeWidth),d=(100-u)/2,f=2*Math.PI*at(n/r,0,.9999),h=c+d*Math.sin(f),m=c-d*Math.cos(f),p=f>Math.PI?1:0;return(0,e.jsx)("div",{className:Oe()(s.progressCircle,o&&s.indeterminate,l),children:(0,e.jsxs)("svg",{viewBox:"0 0 100 100",className:s.image,children:[s.circle&&(0,e.jsx)("circle",{cx:c,cy:c,r:d,strokeWidth:u,className:s.circle}),o?(0,e.jsx)("path",{d:YE(c,d,10),strokeWidth:u,className:s.progress}):(0,e.jsx)("path",{d:"M ".concat(c," ").concat(c-d," A ").concat(d," ").concat(d,", 0, ").concat(p," 1, ").concat(h," ").concat(m),strokeWidth:u,className:s.progress})]})})};function YE(e,t,n){for(var r="",i=0;i<n;i++){var o=2*Math.PI*i/n,a=e+t*Math.sin(o),l=e-t*Math.cos(o),s=2*Math.PI*(i+.3)/n,c=e+t*Math.sin(s),u=e-t*Math.cos(s);r+="M ".concat(a," ").concat(l," A ").concat(t," ").concat(t,", 0, 0 1, ").concat(c," ").concat(u," ")}return r}const XE={input:"input_sYI",label:"label_FEo",container:"container_Hgg"};function qE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function $E(e){return(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){qE(e,t,n[t])}))}return e}({},XE,e)}),[e])}var QE=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._elements=new Map,this._callbacks=[]}var t=e.prototype;return t.has=function(e){return this._elements.has(e)},t.get=function(e){return this._elements.get(e)},t.entries=function(){return this._elements},t.register=function(e,t){if(this._elements.has(e))console.warn("Duplicate element '".concat(String(e),"' registered!"));else{this._elements.set(e,t);var n=!0,r=!1,i=void 0;try{for(var o,a=this._callbacks[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){o.value.onRegister(e,t)}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}}},t.unregister=function(e,t){if(this._elements.get(e)===t){this._elements.delete(e);var n=!0,r=!1,i=void 0;try{for(var o,a=this._callbacks[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){o.value.onUnregister(e,t)}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}}},t.attachCallback=function(e){this._callbacks.includes(e)?console.warn("Element registry callback already attached!"):this._callbacks.push(e)},t.detachCallback=function(e){var t=this._callbacks.indexOf(e);-1!==t?this._callbacks.splice(t,1):console.warn("Element registry callback not attached!")},e}();function ZE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function JE(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||tO(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function eO(e){return function(e){if(Array.isArray(e))return ZE(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||tO(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function tO(e,t){if(e){if("string"==typeof e)return ZE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?ZE(e,t):void 0}}var nO=function(t){var n=t.skipInitial,r=void 0===n||n,o=t.children,a=(0,i.useRef)(r);(0,i.useEffect)((function(){return function(){a.current=!1}}),[o]);var l=(0,i.useMemo)((function(){var e=new QE;return e.attachCallback({onRegister:function(){},onUnregister:function(e){d((function(t){return iO(t,e)}))}}),e}),[]),s=(0,i.useRef)(null),c=JE((0,i.useState)((function(){return function(e){var t=new Array(i.Children.count(e));return i.Children.forEach(e,(function(e,n){t[n]=e})),t}(o)})),2),u=c[0],d=c[1];(0,i.useEffect)((function(){var e=function(e){var t=new Set;return i.Children.forEach(e,(function(e){var n=oO(e);null!=n&&t.add(n)})),t}(o);if(null!=s.current){d((function(t){return function(e,t,n){var r,o=new Map,a=[];i.Children.forEach(e,(function(e){var t=oO(e);null!=t&&(n.has(t)?(o.set(t,a),a=[]):a.push(e))}));var l=[];return i.Children.forEach(t,(function(e){var t=oO(e);if(null!=t){var n,r=o.get(t);if(r)(n=l).push.apply(n,eO(r))}l.push(e)})),(r=l).push.apply(r,eO(a)),l}(t,o,e)}));var t=!0,n=!1,r=void 0;try{for(var a,c=function(){var t=a.value;if(!e.has(t)){var n=l.get(t);n?n(bt.exit):d((function(e){return iO(e,t)}))}},u=s.current.values()[Symbol.iterator]();!(t=(a=u.next()).done);t=!0)c()}catch(e){n=!0,r=e}finally{try{t||null==u.return||u.return()}finally{if(n)throw r}}var f=!0,h=!1,m=void 0;try{for(var p,v=e.values()[Symbol.iterator]();!(f=(p=v.next()).done);f=!0){var g=p.value;if(!s.current.has(g)){var y=l.get(g);y&&y(bt.enter)}}}catch(e){h=!0,m=e}finally{try{f||null==v.return||v.return()}finally{if(h)throw m}}}s.current=e}),[o,l]);var f=(0,i.useContext)(Vt);return(0,e.jsx)(Gt.Provider,{value:Ft,children:u.map((function(t){var n=oO(t);if(null!=n){var r=!s.current||s.current.has(n);return(0,e.jsx)(rO,{transitionKey:n,exiting:f||!r,transitionRegistry:l,skipInitialRef:a,children:t},n)}return t}))})},rO=function(t){var n=t.transitionKey,r=t.transitionRegistry,o=t.skipInitialRef,a=t.exiting,l=t.children,s=JE((0,i.useState)(null==n||o.current?bt.in:bt.enter),2),c=s[0],u=s[1],d=(0,i.useCallback)((function(){null!=n&&r.register(n,u)}),[n,r]),f=(0,i.useCallback)((function(){null!=n&&r.unregister(n,u)}),[n,r]),h=(0,i.useMemo)((function(){return{state:c,onMount:d,onUnmount:f}}),[d,f,c]),m=(0,i.useContext)(Ge);return(0,e.jsx)(Gt.Provider,{value:h,children:(0,e.jsx)(Vt.Provider,{value:a,children:(0,e.jsx)(Ge.Provider,{value:a?Ve:m,children:l})})})};function iO(e,t){return e.filter((function(e){return oO(e)!==t}))}function oO(e){return null!==e&&"object"==typeof e?e.key:null}const aO={balloon:"balloon_H23",up:"up_ehW",start:"start_wu1",down:"down_ztr",center:"center_hug",end:"end_EKq",left:"left_LHd",right:"right_JdH",bounds:"bounds__AO",container:"container_jfe",arrow:"arrow_Xfn",content:"content_JQV"},lO={balloon:"balloon_DNs balloon_H23",base:"base_uUu",enter:"enter_ZTs","enter-active":"enter-active_bJR",enterActive:"enter-active_bJR","exit-active":"exit-active_AqC",exitActive:"exit-active_AqC",container:"container_sGN container_jfe",arrow:"arrow_tFt arrow_Xfn",content:"content_HM0 content_JQV"};function sO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var cO=i.forwardRef((function(t,n){var r=t.direction,o=t.alignment,a=t.theme,l=void 0===a?lO:a,s=t.className,c=t.style,u=t.children,d=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){sO(e,t,n[t])}))}return e}({},aO,l)}),[l]);return(0,e.jsx)($t,{styles:d,children:(0,e.jsx)("div",{ref:n,style:c,className:Oe()(d.balloon,null!=r&&d[r],null!=o&&d[o],s),children:(0,e.jsxs)("div",{className:d.bounds,children:[(0,e.jsx)("div",{className:d.container,children:(0,e.jsx)("div",{className:d.arrow})}),(0,e.jsx)("div",{className:d.content,children:u})]})})})}));const uO={"anchored-balloon":"anchored-balloon_AYp",anchoredBalloon:"anchored-balloon_AYp",hidden:"hidden_W0n",up:"up_el0",down:"down_Xl7",left:"left_SI8",right:"right_RQp"};var dO=function(t){var n=t.visible,r=t.direction,o=void 0===r?"up":r,a=t.alignment,l=void 0===a?"center":a,s=t.theme,c=t.content,u=t.balloonKey,d=void 0===u?"anchored-balloon":u,f=t.className,h=t.children;if(!Ut(h))throw new Error("AnchoredBalloon requires a single child react element!");var m=(0,i.useRef)(null),p=(0,i.useRef)(null),v=zd(n),g=Gd(m,n),y=Fd(p,Dd,n),b=(0,i.useMemo)((function(){return n&&g&&y?function(e,t,n,r,i){var o=r,a=i,l=hO(e,t,o,a),s=l.y<0,c=l.y+t.y>n.y,u=l.x<0,d=l.x+t.x>n.x;if(!(s||c||u||d))return{direction:o,alignment:a,style:vO(l)};a="left"===o||"right"===o?fO(a,s,c):fO(a,u,d);"up"===o?s&&(o="down"):"down"===o?c&&(o="up"):"left"===o?u&&(o="right"):"right"===o&&d&&(o="left");if(l=hO(e,t,o,a),s=l.y<0,c=l.y+t.y>n.y,u=l.x<0,d=l.x+t.x>n.x,!(s||c||u||d))return{direction:o,alignment:a,style:vO(l)};a="left"===o||"right"===o?fO(a,s,c):fO(a,u,d);return l=hO(e,t,o,a),{direction:o,alignment:a,style:vO(l)}}(g,y,v,o,l):null}),[n,g,y,v,o,l]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(zn,{ref:m,children:h}),(0,e.jsx)(nO,{children:n&&(0,e.jsx)(kc,{children:(0,e.jsx)(cO,{ref:p,direction:null==b?void 0:b.direction,alignment:null==b?void 0:b.alignment,theme:s,className:Oe()(f,uO.anchoredBalloon,null==b&&uO.hidden,null!=b&&uO[b.direction]),style:null==b?void 0:b.style,children:c},d)},"balloon")})]})};function fO(e,t,n){if(t){if("start"===e)return"center";if("center"===e)return"end"}else if(n){if("center"===e)return"start";if("end"===e)return"center"}return e}function hO(e,t,n,r){return"up"===n?{x:mO(e,t,r),y:e.top-t.y}:"down"===n?{x:mO(e,t,r),y:e.bottom}:"left"===n?{x:e.left-t.x,y:pO(e,t,r)}:"right"===n?{x:e.right,y:pO(e,t,r)}:ct}function mO(e,t,n){return"start"===n?(e.left+e.right)/2-t.x:"end"===n?(e.left+e.right)/2:(e.left+e.right-t.x)/2}function pO(e,t,n){return"start"===n?(e.top+e.bottom)/2-t.y:"end"===n?(e.top+e.bottom)/2:(e.top+e.bottom-t.y)/2}function vO(e){return{left:"".concat(e.x.toFixed(0),"px"),top:"".concat(e.y.toFixed(0),"px"),"--posX":"".concat(e.x.toFixed(0),"px"),"--posY":"".concat(e.y.toFixed(0),"px")}}const gO={balloon:"balloon_qJY balloon_H23",enter:"enter_ZTk","enter-active":"enter-active_AJs",enterActive:"enter-active_AJs","exit-active":"exit-active_RfZ",exitActive:"exit-active_RfZ",container:"container_zgM container_jfe",arrow:"arrow_SVb arrow_Xfn",content:"content_A82 content_JQV"};function yO(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bO(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yO(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yO(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xO=function(t){var n=t.tooltip,r=t.disabled,o=t.theme,a=void 0===o?gO:o,l=t.direction,s=t.alignment,c=t.className,u=t.children;if(!i.isValidElement(u))throw new Error("Tooltip requires a single child react element!");var d=bO((0,i.useState)(!1),2),f=d[0],h=d[1],m=(0,i.useCallback)((function(){return h(!0)}),[]),p=(0,i.useCallback)((function(){return h(!1)}),[]),v=(0,i.useCallback)((function(){return h(!1)}),[]),g=bO((0,i.useState)(!1),2),y=g[0],b=g[1],x=(0,i.useCallback)((function(e){return b(e)}),[]),_=cr();(0,i.useEffect)((function(){if(_&&y){var e=Jn.subscribe((function(e){e&&b(!1)}));return function(){return e.dispose()}}}),[_,y]);var j=(0,i.useRef)(null),E=(0,i.useCallback)((function(e){j.current!==e&&(null!=j.current&&(j.current.removeEventListener("mouseover",m),j.current.removeEventListener("mouseleave",p),j.current.removeEventListener("mousedown",v)),null!=e&&(e.addEventListener("mouseover",m),e.addEventListener("mouseleave",p),e.addEventListener("mousedown",v)),j.current=e)}),[v,p,m]),O=!!n&&i.Children.count(u)>0,T=(0,i.useContext)(xu);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(Jh,{onFocusChange:x,children:(0,e.jsx)(dO,{visible:(_&&y||f)&&O&&!r&&!T,direction:l,alignment:s,theme:a,content:n,className:c,children:(0,e.jsx)(zn,{ref:E,children:u})})})})};const _O={expandIcon:'"Media/Glyphs/ThickStrokeArrowDown.svg"',collapseIcon:'"Media/Glyphs/ThickStrokeArrowUp.svg"',section:"section_gUk",content:"content_owQ",expandable:"expandable_gK1","title-bar":"title-bar_wU9",titleBar:"title-bar_wU9",title:"title_bwV","toggle-button":"toggle-button_sQk",toggleButton:"toggle-button_sQk","button-space":"button-space_Iht",buttonSpace:"button-space_Iht"};var jO={theme:_O,expanded:!1},EO=i.createContext(jO);function OO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function TO(e){return(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){OO(e,t,n[t])}))}return e}({},_O,e)}),[e])}const IO={section:"section_sop section_gUk",header:"header_l0j undefined",content:"content_flM content_owQ",locked:"locked_UXm",first:"first_l25",last:"last_ZNw","title-bar":"title-bar_J7X title-bar_wU9",titleBar:"title-bar_J7X title-bar_wU9",title:"title_PYv title_bwV","toggle-button":"toggle-button_UA2 toggle-button_sQk",toggleButton:"toggle-button_UA2 toggle-button_sQk"};function SO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function wO(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){SO(e,t,n[t])}))}return e}function NO(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function PO(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var CO=i.forwardRef((function(t,n){var r=t.focusKey,o=t.header,a=t.tooltip,l=t.theme,s=void 0===l?IO:l,c=t.className,u=t.children,d=t.onFocusChange,f=PO(t,["focusKey","header","tooltip","theme","className","children","onFocusChange"]),h=TO(s),m=i.Children.count(o)>0,p=i.Children.count(u)>0,v=(0,i.useMemo)((function(){return{theme:h,expanded:p}}),[p,h]);return(0,e.jsx)(xO,{tooltip:a,children:(0,e.jsx)(Tr,NO(wO({ref:n,focusKey:r,className:Oe()(h.section,c),onFocusChange:d},f),{children:(0,e.jsx)(EO.Provider,{value:v,children:(0,e.jsxs)(Fn,{direction:On.Vertical,children:[m&&(0,e.jsx)("div",{className:Oe()(h.header,h.first),children:o}),(0,e.jsx)("div",{className:Oe()(h.content,!m&&h.first,h.last),children:u})]})})}))})}));const AO="screenshot-preview-container_IK5",LO="screenshot-item_P7A item_vDX item-states_QjV",MO="unselected_bc1",RO="screenshot-label_VCX",kO="image_b7r",DO="add-button_z14 item_vDX item-states_QjV";var UO=function(t){var n=t.screenshots,r=t.selectedScreenshots,i=t.onSelect,o=t.onAdd;return(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:Oe()(AO),children:[n.map((function(t){return(0,e.jsx)(FO,{screenshot:t,onSelect:i,selectedScreenshots:r},t.path)})),void 0!==o&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Menu.ASSET_ADD_PREVIEW_SCREENSHOT,{}),children:(0,e.jsx)(xl,{src:"Media/Glyphs/Plus.svg",className:DO,onSelect:o})})]})})},FO=function(t){var n=t.screenshot,r=t.onSelect,o=t.selectedScreenshots,a=t.tooltip,l=(0,i.useCallback)((function(){r(n.id)}),[r,n.id]),s=(0,i.useMemo)((function(){return void 0===o||o.findIndex((function(e){return e.id===n.id}))>=0}),[n.id,o]);return(0,e.jsx)(xO,{tooltip:a,children:(0,e.jsxs)(ml,{className:Oe()(LO,!s&&MO),onSelect:l,children:[(0,e.jsx)(BE,{className:kO,src:n.path}),(0,e.jsx)("div",{className:RO,children:n.name})]})})};const GO="asset-upload-panel_yfb",VO="active_SQ8",BO="progress-screen_UMd sub-screen_Gej",HO="screenshot-selection-panel_kOx sub-screen_Gej",KO="screenshot-selection-empty_ejn",WO="form-screen_khs sub-screen_Gej",zO="group_PN8",YO="textarea_ez6 input_dAN item-states_QjV",XO="image_Uqz",qO="forum-link_jbe",$O="forum-link-input_dEN input_dAN item-states_QjV",QO="remove-button_Dkj",ZO="progress-container_oaB",JO="indicator_FuY",eT="complete_wvH",tT="failure__u3",nT="progress-label_dkO",rT="progress-sub-label_OpL progress-label_dkO",iT="invalid-input_yQe",oT="button_rQP item-normal_Wb_ item-states_QjV",aT="labeled-text-input_A5u",lT="label_f56",sT="label-main_UpB",cT="label-error_XdV",uT="title_zMh",dT="screenshot-empty-label_BNG";var fT=function(t){var n=t.allScreenshots,r=t.selectedScreenshots,i=t.onSelect,o=t.onExit,a=t.focusKey,l=t.className,s=0===n.length;return(0,e.jsx)("div",{className:Oe()(l,HO,s&&KO),children:(0,e.jsxs)(Fn,{focusKey:a,children:[(0,e.jsx)(ml,{className:oT,onSelect:o,children:(0,e.jsx)(Ks.Common.ACTION,{hash:"Back"})}),s?(0,e.jsxs)("div",{className:dT,children:[(0,e.jsx)(Ks.Menu.ASSET_SCREENSHOT_EMPTY_TITLE,{}),(0,e.jsx)(Ks.Menu.ASSET_SCREENSHOT_EMPTY_SUBTITLE,{})]}):(0,e.jsx)(UO,{screenshots:n,selectedScreenshots:r,onSelect:i})]})})};const hT={"progress-circle":"progress-circle_vZs progress-circle_OLN",progressCircle:"progress-circle_vZs progress-circle_OLN",progress:"progress_jR8 progress_mlv",complete:"complete_leS",failure:"failure_m6n"};function mT(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function pT(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function vT(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){pT(e,t,n[t])}))}return e}function gT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function yT(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function bT(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||_T(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function xT(e){return function(e){if(Array.isArray(e))return mT(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||_T(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _T(e,t){if(e){if("string"==typeof e)return mT(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?mT(e,t):void 0}}var jT,ET=Rr({checkmark:"Media/Glyphs/Checkmark.svg",cross:"Media/Glyphs/Close.svg",trash:"Media/Glyphs/Trash.svg"}),OT=new Se("Asset upload form"),TT=new Se("Screenshot selection form"),IT=new Se("Asset Name");!function(e){e[e.None=0]="None",e[e.Screenshot=1]="Screenshot",e[e.Preview=2]="Preview"}(jT||(jT={}));var ST=function(t){var n,r,o,a=t.state,l=t.title,s=t.image,c=t.defaultArgs,d=t.onClose,f=t.onSubmit,h=t.error,m=bT((0,i.useState)(null!==(n=null==c?void 0:c.name)&&void 0!==n?n:""),2),p=m[0],v=m[1],g=(0,i.useCallback)((function(e){return v(e.target.value)}),[]),y=bT((0,i.useState)(null!=(null==c?void 0:c.forumLinks)&&c.forumLinks.length>0?c.forumLinks:[""]),2),b=y[0],x=y[1],_=(0,i.useCallback)((function(e,t){return x((function(n){return function(e,t,n){if(e[t]===n)return e;var r=xT(e);return r[t]=n,r}(n,e,t)}))}),[]),j=(0,i.useCallback)((function(e){x((function(t){return function(e,t){var n=xT(e);return n.splice(t,1),n}(t,e)}))}),[]),E=(0,i.useCallback)((function(){x((function(e){return xT(e).concat([""])}))}),[]),O=bT((0,i.useState)(null!==(r=null==c?void 0:c.shortDesc)&&void 0!==r?r:""),2),T=O[0],I=O[1],S=(0,i.useCallback)((function(e){return I(e.target.value)}),[]),w=bT((0,i.useState)(null!==(o=null==c?void 0:c.longDesc)&&void 0!==o?o:""),2),P=w[0],A=w[1],L=(0,i.useCallback)((function(e){return A(e.target.value)}),[]),M=(0,i.useCallback)((function(){f({name:p,forumLinks:b,shortDesc:T,longDesc:P})}),[b,P,p,f,T]),R=!u(p.trim()),k=!u(T.trim()),D=!u(P.trim()),U=(0,i.useMemo)((function(){return b.findIndex((function(e){return!NT(e)}))<0}),[b]),F=R&&k&&D&&U,G=$E(),V=C(SE),B=C(wE),H=bT((0,i.useState)(jT.None),2),K=H[0],W=H[1],z=(0,i.useCallback)((function(){return W(jT.Screenshot)}),[]),Y=(0,i.useCallback)((function(){return W(jT.Preview)}),[]),X=(0,i.useCallback)((function(){return W(jT.None)}),[]),q=(0,i.useCallback)((function(e){!function(e){N(jE,"setPreview",e)}(e),W(jT.None)}),[]);return(0,e.jsx)($r,{header:(0,e.jsx)(Tl,{children:(0,e.jsx)("div",{className:uT,children:l})}),theme:Qr,className:GO,onClose:d,children:(0,e.jsxs)(Ze,{focused:K!==jT.None?TT:OT,children:[(0,e.jsx)(mf,{className:Oe()(WO,a===_E.Form&&!K&&VO),children:(0,e.jsxs)(Fn,{direction:On.Vertical,initialFocused:IT,focusKey:OT,children:[(0,e.jsx)(HE,{src:s,className:XO,onSelect:Y}),(0,e.jsx)(CO,{className:zO,children:(0,e.jsx)(PT,{label:(0,e.jsx)(Ks.Menu.ASSET_NAME,{}),error:(0,e.jsx)(Ks.Menu.ASSET_ERROR_NAME,{}),value:p,placeholder:(0,e.jsx)(Ks.Menu.ASSET_NAME,{}),className:Oe()(G.input,YO),onChange:g})}),(0,e.jsx)(CO,{className:zO,children:(0,e.jsx)(PT,{label:(0,e.jsx)(Ks.Menu.ASSET_SHORT_DESCRIPTION,{}),error:(0,e.jsx)(Ks.Menu.ASSET_ERROR_DESCRIPTION,{}),multiline:3,maxLength:150,value:T,className:Oe()(G.input,YO),placeholder:(0,e.jsx)(Ks.Menu.ASSET_SHORT_DESCRIPTION,{}),onChange:S})}),(0,e.jsx)(CO,{className:zO,children:(0,e.jsx)(PT,{label:(0,e.jsx)(Ks.Menu.ASSET_LONG_DESCRIPTION,{}),error:(0,e.jsx)(Ks.Menu.ASSET_ERROR_DESCRIPTION,{}),multiline:6,maxLength:350,value:P,className:Oe()(G.input,YO),placeholder:(0,e.jsx)(Ks.Menu.ASSET_LONG_DESCRIPTION,{}),onChange:L})}),(0,e.jsx)(CO,{className:zO,children:(0,e.jsxs)("div",{className:aT,children:[(0,e.jsx)(CT,{label:(0,e.jsx)(Ks.Menu.ASSET_FORUM_LINKS,{}),error:(0,e.jsx)(Ks.Menu.ASSET_ERROR_LINK,{}),showError:!U}),b.map((function(t,n){return(0,e.jsx)(AT,{index:n,value:t,onChange:_,onRemove:b.length>1?j:void 0,className:G.input},n)})),b.length<5&&(0,e.jsx)(ml,{onSelect:E,className:oT,children:(0,e.jsx)(Ks.Menu.ASSET_ADD_LINK,{})})]})}),(0,e.jsx)(CO,{className:zO,children:(0,e.jsxs)("div",{className:aT,children:[(0,e.jsx)(CT,{label:(0,e.jsx)(Ks.Menu.ASSET_PREVIEW_SCREENSHOTS,{})}),(0,e.jsx)(UO,{screenshots:B,onSelect:ME,onAdd:z,itemTooltip:(0,e.jsx)(Ks.Menu.ASSET_REMOVE_PREVIEW_SCREENSHOT,{})})]})}),(0,e.jsx)(ml,{onSelect:M,disabled:!F,className:oT,children:(0,e.jsx)(Ks.Common.SUBMIT,{})})]})}),(0,e.jsx)(fT,{allScreenshots:V,selectedScreenshots:K===jT.Preview?void 0:B,onSelect:K===jT.Screenshot?LE:q,onExit:X,focusKey:TT,className:K!==jT.None?VO:void 0}),(0,e.jsx)(wT,{state:a,error:h})]})})},wT=function(t){var n=t.state,r=t.error,i=n===_E.Complete,o=n===_E.Failure;return(0,e.jsxs)("div",{className:Oe()(BO,n!==_E.Form&&VO),children:[(0,e.jsxs)("div",{className:ZO,children:[(0,e.jsx)(zE,{indeterminate:!(i||o),progress:1,max:1,theme:hT,className:Oe()(i&&hT.complete,o&&hT.failure)}),(0,e.jsx)(ll,{src:o?ET.cross:ET.checkmark,className:Oe()(JO,i&&eT,o&&tT)})]}),(0,e.jsx)("div",{className:nT,children:LT(n)}),(0,e.jsx)("div",{className:rT,children:r})]})},NT=function(e){return!!u(e)||e.toLowerCase().includes("forum.paradoxplaza.com")},PT=function(t){var n=t.label,r=t.error,i=t.showError,o=t.focusKey,a=yT(t,["label","error","showError","focusKey"]),l=void 0===a.value||u(a.value.toString().trim()),s=void 0!==i?i:l;return(0,e.jsxs)("div",{className:aT,children:[(0,e.jsx)(CT,{label:n,error:r,showError:s}),(0,e.jsx)(Sp,gT(vT({},a),{className:Oe()(a.className,s&&iT),focusKey:o}))]})},CT=function(t){var n=t.label,r=t.error,i=t.showError;return(0,e.jsxs)("div",{className:lT,children:[(0,e.jsx)("div",{className:sT,children:n}),i&&(0,e.jsx)("div",{className:cT,children:r})]})},AT=function(t){var n=t.index,r=t.value,o=t.onChange,a=t.onRemove,l=t.className,s=(0,i.useCallback)((function(e){return o(n,e.target.value)}),[o,n]),c=(0,i.useCallback)((function(){return a(n)}),[a,n]),u=(0,i.useMemo)((function(){return NT(r)}),[r]);return(0,e.jsx)("div",{className:qO,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(Sp,{value:r,placeholder:(0,e.jsx)(Ks.Menu.ASSET_FORUM_LINK,{INDEX:(n+1).toString()}),className:Oe()(l,$O,!u&&iT),onChange:s}),null!=a&&(0,e.jsx)(xl,{tinted:!0,src:ET.trash,className:QO,onSelect:c})]})})};function LT(t){switch(t){case _E.Submitting:return(0,e.jsx)(Ks.Menu.ASSET_SUBMITTING,{});case _E.Complete:return(0,e.jsx)(Ks.Menu.ASSET_COMPLETE,{});case _E.Failure:return(0,e.jsx)(Ks.Menu.ASSET_FAILURE,{});default:return(0,e.jsx)(Ks.Menu.ASSET_PREPARING,{})}}var MT=new Se("DIALOG"),RT=new Se("CHILDREN"),kT=function(t){var n=t.children,r=C(EE);return(0,e.jsxs)(Ze,{focused:r?MT:RT,children:[(0,e.jsx)(He,{focusKey:RT,children:n}),r&&(0,e.jsx)(He,{focusKey:MT,children:(0,e.jsx)(DT,{})})]})},DT=function(){var t=C(OE),n=C(TE),r=C(IE),i=C(NE),o=C(PE);return(0,e.jsx)(kc,{children:(0,e.jsx)(el,{children:(0,e.jsx)(ST,{state:t,title:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Ks.Menu.ASSET_UPLOAD,{})," - ",(0,e.jsx)(Ks.Menu.ASSET_TYPE,{hash:n})]}),image:r,defaultArgs:i,onSubmit:CE,onClose:AE,error:o})})},"AssetUploadPanel")},UT=new Se("DIALOG"),FT=new Se("CHILDREN"),GT=new Se("NO_KEY"),VT=function(t){var n=t.children,r=C(Xl),i=C(ql);return(0,e.jsxs)(Ze,{focused:r?UT:FT,children:[r&&(0,e.jsx)(kc,{children:(0,e.jsx)(el,{children:(0,e.jsxs)($r,{focusKey:UT,theme:Qr,className:Il.dialog,children:[(0,e.jsx)("div",{className:Il.message,children:(0,e.jsx)(Ks.Options.DISPLAY_SETTINGS_PROMPT,{})}),(0,e.jsx)("div",{className:Il.buttons,children:(0,e.jsxs)(Fn,{initialFocused:GT,children:[(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:ps,children:(0,e.jsx)(Ks.Options.DISPLAY_SETTINGS_CONFIRM,{})}),(0,e.jsx)(ml,{focusKey:GT,theme:Ad,className:Oe()(Il.button,Ad.negative),onSelect:vs,children:(0,e.jsx)(Ks.Options.DISPLAY_SETTINGS_REVERT,{TIME:(0,e.jsx)(dc,{value:i,unit:tc.Integer})})})]})})]})})},"displayConfirmationDialog"),(0,e.jsx)(He,{focusKey:FT,children:n})]})},BT=Os("LocalizedInputPath",(function(e,t){var n=t.group,r=t.path,i=t.gamepadType;if(r.length>0){var o=Ks.Options.INPUT_MODIFIER_SEPARATOR.renderString(e,{fallback:" + "});return r.map((function(t){var r="".concat(n,".").concat(t),o=Ks.Options.INPUT_CONTROL.renderString(e,{hash:r,fallback:t});return i===Xn.PS&&"Gamepad"===n?Ks.Options.INPUT_CONTROL_PS.renderString(e,{hash:r,fallback:o}):o})).join(o)}return Ks.Options.INPUT_CONTROL_UNSET.renderString(e,{})}),(function(e,t){return e.group===t.group&&f(e.path,t.path)}));var HT=/\s/,KT=function(){function t(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,t),this.linkRenderer=e}return t.prototype.render=function(t){for(var n=[],r=0,i=-1,o=-1,a=0;a<t.length;a++)switch(t[a]){case"<":-1===o&&(i=a,o=-1);break;case"|":-1!==i&&-1===o&&(o=a);break;case">":if(-1!==i){r<i&&n.push(WT(t,r,i,null));var l=t.substring(i+1,-1!==o?o:a),s=a<t.length-1&&HT.test(t[a+1])?t[a+1]:null,c=WT(t,-1!==o?o+1:i+1,a,s),u=null!=this.linkRenderer?this.linkRenderer(l,c,i):void 0;void 0!==u?n.push((0,e.jsxs)("span",{children:[u,s]},i)):n.push((0,e.jsx)(iI,{linkData:l,children:c},i)),r=a+1,i=-1,o=-1}}return r<t.length&&n.push(WT(t,r,t.length,null)),[n,JT.None,[]]},t}();function WT(t,n,r,i){for(var o=[],a=n,l=!1,s=-1,c=n;c<r;c++)if("*"===t[c])if(l)if(-1===s)s=c-1,l=!1;else{a<s&&o.push(t.substring(a,s));var u=t.substring(s+2,c-1);c<r-1?HT.test(t[c+1])&&(u+=t[c+1]):null!=i&&(u+=i),o.push((0,e.jsx)("b",{children:u},s)),a=c+1,s=-1,l=!1}else l=!0;else l=!1;if(a<r){var d=t.substring(a,r);null!=i&&(d+=i),o.push(d)}return o}const zT={h1:"h1_YPD",h2:"h2_TYz",h3:"h3__p1",h4:"h4_Gmc",h5:"h5_QKx",h6:"h6__nd",link:"link_jpN"};function YT(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function XT(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function qT(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){XT(e,t,n[t])}))}return e}function $T(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function QT(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function ZT(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return YT(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return YT(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var JT;!function(e){e[e.None=0]="None",e[e.Heading1=1]="Heading1",e[e.Heading2=2]="Heading2",e[e.Heading3=3]="Heading3",e[e.Heading4=4]="Heading4",e[e.Heading5=5]="Heading5",e[e.Heading6=6]="Heading6"}(JT||(JT={}));var eI=(0,i.createContext)({theme:zT,onLinkSelect:void 0}),tI=new KT,nI=function(t){var n=t.focusKey,r=t.text,o=void 0===r?"":r,a=t.theme,l=t.renderer,s=void 0===l?tI:l,c=t.className,u=t.onLinkSelect,d=QT(t,["focusKey","text","theme","renderer","className","onLinkSelect"]),f=(0,i.useMemo)((function(){return qT({},zT,a)}),[a]),h=(0,i.useMemo)((function(){return{theme:f,onLinkSelect:u}}),[u,f]),m=xs(o),p=ZT((0,i.useMemo)((function(){return s.render(m)}),[s,m]),2),v=p[0],g=p[1];return(0,e.jsx)(Fn,{focusKey:n,children:(0,e.jsx)(eI.Provider,{value:h,children:(0,e.jsx)("p",$T(qT({},d),{className:Oe()(rI(f,g),c),cohinline:"cohinline",children:v}))})})};function rI(e,t){switch(t){case JT.Heading1:return e.h1;case JT.Heading2:return e.h2;case JT.Heading3:return e.h3;case JT.Heading4:return e.h4;case JT.Heading5:return e.h5;case JT.Heading6:return e.h6;default:return}}var iI=function(t){var n=t.linkData,r=t.children,o=(0,i.useContext)(eI),a=(0,i.useCallback)((function(){o.onLinkSelect&&o.onLinkSelect(n)}),[o,n]);return""!==n?(0,e.jsx)(ml,{className:o.theme.link,onSelect:a,children:r}):(0,e.jsx)(e.Fragment,{children:r})};const oI={paragraphs:"paragraphs_nbD"};function aI(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function lI(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sI(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){lI(e,t,n[t])}))}return e}function cI(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function uI(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function dI(e){return function(e){if(Array.isArray(e))return aI(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return aI(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return aI(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var fI=function(t){var n=t.focusKey,r=t.text,o=t.theme,a=t.renderer,l=t.className,s=t.children,c=t.onLinkSelect,u=t.maxLineLength,d=t.splitLineLength,f=uI(t,["focusKey","text","theme","renderer","className","children","onLinkSelect","maxLineLength","splitLineLength"]),h=(0,i.useMemo)((function(){return sI({},oI,o)}),[o]),m=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=arguments.length>2?arguments[2]:void 0,r=arguments.length>3?arguments[3]:void 0,o=bs();return(0,i.useMemo)((function(){return i.Children.toArray(e).flatMap((function(e){return mI(_s(o,e,"\n"),t,!1,n,r)}))}),[e,o,n,r,t])}(i.Children.count(s)>0?s:r,!0,u,d);return(0,e.jsx)("div",cI(sI({},f),{className:Oe()(h.paragraphs,l),children:(0,e.jsx)(Fn,{focusKey:n,children:m.map((function(t,n){return(0,e.jsx)(nI,{text:t,theme:h,renderer:a,onLinkSelect:c},n)}))})}))};var hI=function(e,t){var n=e,r=[];do{var i=n.substring(0,t).lastIndexOf(" ");-1===i?(r.push(n.substring(0,t)),n=n.substring(t)):(r.push(n.substring(0,i)),n=n.substring(i))}while(n.length>t);return n.length>0&&r.push(n),r};function mI(e){var t,n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=arguments.length>3?arguments[3]:void 0,o=arguments.length>4?arguments[4]:void 0,a=e.split(/\r\n|\r|\n/);n&&(a=a.filter((function(e,t,n){var i;return""!==e.trim()||r&&""===(null===(i=n[t+1])||void 0===i?void 0:i.trim())})));var l=[];return a.forEach((function(e){return void 0!==i&&e.length>i?(t=l).push.apply(t,dI(hI(e,null!=o?o:150))):l.push(e)})),l}var pI="inputRebinding",vI=E(pI,"activeRebinding"),gI=E(pI,"activeConflict"),yI=S(pI,"cancelRebinding"),bI=S(pI,"completeAndSwapConflicts"),xI=S(pI,"completeAndUnsetConflicts");function _I(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jI(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return _I(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _I(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function EI(e){var t=jI((0,i.useState)(e),2),n=t[0],r=t[1],o=(0,i.useContext)(Vt);return(0,i.useEffect)((function(){if(!o){var t=window.requestAnimationFrame((function(){o||r(e)}));return function(){return window.cancelAnimationFrame(t)}}}),[o,e]),n}var OI=function(t){var n=EI(t.children);return(0,e.jsx)(e.Fragment,{children:n})},TI="user",II=E(TI,"switchPromptVisible"),SI=E(TI,"avatar"),wI=E(TI,"userID"),NI=E(TI,"switchUserHintOverload");function PI(){N(TI,"switchUser")}function CI(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function AI(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return CI(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return CI(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var LI=function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.time=t,this.refCount=0},MI=i.createContext(new Map);const RI={balloon:"balloon_YD_ balloon_DNs balloon_H23",base:"base_CfJ",enter:"enter_ek6","exit-active":"exit-active_s_4",exitActive:"exit-active_s_4","enter-active":"enter-active_QVu",enterActive:"enter-active_QVu",exit:"exit_RYd",container:"container_p5S container_sGN container_jfe",arrow:"arrow_WhB arrow_tFt arrow_Xfn",content:"content_Bye content_HM0 content_JQV"},kI="keyboard-input-hint_eiZ",DI="icon_Mm0";function UI(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function FI(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return UI(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return UI(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var GI="inputAction:",VI=new KT((function(t,n,r){if(t.startsWith(GI)){var i=FI(function(e){if(e.endsWith("]")){var t=e.lastIndexOf("[");if(t<e.length-1){var n=parseInt(e.substring(t+1,e.length-1));return isNaN(n)?[e,void 0]:[e.substring(0,t),n]}}return[e,void 0]}(t.substring(GI.length).trim()),2),o=i[0],a=i[1];return(0,e.jsx)(BI,{linkData:o,bindingIndex:a},r)}}));function BI(t){var n=t.linkData,r=t.bindingIndex,o=C(Qn),a=(0,i.useMemo)((function(){var e=n.indexOf("/");return e>=0&&n.length>=e+1?{map:n.substring(0,e),action:n.substring(e+1),controlScheme:o}:{map:"",action:"",controlScheme:o}}),[o,n]),l=M(ir,a),s=(0,i.useMemo)((function(){return void 0!==r&&r>=0&&r<l.length?[l[r]]:l}),[r,l]);return(0,e.jsx)(e.Fragment,{children:o===Yn.gamepad?s.map((function(t,r){return(0,e.jsx)(KI,{hint:t},n+r)})):s.map((function(t,r){return(0,e.jsx)(HI,{hint:t},n+r)}))})}var HI=function(t){var n=t.hint;return(0,e.jsx)("span",{className:kI,children:(0,e.jsx)("b",{children:(0,e.jsx)(BT,{group:n.name,path:n.bindings})})})},KI=function(t){var n=t.hint;return(0,e.jsxs)(e.Fragment,{children:[n.modifiers.map((function(t){return(0,e.jsx)(WI,{path:t,modifier:!0},t)})),n.bindings.map((function(t){return(0,e.jsx)(WI,{path:t},t)}))]})},WI=function(t){var n=t.path,r=t.modifier,i=KS(n);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("img",{src:i||"",className:DI}),r&&"+"]})};const zI="trigger-item_rd_",YI="completed_V8G",XI="checkbox_Y9N",qI="label_vR9";var $I=function(t){var n=t.trigger;return(0,i.useEffect)((function(){n.completed&&Jt(Qt.tutorialTriggerCompleteEvent)}),[n.completed]),(0,e.jsxs)("div",{className:Oe()(zI,n.completed&&YI),children:[(0,e.jsx)(pp,{checked:n.completed||n.preCompleted,className:XI,focusKey:Te}),(0,e.jsx)(nI,{text:(0,e.jsx)(Ks.Tutorials.TRIGGER,{hash:n.name}),renderer:VI,className:qI})]})};const QI={"tutorial-layout":"tutorial-layout_iuN",tutorialLayout:"tutorial-layout_iuN",image:"image_NyN",columns:"columns_ITy","icon-column":"icon-column_K_S",iconColumn:"icon-column_K_S","content-column":"content-column_ygV",contentColumn:"content-column_ygV",top:"top_4SL",icon:"icon_Qax",content:"content_p9h",scrollable:"scrollable_ErH",title:"title_JUj","close-button":"close-button_K6M",closeButton:"close-button_K6M",description:"description_Dj3",rows:"rows_vbh",row:"row_yh5",triggers:"triggers_Da1 row_yh5",bottom:"bottom_oC7 row_yh5",pages:"pages_kqp"};function ZI(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function JI(e){return(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ZI(e,t,n[t])}))}return e}({},QI,e)}),[e])}function eS(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tS(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return eS(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return eS(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function nS(e,t){var n;return!e.mandatory||(null===(n=t.trigger)||void 0===n?void 0:n.preCompleted)||null==t.trigger||e.advisorActivation||t.completed}function rS(e,t){return e.phases.findIndex((function(e){return c(e.entity,t.entity)}))}function iS(){var e=Yc.value,t=Xc.value;if(null!=e&&null!=t){var n=rS(e,t),r=tS(oS(e,n),2),i=r[0];r[1];if(i>0)Zc(e.entity,e.phases[n-1].entity);else if(n>0){var o=e.phases.findIndex((function(e){var t;return null===(t=e.trigger)||void 0===t?void 0:t.phaseBranching}));o>=0&&Zc(e.entity,e.phases[o].entity)}}}function oS(e,t){var n=e.phases.length,r=e.phases.findIndex((function(e){var t;return null==e||null===(t=e.trigger)||void 0===t?void 0:t.phaseBranching}));if(r<0)return[t,n];if(t<=r)return[t,r+1];for(var i=-1,o=-1,a=r+1;a<n;a++){var l=e.phases[a];if(((null==l?void 0:l.forcesCompletion)||a===n-1)&&a>=t){o=a;break}}for(var s=n-1;s>r;s--){var c=e.phases[s];if((null==c?void 0:c.isBranch)&&s<=t){i=s;break}}return[t-i,o-i+1]}function aS(){var e=C(Uc),t=C(Yc),n=A(Gc,lS,!1);return(0,i.useMemo)((function(){return!(n||(null==t?void 0:t.mandatory)&&e)}),[null==t?void 0:t.mandatory,n,e])}function lS(e,t){return null!=t}const sS={item:"item_Lji",button:"button_iQJ item_Lji",animate:"animate_fHa",blink:"blink_HHL",none:"none_bxA",icon:"icon_G81",pages:"pages_Lzi item_Lji",label:"label_FEJ",divider:"divider_bFc"};function cS(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function uS(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return cS(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return cS(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var dS=function(t){var n,r,o=t.tutorial,a=t.phase,l=t.pagesVisible,s=t.theme,d=t.closeable,f=void 0!==d&&d,h=t.scrollable,m=void 0!==h&&h,p=t.disableTooltips,v=void 0!==p&&p,g=t.className,y=o.phases.findIndex((function(e){return c(e.entity,a.entity)})),b=uS((0,i.useMemo)((function(){return oS(o,y)}),[y,o]),2),x=b[0],_=b[1],j=nS(o,a),E=y>0,O=xs(cr()?(0,e.jsx)(Ks.Tutorials.DESCRIPTION_GAMEPAD,{hash:a.name,fallback:""}):(0,e.jsx)(Ks.Tutorials.DESCRIPTION_KEYBOARD,{hash:a.name,fallback:""})),T=xs((0,e.jsx)(Ks.Tutorials.DESCRIPTION,{hash:a.name})),I=!o.completed&&!o.advisorActivation,S=a.descriptionVisible?O||T:null,w=(n=a,(r=WS())!==Xn.PS||u(n.overrideImagePS)?r!==Xn.Xbox||u(n.overrideImageXbox)?n.image:n.overrideImageXbox:n.overrideImagePS);return(0,e.jsx)(fS,{theme:s,image:w,icon:a.icon,title:a.titleVisible?(0,e.jsx)(Ks.Tutorials.TITLE,{hash:a.name}):void 0,description:a.descriptionVisible?S:null,onClose:f?nu:void 0,scrollable:m,trigger:a.trigger,pagesVisible:l,phaseIndex:x,phaseCount:_,nextVisible:j,previousVisible:E,handleActivatePreviousPhase:iS,handleActivateNextPhase:tu,animateButton:I,className:g,disableTooltips:v})};var fS=function(t){var n=t.theme,r=void 0===n?QI:n,i=t.className,o=t.image,a=t.icon,l=t.title,s=t.autoScroll,c=void 0===s||s,u=t.description,d=t.onClose,f=t.scrollable,h=t.trigger,m=t.pagesVisible,p=t.phaseIndex,v=void 0===p?0:p,g=t.phaseCount,y=void 0===g?1:g,b=t.nextVisible,x=t.previousVisible,_=t.handleActivatePreviousPhase,j=t.handleActivateNextPhase,E=t.animateButton,O=t.disableTooltips,T=JI(r),I=m&&-1!==v&&y>1,S=v+1===y,w=cr(),N=l||u?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)("div",{className:T.top,children:[l&&(0,e.jsx)("div",{className:T.title,children:l}),!w&&d&&(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/Close.svg",theme:_l,className:T.closeButton,onSelect:d})]}),u&&(0,e.jsx)("div",{className:T.description,children:(0,e.jsx)(fI,{renderer:VI,children:u})})]}):void 0;return(0,e.jsxs)("div",{className:Oe()(T.tutorialLayout,i),children:[o&&(0,e.jsx)(BE,{src:o,className:T.image}),(a||N)&&(0,e.jsxs)("div",{className:T.columns,children:[a&&(0,e.jsx)("div",{className:T.iconColumn,children:(0,e.jsx)("img",{src:a,className:T.icon})}),(0,e.jsx)("div",{className:T.contentColumn,children:f?(0,e.jsx)(mf,{autoScroll:c,className:T.scrollable,children:N}):(0,e.jsx)("div",{className:T.content,children:N})})]}),((null==h?void 0:h.displayUI)||x||b||I)&&(0,e.jsxs)("div",{className:T.rows,children:[(null==h?void 0:h.displayUI)&&(0,e.jsx)("div",{className:T.triggers,children:(0,e.jsx)($I,{trigger:h})}),w||!x&&!b?I&&(0,e.jsx)("div",{className:T.bottom,children:(0,e.jsx)("div",{className:T.pages,children:(0,e.jsx)(ah,{value:v+1,total:y})})}):(0,e.jsxs)("div",{className:T.bottom,children:[x&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(xO,{tooltip:!O&&(0,e.jsx)(Ks.Tutorials.BUTTON_TOOLTIP_PREVIOUS,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/FilledArrowLeft.svg",theme:sS,onSelect:_})}),(I||b)&&(0,e.jsx)("div",{className:sS.divider})]}),I&&(0,e.jsx)("div",{className:sS.pages,children:(0,e.jsx)("div",{className:sS.label,children:(0,e.jsx)(ah,{value:v+1,total:y})})}),b&&(0,e.jsxs)(e.Fragment,{children:[I&&(0,e.jsx)("div",{className:sS.divider}),(0,e.jsx)(xO,{tooltip:O?void 0:S?(0,e.jsx)(Ks.Tutorials.BUTTON_TOOLTIP_DONE,{}):(0,e.jsx)(Ks.Tutorials.BUTTON_TOOLTIP_NEXT,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:S?"Media/Glyphs/Checkmark.svg":"Media/Glyphs/FilledArrowRight.svg",theme:sS,className:Oe()(E&&sS.animate),onSelect:j})})]})]})]})]})};const hS={image:"image_GQL image_NyN"};var mS=function(t){var n=t.tutorial,r=t.phase,i=t.direction,o=t.alignment,a=t.children,l=null!=n&&null!=r&&(0,e.jsx)(dS,{tutorial:n,phase:r,pagesVisible:!0,theme:hS,closeable:n.completed||n.advisorActivation||!n.mandatory,disableTooltips:!0});return(0,e.jsx)(dO,{balloonKey:null==r?void 0:r.name,theme:RI,visible:null!=n,content:(0,e.jsx)(OI,{children:l}),direction:i,alignment:o,children:a})};const pS="tutorial-blink-active_s4x",vS="tutorial-blink_EvY";function gS(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yS(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gS(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gS(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bS=function(t){var n,r,o=t.uiTag,a=t.active,l=void 0===a||a,s=t.disableBlinking,c=void 0!==s&&s,u=t.children;if(!i.isValidElement(u))throw new Error("TutorialGuideTarget requires a single child react element!");var d=C(Yc),f=C(Xc),h=xS(o,l),m=yS(_S(o,l),3),p=m[0],v=m[1],g=m[2],y=!c&&(h||v),b=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=(0,i.useContext)(MI),r=AI((0,i.useState)(0),2),o=r[0],a=r[1];return(0,i.useEffect)((function(){if(t){var r,i=performance.now(),o=null!==(r=n.get(e))&&void 0!==r?r:new LI(i);return 0===o.refCount&&n.set(e,o),o.refCount++,a(Math.min(o.time-i,0)),function(){o.refCount--,0===o.refCount&&n.delete(e)}}}),[t,n,e]),o+"ms"}(vS,y),x={tutorial:p?d:null,phase:p?f:null,balloonDirection:p&&g>=0?null===(n=null==f?void 0:f.balloonTargets[g])||void 0===n?void 0:n.direction:void 0,balloonAlignment:p&&g>=0?null===(r=null==f?void 0:f.balloonTargets[g])||void 0===r?void 0:r.alignment:void 0,disableTooltips:p,animationDelay:y?{animationDelay:b}:void 0,className:y?pS:void 0};return(0,e.jsx)(xu.Provider,{value:x.disableTooltips,children:(0,e.jsx)(mS,{tutorial:x.tutorial,phase:x.phase,direction:x.balloonDirection,alignment:x.balloonAlignment,children:(0,e.jsx)(zn,{style:x.animationDelay,className:x.className,children:u})})})},xS=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=yS((0,i.useState)(!1),2),r=n[0],o=n[1],a=(0,i.useContext)(bu);return(0,i.useEffect)((function(){if(void 0!==e&&""!==e&&t)return a.mountBlinkListener(e,o),function(){return a.unmountBlinkListener(e)};o(!1)}),[a,e,t]),r},_S=function(e,t){var n=yS((0,i.useState)(!1),2),r=n[0],o=n[1],a=yS((0,i.useState)(!1),2),l=a[0],s=a[1],c=yS((0,i.useState)(-1),2),u=c[0],d=c[1],f=(0,i.useContext)(bu);return(0,i.useEffect)((function(){if(void 0!==e&&""!==e&&t)return f.mountBalloonListener(e,o,s,d),function(){return f.unmountBalloonListener(e)};o(!1)}),[f,e,t]),[r,l,u]},jS="prefabs",ES=E(jS,"themes"),OS=T(jS,"prefabDetails"),TS=E(jS,"manualUITags"),IS={entity:ii,name:"",uiTag:"",icon:"Media/Placeholder.svg",preview:null,titleId:"",descriptionId:null,locked:!1,uniquePlaced:!1,constructionCost:null,effects:[],properties:[],requirements:{requireAny:[],requireAll:[]}};const SS="action-guide_eqv",wS="item_p05",NS="button-icon_N8P",PS="item-clickable_sKM item-mouse-states_Fmi",CS="button-text_U4q",AS="plus_ITh",LS="label_MOA";function MS(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function RS(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function kS(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var DS=function(t){var n=t.disabled,r=t.specifiedActions,o=t.className,a=t.labels,l=void 0===a||a,s=EI(C(nr)),c=(0,i.useMemo)((function(){return void 0!==r?s.filter((function(e){return r.includes(e.name)})):s}),[s,r]);return(0,e.jsx)("div",{className:Oe()(SS,o),children:n?null:c.map((function(t,n){return(0,e.jsx)(US,{item:t,label:l,onSelect:rr},n)}))})},US=function(t){var n,r=t.item,o=t.label,a=t.onSelect,l=C(NI),s=(0,i.useCallback)((function(){a&&a(r.name)}),[r.name,a]),c=r.name;if("Switch User"===c)c=l||r.name;return(0,e.jsx)(bS,{uiTag:(null===(n=TS.value)||void 0===n?void 0:n.actionHints)+"+"+r.name,children:(0,e.jsxs)(HS,{className:wS,onSelect:s,children:[r.modifiers.map((function(t,n){return(0,e.jsx)(FS,{path:t,modifier:!0},n)})),r.bindings.map((function(t,n){return(0,e.jsx)(FS,{path:t},n)})),o?(0,e.jsx)("div",{className:LS,children:(0,e.jsx)(Ks.Common.ACTION,{hash:c})}):null]})})},FS=function(t){var n=t.path,r=t.modifier,i=KS(n);return(0,e.jsxs)(e.Fragment,{children:[null!=i?(0,e.jsx)("img",{src:i,className:NS}):(0,e.jsx)(GS,{path:n}),r&&(0,e.jsx)("div",{className:AS,children:"+"})]})},GS=function(t){var n=t.path,r=VS(n),i=BS(n);return(0,e.jsx)("div",{className:CS,children:(0,e.jsx)(BT,{group:r,path:i})})},VS=function(e){return(0,i.useMemo)((function(){var t=e.indexOf("<"),n=e.indexOf(">");return t>=0&&n>t?e.substring(t+1,n):e}),[e])},BS=function(e){return(0,i.useMemo)((function(){var t=e.indexOf("/");return t>=0?e.substring(t+1).split("/"):[e]}),[e])},HS=function(t){var n=t.children,r=t.className,i=kS(t,["children","className"]);return(0,e.jsx)(ml,RS(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){MS(e,t,n[t])}))}return e}({className:Oe()(wS,r,!i.disabled&&PS),focusKey:Te},i),{children:n}))};function KS(e){var t=WS();return(0,i.useMemo)((function(){switch(t){case Xn.Xbox:switch(e){case"<Gamepad>/leftStick":return"Media/Gamepad/Xbox/LeftStick.svg";case"<Gamepad>/rightStick":return"Media/Gamepad/Xbox/RightStick.svg";case"<Gamepad>/leftStick/up":return"Media/Gamepad/Xbox/LstickUp.svg";case"<Gamepad>/leftStick/down":return"Media/Gamepad/Xbox/LstickDown.svg";case"<Gamepad>/leftStick/left":return"Media/Gamepad/Xbox/LstickLeft.svg";case"<Gamepad>/leftStick/right":return"Media/Gamepad/Xbox/LstickRight.svg";case"<Gamepad>/rightStick/up":return"Media/Gamepad/Xbox/RstickUp.svg";case"<Gamepad>/rightStick/down":return"Media/Gamepad/Xbox/RstickDown.svg";case"<Gamepad>/rightStick/left":return"Media/Gamepad/Xbox/RstickLeft.svg";case"<Gamepad>/rightStick/right":return"Media/Gamepad/Xbox/RstickRight.svg";case"<Gamepad>/dpad":return"Media/Gamepad/Xbox/Dpad.svg";case"<Gamepad>/dpad/x":return"Media/Gamepad/Xbox/DpadX.svg";case"<Gamepad>/dpad/y":return"Media/Gamepad/Xbox/DpadY.svg";case"<Gamepad>/dpad/up":return"Media/Gamepad/Xbox/DpadUp.svg";case"<Gamepad>/dpad/down":return"Media/Gamepad/Xbox/DpadDown.svg";case"<Gamepad>/dpad/left":return"Media/Gamepad/Xbox/DpadLeft.svg";case"<Gamepad>/dpad/right":return"Media/Gamepad/Xbox/DpadRight.svg";case"<Gamepad>/buttonNorth":return"Media/Gamepad/Xbox/North.svg";case"<Gamepad>/buttonSouth":return"Media/Gamepad/Xbox/South.svg";case"<Gamepad>/buttonWest":return"Media/Gamepad/Xbox/West.svg";case"<Gamepad>/buttonEast":return"Media/Gamepad/Xbox/East.svg";case"<Gamepad>/leftShoulder":return"Media/Gamepad/Xbox/LeftShoulder.svg";case"<Gamepad>/rightShoulder":return"Media/Gamepad/Xbox/RightShoulder.svg";case"<Gamepad>/leftTrigger":return"Media/Gamepad/Xbox/LeftTrigger.svg";case"<Gamepad>/rightTrigger":return"Media/Gamepad/Xbox/RightTrigger.svg";case"<Gamepad>/start":return"Media/Gamepad/Xbox/Start.svg";case"<Gamepad>/select":return"Media/Gamepad/Xbox/Select.svg";case"<Gamepad>/leftStickPress":return"Media/Gamepad/Xbox/LstickPress.svg";case"<Gamepad>/rightStickPress":return"Media/Gamepad/Xbox/RstickPress.svg";default:return null}case Xn.PS:switch(e){case"<Gamepad>/leftStick":return"Media/Gamepad/PS/PS_Lstick.svg";case"<Gamepad>/rightStick":return"Media/Gamepad/PS/PS_Rstick.svg";case"<Gamepad>/leftStick/up":return"Media/Gamepad/PS/PS_LstickUp.svg";case"<Gamepad>/leftStick/down":return"Media/Gamepad/PS/PS_LstickDown.svg";case"<Gamepad>/leftStick/left":return"Media/Gamepad/PS/PS_LstickLeft.svg";case"<Gamepad>/leftStick/right":return"Media/Gamepad/PS/PS_LstickRight.svg";case"<Gamepad>/rightStick/up":return"Media/Gamepad/PS/PS_RstickUp.svg";case"<Gamepad>/rightStick/down":return"Media/Gamepad/PS/PS_RstickDown.svg";case"<Gamepad>/rightStick/left":return"Media/Gamepad/PS/PS_RstickLeft.svg";case"<Gamepad>/rightStick/right":return"Media/Gamepad/PS/PS_RstickRight.svg";case"<Gamepad>/dpad":return"Media/Gamepad/PS/PS_Dpad.svg";case"<Gamepad>/dpad/x":return"Media/Gamepad/PS/PS_DpadX.svg";case"<Gamepad>/dpad/y":return"Media/Gamepad/PS/PS_DpadY.svg";case"<Gamepad>/dpad/up":return"Media/Gamepad/PS/PS_DpadUp.svg";case"<Gamepad>/dpad/down":return"Media/Gamepad/PS/PS_DpadDown.svg";case"<Gamepad>/dpad/left":return"Media/Gamepad/PS/PS_DpadLeft.svg";case"<Gamepad>/dpad/right":return"Media/Gamepad/PS/PS_DpadRight.svg";case"<Gamepad>/buttonNorth":return"Media/Gamepad/PS/PS_triangle.svg";case"<Gamepad>/buttonSouth":return"Media/Gamepad/PS/PS_X.svg";case"<Gamepad>/buttonWest":return"Media/Gamepad/PS/PS_square.svg";case"<Gamepad>/buttonEast":return"Media/Gamepad/PS/PS_O.svg";case"<Gamepad>/leftShoulder":return"Media/Gamepad/PS/PS_L1.svg";case"<Gamepad>/rightShoulder":return"Media/Gamepad/PS/PS_R1.svg";case"<Gamepad>/leftTrigger":return"Media/Gamepad/PS/PS_L2.svg";case"<Gamepad>/rightTrigger":return"Media/Gamepad/PS/PS_R2.svg";case"<Gamepad>/start":return"Media/Gamepad/PS/PS_Options.svg";case"<Gamepad>/select":return"Media/Gamepad/PS/PS_Create.svg";case"<Gamepad>/leftStickPress":return"Media/Gamepad/PS/PS_LStickPress.svg";case"<Gamepad>/rightStickPress":return"Media/Gamepad/PS/PS_RStickPress.svg";case"<Gamepad>/touchpadButton":case"<DualShockGamepad>/touchpadButton":return"Media/Gamepad/PS/PS_Touchpad.svg";default:return null}}}),[t,e])}function WS(){var e=C(ns),t=C(or);switch(e){case Gl.AutoDetect:return t;case Gl.PS:return Xn.PS;case Gl.Xbox:return Xn.Xbox}}function zS(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function YS(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zS(e,t,n[t])}))}return e}var XS=new Se("CHILDREN_KEY"),qS=new Se("DIALOG_KEY"),$S=function(t){var n=t.children,r=C(vI),i=C(gI),o=null!=r&&null==i;return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(_p,{excludes:[],disabled:!o,children:(0,e.jsxs)(Ze,{focused:null!=r?qS:XS,children:[(0,e.jsx)(He,{focusKey:XS,children:n}),null!=r&&(0,e.jsx)(kc,{children:(0,e.jsx)(He,{focusKey:qS,children:null==i?(0,e.jsx)(QS,{binding:r,onClose:yI}):(0,e.jsx)(ZS,{binding:i.binding,conflicts:i.conflicts,onConfirmSwap:i.canSwap?bI:void 0,onConfirmUnset:i.canUnset?xI:void 0,onClose:yI})})},"inputRebindingDialog")]})})})},QS=function(t){var n=t.binding,r=t.onClose,i=cr(),o=WS();return(0,e.jsx)(el,{children:(0,e.jsx)(wn,{disabled:"Gamepad"===n.group,onAction:r,children:(0,e.jsx)($r,{theme:Qr,className:Il.dialog,header:(0,e.jsx)(Tl,{onCloseOverride:"Mouse"!==n.group?r:void 0,children:(0,e.jsx)(Ks.Options.INPUT_REBIND_TITLE,{BINDING:(0,e.jsx)(Ks.Options.OPTION,{hash:n.title})})}),children:(0,e.jsx)("div",{className:Il.message,children:(0,e.jsx)(fI,{theme:Il,children:i&&o===Xn.PS?(0,e.jsx)(Ks.Options.INPUT_REBIND_PROMPT_PS,{hash:n.group}):(0,e.jsx)(Ks.Options.INPUT_REBIND_PROMPT,{hash:n.group})})})})})})},ZS=function(t){var n=t.binding,r=t.conflicts,i=t.onConfirmSwap,o=t.onConfirmUnset,a=t.onClose,l=WS(),s={BINDING:(0,e.jsx)(Ks.Options.OPTION,{hash:n.title}),CONTROL:(0,e.jsx)(BT,{group:n.group,path:n.path,gamepadType:l})};return(0,e.jsx)(el,{children:(0,e.jsx)(wn,{onAction:a,children:(0,e.jsxs)($r,{theme:Qr,className:Il.dialog,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Options.INPUT_CONFLICT_TITLE,{})}),onClose:yI,children:[(0,e.jsx)("div",{className:Il.message,children:(0,e.jsx)(fI,{theme:Il,children:null!=i?(0,e.jsx)(Ks.Options.INPUT_CONFLICT_PROMPT,YS({},s)):(0,e.jsx)(Ks.Options.INPUT_CONFLICT_NO_RESOLUTION,YS({},s))})}),(0,e.jsx)("div",{className:Il.errorDetails,children:(0,e.jsx)(mf,{className:Il.content,children:r.map((function(t,n){return(0,e.jsx)("div",{children:(0,e.jsx)(Ks.Options.OPTION,{hash:t.title})},n)}))})}),(0,e.jsx)(Fn,{initialFocused:"cancel",children:(0,e.jsxs)("div",{className:Il.buttonsVertical,children:[null!=i&&(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:i,children:(0,e.jsx)(Ks.Options.SWAP_BINDINGS,{})}),null!=o&&(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:o,children:(0,e.jsx)(Ks.Options.UNSET_BINDINGS,{})}),(0,e.jsx)(ml,{focusKey:"cancel",theme:Ad,className:Oe()(Il.button,Ad.negative),onSelect:a,children:(0,e.jsx)(Ks.Common.CANCEL,{})})]})})]})})})};function JS(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,i.useEffect)((function(){if(t){var n=0,r=function(){e(),n=window.requestAnimationFrame(r)};return n=window.requestAnimationFrame(r),function(){return window.cancelAnimationFrame(n)}}}),[e,t])}var ew=function(t){var n=t.children,r=cr(),o=C(Zn);return JS((0,i.useCallback)((function(){!function(e){N(qn,"onGamepadPointerEvent",e)}(document.elementFromPoint(o.x,o.y)!==document.body)}),[o.x,o.y]),r),(0,e.jsx)(e.Fragment,{children:n})},tw=function(t){var n=t.children,r=t.activeUiClassName,o=C($l);(0,i.useEffect)((function(){return function(e){for(var t=document.body.classList.length-1;t>=0;t--){var n=document.body.classList[t];n.startsWith("style--")&&document.body.classList.remove(n)}document.body.classList.add("style--"+e)}(o)}),[o]);var a=C(Ql);(0,i.useEffect)((function(){return function(e){var t=1-.75*bE(e,1);document.documentElement.style.setProperty("--panelOpacityNormal",t.toString().replace(",","."));var n=bE(t,.66);document.documentElement.style.setProperty("--panelOpacityDark",n.toString().replace(",",".")),0===e?document.body.classList.add("no-panel-blur"):document.body.classList.remove("no-panel-blur")}(a)}),[a]);var l=C(Jl);(0,i.useEffect)((function(){return xE(l)}),[l]);var s=C(Zl);return(0,i.useEffect)((function(){return e=s,void(document.documentElement.style.fontSize=e?"":"1px");var e}),[s]),nw(r),function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];(0,i.useEffect)((function(){if(e){var t=function(e){82!==e.keyCode&&116!==e.keyCode||!e.metaKey&&!e.ctrlKey||window.location.reload()};return window.addEventListener("keydown",t),function(){return window.removeEventListener("keydown",t)}}}),[e])}(false),(0,e.jsx)(je,{children:(0,e.jsx)(ew,{children:(0,e.jsx)(vE,{children:(0,e.jsx)(xf,{children:(0,e.jsx)(Dl,{children:(0,e.jsx)(VT,{children:(0,e.jsx)(kT,{children:(0,e.jsxs)($S,{children:[n,false]})})})})})})})})};function nw(e){var t=C(X);Of("".concat(t," ").concat(e))}function rw(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function iw(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ow(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){iw(e,t,n[t])}))}return e}function aw(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function lw(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return rw(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return rw(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var sw={default:"Overpass","ru-RU":"Noto Sans","ko-KR":"Noto Sans KR","ja-JP":"Noto Sans JP","zh-HANS":"Noto Sans SC","zh-HANT":"Noto Sans TC"},cw=function(t){var n=t.children,r=C(Xf),o=C(ls),a=C(Q),l=(0,i.useMemo)((function(){return function(e){switch(e){case Kf.Id:return dw;case Kf.Fallback:return fw;default:return uw}}(r)}),[r]),s=lw((0,i.useState)({translate:l,unitSettings:o}),2),c=s[0],u=s[1];return(0,i.useEffect)((function(){return u((function(e){return aw(ow({},e),{unitSettings:o})}))}),[o]),(0,i.useEffect)((function(){var e=qf.subscribe((function(){return u((function(e){return ow({},e)}))}));return function(){return e.dispose()}}),[]),k_.defaults.font.family=sw[a]||sw.default,function(e){Of("locale-".concat(e))}(a),(0,e.jsx)(ys.Provider,{value:c,children:n})};function uw(e,t){var n=a().translate(e);return n===e?null!=t?t:null:n}function dw(e,t){return e}function fw(e,t){return null!=t?t:null}const hw={button:"button_Ylt"},mw={button:"button_Yp5"};var pw="paradox",vw=E(pw,"requestActive"),gw=E(pw,"loggedIn"),yw=E(pw,"accountLinkState"),bw=E(pw,"accountLinkProvider"),xw=E(pw,"userName"),_w=E(pw,"hasInternetConnection"),jw=E(pw,"pdxSDKEnabled");function Ew(){N(pw,"linkAccount")}function Ow(){N(pw,"unlinkAccount")}function Tw(){N(pw,"logout")}var Iw,Sw=E(pw,"activeDialogs");function ww(){N(pw,"closeActiveDialog")}function Nw(){N(pw,"showLoginForm")}!function(e){e.Login="Game.UI.Menu.ParadoxBindings+LoginDialog",e.Registration="Game.UI.Menu.ParadoxBindings+RegistrationDialog",e.AccountLink="Game.UI.Menu.ParadoxBindings+AccountLinkDialog",e.AccountLinkOverwrite="Game.UI.Menu.ParadoxBindings+AccountLinkOverwriteDialog",e.LegalDocument="Game.UI.Menu.ParadoxBindings+LegalDocumentDialog",e.Confirmation="Game.UI.Menu.ParadoxBindings+ConfirmationDialog",e.Error="Game.UI.Menu.ParadoxBindings+ErrorDialog"}(Iw||(Iw={}));var Pw,Cw=E(pw,"countryCodes");function Aw(){N(pw,"showRegistrationForm")}function Lw(e){N(pw,"showLink",e)}function Mw(){N(pw,"confirmAccountLink")}function Rw(){N(pw,"confirmAccountLinkOverwrite")}function kw(){N(pw,"markLegalDocumentAsViewed")}function Dw(){N(pw,"showTermsOfUse")}function Uw(){N(pw,"showPrivacyPolicy")}!function(e){e[e.hidden=0]="hidden",e[e.unlinked=1]="unlinked",e[e.linked=2]="linked"}(Pw||(Pw={}));const Fw="paradox-dialog_wt7",Gw="wide_h40",Vw="header_G7_",Bw="close-button_FeS",Hw="content_hZD",Kw="form-container_Lw7",Ww="icon-row_rFk",zw="icon_Bz_",Yw="title_dnP",Xw="button-row_tSi",qw="flex-row_a_W",$w="form-row_LB0",Qw="form-row-label_xO0",Zw="light-field_CGM",Jw="dark-field_bE7",eN="form-field_D62",tN="invalid_LPr",nN="forgot-password-link_Wch",rN="day-field_fHK",iN="month-field_Um1",oN="year-field_l7n",aN="labeled-toggle_Hn2",lN="toggle_Zwc",sN="hint_PBH",cN="label_Ujn",uN="terms_p0E",dN="divider_ms0",fN="document-scrollable_EHj",hN="document-text_T4G";var mN=function(t){var n=t.wide,r=t.onClose,i=t.children,o=cr();return(0,e.jsx)(wn,{onAction:r,children:(0,e.jsxs)("div",{className:Oe()(Fw,n&&Gw),children:[(0,e.jsx)("div",{className:Vw,children:!o&&r&&(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/Close.svg",theme:_l,className:Bw,onSelect:r})}),(0,e.jsx)("div",{className:Hw,children:i})]})})},pN=function(t){var n=t.icon,r=t.titleId,i=t.messageId,o=t.messageArgs,a=t.children;return(0,e.jsx)(mN,{onClose:ww,children:(0,e.jsxs)(Fn,{children:[n&&(0,e.jsx)("div",{className:Ww,children:(0,e.jsx)("img",{src:n,className:zw})}),r&&(0,e.jsx)("div",{className:Yw,children:(0,e.jsx)(Ss,{id:r})}),i&&(0,e.jsx)("p",{children:(0,e.jsx)(Ss,{id:i,args:o})}),a]})})},vN=function(t){var n=t.type,r=t.value,o=t.placeholder,a=t.invalid,l=t.className,s=t.vkTitle,c=t.onChange,u=(0,i.useCallback)((function(e){return c(e.target.value)}),[c]);return(0,e.jsx)(Sp,{type:n,value:r,placeholder:o,vkTitle:s,className:Oe()(eN,a&&tN,l),onChange:u})},gN=function(t){var n=t.value,r=t.label,i=t.invalid,o=t.disabled,a=t.onChange;return(0,e.jsxs)(Tr,{className:aN,children:[(0,e.jsx)(pp,{checked:n,disabled:o,className:Oe()(lN,i&&tN),onChange:a}),(0,e.jsx)("div",{className:cN,children:r})]})};function yN(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bN(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function xN(){return xN=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},xN.apply(this,arguments)}function _N(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){bN(e,t,n[t])}))}return e}function jN(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function EN(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yN(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yN(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ON=new Se("CANCEL_KEY"),TN=function(t){var n=xN({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(t)),r=EN((0,i.useState)(!1),2),o=r[0],a=r[1],l=(0,i.useContext)(kl),s=(0,i.useCallback)((function(e){l.onClose(),n.dismissable?function(e,t){N(W,"dismissableConfirmationDialogCallback",e,t)}(e,o):function(e){N(W,"confirmationDialogCallback",e)}(e)}),[l,o,n.dismissable]);return"Paradox"===n.skin?(0,e.jsx)(el,{children:(0,e.jsx)(mN,{onClose:function(){return s(1)},children:(0,e.jsxs)(Fn,{children:[n.title&&(0,e.jsx)("div",{className:Il.pdxTitle,children:(0,e.jsx)(ph,{value:n.title})}),(0,e.jsx)(fI,{theme:Il,children:(0,e.jsx)(ph,{value:n.message})}),(0,e.jsx)("div",{className:Il.pdxButtonRow,children:(0,e.jsx)(IN,_N({dismissed:o,setDismissed:a,callback:s},n))})]})})}):(0,e.jsx)(Al,{title:n.title&&(0,e.jsx)(ph,{value:n.title}),buttons:(0,e.jsx)(IN,_N({dismissed:o,setDismissed:a,callback:s},n)),onClose:function(){return s(1)},children:(0,e.jsx)(fI,{theme:Il,children:(0,e.jsx)(ph,{value:n.message})})})},IN=function(t){var n=t.dismissed,r=t.setDismissed,i=t.callback,o=jN(t,["dismissed","setDismissed","callback"]);return(0,e.jsx)(wn,{onAction:function(){return i(1)},children:(0,e.jsxs)(Fn,{initialFocused:o.hasCancelAction?ON:null,children:[(0,e.jsxs)("div",{className:Il.buttons,children:[(0,e.jsx)(ml,{theme:"Paradox"===o.skin?hw:Ad,className:Oe()("Default"===o.skin&&Il.button),onSelect:function(){return i(0)},children:(0,e.jsx)(ph,{value:o.confirmAction})}),o.otherActions.map((function(t,n){return(0,e.jsx)(ml,{theme:"Paradox"===o.skin?hw:Ad,className:Oe()("Default"===o.skin&&Il.button),onSelect:function(){return i(n+2)},children:(0,e.jsx)(ph,{value:t})},n)})),o.hasCancelAction&&(0,e.jsx)(ml,{focusKey:ON,theme:"Paradox"===o.skin?mw:Ad,className:Oe()("Default"===o.skin&&Il.button,"Default"===o.skin&&Ad.negative),onSelect:function(){return i(1)},children:(0,e.jsx)(ph,{value:o.cancelAction})})]}),o.dismissable&&(0,e.jsxs)("div",{className:Il.footer,children:[(0,e.jsx)(pp,{checked:n,onChange:r}),(0,e.jsx)("div",{className:Il.footerLabel,children:(0,e.jsx)(Ks.Common.DONT_SHOW_AGAIN,{})})]})]})})},SN=function(t){var n=t.title,r=t.message,o=t.confirm,a=t.cancel,l=t.onConfirm,s=t.onCancel,c=t.dismissable,u=void 0!==c&&c,d=(0,i.useContext)(kl),f=EN((0,i.useState)(!1),2),h=f[0],m=f[1],p=(0,i.useCallback)((function(){d.onClose(),s&&s()}),[d,s]),v=(0,i.useCallback)((function(){d.onClose(),l(h)}),[d,h,l]);return(0,e.jsx)(wn,{onAction:p,children:(0,e.jsx)(Al,{title:n,buttons:(0,e.jsxs)(Fn,{initialFocused:ON,children:[(0,e.jsxs)("div",{className:Il.buttons,children:[(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:v,children:null!=o?o:(0,e.jsx)(Ks.Common.YES,{})}),(0,e.jsx)(ml,{focusKey:ON,theme:Ad,className:Oe()(Il.button,Ad.negative),onSelect:p,children:null!=a?a:(0,e.jsx)(Ks.Common.NO,{})})]}),u&&(0,e.jsxs)("div",{className:Il.footer,children:[(0,e.jsx)(pp,{checked:h,onChange:m}),(0,e.jsx)("div",{className:Il.footerLabel,children:(0,e.jsx)(Ks.Common.DONT_SHOW_AGAIN,{})})]})]}),onClose:p,children:(0,e.jsx)(fI,{theme:Il,children:r})})})};function wN(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function NN(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function PN(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var CN=function(t){var n=t.theme,r=t.children,i=PN(t,["theme","children"]);return(0,e.jsx)(xl,NN(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){wN(e,t,n[t])}))}return e}({},i),{theme:n,children:(0,e.jsx)("div",{className:n.label,children:r})}))};const AN={button:"button_uFa child-opacity-transition_nkS",icon:"icon_zVk",label:"label_NLv"};var LN=new Se("NO_KEY");function MN(){var t=(0,i.useContext)(Rl);return(0,i.useCallback)((function(){return t.showDialog((0,e.jsx)(RN,{}))}),[t])}var RN=function(){var t=(0,i.useContext)(kl),n=(0,i.useCallback)((function(){t.onClose(),N(Lu,"exitToMainMenu")}),[t]),r=(0,i.useCallback)((function(){t.onClose(),te()}),[t]),o=C(Xu);return(0,e.jsx)(Al,{wide:!0,title:(0,e.jsx)(Ks.Common.EXIT_DIALOG_TITLE,{}),buttons:(0,e.jsx)(Fn,{initialFocused:LN,children:(0,e.jsxs)("div",{className:Il.buttons,children:[(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:n,children:(0,e.jsx)(Ks.Common.EXIT_TO_MENU,{})}),o&&(0,e.jsx)(ml,{theme:Ad,className:Il.button,onSelect:r,children:(0,e.jsx)(Ks.Common.EXIT_TO_DESKTOP,{})}),(0,e.jsx)(ml,{focusKey:LN,theme:Ad,className:Oe()(Il.button,Ad.negative),onSelect:t.onClose,children:(0,e.jsx)(Ks.Common.CANCEL,{})})]})}),onClose:t.onClose,children:(0,e.jsx)(fI,{theme:Il,children:(0,e.jsx)(Ks.Common.EXIT_DIALOG_TEXT,{})})})};const kN={enter:"enter_eIx enter_kO6","enter-active":"enter-active_Y4y enter-active_lrI",enterActive:"enter-active_Y4y enter-active_lrI",exit:"exit_PzK exit_Von","exit-active":"exit-active_jCs exit-active_jtN",exitActive:"exit-active_jCs exit-active_jtN",base:"base_D7z"},DN="master-screen_B69";var UN=i.forwardRef((function(t,n){var r=t.focusKey,i=t.className,o=t.children;return(0,e.jsx)(He,{focusKey:r,children:(0,e.jsx)(Lr,{children:(0,e.jsx)($t,{styles:kN,children:(0,e.jsx)("div",{ref:n,className:Oe()(DN,i),children:o})})})})}));const FN="content_Y6b",GN="menu_ZQW";var VN=i.forwardRef((function(t,n){var r=t.focusKey,o=t.className,a=t.onSelectScreen,l=t.onClose,s=t.onNewMap,c=(0,i.useMemo)((function(){return{"Pause Menu":l,Back:l}}),[l]),u=MN();return(0,e.jsx)(UN,{ref:n,focusKey:r,className:o,children:(0,e.jsx)(_p,{children:(0,e.jsx)(Tn,{actions:c,children:(0,e.jsx)("div",{className:FN,children:(0,e.jsx)("div",{className:GN,children:(0,e.jsxs)(Fn,{direction:On.Vertical,children:[(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/ArrowRight.svg",theme:AN,onSelect:l,children:(0,e.jsx)(Ks.Editor.BACK_TO_EDITOR,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Pen.svg",theme:AN,onSelect:s,children:(0,e.jsx)(Ks.Editor.NEW_MAP,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Gear.svg",theme:AN,onSelect:function(){return a(HZ.options)},children:(0,e.jsx)(Ks.Menu.OPTIONS,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:AN,onSelect:u,children:(0,e.jsx)(Ks.Menu.EXIT_GAME,{})})]})})})})})})}));function BN(e,t){return(0,i.useCallback)((function(n){if(null!=n){var r=e(n);null!=r&&t(r)}}),[e,t])}function HN(e){return BN(s,e)}function KN(e){return"string"==typeof e?e:null}const WN="locked-badge_hmR";var zN=Rr({Lock:"Media/Glyphs/Lock.svg"}),YN=function(t){var n=t.style,r=t.className;return(0,e.jsx)(ll,{src:zN.Lock,className:Oe()(WN,r),style:n})};const XN="tab-bar_oPw",qN="tab_Hrb",$N="lock_F5I";function QN(t){var n=t.tabs,r=t.selectedTab,o=t.selectPreviousSound,a=void 0===o?Qt.selectPreviousItem:o,l=t.selectNextSound,s=void 0===l?Qt.selectNextItem:l,c=t.children,u=t.onSelect,d=0===n.length||1===n.length&&n[0]===r,f=(0,i.useMemo)((function(){return{"Switch Tab":function(e){if(0!==e){var t=null!=r?n.indexOf(r):-1,i=e<0?ap(n,t,!0):ip(n,t,!0);null!=i&&i!==r&&(u(i),Jt(e<0?a:s))}}}}),[u,s,a,r,n]);return(0,e.jsx)(Tn,{actions:f,disabled:d,children:c})}var ZN=function(t){var n=t.className,r=t.children;return(0,e.jsx)("div",{className:Oe()(XN,n),children:r})};function JN(t){var n=t.id,r=t.selectedId,o=t.uiTag,a=t.disabled,l=t.locked,s=t.selectSound,c=t.className,u=t.children,d=t.onSelect,f=n===r,h=(0,i.useCallback)((function(){d(n),o&&lu(o)}),[n,d,o]);return(0,e.jsx)(bS,{uiTag:o,active:!a,children:(0,e.jsxs)(ml,{focusKey:Te,disabled:a,selectSound:s,className:Oe()(qN,f&&"selected",c),onSelect:h,children:[u,l&&(0,e.jsx)(YN,{className:$N})]})})}function eP(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function tP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function nP(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function rP(e){var t=e.component,n=e.value,r=e.groupValue,o=e.onChange,a=e.onToggleSelected,l=nP(e,["component","value","groupValue","onChange","onToggleSelected"]),s=(0,i.useCallback)((function(e){e?o&&o(n):a&&a(n)}),[n,o,a]);return i.createElement(t,tP(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){eP(e,t,n[t])}))}return e}({},l),{checked:n===r,onChange:s}))}const iP={toggle:"toggle_H7r item-mouse-states_Fmi",bullet:"bullet_rDK"};function oP(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function aP(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){oP(e,t,n[t])}))}return e}function lP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function sP(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var cP=function(t){var n=t.checked,r=t.disabled,o=t.theme,a=t.style,l=t.className,s=sP(t,["checked","disabled","theme","style","className"]),c=(0,i.useMemo)((function(){return aP({},iP,o)}),[o]);return(0,e.jsx)(cp,lP(aP({},s),{checked:n,disabled:r,style:a,className:Oe()(c.toggle,l),children:(0,e.jsx)("div",{className:Oe()(c.bullet,n&&"checked",r&&"disabled")})}))},uP=i.createContext({onOptionMouseEnter:function(){},onOptionMouseLeave:function(){}});const dP={field:"field_amr field_cjf",label:"label_VSW label_T__"};function fP(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var hP,mP,pP=(hP=function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){fP(e,t,n[t])}))}return e}({},hl),mP=null!=(mP={hover:null,focus:null})?mP:{},Object.getOwnPropertyDescriptors?Object.defineProperties(hP,Object.getOwnPropertyDescriptors(mP)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(mP)).forEach((function(e){Object.defineProperty(hP,e,Object.getOwnPropertyDescriptor(mP,e))})),hP),vP=function(t){var n=t.id,r=t.label,o=t.theme,a=void 0===o?dP:o,l=t.disabled,s=t.className,c=t.children,u=t.onClick,d=(0,i.useContext)(uP),f=(0,i.useCallback)((function(){n&&d.onOptionMouseEnter(n),Jt(Qt.hoverItem)}),[n,d]),h=(0,i.useCallback)((function(){return n&&d.onOptionMouseLeave(n)}),[n,d]),m=(0,i.useCallback)((function(e){!l&&u&&u(e)}),[l,u]);return(0,e.jsxs)(Tr,{focusKey:l?Te:n,focusSound:Qt.hoverItem,className:Oe()(a.field,l&&"disabled",s),onMouseEnter:f,onMouseLeave:h,onClick:m,children:[(0,e.jsx)("div",{className:a.label,children:null!=r?r:null!=n&&(0,e.jsx)(Ks.Options.OPTION,{hash:n})}),c]})};const gP="toggle_ATa",yP="radio-toggle_TY5 toggle_H7r item-mouse-states_Fmi",bP="bullet_DoE bullet_rDK";function xP(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _P(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xP(e,t,n[t])}))}return e}function jP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function EP(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var OP=function(t){var n=t.value,r=t.disabled,o=t.onChange,a=EP(t,["value","disabled","onChange"]),l=(0,i.useCallback)((function(){o(!n)}),[o,n]);return(0,e.jsx)(vP,jP(_P({},a),{onClick:l,disabled:r,children:(0,e.jsx)(pp,{checked:n,className:gP,onChange:o,disabled:r})}))};function TP(t){var n=t.value,r=t.groupValue,o=t.disabled,a=t.onChange,l=t.onToggleSelected,s=EP(t,["value","groupValue","disabled","onChange","onToggleSelected"]),c=(0,i.useCallback)((function(){a(n)}),[a,n]);return(0,e.jsx)(vP,jP(_P({},s),{onClick:c,disabled:o,children:(0,e.jsx)(rP,{theme:{toggle:yP,bullet:bP},component:cP,onChange:a,onToggleSelected:l,value:n,groupValue:r,disabled:o,className:yP})}))}const IP={enter:"enter_vUK enter_kO6","enter-active":"enter-active_K1n enter-active_lrI",enterActive:"enter-active_K1n enter-active_lrI",exit:"exit_NNr exit_Von","exit-active":"exit-active_kYK exit-active_jtN",exitActive:"exit-active_kYK exit-active_jtN",base:"base_V9Q"},SP="sub-screen__iU",wP="header_DFK child-opacity-transition_nkS",NP="title_TgD",PP="header-button_Hid",CP="back-button_sEa header-button_Hid",AP="content_Ds0",LP="header-aside_Pkh";var MP=new Se("CONTENT_KEY"),RP=i.forwardRef((function(t,n){var r=t.focusKey,i=t.title,o=t.header,a=t.className,l=t.children,s=t.onClose;nn(tn);var c=cr();return(0,e.jsx)(He,{focusKey:r,children:(0,e.jsx)(Lr,{children:(0,e.jsx)(wn,{onAction:s,children:(0,e.jsx)($t,{styles:IP,children:(0,e.jsx)(Tr,{ref:n,className:Oe()(SP,a),children:(0,e.jsxs)(Fn,{initialFocused:MP,children:[(0,e.jsxs)("div",{className:wP,children:[!c&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Menu.BACK,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/TriangleArrowLeft.svg",className:CP,onSelect:s})}),(0,e.jsx)("div",{className:NP,children:i}),!!o&&(0,e.jsx)("div",{className:LP,children:o})]}),(0,e.jsx)(Tr,{focusKey:MP,className:AP,children:l})]})})})})})})}));const kP="empty-state_GEy";var DP=function(t){var n=t.children,r=t.className;return(0,e.jsx)("div",{className:Oe()(kP,r),children:n})};const UP="label_sAz";var FP=function(t){var n=t.props,r=(0,e.jsx)("div",{className:Oe()(UP,"label-level-"+n.level),children:(0,e.jsx)(ph,{value:n.displayName})});return n.tooltip?(0,e.jsx)(xO,{tooltip:(0,e.jsx)(ph,{value:n.tooltip}),children:r}):r};const GP="breadcrumbs_xcd";var VP=function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({},hh.Label,FP);const BP={button:"button_WWa",icon:"icon_OPJ",label:"label_vrX"},HP="buttons_hd7",KP="button_SH8";function WP(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zP(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){WP(e,t,n[t])}))}return e}function YP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var XP=function(t){var n=t.children;return(0,e.jsx)("div",{className:HP,children:n})},qP=function(t){var n=xh(Th,Mh(t.parent,t.path));return(0,e.jsx)($P,{id:t.path,disabled:t.props.disabled,onSelect:n,confirmationMessage:null!=t.props.confirmationMessage?(0,e.jsx)(ph,{value:t.props.confirmationMessage}):null,children:(0,e.jsx)(ph,{value:t.props.displayName})})},$P=function(t){var n=t.id,r=t.disabled,o=t.confirmationMessage,a=t.children,l=t.onSelect,s=(0,i.useContext)(Rl),c=(0,i.useContext)(uP),u=(0,i.useCallback)((function(){"string"==typeof n&&c.onOptionMouseEnter(n)}),[n,c]),d=(0,i.useCallback)((function(){"string"==typeof n&&c.onOptionMouseLeave(n)}),[n,c]),f=(0,i.useCallback)((function(){null!=o?s.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:o,onConfirm:l})):l()}),[s,o,l]);return(0,e.jsx)(ml,{focusKey:n,disabled:r,theme:BP,className:KP,onSelect:f,onMouseEnter:u,onMouseLeave:d,children:a})};const QP="divider_wuh";var ZP=function(){return(0,e.jsx)("div",{className:QP})},JP=i.createContext(!0),eC=function(t){var n=t.visible,r=t.direction,o=void 0===r?"down":r,a=t.minHeight,l=void 0===a?0:a,s=t.minWidth,c=void 0===s?0:s,u=t.className,d=t.content,f=t.children,h=(0,i.useRef)(null),m=(0,i.useRef)(null),p=Gd(h,n),v=Gd(m,n&&null!=m),g=zd(n),y=qd(),b=(0,i.useMemo)((function(){var e=l*y,t=!0===c?(null==p?void 0:p.width)||0:c*y;return n&&null!=p?function(e,t,n,r,i,o){var a=t.y-e.bottom,l=e.top;r>0&&("down"===n&&a<r&&a<l?n="up":l<r&&l<a&&(n="down"));var s=null!=o?Math.max(e.left+o.width-t.x,0):0;return"up"===n?{position:"absolute",left:e.left-s,bottom:t.y-e.top,maxHeight:l,minWidth:i,visibility:o&&o.width>0?"inherit":"hidden"}:{position:"absolute",left:e.left-s,top:e.bottom,maxHeight:a,minWidth:i,visibility:o&&o.width>0?"inherit":"hidden"}}(p,g,o,e,t,v):tC}),[l,y,c,p,n,g,o,v]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(zn,{ref:h,children:f}),n&&(0,e.jsx)(kc,{children:(0,e.jsx)(JP.Provider,{value:n&&null!=p,children:(0,e.jsx)("div",{className:u,style:b,ref:m,children:d})})},"popup")]})},tC={position:"absolute",visibility:"hidden"};const nC="pointer-barrier_etG";var rC=function(t){var n=t.onClick;return(0,e.jsx)(kc,{children:(0,e.jsx)("div",{className:nC,onClick:n})})};const iC={hiddenIcon:'"Media/Glyphs/StrokeArrowDown.svg"',visibleIcon:'"Media/Glyphs/StrokeArrowUp.svg"',"dropdown-toggle":"dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_prl",label:"label_l_4","dropdown-popup":"dropdown-popup_mMv",dropdownPopup:"dropdown-popup_mMv","dropdown-menu":"dropdown-menu_Swd",dropdownMenu:"dropdown-menu_Swd"},oC={"dropdown-toggle":"dropdown-toggle_bN9",dropdownToggle:"dropdown-toggle_bN9",label:"label_REA",indicator:"indicator_lzV","dropdown-popup":"dropdown-popup_duR",dropdownPopup:"dropdown-popup_duR","dropdown-menu":"dropdown-menu_rL4",dropdownMenu:"dropdown-menu_rL4",scrollable:"scrollable_MVT","dropdown-item":"dropdown-item_t3P",dropdownItem:"dropdown-item_t3P"};function aC(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function lC(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sC(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return aC(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return aC(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var cC=i.createContext({visible:!1,theme:oC,show:function(){},hide:function(){},toggle:function(){}}),uC=new Se("DROPDOWN_TOGGLE"),dC=new Se("DROPDOWN_MENU"),fC=function(t){var n=t.focusKey,r=t.initialFocused,o=t.theme,a=void 0===o?oC:o,l=t.content,s=t.children,c=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){lC(e,t,n[t])}))}return e}({},iC,a)}),[a]),u=sC((0,i.useState)(!1),2),d=u[0],f=u[1],h=(0,i.useRef)(null),m=(0,i.useMemo)((function(){return{visible:d,theme:c,show:function(){return f(!0)},hide:function(){return f(!1)},toggle:function(){return f((function(e){return!e}))}}}),[d,c]);(0,i.useEffect)((function(){if(d){var e=function(e){if(h.current){var t=h.current.getBoundingClientRect();(e.clientX<t.left||e.clientX>t.right||e.clientY<t.top||e.clientY>t.bottom)&&f(!1)}};return document.addEventListener("mousedown",e),function(){return document.removeEventListener("mousedown",e)}}}),[d]);var p=(0,e.jsx)(Or,{className:null==c?void 0:c.dropdownMenu,ref:h,children:(0,e.jsx)(Fn,{focusKey:dC,initialFocused:r,children:(0,e.jsx)(mf,{className:c.scrollable,children:l})})});return(0,e.jsxs)(e.Fragment,{children:[d&&(0,e.jsx)(rC,{onClick:m.hide}),(0,e.jsx)(_p,{includes:xp,disabled:!d,children:(0,e.jsx)(wn,{onAction:m.hide,disabled:!d,children:(0,e.jsx)(Ze,{focusKey:n,focused:d?dC:uC,activation:Ue.AnyChildren,children:(0,e.jsx)(cC.Provider,{value:m,children:(0,e.jsx)(eC,{visible:d,className:c.dropdownPopup,content:p,minHeight:300,minWidth:!0,children:(0,e.jsx)(He,{focusKey:uC,children:s})})})})})})]})};function hC(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function mC(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){hC(e,t,n[t])}))}return e}function pC(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function vC(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var gC=function(t){var n=t.theme,r=t.children,o=vC(t,["theme","children"]),a=(0,i.useContext)(cC),l=null!=n?n:a.theme;return(0,e.jsxs)(yC,pC(mC({},o),{theme:n,children:[(0,e.jsx)("div",{className:l.label,children:r}),l.indicator&&(0,e.jsxs)(e.Fragment,{children:[a.visible&&l.visibleIcon&&(0,e.jsx)(ll,{src:l.visibleIcon,className:l.indicator}),!a.visible&&l.hiddenIcon&&(0,e.jsx)(ll,{src:l.hiddenIcon,className:l.indicator})]})]}))},yC=function(t){var n=t.theme,r=t.sounds,o=t.selectSound,a=void 0===o?Qt.selectDropdown:o,l=t.className,s=t.children,c=vC(t,["theme","sounds","selectSound","className","children"]),u=(0,i.useContext)(cC),d=null!=n?n:u.theme,f=cr();return(0,e.jsx)(ml,pC(mC({},c),{focusKey:uC,className:Oe()(d.dropdownToggle,l,u.visible&&"active",u.visible&&f&&"focused"),sounds:r,selectSound:a,onSelect:u.toggle,children:s}))};function bC(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var xC=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){bC(e,t,n[t])}))}return e}({},hl),{hover:null});function _C(t){var n=t.focusKey,r=t.value,o=t.selected,a=t.theme,l=t.sounds,s=void 0===l?xC:l,c=t.className,u=t.onChange,d=t.onToggleSelected,f=t.closeOnSelect,h=void 0===f||f,m=t.children,p=(0,i.useContext)(cC),v=null!=a?a:p.theme,g=(0,i.useCallback)((function(){o?d&&d(r):u&&u(r),h&&p.hide()}),[o,h,p,u,r,d]),y=null!=n?n:"string"==typeof r||"number"==typeof r?r:void 0;return(0,e.jsx)(ml,{focusKey:y,sounds:s,className:Oe()(v.dropdownItem,o&&"selected",c),onSelect:g,children:m||" "})}const jC={"dropdown-toggle":"dropdown-toggle_V9z dropdown-toggle_prl value-field_yJi value_PW_",dropdownToggle:"dropdown-toggle_V9z dropdown-toggle_prl value-field_yJi value_PW_",indicator:"indicator_Xmj","dropdown-menu":"dropdown-menu_jf2 dropdown-menu_Swd",dropdownMenu:"dropdown-menu_jf2 dropdown-menu_Swd","dropdown-item":"dropdown-item_sZT undefined",dropdownItem:"dropdown-item_sZT undefined"},EC={field:"field_MBO field_UuC",label:"label_DGc label_ZLb"};function OC(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function TC(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){OC(e,t,n[t])}))}return e}function IC(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var SC=IC(TC({},hl),{hover:null,focus:null});var wC=function(t){var n=t.id,r=t.label,o=t.theme,a=void 0===o?EC:o,l=t.disabled,s=t.className,c=t.children,u=t.onClick,d=(0,i.useContext)(uP),f=(0,i.useCallback)((function(){"string"==typeof n&&d.onOptionMouseEnter(n),Jt(Qt.hoverItem)}),[n,d]),h=(0,i.useCallback)((function(){"string"==typeof n&&d.onOptionMouseLeave(n)}),[n,d]),m=(0,i.useCallback)((function(e){!l&&u&&u(e)}),[l,u]);return(0,e.jsxs)(Tr,{focusKey:l?Te:n,focusSound:Qt.hoverItem,className:Oe()(a.field,l&&"disabled",s),onMouseEnter:f,onMouseLeave:h,onClick:m,children:[(0,e.jsx)("div",{className:a.label,children:r}),c]})};const NC="dropdown_iVn";function PC(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function CC(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){PC(e,t,n[t])}))}return e}function AC(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function LC(t){return(0,e.jsx)(MC,CC({items:t.props.items,value:t.props.value},t))}function MC(t){var n=t.items.findIndex((function(e){return f(e.value,t.value)})),r=-1!==n?t.items[n]:null,i=xh(Ih,Mh(t.parent,t.path));return(0,e.jsx)(wC,AC(CC({},t.props),{id:t.path,label:(0,e.jsx)(ph,{value:t.props.displayName}),children:(0,e.jsx)(fC,{focusKey:t.props.disabled?Te:Ie,initialFocused:n,theme:jC,content:t.items.filter((function(e){return!e.disabled})).map((function(t,n){return(0,e.jsx)(_C,{focusKey:n,value:t.value,selected:!!r&&f(r.value,t.value),onChange:i,children:RC(t)},n)})),children:(0,e.jsx)(gC,{disabled:t.props.disabled,sounds:SC,className:NC,children:RC(r)})})}))}function RC(t){return t?(0,e.jsx)(ph,{value:t.displayName}):null}const kC="field_G2v value-field_yJi",DC="value_kpD value_PW_",UC="unset_Ksk",FC="clear-button_wAo secondary-button_Kvj";function GC(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function VC(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){GC(e,t,n[t])}))}return e}function BC(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function HC(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var KC=function(t){var n=t.group,r=(t.canBeEmpty,t.value),o=t.disabled,a=t.onSelect,l=t.onUnset,s=HC(t,["group","canBeEmpty","value","disabled","onSelect","onUnset"]),c=(0,i.useMemo)((function(){return{"Unset Binding":l}}),[l]),u=cr(),d=WS();return(0,e.jsx)(Tn,{actions:c,children:(0,e.jsx)(wC,BC(VC({},s),{disabled:o,onClick:a,children:(0,e.jsxs)("div",{className:Oe()(kC,0===r.length&&UC),children:[(0,e.jsx)(ml,{className:DC,onSelect:a,onClick:Cm,children:(0,e.jsx)(BT,{group:n,path:r,gamepadType:d})}),!u&&null!=l&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Options.UNSET_BINDING_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/Close.svg",className:FC,onSelect:l,onClick:Cm})})]})}))})};const WC="modding-toolchain-button_P4o",zC="status_jJW",YC="button_Mw_",XC="progress-circle_Pxf",qC={strokeWidth:"10","progress-circle":"progress-circle_jQu progress-circle_OLN",progressCircle:"progress-circle_jQu progress-circle_OLN",circle:"circle_Rpd",progress:"progress_PiA progress_mlv"};function $C(t,n){switch(t){case Fl.Bar:return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:zC,children:(0,e.jsx)(dc,{value:100*n,unit:tc.Percentage})}),(0,e.jsx)("div",{className:XC,children:(0,e.jsx)(zE,{progress:n,max:1,theme:qC})})]});case Fl.Spin:return(0,e.jsx)("div",{className:XC,children:(0,e.jsx)(zE,{progress:100,max:100,indeterminate:!0,theme:qC})});default:return null}}var QC=function(t){var n=t.id,r=t.state,o=t.disabled,a=t.onSelect,l=(0,i.useCallback)((function(){a(n)}),[n,a]),s=(0,i.useContext)(uP),c=(0,i.useCallback)((function(){return s.onOptionMouseEnter("ModdingToolchain.".concat(Bl[r]))}),[s,r]),u=(0,i.useCallback)((function(){return s.onOptionMouseLeave("ModdingToolchain.".concat(Bl[r]))}),[s,r]);return(0,e.jsx)(ml,{focusKey:"ModdingToolchain",disabled:o,theme:BP,className:YC,onSelect:l,onMouseEnter:c,onMouseLeave:u,children:(0,e.jsx)(Ks.Options.OPTION,{hash:"ModdingToolchain.".concat(Bl[r])})})};function ZC(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function JC(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ZC(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZC(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var eA=function(t){var n=t.children,r=JC((0,i.useState)(!1),2),o=r[0],a=r[1],l=pn("SelectableFocusBoundary",!0,o);xn(l,(0,i.useCallback)((function(e){e||a(!1)}),[]));var s=(0,i.useMemo)((function(){return{Select:function(){return a(!o)},Back:o?function(){return a(!1)}:null}}),[o]);return(0,e.jsx)(_p,{includes:xp,disabled:!o,children:(0,e.jsx)(Tn,{actions:s,children:(0,e.jsx)(Be,{controller:l,children:n})})})};const tA={slider:"slider_fKm slider_pUS",range:"range_KXa range_iUN"},nA="value_hdd",rA="slider_KjX";function iA(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function oA(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){iA(e,t,n[t])}))}return e}function aA(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var lA=function(t){var n,r=(0,i.useMemo)((function(){return Object.values(tc).find((function(e){return e===t.props.unit}))}),[t.props.unit]),o=Bm(null!==(n=t.props.step)&&void 0!==n?n:1),a=t.props.scaleDragVolume?Um:Dm,l=xh(Ih,Mh(t.parent,t.path));return(0,e.jsxs)(wC,aA(oA({},t.props),{id:t.path,label:(0,e.jsx)(ph,{value:t.props.displayName}),children:[(0,e.jsx)("div",{className:nA,children:(0,e.jsx)(dc,{value:t.props.value,unit:r})}),(0,e.jsx)(eA,{children:(0,e.jsx)(Fm,{value:t.props.value,start:t.props.min,end:t.props.max,gamepadStep:t.props.step,disabled:t.props.disabled,valueTransformer:o,sounds:a,theme:tA,className:rA,onChange:l})})]}))};const sA="toggle_th_";function cA(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function uA(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function dA(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fA(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){dA(e,t,n[t])}))}return e}function hA(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var mA,pA=function(t){var n=t.parent,r=t.data,o=(0,i.useMemo)((function(){var e,t=-1;return r.reduce((function(r,i,o){if(i.props.__Type===hh.Label){var a=i.props.level,l=n+".breadcrumbs."+o;0===a?(e=hA(fA({},i),{path:l,props:{__Type:hh.Breadcrumbs},children:[hA(fA({},i),{path:l+"."+o})]}),r.push(e)):e&&a===t?(e=hA(fA({},e),{path:l,children:e.children.filter((function(e){return e.props.level!==a})).concat(i)}),r.push(e)):null==e||e.children.push(hA(fA({},i),{path:l+"."+o})),t=a}else r.push(i);return r}),[])}),[r,n]);return(0,e.jsx)(Yh,{parent:n,components:vA,data:o})},vA=(dA(mA={},hh.Button,(function(t){return(0,e.jsx)(XP,{children:(0,e.jsx)(qP,zP({},t))})})),dA(mA,hh.ButtonRow,(function(t){var n=Mh(t.parent,t.path);return(0,e.jsx)(XP,{children:t.children.map((function(e){return(0,i.createElement)(qP,YP(zP({},e),{key:e.path,parent:n,path:e.path}))}))})})),dA(mA,Cl.ButtonWithConfirmation,(function(t){return(0,e.jsx)(XP,{children:(0,e.jsx)(qP,zP({},t))})})),dA(mA,hh.FloatSliderField,(function(t){return(0,e.jsx)(lA,oA({},t))})),dA(mA,hh.IntSliderField,(function(t){return(0,e.jsx)(lA,oA({},t))})),dA(mA,hh.Divider,ZP),dA(mA,hh.Label,FP),dA(mA,hh.Breadcrumbs,(function(t){var n=t.children,r=t.parent;return(0,e.jsx)("div",{className:GP,children:(0,e.jsx)(Yh,{parent:r,data:n,components:VP})})})),dA(mA,hh.ToggleField,(function(t){var n=xh(Ih,Mh(t.parent,t.path)),r=(0,i.useCallback)((function(){Jt(Qt.selectToggle),n(!t.props.value)}),[n,t.props.value]);return(0,e.jsx)(wC,uA(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){cA(e,t,n[t])}))}return e}({},t.props),{id:t.path,label:(0,e.jsx)(ph,{value:t.props.displayName}),onClick:r,children:(0,e.jsx)(pp,{checked:t.props.value,className:sA,onChange:n,disabled:t.props.disabled})}))})),dA(mA,hh.EnumField,(function(t){return(0,e.jsx)(MC,CC({items:t.props.enumMembers,value:t.props.value},t))})),dA(mA,Cl.InputBindingField,(function(t){var n=Mh(t.parent,t.path),r=xh(ss,n),i=xh(cs,n);return(0,e.jsx)(KC,BC(VC({},t.props),{id:t.path,label:(0,e.jsx)(ph,{value:t.props.displayName}),onSelect:r,onUnset:t.props.canBeEmpty?i:void 0}))})),dA(mA,Cl.DropdownField,LC),dA(mA,Cl.ModdingToolchainButton,(function(t){var n=C(rs),r=C(is),i=C(as),o=C(os),a=xh(Th,Mh(t.parent,t.path));return(0,e.jsxs)("div",{className:WC,children:[o!==Vl.Idle&&(0,e.jsx)("div",{className:zC,children:(0,e.jsx)(Ks.Options.MOD_TOOLCHAIN_STATUS,{hash:Vl[o]})}),$C(r,n),(0,e.jsx)(QC,{id:t.path,state:i,disabled:t.props.disabled,onSelect:a})]})})),dA(mA,hh.ValueField,(function(t){return(0,e.jsx)(wC,IC(TC({},t.props),{id:t.path,label:(0,e.jsx)(ph,{value:t.props.displayName}),children:t.props.value}))})),dA(mA,Cl.ScreenResolutionDropdownField,LC),mA);const gA="option-page-header_fSe",yA="option-page-sub-header_FIo",bA="sections-tabs_EK2",xA="tab_P7S",_A="first_vLK",jA="last_BSJ";var EA=function(t){var n=t.sections,r=t.subHeader,i=t.selectedId,o=t.className,a=t.onSelect;return(0,e.jsxs)("div",{className:Oe()(gA,o),children:[n.length>1?(0,e.jsx)("div",{className:Oe()(bA),children:n.map((function(t,r){return(0,e.jsx)(ml,{focusKey:Te,selected:i===t.id,className:Oe()(xA,0===r&&_A,r===n.length-1&&jA),onSelect:function(){return a(t.id)},children:(0,e.jsx)(Ks.Options.TAB,{hash:t.id})},r)}))}):(0,e.jsx)("div",{}),!!r&&(0,e.jsx)("div",{className:yA,children:r})]})};const OA={"option-page":"option-page_CW8",optionPage:"option-page_CW8","main-column":"main-column_D0A",mainColumn:"main-column_D0A",scrollable:"scrollable_Ptf","info-column":"info-column_uQ0",infoColumn:"info-column_uQ0","info-title":"info-title_a3p",infoTitle:"info-title_a3p","info-description":"info-description_wwd",infoDescription:"info-description_wwd"};function TA(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function IA(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return TA(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return TA(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var SA=function(t){var n=t.page,r=t.selectedSectionId,o=t.className,a=t.isSearch,l=t.subHeader,s=t.onSelectSection,c=n.sections.find((function(e){return e.id===r})),u=IA((0,i.useState)(!1),2),d=u[0],f=u[1],h=IA((0,i.useState)(null),2),m=h[0],p=h[1],v=(0,i.useCallback)((function(e){"string"==typeof e&&p(e)}),[]),g=cr(),y=IA((0,i.useState)(null),2),b=y[0],x=y[1],_=null!=b?b:d&&g?m:null,j=(0,i.useMemo)((function(){return{onOptionMouseEnter:function(e){x(e)},onOptionMouseLeave:function(e){x((function(t){return t===e?null:t}))}}}),[]),E=Lh("options"),O=C(Wl);return(0,e.jsx)(Jh,{onFocusChange:f,children:(0,e.jsxs)("div",{className:Oe()(OA.optionPage,o),children:[(0,e.jsx)("div",{className:OA.mainColumn,children:(0,e.jsxs)(Fn,{children:[!a&&(l||n.sections.length>1)&&(0,e.jsx)(EA,{sections:n.sections,selectedId:r,className:OA.header,onSelect:s,subHeader:l}),a&&!O.length?(0,e.jsx)(DP,{children:(0,e.jsx)("div",{children:(0,e.jsx)(Ks.Options.SEARCH,{hash:"nothing found"})})}):(0,e.jsx)(mf,{className:OA.scrollable,children:null!=c&&(0,e.jsx)(uP.Provider,{value:j,children:(0,e.jsx)(Mn,{focused:m,direction:On.Vertical,onChange:v,onRefocus:Rn,children:(0,e.jsx)(pA,{parent:E,data:O})})})},r)]})}),(0,e.jsx)("div",{className:OA.infoColumn,children:null!=_&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:OA.infoTitle,children:(0,e.jsx)(Ks.Options.OPTION,{hash:_})}),(0,e.jsx)("div",{className:OA.infoDescription,children:(0,e.jsx)(Ks.Options.OPTION_DESCRIPTION,{hash:_})})]})})]})})};const wA="search-input_Z06",NA="search-input-clear_VxJ";function PA(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CA(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return PA(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PA(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var AA=Rr({Clear:"Media/Glyphs/Clear.svg"}),LA=function(t){var n=t.search,r=n.isSearching,i=n.focusedPage,o=n.setFocusedPage,a=n.matchingPages,l=null;if(r&&(a.size>1||i&&!a.has(i)&&a.size>0)){var s={id:"All results",sections:[]};l=(0,e.jsx)(qA,{item:s,selected:!i,onSelect:function(){i&&o(void 0)}},s.id)}return l},MA=function(t){var n=t.search,r=n.searchQuery,o=n.setSearchQuery,a=$E(),l=(0,i.useCallback)((function(e){o(e)}),[o]);return(0,e.jsxs)(Fn,{children:[(0,e.jsx)(Sp,{value:r,onChange:function(e){return o(e.target.value)},placeholder:(0,e.jsx)(Ks.Options.SEARCH,{hash:"input placeholder"}),className:Oe()(a.input,wA)}),r&&(0,e.jsx)(xl,{tinted:!0,src:AA.Clear,className:NA,onSelect:function(){return l("")}})]})};const RA="content_Mtn",kA="menu_hb1 child-opacity-transition_nkS",DA="scrollable_Fma",UA="item_pq7",FA="primary_Q54",GA="detail_eTp child-opacity-transition_nkS",VA="option-section_VzQ",BA="advanced-toggle_fyX",HA="advanced-toggle-checked_FFb";function KA(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function WA(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zA(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return KA(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return KA(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var YA=new Se("menu"),XA=i.forwardRef((function(t,n){var r=t.focusKey,o=t.className,a=t.onClose,l=C(Kl),s=C(zl),c=l.find((function(e){return e.id===s})),u=C(Yl),d=null==c?void 0:c.sections.find((function(e){return e.id===u})),f=C(Wl),h=zA((0,i.useState)(!1),2),m=h[0],p=h[1],v=function(){var e=bs(),t=C(Kl),n=CA((0,i.useState)(""),2),r=n[0],o=n[1],a=CA((0,i.useState)(),2),l=a[0],s=a[1],c=CA((0,i.useState)((function(){return new Set})),2),u=c[0],d=c[1],f=(0,i.useCallback)((function(e){e.length<2&&s(void 0),o(e)}),[]);return(0,i.useEffect)((function(){var n=[],i=new Set;r.length>=2?(t.forEach((function(t){return t.sections.forEach((function(o){o.items.forEach((function(o){if("id"in o.displayName&&!o.searchHidden){var a,s=null===(a=e.translate(o.displayName.id||""))||void 0===a?void 0:a.toLowerCase();(null==s?void 0:s.includes(r.trim().toLowerCase()))&&(l&&t.id!==l||n.push(o.id),i.add(t.id))}}))}))})),ds(n,r),d(i)):(ds([]),d(i))}),[t,r,l,e]),{setSearchQuery:f,searchQuery:r,matchingPages:u,focusedPage:l,setFocusedPage:s,isSearching:r.length>=2}}(),g=v.isSearching,y=v.setSearchQuery,b=v.focusedPage,x=v.setFocusedPage,_=v.matchingPages,j=(0,i.useCallback)((function(){y(""),a()}),[a,y]),E=(0,i.useCallback)((function(e){var t,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"",r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=l.find((function(t){return t.id===e})),o=n||null!=i&&i.sections.length>0?null===(t=null==i?void 0:i.sections[0])||void 0===t?void 0:t.id:null;i&&(g?x(i.id):o&&b!==i.id&&us(i.id,o,r))}),[b,g,l,x]),O=(0,i.useCallback)((function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(c){var n=c.sections.find((function(t){return t.id===e}));n&&us(c.id,n.id,t)}}),[c]);(0,i.useEffect)((function(){var e=f.filter((function(e){return e.props.__Type!==hh.Breadcrumbs})).reduce((function(e,t){return e+(t.props.__Type===hh.ButtonRow?t.children.length:1)}),0)===(null==d?void 0:d.items.length);p(e)}),[f,s,null==d?void 0:d.items,u]);var T=BN(KN,E),I=(0,i.useCallback)((function(e){u&&(p(e),O(u,e))}),[O,u]),S=(0,i.useMemo)((function(){return null!=c?c.sections.map((function(e){return e.id})):[]}),[c]),w=(0,i.useMemo)((function(){var e;return!!(null===(e=null==c?void 0:c.sections.find((function(e){return e.id===u})))||void 0===e?void 0:e.items.some((function(e){return e.isAdvanced})))}),[c,u]);return(0,e.jsx)(RP,{ref:n,focusKey:r,title:(0,e.jsx)(Ks.Options.SCREEN_TITLE,{}),className:o,onClose:j,header:(0,e.jsx)(MA,{search:v}),children:(0,e.jsx)("div",{className:RA,children:(0,e.jsx)(QN,{tabs:S,selectedTab:u,onSelect:O,children:(0,e.jsxs)(Fn,{initialFocused:YA,direction:On.Horizontal,children:[(0,e.jsx)(Or,{className:kA,children:(0,e.jsx)(mf,{className:DA,children:(0,e.jsxs)(Mn,{focusKey:YA,focused:s,direction:On.Vertical,onChange:T,children:[(0,e.jsx)(LA,{search:v}),l.filter((function(e){return!g||_.has(e.id)||b===e.id})).map((function(t,n,r){return(0,e.jsx)(qA,{item:t,selected:b===t.id||!g&&s===t.id||1===r.length,onSelect:E},t.id)}))]})})}),(0,e.jsx)(Or,{className:GA,children:null!=c&&(0,e.jsx)(SA,{page:c,selectedSectionId:u,onSelectSection:O,className:VA,isSearch:g,subHeader:w&&(0,e.jsx)(OP,{label:(0,e.jsx)(Ks.Options.SEARCH,{hash:m?"hide advanced":"show advanced"}),value:m,onChange:I,className:Oe()(BA,WA({},HA,m))})},s)})]})})})})})),qA=function(t){var n=t.item,r=t.selected,o=t.suffix,a=t.onSelect,l=(0,i.useCallback)((function(){return a(n.id)}),[n.id,a]),s=cr();return(0,e.jsxs)(ml,{focusKey:n.id,selected:r,className:Oe()(UA,!s&&FA),onSelect:l,children:[(0,e.jsx)("span",{children:(0,e.jsx)(Ks.Options.SECTION,{hash:n.id})}),o&&(0,e.jsx)("span",{children:o})]})};const $A={base:"base_KL3",enter:"enter_VtK","exit-active":"exit-active_ZDb",exitActive:"exit-active_ZDb","enter-active":"enter-active_VOn",enterActive:"enter-active_VOn",exit:"exit_qAg"},QA="pause-menu_uzz menu-theme_k91",ZA="content-container_Ake",JA="content_X6U",eL="action-hints_o79 child-opacity-transition_nkS",tL="version_Vtb";function nL(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rL(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return nL(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return nL(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var iL,oL,aL,lL,sL=function(t){var n=t.className,r=t.children;nn(tn);var o=rL((0,i.useState)(!1),2),a=o[0],l=o[1],s=cr(),c=C(ku);return Zr(!a),Jr(!a),(0,e.jsx)(Jh,{onFocusChange:l,children:(0,e.jsx)(_p,{children:(0,e.jsx)($t,{styles:$A,children:(0,e.jsxs)("div",{className:Oe()(QA,n),children:[(0,e.jsxs)("div",{className:ZA,children:[(0,e.jsx)("div",{className:JA,children:r}),s&&(0,e.jsx)(DS,{className:eL})]}),(0,e.jsx)("div",{className:tL,children:c})]})})})})},cL="tooltip",uL=E(cL,"groups");function dL(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function fL(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return dL(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return dL(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function hL(e){return ni(e,lL.Formatted)}!function(e){e[e.Start=0]="Start",e[e.Center=1]="Center",e[e.End=2]="End"}(iL||(iL={})),function(e){e[e.Info=0]="Info",e[e.Success=1]="Success",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(oL||(oL={})),function(e){e.Number="Game.UI.Tooltip.NumberTooltip",e.Progress="Game.UI.Tooltip.ProgressTooltip",e.String="Game.UI.Tooltip.StringTooltip",e.Name="Game.UI.Tooltip.NameTooltip",e.Notification="Game.UI.Tooltip.NotificationTooltip",e.ZoningEvaluation="Game.UI.Tooltip.ZoningEvaluationTooltip"}(aL||(aL={})),function(e){e.Custom="names.CustomName",e.Localized="names.LocalizedName",e.Formatted="names.FormattedName"}(lL||(lL={}));var mL=i.memo((function(t){var n=pL(t.value);return(0,e.jsx)(e.Fragment,{children:n})}),(function(e,t){return f(e,t,3)}));function pL(e){var t=vL();return(0,i.useMemo)((function(){return t(e)}),[e,t])}function vL(){var e=bs();return(0,i.useCallback)((function(t){if(null!=t){if(function(e){return ni(e,lL.Custom)}(t))return t.name;if(hL(t)||function(e){return ni(e,lL.Localized)}(t)){var n=e.translate(t.nameId);if(null!=n){if(hL(t)){var r=null!=t.nameArgs?function(e,t){return Object.entries(t).reduce((function(t,n){var r,i=fL(n,2),o=i[0],a=i[1];return t[o]=null!==(r=e.translate(a))&&void 0!==r?r:a,t}),{})}(e,t.nameArgs):null;if(null!=r)return Ul(n,r)}return n}return t.nameId}}return""}),[e])}function gL(e,t){return f(e,t,2)}const yL={title:"title_lCJ",description:"description_dNa",content:"content_OhK"};function bL(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function xL(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function _L(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var jL=function(t){var n=t.title,r=t.description,i=t.content,o=t.children,a=_L(t,["title","description","content","children"]),l=(0,e.jsx)(EL,{title:n,description:r,content:i});return(0,e.jsx)(xO,xL(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){bL(e,t,n[t])}))}return e}({},a),{tooltip:l,children:o}))},EL=function(t){var n=t.title,r=t.description,o=t.content,a=t.className,l=i.Children.count(n)>0,s=i.Children.count(r)>0,c=i.Children.count(o)>0;return(0,e.jsxs)("div",{className:Oe()(yL.layout,a),children:[l&&(0,e.jsx)("div",{className:yL.title,children:n}),s&&(0,e.jsx)(fI,{className:yL.description,children:r}),c&&(0,e.jsx)("div",{className:yL.content,children:o})]})};const OL="group-container_Fl2 tooltip-fade-in_S9n",TL="group_zcS",IL="gamepad_kHF",SL="item_k3Z tooltip-base_zwi",wL="row-item_oHU item_k3Z tooltip-base_zwi",NL="icon_Blg",PL="score-indicator_i6X",CL="positive_Uf2",AL="negative_pRC",LL="label_zet",ML="value_uLz";function RL(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function kL(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){RL(e,t,n[t])}))}return e}function DL(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function UL(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var FL=function(t){var n=t.disabled,r=t.children,i=Lh(cL),o=C(uL),a=zd();return(0,e.jsxs)(e.Fragment,{children:[r,!n&&o.map((function(t){return function(e,t){return e.x>-.1*t.x&&e.x<1.1*t.x&&e.y>-.1*t.y&&e.y<1.1*t.y}(t.props.position,a)?(0,e.jsx)(GL,kL({parent:i},t),t.path):void 0}))]})},GL=function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=cr(),c=(0,i.useMemo)((function(){return{top:o.position.y,left:o.position.x,justifyContent:VL(o.verticalAlignment),alignItems:VL(o.horizontalAlignment)}}),[o]),u=(0,i.useMemo)((function(){return{alignItems:VL(o.horizontalAlignment)}}),[o.horizontalAlignment]);return(0,e.jsx)(kc,{children:(0,e.jsx)("div",{className:OL,style:c,children:(0,e.jsx)("div",{className:Oe()(TL,s&&IL),style:u,children:(0,e.jsx)(Yh,{parent:l,components:zL,data:a})})})})};function VL(e){switch(e){case iL.Start:return"flex-start";case iL.Center:return"center";case iL.End:return"flex-end";default:return"center"}}function BL(e){return e>0?"+":e<0?"−":"±"}var HL,KL=function(t){var n=t.icon,r=t.label,i=t.color,o=void 0===i?oL.Info:i,a=t.className,l=t.children;return(0,e.jsxs)("div",{className:Oe()(wL,a),children:[n&&(0,e.jsx)("img",{src:n,className:NL}),r&&(0,e.jsx)("div",{className:LL,children:(0,e.jsx)(ph,{value:r})}),(0,e.jsx)("div",{className:Oe()(ML,WL[o]),children:l})]})},WL=[void 0,"success_bHA","warning_e1p","error_NkQ"],zL=(RL(HL={},aL.Number,YL((function(t){var n=t.value,r=t.unit,i=t.signed,o=UL(t,["value","unit","signed"]);return(0,e.jsx)(KL,DL(kL({},o),{children:(0,e.jsx)(dc,{value:n,unit:r,signed:i})}))}))),RL(HL,aL.Progress,YL((function(t){var n=t.value,r=t.max,i=t.unit,o=t.omitMax,a=UL(t,["value","max","unit","omitMax"]),l=!o||n!==r;return(0,e.jsx)(KL,DL(kL({},a),{children:l?(0,e.jsx)(ah,{value:n,total:r,unit:i}):(0,e.jsx)(dc,{value:n,unit:i})}))}))),RL(HL,aL.String,YL((function(t){var n=t.value,r=UL(t,["value"]);return(0,e.jsx)(KL,DL(kL({},r),{children:(0,e.jsx)(ph,{value:n})}))}))),RL(HL,aL.Name,YL((function(t){var n=t.icon,r=t.name;return(0,e.jsx)(KL,{icon:n,children:(0,e.jsx)(mL,{value:r})})}))),RL(HL,aL.Notification,YL((function(t){var n=t.name,r=t.color;return t.verbose?(0,e.jsx)("div",{className:SL,children:(0,e.jsx)(EL,{title:(0,e.jsx)(Ks.Notifications.TITLE,{hash:n}),description:(0,e.jsx)(Ks.Notifications.DESCRIPTION,{hash:n})})}):(0,e.jsx)(KL,{color:r,children:(0,e.jsx)(Ks.Notifications.TITLE,{hash:n})})}))),RL(HL,aL.ZoningEvaluation,YL((function(t){var n=t.factor,r=t.score;return(0,e.jsxs)("div",{className:wL,children:[(0,e.jsx)("div",{className:Oe()(PL,r>=0?CL:AL),children:BL(r)}),(0,e.jsx)("div",{className:ML,children:r>=0?(0,e.jsx)(Ks.ZoningFactors.POSITIVE,{hash:n}):(0,e.jsx)(Ks.ZoningFactors.NEGATIVE,{hash:n})})]})}))),HL);function YL(e){var t,n=function(t){var n=t.props;return i.createElement(e,n)};return n.displayName=null!==(t=e.displayName)&&void 0!==t?t:e.name,i.memo(n,(function(e,t){return f(e,t,4)}))}var XL,qL,$L="editorHierarchy";!function(e){e[e.None=0]="None",e[e.Map=1]="Map",e[e.Climate=2]="Climate",e[e.Water=3]="Water",e[e.Resources=4]="Resources",e[e.ObjectContainer=5]="ObjectContainer",e[e.Object=6]="Object",e[e.SubMesh=7]="SubMesh"}(XL||(XL={})),function(e){e[e.Default=0]="Default",e[e.FirstPerson=1]="FirstPerson",e[e.Orbit=2]="Orbit"}(qL||(qL={}));var QL=E($L,"width"),ZL=E($L,"totalCount"),JL=E($L,"selectedId"),eM=E($L,"viewport"),tM=w($L,"setWidth"),nM=w($L,"setViewportRange"),rM=w($L,"setSelectedId"),iM=w($L,"setExpanded"),oM=E($L,"cameraMode"),aM=w($L,"toggleCameraMode");function lM(e,t){return e.type===t.type&&c(e.entity,t.entity)&&e.subIndex===t.subIndex}var sM,cM="editorPanel";!function(e){e.EditorSection="Game.UI.Editor.EditorSection",e.Compass="Game.UI.Editor.Compass",e.SeasonWheel="Game.UI.Editor.SeasonWheel",e.TimeOfDayWeightsChart="Game.UI.Editor.TimeOfDayWeightsChart",e.ItemPicker="Game.UI.Editor.ItemPicker",e.ItemPickerFooter="Game.UI.Editor.ItemPickerFooter",e.SearchField="Game.UI.Editor.SearchField",e.PopupSearchField="Game.UI.Editor.PopupSearchField",e.LocalizationField="Game.UI.Editor.LocalizationField",e.FilterMenu="Game.UI.Editor.FilterMenu"}(sM||(sM={}));var uM=E(cM,"active"),dM=E(cM,"title"),fM=E(cM,"width"),hM=E(cM,"children"),mM=w(cM,"setWidth"),pM=S(cM,"cancel"),vM=S(cM,"close");function gM(e){N(e.group,"deleteEditorSection",e.path)}function yM(e,t){N(e.group,"setEditorSectionActive",e.path,t)}function bM(e,t){N(e.group,"setSelectedSeason",e.path,t)}function xM(e,t,n){N(e.group,"setSeasonStartTimeOfYear",e.path,t,n)}function _M(e,t){N(e.group,"setItemSelected",e.path,t)}function jM(e,t,n){N(e.group,"setSearchFavorite",e.path,t,n)}function EM(e,t,n){N(e.group,"toggleFilter",e.path,t,n)}function OM(e){N(e.group,"clearFilters",e.path)}var TM,IM="mapTiles",SM=E(IM,"mapTileSelectionEnabled"),wM=E(IM,"buildableLand"),NM=E(IM,"water"),PM=E(IM,"resources"),CM=E(IM,"purchasePrice"),AM=E(IM,"purchaseFlags"),LM=E(IM,"expansionPermits"),MM=E(IM,"expansionPermitCost");function RM(e){N(IM,"setMapTileSelectionEnabled",e)}function kM(){RM(!1)}function DM(){N(IM,"purchaseMapTiles")}!function(e){e[e.None=0]="None",e[e.NoSelection=1]="NoSelection",e[e.InsufficientFunds=2]="InsufficientFunds",e[e.InsufficientPermits=4]="InsufficientPermits"}(TM||(TM={}));var UM=E("feature","lockedFeatures");function FM(e){var t=(0,i.useCallback)((function(t,n){var r;return{locked:void 0!==n.find((function(t){return t.name===e})),requirements:(null===(r=n.find((function(t){return t.name===e})))||void 0===r?void 0:r.requirements)||{requireAny:[],requireAll:[]}}}),[e]),n=A(UM,t,{locked:!1,requirements:{requireAny:[],requireAll:[]}});return{locked:n.locked,requirements:n.requirements}}function GM(e){var t=(0,i.useCallback)((function(t,n){return void 0!==n.find((function(t){return t.name===e}))}),[e]);return A(UM,t,!1)}function VM(e){var t;return void 0!==(null===(t=UM.value)||void 0===t?void 0:t.find((function(t){return t.name===e})))}var BM="radio",HM=E(BM,"enabled"),KM=E(BM,"volume"),WM=E(BM,"paused"),zM=E(BM,"muted"),YM=E(BM,"skipAds"),XM=E(BM,"emergencyMode"),qM=E(BM,"emergencyFocusable"),$M=E(BM,"emergencyMessage"),QM=E(BM,"selectedNetwork"),ZM=E(BM,"selectedStation"),JM=E(BM,"networks"),eR=E(BM,"stations"),tR=E(BM,"currentSegment"),nR=I(BM,"segmentChanged");function rR(e){N(BM,"setVolume",e)}function iR(){var e;e=!WM.value,N(BM,"setPaused",e)}function oR(){var e;e=!zM.value,N(BM,"setMuted",e)}function aR(){var e;e=!YM.value,N(BM,"setSkipAds",e)}function lR(){N(BM,"playPrevious")}function sR(){N(BM,"playNext")}function cR(){N(BM,"focusEmergency")}function uR(e){N(BM,"selectNetwork",e)}function dR(e){N(BM,"selectStation",e)}var fR=E("tool","activeTool"),hR=(I("tool","bulldozeConfirmationRequested"),E("tool","availableSnapMask")),mR=E("tool","selectedSnapMask"),pR=E("tool","allSnapMask"),vR=E("tool","snapOptionNames"),gR=E("tool","elevationRange"),yR=E("tool","elevation"),bR=E("tool","elevationStep"),xR=E("tool","parallelModeSupported"),_R=E("tool","parallelMode"),jR=E("tool","parallelOffset"),ER=E("tool","undergroundModeSupported"),OR=E("tool","undergroundMode"),TR=E("tool","elevationDownDisabled"),IR=E("tool","elevationUpDisabled"),SR=E("tool","colorSupported"),wR=E("tool","color");function NR(e){N("tool","setColor",e)}function PR(e){N("tool","selectTool",e)}function CR(e){N("tool","selectToolMode",e)}function AR(e){e<0?MR():e>0&&LR()}function LR(){N("tool","elevationUp")}function MR(){N("tool","elevationDown")}function RR(e){N("tool","setElevationStep",e)}function kR(e){N("tool","setSelectedSnapMask",e)}function DR(){N("tool","toggleParallelMode")}function UR(e){N("tool","setParallelOffset",e)}function FR(e){N("tool","setUndergroundMode",e)}var GR="Bulldoze Tool",VR="Default Tool",BR="Net Tool",HR="Selection Tool",KR=(E("tool","allowBrush"),E("tool","selectedBrush")),WR=(E("tool","brushes"),E("tool","brushSize")),zR=E("tool","brushStrength"),YR=(E("tool","brushAngle"),E("tool","brushSizeMin")),XR=E("tool","brushSizeMax");function qR(e){N("tool","setBrushSize",e)}function $R(e){N("tool","setBrushStrength",e)}function QR(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ZR(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return QR(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return QR(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function JR(e,t){var n=ZR((0,i.useState)(!1),2),r=n[0],o=n[1];return(0,i.useEffect)((function(){var t=function(t){t.button===e&&o(!1)};return window.addEventListener("mouseup",t),function(){return window.removeEventListener("mouseup",t)}}),[e]),(0,i.useMemo)((function(){return null!=t?{mouseDown:r,onMouseDown:function(t){t.button===e&&o(!0)},onMouseUp:function(n){r&&n.button===e&&(o(!1),t(n))}}:{mouseDown:r}}),[e,t,r])}const ek="field_eKJ",tk="content_syM",nk="selectable_otQ",rk="divider_GbU";var ik=function(t){var n=t.contentClassName,r=t.className,i=t.children,o=t.onSelect,a=Oe()(ek,null!=o&&nk,r),l=(0,e.jsx)("div",{className:Oe()(tk,n),children:i});return null!=o?(0,e.jsx)(ml,{className:a,onSelect:o,children:l}):(0,e.jsx)(Tr,{className:a,children:l})},ok=function(){return(0,e.jsx)("div",{className:rk})};const ak="time-controls_TVa field_eKJ",lk="period_iJ_",sk="button_w1a",ck="paused_DLu",uk="secondary-active_X5T",dk="play-pause_Z_u",fk="speed_O0e",hk="date-time-container_UTv",mk="date-time_mlZ",pk="disable-pause-animation_GSc",vk="paused-label_YTz",gk="time-hours_w20",yk="time-colon_t_C",bk="time-minutes_QOr",xk="time-period_Qyj",_k="date_fBv";function jk(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var Ek=Rr({pause:"Media/Glyphs/SimulationPause.svg",play:"Media/Glyphs/SimulationPlay.svg",speed1:"Media/Glyphs/SimulationSpeed1.svg",speed2:"Media/Glyphs/SimulationSpeed2.svg",speed3:"Media/Glyphs/SimulationSpeed3.svg"}),Ok=function(t){var n,r,o,a,l=t.disablePauseAnimation,s=C(Kp),c=C(Wp),u=Zp(C(Gp),C(Vp)),d=C(ls).timeFormat===fs.TwentyFourHours,f=(0,i.useMemo)((function(){return zs(d?u.hour:u.hour%12||12,2)}),[u.hour,d]),h=(0,i.useMemo)((function(){return zs(u.minute,2)}),[u.minute]),m=JR(2,Sk);return(0,e.jsxs)("div",{className:Oe()(ak,(a={},jk(a,lk,!d),jk(a,pk,l),a)),children:[(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolbarSimulationToggle,children:(0,e.jsx)(jL,{title:s?(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_PLAY,{}):(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_PAUSE,{}),description:s?(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_PLAY,{}):(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_PAUSE,{}),children:(0,e.jsx)(xl,{tinted:!0,src:s?Ek.pause:Ek.play,selectSound:null,className:Oe()(sk,dk,s&&ck),onSelect:Tk})})}),(0,e.jsx)(ok,{}),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolbarSimulationDateTime,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_DATE,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_DATE,{}),children:(0,e.jsx)(Wn,{children:(0,e.jsxs)("div",{className:hk,children:[(0,e.jsxs)("div",{className:Oe()(mk,s&&ck),children:[(0,e.jsx)("div",{className:gk,children:f}),(0,e.jsx)("div",{className:yk,children:":"}),(0,e.jsx)("div",{className:bk,children:h}),!d&&(0,e.jsx)("div",{className:xk,children:u.hour<12?(0,e.jsx)(Ks.Common.TIME_PERIOD_AM,{}):(0,e.jsx)(Ks.Common.TIME_PERIOD_PM,{})}),(0,e.jsx)("div",{className:_k,children:(0,e.jsx)(Ys,{value:u})})]}),s&&(0,e.jsx)("div",{className:vk,children:(0,e.jsx)(Ks.Toolbar.SIMULATION_PAUSED,{})})]})})})}),(0,e.jsx)(ok,{}),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.toolbarSimulationSpeed,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_GAME_SPEED,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_GAME_SPEED,{}),children:(0,e.jsx)(xl,{tinted:!0,src:Lk(c),selectSound:null,className:Oe()(sk,fk,s&&ck,m.mouseDown&&uk),onSelect:Ik,onMouseDown:m.onMouseDown,onMouseUp:m.onMouseUp})})})]})};function Tk(){var e=!Kp.value;Jt(e?Qt.pauseSimulation:Qt.resumeSimulation),Yp(e)}function Ik(){Ak(Wp.value+1)}function Sk(){Ak(Wp.value+3-1)}function wk(){Ak(0)}function Nk(){Ak(1)}function Pk(){Ak(2)}function Ck(){if(Kp.value)Jt(Qt.resumeSimulation),Xp(0);else{var e=Wp.value;e<2?Ak(e+1):(Jt(Qt.pauseSimulation),Yp(!0))}}function Ak(e){var t,n=e%3;Jt((t=n)<.5?Qt.simulationSpeed1:t<1.5?Qt.simulationSpeed2:Qt.simulationSpeed3),Xp(n)}function Lk(e){return e<.5?Ek.speed1:e<1.5?Ek.speed2:Ek.speed3}function Mk(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Rk(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function kk(){var e=C(Sa),t=C(Ra),n=C(fR),r=C(IR),o=C(TR),a=!(r&&o),l=C(OR),s=C(ai),c=(0,i.useRef)(VR),u=Dk(),d=function(){var e=FM("Infoviews"),t=FM("Progression Panel"),n=FM("City Budget"),r=FM("City Info Panel"),o=FM("City Statistics"),a=FM("Transportation Overview"),l=FM("Chirper"),s=FM("Followed Citizens"),c=FM("Event Journal"),u=FM("Radio"),d=FM("Photo Mode"),f=C(ai),h=C(HM);return(0,i.useMemo)((function(){return{"Info View":function(){ni(Ra.value,La.InfoviewMenu)?Ga(La.InfoviewMenu):null!==f?si():e.locked||(Fa(La.InfoviewMenu),Pa())},"Progression Panel":Uk(La.Progression,t),"Economy Panel":Uk(La.Economy,n),"City Information Panel":Uk(La.CityInfo,r),"Statistic Panel":Uk(La.Statistics,o),"Transportation Overview Panel":Uk(La.TransportationOverview,a),"Chirper Panel":Uk(La.Chirper,l),"Lifepath Panel":Uk(La.LifePath,s),"Event Journal Panel":Uk(La.Journal,c),"Radio Panel":h?Uk(La.Radio,u):null,"Photo Mode Panel":Uk(La.PhotoMode,d)}}),[f,l,r,n,c,e.locked,s,d,t,h,u,o,a])}(),f=(0,i.useCallback)((function(){return CR(function(e){var t=e.modes.reduce((function(t,n){return n.index>e.modeIndex&&(void 0===t||n.index<t)?n.index:t}),void 0);if(void 0!==t)return t;var n=e.modes.reduce((function(e,t){return void 0===e||t.index<e?t.index:e}),void 0);return void 0!==n?n:e.modeIndex}(n))}),[n]),h=FM("Map Tiles"),m=C(pR),p=C(mR),v=(0,i.useCallback)((function(){kR((p&m)===m?p&~m:p|m)}),[m,p]),g=(null==t?void 0:t.__Type)===La.PhotoMode;return(0,i.useMemo)((function(){return Rk(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Mk(e,t,n[t])}))}return e}({},u,d),{"Change Elevation":a?function(e){e>0?r||(Jt(Qt.increaseElevation),LR()):e<0&&(o||(Jt(Qt.decreaseElevation),MR()))}:null,Bulldozer:function(){n.id===GR?(Jt(Qt.bulldozeEnd),PR(c.current)):(c.current=n.id,Jt(Qt.bulldoze),PR(GR))},Back:n.id!==VR?function(){n.id===GR&&Jt(Qt.bulldozeEnd),PR(VR)}:null,"Leave Underground Mode":l?function(){Jt(Qt.increaseElevation),FR(!1)}:null,"Leave Info View":null!=s?si:null,"Pause Menu":e!==Oa.pauseMenu?Ca:null,"Switch Toolmode":f,"Toggle Snapping":v,"Hide UI":function(){return wa(Sa.value!==Oa.freeCamera?Oa.freeCamera:Oa.main)},"Map Tile Purchase Panel":h.locked||g?null:function(){return RM(!SM.value)}})}),[u,d,a,n.id,l,s,e,f,v,h.locked,g,r,o])}function Dk(){var e=C(Kp);return(0,i.useMemo)((function(){return{"Switch Speed":Ck,"Speed 1":wk,"Speed 2":Nk,"Speed 3":Pk,"Pause Simulation":e?null:function(){Jt(Qt.pauseSimulation),Yp(!0)},"Resume Simulation":e?function(){Jt(Qt.resumeSimulation),Yp(!1)}:null}}),[e])}function Uk(e,t){return void 0!==t&&t.locked?null:function(){return ni(Ra.value,e)?Ga(e):Fa(e)}}const Fk="bulldoze-cursor_uNU",Gk="replace-cursor_jgP",Vk="complex-curve-cursor_N47",Bk="continuous-cursor_wVn",Hk="grid-cursor_zBe",Kk="parallel-mode-cursor_kzY",Wk="simple-curve-cursor_JKS",zk="straight-cursor_AcO",Yk="crosshair-default_S39 crosshair_gJi",Xk="bulldoze-crosshair_C1X crosshair_gJi",qk="replace-crosshair_VpJ crosshair_gJi",$k="complex-curve-crosshair_Yhl crosshair_gJi",Qk="continuous-crosshair_DwR crosshair_gJi",Zk="grid-crosshair_V69 crosshair_gJi",Jk="parallel-mode-crosshair_lYy crosshair_gJi",eD="simple-curve-crosshair_BYp crosshair_gJi",tD="straight-crosshair_IEJ crosshair_gJi";function nD(){var e=C(fR),t=C($n),n=C(_R);Tf(t?void 0:rD(n,e,"Cursor"))}function rD(e,t,n){var r,i,o,a,l,s;return t.id===BR&&e?"Cursor"===n?Kk:Jk:t.id===GR?"Cursor"===n?Fk:Xk:t.id===BR&&"Replace"===(null===(r=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===r?void 0:r.id)?"Cursor"===n?Gk:qk:t.id===BR&&"Straight"===(null===(i=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===i?void 0:i.id)?"Cursor"===n?zk:tD:t.id===BR&&"SimpleCurve"===(null===(o=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===o?void 0:o.id)?"Cursor"===n?Wk:eD:t.id===BR&&"ComplexCurve"===(null===(a=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===a?void 0:a.id)?"Cursor"===n?Vk:$k:t.id===BR&&"Continuous"===(null===(l=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===l?void 0:l.id)?"Cursor"===n?Bk:Qk:t.id===BR&&"Grid"===(null===(s=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===s?void 0:s.id)?"Cursor"===n?Hk:Zk:"Cursor"===n?void 0:Yk}var iD,oD="toolbar";!function(e){e[e.asset=0]="asset",e[e.menu=1]="menu"}(iD||(iD={}));var aD=E(oD,"toolbarGroups"),lD=T(oD,"assetCategories"),sD=T(oD,"assets"),cD=E(oD,"themes"),uD=E(oD,"selectedTheme"),dD=E(oD,"selectedAssetMenu"),fD=E(oD,"selectedAssetCategory"),hD=E(oD,"selectedAsset"),mD=w(oD,"selectTheme"),pD=w(oD,"selectAssetMenu"),vD=w(oD,"selectAssetCategory"),gD=w(oD,"selectAsset"),yD=S(oD,"clearAssetSelection");function bD(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _D(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function jD(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function ED(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bD(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bD(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function OD(t){var n=t.value,r=t.valueFormatter,o=t.inputValidator,a=t.inputTransformer,l=void 0===a?TD:a,s=t.inputParser,c=t.onChange,u=t.onFocus,d=t.onBlur,f=jD(t,["value","valueFormatter","inputValidator","inputTransformer","inputParser","onChange","onFocus","onBlur"]),h=ED((0,i.useState)(null),2),m=h[0],p=h[1],v=(0,i.useMemo)((function(){return r(n)}),[n,r]),g=(0,i.useCallback)((function(e){var t=l(e.target.value||"");if(o(t)){var n=m;if(p(t),c){var r=null!==n?s(n):void 0,i=null!==t?s(t):void 0;if(void 0!==i&&i!==r)return c(i)}}}),[s,l,o,m,c]),y=(0,i.useCallback)((function(e){p(r(n)),u&&u(e)}),[u,n,r]),b=(0,i.useCallback)((function(e){p(null),d&&d(e)}),[d]);return(0,e.jsx)(Sp,_D(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xD(e,t,n[t])}))}return e}({},f),{value:null!=m?m:v,onChange:g,onFocus:y,onBlur:b}))}function TD(e){return e}function ID(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function SD(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var wD=function(t){return(0,e.jsx)(OD,SD(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ID(e,t,n[t])}))}return e}({},t),{valueFormatter:ND,inputParser:PD,inputTransformer:CD,inputValidator:AD}))};function ND(e){return n=(t=e).r,r=t.g,i=t.b,vm(n)+vm(r)+vm(i);var t,n,r,i}function PD(e){return gm(e)||void 0}function CD(e){return e.toUpperCase()}function AD(e){return/^#?([a-f0-9]{0,6})$/i.test(e)}const LD={"dropdown-toggle":"dropdown-toggle_Iei dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_Iei dropdown-toggle_prl",indicator:"indicator_Not","dropdown-menu":"dropdown-menu_cSm dropdown-menu_Swd",dropdownMenu:"dropdown-menu_cSm dropdown-menu_Swd","dropdown-item":"dropdown-item_Hjk undefined",dropdownItem:"dropdown-item_Hjk undefined","toggle-flags-button":"toggle-flags-button_T7X undefined",toggleFlagsButton:"toggle-flags-button_T7X undefined","dropdown-flag-item":"dropdown-flag-item_uJx dropdown-flag-item_EcT",dropdownFlagItem:"dropdown-flag-item_uJx dropdown-flag-item_EcT",toggle:"toggle_qtt toggle_RyX",label:"label_tNr"};var MD=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{h:1,s:1,v:1,a:1},t=e.s,n=e.v,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:36;return UD({h:0,s:t,v:n,a:1},{h:1,s:t,v:n,a:1},r)}();function RD(e){var t=e.h,n=e.v;return UD({h:t,s:0,v:n,a:1},{h:t,s:1,v:n,a:1},2)}function kD(e){var t=e.h,n=e.s;return UD({h:t,s:n,v:0,a:1},{h:t,s:n,v:1,a:1},2)}function DD(e){var t=e.h,n=e.s,r=e.v;return UD({h:t,s:n,v:r,a:0},{h:t,s:n,v:r,a:1},2)}function UD(e,t,n){for(var r,i,o,a=[],l=0;l<=n;l++)a.push({offset:l/n,color:pm(ym((r=e,i=t,o=l/n,{h:lt(r.h,i.h,o),s:lt(r.s,i.s,o),v:lt(r.v,i.v,o),a:lt(r.a,i.a,o)})))});return{stops:a}}function FD(e,t){return{stops:[{offset:0,color:pm(e)},{offset:1,color:pm(t)}]}}const GD={edge:"edge_xBb","start-edge":"start-edge_nii edge_xBb",startEdge:"start-edge_nii edge_xBb","end-edge":"end-edge_egi edge_xBb",endEdge:"end-edge_egi edge_xBb","track-bounds":"track-bounds_hs9 track-bounds_H8_",trackBounds:"track-bounds_hs9 track-bounds_H8_"};function VD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function BD(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){VD(e,t,n[t])}))}return e}function HD(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function KD(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var WD=function(t){var n,r,o=t.gradient,a=t.theme,l=KD(t,["gradient","theme"]),s=(0,i.useMemo)((function(){return BD({},GD,a)}),[a]),c=(0,i.useMemo)((function(){var e,t;return{"--startColor":null!==(n=null===(e=o.stops.find((function(e){return 0===e.offset})))||void 0===e?void 0:e.color)&&void 0!==n?n:"grey","--endColor":null!==(r=null===(t=o.stops.find((function(e){return 1===e.offset})))||void 0===t?void 0:t.color)&&void 0!==r?r:"grey","--gradient":_m(o)}}),[o]);return(0,e.jsxs)(Fm,HD(BD({},l),{theme:s,style:c,children:[(0,e.jsx)("div",{className:s.startEdge}),(0,e.jsx)("div",{className:s.endEdge})]}))};function zD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function YD(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function XD(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var qD=function(t){var n=t.min,r=void 0===n?it:n,o=t.max,a=void 0===o?ot:o,l=t.fractionDigits,s=void 0===l?3:l,c=XD(t,["min","max","fractionDigits"]),u=(0,i.useCallback)((function(e){return function(e,t,n){if("-"===e||"."===e)return;if(""===e)return t<=0&&n>=0?0:void 0;var r=parseFloat(e);return isNaN(r)?void 0:at(r,t,n)}(e,r,a)}),[r,a]),d=(0,i.useCallback)((function(e){return e.toFixed(s)}),[s]);return(0,e.jsx)(OD,YD(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zD(e,t,n[t])}))}return e}({},c),{valueFormatter:d,inputParser:u,inputValidator:r<0?$D:QD}))};function $D(e){return/^-?[0-9]*\.?[0-9]*$/.test(e)}function QD(e){return/^[0-9]*\.?[0-9]*$/.test(e)}function ZD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function JD(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function eU(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var tU=function(t){var n=t.min,r=void 0===n?nt:n,o=t.max,a=void 0===o?rt:o,l=eU(t,["min","max"]),s=(0,i.useCallback)((function(e){return function(e,t,n){if("-"===e)return;if(""===e)return t<=0&&n>=0?0:void 0;var r=parseInt(e,10);return isNaN(r)?void 0:at(r,t,n)}(e,r,a)}),[r,a]);return(0,e.jsx)(OD,JD(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ZD(e,t,n[t])}))}return e}({},l),{valueFormatter:nU,inputParser:s,inputValidator:r<0?rU:iU}))};function nU(e){return Math.trunc(e).toString(10)}function rU(e){return/^-?[0-9]*$/.test(e)}function iU(e){return/^[0-9]*$/.test(e)}const oU={slider:"slider_fer slider_pUS","gamepad-active":"gamepad-active_Elg",gamepadActive:"gamepad-active_Elg",thumb:"thumb_z1a"},aU="color-component-input_WeK",lU="label_GH4",sU="slider-container_NuQ",cU="slider_xgT",uU="alpha_N_s",dU="input_zfe";var fU=function(t){var n=t.label,r=t.value,o=t.scale,a=t.step,l=t.gradient,s=t.alpha,c=t.onChange,u=t.textField,d=void 0===u||u,f=(0,i.useCallback)((function(e){return c(at(e/o,0,1))}),[c,o]),h=Bm(a),m=cr();return(0,e.jsxs)("div",{className:aU,children:[d&&(0,e.jsx)("div",{className:lU,children:n}),(0,e.jsx)("div",{className:Oe()(cU,s&&uU),children:(0,e.jsx)("div",{className:sU,children:(0,e.jsx)(WD,{value:r*o,start:0,end:o,theme:oU,gradient:l,gamepadStep:o/50,valueTransformer:h,className:Oe()(m&&oU.gamepadActive),onChange:f})})}),d&&(1!==a?(0,e.jsx)(qD,{value:r*o,onChange:f,className:dU}):(0,e.jsx)(tU,{value:Math.round(r*o),onChange:f,className:dU}))]})};function hU(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function mU(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){hU(e,t,n[t])}))}return e}function pU(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var vU=function(t){var n=t.color,r=t.onChange,o=t.textField,a=void 0===o||o,l=(0,i.useCallback)((function(e){return r(pU(mU({},n),{h:e}))}),[n,r]),s=(0,i.useCallback)((function(e){return r(pU(mU({},n),{s:e}))}),[n,r]),c=(0,i.useCallback)((function(e){return r(pU(mU({},n),{v:e}))}),[n,r]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(fU,{label:"H",value:n.h,scale:360,step:1,gradient:MD,onChange:l,textField:a}),(0,e.jsx)(fU,{label:"S",value:n.s,scale:100,step:1,gradient:RD(n),onChange:s,textField:a}),(0,e.jsx)(fU,{label:"V",value:n.v,scale:100,step:1,gradient:kD(n),onChange:c,textField:a})]})},gU=function(t){var n=t.color,r=t.onChange,o=t.scale,a=void 0===o?255:o,l=t.step,s=void 0===l?1:l,c=t.textField,u=void 0===c||c,d=ym(n),f=n.h,h=(0,i.useCallback)((function(e){return r(bm(pU(mU({},d),{r:e}),f))}),[d,f,r]),m=(0,i.useCallback)((function(e){return r(bm(pU(mU({},d),{g:e}),f))}),[d,f,r]),p=(0,i.useCallback)((function(e){return r(bm(pU(mU({},d),{b:e}),f))}),[d,f,r]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(fU,{label:"R",value:d.r,scale:a,step:s,gradient:FD(pU(mU({},d),{r:0,a:1}),pU(mU({},d),{r:1,a:1})),onChange:h,textField:u}),(0,e.jsx)(fU,{label:"G",value:d.g,scale:a,step:s,gradient:FD(pU(mU({},d),{g:0,a:1}),pU(mU({},d),{g:1,a:1})),onChange:m,textField:u}),(0,e.jsx)(fU,{label:"B",value:d.b,scale:a,step:s,gradient:FD(pU(mU({},d),{b:0,a:1}),pU(mU({},d),{b:1,a:1})),onChange:p,textField:u})]})},yU=function(t){var n=t.color,r=t.scale,o=void 0===r?100:r,a=t.step,l=void 0===a?1:a,s=t.onChange,c=t.textField,u=void 0===c||c,d=(0,i.useCallback)((function(e){return s(pU(mU({},n),{a:e}))}),[n,s]);return(0,e.jsx)(fU,{label:"A",value:n.a,scale:o,step:l,gradient:DD(n),alpha:!0,onChange:d,textField:u})};function bU(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xU(e){return function(e){if(Array.isArray(e))return bU(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return bU(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bU(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var _U=function(t){var n=t.s,r=void 0===n?1:n,o=t.v,a=void 0===o?1:o,l=t.outerRadius,s=t.innerRadius,c=t.className,u=(0,i.useMemo)((function(){var t=2*Math.PI/360+.02,n=l-1,i=s+1,o=2*l;return(0,e.jsx)("svg",{width:o,height:o,viewBox:"0 0 ".concat(o," ").concat(o),className:c,children:(0,e.jsx)("g",{transform:"translate(".concat(l," ").concat(l,")"),children:xU(Array(360)).map((function(o,l){var s=l/360,c=2*Math.PI*s,u=c+t,d=Math.sin(c),f=Math.cos(c),h=Math.sin(u),m=Math.cos(u),p=pm(ym({h:s,s:r,v:a,a:1})),v=[[d*n,-f*n],[d*n,-f*n],[h*n,-m*n],[h*i,-m*i]];return(0,e.jsx)("path",{d:"M".concat(v.join(" L"),"z"),fill:p,stroke:p,strokeWidth:2},l)}))})})}),[c,s,l,r,a]);return u};const jU="radial-hue-picker_TbV",EU="active_JI3",OU="wheel_aXq",TU="thumb_ydk";function IU(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function SU(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return IU(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return IU(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var wU=function(t){var n=t.h,r=t.s,o=void 0===r?1:r,a=t.v,l=void 0===a?1:a,s=t.decimalPrecision,c=void 0===s?3:s,u=t.outerRadius,d=t.innerRadius,f=t.className,h=t.onChange,m=t.onDragStart,p=t.onDragEnd,v=(0,i.useRef)(null),g=(0,i.useCallback)((function(e){var t=e.clientX,n=e.clientY;return!(!v.current||!function(e,t,n,r,i){var o=e.getBoundingClientRect(),a=o.left,l=o.top,s=o.width,c=o.height,u=t-a-s/2,d=n-l-c/2,f=u*u+d*d,h=i*i;return f>=r*r&&f<=h}(v.current,t,n,d,u))&&(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),Jt(Qt.grabSlider),m&&m(),h&&h(NU(v.current,t,n,c)),!0)}),[d,u,m,h,c]),y=(0,i.useCallback)((function(e){var t=e.clientX,n=e.clientY;v.current&&h&&(Jt(Qt.dragSlider),h(NU(v.current,t,n,c)))}),[h,c]),b=SU(Zd(g,y,(0,i.useCallback)((function(){p&&p()}),[p])),2),x=b[0],_=b[1],j={width:2*u,height:2*u},E=(d+u)/2,O=2*n*Math.PI,T={transform:"translate(".concat(E*Math.sin(O),"px, ").concat(-E*Math.cos(O),"px) translate(-50%, -50%)"),top:u,left:u,backgroundColor:pm(ym({h:n,s:o,v:l,a:1}))};return(0,e.jsxs)("div",{ref:v,className:Oe()(jU,x&&EU,f),style:j,onMouseDown:_,children:[(0,e.jsx)(_U,{s:o,v:l,outerRadius:u,innerRadius:d,className:OU}),(0,e.jsx)("div",{className:TU,style:T})]})};function NU(e,t,n,r){var i=e.getBoundingClientRect(),o=i.left,a=i.top,l=t-o-i.width/2,s=n-a-i.height/2;return at(st(Math.atan2(-l,s)/(2*Math.PI)+.5,r),0,1)}function PU(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CU(e){return function(e){if(Array.isArray(e))return PU(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return PU(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PU(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var AU=function(t){var n=t.h,r=t.width,o=t.height,a=t.className,l=(0,i.useId)(),s=(0,i.useMemo)((function(){var t=Math.round(o/1);return(0,e.jsx)("svg",{width:r,height:o,viewBox:"0 0 ".concat(r," ").concat(o),className:a,children:CU(Array(t)).map((function(i,o){var a=1-o/t,s=pm(ym({h:n,s:0,v:a,a:1})),c=pm(ym({h:n,s:1,v:a,a:1})),u="g-".concat(l,"-").concat(o),d=1*o;return(0,e.jsxs)("g",{children:[(0,e.jsxs)("linearGradient",{id:"".concat(u),gradientTransform:"rotate(90)",children:[(0,e.jsx)("stop",{offset:"0%",stopColor:s}),(0,e.jsx)("stop",{offset:"100%",stopColor:c})]}),(0,e.jsx)("rect",{y:d,width:2*r,height:1,fill:"url(#".concat(u,")")})]},o)}))})}),[a,n,o,l,r]);return s};const LU="saturation-gradient-picker_tkk",MU="active_LF5",RU="gradient_LME",kU="thumb_l7W";function DU(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function UU(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||GU(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function FU(e){return function(e){if(Array.isArray(e))return DU(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||GU(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function GU(e,t){if(e){if("string"==typeof e)return DU(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?DU(e,t):void 0}}var VU=function(t){var n=t.h,r=t.s,o=t.v,a=t.decimalPrecision,l=void 0===a?3:a,s=t.width,c=t.height,u=t.className,d=t.onChange,f=t.onDragStart,h=t.onDragEnd,m=(0,i.useRef)(null),p=(0,i.useCallback)((function(e){var t=e.clientX,r=e.clientY;return!!m.current&&(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),Jt(Qt.grabSlider),f&&f(),d&&d.apply(void 0,FU(BU(m.current,t,r,n,l))),!0)}),[f,d,n,l]),v=(0,i.useCallback)((function(e){var t=e.clientX,r=e.clientY;m.current&&d&&(Jt(Qt.dragSlider),d.apply(void 0,FU(BU(m.current,t,r,n,l))))}),[d,n,l]),g=UU(Zd(p,v,(0,i.useCallback)((function(){h&&h()}),[h])),2),y=g[0],b=g[1],x=Oe()(LU,y&&MU,u),_={width:s,height:c},j={transform:"translate(".concat(r*s,"px, ").concat((1-o)*c,"px) translate(-50%, -50%)"),backgroundColor:pm(ym({h:n,s:r,v:o,a:1}))};return(0,e.jsxs)("div",{ref:m,className:x,style:_,onMouseDown:b,children:[(0,e.jsx)(AU,{h:n,width:s,height:c,className:RU}),(0,e.jsx)("div",{className:kU,style:j})]})};function BU(e,t,n,r,i){var o=e.getBoundingClientRect(),a=o.left,l=o.top,s=o.width,c=o.height;return[at(st((t-a)/s,i),0,1),at(st(1-(n-l)/c,i),0,1)]}const HU="color-picker_aNX",KU="section_cwE",WU="preview_HmH",zU="preview-swatch_fDW",YU="wheel_lpH",XU="sv_Nf5",qU="sv-picker_DTa",$U="modes_ZSt",QU="mode-dropdown_fGC",ZU="sliders_sCL",JU="hex_c98",eF="hex-label_yqK",tF="hex-input_hFc";function nF(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rF(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function iF(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){rF(e,t,n[t])}))}return e}function oF(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function aF(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return nF(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return nF(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var lF,sF;!function(e){e[e.None=0]="None",e[e.Current=1]="Current",e[e.CurrentAndLast=2]="CurrentAndLast"}(lF||(lF={})),function(e){e.Hsv="Hsv",e.RgbFloat="RgbFloat",e.RgbByte="RgbByte"}(sF||(sF={}));var cF=function(t){var n=t.focusKey,r=t.color,o=t.alpha,a=t.colorWheel,l=void 0===a||a,s=t.sliderTextInput,c=void 0===s||s,u=t.preview,d=void 0===u?lF.None:u,f=t.mode,h=t.hexInput,m=void 0===h||h,p=t.onChange;r=oF(iF({},r),{a:o?r.a:1});var v=(0,i.useRef)(r),g=aF((0,i.useState)(f||sF.Hsv),2),y=g[0],b=g[1],x=(0,i.useCallback)((function(e){return p(oF(iF({},r),{h:e}))}),[p,r]),_=(0,i.useCallback)((function(e,t){return p(oF(iF({},r),{s:e,v:t}))}),[p,r]),j=(0,i.useCallback)((function(e){return p(bm(oF(iF({},e),{a:r.a}),r.h))}),[p,r]),E=(0,i.useCallback)((function(){return p(v.current)}),[p]),O=qd();return(0,e.jsx)(Fn,{focusKey:n,children:(0,e.jsxs)("div",{className:HU,children:[d!==lF.None&&(0,e.jsxs)("div",{className:WU,children:[d===lF.CurrentAndLast&&(0,e.jsx)("div",{className:zU,style:{backgroundColor:pm(ym(v.current))},onClick:E}),(0,e.jsx)("div",{className:zU,style:{backgroundColor:pm(ym(r))}})]}),l&&(0,e.jsxs)("div",{className:Oe()(KU,YU),children:[(0,e.jsx)(wU,{h:r.h,outerRadius:93*O,innerRadius:70*O,onChange:x}),(0,e.jsx)("div",{className:XU,children:(0,e.jsx)(VU,oF(iF({},r),{width:94*O,height:94*O,onChange:_,className:qU}))})]}),void 0===f&&(0,e.jsx)("div",{className:Oe()($U,KU),children:(0,e.jsx)(fC,{theme:LD,content:Object.values(sF).map((function(t){return(0,e.jsx)(_C,{focusKey:t,value:t,selected:y===t,onChange:b,children:uF(t)},t)})),children:(0,e.jsx)(gC,{className:QU,children:uF(y)})})}),(0,e.jsx)("div",{className:Oe()(ZU,KU),children:(0,e.jsx)(dF,{mode:y,color:r,alpha:o,onChange:p,textField:c})}),m&&(0,e.jsxs)("div",{className:Oe()(JU,KU),children:[(0,e.jsx)("div",{className:eF,children:"Hex"}),(0,e.jsx)(wD,{value:ym(r),onChange:j,className:tF})]})]})})};function uF(e){switch(e){case sF.Hsv:return"HSV";case sF.RgbFloat:return"RGB 0-1.0";case sF.RgbByte:return"RGB 0-255"}}var dF=function(t){var n=t.mode,r=t.color,i=t.alpha,o=t.onChange,a=t.textField,l=void 0===a||a;switch(n){case sF.Hsv:return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(vU,{color:r,onChange:o,textField:l}),i&&(0,e.jsx)(yU,{color:r,scale:100,step:1,onChange:o,textField:l})]});case sF.RgbFloat:return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(gU,{color:r,scale:1,step:.001,onChange:o,textField:l}),i&&(0,e.jsx)(yU,{color:r,scale:1,step:.001,onChange:o,textField:l})]});case sF.RgbByte:return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(gU,{color:r,scale:255,step:1,onChange:o,textField:l}),i&&(0,e.jsx)(yU,{color:r,scale:255,step:1,onChange:o,textField:l})]})}};const fF="color-field_due",hF="alpha_R9X",mF="disabled_QDB",pF="color-picker-container_Sj5";function vF(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function gF(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function yF(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function bF(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return vF(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return vF(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xF=new Se("BUTTON_KEY"),_F=new Se("PICKER_KEY");var jF=function(t){var n=t.focusKey,r=t.disabled,o=t.value,a=t.className,l=t.selectAction,s=void 0===l?"Select":l,c=t.alpha,u=void 0!==c&&c,d=t.popupDirection,f=void 0===d?"down":d,h=t.onChange,m=t.onClick,p=t.onMouseEnter,v=t.onMouseLeave,g=bF((0,i.useState)(!1),2),y=g[0],b=g[1],x=(0,i.useCallback)((function(){return b((function(e){return!e}))}),[]),_=(0,i.useCallback)((function(){return b(!1)}),[]);(0,i.useEffect)((function(){r&&y&&b(!1)}),[r,y]);var j,E=(0,i.useRef)(0),O=(0,i.useCallback)((function(e){E.current=e.h,h(ym(e))}),[h]),T=(0,i.useMemo)((function(){var e;return gF(e={},s,(function(){return x()})),gF(e,"Back",_),e}),[_,x,s]),I=(0,i.useRef)(null),S=(0,e.jsx)(Tn,{actions:T,children:(0,e.jsx)("div",{ref:I,className:pF,children:(0,e.jsx)(cF,{focusKey:_F,color:EF(o,E.current),alpha:u,onChange:O,colorWheel:!1,sliderTextInput:!1,mode:sF.Hsv,hexInput:!1})})}),w=(0,i.useCallback)((function(){return b(!1)}),[]);return(0,e.jsxs)(e.Fragment,{children:[y&&(0,e.jsx)(rC,{onClick:w}),(0,e.jsx)(Ze,{focusKey:n,focused:y?_F:xF,children:(0,e.jsx)(eC,{visible:y,content:S,direction:f,children:(0,e.jsx)(ml,{focusKey:xF,selectAction:s,onClick:m,onMouseEnter:p,onMouseLeave:v,className:Oe()(a,fF,(j={},gF(j,mF,r),gF(j,hF,o.a<1),j)),onSelect:r?void 0:x,children:(0,e.jsx)("div",{style:{backgroundColor:pm(o)}})})})})]})};function EF(e,t){var n=bm(e,t);return 0===n.h&&t>.99?yF(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){gF(e,t,n[t])}))}return e}({},n),{h:1}):n}const OF="unlock-highlight-badge_D9D";var TF=function(t){var n=t.className;return C(es)?(0,e.jsx)("div",{className:Oe()(OF,n)}):null};const IF={indicatorNormalColor:"#424242",indicatorSelectedColor:"#1e83aa",button:"button_KVN",icon:"icon_Ysc","multi-select":"multi-select_Roq",multiSelect:"multi-select_Roq",badge:"badge_IEE",indicator:"indicator_ySy"};var SF=function(t){var n=t.focusKey,r=t.src,o=t.selected,a=t.multiSelect,l=t.disabled,s=t.tooltip,c=t.selectSound,u=t.uiTag,d=t.className,f=t.children,h=t.onSelect,m=(0,i.useCallback)((function(){h&&h(),u&&lu(u)}),[h,u]);return(0,e.jsx)(bS,{uiTag:u,children:(0,e.jsx)(xO,{tooltip:s,children:(0,e.jsx)(xl,{focusKey:n,src:r,disabled:l,selected:o,theme:IF,selectSound:c,className:Oe()(a&&IF.multiSelect,d),onSelect:m,children:f})})})};function wF(t){var n=t.focusKey,r=t.value,o=t.src,a=t.selected,l=t.highlight,s=t.multiSelect,c=t.uiTag,u=t.className,d=t.children,f=t.onSelect,h=t.onClick,m=(0,i.useCallback)((function(){f&&f(r),c&&lu(c)}),[f,r,c]),p=(0,i.useCallback)((function(e){h&&(e.stopPropagation(),h(r))}),[r,h]);return(0,e.jsx)(bS,{uiTag:c,children:(0,e.jsxs)(xl,{focusKey:n,src:o,selected:a,theme:IF,className:Oe()(s&&IF.multiSelect,u),onSelect:m,onClick:p,children:[d,l&&(0,e.jsx)(TF,{className:IF.badge})]})})}var NF=function(t){var n=t.focusKey,r=t.selectedValue,o=t.values,a=t.tooltip,l=t.uiTag,s=t.onSelect,c=(0,i.useCallback)((function(){s(function(e,t){if(0===t.length)return e;var n=!0,r=!1,i=void 0;try{for(var o,a=t[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var l=o.value;if(l<e)return l}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return t[0]}(r,o)),l&&lu(l)}),[s,r,l,o]),u=o.findIndex((function(e){return e<=r}));return(0,e.jsx)(bS,{uiTag:l,children:(0,e.jsx)(xO,{tooltip:a,children:(0,e.jsx)(ml,{focusKey:n,theme:IF,onSelect:c,children:(0,e.jsxs)("svg",{viewBox:"0 0 20 16",className:IF.indicator,children:[(0,e.jsx)("path",{d:"M0,12h4v4h-4Z",fill:u<=3?IF.indicatorSelectedColor:IF.indicatorNormalColor}),(0,e.jsx)("path",{d:"M5,8h4v8h-4Z",fill:u<=2?IF.indicatorSelectedColor:IF.indicatorNormalColor}),(0,e.jsx)("path",{d:"M10,4h4v12h-4Z",fill:u<=1?IF.indicatorSelectedColor:IF.indicatorNormalColor}),(0,e.jsx)("path",{d:"M15,0h4v16h-4Z",fill:u<=0?IF.indicatorSelectedColor:IF.indicatorNormalColor})]})})})})};const PF="group_fXk",CF="item_RBL item-focused_FuT",AF="item-content__FJ",LF="readonly_jlY",MF="label_EcW",RF="content_I1Y",kF="arrow-button_V0s",DF="field_hZA",UF="hidden_o8e",FF="color-field_zGk";function GF(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function VF(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return GF(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return GF(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var BF=function(){var t=cr(),n=VF((0,i.useState)(!1),2),r=n[0],o=n[1],a=t&&!r;return(0,e.jsx)(Jh,{onFocusChange:o,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(KF,{readonly:a}),(0,e.jsx)(WF,{readonly:a}),(0,e.jsx)(zF,{readonly:a}),(0,e.jsx)(ZF,{readonly:a}),(0,e.jsx)(QF,{readonly:a}),(0,e.jsx)(eG,{readonly:a}),(0,e.jsx)(XF,{readonly:a}),(0,e.jsx)(tG,{})]})})},HF=function(t){var n=t.focusKey,r=t.title,o=t.readonly,a=t.hidden,l=t.leftDisabled,s=t.rightDisabled,c=t.uiTag,u=t.uiTagLeft,d=t.uiTagRight,f=t.children,h=t.onSelectLeft,m=t.onSelectRight,p=(l||!h)&&(s||!m),v=(0,i.useMemo)((function(){return{"Change Tool Option":p?null:function(e){Jt(Qt.dragSlider),e<0?h&&!l&&(h(),u&&lu(u)):e>0&&m&&!s&&(m(),d&&lu(d))}}}),[p,l,h,m,s,u,d]);return(0,e.jsx)(Tn,{actions:v,children:(0,e.jsx)(Tr,{focusKey:n,className:Oe()(CF,o&&LF,a&&UF),children:(0,e.jsxs)("div",{className:AF,children:[null!=r&&(0,e.jsx)("div",{className:MF,children:r}),(0,e.jsx)(bS,{uiTag:a?void 0:c,disableBlinking:!0,children:(0,e.jsxs)("div",{className:RF,children:[!o&&(0,e.jsx)(bS,{uiTag:u,children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/ThickStrokeArrowLeft.svg",disabled:l,className:kF,onSelect:h})}),f,!o&&(0,e.jsx)(bS,{uiTag:d,children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/ThickStrokeArrowRight.svg",disabled:s,className:kF,onSelect:m})})]})})]})})})},KF=function(t){var n,r=t.readonly,o=C(uD),a=C(cD),s=(0,i.useCallback)((function(){var e=ap(a,a.findIndex((function(e){return c(e.entity,o)})),!0);e&&mD(e.entity)}),[o,a]),u=(0,i.useCallback)((function(){var e=ip(a,a.findIndex((function(e){return c(e.entity,o)})),!0);e&&mD(e.entity)}),[o,a]);return(0,e.jsx)(OI,{children:a.length>1&&(0,e.jsx)("div",{className:PF,children:(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.THEME_PANEL_TITLE,{}),readonly:r,uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsThemes,onSelectLeft:s,onSelectRight:u,children:a.map((function(t){return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_TITLE,{hash:t.name}),description:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DESCRIPTION,{hash:t.name}),children:(0,e.jsx)(wF,{focusKey:Te,value:t.entity,src:t.icon,selected:c(t.entity,o),highlight:t.highlight,onClick:mD})},l(t.entity))}))})})})},WF=function(t){var n,r,o=t.readonly,a=C(fR);cu(null===(n=TS.value)||void 0===n?void 0:n.toolOptionsModes);var l=(0,i.useCallback)((function(e){return CR(e)}),[]),s=(0,i.useCallback)((function(){var e=ap(a.modes,a.modes.findIndex((function(e){return e.index===a.modeIndex})),!0);e&&l(e.index)}),[a.modeIndex,a.modes,l]),c=(0,i.useCallback)((function(){var e=ip(a.modes,a.modes.findIndex((function(e){return e.index===a.modeIndex})),!0);e&&l(e.index)}),[a.modeIndex,a.modes,l]);return(0,e.jsx)(OI,{children:a.modes.length>1&&(0,e.jsx)("div",{className:PF,children:(0,e.jsx)(HF,{title:a.modes.length<=7?(0,e.jsx)(Ks.Toolbar.TOOL_MODE_TITLE,{}):null,readonly:o,uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolOptionsModes,onSelectLeft:s,onSelectRight:c,children:a.modes.map((function(t){var n;return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_TITLE,{hash:t.id}),description:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DESCRIPTION,{hash:t.id}),children:(0,e.jsx)(wF,{focusKey:Te,value:t.index,src:t.icon,selected:t.index===a.modeIndex,onSelect:l,uiTag:(null===(n=TS.value)||void 0===n?void 0:n.toolOptionsModes)+t.id})},t.id)}))})})})},zF=function(t){var n,r,o=t.readonly,a=C(KR),l=C(WR),s=C(zR),u=C(YR),d=C(XR),f=l<=u,h=l>=d,m=(0,i.useCallback)((function(){qR(at(YF(l,-(l>550?100:l>125?50:10)),u,d))}),[l,u,d]),p=(0,i.useCallback)((function(){qR(at(YF(l,l>475?100:l>95?50:10),u,d))}),[l,d,u]),v=s<=.01,g=s>=1,y=(0,i.useCallback)((function(){$R(at(YF(s,-(s>.11?.05:.01)),.01,1))}),[s]),b=(0,i.useCallback)((function(){$R(at(YF(s,+(s>.095?.05:.01)),.01,1))}),[s]);return(0,e.jsx)(OI,{children:!c(a,ii)&&(0,e.jsxs)("div",{className:PF,children:[(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.BRUSH_SIZE,{}),readonly:o,uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsBrushSize,leftDisabled:f,onSelectLeft:m,rightDisabled:h,onSelectRight:p,children:(0,e.jsx)("div",{className:DF,children:(0,e.jsx)(dc,{value:l,unit:tc.Integer})})}),(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.BRUSH_STRENGTH,{}),readonly:o,uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolOptionsBrushStrength,leftDisabled:v,onSelectLeft:y,rightDisabled:g,onSelectRight:b,children:(0,e.jsx)("div",{className:DF,children:(0,e.jsx)(dc,{value:100*s,unit:tc.Percentage})})})]})})};function YF(e,t){return t*Math.round(e/t)+t}var XF=function(t){var n,r=t.readonly,o=C(hR),a=C(pR),l=C(mR),s=C(vR),c=qF(o),u=(l&a)===a,d=(0,i.useCallback)((function(){kR(u?l&~a:l|a)}),[u,a,l]),f=(0,i.useCallback)((function(e){var t=1<<e;kR(0!=(l&t)?l&~t:l|t)}),[l]);return(0,e.jsx)(OI,{children:c.length>0&&(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsSnapping,children:(0,e.jsxs)("div",{className:PF,children:[r&&(0,e.jsxs)(HF,{title:c.length<=6?(0,e.jsx)(Ks.Toolbar.SNAPPING_TITLE,{}):null,readonly:!0,children:[(0,e.jsx)(SF,{focusKey:Te,src:"Media/Tools/Snap Options/All.svg",selected:u}),c.map((function(t){return(0,e.jsx)(wF,{focusKey:Te,value:t,src:"Media/Tools/Snap Options/"+s[t]+".svg",selected:0!=(l&1<<t)},t)}))]}),(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_SNAP_ALL,{}),readonly:r,hidden:r,onSelectLeft:d,onSelectRight:d,children:(0,e.jsx)(SF,{src:"Media/Tools/Snap Options/All.svg",selected:u,onSelect:d})}),c.map((function(t){var n=function(){return f(t)};return(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP,{hash:s[t]}),readonly:r,hidden:r,onSelectLeft:n,onSelectRight:n,children:(0,e.jsx)(wF,{value:t,src:"Media/Tools/Snap Options/"+s[t]+".svg",selected:0!=(l&1<<t),onSelect:f})},t)}))]})})})},qF=function(e){return(0,i.useMemo)((function(){for(var t=[],n=0;e>>n>0;)0!=(e>>n&1)&&t.push(n),n++;return t}),[e])},$F=[10,5,2.5,1.25],QF=function(t){var n,r,o,a,l=t.readonly,s=C(gR),c=C(yR),u=C(bR),d=c<=s.min,f=c>=s.max,h=u<=$F[$F.length-1],m=(0,i.useCallback)((function(){for(var e=0;e<$F.length;e++)if($F[e]<u){var t,n;RR($F[e]),Jt(Qt.decreaseElevation),(null===(t=TS.value)||void 0===t?void 0:t.toolOptionsElevationStep)&&lu(null===(n=TS.value)||void 0===n?void 0:n.toolOptionsElevationStep);break}}),[u]),p=u>=$F[0],v=(0,i.useCallback)((function(){for(var e=$F.length-1;e>=0;e--)if($F[e]>u){var t,n;RR($F[e]),Jt(Qt.increaseElevation),(null===(t=TS.value)||void 0===t?void 0:t.toolOptionsElevationStep)&&lu(null===(n=TS.value)||void 0===n?void 0:n.toolOptionsElevationStep);break}}),[u]);return(0,e.jsx)(OI,{children:s.min<s.max&&(0,e.jsxs)("div",{className:PF,children:[(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.ELEVATION_TITLE,{}),uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsElevation,uiTagLeft:null===(r=TS.value)||void 0===r?void 0:r.toolOptionsElevationDecrease,uiTagRight:null===(o=TS.value)||void 0===o?void 0:o.toolOptionsElevationIncrease,readonly:l,leftDisabled:d,onSelectLeft:MR,rightDisabled:f,onSelectRight:LR,children:(0,e.jsx)("div",{className:DF,children:(0,e.jsx)(dc,{value:c,unit:tc.NetElevation})})},"elevation"),(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_ELEVATION_STEP,{}),hidden:l,uiTag:null===(a=TS.value)||void 0===a?void 0:a.toolOptionsElevationStep,onSelectLeft:h?void 0:m,onSelectRight:p?void 0:v,children:(0,e.jsx)("div",{className:DF,children:(0,e.jsx)(dc,{value:u,unit:tc.NetElevation})})},"elevationStep")]})})},ZF=function(t){var n,r=t.readonly,o=C(fR),a=C(ER),l=C(OR),s=(0,i.useCallback)((function(){FR(!l),Jt(l?Qt.increaseElevation:Qt.decreaseElevation)}),[l]);return(0,e.jsx)(OI,{children:o.id!==VR&&a&&(0,e.jsx)("div",{className:PF,children:(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.UNDERGROUND_MODE_TITLE,{}),readonly:r,uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsUnderground,onSelectLeft:s,onSelectRight:s,children:(0,e.jsx)(SF,{src:"Media/Tools/Net Tool/Underground.svg",disabled:!a,selected:l,onSelect:s})})})})},JF=[2,4,8,16,24,32,40,48,56,64,72,80,88,96],eG=function(t){var n,r,o,a,l=t.readonly,s=C(xR),c=C(_R),u=C(jR),d=JF,f=u<=d[0],h=(0,i.useCallback)((function(){for(var e=d.length-1;e>=0;e--)if(d[e]<u){UR(d[e]);break}}),[u,d]),m=u>=d[d.length-1],p=(0,i.useCallback)((function(){for(var e=0;e<d.length;e++)if(d[e]>u){UR(d[e]);break}}),[u,d]);return(0,e.jsx)(OI,{children:s&&(0,e.jsxs)("div",{className:Oe()(PF,l&&!c&&UF),children:[(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.PARALLEL_MODE_TITLE,{}),hidden:l,onSelectLeft:DR,onSelectRight:DR,children:(0,e.jsx)(SF,{src:"Media/Tools/Net Tool/Parallel.svg",selected:c,onSelect:DR,uiTag:l||null===(n=TS.value)||void 0===n?void 0:n.toolOptionsParallelMode})},"parallelMode"),c&&(0,e.jsx)(HF,{title:(0,e.jsx)(Ks.Toolbar.PARALLEL_OFFSET_TITLE,{}),readonly:l,leftDisabled:f,onSelectLeft:h,rightDisabled:m,onSelectRight:p,uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolOptionsParallelModeOffset,uiTagLeft:null===(o=TS.value)||void 0===o?void 0:o.toolOptionsParallelModeOffsetDecrease,uiTagRight:null===(a=TS.value)||void 0===a?void 0:a.toolOptionsParallelModeOffsetIncrease,children:(0,e.jsx)("div",{className:DF,children:(0,e.jsx)(dc,{value:u/8,unit:tc.FloatTwoFractions})})},"parallelOffset")]})})},tG=function(){var t=C(fR),n=C(SR),r=C(wR),o=(0,i.useCallback)((function(e){return NR(e)}),[]);return(0,e.jsx)(OI,{children:t.id!==VR&&n&&(0,e.jsx)("div",{className:PF,children:(0,e.jsx)(Tr,{className:Oe()(CF,LF),children:(0,e.jsxs)("div",{className:AF,children:[(0,e.jsx)("div",{className:MF,children:(0,e.jsx)(Ks.ToolOptions.COLOR_TITLE,{hash:t.id})}),(0,e.jsx)("div",{className:RF,children:(0,e.jsx)(jF,{className:FF,selectAction:"Toggle Tool Color Picker",popupDirection:"up",value:r,onChange:o})})]})})})})};const nG="item_bZY",rG="item-content_nNz",iG="label_RZX",oG="content_ZIz",aG="number-field__Hd",lG="start-button_F6t",sG="end-button_ztm";var cG=function(){return(0,e.jsxs)(Fn,{children:[(0,e.jsx)(dG,{}),(0,e.jsx)(fG,{}),(0,e.jsx)(hG,{}),(0,e.jsx)(bG,{}),(0,e.jsx)(yG,{}),(0,e.jsx)(jG,{}),(0,e.jsx)(pG,{}),(0,e.jsx)(EG,{})]})},uG=function(t){var n=t.title,r=t.uiTag,i=t.children;return(0,e.jsx)(Tr,{className:nG,children:(0,e.jsxs)("div",{className:rG,children:[(0,e.jsx)("div",{className:iG,children:n}),(0,e.jsx)(bS,{uiTag:r,children:(0,e.jsx)("div",{className:oG,children:i})})]})})},dG=function(){var t,n=C(uD),r=C(cD),i=HN(mD);return(0,e.jsx)(OI,{children:r.length>1&&(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.Toolbar.THEME_PANEL_TITLE,{}),uiTag:null===(t=TS.value)||void 0===t?void 0:t.toolOptionsThemes,children:(0,e.jsx)(Mn,{focused:l(n),direction:On.Horizontal,onChange:i,children:r.map((function(t){return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_TITLE,{hash:t.name}),description:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DESCRIPTION,{hash:t.name}),children:(0,e.jsx)(wF,{focusKey:l(t.entity),value:t.entity,src:t.icon,selected:c(t.entity,n),highlight:t.highlight,onClick:mD})},l(t.entity))}))})})})},fG=function(){var t,n;cu(null===(t=TS.value)||void 0===t?void 0:t.toolOptionsModes);var r=C(fR),o=(0,i.useCallback)((function(e){return CR(e)}),[]),a=(0,i.useCallback)((function(e){"number"==typeof e&&o(e)}),[o]);return(0,e.jsx)(OI,{children:r.modes.length>1&&(0,e.jsx)(uG,{title:r.modes.length<=7?(0,e.jsx)(Ks.Toolbar.TOOL_MODE_TITLE,{}):null,uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsModes,children:(0,e.jsx)(Mn,{focused:r.modeIndex,direction:On.Horizontal,onChange:a,children:r.modes.map((function(t){var n;return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_TITLE,{hash:t.id}),description:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DESCRIPTION,{hash:t.id}),children:(0,e.jsx)(wF,{uiTag:(null===(n=TS.value)||void 0===n?void 0:n.toolOptionsModes)+t.id,focusKey:t.index,value:t.index,src:t.icon,selected:t.index===r.modeIndex,onSelect:o})},t.id)}))})})})},hG=function(){var t,n,r=C(KR),o=C(WR),a=C(zR),l=C(YR),s=C(XR),u=o<=l,d=o>=s,f=(0,i.useCallback)((function(){qR(at(mG(o,-(o>550?100:o>125?50:10)),l,s))}),[o,l,s]),h=(0,i.useCallback)((function(){qR(at(mG(o,o>475?100:o>95?50:10),l,s))}),[o,s,l]),m=a<=.01,p=a>=1,v=(0,i.useCallback)((function(){$R(at(mG(a,-(a>.11?.05:.01)),.01,1))}),[a]),g=(0,i.useCallback)((function(){$R(at(mG(a,+(a>.095?.05:.01)),.01,1))}),[a]);return(0,e.jsx)(OI,{children:!c(r,ii)&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.Toolbar.BRUSH_SIZE,{}),uiTag:null===(t=TS.value)||void 0===t?void 0:t.toolOptionsBrushSize,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(SF,{src:"Media/Glyphs/ThickStrokeArrowDown.svg",disabled:u,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DECREASE_BRUSH_SIZE,{}),selectSound:Qt.decreaseElevation,className:lG,onSelect:f}),(0,e.jsx)("div",{className:aG,children:(0,e.jsx)(dc,{value:o,unit:tc.Integer})}),(0,e.jsx)(SF,{src:"Media/Glyphs/ThickStrokeArrowUp.svg",disabled:d,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_INCREASE_BRUSH_SIZE,{}),selectSound:Qt.increaseElevation,className:sG,onSelect:h})]})}),(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.Toolbar.BRUSH_STRENGTH,{}),uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsBrushStrength,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(SF,{src:"Media/Glyphs/ThickStrokeArrowDown.svg",disabled:m,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DECREASE_BRUSH_STRENGTH,{}),selectSound:Qt.decreaseElevation,className:lG,onSelect:v}),(0,e.jsx)("div",{className:aG,children:(0,e.jsx)(dc,{value:100*a,unit:tc.Percentage})}),(0,e.jsx)(SF,{src:"Media/Glyphs/ThickStrokeArrowUp.svg",disabled:p,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_INCREASE_BRUSH_STRENGTH,{}),selectSound:Qt.increaseElevation,className:sG,onSelect:g})]})})]})})};function mG(e,t){return t*Math.round(e/t)+t}var pG=function(){var t,n=C(hR),r=C(pR),o=C(mR),a=C(vR),l=vG(n),s=(o&r)===r,c=(0,i.useCallback)((function(){kR(s?o&~r:o|r)}),[s,r,o]),u=(0,i.useCallback)((function(e){var t=1<<e;kR(0!=(o&t)?o&~t:o|t)}),[o]);return(0,e.jsx)(OI,{children:l.length>0&&(0,e.jsx)(uG,{title:l.length<=6?(0,e.jsx)(Ks.Toolbar.SNAPPING_TITLE,{}):null,uiTag:null===(t=TS.value)||void 0===t?void 0:t.toolOptionsSnapping,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[l.length>1&&(0,e.jsx)(SF,{multiSelect:!0,src:"Media/Tools/Snap Options/All.svg",selected:s,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_SNAP_ALL,{}),onSelect:c}),l.map((function(t){return(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP,{hash:a[t]}),children:(0,e.jsx)(wF,{focusKey:t,value:t,src:"Media/Tools/Snap Options/"+a[t]+".svg",selected:0!=(o&1<<t),multiSelect:!0,onSelect:u},t)},t)}))]})})})},vG=function(e){return(0,i.useMemo)((function(){for(var t=[],n=0;e>>n>0;)0!=(e>>n&1)&&t.push(n),n++;return t}),[e])},gG=[10,5,2.5,1.25],yG=function(){var t,n,r,o,a=C(gR),l=C(yR),s=C(bR),c=l<=a.min,u=l>=a.max,d=(0,i.useCallback)((function(e){return RR(e)}),[]),f=(0,i.useCallback)((function(){return MR()}),[]),h=(0,i.useCallback)((function(){return LR()}),[]);return(0,e.jsx)(OI,{children:a.min<a.max&&(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.Toolbar.ELEVATION_TITLE,{}),uiTag:null===(t=TS.value)||void 0===t?void 0:t.toolOptionsElevation,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(SF,{src:"Media/Glyphs/ThickStrokeArrowDown.svg",disabled:c,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_DECREASE_ELEVATION,{}),selectSound:Qt.decreaseElevation,uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsElevationDecrease,className:lG,onSelect:f}),(0,e.jsx)("div",{className:aG,children:(0,e.jsx)(dc,{value:l,unit:tc.NetElevation})}),(0,e.jsx)(SF,{src:"Media/Glyphs/ThickStrokeArrowUp.svg",disabled:u,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_INCREASE_ELEVATION,{}),selectSound:Qt.increaseElevation,uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolOptionsElevationIncrease,className:sG,onSelect:h}),(0,e.jsx)(NF,{selectedValue:s,values:gG,uiTag:null===(o=TS.value)||void 0===o?void 0:o.toolOptionsElevationStep,tooltip:(0,e.jsx)(Ks.ToolOptions.TOOLTIP_ELEVATION_STEP,{}),onSelect:d})]})})})},bG=function(){var t,n=C(fR),r=C(ER),o=C(OR),a=(0,i.useCallback)((function(){return FR(!o)}),[o]);return(0,e.jsx)(OI,{children:n.id!==VR&&r&&(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.Toolbar.UNDERGROUND_MODE_TITLE,{}),children:(0,e.jsx)(SF,{src:"Media/Tools/Net Tool/Underground.svg",disabled:!r,selected:o,multiSelect:!0,uiTag:null===(t=TS.value)||void 0===t?void 0:t.toolOptionsUnderground,tooltip:(0,e.jsx)(Ks.Toolbar.TOGGLE_UNDERGROUND_MODE,{}),selectSound:o?Qt.increaseElevation:Qt.decreaseElevation,onSelect:a})})})},xG=new Se("PARALLEL_MODE_TOGGLE"),_G=[2,4,8,16,24,32,40,48,56,64,72,80,88,96],jG=function(){var t,n,r,o,a=C(xR),l=C(_R),s=C(jR),c=(0,i.useMemo)((function(){return _G.sort((function(e,t){return e-t}))}),[]),u=s<=c[0],d=(0,i.useCallback)((function(){for(var e=c.length-1;e>=0;e--)if(c[e]<s){UR(c[e]);break}}),[s,c]),f=s>=c[c.length-1],h=(0,i.useCallback)((function(){for(var e=0;e<c.length;e++)if(c[e]>s){UR(c[e]);break}}),[s,c]);return(0,e.jsx)(OI,{children:a&&(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.Toolbar.PARALLEL_MODE_TITLE,{}),children:(0,e.jsxs)(Fn,{initialFocused:xG,direction:On.Horizontal,children:[l&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(SF,{src:"Media/Tools/Net Tool/ParallelMinus.svg",tooltip:(0,e.jsx)(Ks.Toolbar.DECREASE_PARALLEL_OFFSET,{}),className:lG,disabled:u,onSelect:d,uiTag:null===(t=TS.value)||void 0===t?void 0:t.toolOptionsParallelModeOffsetDecrease}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolOptionsParallelModeOffset,children:(0,e.jsx)("div",{className:aG,children:(0,e.jsx)(dc,{value:s/8,unit:tc.FloatTwoFractions})})}),(0,e.jsx)(SF,{src:"Media/Tools/Net Tool/ParallelPlus.svg",tooltip:(0,e.jsx)(Ks.Toolbar.INCREASE_PARALLEL_OFFSET,{}),className:sG,disabled:f,onSelect:h,uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolOptionsParallelModeOffsetIncrease})]}),(0,e.jsx)(SF,{focusKey:xG,src:"Media/Tools/Net Tool/Parallel.svg",tooltip:(0,e.jsx)(Ks.Toolbar.TOGGLE_PARALLEL_MODE,{}),selected:l,multiSelect:!0,onSelect:DR,uiTag:null===(o=TS.value)||void 0===o?void 0:o.toolOptionsParallelMode})]})})})},EG=function(){var t=C(fR),n=C(SR),r=C(wR),o=(0,i.useCallback)((function(e){return NR(e)}),[]);return(0,e.jsx)(OI,{children:t.id!==VR&&n&&(0,e.jsx)(uG,{title:(0,e.jsx)(Ks.ToolOptions.COLOR_TITLE,{hash:t.id}),children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.ToolOptions.COLOR_TOOLTIP,{hash:t.id}),children:(0,e.jsx)(jF,{popupDirection:"up",value:r,onChange:o})})})})};const OG={"tool-options-panel":"tool-options-panel_Se6",toolOptionsPanel:"tool-options-panel_Se6","gamepad-active":"gamepad-active_Qvi",gamepadActive:"gamepad-active_Qvi",enter:"enter_YDH","exit-active":"exit-active_hKG",exitActive:"exit-active_hKG","enter-active":"enter-active_bG3",enterActive:"enter-active_bG3",exit:"exit_oe7"};var TG=i.forwardRef((function(t,n){var r,i=t.focusKey,o=t.className,a=t.onClose,l=cr();return(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.toolOptions,disableBlinking:!0,children:(0,e.jsx)(He,{focusKey:i,children:(0,e.jsx)(wn,{onAction:a,children:(0,e.jsx)($t,{styles:OG,children:(0,e.jsx)(Or,{ref:n,className:Oe()(OG.toolOptionsPanel,l&&OG.gamepadActive,o),children:l?(0,e.jsx)(BF,{}):(0,e.jsx)(cG,{})})})})})})}));function IG(){var e=C(cD),t=C(fR),n=C(KR),r=C(hR),i=C(gR),o=C(xR),a=C(ER),l=C(SR);return t.id!==HR&&(e.length>1||t.modes.length>1||0!==r||i.min<i.max||o||l||t.id!==VR&&a||!c(n,ii))}const SG="background-process-indicator_NS7",wG="spinner_TZP",NG="message_UX3";var PG,CG=function(t){var n=t.className,r=C(J);return r?(0,e.jsxs)("div",{className:Oe()(SG,n),children:[(0,e.jsx)("div",{className:NG,children:(0,e.jsx)(Ss,{id:r})}),(0,e.jsx)(ll,{src:"Media/Glyphs/ArrowCircular.svg",className:wG})]}):null},AG=function(t){var n=t.disabled,r=void 0===n||n,o=t.children,a=(0,i.useContext)(Ge);return(0,e.jsx)(Ge.Provider,{value:r?Ve:a,children:o})},LG="climate",MG=E(LG,"seasonNameId"),RG=E(LG,"weather"),kG=E(LG,"temperature");!function(e){e[e.Clear=0]="Clear",e[e.Few=1]="Few",e[e.Scattered=2]="Scattered",e[e.Broken=3]="Broken",e[e.Overcast=4]="Overcast",e[e.Rain=5]="Rain",e[e.Snow=6]="Snow",e[e.Hail=7]="Hail",e[e.Storm=8]="Storm"}(PG||(PG={}));const DG="climate-field_dIy field_eKJ",UG="weather_dXo",FG="weather-container_L1D",GG="active_k1G",VG="obstructed_oBa",BG="sun_XMt celestial-object_su7",HG="moon_TlF celestial-object_su7",KG="weather-icon_BeV",WG="temperature_CiN",zG="season_js3",YG="season-hidden_Y_1";function XG(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var qG=function(t){var n=t.hideSeason,r=t.theme,i=C(MG),o=C(RG),a=C(kG),l=function(e){switch(e){case Up.Sunrise:case Up.Day:case Up.Sunset:return!1;default:return!0}}(C(Hp));return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_WEATHER,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_WEATHER,{}),children:(0,e.jsxs)(Tr,{className:Oe()(DG,null==r?void 0:r.climateField,XG({},YG,n)),children:[(0,e.jsx)("div",{className:Oe()(UG,null==r?void 0:r.weather),children:(0,e.jsxs)("div",{className:FG,children:[(0,e.jsx)("img",{src:"Media/Game/Climate/Sun.svg",className:Oe()(BG,!l&&GG,o>PG.Few&&VG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Moon.svg",className:Oe()(HG,l&&GG,o>PG.Few&&VG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Few.svg",className:Oe()(KG,o===PG.Few&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Scattered.svg",className:Oe()(KG,o===PG.Scattered&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Broken.svg",className:Oe()(KG,o===PG.Broken&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Overcast.svg",className:Oe()(KG,o===PG.Overcast&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Rain.svg",className:Oe()(KG,o===PG.Rain&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Snow.svg",className:Oe()(KG,o===PG.Snow&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Hail.svg",className:Oe()(KG,o===PG.Hail&&GG)}),(0,e.jsx)("img",{src:"Media/Game/Climate/Storm.svg",className:Oe()(KG,o===PG.Storm&&GG)}),(0,e.jsx)("div",{className:Oe()(WG,null==r?void 0:r.temperature),children:(0,e.jsx)(dc,{value:a,unit:tc.Temperature})})]})}),!n&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(ok,{}),(0,e.jsx)("div",{className:Oe()(zG,null==r?void 0:r.season),children:null!=i&&(0,e.jsx)(Ss,{id:i})})]})]})})};var $G="editorBottomBar",QG=E($G,"timeOfDay",0),ZG=E($G,"date",0),JG=E($G,"cloudiness",0),eV=function(e){return N($G,"setTimeOfDay",e)},tV=function(){return N($G,"resetTimeOfDay")},nV=function(e){return N($G,"setDate",e)},rV=function(){return N($G,"resetDate")},iV=function(e){return N($G,"setCloudiness",e)},oV=function(){return N($G,"resetCloudiness")};const aV="bottom-bar_ODl",lV="bp-indicator_RBs",sV="button_wKY",cV="button-highlight_lZc",uV="sliders_H5X",dV="slider_aPR",fV="slider-container_Fkn",hV="aside_uAL",mV="icon_KvW item-mouse-states_Fmi item-focused_FuT",pV="controls_tq0",vV="modes_Bd5",gV="inspector-modes_ur5";var yV=function(t){var n=t.className,r=t.onPauseMenuToggle,i=C(ZG),o=C(QG),a=C(JG);return(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:Oe()(aV,n),children:[(0,e.jsxs)("div",{className:pV,children:[(0,e.jsxs)("div",{className:hV,children:[(0,e.jsx)(Ok,{disablePauseAnimation:!0}),(0,e.jsx)(AG,{children:(0,e.jsx)(qG,{hideSeason:!0})})]}),(0,e.jsxs)("div",{className:uV,children:[(0,e.jsx)(bV,{value:o,onChange:eV,icon:"Media/Editor/Time.svg",onReset:tV,sliderTooltip:(0,e.jsx)(Ks.Editor.TIME_OF_DAY,{}),resetTooltip:(0,e.jsx)(Ks.Editor.RESET_TIME_OF_DAY,{})}),(0,e.jsx)(bV,{value:i,onChange:nV,icon:"Media/Editor/Date.svg",onReset:rV,sliderTooltip:(0,e.jsx)(Ks.Editor.TIME_OF_YEAR,{}),resetTooltip:(0,e.jsx)(Ks.Editor.RESET_TIME_OF_YEAR,{})}),(0,e.jsx)(bV,{value:a,onChange:iV,icon:"Media/Editor/Weather.svg",onReset:oV,sliderTooltip:(0,e.jsx)(Ks.Editor.CLOUDINESS,{}),resetTooltip:(0,e.jsx)(Ks.Editor.RESET_CLOUDINESS,{})})]}),(0,e.jsx)("div",{children:(0,e.jsx)(CG,{className:lV})})]}),(0,e.jsxs)("div",{className:vV,children:[(0,e.jsxs)("div",{className:gV,children:[(0,e.jsx)(xV,{cameraMode:qL.FirstPerson,icon:"Media/Editor/CinematicCameraOn.svg",offIcon:"Media/Editor/CinematicCameraOff.svg",tooltip:(0,e.jsx)(Ks.PhotoMode.TOGGLE_FIRST_PERSON_MODE,{})}),(0,e.jsx)(xV,{cameraMode:qL.Orbit,icon:"Media/Game/Icons/Orbit.svg",tooltip:(0,e.jsx)(Ks.PhotoMode.TOGGLE_ORBIT_MODE,{})}),(0,e.jsx)(xl,{src:"Media/Editor/Edit.svg",className:sV}),(0,e.jsx)(xl,{src:"Media/Editor/Save.svg",className:sV}),(0,e.jsx)(xl,{src:"Media/Editor/Load.svg",className:sV})]}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Common.PAUSE_MENU_TOGGLE_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Gear.svg",className:sV,onSelect:r})})]})]})})},bV=function(t){var n=t.value,r=t.onChange,i=t.icon,o=t.onReset,a=t.sliderTooltip,l=t.resetTooltip;return(0,e.jsxs)("div",{className:dV,children:[(0,e.jsx)(xO,{tooltip:l,children:(0,e.jsx)(xl,{src:i,className:mV,onSelect:o})}),(0,e.jsx)(Or,{className:fV,children:(0,e.jsx)(eA,{children:(0,e.jsx)(xO,{tooltip:a,children:(0,e.jsx)(Fm,{value:n,start:0,end:1,noFill:!0,onChange:r})})})})]})},xV=function(t){var n=t.cameraMode,r=t.icon,o=t.offIcon,a=t.tooltip,l=C(oM)===n,s=(0,i.useCallback)((function(){aM(l?qL.Default:n)}),[l,n]),c=void 0===o||l?r:o;return(0,e.jsx)(xO,{tooltip:a,children:(0,e.jsx)(xl,{src:c,className:Oe()(sV,l&&cV),onSelect:s})})};function _V(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function EV(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){jV(e,t,n[t])}))}return e}function OV(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function TV(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function IV(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return _V(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _V(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var SV=i.forwardRef((function(t,n){var r=t.theme,o=void 0===r?Vr:r,a=t.onClose,l=t.expanded,s=void 0===l||l,c=t.headerText,u=t.onToggleExpanded,d=t.className,f=t.children,h=t.isFocusRoot,m=TV(t,["theme","onClose","expanded","headerText","onToggleExpanded","className","children","isFocusRoot"]),p=Gr(o),v=IV((0,i.useState)(s),2),g=v[0],y=v[1],b=(0,i.useCallback)((function(){Jt(Qt.expandPanel),y((function(e){return!e})),u&&u(!g)}),[g,u]),x=(0,i.useMemo)((function(){return{theme:p,onClose:a,expanded:g,toggleExpanded:b}}),[p,a,g,b]);(0,i.useEffect)((function(){y(s)}),[s]);var _=h?Lr:Jh;return(0,e.jsx)(_,{children:(0,e.jsx)(wn,{onAction:a,children:(0,e.jsx)(Ur.Provider,{value:x,children:(0,e.jsx)($r,OV(EV({theme:p,ref:n,header:(0,e.jsx)(wV,{children:c})},m),{className:Oe()(g?"expanded":"collapsed","collapsible",d),children:g?f:void 0}))})})})})),wV=function(t){var n=t.icon,r=t.theme,o=t.className,a=t.children,l=(0,i.useContext)(Ur),s=!cr()&&null!=l.onClose,c=null!=r?r:l.theme;return(0,e.jsxs)("div",{onClick:l.toggleExpanded,className:Oe()(c.titleBar,o),children:[null!=n?(0,e.jsx)("img",{src:n,className:c.icon}):s&&(0,e.jsx)("div",{className:c.iconSpace}),(0,e.jsx)("div",{className:c.iconSpace}),(0,e.jsx)("div",{className:c.title,children:a}),(0,e.jsx)(ll,{className:c.toggle,src:l.expanded?c.toggleIconExpanded:c.toggleIcon}),s?(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:c.closeIcon,theme:_l,className:c.closeButton,onSelect:l.onClose,onClick:Cm}):null!=n&&(0,e.jsx)("div",{className:c.iconSpace})]})},NV="editorToolOptions",PV=E(NV,"children");const CV={panel:"panel_WVw panel_YqS",header:"header_IuN header_Bpo child-opacity-transition_nkS",content:"content_yeu content_AD7 child-opacity-transition_nkS",footer:"footer_j9m footer_pD5 child-opacity-transition_nkS",title:"title_q1x title_zQN"},AV={button:"button_WPv"},LV="editor-button-row_NuZ editor-widget_QQl",MV="button_dLA";function RV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function kV(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){RV(e,t,n[t])}))}return e}function DV(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var UV=function(t){var n=t.parent,r=t.path,i=t.props,o=xh(Th,Mh(n,r));return(0,e.jsx)(GV,{disabled:i.disabled,onSelect:o,children:(0,e.jsx)(ph,{value:i.displayName})})},FV=function(t){var n=t.children;return(0,e.jsx)("div",{className:LV,children:n})},GV=function(t){var n=t.disabled,r=t.className,i=t.children,o=t.onSelect;return(0,e.jsx)(ml,{disabled:n,theme:AV,className:Oe()(MV,r),onSelect:o,children:i})};function VV(e){return(0,i.useMemo)((function(){return{flex:"".concat(e.grow," ").concat(e.shrink," ").concat(BV(e.basis))}}),[e.basis,e.grow,e.shrink])}function BV(e){return e<0?"auto":0===e?"0":"".concat(e,"rem")}const HV="column_iuw editor-widget_QQl";var KV=function(t){var n=t.className,r=t.style,i=t.children;return(0,e.jsx)("div",{className:Oe()(HV,n),style:r,children:(0,e.jsx)(Fn,{children:i})})};const WV={pickerMinHeight:"400rem","editor-item-base":"editor-item-base_sYx editor-widget_QQl",editorItemBase:"editor-item-base_sYx editor-widget_QQl",centered:"centered_t1M","editor-item":"editor-item_VnW editor-item-base_sYx editor-widget_QQl",editorItem:"editor-item_VnW editor-item-base_sYx editor-widget_QQl",row:"row_d2o",label:"label_BbZ",control:"control_Hds",children:"children_ab1",toggle:"toggle_wf6",input:"input_Wfi","picker-toggle":"picker-toggle_d6k",pickerToggle:"picker-toggle_d6k","dropdown-toggle":"dropdown-toggle_kaj",dropdownToggle:"dropdown-toggle_kaj","directory-button":"directory-button_ayP",directoryButton:"directory-button_ayP","directory-icon":"directory-icon_NVL",directoryIcon:"directory-icon_NVL","vector-label":"vector-label_fxy",vectorLabel:"vector-label_fxy","vector-input":"vector-input_B11 input_Wfi",vectorInput:"vector-input_B11 input_Wfi","slider-container":"slider-container_Q_K",sliderContainer:"slider-container_Q_K",slider:"slider_ROT","slider-input":"slider-input_DXM input_Wfi",sliderInput:"slider-input_DXM input_Wfi",picker:"picker_Ij2","picker-popup":"picker-popup_pUb",pickerPopup:"picker-popup_pUb",swatch:"swatch_wOH",alpha:"alpha_Sth","group-children":"group-children_Zwx",groupChildren:"group-children_Zwx","expandable-header":"expandable-header_hQZ",expandableHeader:"expandable-header_hQZ","header-label":"header-label_H79",headerLabel:"header-label_H79","header-summary":"header-summary_U_C",headerSummary:"header-summary_U_C","expandable-children":"expandable-children_e7j",expandableChildren:"expandable-children_e7j","color-picker-container":"color-picker-container_bUs",colorPickerContainer:"color-picker-container_bUs","details-block":"details-block_E_n",detailsBlock:"details-block_E_n"};var zV=function(t){var n=t.disabled,r=t.centered,i=t.className,o=t.children;return(0,e.jsx)(Fn,{children:(0,e.jsx)("div",{className:Oe()(WV.editorItem,n&&"disabled",r&&WV.centered,i),children:o})})},YV=function(t){var n=t.disabled,r=t.centered,i=t.className,o=t.focusKey,a=void 0===o?Ie:o,l=t.onFocusChange,s=t.children;return(0,e.jsx)(Tr,{focusKey:n?Te:a,className:Oe()(WV.editorItem,n&&"disabled",r&&WV.centered,i),onFocusChange:l,children:s})},XV=function(t){var n=t.label,r=t.summary,o=t.expanded,a=t.disabled,l=t.centered,s=t.className,c=t.children,u=t.onExpandedChange,d=(0,i.useCallback)((function(){return u(!o)}),[o,u]);return(0,e.jsx)(Tr,{focusKey:a?Te:Ie,className:Oe()(WV.editorItemBase,a&&"disabled",l&&WV.centered,s),children:(0,e.jsxs)(Fn,{children:[(0,e.jsxs)(xl,{tinted:!0,src:o?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg",className:Oe()(WV.expandableHeader,o&&WV.expanded),onSelect:d,children:[(0,e.jsx)("div",{className:WV.headerLabel,children:n}),null!=r&&(0,e.jsx)("div",{className:WV.headerSummary,children:r})]}),o&&(0,e.jsx)("div",{className:WV.expandableChildren,children:c})]})})},qV=function(t){var n=t.label,r=t.onSelect,i=t.children;return(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,onClick:r,children:n}),i&&(0,e.jsx)("div",{className:WV.control,children:i})]})},$V=function(t){var n=t.visible,r=t.children;return n?(0,e.jsx)("div",{className:WV.detailsBlock,children:r}):null};const QV="compass_DU0",ZV="north_meN",JV="needle_PzX";var eB=function(t){var n=t.angle,r=t.className;return(0,e.jsxs)("div",{className:Oe()(QV,r),children:[(0,e.jsx)("div",{className:ZV,children:"N"}),(0,e.jsx)("img",{src:"Media/Editor/CompassNeedle.svg",className:JV,style:{transform:"rotate(".concat(n,"deg)")}})]})};const tB="divider_FEz";var nB=(0,i.createContext)({}),rB=function(){return(0,i.useContext)(nB)};function iB(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function oB(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function aB(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){oB(e,t,n[t])}))}return e}function lB(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function sB(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return iB(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return iB(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var cB={x:0,y:0},uB=function(e,t,n){var r=rB(),o=r.events.bindElement,a=r.viewport,l=e.onDrag,s=e.onWindowMouseMove,c=(0,i.useRef)(!1),u=sB((0,i.useState)(!1),2),d=u[0],f=u[1],h=sB((0,i.useState)(!1),2),m=h[0],p=h[1],v=(0,i.useRef)(a);v.current=a,(0,i.useEffect)((function(){if(e){var r=aB({},e),i=r.onMouseDown;if(r.onMouseDown=function(e,t){cB.x=e.clientX,cB.y=e.clientY,null==i||i(e,t)},r.onDrag){var a=r.onMouseDown;r.onMouseDown=function(e,t){null==a||a(e,t),t&&0===e.button&&!e.propagationStopped&&(e.propagationStopped=!0,f(!0))}}if(r.onMouseMove||n){var l=r.onMouseMove,s=r.onMouseEnter,u=r.onMouseLeave;r.onMouseMove=function(e,t){t?c.current||(null==s||s(e),c.current=!0,p(!0)):c.current&&(null==u||u(e),c.current=!1,p(!1)),null==l||l(e,t)}}if(r.onSelect||r.onClick||r.onDrag){var d=r.onClick;r.onClick=function(e,t){var n;t&&!e.propagationStopped&&(e.clientX===cB.x&&e.clientY===cB.y&&(e.propagationStopped=!0,null===(n=r.onSelect)||void 0===n||n.call(r,e),null==d||d(e)))}}return o(r,t)}}),[o,t,n,e]),(0,i.useEffect)((function(){if(d){var e=function(e){var n=v.current;if(e.buttons>0&&n){var r=n.posFromMouse(e),i=n.pointFromPos(r);null==l||l({point:i,position:r,shiftKey:e.shiftKey,ctrlKey:e.ctrlKey,altKey:e.altKey})}else t()},t=function(){requestAnimationFrame((function(){f(!1),document.removeEventListener("mousemove",e),document.removeEventListener("mouseup",t)}))};return document.addEventListener("mousemove",e),document.addEventListener("mouseup",t),function(){document.removeEventListener("mousemove",e),window.removeEventListener("mouseup",t)}}}),[d,l]),(0,i.useEffect)((function(){if(s){var e=function(e){var t=v.current;if(t){var n=t.posFromMouse(e),r=t.pointFromPos(n);s(lB(aB({},e),{point:r,position:n,shiftKey:e.shiftKey,ctrlKey:e.ctrlKey,altKey:e.altKey}))}};return document.addEventListener("mousemove",e),function(){document.removeEventListener("mousemove",e)}}}),[s]),(0,i.useEffect)((function(){var t=!!(e.focused||e.selected||m);null==n||n(t)}),[m,n,e.focused,e.selected])};function dB(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fB(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function hB(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var mB=(0,i.forwardRef)((function(t,n){var r=t.interaction,i=t.viewport,o=t.children,a=hB(t,["interaction","viewport","children"]);uB(a);a.onWindowMouseMove;var l=hB(a,["onWindowMouseMove"]),s="0 0 ".concat(null==i?void 0:i.size.width," ").concat(null==i?void 0:i.size.height);return(0,e.jsx)("svg",fB(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){dB(e,t,n[t])}))}return e}({ref:n,width:"100%",height:"100%",viewBox:s},l,r.bindings),{children:o}))})),pB=["onClick","onContextMenu","onDoubleClick","onMouseDown","onMouseEnter","onMouseLeave","onMouseMove","onMouseOut","onMouseOver","onMouseUp"];function vB(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function gB(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function yB(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function bB(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||_B(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function xB(e){return function(e){if(Array.isArray(e))return vB(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||_B(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _B(e,t){if(e){if("string"==typeof e)return vB(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?vB(e,t):void 0}}var jB=function(){var e=(0,i.useRef)();return(0,i.useMemo)((function(){var t={},n=function(n,r){if(e.current){var i,o=yB(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){gB(e,t,n[t])}))}return e}({},r),{position:e.current.posFromMouse(r),point:e.current.pointFromMouse(r)});null===(i=xB(t[n]||[]))||void 0===i||i.forEach((function(e){return e(o)}))}};return{events:{bindElement:function(n,r){var i=[];return Object.entries(n).forEach((function(n){var o=bB(n,2),a=o[0],l=o[1];if(pB.includes(a)){var s=function(t){if(e.current){var n,i=!r||r(null===(n=e.current)||void 0===n?void 0:n.posFromMouse(t),t);t.propagationStopped||"function"!=typeof l||l(t,i)}};!function(e,n){t[e]=t[e]?xB(t[e]).concat([n]):[n]}(a,s),i.push([a,s])}})),function(){i.forEach((function(e){var n,r,i=bB(e,2),o=i[0],a=i[1];return r=a,void t[n=o].splice(t[n].indexOf(r),1)}))}}},bindings:{onWheel:function(e){return n("onWheel",e)},onClick:function(e){return n("onClick",e)},onDoubleClick:function(e){return n("onDoubleClick",e)},onMouseDown:function(e){return n("onMouseDown",e)},onMouseUp:function(e){return n("onMouseUp",e)},onMouseMove:function(e){return n("onMouseMove",e)}},updateViewport:function(t){e.current=t}}}),[])},EB=function(e){return function(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];return 2===n.length?e({x:n[0],y:n[1]}):e(n[0])}};function OB(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function TB(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function IB(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){TB(o,r,i,a,l,"next",e)}function l(e){TB(o,r,i,a,l,"throw",e)}a(void 0)}))}}function SB(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return OB(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return OB(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var wB=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},NB={x:0,y:0};function PB(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CB(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function AB(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){CB(o,r,i,a,l,"next",e)}function l(e){CB(o,r,i,a,l,"throw",e)}a(void 0)}))}}function LB(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return PB(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PB(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var MB=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},RB={x:1,y:1},kB=.25,DB=.1,UB=100,FB=function(e,t){var n=(e.max.x-e.min.x)/2*t.x,r=(e.max.x+e.min.x)/2,i=(e.max.y-e.min.y)/2*t.y,o=(e.max.y+e.min.y)/2;return{min:{x:r-n,y:o-i},max:{x:r+n,y:o+i}}};function GB(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function VB(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return GB(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return GB(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var BB=function(e,t){var n=VB((0,i.useState)(),2),r=n[0],o=n[1],a=VB(function(e,t,n,r){var o=LB((0,i.useState)(RB),2),a=o[0],l=o[1],s=(0,i.useCallback)((function(e,t,r,i){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];l((function(a){var l=a.x,s=a.y;if("y"!==n&&!r)if(o)l=a.x+10*e;else{var c=e||t;l=a.x+Math.sign(c)*kB}return"x"===n||i||(s=o?a.y+10*t:a.y+Math.sign(t)*kB),{x:Math.min(UB,Math.max(DB,l)),y:Math.min(UB,Math.max(DB,s))}}))}),[n]);return(0,i.useEffect)((function(){if(n){var t=e.current,r=function(e){e.preventDefault(),s(e.deltaX,e.deltaY,e.ctrlKey,e.shiftKey)};return null==t||t.addEventListener("wheel",r),function(){null==t||t.removeEventListener("wheel",r)}}}),[s,e,n]),JS((0,i.useCallback)(AB((function(){var e;return MB(this,(function(t){switch(t.label){case 0:return r?[4,r()]:[3,2];case 1:e=t.sent(),s(e.x,e.y,!1,!1,!0),t.label=2;case 2:return[2]}}))})),[s,r]),n&&void 0!==r),(0,i.useMemo)((function(){return[e.current?FB(t,a):t,function(){return l(RB)}]}),[t,e,a])}(e,t.bounds,null==t?void 0:t.zoomable,t.zoomCallback),2),l=a[0],s=a[1],c=VB(function(e,t,n){var r=SB((0,i.useState)(NB),2),o=r[0],a=r[1];return(0,i.useEffect)((function(){if(e.current&&t){var n,r=e.current,i={x:0,y:0},o=function(e){var r=e.shiftKey?2:e.ctrlKey?.5:1;a((function(o){return n=n||o,{x:"y"===t?0:n.x+(i.x-e.x)*r,y:"x"===t?0:n.y+(i.y-e.y)*r}}))},l=function(e){1===e.button&&(i=e,window.addEventListener("mousemove",o),window.addEventListener("mouseup",(function(){n=void 0,window.removeEventListener("mousemove",o),window.removeEventListener("mouseup",o)})))};return r.addEventListener("mousedown",l),function(){r.removeEventListener("mousedown",l)}}}),[t,e]),JS((0,i.useCallback)(IB((function(){var e,r,i;return wB(this,(function(o){switch(o.label){case 0:return n?[4,n()]:[3,2];case 1:e=o.sent(),r="y"===t?0:e.x,i="x"===t?0:e.y,a((function(e){return{x:e.x+2*r,y:e.y+2*i}})),o.label=2;case 2:return[2]}}))})),[n,t]),t&&void 0!==n),(0,i.useMemo)((function(){return[t?o:NB,function(){return a(NB)}]}),[o,t])}(e,t.panable,t.panCallback),2),u=c[0],d=c[1],f=qd(),h=Gd(e),m=t||{},p=m.padding,v=void 0===p?0:p,g=m.inverted,y=void 0===g||g;return(0,i.useEffect)((function(){if(h&&h.width&&h.height){var e=function(e){return e*f},t=h.width,n=h.height,r=function(e,t,n,r){var i,o,a,l;if("number"==typeof e?i=o=a=l=t(e):"x"in e?(i=a=t(e.y),l=o=t(e.x)):(i=t(e.top),o=t(e.right),a=t(e.bottom),l=t(e.left)),l+o>=n||i+a>=r)throw new Error("SVG paddings on given axis can't add up to more than the width or height of svg");return{top:i,right:o,bottom:a,left:l}}(v,e,t,n),i=l||{min:{x:0,y:0},max:{x:t,y:n}},a=(t-(r.left+r.right))/(i.max.x-i.min.x),c=(n-(r.top+r.bottom))/(i.max.y-i.min.y);if(u&&(u.x||u.y)){var m={x:u.x/a,y:u.y/c*(y?-1:1)};i={min:{x:i.min.x+m.x,y:i.min.y+m.y},max:{x:i.max.x+m.x,y:i.max.y+m.y}}}var p={x:h.x,y:h.y},g=function(e){return r.left+(e-i.min.x)*a},b=function(e){return r.bottom+(e-i.min.y)*c},x=EB((function(e){return{x:g(e.x),y:b(e.y)}})),_=function(e){return(e-r.left)/a+i.min.x},j=function(e){return(e-r.bottom)/c+i.min.y},E=EB((function(e){return{x:_(e.x),y:j(e.y)}})),O=function(e){return e/a},T=function(e){return e/c},I=EB((function(e){return{x:O(e.x),y:T(e.y)}})),S=function(e){return e*a},w=function(e){return e*c},N=EB((function(e){return{x:S(e.x),y:w(e.y)}})),P=function(e){return{x:e.clientX-p.x,y:y?n-(e.clientY-p.y):e.clientY-p.y}};o({size:{width:t,height:n},bounds:i,offset:p,inverted:y,padding:r,px:_,py:j,vx:g,vy:b,sx:O,sy:T,svx:S,svy:w,rem:e,posFromPoint:x,pointFromPos:E,posFromMouse:P,pointFromMouse:function(e){return E(P(e))},scaleToPoint:I,scaleToViewport:N,resetViewport:function(){s(),d()}})}}),[l,v,y,t.bounds,u,e,f,d,s,h]),r};function HB(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function KB(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return HB(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return HB(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var WB=(0,i.createContext)({registerSVGContext:function(){}}),zB=function(t){var n=t.children,r=KB((0,i.useState)(),2),o=r[0],a=r[1],l=YB().registerSVGContext;return(0,i.useEffect)((function(){o&&l&&l(o)}),[o,l]),(0,e.jsx)(WB.Provider,{value:{registerSVGContext:a,svg:o},children:n})},YB=function(){return(0,i.useContext)(WB)};function XB(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function qB(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){XB(e,t,n[t])}))}return e}function $B(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function QB(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var ZB={min:{x:0,y:0},max:{x:1,y:1}},JB=function(t){var n=t.inverted,r=void 0===n||n,o=t.children,a=t.bounds,l=void 0===a?ZB:a,s=t.zoomable,c=t.panable,u=t.padding,d=t.zoomCallback,f=t.panCallback,h=QB(t,["inverted","children","bounds","zoomable","panable","padding","zoomCallback","panCallback"]),m=(0,i.useRef)(null),p=BB(m,{bounds:l,inverted:r,padding:u,zoomable:s,panable:c,zoomCallback:d,panCallback:f}),v=jB(),g=YB().registerSVGContext;(0,i.useEffect)((function(){v.updateViewport(p)}),[v,p]);var y=(0,i.useMemo)((function(){var e={viewport:p,events:v.events};return requestAnimationFrame((function(){return g(e)})),e}),[p,v.events,g]),b=r?"translate(0 ".concat(null==p?void 0:p.size.height,") scale(1 -1)"):"";return(0,e.jsx)(nB.Provider,{value:y,children:(0,e.jsx)(mB,$B(qB({interaction:v,viewport:p,ref:m},h),{children:!!y.viewport&&(0,e.jsx)("g",{transform:b,children:o})}))})};const eH=Math.sqrt(50),tH=Math.sqrt(10),nH=Math.sqrt(2);function rH(e,t,n){const r=(t-e)/Math.max(0,n),i=Math.floor(Math.log10(r)),o=r/Math.pow(10,i),a=o>=eH?10:o>=tH?5:o>=nH?2:1;let l,s,c;return i<0?(c=Math.pow(10,-i)/a,l=Math.round(e*c),s=Math.round(t*c),l/c<e&&++l,s/c>t&&--s,c=-c):(c=Math.pow(10,i)*a,l=Math.round(e/c),s=Math.round(t/c),l*c<e&&++l,s*c>t&&--s),s<l&&.5<=n&&n<2?rH(e,t,2*n):[l,s,c]}function iH(e,t,n){return rH(e=+e,t=+t,n=+n)[2]}function oH(e,t){return null==e||null==t?NaN:e<t?-1:e>t?1:e>=t?0:NaN}function aH(e,t){return null==e||null==t?NaN:t<e?-1:t>e?1:t>=e?0:NaN}function lH(e){let t,n,r;function i(e,r,i=0,o=e.length){if(i<o){if(0!==t(r,r))return o;do{const t=i+o>>>1;n(e[t],r)<0?i=t+1:o=t}while(i<o)}return i}return 2!==e.length?(t=oH,n=(t,n)=>oH(e(t),n),r=(t,n)=>e(t)-n):(t=e===oH||e===aH?e:sH,n=e,r=e),{left:i,center:function(e,t,n=0,o=e.length){const a=i(e,t,n,o-1);return a>n&&r(e[a-1],t)>-r(e[a],t)?a-1:a},right:function(e,r,i=0,o=e.length){if(i<o){if(0!==t(r,r))return o;do{const t=i+o>>>1;n(e[t],r)<=0?i=t+1:o=t}while(i<o)}return i}}}function sH(){return 0}const cH=lH(oH),uH=cH.right,dH=(cH.left,lH((function(e){return null===e?NaN:+e})).center,uH);function fH(e,t,n){e.prototype=t.prototype=n,n.constructor=e}function hH(e,t){var n=Object.create(e.prototype);for(var r in t)n[r]=t[r];return n}function mH(){}var pH=.7,vH=1/pH,gH="\\s*([+-]?\\d+)\\s*",yH="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",bH="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",xH=/^#([0-9a-f]{3,8})$/,_H=new RegExp(`^rgb\\(${gH},${gH},${gH}\\)$`),jH=new RegExp(`^rgb\\(${bH},${bH},${bH}\\)$`),EH=new RegExp(`^rgba\\(${gH},${gH},${gH},${yH}\\)$`),OH=new RegExp(`^rgba\\(${bH},${bH},${bH},${yH}\\)$`),TH=new RegExp(`^hsl\\(${yH},${bH},${bH}\\)$`),IH=new RegExp(`^hsla\\(${yH},${bH},${bH},${yH}\\)$`),SH={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function wH(){return this.rgb().formatHex()}function NH(){return this.rgb().formatRgb()}function PH(e){var t,n;return e=(e+"").trim().toLowerCase(),(t=xH.exec(e))?(n=t[1].length,t=parseInt(t[1],16),6===n?CH(t):3===n?new RH(t>>8&15|t>>4&240,t>>4&15|240&t,(15&t)<<4|15&t,1):8===n?AH(t>>24&255,t>>16&255,t>>8&255,(255&t)/255):4===n?AH(t>>12&15|t>>8&240,t>>8&15|t>>4&240,t>>4&15|240&t,((15&t)<<4|15&t)/255):null):(t=_H.exec(e))?new RH(t[1],t[2],t[3],1):(t=jH.exec(e))?new RH(255*t[1]/100,255*t[2]/100,255*t[3]/100,1):(t=EH.exec(e))?AH(t[1],t[2],t[3],t[4]):(t=OH.exec(e))?AH(255*t[1]/100,255*t[2]/100,255*t[3]/100,t[4]):(t=TH.exec(e))?VH(t[1],t[2]/100,t[3]/100,1):(t=IH.exec(e))?VH(t[1],t[2]/100,t[3]/100,t[4]):SH.hasOwnProperty(e)?CH(SH[e]):"transparent"===e?new RH(NaN,NaN,NaN,0):null}function CH(e){return new RH(e>>16&255,e>>8&255,255&e,1)}function AH(e,t,n,r){return r<=0&&(e=t=n=NaN),new RH(e,t,n,r)}function LH(e){return e instanceof mH||(e=PH(e)),e?new RH((e=e.rgb()).r,e.g,e.b,e.opacity):new RH}function MH(e,t,n,r){return 1===arguments.length?LH(e):new RH(e,t,n,null==r?1:r)}function RH(e,t,n,r){this.r=+e,this.g=+t,this.b=+n,this.opacity=+r}function kH(){return`#${GH(this.r)}${GH(this.g)}${GH(this.b)}`}function DH(){const e=UH(this.opacity);return`${1===e?"rgb(":"rgba("}${FH(this.r)}, ${FH(this.g)}, ${FH(this.b)}${1===e?")":`, ${e})`}`}function UH(e){return isNaN(e)?1:Math.max(0,Math.min(1,e))}function FH(e){return Math.max(0,Math.min(255,Math.round(e)||0))}function GH(e){return((e=FH(e))<16?"0":"")+e.toString(16)}function VH(e,t,n,r){return r<=0?e=t=n=NaN:n<=0||n>=1?e=t=NaN:t<=0&&(e=NaN),new HH(e,t,n,r)}function BH(e){if(e instanceof HH)return new HH(e.h,e.s,e.l,e.opacity);if(e instanceof mH||(e=PH(e)),!e)return new HH;if(e instanceof HH)return e;var t=(e=e.rgb()).r/255,n=e.g/255,r=e.b/255,i=Math.min(t,n,r),o=Math.max(t,n,r),a=NaN,l=o-i,s=(o+i)/2;return l?(a=t===o?(n-r)/l+6*(n<r):n===o?(r-t)/l+2:(t-n)/l+4,l/=s<.5?o+i:2-o-i,a*=60):l=s>0&&s<1?0:a,new HH(a,l,s,e.opacity)}function HH(e,t,n,r){this.h=+e,this.s=+t,this.l=+n,this.opacity=+r}function KH(e){return(e=(e||0)%360)<0?e+360:e}function WH(e){return Math.max(0,Math.min(1,e||0))}function zH(e,t,n){return 255*(e<60?t+(n-t)*e/60:e<180?n:e<240?t+(n-t)*(240-e)/60:t)}function YH(e,t,n,r,i){var o=e*e,a=o*e;return((1-3*e+3*o-a)*t+(4-6*o+3*a)*n+(1+3*e+3*o-3*a)*r+a*i)/6}fH(mH,PH,{copy(e){return Object.assign(new this.constructor,this,e)},displayable(){return this.rgb().displayable()},hex:wH,formatHex:wH,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return BH(this).formatHsl()},formatRgb:NH,toString:NH}),fH(RH,MH,hH(mH,{brighter(e){return e=null==e?vH:Math.pow(vH,e),new RH(this.r*e,this.g*e,this.b*e,this.opacity)},darker(e){return e=null==e?pH:Math.pow(pH,e),new RH(this.r*e,this.g*e,this.b*e,this.opacity)},rgb(){return this},clamp(){return new RH(FH(this.r),FH(this.g),FH(this.b),UH(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:kH,formatHex:kH,formatHex8:function(){return`#${GH(this.r)}${GH(this.g)}${GH(this.b)}${GH(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:DH,toString:DH})),fH(HH,(function(e,t,n,r){return 1===arguments.length?BH(e):new HH(e,t,n,null==r?1:r)}),hH(mH,{brighter(e){return e=null==e?vH:Math.pow(vH,e),new HH(this.h,this.s,this.l*e,this.opacity)},darker(e){return e=null==e?pH:Math.pow(pH,e),new HH(this.h,this.s,this.l*e,this.opacity)},rgb(){var e=this.h%360+360*(this.h<0),t=isNaN(e)||isNaN(this.s)?0:this.s,n=this.l,r=n+(n<.5?n:1-n)*t,i=2*n-r;return new RH(zH(e>=240?e-240:e+120,i,r),zH(e,i,r),zH(e<120?e+240:e-120,i,r),this.opacity)},clamp(){return new HH(KH(this.h),WH(this.s),WH(this.l),UH(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const e=UH(this.opacity);return`${1===e?"hsl(":"hsla("}${KH(this.h)}, ${100*WH(this.s)}%, ${100*WH(this.l)}%${1===e?")":`, ${e})`}`}}));const XH=e=>()=>e;function qH(e,t){return function(n){return e+n*t}}function $H(e){return 1==(e=+e)?QH:function(t,n){return n-t?function(e,t,n){return e=Math.pow(e,n),t=Math.pow(t,n)-e,n=1/n,function(r){return Math.pow(e+r*t,n)}}(t,n,e):XH(isNaN(t)?n:t)}}function QH(e,t){var n=t-e;return n?qH(e,n):XH(isNaN(e)?t:e)}const ZH=function e(t){var n=$H(t);function r(e,t){var r=n((e=MH(e)).r,(t=MH(t)).r),i=n(e.g,t.g),o=n(e.b,t.b),a=QH(e.opacity,t.opacity);return function(t){return e.r=r(t),e.g=i(t),e.b=o(t),e.opacity=a(t),e+""}}return r.gamma=e,r}(1);function JH(e){return function(t){var n,r,i=t.length,o=new Array(i),a=new Array(i),l=new Array(i);for(n=0;n<i;++n)r=MH(t[n]),o[n]=r.r||0,a[n]=r.g||0,l[n]=r.b||0;return o=e(o),a=e(a),l=e(l),r.opacity=1,function(e){return r.r=o(e),r.g=a(e),r.b=l(e),r+""}}}JH((function(e){var t=e.length-1;return function(n){var r=n<=0?n=0:n>=1?(n=1,t-1):Math.floor(n*t),i=e[r],o=e[r+1],a=r>0?e[r-1]:2*i-o,l=r<t-1?e[r+2]:2*o-i;return YH((n-r/t)*t,a,i,o,l)}})),JH((function(e){var t=e.length;return function(n){var r=Math.floor(((n%=1)<0?++n:n)*t),i=e[(r+t-1)%t],o=e[r%t],a=e[(r+1)%t],l=e[(r+2)%t];return YH((n-r/t)*t,i,o,a,l)}}));function eK(e,t){var n,r=t?t.length:0,i=e?Math.min(r,e.length):0,o=new Array(i),a=new Array(r);for(n=0;n<i;++n)o[n]=sK(e[n],t[n]);for(;n<r;++n)a[n]=t[n];return function(e){for(n=0;n<i;++n)a[n]=o[n](e);return a}}function tK(e,t){var n=new Date;return e=+e,t=+t,function(r){return n.setTime(e*(1-r)+t*r),n}}function nK(e,t){return e=+e,t=+t,function(n){return e*(1-n)+t*n}}function rK(e,t){var n,r={},i={};for(n in null!==e&&"object"==typeof e||(e={}),null!==t&&"object"==typeof t||(t={}),t)n in e?r[n]=sK(e[n],t[n]):i[n]=t[n];return function(e){for(n in r)i[n]=r[n](e);return i}}var iK=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,oK=new RegExp(iK.source,"g");function aK(e,t){var n,r,i,o=iK.lastIndex=oK.lastIndex=0,a=-1,l=[],s=[];for(e+="",t+="";(n=iK.exec(e))&&(r=oK.exec(t));)(i=r.index)>o&&(i=t.slice(o,i),l[a]?l[a]+=i:l[++a]=i),(n=n[0])===(r=r[0])?l[a]?l[a]+=r:l[++a]=r:(l[++a]=null,s.push({i:a,x:nK(n,r)})),o=oK.lastIndex;return o<t.length&&(i=t.slice(o),l[a]?l[a]+=i:l[++a]=i),l.length<2?s[0]?function(e){return function(t){return e(t)+""}}(s[0].x):function(e){return function(){return e}}(t):(t=s.length,function(e){for(var n,r=0;r<t;++r)l[(n=s[r]).i]=n.x(e);return l.join("")})}function lK(e,t){t||(t=[]);var n,r=e?Math.min(t.length,e.length):0,i=t.slice();return function(o){for(n=0;n<r;++n)i[n]=e[n]*(1-o)+t[n]*o;return i}}function sK(e,t){var n,r,i=typeof t;return null==t||"boolean"===i?XH(t):("number"===i?nK:"string"===i?(n=PH(t))?(t=n,ZH):aK:t instanceof PH?ZH:t instanceof Date?tK:(r=t,!ArrayBuffer.isView(r)||r instanceof DataView?Array.isArray(t)?eK:"function"!=typeof t.valueOf&&"function"!=typeof t.toString||isNaN(t)?rK:nK:lK))(e,t)}function cK(e,t){return e=+e,t=+t,function(n){return Math.round(e*(1-n)+t*n)}}function uK(e){return+e}var dK=[0,1];function fK(e){return e}function hK(e,t){return(t-=e=+e)?function(n){return(n-e)/t}:(n=isNaN(t)?NaN:.5,function(){return n});var n}function mK(e,t,n){var r=e[0],i=e[1],o=t[0],a=t[1];return i<r?(r=hK(i,r),o=n(a,o)):(r=hK(r,i),o=n(o,a)),function(e){return o(r(e))}}function pK(e,t,n){var r=Math.min(e.length,t.length)-1,i=new Array(r),o=new Array(r),a=-1;for(e[r]<e[0]&&(e=e.slice().reverse(),t=t.slice().reverse());++a<r;)i[a]=hK(e[a],e[a+1]),o[a]=n(t[a],t[a+1]);return function(t){var n=dH(e,t,1,r)-1;return o[n](i[n](t))}}function vK(e,t){return t.domain(e.domain()).range(e.range()).interpolate(e.interpolate()).clamp(e.clamp()).unknown(e.unknown())}function gK(){var e,t,n,r,i,o,a=dK,l=dK,s=sK,c=fK;function u(){var e,t,n,s=Math.min(a.length,l.length);return c!==fK&&(e=a[0],t=a[s-1],e>t&&(n=e,e=t,t=n),c=function(n){return Math.max(e,Math.min(t,n))}),r=s>2?pK:mK,i=o=null,d}function d(t){return null==t||isNaN(t=+t)?n:(i||(i=r(a.map(e),l,s)))(e(c(t)))}return d.invert=function(n){return c(t((o||(o=r(l,a.map(e),nK)))(n)))},d.domain=function(e){return arguments.length?(a=Array.from(e,uK),u()):a.slice()},d.range=function(e){return arguments.length?(l=Array.from(e),u()):l.slice()},d.rangeRound=function(e){return l=Array.from(e),s=cK,u()},d.clamp=function(e){return arguments.length?(c=!!e||fK,u()):c!==fK},d.interpolate=function(e){return arguments.length?(s=e,u()):s},d.unknown=function(e){return arguments.length?(n=e,d):n},function(n,r){return e=n,t=r,u()}}function yK(){return gK()(fK,fK)}function bK(e,t){switch(arguments.length){case 0:break;case 1:this.range(e);break;default:this.range(t).domain(e)}return this}var xK,_K=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function jK(e){if(!(t=_K.exec(e)))throw new Error("invalid format: "+e);var t;return new EK({fill:t[1],align:t[2],sign:t[3],symbol:t[4],zero:t[5],width:t[6],comma:t[7],precision:t[8]&&t[8].slice(1),trim:t[9],type:t[10]})}function EK(e){this.fill=void 0===e.fill?" ":e.fill+"",this.align=void 0===e.align?">":e.align+"",this.sign=void 0===e.sign?"-":e.sign+"",this.symbol=void 0===e.symbol?"":e.symbol+"",this.zero=!!e.zero,this.width=void 0===e.width?void 0:+e.width,this.comma=!!e.comma,this.precision=void 0===e.precision?void 0:+e.precision,this.trim=!!e.trim,this.type=void 0===e.type?"":e.type+""}function OK(e,t){if((n=(e=t?e.toExponential(t-1):e.toExponential()).indexOf("e"))<0)return null;var n,r=e.slice(0,n);return[r.length>1?r[0]+r.slice(2):r,+e.slice(n+1)]}function TK(e){return(e=OK(Math.abs(e)))?e[1]:NaN}function IK(e,t){var n=OK(e,t);if(!n)return e+"";var r=n[0],i=n[1];return i<0?"0."+new Array(-i).join("0")+r:r.length>i+1?r.slice(0,i+1)+"."+r.slice(i+1):r+new Array(i-r.length+2).join("0")}jK.prototype=EK.prototype,EK.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};const SK={"%":(e,t)=>(100*e).toFixed(t),b:e=>Math.round(e).toString(2),c:e=>e+"",d:function(e){return Math.abs(e=Math.round(e))>=1e21?e.toLocaleString("en").replace(/,/g,""):e.toString(10)},e:(e,t)=>e.toExponential(t),f:(e,t)=>e.toFixed(t),g:(e,t)=>e.toPrecision(t),o:e=>Math.round(e).toString(8),p:(e,t)=>IK(100*e,t),r:IK,s:function(e,t){var n=OK(e,t);if(!n)return e+"";var r=n[0],i=n[1],o=i-(xK=3*Math.max(-8,Math.min(8,Math.floor(i/3))))+1,a=r.length;return o===a?r:o>a?r+new Array(o-a+1).join("0"):o>0?r.slice(0,o)+"."+r.slice(o):"0."+new Array(1-o).join("0")+OK(e,Math.max(0,t+o-1))[0]},X:e=>Math.round(e).toString(16).toUpperCase(),x:e=>Math.round(e).toString(16)};function wK(e){return e}var NK,PK,CK,AK=Array.prototype.map,LK=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function MK(e){var t,n,r=void 0===e.grouping||void 0===e.thousands?wK:(t=AK.call(e.grouping,Number),n=e.thousands+"",function(e,r){for(var i=e.length,o=[],a=0,l=t[0],s=0;i>0&&l>0&&(s+l+1>r&&(l=Math.max(1,r-s)),o.push(e.substring(i-=l,i+l)),!((s+=l+1)>r));)l=t[a=(a+1)%t.length];return o.reverse().join(n)}),i=void 0===e.currency?"":e.currency[0]+"",o=void 0===e.currency?"":e.currency[1]+"",a=void 0===e.decimal?".":e.decimal+"",l=void 0===e.numerals?wK:function(e){return function(t){return t.replace(/[0-9]/g,(function(t){return e[+t]}))}}(AK.call(e.numerals,String)),s=void 0===e.percent?"%":e.percent+"",c=void 0===e.minus?"−":e.minus+"",u=void 0===e.nan?"NaN":e.nan+"";function d(e){var t=(e=jK(e)).fill,n=e.align,d=e.sign,f=e.symbol,h=e.zero,m=e.width,p=e.comma,v=e.precision,g=e.trim,y=e.type;"n"===y?(p=!0,y="g"):SK[y]||(void 0===v&&(v=12),g=!0,y="g"),(h||"0"===t&&"="===n)&&(h=!0,t="0",n="=");var b="$"===f?i:"#"===f&&/[boxX]/.test(y)?"0"+y.toLowerCase():"",x="$"===f?o:/[%p]/.test(y)?s:"",_=SK[y],j=/[defgprs%]/.test(y);function E(e){var i,o,s,f=b,E=x;if("c"===y)E=_(e)+E,e="";else{var O=(e=+e)<0||1/e<0;if(e=isNaN(e)?u:_(Math.abs(e),v),g&&(e=function(e){e:for(var t,n=e.length,r=1,i=-1;r<n;++r)switch(e[r]){case".":i=t=r;break;case"0":0===i&&(i=r),t=r;break;default:if(!+e[r])break e;i>0&&(i=0)}return i>0?e.slice(0,i)+e.slice(t+1):e}(e)),O&&0==+e&&"+"!==d&&(O=!1),f=(O?"("===d?d:c:"-"===d||"("===d?"":d)+f,E=("s"===y?LK[8+xK/3]:"")+E+(O&&"("===d?")":""),j)for(i=-1,o=e.length;++i<o;)if(48>(s=e.charCodeAt(i))||s>57){E=(46===s?a+e.slice(i+1):e.slice(i))+E,e=e.slice(0,i);break}}p&&!h&&(e=r(e,1/0));var T=f.length+e.length+E.length,I=T<m?new Array(m-T+1).join(t):"";switch(p&&h&&(e=r(I+e,I.length?m-E.length:1/0),I=""),n){case"<":e=f+e+E+I;break;case"=":e=f+I+e+E;break;case"^":e=I.slice(0,T=I.length>>1)+f+e+E+I.slice(T);break;default:e=I+f+e+E}return l(e)}return v=void 0===v?6:/[gprs]/.test(y)?Math.max(1,Math.min(21,v)):Math.max(0,Math.min(20,v)),E.toString=function(){return e+""},E}return{format:d,formatPrefix:function(e,t){var n=d(((e=jK(e)).type="f",e)),r=3*Math.max(-8,Math.min(8,Math.floor(TK(t)/3))),i=Math.pow(10,-r),o=LK[8+r/3];return function(e){return n(i*e)+o}}}}function RK(e,t,n,r){var i,o=function(e,t,n){n=+n;const r=(t=+t)<(e=+e),i=r?iH(t,e,n):iH(e,t,n);return(r?-1:1)*(i<0?1/-i:i)}(e,t,n);switch((r=jK(null==r?",f":r)).type){case"s":var a=Math.max(Math.abs(e),Math.abs(t));return null!=r.precision||isNaN(i=function(e,t){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(TK(t)/3)))-TK(Math.abs(e)))}(o,a))||(r.precision=i),CK(r,a);case"":case"e":case"g":case"p":case"r":null!=r.precision||isNaN(i=function(e,t){return e=Math.abs(e),t=Math.abs(t)-e,Math.max(0,TK(t)-TK(e))+1}(o,Math.max(Math.abs(e),Math.abs(t))))||(r.precision=i-("e"===r.type));break;case"f":case"%":null!=r.precision||isNaN(i=function(e){return Math.max(0,-TK(Math.abs(e)))}(o))||(r.precision=i-2*("%"===r.type))}return PK(r)}function kK(e){var t=e.domain;return e.ticks=function(e){var n=t();return function(e,t,n){if(!((n=+n)>0))return[];if((e=+e)==(t=+t))return[e];const r=t<e,[i,o,a]=r?rH(t,e,n):rH(e,t,n);if(!(o>=i))return[];const l=o-i+1,s=new Array(l);if(r)if(a<0)for(let e=0;e<l;++e)s[e]=(o-e)/-a;else for(let e=0;e<l;++e)s[e]=(o-e)*a;else if(a<0)for(let e=0;e<l;++e)s[e]=(i+e)/-a;else for(let e=0;e<l;++e)s[e]=(i+e)*a;return s}(n[0],n[n.length-1],null==e?10:e)},e.tickFormat=function(e,n){var r=t();return RK(r[0],r[r.length-1],null==e?10:e,n)},e.nice=function(n){null==n&&(n=10);var r,i,o=t(),a=0,l=o.length-1,s=o[a],c=o[l],u=10;for(c<s&&(i=s,s=c,c=i,i=a,a=l,l=i);u-- >0;){if((i=iH(s,c,n))===r)return o[a]=s,o[l]=c,t(o);if(i>0)s=Math.floor(s/i)*i,c=Math.ceil(c/i)*i;else{if(!(i<0))break;s=Math.ceil(s*i)/i,c=Math.floor(c*i)/i}r=i}return e},e}function DK(){var e=yK();return e.copy=function(){return vK(e,DK())},bK.apply(e,arguments),kK(e)}function UK(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function FK(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}NK=MK({thousands:",",grouping:[3],currency:["$",""]}),PK=NK.format,CK=NK.formatPrefix;var GK=function(t){var n=rB().viewport,r=n.posFromPoint,o=n.rem,a=t.d,l=t.strokeWidth,s=t.fill,c=void 0===s?"transparent":s,u=FK(t,["d","strokeWidth","fill"]),d=(0,i.useMemo)((function(){return null==a?void 0:a.replace(/(-?\d+\.?\d*),(-?\d+\.?\d*)/g,(function(e,t,n){var i=r(Number(t),Number(n));return"".concat(i.x,",").concat(i.y)})).replace(/([HhVv])\s*?(-?\d+\.?\d*)/g,(function(e,t,n){var i="h"===t.toLowerCase(),o=r(Number(n),Number(n));return"".concat(t," ").concat(i?o.x:o.y)}))}),[a,r]);return(0,e.jsx)("path",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){UK(e,t,n[t])}))}return e}({d,strokeWidth:l?o(l):void 0,fill:c},u))};const VK="grid-lines_BXH",BK="axis-labels_IjN";var HK=function(t){var n,r,i=t.label,o=t.x,a=t.y,l=t.fontSize,s=t.onTop,c=t.last;switch(void 0===i?"undefined":(r=i)&&"undefined"!=typeof Symbol&&r.constructor===Symbol?"symbol":typeof r){case"string":case"object":n=i;break;default:n=t.label.toString().replace(/^(-)?0/,"$1")||"0"}return(0,e.jsx)("g",{transform:"translate(".concat(o+.5*l," ").concat(a+l*(s?.5:-1.5),")"),children:(0,e.jsx)("text",{transform:"scale(1 -1)",fontSize:l,textAnchor:c?"end":"mid",children:n})})},KK=function(t){var n=t.fixed,r=t.overdraw,o=void 0!==r&&r,a=t.textScale,l=void 0===a?1:a,s=t.tickWidth,c=void 0===s?100:s,u=t.tickHeight,d=void 0===u?100:u,f=t.formatLabelX,h=t.formatLabelY,m=rB().viewport,p=m.size,v=m.rem,g=m.bounds,y=m.posFromPoint,b=(0,i.useMemo)((function(){if(!g)return{};for(var t="",r=Number(o)*Math.max(v(c)/p.width,v(d)/p.height)*2,i=1+2*r,a=[],s=[],u=Math.ceil(p.width*i/v(c)),m=Math.ceil(p.height*i/v(d)),b=g.max.x-g.min.x,x=g.max.y-g.min.y,_=g.min.x-b*r,j=g.max.x+b*r,E=g.min.y-x*r,O=g.max.y+x*r,T=DK().domain([_,j]).nice().ticks(u),I=0;I<T.length;I++){var S=y(T[I],0),w=f?f(T[I]):T[I];a.push((0,e.jsx)(HK,{x:S.x,y:n?0:S.y,label:w,fontSize:v(11*l),onTop:n,last:I===T.length-1},"".concat(I,"-").concat(w,"-").concat(S.x)))}for(var N=DK().domain([E,O]).nice().ticks(m),P=0;P<N.length;P++){var C=y(0,N[P]),A=h?h(N[P]):N[P];s.push((0,e.jsx)(HK,{x:n?0:C.x,y:C.y,label:A,fontSize:v(11*l),onTop:n},"".concat(P,"-").concat(A,"-").concat(C.y)))}return n||(t+="M ".concat(_,",0 L ").concat(j,", 0 "),t+="M 0, ".concat(E," L 0, ").concat(O)),{axesPath:t,xLabels:a,yLabels:s}}),[g,o,v,c,p.width,p.height,d,n,y,f,l,h]),x=b.axesPath,_=b.xLabels,j=b.yLabels;return(0,e.jsxs)("g",{className:BK,children:[x&&(0,e.jsx)(GK,{d:x,strokeWidth:.5,stroke:"#fff7"}),(0,e.jsx)("g",{children:_}),(0,e.jsx)("g",{children:j})]})},WK=function(t){var n=t.halfSteps,r=t.overdraw,o=void 0!==r&&r,a=t.drawAxes,l=void 0===a||a,s=t.tickWidth,c=void 0===s?100:s,u=t.tickHeight,d=void 0===u?100:u,f=rB().viewport,h=f.size,m=f.rem,p=f.bounds,v=(0,i.useMemo)((function(){if(!p||!l)return{};var e="\n",t="\n",r=Number(o)*Math.max(m(c)/h.width,m(d)/h.height)*2,i=1+2*r,a=p.max.x-p.min.x,s=p.max.y-p.min.y,u=p.min.x-a*r,f=p.max.x+a*r,v=p.min.y-s*r,g=p.max.y+s*r;if(!0===l||l.includes("x")){for(var y=Math.ceil(h.width*i/m(c)),b=DK().domain([u,f]).nice().ticks(y),x=(b[1]-b[0])/2,_=0;_<b.length;_++)e+="M ".concat(b[_],",").concat(v," V ").concat(g," "),e+="\n",n&&(t+="M ".concat(b[_]+x,",").concat(v," V ").concat(g," "),t+="\n");e+="\n",t+="\n"}if(!0===l||l.includes("y"))for(var j=Math.ceil(h.height*i/m(d)),E=DK().domain([v,g]).nice().ticks(j),O=(E[1]-E[0])/2,T=0;T<E.length;T++)e+="M ".concat(u,",").concat(E[T]," H ").concat(f," "),e+="\n",n&&(t+="M ".concat(u,",").concat(E[T]+O," H ").concat(f," "),t+="\n");return{gridPath:e,halfStepsGridPath:t,xLabels:[],yLabels:[]}}),[p,l,o,m,c,h.width,h.height,d,n]),g=v.gridPath,y=v.halfStepsGridPath;return(0,e.jsxs)("g",{className:VK,children:[(0,e.jsx)(GK,{d:g,strokeWidth:.5,stroke:"#fff3"}),y&&(0,e.jsx)(GK,{d:y,strokeWidth:.5,stroke:"#fff1"})]})};function zK(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function YK(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function XK(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){YK(e,t,n[t])}))}return e}function qK(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function $K(e){return function(e){if(Array.isArray(e))return zK(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return zK(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zK(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var QK=function(e,t,n,r){return e+(t-n)*r},ZK={inTangent:0,outTangent:0,inWeight:0,outWeight:0,weightedMode:0,readonly:!0};const JK="editorItem_DvB",eW="editor_Es7",tW="row_GIj row_d2o",nW="controls_RpG",rW="column_MrW",iW="animation-curve-path_TwV",oW="animation-curve-control-point-arm_Wh2",aW="animation-curve-control-point-handle_qUn",lW="animation-curve-keyframe_DpO",sW="multiple-curves_HvS",cW="animation-curve-keyframes_TMk",uW="animation-curve-preview-path_VCR",dW="hidden_prB";var fW=function(t){var n=t.keys,r=void 0===n?[]:n,o=t.className,a=(0,i.useMemo)((function(){var e=r.reduce((function(e,t,n){if(0===n)e.push("M ".concat(t.time,",").concat(t.value));else{var i=r[n-1],o=isFinite(i.outTangent)&&isFinite(t.inTangent),a=i.time,l=i.value,s=t.time,c=t.value,u=i.outTangent,d=t.inTangent,f=i.outWeight,h=1-t.inWeight;if(o){var m=QK(a,s,a,f),p=QK(l,m,a,u),v=QK(a,s,a,h),g=QK(c,v,s,d);e.push("C".concat(m,",").concat(p," ").concat(v,",").concat(g," ").concat(s,",").concat(c))}else l===c?e.push("L".concat(s,",").concat(c)):u===Number.NEGATIVE_INFINITY&&d!==Number.POSITIVE_INFINITY||u!==Number.POSITIVE_INFINITY&&d===Number.NEGATIVE_INFINITY?e.push("L".concat(a,",").concat(c," ").concat(s,",").concat(c)):e.push("L ".concat(s,",").concat(l," ").concat(s,",").concat(c))}return e}),[]);return e.join(" ")}),[r]);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(GK,{d:a,className:Oe()(iW,o,0===r.length&&dW)})})};const hW="tooltip-row_zpQ",mW="tooltip-label_JO7";var pW,vW,gW=function(e){if(0===e)return"00.000s";var t=Math.floor(e/3600),n=Math.floor((e-3600*t)/60),r=Math.floor(e-3600*t-60*n),i=(e%1).toFixed(3).replace("0.",""),o="";return t&&(o+=t.toString().padStart(2,"0")+":"),n&&(o+=n.toString().padStart(2,"0")+":"),o+=r.toString().padStart(2,"0")+".",(o+=i)+"s"},yW=function(t){var n=t.keyframe,r=t.hide;return n?(0,e.jsxs)("div",{children:["time"!==r&&"number"==typeof n.time&&(0,e.jsxs)("div",{className:hW,children:[(0,e.jsxs)("div",{className:mW,children:[(0,e.jsx)(Ks.AnimationCurve.TIME_LABEL,{}),":"]}),(0,e.jsx)("div",{children:gW(n.time)})]}),"value"!==r&&"number"==typeof n.value&&(0,e.jsxs)("div",{className:hW,children:[(0,e.jsxs)("div",{className:mW,children:[(0,e.jsx)(Ks.AnimationCurve.VALUE_LABEL,{}),":"]}),(0,e.jsx)("div",{children:n.value.toFixed(3)})]})]}):null};!function(e){e[e.None=0]="None",e[e.In=1]="In",e[e.Out=2]="Out",e[e.Both=3]="Both"}(pW||(pW={})),function(e){e[e.Default=0]="Default",e[e.Clamp=1]="Clamp",e[e.Once=1]="Once",e[e.Loop=2]="Loop",e[e.PingPong=4]="PingPong",e[e.ClampForever=8]="ClampForever"}(vW||(vW={}));pW.None;function bW(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xW(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function _W(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){xW(o,r,i,a,l,"next",e)}function l(e){xW(o,r,i,a,l,"throw",e)}a(void 0)}))}}function jW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function EW(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bW(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bW(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var OW=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},TW={data:{curves:[{keys:[],preWrapMode:vW.Default,postWrapMode:vW.Default}],bounds:{min:{x:0,y:0},max:{x:0,y:0}}},activeKeyframe:-1,draggedKeyframeRef:{current:-1},activeCurve:0,activeProperty:0,canAddKeyframes:!1,smoothenOnMove:!1,isDraggingKeyframe:!1,selectActiveCurve:function(){},deselectKeyframes:function(){},selectKeyframe:function(){},setDraggedKeyframe:function(){},removeKeyframe:function(){},setKeyframes:function(){},updateKeyframe:_W((function(){return OW(this,(function(e){return[2,-1]}))})),addKeyframe:_W((function(){return OW(this,(function(e){return[2,-1]}))}))},IW=(0,i.createContext)(TW),SW=function(t){var n=t.children,r=t.data,o=t.canAddKeyframes,a=t.smoothenOnMove,l=t.parseKeyframe,s=t.keyframeRenderer,c=t.onMoveKeyframe,u=t.onAddKeyframe,d=t.onRemoveKeyframe,f=t.onSetKeyframes,h=t.onSetActiveCurve,m=t.onSetActiveKeyFrame,p=EW((0,i.useState)(-1),2),v=p[0],g=p[1],y=EW((0,i.useState)(!1),2),b=y[0],x=y[1],_=EW((0,i.useState)(0),2),j=_[0],E=_[1],O=(0,i.useRef)(-1),T=(0,i.useCallback)((function(e){O.current=e,x(!0);var t=function(){O.current=-1,document.removeEventListener("mouseup",t),x(!1)};document.addEventListener("mouseup",t)}),[]),I=(0,i.useMemo)((function(){var e,t,n=null===(e=r.curves[j])||void 0===e?void 0:e.keys[0],i=(null==n?void 0:n.readonly)?1:0,o=(t=_W((function(e,t){return OW(this,(function(n){switch(n.label){case 0:if(!f)throw"onSetKeyframes not provided";return[4,f(e,t)];case 1:return n.sent(),a(-1),[2]}}))})),function(e,n){return t.apply(this,arguments)}),a=function(e){g((function(t){return t===e?-1:e})),null==m||m(j,e-i)},l=function(){var e=_W((function(e,t,o){var a,l;return OW(this,(function(s){switch(s.label){case 0:if(!u)throw"onAddKeyframe not provided";return r.curves[o]?[4,u(e,t,o)]:[3,2];case 1:return a=s.sent(),l=a+(e>(null==n?void 0:n.time)?i:0),g(l),null==m||m(j,l),[2,l];case 2:return[2,-1]}}))}));return function(t,n,r){return e.apply(this,arguments)}}(),s=function(){var e=_W((function(e,t,r,o){var a,l,s;return OW(this,(function(u){switch(u.label){case 0:if(!c)throw"onMoveKeyframe not provided";return a=Math.max(0,e-i),[4,c(a,t,r,o)];case 1:return l=u.sent(),s=l+(t.time>(null==n?void 0:n.time)?i:0),g((function(e){return-1===e?-1:s})),[2,s]}}))}));return function(t,n,r,i){return e.apply(this,arguments)}}();return{selectActiveCurve:function(e){E(e),null==h||h(e),a(-1),null==m||m(e,-1)},deselectKeyframes:function(){a(-1)},selectKeyframe:a,addKeyframe:l,updateKeyframe:s,removeKeyframe:function(e,t){if(!d)throw"onRemoveKeyframe not provided";var n=Math.max(0,e-i);d(n,t),a(-1)},setKeyframes:o}}),[j,r.curves,u,c,d,h,m,f]);(0,i.useEffect)((function(){var e,t=(null===(e=r.curves[j])||void 0===e?void 0:e.keys.length)-1||-1;v>t&&g(t)}),[j,v,r.curves]);var S=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){jW(e,t,n[t])}))}return e}({data:r,activeKeyframe:v,draggedKeyframeRef:O,activeCurve:j,canAddKeyframes:o,smoothenOnMove:a,parseKeyframe:l,keyframeRenderer:s,setDraggedKeyframe:T,isDraggingKeyframe:b},I)}),[r,v,j,b,o,a,l,s,T,I]);return(0,e.jsx)(IW.Provider,{value:S,children:n})},wW=function(){return(0,i.useContext)(IW)},NW=function(e,t,n,r,i){var o=e.offset.x+t,a=e.offset.y+(e.inverted?e.size.height-n:n);return{x:o,y:a,width:r,height:i,left:o,top:a,right:r>0?o+r:o,bottom:i>0?a+i:a}};function PW(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function AW(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function LW(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return PW(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PW(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var MW=(0,i.forwardRef)((function(t,n){var r=t.cx,o=t.cy,a=t.r,l=t.rh,s=t.collisionThreshold,c=void 0===s?0:s,u=t.fill,d=t.fillh,f=t.stroke,h=t.strokeh,m=t.strokeWidth,p=(t.onSelect,t.focused,t.selected,t.className),v=AW(t,["cx","cy","r","rh","collisionThreshold","fill","fillh","stroke","strokeh","strokeWidth","onSelect","focused","selected","className"]),g=rB().viewport,y=g.posFromPoint,b=g.rem,x=LW((0,i.useState)(!1),2),_=x[0],j=x[1],E=y(r,o),O=b(_&&l?l:a),T=b(m||1),I=b(c)+T/2,S=T/2+I+O;(0,i.useEffect)((function(){n&&"current"in n&&n.current&&(n.current.getBoundingClientRect=function(){return NW(g,E.x-S/2,E.y-S/2,S,S)})}),[S,n,E.x,E.y,g]);var w=(0,i.useCallback)((function(e){return Math.sqrt(Math.pow(e.x-E.x,2)+Math.pow(e.y-E.y,2))<O+I}),[E.x,E.y,O,I]);return uB(t,w,j),(0,e.jsx)("circle",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){CW(e,t,n[t])}))}return e}({ref:n,cx:E.x,cy:E.y,r:O,fill:_&&d?d:u,stroke:_&&h?h:f,strokeWidth:T,className:Oe()({hovered:_},p)},v),"circle")}));function RW(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function DW(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function UW(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return RW(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return RW(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var FW=function(t){var n=t.x1,r=t.y1,o=t.x2,a=t.y2,l=t.strokeWidth,s=t.stroke,c=t.strokeh,u=t.collisionThreshold,d=DW(t,["x1","y1","x2","y2","strokeWidth","stroke","strokeh","collisionThreshold"]),f=rB().viewport,h=f.posFromPoint,m=f.rem,p=UW((0,i.useState)(!1),2),v=p[0],g=p[1],y=h(n,r),b=h(o,a),x=m(l||1),_=m(u||5)+x/2,j=(0,i.useCallback)((function(e){return function(e,t,n){var r,i,o=e.x-t.x,a=e.y-t.y,l=n.x-t.x,s=n.y-t.y,c=l*l+s*s,u=0!==c?(o*l+a*s)/c:-1;u<0?(r=t.x,i=t.y):u>1?(r=n.x,i=n.y):(r=t.x+u*l,i=t.y+u*s);var d=e.x-r,f=e.y-i;return Math.sqrt(d*d+f*f)}(e,y,b)<_}),[_,y,b]);return uB(d,j,g),(0,e.jsx)("line",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){kW(e,t,n[t])}))}return e}({x1:y.x,y1:y.y,x2:b.x,y2:b.y,strokeWidth:x,stroke:v&&null!=c?c:s},d))};function GW(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function VW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function BW(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function HW(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return GW(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return GW(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var KW=(0,i.forwardRef)((function(t,n){var r=t.x,o=t.y,a=t.width,l=t.height,s=t.widthh,c=t.heighth,u=t.collisionThreshold,d=void 0===u?0:u,f=t.origin,h=t.fill,m=t.fillh,p=t.stroke,v=t.strokeh,g=t.strokeWidth,y=(t.onSelect,t.focused,t.selected,t.className),b=t.transform,x=BW(t,["x","y","width","height","widthh","heighth","collisionThreshold","origin","fill","fillh","stroke","strokeh","strokeWidth","onSelect","focused","selected","className","transform"]),_=rB().viewport,j=_.posFromPoint,E=_.rem,O=HW((0,i.useState)(!1),2),T=O[0],I=O[1],S=j(r,o),w=E(T&&s?s:a),N=E(T&&c?c:l);"center"===f&&(S={x:S.x-w/2,y:S.y-N/2});var P=E(g||1),C=E(d)+P/2,A=(0,i.useCallback)((function(e){var t;return t="center"!==f?{x:(2*S.x+w)/2,y:(2*S.y+N)/2}:S,Math.abs(e.x-t.x)<=w/2+C&&Math.abs(e.y-t.y)<=N/2+C}),[f,w,C,N,S]);(0,i.useEffect)((function(){n&&"current"in n&&n.current&&(n.current.getBoundingClientRect=function(){return NW(_,S.x-C/2,S.y-C/2,w+C/2,N+C/2)})}),[C,N,n,_,S.x,S.y,w]),uB(t,A,I);var L=null==b?void 0:b.replace(/rotate\((\d+)\)/,"rotate($1 ".concat(S.x+w/2," ").concat(S.y+N/2,")"));return(0,e.jsx)("rect",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){VW(e,t,n[t])}))}return e}({ref:n,x:S.x,y:S.y,width:w,height:N,fill:T&&m?m:h,stroke:T&&v?v:p,strokeWidth:P,className:Oe()({hovered:T},y),transform:L},x))}));function WW(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function zW(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){WW(o,r,i,a,l,"next",e)}function l(e){WW(o,r,i,a,l,"throw",e)}a(void 0)}))}}var YW=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},XW="cinematicCamera",qW=E(XW,"playbackDuration"),$W=E(XW,"timelinePosition"),QW=(E(XW,"timelineLength"),E(XW,"loop")),ZW=w(XW,"toggleLoop"),JW=E(XW,"playing"),ez=function(e){return N(XW,"setPlaybackDuration",e)},tz=S(XW,"onAfterPlaybackDurationChange"),nz=function(e){return N(XW,"setTimelinePosition",e)},rz=function(){return N(XW,"stopPlayback")},iz=function(){return N(XW,"togglePlayback")},oz=function(e,t,n,r){return P(XW,"moveKeyFrame",e,t,n,r)},az=function(e,t,n,r){return P(XW,"addKeyFrame",e,t,n,r)},lz=function(){return N(XW,"reset")},sz=function(){return P(XW,"getControllerDelta")},cz=function(e){return N(XW,"toggleCurveEditorFocus",e)},uz=w(XW,"save"),dz=w(XW,"load"),fz=w(XW,"delete"),hz=E(XW,"lastLoaded"),mz=E(XW,"assets"),pz=E(XW,"availableCloudTargets"),vz=E(XW,"selectedCloudTarget"),gz=w(XW,"selectCloudTarget"),yz=E(XW,"transformAnimationCurves"),bz=E(XW,"modifierAnimationCurves"),xz=function(e,t){return(0,i.useMemo)((function(){return{onAddKeyframe:(n=zW((function(n,r,i){return YW(this,(function(o){switch(o.label){case 0:return void 0===i||-1===i?[3,2]:[4,az(e,n,r,null!=t?t:i)];case 1:return[2,o.sent()];case 2:return[2,-1]}}))})),function(e,t,r){return n.apply(this,arguments)}),onMoveKeyframe:function(){var n=zW((function(n,r,i,o){return YW(this,(function(i){switch(i.label){case 0:return null==o?[3,2]:[4,oz(e,null!=t?t:o,n,r)];case 1:return[2,i.sent()];case 2:return[2,-1]}}))}));return function(e,t,r,i){return n.apply(this,arguments)}}(),onRemoveKeyframe:function(n,r){null!=r&&function(e,t,n){N(XW,"removeKeyFrame",e,t,n)}(e,null!=t?t:r,n)},onSetKeyframes:function(e,t){throw new Error("Function not implemented.")}};var n}),[t,e])};function _z(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function jz(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){_z(o,r,i,a,l,"next",e)}function l(e){_z(o,r,i,a,l,"throw",e)}a(void 0)}))}}function Ez(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Oz(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Ez(e,t,n[t])}))}return e}function Tz(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var Iz=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};var Sz=function(t){var n=t.keyframe,r=t.index,o=t.pos,a=t.type,l=t.isFocused,s=wW(),c=s.activeCurve,u=s.updateKeyframe,d=rB().viewport,f=d.rem,h=d.scaleToViewport,m=d.scaleToPoint,p=d.posFromPoint,v=d.pointFromPos,g=(0,i.useMemo)((function(){var e={x:o.x-n.time,y:o.y-n.value},t=h(e),r=Math.sqrt(t.x*t.x+t.y*t.y),i=t.x<0?-1:1,l=t.x/r,s=isFinite(o.y)?t.y/r:Math.sign(o.y)*i,c=n["in"===a?"inWeight":"outWeight"]||.01,u=f(lt(15,75,c)),d=m(l*u,s*u);return{x:n.time+d.x,y:n.value+d.y}}),[o.x,o.y,n,h,a,f,m]),y=(0,i.useCallback)((function(e){var t,i,o=e.point,l=e.position,s=e.shiftKey,d=n.time,f=n.value,h=o.x-d,m=o.y-f,v=p(d,f),g=at(ht((i=v,{x:(t=l).x-i.x,y:t.y-i.y})),15,75);if(!(g<15)){var y,b,x,_,j=Math.max((g-15)/60,.01);if("in"===a?(y="inTangent",b="inWeight",h>0&&(h=0)):(y="outTangent",b="outWeight",h<0&&(h=0)),x=function(e,t){return Math.abs(t-e)<Math.max(1e-6*Math.max(Math.abs(e),Math.abs(t)),8*Number.EPSILON)}(h,0)?o.y>f?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:m/h,s)u(r,Tz(Oz({},n),{inTangent:x,outTangent:x,inWeight:j,outWeight:j}),!1,c);else u(r,Tz(Oz({},n),(Ez(_={},y,x),Ez(_,b,j),_)),!1,c)}}),[c,r,n,p,a,u]),b=cr();return JS((0,i.useCallback)(jz((function(){var e,t,n;return Iz(this,(function(r){switch(r.label){case 0:return[4,sz()];case 1:return e=r.sent(),t=p(g),n={x:t.x+100*e[0],y:t.y+100*e[1]},y({point:v(n),position:n}),[2]}}))})),[g,y,v,p]),b&&l),(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(FW,{strokeWidth:.5,x1:n.time,y1:n.value,x2:g.x,y2:g.y,className:oW}),(0,e.jsx)(KW,{origin:"center",x:g.x,y:g.y,width:l?8:4,height:l?8:4,collisionThreshold:10,onDrag:y,className:aW})]})},wz=function(t){var n,r,o=t.index,a=t.data,l=t.keyframes,s=t.editTarget,c=(0,i.useMemo)((function(){return function(e,t){var n,r;if(t.length<2)return{};var i=t[e],o=i.time,a=i.value;if(e<t.length-1){var l=t[e+1].time,s=QK(o,l,o,i.outWeight);r={x:s,y:QK(a,s,o,i.outTangent)}}if(e>0){var c=t[e-1].time,u=QK(c,o,c,1-i.inWeight);n={x:u,y:QK(a,u,o,i.inTangent)}}return{in:n,out:r}}(o,l)}),[o,l]),u=cr();return(0,e.jsxs)(e.Fragment,{children:[c.in&&a.inWeight>0&&!(null===(n=l[o-1])||void 0===n?void 0:n.readonly)&&(0,e.jsx)(Sz,{index:o,keyframe:a,type:"in",pos:c.in,isFocused:u&&s===Vz.LeftTangent}),c.out&&a.outWeight>0&&!(null===(r=l[o+1])||void 0===r?void 0:r.readonly)&&(0,e.jsx)(Sz,{index:o,keyframe:a,type:"out",pos:c.out,isFocused:u&&s===Vz.RightTangent})]})};function Nz(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function Pz(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){Nz(o,r,i,a,l,"next",e)}function l(e){Nz(o,r,i,a,l,"throw",e)}a(void 0)}))}}var Cz=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},Az=function(t){var n=t.data,r=t.keyframes,o=t.isActive,a=t.index,l=t.curveIndex,s=void 0===l?0:l,c=t.onSelect,u=t.onDragStart,d=t.keyframeRenderer,f=t.editTarget,h=t.isFocused,m=t.onControllerDrag,p=t.controllerDragCallback,v=(0,i.useRef)(n),g=rB();v.current=n;var y=(0,i.useCallback)((function(){n.readonly||null==c||c(a,s)}),[n.readonly,c,a,s]),b=(0,i.useCallback)((function(e,t){t&&(null==u||u(a))}),[a,u]),x=cr();return JS((0,i.useCallback)(Pz((function(){var e,t,r,i;return Cz(this,(function(o){switch(o.label){case 0:return m&&p?[4,p()]:[3,2];case 1:e=o.sent(),t={x:n.time,y:n.value},r=g.viewport.posFromPoint(t),i={x:r.x+100*e.x,y:r.y+100*e.y},m(g.viewport.pointFromPos(i),a),o.label=2;case 2:return[2]}}))})),[p,n.time,n.value,a,m,g.viewport]),x&&p&&m&&o&&f===Vz.Keyframe),n.readonly?null:(0,e.jsx)("g",{className:Oe()(lW,{active:o}),children:d?d(t,y,b):(0,e.jsxs)(e.Fragment,{children:[o&&(0,e.jsx)(wz,{data:n,index:a,keyframes:r,editTarget:f}),(0,e.jsx)(MW,{cx:n.time,cy:n.value,r:Lz(o,h,x),rh:3.5,onSelect:y,onMouseDown:b,collisionThreshold:12})]})})},Lz=function(e,t,n){return n&&e?4.5:!n&&e||n&&t?3.5:2.5},Mz=function(t){var n,r=wW(),i=r.data,o=r.activeKeyframe,a=r.activeCurve,l=r.parseKeyframe,s=r.setDraggedKeyframe,c=r.selectKeyframe,u=r.keyframeRenderer,d=t.curveIndex,f=t.focusedKeyframe,h=t.editTarget,m=t.onControllerDrag,p=t.controllerDragCallback,v=null===(n=i.curves[d])||void 0===n?void 0:n.keys;return(0,e.jsx)("g",{children:i.curves.map((function(t,n){var r;return(0,e.jsx)("g",{className:cW,children:d===n&&!!(null===(r=t.keys)||void 0===r?void 0:r.length)&&t.keys.map((function(t,r){return(0,e.jsx)(Az,{data:t,index:r,curveIndex:d,keyframes:v,isActive:o===r&&a===n,isFocused:f===r&&a===n,editTarget:h,onSelect:c,onDragStart:s,parseKeyframe:l,keyframeRenderer:u,onControllerDrag:m,controllerDragCallback:p},t.time)}))},n)}))})};function Rz(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kz(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function Dz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Uz(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Dz(e,t,n[t])}))}return e}function Fz(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Gz(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Rz(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Rz(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Vz,Bz=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},Hz=function(t){return(0,e.jsx)(yW,{keyframe:t})},Kz=function(t){return(0,e.jsx)(dc,{value:t,unit:tc.FloatTwoFractions})};!function(e){e[e.None=0]="None",e[e.LeftTangent=1]="LeftTangent",e[e.Keyframe=2]="Keyframe",e[e.RightTangent=3]="RightTangent"}(Vz||(Vz={}));var Wz=function(t){var n,r,o,a=t.children,l=t.style,s=t.zoomable,c=t.panable,u=t.padding,d=t.className,f=t.gridLines,h=void 0===f||f,m=t.showTooltipOnDrag,p=void 0!==m&&m,v=t.tooltipKeyframe,g=t.textScale,y=void 0===g?1:g,b=t.formatTooltip,x=void 0===b?Hz:b,_=t.formatLabelX,j=void 0===_?Kz:_,E=t.formatLabelY,O=void 0===E?Kz:E,T=t.onClick,I=t.onMouseDown,S=t.onWindowMouseMove,w=t.keyframeMoveCallback,N=t.zoomCallback,P=t.panCallback,C=t.OnFocusChange,A=t.focusKey,L=wW(),M=L.data,R=L.canAddKeyframes,k=L.activeKeyframe,D=L.selectKeyframe,U=L.activeCurve,F=L.addKeyframe,G=L.removeKeyframe,V=L.deselectKeyframes,B=L.updateKeyframe,H=L.isDraggingKeyframe,K=L.draggedKeyframeRef,W=L.setDraggedKeyframe,z=L.parseKeyframe,Y=L.smoothenOnMove,X=(0,i.useRef)(null),q=(0,i.useCallback)((function(e){var t=e.point,n=t.x,r=t.y;F(n,r,U)}),[U,F]),$=(0,i.useCallback)((function(e){null==T||T(e),V()}),[V,T]),Q=(0,i.useCallback)((r=function(e,t){var n,r,i,o,a,l,s=arguments;return Bz(this,(function(c){switch(c.label){case 0:return n=s.length>2&&void 0!==s[2]&&s[2],t>-1?(r=M.curves[U].keys,i=r[t],o=Fz(Uz({},i),{time:e.x,value:e.y}),a=z?z(i,o,t,r,U):o,[4,B(t,a,!!Y,U)]):[3,2];case 1:l=c.sent(),n&&W(l),c.label=2;case 2:return[2]}}))},o=function(){var e=this,t=arguments;return new Promise((function(n,i){var o=r.apply(e,t);function a(e){kz(o,n,i,a,l,"next",e)}function l(e){kz(o,n,i,a,l,"throw",e)}a(void 0)}))},function(e,t){return o.apply(this,arguments)}),[U,M.curves,z,W,Y,B]),Z=(0,i.useCallback)((function(e){null==S||S(e),Q(e.point,K.current,!0)}),[K,Q,S]);(0,i.useEffect)((function(){if(-1!==k){var e=function(e){"Backspace"!==e.code&&"Delete"!==e.code||G(k,U)};return document.addEventListener("keydown",e),function(){document.removeEventListener("keydown",e)}}}),[U,k,F,G]);var J=v||(H?null===(n=M.curves[U])||void 0===n?void 0:n.keys[K.current]:void 0),ee=J?x(J):void 0,te=(0,i.useMemo)((function(){return U>=0&&U<M.curves.length?M.curves[U].keys.findIndex((function(e){return!e.readonly})):-1}),[U,M.curves]),ne=Gz((0,i.useState)(-1),2),re=ne[0],ie=ne[1],oe=Gz((0,i.useState)(Vz.Keyframe),2),ae=oe[0],le=oe[1],se=Gz((0,i.useState)(!1),2),ce=se[0],ue=se[1],de=(0,i.useCallback)((function(e){if(ue(e),C&&C(e),e&&U>=0&&U<M.curves.length&&te>=0){var t=M.curves[U];k>=0&&k<t.keys.length&&!t.keys[k].readonly?ie(k):(re<0||re>=t.keys.length||t.keys[re].readonly)&&ie(te)}}),[C,U,k,M.curves,te,re]),fe=(0,i.useMemo)((function(){return{"Move Horizontal":U>=0&&U<M.curves.length&&M.curves[U].keys.length>1?function(e){if(U>=0&&U<M.curves.length){var t=M.curves[U];if(k>=0){var n=k>0&&!t.keys[k-1].readonly,r=k<t.keys.length-1&&!t.keys[k+1].readonly,i=at(ae+Math.sign(e),n?Vz.LeftTangent:Vz.Keyframe,r?Vz.RightTangent:Vz.Keyframe);if(i!==ae)return le(i),!0}else{var o=t.keys.findIndex((function(e){return!e.readonly})),a=t.keys.length-Array.from(t.keys).reverse().findIndex((function(e){return!e.readonly}))-1;if(o>=0&&a>=0&&a>=o){var l=at(re+Math.sign(e),o,a);if(l!==re&&!M.curves[U].keys[l].readonly)return ie(l),!0}}}return!1}:null,Back:function(){return U>=0&&U<M.curves.length&&k>=0&&k<M.curves[U].keys.length&&(V(),!0)},Select:function(){D(re,U),le(Vz.Keyframe)}}}),[U,k,M.curves,V,ae,re,D]);return(0,e.jsx)(Tn,{actions:fe,children:(0,e.jsxs)(YV,{className:Oe()(rW,JK,d),focusKey:A,onFocusChange:de,children:[(0,e.jsx)(Nu,{disabled:!p,alwaysVisible:!0,screenSpacePosition:!0,tooltip:ee}),(0,e.jsx)("div",{className:Oe()(eW,Dz({},sW,M.curves.length>1)),ref:X,children:(0,e.jsxs)(JB,{bounds:M.bounds,padding:u||12,onDoubleClick:R?q:void 0,onClick:$,onMouseDown:I,onWindowMouseMove:Z,style:l,zoomable:s,panable:c,zoomCallback:ce?N:void 0,panCallback:ce?P:void 0,children:[h&&(0,e.jsx)(WK,{overdraw:!0,halfSteps:!0}),(0,e.jsx)("g",{children:M.curves.map((function(t,n){return(0,e.jsx)(fW,{keys:t.keys,className:Oe()({active:M.curves.length>1&&n===U})},n)}))}),U>=0&&(0,e.jsx)(Mz,{curveIndex:U,focusedKeyframe:ce?re:-1,editTarget:ce?ae:Vz.None,onControllerDrag:Q,controllerDragCallback:w}),a,(0,e.jsx)(KK,{fixed:!0,textScale:y,formatLabelX:j,formatLabelY:O})]})})]})})};const zz={button:"button_UQQ"};var Yz={x:0,y:2},Xz=function(t){var n=t.data,r=t.onSelect,o=t.className,a=(0,i.useRef)(null);return(0,e.jsx)(ml,{ref:a,theme:zz,onSelect:r,className:WV.dropdownToggle,children:(0,e.jsx)(JB,{className:o,bounds:n.bounds,padding:Yz,children:n.curves.map((function(t,n){return(0,e.jsx)(fW,{keys:t.keys,className:uW},n)}))})})},qz=function(t){var n=t.label,r=t.children;return(0,e.jsxs)(zV,{children:[(0,e.jsx)("div",{className:WV.row,children:(0,e.jsx)("div",{className:WV.label,children:n})}),(0,e.jsx)("div",{className:WV.groupChildren,children:r})]})},$z=function(t){var n=t.label,r=t.expanded,i=t.children,o=t.onExpandedChange;return(0,e.jsx)(XV,{label:n,expanded:r,onExpandedChange:o,children:(0,e.jsx)("div",{className:WV.groupChildren,children:i})})};const Qz="draggable-value_l2t",Zz="draggable-value-cursor_v5P",Jz="dragging_d8v";function eY(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function nY(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return eY(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return eY(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function rY(t,n){var r,o=t.value,a=t.disabled,l=t.className,s=t.dragTransformation,c=t.onChange,u=t.onDragStart,d=t.onDragEnd,f=t.children,h=(0,i.useRef)(null),m=(0,i.useCallback)((function(e){var t=e.clientX;return!a&&(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),h.current={clientX:t,value:o},u&&u(),!0)}),[a,o,u]),p=nY(Zd(m,(0,i.useCallback)((function(e){var t=e.clientX;if(!a&&null!=h.current){var n=(t-h.current.clientX)/window.innerWidth;c&&c(s(h.current.value,n))}}),[a,s,c]),(0,i.useCallback)((function(){d&&d()}),[d])),2),v=p[0],g=p[1];return Of(v&&!a?Zz:void 0),(0,e.jsx)("div",{ref:n,className:Oe()((r={},tY(r,Qz,!a),tY(r,Jz,v),r),l),onMouseDown:g,children:f})}var iY=(0,i.forwardRef)(rY);function oY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function aY(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){oY(e,t,n[t])}))}return e}function lY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var sY=function(t){var n=t.label,r=t.value,o=t.min,a=void 0===o?it:o,l=t.max,s=void 0===l?ot:l,c=t.fractionDigits,u=void 0===c?3:c,d=t.disabled,f=t.onChange,h=t.onChangeStart,m=t.onChangeEnd,p=(0,i.useCallback)((function(e,t){return fY(e,t,a,s)}),[a,s]);return(0,e.jsx)(YV,{disabled:d,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:d,className:WV.label,dragTransformation:p,onChange:f,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(qD,{value:r,min:a,max:s,fractionDigits:u,disabled:d,className:WV.input,onChange:f,onFocus:h,onBlur:m})})]})})},cY=function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(lY(aY({},r),{x:e}))}),[r,a]),u=(0,i.useCallback)((function(e){return a(lY(aY({},r),{y:e}))}),[r,a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:o,className:WV.label,dragTransformation:mY,onChange:a,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(dY,{label:"X",value:r.x,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(dY,{label:"Y",value:r.y,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s})]})})]})})},uY=function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(lY(aY({},r),{x:e}))}),[r,a]),u=(0,i.useCallback)((function(e){return a(lY(aY({},r),{y:e}))}),[r,a]),d=(0,i.useCallback)((function(e){return a(lY(aY({},r),{z:e}))}),[r,a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:o,className:WV.label,dragTransformation:pY,onChange:a,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(dY,{label:"X",value:r.x,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(dY,{label:"Y",value:r.y,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(dY,{label:"Z",value:r.z,disabled:o,onChange:d,onChangeStart:l,onChangeEnd:s})]})})]})})},dY=function(t){var n=t.label,r=t.value,i=t.disabled,o=t.onChange,a=t.onChangeStart,l=t.onChangeEnd;return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(iY,{value:r,disabled:i,className:WV.vectorLabel,dragTransformation:hY,onChange:o,children:n}),(0,e.jsx)(qD,{value:r,disabled:i,onChange:o,onFocus:a,onBlur:l,className:WV.vectorInput})]})};function fY(e,t,n,r){return at(e+60*t,n,r)}function hY(e,t){return fY(e,t,it,ot)}function mY(e,t){return{x:at(e.x+30*t,it,ot),y:at(e.y+30*t,it,ot)}}function pY(e,t){return{x:at(e.x+30*t,it,ot),y:at(e.y+30*t,it,ot),z:at(e.z+30*t,it,ot)}}function vY(e,t){return{x:at(e.x+30*t,it,ot),y:at(e.y+30*t,it,ot),z:at(e.z+30*t,it,ot),w:at(e.w+30*t,it,ot)}}function gY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function yY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var bY=function(){var t,n=wW(),r=n.activeKeyframe,o=n.activeCurve,a=n.data,l=n.canAddKeyframes,s=n.parseKeyframe,c=n.updateKeyframe,u=n.removeKeyframe,d=null===(t=a.curves[o])||void 0===t?void 0:t.keys[r],f=(0,i.useMemo)((function(){var e=function(e,t){var n,i=yY(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){gY(e,t,n[t])}))}return e}({},d),gY({},e,t)),l=s?s(d,i,r,null===(n=a.curves[o])||void 0===n?void 0:n.keys,o):i;c(r,l,!1,o)};return{changeTime:function(t){return e("time",t)},changeValue:function(t){return e("value",t)},changeInTangent:function(t){return e("inTangent",t)},changeInWeight:function(t){return e("inWeight",t)},changeOutTangent:function(t){return e("outTangent",t)},changeOutWeight:function(t){return e("outWeight",t)},smoothenTangents:function(){return c(r,d,!0,o)},removeKeyframe:function(){return u(r,o)}}}),[o,r,a.curves,d,s,u,c]);if(!d)return null;var h=a.curves[o];return(0,e.jsxs)(qz,{label:"Keyframe ".concat(r),children:[(0,e.jsx)(sY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Time"}),value:d.time,onChange:f.changeTime}),(0,e.jsx)(sY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Value"}),value:d.value,onChange:f.changeValue}),r>0&&(0,e.jsxs)(qz,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"In"}),children:[(0,e.jsx)(sY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Tangent"}),value:d.inTangent,onChange:f.changeInTangent}),(0,e.jsx)(sY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Weight"}),value:d.inWeight,min:0,max:1,onChange:f.changeInWeight})]}),r<h.keys.length-1&&(0,e.jsxs)(qz,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Out"}),children:[(0,e.jsx)(sY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Tangent"}),value:d.outTangent,onChange:f.changeOutTangent}),(0,e.jsx)(sY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Weight"}),value:d.outWeight,min:0,max:1,onChange:f.changeOutWeight})]}),(0,e.jsx)(zV,{children:(0,e.jsxs)("div",{className:Oe()(tW,nW),children:[(0,e.jsx)(ml,{theme:AV,onSelect:f.smoothenTangents,children:"Smoothen"}),l&&(0,e.jsx)(ml,{disabled:h.keys.length<3,theme:AV,onSelect:f.removeKeyframe,children:"Delete Keyframe"})]})})]})},xY={min:{x:0,y:0},max:{x:1,y:1}},_Y=function(e,t){var n=(0,i.useRef)(),r=(0,i.useRef)(),o=(0,i.useRef)(),a=(0,i.useRef)(),l=(0,i.useRef)(),s=(0,i.useRef)(),c=t||{},u=c.autoUpdateBounds,d=c.minX,f=c.maxX,h=c.minY,m=c.maxY,p=c.wrapMode,v=c.hash,g=(0,i.useMemo)((function(){var t=Array.isArray(e)?e:[e],i=t.reduce((function(e,t){return t?{maxKeysCount:Math.max(t.keys.filter((function(e){return!e.readonly})).length,e.maxKeysCount),readOnlyCount:t.keys.reduce((function(e,t){return e+Number(!!t.readonly)}),0)}:{maxKeysCount:0,readOnlyCount:0}}),{maxKeysCount:0,readOnlyCount:0}),c=xY;if(0===i.maxKeysCount)return{bounds:c={min:{x:null!=d?d:0,y:null!=h?h:0},max:{x:null!=f?f:1,y:null!=m?m:1}},curves:t};var g=r.current!==i.maxKeysCount,y=l.current||{},b=y.minX!==d||y.maxX!==f||y.minY!==h||y.maxY!==m,x=t.length!==a.current,_=s.current!==v;if(u||!n.current||g||b||p!==(null==y?void 0:y.wrapMode)||x||_){i.maxKeysCount>0&&(c={min:{x:null!=d?d:1/0,y:null!=h?h:1/0},max:{x:null!=f?f:-1/0,y:null!=m?m:-1/0}});var j="number"==typeof d,E="number"==typeof f,O="number"==typeof h,T="number"==typeof m;t.forEach((function(e){return e.keys.forEach((function(e){e.time<c.min.x&&(!j||u)&&(c.min.x=e.time),e.time>c.max.x&&(!E||u)&&(c.max.x=e.time),e.value<c.min.y&&(!O||u)&&(c.min.y=e.value),e.value>c.max.y&&(!T||u)&&(c.max.y=e.value)}))}));var I=c.max.x-c.min.x;if(I<1)c.min.x=Math.floor(c.min.x-(1-I)/2),c.max.x=Math.ceil(c.min.x+(1-I)/2);else if(0===I){var S=Math.max(1,Math.pow(10,Math.round(Math.log10(Math.abs(c.min.x)))));j&&T||!j&&!E?(c.min.x-=S/2,c.max.x+=S/2):j?c.max.x+=S:E&&(c.min.x-=S)}var w=c.max.y-c.min.y;if(w<1&&0!==w)c.min.y=Math.floor(c.min.y-(1-w)/2),c.max.y=Math.ceil(c.min.y+(1-w)/2);else if(0===w){var N=Math.max(1,Math.pow(10,Math.round(Math.log10(Math.abs(c.min.y)))));O&&T||!O&&!T?(c.min.y-=N/2,c.max.y+=N/2):O?c.max.y+=N:T&&(c.min.y-=N)}}else c=n.current;var P,C,A={bounds:(P=n.current,C=c,P&&P.min.y===C.min.y&&P.max.y===C.max.y&&P.min.x===C.min.x&&P.max.x===C.max.x?P:C),curves:t,maxKeysCount:i.maxKeysCount};return p&&function(e,t,n){e&&t.filter((function(e){return e.keys.length>0})).map((function(t){var r=t.keys;r[0].readonly&&r.splice(0,1),r[r.length-1].readonly&&r.splice(r.length-1,1);var i,o,a=r.length-1,l=r[0],s=r[1],c=r[a],u=r[a-1];l.time>n.min.x&&("clamp"===e?(l.outTangent=0,i=qK(XK({},ZK),{time:n.min.x,value:l.value})):"loop"===e?(i=qK(XK({},ZK,c),{time:l.time-(c.time-u.time)}),l.inTangent=c.inTangent,l.inWeight=c.inWeight):(i=qK(XK({},ZK,s),{outTangent:-s.inTangent,outWeight:s.inWeight,time:l.time-(s.time-l.time)}),l.inTangent=-l.outTangent,l.inWeight=l.outWeight),i&&r.unshift(i)),c.time<n.max.x&&("clamp"===e?(c.inTangent=0,o=qK(XK({},ZK),{time:n.max.x,value:c.value})):"loop"===e?(o=qK(XK({},ZK,l),{time:c.time+(s.time-l.time)}),c.outTangent=l.outTangent,c.outWeight=l.outWeight):(o=qK(XK({},ZK,u),{inTangent:-u.outTangent,inWeight:u.outWeight,time:c.time+(c.time-u.time)}),c.outTangent=-c.inTangent,c.outWeight=c.inWeight),o&&r.push(o)),t.keys=$K(r)}))}(p,t,A.bounds),n.current=c,r.current=i.maxKeysCount,o.current=i.readOnlyCount,s.current=v,a.current=t.length,l.current={maxX:f,minX:d,maxY:m,minY:h,wrapMode:p},A}),[e,d,f,h,m,v,u,p]);return g};function jY(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function EY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function OY(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){EY(e,t,n[t])}))}return e}function TY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function IY(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jY(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jY(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var SY=function(t){var n=t.label,r=t.value,o=t.disabled,a=t.hidePreview,l=t.expanded,s=t.initialEditing,c=t.autoUpdateBounds,u=t.bounds,d=t.smoothenOnMove,f=t.canAddKeyframes,h=void 0===f||f,m=t.wrapMode,p=t.parseKeyframe,v=t.onAddKeyframe,g=t.onMoveKeyframe,y=t.onRemoveKeyframe,b=t.onSetKeyframes,x=_Y(r,OY({autoUpdateBounds:!0},u)),_=_Y(r,TY(OY({autoUpdateBounds:c},u),{wrapMode:m})),j=IY((0,i.useState)(l||s),2),E=j[0],O=j[1],T=(0,i.useMemo)((function(){if(!l&&!o)return function(){return O((function(e){return!e}))}}),[l,o]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(YV,{disabled:o,children:(0,e.jsx)(qV,{label:n,onSelect:T,children:!a&&(0,e.jsx)(Xz,{data:x,onSelect:T})})}),(0,e.jsx)($V,{visible:E,children:(0,e.jsxs)(SW,{data:_,onAddKeyframe:v,onMoveKeyframe:g,onRemoveKeyframe:y,onSetKeyframes:b,parseKeyframe:p,canAddKeyframes:h,smoothenOnMove:d,children:[(0,e.jsx)(Wz,{zoomable:!0,panable:!0}),(0,e.jsx)(bY,{})]})})]})};function wY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function NY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var PY=function(e){var t=e.parent,n=e.path,r=(0,i.useMemo)((function(){var e=Eh(t.path,n);return{onAddKeyframe:function(n,r,i){return function(e,t,n,r){return P(e,"addKeyframe",t,n,r,arguments.length>4&&void 0!==arguments[4]?arguments[4]:0)}(t.group,e,n,r,i)},onMoveKeyframe:function(n,r,i,o){return function(e,t,n,r){return P(e,"moveKeyframe",t,n,r,arguments.length>4&&void 0!==arguments[4]&&arguments[4],arguments.length>5&&void 0!==arguments[5]?arguments[5]:0)}(t.group,e,n,r,i,o)},onRemoveKeyframe:function(n,r){return function(e,t,n){N(e,"removeKeyframe",t,n,arguments.length>3&&void 0!==arguments[3]?arguments[3]:0)}(t.group,e,n,r)},onSetKeyframes:function(n,r){return function(e,t,n){N(e,"setKeyframes",t,n,arguments.length>3&&void 0!==arguments[3]?arguments[3]:0)}(t.group,e,n,r)}}}),[t.group,t.path,n]);return r};function CY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function AY(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){CY(e,t,n[t])}))}return e}function LY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}const MY={slider:"slider_KXG slider_pUS",compact:"compact_c2g",range:"range_nHO range_iUN",thumb:"thumb_kkL"};var RY=function(t){var n=t.label,r=t.value,i=t.min,o=t.max,a=t.disabled,l=t.onChange,s=t.onChangeStart,c=t.onChangeEnd;return(0,e.jsx)(YV,{disabled:a,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(Or,{className:WV.sliderContainer,children:(0,e.jsx)(eA,{children:(0,e.jsx)(Fm,{value:r,start:i,end:o,disabled:a,theme:MY,className:WV.slider,valueTransformer:Vm,onChange:l,onDragStart:s,onDragEnd:c})})}),(0,e.jsx)(tU,{value:r,min:i,max:o,disabled:a,onChange:l,onFocus:s,onBlur:c,className:WV.sliderInput})]})})]})})},kY=function(t){var n=t.label,r=t.value,i=t.min,o=t.max,a=t.fractionDigits,l=void 0===a?3:a,s=t.disabled,c=t.onChange,u=t.onChangeStart,d=t.onChangeEnd,f=Bm(Math.pow(10,-l));return(0,e.jsx)(YV,{disabled:s,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(Or,{className:WV.sliderContainer,children:(0,e.jsx)(eA,{children:(0,e.jsx)(Fm,{value:r,start:i,end:o,disabled:s,theme:MY,className:WV.slider,valueTransformer:f,onChange:c,onDragStart:u,onDragEnd:d})})}),(0,e.jsx)(qD,{value:r,min:i,max:o,fractionDigits:l,disabled:s,onChange:c,onFocus:u,onBlur:d,className:WV.sliderInput})]})})]})})};function DY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function UY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function FY(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var GY=function(t){var n=t.min,r=void 0===n?0:n,o=t.max,a=void 0===o?1439/1440:o,l=FY(t,["min","max"]),s=(0,i.useCallback)((function(e){return function(e,t,n){if("-"===e)return;if(""===e)return t<=0&&n>=0?0:void 0;var r=/^(-?)(\d+):(\d+)$/g.exec(e);if(null!=r){var i=("-"===r[1]?-1:1)*(60*parseInt(r[2])+parseInt(r[3]))/1440;if(!isNaN(i))return at(i,t,n)}var o=parseInt(e,10)/24;return isNaN(o)?void 0:at(o,t,n)}(e,r,a)}),[r,a]);return(0,e.jsx)(OD,UY(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){DY(e,t,n[t])}))}return e}({},l),{valueFormatter:VY,inputParser:s,inputValidator:r<0?BY:HY}))};function VY(e){var t=-1===Math.sign(e)?"-":"",n=Math.floor(24*(Math.abs(e)+1e-5)),r=Math.round(1440*Math.abs(e))%60;return"".concat(t).concat(zs(n,2),":").concat(zs(r,2))}function BY(e){return/^-?[0-9]*:?[0-9]*$/.test(e)}function HY(e){return/^[0-9]*:?[0-9]*$/.test(e)}var KY=function(t){var n=t.label,r=t.value,i=t.min,o=t.max,a=t.disabled,l=t.onChange,s=t.onChangeStart,c=t.onChangeEnd;return(0,e.jsx)(YV,{disabled:a,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(Or,{className:WV.sliderContainer,children:(0,e.jsx)(eA,{children:(0,e.jsx)(Fm,{value:r,start:i,end:o,disabled:a,theme:MY,className:WV.slider,valueTransformer:WY,onChange:l,onDragStart:s,onDragEnd:c})})}),(0,e.jsx)(GY,{value:r,min:i,max:o,disabled:a,onChange:l,onFocus:s,onBlur:c,className:WV.sliderInput})]})})]})})};function WY(e,t,n){return at(Math.round(96*(e+n*(t-e)))/96,Math.min(e,t),Math.max(e,t))}function zY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function YY(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zY(e,t,n[t])}))}return e}function XY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function qY(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function $Y(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function QY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function ZY(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return qY(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return qY(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var JY=new Se("swatch"),eX=new Se("picker");var tX=new Se("FIELD"),nX=function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onOpenDirectoryBrowser,l=(0,i.useCallback)((function(){return a()}),[a]);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(YV,{disabled:o,children:(0,e.jsx)(Ze,{focused:tX,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(ml,{focusKey:tX,className:Oe()(WV.pickerToggle,WV.directoryButton),disabled:o,onSelect:l,children:[r,(0,e.jsx)("img",{src:"Media/Editor/Folder.svg",className:WV.directoryIcon})]})})]})})})})};const rX={"dropdown-flag-item":"dropdown-flag-item_EcT",dropdownFlagItem:"dropdown-flag-item_EcT",toggle:"toggle_RyX",label:"label_PwM"};function iX(t){var n=t.focusKey,r=t.value,o=t.checked,a=t.theme,l=void 0===a?rX:a,s=t.toggleComponent,c=void 0===s?pp:s,u=t.className,d=t.onChange,f=t.children,h=(0,i.useCallback)((function(){d&&d(r,!o)}),[o,d,r]);return(0,e.jsx)(In,{onAction:h,children:(0,e.jsxs)(Tr,{focusKey:n,className:Oe()(l.dropdownFlagItem,o&&"checked",u),onClick:h,children:[i.createElement(c,{checked:o,className:l.toggle}),(0,e.jsx)("div",{className:l.label,children:f})]})})}function oX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var aX=function(t){var n=t.label,r=t.value,o=t.enumMembers,a=t.disabled,l=t.onChange,s=bs(),c=(0,i.useMemo)((function(){return cX(s,o,r)}),[s,o,r]);return(0,e.jsx)(YV,{disabled:a,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(fC,{theme:LD,initialFocused:c,content:null==o?void 0:o.map((function(t,n){return(0,e.jsx)(_C,{focusKey:n,value:t.value,selected:r===t.value,onChange:l,children:(0,e.jsx)(ph,{value:t.displayName})},n)})),children:(0,e.jsx)(gC,{sounds:sX,className:WV.dropdownToggle,children:c})})})]})})},lX=function(t){var n=t.label,r=t.value,o=t.enumMembers,a=t.disabled,l=t.onChange,s=bs(),c=(0,i.useMemo)((function(){return function(e,t,n){if(0n!==n){var r=t.map((function(e){return e.value})).find((function(e){return e===n}));return r?cX(e,t,r):t.filter((function(e){return 0n!==e.value&&(n&e.value)===e.value})).map((function(t){return vh(e,t.displayName)})).join(", ")||" "}return cX(e,t,0n)}(s,o,r)}),[s,o,r]),u=(0,i.useCallback)((function(e,t){l(t?r|e:r&~e)}),[l,r]),d=(0,i.useMemo)((function(){return o.map((function(e){return e.value})).reduce((function(e,t){return e|t}))}),[o]),f=d===r,h=(0,i.useCallback)((function(){return l(d)}),[d,l]),m=(0,i.useCallback)((function(){return l(0n)}),[l]);return(0,e.jsx)(YV,{disabled:a,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(fC,{theme:LD,initialFocused:0,content:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(ml,{onSelect:f?m:h,selected:f,className:LD.toggleFlagsButton,children:"Select Nothing/Everything"}),o.map((function(t,n){return(0,e.jsx)(iX,{theme:LD,focusKey:n,value:t.value,checked:(t.value&r)===t.value,onChange:u,children:(0,e.jsx)(ph,{value:t.displayName})},n)}))]}),children:(0,e.jsx)(gC,{sounds:sX,className:WV.dropdownToggle,children:c})})})]})})},sX=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){oX(e,t,n[t])}))}return e}({},hl),{hover:null,focus:null});function cX(e,t,n){var r=t.find((function(e){return e.value===n}));return null!=r?vh(e,r.displayName):" "}function uX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function dX(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){uX(e,t,n[t])}))}return e}function fX(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function hX(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var mX=function(t){var n=t.label,r=t.value,o=t.min,a=void 0===o?nt:o,l=t.max,s=void 0===l?rt:l,c=t.disabled,u=t.onChange,d=t.onChangeStart,f=t.onChangeEnd,h=(0,i.useCallback)((function(e,t){return vX(e,t,a,s)}),[a,s]);return(0,e.jsx)(YV,{disabled:c,children:(0,e.jsxs)("div",{"data-type":"field",className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:c,className:WV.label,dragTransformation:h,onChange:u,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(tU,{value:r,min:a,max:s,disabled:c,className:WV.input,onChange:u,onFocus:d,onBlur:f})})]})})},pX=function(t){var n=t.label,r=t.value,i=t.disabled,o=t.onChange,a=t.onChangeStart,l=t.onChangeEnd;return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(iY,{value:r,disabled:i,className:WV.vectorLabel,dragTransformation:gX,onChange:o,children:n}),(0,e.jsx)(tU,{value:r,disabled:i,className:WV.vectorInput,onChange:o,onFocus:a,onBlur:l})]})};function vX(e,t,n,r){return at(Math.trunc(e+30*t),n,r)}function gX(e,t){return vX(e,t,nt,rt)}function yX(e,t){return{x:at(Math.trunc(e.x+60*t),nt,rt),y:at(Math.trunc(e.y+60*t),nt,rt)}}function bX(e,t){return{x:at(Math.trunc(e.x+60*t),nt,rt),y:at(Math.trunc(e.y+60*t),nt,rt),z:at(Math.trunc(e.z+60*t),nt,rt)}}function xX(e,t){return{x:at(Math.trunc(e.x+60*t),nt,rt),y:at(Math.trunc(e.y+60*t),nt,rt),z:at(Math.trunc(e.z+60*t),nt,rt),w:at(Math.trunc(e.w+60*t),nt,rt)}}var _X=new Se("FIELD"),jX=new Se("PICKER"),EX=function(t){var n=t.label,r=t.value,o=t.expanded,a=t.disabled,l=t.children,s=t.onExpandedChange,c=(0,i.useCallback)((function(){return s(!o)}),[o,s]),u=(0,i.useCallback)((function(){return s(!1)}),[s]),d=Xd(WV.pickerMinHeight),f=(0,e.jsx)(Fn,{focusKey:jX,children:l});return(0,e.jsxs)(e.Fragment,{children:[o&&(0,e.jsx)(rC,{onClick:u}),(0,e.jsx)(YV,{disabled:a,children:(0,e.jsx)(Ze,{focused:o?jX:_X,children:(0,e.jsx)(eC,{visible:o,minHeight:d,content:f,className:WV.pickerPopup,minWidth:!0,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(ml,{focusKey:_X,className:Oe()(WV.pickerToggle,o&&WV.expanded),disabled:a,onSelect:c,children:r})})]})})})})]})},OX=function(t){var n=t.label,r=t.value,i=t.disabled,o=t.onChange;return(0,e.jsx)(YV,{disabled:i,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)(pp,{checked:r,disabled:i,onChange:o,className:WV.toggle})]})})};const TX="popup-content_QLL",IX="popup-content-scrollable_clr";function SX(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function wX(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return SX(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return SX(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var NX=function(t){var n=t.availableFilters,r=t.activeFilters,o=t.onToggleFilter,a=t.onClear,l=wX((0,i.useState)(!1),2),s=l[0],c=l[1],u=CX(n,r),d=(0,i.useMemo)((function(){return r.length>0?r.join(", "):(0,e.jsx)(Ks.Common.NONE,{})}),[r]);return(0,e.jsx)(EX,{label:(0,e.jsx)(Ks.Editor.FILTERS,{}),value:d,expanded:s,onExpandedChange:c,children:(0,e.jsxs)("div",{className:TX,children:[(0,e.jsx)(mf,{className:IX,children:u.map((function(t){return(0,e.jsx)(PX,{filter:t.filter,active:t.active,onToggle:o},t.filter)}))}),(0,e.jsx)(GV,{onSelect:a,children:(0,e.jsx)(Ks.Editor.CLEAR_ALL,{})})]})})},PX=function(t){var n=t.filter,r=t.active,o=t.onToggle,a=(0,i.useCallback)((function(){return o(n,!r)}),[r,n,o]);return(0,e.jsx)(OX,{label:n,value:r,onChange:a})},CX=function(e,t){return(0,i.useMemo)((function(){return e.map((function(e){return{filter:e,active:t.includes(e)}}))}),[t,e])};const AX="editor-icon-button-group_Qiw editor-widget_QQl",LX="button_qdd";function MX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function RX(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){MX(e,t,n[t])}))}return e}function kX(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var DX=function(t){var n=t.parent,r=t.path,i=t.props,o=xh(Th,Mh(n,r));return(0,e.jsx)(xO,{tooltip:i.tooltip&&(0,e.jsx)(ph,{value:i.tooltip}),children:(0,e.jsx)(FX,{src:i.icon,selected:i.selected,disabled:i.disabled,onSelect:o})})},UX=function(t){var n=t.children;return(0,e.jsx)("div",{className:AX,children:n})},FX=function(t){var n=t.src,r=t.selected,i=t.disabled,o=t.tinted,a=t.className,l=t.onSelect;return(0,e.jsx)(xl,{src:n,selected:r,disabled:i,theme:AV,className:Oe()(LX,a),onSelect:l,tinted:o})};var GX=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._callback=null}var t=e.prototype;return t.scrollTo=function(e,t){null!=this._callback&&this._callback.scrollTo(e,t)},t.scrollBy=function(e,t){null!=this._callback&&this._callback.scrollBy(e,t)},t.smoothScrollTo=function(e,t){null!=this._callback&&this._callback.smoothScrollTo(e,t)},t.scrollIntoView=function(e){null!=this._callback&&this._callback.scrollIntoView(e)},t._attachCallback=function(e){null==this._callback?this._callback=e:console.warn("Scroll controller callback already attached!")},t._detachCallback=function(e){this._callback===e?this._callback=null:console.warn("Scroll controller callback not attached!")},e}();function VX(){return(0,i.useMemo)((function(){return new GX}),[])}const BX="virtual-list_Amj",HX="vertical_RRQ",KX="horizontal_QEG";function WX(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zX(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return WX(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return WX(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var YX=i.forwardRef((function(t,n){var r=t.sizeProvider,o=t.direction,a=void 0===o?"vertical":o,l=t.controller,s=t.smooth,c=t.className,u=t.style,d=t.renderItem,f=t.onRenderedRangeChange,h=(0,i.useRef)(null),m=Je(n,h),p=XX(h,r,a,void 0,d,f),v=p.list,g=p.onScroll,y="vertical"===a;return(0,e.jsx)(mf,{ref:m,vertical:y,horizontal:!y,controller:l,smooth:s,className:c,style:u,onScroll:g,children:v})}));function XX(t,n,r,o,a,l){var s=Fd(t,Ud),c=zd(),u=null!=s?s:c,d="vertical"===r,f=d?u.y:u.x,h=zX((0,i.useState)(0),2),m=h[0],p=h[1],v=(0,i.useMemo)((function(){return n.getRenderedRange(m,f)}),[f,m,n]);(0,i.useEffect)((function(){null!=l&&l(v.startIndex,v.endIndex)}),[l,v.endIndex,v.startIndex]);var g=(0,i.useMemo)((function(){return"".concat(n.getTotalSize(),"px")}),[n]),y=(0,i.useMemo)((function(){return"".concat(v.offset,"px")}),[v.offset]),b=(0,i.useCallback)((function(){t.current&&p(d?t.current.scrollTop:t.current.scrollLeft)}),[t,d]);(0,i.useEffect)((function(){return b()}),[b]),(0,i.useEffect)((function(){var e=0;return function t(){b(),e=window.requestAnimationFrame(t)}(),function(){return window.cancelAnimationFrame(e)}}),[b]);var x=(0,i.useMemo)((function(){for(var e=new Array(v.endIndex-v.startIndex),t=0;t<e.length;t++)e[t]=a(v.startIndex+t,t);return e}),[v.endIndex,v.startIndex,a]),_=(0,i.useMemo)((function(){return(0,e.jsx)("div",{className:Oe()(BX,o,d?HX:KX),style:d?{height:g,paddingTop:y}:{width:g,paddingLeft:y},children:x})}),[d,g,y,x,o]);return(0,i.useMemo)((function(){return{list:_,onScroll:b}}),[_,b])}var qX={getRenderedRange:function(){return{offset:0,size:0,startIndex:0,endIndex:0}},getTotalSize:function(){return 0}};function $X(e,t,n){return(0,i.useMemo)((function(){return{getRenderedRange:function(r,i){var o=at(Math.floor(r/e)-n,0,t),a=at(Math.ceil((r+i)/e)+n,o,t);return{offset:e*o,startIndex:o,endIndex:a}},getTotalSize:function(){return e*t}}}),[t,e,n])}function QX(e,t){for(var n=e.length-1;n>=0;--n)if(t>=e[n].x)return n;return 0}const ZX="24rem",JX="26rem",eq="Media/Editor/DefaultObject.svg",tq="Media/Glyphs/ThickStrokeArrowRight.svg",nq="item-picker_ORP editor-widget_QQl",rq="favorite_pLV",iq="list-item_qRg item_H00",oq="image_scT",aq="name_u39",lq="dir-arrow_DVY",sq="grid-row_Uxw",cq="grid-item_qEa item_H00";function uq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dq(e){return function(e){if(Array.isArray(e))return uq(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return uq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uq(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var fq=i.forwardRef((function(t,n){var r=t.focusKey,o=t.selectedIndex,a=t.columnCount,l=t.hasImages,s=void 0===l||l,c=t.data,u=t.className,d=t.style,f=t.onRenderedRangeChange,h=t.onSelect,m=t.onToggleFavorite,p=(0,i.useRef)(null),v=VX(),g=(0,i.useCallback)((function(e){"number"==typeof e&&h(e)}),[h]),y=1===a,b=Xd(ZX),x=$X(b,c.length,2),_=(0,i.useCallback)((function(t,n){var r,i,a,l=c.get(t);return(0,e.jsx)(hq,{index:t,name:null!=l?(0,e.jsx)(ph,{value:l.displayName}):" ",image:null!==(r=null==l?void 0:l.image)&&void 0!==r?r:null,hasImage:s,directory:null!==(i=null==l?void 0:l.directory)&&void 0!==i&&i,favorite:null!==(a=null==l?void 0:l.favorite)&&void 0!==a&&a,selected:o===t,className:iq,onSelect:h,onToggleFavorite:m},n)}),[c,s,o,h,m]),j=Fd(p),E=Xd(JX),O=(null!=j?j.x-E:a)/a,T=null!=j?Math.ceil(c.length/a):0,I=$X(O,T,2),S=(0,i.useCallback)((function(t,n){var r=t*a,i=Math.min((t+1)*a,c.length);return(0,e.jsx)("div",{className:sq,style:{"--itemSize":O+"px"},children:dq(Array(i-r).keys()).map((function(t){var n,i,a,l=r+t,u=c.get(l);return(0,e.jsx)(hq,{index:l,name:null!=u?(0,e.jsx)(ph,{value:u.displayName}):" ",image:null!==(n=null==u?void 0:u.image)&&void 0!==n?n:null,hasImage:s,directory:null!==(i=null==u?void 0:u.directory)&&void 0!==i&&i,favorite:null!==(a=null==u?void 0:u.favorite)&&void 0!==a&&a,selected:o===l,className:cq,onSelect:h,onToggleFavorite:m},t)}))},n)}),[a,c,O,s,o,h,m]),w=(0,i.useCallback)((function(e,t){f&&f(e*a,t*a)}),[a,f]),N=(0,i.useRef)(0);N.current=-1===o||null===j?0:y?b*(o+.5)-j.y/2:O*(Math.floor(o/a)+.5)-j.y/2;var P=(0,i.useRef)(0);return(0,i.useImperativeHandle)(n,(function(){return{scrollToSelected:function(){window.cancelAnimationFrame(P.current),v.scrollTo(0,N.current),P.current=window.requestAnimationFrame((function(){v.scrollTo(0,N.current),P.current=window.requestAnimationFrame((function(){v.scrollTo(0,N.current)}))}))}}})),(0,i.useEffect)((function(){return function(){return window.cancelAnimationFrame(P.current)}}),[]),(0,e.jsx)(Mn,{focusKey:r,focused:o,onChange:g,children:(0,e.jsx)(YX,{ref:p,controller:v,smooth:!1,className:Oe()(nq,u),style:d,sizeProvider:null!=j?y?x:I:qX,renderItem:y?_:S,onRenderedRangeChange:w})})})),hq=function(t){var n=t.index,r=t.name,o=t.image,a=t.hasImage,l=t.directory,s=t.favorite,c=t.selected,u=t.className,d=t.onSelect,f=t.onToggleFavorite,h=(0,i.useCallback)((function(){return d(n)}),[n,d]),m=JR(2,(0,i.useMemo)((function(){return null!=f?function(){f(n,!s),Jt(Qt.selectToggle)}:void 0}),[n,s,f])),p=m.onMouseUp,v=m.onMouseDown;return(0,e.jsxs)(ml,{focusKey:n,selected:c,className:Oe()(u,s&&rq),onClick:h,onMouseDown:v,onMouseUp:p,children:[a&&(0,e.jsx)("img",{src:null!=o?o:eq,className:oq}),(0,e.jsx)("div",{className:aq,children:r}),l&&(0,e.jsx)(ll,{src:tq,className:lq})]})};const mq="item-picker-footer_Hi4 editor-widget_QQl",pq="summary_gnF",vq="slider_iLE";var gq=function(t){var n=t.length,r=t.columnCount,o=t.onColumnCountChange,a=(0,i.useCallback)((function(e){return o(e<=10?e:1)}),[o]);return(0,e.jsxs)("div",{className:mq,children:[(0,e.jsx)("div",{className:pq,children:(0,e.jsx)(Ks.Editor.ELEMENT_COUNT,{COUNT:n.toString()})}),(0,e.jsx)(Fm,{value:1===r?11:r,start:11,end:4,theme:MY,className:Oe()(MY.compact,vq),valueTransformer:Vm,onChange:a})]})};const yq={summary:"summary_sOH",section:"section_KBF",controls:"controls_kKZ",control:"control_p7u",children:"children_oyd section_KBF","list-item":"list-item_zT4",listItem:"list-item_zT4",header:"header_jkI",label:"label_Mi4",toggle:"toggle_IOi",action:"action_AoQ","toggle-label":"toggle-label_UK9",toggleLabel:"toggle-label_UK9"};function bq(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function xq(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){bq(e,t,n[t])}))}return e}function _q(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var jq=function(t){var n=t.parent,r=t.index,o=t.length,a=t.resizable,l=t.sortable,s=t.data,c=(0,i.useContext)(Xh),u=Oq(n,r,l,a);return(0,e.jsx)(Iq,_q(xq({focusKey:r,first:0===r,last:r===o-1},u),{onExpandedChange:void 0,children:(0,e.jsx)(zh,{parent:n,components:c,data:s})}))},Eq=function(t){var n=t.parent,r=t.index,o=t.length,a=t.resizable,l=t.sortable,s=t.data,c=Oq(n,r,l,a),u=Mh(n,s.path),d=(0,i.useContext)(Xh),f=xh(Sh,u);return(0,e.jsx)(Iq,_q(xq({focusKey:r,label:(0,e.jsx)(ph,{value:s.props.displayName}),first:0===r,last:r===o-1,expanded:s.props.expanded},c),{onExpandedChange:f,children:(0,e.jsx)(Yh,{parent:u,components:d,data:s.children})}))};function Oq(e,t,n,r){return(0,i.useMemo)((function(){return{onMoveUp:n?function(){return Ph(e,t,t-1)}:void 0,onMoveDown:n?function(){return Ph(e,t,t+1)}:void 0,onDuplicate:r?function(){return function(e,t){N(e.group,"duplicateListElement",e.path,t)}(e,t)}:void 0,onDelete:r?function(){return function(e,t){N(e.group,"deleteListElement",e.path,t)}(e,t)}:void 0}}),[e,t,n,r])}var Tq=function(t){var n=t.label,r=t.expanded,o=t.length,a=t.currentPageIndex,l=t.pageCount,s=t.disabled,c=t.children,u=t.onAddItem,d=t.onClear,f=t.onExpandedChange,h=t.onCurrentPageChange,m=(0,i.useCallback)((function(){return h(a-1)}),[a,h]),p=(0,i.useCallback)((function(){return h(a+1)}),[a,h]),v=r&&l>1?"Page ".concat(Ws(a+1),"/").concat(l,", Count: ").concat(Ws(o)):"Count: ".concat(Ws(o));return(0,e.jsxs)(XV,{label:n,summary:v,expanded:r,disabled:s,onExpandedChange:f,children:[l>1&&(0,e.jsxs)("div",{className:yq.controls,children:[(0,e.jsx)(ml,{disabled:0===a,theme:AV,className:yq.control,onSelect:m,children:"Previous Page"}),(0,e.jsx)(ml,{disabled:a>=l-1,theme:AV,className:yq.control,onSelect:p,children:"Next Page"})]}),o>0&&(0,e.jsx)("div",{className:yq.children,children:c}),(null!=u||null!=d)&&(0,e.jsxs)("div",{className:yq.controls,children:[null!=u&&(0,e.jsx)(ml,{disabled:s,theme:AV,className:yq.control,onSelect:u,children:"Add item"}),null!=d&&(0,e.jsx)(ml,{disabled:s||0===o,theme:AV,className:yq.control,onSelect:d,children:"Clear"})]})]})},Iq=function(t){var n=t.focusKey,r=t.label,o=t.disabled,a=t.first,l=t.last,s=t.expanded,c=void 0===s||s,u=t.children,d=t.onMoveUp,f=t.onMoveDown,h=t.onDuplicate,m=t.onDelete,p=t.onExpandedChange,v=null!=p,g=(0,i.useCallback)((function(){null!=p&&p(!c)}),[c,p]);return(0,e.jsxs)("div",{className:yq.listItem,children:[(0,e.jsx)("div",{className:yq.header,children:(0,e.jsxs)(Fn,{focusKey:n,direction:On.Horizontal,children:[v?(0,e.jsx)(xl,{tinted:!0,src:c?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg",className:Oe()(yq.toggle,c&&yq.expanded),onSelect:g,children:(0,e.jsx)("div",{className:yq.toggleLabel,children:r})}):(0,e.jsx)("div",{className:yq.label,children:r}),d&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Editor.LIST_ITEM_MOVE_UP,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/StrokeArrowUp.svg",disabled:a||o,className:yq.action,onSelect:d})}),f&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Editor.LIST_ITEM_MOVE_DOWN,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/StrokeArrowDown.svg",disabled:l||o,className:yq.action,onSelect:f})}),h&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Editor.LIST_ITEM_DUPLICATE,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Copy.svg",disabled:o,className:yq.action,onSelect:h})}),m&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Editor.LIST_ITEM_DELETE,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Trash.svg",disabled:o,className:yq.action,onSelect:m})})]})}),u]})};function Sq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function wq(e){return function(e){if(Array.isArray(e))return Sq(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Sq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Sq(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Nq,Pq,Cq,Aq,Lq="selectedInfo",Mq=E(Lq,"selectedEntity"),Rq=E(Lq,"selectedUITag"),kq=(E(Lq,"activeSelection"),E(Lq,"position")),Dq=E(Lq,"topSections"),Uq=E(Lq,"middleSections"),Fq=E(Lq,"bottomSections"),Gq=E(Lq,"titleSection"),Vq=E(Lq,"developerSection"),Bq=E(Lq,"lineVisualizerSection"),Hq=E(Lq,"householdSidebarSection"),Kq=E(Lq,"tooltipTags"),Wq=E(Lq,"selectedRoute"),zq=w(Lq,"selectEntity"),Yq=w(Lq,"setSelectedRoute"),Xq=S(Lq,"clearSelection");!function(e){e.Resource="Game.UI.InGame.ResourceSection",e.LocalServices="Game.UI.InGame.LocalServicesSection",e.Actions="Game.UI.InGame.ActionsSection",e.Description="Game.UI.InGame.DescriptionSection",e.Developer="Game.UI.InGame.DeveloperSection",e.Residents="Game.UI.InGame.ResidentsSection",e.HouseholdSidebar="Game.UI.InGame.HouseholdSidebarSection",e.Districts="Game.UI.InGame.DistrictsSection",e.Title="Game.UI.InGame.TitleSection",e.Notifications="Game.UI.InGame.NotificationsSection",e.Policies="Game.UI.InGame.PoliciesSection",e.Profitability="Game.UI.InGame.ProfitabilitySection",e.AverageHappiness="Game.UI.InGame.AverageHappinessSection",e.Schedule="Game.UI.InGame.ScheduleSection",e.Line="Game.UI.InGame.LineSection",e.Lines="Game.UI.InGame.LinesSection",e.Color="Game.UI.InGame.ColorSection",e.LineVisualizer="Game.UI.InGame.LineVisualizerSection",e.TicketPrice="Game.UI.InGame.TicketPriceSection",e.VehicleCount="Game.UI.InGame.VehicleCountSection",e.Attractiveness="Game.UI.InGame.AttractivenessSection",e.Efficiency="Game.UI.InGame.EfficiencySection",e.Employees="Game.UI.InGame.EmployeesSection",e.Upkeep="Game.UI.InGame.UpkeepSection",e.Level="Game.UI.InGame.LevelSection",e.Education="Game.UI.InGame.EducationSection",e.Pollution="Game.UI.InGame.PollutionSection",e.Healthcare="Game.UI.InGame.HealthcareSection",e.Deathcare="Game.UI.InGame.DeathcareSection",e.Garbage="Game.UI.InGame.GarbageSection",e.Police="Game.UI.InGame.PoliceSection",e.Vehicles="Game.UI.InGame.VehiclesSection",e.DispatchedVehicles="Game.UI.InGame.DispatchedVehiclesSection",e.Electricity="Game.UI.InGame.ElectricitySection",e.Transformer="Game.UI.InGame.TransformerSection",e.Battery="Game.UI.InGame.BatterySection",e.Water="Game.UI.InGame.WaterSection",e.Sewage="Game.UI.InGame.SewageSection",e.Fire="Game.UI.InGame.FireSection",e.Prison="Game.UI.InGame.PrisonSection",e.Shelter="Game.UI.InGame.ShelterSection",e.Parking="Game.UI.InGame.ParkingSection",e.Park="Game.UI.InGame.ParkSection",e.Mail="Game.UI.InGame.MailSection",e.Road="Game.UI.InGame.RoadSection",e.Company="Game.UI.InGame.CompanySection",e.Storage="Game.UI.InGame.StorageSection",e.PrivateVehicle="Game.UI.InGame.PrivateVehicleSection",e.PublicTransportVehicle="Game.UI.InGame.PublicTransportVehicleSection",e.CargoTransportVehicle="Game.UI.InGame.CargoTransportVehicleSection",e.DeliveryVehicle="Game.UI.InGame.DeliveryVehicleSection",e.HealthcareVehicle="Game.UI.InGame.HealthcareVehicleSection",e.FireVehicle="Game.UI.InGame.FireVehicleSection",e.PoliceVehicle="Game.UI.InGame.PoliceVehicleSection",e.MaintenanceVehicle="Game.UI.InGame.MaintenanceVehicleSection",e.DeathcareVehicle="Game.UI.InGame.DeathcareVehicleSection",e.PostVehicle="Game.UI.InGame.PostVehicleSection",e.GarbageVehicle="Game.UI.InGame.GarbageVehicleSection",e.Passengers="Game.UI.InGame.PassengersSection",e.Cargo="Game.UI.InGame.CargoSection",e.Load="Game.UI.InGame.LoadSection",e.Status="Game.UI.InGame.StatusSection",e.Citizen="Game.UI.InGame.CitizenSection",e.DummyHuman="Game.UI.InGame.DummyHumanSection",e.Animal="Game.UI.InGame.AnimalSection",e.SelectVehicles="Game.UI.InGame.SelectVehiclesSection",e.DestroyedBuilding="Game.UI.InGame.DestroyedBuildingSection",e.DestroyedTree="Game.UI.InGame.DestroyedTreeSection",e.Comfort="Game.UI.InGame.ComfortSection"}(Nq||(Nq={})),function(e){e[e.none=0]="none",e[e.low=1]="low",e[e.medium=2]="medium",e[e.high=3]="high"}(Pq||(Pq={})),function(e){e[e.PostFacility=0]="PostFacility",e[e.MailBox=1]="MailBox"}(Cq||(Cq={})),function(e){e.GenericInfo="Game.UI.InGame.GenericInfo",e.CapacityInfo="Game.UI.InGame.CapacityInfo",e.InfoList="Game.UI.InGame.InfoList"}(Aq||(Aq={}));var qq;function $q(e){var t=bs();return(0,i.useMemo)((function(){var n=Zq(t,e);return""!==n?n:null}),[t,e])}function Qq(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=bs(),a=C(Kq);return(0,i.useMemo)((function(){var i=[r?"":Zq(o,e)].concat(wq(t.map((function(t){return Zq(o,e+t)}))),wq(a.filter((function(e){return n.includes(e)})).map((function(t){return Zq(o,e+t)})))).filter((function(e){return""!==e}));return i.length>0?i:null}),[o,a,e,r,n,t])}function Zq(e,t){return Ks.SelectedInfoPanel.TOOLTIP.renderString(e,{hash:t,fallback:""})}!function(e){e.Citizen="Citizen",e.Household="Household",e.Building="Building"}(qq||(qq={}));const Jq={"dropdown-toggle":"dropdown-toggle_ODx dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_ODx dropdown-toggle_prl",indicator:"indicator_JII","dropdown-menu":"dropdown-menu_xq2 dropdown-menu_Swd",dropdownMenu:"dropdown-menu_xq2 dropdown-menu_Swd","dropdown-item":"dropdown-item_R_l undefined",dropdownItem:"dropdown-item_R_l undefined"},e$="info-row_QQ9 item-focused_FuT",t$="disable-focus-highlight_I85",n$="link_ICj",r$="tooltipRow_uIh",i$="left_RyE",o$="hasIcon_iZ3",a$="right_ZUb",l$="icon_ugE",s$="uppercase_f0y",c$="subRow_NJI";var u$=function(t){var n=t.icon,r=t.left,i=t.right,o=t.tooltip,a=t.link,l=t.uppercase,s=void 0!==l&&l,c=t.subRow,u=void 0!==c&&c,d=t.disableFocus,f=void 0!==d&&d,h=t.className;return(0,e.jsx)(xO,{tooltip:o,direction:"right",alignment:"center",children:a?(0,e.jsxs)("div",{className:Oe()(e$,u&&c$,a&&n$,h),children:[n&&(0,e.jsx)("img",{src:n,className:Oe()(l$,a&&n$)}),r&&(0,e.jsx)("div",{className:Oe()(i$,s&&s$,a&&n$,n&&o$),children:r}),a&&(0,e.jsx)(Tr,{className:Oe()(a$,a&&n$),children:a}),i&&(0,e.jsx)("div",{className:Oe()(a$,a&&n$),children:i})]}):f?(0,e.jsxs)(Or,{className:Oe()(e$,u&&c$,t$,h),children:[n&&(0,e.jsx)("img",{src:n,className:l$}),r&&(0,e.jsx)("div",{className:Oe()(i$,s&&s$),children:r}),i&&(0,e.jsx)("div",{className:Oe()(a$),children:i})]}):(0,e.jsxs)(Tr,{focusKey:f?Te:Ie,className:Oe()(e$,u&&c$,h),children:[n&&(0,e.jsx)("img",{src:n,className:l$}),r&&(0,e.jsx)("div",{className:Oe()(i$,s&&s$),children:r}),i&&(0,e.jsx)("div",{className:Oe()(a$),children:i})]})})},d$=function(t){var n=t.icon,r=t.left,i=t.right,o=t.uppercase,a=void 0!==o&&o,l=t.subRow,s=void 0!==l&&l;return(0,e.jsxs)("div",{className:Oe()(e$,r$,s&&c$),children:[n&&(0,e.jsx)("img",{src:n,className:Oe()(l$)}),r&&(0,e.jsx)("div",{className:Oe()(i$,a&&s$,n&&o$),children:r}),i&&(0,e.jsx)("div",{className:Oe()(a$),children:i})]})};const f$="info-section_I7V",h$="content_Cdk item-focused_FuT",m$="divider_rfM",p$="no-margin_K7I",v$="disable-focus-highlight_ik3",g$="info-wrap-box_Rt4";var y$=function(t){var n=t.focusKey,r=t.tooltip,i=t.disableFocus,o=void 0!==i&&i,a=t.className,l=t.children;return(0,e.jsx)("div",{className:Oe()(f$,a),children:(0,e.jsx)(xO,{tooltip:r,direction:"right",alignment:"center",children:o?(0,e.jsx)(Or,{className:Oe()(h$,v$),children:(0,e.jsx)(Fn,{children:l})}):(0,e.jsx)(Tr,{focusKey:n,className:h$,children:(0,e.jsx)(Fn,{children:l})})})})},b$=function(t){var n=t.noMargin,r=void 0!==n&&n;return(0,e.jsx)("div",{className:Oe()(m$,r&&p$)})};const x$={dropdown:"dropdown_zWC",item:"item_Bmu",thumb:"thumb_eC2",label:"label_jXx"};function _$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var j$=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){_$(e,t,n[t])}))}return e}({},hl),{hover:null,focus:null});function E$(e,t){N("SelectVehiclesSection","selectVehicles",e,t)}var O$=function(t){var n=t.vehicle;return(0,e.jsxs)("div",{className:x$.item,children:[(0,e.jsx)("img",{src:n.thumbnail,className:x$.thumb}),(0,e.jsxs)("div",{className:x$.label,children:[(0,e.jsx)(Ks.Assets.NAME,{hash:n.id})," "]})]})};const T$="left_vb1",I$="right_wuq",S$="delete-button_iT6",w$="input_xcv";var N$=function(t){var n=t.localization,r=t.supportedLocales,i=t.onChange,o=t.onAdd,a=t.onRemove;return(0,e.jsxs)(zV,{children:[n.map((function(t,n){return(0,e.jsx)(P$,{index:n,localeId:t.localeId,text:t.text,supportedLocales:r,onChange:i,onRemove:a},n)})),(0,e.jsx)("div",{children:(0,e.jsx)(FV,{children:(0,e.jsx)(GV,{disabled:!1,onSelect:o,children:(0,e.jsx)(Ks.Editor.ADD_TRANSLATION,{})})})})]})},P$=function(t){var n=t.index,r=t.localeId,o=t.text,a=t.supportedLocales,l=t.onChange,s=t.onRemove,c=(0,i.useCallback)((function(e){return l(n,a[e],o)}),[n,a,l,o]),u=(0,i.useCallback)((function(e){return l(n,r,e.target.value||"")}),[n,r,l]),d=(0,i.useCallback)((function(){return s(n)}),[n,s]),f=(0,i.useMemo)((function(){return a.findIndex((function(e){return e===r}))}),[r,a]);return(0,e.jsx)(YV,{className:WV.row,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)("div",{className:T$,children:(0,e.jsx)(fC,{theme:LD,initialFocused:n,content:a.map((function(t,n){return(0,e.jsx)(_C,{focusKey:n,value:n,selected:f===n,onChange:c,children:(0,e.jsx)(ph,{value:Qf(t)})},n)})),children:(0,e.jsx)(gC,{sounds:j$,className:WV.dropdownToggle,children:r})})}),(0,e.jsxs)("div",{className:I$,children:[(0,e.jsx)(Sp,{value:o,className:Oe()(WV.input,w$),onChange:u}),(0,e.jsx)(FX,{className:S$,src:"media/glyphs/trash.svg",selected:!1,disabled:!1,onSelect:d,tinted:!0})]})]})})};const C$="Media/Glyphs/ThickStrokeArrowLeft.svg",A$="page-layout_JSP editor-widget_QQl",L$="header_u77",M$="back-button_rnO",R$="title_zOE";var k$=function(t){var n=t.title,r=t.className,i=t.style,o=t.children,a=t.onBack,l=cr();return(0,e.jsx)(wn,{onAction:a,children:(0,e.jsxs)("div",{className:Oe()(A$,r),style:i,children:[(0,e.jsxs)("div",{className:L$,children:[!l&&null!=a&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Common.GO_BACK_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:C$,className:M$,onSelect:a})}),(0,e.jsx)("div",{className:R$,children:n})]}),o]})})},D$=n(233),U$=n.n(D$);function F$(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function G$(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return F$(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return F$(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function V$(e,t,n,r){var o=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=(0,i.useRef)(t),o=(0,i.useMemo)((function(){return(new(U$().SpringSystem)).createSpring().setCurrentValue(r.current).setAtRest()}),[]),a=Mr(e);return(0,i.useEffect)((function(){o.setSpringConfig(a)}),[o,a]),(0,i.useEffect)((function(){o.setOvershootClampingEnabled(n)}),[o,n]),o}(e,null!=n?n:t,r);return(0,i.useEffect)((function(){o.setEndValue(t)}),[o,t]),function(e){var t=G$((0,i.useState)(e.getCurrentValue()),2),n=t[0],r=t[1];return(0,i.useEffect)((function(){var t={onSpringUpdate:function(e){r(e.getCurrentValue())}};return e.addListener(t),function(){e.removeListener(t)}}),[e]),n}(o)}const B$="page-view_PUO editor-widget_QQl",H$="page_hHC",K$="active_xN8";var W$={tension:150,friction:15},z$=function(t){var n=t.currentPage,r=t.pages,i=t.className,o=t.style,a=V$(W$,n,void 0,!0);return(0,e.jsx)("div",{className:Oe()(B$,i),style:o,children:(0,e.jsx)(Ze,{focused:n,children:r.map((function(t,r){return(0,e.jsx)("div",{className:Oe()(H$,r===n&&K$),style:{"--offset":r-a},children:(0,e.jsx)(Fn,{focusKey:r,children:t})},r)}))})})};const Y$="scrollable_VJQ editor-widget_QQl";var X$=function(t){var n=t.className,r=t.style,i=t.children;return(0,e.jsx)(mf,{trackVisibility:"scrollable",className:Oe()(Y$,n),style:r,children:(0,e.jsx)(Fn,{children:i})})};const q$={popupMinHeight:"300rem","search-field":"search-field_jRt editor-widget_QQl",searchField:"search-field_jRt editor-widget_QQl",input:"input_UVn",actions:"actions_qt8",action:"action_Qra",popup:"popup_OTO",item:"item_NeK",value:"value_Mug","favorite-action":"favorite-action_s2e",favoriteAction:"favorite-action_s2e","favorite-icon":"favorite-icon_JvS",favoriteIcon:"favorite-icon_JvS"};function $$(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Q$(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return $$(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $$(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Z$=function(t){var n=t.value,r=t.valueIsFavorite,o=t.suggestions,a=t.onChange,l=t.onChangeFavorite,s=cr(),c=(0,i.useRef)(null),u=Q$((0,i.useState)(!1),2),d=u[0],f=u[1],h=(0,i.useCallback)((function(e){return a(e.target.value||"")}),[a]),m=(0,i.useCallback)((function(){return f(!0)}),[]),p=(0,i.useCallback)((function(){return f(!1)}),[]),v=(0,i.useMemo)((function(){return null!=l?function(){return l(n,!r)}:null}),[r,n,l]),g=(0,i.useCallback)((function(){return a("")}),[a]),y=(0,i.useCallback)((function(e){var t;a(e),null===(t=c.current)||void 0===t||t.blur()}),[a]),b=Xd(q$.popupMinHeight),x=(0,e.jsx)(mf,{className:q$.scrollable,children:o.map((function(t,n){return(0,e.jsx)(J$,{value:t.value,favorite:t.favorite,onSelect:y,onChangeFavorite:l},n)}))});return(0,e.jsx)(eC,{visible:!s&&d&&o.length>0,direction:"down",minHeight:b,className:q$.popup,content:x,minWidth:!0,children:(0,e.jsx)(Wn,{children:(0,e.jsxs)("div",{className:q$.searchField,children:[(0,e.jsx)(Sp,{ref:c,value:n,placeholder:(0,e.jsx)(Ks.Editor.SEARCH_PLACEHOLDER,{}),className:q$.input,onChange:h,onFocus:m,onBlur:p}),!s&&n&&(0,e.jsxs)("div",{className:q$.actions,children:[(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Common.CLEAR_SEARCH_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/Clear.svg",className:q$.action,onSelect:g,onMouseDown:d?eQ:void 0})}),null!=v&&(0,e.jsx)(xO,{tooltip:r?(0,e.jsx)(Ks.Editor.REMOVE_FAVORITE,{}):(0,e.jsx)(Ks.Editor.ADD_FAVORITE,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:r?"Media/Glyphs/StarFilled.svg":"Media/Glyphs/StarOutline.svg",className:q$.action,onSelect:v,onMouseDown:d?eQ:void 0})})]})]})})})},J$=function(t){var n=t.value,r=t.favorite,o=t.onSelect,a=t.onChangeFavorite,l=xh(o,n),s=(0,i.useMemo)((function(){return null!=a?function(){return a(n,!r)}:null}),[r,n,a]);return(0,e.jsxs)("div",{className:q$.item,children:[(0,e.jsx)("div",{className:q$.value,onMouseDown:eQ,onClick:l,children:n}),null!=s&&(0,e.jsx)("div",{className:q$.favoriteAction,onMouseDown:eQ,onClick:s,children:(0,e.jsx)(ll,{src:r?"Media/Glyphs/StarFilled.svg":"Media/Glyphs/StarOutline.svg",className:q$.favoriteIcon})})]})};function eQ(e){e.preventDefault()}var tQ=function(t){var n=t.value,r=t.onChange,o=cr(),a=(0,i.useRef)(null),l=(0,i.useCallback)((function(e){return r(e.target.value||"")}),[r]),s=(0,i.useCallback)((function(){return r("")}),[r]);return(0,e.jsxs)("div",{className:q$.searchField,children:[(0,e.jsx)(Sp,{ref:a,value:n,placeholder:(0,e.jsx)(Ks.Editor.SEARCH_PLACEHOLDER,{}),className:q$.input,onChange:l}),!o&&n&&(0,e.jsx)("div",{className:q$.actions,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Common.CLEAR_SEARCH_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/Clear.svg",className:q$.action,onSelect:s,onMouseDown:nQ})})})]})};function nQ(e){e.preventDefault()}var rQ=ym({h:.66,s:.75,v:.7,a:1}),iQ=ym({h:.58,s:.7,v:.7,a:1}),oQ=ym({h:.3,s:.6,v:.7,a:1}),aQ=ym({h:0,s:.7,v:.7,a:1}),lQ=-40,sQ=40;var cQ=_m({stops:[{color:pm(rQ),offset:0},{color:pm(iQ),offset:.33},{color:pm(oQ),offset:.67},{color:pm(aQ),offset:1}]});const uQ="season-wheel_qNt",dQ="canvas_PkU",fQ="thumb_tno",hQ="month-label_bLZ",mQ="legend_drE",pQ="gradient_xVL",vQ="labels_F5a";function gQ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yQ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function bQ(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){yQ(e,t,n[t])}))}return e}function xQ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function _Q(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function jQ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||OQ(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function EQ(e){return function(e){if(Array.isArray(e))return gQ(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||OQ(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function OQ(e,t){if(e){if("string"==typeof e)return gQ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?gQ(e,t):void 0}}var TQ,IQ=.02;!function(e){e[e.rangeStart=0]="rangeStart",e[e.rangeEnd=1]="rangeEnd"}(TQ||(TQ={}));var SQ=i.memo((function(t){var n=t.size,r=t.seasons,o=t.selectedSeason,a=t.className,s=t.onSelect,u=t.onSeasonStartTimeOfYearChange,d=(0,i.useRef)(null),f=qd(),h=Math.floor(n),m=h/2-20*f,p=.9*m,v=.8*m,g=v,y=.6*m,b=.5*m,x=jQ((0,i.useState)(ii),2),_=x[0],j=x[1],E=jQ((0,i.useState)(!1),2),O=E[0],T=E[1],I=(0,i.useRef)(null);(0,i.useEffect)((function(){if(d.current){var e,t,n,i,a=d.current.getContext("2d"),l=2*f;a.clearRect(0,0,h,h),a.save(),a.translate(h/2,h/2),a.rotate(-.5*Math.PI),a.beginPath();for(var s=0;s<12;s++){var u=2*Math.PI*s/12;a.moveTo(b*Math.cos(u),b*Math.sin(u)),a.lineTo(g*Math.cos(u),g*Math.sin(u))}a.strokeStyle="rgba(255, 255, 255, 0.4)",a.lineWidth=2*f,a.stroke();for(var p=0;p<r.length;p++){var y=r[p],x=r[(p+1)%r.length],j=y.startTimeOfYear.max,E=y.startTimeOfYear.min,T=y===x?1:0,I=x.startTimeOfYear.max+T,S=x.startTimeOfYear.min+T;if(a.beginPath(),a.arc(0,0,m,2*Math.PI*E+l/m,2*Math.PI*S-l/m,!1),!CQ(S,I))for(var w=S,N=S+(I-S+1)%1,P=0;P<2;P++){var C=lt(m,v,(P+1)/3)-l,A=lt(w,N,P/2),L=lt(w,N,(P+1)/2);a.arc(0,0,C,2*Math.PI*A-l/C,2*Math.PI*L-l/C,!1)}if(a.arc(0,0,v,2*Math.PI*I-l/v,2*Math.PI*j+l/v,!0),!CQ(j,E))for(var M=j,R=j+(E-j-1)%1,k=0;k<2;k++){var D=lt(v,m,(k+1)/3)+l,U=lt(M,R,k/2),F=lt(M,R,(k+1)/2);a.arc(0,0,D,2*Math.PI*U+l/D,2*Math.PI*F+l/D,!0)}a.closePath();var G=.5;c(y.entity,o)?G=1:c(y.entity,_)&&!O&&(G=.6),a.fillStyle=pm(mm((e=y.temperature,t=void 0,n=void 0,i=void 0,(i=(n=sQ)-(t=lQ)>0?3*(at(e,t,n)-t)/(n-t):1.5)<=1?xm(rQ,iQ,i):i<=2?xm(iQ,oQ,i-1):xm(oQ,aQ,i-2)),G)),a.fill(),c(y.entity,o)&&(a.strokeStyle="rgb(255, 255, 255)",a.lineWidth=2*f,a.stroke())}a.restore()}}),[O,h,_,v,b,g,m,f,r,o]);var S=(0,i.useCallback)((function(e,t,n){if(d.current){var i=r.findIndex((function(t){return c(t.entity,e)}));if(-1!==i){var o=function(e,t){return t===TQ.rangeStart?e.startTimeOfYear.min:e.startTimeOfYear.max}(r[i],t),a=wQ(d.current,n.clientX,n.clientY)-o;I.current={seasonEntity:e,type:t,angleOffset:a},function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),n.preventDefault(),T(!0),Jt(Qt.grabSlider)}}}),[r]),w=(0,i.useCallback)((function(e){if(I.current&&d.current){e.preventDefault();var t=(wQ(d.current,e.clientX,e.clientY)+I.current.angleOffset+1)%1,n=I.current.seasonEntity,i=r.findIndex((function(e){return c(e.entity,n)}));if(-1!==i){var o=r[i],a=function(e,t,n,r){var i=e[t],o=e[(t+e.length-1)%e.length],a=e[(t+1)%e.length];if(n===TQ.rangeStart)return{min:NQ(r,(o.startTimeOfYear.max+IQ+1)%1,i.startTimeOfYear.max),max:i.startTimeOfYear.max};var l=i.startTimeOfYear.min,s=(a.startTimeOfYear.min-IQ+1)%1;return{min:i.startTimeOfYear.min,max:NQ(r,l,s)}}(r,i,I.current.type,t);yt(a,o.startTimeOfYear)||(Jt(Qt.dragSlider),u(n,a))}}}),[u,r]),N=(0,i.useCallback)((function(e){e.preventDefault(),T(!1)}),[]);(0,i.useEffect)((function(){if(O)return document.addEventListener("mousemove",w),document.addEventListener("mouseup",N),function(){document.removeEventListener("mousemove",w),document.removeEventListener("mouseup",N)}}),[O,w,N]);var P=(0,i.useCallback)((function(e){if(null!=d.current){var t=d.current.getBoundingClientRect(),n=t.left,i=t.top,o=t.width,a=t.height,l=e.clientX-n-o/2,s=e.clientY-i-a/2,c=Math.sqrt(l*l+s*s),u=wQ(d.current,e.clientX,e.clientY),f=ii;if(c>p&&c<m){for(var h=0;h<r.length;h++)if(PQ(u,r[h].startTimeOfYear.min,r[(h+1)%r.length].startTimeOfYear.min)){f=r[h].entity;break}}else if(c>v&&c<=p)for(var g=0;g<r.length;g++)if(PQ(u,r[g].startTimeOfYear.max,r[(g+1)%r.length].startTimeOfYear.max)){f=r[g].entity;break}j(f)}}),[v,p,m,r]),C=(0,i.useCallback)((function(){return j(ii)}),[]),A=(0,i.useCallback)((function(){c(_,ii)||s(_)}),[_,s]),L={top:h/2,left:h/2};return(0,e.jsxs)("div",{style:{width:h,height:h},className:Oe()(uQ,a),children:[(0,e.jsx)("canvas",{ref:d,width:h,height:h,className:dQ,onMouseMove:P,onMouseLeave:C,onMouseDown:A}),r.map((function(t){return(0,e.jsxs)(i.Fragment,{children:[(0,e.jsx)(AQ,{seasonEntity:t.entity,type:TQ.rangeStart,angle:t.startTimeOfYear.min,radius:m,style:L,onMouseDown:S}),(0,e.jsx)(AQ,{seasonEntity:t.entity,type:TQ.rangeEnd,angle:t.startTimeOfYear.max,radius:v,style:L,onMouseDown:S})]},l(t.entity))})),EQ(Array(12).keys()).map((function(t){return(0,e.jsx)(LQ,{monthIndex:t,radius:y,style:L},t)}))]})}),(function(e,t){var n=e.seasons,r=_Q(e,["seasons"]),i=t.seasons;return f(r,_Q(t,["seasons"]),2)&&function(e,t){if(e.length!==t.length)return!1;for(var n=0;n<e.length;n++){if(!yt(e[n].startTimeOfYear,t[n].startTimeOfYear))return!1;if(e[n].temperature!==t[n].temperature)return!1}return!0}(n,i)}));function wQ(e,t,n){var r=e.getBoundingClientRect(),i=r.left,o=r.top,a=t-i-r.width/2,l=n-o-r.height/2;return at(Math.atan2(-a,l)/(2*Math.PI)+.5,0,1)}function NQ(e,t,n){return PQ(e,t,n)?e:(t-e+1)%1<(e-n+1)%1?t:n}function PQ(e,t,n){if(CQ(t,n))return!1;if(t<n){if(e>=t&&e<n)return!0}else if(e>=t||e<n)return!0;return!1}function CQ(e,t){var n=Math.abs(e-t)%1;return n<1e-4||n>.9999}var AQ=function(t){var n=t.seasonEntity,r=t.type,o=t.angle,a=t.radius,l=t.style,s=t.onMouseDown,c=(0,i.useCallback)((function(e){return s(n,r,e)}),[s,n,r]),u=a*Math.sin(2*o*Math.PI),d=-a*Math.cos(2*o*Math.PI),f=360*o-(r===TQ.rangeEnd?180:0);return(0,e.jsx)(ll,{src:"Media/Editor/SeasonThumb.svg",className:fQ,style:xQ(bQ({},l),{transform:"translate(-50%, -100%) translate(".concat(u.toFixed(2),"px, ").concat(d.toFixed(2),"px) rotate(").concat(f.toFixed(2),"deg)")}),onMouseDown:c})},LQ=function(t){var n=t.monthIndex,r=t.radius,i=t.style,o=(n+.5)/12,a=r*Math.sin(2*o*Math.PI),l=-r*Math.cos(2*o*Math.PI);return(0,e.jsx)("div",{className:hQ,style:xQ(bQ({},i),{transform:"translate(-50%, -50%) translate(".concat(a.toFixed(2),"px, ").concat(l.toFixed(2),"px)")}),children:zs(n+1,2)})},MQ=function(t){var n=t.width;return(0,e.jsxs)("div",{className:mQ,style:{width:"".concat(n,"rem")},children:[(0,e.jsx)("div",{className:pQ,style:{backgroundImage:cQ}}),(0,e.jsxs)("div",{className:vQ,children:[(0,e.jsx)("div",{children:(0,e.jsx)(dc,{value:lQ,unit:tc.Temperature,signed:!0})}),(0,e.jsx)("div",{children:(0,e.jsx)(dc,{value:0,unit:tc.Temperature})}),(0,e.jsx)("div",{children:(0,e.jsx)(dc,{value:sQ,unit:tc.Temperature,signed:!0})})]})]})};const RQ={toggle:"toggle_GUy",checkmark:"checkmark_Bc3"},kQ={"editor-section":"editor-section_zoX",editorSection:"editor-section_zoX",header:"header_MLk",primary:"primary_j00",toggle:"toggle_XlP",action:"action_T_m",icon:"icon_v5n",label:"label_OqN","action-checkbox":"action-checkbox_Z8G",actionCheckbox:"action-checkbox_Z8G",content:"content_yUv"};var DQ=function(t){var n=t.title,r=t.active,o=void 0===r||r,a=t.primary,l=t.headerColor,s=t.expanded,c=t.className,u=t.children,d=t.onDelete,f=t.onActiveChange,h=t.onExpandedChange,m=(0,i.useCallback)((function(){null!=h&&h(!s)}),[s,h]),p=(0,i.useCallback)((function(){null!=f&&f(!o)}),[o,f]);return(0,e.jsxs)("div",{className:Oe()(kQ.editorSection,a&&kQ.primary,c),children:[(0,e.jsx)("div",{className:kQ.header,style:{backgroundColor:l},children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[null!=h?(0,e.jsx)(CN,{src:s?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg",theme:kQ,className:kQ.toggle,onSelect:m,children:n}):(0,e.jsx)(CN,{src:"Media/Glyphs/Circle.svg",theme:kQ,className:kQ.toggle,disabled:!0,children:n}),d&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Common.DELETE_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Trash.svg",className:kQ.action,onSelect:d})}),f&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Editor.ACTIVE_TOOLTIP,{}),children:(0,e.jsx)(ml,{className:kQ.action,onSelect:p,children:(0,e.jsx)(pp,{focusKey:Te,checked:o,theme:RQ,className:kQ.actionCheckbox,onChange:f})})})]})}),null!=h&&s&&(0,e.jsx)("div",{className:kQ.content,children:u})]})};const UQ="chart_SQk";function FQ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function GQ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var VQ,BQ=function(t){var n=t.parent,r=t.data;return(0,e.jsx)(Yh,{parent:n,components:HQ,data:r})},HQ=(FQ(VQ={},hh.Column,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=VV(o.flex),c=(0,i.useContext)(Xh);return(0,e.jsx)(KV,{style:s,children:(0,e.jsx)(Yh,{parent:l,components:c,data:a})})})),FQ(VQ,hh.Scrollable,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=VV(o.flex),c=(0,i.useContext)(Xh);return(0,e.jsx)(X$,{style:s,children:(0,e.jsx)(Yh,{parent:l,components:c,data:a})})})),FQ(VQ,hh.PageView,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=VV(o.flex),c=(0,i.useContext)(Xh),u=(0,i.useMemo)((function(){return a.map((function(t){return(0,e.jsx)(zh,{parent:l,components:c,data:t},t.path)}))}),[a,l,c]);return(0,e.jsx)(z$,{currentPage:o.currentPage,pages:u,style:s})})),FQ(VQ,hh.PageLayout,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=VV(o.flex),c=(0,i.useContext)(Xh),u=xh(Th,l);return(0,e.jsx)(k$,{title:(0,e.jsx)(ph,{value:o.title}),style:s,onBack:o.hasBackAction?u:void 0,children:(0,e.jsx)(Yh,{parent:l,components:c,data:a})})})),FQ(VQ,sM.ItemPicker,(function(t){var n=t.parent,r=t.path,o=t.props,a=Mh(n,r),l=(0,i.useMemo)((function(){return{length:o.length,get:function(e){var t=e-o.visibleStartIndex;return t>=0&&t<o.visibleItems.length?o.visibleItems[t]:null}}}),[o.length,o.visibleItems,o.visibleStartIndex]),s=(0,i.useCallback)((function(e,t){var n=e-e%64,r=Math.min(t-t%64+64,o.length);!function(e,t,n){N(e.group,"setVisibleItemRange",e.path,t,n)}(a,n,r)}),[a,o.length]),c=xh(_M,a),u=(0,i.useCallback)((function(e,t){!function(e,t,n){N(e.group,"setItemFavorite",e.path,t,n)}(a,e,t),e===o.selectedIndex&&d.current&&d.current.scrollToSelected()}),[a,o.selectedIndex]),d=(0,i.useRef)(null),f=(0,i.useContext)(JP);(0,i.useLayoutEffect)((function(){f&&d.current&&d.current.scrollToSelected()}),[o.columnCount,o.length,f]);var h=VV(o.flex);return(0,e.jsx)(fq,{ref:d,selectedIndex:o.selectedIndex,columnCount:o.columnCount,hasImages:o.hasImages,data:l,style:h,onRenderedRangeChange:s,onSelect:c,onToggleFavorite:o.hasFavorites?u:void 0})})),FQ(VQ,sM.ItemPickerFooter,(function(t){var n=t.parent,r=t.path,i=t.props,o=xh(Ih,Mh(n,r));return(0,e.jsx)(gq,{length:i.length,columnCount:i.columnCount,onColumnCountChange:o})})),FQ(VQ,sM.SearchField,(function(t){var n=t.parent,r=t.path,i=t.props,o=xh(Ih,Mh(n,r));return(0,e.jsx)(tQ,{value:i.value,onChange:o})})),FQ(VQ,sM.PopupSearchField,(function(t){var n=t.parent,r=t.path,i=t.props,o=Mh(n,r),a=xh(Ih,o),l=xh(jM,o);return(0,e.jsx)(Z$,{value:i.value,valueIsFavorite:i.valueIsFavorite,suggestions:i.suggestions,onChange:a,onChangeFavorite:i.hasFavorites?l:void 0})})),FQ(VQ,hh.Divider,(function(){return(0,e.jsx)("div",{className:tB})})),FQ(VQ,hh.Button,(function(t){return(0,e.jsx)(FV,{children:(0,e.jsx)(UV,kV({},t))})})),FQ(VQ,hh.ButtonRow,(function(t){var n=t.parent,r=t.path,i=t.children,o=Mh(n,r);return(0,e.jsx)(FV,{children:i.map((function(t){var n=t.path,r=DV(t,["path"]);return(0,e.jsx)(UV,kV({parent:o,path:n},r),n)}))})})),FQ(VQ,hh.IconButton,(function(t){return(0,e.jsx)(UX,{children:(0,e.jsx)(DX,RX({},t))})})),FQ(VQ,hh.IconButtonGroup,(function(t){var n=t.parent,r=t.path,i=t.children,o=Mh(n,r);return(0,e.jsx)(UX,{children:i.map((function(t){var n=t.path,r=kX(t,["path"]);return(0,e.jsx)(DX,RX({parent:o,path:n},r),n)}))})})),FQ(VQ,hh.Group,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=(0,i.useContext)(Xh);return(0,e.jsx)(qz,{label:(0,e.jsx)(ph,{value:o.displayName}),children:(0,e.jsx)(Yh,{parent:l,components:s,data:a})})})),FQ(VQ,hh.ExpandableGroup,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=(0,i.useContext)(Xh),c=xh(Sh,l);return(0,e.jsx)($z,{label:(0,e.jsx)(ph,{value:o.displayName}),expanded:o.expanded,onExpandedChange:c,children:(0,e.jsx)(Yh,{parent:l,components:s,data:a})})})),FQ(VQ,hh.PagedList,(function(t){var n=t.parent,r=t.path,i=t.props,o=t.children,a=Mh(n,r),l=xh(Nh,a),s=xh(Ch,a),c=xh(Sh,a),u=xh(Ah,a);return(0,e.jsx)(Tq,{expanded:i.expanded,label:(0,e.jsx)(ph,{value:i.displayName}),length:i.length,currentPageIndex:i.currentPageIndex,pageCount:i.pageCount,onAddItem:l,onClear:s,onExpandedChange:c,onCurrentPageChange:u,children:o.map((function(t,n){return t.props.__Type===hh.ExpandableGroup?(0,e.jsx)(Eq,{parent:a,index:i.childStartIndex+n,length:i.length,resizable:i.resizable,sortable:i.sortable,data:t},i.childStartIndex+n):(0,e.jsx)(jq,{parent:a,index:i.childStartIndex+n,length:i.length,resizable:i.resizable,sortable:i.sortable,data:t},i.childStartIndex+n)}))})})),FQ(VQ,hh.ValueField,(function(t){var n=t.props;return(0,e.jsx)(YV,{children:(0,e.jsxs)("div",{style:{color:"red",whiteSpace:"pre",fontSize:"12px"},children:[(0,e.jsx)(ph,{value:n.displayName}),n.value]})})})),FQ(VQ,hh.ToggleField,KQ(OX)),FQ(VQ,hh.IntInputField,KQ(mX)),FQ(VQ,hh.IntSliderField,KQ(RY)),FQ(VQ,hh.UIntInputField,KQ((function(t){var n=t.min,r=void 0===n?0:n,i=t.max,o=void 0===i?4294967295:i,a=hX(t,["min","max"]);return(0,e.jsx)(mX,fX(dX({},a),{min:r,max:o}))}))),FQ(VQ,hh.UIntSliderField,KQ(RY)),FQ(VQ,hh.TimeBoundsSliderField,KQ((function(t){var n=t.label,r=t.value,o=t.min,a=t.max,l=t.allowMinGreaterMax,s=t.disabled,c=t.onChange,u=t.onChangeStart,d=t.onChangeEnd,f=(0,i.useCallback)((function(e){return c(XY(YY({},r),{min:l?e:Math.min(e,r.max)}))}),[l,c,r]),h=(0,i.useCallback)((function(e){return c(XY(YY({},r),{max:l?e:Math.max(e,r.min)}))}),[l,c,r]);return(0,e.jsxs)(qz,{label:n,children:[(0,e.jsx)(KY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Min"}),value:r.min,min:o,max:a,disabled:s,onChange:f,onChangeStart:u,onChangeEnd:d}),(0,e.jsx)(KY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Max"}),value:r.max,min:o,max:a,disabled:s,onChange:h,onChangeStart:u,onChangeEnd:d})]})}))),FQ(VQ,hh.Int2InputField,KQ((function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(fX(dX({},r),{x:e}))}),[r,a]),u=(0,i.useCallback)((function(e){return a(fX(dX({},r),{y:e}))}),[r,a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:o,className:WV.label,dragTransformation:yX,onChange:a,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(pX,{label:"X",value:r.x,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(pX,{label:"Y",value:r.y,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s})]})})]})})}))),FQ(VQ,hh.Int3InputField,KQ((function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(fX(dX({},r),{x:e}))}),[r,a]),u=(0,i.useCallback)((function(e){return a(fX(dX({},r),{y:e}))}),[r,a]),d=(0,i.useCallback)((function(e){return a(fX(dX({},r),{z:e}))}),[r,a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:o,className:WV.label,dragTransformation:bX,onChange:a,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(pX,{label:"X",value:r.x,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(pX,{label:"Y",value:r.y,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(pX,{label:"Z",value:r.z,disabled:o,onChange:d,onChangeStart:l,onChangeEnd:s})]})})]})})}))),FQ(VQ,hh.Int4InputField,KQ((function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(fX(dX({},r),{x:e}))}),[r,a]),u=(0,i.useCallback)((function(e){return a(fX(dX({},r),{y:e}))}),[r,a]),d=(0,i.useCallback)((function(e){return a(fX(dX({},r),{z:e}))}),[r,a]),f=(0,i.useCallback)((function(e){return a(fX(dX({},r),{w:e}))}),[r,a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:o,className:WV.label,dragTransformation:xX,onChange:a,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(pX,{label:"X",value:r.x,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(pX,{label:"Y",value:r.y,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(pX,{label:"Z",value:r.z,disabled:o,onChange:d,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(pX,{label:"W",value:r.w,disabled:o,onChange:f,onChangeStart:l,onChangeEnd:s})]})})]})})}))),FQ(VQ,hh.FloatInputField,KQ(sY)),FQ(VQ,hh.FloatSliderField,KQ(kY)),FQ(VQ,hh.TimeSliderField,KQ(KY)),FQ(VQ,hh.Float2InputField,KQ(cY)),FQ(VQ,hh.Float3InputField,KQ(uY)),FQ(VQ,hh.EulerAnglesField,KQ(uY)),FQ(VQ,hh.Float4InputField,KQ((function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(lY(aY({},r),{x:e}))}),[r,a]),u=(0,i.useCallback)((function(e){return a(lY(aY({},r),{y:e}))}),[r,a]),d=(0,i.useCallback)((function(e){return a(lY(aY({},r),{z:e}))}),[r,a]),f=(0,i.useCallback)((function(e){return a(lY(aY({},r),{w:e}))}),[r,a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)(iY,{value:r,disabled:o,className:WV.label,dragTransformation:vY,onChange:a,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(dY,{label:"X",value:r.x,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(dY,{label:"Y",value:r.y,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(dY,{label:"Z",value:r.z,disabled:o,onChange:d,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(dY,{label:"W",value:r.z,disabled:o,onChange:f,onChangeStart:l,onChangeEnd:s})]})})]})})}))),FQ(VQ,hh.StringInputField,KQ((function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(e.target.value||"")}),[a]);return(0,e.jsx)(YV,{disabled:o,children:(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(Sp,{value:r,disabled:o,className:WV.input,onChange:c,onFocus:l,onBlur:s})})]})})}))),FQ(VQ,hh.Bounds1SliderField,KQ((function(t){var n=t.label,r=t.value,o=t.min,a=t.max,l=t.fractionDigits,s=void 0===l?3:l,c=t.allowMinGreaterMax,u=t.disabled,d=t.onChange,f=t.onChangeStart,h=t.onChangeEnd,m=(0,i.useCallback)((function(e){return d(XY(YY({},r),{min:c?e:Math.min(e,r.max)}))}),[d,c,r]),p=(0,i.useCallback)((function(e){return d(XY(YY({},r),{max:c?e:Math.max(e,r.min)}))}),[d,c,r]);return(0,e.jsxs)(qz,{label:n,children:[(0,e.jsx)(kY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Min"}),value:r.min,min:o,max:a,fractionDigits:s,disabled:u,onChange:m,onChangeStart:f,onChangeEnd:h}),(0,e.jsx)(kY,{label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Max"}),value:r.max,min:o,max:a,fractionDigits:s,disabled:u,onChange:p,onChangeStart:f,onChangeEnd:h})]})}))),FQ(VQ,hh.Bounds1InputField,KQ((function(t){var n=t.label,r=t.value,o=t.allowMinGreaterMax,a=t.disabled,l=t.onChange,s=t.onChangeStart,c=t.onChangeEnd,u=(0,i.useCallback)((function(e){return l(XY(YY({},r),{min:o?e:Math.min(e,r.max)}))}),[l,o,r]),d=(0,i.useCallback)((function(e){return l(XY(YY({},r),{max:o?e:Math.max(e,r.min)}))}),[l,o,r]);return(0,e.jsxs)(qz,{label:n,children:[(0,e.jsx)(sY,{disabled:a,label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Min"}),value:r.min,onChange:u,onChangeStart:s,onChangeEnd:c}),(0,e.jsx)(sY,{disabled:a,label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Max"}),value:r.max,onChange:d,onChangeStart:s,onChangeEnd:c})]})}))),FQ(VQ,hh.Bounds2InputField,KQ((function(t){var n=t.label,r=t.value,o=t.allowMinGreaterMax,a=t.disabled,l=t.onChange,s=t.onChangeStart,c=t.onChangeEnd,u=(0,i.useCallback)((function(e){l(XY(YY({},r),{min:{x:o?e.x:Math.min(e.x,r.max.x),y:o?e.y:Math.min(e.y,r.max.y)}}))}),[l,o,r]),d=(0,i.useCallback)((function(e){l(XY(YY({},r),{max:{x:o?e.x:Math.max(e.x,r.min.x),y:o?e.y:Math.max(e.y,r.min.y)}}))}),[l,o,r]);return(0,e.jsxs)(qz,{label:n,children:[(0,e.jsx)(cY,{disabled:a,label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Min"}),value:r.min,onChange:u,onChangeStart:s,onChangeEnd:c}),(0,e.jsx)(cY,{disabled:a,label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Max"}),value:r.max,onChange:d,onChangeStart:s,onChangeEnd:c})]})}))),FQ(VQ,hh.Bounds3InputField,KQ((function(t){var n=t.label,r=t.value,o=t.allowMinGreaterMax,a=t.disabled,l=t.onChange,s=t.onChangeStart,c=t.onChangeEnd,u=(0,i.useCallback)((function(e){l(XY(YY({},r),{min:{x:o?e.x:Math.min(e.x,r.max.x),y:o?e.y:Math.min(e.y,r.max.y),z:o?e.z:Math.min(e.z,r.max.z)}}))}),[l,o,r]),d=(0,i.useCallback)((function(e){l(XY(YY({},r),{max:{x:o?e.x:Math.max(e.x,r.min.x),y:o?e.y:Math.max(e.y,r.min.y),z:o?e.z:Math.max(e.z,r.min.z)}}))}),[l,o,r]);return(0,e.jsxs)(qz,{label:n,children:[(0,e.jsx)(uY,{disabled:a,label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Min"}),value:r.min,onChange:u,onChangeStart:s,onChangeEnd:c}),(0,e.jsx)(uY,{disabled:a,label:(0,e.jsx)(Ks.Editor.WIDGETS,{hash:"Max"}),value:r.max,onChange:d,onChangeStart:s,onChangeEnd:c})]})}))),FQ(VQ,hh.ColorField,KQ((function(t){var n=t.label,r=t.value,o=t.showAlpha,a=t.disabled,l=t.onChange,s=ZY((0,i.useState)(!1),2),c=s[0],u=s[1],d=(0,i.useCallback)((function(){return u((function(e){return!e}))}),[]);(0,i.useEffect)((function(){a&&u(!1)}),[a]);var f=ZY((0,i.useState)(0),2),h=f[0],m=f[1],p=(0,i.useCallback)((function(e){m(e.h),l(ym(e))}),[l]),v=(0,i.useMemo)((function(){return function(e,t){var n=bm(e,t);if(0===n.h&&t>.99)return QY(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){$Y(e,t,n[t])}))}return e}({},n),{h:1});return n}(r,h)}),[h,r]);return(0,e.jsx)(YV,{disabled:a,children:(0,e.jsxs)(Ze,{focused:c?eX:JY,children:[(0,e.jsxs)("div",{className:WV.row,children:[(0,e.jsx)("div",{className:WV.label,children:n}),(0,e.jsx)("div",{className:WV.control,children:(0,e.jsx)(ml,{focusKey:JY,className:Oe()(WV.swatch,r.a<1&&WV.alpha),onSelect:a?void 0:d,children:(0,e.jsx)("div",{style:{backgroundColor:pm(r)}})})})]}),c&&(0,e.jsx)("div",{className:WV.colorPickerContainer,children:(0,e.jsx)(cF,{focusKey:eX,color:v,alpha:o,onChange:p})})]})})}))),FQ(VQ,hh.Bezier4x3Field,KQ((function(t){var n=t.label,r=t.value,o=t.disabled,a=t.onChange,l=t.onChangeStart,s=t.onChangeEnd,c=(0,i.useCallback)((function(e){return a(LY(AY({},r),{a:e}))}),[a,r]),u=(0,i.useCallback)((function(e){return a(LY(AY({},r),{b:e}))}),[a,r]),d=(0,i.useCallback)((function(e){return a(LY(AY({},r),{c:e}))}),[a,r]),f=(0,i.useCallback)((function(e){return a(LY(AY({},r),{d:e}))}),[a,r]);return(0,e.jsxs)(qz,{label:n,children:[(0,e.jsx)(uY,{label:"A",value:r.a,disabled:o,onChange:c,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(uY,{label:"B",value:r.b,disabled:o,onChange:u,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(uY,{label:"C",value:r.c,disabled:o,onChange:d,onChangeStart:l,onChangeEnd:s}),(0,e.jsx)(uY,{label:"D",value:r.d,disabled:o,onChange:f,onChangeStart:l,onChangeEnd:s})]})}))),FQ(VQ,hh.EnumField,(function(t){var n=t.parent,r=t.path,o=t.props,a=Mh(n,r),l=(0,i.useMemo)((function(){return o.enumMembers.map(Oh)}),[o.enumMembers]),s=(0,i.useCallback)((function(e){return Ih(a,Et(e))}),[a]);return(0,e.jsx)(aX,{label:(0,e.jsx)(ph,{value:o.displayName}),value:jt(o.value),enumMembers:l,disabled:o.disabled,onChange:s})})),FQ(VQ,hh.FlagsField,(function(t){var n=t.parent,r=t.path,o=t.props,a=Mh(n,r),l=(0,i.useMemo)((function(){return o.enumMembers.map(Oh)}),[o.enumMembers]),s=(0,i.useCallback)((function(e){return Ih(a,Et(e))}),[a]);return(0,e.jsx)(lX,{label:(0,e.jsx)(ph,{value:o.displayName}),value:jt(o.value),enumMembers:l,disabled:o.disabled,onChange:s})})),FQ(VQ,hh.AnimationCurveField,(function(t){var n=PY(t);return(0,e.jsx)(SY,NY(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){wY(e,t,n[t])}))}return e}({},t.props,n),{smoothenOnMove:!1,label:(0,e.jsx)(ph,{value:t.props.displayName})}))})),FQ(VQ,hh.PopupValueField,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=(0,i.useContext)(Xh),c=xh(Sh,l);return(0,e.jsx)(EX,{label:(0,e.jsx)(ph,{value:o.displayName}),value:(0,e.jsx)(ph,{value:o.displayValue}),expanded:o.expanded,disabled:o.disabled,onExpandedChange:c,children:(0,e.jsx)(Yh,{parent:l,components:s,data:a})})})),FQ(VQ,hh.DirectoryPickerButton,(function(t){var n=t.parent,r=t.path,i=t.props,o=xh(wh,Mh(n,r));return(0,e.jsx)(nX,{label:(0,e.jsx)(ph,{value:i.displayName}),value:i.displayValue,disabled:i.disabled,onOpenDirectoryBrowser:o})})),FQ(VQ,sM.EditorSection,(function(t){var n=t.parent,r=t.path,o=t.props,a=t.children,l=Mh(n,r),s=(0,i.useContext)(Xh),c=xh(gM,l),u=xh(Sh,l),d=xh(yM,l);return(0,e.jsx)(DQ,{title:(0,e.jsx)(ph,{value:o.displayName}),active:o.active,primary:o.primary,headerColor:null!=o.color?pm(o.color):void 0,expanded:o.expanded,onDelete:o.deletable?c:void 0,onActiveChange:o.activatable?d:void 0,onExpandedChange:o.expandable?u:void 0,children:(0,e.jsx)(Yh,{parent:l,components:s,data:a})})})),FQ(VQ,sM.Compass,(function(t){var n=t.props;return(0,e.jsx)(zV,{centered:!0,children:(0,e.jsx)(eB,{angle:n.angle})})})),FQ(VQ,sM.SeasonWheel,(function(t){var n=t.parent,r=t.path,i=t.props,o=Mh(n,r),a=xh(bM,o),l=xh(xM,o),s=qd();return(0,e.jsxs)(zV,{centered:!0,children:[(0,e.jsx)(SQ,{size:360*s,seasons:i.seasons,selectedSeason:i.selectedSeason,onSelect:a,onSeasonStartTimeOfYearChange:l}),(0,e.jsx)(MQ,{width:360*s})]})})),FQ(VQ,sM.TimeOfDayWeightsChart,(function(t){var n,r=t.props,o=(0,i.useMemo)((function(){return{datasets:[{data:[r.value.x,r.value.y,r.value.z,r.value.w,r.value.x]}]}}),[r.value.x,r.value.y,r.value.z,r.value.w]),a=(n=C(Jl),(0,i.useMemo)((function(){return{layout:{padding:{top:8,right:8,bottom:0,left:8}},elements:{line:{fill:!0,tension:0,borderWidth:2,borderColor:"#ffb543",backgroundColor:"rgba(255, 181, 67, 0.3)"},point:{radius:4,backgroundColor:"#ffb543"}},scales:{y:{display:!1,min:0,suggestedMax:1,labels:[],grid:{color:"rgba(255, 255, 255, 0.5)",lineWidth:function(e){return 0===e.tick.value?2:1}}},x:{labels:["00","06","12","18","00"],grid:{color:"rgba(255, 255, 255, 0.4)",borderColor:"rgba(255, 255, 255, 0.4)",lineWidth:1,borderWidth:1},ticks:{font:{size:14*n,weight:"bold"},color:"rgba(255, 255, 255, 0.6)",padding:0,autoSkip:!1},beginAtZero:!0}}}}),[n]));return(0,e.jsx)(zV,{children:(0,e.jsx)(Zj,{type:"line",data:o,options:a,className:UQ})})})),FQ(VQ,sM.LocalizationField,(function(t){var n=t.parent,r=t.path,o=t.props,a=Mh(n,r),l=(0,i.useCallback)((function(e,t,n){!function(e,t,n,r){N(e.group,"setLocalizationEntry",e.path,t,n,r)}(a,e,t,n)}),[a]),s=C(Yf),c=(0,i.useCallback)((function(e){!function(e,t){N(e.group,"removeLocalizationEntry",e.path,t)}(a,e)}),[a]),u=(0,i.useCallback)((function(){!function(e){N(e.group,"addLocalizationEntry",e.path)}(a)}),[a]);return(0,e.jsx)(N$,{localization:o.localization,supportedLocales:s,onChange:l,onAdd:u,onRemove:c})})),FQ(VQ,sM.FilterMenu,(function(t){var n=t.parent,r=t.path,i=t.props,o=Mh(n,r),a=xh(EM,o),l=xh(OM,o);return(0,e.jsx)(NX,{availableFilters:i.availableFilters,activeFilters:i.activeFilters,onToggleFilter:a,onClear:l})})),VQ);function KQ(t){var n,r=function(n){var r=n.parent,i=n.path,o=n.props,a=xh(Ih,Mh(r,i));return(0,e.jsx)(t,GQ(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){FQ(e,t,n[t])}))}return e}({},o),{label:(0,e.jsx)(ph,{value:o.displayName}),onChange:a}))};return r.displayName=null!==(n=t.displayName)&&void 0!==n?n:t.name,r}const WQ={"resize-container":"resize-container_AAw",resizeContainer:"resize-container_AAw","drag-handle":"drag-handle_enz",dragHandle:"drag-handle_enz",left:"left_jHP",right:"right_fxN","resize-cursor":"resize-cursor_YOy",resizeCursor:"resize-cursor_YOy"};function zQ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function YQ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return zQ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zQ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var XQ=function(t){var n=t.width,r=t.minWidth,o=t.maxWidth,a=t.direction,l=t.className,s=t.children,c=t.onResize,u="left"===a?-1:1,d=YQ((0,i.useState)(0),2),f=d[0],h=d[1],m=(0,i.useCallback)((function(e){return h(e)}),[]),p=(0,i.useCallback)((function(){return h(0)}),[]),v=(0,i.useCallback)((function(e){c(at(n+u*e,r,o)),h(0)}),[c,n,u,r,o]);return(0,e.jsxs)("div",{className:Oe()(WQ.resizeContainer,l),style:{width:at(n+u*f,r,o)},children:[s,"none"!==a&&(0,e.jsx)(qQ,{className:WQ[a],onChange:m,onDragStart:p,onDragEnd:v})]})},qQ=function(t){var n=t.className,r=t.onChange,o=t.onDragStart,a=t.onDragEnd,l=(0,i.useRef)(null),s=(0,i.useCallback)((function(e){var t=e.clientX;return function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),l.current=t,o(),!0}),[o]),c=(0,i.useCallback)((function(e){var t=e.clientX;null!=l.current&&(a(t-l.current),l.current=null)}),[a]),u=(0,i.useCallback)((function(e){var t=e.clientX;null!=l.current&&r(t-l.current)}),[r]),d=YQ(Zd(s,u,c),2),f=d[0],h=d[1];return Of(f?WQ.resizeCursor:void 0),(0,e.jsx)("div",{className:Oe()(WQ.dragHandle,f&&"dragging",n),onMouseDown:h})};const $Q="250rem",QQ="800rem",ZQ="panel_R8J",JQ="content_Mxn";function eZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tZ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return eZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return eZ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var nZ=function(t){var n=t.resizeDirection,r=t.className,o=tZ((0,i.useState)(!0),2),a=o[0],l=o[1],s=Xd($Q),c=Xd(QQ),u=C(fM),d=qd(),f=(0,i.useCallback)((function(e){mM(Math.round(e/d))}),[d]),h=C(dM),m=C(hM),p=Lh(cM),v=C(PV),g=Lh(NV),y=v.length>0?(0,e.jsx)(Fn,{focusKey:Te,children:(0,e.jsx)(BQ,{parent:g,data:v})}):void 0;return(0,e.jsx)(XQ,{width:u*d,minWidth:s,maxWidth:c,direction:a?n:"none",className:r,onResize:f,children:(0,e.jsx)(SV,{expanded:a,headerText:null!=h&&(0,e.jsx)(ph,{value:h}),footer:y,theme:CV,className:ZQ,contentClassName:JQ,onToggleExpanded:l,onClose:vM,allowFocusExit:!0,children:(0,e.jsx)(wn,{onAction:pM,children:(0,e.jsx)(Fn,{children:(0,e.jsx)(BQ,{parent:p,data:m})})})})})};const rZ="30rem",iZ="hierarchy_vuK",oZ="item_Ksl",aZ="item-label_GTI",lZ="arrow-container_Mio",sZ="arrow_wix",cZ="expanded_YQt",uZ="bullet_B3F",dZ="title_THo",fZ="placeholder_bdR",hZ="actions_Qtv";function mZ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var pZ=function(t){var n=t.className,r=C(ZL),o=$X(Xd(rZ),r,10),a=C(eM),l=C(JL),s=function(e,t){var n=e.items.findIndex((function(e){return lM(e.id,t)}));return-1!==n?e.startIndex+n:null}(a,l),c=(0,i.useCallback)((function(t){var n=t-a.startIndex;if(n>=0&&n<a.items.length){var r=a.items[n];return(0,e.jsx)(vZ,{index:t,data:r,selected:lM(r.id,l),onSelect:rM,onToggleExpanded:iM},t)}return(0,e.jsx)(gZ,{},t)}),[l,a.items,a.startIndex]),u=(0,i.useCallback)((function(e,t){nM(e,t)}),[]),d=(0,i.useCallback)((function(e){if("number"==typeof e){var t=e-a.startIndex;t>=0&&t<a.items.length&&rM(a.items[t].id)}}),[a]);return(0,e.jsx)(Mn,{direction:On.Vertical,focused:s,onChange:d,children:(0,e.jsx)(YX,{className:Oe()(iZ,n),sizeProvider:o,renderItem:c,onRenderedRangeChange:u})})},vZ=function(t){var n,r=t.index,o=t.data,a=t.selected,l=t.onSelect,s=t.onToggleExpanded,c=cr(),u=(0,i.useCallback)((function(){o.selectable||c?l(o.id):o.expandable&&s(o.id,!o.expanded)}),[o.expandable,o.expanded,o.id,o.selectable,c,l,s]),d=(0,i.useCallback)((function(){s(o.id,!o.expanded),Jt(Qt.expandPanel)}),[o.expanded,o.id,s]),f=(0,i.useMemo)((function(){return mZ({},o.expanded?"Collapse Group":"Expand Group",o.expandable?d:null)}),[o.expanded,o.expandable,d]);return(0,e.jsxs)("div",{className:Oe()(oZ,(n={},mZ(n,cZ,o.expanded),mZ(n,"selected",a),n)),style:{"--level":o.level},onClick:u,children:[(0,e.jsx)(Tn,{actions:f,children:(0,e.jsxs)(ml,{className:aZ,focusKey:r,selected:a,onSelect:u,children:[o.expandable?(0,e.jsx)("div",{className:lZ,children:(0,e.jsx)("img",{src:"Media/Editor/HierarchyExpand.svg",className:sZ,onClick:d})}):(0,e.jsx)("img",{src:"Media/Editor/HierarchyNode.svg",className:uZ}),(0,e.jsx)("div",{className:dZ,children:(0,e.jsx)(ph,{value:o.name})})]})}),(0,e.jsx)("div",{className:hZ,children:o.id.type===XL.Object&&(0,e.jsx)(xl,{src:"Media\\Editor\\Bulldozer.svg",onSelect:function(){}})})]})},gZ=function(){return(0,e.jsx)("div",{className:fZ})};const yZ="200rem",bZ="500rem",xZ="panel_Qoc",_Z="content_taQ",jZ="hierarchy_QwS";function EZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function OZ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return EZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return EZ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var TZ=function(t){var n=t.className,r=t.onClose,o=OZ((0,i.useState)(!0),2),a=o[0],l=o[1],s=Xd(yZ),c=Xd(bZ),u=C(QL),d=qd(),f=(0,i.useCallback)((function(e){return tM(Math.round(e/d))}),[d]);return(0,e.jsx)(XQ,{width:u*d,minWidth:s,maxWidth:c,direction:a?"right":"none",className:n,onResize:f,children:(0,e.jsx)(wn,{onAction:r,children:(0,e.jsx)(SV,{theme:CV,headerText:(0,e.jsx)(Ks.Editor.WORKSPACE,{}),className:xZ,contentClassName:_Z,onToggleExpanded:l,onClose:r,allowFocusExit:!0,children:(0,e.jsx)(pZ,{className:jZ})})})})},IZ="editorTool",SZ=E(IZ,"tools"),wZ=E(IZ,"activeTool"),NZ=w(IZ,"selectTool");const PZ={button:"button_iZC",icon:"icon_oET"},CZ="editor-toolbar_i1J",AZ="button_i0V";var LZ=function(t){var n=t.className,r=C(SZ),o=C(wZ),a=(0,i.useCallback)((function(e){return NZ(wZ.value!==e?e:null)}),[]);return(0,e.jsx)("div",{className:Oe()(CZ,n),children:(0,e.jsx)(Fn,{direction:On.Horizontal,children:r.map((function(t){var n=t.id,r=t.icon,i=t.disabled;return(0,e.jsx)(MZ,{id:n,icon:r,tooltip:(0,e.jsx)(Ks.Editor.TOOL,{hash:n}),selected:o===n,disabled:i,onSelect:a},n)}))})})},MZ=function(t){var n=t.id,r=t.icon,o=t.tooltip,a=t.selected,l=t.disabled,s=t.onSelect,c=(0,i.useCallback)((function(){return s(n)}),[n,s]);return(0,e.jsx)(xO,{tooltip:o,children:(0,e.jsx)(xl,{src:r,disabled:l,theme:PZ,selected:a,className:AZ,onSelect:c})})};const RZ="editor-main-screen_m89",kZ="main_k4u",DZ="tool-options_Cqd",UZ="toolbar_Qbd",FZ="hierarchy-panel_UPK",GZ="editor-panel_oDZ";function VZ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function BZ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var HZ,KZ=function(t){var n=t.focusKey,r=t.className,o=t.onPauseMenuToggle,a=C(uM),l=C(oM),s=IG(),c=Dk(),u=C(fR),d=(0,i.useRef)(u.id),f=u.id===VR,h=(0,i.useCallback)((function(){var e=Object.keys(qL).length/2;aM((l+1)%e)}),[l]),m=(0,i.useMemo)((function(){return BZ(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){VZ(e,t,n[t])}))}return e}({},c),{Back:function(){f?a?vM():o():(u.id===GR&&Jt(Qt.bulldozeEnd),PR(VR))},Bulldozer:function(){u.id===GR?(Jt(Qt.bulldozeEnd),PR(d.current)):(d.current=u.id,Jt(Qt.bulldoze),PR(GR))},"Change Elevation":AR,"Photo Mode Panel":h})}),[u.id,f,a,o,h,c]);return nD(),(0,e.jsx)(Tn,{actions:m,children:(0,e.jsx)(Rc,{children:(0,e.jsx)(FL,{children:(0,e.jsx)(Fn,{focusKey:n,activation:Ue.Always,children:(0,e.jsx)(Wn,{children:(0,e.jsxs)("div",{className:Oe()(RZ,r),children:[(0,e.jsxs)("div",{className:kZ,children:[(0,e.jsx)(LZ,{className:UZ}),(0,e.jsx)(TZ,{className:FZ}),a&&(0,e.jsx)(nZ,{resizeDirection:"left",className:GZ}),s&&(0,e.jsx)(TG,{className:DZ})]}),(0,e.jsx)(yV,{onPauseMenuToggle:o})]})})})})})})};function WZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zZ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function YZ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return WZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return WZ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e[e.main=0]="main",e[e.pauseMenu=1]="pauseMenu",e[e.options=2]="options"}(HZ||(HZ={}));function XZ(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,i.useEffect)((function(){if(!e){var t=zp.subscribe((function(){}));return function(){null==t||t.dispose()}}}),[e])}const qZ="debug-prefab-tool-panel_xQO";var $Z=new Se("CHILDREN"),QZ=function(t){var n=t.children,r=C(Pf),o=C(uM),a=(0,i.useMemo)((function(){return{"Debug Prefab Tool":function(){return NZ(o?null:"PrefabTool")}}}),[o]);return r?(0,e.jsx)(Tn,{actions:a,children:(0,e.jsxs)(Ze,{focused:$Z,children:[(0,e.jsx)(He,{focusKey:$Z,children:n}),o&&(0,e.jsx)(nZ,{resizeDirection:"left",className:qZ})]})}):(0,e.jsx)(e.Fragment,{children:n})};function ZZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function JZ(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function eJ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function tJ(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function nJ(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){eJ(e,t,n[t])}))}return e}function rJ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function iJ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ZZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZZ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var oJ=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},aJ={},lJ=function(t){var n=t.styles,r=t.enterDuration,o=t.exitDuration,a=t.enterExpandHeight,l=void 0===a||a,s=t.exitCollapseHeight,c=void 0===s||s,u=t.children;if(!Ut(u))throw new Error("HeightTransition requires a single child react element!");var d=null!=n?n:aJ,f=(0,i.useContext)(Gt),h=f.state,m=f.onMount,p=f.onUnmount,v=(0,i.useContext)(dr),g=(0,i.useRef)(null),y=Je(u.ref,g),b=(0,i.useRef)(!1),x=iJ((0,i.useState)(function(e,t){switch(e){case bt.enter:return t.enter;case bt.exit:return t.exit;default:return null}}(h,d)),2),_=x[0],j=x[1],E=(0,i.useRef)(_);E.current=_;var O=(0,i.useCallback)((function(e){b.current&&j(e)}),[]),T=iJ((0,i.useState)(h===bt.enter&&l?{height:"0px"}:{}),2),I=T[0],S=T[1],w=(0,i.useCallback)((function(e){b.current&&S(e)}),[]);return(0,i.useEffect)((function(){return b.current||(b.current=!0,m()),function(){b.current&&(b.current=!1,p())}}),[m,p]),(0,i.useEffect)((function(){var e,t=new tt;return(e=function(){var e,n,i,a,s,u;return oJ(this,(function(f){switch(f.label){case 0:return h!==bt.enter?[3,10]:(O(d.enter),l&&tJ(g.current,HTMLElement)&&(e=g.current.offsetHeight,w((function(t){return null==t?{height:e+"px"}:t}))),[4,Dt(t)]);case 1:return f.sent()?[4,Dt(t)]:[2];case 2:return f.sent()?(O(d.enterActive),[4,Dt(t)]):[2];case 3:if(!f.sent())return[2];if(n=null!=r?r:Pt(g.current),!l)return[3,7];i=performance.now(),a=Ct(g.current,"height"),s=0,tJ(g.current,HTMLElement)&&(s=g.current.scrollHeight,w({height:s+"px"})),f.label=4;case 4:return performance.now()-i<=n?(tJ(g.current,HTMLElement)&&(u=g.current.scrollHeight,s<u&&(w(null!=a?rJ(nJ({},At(g.current,"height",function(e,t){if(t<e.delay)return wt(St({},e),{delay:e.delay-t});if(e.duration>0||t<e.delay+e.duration){var n=(t-e.delay)/e.duration;return{delay:0,duration:(1-n)*e.duration,timingFunction:Rt(e.timingFunction,n)}}return wt(St({},e),{duration:0,delay:0})}(a,performance.now()-i))),{height:u+"px"}):{height:u+"px"}),s=u)),[4,Dt(t)]):[3,6];case 5:return f.sent()?[3,4]:[2];case 6:return[3,9];case 7:return[4,kt(n,t)];case 8:if(!f.sent())return[2];f.label=9;case 9:return l&&v.updateThumbs(),O(null),w(null),[3,16];case 10:return h!==bt.exit?[3,16]:null!=E.current?[3,13]:(O(d.exit),c&&tJ(g.current,HTMLElement)&&w({height:g.current.offsetHeight+"px"}),[4,Dt(t)]);case 11:return f.sent()?[4,Dt(t)]:[2];case 12:if(!f.sent())return[2];f.label=13;case 13:return O(d.exitActive),[4,Dt(t)];case 14:return f.sent()?(c&&tJ(g.current,HTMLElement)&&w({height:"0px"}),[4,kt(null!=o?o:Pt(g.current),t)]):[2];case 15:if(!f.sent())return[2];c&&v.updateThumbs(),b.current&&(b.current=!1,p()),f.label=16;case 16:return[2]}}))},function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){JZ(o,r,i,a,l,"next",e)}function l(e){JZ(o,r,i,a,l,"throw",e)}a(void 0)}))})(),function(){t.cancel(),O(null),w(null)}}),[r,l,c,o,p,v,h,d.enter,d.enterActive,d.exit,d.exitActive,O,w]),(0,e.jsx)(Gt.Provider,{value:Ft,children:i.cloneElement(u,rJ(nJ({},u.props),{ref:y,className:Oe()(u.props.className,d.base,_),style:nJ({},u.props.style,I)}))})};var sJ,cJ="notification",uJ=E(cJ,"notifications");!function(e){e[e.None=0]="None",e[e.Progressing=1]="Progressing",e[e.Indeterminate=2]="Indeterminate",e[e.Complete=3]="Complete",e[e.Failure=4]="Failure",e[e.Warning=5]="Warning"}(sJ||(sJ={}));const dJ={"progress-circle":"progress-circle_lIZ progress-circle_OLN",progressCircle:"progress-circle_lIZ progress-circle_OLN",progress:"progress_EdA progress_mlv",complete:"complete_yk6",failure:"failure_Zlz"},fJ={"notifications-panel":"notifications-panel_AtV",notificationsPanel:"notifications-panel_AtV",header:"header_JLb",scrollable:"scrollable_aqz","item-transition":"item-transition_kWi",itemTransition:"item-transition_kWi",enter:"enter_imo","enter-active":"enter-active_KuO",enterActive:"enter-active_KuO",exit:"exit_Dv6","exit-active":"exit-active_QeX",exitActive:"exit-active_QeX",item:"item_tYE",thumbnail:"thumbnail_MaF","main-column":"main-column_j77",mainColumn:"main-column_j77",title:"title_wMV",text:"text__0z","progress-container":"progress-container_Trw",progressContainer:"progress-container_Trw","progress-circle":"progress-circle_MKN",progressCircle:"progress-circle_MKN","progress-label":"progress-label_bgv",progressLabel:"progress-label_bgv","progress-icon":"progress-icon_KDy",progressIcon:"progress-icon_KDy","complete-icon":"complete-icon_CuU progress-icon_KDy",completeIcon:"complete-icon_CuU progress-icon_KDy","failure-icon":"failure-icon_Pny progress-icon_KDy",failureIcon:"failure-icon_Pny progress-icon_KDy","warning-icon":"warning-icon_dBU progress-icon_KDy",warningIcon:"warning-icon_dBU progress-icon_KDy"};var hJ=Rr({Checkmark:"Media/Glyphs/Checkmark.svg",Close:"Media/Glyphs/Close.svg",Warning:"Media/Glyphs/Warning.svg"}),mJ=function(t){var n=t.className,r=C(uJ);return(0,e.jsxs)("div",{className:Oe()(fJ.notificationsPanel,n),children:[(0,e.jsx)("div",{className:fJ.header,children:(0,e.jsx)(Ks.Menu.NOTIFICATIONS_TITLE,{})}),(0,e.jsx)(mf,{className:fJ.scrollable,children:(0,e.jsx)(Fn,{children:(0,e.jsx)(nO,{children:r.map((function(t){return(0,e.jsx)(vJ,{item:t},t.id)}))})})})]})},pJ={tension:30,friction:10},vJ=function(t){var n=t.item,r=V$(pJ,n.progress,n.progress,!0),o=(0,i.useCallback)((function(){return e=n.id,void N(cJ,"selectNotification",e);var e}),[n.id]);return(0,e.jsx)(lJ,{styles:fJ,children:(0,e.jsx)("div",{className:fJ.itemTransition,children:(0,e.jsxs)(ml,{onSelect:o,className:fJ.item,children:[n.thumbnail&&(0,e.jsx)("img",{src:n.thumbnail,className:fJ.thumbnail}),(0,e.jsxs)("div",{className:fJ.mainColumn,children:[(0,e.jsx)("div",{className:fJ.title,children:gJ(n)}),(0,e.jsx)("div",{className:fJ.text,children:yJ(n)})]}),n.progressState!==sJ.None&&(0,e.jsxs)("div",{className:fJ.progressContainer,children:[(0,e.jsx)(zE,{progress:n.progressState!==sJ.Complete?r:100,max:100,indeterminate:n.progressState===sJ.Indeterminate,theme:dJ,className:Oe()(fJ.progressCircle,bJ(n))}),xJ(n)]})]})})})};function gJ(t){return null!=t.title?t.title:null!=t.titleId?(0,e.jsx)(Ks.Menu.NOTIFICATION_TITLE,{hash:t.titleId}):void 0}function yJ(t){return null!=t.text?t.text:null!=t.textId?(0,e.jsx)(Ks.Menu.NOTIFICATION_DESCRIPTION,{hash:t.textId}):void 0}function bJ(e){switch(e.progressState){case sJ.Complete:return dJ.complete;case sJ.Failure:return dJ.failure;default:return}}function xJ(t){switch(t.progressState){case sJ.Complete:return(0,e.jsx)(ll,{src:hJ.Checkmark,className:fJ.completeIcon});case sJ.Failure:return(0,e.jsx)(ll,{src:hJ.Close,className:fJ.failureIcon});case sJ.Warning:return(0,e.jsx)(ll,{src:hJ.Warning,className:fJ.warningIcon});case sJ.Indeterminate:return;default:return(0,e.jsx)("div",{className:fJ.progressLabel,children:(0,e.jsx)(dc,{value:t.progress,unit:tc.Percentage})})}}const _J={button:"button_Qvi item-mouse-states_Fmi",icon:"icon_Z6Y",label:"label_yYE"},jJ="paradox-panel_iFS",EJ="incentive-container_e7Y",OJ="incentive-image_Qzc",TJ="incentive-main_IhA",IJ="incentive-prompt_k0u",SJ="incentive-footer_UuL",wJ="incentive-legal_MJN",NJ="header_MiJ",PJ="logo_opg",CJ="title_S09",AJ="content_VTM",LJ="user-name_GiO",MJ="button-row_LTO",RJ="button-container_sgE",kJ="button_o5e",DJ="legal-row_qI2",UJ="legal-row-center_ZHk",FJ="legal-link_Cxy item-states_QjV";var GJ=function(t){var n=t.className,r=C(gw),i=C(_w),o=C(jw);return(0,e.jsx)("div",{className:Oe()(jJ,n),children:i&&o?r?(0,e.jsx)(BJ,{}):(0,e.jsx)(VJ,{}):(0,e.jsx)(KJ,{label:o?(0,e.jsx)(Ks.Paradox.NO_INTERNET_CONNECTION,{}):(0,e.jsx)(Ks.Paradox.SDK_DISABLED,{})})})},VJ=function(){var t=C(_w);return(0,e.jsxs)("div",{className:EJ,children:[(0,e.jsxs)("div",{className:TJ,children:[(0,e.jsx)("div",{className:OJ}),(0,e.jsx)("div",{className:IJ,children:(0,e.jsx)(Ks.Paradox.LOGIN_INCENTIVE,{})})]}),(0,e.jsxs)("div",{className:SJ,children:[(0,e.jsx)(xO,{tooltip:t?null:(0,e.jsx)(Ks.Paradox.NO_INTERNET_CONNECTION,{}),children:(0,e.jsx)(CN,{tinted:t,src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",theme:BP,onSelect:Nw,disabled:!t,children:(0,e.jsx)(Ks.Paradox.LOGIN_BUTTON,{})})}),(0,e.jsx)("div",{className:wJ,children:(0,e.jsx)(WJ,{className:UJ})})]})]})},BJ=function(){var t=C(yw),n=C(bw),r=function(e){return(0,i.useMemo)((function(){return null!==e&&e.length>=3&&e.indexOf("@")>=1?e[0]+"***@***"+e[e.length-1]:e}),[e])}(C(xw));return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)("div",{className:NJ,children:[(0,e.jsx)(ll,{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:PJ}),(0,e.jsx)("div",{className:CJ,children:(0,e.jsx)(Ks.Paradox.PARADOX_ACCOUNT,{})})]}),(0,e.jsxs)("div",{className:AJ,children:[(0,e.jsx)("div",{className:LJ,children:r}),(0,e.jsxs)("div",{className:RJ,children:[(0,e.jsxs)("div",{className:MJ,children:[t===Pw.unlinked&&(0,e.jsx)(HJ,{accountLinkProvider:n,className:kJ}),t===Pw.linked&&(0,e.jsx)(ml,{theme:BP,className:kJ,onSelect:Ow,children:(0,e.jsx)(Ks.Paradox.UNLINK_ACCOUNT_BUTTON,{})}),(0,e.jsx)(ml,{theme:BP,className:kJ,onSelect:Tw,children:(0,e.jsx)(Ks.Paradox.LOGOUT_BUTTON,{})})]}),(0,e.jsx)(WJ,{})]})]})]})},HJ=function(t){var n=t.accountLinkProvider,r=t.className;return"PSN"!==n.toLowerCase()?(0,e.jsx)(CN,{src:"Media/Menu/Platforms/".concat(n,".svg"),theme:_J,style:{backgroundColor:zJ(n)},className:r,onSelect:Ew,children:(0,e.jsx)(Ks.Paradox.ACCOUNT_LINK_PROMPT_SHORT,{hash:n})}):(0,e.jsx)(ml,{theme:_J,style:{backgroundColor:zJ(n)},className:r,onSelect:Ew,children:(0,e.jsx)(Ks.Paradox.ACCOUNT_LINK_PROMPT_SHORT,{hash:n})})},KJ=function(t){var n=t.label;return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)("div",{className:NJ,children:[(0,e.jsx)(ll,{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:PJ}),(0,e.jsx)("div",{className:CJ,children:(0,e.jsx)(Ks.Paradox.PARADOX_ACCOUNT,{})})]}),(0,e.jsx)("div",{className:AJ,children:(0,e.jsx)("div",{className:LJ,children:n})})]})},WJ=function(t){var n=t.className;return(0,e.jsxs)("div",{className:Oe()(DJ,n),children:[(0,e.jsx)(ml,{className:FJ,onSelect:Dw,children:(0,e.jsx)(Ks.Paradox.TERMS_OF_USE,{})}),(0,e.jsx)(ml,{className:FJ,onSelect:Uw,children:(0,e.jsx)(Ks.Paradox.PRIVACY_POLICY,{})})]})};function zJ(e){switch(e){case"PSN":return"#003087";case"XboxLive":return"#107C10";default:return"#555"}}const YJ="logo_xOs child-opacity-transition_nkS",XJ="content_LhM",qJ="column_y44",$J="paradox-panel_t14 child-opacity-transition_nkS",QJ="notifications-panel_c5F child-opacity-transition_nkS";var ZJ=(0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.CONFIRMATION,{}),message:(0,e.jsx)(Ks.Menu.APPLICATION_QUIT_MESSAGE,{}),onConfirm:function(){return te()}}),JJ=i.forwardRef((function(t,n){var r=t.focusKey,o=t.className,a=(0,i.useContext)(Rl),l=C(Du),s=C(td),c=C(Bu),u=C(Xu);return(0,e.jsxs)(UN,{ref:n,focusKey:r,className:o,children:[(0,e.jsx)("img",{src:"Media/Menu/GameLogo.svg",className:YJ}),(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:XJ,children:[(0,e.jsx)("div",{className:qJ}),(0,e.jsxs)("div",{className:qJ,children:[(0,e.jsx)(CN,{tinted:!0,disabled:!l,src:"Media/Glyphs/ArrowRight.svg",theme:AN,onSelect:od,children:(0,e.jsx)(Ks.Menu.CONTINUE_GAME,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Plus.svg",theme:AN,onSelect:function(){return id(Cu.NewGame)},children:(0,e.jsx)(Ks.Menu.NEW_GAME,{})}),(0,e.jsx)(CN,{tinted:!0,disabled:0===s.length,src:"Media/Glyphs/Progress.svg",theme:AN,onSelect:function(){return id(Cu.LoadGame)},children:(0,e.jsx)(Ks.Menu.LOAD_GAME,{})}),!c&&(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Pen.svg",theme:AN,onSelect:ad,children:(0,e.jsx)(Ks.Menu.EDITOR,{})}),(0,e.jsx)(e0,{fallbackToLogin:!0}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Gear.svg",theme:AN,onSelect:function(){return id(Cu.Options)},children:(0,e.jsx)(Ks.Menu.OPTIONS,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Credits.svg",theme:AN,onSelect:function(){return id(Cu.Credits)},children:(0,e.jsx)(Ks.Menu.CREDITS,{})}),u&&(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:AN,onSelect:function(){return a.showDialog(ZJ)},children:(0,e.jsx)(Ks.Menu.EXIT_APPLICATION,{})})]}),(0,e.jsxs)("div",{className:qJ,children:[(0,e.jsx)(GJ,{className:$J}),(0,e.jsx)(mJ,{className:QJ})]}),(0,e.jsx)("div",{className:qJ})]})})]})}));var e0=function(t){var n,r,i=t.fallbackToLogin,o=C(gw),a=C(_w),l=C(jw),s=C(Vu),c=(n=s,r=a,l?n?r?null:(0,e.jsx)(Ks.Paradox.NO_INTERNET_CONNECTION,{}):(0,e.jsx)(Ks.Paradox.UGC_DISABLED,{}):(0,e.jsx)(Ks.Paradox.SDK_DISABLED,{})),u=C(Hu);return(0,e.jsx)(e.Fragment,{children:!u&&(0,e.jsx)(xO,{tooltip:c,children:(0,e.jsx)(CN,{tinted:!0,src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",theme:AN,disabled:!s||!a||!l||!i&&!o,onSelect:o?ld:Nw,children:(0,e.jsx)(Ks.Menu.PDX_MODS,{})})})})};function t0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function n0(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function r0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function i0(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function o0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function a0(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var l0=function(t){var n=t.controller,r=t.children,o=qd(),a=(0,i.useRef)(0),l=(0,i.useMemo)((function(){return{"Scroll Vertical":function(e){a.current=300*-e}}}),[]);return(0,i.useEffect)((function(){var e=performance.now(),t=0,r=function(i){if(0!==a.current){var l=(i-e)/1e3;n.scrollBy(0,a.current*l*o)}e=i,t=window.requestAnimationFrame(r)};return t=window.requestAnimationFrame(r),function(){return window.cancelAnimationFrame(t)}}),[n,o]),(0,e.jsx)(Tn,{actions:l,children:r})};var s0=/^(#+)\s+/,c0=/\s/;var u0=function(){function t(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,t)}return t.prototype.render=function(t){var n=[];t=t.replace(/<br>/gim,"␤");var r=JT.None,i=new Array,o=0,a=s0.exec(t);null!=a&&(r=at(a[1].length,1,6),o=a[0].length);for(var l=-1,s=-1,c=-1,u=-1,d=0;d<t.length;d++)switch(t[d]){case"␤":t=t.substring(0,d)+" "+t.substring(d+1),n.push((0,e.jsx)("br",{},d));break;case"!":d<t.length-1&&-1===s&&(l=d);break;case"[":s=d,c=-1,u=-1;break;case"]":-1!==s&&-1===c?c=d:l=-1;break;case"(":-1!==s&&-1!==c&&-1===u&&(c===d-1?u=d:(l=-1,s=-1,c=-1));break;case")":if(-1!==u){if(-1===l){o<s&&n.push(d0(t,o,s,null));var f=d0(t,s+1,c,d<t.length-1&&c0.test(t[d+1])?t[d+1]:null),h=t.substring(u+1,d);n.push((0,e.jsx)(iI,{linkData:h,children:f},s))}else{var m=t.substring(s+1,c),p=t.substring(u+1,d);n.push((0,e.jsx)("img",{alt:m,src:p},l)),i.push(p)}o=d+1,l=-1,s=-1,c=-1,u=-1}break;default:-1!==l&&-1===s&&(l=-1)}return o<t.length&&n.push(d0(t,o,t.length,null)),[n,r,i]},t}();function d0(t,n,r,i){for(var o=[],a=n,l=!1,s=-1,c=n;c<r;c++)if("*"===t[c])if(l)if(-1===s)s=c-1,l=!1;else{a<s&&o.push(t.substring(a,s));var u=t.substring(s+2,c-1);c<r-1?c0.test(t[c+1])&&(u+=t[c+1]):null!=i&&(u+=i),o.push((0,e.jsx)("b",{children:u},s)),a=c+1,s=-1,l=!1}else l=!0;else l=!1;if(a<r){var d=t.substring(a,r);null!=i&&(d+=i),o.push(d)}return o}var f0;function h0(e){return/^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i.test(e)}function m0(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function p0(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return m0(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return m0(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e[e.None=0]="None",e[e.ForgotPassword=1]="ForgotPassword",e[e.Login=2]="Login"}(f0||(f0={}));const v0={"dropdown-toggle":"dropdown-toggle_th2 dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_th2 dropdown-toggle_prl",invalid:"invalid_rQd",indicator:"indicator_Iwz","dropdown-menu":"dropdown-menu_uEW dropdown-menu_Swd",dropdownMenu:"dropdown-menu_uEW dropdown-menu_Swd",scrollable:"scrollable_NAI undefined","dropdown-item":"dropdown-item_IIB undefined",dropdownItem:"dropdown-item_IIB undefined"};function g0(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function y0(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||x0(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function b0(e){return function(e){if(Array.isArray(e))return g0(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||x0(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function x0(e,t){if(e){if("string"==typeof e)return g0(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?g0(e,t):void 0}}const _0="loading-overlay_ica";function j0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var E0,O0=new Se("CHILDREN"),T0=(j0(E0={},Iw.Login,(function(){var t=p0((0,i.useState)(""),2),n=t[0],r=t[1],o=!h0(n),a=p0((0,i.useState)(""),2),l=a[0],s=a[1],c=0===l.length,u=p0((0,i.useState)(f0.None),2),d=u[0],f=u[1],h=(0,i.useCallback)((function(){o||c?f(f0.Login):(f(f0.None),N(pw,"submitLoginForm",ri({email:n,password:l},"Game.UI.Menu.ParadoxBindings+LoginFormData")))}),[n,o,l,c]),m=(0,i.useCallback)((function(){o?f(f0.ForgotPassword):(f(f0.None),function(e){N(pw,"submitPasswordReset",e)}(n))}),[n,o]);return(0,e.jsx)(mN,{onClose:ww,children:(0,e.jsx)("div",{className:Kw,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)("div",{className:Ww,children:(0,e.jsx)("img",{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:zw})}),(0,e.jsx)("div",{className:Yw,children:(0,e.jsx)(Ks.Paradox.LOGIN_FORM_TITLE,{})}),(0,e.jsx)("div",{className:Oe()($w,Zw),children:(0,e.jsx)(vN,{type:"email",value:n,placeholder:(0,e.jsx)(Ks.Paradox.EMAIL_FIELD_LABEL,{}),invalid:d!==f0.None&&o,onChange:r})}),(0,e.jsxs)("div",{className:Oe()($w,qw,Zw),children:[(0,e.jsx)("div",{style:{flex:1},children:(0,e.jsx)(vN,{type:"password",placeholder:(0,e.jsx)(Ks.Paradox.PASSWORD_FIELD_LABEL,{}),value:l,invalid:d===f0.Login&&c,onChange:s})}),(0,e.jsx)(ml,{onSelect:m,className:nN,children:(0,e.jsx)(Ks.Paradox.FORGOT_PASSWORD_LINK,{})})]}),(0,e.jsx)(Tr,{className:Xw,style:{justifyContent:"flex-end"},children:(0,e.jsx)(ml,{theme:hw,onSelect:h,children:(0,e.jsx)(Ks.Paradox.LOGIN_BUTTON,{})})}),(0,e.jsx)("div",{className:dN}),(0,e.jsxs)("div",{className:Xw,children:[(0,e.jsx)("div",{className:sN,children:(0,e.jsx)(Ks.Paradox.REGISTRATION_HINT,{})}),(0,e.jsx)(ml,{theme:mw,onSelect:Aw,children:(0,e.jsx)(Ks.Paradox.REGISTRATION_FROM_LOGIN_LINK,{})})]})]})})})})),j0(E0,Iw.Registration,(function(){var t=y0((0,i.useState)(""),2),n=t[0],r=t[1],o=!h0(n),a=y0((0,i.useState)(""),2),l=a[0],s=a[1],c=0===l.length,u=C(Cw),d=y0((0,i.useState)(null),2),f=d[0],h=d[1],m=y0((0,i.useState)(null),2),p=m[0],v=m[1],g=y0((0,i.useState)(null),2),y=g[0],b=g[1],x=y0((0,i.useState)(null),2),_=x[0],j=x[1],E=null!=y&&null!=p?new Date(p,y,0).getDate():31,O=Math.min((new Date).getFullYear(),2020);(0,i.useEffect)((function(){null!=_&&_>E&&j(null)}),[_,E]);var T=y0((0,i.useState)(!1),2),I=T[0],S=T[1],w=y0((0,i.useState)(!1),2),P=w[0],A=w[1],L=(0,i.useCallback)((function(){if(o||c||null==f||null==p||null==y||null==_)A(!0);else{A(!1);var e=function(e,t,n){return"".concat(zs(e,4),"-").concat(zs(t,2),"-").concat(zs(n,2))}(null!=p?p:0,y,_);N(pw,"submitRegistrationForm",ri({email:n,password:l,country:f,dateOfBirth:e,marketingPermission:I},"Game.UI.Menu.ParadoxBindings+RegistrationFormData"))}}),[o,c,p,y,_,n,l,f,I]);return(0,e.jsx)(mN,{onClose:ww,children:(0,e.jsx)("div",{className:Kw,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)("div",{className:Ww,children:(0,e.jsx)("img",{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:zw})}),(0,e.jsx)("div",{className:Yw,children:(0,e.jsx)(Ks.Paradox.REGISTRATION_FORM_TITLE,{})}),(0,e.jsx)("div",{className:Oe()($w,Jw),children:(0,e.jsx)(vN,{value:n,placeholder:(0,e.jsx)(Ks.Paradox.EMAIL_FIELD_LABEL,{}),onChange:r,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"ParadoxAccountEmail"}),invalid:P&&o})}),(0,e.jsx)("div",{className:Oe()($w,Jw),children:(0,e.jsx)(vN,{type:"password",value:l,placeholder:(0,e.jsx)(Ks.Paradox.PASSWORD_FIELD_LABEL,{}),onChange:s,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"ParadoxAccountPassword"}),invalid:P&&c})}),(0,e.jsx)("div",{className:Oe()($w,Jw),children:(0,e.jsx)(fC,{theme:v0,content:u.map((function(t,n){return(0,e.jsx)(_C,{focusKey:t,value:t,onChange:h,children:(0,e.jsx)(Ks.ISO.COUNTRY,{hash:t})},n)})),children:(0,e.jsx)(gC,{className:Oe()(P&&null==f&&v0.invalid),children:null==f?(0,e.jsx)(Ks.Paradox.COUNTRY_FIELD_LABEL,{}):(0,e.jsx)(Ks.ISO.COUNTRY,{hash:f})})})}),(0,e.jsxs)("div",{className:$w,children:[(0,e.jsx)("div",{className:Qw,children:(0,e.jsx)(Ks.Paradox.BIRTH_DATE_FIELD_LABEL,{})}),(0,e.jsx)(Tr,{className:qw,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)("div",{className:Oe()(oN,Jw),children:(0,e.jsx)(fC,{initialFocused:p,theme:v0,content:b0(Array(O-1901).keys()).map((function(t,n){return(0,e.jsx)(_C,{focusKey:O-t,value:O-t,onChange:v,children:Ws(O-t)},n)})),children:(0,e.jsx)(gC,{className:Oe()(P&&null==p&&v0.invalid),children:null==p?(0,e.jsx)(Ks.Paradox.BIRTH_DATE_YEAR_FIELD_LABEL,{}):Ws(p)})})}),(0,e.jsx)("div",{className:Oe()(iN,Jw),children:(0,e.jsx)(fC,{initialFocused:y,theme:v0,content:b0(Array(12).keys()).map((function(t,n){return(0,e.jsx)(_C,{focusKey:t+1,value:t+1,onChange:b,children:(0,e.jsx)(Ks.Common.MONTH,{index:t})},n)})),children:(0,e.jsx)(gC,{className:Oe()(P&&null==y&&v0.invalid),children:null==y?(0,e.jsx)(Ks.Paradox.BIRTH_DATE_MONTH_FIELD_LABEL,{}):(0,e.jsx)(Ks.Common.MONTH,{index:y-1})})})}),(0,e.jsx)("div",{className:Oe()(rN,Jw),children:(0,e.jsx)(fC,{initialFocused:_,theme:v0,content:b0(Array(E).keys()).map((function(t,n){return(0,e.jsx)(_C,{focusKey:t+1,value:t+1,onChange:j,children:Ws(t+1)},n)})),children:(0,e.jsx)(gC,{className:Oe()(P&&null==_&&v0.invalid),children:null==_?(0,e.jsx)(Ks.Paradox.BIRTH_DATE_DAY_FIELD_LABEL,{}):Ws(_)})})})]})})]}),(0,e.jsx)("div",{children:(0,e.jsx)(gN,{value:I,label:(0,e.jsx)(Ks.Paradox.MARKETING_PERMISSION_TOGGLE_LABEL,{}),onChange:S})}),(0,e.jsxs)(Tr,{activation:Ue.AnyChildren,children:[(0,e.jsx)(fI,{}),(0,e.jsx)(nI,{text:(0,e.jsx)(Ks.Paradox.TERMS_PRIVACY_NOTICE,{}),className:uN,onLinkSelect:Lw})]}),(0,e.jsx)("div",{className:Xw,children:(0,e.jsx)(ml,{theme:hw,onSelect:L,children:(0,e.jsx)(Ks.Paradox.SUBMIT_REGISTRATION_BUTTON,{})})}),(0,e.jsx)("div",{className:dN}),(0,e.jsx)("div",{className:Xw,children:(0,e.jsx)(ml,{theme:mw,onSelect:Nw,children:(0,e.jsx)(Ks.Paradox.LOGIN_FROM_REGISTRATION_LINK,{})})})]})})})})),j0(E0,Iw.AccountLink,(function(t){return(0,e.jsxs)(pN,n0(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){t0(e,t,n[t])}))}return e}({},t),{children:[(0,e.jsxs)("div",{className:Xw,children:[(0,e.jsx)(ml,{theme:mw,onSelect:Dw,children:(0,e.jsx)(Ks.Paradox.TERMS_OF_USE,{})}),(0,e.jsx)(ml,{theme:mw,onSelect:Uw,children:(0,e.jsx)(Ks.Paradox.PRIVACY_POLICY,{})})]}),(0,e.jsxs)("div",{className:Xw,children:[(0,e.jsx)(ml,{theme:hw,onSelect:Mw,children:(0,e.jsx)(Ks.Paradox.LINK_ACCOUNT_BUTTON,{})}),(0,e.jsx)(ml,{theme:mw,onSelect:ww,children:(0,e.jsx)(Ks.Paradox.SKIP_BUTTON,{})})]})]}))})),j0(E0,Iw.AccountLinkOverwrite,(function(t){return(0,e.jsx)(pN,i0(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){r0(e,t,n[t])}))}return e}({},t),{children:(0,e.jsxs)("div",{className:Xw,children:[(0,e.jsx)(ml,{theme:hw,onSelect:Rw,children:(0,e.jsx)(Ks.Common.YES,{})}),(0,e.jsx)(ml,{theme:mw,onSelect:ww,children:(0,e.jsx)(Ks.Common.NO,{})})]})}))})),j0(E0,Iw.LegalDocument,(function(t){var n=t.text,r=t.agreementRequired,o=VX(),a=(0,i.useMemo)((function(){return new u0}),[]);return(0,i.useEffect)((function(){return o.scrollTo(0,0)}),[o,n]),(0,e.jsx)(mN,{wide:!0,onClose:r?void 0:ww,children:(0,e.jsxs)(l0,{controller:o,children:[(0,e.jsx)(mf,{controller:o,className:fN,trackVisibility:"always",children:(0,e.jsx)("div",{className:hN,children:(0,e.jsx)(AG,{children:(0,e.jsx)(fI,{text:n,renderer:a,onLinkSelect:Lw})})})}),(0,e.jsx)("div",{className:Xw,children:(0,e.jsx)(ml,{theme:hw,onSelect:r?kw:ww,children:(0,e.jsx)(Ks.Common.OK,{})})})]})})})),j0(E0,Iw.Confirmation,(function(t){return(0,e.jsx)(pN,a0(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){o0(e,t,n[t])}))}return e}({},t),{children:(0,e.jsx)("div",{className:Xw,children:(0,e.jsx)(ml,{theme:hw,onSelect:ww,children:(0,e.jsx)(Ks.Common.OK,{})})})}))})),j0(E0,Iw.Error,(function(t){var n=t.messageId,r=t.message;return(0,e.jsxs)(mN,{onClose:ww,children:[null!=n&&(0,e.jsx)("p",{children:(0,e.jsx)(Ss,{id:n})}),null!=r&&(0,e.jsx)("p",{children:r}),null==n&&null==r&&(0,e.jsx)("p",{children:(0,e.jsx)(Ks.Paradox.UNKNOWN_ERROR,{})}),(0,e.jsx)("div",{className:Xw,children:(0,e.jsx)(ml,{theme:hw,onSelect:ww,children:(0,e.jsx)(Ks.Common.CLOSE,{})})})]})})),E0),I0=function(t){var n,r=t.children,o=C(vw),a=C(Sw).map((function(e){return function(e,t,n,r){var o=e[t.__Type];return null!=o?i.createElement(o,kh({},t,null!=n?n:{},null!=r?{key:r}:{})):void 0}(T0,e,void 0)})).filter((function(e){return null!=e}));return n=o?null:a.length>0?a.length-1:O0,(0,e.jsxs)(Ze,{focused:n,children:[(0,e.jsx)(He,{focusKey:O0,children:r}),a.map((function(t,n){return(0,e.jsx)(He,{focusKey:n,children:(0,e.jsx)(el,{children:t})},n)})),o&&(0,e.jsx)(S0,{})]})},S0=function(){return(0,e.jsx)("div",{className:_0,children:(0,e.jsx)(Ks.Paradox.LOADING,{})})};const w0="logo_C34 child-opacity-transition_nkS",N0="content_reP",P0="column_cmR",C0="paradox-panel_CK7 child-opacity-transition_nkS",A0="notifications-panel_AGm child-opacity-transition_nkS";var L0=i.forwardRef((function(t,n){var r=t.focusKey,o=t.className,a=t.onClose,l=C(td),s=C(Na),c=(0,i.useMemo)((function(){return{Back:a,"Pause Menu":a}}),[a]),u=MN();return(0,e.jsx)(UN,{ref:n,focusKey:r,className:o,children:(0,e.jsx)(I0,{children:(0,e.jsx)(_p,{children:(0,e.jsxs)(Tn,{actions:c,children:[(0,e.jsx)("img",{src:"Media/Menu/GameLogo.svg",className:w0}),(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:N0,children:[(0,e.jsx)("div",{className:P0}),(0,e.jsxs)("div",{className:P0,children:[(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/ArrowRight.svg",theme:AN,onSelect:a,children:(0,e.jsx)(Ks.Menu.RESUME_GAME,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Save.svg",theme:AN,onSelect:function(){return wa(Oa.saveGame)},children:(0,e.jsx)(Ks.Menu.SAVE_GAME,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Plus.svg",theme:AN,onSelect:function(){return wa(Oa.newGame)},children:(0,e.jsx)(Ks.Menu.NEW_GAME,{})}),(0,e.jsx)(CN,{tinted:!0,disabled:0===l.length,src:"Media/Glyphs/Progress.svg",theme:AN,onSelect:function(){return wa(Oa.loadGame)},children:(0,e.jsx)(Ks.Menu.LOAD_GAME,{})}),(0,e.jsx)(e0,{fallbackToLogin:!1}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Gear.svg",theme:AN,onSelect:function(){return wa(Oa.options)},children:(0,e.jsx)(Ks.Menu.OPTIONS,{})}),(0,e.jsx)(CN,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:AN,onSelect:u,disabled:!s,children:(0,e.jsx)(Ks.Menu.EXIT_GAME,{})})]}),(0,e.jsxs)("div",{className:P0,children:[(0,e.jsx)(GJ,{className:C0}),(0,e.jsx)(mJ,{className:A0})]}),(0,e.jsx)("div",{className:P0})]})})]})})})})}));const M0={base:"base_USz",enter:"enter_HYB","exit-active":"exit-active_hp7",exitActive:"exit-active_hp7","enter-active":"enter-active_fw8",enterActive:"enter-active_fw8",exit:"exit_N8B"};function R0(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function k0(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return R0(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return R0(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var D0=function(t){var n=t.in,r=t.skipInitial,o=void 0===r||r,a=t.onEnter,l=t.onExit,s=t.children,c=(0,i.useRef)(o);(0,i.useEffect)((function(){n||(c.current=!1)}),[n]);var u=n?c.current?bt.in:bt.enter:bt.exit,d=k0((0,i.useState)(0),2),f=d[0],h=d[1],m=n||f>0,p=(0,i.useRef)(a);p.current=a;var v=(0,i.useRef)(l);v.current=l,(0,i.useEffect)((function(){if(m)return p.current&&p.current(),function(){v.current&&v.current()}}),[m]);var g=(0,i.useCallback)((function(){return h((function(e){return e+1}))}),[]),y=(0,i.useCallback)((function(){return h((function(e){return e-1}))}),[]),b=(0,i.useMemo)((function(){return{state:u,onMount:g,onUnmount:y}}),[g,y,u]),x=(0,i.useContext)(Vt),_=(0,i.useContext)(Ge);return(0,e.jsx)(Gt.Provider,{value:b,children:(0,e.jsx)(Vt.Provider,{value:x||!n,children:(0,e.jsx)(Ge.Provider,{value:n?_:Ve,children:m&&s})})})};const U0="buttons_vR9",F0="button_GlF";var G0=function(t){var n=t.buttons,r=t.onSelect;return(0,e.jsx)("div",{className:U0,children:n.map((function(t){return(0,e.jsx)(V0,{item:t,onSelect:r},t.id)}))})},V0=function(t){var n=t.item,r=t.onSelect,o=(0,i.useContext)(Rl),a=(0,i.useContext)(uP),l=(0,i.useCallback)((function(){return a.onOptionMouseEnter(n.id)}),[n.id,a]),s=(0,i.useCallback)((function(){return a.onOptionMouseLeave(n.id)}),[n.id,a]),c=(0,i.useCallback)((function(){return r(n.id)}),[n.id,r]),u=(0,i.useCallback)((function(){n.confirm?o.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.Options.WARNING,{hash:n.id}),onConfirm:c})):r(n.id)}),[o,c,n.confirm,n.id,r]);return(0,e.jsx)(ml,{focusKey:n.id,disabled:n.disabled,theme:BP,className:F0,onSelect:u,onMouseEnter:l,onMouseLeave:s,children:(0,e.jsx)(Ks.Options.OPTION,{hash:n.id})})};const B0="ellipsis-text-input_h9o",H0="input_MMV",K0="label_qsp";function W0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function z0(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){W0(e,t,n[t])}))}return e}function Y0(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var X0=i.forwardRef((function(t,n){var r=t.value,i=t.maxLength,o=void 0===i?64:i,a=t.theme,l=void 0===a?XE:a,s=t.className,c=Y0(t,["value","maxLength","theme","className"]),u=$E(l);return(0,e.jsxs)(Or,{className:Oe()(B0,u.container,s),children:[(0,e.jsx)(Sp,z0({ref:n,value:r,maxLength:o,className:Oe()(H0,u.input)},c)),(0,e.jsx)("div",{className:Oe()(K0,u.label),children:r||" "})]})})),q0=function(e,t){return e<t?-1:e>t?1:0},$0=function(e,t){var n=e.localeCompare(t);return n?n/Math.abs(n):0},Q0=/(^0x[\da-fA-F]+$|^([+-]?(?:\d+(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+)?(?!\.\d+)(?=\D|\s|$))|\d+)/g,Z0=/^\s+|\s+$/g,J0=/\s+/g,e1=/^[+-]?(?:\d+(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+)?$/,t1=/(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[/-]\d{1,4}[/-]\d{1,4}|^\w+, \w+ \d+, \d{4})/,n1=/^0+[1-9]{1}[0-9]*$/,r1=/[^\x00-\x80]/,i1=function(e,t){return e<t?-1:e>t?1:0},o1=function(e,t){return e.value===t.value?0:void 0!==e.parsedNumber&&void 0!==t.parsedNumber?q0(e.parsedNumber,t.parsedNumber):e.chunks&&t.chunks?function(e,t){for(var n=e.length,r=t.length,i=Math.min(n,r),o=0;o<i;o++){var a=e[o],l=t[o];if(a.normalizedString!==l.normalizedString){if(""===a.normalizedString!=(""===l.normalizedString))return""===a.normalizedString?-1:1;if(void 0!==a.parsedNumber&&void 0!==l.parsedNumber){var s=q0(a.parsedNumber,l.parsedNumber);return 0===s?i1(a.normalizedString,l.normalizedString):s}return void 0!==a.parsedNumber||void 0!==l.parsedNumber?void 0!==a.parsedNumber?-1:1:r1.test(a.normalizedString+l.normalizedString)?$0(a.normalizedString,l.normalizedString):i1(a.normalizedString,l.normalizedString)}}return n>i||r>i?n<=i?-1:1:0}(e.chunks,t.chunks):function(e,t){return(e.chunks?!t.chunks:t.chunks)?e.chunks?-1:1:(e.isNaN?!t.isNaN:t.isNaN)?e.isNaN?-1:1:(e.isSymbol?!t.isSymbol:t.isSymbol)?e.isSymbol?-1:1:(e.isObject?!t.isObject:t.isObject)?e.isObject?-1:1:(e.isArray?!t.isArray:t.isArray)?e.isArray?-1:1:(e.isFunction?!t.isFunction:t.isFunction)?e.isFunction?-1:1:(e.isNull?!t.isNull:t.isNull)?e.isNull?-1:1:0}(e,t)},a1=function(e){return e.replace(J0," ").replace(Z0,"")},l1=function(e){if(0!==e.length){var t=Number(e);if(!Number.isNaN(t))return t}},s1=function(e,t,n){if(e1.test(e)&&(!n1.test(e)||0===t||"."!==n[t-1]))return l1(e)||0},c1=function(e,t,n){return{parsedNumber:s1(e,t,n),normalizedString:a1(e)}},u1=function(e){var t=function(e){return e.replace(Q0,"\0$1\0").replace(/\0$/,"").replace(/^\0/,"").split("\0")}(e).map(c1);return t},d1=function(e){return"function"==typeof e},f1=function(e){return Number.isNaN(e)||e instanceof Number&&Number.isNaN(e.valueOf())},h1=function(e){return null===e},m1=function(e){return!(null===e||"object"!=typeof e||Array.isArray(e)||e instanceof Number||e instanceof String||e instanceof Boolean||e instanceof Date)},p1=function(e){return"symbol"==typeof e},v1=function(e){return void 0===e},g1=function(e){var t=l1(e);return void 0!==t?t:function(e){if(t1.test(e)){var t=Date.parse(e);if(!Number.isNaN(t))return t}}(e)},y1=function(e){if("string"==typeof e||e instanceof String||("number"==typeof e||e instanceof Number)&&!f1(e)||"boolean"==typeof e||e instanceof Boolean||e instanceof Date){var t=function(e){return"boolean"==typeof e||e instanceof Boolean?Number(e).toString():"number"==typeof e||e instanceof Number?e.toString():e instanceof Date?e.getTime().toString():"string"==typeof e||e instanceof String?e.toLowerCase().replace(Z0,""):""}(e),n=g1(t);return{parsedNumber:n,chunks:u1(n?""+n:t),value:e}}return{isArray:Array.isArray(e),isFunction:d1(e),isNaN:f1(e),isNull:h1(e),isObject:m1(e),isSymbol:p1(e),isUndefined:v1(e),value:e}},b1=function(e){return"string"==typeof e&&("asc"===e||"desc"===e)};function x1(e){var t,n;return function(e){return function(t,n){var r=y1(t),i=y1(n);return o1(r,i)*("desc"===e.order?-1:1)}}((n="asc","string"==typeof(t=e)&&b1(t)?n=t:t&&"object"==typeof t&&t.order&&b1(t.order)&&(n=t.order),{order:n}))}const _1={field:"field_zMw",header:"header__eC",icon:"icon_Aag",label:"label_aUL",content:"content_KQe"};var j1=i.createContext(_1),E1=function(t){var n=t.icon,r=t.tinted,o=t.label,a=t.theme,l=t.focusable,s=void 0!==l&&l,c=t.className,u=t.children,d=(0,i.useContext)(j1),f=null!=a?a:d;return(0,e.jsx)(Wn,{children:(0,e.jsxs)(Tr,{focusKey:s?Ie:Te,className:Oe()(f.field,c),children:[(n||o)&&(0,e.jsxs)("div",{className:f.header,children:[n&&(r?(0,e.jsx)(ll,{src:n,className:f.icon}):(0,e.jsx)("img",{src:n,className:f.icon})),o&&(0,e.jsx)("div",{className:f.label,children:o})]}),(0,e.jsx)("div",{className:f.content,children:u})]})})};const O1={button:"button_GME"},T1="detail-section_aIw child-opacity-transition_nkS",I1="title_eSB",S1="image_xzf",w1="scrollable_zgX",N1="scrollable-content_lJB",P1="description_dxc",C1="field_rvA",A1="label_Sfx",L1="value_TJa",M1="theme-icon_mTh",R1="humidity-icon_jtJ",k1="scrollable-footer_VMh",D1="footer_uQp",U1="footer-button_d4A";var F1=function(t){var n=t.title,r=t.preview,o=t.content,a=t.footer,l=t.className,s=i.Children.count(n)>0,c=i.Children.count(o)>0,u=i.Children.count(a)>0;return(0,e.jsxs)("div",{className:Oe()(T1,l),children:[s&&(0,e.jsx)("div",{className:I1,children:n}),null!=r&&(0,e.jsx)(BE,{src:r,className:S1}),(0,e.jsx)(mf,{autoScroll:!0,className:w1,children:c&&(0,e.jsxs)("div",{className:N1,children:[o,!u&&(0,e.jsx)("div",{className:k1})]})}),u&&(0,e.jsx)("div",{className:D1,children:a})]})},G1=function(t){var n=t.label,r=t.children;return(0,e.jsxs)("div",{className:C1,children:[(0,e.jsx)("div",{className:A1,children:n}),(0,e.jsx)("div",{className:L1,children:r})]})},V1=function(t){var n=t.disabled,r=t.children,i=t.className,o=t.onSelect;return(0,e.jsx)(ml,{focusKey:Te,theme:O1,className:Oe()(U1,i),disabled:n,onSelect:o,children:r})};const B1={field:"field_xlu",header:"header_iiq",icon:"icon_lom",label:"label_BcU",content:"content_q4e"};function H1(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function K1(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){H1(e,t,n[t])}))}return e}function W1(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var z1=function(t){var n=t.selectedMap,r=t.selectedTheme,i=t.activeStep,o=t.className,a=t.onContinue,l=t.onStartGameSelect,s=cr(),c=C(Na);return(0,e.jsx)(F1,{className:o,title:null!=n?(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:n.displayName,fallback:n.displayName}):void 0,preview:null==n?void 0:n.preview,content:null!=n?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:P1,children:(0,e.jsx)(Ks.Maps.MAP_DESCRIPTION,{hash:n.displayName,fallback:""})}),null!=r&&(0,e.jsxs)(G1,{label:(0,e.jsx)(Ks.GameListScreen.THEME_LABEL,{}),children:[(0,e.jsx)(As,{src:r.icon,className:M1}),(0,e.jsx)(Ks.Assets.THEME,{hash:r.id})]}),(0,e.jsxs)(G1,{label:(0,e.jsx)(Ks.GameListScreen.CLIMATE_LABEL,{}),children:[(0,e.jsx)("img",{src:Y1(n.cloudiness,n.precipitation),className:R1}),(0,e.jsx)(eh,W1(K1({},n.temperatureRange),{unit:tc.Temperature}))]}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.LATITUDE_LABEL,{}),children:X1(n.latitude)}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.BUILDABLE_AREA_LABEL,{}),children:(0,e.jsx)(dc,{value:Math.round(n.area>0?n.buildableLand/n.area*100:0),unit:tc.Percentage})}),(0,e.jsxs)(G1,{label:(0,e.jsx)(Ks.GameListScreen.CONNECTIONS_LABEL,{}),children:[n.connections.road&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.OUTSIDE_CONNECTIONS,{hash:"Road"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Roads.svg",theme:B1})}),n.connections.train&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.OUTSIDE_CONNECTIONS,{hash:"Train"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Train.svg",theme:B1})}),n.connections.ship&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.OUTSIDE_CONNECTIONS,{hash:"Ship"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Ship.svg",theme:B1})}),n.connections.air&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.OUTSIDE_CONNECTIONS,{hash:"Air"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Airplane.svg",theme:B1})}),n.connections.electricity&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.OUTSIDE_CONNECTIONS,{hash:"Electricity"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Electricity.svg",theme:B1})}),n.connections.water&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.OUTSIDE_CONNECTIONS,{hash:"Water"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Water.svg",theme:B1})})]}),(0,e.jsxs)(G1,{label:(0,e.jsx)(Ks.GameListScreen.RESOURCES_LABEL,{}),children:[n.resources.fertile>=.1&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.RESOURCE,{hash:"Fertility"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Fertility.svg",theme:B1,children:(0,e.jsx)(dc,{value:n.resources.fertile,unit:tc.Area})})}),n.resources.forest>=.1&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.RESOURCE,{hash:"Forest"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Forest.svg",theme:B1,children:(0,e.jsx)(dc,{value:n.resources.forest,unit:tc.Weight})})}),n.resources.ore>=.1&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.RESOURCE,{hash:"Ore"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Ore.svg",theme:B1,children:(0,e.jsx)(dc,{value:n.resources.ore,unit:tc.Weight})})}),n.resources.oil>=.1&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Maps.RESOURCE,{hash:"Oil"}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Oil.svg",theme:B1,children:(0,e.jsx)(dc,{value:n.resources.oil,unit:tc.Weight})})})]})]}):void 0,footer:null==n||s?void 0:i===b2.mapSelection?(0,e.jsx)(V1,{onSelect:a,children:(0,e.jsx)(Ks.Menu.SELECT_MAP_BUTTON,{})}):(0,e.jsx)(V1,{onSelect:l,disabled:!c,children:(0,e.jsx)(Ks.Menu.START_GAME_BUTTON,{})})},null==n?void 0:n.id)};function Y1(e,t){var n=.25*e+.75*t;return n<.1?"Media/Game/Icons/Arid.svg":n<.15?"Media/Game/Icons/SemiArid.svg":n<.2?"Media/Game/Icons/SemiHumid.svg":"Media/Game/Icons/Humid.svg"}function X1(t){return t>15?(0,e.jsx)(Ks.GameListScreen.HEMISPHERE_N,{}):t<-15?(0,e.jsx)(Ks.GameListScreen.HEMISPHERE_S,{}):(0,e.jsx)(Ks.GameListScreen.EQUATOR,{})}const q1="item_6bQ",$1="locked_llh",Q1="thumbnail_jir",Z1="thumbnail-container_JcP",J1="vignette_Gss",e2="title_DFa";var t2=function(t){var n=t.map,r=t.locked,o=t.selected,a=t.onClick,l=(0,i.useCallback)((function(){return a(n.id)}),[n.id,a]);return(0,e.jsxs)(ml,{focusKey:n.id,selected:o,className:Oe()(q1,r&&$1),onClick:l,children:[(0,e.jsxs)("div",{className:Z1,children:[(0,e.jsx)(BE,{src:n.thumbnail,className:Q1}),(0,e.jsx)("div",{className:J1})]}),(0,e.jsx)("div",{className:e2,children:(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:n.displayName,fallback:n.displayName})})]})};const n2="map-grid_EhO child-opacity-transition_nkS",r2="scrollable_Wdh",i2="content_V7r";var o2=i.forwardRef((function(t,n){var r=t.focusKey,o=t.maps,a=t.selectedMap,l=t.className,s=t.onSelectMap,c=(0,i.useCallback)((function(e){"string"==typeof e&&s(e)}),[s]);return(0,e.jsx)("div",{ref:n,className:Oe()(n2,l),children:(0,e.jsx)(mf,{className:r2,children:(0,e.jsx)("div",{className:i2,children:(0,e.jsx)(Mn,{focusKey:r,focused:a,onChange:c,children:o.map((function(t){return(0,e.jsx)(t2,{map:t,locked:t.locked,selected:t.id===a,onClick:s},t.id)}))})})})})}));const a2="content_bgM",l2="step-container_NnT",s2="step_QIP",c2="detail_OCx",u2="header_mQE",d2="no-gamepad_nYD",f2="title_KQ_",h2="tabs_BJl",m2="tab_COL",p2="selected_s7w";function v2(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function g2(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function y2(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return v2(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return v2(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var b2;!function(e){e[e.mapSelection=0]="mapSelection",e[e.mapOptions=1]="mapOptions"}(b2||(b2={}));var x2=i.forwardRef((function(t,n){var r,o=t.focusKey,a=t.className,l=t.onClose,s=y2((0,i.useState)(b2.mapSelection),2),c=s[0],u=s[1],d=function(){var e=bs(),t=C(Zu),n=x1();return(0,i.useMemo)((function(){return t.map((function(t){return{value:t,name:Ks.Maps.MAP_TITLE.renderString(e,{hash:t.displayName})}})).sort((function(e,t){return n(e.name,t.name)})).map((function(e){return e.value}))}),[e,t,n])}(),f=y2((0,i.useState)(rp(d,"id")),2),h=f[0],m=f[1];(0,i.useEffect)((function(){null!==h&&d.findIndex((function(e){return e.id===h}))<0&&m(rp(d,"id"))}),[d,h]);var p,v=null!==(r=d.find((function(e){return e.id===h})))&&void 0!==r?r:null,g=C(Qu),y=C(Yu),b=bs(),x=O2(),_=y2((0,i.useState)(""),2),j=_[0],E=_[1],O=y2((0,i.useState)(""),2),T=O[0],I=O[1],S=y2((0,i.useState)(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){g2(e,t,n[t])}))}return e}({},y)),2),w=S[0],P=S[1],A=null!==(p=g.find((function(e){return e.id===T})))&&void 0!==p?p:null,L=C(Hu),M=C(Ju),R=C(ed);(0,i.useEffect)((function(){null!=(null==v?void 0:v.theme)&&I(null==v?void 0:v.theme)}),[null==v?void 0:v.theme]),(0,i.useEffect)((function(){var e;null!=(null==v?void 0:v.displayName)&&(v.nameAsCityName?E(null!==(e=Ks.Maps.MAP_TITLE.renderString(b,{hash:v.displayName}))&&void 0!==e?e:x()):E(x()))}),[x,b,null==v?void 0:v.displayName,null==v?void 0:v.nameAsCityName]);var k=(0,i.useCallback)((function(){c===b2.mapOptions?(u(b2.mapSelection),Jt(Qt.closeMenu)):l()}),[c,l]),D=(0,i.useCallback)((function(){u(b2.mapOptions),Jt(Qt.openMenu)}),[]),U=(0,i.useCallback)((function(){var e;e=v.id,N(Lu,"shareMap",e)}),[v]),F=y2(ud(),2),G=F[0],V=F[1],B=(0,i.useCallback)((function(){null!=h&&(cd(G),N(Lu,"newGame",{mapId:h,cityName:j,theme:T,options:w}))}),[h,G,j,T,w]),H=(0,i.useMemo)((function(){return{Select:c===b2.mapSelection?function(){Jt(Qt.selectItem),D()}:null,"Start Game":c===b2.mapOptions?function(){Jt(Qt.selectItem),B()}:null,"Switch Tab":c===b2.mapSelection&&M.length>=2?function(e){var t=M.indexOf(R);gd(t>=0?M[(t+e+M.length)%M.length]:M[0])}:null}}),[c,M,D,B,R]);return(0,e.jsx)(RP,{ref:n,focusKey:o,title:_2(c),className:a,onClose:k,children:(0,e.jsx)(Tn,{actions:H,children:(0,e.jsx)(Ze,{focused:c,activation:Ue.Always,children:(0,e.jsxs)("div",{className:a2,children:[(0,e.jsx)("div",{className:l2,children:(0,e.jsxs)(nO,{children:[c===b2.mapSelection&&(0,e.jsx)($t,{styles:M0,children:(0,e.jsx)(o2,{focusKey:b2.mapSelection,maps:d,selectedMap:h,className:s2,onSelectMap:m})},b2.mapSelection),c===b2.mapOptions&&(0,e.jsx)($t,{styles:$A,children:(0,e.jsx)(e3,{focusKey:b2.mapOptions,cityName:j,theme:T,options:w,className:s2,onCityNameChange:E,onThemeChange:I,onOptionsChange:P,tutorialState:G,setTutorialState:V,onShareGame:L||(null==v?void 0:v.isReadonly)?void 0:U,shareGameLocaleKey:"shareMap"})},b2.mapOptions)]})}),(0,e.jsx)(z1,{selectedMap:v,selectedTheme:A,activeStep:c,className:c2,onContinue:D,onStartGameSelect:B})]})})})})}));function _2(t){return t===b2.mapSelection?(0,e.jsx)(j2,{}):t===b2.mapOptions?(0,e.jsx)(Ks.Menu.MAP_OPTIONS,{}):null}var j2=function(){var t=cr(),n=C(Ju),r=C(ed);return(0,e.jsxs)("div",{className:Oe()(u2,!t&&d2),children:[(0,e.jsx)("div",{className:f2,children:(0,e.jsx)(Ks.Menu.NEW_GAME,{})}),n.length>=2&&(0,e.jsx)("div",{className:h2,children:n.map((function(t){return(0,e.jsx)(E2,{filter:t,selectedFilter:r},t)}))})]})},E2=function(t){var n=t.filter,r=t.selectedFilter,o=(0,i.useCallback)((function(){return gd(n)}),[n]);return(0,e.jsx)(ml,{className:Oe()(m2,PP,r===n&&p2),onSelect:o,focusKey:Te,children:(0,e.jsx)(Ks.GameListScreen.MAP_FILTER,{hash:Au[n]})})};function O2(){var e=bs(),t=M($f,"Assets.CITY_NAME");return(0,i.useCallback)((function(n){if(0===t)return"";var r=Math.floor(Math.random()*t),i=Ks.Assets.CITY_NAME.renderString(e,{index:r});return i===n&&(r=(r+1)%t,i=Ks.Assets.CITY_NAME.renderString(e,{index:r})),i}),[t,e])}const T2={container:"container_AwD",input:"input_Hft",label:"label_lus"},I2={field:"field_iTK field_cjf",label:"label_TLv label_T__"},S2="city-name-field_H7e value-field_yJi",w2="input_RLt",N2="dice-button_U3N secondary-button_Kvj";function P2(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function C2(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return P2(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return P2(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var A2=function(t){var n=t.id,r=t.label,o=t.value,a=t.disabled,l=t.onChange,s=C2((0,i.useState)(o),2),c=s[0],u=s[1];(0,i.useEffect)((function(){return u(o)}),[o]);var d=(0,i.useCallback)((function(e){u(e.target.value),l(e.target.value)}),[l]),f=O2(),h=(0,i.useCallback)((function(){return l(f(o))}),[f,l,o]);return(0,e.jsx)(vP,{id:n,label:r,theme:I2,disabled:a,children:(0,e.jsx)("div",{className:S2,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(X0,{value:c,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"CityName"}),className:w2,theme:T2,onChange:d,maxLength:85}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Menu.RANDOM_CITY_NAME_BUTTON_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Dice.svg",sounds:pP,selectSound:Qt.generateRandomName,className:N2,onSelect:h})})]})})})};const L2={"theme-item":"theme-item_qct",themeItem:"theme-item_qct","theme-icon":"theme-icon_jJ9",themeIcon:"theme-icon_jJ9","theme-name":"theme-name_hYf",themeName:"theme-name_hYf"};var M2=function(t){var n,r=t.id,i=t.label,o=t.value,a=t.disabled,l=t.onChange,s=C(Qu),c=s.find((function(e){return e.id===o}));return(0,e.jsx)(vP,{id:r,label:i,theme:I2,disabled:a,className:L2.themeField,children:(0,e.jsx)(fC,{focusKey:a?Te:Ie,initialFocused:o,theme:jC,content:s.map((function(t){return(0,e.jsxs)(_C,{focusKey:t.id,value:t.id,className:L2.themeItem,onChange:l,children:[(0,e.jsx)(As,{src:t.icon,className:L2.themeIcon}),(0,e.jsx)("div",{className:L2.themeName,children:(0,e.jsx)(Ks.Assets.THEME,{hash:t.id})})]},t.id)})),children:(0,e.jsx)(gC,{disabled:a,sounds:pP,children:(0,e.jsxs)("div",{className:L2.themeItem,children:[(0,e.jsx)(As,{src:null!==(n=null==c?void 0:c.icon)&&void 0!==n?n:"Media/Placeholder.svg",className:L2.themeIcon}),(0,e.jsx)("div",{className:L2.themeName,children:(0,e.jsx)(Ks.Assets.THEME,{hash:o})})]})})})})};const R2={base:"base_mxi",enter:"enter_H6J","exit-active":"exit-active_jeC",exitActive:"exit-active_jeC","enter-active":"enter-active_YSl",enterActive:"enter-active_YSl",exit:"exit_OM8"},k2="game-options_iDr child-opacity-transition_nkS",D2="main-row_a1n",U2="options-column_l0j",F2="toggle-item_uwk",G2="info-column_IaC",V2="info-title_oAQ",B2="tutorial-options-title_qO8 info-title_oAQ",H2="info-description_NL4",K2="achievements-warning-row_Y_z",W2="achievements-warning_W0f",z2="space_NYm";function Y2(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function X2(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function q2(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function $2(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Y2(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Y2(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Q2,Z2="cityName",J2="theme",e3=i.forwardRef((function(t,n){var r=t.focusKey,o=t.cityName,a=t.theme,l=t.options,s=t.tutorialState,c=t.disabledOptions,u=void 0===c?[]:c,d=t.className,f=t.onCityNameChange,h=t.onThemeChange,m=t.onOptionsChange,p=t.onDeleteGame,v=t.onShareGame,g=t.setTutorialState,y=t.shareGameLocaleKey,b=$2((0,i.useState)(!1),2),x=b[0],_=b[1],j=cr(),E=C(Gu),O=C(Vu),T=(0,i.useCallback)((function(e,t){m&&m(q2(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){X2(e,t,n[t])}))}return e}({},l),X2({},e,t)))}),[l,m]),I=$2((0,i.useState)(Z2),2),S=I[0],w=I[1],N=(0,i.useCallback)((function(e){"string"==typeof e&&w(e)}),[]),P=$2((0,i.useState)(null),2),A=P[0],L=P[1],M=(0,i.useMemo)((function(){return{onOptionMouseEnter:function(e){return L(e)},onOptionMouseLeave:function(e){return L((function(t){return t===e?null:t}))}}}),[]),R=null!=A?A:x&&j?S:null,k=C(Uu),D=null!=y?y:"shareSave",U=(0,i.useCallback)((function(e){"deleteSave"===e&&p(),e===D&&v()}),[p,v,D]);return(0,e.jsx)(Jh,{onFocusChange:_,children:(0,e.jsxs)("div",{ref:n,className:Oe()(k2,d),children:[(0,e.jsxs)("div",{className:D2,children:[(0,e.jsx)("div",{className:U2,children:(0,e.jsx)(uP.Provider,{value:M,children:(0,e.jsxs)(Mn,{focusKey:r,focused:S,onChange:N,direction:On.Both,children:[(0,e.jsx)(A2,{id:Z2,label:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:Z2}),value:o,disabled:u.includes(Z2),onChange:f}),(0,e.jsx)(M2,{id:J2,label:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:J2}),value:a,disabled:u.includes(J2),onChange:h}),(0,e.jsx)(ZP,{}),Object.entries(l).filter((function(e){var t=$2(e,2),n=t[0];t[1];return"__Type"!==n})).map((function(t){var n=$2(t,2),r=n[0],i=n[1];return(0,e.jsx)(t3,{id:r,value:i,disabled:u.includes(r),onChange:T},r)})),(0,e.jsx)(ZP,{}),(0,e.jsx)("div",{className:Oe()(V2,B2),children:(0,e.jsx)(Ks.GameListScreen.TUTORIAL_OPTIONS,{})}),(0,e.jsx)(TP,{id:k?"continueTutorials":"beginTutorials",label:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:k?"continueTutorials":"beginTutorials"}),value:Mu.Continue,groupValue:s,className:F2,onChange:g}),k&&(0,e.jsx)(TP,{id:"restartTutorials",label:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:"restartTutorials"}),value:Mu.Reset,groupValue:s,className:F2,onChange:g}),(0,e.jsx)(TP,{id:"disableTutorials",label:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:"disableTutorials"}),value:Mu.Disable,groupValue:s,className:F2,onChange:g}),(null!=p||null!=v)&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(ZP,{}),(0,e.jsx)(G0,{buttons:[null!=p?{id:"deleteSave",disabled:!1,confirm:!0}:null,null!=v?{id:D,disabled:!O,confirm:!1}:null].filter(sp),onSelect:U})]})]})})}),(0,e.jsx)("div",{className:G2,children:null!=R&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:V2,children:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:R})}),(0,e.jsx)("div",{className:H2,children:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION_DESCRIPTION,{hash:R})})]})})]}),(0,e.jsx)(D0,{in:E||l.unlockAll||l.unlimitedMoney,children:(0,e.jsx)(lJ,{styles:R2,children:(0,e.jsxs)("div",{className:K2,children:[(0,e.jsx)("div",{className:W2,children:E?(0,e.jsx)(Ks.Menu.ACHIEVEMENTS_WARNING_MODS,{}):(0,e.jsx)(Ks.Menu.ACHIEVEMENTS_WARNING_GAME_OPTIONS,{})}),(0,e.jsx)("div",{className:z2})]})})})]})})})),t3=function(t){var n=t.id,r=t.value,o=t.disabled,a=t.onChange,l=(0,i.useCallback)((function(e){return a(n,e)}),[n,a]);return(0,e.jsx)(OP,{id:n,value:r,label:(0,e.jsx)(Ks.GameListScreen.GAME_OPTION,{hash:n}),disabled:o,className:F2,onChange:l})};function n3(e,t){var n=x1();return e.sort((function(e,r){switch(t){case Q2.LastModified:return new Date(r.lastModified).getTime()-new Date(e.lastModified).getTime()||n(e.displayName,r.displayName);case Q2.Population:return r.population-e.population||n(e.displayName,r.displayName);default:return n(e.displayName,r.displayName)}}))}!function(e){e[e.Name=0]="Name",e[e.LastModified=1]="LastModified",e[e.Population=2]="Population"}(Q2||(Q2={}));var r3=function(t){var n,r=t.save,i=t.activeStep,o=t.className,a=t.onOptionsToggle,l=t.onLoadGameSelect,s=C(Na),c=cr(),u=null!=r&&r.locked,d=null!==(n=C(Qu).find((function(e){return e.id===(null==r?void 0:r.theme)})))&&void 0!==n?n:null;return(0,e.jsx)(F1,{className:o,title:null!=r?r.displayName:void 0,preview:null==r?void 0:r.preview,content:null!=r?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.Menu.CITY_NAME_LABEL,{}),children:r.cityName}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.POPULATION_LABEL,{}),children:(0,e.jsx)(dc,{value:r.population,unit:tc.Integer})}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.Menu.SIMULATION_DATE_LABEL,{}),children:(0,e.jsx)(Js,{value:r.simulationDate})}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.MONEY_LABEL,{}),children:r.options.unlimitedMoney?(0,e.jsx)(Ks.Menu.UNLIMITED_MONEY_LABEL,{}):(0,e.jsx)(dc,{value:r.money,unit:tc.Money})}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.XP_LABEL,{}),children:(0,e.jsx)(dc,{value:r.xp,unit:tc.Integer})}),null!=r.mapName&&(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.MAP_LABEL,{}),children:(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:r.mapName})}),null!=d&&(0,e.jsxs)(G1,{label:(0,e.jsx)(Ks.GameListScreen.THEME_LABEL,{}),children:[(0,e.jsx)(As,{src:d.icon,className:M1}),(0,e.jsx)(Ks.Assets.THEME,{hash:d.id})]})]}):void 0,footer:null==r||c?void 0:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(V1,{disabled:u||!s,onSelect:l,children:(0,e.jsx)(Ks.Menu.LOAD_GAME_BUTTON,{})}),(0,e.jsx)(V1,{disabled:u,onSelect:a,children:i===h8.options?(0,e.jsx)(Ks.Menu.SAVE_LIST,{}):(0,e.jsx)(Ks.Menu.SAVE_OPTIONS,{})})]})})};const i3="save-list-header_f5S",o3="sort-label_KDJ",a3="sort-buttons_vQU",l3="sort-button_UDY";var s3=[Q2.Name,Q2.LastModified,Q2.Population],c3=function(t){var n=t.selectedOrdering,r=t.className,i=t.onSelectOrdering;return(0,e.jsx)(d3,{label:(0,e.jsx)(Ks.Menu.SAVE_ORDERING_LABEL,{}),options:s3,selectedOption:n,onSelectOption:i,getOptionLabel:function(t){return(0,e.jsx)(Ks.Menu.SAVE_ORDERING,{hash:Q2[t]})},className:r})},u3=function(t){var n=t.targets,r=t.selectedTarget,i=t.className,o=t.onSelectTarget;return(0,e.jsx)(d3,{label:(0,e.jsx)(Ks.Menu.CLOUD_TARGET_LABEL,{}),options:n,selectedOption:r,onSelectOption:o,getOptionLabel:function(t){return(0,e.jsx)(Ks.Menu.CLOUD_TARGET,{hash:t})},className:i})};function d3(t){var n=t.label,r=t.options,i=t.selectedOption,o=t.className,a=t.onSelectOption,l=t.getOptionLabel;return(0,e.jsxs)("div",{className:Oe()(i3,o),children:[(0,e.jsx)("div",{className:o3,children:n}),(0,e.jsx)("div",{className:a3,children:r.map((function(t,n){return(0,e.jsx)(ml,{focusKey:Te,selected:i===t,className:l3,onSelect:function(){return a(t)},children:l(t)},n)}))})]})}const f3="42rem",h3="save-list_gdH child-opacity-transition_nkS",m3="scrollable_C4r";var p3=(0,i.forwardRef)((function(t,n){var r=t.selectedSave,o=t.ordering,a=t.className,l=t.onSelectSave,s=t.onSelectOrdering,c=C(td),u=(0,i.useMemo)((function(){return n3(c,o)}),[o,c]),d=$X(Xd(f3),u.length,3),f=(0,i.useMemo)((function(){return{"Switch Ordering":function(e){var t;if(Jt(Qt.dragSlider),e<0)Jt(Qt.selectPreviousItem),s(null!==(t=ap(s3,s3.indexOf(o),!0))&&void 0!==t?t:o);else if(e>0){var n;Jt(Qt.selectNextItem),s(null!==(n=ip(s3,s3.indexOf(o),!0))&&void 0!==n?n:o)}}}}),[s,o]),h=(0,i.useCallback)((function(e){"string"==typeof e&&l(e)}),[l]),m=(0,i.useCallback)((function(e){return l(e.id)}),[l]),p=(0,i.useCallback)((function(t){var n=u[t];return(0,e.jsx)(wd,{save:n,selected:r===n.displayName||r===n.id,locked:!1,tooltipsInactive:!0,onClick:m},n.id)}),[m,r,u,o]);return(0,e.jsx)(Tn,{actions:f,children:(0,e.jsxs)("div",{ref:n,className:Oe()(h3,a),children:[(0,e.jsx)(c3,{selectedOrdering:o,onSelectOrdering:s}),(0,e.jsx)(Mn,{focused:r,onChange:h,children:(0,e.jsx)(YX,{className:Oe()(m3),sizeProvider:d,renderItem:p})})]})})})),v3=function(t){var n=t.title,r=t.message,o=t.onConfirm,a=(0,i.useContext)(kl),l=(0,i.useCallback)((function(){a.onClose(),o&&o()}),[a,o]);return(0,e.jsx)(Al,{title:n,buttons:(0,e.jsx)("div",{className:Il.buttons,children:(0,e.jsx)(Fn,{children:(0,e.jsx)(ml,{theme:Ad,className:Il.buttonOk,onSelect:l,children:(0,e.jsx)(Ks.Common.OK,{})})})}),onClose:a.onClose,children:(0,e.jsx)(fI,{theme:Il,children:r})})},g3=E("toolbarBottom","population"),y3=E("toolbarBottom","populationDelta"),b3=E("toolbarBottom","money"),x3=E("toolbarBottom","moneyDelta"),_3=E("toolbarBottom","cityName"),j3=E("toolbarBottom","unlimitedMoney"),E3=E("toolbarBottom","populationTrendThresholds"),O3=E("toolbarBottom","moneyTrendThresholds");var T3,I3="milestone",S3={entity:ii,index:0,xpRequirement:0,reward:0,devTreePoints:0,mapTiles:0,loanLimit:0,image:"Media/Placeholder.svg",backgroundColor:{r:0,g:0,b:0,a:0},accentColor:{r:.18,g:.235,b:.337,a:1},textColor:{r:1,g:1,b:1,a:1},locked:!1};!function(e){e.Feature="milestone.Feature",e.Service="milestone.Service",e.Zone="milestone.Asset",e.Policy="milestone.Policy"}(T3||(T3={}));var w3=E(I3,"achievedMilestone"),N3=E(I3,"achievedMilestoneXP"),P3=E(I3,"nextMilestoneXP"),C3=E(I3,"totalXP"),A3=I(I3,"xpMessageAdded"),L3=E(I3,"maxMilestoneReached"),M3=E(I3,"milestones"),R3=E(I3,"unlockedMilestone",ii);function k3(){N(I3,"clearUnlockedMilestone")}var D3=T(I3,"milestoneDetails"),U3=T(I3,"milestoneUnlocks"),F3=T(I3,"unlockDetails"),G3=function(t){var n=t.className,r=t.onSaveGameSelect,i=cr(),o=C(Na),a=C(Ku),l=C(_3),s=C(g3),c=C(b3),u=C(C3),d=C(Wu),f=Zp(C(Gp),C(Vp)),h=C(j3),m=C(rd);return(0,e.jsx)(F1,{className:n,title:l,preview:a,content:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.Menu.CITY_NAME_LABEL,{}),children:l}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.POPULATION_LABEL,{}),children:(0,e.jsx)(dc,{value:s,unit:tc.Integer})}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.Menu.SIMULATION_DATE_LABEL,{}),children:(0,e.jsx)(Js,{value:f})}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.MONEY_LABEL,{}),children:h?(0,e.jsx)(Ks.Menu.UNLIMITED_MONEY_LABEL,{}):(0,e.jsx)(dc,{value:c,unit:tc.Money})}),(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.XP_LABEL,{}),children:(0,e.jsx)(dc,{value:u,unit:tc.Integer})}),null!=d&&(0,e.jsx)(G1,{label:(0,e.jsx)(Ks.GameListScreen.MAP_LABEL,{}),children:(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:d})})]}),footer:i?void 0:(0,e.jsx)(xO,{tooltip:m.reasonHash&&(0,e.jsx)(Ks.Common.SAVEABILITY_REASON,{hash:m.reasonHash}),children:(0,e.jsx)(V1,{onSelect:r,disabled:!m.canSave||!o,children:(0,e.jsx)(Ks.GameListScreen.SAVE_GAME_BUTTON,{})})})})};const V3="42rem",B3="save-list_zHX child-opacity-transition_nkS",H3="scrollable_t4Z",K3="name-field_FGr";function W3(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function z3(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return W3(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return W3(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Y3=new Se("nameField"),X3=i.forwardRef((function(t,n){var r=t.saveName,o=t.cloudTarget,a=t.className,l=t.onSaveNameChange,s=t.onSelectCloudTarget,c=C(hd),u=z3((0,i.useState)(Y3),2),d=u[0],f=u[1],h=C(td),m=(0,i.useMemo)((function(){return n3(h.filter((function(e){return!e.isReadonly&&e.cloudTarget===o&&!e.autoSave})),Q2.LastModified)}),[o,h]),p=(0,i.useRef)(null),v=$X(Xd(V3),m.length,3);(0,i.useEffect)((function(){if(p.current){p.current.focus();var e=p.current.value.length;p.current.setSelectionRange(0,e)}}),[]);var g=(0,i.useMemo)((function(){return c.length>1?{"Switch Savegame Location":function(e){var t;if(Jt(Qt.dragSlider),e<0)Jt(Qt.selectPreviousItem),s(null!==(t=ap(c,c.indexOf(o),!0))&&void 0!==t?t:o);else if(e>0){var n;Jt(Qt.selectNextItem),s(null!==(n=ip(c,c.indexOf(o),!0))&&void 0!==n?n:o)}}}:{}}),[s,c,o]),y=(0,i.useCallback)((function(e){if("string"!=typeof e)f(Y3);else{var t=h.find((function(t){return t.id===e}));null!=t&&(f(e),l(t.displayName),p.current&&p.current.blur())}}),[l,h]),b=(0,i.useCallback)((function(e){f(e.id),l(e.displayName),p.current&&p.current.blur()}),[l]),x=(0,i.useCallback)((function(e){return l(e.target.value)}),[l]),_=(0,i.useCallback)((function(t){var n=m[t];return(0,e.jsx)(wd,{save:n,selected:r===n.displayName&&d===n.id,locked:!1,tooltipsInactive:!0,onClick:b},n.id)}),[d,b,r,m]);return(0,e.jsx)(Tn,{actions:g,children:(0,e.jsxs)("div",{ref:n,className:Oe()(B3,a),children:[c.length>1&&(0,e.jsx)(u3,{targets:c,selectedTarget:o,onSelectTarget:s}),(0,e.jsxs)(Mn,{focused:d,onChange:y,children:[(0,e.jsx)(YX,{className:Oe()(H3),sizeProvider:v,renderItem:_}),(0,e.jsx)("div",{className:K3,children:(0,e.jsx)(X0,{ref:p,maxLength:85,focusKey:Y3,placeholder:(0,e.jsx)(Ks.Menu.NAME_FIELD_PLACEHOLDER,{}),value:r,onChange:x,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"SaveName"}),theme:T2})})]})]})})}));const q3="save-slot-list_MCn child-opacity-transition_nkS",$3="scrollable_W3E";var Q3=i.forwardRef((function(t,n){var r=t.sortedSaves,o=t.saveName,a=t.cloudTarget,l=t.slots,s=t.selectedSlotId,c=t.className,u=t.onSaveNameChange,d=t.onSelectCloudTarget,f=t.onSelectSlot,h=C(hd),m=(0,i.useMemo)((function(){return h.length>1?{"Switch Savegame Location":function(e){var t;if(Jt(Qt.dragSlider),e<0)Jt(Qt.selectPreviousItem),d(null!==(t=ap(h,h.indexOf(a),!0))&&void 0!==t?t:a);else if(e>0){var n;Jt(Qt.selectNextItem),d(null!==(n=ip(h,h.indexOf(a),!0))&&void 0!==n?n:a)}}}:{}}),[d,h,a]);return(0,e.jsx)(Tn,{actions:m,children:(0,e.jsxs)("div",{ref:n,className:Oe()(q3,c),children:[h.length>1&&(0,e.jsx)(u3,{targets:h,selectedTarget:a,onSelectTarget:d}),(0,e.jsx)(Fn,{initialFocused:s>r.length-1?"Save->Empty:".concat(s):"Save->".concat(r[s].id),children:(0,e.jsx)(mf,{className:$3,children:Array.from({length:l},(function(t,n){return n>r.length-1?(0,e.jsx)(M5,{focusKey:"Save->Empty:".concat(n),slotId:n,selected:s===n,saveName:o,onSaveNameChange:u,onSelect:f},n):(0,e.jsx)(M5,{focusKey:"Save->".concat(r[n].id),slotId:n,selected:s===n,saveGame:r[n],saveName:o,onSaveNameChange:u,onSelect:f},n)}))})})]})})}));const Z3={container:"container_K3P",input:"input_f_x",label:"label_OFp"},J3="save-slot_vY4 child-opacity-transition_nkS",e5="title_L43",t5="field_Yxz",n5="empty-label_OR4",r5="title-content_SFM",i5="image_u6c",o5="scrollable_khn",a5="scrollable-content_hzP",l5="label_out",s5="value_wmH",c5="scrollable-footer_nav";var u5=function(t){var n=t.focusKey,r=t.slotId,o=t.saveName,a=t.saveGame,l=t.selected,s=void 0!==l&&l,c=t.className,u=t.onSaveNameChange,d=t.onSelect,f=(0,i.useRef)(null);(0,i.useEffect)((function(){if(s){if(f.current){f.current.focus();var e=f.current.value.length;f.current.setSelectionRange(0,e)}a?u&&u(a.displayName):o&&u&&u(o)}}),[u,d,a,o,s]);var h,m,p,v,g,y=C(Ku),b=C(_3),x=C(g3),_=C(b3),j=C(C3),E=C(Wu),O=Zp(C(Gp),C(Vp)),T=C(j3),I=(0,i.useCallback)((function(e){return u&&u(e.target.value)}),[u]),S=(0,i.useCallback)((function(e){e&&(d(r),a&&u&&u(a.displayName))}),[u,d,a,r]),w=(0,i.useCallback)((function(){a&&u&&u(a.displayName),f.current&&f.current.focus(),d(r)}),[u,d,a,r]),N=(0,i.useCallback)((function(){if(!o){var e=E5();u&&u(e)}}),[u,o]);return(0,e.jsxs)(Tr,{focusKey:n,onFocusChange:S,onClick:w,className:Oe()(J3,s&&"selected",c),children:[(a||s)&&(0,e.jsx)("div",{className:e5,children:(0,e.jsx)("div",{className:r5,children:!a&&s?(0,e.jsx)(X0,{ref:f,maxLength:85,placeholder:(0,e.jsx)(Ks.Menu.NAME_FIELD_PLACEHOLDER,{}),value:o,onChange:I,onBlur:N,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"SaveName"}),theme:Z3}):null==a?void 0:a.displayName})}),a?s?null!=y&&(0,e.jsx)(BE,{src:y,className:i5}):(0,e.jsx)(BE,{src:null==a?void 0:a.preview,className:i5}):null!=y&&s&&(0,e.jsx)(BE,{src:y,className:i5}),(0,e.jsx)(mf,{autoScroll:!0,className:o5,children:(0,e.jsxs)("div",{className:a5,children:[a||s?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.Menu.CITY_NAME_LABEL,{}),children:null!==(h=null==a?void 0:a.cityName)&&void 0!==h?h:b}),(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.GameListScreen.POPULATION_LABEL,{}),children:(0,e.jsx)(dc,{value:null!==(m=null==a?void 0:a.population)&&void 0!==m?m:x,unit:tc.Integer})}),(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.Menu.SIMULATION_DATE_LABEL,{}),children:(0,e.jsx)(Js,{value:null!==(p=null==a?void 0:a.simulationDate)&&void 0!==p?p:O})}),(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.GameListScreen.MONEY_LABEL,{}),children:!a&&T?(0,e.jsx)(Ks.Menu.UNLIMITED_MONEY_LABEL,{}):(0,e.jsx)(dc,{value:null!==(v=null==a?void 0:a.money)&&void 0!==v?v:_,unit:tc.Money})}),(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.GameListScreen.XP_LABEL,{}),children:(0,e.jsx)(dc,{value:null!==(g=null==a?void 0:a.xp)&&void 0!==g?g:j,unit:tc.Integer})}),null!=(null==a?void 0:a.mapName)?(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.GameListScreen.MAP_LABEL,{}),children:(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:a.mapName})}):null!=E&&(0,e.jsx)(d5,{label:(0,e.jsx)(Ks.GameListScreen.MAP_LABEL,{}),children:(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:E})})]}):(0,e.jsx)("div",{className:n5,children:(0,e.jsx)(Ks.Menu.EMPTY_SLOT,{})}),(0,e.jsx)("div",{className:c5})]})})]})},d5=function(t){var n=t.label,r=t.children;return(0,e.jsxs)("div",{className:t5,children:[(0,e.jsx)("div",{className:l5,children:n}),(0,e.jsx)("div",{className:s5,children:r})]})};const f5="save-game-slots_y4R",h5="header_iE9 child-opacity-transition_nkS",m5="slots_s__",p5="slot_DnC";var v5=function(t){var n=t.sortedSaves,r=t.saveName,o=t.cloudTarget,a=t.slots,l=t.selectedSlotId,s=t.className,c=t.onSaveNameChange,u=t.onSelectCloudTarget,d=t.onSelectSlot,f=C(hd),h=(0,i.useMemo)((function(){return f.length>1?{"Switch Savegame Location":function(e){var t;if(Jt(Qt.dragSlider),e<0)Jt(Qt.selectPreviousItem),u(null!==(t=ap(f,f.indexOf(o),!0))&&void 0!==t?t:o);else if(e>0){var n;Jt(Qt.selectNextItem),u(null!==(n=ip(f,f.indexOf(o),!0))&&void 0!==n?n:o)}}}:{}}),[u,f,o]),m=(0,i.useMemo)((function(){var e;return!n||0===n.length||l>n.length-1?"Save->Empty:".concat(l):"Save->".concat(null===(e=n[l])||void 0===e?void 0:e.id)}),[l,n]);return(0,e.jsx)(Tn,{actions:h,children:(0,e.jsxs)("div",{className:Oe()(f5,s),children:[f.length>1&&(0,e.jsx)(u3,{targets:f,selectedTarget:o,onSelectTarget:u,className:h5}),(0,e.jsx)("div",{className:m5,children:(0,e.jsx)(Fn,{initialFocused:m,children:Array.from({length:a},(function(t,i){return!n||0===n.length||i>n.length-1?(0,e.jsx)(u5,{slotId:i,saveName:r,focusKey:"Save->Empty:".concat(i),className:p5,selected:l===i,onSelect:d,onSaveNameChange:c},i):(0,e.jsx)(u5,{slotId:i,focusKey:"Save->".concat(n[i].id),saveGame:n[i],selected:l===i,className:p5,onSelect:d,onSaveNameChange:c},i)}))})})]})})};const g5="content_ZK4",y5="list_Lyo",b5="detail_LOs";function x5(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _5(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return x5(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return x5(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var j5=i.forwardRef((function(t,n){var r=t.focusKey,o=t.className,a=t.onClose;(0,i.useEffect)((function(){return sd(!0),function(){return sd(!1)}}),[]);var l=C(qu),s=C(td),c=C(md),d=(0,i.useMemo)((function(){return n3(s.filter((function(e){return!e.isReadonly&&e.cloudTarget===c&&!e.autoSave})),Q2.LastModified)}),[c,s]),f=_5((0,i.useState)(E5),2),h=f[0],m=f[1],p=_5((0,i.useState)(function(e,t){var n=e.findIndex((function(e){return e.displayName===t}));return n>0?n:0}(d,h)),2),v=p[0],g=p[1],y=(0,i.useContext)(Rl),b=(0,i.useCallback)((function(){var t=h.trim();u(h)?y.showDialog((0,e.jsx)(v3,{title:(0,e.jsx)(Ks.Common.ERROR,{}),message:(0,e.jsx)(Ks.GameListScreen.INVALID_NAME_MESSAGE,{})})):function(e){N(Lu,"saveGame",e)}(t)}),[y,h]),x=C(rd),_=(0,i.useMemo)((function(){return x.canSave?{"Save Game":function(){Jt(Qt.selectItem),b()}}:{}}),[b,x.canSave]);return(0,e.jsx)(RP,{ref:n,focusKey:r,title:(0,e.jsx)(Ks.Menu.SAVE_GAME,{}),className:o,onClose:a,children:(0,e.jsx)(Tn,{actions:_,children:(0,e.jsx)("div",{className:g5,children:l>3?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Q3,{slots:l,selectedSlotId:v,sortedSaves:d,saveName:h,cloudTarget:c,onSelectCloudTarget:vd,onSaveNameChange:m,onSelectSlot:g,className:y5}),(0,e.jsx)(G3,{className:b5,onSaveGameSelect:b})]}):l>0?(0,e.jsx)(v5,{slots:l,selectedSlotId:v,sortedSaves:d,saveName:h,cloudTarget:c,onSaveNameChange:m,onSelectCloudTarget:vd,onSelectSlot:g}):(0,e.jsxs)(Fn,{children:[(0,e.jsx)(X3,{saveName:h,cloudTarget:c,onSelectCloudTarget:vd,onSaveNameChange:m,className:y5}),(0,e.jsx)(G3,{className:b5,onSaveGameSelect:b})]})})})})}));function E5(){var e;return null!==(e=zu.value)&&void 0!==e?e:_3.value}const O5={container:"container_vNp",input:"input_Lfn",label:"label_F5D"},T5="save-slot-item_oai",I5="locked_k9Y",S5="theme-icon_tB3",w5="title_Y9K",N5="population-value_XhI",P5="population-icon_aqa",C5="date_Oac",A5="state-icon_zkF",L5="title-inner_nf4";var M5=function(t){var n=t.focusKey,r=t.locked,o=void 0!==r&&r,a=t.selected,l=void 0!==a&&a,s=t.saveName,c=t.saveGame,u=t.slotId,d=t.onSaveNameChange,f=t.onSelectSave,h=t.onSelect,m=(0,i.useRef)(null),p=C(Qu).find((function(e){return e.id===(null==c?void 0:c.theme)})),v=c?Nd(c.cloudTarget,c.isReadonly):null;(0,i.useEffect)((function(){if(l){if(m.current){m.current.focus();var e=m.current.value.length;m.current.setSelectionRange(0,e)}c?(d&&d(c.displayName),f&&f(c)):s&&d&&d(s)}}),[d,h,f,c,s,l]);var g,y=(0,i.useCallback)((function(e){return d&&d(e.target.value)}),[d]),b=(0,i.useCallback)((function(e){e&&(c&&(f&&f(c),d&&d(c.displayName)),h&&h(u))}),[d,h,f,c,u]),x=(0,i.useCallback)((function(){c&&(o||f&&f(c),d&&d(c.displayName)),o||h&&h(u)}),[o,d,h,f,c,u]),_=(0,i.useCallback)((function(){if(!s){var e=E5();d&&d(e)}}),[d,s]);return(0,e.jsxs)(Tr,{onClick:x,focusKey:o?Te:n||Te,className:Oe()(T5,o&&I5,l&&"selected"),onFocusChange:b,children:[c&&(0,e.jsx)(As,{src:null!==(g=null==p?void 0:p.icon)&&void 0!==g?g:"",className:S5}),null!=v&&(0,e.jsx)(ll,{src:v,className:A5}),(0,e.jsx)("div",{className:w5,children:!c&&l?(0,e.jsx)(X0,{ref:m,maxLength:85,placeholder:(0,e.jsx)(Ks.Menu.NAME_FIELD_PLACEHOLDER,{}),value:s,onChange:y,onBlur:_,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"SaveName"}),theme:O5}):(0,e.jsx)("div",{className:L5,children:c?c.displayName:(0,e.jsx)(Ks.Menu.EMPTY_SLOT,{})})}),c&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:N5,children:(0,e.jsx)(dc,{value:c.population,unit:tc.Integer})}),(0,e.jsx)(ll,{src:"Media/Game/Icons/Citizen.svg",className:P5}),(0,e.jsx)(Pc,{className:C5,children:(0,e.jsx)(nc,{value:c.lastModified})})]})]})};const R5="save-slot-list_QCI child-opacity-transition_nkS",k5="scrollable_yF6";var D5=(0,i.forwardRef)((function(t,n){var r=t.slots,o=t.selectedSlot,a=t.sortedSaves,l=t.ordering,s=t.className,c=t.onSelectSave,u=t.onSelectOrdering,d=t.onSelectSlot,f=(0,i.useMemo)((function(){return{"Switch Ordering":function(e){var t;if(Jt(Qt.dragSlider),e<0)Jt(Qt.selectPreviousItem),u(null!==(t=ap(s3,s3.indexOf(l),!0))&&void 0!==t?t:l);else if(e>0){var n;Jt(Qt.selectNextItem),u(null!==(n=ip(s3,s3.indexOf(l),!0))&&void 0!==n?n:l)}}}}),[u,l]),h=(0,i.useCallback)((function(e){return c(e.id)}),[c]);return(0,e.jsx)(Tn,{actions:f,children:(0,e.jsxs)("div",{ref:n,className:Oe()(R5,s),children:[(0,e.jsx)(c3,{selectedOrdering:l,onSelectOrdering:u}),(0,e.jsx)(Fn,{initialFocused:o<a.length?"Save->".concat(a[o].id):void 0,children:(0,e.jsx)(mf,{className:k5,children:Array.from({length:r},(function(t,n){return n>a.length-1?(0,e.jsx)(M5,{slotId:n,locked:!0},n):(0,e.jsx)(M5,{slotId:n,focusKey:"Save->".concat(a[n].id),locked:a[n].locked,selected:o===n,saveGame:a[n],onSelectSave:h,onSelect:d},n)}))})})]})})}));const U5="save-slot_w9I child-opacity-transition_nkS",F5="locked_ZDr",G5="title_BPq",V5="field_tWJ",B5="empty-label_w3f",H5="title-content_PH_",K5="image_H0A",W5="scrollable_wz4",z5="scrollable-content_VzH",Y5="label_W0E",X5="value_Azu",q5="scrollable-footer_TG4";var $5=function(t){var n=t.focusKey,r=t.locked,o=void 0!==r&&r,a=t.saveGame,l=t.selected,s=void 0!==l&&l,c=t.slotId,u=t.className,d=t.onSelectSave,f=t.onSelect,h=(0,i.useCallback)((function(e){e&&(f&&f(c),a&&d&&d(a))}),[f,d,a,c]),m=(0,i.useCallback)((function(){o||(a&&d&&d(a),f&&f(c))}),[o,f,d,a,c]);return(0,e.jsxs)(Tr,{focusKey:o?Te:n||Te,onClick:m,onFocusChange:h,className:Oe()(U5,o&&F5,s&&"selected",u),children:[a&&(0,e.jsx)("div",{className:G5,children:(0,e.jsx)("div",{className:H5,children:null==a?void 0:a.displayName})}),null!=a&&(0,e.jsx)(BE,{src:null==a?void 0:a.preview,className:K5}),(0,e.jsx)(mf,{autoScroll:!0,className:W5,children:(0,e.jsxs)("div",{className:z5,children:[a?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Q5,{label:(0,e.jsx)(Ks.Menu.CITY_NAME_LABEL,{}),children:null==a?void 0:a.cityName}),(0,e.jsx)(Q5,{label:(0,e.jsx)(Ks.GameListScreen.POPULATION_LABEL,{}),children:(0,e.jsx)(dc,{value:null==a?void 0:a.population,unit:tc.Integer})}),(0,e.jsx)(Q5,{label:(0,e.jsx)(Ks.Menu.SIMULATION_DATE_LABEL,{}),children:(0,e.jsx)(Js,{value:null==a?void 0:a.simulationDate})}),(0,e.jsx)(Q5,{label:(0,e.jsx)(Ks.GameListScreen.MONEY_LABEL,{}),children:(0,e.jsx)(dc,{value:null==a?void 0:a.money,unit:tc.Money})}),(0,e.jsx)(Q5,{label:(0,e.jsx)(Ks.GameListScreen.XP_LABEL,{}),children:(0,e.jsx)(dc,{value:null==a?void 0:a.xp,unit:tc.Integer})}),null!=(null==a?void 0:a.mapName)&&(0,e.jsx)(Q5,{label:(0,e.jsx)(Ks.GameListScreen.MAP_LABEL,{}),children:(0,e.jsx)(Ks.Maps.MAP_TITLE,{hash:a.mapName})})]}):(0,e.jsx)("div",{className:Oe()(B5,F5),children:(0,e.jsx)(Ks.Menu.EMPTY_SLOT,{})}),(0,e.jsx)("div",{className:q5})]})})]})},Q5=function(t){var n=t.label,r=t.children;return(0,e.jsxs)("div",{className:V5,children:[(0,e.jsx)("div",{className:Y5,children:n}),(0,e.jsx)("div",{className:X5,children:r})]})};const Z5="save-game-slots_bkN",J5="header_bYW child-opacity-transition_nkS",e8="slots_qGG",t8="slot_yiX",n8="footer_x7R child-opacity-transition_nkS",r8="footer-button_OFi";var i8=(0,i.forwardRef)((function(t,n){var r=t.slots,o=t.selectedSlot,a=t.sortedSaves,l=t.selectedSave,s=t.ordering,c=t.className,u=t.onSelectOrdering,d=t.onSelectSave,f=t.onLoadGameSelect,h=t.onOptionsToggle,m=t.onSelectSlot,p=cr(),v=null!=l&&l.locked,g=(0,i.useMemo)((function(){return{"Switch Ordering":function(e){var t;if(Jt(Qt.dragSlider),e<0)Jt(Qt.selectPreviousItem),u(null!==(t=ap(s3,s3.indexOf(s),!0))&&void 0!==t?t:s);else if(e>0){var n;Jt(Qt.selectNextItem),u(null!==(n=ip(s3,s3.indexOf(s),!0))&&void 0!==n?n:s)}}}}),[u,s]),y=(0,i.useCallback)((function(e){return d(e.id)}),[d]),b=(0,i.useMemo)((function(){var e;return!a||0===a.length||o>a.length-1?"Save->Empty:".concat(o):"Save->".concat(null===(e=a[o])||void 0===e?void 0:e.id)}),[o,a]);return(0,e.jsx)(Tn,{actions:g,children:(0,e.jsxs)("div",{ref:n,className:Oe()(Z5,c),children:[(0,e.jsx)(c3,{selectedOrdering:s,onSelectOrdering:u,className:J5}),(0,e.jsx)("div",{className:e8,children:(0,e.jsx)(Fn,{initialFocused:b,children:Array.from({length:r},(function(t,n){return!a||0===a.length||n>a.length-1?(0,e.jsx)($5,{slotId:n,locked:!0,className:t8},n):(0,e.jsx)($5,{slotId:n,selected:o===n,focusKey:"Save->".concat(a[n].id),locked:a[n].locked,saveGame:a[n],className:t8,onSelectSave:y,onSelect:m},n)}))})}),(0,e.jsx)("div",{className:n8,children:null==l||p?void 0:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(V1,{className:r8,disabled:v,onSelect:f,children:(0,e.jsx)(Ks.Menu.LOAD_GAME_BUTTON,{})}),(0,e.jsx)(V1,{className:r8,disabled:v,onSelect:h,children:(0,e.jsx)(Ks.Menu.SAVE_OPTIONS,{})})]})})]})})}));const o8="content_xXo",a8="step-container_Cmk",l8="step_buR",s8="detail_T2m";function c8(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function u8(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function d8(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){u8(e,t,n[t])}))}return e}function f8(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return c8(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return c8(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var h8;!function(e){e[e.selection=0]="selection",e[e.options=1]="options"}(h8||(h8={}));var m8=i.forwardRef((function(t,n){var r,o,a,l,s=t.focusKey,c=t.className,u=t.onClose,d=t.requireConfirmation,f=void 0!==d&&d,h=f8((0,i.useState)(h8.selection),2),m=h[0],p=h[1],v=f8((0,i.useState)(Q2.LastModified),2),g=v[0],y=v[1],b=C(td),x=(0,i.useMemo)((function(){return n3(b,g)}),[g,b]),_=f8((0,i.useState)((function(){return function(e){return rp(n3(td.value,e),"id")}(g)})),2),j=_[0],E=_[1],O=f8((0,i.useState)(x.findIndex((function(e){return e.id===j}))),2),T=O[0],I=O[1],S=C(qu),w=(0,i.useMemo)((function(){return null!==(r=b.find((function(e){return e.id===j})))&&void 0!==r?r:null}),[b,j]),P=f8((0,i.useState)(null!==(o=null==w?void 0:w.cityName)&&void 0!==o?o:""),2),A=P[0],L=P[1],M=f8((0,i.useState)(null!==(a=null==w?void 0:w.theme)&&void 0!==a?a:""),2),R=M[0],k=M[1],D=C(Yu),U=f8((0,i.useState)(null!==(l=d8({},D,null==w?void 0:w.options))&&void 0!==l?l:d8({},D)),2),F=U[0],G=U[1],V=function(e){var t=["theme","leftHandTraffic"];null!=e&&(e.options.unlockAll&&t.push("unlockAll"),e.options.unlimitedMoney&&t.push("unlimitedMoney"));return t}(w),B=f8(ud(),2),H=B[0],K=B[1],W=(0,i.useContext)(Rl),z=C(Hu),Y=(0,i.useCallback)((function(e){var t=b.find((function(t){return t.id===e}));null!=t&&(L(t.cityName),k(t.theme),G(d8({},D,t.options)),E(e))}),[D,b]),X=(0,i.useCallback)((function(){m===h8.options?(p(h8.selection),Jt(Qt.closeMenu)):u()}),[m,u]),q=(0,i.useCallback)((function(){m===h8.selection?(p(h8.options),Jt(Qt.openMenu)):(p(h8.selection),Jt(Qt.closeMenu))}),[m]),$=C(pd),Q=(0,i.useCallback)((function(){if(j){var t=function(e){cd(H),function(e,t){N(Lu,"loadGame",e,t)}({saveId:j,cityName:A,options:F},e)};if(f&&!$)return void W.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.GameListScreen.CONFIRM_UNSAVED_MESSAGE,{}),onConfirm:t,dismissable:!0}));t(!1)}}),[A,W,$,F,f,j,H]),Z=(0,i.useCallback)((function(){var e;e=w.id,N(Lu,"deleteSave",e),p(h8.selection)}),[w]),J=(0,i.useCallback)((function(){var e;e=w.id,N(Lu,"shareSave",e)}),[w]),ee=(0,i.useMemo)((function(){return{"Save Options":function(){Jt(Qt.selectItem),q()},"Load Game":function(){Jt(Qt.selectItem),Q()}}}),[Q,q]);return(0,e.jsx)(RP,{ref:n,focusKey:s,title:p8(m),className:c,onClose:X,children:(0,e.jsx)(Tn,{actions:ee,children:3!==S?(0,e.jsx)("div",{className:o8,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)("div",{className:a8,children:(0,e.jsxs)(nO,{children:[m===h8.selection&&(0,e.jsx)($t,{styles:M0,children:-1===S?(0,e.jsx)(p3,{selectedSave:j,ordering:g,className:l8,onSelectSave:Y,onSelectOrdering:y}):(0,e.jsx)(D5,{slots:S,selectedSlot:T,ordering:g,sortedSaves:x,className:l8,onSelectSave:Y,onSelectOrdering:y,onSelectSlot:I})},h8.selection),m===h8.options&&(0,e.jsx)($t,{styles:$A,children:(0,e.jsx)(e3,{cityName:A,theme:R,options:F,disabledOptions:V,className:l8,onCityNameChange:L,onThemeChange:k,onOptionsChange:G,tutorialState:H,setTutorialState:K,onDeleteGame:(null==w?void 0:w.isReadonly)?void 0:Z,onShareGame:z||(null==w?void 0:w.isReadonly)?void 0:J})},h8.options)]})}),(0,e.jsx)(r3,{save:w,activeStep:m,className:s8,onOptionsToggle:q,onLoadGameSelect:Q})]})}):(0,e.jsx)(Fn,{children:(0,e.jsxs)(nO,{children:[m===h8.selection&&(0,e.jsx)($t,{styles:M0,children:(0,e.jsx)("div",{className:o8,children:(0,e.jsx)(i8,{slots:S,selectedSlot:T,sortedSaves:x,ordering:g,selectedSave:w,onSelectSave:Y,onLoadGameSelect:Q,onOptionsToggle:q,onSelectOrdering:y,onSelectSlot:I})})}),m===h8.options&&(0,e.jsx)($t,{styles:$A,children:(0,e.jsxs)("div",{className:o8,children:[(0,e.jsx)("div",{className:a8,children:(0,e.jsx)(e3,{cityName:A,theme:R,options:F,disabledOptions:V,className:l8,onCityNameChange:L,onThemeChange:k,onOptionsChange:G,tutorialState:H,setTutorialState:K,onDeleteGame:(null==w?void 0:w.isReadonly)?void 0:Z,onShareGame:z||(null==w?void 0:w.isReadonly)?void 0:J})}),(0,e.jsx)(r3,{save:w,className:s8,onOptionsToggle:q,onLoadGameSelect:Q})]})})]})})})})}));function p8(t){return t===h8.selection?(0,e.jsx)(Ks.Menu.LOAD_GAME,{}):t===h8.options?(0,e.jsx)(Ks.Menu.SAVE_OPTIONS,{}):null}var v8="photoMode";function g8(){N(v8,"resetCamera")}var y8=E(v8,"overlayHidden");function b8(e){N(v8,"setOverlayHidden",e)}var x8=E(v8,"orbitCameraActive");function _8(){N(v8,"toggleOrbitCameraActive")}function j8(){N(v8,"takeScreenshot")}function E8(e){N(v8,"selectTab",e)}function O8(e){N(v8,"setCinematicCameraVisible",e)}var T8,I8=E(v8,"cinematicCameraVisible"),S8=E(v8,"tabs"),w8=E(v8,"activeTab");!function(e){e.DropdownField="Game.UI.Widgets.DropdownField"}(T8||(T8={}));var N8=E(v8,"children");function P8(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function C8(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function A8(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return P8(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return P8(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var L8=function(t){var n=t.onClose,r=t.focusKey,o=C(y8),a=A8((0,i.useState)(o),1)[0];M8(),(0,i.useEffect)((function(){if(b8(!0),!a)return function(){return b8(!1)}}),[a]);var l=Dk(),s=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){C8(e,t,n[t])}))}return e}({Back:n,"Take Photo":function(){Jt(Qt.takePhoto),j8()},"Hide UI":n},l)}),[n,l]);return(0,e.jsx)(_p,{children:(0,e.jsx)(Tn,{actions:s,children:(0,e.jsx)(Ze,{focusKey:r,focused:null,activation:Ue.Always})})})};function M8(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];Tf(e?"hide-ui":void 0)}const R8={button:"button_ke4",icon:"icon_be5"};function k8(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function D8(){return D8=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},D8.apply(this,arguments)}function U8(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var F8=function(t){var n=D8({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(t));return(0,e.jsx)(xl,U8(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){k8(e,t,n[t])}))}return e}({},n),{tinted:!0,theme:R8}))},G8="signatureBuildings",V8=E(G8,"unlockedSignatures");function B8(){N(G8,"clearUnlockedSignatures")}const H8={enter:"enter_C0S enter_kO6","enter-active":"enter-active_ule enter-active_lrI",enterActive:"enter-active_ule enter-active_lrI",exit:"exit_TO8 exit_Von","exit-active":"exit-active_KS9 exit-active_jtN",exitActive:"exit-active_KS9 exit-active_jtN"};var K8=i.createContext(null);const W8="asset-category-tab-bar_IGA",z8="tab-icon_YCN",Y8="locked_u4O",X8="lock_4IG",q8="items_gPf",$8="close-button_kMj",Q8={button:"button_Yym",icon:"icon_LAz",locked:"locked_jsF","item-inner":"item-inner_NKx",itemInner:"item-inner_NKx",highlight:"highlight_Y8Z",lock:"lock_HjE"};var Z8,J8,e4=function(t){var n=t.categories,r=t.selectedCategory,i=t.onChange,o=t.onClose,a=cr();return(0,e.jsxs)("div",{className:W8,children:[(0,e.jsx)("div",{className:q8,children:n.map((function(t){return(0,e.jsx)(t4,{singleTab:1===n.length,subCategory:t,selected:c(r,t.entity),onSelect:i},l(t.entity))}))}),!a&&(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:kr.closeIcon,theme:_l,className:Oe()(kr.closeButton,$8),onSelect:o})]})},t4=function(t){var n=t.subCategory,r=t.selected,o=t.singleTab,a=void 0!==o&&o,l=t.onSelect;su(n.uiTag,r&&!n.locked),cu(n.uiTag,r&&!n.locked);var s=(0,i.useCallback)((function(){return l(n.entity)}),[l,n.entity]),c=(0,i.useContext)(K8),u=(0,i.useCallback)((function(){return c&&c.showDetails(n.entity)}),[n.entity,c]),d=(0,i.useCallback)((function(){return c&&c.hideDetails(n.entity)}),[n.entity,c]);return(0,e.jsx)(bS,{uiTag:n.uiTag,active:!n.locked,disableBlinking:a,children:(0,e.jsx)(xO,{tooltip:!c&&(0,e.jsx)(Ks.SubServices.NAME,{hash:n.name}),children:a?(0,e.jsxs)("div",{style:{position:"relative"},onMouseOver:u,onMouseLeave:d,children:[(0,e.jsx)("img",{src:n.icon,className:Oe()(z8,n.locked&&Y8)}),n.locked&&(0,e.jsx)(YN,{className:X8})]}):(0,e.jsxs)(xl,{focusKey:Te,src:n.icon,selected:r,theme:Q8,className:Oe()(n.locked&&Q8.locked),onSelect:s,onMouseOver:u,onMouseLeave:d,children:[(0,e.jsx)("div",{className:Q8.itemInner}),n.highlight&&(0,e.jsx)(TF,{className:Q8.highlight}),n.locked&&(0,e.jsx)(YN,{className:Q8.lock})]})})})};!function(e){e[e.none=0]="none",e[e.residential=1]="residential",e[e.commercial=2]="commercial",e[e.industrial=3]="industrial"}(Z8||(Z8={})),function(e){e.Milestone="prefabs.MilestoneRequirement",e.DevTreeNode="prefabs.DevTreeNodeRequirement",e.StrictObjectBuilt="prefabs.StrictObjectBuiltRequirement",e.ZoneBuilt="prefabs.ZoneBuiltRequirement",e.Citizen="prefabs.CitizenRequirement",e.Processing="prefabs.ProcessingRequirement",e.ObjectBuilt="prefabs.ObjectBuiltRequirement",e.Unlock="prefabs.UnlockRequirement",e.Tutorial="prefabs.TutorialRequirement"}(J8||(J8={}));const n4="requirement-field_e7h",r4="progress-bounds_MkW",i4="progress_jYy",o4="content_OHh",a4="icon_IKb",l4="label_DwS",s4="checkmark_Nhp";function c4(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function u4(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){c4(e,t,n[t])}))}return e}var d4,f4=function(t){var n=t.icon,r=t.progress,i=t.max,o=t.locked,a=t.children,l=o?at(r/i,0,1):i;return(0,e.jsxs)("div",{className:n4,children:[(0,e.jsx)("div",{className:r4,style:{width:"".concat(100*l,"%")},children:(0,e.jsx)("div",{className:i4,style:{width:"".concat(l>0?100/l:0,"%")}})}),(0,e.jsxs)("div",{className:o4,children:[n&&(0,e.jsx)("img",{src:n,className:a4}),(0,e.jsx)("div",{className:l4,children:a}),!o&&(0,e.jsx)(ll,{src:"Media/Glyphs/Checkmark.svg",className:s4})]})]})},h4=(c4(d4={},J8.Milestone,(function(t){var n=C(w3);return(0,e.jsx)(f4,{icon:"Media/Game/Icons/Trophy.svg",progress:t.locked?n:t.index,max:t.index,locked:t.locked,children:(0,e.jsx)(Ks.Progression.MILESTONE_UNLOCK_REQUIREMENT,{INDEX:(0,e.jsx)(dc,{value:t.index,unit:tc.Integer}),NAME:(0,e.jsx)(Ks.Progression.MILESTONE_NAME,{index:t.index})})})})),c4(d4,J8.DevTreeNode,(function(t){return(0,e.jsx)(f4,{icon:"Media/Game/Icons/DevPoint.svg",progress:t.locked?0:1,max:1,locked:t.locked,children:(0,e.jsx)(Ks.Progression.NODE_UNLOCK_REQUIREMENT,{NAME:(0,e.jsx)(Ks.Progression.NODE_NAME,{hash:t.name})})})})),c4(d4,J8.StrictObjectBuilt,(function(t){var n=(0,i.useMemo)((function(){var n={NAME:(0,e.jsx)(Ks.Assets.NAME,{hash:t.requirement}),CURRENT:(0,e.jsx)(dc,{value:t.progress,unit:tc.Integer}),TARGET:(0,e.jsx)(dc,{value:t.minimumCount,unit:tc.Integer})};return null!=t.labelId?(0,e.jsx)(Ss,{id:t.labelId,args:n}):(0,e.jsx)(Ks.Progression.STRICT_OBJECT_BUILT_REQUIREMENT,u4({},n))}),[t.labelId,t.requirement,t.progress,t.minimumCount]);return(0,e.jsx)(f4,{icon:t.icon,progress:t.progress,max:t.minimumCount,locked:t.locked,children:n})})),c4(d4,J8.ZoneBuilt,(function(t){var n=(0,i.useMemo)((function(){var n={ZONE:null!=t.requiredZone?(0,e.jsx)(Ks.Assets.NAME,{hash:t.requiredZone}):"",CURRENT:(0,e.jsx)(dc,{value:t.progress,unit:tc.Integer}),TARGET:(0,e.jsx)(dc,{value:t.minimumSquares>0?t.minimumSquares:t.minimumCount,unit:tc.Integer}),LEVEL:(0,e.jsx)(dc,{value:t.minimumLevel,unit:tc.Integer})};return null!=t.labelId?(0,e.jsx)(Ss,{id:t.labelId,args:n}):t.minimumSquares>0||0===t.minimumCount?t.minimumLevel>1?(0,e.jsx)(Ks.Progression.ZONE_BUILT_REQUIREMENT_CELLS_LEVEL,u4({},n)):(0,e.jsx)(Ks.Progression.ZONE_BUILT_REQUIREMENT_CELLS,u4({},n)):t.minimumLevel>1?(0,e.jsx)(Ks.Progression.ZONE_BUILT_REQUIREMENT_COUNT_LEVEL,u4({},n)):(0,e.jsx)(Ks.Progression.ZONE_BUILT_REQUIREMENT_COUNT,u4({},n))}),[t.labelId,t.minimumCount,t.minimumLevel,t.minimumSquares,t.progress,t.requiredZone]);return(0,e.jsx)(f4,{icon:t.icon,progress:t.progress,max:t.minimumSquares>0?t.minimumSquares:t.minimumCount,locked:t.locked,children:n})})),c4(d4,J8.Citizen,(function(t){var n=(0,i.useMemo)((function(){if(t.minimumPopulation>0||0===t.minimumHappiness){var n={VALUE:(0,e.jsx)(dc,{value:t.minimumPopulation,unit:tc.Integer})};return null!=t.labelId?(0,e.jsx)(Ss,{id:t.labelId,args:n}):(0,e.jsx)(Ks.Progression.POPULATION_REQUIREMENT,u4({},n))}var r={VALUE:(0,e.jsx)(dc,{value:t.minimumHappiness,unit:tc.PercentageSingleFraction})};return null!=t.labelId?(0,e.jsx)(Ss,{id:t.labelId,args:r}):(0,e.jsx)(Ks.Progression.HAPPINESS_REQUIREMENT,u4({},r))}),[t.minimumPopulation,t.minimumHappiness,t.labelId]);return(0,e.jsx)(f4,{icon:t.minimumPopulation>0||0===t.minimumHappiness?"Media/Game/Icons/Citizen.svg":"Media/Game/Icons/Happy.svg",progress:t.progress,max:t.minimumPopulation>0?t.minimumPopulation:t.minimumHappiness,locked:t.locked,children:n})})),c4(d4,J8.Processing,(function(t){var n=(0,i.useMemo)((function(){var n={RESOURCE:(0,e.jsx)(Ks.Resources.TITLE,{hash:t.resourceType}),CURRENT:(0,e.jsx)(dc,{value:t.progress,unit:tc.Integer}),TARGET:(0,e.jsx)(dc,{value:t.minimumProducedAmount,unit:tc.Integer})};return null!=t.labelId?(0,e.jsx)(Ss,{id:t.labelId,args:n}):(0,e.jsx)(Ks.Progression.PROCESSING_REQUIREMENT,u4({},n))}),[t.labelId,t.resourceType,t.progress,t.minimumProducedAmount]);return(0,e.jsx)(f4,{icon:"Media/Game/Icons/Company.svg",progress:t.progress,max:t.minimumProducedAmount,locked:t.locked,children:n})})),c4(d4,J8.ObjectBuilt,(function(t){var n=(0,i.useMemo)((function(){var n={CURRENT:(0,e.jsx)(dc,{value:t.progress,unit:tc.Integer}),TARGET:(0,e.jsx)(dc,{value:t.minimumCount,unit:tc.Integer})};return null!=t.labelId?(0,e.jsx)(Ss,{id:t.labelId,args:n}):(0,e.jsx)(Ks.Progression.OBJECT_BUILT_REQUIREMENT,u4({hash:t.name},n))}),[t.labelId,t.name,t.progress,t.minimumCount]);return(0,e.jsx)(f4,{icon:"Media/Game/Icons/Build.svg",progress:t.progress,max:t.minimumCount,locked:t.locked,children:n})})),c4(d4,J8.Unlock,(function(){return null})),c4(d4,J8.Tutorial,(function(t){var n=t.locked;return(0,e.jsx)(f4,{icon:"Media/Game/Icons/Build.svg",progress:0,max:1,locked:n,children:(0,e.jsx)(Ks.Progression.TUTORIAL_REQUIREMENT,{})})})),d4);const m4={"unlocking-requirements":"unlocking-requirements_xaC",unlockingRequirements:"unlocking-requirements_xaC",row:"row_fam",title:"title_grF",divider:"divider_Cqj"};function p4(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var v4=function(t){var n=t.requirements,r=t.theme,o=t.className,a=(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){p4(e,t,n[t])}))}return e}({},m4,r)}),[r]),l=n.requireAny.length>0,s=n.requireAll.length>0;return(0,e.jsxs)("div",{className:Oe()(a.unlockingRequirements,o),children:[l&&(0,e.jsxs)("div",{className:a.row,children:[(0,e.jsx)("div",{className:a.title,children:(0,e.jsx)(Ks.Progression.REQUIRES_ANY,{})}),(0,e.jsx)(Vh,{components:h4,data:n.requireAny})]}),l&&s&&(0,e.jsx)("div",{className:m4.divider}),s&&(0,e.jsxs)("div",{className:a.row,children:[(0,e.jsx)("div",{className:a.title,children:l?(0,e.jsx)(Ks.Progression.REQUIRES_ALL,{}):n.requireAll.length>1?(0,e.jsx)(Ks.Progression.REQUIREMENTS,{}):(0,e.jsx)(Ks.Progression.REQUIREMENT,{})}),(0,e.jsx)(Vh,{components:h4,data:n.requireAll})]})]})};var g4,y4,b4,x4="upgradeMenu",_4=T(x4,"upgrades"),j4=T(x4,"upgradeDetails"),E4=E(x4,"selectedUpgrade"),O4=E(x4,"upgrading");function T4(e,t){N(x4,"selectUpgrade",e,t)}function I4(){N(x4,"clearUpgradeSelection")}!function(e){e.CityModifier="prefabs.CityModifierEffect",e.LocalModifier="prefabs.LocalModifierEffect",e.LeisureProvider="prefabs.LeisureProviderEffect",e.AdjustHappinessEffect="prefabs.AdjustHappinessEffect"}(g4||(g4={})),function(e){e.Attractiveness="Attractiveness",e.CrimeAccumulation="CrimeAccumulation",e.PoliceStationUpkeep="PoliceStationUpkeep",e.DisasterWarningTime="DisasterWarningTime",e.DisasterDamageRate="DisasterDamageRate",e.DiseaseProbability="DiseaseProbability",e.ParkEntertainment="ParkEntertainment",e.CriminalMonitorProbability="CriminalMonitorProbability",e.IndustrialAirPollution="IndustrialAirPollution",e.IndustrialGroundPollution="IndustrialGroundPollution",e.IndustrialGarbage="IndustrialGarbage",e.RecoveryFailChange="RecoveryFailChange",e.OreResourceAmount="OreResourceAmount",e.OilResourceAmount="OilResourceAmount",e.UniversityInterest="UniversityInterest",e.OfficeSoftwareDemand="OfficeSoftwareDemand",e.IndustrialElectronicsDemand="IndustrialElectronicsDemand",e.OfficeSoftwareEfficiency="OfficeSoftwareEfficiency",e.IndustrialElectronicsEfficiency="IndustrialElectronicsEfficiency",e.TelecomCapacity="TelecomCapacity",e.Entertainment="Entertainment",e.HighwayTrafficSafety="HighwayTrafficSafety",e.PrisonTime="PrisonTime",e.CrimeProbability="CrimeProbability",e.CollegeGraduation="CollegeGraduation",e.UniversityGraduation="UniversityGraduation",e.ImportCost="ImportCost",e.LoanInterest="LoanInterest",e.BuildingLevelingCost="BuildingLevelingCost",e.ExportCost="ExportCost",e.TaxiStartingFee="TaxiStartingFee",e.IndustrialEfficiency="IndustrialEfficiency",e.OfficeEfficiency="OfficeEfficiency",e.PollutionHealthAffect="PollutionHealthAffect",e.HospitalEfficiency="HospitalEfficiency"}(y4||(y4={})),function(e){e.CrimeAccumulation="CrimeAccumulation",e.ForestFireResponseTime="ForestFireResponseTime",e.ForestFireHazard="ForestFireHazard",e.Wellbeing="Wellbeing",e.Health="Health"}(b4||(b4={}));const S4="field_AjF",w4="icon_WOc",N4="content_dov";function P4(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function C4(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){P4(e,t,n[t])}))}return e}var A4=function(t){var n=t.type,r=t.delta,o=t.unit,a=(0,i.useMemo)((function(){return function(e){switch(e){case y4.Attractiveness:return"Media/Game/Icons/Tourism.svg";case y4.CrimeAccumulation:case y4.PoliceStationUpkeep:return"Media/Game/Icons/Police.svg";case y4.DisasterWarningTime:case y4.DisasterDamageRate:return"Media/Game/Icons/Disaster.svg";case y4.DiseaseProbability:return"Media/Game/Icons/Healthcare.svg";case y4.ParkEntertainment:return"Media/Game/Icons/ParksAndRecreation.svg";case y4.CriminalMonitorProbability:return"Media/Game/Icons/Police.svg";case y4.IndustrialAirPollution:return"Media/Game/Icons/AirPollution.svg";case y4.IndustrialGroundPollution:return"Media/Game/Icons/GroundPollution.svg";case y4.IndustrialGarbage:return"Media/Game/Icons/Garbage.svg";case y4.RecoveryFailChange:return"Media/Game/Icons/Healthcare.svg";case y4.OreResourceAmount:return"Media/Game/Icons/Coal.svg";case y4.OilResourceAmount:return"Media/Game/Icons/Oil.svg";case y4.UniversityInterest:return"Media/Game/Icons/Education.svg";case y4.OfficeSoftwareDemand:return"Media/Game/Icons/ZoneOfficeHigh.svg";case y4.IndustrialElectronicsDemand:return"Media/Game/Icons/ZoneIndustrialManufacturing.svg";case y4.OfficeSoftwareEfficiency:return"Media/Game/Icons/ZoneOfficeHigh.svg";case y4.IndustrialElectronicsEfficiency:return"Media/Game/Icons/ZoneIndustrialManufacturing.svg";case y4.TelecomCapacity:return"Media/Game/Icons/Telecom.svg";case y4.Entertainment:return"Media/Game/Icons/Leisure.svg";case y4.HighwayTrafficSafety:return"Media/Game/Icons/Roads.svg";case y4.PrisonTime:case y4.CrimeProbability:return"Media/Game/Icons/Police.svg";case y4.CollegeGraduation:case y4.UniversityGraduation:return"Media/Game/Icons/Graduation.svg";case y4.ImportCost:return"Media/Game/Icons/OutsideConnections.svg";case y4.LoanInterest:return"Media/Game/Icons/Money.svg";case y4.BuildingLevelingCost:return"Media/Game/Icons/BuildingLevel.svg";case y4.ExportCost:return"Media/Game/Icons/OutsideConnections.svg";case y4.TaxiStartingFee:return"Media/Game/Icons/Taxi.svg";case y4.IndustrialEfficiency:return"Media/Game/Icons/ZoneIndustrial.svg";case y4.OfficeEfficiency:return"Media/Game/Icons/ZoneOffice.svg";case y4.PollutionHealthAffect:return"Media/Game/Icons/AirPollution.svg";case y4.HospitalEfficiency:return"Media/Game/Icons/Healthcare.svg";default:return console.warn("Missing icon for CityModifierType.".concat(e,"!")),"Media/Placeholder.svg"}}(n)}),[n]);return(0,e.jsxs)("div",{className:S4,children:[(0,e.jsx)("img",{src:a,className:w4}),(0,e.jsx)("div",{className:N4,children:(0,e.jsx)(Ks.Properties.CITY_MODIFIER_EFFECT,{TYPE:(0,e.jsx)(Ks.Properties.CITY_MODIFIER,{hash:n}),DELTA:(0,e.jsx)(dc,{value:r,unit:o,signed:!0})})})]})};var L4=function(t){var n=t.type,r=t.delta,o=t.unit,a=t.radius,l=(0,i.useMemo)((function(){return function(e){switch(e){case b4.CrimeAccumulation:return"Media/Game/Icons/Police.svg";case b4.ForestFireResponseTime:case b4.ForestFireHazard:return"Media/Game/Icons/FireSafety.svg";case b4.Wellbeing:return"Media/Game/Icons/WellBeing.svg";case b4.Health:return"Media/Game/Icons/Healthcare.svg";default:return console.warn("Missing icon for LocalModifierType.".concat(e,"!")),"Media/Placeholder.svg"}}(n)}),[n]);return(0,e.jsxs)("div",{className:S4,children:[(0,e.jsx)("img",{src:l,className:w4}),(0,e.jsx)("div",{className:N4,children:(0,e.jsx)(Ks.Properties.LOCAL_MODIFIER_EFFECT,{TYPE:(0,e.jsx)(Ks.Properties.LOCAL_MODIFIER,{hash:n}),DELTA:(0,e.jsx)(dc,{value:r,unit:o,signed:!0}),RADIUS:(0,e.jsx)(dc,{value:a,unit:tc.Length})})})]})};var M4,R4=function(t){var n=t.effect,r=t.targetKey,i=t.icon,o=t.typeKey;return(0,e.jsxs)("div",{className:S4,children:[(0,e.jsx)("img",{src:i,className:w4}),(0,e.jsx)("div",{className:N4,children:(0,e.jsx)(Ks.Properties.ADJUST_HAPPINESS_MODIFIER_EFFECT,{TYPE:(0,e.jsx)(Ks.Properties.ADJUST_HAPPINESS_MODIFIER_TYPE,{hash:o}),DELTA:(0,e.jsx)(dc,{value:n,unit:tc.Percentage,signed:!0}),TARGET:(0,e.jsx)(Ks.Properties.ADJUST_HAPPINESS_MODIFIER_TARGET,{hash:r})})})]})},k4=(P4(M4={},g4.CityModifier,(function(t){var n=t.modifiers;return(0,e.jsx)(e.Fragment,{children:n.map((function(t,n){return(0,e.jsx)(A4,C4({},t),n)}))})})),P4(M4,g4.LocalModifier,(function(t){var n=t.modifiers;return(0,e.jsx)(e.Fragment,{children:n.map((function(t,n){return(0,e.jsx)(L4,C4({},t),n)}))})})),P4(M4,g4.LeisureProvider,(function(t){var n=t.type,r=t.efficiency;return(0,e.jsxs)("div",{className:S4,children:[(0,e.jsx)("img",{src:"Media/Game/Icons/Leisure.svg",className:w4}),(0,e.jsx)("div",{className:N4,children:(0,e.jsx)(Ks.Properties.LEISURE_PROVIDER_EFFECT,{TYPE:(0,e.jsx)(Ks.Properties.LEISURE_TYPE,{hash:n}),EFFICIENCY:(0,e.jsx)(dc,{value:r,unit:tc.Integer,signed:!0})})})]})})),P4(M4,g4.AdjustHappinessEffect,(function(t){var n=t.wellbeingEffect,r=t.healthEffect,i=t.targets;return(0,e.jsxs)(e.Fragment,{children:[n>0&&i.map((function(t){return(0,e.jsx)(R4,{effect:n,targetKey:t,icon:"Media/Game/Icons/WellBeing.svg",typeKey:"Wellbeing"},t)})),r>0&&i.map((function(t){return(0,e.jsx)(R4,{effect:r,targetKey:t,icon:"Media/Game/Icons/Healthcare.svg",typeKey:"Health"},t)}))]})})),M4);function D4(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var U4,F4,G4=(D4(U4={},"Game.UI.Common.NumberProperty",(function(t){var n=t.labelId,r=t.unit,i=t.value,o=t.signed;return(0,e.jsx)(E1,{label:(0,e.jsx)(Ss,{id:n}),children:(0,e.jsx)(dc,{value:i,unit:r,signed:o})})})),D4(U4,"Game.UI.Common.Number2Property",(function(){return null})),D4(U4,"Game.UI.Common.StringProperty",(function(t){var n=t.labelId,r=t.valueId;return(0,e.jsx)(E1,{label:(0,e.jsx)(Ss,{id:n}),children:(0,e.jsx)(Ss,{id:r})})})),U4);!function(e){e[e.none=0]="none",e[e.low=1]="low",e[e.medium=2]="medium",e[e.high=3]="high"}(F4||(F4={}));var V4;!function(e){e[e.low=0]="low",e[e.high=1]="high",e[e.both=2]="both"}(V4||(V4={}));const B4={field:"field_rIn",header:"header_lrj",content:"content_RIT",icon:"icon_tiy",value:"value_Yc3"};function H4(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function K4(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function W4(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return H4(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return H4(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var z4,Y4=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){K4(e,t,n[t])}))}return e}({},G4),(K4(z4={},"prefabs.ConsumptionProperty",(function(t){var n=t.electricityConsumption,r=t.waterConsumption,i=t.garbageAccumulation;return(0,e.jsxs)(e.Fragment,{children:[n>0&&(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.Properties.ELECTRICITY_CONSUMPTION,{}),children:(0,e.jsx)(dc,{value:n,unit:tc.Power})}),r>0&&(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.Properties.WATER_CONSUMPTION,{}),children:(0,e.jsx)(dc,{value:r,unit:tc.VolumePerMonth})}),i>0&&(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.Properties.GARBAGE_ACCUMULATION,{}),children:(0,e.jsx)(dc,{value:i,unit:tc.WeightPerMonth})})]})})),K4(z4,"prefabs.PollutionProperty",(function(t){var n=t.groundPollution,r=t.airPollution,i=t.noisePollution;return(0,e.jsxs)(e.Fragment,{children:[n>F4.none&&(0,e.jsxs)(E1,{label:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS_GROUND,{}),children:[(0,e.jsx)("img",{src:"Media/Game/Icons/GroundPollution.svg",className:B4.icon}),(0,e.jsx)("div",{className:B4.value,children:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS,{index:n})})]}),r>F4.none&&(0,e.jsxs)(E1,{label:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS_AIR,{}),children:[(0,e.jsx)("img",{src:"Media/Game/Icons/AirPollution.svg",className:B4.icon}),(0,e.jsx)("div",{className:B4.value,children:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS,{index:r})})]}),i>F4.none&&(0,e.jsxs)(E1,{label:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS_NOISE,{}),children:[(0,e.jsx)("img",{src:"Media/Game/Icons/NoisePollution.svg",className:B4.icon}),(0,e.jsx)("div",{className:B4.value,children:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS,{index:i})})]})]})})),K4(z4,"prefabs.ElectricityProperty",(function(t){var n=t.labelId,r=t.minCapacity,i=t.maxCapacity,o=t.voltage;return(0,e.jsx)(E1,{label:(0,e.jsx)(Ss,{id:n}),children:(0,e.jsx)(Ks.Properties.POWER_VOLTAGE_FORMAT,{VALUE:(0,e.jsx)(eh,{min:r,max:i,unit:tc.Power}),VOLTAGE:(0,e.jsx)(Ks.Properties.VOLTAGE,{index:o})})})})),K4(z4,"prefabs.TransportStopProperty",(function(t){var n=t.stops;return(0,e.jsx)(e.Fragment,{children:Object.entries(n).map((function(t,n){var r=W4(t,2),i=r[0],o=r[1];return o>0&&(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.Properties.TRANSPORT_STOP_COUNT,{hash:i}),children:(0,e.jsx)(dc,{value:o,unit:tc.Integer})},n)}))})})),z4)),X4=function(t){var n=t.data;return(0,e.jsx)(j1.Provider,{value:B4,children:(0,e.jsx)(Vh,{components:Y4,data:n})})};const q4="asset-detail-panel_hf8",$4="title-bar_I7O child-opacity-transition_nkS",Q4="title_qub",Z4="construction-cost-field_I8G",J4="not-enough-money_vtd",e6="construction-cost-icon_hgB",t6="content_rep row_H0d child-opacity-transition_nkS",n6="preview-container_sPA",r6="preview_MDY",i6="column_dTT",o6="description_ZQn",a6="effects_y8n",l6="stats-row_Q3F row_H0d child-opacity-transition_nkS",s6="requirements-row_yaX row_H0d child-opacity-transition_nkS",c6="already-built-row_NJp row_H0d child-opacity-transition_nkS";var u6=i.forwardRef((function(t,n){var r,i,o=t.entity,a=t.className,l=t.upgrade,s=void 0!==l&&l,c=null!==(r=M(OS,o))&&void 0!==r?r:IS,u=null!==(i=M(j4,o))&&void 0!==i?i:IS,d=s?u:c,f=d.properties.length>0,h=d.uniquePlaced||d.locked&&d.requirements.requireAll.length+d.requirements.requireAny.length>0;return(0,e.jsxs)("div",{ref:n,className:Oe()(q4,a),children:[(0,e.jsxs)("div",{className:$4,children:[(0,e.jsx)("div",{className:Q4,children:(0,e.jsx)(Ss,{id:d.titleId})}),null!=d.constructionCost&&("number"==typeof d.constructionCost.value?(0,e.jsx)(d6,{value:d.constructionCost.value,unit:d.constructionCost.unit}):(0,e.jsx)(f6,{value:d.constructionCost.value,unit:d.constructionCost.unit}))]}),(0,e.jsxs)("div",{className:t6,children:[(0,e.jsx)("div",{className:n6,children:(0,e.jsx)("img",{src:d.icon,className:r6})}),(0,e.jsxs)("div",{className:i6,children:[null!=d.descriptionId&&(0,e.jsx)(fI,{className:o6,children:(0,e.jsx)(Ss,{id:d.descriptionId})}),d.effects.length>0&&(0,e.jsx)("div",{className:a6,children:(0,e.jsx)(Vh,{components:k4,data:d.effects})})]})]}),f&&(0,e.jsx)("div",{className:l6,children:(0,e.jsx)(X4,{data:d.properties})}),!d.uniquePlaced&&h&&(0,e.jsx)(v4,{requirements:d.requirements,className:s6}),d.uniquePlaced&&(0,e.jsx)("div",{className:c6,children:(0,e.jsx)(Ks.Toolbar.ASSET_ALREADY_BUILT,{})})]})})),d6=function(t){var n=t.value,r=t.unit,i=C(b3);return(0,e.jsxs)("div",{className:Oe()(Z4,i<n&&J4),children:[(0,e.jsx)("div",{children:(0,e.jsx)(dc,{value:n,unit:r})}),(0,e.jsx)(ll,{src:"Media/Glyphs/Money.svg",className:e6})]})},f6=function(t){var n=t.value,r=t.unit,i=C(b3);return(0,e.jsxs)("div",{className:Oe()(Z4,i<n.x&&J4),children:[(0,e.jsx)("div",{children:(0,e.jsx)(dc,{value:n.y,unit:r})}),(0,e.jsx)(ll,{src:"Media/Glyphs/Money.svg",className:e6})]})};function h6(e,t,n){return(0,i.useMemo)((function(){if(null==n)return[];var r=n*t;if(r>=e.length)return[];var i=Math.min(r+t,e.length);return e.slice(r,i)}),[n,t,e])}const m6="asset-grid_H7_",p6="content_O28",v6="row_nrc",g6="item_KJ3 item-hover_WK8 item-active_Spn",y6="thumbnail_kkU",b6="not-enough-money__6E",x6="item-inner_hCN",_6="highlight_VDQ",j6="lock_w5T",E6="already-built_NqB",O6="not-enough-money-badge_S3U",T6="page-indicators_Z3v",I6="page-indicator_zOa";function S6(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function w6(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||P6(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function N6(e){return function(e){if(Array.isArray(e))return S6(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||P6(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function P6(e,t){if(e){if("string"==typeof e)return S6(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?S6(e,t):void 0}}var C6=18,A6=function(t){var n=t.className,r=C(fD),o=C(hD),a=M(sD,r),s=HN(gD),u=Math.ceil(a.length/C6),d=M6(a,C6,o),f=h6(a,C6,d),h=(0,i.useMemo)((function(){return{"Move Vertical":function(e){var t=a.findIndex((function(e){return c(e.entity,o)}))%2;if(e<0){if(d<u-1){var n=Math.min((d+1)*C6+t,a.length-1);return gD(a[n].entity),!0}}else if(e>0){if(d>0)return gD(a[(d-1)*C6+9+t].entity),!0}return!1}}}),[a,u,o,d]);return EI((0,e.jsx)(Tn,{actions:h,disabled:u<2,children:(0,e.jsxs)("div",{className:Oe()(m6,n),children:[(0,e.jsx)("div",{className:p6,children:(0,e.jsx)(Mn,{focused:l(o),onChange:s,children:N6(Array(2)).map((function(t,n){return(0,e.jsx)("div",{className:v6,children:f.slice(9*n,9*(n+1)).map((function(t){return(0,e.jsx)(L6,{asset:t,selected:c(t.entity,o),onSelect:gD},l(t.entity))}))},n)}))})}),(0,e.jsx)("div",{className:T6,children:u>1&&N6(Array(u).keys()).map((function(t){return(0,e.jsx)("div",{onClick:function(){return gD(a[t*C6].entity)},className:Oe()(I6,t===d&&"selected")},t)}))})]})}))},L6=function(t){var n=t.asset,r=t.selected,o=t.onSelect;su(n.uiTag,r&&!n.locked),cu(n.uiTag,r&&!n.locked);var a=w6((0,i.useState)(!1),2),s=a[0],c=a[1],u=(0,i.useContext)(K8),d=C(b3),f=(0,i.useCallback)((function(){return o(n.entity)}),[n.entity,o]),h=(0,i.useCallback)((function(){return u&&u.showDetails(n.entity)}),[n.entity,u]),m=(0,i.useCallback)((function(){return u&&u.hideDetails(n.entity)}),[n.entity,u]),p=!(n.locked||n.uniquePlaced)&&null!=n.constructionCost&&("number"==typeof n.constructionCost.value?d<n.constructionCost.value:d<n.constructionCost.value.x),v=cr()&&s;return(0,i.useEffect)((function(){null!=u&&(v?u.showDetails(n.entity):u.hideDetails(n.entity))}),[n.entity,u,v]),(0,e.jsx)(bS,{uiTag:n.uiTag,disableBlinking:r,active:!n.locked,children:(0,e.jsx)(Jh,{onFocusChange:c,children:(0,e.jsx)(xO,{tooltip:!u&&(0,e.jsx)(Ks.Assets.NAME,{hash:n.name}),children:(0,e.jsxs)(ml,{focusKey:l(n.entity),selected:r,className:Oe()(g6,p&&b6),onClick:f,disabled:n.locked||n.uniquePlaced,onMouseOver:h,onMouseLeave:m,children:[(0,e.jsx)("div",{className:x6}),(0,e.jsx)("img",{src:n.icon,onError:tl,className:y6}),n.uniquePlaced&&(0,e.jsx)("img",{src:"Media/Game/Icons/AlreadyBuilt.svg",className:E6}),p&&(0,e.jsx)("img",{src:"Media/Game/Icons/NoMoney.svg",className:O6}),n.highlight&&(0,e.jsx)(TF,{className:_6}),n.locked&&(0,e.jsx)(YN,{className:j6})]})})})})};function M6(e,t,n){if(0===t)return 0;var r=e.findIndex((function(e){return c(e.entity,n)}));return-1===r?0:Math.trunc(r/t)}const R6="asset-panel_VFR",k6="gamepad-active_KKW",D6="detail-container_E9q",U6="detail-panel_izf";function F6(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function G6(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return F6(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return F6(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var V6=function(t){var n=t.focusKey,r=t.className,o=t.onClose;nn(en);var a=cr(),l=G6((0,i.useState)(ii),2),s=l[0],u=l[1],d=!c(s,ii),f=(0,i.useMemo)((function(){return{showDetails:function(e){return u(e)},hideDetails:function(e){return u((function(t){return c(t,e)?ii:t}))}}}),[]);(0,i.useEffect)((function(){if(a&&d){var e=Jn.subscribe((function(e){e&&u(ii)}));return function(){return e.dispose()}}}),[a,d]);var h=EI(C(dD)),m=EI(C(fD)),p=M(lD,h),v=M(OS,h);su(null==v?void 0:v.uiTag,!(null==v?void 0:v.locked)),cu(null==v?void 0:v.uiTag);var g=(0,i.useMemo)((function(){return{Back:o,"Switch Tab":p.length>=2?function(e){var t=p.findIndex((function(e){return c(e.entity,m)}));if(e<0){var n=lp(t,p.length,!0);null!=n&&(vD(p[n].entity),Jt(Qt.selectPreviousItem))}else if(e>0){var r=op(t,p.length,!0);null!=r&&(vD(p[r].entity),Jt(Qt.selectNextItem))}}:null}}),[p,o,m]);return(0,e.jsx)(Tn,{actions:g,children:(0,e.jsx)($t,{styles:H8,children:(0,e.jsxs)(Tr,{focusKey:n,className:r,children:[(0,e.jsx)("div",{className:D6,children:d&&(0,e.jsx)(u6,{entity:s,className:U6},"details")}),(0,e.jsx)(K8.Provider,{value:f,children:(0,e.jsx)($r,{className:Oe()(R6,a&&k6),header:p.length>0?(0,e.jsx)(e4,{categories:p,selectedCategory:m,onChange:vD,onClose:o}):void 0,children:(0,e.jsx)(A6,{})})})]})})})};const B6={header:"header_emp header_Bpo child-opacity-transition_nkS",content:"content__Ej content_AD7 child-opacity-transition_nkS",footer:"footer_kk9 footer_pD5 child-opacity-transition_nkS",title:"title_h2h title_zQN"};var H6="chirper",K6=E(H6,"chirps"),W6=I(H6,"chirpAdded");function z6(e){N(H6,"addLike",e)}function Y6(e){N(H6,"removeLike",e)}function X6(e){N(H6,"selectLink",e)}const q6="chirp-layout_IRk",$6="avatar_h3G",Q6="padded_FS6",Z6="content_ysS",J6="header_eEy",e7="sender_lDZ",t7="date_GKh",n7="message_Y0C",r7="footer_3qO",i7="like-button_LNZ",o7="liked_F9N";var a7=["#571f1f","#841212","#9c1a4b","#cd3c73","#ec7692","#8a7c17","#bf9e04","#e7a415","#fdc61e","#fcdb56","#2a571f","#13900a","#57b12b","#2eb077","#40dbae","#1f4057","#0f5c91","#3d7ac4","#3599ff","#7db0ea","#491f57","#671284","#a148ab","#c660ca","#d687e2"];function l7(e){return e>0?a7[e%a7.length]:void 0}var s7={tension:30,friction:10},c7=function(t){var n,r,o=t.focusKey,a=t.chirp,l=t.className,s=(0,i.useCallback)((function(){a.liked?Y6(a.entity):z6(a.entity)}),[a.entity,a.liked]),c=(0,i.useCallback)((function(){X6(a.sender.link.target)}),[a]),u=(0,i.useMemo)((function(){return{"Select Chirp Sender":function(){Jt(Qt.selectItem),c()},"Like Chirp":a.liked?null:function(){Jt(Qt.likeChirp),z6(a.entity)},"Unlike Chirp":a.liked?function(){Jt(Qt.likeChirp),Y6(a.entity)}:null}}),[a.entity,a.liked,c]),d=C(Gp),f=$p(d,C(Bp)),h=(0,i.useMemo)((function(){return Zp(d,a.date)}),[a.date,d]),m=vL(),p=(0,i.useMemo)((function(){return m(a.sender.link.name)}),[a.sender.link.name,m]),v=function(t,n){var r=(0,i.useMemo)((function(){return t.links.reduce((function(e,t,r){var i=n(t.name);return e["LINK_".concat(r)]="<".concat(t.target,"|").concat(i,">"),e["LINK_NAME_".concat(r)]=i,e["LINK_TARGET_".concat(r)]=t.target,e}),{})}),[t.links,n]);return(0,e.jsx)(fI,{onLinkSelect:X6,children:(0,e.jsx)(Ss,{id:t.messageId,args:r})})}(a,m),g=Math.round(V$(s7,a.likes,void 0,!0));return(0,e.jsx)(Tn,{actions:u,children:(0,e.jsxs)(Tr,{focusKey:o,className:Oe()(q6,l),children:[(0,e.jsx)(xl,{focusKey:Te,src:null!==(r=a.sender.avatar)&&void 0!==r?r:"Media/Game/Misc/ChirperBlankAvatar.svg",disabled:""===a.sender.link.target,className:Oe()($6,(null===(n=a.sender.avatar)||void 0===n?void 0:n.endsWith(".svg"))&&Q6),style:{backgroundColor:l7(a.sender.randomIndex)},onSelect:c}),(0,e.jsxs)("div",{className:Z6,children:[(0,e.jsxs)("div",{className:J6,children:[(0,e.jsx)(ml,{focusKey:Te,className:e7,onSelect:c,disabled:""===a.sender.link.target,children:p}),(0,e.jsx)("div",{className:t7,children:qp(f,h)?(0,e.jsx)($s,{value:h}):(0,e.jsx)(Ys,{value:h})})]}),(0,e.jsx)("div",{className:n7,children:v}),(0,e.jsxs)("div",{className:r7,children:[(0,e.jsx)(dc,{value:a.liked?g+1:g,unit:tc.IntegerRounded}),(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:a.liked?"Media/Glyphs/HeartFilled.svg":"Media/Glyphs/HeartOutline.svg",className:Oe()(i7,a.liked&&o7),selectSound:Qt.likeChirp,onSelect:s})]})]})]})})};const u7={"item-transition":"item-transition_UXZ",itemTransition:"item-transition_UXZ",enter:"enter_eca","enter-active":"enter-active_bH4",enterActive:"enter-active_bH4",exit:"exit_Jp9","exit-active":"exit-active_rih",exitActive:"exit-active_rih",container:"container_Z2a",space:"space_emJ","event-item":"event-item_q35",eventItem:"event-item_q35","event-date":"event-date_xTF",eventDate:"event-date_xTF","event-label":"event-label_BDa container_Z2a",eventLabel:"event-label_BDa container_Z2a"};var d7=function(t){var n=t.focusKey,r=t.style,i=t.children;return(0,e.jsx)(lJ,{styles:u7,children:(0,e.jsxs)("div",{className:u7.itemTransition,style:r,children:[(0,e.jsx)(Tr,{focusKey:n,focusSound:Qt.hoverItem,className:u7.container,children:i}),(0,e.jsx)("div",{className:u7.space})]})})},f7=function(t){var n=t.focusKey,r=t.date,i=t.children;return(0,e.jsx)(lJ,{styles:u7,children:(0,e.jsxs)("div",{className:u7.itemTransition,children:[(0,e.jsxs)("div",{className:u7.eventItem,children:[(0,e.jsx)("div",{className:u7.eventDate,children:(0,e.jsx)(Ys,{value:r})}),(0,e.jsx)(Tr,{focusKey:n,focusSound:Qt.hoverItem,className:u7.eventLabel,children:i})]}),(0,e.jsx)("div",{className:u7.space})]})})};const h7="chirper-panel_kDN",m7="scrollable_SAp";var p7=function(t){var n,r,o,a=t.className,s=t.onClose,c=C(K6),u=VX(),d=(0,i.useContext)(Vt);return su(null===(n=TS.value)||void 0===n?void 0:n.chirperPanel,c.length>0),(0,i.useEffect)((function(){if(!d){var e=W6.subscribe((function(){u.smoothScrollTo(0,0),Jt(Qt.chirpEvent)}));return function(){return e.dispose()}}}),[d,u]),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.chirperPanel,disableBlinking:!0,children:(0,e.jsx)($r,{theme:B6,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Chirper.PANEL_TITLE,{})}),transitionSounds:en,className:Oe()(h7,a),onClose:s,children:c.length>0?(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.chirperPanelChirps,children:(0,e.jsx)(mf,{controller:u,className:m7,children:(0,e.jsx)(Fn,{children:(0,e.jsx)(nO,{children:c.map((function(t){return(0,e.jsx)(d7,{children:(0,e.jsx)(c7,{chirp:t})},l(t.entity))}))})})})}):(0,e.jsx)(DP,{children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Chirper.OPENING_MESSAGE,{})})})})})};const v7={balloon:"balloon_ltu balloon_qJY balloon_H23",enter:"enter_tT_ enter_ZTk","enter-active":"enter-active_r4U enter-active_AJs",enterActive:"enter-active_r4U enter-active_AJs",exit:"exit_OtI undefined","exit-active":"exit-active_Dqt exit-active_RfZ",exitActive:"exit-active_Dqt exit-active_RfZ",container:"container_eNL container_zgM container_jfe",locked:"locked_UbY",arrow:"arrow_R9U arrow_SVb arrow_Xfn",content:"content_wfU content_A82 content_JQV",main:"main_F2U",lock:"lock_Gqk",requirements:"requirements_dsk"};function g7(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function y7(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function b7(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var x7=function(t){var n=t.title,r=t.description,o=t.content,a=t.locked,l=void 0!==a&&a,s=t.requirements,c=t.className,u=t.children,d=b7(t,["title","description","content","locked","requirements","className","children"]),f=i.Children.count(n)>0||i.Children.count(r)>0||i.Children.count(o)>0,h=(0,i.useMemo)((function(){return l&&s&&s.requireAll.length+s.requireAny.length>0}),[l,s]);return(0,e.jsx)(xO,y7(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){g7(e,t,n[t])}))}return e}({},d),{theme:v7,className:Oe()(h&&v7.locked,c),tooltip:f||h?(0,e.jsxs)(e.Fragment,{children:[f&&(0,e.jsx)(EL,{title:n,description:r,content:o,className:v7.main}),f&&h&&(0,e.jsx)(YN,{className:v7.lock}),h&&s&&(0,e.jsx)(v4,{requirements:s,className:v7.requirements})]}):void 0,children:u}))};const _7="detail-layout_vME",j7="scrollable_sRo",E7="header_Vle",O7="icon-container_FJv",T7="icon_IKT",I7="title_UOl",S7="description_VWf",w7="content_AGf",N7="bottom_fjL";var P7=function(t){var n=t.icon,r=t.title,o=t.description,a=t.bottom,l=t.className,s=t.children,c=i.Children.count(s)>0,u=i.Children.count(a)>0;return(0,e.jsxs)("div",{className:Oe()(_7,l),children:[(0,e.jsxs)(mf,{autoScroll:!0,className:j7,children:[(0,e.jsxs)("div",{className:E7,children:[n&&(0,e.jsx)("div",{className:O7,children:(0,e.jsx)("img",{src:n,className:T7})}),(0,e.jsx)("div",{className:I7,children:r})]}),(0,e.jsx)("div",{className:S7,children:(0,e.jsx)(fI,{children:o})}),c&&(0,e.jsx)("div",{className:w7,children:s})]}),u&&(0,e.jsx)("div",{className:N7,children:a})]})};const C7="unlocking-label_ctB",A7="locked_rgX",L7="unlocked_rws";var M7=function(t){var n=t.state;return(0,e.jsx)("div",{className:Oe()("Locked"===n?A7:L7,C7),children:"Locked"===n?(0,e.jsx)(Ks.Common.LOCKED,{}):(0,e.jsx)(Ks.Common.UNLOCKED,{})})};const R7={"unlocking-requirements":"unlocking-requirements_Usp",unlockingRequirements:"unlocking-requirements_Usp"};var k7="cityInfo",D7=E(k7,"residentialLowDemand"),U7=E(k7,"residentialMediumDemand"),F7=E(k7,"residentialHighDemand"),G7=E(k7,"commercialDemand"),V7=E(k7,"industrialDemand"),B7=E(k7,"officeDemand"),H7=E(k7,"residentialLowFactors"),K7=E(k7,"residentialMediumFactors"),W7=E(k7,"residentialHighFactors"),z7=E(k7,"commercialFactors"),Y7=E(k7,"industrialFactors"),X7=E(k7,"officeFactors"),q7=E(k7,"happiness"),$7=E(k7,"happinessFactors");const Q7={"demand-bar":"demand-bar_WmU",demandBar:"demand-bar_WmU",icon:"icon_b9Y",locked:"locked_Lrk",lock:"lock_ezp"};var Z7=function(t){var n=t.icon,r=t.color,i=t.demand,o=t.locked,a=void 0!==o&&o,l=qd(),s=99*l,c=444*l,u=s/2,d=c-u,f=i*c,h=f<s?f-u*(f/s):f-u;return(0,e.jsxs)("div",{className:Q7.demandBar,children:[(0,e.jsx)("img",{src:n,onError:tl,className:Oe()(Q7.icon,a&&Q7.locked)}),(0,e.jsxs)("svg",{viewBox:"0 0 ".concat(c," ").concat(s),className:Q7.svg,height:"".concat(s),width:"".concat(c),children:[(0,e.jsxs)("linearGradient",{id:"monochrome",gradientUnits:"userSpaceOnUse",x1:0,x2:c,y1:0,y2:0,children:[(0,e.jsx)("stop",{offset:"0%",stopColor:"rgba(0, 0, 0, 0.2)"}),(0,e.jsx)("stop",{offset:"100%",stopColor:"rgba(0, 0, 0, 0)"})]}),(0,e.jsx)("polygon",{points:"0,0 0,".concat(s," ").concat(d,",").concat(s," ").concat(c,",").concat(u," ").concat(d,",0 0,0"),fill:a?"rgb(45, 46, 54)":"rgba(0, 0, 0, 0.45)"}),!a&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("polygon",{points:"0,0 0,".concat(s," ").concat([h],",").concat(s," ").concat([f],",").concat(u," ").concat([h],",0 0,0"),fill:r}),(0,e.jsx)("polygon",{points:"0,0 0,".concat(s," ").concat([h],",").concat(s," ").concat([f],",").concat(u," ").concat([h],",0 0,0"),fill:"url(#monochrome)"})]})]}),a&&(0,e.jsx)(YN,{className:Q7.lock})]})};const J7="demand-factors_RlK",e9="factor_iZk",t9="label_qWr",n9="icon_d3_";var r9=function(t){var n=t.factors,r=t.locked,i=void 0!==r&&r;return(0,e.jsx)("div",{className:J7,children:!i&&n.filter((function(e){return null!=e.factor})).map((function(t,n){return(0,e.jsx)(i9,{factor:t},n)}))})},i9=function(t){var n=t.factor;return(0,e.jsxs)("div",{className:e9,children:[(0,e.jsx)("img",{className:n9,src:n.weight<0?"Media/Game/Misc/DemandFactorNegative.svg":"Media/Game/Misc/DemandFactorPositive.svg",onError:tl}),(0,e.jsx)("div",{className:t9,children:n.weight<0?(0,e.jsx)(Ks.CityInfoPanel.DEMAND_FACTOR_NEGATIVE,{hash:n.factor}):(0,e.jsx)(Ks.CityInfoPanel.DEMAND_FACTOR_POSITIVE,{hash:n.factor})})]})};const o9="demand-section_xG1",a9="title_TAF title_PYv title_bwV",l9="content_Bmx",s9={section:"section_egX section_sop section_gUk",header:"header_LLa header_l0j undefined",content:"content_lbR content_flM content_owQ",locked:"locked_dpm"};function c9(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var u9=function(t){var n=t.type,r=t.demand,o=t.unlocking,a=t.factors,l=t.className,s=t.onSelect,c=t.onHover,u=(0,i.useCallback)((function(){return c(n)}),[c,n]),d=(0,i.useCallback)((function(){return Jt(Qt.hoverItem)}),[]),f=(0,i.useCallback)((function(){return c(y9.None)}),[c]),h=(0,i.useCallback)((function(e){e&&(s(n),Jt(Qt.hoverItem))}),[s,n]),m=(0,i.useCallback)((function(){s(n),Jt(Qt.selectItem)}),[s,n]),p=function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){c9(e,t,n[t])}))}return e}({},IO,s9);return(0,e.jsx)(CO,{theme:p,header:(0,e.jsx)("div",{className:a9,children:(0,e.jsx)(Ks.CityInfoPanel.DEMAND_TITLE,{hash:y9[n]})}),onClick:m,onMouseOver:u,onMouseEnter:d,onMouseLeave:f,onFocusChange:h,className:Oe()(o9,(null==o?void 0:o.locked)&&p.locked,l),children:(0,e.jsxs)("div",{className:l9,children:[(0,e.jsx)(Z7,{icon:x9[n],color:b9[n],demand:(null==o?void 0:o.locked)?0:r,locked:null==o?void 0:o.locked}),(0,e.jsx)(r9,{factors:a,locked:null==o?void 0:o.locked})]})})};const d9="demand-page_X1J",f9="main-column_cMY",h9="scrollable_VIF",m9="info-column_dEc",p9="demand-row_CQi";function v9(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function g9(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return v9(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return v9(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var y9;!function(e){e[e.None=0]="None",e[e.ResidentialLow=1]="ResidentialLow",e[e.ResidentialMedium=2]="ResidentialMedium",e[e.ResidentialHigh=3]="ResidentialHigh",e[e.Commercial=4]="Commercial",e[e.Industrial=5]="Industrial",e[e.Office=6]="Office"}(y9||(y9={}));var b9=["","#8BDB46","#00AE1A","#2B7600","#46B2DB","#DBC246","#8D44AD"],x9=["","Media/Game/Icons/ZoneResidentialLow.svg","Media/Game/Icons/ZoneResidentialMedium.svg","Media/Game/Icons/ZoneResidentialHigh.svg","Media/Game/Icons/ZoneCommercial.svg","Media/Game/Icons/ZoneIndustrial.svg","Media/Game/Icons/ZoneOffice.svg"];function _9(){var t,n=C(D7),r=C(U7),o=C(F7),a=C(G7),l=C(V7),s=C(B7),c=C(H7),u=C(K7),d=C(W7),f=C(z7),h=C(Y7),m=C(X7),p=FM("ZonesOffice"),v=FM("Residential Medium"),g=FM("Residential High"),y=g9((0,i.useState)(y9.ResidentialLow),2),b=y[0],x=y[1],_=g9((0,i.useState)(y9.None),2),j=_[0],E=_[1],O=(0,i.useMemo)((function(){return j!==y9.None?j:b}),[j,b]);return(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.cityInfoPanelDemandPage,children:(0,e.jsx)("div",{className:d9,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)("div",{className:f9,children:(0,e.jsxs)(mf,{className:h9,children:[(0,e.jsx)(u9,{type:y9.ResidentialLow,demand:n,factors:c,onHover:E,onSelect:x,className:Oe()(b===y9.ResidentialLow&&"selected",p9)}),(0,e.jsx)(u9,{type:y9.ResidentialMedium,demand:r,factors:u,unlocking:v,onHover:E,onSelect:x,className:Oe()(b===y9.ResidentialMedium&&"selected",p9)}),(0,e.jsx)(u9,{type:y9.ResidentialHigh,demand:o,factors:d,unlocking:g,onHover:E,onSelect:x,className:Oe()(b===y9.ResidentialHigh&&"selected",p9)}),(0,e.jsx)(u9,{type:y9.Commercial,demand:a,factors:f,onHover:E,onSelect:x,className:Oe()(b===y9.Commercial&&"selected",p9)}),(0,e.jsx)(u9,{type:y9.Industrial,demand:l,factors:h,onHover:E,onSelect:x,className:Oe()(b===y9.Industrial&&"selected",p9)}),(0,e.jsx)(u9,{type:y9.Office,demand:s,factors:m,unlocking:p,onHover:E,onSelect:x,className:Oe()(b===y9.Office&&"selected",p9)})]})}),(0,e.jsx)(j9,{id:y9[O],icon:x9[O],unlocking:O===y9.Office&&p||O===y9.ResidentialMedium&&v||O===y9.ResidentialHigh&&g||void 0})]})})})}var j9=function(t){var n,r=t.id,i=t.icon,o=t.unlocking;return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:m9,children:(0,e.jsx)(P7,{icon:i,title:(0,e.jsx)(Ks.CityInfoPanel.DEMAND_TITLE,{hash:r}),description:(0,e.jsx)(Ks.CityInfoPanel.DEMAND_DESCRIPTION,{hash:r}),bottom:null!=o&&(n=o.requirements,n.requireAll.length>0||n.requireAny.length>0)?(0,e.jsx)(v4,{theme:R7,requirements:o.requirements}):void 0,children:(null==o?void 0:o.locked)?(0,e.jsx)(M7,{state:"Locked"}):void 0},r)})},E9="policies",O9=E(E9,"cityPolicies"),T9=w(E9,"setCityPolicy");function I9(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0;T9(e,t,n)}var S9=w(E9,"setPolicy");function w9(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0;S9(e,t,n)}const N9="city-policy_QlE item-states_QjV",P9="disable-mouse-states_O0k",C9="content_Epe",A9="left_MRp",L9="right_Xny",M9="icon_pZC",R9="disabled_mRJ",k9="locked_qsG",D9="lock_q6f",U9="checkbox_nNF",F9="control_box",G9="slider_RcP",V9="label_SXQ";function B9(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function H9(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return B9(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return B9(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var K9=function(t){var n,r,o=t.policy,a=t.selected,l=t.className,s=t.onSelect,c=t.onHover,u=H9((0,i.useState)(o.active),2),d=u[0],f=u[1],h=H9((0,i.useState)(null!==(r=null===(n=o.data)||void 0===n?void 0:n.value)&&void 0!==r?r:0),2),m=h[0],p=h[1],v=H9((0,i.useState)(!1),2),g=v[0],y=v[1],b=H9((0,i.useState)(!1),2),x=b[0],_=b[1],j=cr(),E=(0,i.useCallback)((function(){I9(o.entity,!d,m),f(!d)}),[d,o,m]),O=(0,i.useCallback)((function(e){p(e),j&&I9(o.entity,d,e)}),[d,j,o]),T=(0,i.useCallback)((function(){return _(!0)}),[]),I=(0,i.useCallback)((function(){I9(o.entity,d,m),_(!1)}),[d,o,m]),S=(0,i.useCallback)((function(){E(),Jt(Qt.selectItem)}),[E]),w=(0,i.useCallback)((function(){return Jt(Qt.hoverItem)}),[]),N=(0,i.useCallback)((function(){return c(null)}),[c]),P=(0,i.useCallback)((function(){return c(o)}),[c,o]),C=(0,i.useCallback)((function(e){return e&&s(o)}),[s,o]),A=(0,i.useCallback)((function(){s(o),Jt(Qt.selectItem)}),[s,o]),L=(0,i.useCallback)((function(){return y(!1)}),[]),M=(0,i.useCallback)((function(){return y(!0)}),[]);return(0,e.jsx)(bS,{uiTag:o.uiTag,children:(0,e.jsx)(In,{onAction:S,children:(0,e.jsx)(Tr,{onClick:A,onFocusChange:C,onMouseOver:P,onMouseEnter:w,onMouseLeave:N,className:Oe()(N9,a&&"selected",o.locked&&k9,!d&&R9,(g||x)&&P9,l),children:(0,e.jsxs)("div",{className:C9,children:[(0,e.jsxs)("div",{className:A9,children:[(0,e.jsx)("img",{src:o.icon,className:M9}),(0,e.jsx)("div",{className:V9,children:(0,e.jsx)(Ks.Policy.TITLE,{hash:o.id})})]}),(0,e.jsxs)("div",{className:L9,children:[o.data&&m&&(0,e.jsxs)("div",{className:F9,children:[(0,e.jsx)("div",{className:V9,children:(0,e.jsx)(dc,{value:!o.locked&&d?m:0,unit:o.data.unit})}),(0,e.jsx)(Fm,{value:!o.locked&&d?m:0,start:!o.locked&&d?o.data.range.min:0,end:!o.locked&&d?o.data.range.max:1,gamepadStep:o.data.step,onDragEnd:I,onDragStart:T,onChange:O,onMouseOver:M,onMouseLeave:L,disabled:!d||o.locked,className:G9})]}),o.locked&&(0,e.jsx)(YN,{className:D9}),!o.locked&&(0,e.jsx)(pp,{onMouseOver:M,onMouseLeave:L,checked:d,onChange:E,focusKey:Te,className:U9})]})]})})})})};const W9="policies-page_YYY",z9="main-column_Pve",Y9="info-column_G8F",X9="scrollable_SFL";function q9(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function $9(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return q9(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return q9(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Q9=function(){var t,n,r=C(O9),o=$9((0,i.useState)(r.length>0?null!==(n=r.find((function(e){return!e.locked})))&&void 0!==n?n:r[0]:null),2),a=o[0],l=o[1],s=$9((0,i.useState)(null),2),u=s[0],d=s[1],f=(0,i.useMemo)((function(){return null!=u?u:a}),[u,a]);return(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.cityInfoPanelPoliciesPage,children:(0,e.jsxs)("div",{className:W9,children:[(0,e.jsx)(CO,{theme:IO,className:z9,children:(0,e.jsx)(Fn,{children:(0,e.jsx)(mf,{className:X9,children:r.map((function(t){return(0,e.jsx)(K9,{policy:t,selected:c(t.entity,null==a?void 0:a.entity),onSelect:l,onHover:d},t.id)}))})})}),(0,e.jsx)(Z9,{policy:f})]})})},Z9=function(t){var n=t.policy;return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Y9,children:n&&(0,e.jsx)(P7,{icon:n.icon,title:(0,e.jsx)(Ks.Policy.TITLE,{hash:n.id}),description:(0,e.jsx)(Ks.Policy.DESCRIPTION,{hash:n.id}),bottom:n.locked&&(0,e.jsx)(v4,{theme:R7,requirements:n.requirements}),children:n.locked&&(0,e.jsx)(M7,{state:"Locked"})},l(n.entity))})};const J9="city-info-panel_Eha";var eee=function(t){var n,r,i,o=t.selectedTab,a=t.onSelectTab,l=t.onClose;uu(null===(n=TS.value)||void 0===n?void 0:n.cityInfoPanel);var s=FM("Policies");return(0,e.jsx)($r,{header:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.CityInfoPanel.TITLE,{})}),(0,e.jsxs)(ZN,{children:[(0,e.jsx)(JN,{id:Ka.Demand,uiTag:null===(r=TS.value)||void 0===r?void 0:r.cityInfoPanelDemandTab,selectedId:o,onSelect:a,children:(0,e.jsx)(Ks.CityInfoPanel.TAB,{hash:Ka[Ka.Demand]})}),(0,e.jsx)(x7,{locked:s.locked,requirements:s.requirements,children:(0,e.jsx)(JN,{id:Ka.Policies,uiTag:null===(i=TS.value)||void 0===i?void 0:i.cityInfoPanelPoliciesTab,selectedId:o,disabled:s.locked,locked:s.locked,onSelect:a,children:(0,e.jsx)(Ks.CityInfoPanel.TAB,{hash:Ka[Ka.Policies]})})})]})]}),transitionSounds:en,className:J9,onClose:l,children:(0,e.jsx)(QN,{tabs:[Ka.Demand,Ka.Policies],selectedTab:o,onSelect:a,children:tee(o)})})};function tee(t){switch(t){case Ka.Demand:return(0,e.jsx)(_9,{});case Ka.Policies:return(0,e.jsx)(Q9,{});default:return}}var nee="budget",ree=E(nee,"totalIncome"),iee=E(nee,"totalExpenses"),oee=E(nee,"incomeItems"),aee=E(nee,"incomeValues"),lee=E(nee,"expenseItems"),see=E(nee,"expenseValues");function cee(e,t){return e.sources.reduce((function(e,n){return e+t[n.index]}),0)}const uee={"money-field":"money-field_bzk",moneyField:"money-field_bzk",primary:"primary__xr",secondary:"secondary_HCa",positive:"positive_HL9",negative:"negative_PiU",sign:"sign__wn",content:"content_pa5"};var dee=function(t){var n=t.value,r=t.importance,i=t.className;return(0,e.jsxs)("div",{className:Oe()(uee.moneyField,r&&uee[r],Ef(uee,n),i),children:[(0,e.jsx)("div",{className:uee.sign,children:fee(n)}),(0,e.jsx)("div",{className:uee.content,children:(0,e.jsx)(dc,{value:Math.abs(n),unit:tc.Money})})]})};function fee(e){return e<0?"−":e>0?"+":""}const hee="rgba(255, 255, 255, 0.6)",mee="rgba(255, 255, 255, 0.1)",pee="budget-chart_CSi",vee="chart_xgb";function gee(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yee(e){return function(e){if(Array.isArray(e))return gee(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return gee(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gee(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bee=function(t){var n,r,o=t.selectedId,a=t.className,l=C(oee),s=Mr(C(aee),1),c=C(lee),u=Mr(C(see),1),d=(0,i.useMemo)((function(){return{labels:["Budget"],datasets:yee(xee(l,s,1,"income",o)).concat(yee(xee(c,u,-1,"expenses",o)))}}),[l,s,o,c,u]),f=(n=fc(tc.Money),r=C(Jl),{layout:{padding:{top:12,right:24,bottom:0,left:12}},scales:{y:{stacked:!0,suggestedMax:1e3,beginAtZero:!0,grid:{color:mee,lineWidth:2},border:{color:mee,width:2},ticks:{maxTicksLimit:10,font:{size:10*r},color:hee,padding:10,autoSkip:!1,callback:function(e){return n(e)}}},x:{stacked:!0,grid:{display:!1},ticks:{display:!1}}}});return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(pee,a),children:(0,e.jsx)(Zj,{type:"bar",data:d,options:f,className:vee})})};function xee(e,t,n,r,i){return e.map((function(e){return{label:e.id,data:[n*cee(e,t)],backgroundColor:pm(e.color),barPercentage:e.id===i?.9:.5,categoryPercentage:.7,stack:r}})).reverse()}const _ee={field:"field_ZZV",header:"header_FoF",icon:"icon_Vso",label:"label_XR5",content:"content_N5U",positive:"positive_Deq",negative:"negative_iIx"},jee={"detail-layout":"detail-layout_TAz",detailLayout:"detail-layout_TAz"};var Eee=function(t){var n=t.item,r=t.values,i=t.className;return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(jee.budgetItemDetail,i),children:null!=n&&(0,e.jsx)(P7,{icon:n.icon,title:(0,e.jsx)(Ks.EconomyPanel.BUDGET_ITEM,{hash:n.id}),description:(0,e.jsx)(Ks.EconomyPanel.BUDGET_ITEM_DESCRIPTION,{hash:n.id}),bottom:n.sources.map((function(t,n){return(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.EconomyPanel.BUDGET_SUB_ITEM,{hash:t.id}),theme:_ee,className:Ef(_ee,r[t.index]),children:(0,e.jsx)(dc,{value:r[t.index],unit:tc.Money})},n)})),className:jee.detailLayout},n.id)})};const Oee="budget-section_F_L",Tee="header__ZM",Iee="item_fWX item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",See="selected_yiI",wee="title-column_u4_",Nee="title_XJK",Pee="legend-color_jK2",Cee="value-column_Tid",Aee="value-field_M8j",Lee="value-column-divider_afM";var Mee=i.memo((function(t){var n=t.title,r=t.total,o=t.items,a=t.values,l=t.className,s=t.onMouseEnter,c=t.onMouseLeave,u=t.uiTag,d=t.selectedItem,f=t.onItemSelected,h=(0,i.useContext)(Ge);return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(Oee,l),header:(0,e.jsx)(bS,{uiTag:u,children:(0,e.jsxs)("div",{className:Tee,children:[(0,e.jsx)("div",{className:wee,children:n}),(0,e.jsx)("div",{className:Cee,children:(0,e.jsx)(dee,{value:r,importance:"secondary",className:Aee})})]})}),children:(0,e.jsxs)(Ge.Provider,{value:h,children:[o.map((function(t){return(0,e.jsx)(Ree,{item:t,values:a,onMouseEnter:s,onMouseLeave:c,selected:d===t.id,onSelect:f},t.id)})),(0,e.jsx)("div",{className:Lee})]})})}),(function(e,t){return f(e,t,5)})),Ree=function(t){var n=t.item,r=t.values,o=t.onMouseEnter,a=t.onMouseLeave,l=t.selected,s=t.onSelect,c=cee(n,r),u=(0,i.useCallback)((function(){return o(n.id)}),[o,n.id]),d=(0,i.useCallback)((function(){return a(n.id)}),[a,n.id]),f=(0,i.useCallback)((function(){return s(l?null:n.id)}),[n.id,s,l]);return(0,e.jsxs)(Tr,{focusKey:n.id,className:Oe()(Iee,l&&See),onMouseEnter:u,onMouseLeave:d,onClick:f,children:[(0,e.jsxs)("div",{className:wee,children:[(0,e.jsx)("div",{className:Pee,style:{backgroundColor:pm(n.color)}}),(0,e.jsx)("div",{className:Nee,children:(0,e.jsx)(Ks.EconomyPanel.BUDGET_ITEM,{hash:n.id})})]}),(0,e.jsx)("div",{className:Cee,children:(0,e.jsx)(dee,{value:c,className:Aee})})]})};const kee="budget-page_SIZ",Dee="chart-column_Y0V",Uee="main-column_unC",Fee="info-column_K89",Gee="budget-section_zaZ",Vee="total-section_TGf",Bee="total-content_GKQ",Hee="total-label_Uhe",Kee="total-column_Ikw",Wee="total-field_zjM";function zee(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Yee(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return zee(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zee(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Xee=function(){var t,n,r,o;uu(null===(t=TS.value)||void 0===t?void 0:t.economyPanelBudgetPage);var a,l=C(oee),s=Mr(C(aee),1),c=C(lee),u=Mr(C(see),1),d=C(ree),f=C(iee),h=d+f,m=Yee((0,i.useState)(null),2),p=m[0],v=m[1],g=Yee((0,i.useState)(rp(l,"id")),2),y=g[0],b=g[1],x=Yee((0,i.useState)(null),2),_=x[0],j=x[1],E=(0,i.useCallback)((function(e){return j(e)}),[]),O=(0,i.useCallback)((function(e){return j((function(t){return t===e?null:t}))}),[]),T=(0,i.useCallback)((function(e){return"string"==typeof e&&b(e)}),[]),I=cr(),S=I?y:_||p,w=l.find((function(e){return e.id===S})),N=c.find((function(e){return e.id===S}));return(0,e.jsxs)("div",{className:kee,children:[(0,e.jsx)(bee,{selectedId:S,className:Dee}),(0,e.jsx)("div",{className:Uee,children:(0,e.jsxs)(Mn,{focused:y,direction:On.Vertical,onChange:T,onRefocus:Rn,children:[(0,e.jsx)(Mee,{title:(0,e.jsx)(Ks.EconomyPanel.INCOME_SECTION_TITLE,{}),total:d,items:l,values:s,className:Gee,onMouseEnter:E,onMouseLeave:O,selectedItem:I?null:p,onItemSelected:v,uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelBudgetRevenue}),(0,e.jsx)(Mee,{title:(0,e.jsx)(Ks.EconomyPanel.EXPENSES_SECTION_TITLE,{}),total:f,items:c,values:u,className:Gee,onMouseEnter:E,onMouseLeave:O,selectedItem:I?null:p,onItemSelected:v,uiTag:null===(r=TS.value)||void 0===r?void 0:r.economyPanelBudgetExpenses}),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.economyPanelBudgetBalance,children:(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Vee,children:(0,e.jsxs)("div",{className:Bee,children:[(0,e.jsx)("div",{className:Hee,children:(0,e.jsx)(Ks.EconomyPanel.MONTHLY_BALANCE,{})}),(0,e.jsx)("div",{className:Kee,children:(0,e.jsx)(dee,{value:h,importance:"primary",className:Wee})})]})})})]})}),(0,e.jsx)(Eee,{item:null!==(a=null!=w?w:N)&&void 0!==a?a:null,values:null!=w?s:u,className:Fee})]})},qee="loan",$ee=E(qee,"loanLimit"),Qee=E(qee,"currentLoan"),Zee=E(qee,"loanOffer");function Jee(e){N(qee,"requestLoanOffer",e)}function ete(){N(qee,"acceptLoanOffer")}function tte(){N(qee,"resetLoanOffer")}const nte={"loan-form":"loan-form_Ohg",loanForm:"loan-form_Ohg","slider-column":"slider-column_kts",sliderColumn:"slider-column_kts",balloon:"balloon_Jlj",positive:"positive_WFM",negative:"negative_NTL","balloon-content":"balloon-content_QEH",balloonContent:"balloon-content_QEH",limit:"limit_ZPi","direction-labels":"direction-labels_KdN",directionLabels:"direction-labels_KdN",arrow:"arrow_AXM","less-label":"less-label_ZOG",lessLabel:"less-label_ZOG","less-arrow":"less-arrow_Oio arrow_AXM",lessArrow:"less-arrow_Oio arrow_AXM",space:"space_zFI","more-label":"more-label_PtR",moreLabel:"more-label_PtR","more-arrow":"more-arrow_odN arrow_AXM",moreArrow:"more-arrow_odN arrow_AXM","button-column":"button-column_mFb",buttonColumn:"button-column_mFb",button:"button_aQu","accept-button":"accept-button_uUd button_aQu button_SsC",acceptButton:"accept-button_uUd button_aQu button_SsC","reset-button":"reset-button_I2B button_aQu button_eqb item-states_QjV",resetButton:"reset-button_I2B button_aQu button_eqb item-states_QjV"},rte={slider:"slider_iN8 slider_pUS",edge:"edge_Qvg",positive:"positive_kiJ",negative:"negative_HpK","left-edge":"left-edge_Rrm edge_Qvg",leftEdge:"left-edge_Rrm edge_Qvg","right-edge":"right-edge_ocL edge_Qvg",rightEdge:"right-edge_ocL edge_Qvg","track-bounds":"track-bounds_Bp4",trackBounds:"track-bounds_Bp4",thumb:"thumb_yXN thumb_WZt"},ite={balloon:"balloon__3G balloon_H23",container:"container_VsE container_jfe",arrow:"arrow_cyp arrow_Xfn",content:"content_tDr content_JQV"};var ote=function(){var t,n,r=C($ee),o=C(Qee),a=C(Zee),l=a.amount-o.amount,s=Math.abs(l)>.5,c=function(e){var t=Math.pow(10,Math.max(lte(e)-lte(15),0)),n=t/2,r=t,i=5*t;return e/n<=ate?Math.max(n,1):e/r<=ate?Math.max(r,1):Math.max(i,1)}(r),u=(0,i.useCallback)((function(e,t,n){var r=e+n*(t-e),i=e+Math.round(n*(t-e)/c)*c;return Math.abs(o.amount-r)<Math.abs(i-r)?o.amount:at(i,Math.min(e,t),Math.max(e,t))}),[o.amount,c]),d=(0,i.useMemo)((function(){return{"Change Slider Value":function(e){var t=a.amount;e>0?t=Math.floor((a.amount+c)/c)*c:e<0&&(t=Math.ceil((a.amount-c)/c)*c),(o.amount>a.amount&&t>o.amount||o.amount<a.amount&&t<o.amount)&&(t=o.amount),Jee(t),Jt(Dm.drag)}}}),[o.amount,a.amount,c]);return(0,e.jsx)(Tn,{actions:d,children:(0,e.jsxs)(Tr,{className:nte.loanForm,children:[(0,e.jsxs)("div",{className:nte.sliderColumn,children:[(0,e.jsx)("div",{className:nte.limit,children:(0,e.jsx)(Ks.EconomyPanel.LOAN_FORM_LIMIT,{LOAN_LIMIT:(0,e.jsx)(dc,{value:r,unit:tc.Money})})}),(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.economyPanelLoansSlider,children:(0,e.jsxs)(Fm,{focusKey:Te,value:a.amount,start:0,end:r,valueTransformer:u,thumb:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:rte.thumb}),s&&(0,e.jsx)(cO,{alignment:"center",direction:"down",theme:ite,className:nte.balloon,children:(0,e.jsx)("div",{className:Oe()(nte.balloonContent,Ef(nte,l)),children:(0,e.jsx)(dc,{value:l,unit:tc.Money,signed:!0})})})]}),theme:rte,className:nte.slider,style:{"--stopPos":"".concat(100*at(o.amount/Math.max(r,1),0,1),"%")},onChange:Jee,children:[(0,e.jsx)("div",{className:Oe()(rte.leftEdge,o.amount>0?rte.negative:rte.positive)}),(0,e.jsx)("div",{className:Oe()(rte.rightEdge,o.amount<r?rte.positive:rte.negative)})]})}),(0,e.jsxs)("div",{className:nte.directionLabels,children:[o.amount>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:nte.lessLabel,children:(0,e.jsx)(Ks.EconomyPanel.LOAN_FORM_LESS_LABEL,{})}),(0,e.jsx)(ll,{src:"Media/Glyphs/ThickStrokeArrowLeft.svg",className:nte.lessArrow})]}),(0,e.jsx)("div",{className:nte.space}),o.amount<r&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(ll,{src:"Media/Glyphs/ThickStrokeArrowRight.svg",className:nte.moreArrow}),(0,e.jsx)("div",{className:nte.moreLabel,children:(0,e.jsx)(Ks.EconomyPanel.LOAN_FORM_MORE_LABEL,{})})]})]})]}),(0,e.jsx)("div",{className:nte.buttonColumn,children:(0,e.jsxs)(Fn,{direction:On.Vertical,children:[(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelLoansAccept,children:(0,e.jsx)(ml,{selectSound:Qt.takeLoan,className:nte.acceptButton,disabled:!s,onSelect:ete,children:(0,e.jsx)(Ks.EconomyPanel.LOAN_FORM_ACCEPT,{})})}),(0,e.jsx)(ml,{className:nte.resetButton,disabled:!s,onSelect:tte,children:(0,e.jsx)(Ks.EconomyPanel.LOAN_FORM_RESET,{})})]})})]})})},ate=75;function lte(e){return Math.max(Math.floor(Math.log10(Math.abs(e))),0)+1}const ste={"table-header":"table-header_wsv",tableHeader:"table-header_wsv","header-cell":"header-cell_ymh",headerCell:"header-cell_ymh","table-content":"table-content_YfG",tableContent:"table-content_YfG","content-cell":"content-cell_MZC",contentCell:"content-cell_MZC","amount-column":"amount-column_kN8",amountColumn:"amount-column_kN8","interest-rate-column":"interest-rate-column_jcI",interestRateColumn:"interest-rate-column_jcI","monthly-cost-column":"monthly-cost-column_BPo",monthlyCostColumn:"monthly-cost-column_BPo","monthly-cost-field":"monthly-cost-field_eRh",monthlyCostField:"monthly-cost-field_eRh","new-value":"new-value_keh",newValue:"new-value_keh",negative:"negative_qB0","loan-number":"loan-number_Mcp",loanNumber:"loan-number_Mcp","current-value":"current-value_SLp",currentValue:"current-value_SLp",modified:"modified_rG6","strikethrough-line":"strikethrough-line_Yh8",strikethroughLine:"strikethrough-line_Yh8",hidden:"hidden_RHn"};var cte=function(){return(0,e.jsxs)("div",{className:ste.tableHeader,children:[(0,e.jsx)("div",{className:Oe()(ste.headerCell,ste.amountColumn),children:(0,e.jsx)(Ks.EconomyPanel.LOAN_TABLE_AMOUNT,{})}),(0,e.jsx)("div",{className:Oe()(ste.headerCell,ste.interestRateColumn),children:(0,e.jsx)(Ks.EconomyPanel.LOAN_TABLE_INTEREST_RATE,{})}),(0,e.jsx)("div",{className:Oe()(ste.headerCell,ste.monthlyCostColumn),children:(0,e.jsx)(Ks.EconomyPanel.LOAN_TABLE_MONTHLY_COST,{})})]})},ute=function(){var t=C(Qee),n=C(Zee),r=Math.abs(n.amount-t.amount)>.5;return(0,e.jsxs)("div",{className:ste.tableContent,children:[(0,e.jsx)("div",{className:Oe()(ste.contentCell,ste.amountColumn),children:(0,e.jsx)(dte,{currentValue:t.amount,newValue:n.amount,unit:tc.Money,modified:r})}),(0,e.jsx)("div",{className:Oe()(ste.contentCell,ste.interestRateColumn),children:(0,e.jsx)(dte,{currentValue:100*t.dailyInterestRate,newValue:100*n.dailyInterestRate,unit:tc.PercentageSingleFraction,modified:r})}),(0,e.jsxs)("div",{className:Oe()(ste.contentCell,ste.monthlyCostColumn),children:[(0,e.jsxs)("div",{className:Oe()(uee.moneyField,uee.primary,ste.monthlyCostField),children:[(0,e.jsx)("div",{className:Oe()(uee.sign,Ef(ste,-n.dailyPayment)),children:Oc(-n.dailyPayment,!0)}),(0,e.jsx)("div",{className:Oe()(uee.content,Ef(ste,-t.dailyPayment)),children:(0,e.jsx)(dte,{currentValue:t.dailyPayment,newValue:n.dailyPayment,unit:tc.Money,modified:r,newClassName:Ef(ste,-n.dailyPayment)})})]}),(0,e.jsx)("div",{})]})]})},dte=function(t){var n=t.currentValue,r=t.newValue,i=t.unit,o=t.modified,a=t.newClassName;return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)("div",{className:Oe()(ste.currentValue,o&&ste.modified),children:[(0,e.jsx)(dc,{value:n,unit:i}),o&&(0,e.jsx)("div",{className:ste.strikethroughLine})]}),(0,e.jsx)("div",{className:Oe()(ste.newValue,!o&&ste.hidden,a),children:(0,e.jsx)(dc,{value:r,unit:i})})]})};const fte="loan-adjustment_mqe";var hte=function(t){var n=t.className;return(0,e.jsxs)(CO,{header:(0,e.jsx)(cte,{}),theme:IO,className:Oe()(fte,n),children:[(0,e.jsx)(ute,{}),(0,e.jsx)(ote,{})]})};const mte="rgba(255, 255, 255, 0.6)",pte="rgba(255, 255, 255, 0.1)",vte="rgba(139, 219, 70, 0.6)",gte="rgba(233, 95, 74, 0.6)",yte="rgba(233, 95, 74, 1)",bte="loan-chart_IIu",xte="content_K6K",_te="chart-column_YvP",jte="chart_nml",Ete="summary-column_Wm0",Ote="summary-item__T7",Tte="warning_aXt",Ite="divider_s9s",Ste="legend_ots",wte="legend-item_OSA";var Nte=function(t){var n,r,o=t.className,a=C(Qee),l=C(Zee),s=C(ree),c=s>0?l.dailyPayment/s*100:Number.MAX_VALUE,u=Math.abs(C(iee))-a.dailyPayment,d=u+l.dailyPayment,f=s-d,h=(0,i.useMemo)((function(){return{labels:["Budget"],datasets:[{label:"cityIncome",data:[s],backgroundColor:vte,barPercentage:.8,categoryPercentage:.5,stack:"income"},{label:"cityExpenses",data:[u],backgroundColor:gte,barPercentage:.8,categoryPercentage:.5,stack:"expenses"},{label:"loanInterest",data:[l.dailyPayment],backgroundColor:yte,barPercentage:.8,categoryPercentage:.5,stack:"expenses"}]}}),[u,s,l.dailyPayment]),m=(n=fc(tc.Money),r=C(Jl),{layout:{padding:{top:24,right:36,bottom:0,left:12}},scales:{y:{stacked:!0,suggestedMax:1e3,beginAtZero:!0,grid:{color:pte,lineWidth:2},border:{color:pte,width:2},ticks:{maxTicksLimit:10,font:{size:10*r},color:mte,padding:10,autoSkip:!1,callback:function(e){return n(e)}}},x:{display:!1,stacked:!0}}});return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(bte,o),children:(0,e.jsxs)("div",{className:xte,children:[(0,e.jsxs)("div",{className:_te,children:[(0,e.jsx)(Zj,{type:"bar",data:h,options:m,className:jte}),(0,e.jsxs)("div",{className:Ste,children:[(0,e.jsx)(yv,{color:vte,label:(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_LEGEND_INCOME,{}),className:wte}),(0,e.jsx)(yv,{color:gte,label:(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_LEGEND_EXPENSES,{}),className:wte}),l.dailyPayment>0&&(0,e.jsx)(yv,{color:yte,label:(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_LEGEND_LOAN_INTEREST,{}),className:wte})]})]}),(0,e.jsxs)("div",{className:Ete,children:[c<=100&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Cte,{children:(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_RELATIVE_COST,{RELATIVE_LOAN_COST:(0,e.jsx)(dc,{value:c,unit:tc.PercentageSingleFraction})})}),(0,e.jsx)("div",{className:Ite})]}),(0,e.jsx)(Cte,{warning:f<=0,children:Pte(f,l.amount)}),.85*s<d&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:Ite}),(0,e.jsx)(Cte,{warning:!0,children:d>s?(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_BUDGET_WARNING,{}):(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_BUDGET_WARNING_MODIFIED,{})})]})]})]})})};function Pte(t,n){var r=(0,e.jsx)(dc,{value:t,unit:tc.MoneyPerMonth});return t>=0?n>0?(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_REMAINING_SURPLUS,{TOTAL:r}):(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_SURPLUS,{TOTAL:r}):(0,e.jsx)(Ks.EconomyPanel.LOAN_CHART_DEFICIT,{TOTAL:r})}var Cte=function(t){var n=t.warning,r=t.children;return(0,e.jsx)(fI,{className:Oe()(Ote,n&&Tte),children:r})};const Ate={"loan-page":"loan-page_cyR",loanPage:"loan-page_cyR","main-column":"main-column_NUx",mainColumn:"main-column_NUx","info-column":"info-column_c8_",infoColumn:"info-column_c8_",chart:"chart_Dc8"};var Lte=function(){var t;return uu(null===(t=TS.value)||void 0===t?void 0:t.economyPanelLoansPage),(0,i.useEffect)((function(){return tte(),function(){return tte()}}),[]),(0,e.jsxs)("div",{className:Ate.loanPage,children:[(0,e.jsxs)("div",{className:Ate.mainColumn,children:[(0,e.jsx)(hte,{className:Ate.adjustment}),(0,e.jsx)(Nte,{className:Ate.chart})]}),(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Ate.infoColumn,children:(0,e.jsx)(P7,{icon:"Media/Game/Icons/Money.svg",title:(0,e.jsx)(Ks.EconomyPanel.LOAN_PAGE_TITLE,{}),description:(0,e.jsx)(Ks.EconomyPanel.LOAN_PAGE_DESCRIPTION,{})})})]})},Mte=i.createContext({onFocusChange:function(){},onMouseEnter:function(){},onMouseLeave:function(){}});var Rte="production",kte=E(Rte,"maxProgress"),Dte=E(Rte,"resourceCategories"),Ute=T(Rte,"resourceDetails"),Fte=T(Rte,"resources"),Gte=T(Rte,"services"),Vte=T(Rte,"data");const Bte={detail:"detail_sbO",chart:"chart_Eey",column:"column_N8A","left-column":"left-column_GbN",leftColumn:"left-column_GbN","right-column":"right-column_hq1",rightColumn:"right-column_hq1","center-column":"center-column_M5Z",centerColumn:"center-column_M5Z",row:"row_PNm","double-row":"double-row_kpL",doubleRow:"double-row_kpL",label:"label_qcd","resource-label":"resource-label_b8b",resourceLabel:"resource-label_b8b","left-label":"left-label_aR5",leftLabel:"left-label_aR5","right-label":"right-label_q7r",rightLabel:"right-label_q7r","label-padding":"label-padding_TU1",labelPadding:"label-padding_TU1","label-extra-padding":"label-extra-padding_qhR",labelExtraPadding:"label-extra-padding_qhR",image:"image_k4T",icon:"icon_DSu","resource-icon":"resource-icon_GIT",resourceIcon:"resource-icon_GIT","icon-container":"icon-container_iMp",iconContainer:"icon-container_iMp","left-icon-container":"left-icon-container_V3g",leftIconContainer:"left-icon-container_V3g","icon-container-padding":"icon-container-padding_NGu",iconContainerPadding:"icon-container-padding_NGu","icon-container-extra-padding":"icon-container-extra-padding_DY7",iconContainerExtraPadding:"icon-container-extra-padding_DY7","right-icon-container":"right-icon-container_zrI",rightIconContainer:"right-icon-container_zrI","top-icon-container":"top-icon-container_vrp",topIconContainer:"top-icon-container_vrp","bottom-icon-container":"bottom-icon-container_Wzp",bottomIconContainer:"bottom-icon-container_Wzp"};var Hte=function(t){var n=t.entity,r=t.className;return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(Bte.resourceDetail,r),children:!c(n,ii)&&(0,e.jsx)(Kte,{entity:n})})},Kte=function(t){var n=t.entity,r=M(Fte,n),i=M(Ute,n),o=function(e,t){var n=t.inputs.flatMap((function(e){return e})),r=Math.max(n.length,1),i=t.outputs.length+t.serviceOutputs.length+e.consumers.length;e.tradable&&(r++,i++);return Math.max(r,i)}(r,i),a=(40*o+8*(o-1))*qd();return(0,e.jsx)("div",{className:Bte.detail,children:(0,e.jsxs)("div",{className:Bte.chart,style:{height:a},children:[(0,e.jsx)(Wte,{resource:r,details:i}),(0,e.jsx)(Xte,{resource:r,details:i}),(0,e.jsx)(qte,{resource:r,details:i})]})})},Wte=function(t){var n=t.resource,r=t.details;return(0,e.jsxs)("div",{className:Oe()(Bte.column,Bte.leftColumn),children:[0===(null==r?void 0:r.inputs.length)&&(0,e.jsx)(ene,{icon:n.producer.icon,arrow:"ProductionArrow",children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:n.producer.name})}),null==r?void 0:r.inputs.map((function(t,r){return(0,e.jsx)(zte,{resource:n,entities:t},r)})),n.tradable&&(0,e.jsx)(Yte,{})]})},zte=function(t){var n=t.resource,r=t.entities,o=function(e,t){var n=(0,i.useMemo)((function(){return t.map((function(t){return e.subscribe(t)}))}),[e,t]),r=x((0,i.useState)(_(n.map((function(e){return e.value})))),2),o=r[0],a=r[1],l=(0,i.useCallback)((function(){a(_(n.map((function(e){return e.value}))))}),[n]);return(0,i.useEffect)((function(){return a(_(n.map((function(e){return e.value})))),n.map((function(e){return e.setChangeListener(l)})),function(){n.map((function(e){return e.dispose()}))}}),[n,l]),o}(Fte,r);return(0,e.jsxs)("div",{className:Oe()(Bte.row,o.length>1&&Bte.doubleRow),style:{flex:o.length},children:[o.map((function(t,n){return(0,e.jsx)("div",{className:Bte.row,children:(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.leftIconContainer,o.length>1&&(0===n?Bte.topIconContainer:Bte.bottomIconContainer)),children:(0,e.jsx)("img",{src:t.icon,className:Bte.icon})})},l(t.entity))})),(0,e.jsx)("div",{className:Oe()(Bte.label,Bte.rightLabel,Bte.labelPadding,o.length>1&&Bte.labelExtraPadding),children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:n.producer.name})}),(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.leftIconContainer,Bte.iconContainerPadding,o.length>1&&Bte.iconContainerExtraPadding),children:(0,e.jsx)("img",{src:n.producer.icon,className:Bte.icon})}),(0,e.jsx)("img",{src:"Media/Game/Resources/Production/".concat(1===o.length?"Input":"DoubleInput","Arrow.png"),className:Bte.image})]})},Yte=function(){return(0,e.jsxs)("div",{className:Bte.row,children:[(0,e.jsx)("img",{src:"Media/Game/Resources/Production/ImportArrow.png",className:Bte.image}),(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.leftIconContainer),children:(0,e.jsx)("img",{src:"Media/Game/Icons/Import.svg",className:Bte.icon})}),(0,e.jsx)("div",{className:Oe()(Bte.label,Bte.leftLabel),children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_IMPORT,{})})]})},Xte=function(t){var n=t.resource;return(0,e.jsx)("div",{className:Oe()(Bte.column,Bte.centerColumn),children:(0,e.jsxs)("div",{className:Oe()(Bte.label,Bte.resourceLabel),children:[(0,e.jsx)("img",{src:n.icon,className:Oe()(Bte.icon,Bte.resourceIcon)}),(0,e.jsx)(Ks.Resources.TITLE,{hash:n.name})]})})},qte=function(t){var n=t.resource,r=t.details;return(0,e.jsxs)("div",{className:Oe()(Bte.column,Bte.rightColumn),children:[null==r?void 0:r.serviceOutputs.map((function(t){return(0,e.jsx)(Zte,{entity:t},l(t))})),(0,e.jsx)(Qte,{resource:n,details:r}),null==r?void 0:r.outputs.map((function(t,n){return(0,e.jsx)($te,{entity:t},n)})),n.tradable&&(0,e.jsx)(Jte,{})]})},$te=function(t){var n=t.entity,r=M(Fte,n);return(0,e.jsxs)("div",{className:Bte.row,children:[(0,e.jsx)("img",{src:"Media/Game/Resources/Production/OutputArrow.png",className:Bte.image}),(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.leftIconContainer),children:(0,e.jsx)("img",{src:r.producer.icon,className:Bte.icon})}),(0,e.jsx)("div",{className:Oe()(Bte.label,Bte.leftLabel),children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:r.producer.name})}),(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.rightIconContainer),children:(0,e.jsx)("img",{src:r.icon,className:Bte.icon})})]})},Qte=function(t){var n=t.resource;return(0,e.jsx)(e.Fragment,{children:n.consumers.map((function(t,n){return(0,e.jsx)(ene,{icon:t.icon,arrow:"ConsumptionArrow",children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:t.name})},n)}))})},Zte=function(t){var n=t.entity,r=M(Gte,n);return(0,e.jsx)(ene,{icon:r.icon,arrow:"ConsumptionArrow",children:(0,e.jsx)(Ks.Services.NAME,{hash:r.name})})},Jte=function(){return(0,e.jsxs)("div",{className:Bte.row,children:[(0,e.jsx)("img",{src:"Media/Game/Resources/Production/ExportArrow.png",className:Bte.image}),(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.leftIconContainer),children:(0,e.jsx)("img",{src:"Media/Game/Icons/Export.svg",className:Bte.icon})}),(0,e.jsx)("div",{className:Oe()(Bte.label,Bte.leftLabel),children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_EXPORT,{})})]})},ene=function(t){var n=t.icon,r=t.arrow,i=t.children;return(0,e.jsxs)("div",{className:Bte.row,children:[(0,e.jsx)("img",{src:"Media/Game/Resources/Production/".concat(r,".png"),className:Bte.image}),(0,e.jsx)("div",{className:Oe()(Bte.iconContainer,Bte.leftIconContainer),children:(0,e.jsx)("img",{src:n,className:Bte.icon})}),(0,e.jsx)("div",{className:Oe()(Bte.label,Bte.rightLabel),children:i})]})};const tne={"progress-bar":"progress-bar_xWR",progressBar:"progress-bar_xWR","progress-bounds":"progress-bounds_Fjq",progressBounds:"progress-bounds_Fjq",progress:"progress_JAQ",label:"label_nBK"},nne={"progress-bar":"progress-bar_d6t progress-bar_xWR",progressBar:"progress-bar_d6t progress-bar_xWR",progress:"progress_egi progress_JAQ"};function rne(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ine(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){rne(e,t,n[t])}))}return e}function one(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function ane(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var lne=function(t){var n=t.progress,r=t.max,o=t.theme,a=void 0===o?nne:o,l=t.className,s=t.style,c=t.children,u=ane(t,["progress","max","theme","className","style","children"]),d=(0,i.useMemo)((function(){return ine({},tne,a)}),[a]),f=r>0?100*at(n/r,0,1):0;return(0,e.jsxs)("div",one(ine({},u),{className:Oe()(d.progressBar,l),style:s,children:[d.progressLabel&&null!=c&&(0,e.jsx)("div",{className:d.label,children:c}),(0,e.jsx)("div",{className:d.progressBounds,style:{width:f+"%"},children:(0,e.jsx)("div",{className:d.progress,style:{width:(f>0?100/f*100:0)+"%"},children:d.progressLabel&&null!=c&&(0,e.jsx)("div",{className:d.progressLabel,children:c})})}),!d.progressLabel&&null!=c&&(0,e.jsx)("div",{className:d.label,children:c})]}))};const sne={base:"base_BM7",enter:"enter_lhm","exit-active":"exit-active_gO8",exitActive:"exit-active_gO8","enter-active":"enter-active_kU5",enterActive:"enter-active_kU5",exit:"exit_MDH"};function cne(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function une(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return cne(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return cne(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var dne=function(t){var n=t.focusKey,r=t.initialExpanded,o=void 0!==r&&r,a=t.header,l=t.theme,s=void 0===l?IO:l,c=t.transition,u=void 0===c?sne:c,d=t.className,f=t.children,h=t.onToggleExpanded,m=TO(s),p=i.Children.count(f)>0,v=une((0,i.useState)(o),2),g=v[0],y=v[1],b=(0,i.useCallback)((function(){y((function(e){return!e})),Jt(Qt.expandPanel),h&&h(!g)}),[g,h]),x=(0,i.useMemo)((function(){return{theme:m,expandable:p,expanded:g,toggleExpanded:p?b:void 0}}),[p,g,m,b]);return(0,e.jsx)(Or,{className:Oe()(m.section,p&&m.expandable,p&&m.expanded,d),children:(0,e.jsx)(EO.Provider,{value:x,children:(0,e.jsx)(Sn,{expanded:g,expandable:p,onAction:b,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(Tr,{focusKey:p?n:Te,className:Oe()(m.header,p&&m.expandable,m.first,(!p||!g)&&m.last),children:a}),p&&(0,e.jsx)(D0,{in:g,children:(0,e.jsx)(lJ,{styles:u,children:(0,e.jsx)("div",{children:(0,e.jsx)(Or,{className:Oe()(m.content,m.last,m.expandable),children:f})})})})]})})})})},fne=function(t){var n=t.tooltip,r=t.className,o=t.children,a=(0,i.useContext)(EO),l=a.expanded,s=a.toggleExpanded,c=a.theme,u=null!=s;return(0,e.jsx)(xO,{tooltip:n,children:(0,e.jsxs)(Tr,{focusKey:u?Ie:Te,className:Oe()(c.titleBar,u&&c.expandable,r),onClick:s,children:[u&&(0,e.jsx)("div",{className:c.buttonSpace}),(0,e.jsx)("div",{className:c.title,children:o}),u&&(0,e.jsx)(ll,{src:l?c.collapseIcon:c.expandIcon,className:c.toggleButton})]})})};const hne="resource-list_Ra6",mne="category_nho",pne="categoryHeader_YGs",vne="table-header_Qbg",gne="header-cell_k7Z",yne="scrollable_Tuh",bne="table-lines_PGv",xne="name_IJ7",_ne="production_iuR",jne="surplus-deficit_oEQ",Ene="deficit-label_CkA",One="surplus-label_U6j",Tne="resource-item_oLG item-hover_WK8 item-focused_FuT",Ine="icon-container_Bnw",Sne="icon_J9H icon_Iwk",wne="name-column_Jt4",Nne="data-column_k1t",Pne="production-bar_PrU",Cne={"progress-bar":"progress-bar_oCn progress-bar_RG2 progress-bar_xWR",progressBar:"progress-bar_oCn progress-bar_RG2 progress-bar_xWR",progress:"progress_gQv progress_GLS progress_JAQ"},Ane={"progress-bar":"progress-bar_P_j progress-bar_RG2 progress-bar_xWR",progressBar:"progress-bar_P_j progress-bar_RG2 progress-bar_xWR",progress:"progress_zGB progress_GLS progress_JAQ"},Lne={"progress-bar":"progress-bar_RG2 progress-bar_xWR",progressBar:"progress-bar_RG2 progress-bar_xWR",progress:"progress_GLS progress_JAQ"};var Mne=function(t){var n,r=t.className,i=C(Dte),o=C(kte);return(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelProductionResources,children:(0,e.jsx)(mf,{className:Oe()(hne,yne,r),children:(0,e.jsx)(Fn,{direction:On.Vertical,children:i.map((function(t,n){return(0,e.jsx)(Rne,{max:o,category:t,initialExpanded:0===n},l(t.entity))}))})})})},Rne=function(t){var n=t.category,r=t.max,i=t.initialExpanded;return(0,e.jsxs)(dne,{focusKey:l(n.entity),initialExpanded:i,header:(0,e.jsx)(fne,{className:pne,children:(0,e.jsx)(Ks.EconomyPanel.RESOURCE_CATEGORY,{hash:n.name})}),theme:IO,className:mne,children:[(0,e.jsxs)("div",{className:vne,children:[(0,e.jsx)("div",{className:Oe()(gne,xne)}),(0,e.jsx)("div",{className:Oe()(gne,_ne),children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_PRODUCTION,{})}),(0,e.jsx)("div",{className:Oe()(gne,jne),children:(0,e.jsx)("span",{className:One,children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_SURPLUS,{})})}),(0,e.jsx)("div",{className:Oe()(gne,jne),children:(0,e.jsx)("span",{className:Ene,children:(0,e.jsx)(Ks.EconomyPanel.PRODUCTION_PAGE_DEFICIT,{})})})]}),(0,e.jsx)(Fn,{direction:On.Vertical,children:n.resources.map((function(t){return(0,e.jsx)(kne,{resource:t,max:r},l(t.entity))}))}),(0,e.jsxs)("div",{className:bne,children:[(0,e.jsx)("div",{className:xne}),(0,e.jsx)("div",{className:_ne}),(0,e.jsx)("div",{className:jne}),(0,e.jsx)("div",{className:jne})]})]})},kne=function(t){var n,r,o=t.resource,a=t.max,s=(n=o.entity,r=(0,i.useContext)(Mte),{handleFocusChange:(0,i.useCallback)((function(e){return r.onFocusChange(n,e)}),[n,r]),handleMouseEnter:(0,i.useCallback)((function(){return r.onMouseEnter(n)}),[n,r]),handleMouseLeave:(0,i.useCallback)((function(){return r.onMouseLeave(n)}),[n,r])}),c=s.handleFocusChange,u=s.handleMouseEnter,d=s.handleMouseLeave,f=M(Vte,o.entity);return(0,e.jsx)(Jh,{onFocusChange:c,children:(0,e.jsxs)(Tr,{focusKey:l(o.entity),className:Tne,onMouseEnter:u,onMouseLeave:d,children:[(0,e.jsx)("div",{className:Oe()(wne),children:(0,e.jsx)("div",{className:Ine,children:(0,e.jsx)("img",{src:o.icon,className:Sne})})}),(0,e.jsx)("div",{className:Oe()(Nne),children:(0,e.jsx)(lne,{progress:f.production,max:a,theme:Lne,className:Pne,children:(0,e.jsx)(dc,{value:f.production,unit:tc.WeightPerMonth})})}),(0,e.jsx)("div",{className:Oe()(Nne),children:(0,e.jsx)(lne,{progress:f.surplus,max:a,theme:Ane,className:Pne,children:(0,e.jsx)(dc,{value:f.surplus,unit:tc.WeightPerMonth})})}),(0,e.jsx)("div",{className:Oe()(Nne),children:(0,e.jsx)(lne,{progress:f.deficit,max:a,theme:Cne,className:Pne,children:(0,e.jsx)(dc,{value:f.deficit,unit:tc.WeightPerMonth})})})]})})};const Dne="production-page_A9T",Une="main-column_FBD",Fne="info-column_jLZ";function Gne(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Vne(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Gne(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Gne(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Bne,Hne=function(){var t;uu(null===(t=TS.value)||void 0===t?void 0:t.economyPanelProductionPage);var n=Vne((0,i.useState)(ii),2),r=n[0],o=n[1],a=(0,i.useMemo)((function(){return{onFocusChange:function(e,t){return t&&o(e)},onMouseEnter:function(e){return o(e)},onMouseLeave:function(e){return o((function(t){return c(t,e)?ii:t}))}}}),[]);return(0,e.jsxs)("div",{className:Dne,children:[(0,e.jsx)(Mte.Provider,{value:a,children:(0,e.jsx)(Mne,{className:Une})}),(0,e.jsx)(Hte,{entity:r,className:Fne})]})},Kne="serviceBudget",Wne=E(Kne,"services"),zne=T(Kne,"serviceDetails");!function(e){e[e.Service=0]="Service",e[e.BudgetSlider=1]="BudgetSlider",e[e.ServiceFee=2]="ServiceFee",e[e.FeeRevenue=3]="FeeRevenue",e[e.ExportRevenue=4]="ExportRevenue",e[e.ServiceUpkeep=5]="ServiceUpkeep",e[e.ImportExpense=6]="ImportExpense"}(Bne||(Bne={}));var Yne={type:Bne.BudgetSlider},Xne={type:Bne.FeeRevenue},qne={type:Bne.ExportRevenue},$ne={type:Bne.ServiceUpkeep},Qne={type:Bne.ImportExpense},Zne=i.createContext({onFocusChange:function(){},onMouseEnter:function(){},onMouseLeave:function(){}});function Jne(e){var t=(0,i.useContext)(Zne);return{handleFocusChange:(0,i.useCallback)((function(n){return t.onFocusChange(e,n)}),[e,t]),handleMouseEnter:(0,i.useCallback)((function(){return t.onMouseEnter(e)}),[e,t]),handleMouseLeave:(0,i.useCallback)((function(){return t.onMouseLeave(e)}),[e,t])}}const ere="service-item-detail_iHg",tre="detail-layout_yS8";var nre=function(t){var n=t.service,r=t.itemId,i=t.className,o=M(zne,n);return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(ere,i),children:rre(r,o)})};function rre(t,n){switch(null==t?void 0:t.type){case Bne.Service:return(0,e.jsx)(ire,{entity:t.entity});case Bne.BudgetSlider:return null!=n?(0,e.jsx)(ore,{serviceDetails:n}):null;case Bne.ServiceFee:if(null!=n){var r=n.fees.find((function(e){return e.name===t.name}));if(null!=r)return(0,e.jsx)(are,{fee:r,serviceDetails:n})}return null;case Bne.FeeRevenue:return(0,e.jsx)(lre,{});case Bne.ExportRevenue:return(0,e.jsx)(sre,{});case Bne.ServiceUpkeep:return(0,e.jsx)(cre,{});case Bne.ImportExpense:return(0,e.jsx)(ure,{});default:return null}}var ire=function(t){var n=t.entity,r=M(OS,n);return r?(0,e.jsx)(P7,{icon:r.icon,title:(0,e.jsx)(Ss,{id:r.titleId}),description:r.descriptionId?(0,e.jsx)(Ss,{id:r.descriptionId}):void 0}):null},ore=function(t){var n=t.serviceDetails,r=n.efficiency-100;return(0,e.jsx)(P7,{icon:n.icon,title:(0,e.jsx)(Ks.EconomyPanel.SERVICE_BUDGET_SLIDER_TITLE,{hash:n.name}),description:(0,e.jsx)(Ks.EconomyPanel.SERVICE_BUDGET_SLIDER_DESCRIPTION,{hash:n.name}),className:tre,bottom:(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.EconomyPanel.SERVICE_BUDGET_EFFICIENCY,{}),theme:_ee,className:Ef(_ee,r),children:(0,e.jsx)(dc,{signed:!0,value:r,unit:tc.Percentage})})},"budget")},are=function(t){var n=t.serviceDetails,r=t.fee,i=100*(r.consumptionMultiplier-1),o=100*(r.efficiencyMultiplier-1);return r?(0,e.jsx)(P7,{icon:n.icon,title:(0,e.jsx)(Ks.EconomyPanel.SERVICES_RESOURCE_FEE_LABEL,{hash:r.name}),description:(0,e.jsx)(Ks.EconomyPanel.SERVICES_RESOURCE_FEE_DESCRIPTION,{hash:r.name}),bottom:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_RESOURCE_FEE_CONSUMPTION,{hash:r.name}),theme:_ee,className:Ef(_ee,-i),children:(0,e.jsx)(dc,{signed:!0,value:i,unit:tc.Percentage})}),(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_RESOURCE_FEE_EFFICIENCY,{}),theme:_ee,className:Ef(_ee,o),children:(0,e.jsx)(dc,{signed:!0,value:o,unit:tc.Percentage})}),(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_RESOURCE_FEE_HAPPINESS,{}),theme:_ee,className:Ef(_ee,r.happinessEffect),children:(0,e.jsx)(dc,{signed:!0,value:r.happinessEffect,unit:tc.Integer})})]}),className:tre}):null},lre=function(){return(0,e.jsx)(P7,{icon:"Media/Game/Icons/ServiceFees.svg",title:(0,e.jsx)(Ks.EconomyPanel.SERVICES_FEES_LABEL_FEES,{}),description:(0,e.jsx)(Ks.EconomyPanel.SERVICE_FEES_REVENUE_DESCRIPTION,{}),className:tre})},sre=function(){return(0,e.jsx)(P7,{icon:"Media/Game/Icons/Export.svg",title:(0,e.jsx)(Ks.EconomyPanel.SERVICES_FEES_LABEL_EXPORT,{}),description:(0,e.jsx)(Ks.EconomyPanel.SERVICE_EXPORT_REVENUE_DESCRIPTION,{}),className:tre})},cre=function(){return(0,e.jsx)(P7,{icon:"Media/Game/Icons/ServiceUpkeep.svg",title:(0,e.jsx)(Ks.EconomyPanel.SERVICES_TITLE_EXPENSES,{}),description:(0,e.jsx)(Ks.EconomyPanel.SERVICE_UPKEEP_EXPENSE_DESCRIPTION,{}),className:tre})},ure=function(){return(0,e.jsx)(P7,{icon:"Media/Game/Icons/Import.svg",title:(0,e.jsx)(Ks.EconomyPanel.SERVICES_FEES_LABEL_IMPORT,{}),description:(0,e.jsx)(Ks.EconomyPanel.SERVICE_IMPORT_EXPENSE_DESCRIPTION,{}),className:tre})};const dre="budget-item_b_g item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",fre="label_vC7",hre="field_s_O";var mre=function(t){var n=t.identifier,r=t.label,i=t.value,o=Jne(n),a=o.handleFocusChange,l=o.handleMouseEnter,s=o.handleMouseLeave;return(0,e.jsx)(Jh,{onFocusChange:a,children:(0,e.jsxs)(Tr,{className:dre,onMouseEnter:l,onMouseLeave:s,children:[(0,e.jsx)("div",{className:fre,children:r}),(0,e.jsx)(dee,{value:i,className:hre})]})})};const pre={slider:"slider_Pjj slider_pUS",thumb:"thumb_skm"},vre="slider-item_pCt item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",gre="label_IRx",yre="value_jjh",bre="slider_TyY";var xre=function(t){var n=t.identifier,r=t.label,i=t.value,o=t.min,a=t.max,l=t.gradient,s=t.locked,c=t.onValueChange,u=Jne(n),d=u.handleFocusChange,f=u.handleMouseEnter,h=u.handleMouseLeave,m=Bm(2);return(0,e.jsx)(Jh,{onFocusChange:d,children:(0,e.jsxs)(Tr,{className:vre,onMouseEnter:f,onMouseLeave:h,children:[(0,e.jsx)("div",{className:gre,children:r}),(0,e.jsx)("div",{className:yre,children:(0,e.jsx)(dc,{value:i,unit:tc.Percentage})}),(0,e.jsx)(eA,{children:(0,e.jsx)(WD,{value:i,start:o,end:a,gamepadStep:2,valueTransformer:m,gradient:l,theme:pre,className:bre,disabled:s,onChange:c})})]})})},_re={stops:[{offset:0,color:"var(--negativeColor)"},{offset:.5,color:"#bfac6f"},{offset:1,color:"var(--positiveColor)"}]},jre=function(t){var n,r=t.service,o=t.value,a=t.locked,l=(0,i.useCallback)((function(e){return function(e,t){N(Kne,"setServiceBudget",e,t)}(r,e)}),[r]);return(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelServicesBudget,children:(0,e.jsx)(xre,{identifier:Yne,label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_TITLE_BUDGET,{}),value:o,min:50,max:150,gradient:_re,locked:a,onValueChange:l})})},Ere={stops:[{offset:0,color:"var(--positiveColor)"},{offset:.5,color:"#bfac6f"},{offset:1,color:"var(--negativeColor)"}]},Ore=function(t){var n=t.item,r=t.locked,o=(0,i.useCallback)((function(e){!function(e,t){N(Kne,"setServiceFee",e,t)}(n.resource,lt(n.min,n.max,e/200))}),[n.max,n.min,n.resource]),a=(0,i.useMemo)((function(){return{type:Bne.ServiceFee,name:n.name}}),[n.name]),l=200*(n.fee-n.min)/(n.max-n.min);return(0,e.jsx)(xre,{identifier:a,label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_RESOURCE_FEE_LABEL,{hash:n.name}),value:l,min:0,max:200,gradient:Ere,locked:r,onValueChange:o})};const Tre={header:"header_hMN",title:"title_mu8","reset-button":"reset-button_UEO button_eqb item-states_QjV",resetButton:"reset-button_UEO button_eqb item-states_QjV",scrollable:"scrollable_S7e",content:"content_SjM",adjustment:"adjustment_mUK",space:"space_nob",budget:"budget_EG1","budget-title":"budget-title_Qqo",budgetTitle:"budget-title_Qqo"};var Ire=function(t){var n=t.service,r=t.className,o=(0,i.useCallback)((function(){return function(e){N(Kne,"resetService",e)}(n)}),[n]),a=M(zne,n),l=null!=a&&(a.budgetAdjustable||a.fees.some((function(e){return e.adjustable})));return(0,e.jsx)(CO,{theme:IO,className:Oe()(Tre.serviceDetail,(null==a?void 0:a.locked)&&IO.locked,r),header:a&&(0,e.jsxs)("div",{className:Tre.header,children:[(0,e.jsx)("div",{className:Tre.title,children:(0,e.jsx)(Ks.Services.NAME,{hash:a.name})}),l?(0,e.jsx)(ml,{className:Tre.resetButton,disabled:!1,onSelect:o,children:"Reset"}):null]}),children:(0,e.jsx)(mf,{className:Tre.scrollable,children:(0,e.jsx)(Fn,{direction:On.Vertical,children:a&&(0,e.jsxs)("div",{className:Tre.content,children:[l?(0,e.jsx)(e.Fragment,{children:(0,e.jsxs)("div",{className:Tre.adjustment,children:[a.budgetAdjustable&&(0,e.jsx)(jre,{service:a.entity,value:a.budgetPercentage,locked:a.locked}),a.fees.filter((function(e){return e.adjustable})).map((function(t){return(0,e.jsx)(Ore,{item:t,locked:a.locked},t.resource)}))]})}):null,(0,e.jsx)("div",{className:Tre.space}),a.fees.length>0&&(0,e.jsxs)("div",{className:Tre.budget,children:[(0,e.jsx)("div",{className:Tre.budgetTitle,children:(0,e.jsx)(Ks.EconomyPanel.SERVICES_TITLE_INCOME,{})}),(0,e.jsx)(Sre,{fees:a.fees})]}),(0,e.jsxs)("div",{className:Tre.budget,children:[(0,e.jsx)("div",{className:Tre.budgetTitle,children:(0,e.jsx)(Ks.EconomyPanel.SERVICES_TITLE_EXPENSES,{})}),(0,e.jsx)(mre,{identifier:$ne,label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_LABEL_UPKEEP,{}),value:a.upkeep}),(0,e.jsx)(wre,{fees:a.fees})]})]})})})})},Sre=function(t){var n=t.fees;if(n.length>0){var r=n.reduce((function(e,t){return e+t.incomeInternal}),0),i=n.reduce((function(e,t){return e+t.incomeExports}),0);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(mre,{identifier:Xne,label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_FEES_LABEL_FEES,{}),value:r}),n.some((function(e){return e.exportable||0!==e.incomeExports}))&&(0,e.jsx)(mre,{identifier:qne,label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_FEES_LABEL_EXPORT,{}),value:i})]})}return null},wre=function(t){var n=t.fees;if(n.some((function(e){return e.importable||0!==e.expenseImports}))){var r=n.reduce((function(e,t){return e+t.expenseImports}),0);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(mre,{identifier:Qne,label:(0,e.jsx)(Ks.EconomyPanel.SERVICES_FEES_LABEL_IMPORT,{}),value:r})})}return null};const Nre="service-list_xm3",Pre="list-section_BJP",Cre="scrollable_rmv",Are="item_JFN button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",Lre="locked_ZXT locked_H2O locked_dBl",Mre="icon_HoD icon_soN icon_Iwk",Rre="title_sB9",kre="field_Edk",Dre="total-section_VPy",Ure="total-content_gSd",Fre="total-label_mVx",Gre="total-column_k3X",Vre="total-field_rfq";var Bre=function(t){var n,r=t.selectedService,i=t.className,o=t.onSelectService,a=C(Wne),s=HN(o),u=a.reduce((function(e,t){return e+t.budget}),0);return(0,e.jsxs)("div",{className:Oe()(Nre,i),children:[(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelServicesList,children:(0,e.jsx)(CO,{theme:IO,className:Pre,children:(0,e.jsx)(mf,{className:Cre,children:(0,e.jsx)(Mn,{focused:l(r),direction:On.Vertical,onChange:s,children:a.map((function(t){return(0,e.jsx)(Hre,{item:t,selected:c(t.entity,r),onSelect:o},l(t.entity))}))})})})}),(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Dre,children:(0,e.jsxs)("div",{className:Ure,children:[(0,e.jsx)("div",{className:Fre,children:(0,e.jsx)(Ks.EconomyPanel.MONTHLY_BALANCE,{})}),(0,e.jsx)("div",{className:Gre,children:(0,e.jsx)(dee,{value:u,importance:"primary",className:Vre})})]})})]})},Hre=function(t){var n=t.item,r=t.selected,o=t.onSelect,a=(0,i.useCallback)((function(){return o(n.entity)}),[n.entity,o]),s=Jne((0,i.useMemo)((function(){return{type:Bne.Service,entity:n.entity}}),[n.entity])),c=s.handleFocusChange,u=s.handleMouseEnter,d=s.handleMouseLeave;return(0,e.jsx)(Jh,{onFocusChange:c,children:(0,e.jsxs)(ml,{focusKey:l(n.entity),selected:r,className:Oe()(Are,n.locked&&Lre),onSelect:a,onMouseEnter:u,onMouseLeave:d,children:[(0,e.jsx)("img",{src:n.icon,className:Mre}),(0,e.jsx)("div",{className:Rre,children:(0,e.jsx)(Ks.Services.NAME,{hash:n.name})}),(0,e.jsx)(dee,{value:n.budget,importance:"secondary",className:kre})]})})};const Kre="service-page_a6r",Wre="list-column_PCc",zre="main-column_WYi",Yre="info-column_oLC";function Xre(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function qre(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Xre(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Xre(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var $re=function(){var t;uu(null===(t=TS.value)||void 0===t?void 0:t.economyPanelServicesPage);var n=qre((0,i.useState)(Qre),2),r=n[0],o=n[1],a=cr(),l=qre((0,i.useState)(null),2),s=l[0],c=l[1],u=qre((0,i.useState)(null),2),d=u[0],h=u[1],m=(0,i.useMemo)((function(){return{onFocusChange:function(e,t){c(t?e:function(t){return f(e,t,2)?null:t})},onMouseEnter:function(e){return h(e)},onMouseLeave:function(e){return h((function(t){return f(e,t,2)?null:t}))}}}),[]),p=a?s:d;return(0,e.jsx)("div",{className:Kre,children:(0,e.jsx)(Zne.Provider,{value:m,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(Bre,{selectedService:r,className:Wre,onSelectService:o}),(0,e.jsx)(Ire,{service:r,className:zre}),(0,e.jsx)(nre,{service:r,itemId:p,className:Yre})]})})})};function Qre(){var e,t;return null!==(t=null===(e=function(e){return null==e||0===e.length?null:e[0]}(Wne.value))||void 0===e?void 0:e.entity)&&void 0!==t?t:ii}var Zre="taxation",Jre=(E(Zre,"taxRate"),E(Zre,"taxEffect"),E(Zre,"taxIncome")),eie=(E(Zre,"minTaxRate"),E(Zre,"maxTaxRate"),E(Zre,"areaTypes")),tie=T(Zre,"areaTaxRates"),nie=T(Zre,"areaTaxIncomes"),rie=T(Zre,"areaTaxEffects"),iie=T(Zre,"areaResourceTaxRanges"),oie=T(Zre,"areaResources"),aie=T(Zre,"resourceTaxRates"),lie=T(Zre,"resourceTaxIncomes"),sie=T(Zre,"taxResourceInfos");const cie={colorMinus10:"#1e83aa",colorMinus0:"#4bc3f1",colorPlus0:"#8bdb46",colorPlus30:"#e95f4a","tax-slider":"tax-slider_HNg",taxSlider:"tax-slider_HNg",rate:"rate_lAq",range:"range_EHE","slider-column":"slider-column_XmW",sliderColumn:"slider-column_XmW",slider:"slider_lZg","estimate-column":"estimate-column_DQB",estimateColumn:"estimate-column_DQB","estimate-value":"estimate-value_grH",estimateValue:"estimate-value_grH","estimate-value-disabled":"estimate-value-disabled__q3",estimateValueDisabled:"estimate-value-disabled__q3"};var uie=function(t){var n=t.min,r=t.max,o=t.rate,a=t.income,l=t.range,s=t.primary,c=t.className,u=t.onValueChanged,d=t.disabled,f=(0,i.useMemo)((function(){return function(e,t){var n,r,i,o,a=null!==(n=gm(cie.colorMinus10))&&void 0!==n?n:fm,l=null!==(r=gm(cie.colorMinus0))&&void 0!==r?r:fm,s=null!==(i=gm(cie.colorPlus0))&&void 0!==i?i:fm,c=null!==(o=gm(cie.colorPlus30))&&void 0!==o?o:fm;if(e<0&&t<=0)return{stops:[{offset:0,color:pm(xm(l,a,at(e/-10,0,1)))},{offset:1,color:pm(xm(l,a,at(t/-10,0,1)))}]};if(e<0&&t>0){var u=e/(e-t);return{stops:[{offset:0,color:pm(xm(l,a,at(e/-10,0,1)))},{offset:u,color:pm(l)},{offset:u,color:pm(s)},{offset:1,color:pm(xm(s,c,at(t/30,0,1)))}]}}return{stops:[{offset:0,color:pm(xm(s,c,at(e/30,0,1)))},{offset:1,color:pm(xm(s,c,at(t/30,0,1)))}]}}(n,r)}),[n,r]);return(0,e.jsxs)("div",{className:Oe()(cie.taxSlider,s&&cie.primary,c),children:[(0,e.jsxs)("div",{className:cie.sliderColumn,onClick:Cm,children:[(0,e.jsx)("div",{className:Oe()(cie.rate,null!=l&&l.max-l.min>.1&&cie.range),children:die(o,l)}),(0,e.jsx)(WD,{value:o,start:n,end:r,gamepadStep:1,valueTransformer:Vm,theme:pre,className:cie.slider,gradient:f,onChange:u,disabled:d})]}),(0,e.jsx)("div",{className:cie.estimateColumn,children:(0,e.jsx)(dee,{value:a,importance:s?"secondary":void 0,className:Oe()(cie.estimateValue,d&&cie.estimateValueDisabled)})})]})};function die(t,n){return null==n?(0,e.jsx)(dc,{value:t,unit:tc.PercentageSingleFraction}):n.max-n.min>.1?(0,e.jsx)(eh,{min:n.min,max:n.max,unit:tc.PercentageSingleFraction}):(0,e.jsx)(dc,{value:n.min,unit:tc.PercentageSingleFraction})}const fie="taxation-item_p0I item-hover_WK8 item-focused_FuT",hie="icon_Eeh",mie="title_EA9",pie="slider_rbN";var vie=function(t){var n=t.areaType,r=t.resource,o=M(aie,r),a=M(lie,r),l=M(sie,r),s=(0,i.useCallback)((function(e){return function(e,t,n){N(Zre,"setResourceTaxRate",e,t,n)}(r.resource,r.area,e)}),[r]);return(0,e.jsxs)(Tr,{className:fie,children:[(0,e.jsx)("img",{className:hie,src:l.icon}),(0,e.jsx)("div",{className:mie,children:1!==n.index?(0,e.jsx)(Ks.Resources.TITLE,{hash:l.id}):(0,e.jsx)(Ks.EconomyPanel.TAXATION_RESIDENTIAL_SLIDER_JOBLEVEL,{index:r.resource})}),(0,e.jsx)(uie,{effect:0,rate:o,min:n.resourceTaxRateMin,max:n.resourceTaxRateMax,income:a,className:pie,onValueChanged:s})]})};const gie={"taxation-group":"taxation-group_aQb",taxationGroup:"taxation-group_aQb",header:"header_cPd item-hover_WK8 item-focused_FuT",icon:"icon_vPX","icon-disabled":"icon-disabled_lo2",iconDisabled:"icon-disabled_lo2",title:"title_WQ0","toggle-button":"toggle-button_hTU",toggleButton:"toggle-button_hTU","header-slider":"header-slider_wLI",headerSlider:"header-slider_wLI",content:"content_NUa",enter:"enter_C0R","exit-active":"exit-active_CJ6",exitActive:"exit-active_CJ6","enter-active":"enter-active_kty",enterActive:"enter-active_kty",exit:"exit_xDo",item:"item_YKG"};function yie(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bie(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yie(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yie(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xie=function(t){var n=t.focusKey,r=t.areaType,o=t.onMouseEnter,a=t.onMouseLeave,l=bie((0,i.useState)(!1),2),s=l[0],c=l[1],u=(0,i.useCallback)((function(){c((function(e){return!e})),Jt(Qt.expandPanel)}),[]),d=M(tie,r.index),f=M(iie,r.index),h=M(nie,r.index),m=M(rie,r.index),p=(0,i.useCallback)((function(e){return function(e,t){N(Zre,"setAreaTaxRate",e,t)}(r.index,e)}),[r]),v=M(oie,r.index),g=v.length>0&&!r.locked,y=(0,i.useCallback)((function(){return o(r.id)}),[o,r.id]),b=(0,i.useCallback)((function(){return a(r.id)}),[a,r.id]);return(0,e.jsx)(Sn,{expanded:s,expandable:g,onAction:u,children:(0,e.jsx)(Tr,{focusKey:n,className:gie.taxationGroup,onMouseEnter:y,onMouseLeave:b,children:(0,e.jsxs)(Fn,{children:[(0,e.jsxs)(Tr,{className:gie.header,children:[(0,e.jsx)("img",{className:Oe()(gie.icon,r.locked&&gie.iconDisabled),src:r.icon}),(0,e.jsx)("div",{className:gie.title,children:(0,e.jsx)(Ks.EconomyPanel.TAX_AREA_TITLE,{hash:r.id})}),g&&(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:s?"Media/Glyphs/ThickStrokeArrowUp.svg":"Media/Glyphs/ThickStrokeArrowDown.svg",theme:_l,className:gie.toggleButton,onSelect:u}),(0,e.jsx)(uie,{primary:!0,effect:m,rate:d,min:r.taxRateMin,max:r.taxRateMax,income:h,range:f,className:gie.headerSlider,onValueChanged:p,disabled:r.locked})]}),g&&(0,e.jsx)(D0,{in:s,children:(0,e.jsx)(lJ,{styles:gie,children:(0,e.jsx)("div",{className:gie.content,children:v.map((function(t){return(0,e.jsx)(vie,{areaType:r,resource:t},t.resource)}))})})})]})})})};const _ie="taxation-page_hmd",jie="main-column_JuD",Eie="info-column_e7N",Oie="table-section_D_X",Tie="table-header_qcq",Iie="header-cell_ori",Sie="scrollable_Xqt",wie="table-lines_Abv",Nie="name_DfR",Pie="rate_U86",Cie="estimate_d79",Aie="total-section_IIZ",Lie="total-content_a5i",Mie="total-label_hxK",Rie="total-column_rXB",kie="total-value_hzh";function Die(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Uie(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Die(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Die(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Fie=function(){var t,n,r,o,a=C(eie),l=C(Jre),s=Uie((0,i.useState)(rp(a,"id")),2),c=s[0],u=s[1],d=Uie((0,i.useState)(null),2),f=d[0],h=d[1],m=(0,i.useCallback)((function(e){return h(e)}),[]),p=(0,i.useCallback)((function(e){return h((function(t){return t===e?null:t}))}),[]),v=(0,i.useCallback)((function(e){"string"==typeof e&&u(e)}),[]),g=cr()?c:f,y=a.find((function(e){return e.id===g}));return su(null===(t=TS.value)||void 0===t?void 0:t.economyPanelTaxationPage),(0,e.jsxs)("div",{className:_ie,children:[(0,e.jsxs)("div",{className:jie,children:[(0,e.jsxs)(CO,{header:(0,e.jsxs)("div",{className:Tie,children:[(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelTaxationType,children:(0,e.jsx)("div",{className:Oe()(Iie,Nie),children:(0,e.jsx)(Ks.EconomyPanel.TAX_AREA_COLUMN_TITLE,{})})}),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.economyPanelTaxationRate,children:(0,e.jsx)("div",{className:Oe()(Iie,Pie),children:(0,e.jsx)(Ks.EconomyPanel.TAX_RATE_TITLE,{})})}),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.economyPanelTaxationEstimate,children:(0,e.jsx)("div",{className:Oe()(Iie,Cie),children:(0,e.jsx)(Ks.EconomyPanel.TAX_INCOME_ESTIMATE_TITLE,{})})})]}),theme:IO,className:Oie,children:[(0,e.jsx)(mf,{className:Sie,children:(0,e.jsx)(Mn,{focused:c,onChange:v,onRefocus:Rn,children:a.map((function(t){return(0,e.jsx)(xie,{focusKey:t.id,areaType:t,onMouseEnter:m,onMouseLeave:p},t.id)}))})}),(0,e.jsxs)("div",{className:wie,children:[(0,e.jsx)("div",{className:Nie}),(0,e.jsx)("div",{className:Pie}),(0,e.jsx)("div",{className:Cie})]})]}),(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Aie,children:(0,e.jsxs)("div",{className:Lie,children:[(0,e.jsx)("div",{className:Mie,children:(0,e.jsx)(Ks.EconomyPanel.TAX_INCOME_TOTAL_TITLE,{})}),(0,e.jsx)("div",{className:Rie,children:(0,e.jsx)(dee,{value:l,importance:"primary",className:kie})})]})})]}),(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Eie,children:y&&(0,e.jsx)(P7,{icon:y.icon,title:(0,e.jsx)(Ks.EconomyPanel.TAX_AREA_TITLE,{hash:y.id}),description:(0,e.jsx)(Ks.EconomyPanel.TAX_AREA_DESCRIPTION,{hash:y.id})})})]})};const Gie="economy-panel_e08";var Vie=function(t){var n=t.selectedTab,r=t.onSelectTab,o=t.onClose,a=C(j3),l=(0,i.useMemo)((function(){var e,t,n,r,i;return[{tab:Ba.Budget,feature:"City Budget",uiTag:null===(e=TS.value)||void 0===e?void 0:e.economyPanelBudgetTab},{tab:Ba.Loan,feature:"Loan",uiTag:null===(t=TS.value)||void 0===t?void 0:t.economyPanelLoansTab},{tab:Ba.Taxation,feature:"Taxation",uiTag:null===(n=TS.value)||void 0===n?void 0:n.economyPanelTaxationTab},{tab:Ba.Services,feature:"Service Budgets",uiTag:null===(r=TS.value)||void 0===r?void 0:r.economyPanelServicesTab},{tab:Ba.Production,feature:"Production Panel",uiTag:null===(i=TS.value)||void 0===i?void 0:i.economyPanelProductionTab}]}),[]),s=(0,i.useMemo)((function(){return l.filter((function(e){return!a||e.tab!==Ba.Loan}))}),[l,a]),c=(0,i.useMemo)((function(){return{"Switch Tab":function(e){if(0!==e){var t=s.findIndex((function(e){return e.tab===n})),i=Kie(e,s,t);i>=0&&i<s.length&&i!==t&&(r(s[i].tab),Jt(e<0?Qt.selectPreviousItem:Qt.selectNextItem))}}}}),[s,r,n]);return(0,e.jsx)($r,{header:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.EconomyPanel.TITLE,{})}),(0,e.jsx)(ZN,{children:s.map((function(t){return(0,e.jsx)(Bie,{tab:t.tab,onSelect:r,selectedTab:n,feature:t.feature,uiTag:t.uiTag},t.tab)}))})]}),transitionSounds:en,className:Gie,onClose:o,children:(0,e.jsx)(Tn,{actions:c,children:Hie(n)})})};var Bie=function(t){var n=t.tab,r=t.selectedTab,i=t.feature,o=t.uiTag,a=t.onSelect,l=FM(i);return(0,e.jsx)(x7,{locked:l.locked,requirements:l.requirements,children:(0,e.jsx)(JN,{id:n,uiTag:o,selectedId:r,selectSound:Qt.economy,disabled:l.locked,locked:l.locked,onSelect:a,children:(0,e.jsx)(Ks.EconomyPanel.TAB,{hash:Ba[n]})})})};function Hie(t){switch(t){case Ba.Budget:return(0,e.jsx)(Xee,{});case Ba.Loan:return(0,e.jsx)(Lte,{});case Ba.Taxation:return(0,e.jsx)(Fie,{});case Ba.Services:return(0,e.jsx)($re,{});case Ba.Production:return(0,e.jsx)(Hne,{});default:return null}}var Kie=function(e,t,n){for(var r=n<0?e<0?0:-1:n,i=1;i<=t.length;i+=1){var o=((e<0?r-i:r+i)+t.length)%t.length;if(!VM(t[o].feature))return o}return-1},Wie="eventJournal",zie=T(Wie,"eventMap"),Yie=E(Wie,"events");function Xie(){N(Wie,"closeJournal")}const qie="event-journal-entry_swm",$ie="header_YTt",Qie="icon_TDT",Zie="title_CGf",Jie="date_euC",eoe="info_fKt",toe="entry_oxi";var noe=function(t){var n,r,o=t.event,a=M(zie,o),l=C(Gp),s=$p(l,C(Bp)),c=(0,i.useMemo)((function(){return Zp(l,a.date)}),[a.date,l]),u=0;return(0,e.jsxs)(ml,{className:qie,children:[(0,e.jsxs)("div",{className:$ie,children:[(0,e.jsx)("img",{className:Qie,src:""!==a.icon?a.icon:"Media/Game/Icons/Calendar.svg"}),(0,e.jsx)("div",{className:Zie,children:(0,e.jsx)(Ks.EventJournal.EVENT_TITLE,{hash:a.id})}),(0,e.jsx)("div",{className:Jie,children:qp(s,c)?(0,e.jsx)($s,{value:c}):(0,e.jsx)(Ys,{value:c})})]}),(0,e.jsxs)("div",{className:eoe,children:[null===(n=a.data)||void 0===n?void 0:n.map((function(t){return(0,e.jsxs)("div",{className:toe,children:[(0,e.jsx)(Ks.EventJournal.EFFECT,{hash:t.type})," : ",t.value]},u++)})),null===(r=a.effects)||void 0===r?void 0:r.map((function(t){return(0,e.jsxs)("div",{className:toe,children:[(0,e.jsx)(Ks.EventJournal.EFFECT,{hash:t.type})," : ",(0,e.jsx)(dc,{value:t.value,unit:tc.PercentageSingleFraction})]},u++)}))]})]})};const roe="event-journal_yee",ioe="scrollable_XJ4";var ooe=function(t){var n,r,o=t.onClose;su(null===(n=TS.value)||void 0===n?void 0:n.eventJournalPanel);var a=C(Yie),s=(0,i.useCallback)((function(){Xie(),o()}),[o]);return(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.eventJournalPanel,children:(0,e.jsx)($r,{theme:B6,transitionSounds:en,className:roe,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.EventJournal.PANEL_TITLE,{})}),onClose:s,children:(0,e.jsx)(Fn,{children:a.length>0?(0,e.jsx)(mf,{className:ioe,children:a.map((function(t){return(0,e.jsx)(noe,{event:t},l(t))}))}):(0,e.jsx)(DP,{children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.EventJournal.OPENING_MESSAGE,{})})})})})})};function aoe(e){var t=ni(C(Ra),e),n=(0,i.useCallback)((function(){return Ua(e)}),[e]);return(0,i.useMemo)((function(){return{visible:t,toggle:n}}),[t,n])}const loe={button:"button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","toggle-states":"toggle-states_DTm",toggleStates:"toggle-states_DTm",icon:"icon_soN icon_Iwk",locked:"locked_H2O locked_dBl"},soe="infomode-item_K8b item-focused_FuT item-mouse-states_Fmi",coe="checkbox_JWP",uoe="header_dAd",doe="title_tX0",foe="title-text_uCA",hoe="active_m64",moe="color_Q5Z",poe="legend_K3N",voe="color-legend_PQU legend_K3N",goe="color-legend-item__ty",yoe="label_oSR",boe="gradient_HaQ",xoe="type_puL";function _oe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function joe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){_oe(e,t,n[t])}))}return e}var Eoe=function(t){var n=t.focusKey,r=t.infomode,o=r.id,a=r.active,l=(0,i.useCallback)((function(){!function(e,t,n){N("infoviews","setInfomodeActive",e,t,n)}(r.entity,!r.active,r.priority)}),[r.entity,r.active,r.priority]);return(0,e.jsx)(xO,{direction:"right",tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Infoviews.INFOMODE_TOOLTIP,{hash:o})}),children:(0,e.jsxs)(ml,{focusKey:n,onSelect:l,theme:loe,selectSound:Qt.toggleInfoMode,selectAction:a?"Disable Info Mode":"Enable Info Mode",className:Oe()(soe,a&&hoe),children:[(0,e.jsxs)("div",{className:uoe,children:[(0,e.jsxs)("div",{className:doe,children:[r.color&&(0,e.jsx)(bv,{color:pm(r.color),className:moe}),(0,e.jsx)("div",{className:foe,children:(0,e.jsx)(Ks.Infoviews.INFOMODE,{hash:o})})]}),(0,e.jsxs)("div",{className:xoe,children:[(0,e.jsx)(Ks.Infoviews.INFOMODE_TYPE,{hash:r.type}),(0,e.jsx)(pp,{checked:a,focusKey:Te,className:coe})]})]}),r.gradientLegend&&(0,e.jsx)(Ooe,joe({},r.gradientLegend)),r.colorLegends.length>0&&(0,e.jsx)("div",{className:voe,children:r.colorLegends.map((function(t,n){return(0,e.jsx)(yv,{color:pm(t.color),label:(0,e.jsx)(ph,{value:t.label}),className:goe},n)}))})]})})},Ooe=function(t){var n=t.lowLabel,r=t.highLabel,i=t.gradient;return(0,e.jsxs)("div",{className:poe,children:[n&&(0,e.jsx)("div",{className:yoe,children:(0,e.jsx)(ph,{value:n})}),(0,e.jsx)("div",{className:boe,style:{backgroundImage:_m(i)}}),r&&(0,e.jsx)("div",{className:yoe,children:(0,e.jsx)(ph,{value:r})})]})};const Toe="small-space_DCq",Ioe="space_uKL";var Soe=function(t){var n=t.small,r=void 0!==n&&n;return(0,e.jsx)("div",{className:r?Toe:Ioe})};const woe="labels_L7Q",Noe="row_S2v",Poe="left-icon_fKY",Coe="left_Lgw",Aoe="uppercase_RJI",Loe="right_k3O",Moe="centered_j4I",Roe="small_ExK",koe="label_NuH",Doe="tiny_m9B",Uoe="icon-label_J_h",Foe="icon_W7O";var Goe=function(t){var n=t.icon,r=t.text,i=t.rightText,o=t.uppercase,a=void 0!==o&&o,l=t.centered,s=void 0!==l&&l,c=t.small,u=void 0!==c&&c,d=t.tiny,f=void 0!==d&&d;return(0,e.jsxs)("div",{className:Oe()(woe,Noe,a&&Aoe,s&&Moe,u&&Roe,f&&Doe),children:[n&&(0,e.jsx)("img",{src:n,className:Poe}),r&&(0,e.jsx)("div",{className:Oe()(Coe,Noe),children:r}),i&&(0,e.jsx)("div",{className:Oe()(Loe,Noe),children:i})]})},Voe=function(t){var n=t.icon,r=t.label;return(0,e.jsxs)("div",{className:Uoe,children:[(0,e.jsx)(ll,{src:n,className:Foe}),(0,e.jsx)("div",{className:koe,children:r})]})},Boe=Os("LocalizedPercentage",(function(e,t){var n=t.value,r=t.max;return dc.renderString(e,{value:n>0&&r>0?Math.max(1,100*n/r):0,unit:tc.Percentage})}),(function(e,t){return e.value===t.value&&e.max===t.max})),Hoe={stops:[{color:"#0331fc",offset:0},{color:"#0331fc",offset:.333},{color:"#fcba03",offset:.333},{color:"#fcba03",offset:.666},{color:"#a15800",offset:.666},{color:"#a15800",offset:1}]},Koe={stops:[{color:"#479436",offset:0},{color:"#63B506",offset:.66},{color:"#FF831B",offset:.33},{color:"#FF4E18",offset:1}]},Woe={stops:[{color:"#FF4E18",offset:0},{color:"#FF831B",offset:.33},{color:"#63B506",offset:.66},{color:"#479436",offset:1}]},zoe={stops:[{color:"#e8f6e5",offset:0},{color:"#479436",offset:1}]},Yoe={stops:[{color:"#FF4E18",offset:0},{color:"#FF4E18",offset:.4},{color:"#FF831B",offset:.4},{color:"#FF831B",offset:.5},{color:"#63B506",offset:.5},{color:"#63B506",offset:.6},{color:"#479436",offset:.6},{color:"#479436",offset:1}]},Xoe={stops:[{color:"#FF4E18",offset:0},{color:"#FF4E18",offset:.8},{color:"#FF831B",offset:.8},{color:"#FF831B",offset:.9},{color:"#63B506",offset:.9},{color:"#63B506",offset:1}]};const qoe="bar_nW3",$oe="gradient_P8C",Qoe="pointer_SV2",Zoe="pointerIcon_i8i";var Joe=function(t){var n=t.value,r=t.gradient,i=void 0===r?Yoe:r;return(0,e.jsxs)("div",{className:qoe,children:[(0,e.jsx)("div",{className:Oe()($oe),style:{backgroundImage:_m(i)}}),(0,e.jsx)("div",{className:Qoe,style:tae(n),children:(0,e.jsx)("img",{src:"Media/Misc/IndicatorBarPointer.svg",className:Zoe})})]})},eae=function(t){var n=t.gradient,r=t.value,o=(0,i.useMemo)((function(){var e=r.max-r.min,t=r.current-r.min;return{left:"".concat(t/e*100,"%")}}),[r]);return(0,e.jsxs)("div",{className:qoe,children:[(0,e.jsx)("div",{className:$oe,style:{backgroundImage:_m(n)}}),(0,e.jsx)("div",{className:Qoe,style:o,children:(0,e.jsx)("img",{src:"Media/Misc/IndicatorBarPointer.svg",className:Zoe})})]})};function tae(e){return(0,i.useMemo)((function(){var t=e.max-e.min,n=e.current-e.min;return{left:"".concat(n/t*100,"%")}}),[e])}const nae="infoview-panel-section_RXJ",rae="content_1xS",iae="focusable-border_rVm",oae="focusable_GEc item-focused_FuT";var aae=function(t){var n=t.disableFocus,r=void 0!==n&&n,o=t.tooltip,a=t.focusableBorder,l=t.children,s=i.Children.count(o)>0;return(0,e.jsx)(xO,{tooltip:s?(0,e.jsx)(fI,{children:o}):void 0,direction:"right",children:(0,e.jsx)("div",{className:nae,children:r?(0,e.jsx)("div",{className:rae,children:l}):(0,e.jsx)(Tr,{className:Oe()(rae,a?iae:oae),children:l})})})},lae=function(t){var n=t.title,r=t.value,i=t.gradient,o=t.tooltip,a=t.children;return(0,e.jsxs)(aae,{tooltip:o,children:[n,(0,e.jsx)(eae,{gradient:i,value:r}),a]})},sae=function(){var t=C(mo);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.AirPollutionInfoPanel.AVERAGE_AIR_POLLUTION,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_AIR_POLLUTION_TOOLTIP,{}),value:t,gradient:Hoe})},cae=function(){return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(uae,{}),(0,e.jsx)(dae,{}),(0,e.jsx)(fae,{})]})},uae=function(){var t=C(ea);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.CompanyInfoPanel.COMMERCIAL_PROFITABILITY,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_COMMERCIAL_PROFIT_TOOLTIP,{}),value:t,gradient:Woe})},dae=function(){var t=C(ta);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.CompanyInfoPanel.INDUSTRIAL_PROFITABILITY,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_INDUSTRIAL_PROFIT_TOOLTIP,{}),value:t,gradient:Woe})},fae=function(){var t=C(na);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.CompanyInfoPanel.OFFICE_PROFITABILITY,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_OFFICE_PROFIT_TOOLTIP,{}),value:t,gradient:Woe})},hae=function(){var t=C(Do),n=C(Ro),r=C(ko);return(0,e.jsxs)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.DisasterInfoPanel.SHELTER_AVAILABILITY,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.SHELTER_AVAILABILITY_TOOLTIP,{}),value:t,gradient:Woe,children:[(0,e.jsx)(Soe,{small:!0}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.DisasterInfoPanel.EVACUATED,{}),rightText:n}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.DisasterInfoPanel.CAPACITY,{}),rightText:r})]})},mae=["#808080","#b09868","#368a2e","#b981c0","#5796d1"],pae=[(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Uneducated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Poorly Educated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Educated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Well Educated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Highly Educated"})];const vae="pie-chart_NVJ",gae="label_pdq";var yae={tension:30,friction:10},bae=i.memo((function(t){var n=t.data,r=t.size,o=void 0===r?200:r,a=t.startAngle,l=void 0===a?-.5*Math.PI:a,s=t.defaultBackground,c=void 0===s?"rgba(255, 255, 255, 0.2)":s,u=t.total,d=void 0===u?n.reduce((function(e,t){return e+t.value}),0):u,f=t.className,h=t.labelOffset,m=void 0===h?.75:h,p=t.innerRadius,v=void 0===p?.6:p,g=t.labelAngleThreshold,y=void 0===g?0:g,b=t.animate,x=void 0===b||b,_=qd(),j=Math.trunc(o*_),E=(0,i.useRef)(null),O=V$(yae,1,x?0:1,!0);(0,i.useEffect)((function(){if(null!==E.current){var e=E.current.getContext("2d");if(null!=e){e.clearRect(0,0,j,j);var t=j/2;e.save(),e.translate(t,t),e.rotate(l);var r=0;d>0&&n.forEach((function(n){var i=n.background,o=n.value,a=Math.min(xae(o,d),2*Math.PI-r)*O;a>=0&&(_ae(e,r,r+a,t,v,i,.5*_),r+=a)})),r<2*Math.PI&&_ae(e,r,2*Math.PI,t,v,c,.5*_),e.restore()}}}),[n,o,_,d,v,l,c,O,j]);var T=0;return(0,e.jsxs)("div",{className:Oe()(f,vae),style:{width:o*_,height:o*_},children:[j>0&&(0,e.jsx)("canvas",{ref:E,width:j,height:j}),d>0&&n.filter((function(e){return e.value>=0})).map((function(t,n){var r=Math.min(xae(t.value,d),2*Math.PI-T),i=O*(T+r/2)+l;return T+=r,t.label&&r>y&&(0,e.jsx)("div",{className:gae,style:{left:o*_/2+Math.cos(i)*o*_/2*m,top:o*_/2+Math.sin(i)*o*_/2*m},children:t.label},n)}))]})}),(function(e,t){return f(e,t,3)})),xae=function(e,t){return e/t*2*Math.PI},_ae=function(e,t,n,r,i,o,a){if(!(n<t)){var l=t+a/r,s=n-a/r,c=t+a/(i*r),u=n-a/(i*r);s-l<.01||u-c<.01||(e.fillStyle=o,e.beginPath(),e.arc(0,0,r,l,s),e.arc(0,0,r*i,u,c,!0),e.closePath(),e.fill())}};const jae="info-piechart_wXd",Eae="content__L_",Oae="pie_WkN",Tae="legends_pVz",Iae="legend_fqG";var Sae=function(t){var n=t.title,r=t.colors,i=t.labels,o=t.data,a=t.ignoreZero,l=void 0!==a&&a,s=t.usePercentageValue,c=void 0!==s&&s,u=t.customLegend,d=t.className,f=c&&o.total>0?100/o.total:1;return(0,e.jsxs)("div",{className:Oe()(jae,d),children:[n&&(0,e.jsx)(d$,{uppercase:!0,left:n}),(0,e.jsxs)("div",{className:Eae,children:[(0,e.jsx)("div",{className:Oae,children:(0,e.jsx)(bae,{data:wae(o,r),innerRadius:.6,size:125})}),(0,e.jsx)("div",{className:Tae,children:u||o.values.filter((function(e){return!l||e>0})).map((function(t,n){return(0,e.jsxs)("div",{className:Iae,children:[(0,e.jsx)(yv,{color:r[n],label:i[n]}),(0,e.jsx)(dc,{value:t*f,unit:c?tc.PercentageSingleFraction:tc.Integer})]},n)}))})]})]})},wae=function(e,t){return e.values.map((function(n,r){return{value:e.values[r],background:t[r]}}))},Nae=function(t){var n=t.title,r=t.supplyLabel,i=t.demandLabel,o=t.supplyValue,a=t.demandValue,l=t.availability,s=t.gradient,c=t.tooltip,u=t.children;return(0,e.jsxs)(aae,{tooltip:c,children:[n,(0,e.jsx)(Joe,{value:l,gradient:s}),(0,e.jsx)(Goe,{tiny:!0,text:(0,e.jsx)(Ks.Infoviews.LABEL_VALUE_FORMAT,{LABEL:i,VALUE:a}),rightText:(0,e.jsx)(Ks.Infoviews.LABEL_VALUE_FORMAT,{LABEL:r,VALUE:o})}),(0,e.jsx)(Soe,{small:!0}),u]})},Pae=function(){var t=C(Ri),n=C(ki),r=C(Di),i=C(Ui),o=C(Ii),a=C(Si),l=C(wi),s=C(Ni),c=C(Pi),u=C(Ci),d=C(Ai),f=C(Li),h=C(Fi),m=C(Gi),p=C(Vi),v=C(Bi),g=C(Mi);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Cae,{localeKey:"Elementary",availability:h,eligible:o,capacity:c,students:t,tooltip:(0,e.jsx)(Ks.Infoviews.ELEMENTARY_SCHOOL_AVAILABILITY_TOOLTIP,{})}),(0,e.jsx)(Cae,{localeKey:"High School",availability:m,eligible:a,capacity:u,students:n,tooltip:(0,e.jsx)(Ks.Infoviews.HIGH_SCHOOL_AVAILABILITY_TOOLTIP,{})}),(0,e.jsx)(Cae,{localeKey:"College",availability:p,eligible:l,capacity:d,students:r,tooltip:(0,e.jsx)(Ks.Infoviews.COLLEGE_AVAILABILITY_TOOLTIP,{})}),(0,e.jsx)(Cae,{localeKey:"University",availability:v,eligible:s,capacity:f,students:i,tooltip:(0,e.jsx)(Ks.Infoviews.UNIVERSITY_AVAILABILITY_TOOLTIP,{})}),(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.EDUCATION_DISTRIBUTION_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.EducationInfoPanel.EDUCATION_DISTRIBUTION,{})}),(0,e.jsx)(Sae,{usePercentageValue:!0,colors:mae,labels:pae,data:g})]})]})},Cae=function(t){var n=t.localeKey,r=t.availability,i=t.eligible,o=t.capacity,a=t.students,l=t.tooltip;return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.EducationInfoPanel.EDUCATION_LEVEL,{hash:n}),rightText:(0,e.jsx)(Voe,{icon:"Media/Game/Icons/Citizen.svg",label:(0,e.jsx)(dc,{value:a,unit:tc.Integer})})}),demandLabel:(0,e.jsx)(Ks.EducationInfoPanel.ELIGIBLE,{}),demandValue:(0,e.jsx)(dc,{value:i,unit:tc.Integer}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),supplyValue:(0,e.jsx)(dc,{value:o,unit:tc.Integer}),availability:r,tooltip:l})})},Aae=function(){var t=C(ci),n=C(ui),r=C(di),i=C(fi),o=C(hi),a=C(mi),l=C(pi);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.ElectricityInfoPanel.ELECTRICITY_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.ELECTRICITY_AVAILABILITY_TOOLTIP,{}),availability:o,supplyLabel:(0,e.jsx)(Ks.InfoPanels.PRODUCTION,{}),supplyValue:(0,e.jsx)(dc,{value:n,unit:tc.Power}),demandLabel:(0,e.jsx)(Ks.InfoPanels.CONSUMPTION,{}),demandValue:(0,e.jsx)(dc,{value:t,unit:tc.Power})}),(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.ElectricityInfoPanel.ELECTRICITY_TRADE,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.ELECTRICITY_TRADE_TOOLTIP,{}),availability:a,supplyLabel:(0,e.jsx)(Ks.ElectricityInfoPanel.ELECTRICITY_EXPORT,{}),supplyValue:(0,e.jsx)(dc,{value:r,unit:tc.Power}),demandLabel:(0,e.jsx)(Ks.ElectricityInfoPanel.ELECTRICITY_IMPORT,{}),demandValue:(0,e.jsx)(dc,{value:i,unit:tc.Power})}),(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.ElectricityInfoPanel.BATTERY_CHARGE,{}),rightText:(0,e.jsx)(ah,{value:l.current,total:l.max,unit:tc.Energy})}),tooltip:(0,e.jsx)(Ks.Infoviews.BATTERY_CHARGE_TOOLTIP,{}),value:l,gradient:zoe})]})},Lae=function(){var t,n=C(go);return(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.infoviewsFireHazard,children:(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.FireAndRescueInfoPanel.AVERAGE_FIRE_HAZARD,{}),rightText:(0,e.jsx)(Boe,{value:n.current,max:n.max})}),value:n,gradient:Koe,tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_FIRE_HAZARD_TOOLTIP,{})})})},Mae=function(){return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Rae,{}),(0,e.jsx)(kae,{})]})},Rae=function(){var t=C(oo),n=C(to),r=C(ro);return(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.GarbageInfoPanel.PROCESSING_STATUS,{})}),demandLabel:(0,e.jsx)(Ks.GarbageInfoPanel.GARBAGE_RATE,{}),demandValue:(0,e.jsx)(dc,{value:t,unit:tc.WeightPerMonth}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.PROCESSING,{}),supplyValue:(0,e.jsx)(dc,{value:n,unit:tc.WeightPerMonth}),availability:r,tooltip:(0,e.jsx)(Ks.Infoviews.GARBAGE_PROCESSING_STATUS_TOOLTIP,{})})},kae=function(){var t=C(no),n=C(ao),r=C(io);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.GarbageInfoPanel.LANDFILL_AVAILABILITY,{}),rightText:(0,e.jsx)(dc,{value:100*r.current,unit:tc.Percentage})}),tooltip:(0,e.jsx)(Ks.Infoviews.LANDFILL_AVAILABILITY_TOOLTIP,{}),value:r,gradient:Woe,children:(0,e.jsx)(Goe,{tiny:!0,text:(0,e.jsx)(Ks.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,e.jsx)(Ks.GarbageInfoPanel.STORED_GARBAGE,{}),VALUE:(0,e.jsx)(dc,{value:n,unit:tc.Weight})}),rightText:(0,e.jsx)(Ks.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),VALUE:(0,e.jsx)(dc,{value:t,unit:tc.Weight})})})})},Dae=function(){var t=C(ho);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.GroundPollutionInfoPanel.AVERAGE_GROUND_POLLUTION,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_GROUND_POLLUTION_TOOLTIP,{}),value:t,gradient:Hoe})})};const Uae={positive:"positive_zrK",negative:"negative_YWY"};var Fae=function(){var t=C($7);return(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.HAPPINESS_FACTORS_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.Common.HAPPINESS_FACTORS,{})}),(0,e.jsx)(Soe,{}),t.map((function(t,n){return(0,e.jsx)(Goe,{small:!0,text:t.weight>0?(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_POSITIVE,{hash:t.factor}):(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:t.factor}),rightText:(0,e.jsx)("div",{className:Ef(Uae,t.weight),children:(0,e.jsx)(dc,{value:t.weight,signed:!0})})},n)}))]})},Gae=function(){return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Vae,{}),(0,e.jsx)(Bae,{}),(0,e.jsx)(Hae,{})]})},Vae=function(){var t=C($i),n=C(Qi),r=C(Zi),i=C(Ki),o=C(qi);return(0,e.jsxs)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.HealthcareInfoPanel.HEALTHCARE_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.HEALTHCARE_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,e.jsx)(Ks.HealthcareInfoPanel.SICK_OR_INJURED,{}),demandValue:(0,e.jsx)(dc,{value:o,unit:tc.Integer}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),supplyValue:(0,e.jsx)(dc,{value:n,unit:tc.Integer}),availability:r,children:[(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.HealthcareInfoPanel.AVERAGE_HEALTH,{}),rightText:(0,e.jsx)(dc,{value:i,unit:tc.Percentage})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.HealthcareInfoPanel.PATIENTS,{}),rightText:(0,e.jsx)(dc,{value:t,unit:tc.Integer})})]})},Bae=function(){var t=C(Yi),n=C(Xi),r=C(Ji);return(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.HealthcareInfoPanel.CREMATORIUM_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.CREMATORIUM_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,e.jsx)(Ks.HealthcareInfoPanel.DEATH_RATE,{}),demandValue:(0,e.jsx)(dc,{value:t,unit:tc.IntegerPerMonth}),supplyLabel:(0,e.jsx)(Ks.HealthcareInfoPanel.PROCESSING_RATE,{}),supplyValue:(0,e.jsx)(dc,{value:n,unit:tc.IntegerPerMonth}),availability:r})},Hae=function(){var t=C(Wi),n=C(zi),r=C(eo);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.HealthcareInfoPanel.CEMETERY_AVAILABILITY,{}),rightText:(0,e.jsx)(Boe,{value:n-t,max:n})}),tooltip:(0,e.jsx)(Ks.Infoviews.CEMETERY_AVAILABILITY_TOOLTIP,{}),value:r,gradient:Woe,children:(0,e.jsx)(Goe,{tiny:!0,text:(0,e.jsx)(Ks.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,e.jsx)(Ks.HealthcareInfoPanel.OCCUPIED,{}),VALUE:(0,e.jsx)(dc,{value:t,unit:tc.Integer})}),rightText:(0,e.jsx)(Ks.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),VALUE:(0,e.jsx)(dc,{value:n,unit:tc.Integer})})})})},Kae=function(){var t=C(Po);return(0,e.jsx)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_LAND_VALUE_TOOLTIP,{}),children:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.LandValueInfoPanel.AVERAGE_LAND_VALUE,{}),rightText:(0,e.jsx)(dc,{value:240*t,unit:tc.MoneyPerCell})})})},Wae=function(){var t=C(Co),n=C(Ao),r=C(Lo),i=C(Mo),o=FM("ZonesOffice"),a=[(0,e.jsx)(Ks.LevelInfoPanel.LEVEL1,{}),(0,e.jsx)(Ks.LevelInfoPanel.LEVEL2,{}),(0,e.jsx)(Ks.LevelInfoPanel.LEVEL3,{}),(0,e.jsx)(Ks.LevelInfoPanel.LEVEL4,{}),(0,e.jsx)(Ks.LevelInfoPanel.LEVEL5,{})];return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.RESIDENTIAL_LEVEL_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,centered:!0,text:(0,e.jsx)(Ks.LevelInfoPanel.RESIDENTIAL,{})}),(0,e.jsx)(Sae,{colors:["#86FB14","#64B805","#3C8F1A","#2F7512","#20550C"],labels:a,data:t,usePercentageValue:!0})]}),(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.COMMERCIAL_LEVEL_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,centered:!0,text:(0,e.jsx)(Ks.LevelInfoPanel.COMMERCIAL,{})}),(0,e.jsx)(Sae,{colors:["#43D4FF","#2393B8","#1B748E","#116075","#0A4254"],labels:a,data:n,usePercentageValue:!0})]}),(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.INDUSTRIAL_LEVEL_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,centered:!0,text:(0,e.jsx)(Ks.LevelInfoPanel.INDUSTRIAL,{})}),(0,e.jsx)(Sae,{colors:["#FCCE1A","#B59923","#90781C","#766315","#55450D"],labels:a,data:r,usePercentageValue:!0})]}),(0,e.jsx)(x7,{locked:o.locked,requirements:o.requirements,children:(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.OFFICE_LEVEL_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,centered:!0,text:(0,e.jsx)(Ks.LevelInfoPanel.OFFICE,{})}),(0,e.jsx)(Sae,{colors:["#7941FF","#4E22B3","#3D1C92","#311376","#200B54"],labels:a,data:i,usePercentageValue:!0})]})})]})},zae=function(){var t=C(ca),n=C(ua),r=C(da),i=C(fa),o=C(ha),a=C(ma),l=C(pa),s=C(va),c=C(ga),u=C(ya);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Yae,{text:(0,e.jsx)(Goe,{icon:"Media/Game/Icons/Fertility.svg",text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.FERTILITY,{}),uppercase:!0}),tooltip:(0,e.jsx)(Ks.Infoviews.FERTILE_LAND_RESOURCE_TOOLTIP,{}),available:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:i>0?(0,e.jsx)(dc,{value:i,unit:tc.Area}):0}),extractionRate:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.RATE,{}),rightText:s>0?(0,e.jsx)(dc,{value:s,unit:tc.WeightPerMonth}):0}),renewalRate:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.RENEWAL_RATE,{}),rightText:u>0?(0,e.jsx)(dc,{value:u,unit:tc.WeightPerMonth}):0})}),(0,e.jsx)(Yae,{text:(0,e.jsx)(Goe,{icon:"Media/Game/Icons/Forest.svg",text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.FOREST,{}),uppercase:!0}),tooltip:(0,e.jsx)(Ks.Infoviews.WOOD_RESOURCE_TOOLTIP,{}),available:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:r>0?(0,e.jsx)(dc,{value:r,unit:tc.Weight}):0}),extractionRate:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.RATE,{}),rightText:l>0?(0,e.jsx)(dc,{value:l,unit:tc.WeightPerMonth}):0}),renewalRate:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.RENEWAL_RATE,{}),rightText:c>0?(0,e.jsx)(dc,{value:c,unit:tc.WeightPerMonth}):0})}),(0,e.jsx)(Yae,{text:(0,e.jsx)(Goe,{icon:"Media/Game/Icons/Ore.svg",text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.ORE,{}),uppercase:!0}),tooltip:(0,e.jsx)(Ks.Infoviews.ORE_RESOURCE_TOOLTIP,{}),available:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:n>0?(0,e.jsx)(dc,{value:n,unit:tc.Weight}):0}),extractionRate:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.RATE,{}),rightText:a>0?(0,e.jsx)(dc,{value:a,unit:tc.WeightPerMonth}):0})}),(0,e.jsx)(Yae,{text:(0,e.jsx)(Goe,{icon:"Media/Game/Icons/Oil.svg",text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.OIL,{}),uppercase:!0}),tooltip:(0,e.jsx)(Ks.Infoviews.OIL_RESOURCE_TOOLTIP,{}),available:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:t>0?(0,e.jsx)(dc,{value:t,unit:tc.Weight}):0}),extractionRate:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.NaturalResourcesInfoPanel.RATE,{}),rightText:o>0?(0,e.jsx)(dc,{value:o,unit:tc.WeightPerMonth}):0})})]})},Yae=function(t){var n=t.text,r=t.available,i=t.extractionRate,o=t.renewalRate,a=t.tooltip;return(0,e.jsxs)(aae,{tooltip:a,children:[n,r,i,o]})},Xae=function(){var t=C(vo);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.NoisePollutionInfoPanel.AVERAGE_NOISE_POLLUTION,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_NOISE_POLLUTION_TOOLTIP,{}),value:t,gradient:qae})})},qae={stops:[{color:"#FFF",offset:0},{color:"#F00",offset:1}]},$ae=function(){var t=C(ra),n=C(ia),r=C(oa),i=C(aa),o=C(la),a=C(sa);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.IMPORT_DISTRIBUTION_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.OutsideConnectionsInfoPanel.TOP_IMPORTS,{})}),(0,e.jsx)(Sae,{colors:n,data:r,labels:t.map((function(t){return(0,e.jsx)(Ks.Resources.TITLE,{hash:t.replace("Resource","")},t)})),ignoreZero:!0,usePercentageValue:!0})]}),(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.EXPORT_DISTRIBUTION_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.OutsideConnectionsInfoPanel.TOP_EXPORTS,{})}),(0,e.jsx)(Sae,{colors:o,data:a,labels:i.map((function(t){return(0,e.jsx)(Ks.Resources.TITLE,{hash:t.replace("Resource","")},t)})),ignoreZero:!0,usePercentageValue:!0})]})]})},Qae=function(){var t=C(yo),n=C(bo),r=C(xo),i=C(_o),o=C(jo),a=C(Eo),l=C(Io),s=C(So),c=C(wo),u=C(No),d=C(Oo),f=C(To);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.JAIL_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.JAIL_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,e.jsx)(Ks.PoliceInfoPanel.ARRESTED_CRIMINALS,{}),demandValue:(0,e.jsx)(dc,{value:o,unit:tc.Integer}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),supplyValue:(0,e.jsx)(dc,{value:i,unit:tc.Integer}),availability:n,children:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.IN_JAIL,{}),rightText:(0,e.jsx)(dc,{value:a,unit:tc.Integer})})}),(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.PRISON_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.PRISON_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,e.jsx)(Ks.PoliceInfoPanel.PRISONERS,{}),demandValue:(0,e.jsx)(dc,{value:f,unit:tc.Integer}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),supplyValue:(0,e.jsx)(dc,{value:d,unit:tc.Integer}),availability:r,children:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.IN_PRISON,{}),rightText:(0,e.jsx)(dc,{value:l,unit:tc.Integer})})}),(0,e.jsxs)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.AVERAGE_CRIME_PROBABILITY,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.CRIME_PROBABILITY_TOOLTIP,{}),value:t,gradient:Koe,children:[(0,e.jsx)(Soe,{small:!0}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.CURRENT_NUMBER_OF_CRIMINALS,{}),rightText:(0,e.jsx)(dc,{value:s,unit:tc.Integer})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.NUMBER_OF_CRIMES_PER_MONTH,{}),rightText:(0,e.jsx)(dc,{value:c,unit:tc.IntegerPerMonth})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PoliceInfoPanel.CRIME_SUCCESS_RATE,{}),rightText:(0,e.jsx)(dc,{value:u,unit:tc.PercentageSingleFraction})})]})]})},Zae=["#3a91c7","#8bb9d6","#5fb844","#a3b844"],Jae=[(0,e.jsx)(Ks.PopulationInfoPanel.CHILDREN,{}),(0,e.jsx)(Ks.PopulationInfoPanel.TEENS,{}),(0,e.jsx)(Ks.PopulationInfoPanel.ADULTS,{}),(0,e.jsx)(Ks.PopulationInfoPanel.SENIORS,{})],ele=function(){var t=C(zo),n=C(Yo),r=C(Xo),i=C(qo),o=C($o),a=C(Yi),l=C(Qo),s=C(Zo),c=C(Jo);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.POPULATION_STATISTICS_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.POPULATION,{}),rightText:(0,e.jsx)(dc,{value:t,unit:tc.Integer})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.BIRTH_RATE,{}),rightText:(0,e.jsx)(dc,{value:o,unit:tc.IntegerPerMonth})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.DEATH_RATE,{}),rightText:(0,e.jsx)(dc,{value:a,unit:tc.IntegerPerMonth})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.MOVED_IN,{}),rightText:(0,e.jsx)(dc,{value:l,unit:tc.IntegerPerMonth})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.MOVED_AWAY,{}),rightText:(0,e.jsx)(dc,{value:s,unit:tc.IntegerPerMonth})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.JOBS,{}),rightText:(0,e.jsx)(dc,{value:r,unit:tc.Integer})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.EMPLOYED,{}),rightText:(0,e.jsx)(dc,{value:n,unit:tc.Integer})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.UNEMPLOYMENT,{}),rightText:(0,e.jsx)(dc,{value:i,unit:tc.PercentageSingleFraction})})]}),(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.POPULATION_DISTRIBUTION_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.PopulationInfoPanel.AGE_DISTRIBUTION,{})}),(0,e.jsx)(Soe,{small:!0}),(0,e.jsx)(Sae,{usePercentageValue:!0,colors:Zae,labels:Jae,data:c})]})]})},tle=function(){var t=C(Bo),n=C(Ho),r=C(Ko),i=C(Wo);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.PostInfoPanel.MAIL_SERVICE_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.MAIL_SERVICE_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,e.jsx)(Ks.PostInfoPanel.MAIL_RATE,{}),demandValue:(0,e.jsx)(dc,{value:t,unit:tc.IntegerPerMonth}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.PROCESSING,{}),supplyValue:(0,e.jsx)(dc,{value:n+r,unit:tc.IntegerPerMonth}),availability:i})})},nle=function(){var t=C(lo),n=C(co),r=C(uo),i=C(so);return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.RoadsInfoPanel.PARKING_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.PARKING_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,e.jsx)(Ks.RoadsInfoPanel.PARKED_CARS,{}),demandValue:(0,e.jsx)(dc,{value:n,unit:tc.Integer}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.CAPACITY,{}),supplyValue:(0,e.jsx)(dc,{value:t,unit:tc.Integer}),availability:r,children:(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.RoadsInfoPanel.PARKING_INCOME,{}),rightText:(0,e.jsx)(dc,{value:i,unit:tc.MoneyPerMonth})})})})},rle=function(){var t=C(Go),n=C(Fo),r=C(Uo),i=C(Vo);return(0,e.jsx)(e.Fragment,{children:(0,e.jsxs)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.TourismInfoPanel.ATTRACTIVENESS,{}),rightText:(0,e.jsx)(dc,{value:r.current})}),tooltip:(0,e.jsx)(Ks.Infoviews.CITY_ATTRACTIVENESS_TOOLTIP,{}),value:r,gradient:zoe,children:[(0,e.jsx)(Soe,{small:!0}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.TourismInfoPanel.TOURISM_RATE,{}),rightText:(0,e.jsx)(dc,{value:t,unit:tc.IntegerPerMonth})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.TourismInfoPanel.WEATHER_EFFECT,{}),rightText:(0,e.jsx)(dc,{value:i,unit:tc.Percentage,signed:!0})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.TourismInfoPanel.AVERAGE_HOTEL_PRICE,{}),rightText:(0,e.jsx)(dc,{value:n,unit:tc.Money})})]})})};const ile="rgba(255, 255, 255, 0.6)",ole="rgba(255, 255, 255, 0.1)",ale="rgba(29, 130, 184, 1)",lle="rgba(29, 130, 184, 0.5)",sle="rgba(30, 179, 184, 1)",cle="rgba(30, 179, 184, 0.5)",ule="traffic-chart_r8c";var dle=function(t){var n=t.data,r=t.className,i=mle(n),o=hle(tc.IntegerPerHour,5,ale,lle);return(0,e.jsx)(Zj,{type:"line",data:i,options:o,className:Oe()(ule,r)})},fle=function(t){var n=t.data,r=t.className,i=mle(n),o=hle(tc.Percentage,100,sle,cle);return(0,e.jsx)(Zj,{type:"line",data:i,options:o,className:Oe()(ule,r)})};function hle(e,t,n,r){var o=fc(e),a=C(Jl);return(0,i.useMemo)((function(){var e={elements:{line:{borderColor:n,backgroundColor:r,borderWidth:2,fill:!0},point:{borderColor:n,backgroundColor:n,radius:2,hoverRadius:2,borderWidth:2,hoverBorderWidth:2}},scales:{x:{beginAtZero:!0,grid:{lineWidth:2,color:ole},ticks:{font:{size:10*a,weight:"bold"},color:ile,padding:10,autoSkip:!1}},y:{min:0,suggestedMax:t,grid:{lineWidth:2,color:ole},ticks:{font:{size:10*a,weight:"bold"},color:ile,padding:10,autoSkip:!1,callback:function(e){return o(e)},maxTicksLimit:6}}}};return e}),[r,n,o,t,a])}function mle(e){var t=Qs();return(0,i.useMemo)((function(){return{labels:[t({hour:0,minute:0}),t({hour:6,minute:0}),t({hour:12,minute:0}),t({hour:18,minute:0}),t({hour:0,minute:0})],datasets:[{label:"data",data:e}]}}),[e,t])}var ple=function(){var t=C(fo);return(0,e.jsxs)(aae,{focusableBorder:!0,tooltip:(0,e.jsx)(Ks.Infoviews.TRAFFIC_FLOW,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_TRAFFIC_FLOW,{})}),(0,e.jsx)(fle,{data:t})]})},vle="transportationOverview",gle=E(vle,"passengerTypes"),yle=E(vle,"cargoTypes"),ble=E(vle,"lines"),xle=E(vle,"selectedPassengerType"),_le=E(vle,"selectedCargoType"),jle=w(vle,"select"),Ele=w(vle,"delete"),Ole=w(vle,"rename"),Tle=w(vle,"setColor"),Ile=w(vle,"setActive"),Sle=w(vle,"showLine"),wle=w(vle,"hideLine"),Nle=w(vle,"setSchedule"),Ple=S(vle,"resetVisibility"),Cle=w(vle,"toggleHighlight"),Ale=w(vle,"setSelectedPassengerType"),Lle=w(vle,"setSelectedCargoType");const Mle="row_Pqo",Rle="disable-states_FlS",kle="locked_dOC",Dle="header_Sxm",Ule="secondary-row_bfC",Fle="value_p4t",Gle="fifty-percent_dQ2",Vle="thirty-percent_pPg",Ble="total-label_QwL",Hle="icon_Rph icon_Iwk",Kle="lock_eZg";var Wle=function(t){var n=t.summaries;return(0,e.jsxs)(aae,{disableFocus:!0,children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.TransportInfoPanel.CARGO_TRANSPORT_TITLE,{})}),(0,e.jsx)(zle,{}),(0,e.jsxs)(Fn,{children:[n.map((function(t){return(0,e.jsx)(Yle,{summary:t},t.id)})),(0,e.jsx)(Yle,{lastRow:!0,summary:n.reduce((function(e,t){return{id:"Total",icon:"",locked:!1,cargoCount:e.cargoCount+t.cargoCount,lineCount:e.lineCount+t.lineCount,requirements:{requireAny:[],requireAll:[]}}}))})]})]})},zle=function(){return(0,e.jsxs)("div",{className:Oe()(Mle,Rle,Dle),children:[(0,e.jsx)("div",{className:Hle}),(0,e.jsxs)("div",{className:Ule,children:[(0,e.jsx)("div",{className:Oe()(Fle,Gle),children:(0,e.jsx)(Ks.TransportInfoPanel.ROUTES_LABEL,{})}),(0,e.jsx)("div",{className:Oe()(Fle,Gle),children:(0,e.jsx)(Ks.TransportInfoPanel.CARGO_LABEL,{})})]})]})},Yle=function(t){var n=t.summary,r=t.lastRow,o=void 0!==r&&r,a=!o&&"Bus"!==n.id,l=(0,i.useCallback)((function(){Lle(n.id),Xa(za.Cargo)}),[n.id]);return(0,e.jsx)(x7,{description:(0,e.jsx)(Ks.TransportInfoPanel.SUMMARY_TOOLTIP_CARGO,{hash:n.id}),locked:n.locked,requirements:n.requirements,direction:"right",children:(0,e.jsxs)(ml,{focusKey:Ie,theme:loe,onSelect:a?l:void 0,disabled:n.locked,className:Oe()(Mle,n.locked&&loe.locked,n.locked&&kle,!a&&Rle),children:[o?(0,e.jsx)("div",{className:Ble,children:(0,e.jsx)(Ks.TransportInfoPanel.TOTAL,{})}):(0,e.jsx)("img",{src:n.icon,className:Oe()(loe.icon,Hle)}),n.locked&&(0,e.jsx)(YN,{className:Kle}),(0,e.jsxs)("div",{className:Ule,children:[(0,e.jsx)("div",{className:Oe()(Fle,Gle),children:"Bus"===n.id||0===n.lineCount&&!o?"—":n.lineCount}),(0,e.jsx)("div",{className:Oe()(Fle,Gle),children:n.cargoCount>0||o?(0,e.jsx)(dc,{value:n.cargoCount,unit:tc.WeightPerMonth}):"—"})]})]})})},Xle=function(t){var n=t.summaries;return(0,e.jsxs)(aae,{disableFocus:!0,children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.TransportInfoPanel.PUBLIC_TRANSPORT_TITLE,{})}),(0,e.jsx)(qle,{}),(0,e.jsxs)(Fn,{children:[n.map((function(t){return(0,e.jsx)($le,{summary:t},t.id)})),(0,e.jsx)($le,{lastRow:!0,summary:n.reduce((function(e,t){return{id:"Total",icon:"",locked:!1,touristCount:e.touristCount+t.touristCount,citizenCount:e.citizenCount+t.citizenCount,lineCount:e.lineCount+t.lineCount,requirements:{requireAny:[],requireAll:[]}}}))})]})]})},qle=function(){return(0,e.jsxs)("div",{className:Oe()(Mle,Rle,Dle),children:[(0,e.jsx)("div",{className:Hle}),(0,e.jsxs)("div",{className:Ule,children:[(0,e.jsx)("div",{className:Oe()(Fle,Vle),children:(0,e.jsx)(Ks.TransportInfoPanel.LINES,{})}),(0,e.jsx)("div",{className:Oe()(Fle,Vle),children:(0,e.jsx)(Ks.TransportInfoPanel.TOURISTS,{})}),(0,e.jsx)("div",{className:Oe()(Fle,Vle),children:(0,e.jsx)(Ks.TransportInfoPanel.CITIZENS,{})})]})]})},$le=function(t){var n=t.summary,r=t.lastRow,o=void 0!==r&&r,a=!o&&"Taxi"!==n.id,l=(0,i.useCallback)((function(){Ale(n.id),Xa(za.PublicTransport)}),[n.id]);return(0,e.jsx)(x7,{description:(0,e.jsx)(Ks.TransportInfoPanel.SUMMARY_TOOLTIP_PUBLICTRANSPORT,{hash:n.id}),locked:n.locked,requirements:n.requirements,direction:"right",children:(0,e.jsxs)(ml,{focusKey:Ie,onSelect:a?l:void 0,disabled:n.locked,theme:loe,className:Oe()(Mle,n.locked&&loe.locked,n.locked&&kle,!a&&Rle),children:[o?(0,e.jsx)("div",{className:Ble,children:(0,e.jsx)(Ks.TransportInfoPanel.TOTAL,{})}):(0,e.jsx)("img",{src:n.icon,className:Oe()(loe.icon,Hle)}),n.locked&&(0,e.jsx)(YN,{className:Kle}),(0,e.jsxs)("div",{className:Ule,children:[(0,e.jsx)("div",{className:Oe()(Fle,Vle),children:"Taxi"===n.id||0===n.lineCount&&!o?"—":n.lineCount}),(0,e.jsx)("div",{className:Oe()(Fle,Vle),children:n.touristCount>0||o?(0,e.jsx)(dc,{value:n.touristCount,unit:tc.IntegerPerMonth}):"—"}),(0,e.jsx)("div",{className:Oe()(Fle,Vle),children:n.citizenCount>0||o?(0,e.jsx)(dc,{value:n.citizenCount,unit:tc.IntegerPerMonth}):"—"})]})]})})},Qle=function(){var t=C(Hi);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Xle,{summaries:t.passengerSummaries}),(0,e.jsx)(Wle,{summaries:t.cargoSummaries})]})},Zle=function(){return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Jle,{}),(0,e.jsx)(tse,{}),(0,e.jsx)(ese,{}),(0,e.jsx)(nse,{})]})},Jle=function(){var t=C(vi),n=C(gi),r=C(Oi);return(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.WaterInfoPanel.WATER_AVAILABILITY,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.WATER_AVAILABILITY_TOOLTIP,{}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.OUTPUT,{}),supplyValue:(0,e.jsx)(dc,{value:t,unit:tc.VolumePerMonth}),demandLabel:(0,e.jsx)(Ks.InfoPanels.CONSUMPTION,{}),demandValue:(0,e.jsx)(dc,{value:n,unit:tc.VolumePerMonth}),availability:r})},ese=function(){var t=C(yi),n=C(bi),r=C(Ei);return(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.WaterInfoPanel.SEWAGE_TREATMENT,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.SEWAGE_TREATMENT_TOOLTIP,{}),supplyLabel:(0,e.jsx)(Ks.InfoPanels.PROCESSING,{}),supplyValue:(0,e.jsx)(dc,{value:t,unit:tc.VolumePerMonth}),demandLabel:(0,e.jsx)(Ks.InfoPanels.PRODUCTION,{}),demandValue:(0,e.jsx)(dc,{value:n,unit:tc.VolumePerMonth}),availability:r})},tse=function(){var t=C(xi),n=C(_i),r=C(Ti);return(0,e.jsx)(Nae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.WaterInfoPanel.WATER_TRADE,{})}),tooltip:(0,e.jsx)(Ks.Infoviews.WATER_TRADE_TOOLTIP,{}),supplyLabel:(0,e.jsx)(Ks.WaterInfoPanel.WATER_EXPORT,{}),supplyValue:(0,e.jsx)(dc,{value:t,unit:tc.VolumePerMonth}),demandLabel:(0,e.jsx)(Ks.WaterInfoPanel.WATER_IMPORT,{}),demandValue:(0,e.jsx)(dc,{value:n,unit:tc.VolumePerMonth}),availability:r})},nse=function(){var t=C(ji),n={min:C(bi),max:0,current:t};return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.WaterInfoPanel.SEWAGE_TRADE,{}),rightText:(0,e.jsx)(dc,{value:t,unit:tc.VolumePerMonth})}),tooltip:(0,e.jsx)(Ks.Infoviews.SEWAGE_TRADE_TOOLTIP,{}),value:n,gradient:Xoe})},rse=function(){var t=C(po);return(0,e.jsx)(lae,{title:(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.WaterPollutionInfoPanel.AVERAGE_WATER_POLLUTION,{}),rightText:(0,e.jsx)(Boe,{value:t.current,max:t.max})}),tooltip:(0,e.jsx)(Ks.Infoviews.AVERAGE_WATER_POLLUTION_TOOLTIP,{}),value:t,gradient:Hoe})},ise=["#808080","#b09868","#368a2e","#b981c0","#5796d1","#FFFFFF33"],ose=[(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Uneducated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Poorly Educated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Educated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Well Educated"}),(0,e.jsx)(Ks.EducationInfoPanel.LEVEL,{hash:"Highly Educated"}),(0,e.jsx)(Ks.SelectedInfoPanel.OPEN_POSITIONS,{})],ase=function(){var t=C(ba),n=C(xa),r=C(_a),i=C(ja);return(0,e.jsxs)(aae,{tooltip:(0,e.jsx)(Ks.Infoviews.WORKPLACE_DISTRIBUTION_TOOLTIP,{}),children:[(0,e.jsx)(Goe,{uppercase:!0,text:(0,e.jsx)(Ks.WorkplacesInfoPanel.WORKPLACE_DISTRIBUTION,{})}),(0,e.jsx)(Sae,{colors:ise,labels:ose,data:n,customLegend:n.values.map((function(r,i){return(t.values[i]>0||i===n.values.length-1)&&(0,e.jsxs)("div",{className:Iae,children:[(0,e.jsx)(yv,{color:ise[i],label:ose[i]}),i<n.values.length-1?(0,e.jsx)(ah,{value:r,total:t.values[i],unit:tc.Integer}):(0,e.jsx)(dc,{value:r,unit:tc.Integer})]},i)}))}),(0,e.jsx)(Soe,{}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.WorkplacesInfoPanel.WORKPLACES,{}),rightText:(0,e.jsx)(dc,{value:r,unit:tc.Integer})}),(0,e.jsx)(Goe,{small:!0,text:(0,e.jsx)(Ks.WorkplacesInfoPanel.WORKERS,{}),rightText:(0,e.jsx)(dc,{value:i,unit:tc.Integer})})]})};const lse="title_HFc",sse="active-infoview-panel_aTq",cse="infomodes-panel_B0O",use="scrollable_wt8";var dse=function(t){var n=t.focusKey,r=t.className,o=t.onClose,a=aoe(La.PhotoMode),l=EI(C(ai)),s=(0,i.useMemo)((function(){return function(t){switch(null==t?void 0:t.id){case"Electricity":return(0,e.jsx)(Aae,{});case"WaterPipes":return(0,e.jsx)(Zle,{});case"Transport":return(0,e.jsx)(Qle,{});case"Education":return(0,e.jsx)(Pae,{});case"Healthcare":return(0,e.jsx)(Gae,{});case"Garbage":return(0,e.jsx)(Mae,{});case"Roads":return(0,e.jsx)(nle,{});case"Traffic":return(0,e.jsx)(ple,{});case"AirPollution":return(0,e.jsx)(sae,{});case"GroundPollution":return(0,e.jsx)(Dae,{});case"WaterPollution":return(0,e.jsx)(rse,{});case"NoisePollution":return(0,e.jsx)(Xae,{});case"FireRescue":return(0,e.jsx)(Lae,{});case"Police":return(0,e.jsx)(Qae,{});case"LandValue":return(0,e.jsx)(Kae,{});case"Level":return(0,e.jsx)(Wae,{});case"DisasterControl":return(0,e.jsx)(hae,{});case"Tourism":return(0,e.jsx)(rle,{});case"PostService":return(0,e.jsx)(tle,{});case"Population":return(0,e.jsx)(ele,{});case"Extractors":return(0,e.jsx)(zae,{});case"OutsideConnections":return(0,e.jsx)($ae,{});case"Profitability":return(0,e.jsx)(cae,{});case"Workplaces":return(0,e.jsx)(ase,{});case"Happiness":return(0,e.jsx)(Fae,{});default:return null}}(l)}),[l]),c=(0,i.useCallback)((function(){return o()}),[o]),u=(0,i.useMemo)((function(){var e;return l?"".concat(null===(e=TS.value)||void 0===e?void 0:e.infoviewsPanel,"+").concat(l.uiTag):void 0}),[l]);return cu(u,null!=l),(0,e.jsx)(e.Fragment,{children:l&&!a.visible&&(0,e.jsx)(bS,{uiTag:u,children:(0,e.jsx)($r,{focusKey:n,className:Oe()(sse,r),onClose:c,header:(0,e.jsx)(Tl,{icon:null==l?void 0:l.icon,className:lse,children:(0,e.jsx)(Ks.Infoviews.INFOVIEW,{hash:(null==l?void 0:l.id)||""})}),children:(0,e.jsx)(mf,{className:use,children:(0,e.jsx)(wn,{onAction:c,children:(0,e.jsxs)(Fn,{children:[s,l.infomodes.length>0&&(0,e.jsxs)("div",{className:cse,children:[(0,e.jsx)(Goe,{text:(0,e.jsx)(Ks.Infoviews.MAP_LEGEND,{}),uppercase:!0}),(0,e.jsx)(Soe,{}),null==l?void 0:l.infomodes.map((function(t){return(0,e.jsx)(Eoe,{focusKey:t.id,infomode:t},t.id)}))]})]})})})})})})};const fse={button:"button_FBo button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT toggle-states_DTm",icon:"icon_ZjN icon_soN icon_Iwk",locked:"locked_Tjl locked_H2O locked_dBl",item:"item_IYJ",lock:"lock_OBe"};var hse=function(t){var n,r=t.infoview,o=t.selected,a=t.onSelect,l=(0,i.useCallback)((function(){a(o?ii:r.entity),lu(r.uiTag)}),[a,o,r.entity,r.uiTag]);return(0,e.jsx)(bS,{uiTag:r.uiTag,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Infoviews.INFOVIEW,{hash:r.id}),locked:r.locked,requirements:r.requirements,direction:"up",alignment:"end",children:(0,e.jsx)(xl,{focusKey:r.id,src:null!==(n=r.icon)&&void 0!==n?n:"Media/Placeholder.svg",disabled:r.locked,selected:o,theme:fse,onSelect:l,className:Oe()(fse.item,r.locked&&fse.locked),children:r.locked&&(0,e.jsx)(YN,{className:fse.lock})})})})};const mse="infoview-menu_LhU",pse="menu_O_M",vse="content_Hzl",gse="row_B8G";function yse(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bse(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yse(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yse(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xse=new Se("INFOVIEWS"),_se=new Se("ACTIVE_INFOVIEW"),jse=function(t){var n=t.className,r=t.onClose,o=cr(),a=bse((0,i.useState)(!1),2),l=a[0],s=a[1];Jr(!l||!o);var c=C(ai),u=(0,i.useCallback)((function(){null!=c?li(ii):r()}),[c,r]),d=(0,i.useCallback)((function(){return li(ii)}),[]);return(0,e.jsx)(wn,{onAction:u,children:(0,e.jsx)(Jh,{onFocusChange:s,children:(0,e.jsx)(Ze,{focused:null!=c?_se:xse,children:(0,e.jsxs)("div",{className:Oe()(mse,n),children:[(0,e.jsx)(Ese,{focusKey:xse}),(0,e.jsx)(D0,{in:null!=c,children:(0,e.jsx)(dse,{focusKey:_se,onClose:d})})]})})})})},Ese=function(t){var n,r,o,a=t.focusKey,l=t.className;su(null===(n=TS.value)||void 0===n?void 0:n.infoviewsMenu),cu(null===(r=TS.value)||void 0===r?void 0:r.infoviewsMenu);var s,c=C(oi),u=C(ai),d=null!==(s=null==u?void 0:u.id)&&void 0!==s?s:null,f=bse((0,i.useState)(d),2),h=f[0],m=f[1];return(0,i.useEffect)((function(){null!=d&&m(d)}),[d]),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.infoviewsMenu,children:(0,e.jsx)($r,{focusKey:a,transitionSounds:en,className:Oe()(pse,l),contentClassName:vse,children:(0,e.jsxs)(Mn,{focused:h,onChange:m,onRefocus:Rn,children:[(0,e.jsx)("div",{className:gse,children:Ose(c,0,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,1,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,2,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,3,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,4,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,5,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,6,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,7,d)}),(0,e.jsx)("div",{className:gse,children:Ose(c,8,d)})]})})})};function Ose(t,n,r){return t.filter((function(e){return e.group===n})).map((function(t){return(0,e.jsx)(hse,{infoview:t,selected:t.id===r,onSelect:li},t.id)}))}var Tse,Ise="lifePath";!function(e){e.Chirp="chirper.Chirp",e.LogEntry="lifePath.LifePathEvent"}(Tse||(Tse={}));var Sse=E(Ise,"followedCitizens"),wse=T(Ise,"lifePathDetails"),Nse=T(Ise,"lifePathItems"),Pse=E(Ise,"maxFollowedCitizens");const Cse="placeholder-chirp-layout_BAl",Ase="avatar_Cbz",Lse="content_fgv",Mse="header_LnA",Rse="sender_mvI",kse="date_IvA",Dse="message_F8E",Use="word_ift",Fse="footer_jEC",Gse="likes_Bzb";var Vse=[1,4,2,7,3,3,5,4,2,3,4,2,8,5,6,3,1,2,3],Bse=function(t){var n=t.length,r=t.className;return(0,e.jsxs)("div",{className:Oe()(Cse,r),children:[(0,e.jsx)("div",{className:Ase}),(0,e.jsxs)("div",{className:Lse,children:[(0,e.jsxs)("div",{className:Mse,children:[(0,e.jsx)("div",{className:Rse,style:{width:"".concat(25+n%4*6,"%")}}),(0,e.jsx)("div",{className:kse})]}),(0,e.jsx)("div",{className:Dse,children:Array.from(Array(n).keys()).map((function(t,r){return(0,e.jsx)("div",{className:Use,style:{width:"".concat(5*Vse[(t+n)%Vse.length],"%")}},r)}))}),(0,e.jsx)("div",{className:Fse,children:(0,e.jsx)("div",{className:Gse})})]})]})};const Hse="life-path-detail_PR3",Kse="info-column_pYj",Wse="avatar_FMV",zse="name_I32",Yse="age_Wdj",Xse="activity_QvV",qse="status_JZS",$se="status-item_aJC",Qse="status-icon_ftq",Zse="status-label_oIB",Jse="icon-label_HgD",ece="link_Zls",tce="icon_b3A",nce="label_lMl",rce="feed-column_Idv",ice="back-button_HMQ";function oce(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var ace,lce=new Se("FEED"),sce=(oce(ace={},Tse.Chirp,(function(t){return(0,e.jsx)(d7,{focusKey:l(t.entity),children:(0,e.jsx)(c7,{chirp:t})})})),oce(ace,Tse.LogEntry,(function(t){var n=C(Gp);return(0,e.jsx)(f7,{focusKey:l(t.entity),date:Qp(n,t.date),children:(0,e.jsx)(Ss,{id:t.messageId})})})),ace),cce=i.forwardRef((function(t,n){var r,o,a,l,s,c=t.selectedCitizen,u=t.details,d=t.className,f=t.onBack;uu(null===(r=TS.value)||void 0===r?void 0:r.lifePathPanelDetail);var h,m,p,v,g=C(Gp),y=EI(M(Nse,c)),b=pL(null!==(h=null==u?void 0:u.name)&&void 0!==h?h:null),x=pL(null!==(m=null==u?void 0:u.workplaceName)&&void 0!==m?m:null),_=pL(null!==(p=null==u?void 0:u.schoolName)&&void 0!==p?p:null),j=pL(null!==(v=null==u?void 0:u.residenceName)&&void 0!==v?v:null),E=(0,i.useCallback)((function(){return(null==u?void 0:u.entity)&&zq(null==u?void 0:u.entity)}),[u]),O=(0,i.useCallback)((function(){return(null==u?void 0:u.residenceEntity)&&zq(null==u?void 0:u.residenceEntity)}),[u]),T=(0,i.useCallback)((function(){return(null==u?void 0:u.schoolEntity)&&zq(null==u?void 0:u.schoolEntity)}),[u]),I=(0,i.useCallback)((function(){return(null==u?void 0:u.workplaceEntity)&&zq(null==u?void 0:u.workplaceEntity)}),[u]),S=VX(),w=(0,i.useRef)(!0),N=Mr(rp(y,"entity"));(0,i.useEffect)((function(){w.current?w.current=!1:S.smoothScrollTo(0,0)}),[N,S]);var P,A=cr();return(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.lifePathPanelDetail,children:(0,e.jsxs)("div",{ref:n,className:Oe()(Hse,d),children:[(0,e.jsxs)(Fn,{initialFocused:lce,children:[(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:Kse,children:[(0,e.jsx)("div",{className:Wse,style:{backgroundColor:l7(u.randomIndex)},children:(0,e.jsx)("img",{src:null!==(P=u.avatar)&&void 0!==P?P:"Media/Game/Misc/ChirperBlankAvatar.svg"})}),(0,e.jsx)(ml,{className:zse,onSelect:E,children:b}),(0,e.jsx)("div",{className:Yse,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_AGE,{hash:u.age})}),(u.happiness||u.conditions.length>0)&&(0,e.jsxs)("div",{className:qse,children:[u.happiness&&(0,e.jsx)(uce,{icon:u.happiness.iconPath,label:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE,{hash:u.happiness.key})}),u.conditions.length>0?null===(a=u.conditions)||void 0===a?void 0:a.map((function(t){return(0,e.jsx)(uce,{icon:t.iconPath,label:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_CONDITION_TITLE,{hash:t.key})},t.key)})):void 0]}),(0,e.jsx)("div",{className:Xse,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_STATE,{hash:u.state})}),(0,e.jsxs)("div",{className:Jse,children:[(0,e.jsx)(ll,{className:tce,src:"Media/Glyphs/Education.svg"}),(0,e.jsx)("div",{className:nce,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_EDUCATION,{hash:u.education})})]}),(0,e.jsxs)("div",{className:Jse,children:[(0,e.jsx)(ll,{className:tce,src:"Student"===(null==u?void 0:u.occupation)?"Media/Glyphs/School.svg":"Media/Glyphs/Workplace.svg"}),(0,e.jsx)("div",{className:nce,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_OCCUPATION,{hash:u.occupation})})]}),("Student"===(null==u?void 0:u.occupation)||"Worker"===(null==u?void 0:u.occupation))&&(0,e.jsxs)("div",{className:Jse,children:[(0,e.jsx)(ll,{className:tce,src:"Student"===(null==u?void 0:u.occupation)?"Media/Glyphs/School.svg":"Media/Glyphs/Workplace.svg"}),(0,e.jsx)("div",{className:nce,children:(0,e.jsx)(ml,{className:ece,onSelect:"Student"===(null==u?void 0:u.occupation)?T:I,children:"Student"===(null==u?void 0:u.occupation)?_:x})})]}),null!=u.residenceEntity&&(0,e.jsxs)("div",{className:Jse,children:[(0,e.jsx)(ll,{className:tce,src:"Media/Glyphs/Residence.svg"}),(0,e.jsx)("div",{className:nce,children:(0,e.jsx)(ml,{className:ece,onSelect:O,children:j})})]}),(0,e.jsxs)("div",{className:Jse,children:[(0,e.jsx)(ll,{className:tce,src:"Media/Glyphs/Money.svg"}),(0,e.jsx)("div",{className:nce,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WEALTH,{hash:u.wealth})})]})]})}),(0,e.jsx)(bS,{uiTag:null===(l=TS.value)||void 0===l?void 0:l.lifePathPanelChirps,children:(0,e.jsx)(mf,{controller:S,className:rce,children:(0,e.jsxs)(Fn,{focusKey:lce,direction:On.Vertical,children:[(0,e.jsx)(Vh,{components:sce,data:y,keyProvider:Fh}),(0,e.jsx)(d7,{focusKey:Te,style:{opacity:.75},children:(0,e.jsx)(Bse,{length:7})},"placeholder1"),(0,e.jsx)(d7,{focusKey:Te,style:{opacity:.4},children:(0,e.jsx)(Bse,{length:12})},"placeholder2"),(0,e.jsx)(f7,{focusKey:Te,date:$p(g,u.birthDay),children:(0,e.jsx)(Ks.LifePath.CITIZEN_BIRTH,{})},"birth")]})})})]}),f&&!A&&(0,e.jsx)(bS,{uiTag:null===(s=TS.value)||void 0===s?void 0:s.lifePathPanelBackButton,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.LifePath.BACK_BUTTON_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Glyphs/ArrowLeft.svg",className:ice,onSelect:f})})})]})})})),uce=function(t){var n=t.icon,r=t.label;return(0,e.jsxs)("div",{className:$se,children:[(0,e.jsx)("img",{className:Qse,src:n}),(0,e.jsx)("div",{className:Zse,children:r})]})},dce="camera",fce=E(dce,"focusedEntity");function hce(e){N(dce,"focusEntity",e)}const mce="scrollable_ANx",pce="item_nV8",vce="avatar_K_x",gce="main-column_Dzj",yce="name_ALg",bce="description_UGS",xce="action_oRB";function _ce(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var jce=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){_ce(e,t,n[t])}))}return e}({},hl),{hover:null,focus:null}),Ece=i.forwardRef((function(t,n){var r=t.selectedCitizen,i=t.className,o=t.onSelectCitizen,a=C(Sse),s=C(fce);return(0,e.jsx)("div",{ref:n,className:i,children:a.length>0?(0,e.jsx)(mf,{className:mce,children:(0,e.jsx)(Fn,{children:a.map((function(t){return(0,e.jsx)(Oce,{item:t,selected:c(t.entity,r),focused:c(t.entity,s),onSelect:o},l(t.entity))}))})}):(0,e.jsx)(DP,{children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.LifePath.OPENING_MESSAGE,{})})})})})),Oce=function(t){var n,r=t.item,o=t.selected,a=t.focused,l=t.onSelect,s=pL(r.name),c=A(Qn,sr,!1),u=(0,i.useCallback)((function(){Jt(Qt.selectItem),l(r.entity)}),[r.entity,l]),d=(0,i.useCallback)((function(){hce(a?ii:r.entity)}),[a,r.entity]),f=(0,i.useCallback)((function(){return e=r.entity,void N(Ise,"unfollowCitizen",e);var e}),[r.entity]),h=(0,i.useCallback)((function(){Jt(Qt.hoverItem)}),[]),m=(0,i.useMemo)((function(){return{Select:u,"Unfollow Citizen":function(){Jt(Qt.removeItem),f()}}}),[u,f]);return(0,e.jsx)(Tn,{actions:m,children:(0,e.jsxs)(Tr,{className:Oe()(pce,o&&"selected"),onClick:u,onMouseEnter:h,children:[(0,e.jsx)("div",{className:vce,style:{backgroundColor:l7(r.randomIndex)},children:(0,e.jsx)("img",{src:null!==(n=r.avatar)&&void 0!==n?n:"Media/Game/Misc/ChirperBlankAvatar.svg"})}),(0,e.jsxs)("div",{className:gce,children:[(0,e.jsx)("div",{className:yce,children:s}),(0,e.jsx)("div",{className:bce,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_AGE,{hash:r.age})})]}),(c||a)&&(0,e.jsx)(xO,{tooltip:a?(0,e.jsx)(Ks.SelectedInfoPanel.UNFOCUS,{}):(0,e.jsx)(Ks.SelectedInfoPanel.FOCUS,{}),children:(0,e.jsx)(xl,{focusKey:Te,selected:a,src:"Media/Game/Icons/MapMarker.svg",sounds:jce,className:xce,onSelect:d,onClick:Cm})}),c&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.LifePath.UNFOLLOW_BUTTON_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,src:"Media/Game/Icons/Unfollow.svg",sounds:jce,selectSound:Qt.removeItem,className:xce,onSelect:f,onClick:Cm})})]})})};const Tce={"life-path-panel":"life-path-panel_C3E",lifePathPanel:"life-path-panel_C3E",content:"content_auJ","detail-visible":"detail-visible_Hku",detailVisible:"detail-visible_Hku",list:"list_V2f",detail:"detail_H5A",inactive:"inactive_OSs",enter:"enter_w5W","exit-active":"exit-active_c34",exitActive:"exit-active_c34","enter-active":"enter-active_Qj1",enterActive:"enter-active_Qj1",exit:"exit_hrP"};var Ice=new Se("LIST"),Sce=new Se("DETAIL"),wce=function(t){var n,r,i=t.selectedCitizen,o=t.onClose;uu(null===(n=TS.value)||void 0===n?void 0:n.lifePathPanel);var a=M(wse,i),l=null!=a&&!c(i,ii);return(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.lifePathPanel,disableBlinking:!0,children:(0,e.jsx)($r,{theme:B6,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.LifePath.LIST_PANEL_TITLE,{})}),transitionSounds:en,className:Tce.lifePathPanel,contentClassName:Oe()(Tce.content,l&&Tce.detailVisible),onClose:o,children:(0,e.jsx)(wn,{onAction:l?qa:void 0,children:(0,e.jsxs)(Ze,{focused:l?Sce:Ice,children:[(0,e.jsx)(He,{focusKey:Sce,children:(0,e.jsx)(nO,{children:a&&(0,e.jsx)($t,{styles:Tce,children:(0,e.jsx)(cce,{selectedCitizen:i,details:a,className:Tce.detail,onBack:qa})},"detail")})}),(0,e.jsx)(He,{focusKey:Ice,children:(0,e.jsx)(Ece,{selectedCitizen:i,className:Oe()(Tce.list,l&&Tce.inactive),onSelectCitizen:$a})})]})})})})};const Nce="notifications-panel_LaL",Pce="content_QBu",Cce="empty_KiN";var Ace=function(t){var n=t.className,r=t.onClose,i=C(uJ);return(0,e.jsxs)($r,{header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Menu.NOTIFICATIONS_TITLE,{})}),transitionSounds:en,className:Oe()(Nce,n),onClose:r,children:[(0,e.jsx)(mf,{className:Pce,children:(0,e.jsx)(Fn,{children:(0,e.jsx)(nO,{children:i.map((function(t){return(0,e.jsx)(vJ,{item:t},t.id)}))})})}),(0,e.jsx)(D0,{in:!i.length,children:(0,e.jsx)($t,{styles:M0,children:(0,e.jsx)(DP,{className:Cce,children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Menu.NOTIFICATIONS_OPENING_MESSAGE,{})})})})})]})},Lce=["#DF2E3890","#5D9C5990","#0081C990"],Mce=["#DF2E38","#5D9C59","#0081C9"],Rce=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=arguments.length>2?arguments[2]:void 0,r=t.length>1?e:1;return n?Mce[r%Mce.length]:Lce[r%Lce.length]};const kce={hiddenIcon:'"Media/PhotoMode/Dropdown.svg"',visibleIcon:'"Media/PhotoMode/Dropdown.svg"',"dropdown-toggle":"dropdown-toggle_oMB dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_oMB dropdown-toggle_prl",indicator:"indicator_czv","dropdown-menu":"dropdown-menu_m7l dropdown-menu_Swd",dropdownMenu:"dropdown-menu_m7l dropdown-menu_Swd","dropdown-item":"dropdown-item_JVW undefined",dropdownItem:"dropdown-item_JVW undefined"},Dce="cinematic-camera-main-panel_jpU",Uce="curve-editor_Ay4",Fce="curve-editor-wrapper__lJ item-selected_tAM item-focused_FuT",Gce="curve-selector_YdT",Vce="curve-controls_AqW",Bce="toggle_Mkg",Hce="button-panel_UUV",Kce="control-icon-button_ga5 item-states_QjV",Wce="controls-group_nLN",zce="controls-separator_eet",Yce="dropdown-toggle_Fww item-states_QjV",Xce="property-legend_yOI",qce="property-component_Y36 item-states_QjV",$ce="property-component-indicator_TYv";var Qce=function(t){var n,r=t.groupedModifierData,o=t.onSelectProperty,a=t.activePropertyIndex,l=wW(),s=l.selectActiveCurve,c=l.data,u=YB().svg,d=(0,i.useRef)(a),f=(0,i.useRef)(r.length),h=r[a];if((0,i.useEffect)((function(){var e;a!==d.current&&(null==u||null===(e=u.viewport)||void 0===e||e.resetViewport(),s(0),d.current=a)}),[a,s,u]),(0,i.useEffect)((function(){f.current&&f.current!==r.length&&r.length>0&&o(r.length-1),f.current=r.length}),[r.length,o]),!c.curves.length||!h)return null;var m=!!(null==h?void 0:h.children);return(0,e.jsxs)("div",{className:Gce,children:[(0,e.jsx)(fC,{theme:kce,content:r.map((function(t,n){var r=n===a;return(0,e.jsx)(_C,{focusKey:n,value:n,selected:r,onChange:function(){return o(n)},children:(0,e.jsx)(Ks.PhotoMode.PROPERTY_TITLE,{hash:t.id})},n)})),children:(0,e.jsx)(gC,{className:Yce,children:(0,e.jsx)(Ks.PhotoMode.PROPERTY_TITLE,{hash:h.id})})}),m&&(0,e.jsx)("div",{className:Xce,children:null===(n=h.children)||void 0===n?void 0:n.map((function(t,n){return(0,e.jsx)(Zce,{index:n,onSelect:s,id:t.id,color:Rce(n,c.curves,!0)},t.id)}))})]})},Zce=function(t){var n=t.index,r=t.onSelect,o=t.id,a=t.color,l=(0,i.useCallback)((function(){return r(n)}),[n,r]),s=(0,i.useMemo)((function(){return o.endsWith("/r")?"Red":o.endsWith("/g")?"Green":o.endsWith("/b")?"Blue":o.endsWith("/a")?"Alpha":o}),[o]);return(0,e.jsxs)(ml,{className:qce,onSelect:l,children:[(0,e.jsx)("div",{className:$ce,style:{backgroundColor:a}}),(0,e.jsx)(Ks.PhotoMode.PROPERTY_TITLE,{hash:s})]})};function Jce(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function eue(e,t,n,r,i,o,a){try{var l=e[o](a),s=l.value}catch(e){return void n(e)}l.done?t(s):Promise.resolve(s).then(r,i)}function tue(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){eue(o,r,i,a,l,"next",e)}function l(e){eue(o,r,i,a,l,"throw",e)}a(void 0)}))}}function nue(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function rue(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){nue(e,t,n[t])}))}return e}function iue(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function oue(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Jce(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Jce(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var aue=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}},lue=function(){return""},sue={top:50,left:10,right:10,bottom:10},cue=new Se("CINEMATIC CURVE CONTROLS"),uue=new Se("CINEMATIC CURVE EDITOR"),due=function(t){var n=t.label,r=t.modifierData,o=t.canAddKeyframes,a=t.tutorialTag,l=C(qW),s=oue((0,i.useState)(0),2),c=s[0],u=s[1],d=oue((0,i.useState)(0),2),f=d[0],h=d[1],m=C(Jl),p=r.grouped[f],v=(0,i.useMemo)((function(){return p?p.children?p.children.map((function(e){return e.curve})):[p.curve]:[]}),[p]),g="".concat(f,"-").concat(c),y=_Y(v,{minX:0,maxX:l,minY:isFinite(null==p?void 0:p.min)&&(null==p?void 0:p.min)!==(null==p?void 0:p.max)?p.min:void 0,maxY:isFinite(null==p?void 0:p.max)&&(null==p?void 0:p.min)!==(null==p?void 0:p.max)?p.max:void 0,wrapMode:"clamp",hash:g}),b=xz(n,c),x=(0,i.useCallback)((function(e,t){var n=t.time;return n=Math.max(0,n),n=Math.min(l,n),iue(rue({},t),{time:n})}),[l]),_=oue((0,i.useState)(cue),2),j=_[0],E=_[1],O=(0,i.useMemo)((function(){return{"Move Vertical":function(){E((function(e){return e===cue?uue:cue}))}}}),[]),T=(0,i.useCallback)(tue((function(){var e;return aue(this,(function(t){switch(t.label){case 0:return[4,sz()];case 1:return e=t.sent(),[2,{x:e[0],y:e[1]}]}}))})),[]),I=(0,i.useCallback)(tue((function(){var e;return aue(this,(function(t){switch(t.label){case 0:return[4,P(XW,"getControllerPanDelta")];case 1:return e=t.sent(),[2,{x:e[0],y:e[1]}]}}))})),[]),S=(0,i.useCallback)(tue((function(){var e;return aue(this,(function(t){switch(t.label){case 0:return[4,P(XW,"getControllerZoomDelta")];case 1:return e=t.sent(),[2,{x:e,y:e}]}}))})),[]),w=cr();return(0,e.jsx)(bS,{uiTag:a,children:(0,e.jsx)(Tr,{className:Fce,children:(0,e.jsx)(eA,{children:(0,e.jsx)(Tn,{actions:O,children:(0,e.jsx)(Ze,{focused:j,children:(0,e.jsx)(zB,{children:(0,e.jsxs)(SW,iue(rue({data:y,parseKeyframe:x,canAddKeyframes:o,onSetActiveCurve:function(e){u(p.index+e)}},b),{children:[(0,e.jsxs)(Fn,{direction:On.Horizontal,focusKey:cue,children:[(v.length>0||"Position"===n)&&(0,e.jsx)(fue,{label:n,property:p?p.id:""}),(0,e.jsx)(Qce,{activePropertyIndex:f,onSelectProperty:function(e){u(r.grouped[e].index),h(e)},groupedModifierData:r.grouped})]}),(0,e.jsx)(Wz,{zoomable:"y",panable:"y",showTooltipOnDrag:!0,className:Uce,padding:sue,formatLabelX:lue,textScale:m,keyframeMoveCallback:w?T:void 0,panCallback:w?I:void 0,zoomCallback:w?S:void 0,OnFocusChange:cz,focusKey:uue})]}))})})})})})})},fue=function(t){var n,r=t.label,o=t.property,a=wW(),l=a.activeKeyframe,s=a.activeCurve,c=a.removeKeyframe,u=(0,i.useCallback)((function(){c(l,s)}),[c,l,s]),d=(0,i.useCallback)((function(){!function(e,t){N(XW,"captureKey",e,t)}(r,o)}),[r,o]);return(0,e.jsx)("div",{className:Vce,children:(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.cinematicCameraPanelCaptureKey,children:l<0?(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.CAPTURE,{}),children:(0,e.jsx)(xl,{src:"Media/PhotoMode/AddKeyframe.svg",onSelect:d,className:Kce})}):(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.DELETE_KEY,{}),children:(0,e.jsx)(xl,{src:"Media/PhotoMode/DeleteKeyframe.svg",onSelect:u,className:Kce})})})})};const hue="curve-timeline-editor_pYg",mue="wrapper_aL2 item-selected_tAM item-focused_FuT";function pue(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vue(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function gue(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function yue(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return pue(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pue(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bue={left:0,right:0,top:0,bottom:15},xue=function(t){return(0,e.jsx)(yW,{keyframe:t,hide:"value"})},_ue=function(t,n,r){var i=t.data;return(0,e.jsx)("g",{children:(0,e.jsx)(KW,{origin:"center",x:i.time,y:-1.8,fill:"#eee",width:10,height:17,onSelect:n,collisionThreshold:12,children:(0,e.jsx)(KW,{x:i.time,y:-.525,origin:"center",fill:"#eee",width:7.8,height:7.8,transform:"rotate(45)"})})})},jue=function(){var t=C($W),n=C(qW),r=(0,i.useRef)(!1),o=yue((0,i.useState)(),2),a=o[0],l=o[1],s=C(Jl),c=(0,i.useMemo)((function(){return{parseKeyframe:function(e,t){return gue(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){vue(e,t,n[t])}))}return e}({},t),{value:0,time:Math.min(Math.max(t.time,0),n||1)})},emptyString:function(){return""},labelFormatter:function(e){return"".concat(Math.round(10*e)/10,"s")},goToPoint:function(e){var t=e.point;nz(t.x)}}}),[n]),u=c.parseKeyframe,d=c.emptyString,f=c.labelFormatter,h=c.goToPoint,m=(0,i.useCallback)((function(){r.current=!0;var e=function(){r.current=!1,l(void 0),window.removeEventListener("mouseup",e)};window.addEventListener("mouseup",e)}),[]),p=(0,i.useCallback)((function(e){var t=e.point;if(r.current){var i=Math.max(0,Math.min(t.x,n));nz(i),l({time:i})}}),[n]),v=(0,i.useMemo)((function(){return{bounds:{min:{x:0,y:-1},max:{x:n||1,y:1}},curves:[{keys:[{time:t,value:0,inTangent:1/0,outTangent:1/0,inWeight:.33,outWeight:.33,weightedMode:pW.Both}],postWrapMode:vW.Default,preWrapMode:vW.Default}]}}),[n,t]),g=(0,i.useMemo)((function(){return{"Move Horizontal":function(e){var r=at(t+e*(n/30),0,n);nz(r)}}}),[n,t]);return(0,e.jsx)(Tr,{className:mue,children:(0,e.jsx)(eA,{children:(0,e.jsx)(Tn,{actions:g,children:(0,e.jsx)(SW,{data:v,parseKeyframe:u,keyframeRenderer:_ue,children:(0,e.jsx)(Wz,{formatLabelX:f,formatLabelY:d,className:hue,padding:bue,gridLines:!1,onClick:h,showTooltipOnDrag:!0,tooltipKeyframe:a,formatTooltip:xue,onMouseDown:m,onWindowMouseMove:p,textScale:s,children:(0,e.jsx)(WK,{drawAxes:"x"})})})})})})};const Eue="cinematic-camera-slider_yuq",Oue="slider-container_GDX",Tue="value_uvb";var Iue=function(t){var n=t.focusKey,r=t.value,i=t.start,o=t.end,a=t.className,l=t.onChange,s=t.onDragEnd;return(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.SEGMENT_DURATION,{}),children:(0,e.jsxs)(Or,{className:Oe()(Eue,a),children:[(0,e.jsx)("div",{className:Oue,children:(0,e.jsx)(eA,{children:(0,e.jsx)(Fm,{focusKey:n,value:r,start:i,end:o,onChange:l,onDragEnd:s})})}),(0,e.jsxs)("div",{className:Tue,children:[r.toFixed(1),"s"]})]})})},Sue=function(){var t,n,r=C(JW)?"Pause":"Play";return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.cinematicCameraPanelPlay,children:(0,e.jsx)(xl,{src:"Media/PhotoMode/".concat(r,".svg"),className:Kce,onSelect:iz})}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.cinematicCameraPanelStop,children:(0,e.jsx)(xl,{src:"Media/PhotoMode/Stop.svg",className:Kce,onSelect:rz})})]})};const wue={"toggle-field":"toggle-field_UCG",toggleField:"toggle-field_UCG","cinematic-camera-toggle":"cinematic-camera-toggle_sP4",cinematicCameraToggle:"cinematic-camera-toggle_sP4",toggle:"toggle_PDp",checkmark:"checkmark_jEL",label:"label_cwG"},Nue={"toggle-field":"toggle-field_LYp",toggleField:"toggle-field_LYp","cinematic-camera-toggle":"cinematic-camera-toggle_OVw",cinematicCameraToggle:"cinematic-camera-toggle_OVw",toggle:"toggle_kFw",checkmark:"checkmark_zMx",label:"label__3Z"};var Pue=function(t){var n=t.checked,r=t.onChange,i=t.focusKey,o=t.className;return(0,e.jsx)(Or,{className:Oe()(Nue.cinematicCameraToggle,o),children:(0,e.jsx)(pp,{theme:Nue,checked:n,onChange:r,focusKey:i})})},Cue=function(t){var n=t.checked,r=t.onChange,i=t.focusKey,o=t.className;return(0,e.jsx)(Or,{className:Oe()(wue.cinematicCameraToggle,o),children:(0,e.jsx)(pp,{theme:wue,checked:n,onChange:r,focusKey:i})})};function Aue(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Lue(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Mue(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Lue(e,t,n[t])}))}return e}function Rue(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function kue(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Aue(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Aue(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Due=function(e){var t=C(e),n={},r=[],i=Array.isArray(t)?t.reduce((function(e,t,i){var o,a,l=t.id?null===(o=t.id.match(/^(Position|Rotation|(\w|\.)+\/)/))||void 0===o?void 0:o[1]:null;if(l){var s=n[l];n[l]||(s=Rue(Mue({},t),{index:i,children:[],id:l.replace("/","")}),n[l]=s,e.push(n[l])),a=Rue(Mue({},t),{index:i,groupIndex:e.length-1,curveIndex:s.children.length}),s.children.push(a)}else a=Rue(Mue({},t),{index:i,curveIndex:0}),e.push(a);return r.push(a),e}),[]):[];return{grouped:i,flat:r}},Uue=function(t){var n,r,o,a,l,s,c,u=t.toggleSaveLoadPopupVisibility,d=C(qW),f=C(QW),h=C(JW),m=kue((0,i.useState)(!0),2),p=m[0],v=m[1],g=Due(yz),y=Due(bz);M8(h&&p),(0,i.useEffect)((function(){return function(){rz(),g8()}}),[]);var b=(0,i.useMemo)((function(){return{Back:h?function(){rz()}:null}}),[h]);return(0,e.jsx)(Tn,{actions:b,children:(0,e.jsx)(Fn,{direction:On.Vertical,children:(0,e.jsxs)("div",{className:Dce,children:[(0,e.jsx)(Fn,{direction:On.Horizontal,children:(0,e.jsxs)("div",{className:Hce,children:[(0,e.jsxs)("div",{className:Wce,children:[(0,e.jsx)(Sue,{}),(0,e.jsx)("div",{className:zce}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.SAVE_LOAD_TOOLTIP,{}),children:(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.cinematicCameraPanelSaveLoad,children:(0,e.jsx)(xl,{src:"Media/Glyphs/Save.svg",onSelect:u,className:Kce,tinted:!0})})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.RESET_TOOLTIP,{}),children:(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.cinematicCameraPanelReset,children:(0,e.jsx)(xl,{src:"Media/Glyphs/Trash.svg",onSelect:lz,className:Kce,tinted:!0})})})]}),(0,e.jsxs)("div",{className:Wce,children:[(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.HIDE_UI,{}),children:(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.cinematicCameraPanelHideUI,children:(0,e.jsx)(Pue,{className:Bce,checked:p,onChange:v})})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.LOOP,{}),children:(0,e.jsx)(Cue,{className:Bce,checked:f,onChange:ZW})}),(0,e.jsx)(bS,{uiTag:null===(a=TS.value)||void 0===a?void 0:a.cinematicCameraPanelPlaybackDurationSlider,children:(0,e.jsx)(Iue,{label:(0,e.jsx)(Ks.CinematicCamera.PLAYBACK_DURATION,{}),value:d,start:1,end:120,onChange:ez,onDragEnd:tz})})]})]})}),(0,e.jsx)(due,{label:"Position",canAddKeyframes:!0,modifierData:g,tutorialTag:null===(l=TS.value)||void 0===l?void 0:l.cinematicCameraPanelTransformCurves}),(0,e.jsx)(due,{label:"Property",canAddKeyframes:!0,modifierData:y,tutorialTag:null===(s=TS.value)||void 0===s?void 0:s.cinematicCameraPanelPropertyCurves}),(0,e.jsx)(bS,{uiTag:null===(c=TS.value)||void 0===c?void 0:c.cinematicCameraPanelTimelineSlider,children:(0,e.jsx)(jue,{})})]})})})};const Fue="item-picker-section_y66",Gue="panel-content_vkN",Vue="button-row_odR",Bue="input_xwy item-states_QjV",Hue="control-button_t0_ item-states_QjV",Kue="cloud-picker_mqV item-states_QjV",Wue="cloud-picker-dropdown_ibN";function zue(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Yue(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return zue(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zue(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Xue(t){var n=t.onClose,r=C(mz),o=C(hz),a=Yue((0,i.useState)(function(e,t){if(!u(e)){var n=t.findIndex((function(t){return t.guid===e}));return n>=0?n:0}return 0}(null!==o?o.guid:null,r)),2),l=a[0],s=a[1],c=function(e){var t=(0,i.useCallback)((function(t){var n=e[t],r=Nd(n.cloudTarget,n.isReadOnly);return{displayName:Qf(n.name),image:null!=r?r:"",directory:!1,favorite:!1}}),[e]);return{length:e.length,get:t}}(r),d=xs((0,e.jsx)(Ks.CinematicCamera.NEW_SEQUENCE_PLACEHOLDER,{})),f=Yue((0,i.useState)(r.length>l?r[l].name:d),2),h=f[0],m=f[1],p=(0,i.useContext)(Rl),v=C(pz),g=C(vz),y=(0,i.useCallback)((function(e){return m(e.target.value)}),[]),b=(0,i.useCallback)((function(){l>=0&&l<r.length&&p.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.CinematicCamera.UNSAVED_DISCLAIMER,{}),onConfirm:function(){return dz(r[l].guid,r[l].cloudTarget)}}))}),[l,r,p]),x=(0,i.useCallback)((function(){l>=0&&l<r.length&&p.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.CinematicCamera.DELETE_DISCLAIMER,{NAME:r[l].name}),onConfirm:function(){return fz(r[l].guid,r[l].cloudTarget)}}))}),[l,r,p]),_=(0,i.useCallback)((function(){if(!u(h)){var t=r.find((function(e){return!e.isReadOnly&&e.cloudTarget===g&&e.name===h}));t?p.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.CinematicCamera.OVERRIDE_DISCLAIMER,{NAME:h}),onConfirm:function(){return uz(h,t.guid)}})):uz(h,null)}}),[h,r,p,g]),j=(0,i.useCallback)((function(e){s(e),m(r[e].name)}),[r]),E=$E(),O=C(rd);return(0,e.jsx)($r,{onClose:n,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.CinematicCamera.SAVE_LOAD_TOOLTIP,{})}),contentClassName:Gue,allowFocusExit:!0,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(que,{targets:v,selectedTarget:g,onSelectTarget:gz}),(0,e.jsx)(CO,{className:Fue,children:(0,e.jsx)(eA,{children:(0,e.jsx)(fq,{selectedIndex:l,columnCount:1,data:c,onSelect:j,hasImages:!0})})}),(0,e.jsx)(Sp,{value:h,onChange:y,className:Oe()(E.input,Bue)}),(0,e.jsxs)("div",{className:Vue,children:[(0,e.jsx)(xO,{tooltip:O.reasonHash?(0,e.jsx)(Ks.Common.SAVEABILITY_REASON,{hash:O.reasonHash}):(0,e.jsx)(Ks.CinematicCamera.SAVE_TOOLTIP,{}),children:(0,e.jsx)(xl,{src:"Media/Glyphs/Save.svg",onSelect:_,disabled:!O.canSave||u(h),tinted:!0,className:Hue})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.LOAD_TOOLTIP,{}),children:(0,e.jsx)(xl,{src:"Media/Glyphs/School.svg",disabled:l<0||l>=r.length,onSelect:b,tinted:!0,className:Hue})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.DELETE_TOOLTIP,{}),children:(0,e.jsx)(xl,{src:"Media/Glyphs/Trash.svg",disabled:l<0||l>=r.length||r[l].isReadOnly,onSelect:x,tinted:!0,className:Hue})})]})]})})}function que(t){var n=t.targets,r=t.selectedTarget,i=t.onSelectTarget;return(0,e.jsxs)(Or,{className:Kue,children:[(0,e.jsx)("div",{children:(0,e.jsx)(Ks.Menu.CLOUD_TARGET_LABEL,{})}),(0,e.jsx)("div",{className:Wue,children:(0,e.jsx)(fC,{content:n.map((function(t,n){return(0,e.jsx)(_C,{value:t,onChange:i,children:(0,e.jsx)(Ks.Menu.CLOUD_TARGET,{hash:t})},n)})),theme:Jq,children:(0,e.jsx)(gC,{value:r,children:(0,e.jsx)(Ks.Menu.CLOUD_TARGET,{hash:r})})})})]})}const $ue="cinematic-panel-layout_e2g",Que={base:"base_iGt",enter:"enter_F0S","exit-active":"exit-active__9F",exitActive:"exit-active__9F","enter-active":"enter-active_Dkv",enterActive:"enter-active_Dkv",exit:"exit_tDP",wrapper:"wrapper_bAS"};function Zue(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Jue(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Zue(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Zue(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ede=function(t){var n,r,o=t.isVisible,a=t.onClose;su(null===(n=TS.value)||void 0===n?void 0:n.cinematicCameraPanel);var l=Jue((0,i.useState)(!1),2),s=l[0],c=l[1];(0,i.useEffect)((function(){o||c(!1)}),[o]);var u=(0,i.useCallback)((function(){return c((function(e){return!e}))}),[]);return(0,e.jsxs)("div",{className:$ue,children:[(0,e.jsx)(nO,{children:s&&(0,e.jsx)(Xue,{onClose:u},"CinematicCameraSaveLoad")}),(0,e.jsx)(nO,{children:o&&(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.cinematicCameraPanel,children:(0,e.jsx)($r,{transitionSounds:en,onClose:a,transition:Que,allowFocusExit:!0,children:(0,e.jsx)(Uue,{toggleSaveLoadPopupVisibility:u})},"CinematicCameraPanel")})})]},"CinematicCameraLayout")};const tde={field:"field_Y9F undefined",label:"label_6SZ label_eX_"};function nde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function rde(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){nde(e,t,n[t])}))}return e}function ide(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var ode=ide(rde({},hl),{hover:null,focus:null});var ade=function(t){var n=t.theme,r=void 0===n?tde:n,o=t.disabled,a=t.className,l=t.children,s=t.onClick,c=(0,i.useCallback)((function(e){!o&&s&&s(e)}),[o,s]);return(0,e.jsx)(Tr,{focusKey:o?Te:void 0,focusSound:Qt.hoverItem,className:Oe()(r.field,o&&"disabled",a),onClick:c,children:(0,e.jsx)("div",{children:l})})};const lde="container_eL2",sde="dropdown_pJu item-states_QjV";function cde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ude(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){cde(e,t,n[t])}))}return e}function dde(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function fde(t){var n=t.items.findIndex((function(e){return f(e.value,t.value)})),r=-1!==n?t.items[n]:null,i=xh(Ih,Mh(t.parent,t.path));return(0,e.jsx)(ade,dde(ude({},t.props),{className:lde,children:(0,e.jsx)(fC,{focusKey:t.props.disabled?Te:Ie,initialFocused:n,theme:jC,content:t.items.filter((function(e,t){return!e.disabled&&(0!==t||0===n)})).map((function(t,n){return(0,e.jsx)(_C,{focusKey:n,value:t.value,selected:!!r&&f(r.value,t.value),onChange:i,children:hde(t)},n)})),children:(0,e.jsx)(gC,{disabled:t.props.disabled,sounds:ode,className:sde,children:hde(r)})})}))}function hde(t){return t?(0,e.jsx)(ph,{value:t.displayName}):null}const mde="row_l3P",pde="input_JvC item-states_QjV";var vde=function(t){var n=t.disabled,r=t.children;return(0,e.jsx)(Tr,{focusKey:n?Te:Ie,children:r})},gde=function(t){var n=t.disabled,r=t.children;return(0,e.jsx)(Tr,{focusKey:n?Te:Ie,children:r})};const yde="game-icon-button-group_RE4",bde="button_C2v";function xde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _de(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xde(e,t,n[t])}))}return e}var jde=function(t){var n=t.parent,r=t.path,i=t.props,o=xh(Th,Mh(n,r));return(0,e.jsx)(xO,{tooltip:null!=i.tooltip?(0,e.jsx)(ph,{value:i.tooltip}):null,children:(0,e.jsx)(bS,{uiTag:i.tutorialTag||void 0,children:(0,e.jsx)(Ode,{src:i.icon,selected:i.selected,disabled:i.disabled,onSelect:o})})})},Ede=function(t){var n=t.children;return(0,e.jsx)("div",{className:yde,children:n})},Ode=function(t){var n=t.src,r=t.selected,i=t.disabled,o=t.className,a=t.onSelect;return(0,e.jsx)(xl,{tinted:!0,src:n,selected:r,disabled:i,theme:loe,className:Oe()(bde,o),onSelect:a})};const Tde="toggle-field_D6P",Ide="toggle_CGE";function Sde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function wde(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}const Nde="container_HLA",Pde="group_CmM",Cde="title_vqR",Ade="group-title_vnJ",Lde="children_wvV",Mde="draggable__cr",Rde="before-title-group_JPn",kde="active_ZKV",Dde="tooltip_mo_",Ude="tooltip-content_Eri",Fde="tooltip-content-row_aco";function Gde(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Vde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Bde(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Gde(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Gde(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Hde(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Kde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Wde(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Kde(e,t,n[t])}))}return e}function zde(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Yde(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Hde(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Hde(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Xde=1e4,qde=function(e,t){return[isFinite(e)?e:Math.sign(e)*Xde,isFinite(t)?t>e?t:Xde:Math.sign(t)*Xde]},$de=function(e,t){return Math.pow(Math.abs(e)/t,3)};var Qde=function(t){var n=t.parent,r=t.path,i=t.props,o=t.dragTransformation,a=xh(Ih,Mh(n,r)),l=(0,e.jsx)(iY,{className:Mde,value:i.value,disabled:i.disabled,dragTransformation:o,onChange:a}),s=(0,e.jsx)(ph,{value:i.displayName}),c=i.tooltip&&(0,e.jsx)(ph,{value:i.tooltip}),u=(0,e.jsx)(Zde,{min:i.min,max:i.max,fractionDigits:0});return s||c||u?(0,e.jsx)(jL,{alignment:"start",direction:"left",title:s,description:c,content:u,className:Dde,children:l}):l};function Zde(t){var n=t.min,r=t.max,i=t.fractionDigits,o=isFinite(n),a=isFinite(r)&&(r>n||!o);return o||a?(0,e.jsxs)("div",{className:Ude,children:[o&&(0,e.jsxs)("div",{className:Fde,children:[(0,e.jsx)("div",{children:(0,e.jsx)(Ks.PhotoMode.PROPERTY_LIMIT_MIN,{})}),(0,e.jsx)("div",{children:n.toFixed(i)})]}),a&&(0,e.jsxs)("div",{className:Fde,children:[(0,e.jsx)("div",{children:(0,e.jsx)(Ks.PhotoMode.PROPERTY_LIMIT_MAX,{})}),(0,e.jsx)("div",{children:r.toFixed(i)})]})]}):null}function Jde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var efe,tfe=function(t){var n=t.displayName,r=t.parent,o=t.data,a=(0,i.useContext)(dr).scrollTo;return(0,i.useEffect)((function(){a(0,0)}),[n,a]),(0,e.jsx)(Yh,{parent:r,components:nfe,data:o},n)},nfe=(Jde(efe={},hh.Group,(function(t){var n,r=t.parent,o=t.path,a=t.children,l=t.props,s=Mh(r,o),c=(0,i.useContext)(Xh),u=!1,d=Bde(a.reduce((function(e,t){var n,r,i="Game.UI.Widgets.IconButton"===t.props.__Type,o="Game.UI.Widgets.ToggleField"===t.props.__Type&&t.path<2;i||o?("PhotoMode.ENABLE_PROPERTY_TOOLTIP"===(null===(n=t.props)||void 0===n||null===(r=n.tooltip)||void 0===r?void 0:r.id)&&(u=!!t.props.value),e[0].push(t)):e[1].push(t);return e}),[[],[]]),2),f=d[0],h=d[1],m=(0,e.jsx)(ph,{value:l.displayName}),p=l.tooltip&&(0,e.jsx)(ph,{value:l.tooltip});return(0,e.jsx)(Or,{className:Oe()(Nde,(n={},Vde(n,kde,u),Vde(n,Pde,!h.length),n)),children:(0,e.jsx)(Fn,{direction:On.Horizontal,children:(0,e.jsxs)("div",{className:Lde,children:[!!f.length&&(0,e.jsx)("div",{className:Rde,children:(0,e.jsx)(Yh,{parent:s,components:c,data:f})}),(0,e.jsx)(jL,{alignment:"start",direction:"left",title:m,description:p,className:Dde,children:(0,e.jsx)("div",{className:Oe()(Cde,Vde({},Ade,!h.length)),children:m})}),(0,e.jsx)(Yh,{parent:s,components:c,data:h})]})})})})),Jde(efe,hh.FloatSliderField,(function(t){var n=Yde((0,i.useMemo)((function(){return qde(t.props.min,t.props.max)}),[t.props.min,t.props.max]),2),r=n[0],o=n[1],a=(0,i.useCallback)((function(e,t){return at(e+(t<0?r-e:o-e)*$de(t,.1),r,o)}),[r,o]);return(0,e.jsx)(Qde,zde(Wde({},t),{dragTransformation:a}))})),Jde(efe,hh.IntSliderField,(function(t){var n=Yde((0,i.useMemo)((function(){return qde(t.props.min,t.props.max)}),[t.props.min,t.props.max]),2),r=n[0],o=n[1],a=(0,i.useCallback)((function(e,t){return at(e+(t<0?r-e:o-e)*$de(t,.1),r,o)}),[r,o]);return(0,e.jsx)(Qde,zde(Wde({},t),{dragTransformation:a}))})),Jde(efe,hh.ToggleField,(function(t){var n=xh(Ih,Mh(t.parent,t.path)),r=(0,i.useCallback)((function(){n(!t.props.value)}),[n,t.props.value]);return(0,e.jsx)(ade,wde(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Sde(e,t,n[t])}))}return e}({},t.props),{onClick:r,children:(0,e.jsx)(bS,{uiTag:t.props.tutorialTag||void 0,active:!t.props.disabled,children:(0,e.jsx)("div",{className:Tde,children:(0,e.jsx)(xO,{tooltip:t.props.tooltip&&(0,e.jsx)(ph,{value:t.props.tooltip}),children:(0,e.jsx)(pp,{checked:t.props.value,className:Ide,onChange:n,disabled:t.props.disabled})})})})}))})),Jde(efe,hh.IconButton,(function(t){return(0,e.jsx)(Ede,{children:(0,e.jsx)(jde,_de({},t))})})),Jde(efe,T8.DropdownField,(function(t){return(0,e.jsx)(fde,ude({items:t.props.items,value:t.props.value},t))})),Jde(efe,hh.FloatInputField,(function(t){var n=xh(Ih,Mh(t.parent,t.path));return(0,e.jsx)(vde,{disabled:t.props.disabled||!1,children:(0,e.jsx)("div",{className:"".concat(mde," row-number-input"),children:(0,e.jsx)(qD,{value:t.props.value,min:t.props.min,max:t.props.max,fractionDigits:t.props.fractionDigits,disabled:t.props.disabled,className:pde,onChange:n})})})})),Jde(efe,hh.IntInputField,(function(t){var n=xh(Ih,Mh(t.parent,t.path));return(0,e.jsx)(gde,{disabled:t.props.disabled||!1,children:(0,e.jsx)("div",{className:"".concat(mde," row-number-input"),children:(0,e.jsx)(tU,{value:t.props.value,min:t.props.min,max:t.props.max,disabled:t.props.disabled,className:pde,onChange:n})})})})),Jde(efe,hh.EnumField,(function(t){return(0,e.jsx)(fde,ude({items:t.props.enumMembers,value:t.props.value},t))})),Jde(efe,hh.ColorField,(function(t){var n=xh(Ih,Mh(t.parent,t.path));return(0,e.jsx)(jF,{value:t.props.value,onChange:n,disabled:t.props.disabled,alpha:t.props.showAlpha,popupDirection:"up"})})),efe);const rfe="title_Rbz",ife="panel-title-bar_Vge",ofe="photo-mode-panel_oo_",afe="simulation-warning_t8O",lfe="scrollable_eMn",sfe="button-panel_dnD",cfe="cinematic-camera-button_ctq item-states_QjV",ufe="tab-bar_wDc",dfe="tabs_asW",ffe="tab-button_D0T";var hfe=function(t){var n,r,o,a,l,s,c=t.onClose,u=C(N8),d=C(I8),f=C(JW),h=Lh(v8),m=C(x8);uu(null===(n=TS.value)||void 0===n?void 0:n.photoModePanel);var p=C(S8),v=C(w8),g=(0,i.useCallback)((function(e){return E8(e)}),[]),y=(0,i.useCallback)((function(e){var t=p.findIndex((function(e){return e.id===v}));if(t>=0){var n=(t+e)%p.length;E8(p[n<0?n+p.length:n].id)}else E8(p[p.length-1].id)}),[v,p]),b=(0,i.useCallback)((function(){O8(!d)}),[d]),x=(0,i.useCallback)((function(){O8(!1)}),[]),_=(0,i.useCallback)((function(){f?rz():d?x():c()}),[d,x,c,f]);(0,i.useEffect)((function(){return b8(!0),function(){g8(),b8(!1)}}),[]);var j=d?"ExpandRight":"ExpandLeft",E=(0,i.useMemo)((function(){return function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({"Switch Tab":y},d?"Photo Mode":"Cinematic Mode",b)}),[d,y,b]);return(0,e.jsx)(wn,{onAction:_,children:(0,e.jsx)(Tn,{actions:E,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(ede,{isVisible:d,onClose:x}),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.photoModePanel,children:(0,e.jsx)($r,{transitionSounds:en,className:rfe,onClose:_,allowFocusExit:!0,header:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.photoModePanelTitle,children:(0,e.jsx)(Tl,{className:ife,children:d?(0,e.jsx)(Ks.CinematicCamera.TITLE,{}):(0,e.jsx)(Ks.PhotoMode.TITLE,{})})}),(0,e.jsx)("div",{className:ufe,children:(0,e.jsxs)("div",{className:dfe,children:[(0,e.jsx)(AG,{children:p.map((function(t,n){var r;return(0,e.jsx)(mfe,{id:t.id,icon:t.icon,tooltip:(0,e.jsx)(Ks.PhotoMode.TAB,{hash:t.id}),selected:t.id===v,onSelect:g,tutorialTag:0===n?null===(r=TS.value)||void 0===r?void 0:r.photoModeTab:void 0},n)}))}),(0,e.jsx)(bS,{uiTag:null===(a=TS.value)||void 0===a?void 0:a.photoModeCinematicCameraToggle,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.CinematicCamera.TITLE,{}),children:(0,e.jsx)(xl,{src:"Media/PhotoMode/".concat(j,".svg"),onSelect:b,className:cfe})})})]})})]}),children:(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:ofe,children:["Environment"===v&&(0,e.jsx)("div",{className:afe,children:(0,e.jsx)(Ks.PhotoMode.ENVIRONMENT_DISCLAIMER,{})}),(0,e.jsx)(mf,{className:lfe,children:null!=u&&(0,e.jsx)(tfe,{displayName:v,parent:h,data:u})}),(0,e.jsx)("div",{className:sfe,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(bS,{uiTag:null===(l=TS.value)||void 0===l?void 0:l.photoModePanelTakePicture,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.PhotoMode.TAKE_PHOTO,{}),children:(0,e.jsx)(xl,{tinted:!0,theme:loe,src:"Media/PhotoMode/TakePicture.svg",onSelect:j8,selectSound:Qt.takePhoto})})}),(0,e.jsx)(bS,{uiTag:null===(s=TS.value)||void 0===s?void 0:s.photoModePanelHideUI,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.PhotoMode.HIDE_UI,{}),children:(0,e.jsx)(xl,{tinted:!0,theme:loe,src:"Media/PhotoMode/HideUIOn.svg",onSelect:Aa})})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.PhotoMode.TOGGLE_ORBIT_MODE,{}),children:(0,e.jsx)(xl,{tinted:!0,theme:loe,selected:m,src:"Media/Game/Icons/Orbit.svg",onSelect:_8})})]})})]})})})})]})})})},mfe=function(t){var n=t.id,r=t.icon,o=t.tooltip,a=t.selected,l=t.disabled,s=t.className,c=t.onSelect,u=t.tutorialTag,d=(0,i.useCallback)((function(){return c(n)}),[n,c]),f=(0,i.useMemo)((function(){return"PhotoModeTab+"+n}),[n]);return(0,e.jsx)(xO,{tooltip:o,children:(0,e.jsx)(bS,{uiTag:u,children:(0,e.jsx)(bS,{uiTag:f,children:(0,e.jsx)(xl,{src:r,disabled:l,selected:a,className:Oe()(s,ffe),onSelect:d})})})})},pfe="achievements",vfe=E(pfe,"showAchievementsTab"),gfe=E(pfe,"achievements");const yfe={"progress-bar":"progress-bar_VAk",progressBar:"progress-bar_VAk","progress-bounds":"progress-bounds_aKD",progressBounds:"progress-bounds_aKD",progress:"progress_gG0",label:"label_D0Y","progress-label":"progress-label_SHL",progressLabel:"progress-label_SHL"},bfe="achievement_BUQ item-states_QjV",xfe="content_n2n",_fe="left_tyE",jfe="right_wLd",Efe="icon_fbN",Ofe="locked_tfQ",Tfe="label_hdQ",Ife="progress-bar_MqT";var Sfe=function(t){var n=t.achievement,r=t.selected,o=t.onHover,a=t.onSelect,l=(0,i.useCallback)((function(){return o(n)}),[o,n]),s=(0,i.useCallback)((function(){return Jt(Qt.hoverItem)}),[]),c=(0,i.useCallback)((function(){return o(null)}),[o]),u=(0,i.useCallback)((function(e){e&&(a(n),Jt(Qt.hoverItem))}),[n,a]),d=(0,i.useCallback)((function(){a(n),Jt(Qt.selectItem)}),[n,a]);return(0,e.jsx)(Tr,{onClick:d,onMouseOver:l,onMouseEnter:s,onMouseLeave:c,onFocusChange:u,className:Oe()(bfe,r&&"selected",n.locked&&Ofe),children:(0,e.jsxs)("div",{className:xfe,children:[(0,e.jsxs)("div",{className:_fe,children:[(0,e.jsx)("img",{className:Efe,src:n.imagePath}),(0,e.jsx)("div",{className:Tfe,children:(0,e.jsx)(Ks.Achievements.TITLE,{hash:n.localeKey})})]}),(0,e.jsx)("div",{className:jfe,children:n.isIncremental&&(0,e.jsx)(lne,{theme:yfe,className:Ife,progress:n.locked?n.progress:n.maxProgress,max:n.maxProgress,children:(0,e.jsx)(ah,{value:n.locked?n.progress:n.maxProgress,total:n.maxProgress,unit:tc.Integer})})})]})})};const wfe="achievements-page_jWM",Nfe="main-column_tzh",Pfe="info-column_Ufp",Cfe="scrollable_AyZ";function Afe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Lfe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Afe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Afe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Mfe=function(){var t=C(gfe),n=Lfe((0,i.useState)(t[0]),2),r=n[0],o=n[1],a=Lfe((0,i.useState)(null),2),l=a[0],s=a[1],c=(0,i.useMemo)((function(){return null!=l?l:r}),[l,r]);return(0,e.jsxs)("div",{className:wfe,children:[(0,e.jsx)(CO,{theme:IO,className:Nfe,children:(0,e.jsx)(mf,{className:Cfe,children:(0,e.jsx)(Fn,{children:t.map((function(t){return(0,e.jsx)(Sfe,{selected:r.localeKey===t.localeKey,achievement:t,onSelect:o,onHover:s},t.localeKey)}))})})}),(0,e.jsx)(Rfe,{achievement:c})]})},Rfe=function(t){var n=t.achievement;return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Pfe,children:n&&(0,e.jsx)(P7,{icon:n.imagePath,title:(0,e.jsx)(Ks.Achievements.TITLE,{hash:n.localeKey}),description:(0,e.jsx)(Ks.Achievements.DESCRIPTION,{hash:n.localeKey})})})};function kfe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Dfe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return kfe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return kfe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ufe=(0,i.createContext)({onItemMouseOver:function(){},onItemMouseLeave:function(){},onItemSelect:function(){},clear:function(){}});function Ffe(e,t){return"number"==typeof e||"number"==typeof t?e===t:c(e,t)}function Gfe(e){return"number"==typeof e?e:l(e)}function Vfe(e){return 0===e?0:s(e)}const Bfe="milestone-detail-header_CQr",Hfe="progress-bar_jbW",Kfe="subtitle_qwG",Wfe="title_oo7",zfe="rewards_du7",Yfe="reward-field_SPU";function Xfe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function qfe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Xfe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Xfe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var $fe=function(t){var n,r,i,o=t.details;return(0,e.jsx)(Or,{className:Bfe,style:{backgroundImage:o.image?"url(".concat(o.image,")"):void 0,backgroundColor:pm(o.backgroundColor),color:pm(o.textColor)},children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(Zfe,{xpRequirement:o.xpRequirement}),(0,e.jsx)("div",{className:Kfe,children:(0,e.jsx)(Ks.Progression.MILESTONE_DETAIL_SUBTITLE,{INDEX:(0,e.jsx)(dc,{value:o.index,unit:tc.Integer})})}),(0,e.jsx)("div",{className:Wfe,children:(0,e.jsx)(Ks.Progression.MILESTONE_NAME,{index:o.index})}),(0,e.jsxs)("div",{className:zfe,children:[o.reward>0&&(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.progressionPanelMilestoneRewardsMoney,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Progression.TOOLTIP_TITLE_MONEY,{}),description:(0,e.jsx)(Ks.Progression.TOOLTIP_DESCRIPTION_MONEY,{}),children:(0,e.jsx)(E1,{focusable:!0,icon:"Media/Game/Icons/Money.svg",className:Yfe,children:(0,e.jsx)(dc,{value:o.reward,unit:tc.Money})})})}),o.devTreePoints>0&&(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.progressionPanelMilestoneRewardsDevPoints,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Progression.TOOLTIP_TITLE_POINTS,{}),description:(0,e.jsx)(Ks.Progression.TOOLTIP_DESCRIPTION_POINTS,{}),children:(0,e.jsx)(E1,{focusable:!0,icon:"Media/Game/Icons/DevPoint.svg",className:Yfe,children:(0,e.jsx)(dc,{value:o.devTreePoints,unit:tc.Integer,signed:!0})})})}),o.mapTiles>0&&(0,e.jsx)(bS,{uiTag:null===(i=TS.value)||void 0===i?void 0:i.progressionPanelMilestoneRewardsMapTiles,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Progression.TOOLTIP_TITLE_EXPANSION_PERMITS,{}),description:(0,e.jsx)(Ks.Progression.TOOLTIP_DESCRIPTION_EXPANSION_PERMITS,{}),children:(0,e.jsx)(E1,{focusable:!0,icon:"Media/Game/Icons/ExpansionPermit.svg",className:Yfe,children:(0,e.jsx)(dc,{value:o.mapTiles,unit:tc.Integer,signed:!0})})})})]})]})})},Qfe={tension:150,friction:20},Zfe=function(t){var n,r=t.xpRequirement,o=C(C3),a=at(o,0,r),l=at(V$(Qfe,o),0,r),s=qfe((0,i.useState)(!1),2),c=s[0],u=s[1];return(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.progressionPanelMilestoneXP,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_XP,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_XP,{}),children:(0,e.jsx)(Jh,{onFocusChange:u,children:(0,e.jsx)(Tr,{children:(0,e.jsx)(lne,{progress:l,max:r,theme:yfe,className:Oe()(Hfe,c&&"focused"),children:(0,e.jsx)(ah,{value:a,total:r,unit:tc.XP})})})})})})};const Jfe="unlock-item_cKn item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT item-states_QjV",ehe="icon_dN7",the="small_cfi",nhe="title_tnS";function rhe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ihe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var ohe=function(t){var n=t.id,r=t.selected,o=t.small,a=t.icon,l=t.title,s=t.children,c=function(e,t){var n=(0,i.useContext)(e);return(0,i.useMemo)((function(){return{onMouseOver:function(){return n.onItemMouseOver(t)},onMouseLeave:function(){return n.onItemMouseLeave(t)},onClick:function(){return n.onItemSelect(t)}}}),[n,t])}(Ufe,n);return(0,e.jsxs)(ml,ihe(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){rhe(e,t,n[t])}))}return e}({focusKey:Gfe(n),selected:r,className:Oe()(Jfe,o&&the)},c),{children:[(0,e.jsx)("div",{className:ehe,children:(0,e.jsx)("img",{src:a})}),(0,e.jsx)("div",{className:nhe,children:l}),s]}))};const ahe="milestone-detail_kYc",lhe="scrollable_uML",she="badge_Dd7",che="theme_CAs",uhe="theme-icon_c1W";function dhe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fhe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var hhe,mhe,phe=new Se("UnlocksList"),vhe=function(t){var n,r=t.details,o=t.unlocks,a=t.selectedUnlock,l=t.className,s=BN(Vfe,(0,i.useContext)(Ufe).onItemSelect);return(0,e.jsx)(CO,{theme:IO,className:Oe()(ahe,l),children:(0,e.jsxs)(Fn,{initialFocused:phe,children:[null!=r&&(0,e.jsx)($fe,{details:r}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.progressionPanelMilestoneRewards,children:(0,e.jsx)(mf,{className:lhe,children:(0,e.jsxs)(Mn,{focusKey:phe,focused:null!=a?Gfe(a):null,direction:On.Vertical,onChange:s,onRefocus:Rn,children:[r&&r.loanLimit>0&&(0,e.jsx)(yhe,{loanLimit:r.loanLimit,selected:Ffe(a,0)}),(0,e.jsx)(Vh,{components:ghe,data:o,props:{selectedUnlock:a}})]})})})]})})},ghe=(dhe(mhe={},T3.Feature,(function(t){var n=t.selectedUnlock,r=fhe(t,["selectedUnlock"]);return(0,e.jsx)(bhe,{entity:r.entity,icon:r.icon,title:(0,e.jsx)(Ks.Assets.NAME,{hash:r.name}),devTreeUnlocked:!1,selected:Ffe(r.entity,n)})})),dhe(mhe,T3.Policy,(function(t){var n=t.selectedUnlock,r=fhe(t,["selectedUnlock"]);return(0,e.jsx)(bhe,{entity:r.entity,icon:r.icon,title:(0,e.jsx)(Ks.Policy.TITLE,{hash:r.name}),devTreeUnlocked:!1,selected:Ffe(r.entity,n)})})),dhe(mhe,T3.Service,(function(t){var n=t.selectedUnlock,r=fhe(t,["selectedUnlock"]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(bhe,{entity:r.entity,icon:r.icon,title:(0,e.jsx)(Ks.Services.NAME,{hash:r.name}),devTreeUnlocked:null!==(hhe=r.devTreeUnlocked)&&void 0!==hhe&&hhe,selected:Ffe(r.entity,n)}),r.assets.map((function(t){return(0,e.jsx)(xhe,{item:t,selected:Ffe(t.entity,n)},l(t.entity))}))]})})),dhe(mhe,T3.Zone,(function(t){var n=t.selectedUnlock,r=fhe(t,["selectedUnlock"]);return(0,e.jsx)(xhe,{zone:!0,item:r,selected:Ffe(r.entity,n)})})),mhe),yhe=function(t){var n=t.loanLimit,r=t.selected;return(0,e.jsx)(ohe,{id:0,icon:"Media/Game/Icons/Money.svg",title:(0,e.jsx)(Ks.Progression.LOAN_LIMIT,{}),selected:r,children:(0,e.jsx)("div",{className:she,children:(0,e.jsx)(dc,{value:n,unit:tc.Money,signed:!0})})})},bhe=function(t){var n=t.entity,r=t.icon,i=t.title,o=t.devTreeUnlocked,a=t.selected;return(0,e.jsx)(ohe,{id:n,selected:a,icon:r,title:i,children:o&&(0,e.jsx)("div",{className:she,children:(0,e.jsx)(Ks.Progression.DEV_TREE_UNLOCK_BADGE,{})})})},xhe=function(t){var n=t.item,r=t.selected,i=t.zone,o=C(ES).filter((function(e){return n.themes.some((function(t){return c(t,e.entity)}))}));return(0,e.jsx)(ohe,{small:!i,id:n.entity,selected:r,icon:n.icon,title:(0,e.jsx)(Ks.Assets.NAME,{hash:n.name}),children:o.map((function(t){return(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Assets.THEME,{hash:t.name}),children:(0,e.jsx)("div",{className:che,children:(0,e.jsx)("img",{src:t.icon,className:uhe})})},l(t.entity))}))})};const _he="milestone-list_tfM",jhe="scrollable_UGT",Ehe="item_LnT item-states_QjV",Ohe="circle-layout_Xmw",The="line_jbQ",Ihe="unlocked_gJI",She="first_JVl",whe="last_gAq",Nhe="circle_yGr",Phe="major_RSg",Che="title_UOA";function Ahe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Lhe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Mhe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Rhe=function(t){var n,r=t.selectedMilestone,o=t.className,a=t.onSelectMilestone,s=HN(a),u=C(M3),d=(0,i.useRef)(null),f=VX();return(0,i.useEffect)((function(){window.requestAnimationFrame((function(){null!=d.current&&f.scrollIntoView(d.current)}))}),[f]),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.progressionPanelMilestonesList,children:(0,e.jsx)(CO,{theme:IO,className:Oe()(_he,o),children:(0,e.jsx)(mf,{className:jhe,controller:f,children:(0,e.jsx)(Mn,{focused:l(r),direction:On.Vertical,onChange:s,children:u.map((function(t,n){return(0,e.jsx)(khe,{ref:u.length>n+1&&!u[n+1].locked?d:void 0,milestone:t,nextUnlocked:u.length>n+1&&!u[n+1].locked,selected:c(t.entity,r),first:0===n,last:u.length===n+1,onSelect:a},l(t.entity))}))})})})})},khe=i.forwardRef((function(t,n){var r=t.milestone,o=t.nextUnlocked,a=t.selected,s=t.first,c=t.last,u=t.onSelect,d=Mhe(t,["milestone","nextUnlocked","selected","first","last","onSelect"]),f=(0,i.useCallback)((function(){return u(r.entity)}),[r.entity,u]);return(0,e.jsxs)(ml,Lhe(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Ahe(e,t,n[t])}))}return e}({ref:n,focusKey:l(r.entity),selected:a,className:Oe()(Ehe,r.major&&Phe,!r.locked&&Ihe),onClick:f},d),{children:[(0,e.jsxs)("div",{className:Ohe,children:[(0,e.jsx)("div",{className:Oe()(The,!r.locked&&Ihe,s&&She)}),(0,e.jsx)("div",{className:Nhe}),(0,e.jsx)("div",{className:Oe()(The,o&&Ihe,c&&whe)})]}),(0,e.jsx)("div",{className:Che,children:(0,e.jsx)(Ks.Progression.MILESTONE_NAME,{index:r.index})})]}))})),Dhe=function(t){var n=t.id,r=t.milestoneDetails,i=t.className;return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:i,children:Uhe(n,r)})};function Uhe(t,n){return 0===t?(0,e.jsx)(Ghe,{milestoneDetails:n}):null!=t?(0,e.jsx)(Fhe,{entity:t}):null}var Fhe=function(t){var n=t.entity,r=M(F3,n);return null!=r?(0,e.jsx)(P7,{icon:r.icon,title:(0,e.jsx)(Ss,{id:r.titleId}),description:(0,e.jsx)(Ss,{id:r.descriptionId}),children:(0,e.jsx)(M7,{state:r.locked?"Locked":"Unlocked"})}):null},Ghe=function(t){var n=t.milestoneDetails;return(0,e.jsx)(P7,{icon:"Media/Game/Icons/Money.svg",title:(0,e.jsx)(Ks.Progression.LOAN_LIMIT,{}),description:(0,e.jsx)(Ks.EconomyPanel.LOAN_PAGE_DESCRIPTION,{}),children:(0,e.jsx)(M7,{state:(null==n?void 0:n.locked)?"Locked":"Unlocked"})})};const Vhe="milestone-page_dL2",Bhe="milestone-list_C7c",Hhe="milestone-detail_zdr",Khe="unlock-detail_LWQ";function Whe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zhe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Whe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Whe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Yhe=function(){var t;uu(null===(t=TS.value)||void 0===t?void 0:t.progressionPanelMilestonesPage);var n=zhe((0,i.useState)(Xhe),2),r=n[0],o=n[1],a=zhe(function(e){var t=Dfe((0,i.useState)(null),2),n=t[0],r=t[1],o=Dfe((0,i.useState)(null),2),a=o[0],l=o[1],s=cr();return[(0,i.useMemo)((function(){return{onItemMouseOver:function(e){return r(e)},onItemMouseLeave:function(t){return r((function(n){return null===n||e(t,n)?null:n}))},onItemSelect:function(e){return l(e)},clear:function(){r(null),l(null)}}}),[e]),a,s?a:null!=n?n:a]}(Ffe),3),s=a[0],c=a[1],u=a[2],d=M(D3,r),f=M(U3,r),h=(0,i.useCallback)((function(e){o(e),s.clear()}),[s]);return(0,e.jsxs)("div",{className:Vhe,children:[(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)(Rhe,{selectedMilestone:r,onSelectMilestone:h,className:Bhe}),(0,e.jsx)(Ufe.Provider,{value:s,children:(0,e.jsx)(vhe,{details:d,unlocks:f,selectedUnlock:c,className:Hhe},l(r))})]}),(0,e.jsx)(Dhe,{id:u,milestoneDetails:d,className:Khe})]})};function Xhe(){var e=M3.value;if(0===e.length)return ii;var t=e.findIndex((function(e){return e.locked}));return e[t>1?t-1:-1===t?e.length-1:0].entity}var qhe="devTree",$he=E(qhe,"points"),Qhe=E(qhe,"services"),Zhe=T(qhe,"serviceDetails"),Jhe=T(qhe,"nodes"),eme=T(qhe,"nodeDetails"),tme=O(ii),nme=O(ii);function rme(e){N(qhe,"purchaseNode",e)}const ime="dev-tree-node-detail_k9G",ome="content_w8i",ame="button_cM0",lme="button-label_mXV",sme="cost_DHr",cme="cost-dp-icon_C7u",ume="unlock-hint_PFh",dme="points-display_S2s",fme="points-icon_f8_",hme="points-value_cTm";var mme=function(t){var n,r=t.node,o=t.className,a=M(eme,r),l=C($he),s=(0,i.useCallback)((function(){var e,t;rme(r),(null===(e=TS.value)||void 0===e?void 0:e.progressionPanelDevelopmentUnlockNode)&&lu(null===(t=TS.value)||void 0===t?void 0:t.progressionPanelDevelopmentUnlockNode)}),[r]),c=function(t,n){if(null===t)return null;if(t.unlockable)return n<t.cost?(0,e.jsx)(Ks.Progression.NODE_DEV_POINTS_REQUIREMENT,{}):null;if(t.requirementCount>0)return(0,e.jsx)(Ks.Progression.NODE_PARENT_REQUIREMENT,{});if(t.milestoneRequirement>0)return(0,e.jsx)(Ks.Progression.NODE_MILESTONE_REQUIREMENT,{INDEX:(0,e.jsx)(dc,{value:t.milestoneRequirement,unit:tc.Integer})})}(a,l);return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(ime,o),children:(0,e.jsxs)("div",{className:ome,children:[null!=a&&(0,e.jsxs)(P7,{icon:a.icon,title:(0,e.jsx)(Ks.Progression.NODE_NAME,{hash:a.name}),description:(0,e.jsx)(Ks.Progression.NODE_DESCRIPTION,{hash:a.name}),children:[(0,e.jsx)(M7,{state:a.locked?"Locked":"Unlocked"}),a.locked&&(0,e.jsxs)(e.Fragment,{children:[a.cost>0&&(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.progressionPanelDevelopmentUnlockNode,children:(0,e.jsxs)(ml,{theme:O1,selectSound:Qt.purchase,className:ame,disabled:!a.unlockable||a.cost>l,onSelect:s,children:[(0,e.jsx)("div",{className:lme,children:(0,e.jsx)(Ks.Progression.UNLOCK_NODE_BUTTON,{})}),(0,e.jsxs)("div",{className:sme,children:[(0,e.jsx)(dc,{value:a.cost,unit:tc.Integer}),(0,e.jsx)("img",{src:"Media/Game/Icons/DevPoint.svg",className:cme})]})]})}),null!=c&&(0,e.jsx)("div",{className:ume,children:c})]})]}),(0,e.jsxs)("div",{className:dme,children:[(0,e.jsx)("img",{src:"Media/Game/Icons/DevPoint.svg",className:fme}),(0,e.jsx)("div",{className:hme,children:(0,e.jsx)(Ks.Progression.AVAILABLE_DEV_POINTS,{VALUE:(0,e.jsx)(dc,{value:l,unit:tc.Integer})})})]})]})})};const pme="service-detail-header_uCS",vme="title_XWg",gme="progress-bar_PBl";var yme=function(t){var n=t.details,r=C(w3);return(0,e.jsxs)("div",{className:pme,children:[(0,e.jsx)("div",{className:vme,children:(0,e.jsx)(Ks.Services.NAME,{hash:n.name})}),n.milestoneRequirement>r&&(0,e.jsx)(bme,{currentMilestone:r,targetMilestone:n.milestoneRequirement})]})},bme=function(t){var n=t.currentMilestone,r=t.targetMilestone;return(0,e.jsx)(lne,{progress:n,max:r,theme:yfe,className:gme,children:(0,e.jsx)(Ks.Progression.MILESTONE_UNLOCK_REQUIREMENT,{INDEX:(0,e.jsx)(dc,{value:r,unit:tc.Integer}),NAME:(0,e.jsx)(Ks.Progression.MILESTONE_NAME,{index:r})})})};const xme="service-dev-tree_Azt",_me="canvas_xTK",jme="node-layer_Qxl",Eme="node_qXI",Ome="container_Y6w",Tme="title_iof",Ime="selected_tgO",Sme="circle-outline_wOz",wme="circle_wRS",Nme="unlockable_RZR",Pme="locked_g7f",Cme="cost-container_RMQ",Ame="cost_x8o",Lme="cost-dp-icon_sWc";function Mme(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Rme(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Mme(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Mme(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var kme=function(t){var n,r=t.service,o=t.selectedNode,a=t.locked,s=t.className,u=t.onHoverNode,d=t.onSelectNode,f=(0,i.useRef)(null),h=ft(null!==(n=Fd(f))&&void 0!==n?n:ct),m=qd(),p=M(Jhe,r),v=p.reduce((function(e,t){return{x:Math.max(e.x,t.position.x+1),y:Math.max(e.y,t.position.y+1)}}),{x:5,y:0});(0,i.useEffect)((function(){if(null==o||!p.some((function(e){return c(e.entity,o)}))){var e=p.reduce((function(e,t){return null==e||t.position.x<e.position.x||t.position.x===e.position.x&&t.position.y<e.position.y?t:e}),null);null!=e&&d(e.entity)}}),[p,d,o]);var g=HN(d),y=h.x/v.x,b=128*m,x=b*v.y,_=.5*(h.y-x);return(0,e.jsxs)("div",{ref:f,className:Oe()(xme,s),children:[(0,e.jsx)(Dme,{canvasWidth:h.x,canvasHeight:h.y,columnCount:v.x,columnWidth:y,rowHeight:b,verticalOffset:_,lineWidth:4*m,nodeRadius:31*m,locked:a,nodes:p}),(0,e.jsx)("div",{className:jme,children:(0,e.jsx)(Mn,{focused:l(o),onChange:g,children:!ut(h,ct)&&p.map((function(t){return(0,e.jsx)(Vme,{node:t,selected:c(o,t.entity),style:{top:_+t.position.y*b+"px",left:y*t.position.x+"px",width:y+"px",height:b+"px"},onHover:u,onSelect:d},l(t.entity))}))})})]})},Dme=function(t){var n,r=t.canvasWidth,o=t.canvasHeight,a=t.columnWidth,l=t.rowHeight,s=t.verticalOffset,u=t.lineWidth,d=t.nodeRadius,f=t.columnCount,h=t.locked,m=t.nodes,p=Rme((0,i.useState)(null),2),v=p[0],g=p[1],y=(0,i.useCallback)((function(e){return g(null!==(n=null==e?void 0:e.getContext("2d"))&&void 0!==n?n:null)}),[]);return(0,i.useEffect)((function(){if(v){v.clearRect(0,0,r,o),v.fillStyle="#ffffff",v.globalAlpha=.05;for(var e=1;e<f;e+=2)v.fillRect(e*a,0,a,o);v.globalAlpha=1,v.lineWidth=u;var t=m.sort(Ume),n=!0,i=!1,h=void 0;try{for(var p,g=function(){var e=p.value,t=(e.position.x+.5)*a,n=s+(e.position.y+.5)*l,r=e.requirements;if(r.length>0){var i=r.map((function(e){return m.find((function(t){return c(e,t.entity)}))})).filter((function(e){return null!=e})).sort(Ume).reverse(),o=!0,u=!1,f=void 0;try{for(var h,g=i[Symbol.iterator]();!(o=(h=g.next()).done);o=!0){var y=h.value;if(!(ut(y.position,e.position)||y.position.x>e.position.x)){v.strokeStyle=Fme(y,e);var b=(y.position.x+.5)*a,x=s+(y.position.y+.5)*l;if(e.position.x>y.position.x){var _=b+d,j=t-d,E=Gme(y,e),O=_+(j-_)*E,T=_+(j-_)*(1-E),I=x,S=n;v.beginPath(),v.moveTo(b+d,x),v.bezierCurveTo(O,I,T,S,j,n),v.stroke()}else{var w=Math.sign(e.position.y-y.position.y),N=x+w*d,P=n-w*d;v.beginPath(),v.moveTo(b,N),v.lineTo(t,P),v.stroke()}}}}catch(e){u=!0,f=e}finally{try{o||null==g.return||g.return()}finally{if(u)throw f}}}else if(0===e.position.x){v.strokeStyle=Fme(null,e);var C=t-d;v.beginPath(),v.moveTo(0,n),v.lineTo(C,n),v.stroke()}},y=t[Symbol.iterator]();!(n=(p=y.next()).done);n=!0)g()}catch(e){i=!0,h=e}finally{try{n||null==y.return||y.return()}finally{if(i)throw h}}}}),[v,o,r,m,f,a,s,l,u,d,h]),r>0&&o>0?(0,e.jsx)("canvas",{ref:y,width:r,height:o,className:_me}):null};function Ume(e,t){return!e.locked&&t.locked?1:e.locked&&!t.locked?-1:e.unlockable&&!t.unlockable?1:!e.unlockable&&t.unlockable?-1:0}function Fme(e,t){return t.locked?(null!=e?!e.locked:t.unlockable)?"#2378CD":"#555":"#8bdb46"}function Gme(e,t){return t.position.x-e.position.x<=1?.7:.4}var Vme=function(t){var n=t.node,r=t.selected,o=t.style,a=t.className,s=t.onHover,c=t.onSelect,u=C($he),d=(0,i.useCallback)((function(){Jt(Qt.selectItem),c(n.entity)}),[n.entity,c]),f=Bme(n,u),h=(0,i.useMemo)((function(){return{"Purchase Dev Tree Node":f?function(){Jt(Qt.purchase),rme(n.entity)}:null}}),[n.entity,f]),m=(0,i.useCallback)((function(){return Jt(Qt.hoverItem)}),[]),p=(0,i.useCallback)((function(){return s(n.entity)}),[n.entity,s]),v=(0,i.useCallback)((function(){return s(ii)}),[s]),g=(0,i.useMemo)((function(){var e,t;return n.unlockable&&n.cost>0&&u>=n.cost?null===(e=TS.value)||void 0===e?void 0:e.progressionPanelDevelopmentUnlockableNode:null===(t=TS.value)||void 0===t?void 0:t.progressionPanelDevelopmentNode}),[u,n.cost,n.unlockable]);return(0,e.jsx)(Tn,{actions:h,children:(0,e.jsx)(Tr,{focusKey:l(n.entity),focusSound:Qt.hoverItem,className:Oe()(a,Eme,r&&Ime,n.locked&&(n.unlockable?Nme:Pme)),style:o,onClick:d,onMouseOver:p,onMouseEnter:m,onMouseLeave:v,children:(0,e.jsxs)("div",{className:Ome,children:[(0,e.jsx)("div",{className:Sme,children:(0,e.jsx)(bS,{uiTag:g,children:(0,e.jsx)("div",{className:wme,children:(0,e.jsx)("img",{src:n.icon})})})}),(0,e.jsx)("div",{className:Tme,children:(0,e.jsx)(Ks.Progression.NODE_NAME,{hash:n.name})}),(0,e.jsx)("div",{className:Cme,children:n.locked&&n.cost>0&&(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Progression.TOOLTIP_TITLE_POINTS_COST,{}),description:(0,e.jsx)(Ks.Progression.TOOLTIP_DESCRIPTION_POINTS_COST,{}),children:(0,e.jsxs)("div",{className:Ame,children:[(0,e.jsx)(dc,{value:n.cost,unit:tc.Integer}),(0,e.jsx)("img",{src:"Media/Game/Icons/DevPoint.svg",className:Lme})]})})})]})})})},Bme=function(e,t){return!(!e.locked||!e.unlockable||t<e.cost)};const Hme="service-detail_Cba",Kme="dev-tree_af6";var Wme=function(t){var n,r=t.service,i=t.selectedNode,o=t.className,a=t.onHoverNode,l=t.onSelectNode,s=M(Zhe,r),c=null!==(n=null==s?void 0:s.locked)&&void 0!==n&&n;return(0,e.jsx)(CO,{theme:IO,header:null!=s&&(0,e.jsx)(yme,{details:s}),className:Oe()(Hme,c&&IO.locked,o),children:(0,e.jsx)(kme,{service:r,selectedNode:i,locked:c,className:Kme,onHoverNode:a,onSelectNode:l})})};const zme={button:"button_Sxm button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","toggle-states":"toggle-states_q6D",toggleStates:"toggle-states_q6D",icon:"icon_FKY icon_soN icon_Iwk",locked:"locked_K2j locked_H2O locked_dBl"},Yme="service-list_RLT",Xme="lock_H9c";var qme=function(t){var n=t.selectedService,r=t.className,i=t.onSelectService,o=HN(i),a=C(Qhe);return(0,e.jsx)(CO,{theme:IO,className:Oe()(Yme,r),children:(0,e.jsx)(Mn,{focused:l(n),direction:On.Vertical,onChange:o,onRefocus:Rn,children:a.map((function(t,r){return(0,e.jsx)($me,{index:r,service:t,selected:c(t.entity,n),onSelect:i},l(t.entity))}))})})},$me=function(t){var n=t.index,r=t.service,o=t.selected,a=t.onSelect,s=qd(),c=(0,i.useCallback)((function(){return a(r.entity)}),[r.entity,a]),u=(0,i.useMemo)((function(){var e;return"".concat(null===(e=TS.value)||void 0===e?void 0:e.progressionPanelDevelopmentService,"+").concat(r.uiTag)}),[r.uiTag]);return(0,e.jsx)(bS,{uiTag:u,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Services.NAME,{hash:r.name}),description:(0,e.jsx)(Ks.Services.DESCRIPTION,{hash:r.name}),locked:r.locked,requirements:r.requirements,children:(0,e.jsx)(xl,{focusKey:l(r.entity),src:r.icon,selected:o,theme:zme,className:Oe()(r.locked&&zme.locked),onClick:c,children:r.locked&&(0,e.jsx)(YN,{className:Xme,style:{top:(48*(n+1)-12)*s}})})})})};const Qme="service-page_Rls",Zme="list-column_KaJ",Jme="main-column_vAd",epe="info-column_Za4";function tpe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function npe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return tpe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return tpe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var rpe=function(){var t;uu(null===(t=TS.value)||void 0===t?void 0:t.progressionPanelDevelopmentPage);var n=C(Qhe),r=C(tme),o=c(r,ii)?n.length>0?n[0].entity:ii:r,a=C(nme),l=npe((0,i.useState)(ii),2),s=l[0],u=l[1];return(0,e.jsx)(Fn,{children:(0,e.jsxs)("div",{className:Qme,children:[(0,e.jsx)(qme,{selectedService:o,onSelectService:tme.update,className:Zme}),(0,e.jsx)(Wme,{service:o,selectedNode:a,onHoverNode:u,onSelectNode:nme.update,className:Jme}),(0,e.jsx)(mme,{node:c(s,ii)?a:s,className:epe})]})})};const ipe="progression-panel_vIm";function ope(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ape(e){return function(e){if(Array.isArray(e))return ope(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return ope(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ope(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var lpe=function(t){var n,r,i,o=t.selectedTab,a=t.onSelectTab,l=t.onClose;uu(null===(n=TS.value)||void 0===n?void 0:n.progressionPanel);var s=C(vfe);return(0,e.jsx)($r,{header:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Progression.PANEL_TITLE,{})}),(0,e.jsxs)(ZN,{children:[(0,e.jsx)(spe,{tab:Ma.Development,uiTag:null===(r=TS.value)||void 0===r?void 0:r.progressionPanelDevelopmentTab,selectedTab:o,onSelect:a}),(0,e.jsx)(spe,{tab:Ma.Milestones,uiTag:null===(i=TS.value)||void 0===i?void 0:i.progressionPanelMilestonesTab,selectedTab:o,onSelect:a}),s&&(0,e.jsx)(spe,{tab:Ma.Achievements,selectedTab:o,onSelect:a})]})]}),transitionSounds:en,className:ipe,onClose:l,children:(0,e.jsx)(QN,{tabs:[Ma.Development,Ma.Milestones].concat(ape(s?[Ma.Achievements]:[])),selectedTab:o,onSelect:a,children:cpe(o)})})},spe=function(t){var n=t.tab,r=t.uiTag,i=t.selectedTab,o=t.onSelect,a=t.className;return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Progression.TOOLTIP_TITLE_TAB,{hash:Ma[n]}),description:(0,e.jsx)(Ks.Progression.TOOLTIP_DESCRIPTION_TAB,{hash:Ma[n]}),children:(0,e.jsx)(JN,{id:n,uiTag:r,selectedId:i,onSelect:o,className:a,children:(0,e.jsx)(Ks.Progression.TAB_TITLE,{hash:Ma[n]})})})};function cpe(t){switch(t){case Ma.Development:return(0,e.jsx)(rpe,{});case Ma.Milestones:return(0,e.jsx)(Yhe,{});case Ma.Achievements:return(0,e.jsx)(Mfe,{});default:return null}}function upe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dpe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return upe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return upe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var fpe={focusController:Ve,inputController:ue},hpe=i.createContext(fpe),mpe=i.createContext({attach:function(){},detach:function(){}}),ppe=function(t){var n=t.children,r=dpe((0,i.useState)(fpe),2),o=r[0],a=r[1],l=(0,i.useMemo)((function(){return{attach:function(e){return a(e)},detach:function(e){return a((function(t){return t===e?fpe:t}))}}}),[]);return(0,e.jsx)(mpe.Provider,{value:l,children:(0,e.jsx)(hpe.Provider,{value:o,children:n})})},vpe=function(t){var n=t.children,r=(0,i.useContext)(mpe),o=(0,i.useContext)(Ge),a=(0,i.useContext)(de);return(0,i.useEffect)((function(){var e={focusController:o,inputController:a};return r.attach(e),function(){return r.detach(e)}}),[r,a,o]),(0,e.jsx)(Ge.Provider,{value:Ve,children:(0,e.jsx)(de.Provider,{value:ue,children:n})})},gpe=function(t){var n=t.enabled,r=t.children,o=(0,i.useContext)(hpe),a=(0,i.useContext)(Ge),l=(0,i.useContext)(de);return(0,e.jsx)(Ge.Provider,{value:n?o.focusController:a,children:(0,e.jsx)(de.Provider,{value:n?o.inputController:l,children:r})})};function ype(){return function(e,t){var n=Jp(e.epochTicks+t,e.ticksPerDay);return 60*Math.trunc(n/e.ticksPerDay*24)+Math.trunc(Jp(n/e.ticksPerDay*1440,60))}(C(Gp),C(Vp))}const bpe={"progress-bar":"progress-bar_sYi progress-bar_xWR",progressBar:"progress-bar_sYi progress-bar_xWR",progress:"progress_y5v progress_JAQ"},xpe="station-detail_zWr",_pe="header_gDJ",jpe="station-name_T0f",Epe="section-title_lV4",Ope="list_Kl3",Tpe="program-item_KE_",Ipe="time_A1a",Spe="column_p_F",wpe="title_nsV",Npe="description_knq",Ppe="progress_eLk";var Cpe=function(t){var n,r=t.className,i=C(ZM),o=C(eR).find((function(e){return e.name===i})),a=null!==(n=null==o?void 0:o.schedule)&&void 0!==n?n:[];return(0,e.jsxs)("div",{className:Oe()(xpe,r),children:[(0,e.jsxs)("div",{className:_pe,children:[(0,e.jsx)("div",{className:jpe,children:(null==o?void 0:o.nameId)?(0,e.jsx)(Ss,{id:o.nameId}):null==o?void 0:o.name}),(0,e.jsx)("div",{className:Epe,children:(0,e.jsx)(Ks.Radio.PROGRAM_TITLE,{})})]}),(0,e.jsx)(mf,{className:Ope,children:a.map((function(t,n){return(0,e.jsx)(Ape,{item:t},n)}))})]})},Ape=function(t){var n,r,i=t.item,o=C(tR);return(0,e.jsx)(jL,{disabled:null==o,title:null==o?void 0:o.title,description:null==o?void 0:o.info,children:(0,e.jsxs)("div",{className:Tpe,children:[(0,e.jsx)("div",{className:Ipe,children:(0,e.jsx)($s,{value:(n=i.startTime,r=n%60,{hour:(n-r)/60%24,minute:r})})}),(0,e.jsxs)("div",{className:Spe,children:[(0,e.jsx)("div",{className:wpe,children:i.name}),(0,e.jsx)("div",{className:Npe,children:i.description}),i.active&&(0,e.jsx)(Lpe,{startTime:i.startTime,duration:i.duration})]})]})})},Lpe=function(t){var n=t.startTime,r=t.duration,i=(ype()-n+1440)%1440;return(0,e.jsx)(lne,{progress:i,max:r,theme:bpe,className:Ppe})};const Mpe="stations-menu_kAr",Rpe="networks_SQ5",kpe="stations_mU1",Dpe="network-item_tGo",Upe="station-item_cOt",Fpe="icon_Yr0",Gpe="column_j5W",Vpe="title_Bsq",Bpe="program_xd2",Hpe="progress_zBM";var Kpe=function(t){var n,r,i=t.className,o=C(QM),a=C(ZM),l=C(JM),s=C(eR).filter((function(e){return e.network===o}));return(0,e.jsxs)("div",{className:Oe()(Mpe,i),children:[(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.radioPanelNetworks,children:(0,e.jsx)("div",{className:Rpe,children:l.map((function(t){return(0,e.jsx)(Wpe,{item:t,selected:t.name===o,onSelect:uR},t.name)}))})}),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.radioPanelStations,children:(0,e.jsx)(mf,{className:kpe,children:s.map((function(t){return(0,e.jsx)(zpe,{item:t,selected:t.name===a,onSelect:dR},t.name)}))})})]})},Wpe=function(t){var n=t.item,r=t.selected,o=t.onSelect,a=(0,i.useCallback)((function(){return o(n.name)}),[o,n.name]);return(0,e.jsx)(xO,{tooltip:(0,e.jsx)(EL,{title:n.nameId?(0,e.jsx)(Ss,{id:n.nameId}):n.name,description:n.descriptionId?(0,e.jsx)(Ss,{id:n.descriptionId}):n.description}),children:(0,e.jsx)(xl,{src:n.icon,selected:r,selectSound:r?null:Qt.selectRadioNetwork,className:Dpe,onSelect:r?void 0:a})})},zpe=function(t){var n,r,o,a,l,s=t.item,c=t.selected,u=t.onSelect,d=(0,i.useCallback)((function(){return u(s.name)}),[u,s.name]),f=ype(),h=(f-(null!==(a=null===(n=s.currentProgram)||void 0===n?void 0:n.startTime)&&void 0!==a?a:f)+1440)%1440,m=null!==(l=null===(r=s.currentProgram)||void 0===r?void 0:r.duration)&&void 0!==l?l:0;return(0,e.jsxs)(ml,{selected:c,selectSound:Qt.selectRadioStation,className:Upe,onSelect:c?void 0:d,children:[(0,e.jsx)("img",{src:s.icon,className:Fpe}),(0,e.jsxs)("div",{className:Gpe,children:[(0,e.jsx)("div",{className:Vpe,children:s.nameId?(0,e.jsx)(Ss,{id:s.nameId}):s.name}),(0,e.jsx)("div",{className:Bpe,children:null===(o=s.currentProgram)||void 0===o?void 0:o.name}),(0,e.jsx)(lne,{progress:h,max:m,theme:bpe,className:Hpe})]})]})};const Ype="radio-panel_rXp",Xpe="content_r9x",qpe="stations-menu_m2f",$pe="station-detail_KRp";var Qpe=function(t){var n,r,o=t.className,a=t.onClose;uu(null===(n=TS.value)||void 0===n?void 0:n.radioPanel);var l=C(JM),s=C(QM),c=C(eR),u=(0,i.useMemo)((function(){return c.filter((function(e){return e.network===s}))}),[s,c]),d=C(ZM),f=(0,i.useMemo)((function(){return{"Switch Radio Network":l.length>=2?function(e){var t=l.findIndex((function(e){return e.name===s})),n=e<0?lp(t,l.length,!1):op(t,l.length,!1);null!=n&&n!==t&&(uR(l[n].name),Jt(Qt.selectRadioNetwork))}:null,"Switch Radio Station":u.length>=2?function(e){var t=u.findIndex((function(e){return e.name===d})),n=e<0?op(t,u.length,!1):lp(t,u.length,!1);null!=n&&n!==t&&(dR(u[n].name),Jt(Qt.selectRadioStation))}:null}}),[l,s,d,u]);return(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.radioPanel,children:(0,e.jsx)($r,{header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Radio.PANEL_TITLE,{})}),theme:B6,transitionSounds:en,className:Oe()(Ype,o),contentClassName:Xpe,onClose:a,children:(0,e.jsx)(Tn,{actions:f,children:(0,e.jsxs)(vpe,{children:[(0,e.jsx)(Kpe,{className:qpe}),(0,e.jsx)(Cpe,{className:$pe})]})})})})},Zpe="statistics",Jpe=E(Zpe,"sampleRange"),eve=E(Zpe,"sampleCount"),tve=E(Zpe,"activeGroup"),nve=(E(Zpe,"activeCategory"),E(Zpe,"stacked")),rve=E(Zpe,"categories"),ive=(E(Zpe,"dataLabels"),T(Zpe,"groups")),ove=E(Zpe,"data"),ave=E(Zpe,"selectedStatistics"),lve=T(Zpe,"unlockingRequirements"),sve=E(Zpe,"updatesPerDay");function cve(e){N(Zpe,"addStat",ri(e,"Game.UI.InGame.StatisticsUISystem+StatItem"))}function uve(e){N(Zpe,"setSampleRange",e)}function dve(e,t,n){return dve="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var r=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=fve(e)););return e}(e,t);if(r){var i=Object.getOwnPropertyDescriptor(r,t);return i.get?i.get.call(n):i.value}},dve(e,t,n||e)}function fve(e){return fve=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},fve(e)}function hve(e,t){return!t||"object"!==vve(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function mve(e,t){return mve=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},mve(e,t)}var pve,vve=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function gve(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=fve(e);if(t){var i=fve(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return hve(this,n)}}!function(e){e[e.HourMonth=0]="HourMonth",e[e.Date=1]="Date",e[e.Year=2]="Year"}(pve||(pve={}));var yve=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&mve(e,t)}(n,e);var t=gve(n);function n(e){var r;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,n),(r=t.call(this,e))._startValue=0,r._valueRange=0,r._tickFormat=pve.HourMonth,r._majorTickInterval=1,r._firstMajorTickValue=0,r._tickInterval=1,r._firstTickValue=0,r}var r=n.prototype;return r.determineDataLimits=function(){var e=this.getMinMax(!0),t=e.min,n=e.max;this.min=isFinite(t)?t:0,this.max=isFinite(n)?n:0},r.beforeBuildTicks=function(){dve(fve(n.prototype),"beforeBuildTicks",this).call(this);var e=this.options.ticks.maxTicksLimit,t=this.options.timeSettings,r=0,i=(this.max-this.min)/t.ticksPerDay*24;if(this._tickFormat=pve.HourMonth,this._tickInterval=t.ticksPerDay/24,this._majorTickInterval=t.ticksPerDay,i>=e&&(i/=3,this._tickInterval=t.ticksPerDay/8),i>=e&&(i/=2,this._tickInterval=t.ticksPerDay/4),i>=e&&(i/=2,this._tickInterval=t.ticksPerDay/2),i>=e&&(i/=2,this._tickFormat=pve.Date,this._tickInterval=t.ticksPerDay),i>=e&&(i/=3,this._tickInterval=3*t.ticksPerDay),i>=e&&(i/=4,this._tickFormat=pve.Year,this._tickInterval=t.daysPerYear*t.ticksPerDay),i>=e){var o=1;do{i/=5,o*=5,this._tickInterval*=5,i>=e&&(i/=2,o*=2,this._tickInterval*=2)}while(i>=e&&o<1e3);r=(o-t.epochYear%o)%o*t.ticksPerDay*t.daysPerYear}var a=t.epochTicks-r,l=this.min+a;this._firstMajorTickValue=Math.ceil(l/this._majorTickInterval)*this._majorTickInterval-a,this._firstTickValue=Math.ceil(l/this._tickInterval)*this._tickInterval-a},r.buildTicks=function(){for(var e=[],t=this._tickInterval,n=this._firstTickValue;n<=this.max;n+=t){var r=Math.abs((n-this._firstMajorTickValue)%this._majorTickInterval/this._majorTickInterval)<.001;e.push({value:n,major:r})}return e},r.generateTickLabels=function(e){var t,n,r;for(t=0,n=e.length;t<n;t++)(r=e[t]).label=this.generateTickLabel(r.value,r.major)},r.generateTickLabel=function(e,t){var n=Zp(this.options.timeSettings,Math.ceil(e));return this._tickFormat===pve.HourMonth?t?[this.options.ticks.timeFormat(n),this.options.ticks.dateFormat(n)]:this.options.ticks.timeFormat(n):this._tickFormat===pve.Date?this.options.ticks.dateFormat(n):n.year.toFixed(0)},r.configure=function(){dve(fve(n.prototype),"configure",this).call(this),this._startValue=this.min,this._valueRange=this.max-this.min},r.getPixelForValue=function(e){return this.getPixelForDecimal((e-this._startValue)/this._valueRange)},r.getValueForPixel=function(e){return this._startValue+this.getDecimalForPixel(e)*this._valueRange},n}(l_);yve.id="simulationTime",yve.defaults={timeSettings:{daysPerYear:12,ticksPerDay:1<<17,epochTicks:0,epochYear:0},ticks:{_scriptable:function(e){return"timeFormat"!==e&&"dateFormat"!==e},timeFormat:function(e){return JSON.stringify(["hhmm",e.hour,e.minute])},dateFormat:function(e){return JSON.stringify(["MMyy",e.month,e.year])},maxTicksLimit:11}};const bve={chartFontColor:"rgba(255, 255, 255, 0.6)",chartLineColor:"rgba(255, 255, 255, 0.1)",content:"content_nkU",legend:"legend_nMX","legend-item":"legend-item_all",legendItem:"legend-item_all",graph:"graph_zE6","time-scale":"time-scale_ShR",timeScale:"time-scale_ShR","time-scale-label":"time-scale-label_VSV",timeScaleLabel:"time-scale-label_VSV","time-scale-field":"time-scale-field_lEQ",timeScaleField:"time-scale-field_lEQ","time-scale-title":"time-scale-title_Ow0",timeScaleTitle:"time-scale-title_Ow0","action-icon":"action-icon_T6_",actionIcon:"action-icon_T6_",slider:"slider_mN3"};function xve(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _ve(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xve(e,t,n[t])}))}return e}function jve(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}k_.register(yve);var Eve=function(t){var n,r,o,a,l,s=t.data,c=t.selectedStatistics,u=t.timeScale,d=t.stepCount,f=t.onSetTimeScale,h=t.className,m=fc(tc.Money),p=fc(tc.Integer),v=C(nve),g=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,r=Qs(),o=Xs(),a=C(Jpe),l=C(Vp),s=C(Gp),c=C(Jl),u=C(sve),d=l-s.ticksPerDay/u*a,f=l+s.ticksPerDay/1440+1;return(0,i.useMemo)((function(){var i={layout:{padding:{top:0,right:50,bottom:0,left:25}},elements:{line:{fill:t,borderWidth:3,tension:0},point:{radius:0}},scales:{x:{type:"simulationTime",min:d,max:f,grid:{color:bve.chartLineColor,lineWidth:1},border:{color:bve.chartLineColor,width:1},timeSettings:s,ticks:{maxTicksLimit:11,font:{size:Ove*c},color:bve.chartFontColor,padding:Tve,timeFormat:r,dateFormat:o}},y:{beginAtZero:!0,max:n,grid:{color:bve.chartLineColor,lineWidth:1},border:{color:bve.chartLineColor,width:1},ticks:{font:{size:Ove*c},maxTicksLimit:10,color:bve.chartFontColor,padding:Tve,autoSkip:!1,callback:function(t){return e?e(t):t}},stacked:t}}};return i}),[t,d,f,s,c,r,o,n,e])}(c.length>0&&1===c[0].unitType?m:p,v,c.length>0&&2===c[0].unitType?100:void 0),y=(r=C(Jpe),o=C(Vp),a=C(sve),l=C(Gp),{x:o-l.ticksPerDay/a*r,y:o+l.ticksPerDay/1440+1}),b=(0,i.useMemo)((function(){return jve(_ve({},s),{datasets:s.datasets.map((function(e){var t=e.data.map((function(e,t,n){if(0===t){var r,i,o=n.length>1&&n[0].x<y.x?function(e,t,n){var r=e.x,i=e.y,o=t.x,a=t.y;return{x:n,y:i+(n-r)*(a-i)/(o-r)}}(n[0],n[1],y.x):null;return{x:null!==(r=null==o?void 0:o.x)&&void 0!==r?r:Math.max(e.x,y.x),y:null!==(i=null==o?void 0:o.y)&&void 0!==i?i:e.y}}return t===n.length-1?{x:y.y,y:e.y}:e}));return jve(_ve({},e),{data:t})}))})}),[s,y.x,y.y]);return(0,e.jsx)(CO,{focusKey:Te,theme:IO,className:Oe()(bve.statisticsGraph,h),children:(0,e.jsxs)("div",{className:bve.content,children:[(0,e.jsx)("div",{className:bve.legend,children:c.map((function(t,n){return(0,e.jsx)(yv,{color:pm(t.color),label:(0,e.jsx)(Ks.StatisticsPanel.STAT_TITLE,{hash:t.key}),className:bve.legendItem},n)}))}),(0,e.jsx)(Zj,{type:"line",data:b,options:g,className:bve.graph}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.statisticsPanelTimeScale,children:(0,e.jsxs)("div",{className:bve.timeScale,children:[(0,e.jsx)("div",{className:bve.timeScaleTitle,children:(0,e.jsx)(Ks.StatisticsPanel.TIME_SCALE_TITLE,{})}),(0,e.jsx)(Fm,{focusKey:Te,theme:Lm,className:bve.slider,start:0,end:0===d?1:d,value:u,gamepadStep:1,disabled:0===d,onChange:f,valueTransformer:Vm}),(0,e.jsx)("div",{className:bve.timeScaleLabel,children:(0,e.jsx)("div",{className:bve.timeScaleField,children:(0,e.jsx)(Ks.StatisticsPanel.TIME_SCALE,{index:u})})})]})})]})})};var Ove=10,Tve=10;const Ive={"foldout-item":"foldout-item_wOF",foldoutItem:"foldout-item_wOF",header:"header_8H_ item-mouse-states_Fmi item-focused_FuT","header-content":"header-content_wUX",headerContent:"header-content_wUX","disable-active-state":"disable-active-state_w8a",disableActiveState:"disable-active-state_w8a","disable-mouse-states":"disable-mouse-states_js5",disableMouseStates:"disable-mouse-states_js5",icon:"icon_I32",toggle:"toggle_yQv",content:"content_mJm",enter:"enter_sm5",exit:"exit_ScE","exit-active":"exit-active_LGX",exitActive:"exit-active_LGX","enter-active":"enter-active_jNk",enterActive:"enter-active_jNk"};var Sve=i.createContext({theme:Ive});function wve(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Nve(e){return(0,i.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){wve(e,t,n[t])}))}return e}({},Ive,e)}),[e])}function Pve(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Cve(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Pve(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Pve(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ave=function(t){var n=t.header,r=t.theme,o=void 0===r?Ive:r,a=t.type,l=void 0===a?"Item":a,s=t.nesting,c=void 0===s?0:s,u=t.initialExpanded,d=void 0!==u&&u,f=t.expandFromContent,h=void 0!==f&&f,m=t.onSelect,p=t.onToggleExpanded,v=t.className,g=t.children,y=Nve(o),b=i.Children.count(g)>0,x=Cve((0,i.useState)(d),2),_=x[0],j=x[1],E=(0,i.useCallback)((function(){Jt(Qt.expandPanel),j((function(e){return!e})),p&&p(!_)}),[_,p]),O=(0,i.useCallback)((function(){m&&(Jt(Qt.selectItem),m())}),[m]),T=!b&&!m,I=(0,i.useMemo)((function(){return{theme:y,expandable:b,expanded:_,onToggleExpanded:E,onSelect:O}}),[b,_,O,E,y]);return(0,e.jsx)(Sve.Provider,{value:I,children:(0,e.jsxs)("div",{style:Mve(c),className:Oe()(y.foldoutItem,b&&y.expandable,_&&y.expanded,"Item"===l&&y.item,"Group"===l&&y.group,"Category"===l&&y.category,T&&y.disableMouseStates,v),children:[(0,e.jsx)(In,{onAction:O,disabled:b,children:(0,e.jsx)(Sn,{expandable:b,disabled:!b,expanded:_,onAction:E,children:n})}),(0,e.jsx)(Sn,{expandable:b,disabled:!b||!h,expanded:_,onAction:E,children:(0,e.jsx)(D0,{in:b&&_,children:(0,e.jsx)(lJ,{styles:Ive,children:(0,e.jsx)("div",{className:Oe()(y.content,"foldout-expanded"),children:(0,e.jsx)(Fn,{children:g})})})})})]})})},Lve=function(t){var n=t.icon,r=t.children,o=(0,i.useContext)(Sve),a=(0,i.useCallback)((function(){return Jt(Qt.hoverItem)}),[]),l=(0,i.useCallback)((function(){o.expandable?o.onToggleExpanded&&o.onToggleExpanded():o.onSelect&&o.onSelect()}),[o]);return(0,e.jsxs)(Tr,{className:o.theme.header,onMouseEnter:a,onClick:l,children:[(0,e.jsx)("div",{className:o.theme.icon,children:n}),(0,e.jsx)("div",{className:o.theme.headerContent,children:r}),o.expandable&&(0,e.jsx)(ll,{className:o.theme.toggle,src:o.expanded?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg"})]})};function Mve(e){return{"--nesting":e}}const Rve={"foldout-item":"foldout-item_dah foldout-item_wOF",foldoutItem:"foldout-item_dah foldout-item_wOF",header:"header_MP_ header_8H_ item-mouse-states_Fmi item-focused_FuT","disable-active-state":"disable-active-state_G7o disable-active-state_w8a",disableActiveState:"disable-active-state_G7o disable-active-state_w8a","header-content":"header-content_SqG header-content_wUX",headerContent:"header-content_SqG header-content_wUX",icon:"icon_nAL icon_I32",toggle:"toggle_RV4 toggle_yQv"},kve={toggle:"toggle_GGm toggle_cca item-mouse-states_Fmi"},Dve={locked:"locked_XuG",label:"label_VRN"},Uve={size:"size_DD8",toggle:"toggle_mte size_DD8 toggle_H7r item-mouse-states_Fmi"};function Fve(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Gve(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Fve(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Fve(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Vve=function(t){var n=t.statItem,r=t.selectedStatistics,o=t.nesting,a=void 0===o?0:o,l=Gve((0,i.useState)(!1),2),s=l[0],u=l[1],d=(0,i.useCallback)((function(){return u(!0)}),[]),f=(0,i.useCallback)((function(){return u(!1)}),[]),h=M(ive,n.entity),m=C(tve),p=(0,i.useMemo)((function(){return function(e,t,n){return e.isGroup||e.isSubgroup?n.index===e.entity.index||void 0!==t.find((function(t){return t.entity.index===e.entity.index})):void 0!==t.find((function(t){return t.key===e.key}))||void 0!==t.find((function(t){return t.isSubgroup&&t.entity.index===e.entity.index}))}(n,r,m)}),[m,r,n]),v=(0,i.useCallback)((function(){p?N(Zpe,"removeStat",ri(n,"Game.UI.InGame.StatisticsUISystem+StatItem")):cve(n)}),[p,n]),g=M(lve,n.entity),y=(0,i.useMemo)((function(){return a+1}),[a]),b=(0,i.useMemo)((function(){return-1!==r.findIndex((function(e){return c(e.entity,n.entity)}))||r.some((function(e){return-1!==h.findIndex((function(t){return c(e.entity,t.entity)}))}))}),[h,r,n.entity]);return(0,e.jsx)(Ave,{initialExpanded:b,type:(n.isGroup||n.isSubgroup)&&h.length>0?"Group":"Item",className:Oe()(Dve.statisticsItem,n.locked&&"locked",s&&Rve.disableActiveState),theme:Rve,nesting:a,header:(0,e.jsx)(x7,{locked:n.locked,requirements:g,direction:"right",children:(0,e.jsx)(Lve,{icon:n.locked?(0,e.jsx)(YN,{className:Uve.size}):n.isGroup?(0,e.jsx)(cP,{theme:Uve,disabled:n.locked,onChange:v,onMouseOver:d,onMouseLeave:f,checked:p,focusKey:n.key,style:{borderColor:pm(n.color)}}):(0,e.jsx)(pp,{theme:kve,disabled:n.locked,onChange:v,onMouseOver:d,onMouseLeave:f,checked:p,focusKey:n.key,style:{borderColor:pm(n.color)}}),children:(0,e.jsx)("div",{className:Oe()(Dve.label,n.locked&&Dve.locked),children:(0,e.jsx)(Ks.StatisticsPanel.STAT_TITLE,{hash:n.key})})})}),children:(n.isGroup||n.isSubgroup)&&h.length>0?h.map((function(t){return(0,e.jsx)(Vve,{statItem:t,nesting:y,selectedStatistics:r},t.key)})):void 0})};const Bve="statistics-category-item_qVI",Hve="items_AIY",Kve="header_Ld7";var Wve=function(t){var n=t.category,r=t.selectedStatistics,i=M(ive,n.entity);return(0,e.jsxs)("div",{className:Bve,children:[(0,e.jsx)("div",{className:Kve,children:(0,e.jsx)(Ks.StatisticsPanel.STAT_TITLE,{hash:n.key})}),(0,e.jsx)("div",{className:Hve,children:i.map((function(t){return(0,e.jsx)(Vve,{statItem:t,selectedStatistics:r},t.key)}))})]})};const zve="statistics-menu_y86",Yve="content_Q1O",Xve="scrollable_By7";var qve=function(t){var n,r=t.selectedStatistics,i=C(rve);return(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.statisticsPanelMenu,children:(0,e.jsx)(CO,{theme:IO,className:zve,children:(0,e.jsx)(mf,{className:Xve,children:(0,e.jsx)("div",{className:Yve,children:(0,e.jsx)(Fn,{direction:On.Vertical,children:i.map((function(t){return(0,e.jsx)(Wve,{category:t,selectedStatistics:r},t.key)}))})})})})})};const $ve="city-statistics-panel_ECW",Qve="content_BIL",Zve="graph_Qba";var Jve=function(t){var n,r,o=t.onClose;uu(null===(n=TS.value)||void 0===n?void 0:n.statisticsPanel);var a=C(ave),l=C(ove),s=(0,i.useMemo)((function(){return{datasets:l}}),[l]),c=C(sve),u=C(eve),d=C(Jpe),f=(0,i.useMemo)((function(){return(t=(e=u/c)/12)>1e3?9:t>500?8:t>100?7:t>50?6:t>10?5:t>5?4:e>12?3:e>6?2:e>1?1:0;var e,t}),[u,c]),h=(0,i.useMemo)((function(){return function(e,t){switch(e){case t:return 0;case 6*t:return 1;case 12*t:return 2;case 60*t:return 3;case 120*t:return 4;case 600*t:return 5;case 1200*t:return 6;case 6e3*t:return 7;case 12e3*t:return 8;default:return 9}}(d,c)}),[d,c]),m=(0,i.useMemo)((function(){return{"Change Time Scale":f>0?function(e){if(Jt(Qt.dragSlider),e<0)uve(ege(Math.max(0,h-1),u,c));else if(e>0){uve(ege(Math.min(f,h+1),u,c))}}:null}}),[u,f,h,c]),p=(0,i.useCallback)((function(e){uve(ege(e,u,c))}),[u,c]),v=(0,i.useCallback)((function(){o()}),[o]);return(0,i.useEffect)((function(){if(0===ave.value.length){var e=rve.value;if(e.length>0){var t=ive.getValue(e[0].entity);t.length>0&&cve(t[0])}}}),[]),(0,e.jsx)(Tn,{actions:m,children:(0,e.jsxs)($r,{transitionSounds:en,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Statistics.PANEL_TITLE,{})}),className:$ve,contentClassName:Qve,onClose:v,children:[(0,e.jsx)(qve,{selectedStatistics:a}),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.statisticsPanel,children:(0,e.jsx)(Eve,{data:s,selectedStatistics:a,timeScale:h,stepCount:f,onSetTimeScale:p,className:Zve})})]})})};function ege(e,t,n){switch(e){case 0:return n;case 1:return 6*n;case 2:return 12*n;case 3:return 60*n;case 4:return 120*n;case 5:return 600*n;case 6:return 1200*n;case 7:return 6e3*n;case 8:return 12e3*n;default:return t}}function tge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function nge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return tge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return tge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function rge(e){switch(e){case 0:return"Media/Game/Misc/ScheduleDay.svg";case 1:return"Media/Game/Misc/ScheduleNight.svg";default:return"Media/Game/Misc/ScheduleDayNight.svg"}}const ige="transportation-overview-page_NsJ",oge="types_Mco",age="lines_iup",lge="scrollable_lwl",sge="no-lines_xtM",cge="header_cSe",uge="title_kUy",dge="sort-indicator_ToO",fge="legends_mcP",hge="button_cuw item-mouse-states_Fmi item-focused_FuT icon-focused_FJS",mge="buton-label_mGB",pge="cell-single_qTE cell_geG",vge="cell-double_hmA cell_geG",gge="cell-wide_yZB cell_geG",yge="visibilityButton_mnO",bge={input:"input_hDw",label:"label_NCg",container:"container_sRs"},xge="transportation-line-item_ZFw",_ge="container_G2A item-normal_Wb_ item-hover_WK8 item-focused_FuT",jge="color-field_jwA",Ege="button_PV4 item-mouse-states_Fmi item-focused_FuT",Oge="scheduleButton_PYR",Tge="visibilityButton_zW9",Ige="toggle__VM",Sge="toggleOff_nKd";function wge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Nge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return wge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return wge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Pge=function(t){var n=t.focusKey,r=t.line,o=Nge(function(e){var t=nge((0,i.useState)(),2),n=t[0],r=t[1],o=nge((0,i.useState)(),2),a=o[0],l=o[1],s=pL(e.name);(0,i.useEffect)((function(){null!=e&&n!==s&&(r(s),l(s))}),[e,n,s]);var c=(0,i.useCallback)((function(e){return l(e.target.value)}),[]),u=(0,i.useCallback)((function(){null!=e&&a&&""!==a?Ole(e.lineData.entity,a):l(n)}),[e,n,a]),d=(0,i.useCallback)((function(){return l(n)}),[n]);return[null!=a?a:"",c,u,d]}(r),3),a=o[0],l=o[1],s=o[2],c=Nge((0,i.useState)(!1),2),u=c[0],d=c[1],f=(0,i.useContext)(Rl),h=(0,i.useCallback)((function(){return Ele(r.lineData.entity)}),[r]),m=(0,i.useCallback)((function(e){return Tle(r.lineData.entity,e)}),[r]),p=(0,i.useCallback)((function(){return Ile(r.lineData.entity,!r.lineData.active)}),[r]),v=(0,i.useCallback)((function(){f.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.SelectedInfoPanel.CONFIRM_DELETE_WARNING,{}),onConfirm:h}))}),[f,h]),g=(0,i.useCallback)((function(){r.lineData.visible?wle(r.lineData.entity,!1):Sle(r.lineData.entity,!1)}),[r]),y=(0,i.useCallback)((function(){jle(r.lineData.entity)}),[r]),b=(0,i.useCallback)((function(e){e!==u&&Cle(r.lineData.entity),d(e)}),[u,r.lineData.entity]),x=(0,i.useCallback)((function(){Cle(r.lineData.entity)}),[r.lineData.entity]),_=(0,i.useCallback)((function(){switch(r.lineData.schedule){case 0:Nle(r.lineData.entity,1);break;case 1:Nle(r.lineData.entity,2);break;default:Nle(r.lineData.entity,0)}}),[r]),j=(0,i.useMemo)((function(){return r.lineData.isCargo?"Route":"Line"}),[r.lineData.isCargo]);return(0,e.jsx)(Jh,{onFocusChange:b,children:(0,e.jsx)("div",{className:xge,children:(0,e.jsx)(Tr,{focusKey:n,onMouseEnter:x,onMouseLeave:x,className:_ge,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)("div",{className:gge,children:(0,e.jsx)(X0,{value:a,onChange:l,onBlur:s,onClick:Cm,theme:bge,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"LineName"})})}),(0,e.jsx)("div",{className:vge,children:(0,e.jsx)(dc,{value:r.lineData.length,unit:tc.Length})}),(0,e.jsx)("div",{className:vge,children:r.lineData.stops}),(0,e.jsx)("div",{className:vge,children:r.lineData.vehicles}),(0,e.jsx)("div",{className:vge,children:r.lineData.isCargo?(0,e.jsx)(dc,{value:r.lineData.cargo,unit:tc.Weight}):r.lineData.cargo}),(0,e.jsx)("div",{className:vge,children:(0,e.jsx)(dc,{value:100*r.lineData.usage,unit:tc.Percentage})}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Transport.TOOLTIP_COLOR,{hash:j}),children:(0,e.jsx)(jF,{value:r.lineData.color,className:jge,onChange:m,onClick:Cm})})}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:r.lineData.active?"Deactivate":"Reactivate"}),children:(0,e.jsx)(ml,{className:Ege,onSelect:p,onClick:Cm,children:(0,e.jsx)(ll,{src:"Media/Glyphs/OnOff.svg",className:Oe()(Ige,!r.lineData.active&&Sge)})})})}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Transport.TOOLTIP_SCHEDULE,{hash:j}),children:(0,e.jsx)(xl,{src:rge(r.lineData.schedule),onSelect:_,className:Oe()(Ege,Oge),onClick:Cm})})}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Transport.TOOLTIP_VISIBLE,{hash:j}),children:(0,e.jsx)(xl,{tinted:!0,src:r.lineData.visible?"Media/Glyphs/EyeOpen.svg":"Media/Glyphs/EyeClosed.svg",onSelect:g,className:Oe()(Ege,Tge),onClick:Cm})})}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Transport.TOOLTIP_DETAILS,{hash:j}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/ViewInfo.svg",onSelect:y,className:Ege,onClick:Cm})})}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Transport.TOOLTIP_DELETE,{hash:j}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Trash.svg",onSelect:v,className:Ege,onClick:Cm})})})]})})})})};const Cge="transport-type-item__xs",Age="lock_GRv";var Lge,Mge=function(t){var n=t.type,r=t.cargo,o=t.selected,a=t.focusKey,l=t.onSelect,s=(0,i.useCallback)((function(){return l(n.id)}),[l,n]);return(0,e.jsx)(x7,{title:r?(0,e.jsx)(Ks.Transport.ROUTES,{hash:n.id}):(0,e.jsx)(Ks.Transport.LINES,{hash:n.id}),locked:n.locked,requirements:n.requirements,direction:"right",children:(0,e.jsx)(xl,{focusKey:a,src:n.icon,selected:!n.locked&&o,disabled:n.locked,theme:zme,className:Oe()(Cge,n.locked&&zme.locked),onSelect:s,children:n.locked&&(0,e.jsx)(YN,{className:Age})})})};function Rge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Rge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Rge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e[e.Name=0]="Name",e[e.Length=1]="Length",e[e.Stops=2]="Stops",e[e.Vehicles=3]="Vehicles",e[e.Cargo=4]="Cargo",e[e.Usage=5]="Usage"}(Lge||(Lge={}));var Dge=function(t){var n,r,o,a=t.cargo,s=t.lines,c=t.types,u=t.selectedType,d=t.setSelectedType;uu(null===(n=TS.value)||void 0===n?void 0:n.transportationOverviewPanelLines);var f=kge((0,i.useState)(Lge.Name),2),h=f[0],m=f[1],p=kge((0,i.useState)(!0),2),v=p[0],g=p[1],y=(0,i.useCallback)((function(e){"string"==typeof e&&d(e)}),[d]),b=(0,i.useCallback)((function(e){d(e)}),[d]),x=(0,i.useCallback)((function(e){g(e!==h||!v),m(e)}),[v,h]),_=vL(),j=(0,i.useMemo)((function(){return function(e,t,n,r){var i=x1({order:n?"asc":"desc"});switch(t){case Lge.Name:return e.sort((function(e,t){return i(r(e.name),r(t.name))}));case Lge.Length:return e.sort((function(e,t){return i(e.lineData.length,t.lineData.length)}));case Lge.Stops:return e.sort((function(e,t){return i(e.lineData.stops,t.lineData.stops)}));case Lge.Vehicles:return e.sort((function(e,t){return i(e.lineData.vehicles,t.lineData.vehicles)}));case Lge.Cargo:return e.sort((function(e,t){return i(e.lineData.cargo,t.lineData.cargo)}));case Lge.Usage:return e.sort((function(e,t){return i(e.lineData.usage,t.lineData.usage)}))}}(s,h,v,_)}),[v,s,_,h]),E=kge((0,i.useState)(j.some((function(e){return e.lineData.visible}))||0===j.length),2),O=E[0],T=E[1],I=(0,i.useCallback)((function(){for(var e=0;e<j.length;e++){var t=j[e];O?wle(t.lineData.entity,!1):Sle(t.lineData.entity,!1)}T(!O)}),[O,j]);return(0,i.useEffect)((function(){T(j.some((function(e){return e.lineData.visible}))||0===j.length)}),[j]),(0,e.jsx)(Fn,{direction:On.Horizontal,children:(0,e.jsxs)("div",{className:ige,children:[(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.transportationOverviewPanelTransportTypes,children:(0,e.jsx)(CO,{theme:IO,className:oge,children:(0,e.jsx)(Mn,{focused:u,onChange:y,onRefocus:Rn,children:(0,e.jsx)(mf,{children:c.map((function(t){return(0,e.jsx)(Mge,{type:t,cargo:a,focusKey:t.id,selected:t.id===u,onSelect:b},t.id)}))})})})}),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.transportationOverviewPanelLines,children:(0,e.jsx)(CO,{theme:IO,className:age,header:(0,e.jsx)(Uge,{type:u,cargo:a,sortBy:h,ascending:v,someVisible:O,onSort:x,toggleVisibility:I}),children:(0,e.jsx)(mf,{className:lge,children:(0,e.jsx)(Fn,{direction:On.Vertical,children:j.length>0?j.map((function(t){return(0,e.jsx)(Pge,{focusKey:l(t.lineData.entity),line:t},l(t.lineData.entity))})):(0,e.jsx)("div",{className:sge,children:a?(0,e.jsx)(Ks.Transport.NO_ROUTES,{}):(0,e.jsx)(Ks.Transport.NO_LINES,{})})})})})})]})})},Uge=function(t){var n,r=t.type,o=t.cargo,a=t.sortBy,l=t.ascending,s=t.someVisible,c=t.onSort,u=t.toggleVisibility,d=(0,i.useCallback)((function(){c(Lge.Name)}),[c]),f=(0,i.useCallback)((function(){c(Lge.Stops)}),[c]),h=(0,i.useCallback)((function(){c(Lge.Vehicles)}),[c]),m=(0,i.useCallback)((function(){c(Lge.Cargo)}),[c]),p=(0,i.useCallback)((function(){c(Lge.Usage)}),[c]),v=(0,i.useCallback)((function(){c(Lge.Length)}),[c]),g=(0,e.jsx)(ll,{className:dge,src:"Media/Glyphs/ThickStrokeArrow".concat(l?"Down":"Up",".svg")});return(0,e.jsx)(Tr,{focusKey:"Header",className:cge,children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsx)("div",{className:uge,children:o?(0,e.jsx)(Ks.Transport.ROUTES,{hash:r}):(0,e.jsx)(Ks.Transport.LINES,{hash:r})}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.transportationOverviewPanelLegend,children:(0,e.jsxs)("div",{className:fge,children:[(0,e.jsx)("div",{className:gge,children:(0,e.jsxs)(ml,{onSelect:d,className:hge,children:[(0,e.jsx)("div",{className:mge,children:(0,e.jsx)(Ks.Transport.LEGEND_NAME,{})}),a===Lge.Name&&g]})}),(0,e.jsx)("div",{className:vge,children:(0,e.jsxs)(ml,{onSelect:v,className:hge,children:[(0,e.jsx)("div",{className:mge,children:(0,e.jsx)(Ks.Transport.LEGEND_LENGTH,{})}),a===Lge.Length&&g]})}),(0,e.jsx)("div",{className:vge,children:(0,e.jsxs)(ml,{onSelect:f,className:hge,children:[(0,e.jsx)("div",{className:mge,children:(0,e.jsx)(Ks.Transport.LEGEND_STOPS,{hash:r})}),a===Lge.Stops&&g]})}),(0,e.jsx)("div",{className:vge,children:(0,e.jsxs)(ml,{onSelect:h,className:hge,children:[(0,e.jsx)("div",{className:mge,children:(0,e.jsx)(Ks.Transport.LEGEND_VEHICLES,{hash:r})}),a===Lge.Vehicles&&g]})}),(0,e.jsx)("div",{className:vge,children:(0,e.jsxs)(ml,{onSelect:m,className:hge,children:[(0,e.jsx)("div",{className:mge,children:o?(0,e.jsx)(Ks.Transport.LEGEND_CARGO,{}):(0,e.jsx)(Ks.Transport.LEGEND_PASSENGERS,{hash:r})}),a===Lge.Cargo&&g]})}),(0,e.jsx)("div",{className:vge,children:(0,e.jsxs)(ml,{onSelect:p,className:hge,children:[(0,e.jsx)("div",{className:mge,children:(0,e.jsx)(Ks.Transport.LEGEND_USAGE,{})}),a===Lge.Usage&&g]})}),(0,e.jsx)("div",{className:pge}),(0,e.jsx)("div",{className:pge}),(0,e.jsx)("div",{className:pge}),(0,e.jsx)("div",{className:pge,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Transport.TOOLTIP_VISIBLE,{hash:o?"Route":"Line"}),children:(0,e.jsx)(xl,{tinted:!0,src:s?"Media/Glyphs/EyeOpen.svg":"Media/Glyphs/EyeClosed.svg",onSelect:u,className:Oe()(hge,yge),onClick:Cm})})}),(0,e.jsx)("div",{className:pge}),(0,e.jsx)("div",{className:pge})]})})]})})};const Fge="transportation-overview-panel_VlO";var Gge=[za.PublicTransport,za.Cargo],Vge=function(t){var n,r,o,a,l=t.selectedTab,s=t.onSelectTab,c=t.onClose;uu(null===(n=TS.value)||void 0===n?void 0:n.transportationOverviewPanel);var u=C(gle),d=C(yle),f=C(ble),h=C(xle),m=C(_le),p=(0,i.useMemo)((function(){return l===za.Cargo?d:u}),[l,d,u]),v=(0,i.useMemo)((function(){return l===za.Cargo?m:h}),[m,l,h]),g=(0,i.useMemo)((function(){return l===za.Cargo?f.filter((function(e){var t;return null===(t=e.lineData)||void 0===t?void 0:t.isCargo})).filter((function(e){var t;return(null===(t=e.lineData)||void 0===t?void 0:t.type)===m})):f.filter((function(e){var t;return!(null===(t=e.lineData)||void 0===t?void 0:t.isCargo)})).filter((function(e){var t;return(null===(t=e.lineData)||void 0===t?void 0:t.type)===h}))}),[m,l,h,f]),y=(0,i.useCallback)((function(){c(),Ple()}),[c]),b=FM("Cargo Transport");return(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.transportationOverviewPanel,children:(0,e.jsx)($r,{header:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Transport.LINES_OVERVIEW_TITLE,{})}),(0,e.jsxs)(ZN,{children:[(0,e.jsx)(JN,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.transportationOverviewPanelTabPublicTransport,id:za.PublicTransport,selectedId:l,onSelect:s,children:(0,e.jsx)(Ks.Transport.TAB,{hash:za[za.PublicTransport]})}),(0,e.jsx)(x7,{locked:b.locked,requirements:b.requirements,children:(0,e.jsx)(JN,{uiTag:null===(a=TS.value)||void 0===a?void 0:a.transportationOverviewPanelTabCargo,disabled:b.locked,locked:b.locked,id:za.Cargo,selectedId:l,onSelect:s,children:(0,e.jsx)(Ks.Transport.TAB,{hash:za[za.Cargo]})})})]})]}),className:Fge,transitionSounds:en,onClose:y,children:(0,e.jsx)(QN,{tabs:Gge,selectedTab:l,onSelect:s,children:(0,e.jsx)(Dge,{lines:g,types:p,selectedType:v,setSelectedType:l===za.Cargo?Lle:Ale,cargo:l===za.Cargo},l)})})})};const Bge={"game-main-screen":"game-main-screen_TRK child-opacity-transition_nkS",gameMainScreen:"game-main-screen_TRK child-opacity-transition_nkS","main-container":"main-container__E2",mainContainer:"main-container__E2","main-column":"main-column_g42",mainColumn:"main-column_g42","action-hints":"action-hints_sBV",actionHints:"action-hints_sBV","center-panel-layout":"center-panel-layout_X2p",centerPanelLayout:"center-panel-layout_X2p","info-menu-layout":"info-menu-layout_E8i",infoMenuLayout:"info-menu-layout_E8i","info-layout":"info-layout_BVk",infoLayout:"info-layout_BVk","tool-options-visible":"tool-options-visible_EaE",toolOptionsVisible:"tool-options-visible_EaE","infoview-menu":"infoview-menu_VQI",infoviewMenu:"infoview-menu_VQI","selected-info-panel":"selected-info-panel_iIe",selectedInfoPanel:"selected-info-panel_iIe","tool-layout":"tool-layout_SqM",toolLayout:"tool-layout_SqM","tool-side-column":"tool-side-column_l9i",toolSideColumn:"tool-side-column_l9i","tool-main-column":"tool-main-column_PaC",toolMainColumn:"tool-main-column_PaC","tool-panel":"tool-panel_V_j",toolPanel:"tool-panel_V_j","social-panel-layout":"social-panel-layout_JFt",socialPanelLayout:"social-panel-layout_JFt","emergency-mode":"emergency-mode_zZ8",emergencyMode:"emergency-mode_zZ8","photo-mode-panel-layout":"photo-mode-panel-layout_poh",photoModePanelLayout:"photo-mode-panel-layout_poh","radio-panel":"radio-panel_otL",radioPanel:"radio-panel_otL","bp-indicator":"bp-indicator_dvA",bpIndicator:"bp-indicator_dvA","pause-menu-layout":"pause-menu-layout_eGE",pauseMenuLayout:"pause-menu-layout_eGE","advisor-menu-toggle":"advisor-menu-toggle_Fpe",advisorMenuToggle:"advisor-menu-toggle_Fpe","pause-overlay":"pause-overlay_rOw",pauseOverlay:"pause-overlay_rOw",paused:"paused_kMX","tutorials-renderer":"tutorials-renderer_uj6",tutorialsRenderer:"tutorials-renderer_uj6"};function Hge(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var Kge,Wge=(Hge(Kge={},La.InfoviewMenu,(function(t){var n=t.onClose;return(0,e.jsx)("div",{className:Bge.infoLayout,children:(0,e.jsx)(jse,{className:Bge.infoviewMenu,onClose:n})})})),Hge(Kge,La.Progression,(function(t){var n=t.selectedTab,r=t.onClose;return(0,e.jsx)("div",{className:Bge.centerPanelLayout,children:(0,e.jsx)(lpe,{selectedTab:n,onSelectTab:Ha,onClose:r})})})),Hge(Kge,La.Economy,(function(t){var n=t.selectedTab,r=t.onClose;return(0,e.jsx)("div",{className:Bge.centerPanelLayout,children:(0,e.jsx)(Vie,{selectedTab:n,onSelectTab:Wa,onClose:r})})})),Hge(Kge,La.CityInfo,(function(t){var n=t.selectedTab,r=t.onClose;return(0,e.jsx)("div",{className:Bge.centerPanelLayout,children:(0,e.jsx)(eee,{selectedTab:n,onSelectTab:Ya,onClose:r})})})),Hge(Kge,La.Statistics,(function(t){var n=t.onClose;return(0,e.jsx)("div",{className:Bge.centerPanelLayout,children:(0,e.jsx)(Jve,{onClose:n})})})),Hge(Kge,La.TransportationOverview,(function(t){var n=t.selectedTab,r=t.onClose;return(0,e.jsx)("div",{className:Bge.centerPanelLayout,children:(0,e.jsx)(Vge,{selectedTab:n,onSelectTab:Xa,onClose:r})})})),Hge(Kge,La.Chirper,(function(t){var n=t.onClose;return(0,e.jsx)(Yge,{children:(0,e.jsx)(p7,{onClose:n})})})),Hge(Kge,La.LifePath,(function(t){var n=t.selectedEntity,r=t.onClose;return(0,e.jsx)(Yge,{children:(0,e.jsx)(wce,{selectedCitizen:n,onClose:r})})})),Hge(Kge,La.Journal,(function(t){var n=t.onClose;return(0,e.jsx)(Yge,{children:(0,e.jsx)(ooe,{onClose:n})})})),Hge(Kge,La.Radio,(function(t){var n=t.onClose;return(0,e.jsx)(Qpe,{className:Bge.radioPanel,onClose:n})})),Hge(Kge,La.PhotoMode,(function(t){var n=t.onClose;return(0,e.jsx)(Xge,{children:(0,e.jsx)(hfe,{onClose:n})})})),Hge(Kge,La.Notifications,(function(t){var n=t.onClose;return(0,e.jsx)(Yge,{children:(0,e.jsx)(Ace,{onClose:n})})})),Kge),zge=function(t){var n=t.panel,r=(0,i.useCallback)((function(){return Ga(n.__Type)}),[n.__Type]);return(0,e.jsx)(Gh,{components:Wge,data:n,props:{onClose:r}})},Yge=function(t){var n=t.children,r=C(XM);return(0,e.jsx)("div",{className:Oe()(Bge.socialPanelLayout,r&&Bge.emergencyMode),children:n})},Xge=function(t){var n=t.children;return(0,e.jsx)("div",{className:Oe()(Bge.photoModePanelLayout),children:n})};const qge={"infoview-menu-toggle":"infoview-menu-toggle_bYF",infoviewMenuToggle:"infoview-menu-toggle_bYF",button:"button_H9N","mini-panel-visible":"mini-panel-visible_mDg",miniPanelVisible:"mini-panel-visible_mDg","active-infoview":"active-infoview_J2h",activeInfoview:"active-infoview_J2h",exit:"exit_Oop","enter-active":"enter-active_Wti",enterActive:"enter-active_Wti",enter:"enter_zBP","exit-active":"exit-active__MZ",exitActive:"exit-active__MZ",label:"label_UhV","close-button":"close-button_TMO",closeButton:"close-button_TMO",lock:"lock_Mbc"};var $ge=function(t){var n,r=t.miniPanelVisible,o=t.className,a=ni(C(Ra),La.InfoviewMenu),l=C(ai),s=FM("Infoviews"),c=(0,i.useCallback)((function(){var e;!a&&(null===(e=TS.value)||void 0===e?void 0:e.infoviewsButton)&&lu(TS.value.infoviewsButton),l&&!a?si():ni(Ra.value,La.InfoviewMenu)?(si(),Ga(La.InfoviewMenu)):Fa(La.InfoviewMenu)}),[l,a]),u=cr();return(0,e.jsxs)("div",{className:Oe()(qge.infoviewMenuToggle,r&&qge.miniPanelVisible,o),children:[(0,e.jsx)(nO,{children:null!=l&&r&&(0,e.jsx)($t,{styles:qge,children:(0,e.jsxs)("div",{className:qge.activeInfoview,children:[(0,e.jsx)("div",{className:qge.label,children:(0,e.jsx)(Ks.Infoviews.INFOVIEW,{hash:l.id})}),!u&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Infoviews.CLOSE_INFO_VIEW,{}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:_l,className:qge.closeButton,onSelect:si})})]})})}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.infoviewsButton,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_INFO_VIEWS,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_INFO_VIEWS,{}),requirements:s.requirements,locked:s.locked,children:(0,e.jsx)(F8,{src:"Media/Glyphs/Info.svg",className:qge.button,selected:a,onSelect:c,disabled:s.locked,children:s.locked&&(0,e.jsx)(YN,{className:qge.lock})})})})]})};const Qge={field:"field_eZ6",header:"header_oa2",icon:"icon_t1n",label:"label_pzR",content:"content_DHv",error:"error_XxO"},Zge={section:"section_JVp",resources:"resources_F7B","resource-item":"resource-item_xdp",resourceItem:"resource-item_xdp","resource-icon":"resource-icon_sHE",resourceIcon:"resource-icon_sHE","resource-title":"resource-title_UvF",resourceTitle:"resource-title_UvF",purchase:"purchase_qTi","cost-row":"cost-row_F5P",costRow:"cost-row_F5P",button:"button_adT",problems:"problems_b5X",problem:"problem_d8F","cost-icon":"cost-icon_Tn1",costIcon:"cost-icon_Tn1","cost-icon-disabled":"cost-icon-disabled_Dzu",costIconDisabled:"cost-icon-disabled_Dzu",label:"label_ASS",field:"field_z8Y"};function Jge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function eye(e){return function(e){if(Array.isArray(e))return Jge(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Jge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Jge(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var tye={enter:Qt.mapTilePurchaseMode,exit:Qt.mapTilePurchaseModeEnd},nye=function(t){var n,r,o,a=t.focusKey,l=t.className,s=t.onClose;su(null===(n=TS.value)||void 0===n?void 0:n.mapTilePanel);var c=C(wM),u=C(NM),d=C(PM),f=C(AM)===TM.None,h=(0,i.useMemo)((function(){return{"Purchase Map Tile":f?function(){var e,t;Jt(Qt.purchase),DM(),(null===(e=TS.value)||void 0===e?void 0:e.mapTilePanelPurchase)&&lu(null===(t=TS.value)||void 0===t?void 0:t.mapTilePanelPurchase)}:null}}),[f]);return(0,e.jsx)(Tn,{actions:h,children:(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.mapTilePanel,children:(0,e.jsxs)($r,{focusKey:a,className:Oe()(Zge.mapTilePurchasePanel,l),header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.MapTilePurchase.TITLE,{})}),transitionSounds:tye,onClose:s,children:[(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.mapTilePanelResources,children:(0,e.jsx)("div",{className:Oe()(Zge.section,Zge.resources),children:[c,u].concat(eye(d)).map((function(t){return(0,e.jsx)(rye,{resource:t},t.id)}))})}),(0,e.jsx)(iye,{purchaseEnabled:f})]})})})},rye=function(t){var n=t.resource;return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.MapTilePurchase.TOOLTIP_TITLE_RESOURCE,{hash:n.id}),description:(0,e.jsx)(Ks.MapTilePurchase.TOOLTIP_RESOURCE,{hash:n.id}),children:(0,e.jsxs)("div",{className:Zge.resourceItem,children:[(0,e.jsxs)("div",{className:Zge.resourceTitle,children:[(0,e.jsx)("img",{src:n.icon,className:Zge.resourceIcon}),(0,e.jsx)(Ks.MapTilePurchase.RESOURCE,{hash:n.id})]}),(0,e.jsx)("div",{className:Zge.resourceValue,children:(0,e.jsx)(dc,{value:n.value,unit:n.unit})})]})})},iye=function(t){var n,r=t.purchaseEnabled,o=cr(),a=(0,i.useCallback)((function(){var e,t;DM(),(null===(e=TS.value)||void 0===e?void 0:e.mapTilePanelPurchase)&&lu(null===(t=TS.value)||void 0===t?void 0:t.mapTilePanelPurchase)}),[]);return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)("div",{className:Oe()(Zge.section,Zge.purchase),children:[(0,e.jsx)(oye,{}),!o&&(0,e.jsx)(xO,{tooltip:lye(AM.value),children:(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.mapTilePanelPurchase,children:(0,e.jsx)(ml,{focusKey:Te,theme:O1,selectSound:Qt.purchase,className:Zge.button,disabled:!r,onSelect:a,children:(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS,{hash:TM[TM.None]})})})})]}),o&&0!=(AM.value&(TM.InsufficientFunds|TM.InsufficientPermits))&&(0,e.jsx)("div",{className:Zge.problems,children:aye(AM.value)})]})},oye=function(){var t=C(LM),n=C(MM),r=C(CM),i=0!=(AM.value&TM.InsufficientFunds),o=0!=(AM.value&TM.InsufficientPermits),a=0!=(AM.value&TM.NoSelection);return(0,e.jsx)("div",{className:Zge.costRow,children:a?aye(TM.NoSelection):(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(E1,{theme:Qge,label:(0,e.jsx)(Ks.MapTilePurchase.PERMITS_USED,{}),icon:"Media/Game/Icons/ExpansionPermit.svg",className:Oe()(Zge.field,o&&Qge.error),children:(0,e.jsx)(ah,{value:n,total:t})}),(0,e.jsx)(E1,{theme:Qge,label:(0,e.jsx)(Ks.MapTilePurchase.COST,{}),icon:"Media/Game/Icons/Money.svg",className:Oe()(Zge.field,i&&Qge.error),children:(0,e.jsx)(dc,{value:r,unit:tc.Money})})]})})};function aye(t){switch(t){case TM.NoSelection:return(0,e.jsx)("div",{className:Zge.problem,children:(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS,{hash:TM[TM.NoSelection]})});case TM.InsufficientPermits|TM.InsufficientFunds:return(0,e.jsx)("div",{className:Zge.problem,children:(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS,{hash:"".concat(TM[TM.InsufficientPermits]).concat(TM[TM.InsufficientFunds])})});case TM.InsufficientPermits:return(0,e.jsx)("div",{className:Zge.problem,children:(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS,{hash:TM[TM.InsufficientPermits]})});case TM.InsufficientFunds:return(0,e.jsx)("div",{className:Zge.problem,children:(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS,{hash:TM[TM.InsufficientFunds]})})}}function lye(t){switch(t){case TM.NoSelection:return(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:TM[TM.NoSelection]});case TM.InsufficientPermits|TM.InsufficientFunds:return(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:"".concat(TM[TM.InsufficientPermits]).concat(TM[TM.InsufficientFunds])});case TM.InsufficientPermits:return(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:TM[TM.InsufficientPermits]});case TM.InsufficientFunds:return(0,e.jsx)(Ks.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:TM[TM.InsufficientFunds]})}}const sye="button-row_Idj";var cye=function(t){var n=t.className,r=t.children;return(0,e.jsx)("div",{className:Oe()(sye,n),children:r})};const uye="milestone-trophy-animation_ZMt",dye="waterdrop_Qpf",fye="two_RoL",hye="three_pjZ",mye="trophy_RwE";var pye=function(t){var n=t.className;return(0,e.jsxs)("div",{className:Oe()(uye,n),children:[(0,e.jsx)("div",{className:dye}),(0,e.jsx)("div",{className:Oe()(dye,fye)}),(0,e.jsx)("div",{className:Oe()(dye,hye)}),(0,e.jsx)("img",{src:"Media/Game/Icons/Trophy.svg",className:mye})]})};const vye="milestone-unlock-event-panel_zd2",gye="title_K9M",yye="title-primary_m30",bye="title-secondary_mRY",xye="header_Uqs",_ye="cityscape_b4P",jye="trophy_Q30",Eye="city-title_U_b",Oye="description_Iei",Tye="rewards-label_q85",Iye="rewards_cr_",Sye="reward-field_v6Q",wye="actions_YbO";var Nye=new Se("continueButton"),Pye=function(t){var n,r=t.focusKey,o=t.milestone,a=t.onClose,l=(0,i.useCallback)((function(){a(),Ha(Ma.Milestones)}),[a]),s=null!==(n=M(D3,o))&&void 0!==n?n:S3;return(0,i.useEffect)((function(){Jt(Qt.milestoneEvent)}),[]),(0,e.jsx)("div",{className:vye,children:(0,e.jsx)(wn,{onAction:a,children:(0,e.jsxs)(Fn,{focusKey:r,initialFocused:Nye,children:[(0,e.jsxs)("div",{className:gye,children:[(0,e.jsx)("div",{className:yye,children:(0,e.jsx)(Ks.Progression.MILESTONE_UNLOCK_PANEL_TITLE_PRIMARY,{INDEX:(0,e.jsx)(dc,{value:s.index,unit:tc.Integer})})}),(0,e.jsx)("div",{className:bye,children:(0,e.jsx)(Ks.Progression.MILESTONE_UNLOCK_PANEL_TITLE_SECONDARY,{})})]}),(0,e.jsxs)("div",{className:xye,children:[(0,e.jsx)("img",{src:s.image,className:_ye}),(0,e.jsx)(pye,{className:jye})]}),(0,e.jsx)("div",{className:Eye,children:(0,e.jsx)(Ks.Progression.MILESTONE_NAME,{index:s.index})}),(0,e.jsx)("div",{className:Oye,children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Progression.MILESTONE_DESCRIPTION,{index:s.index})})}),(0,e.jsx)("div",{className:Tye,children:(0,e.jsx)(Ks.Progression.MILESTONE_REWARDS_LABEL,{})}),(0,e.jsxs)("div",{className:Iye,children:[s.reward>0&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Progression.REWARD_FIELD_LABEL,{}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/Money.svg",className:Sye,children:(0,e.jsx)(dc,{value:s.reward,unit:tc.Money})})}),s.devTreePoints>0&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Progression.DEVELOPMENT_POINTS_FIELD_LABEL,{}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/DevPoint.svg",className:Sye,children:(0,e.jsx)(dc,{value:s.devTreePoints,unit:tc.Integer,signed:!0})})}),s.mapTiles>0&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Progression.MAP_TILES_FIELD_LABEL,{}),children:(0,e.jsx)(E1,{icon:"Media/Game/Icons/ExpansionPermit.svg",className:Sye,children:(0,e.jsx)(dc,{value:s.mapTiles,unit:tc.Integer,signed:!0})})})]}),(0,e.jsxs)(cye,{className:wye,children:[(0,e.jsx)(ml,{theme:Ad,onSelect:l,children:(0,e.jsx)(Ks.Progression.PROGRESSION_PANEL_BUTTON,{})}),(0,e.jsx)(ml,{focusKey:Nye,theme:Ad,onSelect:a,children:(0,e.jsx)(Ks.Common.CLOSE,{})})]})]})})})};const Cye="signature-unlock-event-panel_f8P",Aye="image_Pwi",Lye="content_vd9",Mye="title_vLU",Rye="description_cRG",kye="stats_FqV",Dye="stat-field_yOa",Uye="actions_kVJ";function Fye(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Gye(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Fye(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Fye(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Vye=function(t){var n,r,o=t.focusKey,a=t.entities,l=t.onClose,s=Gye((0,i.useState)(0),2),c=s[0],u=s[1],d=a.length>c?a[c]:ii,f=null!==(n=M(OS,d))&&void 0!==n?n:IS;return(0,i.useEffect)((function(){return Jt(Qt.signatureBuildingEvent)}),[]),(0,i.useEffect)((function(){a.length<=c&&(a.length>0?u(0):l())}),[c,a.length,l]),(0,e.jsx)($r,{focusKey:o,theme:Qr,header:(0,e.jsx)(Tl,{icon:"Media/Game/Icons/ZoneSignature.svg",children:(0,e.jsx)(Ks.Progression.BUILDING_UNLOCK_EVENT_PANEL_TITLE,{})}),className:Cye,onClose:l,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(BE,{src:null!==(r=null==f?void 0:f.preview)&&void 0!==r?r:"",className:Aye}),(0,e.jsxs)("div",{className:Lye,children:[(0,e.jsx)("div",{className:Mye,children:(0,e.jsx)(Ss,{id:f.titleId})}),f.descriptionId&&(0,e.jsx)("div",{className:Rye,children:(0,e.jsx)(Ss,{id:f.descriptionId})}),(0,e.jsx)("div",{className:kye,children:null!=f.constructionCost&&(0,e.jsx)(E1,{label:(0,e.jsx)(Ks.Properties.CONSTRUCTION_COST,{}),className:Dye,children:(0,e.jsx)(dc,{value:"number"==typeof f.constructionCost.value?f.constructionCost.value:f.constructionCost.value.y,unit:f.constructionCost.unit})})}),(0,e.jsx)(cye,{className:Uye,children:(0,e.jsx)(ml,{theme:Ad,onSelect:l,children:(0,e.jsx)(Ks.Common.OK,{})})})]})]})})};function Bye(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Hye(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Bye(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Bye(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}const Kye=function(e){var t=Hye((0,i.useState)(),2),n=t[0],r=t[1];return(0,i.useEffect)((function(){var t=0,n=function(){e.current?r(e.current.getBoundingClientRect()):r(void 0),t=window.requestAnimationFrame(n)};return setTimeout((function(){return n()}),0),function(){return window.cancelAnimationFrame(t)}}),[e]),n},Wye={scrollable:"scrollable_A57",value:"value_GiO",button:"button_kAx"},zye={section:"section_Czw section_gUk","title-bar":"title-bar_tE1 title-bar_wU9",titleBar:"title-bar_tE1 title-bar_wU9",expandable:"expandable_HXj",title:"title_dyN title_bwV",content:"content_YjM content_owQ"};var Yye=function(t){var n=t.item,r=(0,i.useCallback)((function(){null!=n.entity&&zq(n.entity)}),[n.entity]);return(0,e.jsx)(ml,{className:Oe()(Wye.button,null!=(null==n?void 0:n.entity)&&Wye.link),disabled:null==(null==n?void 0:n.entity)||0===(null==n?void 0:n.entity.index),onSelect:r,children:n.text})};function Xye(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var qye,$ye=function(t){var n=t.focusKey,r=t.subsections;return(0,e.jsx)(mf,{className:Wye.scrollable,children:(0,e.jsx)(Fn,{focusKey:n,children:(0,e.jsx)(Vh,{components:Qye,data:r})})})},Qye=(Xye(qye={},Aq.GenericInfo,(function(t){var n=t.label,r=t.value,o=t.target,a=(0,i.useCallback)((function(){null!=o&&zq(o)}),[o]);return(0,e.jsx)(CO,{className:Wye.genericInfo,theme:zye,header:(0,e.jsx)(fne,{children:n}),children:(0,e.jsx)(ml,{className:Oe()(Wye.button,null!=o&&Wye.link),disabled:null==o||0===(null==o?void 0:o.index),onSelect:a,children:r})})})),Xye(qye,Aq.CapacityInfo,(function(t){var n=t.label,r=t.value,i=t.max;return(0,e.jsx)(CO,{header:(0,e.jsx)(fne,{children:n}),theme:zye,className:Wye.capacityInfo,children:(0,e.jsx)(lne,{progress:r,max:i,children:"".concat(r,"/").concat(i)})})})),Xye(qye,Aq.InfoList,(function(t){var n=t.label,r=t.list;return(0,e.jsx)(dne,{header:(0,e.jsx)(fne,{children:n}),theme:zye,className:Wye.infoList,transition:null,children:(0,e.jsx)(Fn,{children:r.map((function(t,n){return(0,e.jsx)(Yye,{item:t},n)}))})})})),qye);const Zye="developer-info-panel_GEQ";function Jye(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ebe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Jye(e,t,n[t])}))}return e}var tbe=function(t){var n=t.onClose,r=t.developerInfoSection,o=C(fR),a=(0,i.useRef)(null),l=function(e){var t=C(kq),n=zd(),r=qd();if(e&&t&&n)return{x:Math.trunc(at(t.x*n.x+10*r,0,n.x-e.width-70)),y:Math.trunc(at((1-t.y)*n.y+10*r,90,n.y-e.height-120))};return}(Kye(a)),s=(0,i.useCallback)((function(){n()}),[n]);return(0,e.jsx)(e.Fragment,{children:"Default Tool"===o.id&&(0,e.jsx)($r,{ref:a,className:Zye,style:nbe(l),onClose:s,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.SelectedInfoPanel.DEVELOPER_INFO_TITLE,{})}),children:(0,e.jsx)($ye,ebe({},r))})})};function nbe(e){return e?{left:e.x+"px",top:e.y+"px"}:{visibility:"hidden"}}var rbe="DistrictsSection",ibe=E(rbe,"selecting"),obe=w(rbe,"removeDistrict"),abe=S(rbe,"toggleSelectionTool"),lbe=S(rbe,"toggleDistrictTool");function sbe(e,t,n,r,i,o){var a=fbe(r,i,n.position),l=12*o,s=(jbe/2+_be)*o,c=a.x+s,u=a.y+s;return(e-c)*(e-c)+(t-u)*(t-u)<=l*l}function cbe(e,t,n,r,i,o,a,l,s,c){var u=12*c,d=2*c,f=fbe(r,i,t.position),h=s?1.25*u:l?1.125*u:u,m=s?1.25*d:l?1.125*d:d,p=(jbe/2+_be)*c,v=n>0?Math.min(t.cargo/n,1):0,g=Math.sqrt(v)*(h-m),y={r:a.r,g:a.g,b:a.b,a:v},b=pm(o),x=pm(y);e.beginPath(),e.arc(f.x+p,f.y+p,h,2*Math.PI,0,!1),e.closePath(),e.fillStyle=b,e.fill(),e.beginPath(),e.arc(f.x+p,f.y+p,g,2*Math.PI,0,!1),e.closePath(),e.fillStyle=x,e.fill()}function ube(e,t,n,r,i,o,a,l){var s=fbe(o,a,n.position),c=hbe(l,r,i),u=hbe(l,r,i),d=(jbe/2+_be)*l;return function(e,t,n,r,i,o,a){var l=e-n,s=t-r;if(l*l+s*s>(o*o+a*a)/4)return!1;var c=Math.sin(-i),u=Math.cos(-i);return s=(l=l*u-s*c)*c+s*u,s+=r,(l+=n)>=n-o/2&&l<=n+o/2&&s>=r-a/2&&s<=r+o/2}(e,t,s.x+d,s.y+d,s.z,c,u)}function dbe(e,t,n,r,i,o,a,l,s){var c=2*s,u=3*s,d=fbe(n,r,t.position),f=hbe(s,l,a),h=function(e,t,n){return 26*e*(t?1.25:n?1.125:1)}(s,l,a),m=(jbe/2+_be)*s,p=f/2,v=h/2,g=t.capacity>0?t.cargo/t.capacity:0,y=6*Math.min(g,1),b=l?1.25*c:a?1.125*c:c,x=l?1.25*u:a?1.125*u:u,_=b/2+x,j=b+2*x,E=pm(i),O=pm(o);e.save(),e.translate(d.x+m,d.y+m),e.rotate(d.z),e.fillStyle=E,e.fillRect(-p,-v,f,h),y>0&&(e.beginPath(),e.moveTo(-_,-j),e.arc(-_,-j,x,0,2*Math.PI),y>1&&(e.moveTo(_,-j),e.arc(_,-j,x,0,2*Math.PI)),y>2&&(e.moveTo(-_,0),e.arc(-_,0,x,0,2*Math.PI)),y>3&&(e.moveTo(_,0),e.arc(_,0,x,0,2*Math.PI)),y>4&&(e.moveTo(-_,j),e.arc(-_,j,x,0,2*Math.PI)),y>5&&(e.moveTo(_,j),e.arc(_,j,x,0,2*Math.PI)),e.fillStyle=O,e.fill()),e.restore()}function fbe(e,t,n){var r=e*Math.PI,i=t-2*e,o=2*r+2*i,a=r/o,l=i/o;if(n<a/2){var s=Math.PI*n/a;return{x:e+e*Math.sin(s),y:e-e*Math.cos(s),z:s+Math.PI/2}}if((n-=a/2)<l)return{x:2*e,y:e+n/l*i,z:Math.PI};if((n-=l)<a){var c=Math.PI*(n/a+.5);return{x:e+e*Math.sin(c),y:e-e*Math.cos(c)+i,z:c+Math.PI/2}}if((n-=a)<l)return{x:0,y:e+i-n/l*i,z:0};n-=l;var u=Math.PI*(n/a+1.5);return{x:e+e*Math.sin(u),y:e-e*Math.cos(u),z:u+Math.PI/2}}function hbe(e,t,n){return 18*e*(t?1.25:n?1.125:1)}function mbe(e,t,n,r,i,o){o.broken?function(e,t,n,r,i,o,a,l){for(var s=r*Math.PI*2+2*(i-2*r),c=s/Math.max(2*Math.floor(s/(2*l)),2)/s,u=2*c,d=o-o%u;d<a;d+=u){pbe(e,t,n,r,i,Math.max(d,o),Math.min(d+c,a))}}(e,t,n,r,i,o.start,o.end,10):pbe(e,t,n,r,i,o.start,o.end)}function pbe(e,t,n,r,i,o,a){if(!(a<=o)){var l=r*Math.PI,s=i-2*r,c=2*l+2*s,u=l/c,d=s/c,f=a-o;a=(o=(o+u/2)%1)+f;for(var h=!0;!(!(a>0)||(o<u&&(vbe(e,t,n-s/2,Math.PI,r,o/u,a/u,h),h=!1),o-=u,(a-=u)<0)||(a>0&&o<d&&(gbe(e,t+r,n,-s,o/d,a/d,h),h=!1),o-=d,(a-=d)<0)||(o<u&&(vbe(e,t,n+s/2,0,r,o/u,a/u,h),h=!1),o-=u,(a-=u)<0));)a>0&&o<d&&(gbe(e,t-r,n,s,o/d,a/d,h),h=!1),o-=d,a-=d}}function vbe(e,t,n,r,i,o,a,l){var s=Math.PI*Math.max(o,0)+r,c=Math.max(Math.PI*Math.min(a,1),o)+r;l&&e.moveTo(t+i*Math.cos(s),n+i*Math.sin(s)),e.arc(t,n,i,s,c)}function gbe(e,t,n,r,i,o,a){if(a){var l=-r*at(i-.5,-.5,.5);e.moveTo(t,n+l)}var s=-r*at(o-.5,-.5,.5);e.lineTo(t,n+s)}function ybe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bbe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function xbe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ybe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ybe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var _be=20,jbe=8,Ebe=hm(255,255,255,.75),Obe=hm(255,255,255,1),Tbe=i.memo((function(t){var n=t.canvasHeight,r=t.canvasWidth,o=t.color,a=t.stops,l=t.vehicles,s=t.segments,u=t.stopCapacity,d=xbe((0,i.useState)(null),2),f=d[0],h=d[1],m=xbe((0,i.useState)(null),2),p=m[0],v=m[1],g=(0,i.useRef)(null),y=qd(),b=r,x=n,_=b/2,j=_be*y,E=jbe*y,O=(b-E-2*j)/2,T=x-2*j-E,I=C(Mq),S=(0,i.useCallback)((function(e){if(null!=g.current){for(var t=g.current.getBoundingClientRect(),n=e.clientX-t.left,r=e.clientY-t.top,i=0;i<a.length;i++){var o=a[i];if(sbe(n,r,o,O,T,y))return void zq(o.entity)}for(var s=0;s<l.length;s++){var c=l[s];if(ube(n,r,c,!!p&&p.entity===c.entity,!!f&&f.entity===c.entity,O,T,y))return void zq(c.entity)}}}),[f,T,O,y,p,a,l]),w=(0,i.useCallback)((function(e){if(null!=g.current){for(var t=g.current.getBoundingClientRect(),n=e.clientX-t.left,r=e.clientY-t.top,i=0;i<a.length;i++){var o=a[i];if(sbe(n,r,o,O,T,y))return void h(o)}for(var s=0;s<l.length;s++){var c=l[s];if(ube(n,r,c,!!p&&p.entity===c.entity,!!f&&f.entity===c.entity,O,T,y))return void h(c)}h(null)}}),[f,T,O,y,p,a,l]),N=(0,i.useCallback)((function(){h(null)}),[]);return(0,i.useEffect)((function(){var e=l.find((function(e){return c(e.entity,I)}))||a.find((function(e){return c(e.entity,I)}));v(void 0!==e?e:null)}),[I,a,l]),(0,i.useEffect)((function(){if(g.current){var e=g.current.getContext("2d");if(e.clearRect(0,0,b,x),e.save(),e.beginPath(),s&&s.length>0)for(var t=0;t<s.length;t++)mbe(e,b/2,x/2,O,T,s[t]);if(e.lineWidth=E,e.strokeStyle=pm(Ibe(null,p,f,o)),e.stroke(),l&&l.length>0)for(var n=0;n<l.length;n++){var r=l[n],i=Ibe(r,p,f,o),d=Ibe(r,p,f,Ebe);dbe(e,r,O,T,i,d,c(null==f?void 0:f.entity,r.entity),c(I,r.entity),y)}if(e.setTransform(1,0,0,1,0,0),a&&a.length>0)for(var h=0;h<a.length;h++){var m=a[h],v=Ibe(m,p,f,Obe),_=Ibe(m,p,f,o);cbe(e,m,u,O,T,v,_,c(null==f?void 0:f.entity,m.entity),c(I,m.entity),y)}}}),[o,x,f,T,O,j,_,y,s,I,u,a,E,l,b,p]),(0,e.jsx)(Nu,{tooltip:f&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(mL,{value:f.name}),(0,e.jsx)(u$,{left:f.isCargo?(0,e.jsx)(Ks.SelectedInfoPanel.CARGO_TOOLTIP,{}):(0,e.jsx)(Ks.SelectedInfoPanel.PASSENGERS_TOOLTIP,{}),right:"Game.UI.InGame.LineVisualizerSection+LineStop"===f.__Type?(0,e.jsx)(dc,{value:f.cargo,unit:f.isCargo?tc.Weight:tc.Integer}):(0,e.jsx)(ah,{value:f.cargo,total:f.capacity,unit:f.isCargo?tc.Weight:tc.Integer})})]}),children:(0,e.jsx)("canvas",{ref:g,width:b,height:x,onClick:S,onMouseMove:w,onMouseLeave:N})})}),(function(e,t){var n=e.vehicles,r=e.stops,i=bbe(e,["vehicles","stops"]),o=t.vehicles,a=t.stops,l=bbe(t,["vehicles","stops"]);return function(e,t){if(e.length!==t.length)return!1;for(var n=0;n<t.length;n++){if(t[n].position!==e[n].position)return!1;if(t[n].cargo!==e[n].cargo)return!1;if(t[n].capacity!==e[n].capacity)return!1;if(!c(t[n].entity,e[n].entity))return!1;if(!gL(t[n].name,e[n].name))return!1}return!0}(n,o)&&function(e,t){if(e.length!==t.length)return!1;for(var n=0;n<t.length;n++){if(t[n].position!==e[n].position)return!1;if(t[n].cargo!==e[n].cargo)return!1;if(!c(t[n].entity,e[n].entity))return!1;if(!gL(t[n].name,e[n].name))return!1}return!0}(r,a)&&f(i,l,3)}));function Ibe(e,t,n,r){return null==t||c(null==e?void 0:e.entity,t.entity)?null==n||c(null==e?void 0:e.entity,n.entity)?r:Sbe(-.35,r):null!=n&&c(null==e?void 0:e.entity,n.entity)?r:Sbe(-.5,r)}function Sbe(e,t){var n=[t.r,t.g,t.b,t.a],r=e<0,i=r?0:e,o=r?1+e:1-e;return{r:n[0]*o+i,g:n[1]*o+i,b:n[2]*o+i,a:n[3]}}const wbe="line-visualizer-section_MKT",Nbe="gamepad-active_YL5",Pbe="track-container_c4L";function Cbe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Abe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Cbe(e,t,n[t])}))}return e}function Lbe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Mbe=function(t){var n,r=t.focusKey,o=t.stops,a=Lbe(t,["focusKey","stops"]),l=cr(),s=(0,i.useRef)(null),c=ft(null!==(n=Fd(s))&&void 0!==n?n:ct);return(0,e.jsx)($r,{focusKey:r,header:(0,e.jsx)(Tl,{children:o.find((function(e){return e.isCargo}))?(0,e.jsx)(Ks.SelectedInfoPanel.ROUTE,{}):(0,e.jsx)(Ks.SelectedInfoPanel.LINE,{})}),className:Oe()(wbe,l&&Nbe),children:(0,e.jsx)("div",{ref:s,className:Pbe,children:c.x>0&&c.y>0&&(0,e.jsx)(Tbe,Abe({canvasWidth:c.x,canvasHeight:c.y,stops:o},a))})})};const Rbe={"attractiveness-factors":"attractiveness-factors_CDA",attractivenessFactors:"attractiveness-factors_CDA",positive:"positive_KO_",negative:"negative_gWG"};var kbe=Os("LocalizedDuration",(function(t,n){var r=n.value,i=n.daysPerYear,o=n.maxMonths,a=void 0===o?i:o,l=Math.round(r);if(l>=a){var s=Math.round(r/i);return 1!==s?Ks.Common.VALUE_YEARS.renderString(t,{VALUE:(0,e.jsx)(dc,{value:s,unit:tc.Integer})}):Ks.Common.VALUE_YEAR.renderString(t,{VALUE:(0,e.jsx)(dc,{value:s,unit:tc.Integer})})}if(l>1)return Ks.Common.VALUE_MONTHS.renderString(t,{VALUE:(0,e.jsx)(dc,{value:r,unit:tc.Integer})});if(r>23.5/24)return Ks.Common.VALUE_MONTH.renderString(t,{VALUE:(0,e.jsx)(dc,{value:r,unit:tc.Integer})});var c=Math.floor(24*r),u=Math.floor(60*(24*r-c));return Ks.Common.TIME_FORMAT.renderString(t,{HOUR:zs(c,2),MINUTE:zs(u,2)})}),(function(e,t){return e.value===t.value&&e.daysPerYear===t.daysPerYear}));const Dbe={"capacity-bar":"capacity-bar_uEN",capacityBar:"capacity-bar_uEN","progress-bar":"progress-bar_AtB",progressBar:"progress-bar_AtB",excellent:"excellent_cFG",good:"good_f9U",medium:"medium_P2l",bad:"bad_BRS",critical:"critical_cqP","progress-bounds":"progress-bounds_D6g",progressBounds:"progress-bounds_D6g",progress:"progress_EvF",label:"label_y0j","progress-label":"progress-label_DqS",progressLabel:"progress-label_DqS"};var Ube=function(t){var n=t.progress,r=t.max,i=t.plain,o=void 0!==i&&i,a=t.invertColorCodes,s=void 0!==a&&a,c=t.children,u=t.className,d=r>0?100*at(n/r,0,1):0,f=C(Mq);return(0,e.jsx)("div",{className:Oe()(Dbe.capacityBar,u),children:(0,e.jsx)(lne,{progress:n,max:r,theme:Dbe,className:Oe()(!o&&Fbe(d,s)),children:c},l(f))})};function Fbe(e,t){return e>90?t?Dbe.excellent:Dbe.critical:e>80?t?Dbe.good:Dbe.bad:e>50?Dbe.medium:e>20?t?Dbe.bad:Dbe.good:t?Dbe.critical:Dbe.excellent}const Gbe="icon_BF2",Vbe="concatenator_bTa";const Bbe="description-row_Xb1 info-row_QQ9 item-focused_FuT";var Hbe=function(t){var n=t.children;return(0,e.jsx)("div",{className:Bbe,children:n})};const Kbe={button:"button_ibf button_YEx item-states_QjV toggle-states_oKG",icon:"icon__uJ icon_vbQ",label:"label_KgQ"},Wbe="info-button_n9m",zbe="button_hTp";var Ybe=function(t){var n=t.label,r=t.icon,i=t.selected,o=t.onSelect;return(0,e.jsx)("div",{className:Wbe,children:r?(0,e.jsx)(CN,{src:r,selected:i,onSelect:o,onClick:Cm,className:zbe,theme:Kbe,children:n}):(0,e.jsx)(ml,{selected:i,onSelect:o,onClick:Cm,className:zbe,theme:Kbe,children:n})})},Xbe=E("DestroyedBuildingSection","rebuilding");const qbe="info-link_Mpc item-focused_FuT",$be="row_Q8R",Qbe="ellipsis_C0N",Zbe="uppercase_qZ8",Jbe="icon_hE2";var exe=function(t){var n=t.icon,r=t.tooltip,i=t.uppercase,o=void 0!==i&&i,a=t.onSelect,l=t.children;return(0,e.jsx)(xO,{tooltip:r,children:(0,e.jsxs)(ml,{onSelect:a,onClick:Cm,className:Oe()($be,qbe,o&&Zbe),children:[(0,e.jsx)("img",{src:"Media/Glyphs/ViewInfo.svg",className:Jbe}),n&&(0,e.jsx)("img",{src:n,className:Jbe}),(0,e.jsx)("div",{className:Qbe,children:l})]})})};const txe="districts-section_UaO",nxe="details_abN",rxe="delete-button_UKV";var ixe=function(t){var n=t.district,r=(0,i.useCallback)((function(){return zq(n.entity)}),[n]),o=(0,i.useCallback)((function(){return obe(n.entity)}),[n]),a=(0,i.useMemo)((function(){return{Select:function(){Jt(Qt.selectItem),r()},"Remove Operating District":function(){Jt(Qt.removeItem),o()}}}),[o,r]),l=cr();return(0,e.jsx)(Tn,{actions:a,children:(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(mL,{value:n.name}),link:(0,e.jsx)(exe,{onSelect:r,children:(0,e.jsx)(Ks.SelectedInfoPanel.DETAILS,{})}),right:!l&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.SelectedInfoPanel.REMOVE_OPERATING_DISTRICT,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:Te,onClick:Cm,onSelect:o,src:"Media/Glyphs/Trash.svg",className:rxe})})})})};const oxe="efficiency-factors_QAK",axe="factor-item_vlO",lxe="name_enb",sxe="value_A66",cxe="result_QHn";var uxe=function(t){var n=t.factors;return(0,e.jsx)("div",{className:oxe,children:n.map((function(t,n){return(0,e.jsxs)("div",{className:axe,children:[(0,e.jsx)("div",{className:lxe,children:(0,e.jsx)(Ks.SelectedInfoPanel.EFFICIENCY_FACTORS,{hash:t.factor})}),(0,e.jsx)("div",{className:Oe()(sxe,Ef(Uae,t.value)),children:(0,e.jsx)(dc,{value:t.value,unit:tc.Percentage,signed:!0})}),(0,e.jsx)("div",{className:cxe,children:(0,e.jsx)(dc,{value:t.result,unit:tc.Percentage})})]},n)}))})};const dxe={"progress-bar":"progress-bar_H27 progress-bar_xWR",progressBar:"progress-bar_H27 progress-bar_xWR",progress:"progress_Yn6 progress_JAQ"},fxe="bar_PEM",hxe="level-segment_Reo",mxe="construction-segment_skQ",pxe="label_qUU";function vxe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function gxe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function yxe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){gxe(e,t,n[t])}))}return e}function bxe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function xxe(e){return function(e){if(Array.isArray(e))return vxe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return vxe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return vxe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var _xe=function(t){var n=t.level,r=t.maxLevel,o=t.isUnderConstruction,a=t.progress,l=(0,i.useMemo)((function(){return r-n}),[n,r]);return(0,e.jsxs)("div",{className:fxe,children:[(0,e.jsx)("div",{className:pxe,children:o?(0,e.jsx)(Boe,{value:a,max:100}):(0,e.jsx)(ah,{value:n,total:r,unit:tc.Integer})}),o?(0,e.jsx)(jxe,{progress:a,max:100,className:mxe}):(0,e.jsxs)(e.Fragment,{children:[xxe(Array(n).keys()).map((function(t){return(0,e.jsx)(jxe,{progress:100,className:hxe},t)})),l>0&&(0,e.jsx)(jxe,{progress:a,className:hxe}),l>1&&xxe(Array(l-1).keys()).map((function(t){return(0,e.jsx)(jxe,{progress:0,className:hxe},t)}))]})]})},jxe=function(t){var n=t.progress,r=t.max,i=void 0===r?100:r,o=t.className;return(0,e.jsx)(lne,{progress:n,max:i,className:o,theme:dxe})};const Exe="disabled__qz",Oxe="icon_rxa",Txe="indicator_DKN",Ixe="label_Pzb";var Sxe=function(t){var n=t.pollutionKey,r=t.icon;return(0,e.jsxs)("div",{className:Txe,children:[(0,e.jsx)("div",{className:Ixe,children:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS,{index:n})}),(0,e.jsx)("img",{src:r,className:Oe()(Oxe,wxe(0,n))}),(0,e.jsx)("img",{src:r,className:Oe()(Oxe,wxe(1,n))}),(0,e.jsx)("img",{src:r,className:Oe()(Oxe,wxe(2,n))})]})};function wxe(e,t){switch(t){case Pq.none:return Exe;case Pq.low:return e>0?Exe:void 0;case Pq.medium:return e>1?Exe:void 0;default:return}}var Nxe=function(t){var n=t.children,r=t.className;return(0,e.jsx)("div",{className:Oe()(g$,r),children:n})};const Pxe={field:"field_lUX",header:"header_WRn",icon:"icon__9P",label:"label_vVZ",content:"content_n5J",last:"last_uXj"};var Cxe=function(t){var n=t.upkeep,r=t.inactive;return(0,e.jsx)(d$,{left:Axe(n,r),right:(0,e.jsx)(dc,{value:n.price,unit:tc.Money})})};function Axe(t,n){return"Money"===t.localeKey?n?(0,e.jsx)(Ks.SelectedInfoPanel.UPKEEP_MAINTENANCE_INACTIVE,{BUILDING:(0,e.jsx)(Ss,{id:t.prefabNameID})}):(0,e.jsx)(Ks.SelectedInfoPanel.UPKEEP_MAINTENANCE,{BUILDING:(0,e.jsx)(Ss,{id:t.prefabNameID})}):(0,e.jsx)(Ks.SelectedInfoPanel.UPKEEPFORMAT,{RESOURCE:(0,e.jsx)(Ks.Resources.TITLE,{hash:t.localeKey}),AMOUNT:(0,e.jsx)(dc,{value:t.amount,unit:Lxe(t.localeKey)})})}function Lxe(e){switch(e){case"Money":return tc.Money;case"Telecom":case"Financial":case"Media":case"Entertainment":case"Recreation":return tc.Integer;default:return tc.Weight}}const Mxe="notification_CLy item-focused_FuT",Rxe="full-width_Qk1",kxe="icon_UMr",Dxe="label_RLF",Uxe="badge_ooc",Fxe="badge-icon_ubF";var Gxe=function(t){var n=t.notification;return(0,e.jsx)(xO,{direction:"right",tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Notifications.DESCRIPTION,{hash:n.key})}),children:(0,e.jsxs)(Tr,{className:Oe()(Mxe,Rxe),children:[(0,e.jsx)("img",{src:n.iconPath,className:kxe}),(0,e.jsxs)("div",{className:Dxe,children:[(0,e.jsx)(Ks.Notifications.TITLE,{hash:n.key}),n.count>1&&(0,e.jsx)(Wxe,{className:Uxe,children:(0,e.jsx)(dc,{value:n.count})})]})]})})},Vxe=function(t){var n=t.notification,r=t.tooltipTags,i=null==r?void 0:r.includes("Male");return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_HAPPINESS_DESCRIPTION,{hash:n.key})}),children:(0,e.jsxs)(Tr,{className:Mxe,children:[(0,e.jsx)("img",{src:n.iconPath,className:kxe}),(0,e.jsx)("div",{className:Dxe,children:i?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE_MALE,{hash:n.key}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE_FEMALE,{hash:n.key})})]})})})},Bxe=function(t){var n=t.notification;return(0,e.jsxs)(Tr,{className:Mxe,children:[(0,e.jsx)("img",{src:n.iconPath,className:kxe}),(0,e.jsx)("div",{className:Dxe,children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE,{hash:n.key})})]})},Hxe=function(t){var n=t.notification;return(0,e.jsxs)(Tr,{className:Mxe,children:[(0,e.jsx)("img",{src:n.iconPath,className:kxe}),(0,e.jsx)("div",{className:Dxe,children:(0,e.jsx)(Ks.SelectedInfoPanel.COMPANY_PROFITABILITY_TITLE,{hash:n.key})})]})},Kxe=function(t){var n=t.notification,r=t.tooltipTags,i=null==r?void 0:r.includes("Male");return(0,e.jsx)(e.Fragment,{children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_CONDITION_DESCRIPTION,{hash:n.key})}),children:(0,e.jsxs)(Tr,{className:Mxe,children:[(0,e.jsx)("img",{src:n.iconPath,className:kxe}),(0,e.jsx)("div",{className:Dxe,children:i?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_CONDITION_TITLE_MALE,{hash:n.key}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_CONDITION_TITLE_FEMALE,{hash:n.key})})]})})})},Wxe=function(t){var n=t.className,r=t.children;return(0,e.jsxs)("div",{className:Oe()(Uxe,n),children:[r,(0,e.jsx)(ll,{src:"Media/Game/Icons/Citizen.svg",className:Fxe})]})};const zxe={"status-section":"status-section_J1G notifications-section_cKq",statusSection:"status-section_J1G notifications-section_cKq",row:"row_Azp",bottom:"bottom_Xm5"};function Yxe(e){N("ColorSection","setColor",ri(e,"Game.UI.Common.UIColor"))}const Xxe="detail_dEX item-focused_FuT",qxe="toggle_MTW",$xe="button_UgX item-mouse-states_Fmi item-focused_FuT",Qxe="row_aZw",Zxe="focusable-toggle_EKK",Jxe="space-between_r5l",e_e="icon_BuO icon_hE2";var t_e=function(t){var n=t.line,r=C(Wq),o=(0,i.useMemo)((function(){return c(n.entity,r)}),[n.entity,r]),a=(0,i.useCallback)((function(){return zq(n.entity)}),[n.entity]),l=(0,i.useCallback)((function(){return Yq(n.entity)}),[n.entity]),s=(0,i.useMemo)((function(){return{Select:a,"Select Route":l}}),[a,l]),u=cr();return(0,e.jsx)(Or,{className:Oe()(Xxe,Qxe,Jxe),children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(Tn,{actions:s,children:(0,e.jsxs)(Tr,{className:Oe()(Zxe,Qxe),children:[(0,e.jsx)(cP,{focusKey:Te,className:qxe,onChange:l,checked:o,style:{borderColor:pm(n.color)}}),(0,e.jsx)(mL,{value:n.name})]})}),!u&&(0,e.jsxs)(ml,{onSelect:a,onClick:Cm,className:$xe,children:[(0,e.jsx)("img",{src:"Media/Glyphs/ViewInfo.svg",className:e_e}),(0,e.jsx)(Ks.SelectedInfoPanel.DETAILS,{})]})]})})},n_e=function(t){var n,r=t.building,o=(0,i.useCallback)((function(){return zq(r.entity)}),[r]);return(0,e.jsx)(u$,{subRow:!0,icon:null!==(n=r.serviceIcon)&&void 0!==n?n:void 0,left:(0,e.jsx)(mL,{value:r.name}),link:(0,e.jsx)(exe,{onSelect:o,children:(0,e.jsx)(Ks.SelectedInfoPanel.DETAILS,{})})})};const r_e="border-highlight_ze2";const i_e={button:"button_YEx item-states_QjV","toggle-states":"toggle-states_oKG",toggleStates:"toggle-states_oKG",icon:"icon_vbQ",locked:"locked_Q0p"};function o_e(e){N("ScheduleSection","setSchedule",e)}const a_e="buttons_XOL",l_e="button_kxx",s_e="left_X6Y",c_e="right_IAC",u_e="icon_Sz0";const d_e="route-slider__kp";function f_e(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function h_e(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return f_e(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return f_e(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function m_e(e){N("TicketPriceSection","setTicketPrice",e)}var p_e="ActionsSection",v_e=(E(p_e,"moveableObjectName"),E(p_e,"moving")),g_e=E(p_e,"editingLot"),y_e=S(p_e,"focus"),b_e=S(p_e,"toggleMove"),x_e=S(p_e,"follow"),__e=S(p_e,"delete"),j_e=S(p_e,"toggle"),E_e=S(p_e,"toggleEmptying"),O_e=S(p_e,"toggleLotTool");const T_e={button:"button_Z9O button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",icon:"icon_Tdt icon_soN icon_Iwk"},I_e="actions-section_X1x",S_e="button_xGY",w_e="toggle_LKL",N_e="off_X4Y",P_e="out-of-service_Kfh",C_e="label_y4N";var A_e=new Se("FOCUS_BUTTON");function L_e(e,t){return t.includes("TransportLine")?t.includes("CargoRoute")?e?"ReactivateCargoRoute":"DeactivateCargoRoute":e?"ReactivatePublicTransportLine":"DeactivatePublicTransportLine":e?"Reactivate":"Deactivate"}const M_e="description-section_wKs",R_e="description_jgm",k_e="effects-row_FPw";const D_e="notifications-section_cKq",U_e="factors_Y7i";const F_e={"foldout-item":"foldout-item_Ha3 foldout-item_wOF",foldoutItem:"foldout-item_Ha3 foldout-item_wOF",header:"header_o7z header_8H_ item-mouse-states_Fmi item-focused_FuT","disable-active-state":"disable-active-state_UBt disable-active-state_w8a",disableActiveState:"disable-active-state_UBt disable-active-state_w8a","disable-mouse-states":"disable-mouse-states_ivb disable-mouse-states_js5",disableMouseStates:"disable-mouse-states_ivb disable-mouse-states_js5","header-content":"header-content_t6v header-content_wUX",headerContent:"header-content_t6v header-content_wUX",icon:"icon_p5g icon_I32",toggle:"toggle_r8A toggle_yQv"},G_e="policy_oHN item-focused_FuT",V_e="pad-first_WSR",B_e="lock_uXt",H_e="compact_QL9",K_e="top_LI4 item-mouse-states_Fmi",W_e="expanded_g0B",z_e="active-disabled_HoS",Y_e="locked_ihM",X_e="bottom_qDc",q_e="disabled_NSK",$_e="icon_BTB",Q_e="label_obe",Z_e="slider-wrapper_Sx6",J_e="slider_jk5",eje="value_vMh",tje="checkbox_OrD",nje="space-between_mx0";function rje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ije(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return rje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return rje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var oje=function(t){var n,r,o=t.policy,a=t.className,l=t.onAdjust,s=ije((0,i.useState)(o.active),2),c=s[0],u=s[1],d=ije((0,i.useState)(null!==(r=null===(n=o.data)||void 0===n?void 0:n.value)&&void 0!==r?r:0),2),f=d[0],h=d[1],m=ije((0,i.useState)(!1),2),p=m[0],v=m[1],g=cr();(0,i.useEffect)((function(){var e,t,n=null!==(t=null===(e=o.data)||void 0===e?void 0:e.value)&&void 0!==t?t:0;p||f===n||h(n)}),[o,p,f]);var y=(0,i.useCallback)((function(){l(o.entity,!c,f),u(!c)}),[c,l,o,f]),b=(0,i.useCallback)((function(){v(!0)}),[]),x=(0,i.useCallback)((function(e){h(e),g&&l(o.entity,c,e)}),[c,g,l,o]),_=(0,i.useCallback)((function(){l(o.entity,c,f),v(!1)}),[c,l,o,f]),j=(0,i.useCallback)((function(){y(),Jt(Qt.selectItem)}),[y]),E=!o.locked&&o.active&&o.data&&f;return(0,e.jsx)(bS,{uiTag:o.uiTag,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Policy.TITLE,{hash:o.id}),description:(0,e.jsx)(Ks.Policy.DESCRIPTION,{hash:o.id}),locked:o.locked,direction:"right",requirements:o.requirements,children:(0,e.jsx)(Tr,{className:Oe()(G_e,a),children:(0,e.jsxs)(In,{onAction:j,children:[(0,e.jsx)(lje,{focusKey:E?Te:Ie,policy:o,active:c,onToggle:y,className:Oe()(K_e,E&&W_e)}),E&&o.data&&f&&(0,e.jsxs)("div",{className:X_e,children:[(0,e.jsx)("div",{className:Z_e,children:(0,e.jsx)(Fm,{value:f,start:o.data.range.min,end:o.data.range.max,gamepadStep:o.data.step,onDragStart:b,onDragEnd:_,onChange:x,disabled:!o.active,className:J_e})}),(0,e.jsx)("div",{className:eje,children:(0,e.jsx)(dc,{value:f,unit:o.data.unit})})]})]})})})})},aje=function(t){var n,r=t.policy,o=t.onAdjust,a=t.onMouseOver,l=t.onMouseLeave,s=ije((0,i.useState)(r.active),2),c=s[0],u=s[1],d=(0,i.useCallback)((function(){var e,t;o(r.entity,!c,null!==(t=null===(e=r.data)||void 0===e?void 0:e.value)&&void 0!==t?t:0),u(!c)}),[c,o,r.entity,null===(n=r.data)||void 0===n?void 0:n.value]);return(0,e.jsx)(bS,{uiTag:r.uiTag,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Policy.TITLE,{hash:r.id}),description:(0,e.jsx)(Ks.Policy.DESCRIPTION,{hash:r.id}),locked:r.locked,direction:"down",alignment:"end",requirements:r.requirements,children:(0,e.jsx)(lje,{compact:!0,onMouseOver:a,onMouseLeave:l,className:H_e,focusKey:Te,policy:r,active:c,onToggle:d})})})},lje=function(t){var n=t.focusKey,r=t.policy,o=t.active,a=t.compact,l=void 0!==a&&a,s=t.className,c=t.onToggle,u=t.onMouseOver,d=t.onMouseLeave,f=ije((0,i.useState)(!1),2),h=f[0],m=f[1],p=(0,i.useCallback)((function(){return m(!0)}),[]),v=(0,i.useCallback)((function(){return m(!1)}),[]);return(0,e.jsxs)(ml,{focusKey:n,onSelect:c,onClick:Cm,onMouseOver:u,onMouseLeave:d,selectSound:Qt.togglePolicy,disabled:r.locked,className:Oe()(r.locked&&Y_e,h&&z_e,s),children:[(0,e.jsx)("img",{src:r.icon,className:Oe()($_e,!r.locked&&!r.active&&q_e)}),r.locked&&(0,e.jsx)(YN,{className:B_e}),!l&&(0,e.jsxs)("div",{className:nje,children:[(0,e.jsx)("div",{className:Q_e,children:(0,e.jsx)(Ks.Policy.TITLE,{hash:r.id})}),!r.locked&&(0,e.jsx)(pp,{checked:o,focusKey:Te,className:tje,onMouseOver:p,onMouseLeave:v})]})]})},sje=function(t){var n=t.header,r=t.initialExpanded,i=t.expandFromContent,o=t.focusKey,a=t.tooltip,l=t.disableFocus,s=void 0!==l&&l,c=t.className,u=t.onToggleExpanded,d=t.children;return(0,e.jsx)(Ave,{header:(0,e.jsx)(xO,{tooltip:a,direction:"right",alignment:"center",children:(0,e.jsx)(Lve,{children:n})}),theme:F_e,initialExpanded:r,expandFromContent:i,onToggleExpanded:u,className:Oe()(f$,c),children:s?(0,e.jsx)(Or,{className:Oe()(h$,v$),children:(0,e.jsx)(Fn,{children:d})}):(0,e.jsx)(Tr,{focusKey:o,className:h$,children:(0,e.jsx)(Fn,{children:d})})})};const cje="compact-policies_qEr",uje="label_wgk";function dje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function fje(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return dje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return dje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var hje=function(t){var n=t.vehicle,r=(0,i.useCallback)((function(){return zq(n.entity)}),[n.entity]);return(0,e.jsx)(u$,{subRow:!0,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:n.vehicleKey})}),left:(0,e.jsx)(mL,{value:n.name}),link:(0,e.jsx)(exe,{onSelect:r,children:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:n.stateKey})})})};function mje(e){return"Water"===e?tc.Volume:tc.Weight}var pje;function vje(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var gje=(vje(pje={},Nq.Resource,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.resourceAmount,a=t.resourceKey,l=Qq(n,r,i);return(0,e.jsx)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.RESOURCE,{hash:a}),right:o})})})),vje(pje,Nq.LocalServices,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.localServiceBuildings,a=Qq(n,i,r);return(0,e.jsxs)(y$,{disableFocus:o.length>0,tooltip:a&&(0,e.jsx)(fI,{text:a}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.LOCAL_SERVICES_TITLE,{}),right:o.length}),o.length>0?(0,e.jsx)(Fn,{children:o.map((function(t,n){return(0,e.jsx)(n_e,{building:t},n)}))}):(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.LOCAL_SERVICES_NONE_ASSIGNED,{})})]})})),vje(pje,Nq.Actions,(function(t){var n=t.focusing,r=t.following,o=t.followable,a=t.moveable,l=t.deletable,s=t.disabled,c=t.disableable,u=t.emptying,d=t.emptiable,f=t.hasLotTool,h=t.focusKey,m=C(v_e),p=C(g_e),v=(0,i.useContext)(Rl),g=C(Sse),y=C(Pse),b=C(Kq),x=C(Rq),_=(0,i.useMemo)((function(){var e;return"".concat(null===(e=TS.value)||void 0===e?void 0:e.selectedInfoPanelDelete,"+").concat(x)}),[x]);uu(_,l);var j=(0,i.useCallback)((function(){v.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.SelectedInfoPanel.CONFIRM_DELETE_WARNING,{}),onConfirm:__e}))}),[v]),E=(0,i.useCallback)((function(){O_e()}),[]),O=(0,i.useMemo)((function(){return b.includes("Destroyed")}),[b]),T=(0,i.useCallback)((function(){return x_e()}),[]);return(0,e.jsx)("div",{className:I_e,children:(0,e.jsxs)(Fn,{focusKey:h,initialFocused:A_e,children:[(0,e.jsx)(jL,{title:n?(0,e.jsx)(Ks.SelectedInfoPanel.UNFOCUS,{}):(0,e.jsx)(Ks.SelectedInfoPanel.FOCUS,{}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:n?"ActionsSectionUnfocus":"ActionsSectionFocus"}),children:(0,e.jsx)(xl,{focusKey:A_e,theme:T_e,className:S_e,selected:n,src:"Media/Game/Icons/MapMarker.svg",onSelect:y_e,onClick:Cm})}),a&&(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionRelocate"}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ActionsSectionRelocate"}),children:(0,e.jsx)(xl,{theme:T_e,className:S_e,selected:m,disabled:O,src:"Media/Game/Icons/Relocate.svg",selectSound:Qt.relocateBuilding,onSelect:b_e,onClick:Cm})}),o&&(0,e.jsx)(jL,{title:r?(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionUnfollowCitizen"}):g.length===y?(0,e.jsx)(Ks.SelectedInfoPanel.MAX_FOLLOWED_CITIZENS_REACHED,{}):(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionFollowCitizen"}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:r?"ActionsSectionUnfollowCitizen":"ActionsSectionFollowCitizen"}),children:(0,e.jsx)(xl,{disabled:!r&&g.length===y,theme:T_e,selected:r,className:S_e,src:r?"Media/Game/Icons/Unfollow.svg":"Media/Game/Icons/Follow.svg",onSelect:T,onClick:Cm})}),d&&(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:u?"ActionsSectionStopEmptying":"ActionsSectionStartEmptying"}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:u?"ActionsSectionStopEmptying":"ActionsSectionStartEmptying"}),children:(0,e.jsx)(xl,{selected:u,disabled:O,theme:T_e,className:S_e,onSelect:E_e,onClick:Cm,src:"Media/Game/Icons/Empty.svg"})}),f&&(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionAreaTool"}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ActionsSectionAreaTool"}),children:(0,e.jsx)(xl,{selected:p,disabled:O,theme:T_e,className:S_e,onSelect:E,onClick:Cm,src:"Media/Game/Icons/LotTool.svg"})}),l&&(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionDelete"}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ActionsSectionDelete"}),children:(0,e.jsx)(bS,{uiTag:_,children:(0,e.jsx)(xl,{tinted:!0,theme:T_e,className:S_e,src:"Media/Glyphs/Trash.svg",onSelect:j,onClick:Cm})})}),c&&(0,e.jsxs)("div",{className:P_e,children:[s&&(0,e.jsx)("div",{className:C_e,children:(0,e.jsx)(Ks.SelectedInfoPanel.OUT_OF_SERVICE,{})}),(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP_TITLE,{hash:s?"Reactivate":"Deactivate"}),description:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:L_e(s,b)}),children:(0,e.jsx)(xl,{tinted:!0,src:"Media/Glyphs/OnOff.svg",theme:T_e,disabled:O,className:Oe()(S_e,w_e,s&&N_e),selectSound:s?Qt.enableBuilding:Qt.disableBuilding,onSelect:j_e,onClick:Cm})})]})]})})})),vje(pje,Nq.Description,(function(t){var n=t.localeKey,r=t.effects;return(0,e.jsxs)(y$,{focusKey:Te,className:M_e,children:[(0,e.jsx)("div",{className:R_e,children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Assets.DESCRIPTION,{hash:n})})}),r&&(0,e.jsx)("div",{className:k_e,children:(0,e.jsx)(Vh,{components:k4,data:r})})]})})),vje(pje,Nq.Developer,(function(){return null})),vje(pje,Nq.Residents,(function(t){var n=t.isHousehold,r=t.householdCount,o=t.maxHouseholds,a=t.residentCount,l=t.petCount,s=t.wealthKey,c=t.residence,u=t.residenceEntity,d=t.residenceKey,f=t.educationData,h=t.ageData,m=(0,i.useCallback)((function(){return u&&zq(u)}),[u]);return(0,e.jsxs)(e.Fragment,{children:[null!=c&&(0,e.jsx)(y$,{tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionResidence"})}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_RESIDENCE,{hash:d}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:c})})})}),o>1&&(0,e.jsx)(y$,{tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionHouseholds"})}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.HOUSEHOLDS,{}),right:(0,e.jsx)(ah,{value:r,total:o,unit:tc.Integer})})}),(0,e.jsxs)(y$,{tooltip:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:n?"ResidentsSectionHouseholdMembers":"ResidentsSectionResidents"})}),(0,e.jsx)(b$,{}),(0,e.jsx)(Sae,{colors:Zae,labels:Jae,data:h}),(0,e.jsx)(lEe,{}),(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionAge"})}),(0,e.jsx)(b$,{}),(0,e.jsx)(Sae,{colors:mae,labels:pae,data:f}),(0,e.jsx)(lEe,{}),(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionEducation"})})]}),children:[(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:n?(0,e.jsx)(Ks.SelectedInfoPanel.HOUSEHOLD_MEMBERS,{}):(0,e.jsx)(Ks.SelectedInfoPanel.RESIDENTS,{}),right:a}),l>0&&(0,e.jsx)(u$,{disableFocus:!0,subRow:!0,icon:"Media/Game/Icons/Pet.svg",left:(0,e.jsx)(dc,{value:l})})]}),(n||1===o&&r>0||o>1&&r>0)&&(0,e.jsx)(y$,{tooltip:o>1?(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionAverageHouseholdWealth"})}):(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionHouseholdWealth"})}),children:(0,e.jsx)(u$,{uppercase:!0,left:o>1?(0,e.jsx)(Ks.SelectedInfoPanel.AVERAGE_HOUSEHOLD_WEALTH,{}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WEALTH_TITLE,{}),right:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WEALTH,{hash:s})})})]})})),vje(pje,Nq.HouseholdSidebar,(function(){return null})),vje(pje,Nq.Districts,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.districtMissing,a=t.districts,l=Qq(n,r,i),s=C(ibe);return(0,e.jsxs)(y$,{disableFocus:!0,tooltip:l&&(0,e.jsx)(fI,{text:l}),className:txe,children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.OPERATING_DISTRICTS,{})}),(0,e.jsx)(Fn,{children:a.length>0&&(0,e.jsx)("div",{className:nxe,children:a.map((function(t,n){return(0,e.jsx)(ixe,{district:t},n)}))})}),o?(0,e.jsx)(Ybe,{label:(0,e.jsx)(Ks.SelectedInfoPanel.CREATE_DISTRICT,{}),icon:"Media/Game/Icons/Districts.svg",selected:s,onSelect:lbe}):(0,e.jsx)(Ybe,{label:(0,e.jsx)(Ks.SelectedInfoPanel.SELECT_OPERATING_DISTRICT,{}),icon:"Media/Game/Icons/Districts.svg",selected:s,onSelect:abe})]})})),vje(pje,Nq.Title,(function(){return null})),vje(pje,Nq.Notifications,(function(t){var n=t.focusKey,r=t.notifications;return(0,e.jsx)(Tr,{focusKey:n,className:D_e,children:r.length>0&&(0,e.jsx)(Fn,{children:null==r?void 0:r.map((function(t){return(0,e.jsx)(Gxe,{notification:t},t.key)}))})})})),vje(pje,Nq.Policies,(function(t){var n=t.policies,r=t.group,o=t.tooltipKeys,a=t.tooltipTags,s=fje((0,i.useState)((null==n?void 0:n.length)<3),2),c=s[0],u=s[1],d=fje((0,i.useState)(!1),2),f=d[0],h=d[1],m=(0,i.useCallback)((function(){return h(!0)}),[]),p=(0,i.useCallback)((function(){return h(!1)}),[]),v=Qq(r,o,a,!0),g=C(Rq),y=(0,i.useMemo)((function(){var e;return"".concat(null===(e=TS.value)||void 0===e?void 0:e.selectedInfoPanelPolicies,"+").concat(g)}),[g]);return uu(y),(0,e.jsx)(bS,{uiTag:y,children:(0,e.jsx)(sje,{disableFocus:!0,initialExpanded:(null==n?void 0:n.length)<3,tooltip:c&&v&&(0,e.jsx)(fI,{text:v}),className:f?F_e.disableActiveState:void 0,expandFromContent:!0,onToggleExpanded:u,header:c?(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,className:uje,left:(0,e.jsx)(Ks.SelectedInfoPanel.POLICIES,{})}):(0,e.jsx)("div",{className:cje,children:null==n?void 0:n.map((function(t){return(0,e.jsx)(aje,{policy:t,onAdjust:w9,onMouseOver:m,onMouseLeave:p},l(t.entity))}))}),children:(0,e.jsx)(Fn,{children:null==n?void 0:n.map((function(t,n){return(0,e.jsx)(oje,{policy:t,onAdjust:w9,className:0===n?V_e:void 0},l(t.entity))}))})})})})),vje(pje,Nq.Profitability,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.profitability,a=t.profitabilityFactors,l=Qq(n,i,r,!0);return(0,e.jsx)(xO,{direction:"right",tooltip:(0,e.jsxs)(e.Fragment,{children:[a.length>0&&(0,e.jsx)(e.Fragment,{children:(0,e.jsx)("div",{className:U_e,children:a.map((function(t,n){return(0,e.jsx)(d$,{left:t.weight>0?(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_POSITIVE,{hash:t.factor}):(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:t.factor}),right:(0,e.jsx)("div",{className:Ef(Uae,t.weight),children:(0,e.jsx)(dc,{value:t.weight,signed:!0})})},n)}))})}),(0,e.jsx)(b$,{}),l&&(0,e.jsx)(fI,{text:l})]}),children:(0,e.jsx)(Or,{className:D_e,children:(0,e.jsx)(Hxe,{notification:o})})})})),vje(pje,Nq.AverageHappiness,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.averageHappiness,a=t.happinessFactors,l=Qq(n,i,r,!0);return(0,e.jsx)(xO,{direction:"right",tooltip:(0,e.jsxs)(e.Fragment,{children:[a.length>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:U_e,children:a.map((function(t,n){return(0,e.jsx)(d$,{left:t.weight>0?(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_POSITIVE,{hash:t.factor}):(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:t.factor}),right:(0,e.jsx)("div",{className:Ef(Uae,t.weight),children:(0,e.jsx)(dc,{value:t.weight,signed:!0})})},n)}))}),(0,e.jsx)(b$,{})]}),l&&(0,e.jsx)(fI,{text:l})]}),children:(0,e.jsx)(Or,{className:D_e,children:(0,e.jsx)(Bxe,{notification:o})})})})),vje(pje,Nq.Schedule,(function(t){var n=t.group,r=t.tooltipTags,o=t.tooltipKeys,a=t.schedule,l=(0,i.useCallback)((function(){return o_e(0)}),[]),s=(0,i.useCallback)((function(){return o_e(1)}),[]),c=(0,i.useCallback)((function(){return o_e(2)}),[]),u=Qq(n,o,r,!0),d=C(Kq),f=(0,i.useMemo)((function(){return d.includes("CargoRoute")?"CargoRoute":"TransportLine"}),[d]);return(0,e.jsx)(y$,{disableFocus:!0,tooltip:u&&(0,e.jsx)(fI,{text:u}),children:(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SCHEDULE,{}),right:(0,e.jsx)("div",{className:a_e,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.SelectedInfoPanel.SCHEDULE_DAY_TOOLTIP,{hash:f}),children:(0,e.jsx)(ml,{theme:i_e,onSelect:l,selected:0===a,className:Oe()(l_e,s_e),children:(0,e.jsx)("img",{src:rge(0),className:u_e})})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.SelectedInfoPanel.SCHEDULE_NIGHT_TOOLTIP,{hash:f}),children:(0,e.jsx)(ml,{theme:i_e,onSelect:s,selected:1===a,className:l_e,children:(0,e.jsx)("img",{src:rge(1),className:u_e})})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.SelectedInfoPanel.SCHEDULE_CONTINUOUS_TOOLTIP,{hash:f}),children:(0,e.jsx)(ml,{theme:i_e,onSelect:c,selected:2===a,className:Oe()(l_e,c_e),children:(0,e.jsx)("img",{src:rge(2),className:u_e})})})]})})})})})),vje(pje,Nq.Line,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.stops,a=t.length,l=t.usage,s=t.cargo,c=cr(),u=Qq(n,r,i,!0),d=C(Kq).includes("CargoRoute");return(0,e.jsx)(e.Fragment,{children:(0,e.jsxs)(y$,{disableFocus:!0,tooltip:u&&(0,e.jsx)(fI,{text:u}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:d?(0,e.jsx)(Ks.SelectedInfoPanel.CARGO_TRANSPORT_ROUTE,{}):(0,e.jsx)(Ks.SelectedInfoPanel.PUBLIC_TRANSPORT_LINE,{})}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,right:(0,e.jsx)(dc,{value:a,unit:tc.Length}),left:(0,e.jsx)(Ks.SelectedInfoPanel.LINE_VISUALIZER_LENGTH,{})}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,right:(0,e.jsx)(dc,{value:o,unit:tc.Integer}),left:(0,e.jsx)(Ks.SelectedInfoPanel.LINE_VISUALIZER_STOPS,{})}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,right:(0,e.jsx)(dc,{value:s,unit:d?tc.Weight:tc.Integer}),left:d?(0,e.jsx)(Ks.Transport.LEGEND_CARGO,{}):(0,e.jsx)(Ks.SelectedInfoPanel.PASSENGERS_TITLE,{})}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,right:(0,e.jsx)(dc,{value:100*l,unit:tc.Percentage}),left:(0,e.jsx)(Ks.SelectedInfoPanel.LINE_USAGE,{})}),c&&(0,e.jsx)(Ybe,{label:(0,e.jsx)(Ks.Transport.LINES_OVERVIEW_BUTTON,{}),onSelect:Za})]})})})),vje(pje,Nq.Lines,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.hasLines,a=t.lines,l=t.hasPassengers,s=t.passengers,c=Qq(n,i,r,!0),u=cr();return(0,e.jsxs)(e.Fragment,{children:[l&&(0,e.jsx)(y$,{tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"LinesSectionWaitingPassengers"})}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.WAITING_PASSENGERS,{}),right:(0,e.jsx)(dc,{value:s,unit:tc.Integer})})}),o&&(0,e.jsxs)(y$,{disableFocus:!0,tooltip:c&&(0,e.jsx)(fI,{text:c}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.LINES,{}),right:a.length}),(0,e.jsx)(Tr,{children:(0,e.jsx)(Fn,{children:a&&a.length>0&&a.map((function(t,n){return(0,e.jsx)(t_e,{line:t},n)}))})}),u&&(0,e.jsx)(Ybe,{label:(0,e.jsx)(Ks.Transport.LINES_OVERVIEW_BUTTON,{}),onSelect:Za})]})]})})),vje(pje,Nq.Color,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.color,a=Qq(n,i,r);return(0,e.jsx)(y$,{disableFocus:!0,tooltip:a&&(0,e.jsx)(fI,{text:a}),children:(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.COLOR,{}),right:(0,e.jsx)(jF,{value:o,onChange:Yxe})})})})),vje(pje,Nq.LineVisualizer,(function(){return null})),vje(pje,Nq.TicketPrice,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.sliderData,l=h_e((0,i.useState)(a.value),2),s=l[0],c=l[1],u=cr(),d=(0,i.useCallback)((function(e){c(e),u&&m_e(e)}),[u]),f=(0,i.useCallback)((function(){m_e(s)}),[s]),h=Bm(a.step),m=Qq(n,r,o);return(0,e.jsxs)(y$,{tooltip:m&&(0,e.jsx)(fI,{text:m}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.TICKET_PRICE,{}),right:0===s?(0,e.jsx)(Ks.SelectedInfoPanel.TICKET_PRICE_FREE,{}):(0,e.jsx)(dc,{value:s,unit:tc.Money})}),(0,e.jsx)("div",{className:d_e,children:(0,e.jsx)(Fm,{valueTransformer:h,value:s,start:0,end:a.range.max,gamepadStep:a.step,onDragEnd:f,onChange:d})})]})})),vje(pje,Nq.VehicleCount,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.vehicleCount,l=t.activeVehicles,s=t.vehicleCounts,c=Qq(n,r,o,!0),u=(0,i.useCallback)((function(e){N("VehicleCountSection","setVehicleCount",s[e].x)}),[s]),d=Bm(1),f=(0,i.useMemo)((function(){return s.length>0?s[s.length-1].y:1}),[s]);return(0,e.jsxs)(y$,{tooltip:c&&(0,e.jsx)(fI,{text:c}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_COUNT,{}),right:(0,e.jsx)(ah,{value:a,total:f,unit:tc.Integer})}),(0,e.jsx)("div",{className:d_e,children:(0,e.jsx)(Fm,{valueTransformer:d,value:s.findIndex((function(e){return e.y===a})),start:0,end:s.length-1,gamepadStep:1,onChange:u})}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ACTIVE_VEHICLES,{}),right:(0,e.jsx)(dc,{value:l})})]})})),vje(pje,Nq.Attractiveness,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.attractiveness,a=t.baseAttractiveness,l=t.factors,s=Qq(n,r,i);return(0,e.jsx)(y$,{tooltip:(0,e.jsxs)(e.Fragment,{children:[s&&(0,e.jsx)(fI,{text:s}),l.length>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(b$,{}),(0,e.jsxs)("div",{className:Rbe.attractivenessFactors,children:[(0,e.jsx)(d$,{left:(0,e.jsx)(Ks.SelectedInfoPanel.ATTRACTIVENESS_BASE,{}),right:(0,e.jsx)(dc,{value:a,unit:tc.Integer})}),l.map((function(t,n){return(0,e.jsx)(d$,{left:(0,e.jsx)(Ks.SelectedInfoPanel.ATTRACTIVENESS_FACTORS,{hash:t.localeKey}),right:(0,e.jsx)("div",{className:Ef(Rbe,t.delta),children:(0,e.jsx)(dc,{value:t.delta,unit:tc.Percentage,signed:!0})})},n)}))]})]})]}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ATTRACTIVENESS,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.Integer})})})})),vje(pje,Nq.Efficiency,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.efficiency,a=t.factors,l=Qq(n,r,i);return(0,e.jsx)(y$,{tooltip:(0,e.jsxs)(e.Fragment,{children:[a.length>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(uxe,{factors:a}),(0,e.jsx)(b$,{})]}),l&&(0,e.jsx)(fI,{text:l})]}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.EFFICIENCY,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.PercentageSingleFraction})})})})),vje(pje,Nq.Employees,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.employeeCount,a=t.maxEmployees,l=t.educationDataEmployees,s=t.educationDataWorkplaces,c=Qq(n,i,r);return(0,e.jsx)(y$,{tooltip:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(Sae,{colors:ise,labels:ose,data:l,customLegend:l.values.map((function(t,n){return(s.values[n]>0||n===l.values.length-1)&&(0,e.jsx)(yv,{color:ise[n],label:ose[n],children:n<l.values.length-1?(0,e.jsx)(ah,{value:t,total:s.values[n],unit:tc.Integer}):(0,e.jsx)(dc,{value:t,unit:tc.Integer})},n)}))}),(0,e.jsx)(lEe,{}),c&&(0,e.jsx)(fI,{text:c})]}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.EMPLOYEES,{}),right:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Integer})})})})),vje(pje,Nq.Upkeep,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.upkeeps,a=t.total,l=t.inactive,s=Qq(n,i,r);return(0,e.jsx)(y$,{tooltip:(0,e.jsxs)(e.Fragment,{children:[o.map((function(t,n){return(0,e.jsx)(Cxe,{upkeep:t,inactive:l},n)})),(0,e.jsx)(b$,{}),s&&(0,e.jsx)(fI,{text:s})]}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.UPKEEP,{}),right:(0,e.jsx)(dc,{value:a,unit:tc.MoneyPerMonth})})})})),vje(pje,Nq.Level,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=bxe(t,["group","tooltipKeys","tooltipTags"]),a=Qq(n,r,i,o.isUnderConstruction);return(0,e.jsx)(y$,{tooltip:a&&(0,e.jsx)(fI,{text:a}),children:(0,e.jsx)(u$,{uppercase:!0,left:o.isUnderConstruction?(0,e.jsx)(Ks.SelectedInfoPanel.UNDER_CONSTRUCTION,{}):(0,e.jsx)(Ks.SelectedInfoPanel.LEVEL,{}),right:(0,e.jsx)(_xe,yxe({group:n,tooltipKeys:r,tooltipTags:i},o))})})})),vje(pje,Nq.Education,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.studentCount,a=t.studentCapacity,l=t.graduationTime,s=t.failProbability,c=C(Gp),u=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:u&&(0,e.jsx)(fI,{text:u}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.EDUCATION_STUDENTS,{})}),(0,e.jsx)(Ube,{progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Integer})}),(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.EDUCATION_GRADUATION_TIME,{}),right:s<1?(0,e.jsx)(kbe,{value:l*c.daysPerYear,daysPerYear:c.daysPerYear,maxMonths:3*c.daysPerYear}):(0,e.jsx)(Ks.SelectedInfoPanel.EDUCATION_NO_GRADUATIONS,{})}),(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.EDUCATION_DROPOUT_RATE,{}),right:(0,e.jsx)(Boe,{value:s,max:1})})]})})),vje(pje,Nq.Pollution,(function(t){var n=t.groundPollutionKey,r=t.airPollutionKey,i=t.noisePollutionKey;return(0,e.jsx)(y$,{disableFocus:!0,children:(0,e.jsxs)(Fn,{children:[n!==Pq.none&&(0,e.jsx)(u$,{uppercase:!0,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"PollutionSectionGround"})}),left:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS_GROUND,{}),right:(0,e.jsx)(Sxe,{pollutionKey:n,icon:"Media/Game/Icons/GroundPollution.svg"})}),r!==Pq.none&&(0,e.jsx)(u$,{uppercase:!0,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"PollutionSectionAir"})}),left:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS_AIR,{}),right:(0,e.jsx)(Sxe,{pollutionKey:r,icon:"Media/Game/Icons/AirPollution.svg"})}),i!==Pq.none&&(0,e.jsx)(u$,{uppercase:!0,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"PollutionSectionNoise"})}),left:(0,e.jsx)(Ks.SelectedInfoPanel.POLLUTION_LEVELS_NOISE,{}),right:(0,e.jsx)(Sxe,{pollutionKey:i,icon:"Media/Game/Icons/NoisePollution.svg"})})]})})})),vje(pje,Nq.Healthcare,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.patientCount,a=t.patientCapacity,l=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.HEALTHCARE_PATIENTS,{})}),(0,e.jsxs)(Ube,{progress:o,max:a,children:[o,"/",a]})]})})),vje(pje,Nq.Deathcare,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.bodyCount,a=t.bodyCapacity,l=t.processingSpeed,s=t.processingCapacity,c=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:c&&(0,e.jsx)(fI,{text:c}),children:[(0,e.jsx)(u$,{uppercase:!0,left:"Cemetery"===n?(0,e.jsx)(Ks.SelectedInfoPanel.GRAVES_IN_USE,{}):(0,e.jsx)(Ks.SelectedInfoPanel.DEATHCARE_BODIES,{})}),(0,e.jsx)(Ube,{progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a})}),s>0?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(lEe,{small:!0}),(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DEATHCARE_PROCESSING_SPEED,{})}),(0,e.jsx)(Ube,{invertColorCodes:!0,progress:l,max:s,children:(0,e.jsx)(ah,{value:l,total:s,unit:tc.BodiesPerMonth})})]}):void 0]})})),vje(pje,Nq.Garbage,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.garbage,a=t.garbageCapacity,l=t.processingSpeed,s=t.processingCapacity,c=t.loadKey,u=Qq(n,i,r);return(0,e.jsxs)(y$,{tooltip:u&&(0,e.jsx)(fI,{text:u}),children:[a>0?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.GARBAGE_MANAGEMENT_STORAGE_LABEL,{hash:c})}),(0,e.jsx)(Ube,{progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Weight})})]}):void 0,s>0?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(lEe,{small:!0}),(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.GARBAGE_MANAGEMENT_PROCESSING_SPEED,{})}),(0,e.jsx)(Ube,{invertColorCodes:!0,progress:l,max:s,children:(0,e.jsx)(ah,{value:l,total:s,unit:tc.WeightPerMonth})})]}):void 0]})})),vje(pje,Nq.Police,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.prisonerCount,a=t.prisonerCapacity,l=Qq(n,i,r);return(0,e.jsxs)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.POLICE_PRISONERS,{})}),(0,e.jsxs)(Ube,{progress:o,max:a,children:[o,"/",a]})]})})),vje(pje,Nq.Vehicles,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.vehicleKey,a=t.vehicleCount,l=t.availableVehicleCount,s=t.vehicleCapacity,c=t.vehicleList,u=Qq(n,i,r,!0);return s>0?(0,e.jsxs)(y$,{disableFocus:!0,children:[s-l>0&&(0,e.jsx)(u$,{uppercase:!0,tooltip:u&&(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"VehiclesInMaintenance"})}),left:(0,e.jsx)(Ks.SelectedInfoPanel.MAINTENANCED_VEHICLES,{}),right:(0,e.jsx)(dc,{value:s-l})}),(0,e.jsx)(u$,{uppercase:!0,tooltip:u&&(0,e.jsx)(fI,{text:u}),left:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLES,{hash:o}),right:0===s?(0,e.jsx)(dc,{value:a}):(0,e.jsx)(ah,{value:a,total:s})}),c.length>0&&(0,e.jsx)(Fn,{children:c.map((function(t,n){return(0,e.jsx)(hje,{vehicle:t},n)}))})]}):null})),vje(pje,Nq.DispatchedVehicles,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.vehicleList,a=Qq(n,i,r);return(0,e.jsxs)(y$,{disableFocus:!0,children:[(0,e.jsx)(u$,{uppercase:!0,tooltip:a&&(0,e.jsx)(fI,{text:a}),left:(0,e.jsx)(Ks.SelectedInfoPanel.DISPATCHED_VEHICLES,{}),right:(0,e.jsx)(dc,{value:o.length})}),o.length>0&&(0,e.jsx)(Fn,{children:o.map((function(t,n){return(0,e.jsx)(hje,{vehicle:t},n)}))})]})})),vje(pje,Nq.Electricity,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.capacity,a=t.production,l=Qq(n,r,i),s=a>0&&o>0?at(100*a/o,1,100):0;return(0,e.jsxs)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:[(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_POWER_PRODUCTION,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.Power})}),(0,e.jsx)(u$,{disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_POWER_USAGE,{}),right:(0,e.jsx)(dc,{value:s,unit:tc.Percentage})})]})})),vje(pje,Nq.Transformer,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.capacity,a=t.flow,l=Qq(n,r,i),s=Math.abs(a)>0&&o>0?at(100*Math.abs(a)/o,1,100):0;return(0,e.jsxs)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_TRANSFORMER_CAPACITY,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.Power})}),(0,e.jsx)(u$,{left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_POWER_USAGE,{}),right:(0,e.jsx)(dc,{value:s,unit:tc.Percentage})})]})})),vje(pje,Nq.Battery,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.batteryCharge,a=t.batteryCapacity,l=t.flow,s=t.remainingTime,c=Qq(n,r,i),u=function(t){return t<0?(0,e.jsx)(Ks.SelectedInfoPanel.BATTERY_STATE_DISCHARGING,{}):t>0?(0,e.jsx)(Ks.SelectedInfoPanel.BATTERY_STATE_CHARGING,{}):(0,e.jsx)(Ks.SelectedInfoPanel.BATTERY_STATE_IDLE,{})}(l),d=function(t,n){var r=C(Gp);return t<0?(0,e.jsx)(Ks.SelectedInfoPanel.EMPTY_IN,{DURATION:(0,e.jsx)(kbe,{value:n,daysPerYear:r.daysPerYear})}):t>0?(0,e.jsx)(Ks.SelectedInfoPanel.FULL_IN,{DURATION:(0,e.jsx)(kbe,{value:n,daysPerYear:r.daysPerYear})}):""}(l,s);return(0,e.jsxs)(y$,{tooltip:c&&(0,e.jsx)(fI,{text:c}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_BATTERY_STATE,{}),right:u}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_BATTERY_FLOW,{}),right:(0,e.jsx)(dc,{signed:!0,value:l,unit:tc.Power})}),(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ELECTRICITY_BATTERY_CHARGE,{}),right:d}),(0,e.jsx)(Ube,{progress:o,max:a,invertColorCodes:!0,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Energy})})]})})),vje(pje,Nq.Water,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.capacity,a=t.lastProduction,l=t.pollution,s=Qq(n,i,r),c=a>0&&o>0?at(100*a/o,1,100):0;return(0,e.jsxs)(y$,{tooltip:s&&(0,e.jsx)(fI,{text:s}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.WATER_OUTPUT,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.VolumePerMonth})}),(0,e.jsx)(u$,{disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.WATER_PUMP_USAGE,{}),right:(0,e.jsx)(dc,{value:c,unit:tc.Percentage})}),(0,e.jsx)(u$,{disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.WATER_PUMP_POLLUTION,{}),right:(0,e.jsx)(Boe,{value:l,max:1})})]})})),vje(pje,Nq.Sewage,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.capacity,a=t.lastProcessed,l=t.purification,s=Qq(n,r,i),c=a>0&&o>0?at(100*a/o,1,100):0;return(0,e.jsxs)(y$,{tooltip:s&&(0,e.jsx)(fI,{text:s}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SEWAGE_PROCESSING_CAPACITY,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.VolumePerMonth})}),(0,e.jsx)(u$,{disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SEWAGE_OUTLET_USAGE,{}),right:(0,e.jsx)(dc,{value:c,unit:tc.Percentage})}),l>0&&(0,e.jsx)(u$,{disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SEWAGE_PURIFICATION_RATE,{}),right:(0,e.jsx)(dc,{value:100*l,unit:tc.Percentage})})]})})),vje(pje,Nq.Fire,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.vehicleEfficiency,a=Qq(n,r,i);return(0,e.jsx)(y$,{tooltip:a&&(0,e.jsx)(fI,{text:a}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.EFFICIENCY,{}),right:o})})})),vje(pje,Nq.Prison,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.prisonerCount,a=t.prisonerCapacity,l=Qq(n,i,r);return(0,e.jsxs)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PRISON_PRISONERS,{})}),(0,e.jsxs)(Ube,{progress:o,max:a,children:[o,"/",a]})]})})),vje(pje,Nq.Shelter,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.sheltered,a=t.shelterCapacity,l=Qq(n,i,r);return(0,e.jsxs)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SHELTER_OCCUPANTS,{})}),(0,e.jsxs)(Ube,{progress:o,max:a,children:[o,"/",a]})]})})),vje(pje,Nq.Parking,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.parkedCars,a=t.parkingCapacity,l=Qq(n,i,r);return(0,e.jsx)(y$,{tooltip:l&&(0,e.jsx)(fI,{text:l}),children:a>0?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PARKING_PARKED,{})}),(0,e.jsx)(Ube,{progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Integer})})]}):(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PARKING_PARKED,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.Integer})})})})),vje(pje,Nq.Park,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.maintenance,a=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:a&&(0,e.jsx)(fI,{text:a}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PARK_MAINTENANCE,{})}),(0,e.jsx)(Ube,{progress:o,max:100,invertColorCodes:!0,children:(0,e.jsx)(dc,{value:o,unit:tc.Percentage})})]})})),vje(pje,Nq.Mail,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.sortingRate,a=t.sortingCapacity,l=t.localAmount,s=t.unsortedAmount,c=t.outgoingAmount,u=t.storedAmount,d=t.storageCapacity,f=t.localKey,h=t.unsortedKey,m=t.type,p=Qq(n,i,r);return(0,e.jsxs)(y$,{tooltip:p&&(0,e.jsx)(fI,{text:p}),children:[m===Cq.PostFacility&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:f}),right:l}),a>0||c>0?(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:"Outgoing"}),right:c}):void 0,(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:h}),right:s}),a>0?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.MAIL_SORTING_SPEED,{})}),(0,e.jsx)(Ube,{progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.IntegerPerMonth})})]}):void 0]}),d>0?(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:"Stored"})}),(0,e.jsxs)(Ube,{progress:u,max:d,children:[u,"/",d]})]}):void 0]})})),vje(pje,Nq.Road,(function(t){var n=t.volumeData,r=t.flowData,i=t.length,o=t.bestCondition,a=t.worstCondition,l=t.condition,s=t.upkeep,c=$q("RoadSectionLength"),u=$q("RoadSectionCondition"),d=$q("RoadSectionUpkeep"),f=$q("RoadSectionFlow"),h=$q("RoadSectionVolume");return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(y$,{tooltip:d&&(0,e.jsx)(fI,{text:d}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_UPKEEP,{}),right:(0,e.jsx)(dc,{value:s,unit:tc.MoneyPerMonth})})}),(0,e.jsx)(y$,{tooltip:c&&(0,e.jsx)(fI,{text:c}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_LENGTH,{}),right:(0,e.jsx)(dc,{value:i,unit:tc.Length})})}),(0,e.jsx)(y$,{tooltip:u&&(0,e.jsx)(fI,{text:u}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_CONDITION,{}),right:o===l||a===o||l===o?(0,e.jsx)(dc,{value:o,unit:tc.Percentage}):(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_CONDITION_FORMAT,{WORST:(0,e.jsx)(dc,{value:a,unit:tc.Percentage}),BEST:(0,e.jsx)(dc,{value:o,unit:tc.Percentage}),AVG:(0,e.jsx)(dc,{value:l,unit:tc.Percentage})})})}),(0,e.jsx)(y$,{disableFocus:!0,tooltip:f&&(0,e.jsx)(fI,{text:f}),children:(0,e.jsxs)(Tr,{className:r_e,children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_TRAFFIC_FLOW,{})}),(0,e.jsx)(fle,{data:r})]})}),(0,e.jsx)(y$,{disableFocus:!0,tooltip:h&&(0,e.jsx)(fI,{text:h}),children:(0,e.jsxs)(Tr,{className:r_e,children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ROAD_TRAFFIC_VOLUME,{})}),(0,e.jsx)(dle,{data:n})]})})]})})),vje(pje,Nq.Company,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.companyName,a=t.input1,l=t.input2,s=t.output,c=t.sells,u=t.stores,d=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:d&&(0,e.jsx)(fI,{text:d}),children:[(0,e.jsx)(u$,{disableFocus:!0,uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.COMPANY,{}),right:o?(0,e.jsx)(mL,{value:o}):(0,e.jsx)(Ks.Common.NONE,{})}),null==o&&(0,e.jsx)(u$,{disableFocus:!0,subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.BUILDING_FOR_RENT,{})}),(a||l)&&(0,e.jsx)(u$,{disableFocus:!0,subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.COMPANY_REQUIRES,{}),right:(0,e.jsxs)(e.Fragment,{children:[a&&(0,e.jsx)("img",{src:"Media/Game/Resources/".concat(a,".svg"),className:Gbe}),a&&(0,e.jsx)(Ks.Resources.TITLE,{hash:a}),l&&(0,e.jsx)("div",{className:Vbe,children:"+"}),l&&(0,e.jsx)("img",{src:"Media/Game/Resources/".concat(l,".svg"),className:Gbe}),l&&(0,e.jsx)(Ks.Resources.TITLE,{hash:l})]})}),s&&(0,e.jsx)(u$,{disableFocus:!0,subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.COMPANY_PRODUCES,{}),right:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("img",{src:"Media/Game/Resources/".concat(s,".svg"),className:Gbe}),(0,e.jsx)(Ks.Resources.TITLE,{hash:s})]})}),c&&(0,e.jsx)(u$,{disableFocus:!0,subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.COMPANY_SELLS,{}),right:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("img",{src:"Media/Game/Resources/".concat(c,".svg"),className:Gbe}),(0,e.jsx)(Ks.Resources.TITLE,{hash:c})]})}),u&&(0,e.jsx)(u$,{disableFocus:!0,subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.COMPANY_STORES,{}),right:(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("img",{src:"Media/Game/Resources/".concat(u,".svg"),className:Gbe}),(0,e.jsx)(Ks.Resources.TITLE,{hash:u})]})})]})})),vje(pje,Nq.Storage,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.stored,a=t.capacity,l=t.resources,s=Qq(n,i,r),c=null==l?void 0:l.filter((function(e){return"NoResource"!==e.key&&e.amount>0}));return(0,e.jsxs)(y$,{tooltip:s&&(0,e.jsx)(fI,{text:s}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.WAREHOUSE_STORAGE,{})}),(0,e.jsx)(Ube,{plain:!0,progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Weight})}),c.length>0&&(0,e.jsx)(Nxe,{children:null==c?void 0:c.map((function(t,n){return(0,e.jsx)(E1,{theme:Pxe,className:Oe()(c.length>1&&c.length%2==1&&n===c.length-1&&Pxe.last),icon:"Media/Game/Resources/".concat(t.key,".svg"),label:(0,e.jsx)(Ks.Resources.TITLE,{hash:t.key}),children:(0,e.jsx)(dc,{value:t.amount,unit:tc.Weight})},t.key)}))})]})})),vje(pje,Nq.PrivateVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.keeper,c=t.keeperEntity,u=t.nextStop,d=t.stateKey,f=t.vehicleKey,h=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),m=(0,i.useCallback)((function(){return c&&zq(c)}),[c]),p=(0,i.useCallback)((function(){return u.entity&&zq(u.entity)}),[u]),v=Qq(n,r,o,!0);return(0,e.jsx)(y$,{tooltip:v&&(0,e.jsx)(fI,{text:v}),disableFocus:null!=s||null!=u.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PRIVATE_VEHICLE_TITLE,{hash:f}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:d})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:h,children:(0,e.jsx)(mL,{value:a.name})})}),null!=u.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:p,children:(0,e.jsx)(mL,{value:u.name})})}),null!=s&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DRIVER,{}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:s})})})]})})})),vje(pje,Nq.PublicTransportVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.line,c=t.lineEntity,u=t.nextStop,d=t.stateKey,f=t.vehicleKey,h=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),m=(0,i.useCallback)((function(){return c&&zq(c)}),[c]),p=(0,i.useCallback)((function(){return u.entity&&zq(u.entity)}),[u]),v=Qq(n,r,o,!0);return(0,e.jsx)(y$,{tooltip:v&&(0,e.jsx)(fI,{text:v}),disableFocus:null!=c||null!=u.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PUBLIC_TRANSPORT_VEHICLE_TITLE,{hash:f}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:d})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:h,children:(0,e.jsx)(mL,{value:a.name})})}),null!=u.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:p,children:(0,e.jsx)(mL,{value:u.name})})}),null!=s&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.LINE,{}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:s})})})]})})})),vje(pje,Nq.CargoTransportVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.line,c=t.lineEntity,u=t.nextStop,d=t.stateKey,f=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),h=(0,i.useCallback)((function(){return c&&zq(c)}),[c]),m=(0,i.useCallback)((function(){return u.entity&&zq(u.entity)}),[u]),p=Qq(n,r,o);return(0,e.jsx)(y$,{tooltip:p&&(0,e.jsx)(fI,{text:p}),disableFocus:null!=c||null!=u.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CARGO_TRANSPORT_VEHICLE_TITLE,{}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:d})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:a.name})})}),null!=u.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:u.name})})}),null!=s&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ROUTE,{}),link:(0,e.jsx)(exe,{onSelect:h,children:(0,e.jsx)(mL,{value:s})})})]})})})),vje(pje,Nq.DeliveryVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.stateKey,u=t.vehicleKey,d=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),f=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),h=Qq(n,r,o,!0);return(0,e.jsx)(y$,{tooltip:h&&(0,e.jsx)(fI,{text:h}),disableFocus:!0,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DELIVERY_VEHICLE_TITLE,{hash:u}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:s.name})})})]})})})),vje(pje,Nq.HealthcareVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.patient,u=t.patientEntity,d=t.stateKey,f=t.vehicleKey,h=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),m=(0,i.useCallback)((function(){return u&&zq(u)}),[u]),p=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),v=Qq(n,r,o,!0);return(0,e.jsx)(y$,{tooltip:v&&(0,e.jsx)(fI,{text:v}),disableFocus:null!=u||null!=s.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.HEALTHCARE_VEHICLE_TITLE,{hash:f}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:d})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:h,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:p,children:(0,e.jsx)(mL,{value:s.name})})}),null!=c&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.HEALTHCARE_VEHICLE_PATIENT,{}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:c})})})]})})})),vje(pje,Nq.FireVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.stateKey,u=t.vehicleKey,d=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),f=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),h=Qq(n,r,o,!0);return(0,e.jsx)(y$,{tooltip:h&&(0,e.jsx)(fI,{text:h}),disableFocus:null!=s.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.FIRE_VEHICLE_TITLE,{hash:u}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:s.name})})})]})})})),vje(pje,Nq.PoliceVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.criminal,u=t.criminalEntity,d=t.stateKey,f=t.vehicleKey,h=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),m=(0,i.useCallback)((function(){return u&&zq(u)}),[u]),p=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),v=Qq(n,r,o,!0);return(0,e.jsx)(y$,{tooltip:v&&(0,e.jsx)(fI,{text:v}),disableFocus:null!=u||null!=s.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.POLICE_VEHICLE_TITLE,{hash:f}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:d})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:h,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:p,children:(0,e.jsx)(mL,{value:s.name})})}),null!=c&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.POLICE_VEHICLE_CRIMINAL,{}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:c})})})]})})})),vje(pje,Nq.MaintenanceVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.workShift,l=t.owner,s=t.fromOutside,c=t.nextStop,u=t.stateKey,d=(0,i.useCallback)((function(){return l.entity&&zq(l.entity)}),[l]),f=(0,i.useCallback)((function(){return c.entity&&zq(c.entity)}),[c]),h=Qq(n,r,o),m=$q("MaintenanceVehicleSectionWorkshift");return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)(y$,{tooltip:h&&(0,e.jsx)(fI,{text:h}),disableFocus:null!=c.entity||null!=l.entity,children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.MAINTENANCE_VEHICLE_TITLE,{}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:u})}),null!=l.entity&&(0,e.jsx)(u$,{subRow:!0,left:s?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:l.name})})}),null!=c.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:c.name})})})]}),(0,e.jsxs)(y$,{tooltip:m&&(0,e.jsx)(fI,{text:m}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.WORK_SHIFT,{})}),(0,e.jsx)(Ube,{progress:a,max:100,plain:!0,children:(0,e.jsx)(dc,{value:a,unit:tc.Percentage})})]})]})})),vje(pje,Nq.DeathcareVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.dead,u=t.deadEntity,d=t.stateKey,f=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),h=(0,i.useCallback)((function(){return u&&zq(u)}),[u]),m=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),p=Qq(n,r,o);return(0,e.jsx)(y$,{tooltip:p&&(0,e.jsx)(fI,{text:p}),disableFocus:null!=u||null!=s.entity||null!=a.entity,children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DEATHCARE_VEHICLE_TITLE,{}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:d})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:m,children:(0,e.jsx)(mL,{value:s.name})})}),null!=c&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DEATHCARE_VEHICLE_DEAD,{}),link:(0,e.jsx)(exe,{onSelect:h,children:(0,e.jsx)(mL,{value:c})})})]})})})),vje(pje,Nq.PostVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.stateKey,u=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a.entity]),d=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),f=Qq(n,r,o);return(0,e.jsxs)(y$,{tooltip:f&&(0,e.jsx)(fI,{text:f}),disableFocus:null!=a.entity,children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.POST_VEHICLE_TITLE,{}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:u,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:s.name})})})]})})),vje(pje,Nq.GarbageVehicle,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.owner,l=t.fromOutside,s=t.nextStop,c=t.stateKey,u=t.vehicleKey,d=(0,i.useCallback)((function(){return a.entity&&zq(a.entity)}),[a]),f=(0,i.useCallback)((function(){return s.entity&&zq(s.entity)}),[s]),h=Qq(n,r,o,!0);return(0,e.jsxs)(y$,{tooltip:h&&(0,e.jsx)(fI,{text:h}),disableFocus:null!=s.entity||null!=a.entity,children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.GARBAGE_VEHICLE_TITLE,{hash:u}),right:(0,e.jsx)(Ks.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=a.entity&&(0,e.jsx)(u$,{subRow:!0,left:l?(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}):(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:a.name})})}),null!=s.entity&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:s.name})})})]})})),vje(pje,Nq.Passengers,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.passengers,a=t.maxPassengers,l=t.pets,s=t.vehiclePassengerKey,c=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:c&&(0,e.jsx)(fI,{text:c}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.PASSENGERS,{hash:s})}),(0,e.jsx)(Ube,{progress:o,max:a,plain:!0,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Integer})}),l>0&&(0,e.jsx)(u$,{subRow:!0,icon:"Media/Game/Icons/Pet.svg",left:(0,e.jsx)(dc,{value:l,unit:tc.Integer})})]})})),vje(pje,Nq.Cargo,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.cargo,a=t.capacity,l=t.resources,s=t.cargoKey,c=Qq(n,i,r),u=null==l?void 0:l.filter((function(e){return"NoResource"!==e.key&&e.amount>0}));return(0,e.jsxs)(y$,{tooltip:c&&(0,e.jsx)(fI,{text:c}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CARGO_TITLE,{hash:s})}),(0,e.jsx)(Ube,{plain:!0,progress:o,max:a,children:(0,e.jsx)(ah,{value:o,total:a,unit:tc.Weight})}),(null==u?void 0:u.length)>0&&(0,e.jsx)(Nxe,{children:null==u?void 0:u.map((function(t,n){return(0,e.jsx)(E1,{theme:Pxe,className:Oe()(u.length>1&&u.length%2==1&&n===u.length-1&&Pxe.last),icon:"NoResource"!==t.key?"Media/Game/Resources/".concat(t.key,".svg"):null,label:(0,e.jsx)(Ks.Resources.TITLE,{hash:t.key}),children:(0,e.jsx)(dc,{value:t.amount,unit:tc.Weight})},t.key)}))})]})})),vje(pje,Nq.Load,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.load,a=t.capacity,l=t.loadKey,s=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:s&&(0,e.jsx)(fI,{text:s}),children:[(0,e.jsx)(u$,{left:(0,e.jsx)(Ks.SelectedInfoPanel.LOAD_TITLE,{hash:l})}),(0,e.jsx)(Ube,{progress:o,max:a,plain:!0,children:(0,e.jsx)(ah,{value:o,total:a,unit:mje(l)})})]})})),vje(pje,Nq.Status,(function(t){var n=t.conditions,r=t.notifications,i=t.happiness,o=t.focusKey,a=t.tooltipTags;return(0,e.jsx)(Tr,{focusKey:o,className:zxe.statusSection,children:(0,e.jsxs)(Fn,{children:[(0,e.jsxs)("div",{className:Oe()(zxe.row,zxe.top),children:[i&&(0,e.jsx)(Vxe,{notification:i,tooltipTags:a}),(null==n?void 0:n.length)>0&&(null==n?void 0:n.map((function(t){return(0,e.jsx)(Kxe,{notification:t,tooltipTags:a},t.key)})))]}),(null==r?void 0:r.length)>0&&(null==r?void 0:r.map((function(t,n){return(0,e.jsx)("div",{className:Oe()(zxe.row,zxe.bottom),children:(0,e.jsx)(Gxe,{notification:t,tooltipTags:a})},n)})))]})})})),vje(pje,Nq.Citizen,(function(t){var n,r,o=t.citizenKey,a=t.stateKey,l=t.household,s=t.householdEntity,c=t.residence,u=t.residenceEntity,d=t.residenceKey,f=t.workplace,h=t.workplaceEntity,m=t.workplaceKey,p=t.schoolLevel,v=t.tooltipTags,g=t.school,y=t.schoolEntity,b=t.destination,x=t.destinationEntity,_=t.educationKey,j=t.ageKey,E=t.wealthKey,O=t.occupationKey,T=t.jobLevelKey,I=(0,i.useCallback)((function(){return s&&zq(s)}),[s]),S=(0,i.useCallback)((function(){return u&&zq(u)}),[u]),w=(0,i.useCallback)((function(){return h&&zq(h)}),[h]),N=(0,i.useCallback)((function(){return y&&zq(y)}),[y]),P=(0,i.useCallback)((function(){return x&&zq(x)}),[x]),C=(n=["CitizenSectionOccupation","Unknown"!==T?"CitizenSectionJobTitle":null],r=bs(),(0,i.useMemo)((function(){var e=n.filter(sp).map((function(e){return Zq(r,e)})).filter((function(e){return""!==e}));return e.length>0?e:null}),[n,r])),A=v.includes("Male");return(0,e.jsxs)(e.Fragment,{children:[(0,e.jsxs)(y$,{disableFocus:null!=g,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"CitizenSection"+o})}),children:[(0,e.jsx)(u$,{uppercase:!0,left:A?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_TYPE_MALE,{hash:o}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_TYPE_FEMALE,{hash:o}),right:A?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_STATE_MALE,{hash:a}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_STATE_FEMALE,{hash:a})}),(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_AGE_TITLE,{}),right:A?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_AGE_MALE,{hash:j}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_AGE_FEMALE,{hash:j})}),(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_EDUCATION_TITLE,{}),right:A?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_EDUCATION_MALE,{hash:_}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_EDUCATION_FEMALE,{hash:_})}),null!=g&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_SCHOOL_TITLE,{index:p}),link:(0,e.jsx)(exe,{onSelect:N,children:(0,e.jsx)(mL,{value:g})})})]}),(0,e.jsx)(y$,{disableFocus:!0,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"CitizenSectionHousehold"+o})}),children:(0,e.jsxs)(Fn,{direction:On.Vertical,children:[null!=l&&(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_HOUSEHOLD,{}),link:(0,e.jsx)(exe,{onSelect:I,children:(0,e.jsx)(mL,{value:l})})}),(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WEALTH_TITLE,{}),right:A?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WEALTH_MALE,{hash:E}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WEALTH_FEMALE,{hash:E})}),null!=c&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_RESIDENCE,{hash:d}),link:(0,e.jsx)(exe,{onSelect:S,children:(0,e.jsx)(mL,{value:c})})})]})}),"Tourist"!==O&&(0,e.jsxs)(y$,{disableFocus:null!=f,tooltip:null!=C&&(0,e.jsx)(fI,{children:C}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_OCCUPATION_TITLE,{}),right:A?(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_OCCUPATION_MALE,{hash:O}):(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_OCCUPATION_FEMALE,{hash:O})}),"Unknown"!==T&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_JOB_TITLE,{}),right:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_JOB_LEVEL,{hash:T})}),null!=f&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.CITIZEN_WORKPLACE,{hash:m}),link:(0,e.jsx)(exe,{onSelect:w,children:(0,e.jsx)(mL,{value:f})})})]}),null!=b&&(0,e.jsx)(y$,{disableFocus:!0,tooltip:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.TOOLTIP,{hash:"CitizenSectionDestination"})}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:P,children:(0,e.jsx)(mL,{value:b})})})})]})})),vje(pje,Nq.DummyHuman,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.origin,l=t.originEntity,s=t.destination,c=t.destinationEntity,u=(0,i.useCallback)((function(){return l&&zq(l)}),[l]),d=(0,i.useCallback)((function(){return c&&zq(c)}),[c]),f=Qq(n,r,o,!0);return(0,e.jsx)(y$,{disableFocus:!0,tooltip:f&&(0,e.jsx)(fI,{text:f}),children:(0,e.jsxs)(Fn,{children:[null!=a&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ORIGIN,{}),link:(0,e.jsx)(exe,{onSelect:u,children:(0,e.jsx)(mL,{value:a})})}),null!=s&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:s})})})]})})})),vje(pje,Nq.Animal,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.typeKey,l=t.owner,s=t.ownerEntity,c=t.destination,u=t.destinationEntity,d=(0,i.useCallback)((function(){return s&&zq(s)}),[s]),f=(0,i.useCallback)((function(){return u&&zq(u)}),[u]),h=Qq(n,r,o,!0);return(0,e.jsx)(y$,{disableFocus:!0,tooltip:h&&(0,e.jsx)(fI,{text:h}),children:(0,e.jsxs)(Fn,{children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.ANIMAL_TYPE,{hash:a})}),null!=l&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.OWNED_BY,{}),link:(0,e.jsx)(exe,{onSelect:d,children:(0,e.jsx)(mL,{value:l})})}),null!=c&&(0,e.jsx)(u$,{subRow:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTINATION,{}),link:(0,e.jsx)(exe,{onSelect:f,children:(0,e.jsx)(mL,{value:c})})})]})})})),vje(pje,Nq.SelectVehicles,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.primaryVehicle,s=t.secondaryVehicle,c=t.primaryVehicles,u=t.secondaryVehicles,d=(0,i.useCallback)((function(e){var t;E$(e,null!==(t=null==s?void 0:s.entity)&&void 0!==t?t:ii)}),[null==s?void 0:s.entity]),f=(0,i.useCallback)((function(e){var t;E$(null!==(t=null==a?void 0:a.entity)&&void 0!==t?t:ii,e)}),[null==a?void 0:a.entity]),h=Qq(n,r,o,!0);return(0,e.jsxs)(y$,{disableFocus:!0,className:x$.selectVehiclesSection,tooltip:h&&(0,e.jsx)(fI,{text:h}),children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SELECT_VEHICLE,{})}),(0,e.jsx)(fC,{focusKey:Ie,theme:Jq,initialFocused:a&&l(a.entity),content:null==c?void 0:c.map((function(t){return(0,e.jsx)(_C,{value:t.entity,focusKey:t.id,onChange:d,children:(0,e.jsx)(O$,{vehicle:t})},l(t.entity))})),children:(0,e.jsx)(gC,{sounds:j$,className:x$.dropdown,children:(0,e.jsx)(O$,{vehicle:null!=a?a:c[0]})})}),u&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(u$,{uppercase:!0,disableFocus:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.SELECT_VEHICLE_SECONDARY,{hash:"Train"})}),(0,e.jsx)(fC,{theme:Jq,initialFocused:s&&l(s.entity),content:null==u?void 0:u.map((function(t){return(0,e.jsx)(_C,{value:t.entity,focusKey:t.id,onChange:f,children:(0,e.jsx)(O$,{vehicle:t})},l(t.entity))})),children:(0,e.jsx)(gC,{sounds:j$,className:x$.dropdown,children:(0,e.jsx)(O$,{vehicle:null!=s?s:u[0]})})})]})]})})),vje(pje,Nq.DestroyedBuilding,(function(t){var n=t.group,r=t.tooltipKeys,o=t.tooltipTags,a=t.destroyer,l=t.cleared,s=t.progress,c=t.status,u=Qq(n,r,o),d=C(Xbe),f=(0,i.useCallback)((function(){N("DestroyedBuildingSection","toggleRebuild")}),[]);return(0,e.jsxs)(y$,{disableFocus:l,tooltip:u&&(0,e.jsx)(fI,{text:u}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTROYED,{})}),null!=a&&(0,e.jsx)(Hbe,{children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.DESTROYED_DESCRIPTION,{hash:a})})}),"None"!==c&&"Rebuild"!==c&&(0,e.jsx)(u$,{left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTROYED_STATUS,{hash:c})}),!l&&"Searching"===c&&(0,e.jsx)(Ube,{plain:!0,progress:s,max:100,children:(0,e.jsx)(dc,{value:s,unit:tc.Percentage})}),l&&(0,e.jsx)(Ybe,{label:(0,e.jsx)(Ks.SelectedInfoPanel.REBUILD,{}),selected:d,onSelect:f})]})})),vje(pje,Nq.DestroyedTree,(function(t){var n=t.group,r=t.tooltipKeys,i=t.tooltipTags,o=t.destroyer,a=Qq(n,r,i);return(0,e.jsxs)(y$,{tooltip:a&&(0,e.jsx)(fI,{text:a}),children:[(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.SelectedInfoPanel.DESTROYED_TREE,{})}),null!=o&&(0,e.jsx)(Hbe,{children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.SelectedInfoPanel.DESTROYED_TREE_DESCRIPTION,{hash:o})})})]})})),vje(pje,Nq.Comfort,(function(t){var n=t.group,r=t.tooltipTags,i=t.tooltipKeys,o=t.comfort,a=Qq(n,i,r);return(0,e.jsx)(y$,{tooltip:a&&(0,e.jsx)(fI,{text:a}),children:(0,e.jsx)(u$,{uppercase:!0,left:(0,e.jsx)(Ks.Properties.COMFORT,{}),right:(0,e.jsx)(dc,{value:o,unit:tc.Integer})})})})),pje);const yje="46",bje="household-sidebar-section_Pp8",xje="gamepad-active_M6w",_je="content_uZM",jje="fixed-list_leU",Eje="virtual-list_kom",Oje="item_Pjq button_eqb item-states_QjV",Tje="icon_cU0",Ije="household_aFZ",Sje="divider_hD0",wje="badge_PNB";function Nje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Pje(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||Aje(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Cje(e){return function(e){if(Array.isArray(e))return Nje(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||Aje(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Aje(e,t){if(e){if("string"==typeof e)return Nje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Nje(e,t):void 0}}var Lje={length:0,visibleStartIndex:0,visibleItems:[]},Mje=function(t){var n=t.householdSidebarVariant,r=t.residence,o=t.households,a=t.householdMembers,s=t.householdPets,c=t.focusKey,u=t.className,d=cr(),f=Pje((0,i.useState)(Lje),2),h=f[0],m=f[1],p=(0,i.useMemo)((function(){return n===qq.Building&&o.length>1?o:Cje(a).concat(Cje(s))}),[a,s,o,n]),v=(0,i.useCallback)((function(e,t){for(var n=new Array(t-e),r=0;r<n.length;r++)n[r]=p[e+r];m({length:p.length,visibleStartIndex:e,visibleItems:n})}),[p]),g=(0,i.useMemo)((function(){return function(e,t){return e===qq.Citizen||e===qq.Household||1===t.length}(n,o)}),[n,o]);return(0,e.jsx)($r,{focusKey:c,className:Oe()(bje,d&&xje,u),contentClassName:_je,children:(0,e.jsxs)(Fn,{direction:On.Vertical,children:[(0,e.jsxs)("div",{className:jje,children:[null!=r.entity&&(0,e.jsx)(kje,{item:r}),g&&(0,e.jsx)(kje,{item:o[0]})]}),(0,e.jsx)("div",{className:Sje}),(0,e.jsx)(Rje,{data:h,handleRenderedRangeChange:v},p.length>0&&l(p[0].entity)||void 0)]})})},Rje=function(t){var n=t.data,r=t.handleRenderedRangeChange,o=qd(),a=$X(parseFloat(yje)*o,n.length,2),l=(0,i.useCallback)((function(t){var r=t-n.visibleStartIndex;return r>=0&&r<n.length?(0,e.jsx)(kje,{item:n.visibleItems[r]},r):null}),[n.length,n.visibleItems,n.visibleStartIndex]);return(0,e.jsx)(YX,{renderItem:l,onRenderedRangeChange:r,sizeProvider:a,className:Eje})};var kje=function(t){var n=t.item,r=pL(null==n?void 0:n.name),o=(0,i.useCallback)((function(){!(null==n?void 0:n.selected)&&zq(null==n?void 0:n.entity)}),[n]);return(0,e.jsx)(xO,{direction:"right",tooltip:r,children:(0,e.jsxs)(ml,{selected:null==n?void 0:n.selected,onSelect:o,className:Oe()(Oje,(null==n?void 0:n.memberCount)&&Ije),children:[(0,e.jsx)(ll,{src:null==n?void 0:n.iconPath,className:Tje}),(null==n?void 0:n.memberCount)&&(0,e.jsx)("div",{className:wje,children:null==n?void 0:n.memberCount})]})})};function Dje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Uje(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Dje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Dje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Fje(e){N("TitleSection","renameEntity",e)}const Gje={input:"input_lbJ",label:"label_GFm",container:"container_Q9t"};function Vje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Bje(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Vje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Vje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Hje=function(t){var n=t.group,r=t.tooltipTags,o=t.tooltipKeys,a=t.focusKey,l=t.name,s=t.vkLocaleKey,c=t.icon,u=Bje(function(e,t){var n=pL(e),r=Uje((0,i.useState)(null),2),o=r[0],a=r[1],l=(0,i.useCallback)((function(e){a(e.target.value)}),[a]),s=(0,i.useCallback)((function(){null!=o&&o!==n&&t(o),a(null)}),[o,n,t]),c=(0,i.useCallback)((function(){a(null)}),[]);return[null!=o?o:n,l,s,c]}(l,Fje),3),d=u[0],f=u[1],h=u[2],m=Qq(n,o,r),p=C(Rq),v=(0,i.useMemo)((function(){var e;return"".concat(null===(e=TS.value)||void 0===e?void 0:e.selectedInfoPanelTitle,"+").concat(p)}),[p]);return uu(v),(0,e.jsx)(Tl,{icon:c||void 0,children:(0,e.jsx)(xO,{direction:"right",alignment:"start",tooltip:m&&(0,e.jsx)(fI,{text:m}),children:(0,e.jsx)(bS,{uiTag:v,children:(0,e.jsx)(X0,{theme:Gje,focusKey:a,value:d,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:s}),onChange:f,onBlur:h})})})})};const Kje="selected-info-panel_gG8",Wje="gamepad-active_TBU",zje="scrollable_gsV",Yje="space_N1X",Xje="smallSpace_Bas",qje="row_OqM",$je="household-sidebar_v9l";function Qje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Zje(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Jje(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Zje(e,t,n[t])}))}return e}function eEe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function tEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Qje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Qje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var nEe=new Se("SelectedInfoPanel"),rEe=new Se("LineVisualizer"),iEe=new Se("HouseholdSidebar"),oEe=function(t){var n=t.focusKey,r=t.className,o=t.onClose,a=cr(),s=A(Dq,aEe,new Array),u=A(Uq,aEe,new Array),d=A(Fq,aEe,new Array),f=C(Gq),h=C(Bq),m=C(Hq),p=null!=h||null!=m,v=d.some((function(e){return e.__Type===Nq.Actions})),g=C(g_e),y=C(ibe),b=C(v_e),x=C(E4),_=null!=h?rEe:iEe,j=tEe((0,i.useState)(nEe),2),E=j[0],O=j[1],T=(0,i.useMemo)((function(){return{Back:function(){g||y||b?PR(VR):c(x,ii)?o():I4()},"Move Horizontal":p?function(e){return O(e<0?_:nEe),!0}:void 0,"Focus Selected Object":v?y_e:null}}),[_,g,v,p,b,o,x,y]);(0,i.useEffect)((function(){p||O(nEe)}),[p]);var I=C(Mq),S=C(Wq),w=(0,i.useMemo)((function(){return null==m?void 0:m.residence.entity}),[null==m?void 0:m.residence.entity]),N=(0,i.useMemo)((function(){var e;return null===(e=null==m?void 0:m.households[0])||void 0===e?void 0:e.entity}),[null==m?void 0:m.households]),P=(0,i.useMemo)((function(){return c(S,ii)?c(w,I)||!N?"".concat(null==w?void 0:w.index).concat(I.version).concat(I.index).concat(null==w?void 0:w.version):N&&l(N):"".concat(l(I),"->SIP")}),[N,w,S,I]),L=C(Rq),M=!c(ii,I)&&""!==L,R=(0,i.useMemo)((function(){var e;return"".concat(null===(e=TS.value)||void 0===e?void 0:e.selectedInfoPanel,"+").concat(L)}),[L]);return uu(R,M),(0,e.jsx)(Tr,{focusKey:n,className:Oe()(qje,r),children:(0,e.jsx)(Tn,{actions:T,children:(0,e.jsxs)(Ze,{focused:E,children:[h&&(0,e.jsx)(Mbe,Jje({focusKey:rEe},h),"".concat(l(S),"->LV")),m&&(0,e.jsx)(Mje,eEe(Jje({focusKey:iEe},m),{className:$je}),w&&l(w)),(0,e.jsx)(bS,{uiTag:R,active:M,children:(0,e.jsx)($r,{focusKey:nEe,header:f&&(0,e.jsx)(Hje,Jje({},f)),footer:(0,e.jsx)(Vh,{components:gje,data:d}),transitionSounds:en,className:Oe()(Kje,a&&Wje),onClose:o,children:(0,e.jsxs)(Fn,{direction:On.Vertical,children:[(0,e.jsx)(Vh,{components:gje,data:s}),(0,e.jsx)(mf,{className:zje,children:(0,e.jsx)(Vh,{components:gje,data:u})})]})},1===(null==m?void 0:m.households.length)?N&&l(N):P)})]})})})};function aEe(e,t){return t.filter(sp)}var lEe=function(t){var n=t.small;return(0,e.jsx)("div",{className:Oe()(n?Xje:Yje)})};function sEe(){var e=C(fD),t=C(Mq),n=C(fR),r=C(v_e),i=C(ibe),o=C(O4),a=C(g_e);if(c(t,ii))return!1;if(!c(e,ii))return!1;switch(n.id){case VR:return!0;case HR:return i;case"Object Tool":return o||r;case"Area Tool":return a;case"Upgrade Tool":return!0;default:return!1}}const cEe={"chirper-popup":"chirper-popup_pEX",chirperPopup:"chirper-popup_pEX",item:"item_Pf8",enter:"enter_is9","enter-active":"enter-active_pX6",enterActive:"enter-active_pX6","exit-active":"exit-active_Mg7",exitActive:"exit-active_Mg7","item-inner":"item-inner_Xwb",itemInner:"item-inner_Xwb","chirp-layout":"chirp-layout_xHZ",chirpLayout:"chirp-layout_xHZ"};function uEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||hEe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function fEe(e){return function(e){if(Array.isArray(e))return uEe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||hEe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function hEe(e,t){if(e){if("string"==typeof e)return uEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?uEe(e,t):void 0}}var mEe=function(t){var n=t.disabled,r=t.className,o=t.onClick,a=dEe((0,i.useState)([]),2),s=a[0],u=a[1],d=dEe((0,i.useState)(null),2),f=d[0],h=d[1],m=s.length>0;return(0,i.useEffect)((function(){if(!n){var e=W6.subscribe((function(e){return u((function(t){return fEe(t).concat([e])}))})),t=0;if(m){var r=function(){u((function(e){return e.slice(1,e.length)})),t=window.setTimeout(r,7e3)};t=window.setTimeout(r,7e3)}return function(){e.dispose(),window.clearTimeout(t)}}u([])}),[n,m]),(0,i.useEffect)((function(){c(null!==f?f.entity:ii,s.length>0?s[0].entity:ii)||(s.length>0?(h(s[0]),Jt(Qt.chirpEvent)):h(null))}),[f,s]),(0,e.jsx)("div",{className:Oe()(cEe.chirperPopup,r),children:(0,e.jsx)(nO,{skipInitial:!1,children:f&&(0,e.jsx)($t,{styles:cEe,children:(0,e.jsx)("div",{className:cEe.item,onClick:o,children:(0,e.jsx)("div",{className:cEe.itemInner,children:(0,e.jsx)(c7,{focusKey:Te,chirp:f,className:cEe.chirpLayout})})})},l(f.entity))})})};const pEe={button:"button_iKo button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","emergency-mode":"emergency-mode_MW7",emergencyMode:"emergency-mode_MW7","toggle-states":"toggle-states_Yz9 toggle-states_DTm",toggleStates:"toggle-states_Yz9 toggle-states_DTm",icon:"icon_qLJ icon_soN icon_Iwk"},vEe="horizontal-scroller_lkP",gEe="space_FBs",yEe="content_LaN";var bEe=function(t){var n=t.className,r=t.children,o=(0,i.useRef)(null),a=qd();return(0,i.useEffect)((function(){var e=performance.now(),t=0,n=function(r){if(o.current){var i=Math.max(o.current.scrollWidth,1);o.current.scrollLeft=.08*(r-e)*a%(i/2),t=window.requestAnimationFrame(n)}};return t=window.requestAnimationFrame(n),function(){return window.cancelAnimationFrame(t)}}),[a]),(0,e.jsxs)("div",{ref:o,className:Oe()(vEe,n),children:[(0,e.jsx)("div",{className:gEe}),(0,e.jsx)("div",{className:yEe,children:r}),(0,e.jsx)("div",{className:gEe}),(0,e.jsx)("div",{className:yEe,children:r}),(0,e.jsx)("div",{className:gEe}),(0,e.jsx)("div",{className:yEe,children:r}),(0,e.jsx)("div",{className:gEe}),(0,e.jsx)("div",{className:yEe,children:r})]})};const xEe="emergency-radio-player_v9P",_Ee="expanded_G9_",jEe="right-space_TPn",EEe="controls_mbB",OEe="volume-controls_Pqk",TEe="volume-slider_jT_",IEe="center-controls_rY1",SEe="message-field_Qua",wEe="button_Hpo";var NEe=new Se("FOCUS_EMERGENCY"),PEe=new Se("MUTE"),CEe=new Se("VOLUME"),AEe=(0,i.forwardRef)((function(t,n){var r,i=t.expanded,o=t.className,a=C(zM),l=C(KM),s=C(qM),c=C($M);return(0,e.jsx)(gpe,{enabled:i,children:(0,e.jsx)("div",{ref:n,className:Oe()(xEe,i&&_Ee,o),children:(0,e.jsx)(OI,{children:(0,e.jsxs)(Fn,{direction:On.Horizontal,children:[(0,e.jsxs)("div",{className:EEe,children:[s&&(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Radio.FOCUS_EMERGENCY,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:NEe,src:"Media/Radio/MapMarker.svg",className:wEe,onSelect:cR})}),(0,e.jsx)(xO,{tooltip:a?(0,e.jsx)(Ks.Radio.UNMUTE,{}):(0,e.jsx)(Ks.Radio.MUTE,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:PEe,src:a?"Media/Radio/VolumeMuted.svg":"Media/Radio/Volume.svg",className:wEe,onSelect:oR})}),(0,e.jsx)(Or,{focusSound:Qt.hoverItem,className:OEe,children:(0,e.jsx)(eA,{children:(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.radioPanelVolumeSlider,children:(0,e.jsx)(Fm,{focusKey:i?CEe:Te,start:0,end:1,value:l,onChange:rR,sounds:Um,className:TEe})})})}),(0,e.jsx)("div",{className:IEe,children:(0,e.jsx)(bEe,{className:SEe,children:null!=c&&(0,e.jsx)(ph,{value:c})})})]}),(0,e.jsx)("div",{className:jEe})]})})})})}));const LEe={"radio-player":"radio-player_FIM",radioPlayer:"radio-player_FIM",expanded:"expanded_feM","right-space":"right-space_BDk",rightSpace:"right-space_BDk","segment-field":"segment-field_jsn item-mouse-states_Fmi",segmentField:"segment-field_jsn item-mouse-states_Fmi","segment-field-scroller":"segment-field-scroller_sCs",segmentFieldScroller:"segment-field-scroller_sCs","segment-title":"segment-title_OlY",segmentTitle:"segment-title_OlY","segment-subtitle":"segment-subtitle_S9e",segmentSubtitle:"segment-subtitle_S9e","controls-bounds":"controls-bounds_ty4",controlsBounds:"controls-bounds_ty4","controls-visible":"controls-visible_Rcf",controlsVisible:"controls-visible_Rcf",controls:"controls_YUi","volume-controls":"volume-controls_PII",volumeControls:"volume-controls_PII","volume-slider":"volume-slider_daK",volumeSlider:"volume-slider_daK","ads-control":"ads-control_pkw",adsControl:"ads-control_pkw","ads-control-inner":"ads-control-inner_NuT",adsControlInner:"ads-control-inner_NuT","ads-label":"ads-label_XQP",adsLabel:"ads-label_XQP","center-controls":"center-controls_IeA",centerControls:"center-controls_IeA",button:"button_hbJ button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","play-pause-button":"play-pause-button_s9V button_hbJ button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",playPauseButton:"play-pause-button_s9V button_hbJ button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT"};function MEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function REe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return MEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return MEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var kEe=new Se("SEGMENT_FIELD"),DEe=new Se("MUTE"),UEe=new Se("VOLUME"),FEe=new Se("PREVIOUS"),GEe=new Se("PLAY_PAUSE"),VEe=new Se("NEXT"),BEe=new Se("ADS"),HEe=Qt.selectToggle,KEe=i.forwardRef((function(t,n){var r,o,a=t.controlsVisible,l=t.expanded,s=t.className,c=C(tR),u=C(WM),d=C(zM),f=C(KM),h=C(YM),m=REe((0,i.useState)(VEe),2),p=m[0],v=m[1];(0,i.useEffect)((function(){v(l?GEe:VEe)}),[l]);var g=(0,i.useCallback)((function(){Jt(HEe),aR()}),[]);return(0,e.jsx)(gpe,{enabled:l,children:(0,e.jsx)("div",{ref:n,className:Oe()(LEe.radioPlayer,a&&LEe.controlsVisible,l&&LEe.expanded,s),children:(0,e.jsx)(OI,{children:(0,e.jsxs)(Mn,{focused:p,direction:On.Horizontal,onChange:v,onRefocus:Rn,children:[c&&(0,e.jsx)(ml,{focusKey:kEe,className:LEe.segmentField,onSelect:Qa,children:(0,e.jsxs)(bEe,{className:LEe.segmentFieldScroller,children:[(0,e.jsx)("div",{className:LEe.segmentTitle,children:c.title}),(0,e.jsx)("div",{className:LEe.segmentSubtitle,children:c.info})]},l?1:0)}),(0,e.jsx)("div",{className:LEe.controlsBounds,children:(0,e.jsxs)("div",{className:LEe.controls,children:[(0,e.jsx)(xO,{tooltip:d?(0,e.jsx)(Ks.Radio.UNMUTE,{}):(0,e.jsx)(Ks.Radio.MUTE,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:DEe,src:d?"Media/Radio/VolumeMuted.svg":"Media/Radio/Volume.svg",className:LEe.button,onSelect:oR})}),(0,e.jsx)(Or,{focusSound:Qt.hoverItem,className:LEe.volumeControls,children:(0,e.jsx)(eA,{children:(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.radioPanelVolumeSlider,children:(0,e.jsx)(Fm,{focusKey:UEe,start:0,end:1,value:f,onChange:rR,sounds:Um,className:LEe.volumeSlider})})})}),(0,e.jsxs)("div",{className:LEe.centerControls,children:[(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Radio.PREVIOUS_BUTTON_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:FEe,src:"Media/Radio/Previous.svg",className:LEe.button,onSelect:lR})}),(0,e.jsx)(xO,{tooltip:u?(0,e.jsx)(Ks.Radio.PLAY_BUTTON_TOOLTIP,{}):(0,e.jsx)(Ks.Radio.PAUSE_BUTTON_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:GEe,src:u?"Media/Radio/Play.svg":"Media/Radio/Pause.svg",className:LEe.playPauseButton,onSelect:iR})}),(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Radio.NEXT_BUTTON_TOOLTIP,{}),children:(0,e.jsx)(xl,{tinted:!0,focusKey:VEe,src:"Media/Radio/Next.svg",className:LEe.button,onSelect:sR})})]}),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.radioPanelAdsToggle,children:(0,e.jsx)("div",{className:LEe.adsControl,onClick:g,children:(0,e.jsx)(xO,{tooltip:(0,e.jsx)(Ks.Radio.ADS_BUTTON_TOOLTIP,{}),children:(0,e.jsxs)(Tr,{focusKey:l?BEe:Te,className:LEe.adsControlInner,children:[(0,e.jsx)("div",{className:LEe.adsLabel,children:"Ads"}),(0,e.jsx)(cP,{checked:!h,className:LEe.adsToggle,onChange:aR,toggleSound:HEe})]})})})})]})}),(0,e.jsx)("div",{className:LEe.rightSpace})]})})})})}));const WEe={"station-icon":"station-icon_PgB",stationIcon:"station-icon_PgB","warning-icon":"warning-icon_VOz",warningIcon:"warning-icon_VOz",anchor:"anchor_tuN","anchor-inner":"anchor-inner_KV5",anchorInner:"anchor-inner_KV5",expanded:"expanded_SgP","player-bounds":"player-bounds_x19",playerBounds:"player-bounds_x19",player:"player_rRd",enter:"enter_eXw","enter-active":"enter-active_zDg",enterActive:"enter-active_zDg","exit-active":"exit-active_gQZ",exitActive:"exit-active_gQZ"};function zEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function YEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return zEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var XEe=new Se("RADIO_BUTTON"),qEe=new Se("PLAYER"),$Ee=function(t){var n,r=t.className,o=C(XM),a=aoe(La.Radio),l=GM("Radio"),s=C(eR),c=C(ZM),u=s.find((function(e){return e.name===c})),d=null==u?void 0:u.icon,f=YEe((0,i.useState)(!1),2),h=f[0],m=f[1],p=YEe((0,i.useState)(!1),2),v=p[0],g=p[1],y=(0,i.useCallback)((function(){return g(!0)}),[]),b=(0,i.useCallback)((function(){m(!1),g(!1)}),[]);(0,i.useEffect)((function(){var e=0,t=nR.subscribe((function(){window.clearTimeout(e),m(!0),e=window.setTimeout((function(){return m(!1)}),3e3)}));return function(){window.clearTimeout(e),t.dispose()}}),[]);var x=cr(),_=YEe((0,i.useState)(!1),2),j=_[0],E=_[1],O=YEe((0,i.useState)(!1),2),T=O[0],I=O[1],S=T?qEe:XEe,w=(0,i.useMemo)((function(){return{"Move Horizontal":function(e){var t=e<0;return T!==t&&(I(t),!0)}}}),[T]),N=(0,i.useCallback)((function(e){E(e),e||I(!1)}),[]),P=v||j&&x;return(0,e.jsx)("div",{className:Oe()(WEe.anchor,r),onMouseEnter:y,onMouseLeave:b,children:(0,e.jsx)(Tn,{actions:w,children:(0,e.jsx)(Jh,{onFocusChange:N,children:(0,e.jsxs)(Ze,{focused:S,children:[(0,e.jsx)(He,{focusKey:qEe,children:(0,e.jsxs)(nO,{children:[(a.visible||h||P)&&!o&&!l&&(0,e.jsx)("div",{className:Oe()(WEe.anchorInner,a.visible&&WEe.expanded),children:(0,e.jsx)("div",{className:WEe.playerBounds,children:(0,e.jsx)($t,{styles:WEe,children:(0,e.jsx)(KEe,{controlsVisible:P,expanded:a.visible,className:WEe.player})})})}),o&&(0,e.jsx)("div",{className:Oe()(WEe.anchorInner,a.visible&&WEe.expanded),children:(0,e.jsx)("div",{className:WEe.playerBounds,children:(0,e.jsx)($t,{styles:WEe,children:(0,e.jsx)(AEe,{expanded:a.visible,className:WEe.player})})})})]})},"player"),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.radioPanelButton,children:(0,e.jsx)(ml,{focusKey:XEe,theme:pEe,selected:a.visible,className:Oe()(WEe.button,pEe.toggleStates,o&&pEe.emergencyMode),disabled:l,onSelect:a.toggle,children:o?(0,e.jsx)(ll,{src:"Media/Glyphs/Warning.svg",className:WEe.warningIcon}):(0,e.jsx)("img",{src:d,className:WEe.stationIcon})})})]})})})})};const QEe="number-badge__VH",ZEe="animated_mNr",JEe="map-tile-badge_wN7",eOe="dev-point-badge_B9x";function tOe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function nOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return tOe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return tOe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var rOe=function(t){var n=t.className,r=t.children;return(0,e.jsx)("div",{className:Oe()(QEe,n),children:r})},iOe=function(t){var n=t.value,r=t.className,o=C(Yc),a=C(R3),l=o||!c(a,ii),s=nOe((0,i.useState)(!1),2),u=s[0],d=s[1],f=(0,i.useRef)(null);return(0,i.useEffect)((function(){if(null!=f.current&&(d(!0),n>f.current)){f.current=n;var e=window.setTimeout((function(){return d(!1)}),100);return function(){return window.clearTimeout(e)}}f.current=n}),[n]),(0,e.jsx)(rOe,{className:Oe()(!l&&!u&&ZEe,r),children:Ws(n)})};const oOe="right-menu_u58",aOe="item_sWO",lOe="chirper-popup-anchor_p7b",sOe="chirper-popup_H95",cOe="lock_IUS lock_EMU",uOe={base:"base_GQv",enter:"enter_ZkJ","exit-active":"exit-active__eD",exitActive:"exit-active__eD","enter-active":"enter-active_x_X",enterActive:"enter-active_x_X",exit:"exit_B1r"};function dOe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fOe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){dOe(e,t,n[t])}))}return e}function hOe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var mOe={direction:"left",alignment:"center"},pOe=Rr({chirper:"Media/Game/Icons/Chirper.svg",notifications:"Media/Game/Icons/Notifications.svg",lifepath:"Media/Game/Icons/Lifepath.svg",journal:"Media/Game/Icons/Journal.svg"}),vOe=function(t){var n,r,o,a=t.className,l=A(uJ,yOe,0),s=aoe(La.Notifications),c=aoe(La.Chirper),u=aoe(La.Journal),d=aoe(La.LifePath),f=aoe(La.CinematicCamera),h=C(SM),m=FM("Chirper"),p=FM("Followed Citizens"),v=FM("Event Journal"),g=C(HM),y=C(XM),b=C(ts),x=C(Sa),_=C(ka),j=b&&!_&&!c.visible&&!u.visible&&!d.visible&&!f.visible&&!h&&x===Oa.main,E=(0,i.useCallback)((function(){u.visible?Xie():N(Wie,"openJournal"),u.toggle()}),[u]);return(0,e.jsxs)("div",{className:Oe()(oOe,a),children:[(0,e.jsx)(D0,{in:l>0||s.visible,children:(0,e.jsx)(jL,hOe(fOe({},mOe),{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_NOTIFICATIONS,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_NOTIFICATIONS,{}),children:(0,e.jsx)($t,{styles:uOe,children:(0,e.jsx)(gOe,{src:pOe.notifications,selected:s.visible,onSelect:s.toggle,children:l>0&&(0,e.jsx)(rOe,{children:(0,e.jsx)(dc,{value:l,unit:tc.Integer})})})})}),"notifications-button")}),(0,e.jsxs)("div",{className:Oe()(aOe,lOe),children:[(0,e.jsx)(mEe,{disabled:!j,className:sOe,onClick:c.toggle}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.chirperPanelButton,children:(0,e.jsx)(x7,hOe(fOe({},mOe),{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_CHIRPER,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_CHIRPER,{}),locked:m.locked,requirements:m.requirements,children:(0,e.jsx)(gOe,{src:pOe.chirper,selected:c.visible,selectSound:Qt.chirper,locked:m.locked,onSelect:c.toggle})}))})]}),(0,e.jsx)(bS,{uiTag:null===(r=TS.value)||void 0===r?void 0:r.lifePathPanelButton,children:(0,e.jsx)(x7,hOe(fOe({},mOe),{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_FOLLOWED_CITIZENS,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_FOLLOWED_CITIZENS,{}),locked:p.locked,requirements:p.requirements,children:(0,e.jsx)(gOe,{src:pOe.lifepath,selected:d.visible,locked:p.locked,onSelect:d.toggle})}))}),(0,e.jsx)(bS,{uiTag:null===(o=TS.value)||void 0===o?void 0:o.eventJournalPanelButton,children:(0,e.jsx)(x7,hOe(fOe({},mOe),{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_EVENT_JOURNAL,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_EVENT_JOURNAL,{}),locked:v.locked,requirements:v.requirements,children:(0,e.jsx)(gOe,{src:pOe.journal,selected:u.visible,locked:v.locked,onSelect:E})}))}),(g||y)&&(0,e.jsx)($Ee,{className:aOe})]})},gOe=i.forwardRef((function(t,n){var r=t.src,i=t.selected,o=t.locked,a=t.selectSound,l=t.children,s=t.className,c=t.onSelect;return(0,e.jsx)("div",{ref:n,className:Oe()(aOe,s),children:(0,e.jsxs)(xl,{src:r,selected:i,disabled:o,selectSound:a,theme:pEe,className:pEe.toggleStates,onSelect:c,children:[l,o&&(0,e.jsx)(YN,{className:cOe})]})})}));function yOe(e,t){return t.length}const bOe={"city-name-field":"city-name-field_XDy field_eKJ selectable_otQ",cityNameField:"city-name-field_XDy field_eKJ selectable_otQ",container:"container_MC3",input:"input_JJ_ content_syM",label:"label_mWz content_syM"};function xOe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _Oe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return xOe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xOe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var jOe=function(){var t=C(_3),n=(0,i.useCallback)((function(e){return function(e){N("toolbarBottom","setCityName",e)}(e.target.value)}),[]),r=_Oe((0,i.useState)(!1),2),o=r[0],a=r[1],l=(0,i.useCallback)((function(){return a(!0)}),[]),s=(0,i.useCallback)((function(){return a(!1)}),[]);return(0,e.jsx)(jL,{disabled:o,title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_CITY_NAME,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_CITY_NAME,{}),children:(0,e.jsx)(Tr,{className:bOe.cityNameField,children:(0,e.jsx)(X0,{value:t,vkTitle:(0,e.jsx)(Ks.VirtualKeyboard.TITLE,{hash:"CityName"}),theme:bOe,onChange:n,onFocus:l,onBlur:s})})})};const EOe="content_B0O",OOe="indicators_ZC7",TOe="icon_Tkh",IOe="active_nrD",SOe="trend_NRr",wOe="visible__qP",NOe="dev-info_PVK",POe="factors_IuM";function COe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function AOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return COe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return COe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var LOe=["Media/Game/Icons/Depressed.svg","Media/Game/Icons/Sad.svg","Media/Game/Icons/Neutral.svg","Media/Game/Icons/Content.svg","Media/Game/Icons/Happy.svg"],MOe=function(){var t=C(Uf),n=C(q7),r=function(e){return e>70?4:e>55?3:e>40?2:e>25?1:0}(n),o=function(e){var t=AOe((0,i.useState)(0),2),n=t[0],r=t[1],o=(0,i.useRef)(e),a=(0,i.useRef)(e),l=(0,i.useRef)(null),s=(0,i.useRef)(null),c=(0,i.useMemo)((function(){var e=function(){r(0),s.current=null},t=function(){var n=a.current-o.current;Math.abs(n)>0?(o.current=a.current,r(n),s.current&&window.clearTimeout(s.current),s.current=window.setTimeout(e,1e4),l.current=window.setTimeout(t,15e3)):l.current=null};return t}),[]);return(0,i.useEffect)((function(){a.current=e,null==l.current&&c()}),[c,e]),(0,i.useEffect)((function(){return function(){null!=l.current&&window.clearTimeout(l.current),null!=s.current&&window.clearTimeout(s.current)}}),[]),n}(n),a=Ea("Happiness"),l=C($7);return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.CityInfoPanel.TOOLTIP_HAPPINESS_TITLE,{}),description:(0,e.jsx)(Ks.CityInfoPanel.TOOLTIP_HAPPINESS_DESCRIPTION,{}),content:l.length>0&&(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)(b$,{}),(0,e.jsx)("div",{className:POe,children:l.map((function(t,n){return(0,e.jsx)(d$,{left:t.weight>0?(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_POSITIVE,{hash:t.factor}):(0,e.jsx)(Ks.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:t.factor}),right:(0,e.jsx)("div",{className:Ef(Uae,t.weight),children:(0,e.jsx)(dc,{value:t.weight,signed:!0})})},n)}))})]}),children:(0,e.jsxs)(ik,{contentClassName:EOe,onSelect:a,children:[(0,e.jsx)("img",{src:"Media/Game/Misc/HappinessMinus.svg",className:Oe()(SOe,o<0&&wOe)}),(0,e.jsx)("div",{className:OOe,children:LOe.map((function(t,n){return(0,e.jsx)("img",{src:t,className:Oe()(TOe,n===r&&IOe)},n)}))}),(0,e.jsx)("img",{src:"Media/Game/Misc/HappinessPlus.svg",className:Oe()(SOe,o>0&&wOe)}),t&&(0,e.jsx)("div",{className:NOe,children:n})]})})};const ROe={content:"content_QTZ",icon:"icon_bCS",value:"value_ruP",negative:"negative_xQP",trend:"trend_IAr","trend-icon":"trend-icon_AgE",trendIcon:"trend-icon_AgE",positive:"positive_PUr",unlimited:"unlimited_Dsm"};var kOe=function(t){var n=t.icon,r=t.value,i=t.valueUnit,o=t.trend,a=t.trendIcon,l=t.unlimited,s=void 0!==l&&l,c=t.className,u=t.onSelect;return(0,e.jsxs)(ik,{contentClassName:ROe.content,onSelect:u,className:Oe()(ROe.statField,c),children:[(0,e.jsx)("img",{src:n,className:ROe.icon}),s?(0,e.jsx)("div",{className:ROe.unlimited,children:"∞"}):(0,e.jsxs)(e.Fragment,{children:[(0,e.jsx)("div",{className:Oe()(ROe.value,r<0&&ROe.negative),children:(0,e.jsx)(dc,{value:r,unit:i})}),a&&(0,e.jsx)("div",{className:ROe.trend,children:(0,e.jsx)(ll,{src:a,className:Oe()(ROe.trendIcon,Ef(ROe,o))})})]})]})};const DOe={trend:"trend_K7y",positive:"positive_n5t",negative:"negative_Moc"};var UOe=function(){var t=C(b3),n=C(x3),r=GM("City Budget"),i=C(j3),o=function(e,t){var n=C(O3),r=Math.abs(e),i=Math.abs(t);return 0===i?void 0:i<=r*n.x?"Media/Glyphs/".concat(t<0?"TrendDown":"TrendUp",".svg"):i<=r*n.y?"Media/Glyphs/".concat(t<0?"TrendDownMedium":"TrendUpMedium",".svg"):"Media/Glyphs/".concat(t<0?"TrendDownHigh":"TrendUpHigh",".svg")}(t,n);return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_MONEY,{}),description:i?(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_UNLIMITED_MONEY,{}):(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_MONEY,{}),content:(0,e.jsxs)("div",{className:DOe.trend,children:[(0,e.jsx)(Ks.Toolbar.CURRENT_TREND,{}),(0,e.jsx)("div",{className:Ef(DOe,n),children:(0,e.jsx)(dc,{value:n,unit:tc.MoneyPerHour,signed:!0})})]}),children:(0,e.jsx)(kOe,{icon:"Media/Game/Icons/Money.svg",value:t,valueUnit:tc.Money,trend:n,trendIcon:o,unlimited:i,onSelect:r?void 0:FOe,className:DOe.moneyField})})};function FOe(){Ua(La.Economy)}const GOe={trend:"trend_IdP",positive:"positive_yei",negative:"negative_LzO"};var VOe=function(){var t=C(g3),n=C(y3),r=Ea("Population"),i=function(e,t){var n=C(E3),r=Math.abs(e),i=Math.abs(t);return 0===i?void 0:i<=r*n.x?"Media/Glyphs/".concat(t<0?"TrendDown":"TrendUp",".svg"):i<=r*n.y?"Media/Glyphs/".concat(t<0?"TrendDownMedium":"TrendUpMedium",".svg"):"Media/Glyphs/".concat(t<0?"TrendDownHigh":"TrendUpHigh",".svg")}(t,n);return(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_POPULATION,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_POPULATION,{}),content:(0,e.jsxs)("div",{className:GOe.trend,children:[(0,e.jsx)(Ks.Toolbar.CURRENT_TREND,{}),(0,e.jsx)("div",{className:Ef(GOe,n),children:(0,e.jsx)(dc,{value:n,unit:tc.IntegerPerHour,signed:!0})})]}),children:(0,e.jsx)(kOe,{icon:"Media/Game/Icons/Citizen.svg",value:t,valueUnit:tc.Integer,trend:n,trendIcon:i,onSelect:r,className:GOe.populationField})})};const BOe={width:"116px",height:"36px",shadowHeight:"1.5px",rangeFill:"rgba(255, 255, 255, 0.08)",shadowFill:"rgba(0, 0, 0, 0.2)",image:"image_E3g"};var HOe=function(t){var n=t.items,r=t.className,o=Xd(BOe.width),a=Xd(BOe.height),l=a/Math.max(1,n.length),s=l/2,c=Xd(BOe.shadowHeight);return(0,e.jsx)(Wn,{children:(0,e.jsx)("div",{className:Oe()(BOe.demandBars,r),children:(0,e.jsxs)("svg",{viewBox:"0 0 ".concat(o," ").concat(a),className:BOe.image,children:[(0,e.jsxs)("linearGradient",{id:"shadow",gradientUnits:"objectBoundingBox",x1:0,x2:0,y1:1,y2:0,children:[(0,e.jsx)("stop",{offset:"0",stopColor:BOe.shadowFill}),(0,e.jsx)("stop",{offset:c/l,stopColor:BOe.shadowFill}),(0,e.jsx)("stop",{offset:c/l,stopColor:"rgba(0, 0, 0, 0)"}),(0,e.jsx)("stop",{offset:"1",stopColor:"rgba(0, 0, 0, 0)"})]}),n.map((function(t,n){return(0,e.jsxs)(i.Fragment,{children:[(0,e.jsx)("clipPath",{id:t.key,children:(0,e.jsx)("rect",{x:"0",y:n*l,width:o,height:l,rx:s,ry:s})}),(0,e.jsx)("rect",{x:"0",y:n*l,width:o,height:l,rx:s,ry:s,fill:BOe.rangeFill}),(0,e.jsx)("rect",{x:-l,y:n*l,width:Math.round(l+at(t.value,0,1)*o),height:l,rx:s,ry:s,clipPath:"url(#".concat(t.key,")"),fill:t.color}),(0,e.jsx)("rect",{x:"0",y:n*l,width:o,height:l,rx:s,ry:s,fill:"url(#shadow)"})]},t.key)}))]})})})};const KOe={button:"button_s2g button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","no-border":"no-border_Kqc",noBorder:"no-border_Kqc","toggle-states":"toggle-states_X82 toggle-states_DTm",toggleStates:"toggle-states_X82 toggle-states_DTm",icon:"icon_KJZ icon_soN icon_Iwk"},WOe="city-info-field_kp7",zOe="field_OvX",YOe="toggle_kzL",XOe="lock_D8i lock_EMU",qOe="legend_wn_";function $Oe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function QOe(e){return function(e){if(Array.isArray(e))return $Oe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return $Oe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $Oe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ZOe=Rr({City:"Media/Game/Icons/City.svg"}),JOe=function(){var t,n,r=C(D7),i=C(U7),o=C(F7),a=C(G7),l=C(V7),s=C(B7),c=aoe(La.CityInfo),u=FM("City Info Panel"),d=GM("Residential Medium"),f=GM("Residential High"),h=GM("ZonesOffice"),m=[{key:"ResidentialLow",color:b9[y9.ResidentialLow],value:r}].concat(QOe(d?[]:[{key:"ResidentialMedium",color:b9[y9.ResidentialMedium],value:i}]),QOe(f?[]:[{key:"ResidentialHigh",color:b9[y9.ResidentialHigh],value:o}]),[{key:"Commercial",color:b9[y9.Commercial],value:a},{key:"Industrial",color:b9[y9.Industrial],value:l}],QOe(h?[]:[{key:"Office",color:b9[y9.Office],value:s}]));return(0,e.jsxs)("div",{className:WOe,children:[(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.cityInfoPanelButton,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_CITY_INFO,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_CITY_INFO,{}),locked:u.locked,requirements:u.requirements,children:(0,e.jsx)(xl,{src:ZOe.City,selected:c.visible,disabled:u.locked,theme:KOe,className:Oe()(YOe,KOe.toggleStates),onSelect:c.toggle,children:u.locked&&(0,e.jsx)(YN,{className:XOe})})})}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolbarDemand,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_DEMAND,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_DEMAND,{}),content:(0,e.jsxs)("div",{className:qOe,children:[(0,e.jsx)(eTe,{type:y9.ResidentialLow}),!d&&(0,e.jsx)(eTe,{type:y9.ResidentialMedium}),!f&&(0,e.jsx)(eTe,{type:y9.ResidentialHigh}),(0,e.jsx)(eTe,{type:y9.Commercial}),(0,e.jsx)(eTe,{type:y9.Industrial}),!h&&(0,e.jsx)(eTe,{type:y9.Office})]}),children:(0,e.jsx)(HOe,{items:m,className:zOe})})})]})},eTe=function(t){var n=t.type;return(0,e.jsx)(yv,{color:b9[n],label:(0,e.jsx)(Ks.CityInfoPanel.DEMAND_TITLE,{hash:y9[n]})})};const tTe={"progression-message-feed":"progression-message-feed_P4X",progressionMessageFeed:"progression-message-feed_P4X","item-transition":"item-transition_ugO",itemTransition:"item-transition_ugO",enter:"enter_nmi","enter-active":"enter-active_bWQ",enterActive:"enter-active_bWQ",exit:"exit_mXQ","exit-active":"exit-active_SEi",exitActive:"exit-active_SEi",item:"item_XMq",amount:"amount_nbC",reason:"reason_tLs",space:"space_m_Q"};function nTe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rTe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||oTe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function iTe(e){return function(e){if(Array.isArray(e))return nTe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||oTe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function oTe(e,t){if(e){if("string"==typeof e)return nTe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?nTe(e,t):void 0}}var aTe=function(t){var n=t.className,r=rTe((0,i.useState)([]),2),o=r[0],a=r[1];return(0,i.useEffect)((function(){var e=new sTe(a);return function(){return e.dispose()}}),[]),(0,e.jsx)("div",{className:Oe()(tTe.progressionMessageFeed,n),children:(0,e.jsx)(nO,{children:o.map((function(t){return(0,e.jsx)(lTe,{data:t},t.time)}))})})},lTe=function(t){var n=t.data;return(0,i.useEffect)((function(){return Jt(Qt.xpEvent)}),[]),(0,e.jsx)(lJ,{styles:tTe,exitCollapseHeight:!1,children:(0,e.jsxs)("div",{className:tTe.itemTransition,children:[(0,e.jsxs)("div",{className:tTe.item,children:[(0,e.jsx)("div",{className:tTe.amount,children:(0,e.jsx)(dc,{signed:!0,value:n.message.amount,unit:tc.XP})}),(0,e.jsx)("div",{className:tTe.reason,children:(0,e.jsx)(Ks.Progression.XP_REASON,{hash:n.message.reason})})]}),(0,e.jsx)("div",{className:tTe.space})]})})},sTe=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.listener=t,this.activeMessages=[],this.pendingMessages=[],this.updateTimeoutHandle=0,this.subscription=A3.subscribe(this.handleMessageAdded.bind(this))}var t=e.prototype;return t.handleMessageAdded=function(e){this.pendingMessages.unshift(e),window.clearTimeout(this.updateTimeoutHandle),this.update()},t.update=function(){for(var e=performance.now(),t=!1,n=this.activeMessages.length-1;n>=0;n--){var r=this.activeMessages[n];(r.time+4e3<e||r.time>e)&&(this.activeMessages.splice(n,1),t=!0)}var i=this.activeMessages.reduce((function(e,t){return Math.max(e,t.time)}),0);if(this.activeMessages.length<4&&e-i>500){var o=this.pendingMessages.pop();null!=o&&(this.activeMessages.push({message:o,time:e}),i=e,t=!0)}t&&this.listener(iTe(this.activeMessages));var a=null;if(this.activeMessages.length>0){var l=this.activeMessages.reduce((function(e,t){return Math.min(e,t.time)}),e);a=Math.min(l+4e3,null!=a?a:Number.MAX_VALUE)}this.pendingMessages.length>0&&(a=Math.min(e+500,null!=a?a:Number.MAX_VALUE)),null!=a&&window.setTimeout(this.update.bind(this),a-e)},t.dispose=function(){window.clearTimeout(this.updateTimeoutHandle),this.subscription.dispose()},e}();const cTe={strokeWidth:"6","progress-circle":"progress-circle_jvw progress-circle_OLN",progressCircle:"progress-circle_jvw progress-circle_OLN",progress:"progress_i1E progress_mlv",circle:"circle_Apc"},uTe="progression-field_Lho",dTe="field_p2F",fTe="max-milestone-reached___5",hTe="toggle_bAE",mTe="progress_NK4",pTe="feed_zoj",vTe="lock_YHO lock_EMU",gTe="milestone_Eev";var yTe={tension:150,friction:20},bTe=function(){var t,n=aoe(La.Progression),r=FM("Progression Panel"),i=C(w3),o=C(N3),a=C(P3),l=C(C3),s=V$(yTe,l),c=C(L3),u=C($he),d=Math.max(a-o,0),f=at(s-o,0,d),h=!c&&!r.locked;return(0,e.jsxs)("div",{className:uTe,children:[(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.progressionPanelButton,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_PROGRESSION,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_PROGRESSION,{}),content:c?void 0:(0,e.jsx)(ah,{value:f,total:d,unit:tc.XP}),locked:r.locked,requirements:r.requirements,children:(0,e.jsxs)(ml,{selected:n.visible,disabled:r.locked,className:Oe()(hTe,KOe.toggleStates,h&&KOe.noBorder),theme:KOe,onSelect:n.toggle,children:[c?(0,e.jsx)("img",{src:"Media/Game/Icons/Trophy.svg",className:KOe.icon}):(0,e.jsx)("div",{className:gTe,children:(0,e.jsx)(dc,{value:i})}),h&&(0,e.jsx)(zE,{progress:f,max:d,theme:cTe,className:mTe}),u>0&&(0,e.jsx)(iOe,{value:u,className:eOe}),r.locked&&(0,e.jsx)(YN,{className:vTe})]})})}),(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_CURRENT_MILESTONE,{}),description:c?(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_MAX_MILESTONE,{}):(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_CURRENT_MILESTONE,{}),children:(0,e.jsx)("div",{className:Oe()(dTe,c&&fTe),children:(0,e.jsx)(Ks.Progression.MILESTONE_NAME,{index:i})})}),!c&&(0,e.jsx)(aTe,{className:pTe})]})};const xTe="lock_EMU";var _Te=Rr({Economy:"Media/Game/Icons/Economy.svg",TransportationOverview:"Media/Game/Icons/TransportationOverview.svg",CityStatistics:"Media/Game/Icons/CityStatistics.svg",MapTile:"Media/Game/Icons/MapTile.svg",PhotoMode:"Media/Game/Icons/PhotoMode.svg"}),jTe=function(){var t,n=aoe(La.Economy),r=FM("City Budget");return(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_CITY_ECONOMY,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_CITY_ECONOMY,{}),locked:r.locked,requirements:r.requirements,children:(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.economyPanelButton,children:(0,e.jsx)(xl,{src:_Te.Economy,selected:n.visible,disabled:r.locked,selectSound:Qt.economy,theme:KOe,className:KOe.toggleStates,onSelect:n.toggle,children:r.locked&&(0,e.jsx)(YN,{className:xTe})})})})},ETe=function(){var t,n=aoe(La.TransportationOverview),r=FM("Transportation Overview");return(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.transportationOverviewPanelButton,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_LINES_OVERVIEW,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_LINES_OVERVIEW,{}),locked:r.locked,requirements:r.requirements,children:(0,e.jsx)(xl,{src:_Te.TransportationOverview,selected:n.visible,disabled:r.locked,theme:KOe,className:KOe.toggleStates,onSelect:n.toggle,children:r.locked&&(0,e.jsx)(YN,{className:xTe})})})})},OTe=function(){var t,n=aoe(La.Statistics),r=FM("City Statistics");return(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.statisticsPanelButton,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_CITY_STATISTICS,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_CITY_STATISTICS,{}),locked:r.locked,requirements:r.requirements,children:(0,e.jsx)(xl,{src:_Te.CityStatistics,selected:n.visible,disabled:r.locked,theme:KOe,className:KOe.toggleStates,onSelect:n.toggle,children:r.locked&&(0,e.jsx)(YN,{className:xTe})})})})},TTe=function(){var t,n=C(SM),r=C(LM),o=FM("Map Tiles"),a=(0,i.useCallback)((function(){return RM(!n)}),[n]);return(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.mapTilePanelButton,children:(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_MAP_TILES,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_MAP_TILES,{}),locked:o.locked,requirements:o.requirements,children:(0,e.jsxs)(xl,{src:_Te.MapTile,selected:n,disabled:o.locked,theme:KOe,className:KOe.toggleStates,onSelect:a,children:[!o.locked&&r>0&&(0,e.jsx)(iOe,{value:r,className:JEe}),o.locked&&(0,e.jsx)(YN,{className:xTe})]})})})},ITe=function(){var t,n=aoe(La.PhotoMode),r=FM("Photo Mode");return(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_PHOTO_MODE,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_PHOTO_MODE,{}),locked:r.locked,requirements:r.requirements,children:(0,e.jsx)(bS,{uiTag:null===(t=TS.value)||void 0===t?void 0:t.photoModePanelButton,children:(0,e.jsx)(xl,{src:_Te.PhotoMode,selected:n.visible,disabled:r.locked,theme:KOe,className:KOe.toggleStates,onSelect:n.toggle,children:r.locked&&(0,e.jsx)(YN,{className:xTe})})})})};const STe="toolbar-button-strip_CoK",wTe="group_i85",NTe="button_cBV",PTe="highlight_XBc",CTe="lock_bNk";var ATe=function(t){var n=t.focusKey,r=t.className,o=C(aD),a=C(hD),s=C(dD),u=(0,i.useMemo)((function(){var e=Math.min(o.length-1,1);return-1!==e&&o[e].children.length>0?l(o[e].children[0].entity):null}),[o]);return(0,e.jsx)("div",{className:Oe()(STe,r),children:(0,e.jsx)(Fn,{focusKey:n,initialFocused:u,direction:On.Horizontal,children:o.map((function(t){return(0,e.jsx)("div",{className:wTe,children:t.children.map((function(t){return(0,e.jsx)(LTe,{item:t,selected:c(t.entity,a)||c(t.entity,s)},l(t.entity))}))},l(t.entity))}))})})},LTe=function(t){var n,r=t.item,o=t.selected,a=(0,i.useCallback)((function(){r.type===iD.menu?pD(r.entity):(gD(r.entity),au(r.uiTag,!0))}),[r.entity,r.type,r.uiTag]),s=M(OS,r.entity);return(0,e.jsx)(bS,{uiTag:r.uiTag,active:!(r.locked&&r.type===iD.asset),children:(0,e.jsx)(x7,{title:null!=s?(0,e.jsx)(Ss,{id:s.titleId}):r.name,description:null!=s?(0,e.jsx)(Ss,{id:s.descriptionId}):void 0,locked:r.locked,requirements:r.requirements,children:(0,e.jsxs)(xl,{focusKey:l(r.entity),src:r.icon,selected:o,disabled:r.locked&&r.type===iD.asset,selectSound:null!==(n=o?r.deselectSound:r.selectSound)&&void 0!==n?n:void 0,theme:loe,className:Oe()(NTe,loe.toggleStates,r.locked&&loe.locked),onSelect:o?yD:a,children:[r.highlight&&(0,e.jsx)("div",{className:PTe}),r.locked&&(0,e.jsx)(YN,{className:CTe})]})})})};const MTe="icon_rqi icon_KJZ icon_soN icon_Iwk",RTe="underground_heZ",kTe="lock_okm lock_EMU";Rr({underground:"Media/Game/Misc/Underground.svg",undergroundMask:"Media/Game/Misc/UndergroundToggleMask.svg"});var DTe=function(){var t,n,r=C(ER),o=C(OR),a=(0,i.useCallback)((function(){return FR(!o)}),[o]),l=FM("Underground Mode");return su(null===(t=TS.value)||void 0===t?void 0:t.toolbarUnderground,o),(0,e.jsx)(x7,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_UNDERGROUND,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_UNDERGROUND,{}),locked:l.locked,requirements:l.requirements,children:(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.toolbarUnderground,children:(0,e.jsxs)(ml,{selected:o,disabled:l.locked||!r,selectSound:o?Qt.increaseElevation:Qt.decreaseElevation,theme:KOe,className:KOe.toggleStates,onSelect:a,children:[(0,e.jsx)("div",{className:Oe()(MTe,o&&RTe)}),l.locked&&(0,e.jsx)(YN,{className:kTe})]})})})};const UTe="toolbar_QYu",FTe="hidden__OM",GTe="social-menu-anchor_oJe",VTe="social-menu_nHI",BTe="top_ZSs",HTe="bottom_vae",KTe="paused_ICO",WTe="top-inner_v2o container_yy5",zTe="bottom-inner_ZYV container_yy5",YTe="spacer_oEi",XTe="start_hR7",qTe="end_G0e",$Te="divider_GaZ",QTe="bulldoze-bar_D37",ZTe="active_hed";function JTe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var eIe=new Se("toolbar_top"),tIe=new Se("toolbar_bottom"),nIe=new Se("button_strip"),rIe=function(t){var n=t.focusKey,r=t.className;C(TS);var i=aoe(La.PhotoMode);return(0,e.jsx)(Lr,{children:(0,e.jsx)(Fn,{focusKey:n,initialFocused:eIe,direction:On.Vertical,onRefocus:Rn,children:(0,e.jsxs)("div",{className:Oe()(UTe,r,JTe({},FTe,i.visible)),children:[(0,e.jsx)("div",{className:GTe,children:(0,e.jsx)(vOe,{className:VTe})}),(0,e.jsx)(iIe,{}),(0,e.jsx)(lIe,{}),(0,e.jsx)(sIe,{})]})})})},iIe=function(){var t,n=C(fR).id===GR;return uu(null===(t=TS.value)||void 0===t?void 0:t.toolbarBulldozerBar,n),(0,e.jsx)("div",{className:Oe()(QTe,n&&ZTe)})},oIe=(0,e.jsx)("div",{className:$Te}),aIe=(0,e.jsx)("div",{className:YTe}),lIe=function(){return(0,e.jsx)("div",{className:BTe,children:(0,e.jsx)("div",{className:WTe,children:(0,e.jsxs)(Fn,{focusKey:eIe,initialFocused:nIe,direction:On.Horizontal,children:[(0,e.jsxs)("div",{className:XTe,children:[(0,e.jsx)(TTe,{}),oIe,(0,e.jsx)(bTe,{}),oIe,(0,e.jsx)(JOe,{})]}),(0,e.jsx)(ATe,{focusKey:nIe}),(0,e.jsxs)("div",{className:qTe,children:[aIe,(0,e.jsx)(jTe,{}),oIe,(0,e.jsx)(ETe,{}),oIe,(0,e.jsx)(OTe,{}),oIe,(0,e.jsx)(DTe,{}),aIe,(0,e.jsx)(ITe,{})]})]})})})},sIe=function(){var t=C(Kp);return(0,e.jsx)("div",{className:Oe()(HTe,t&&KTe),children:(0,e.jsx)("div",{className:zTe,children:(0,e.jsxs)(Fn,{focusKey:tIe,children:[(0,e.jsx)(Ok,{}),(0,e.jsx)(qG,{}),(0,e.jsx)(jOe,{}),(0,e.jsx)(VOe,{}),(0,e.jsx)(UOe,{}),(0,e.jsx)(MOe,{})]})})})},cIe=function(t){var n=t.children,r=C(Yc),o=C(Xc),a=C(Gc),l=aS(),s=(0,i.useMemo)((function(){return{"Continue Tutorial":tu}}),[]),c=(0,i.useMemo)((function(){return{"Previous Tutorial Phase":iS}}),[]),u=(0,i.useMemo)((function(){return{"Focus Tutorial List":eu}}),[]),d=(0,i.useMemo)((function(){return{Advisor:mu}}),[]);(0,i.useEffect)((function(){null!==o&&Wc(!1)}),[o]);var f=null!=a&&null==o,h=null!=r&&null!=o&&nS(r,o),m=null!=r&&null!=o&&rS(r,o)>0;return(0,e.jsx)(Tn,{actions:d,disabled:!l,children:(0,e.jsx)(Tn,{actions:u,disabled:!f,children:(0,e.jsx)(Tn,{actions:s,disabled:!h,children:(0,e.jsx)(Tn,{actions:c,disabled:!m,children:n})})})})};const uIe={header:"header_Quv header_Bpo child-opacity-transition_nkS",content:"content_OGC content_AD7 child-opacity-transition_nkS",footer:"footer_H3w footer_pD5 child-opacity-transition_nkS"},dIe={wrapper:"wrapper_GJY",wide:"wide_RVn","image-layout":"image-layout_DU8",imageLayout:"image-layout_DU8",image:"image_KoE",chirper:"chirper_KjN",logo:"logo_igH",content:"content_vpm",title:"title_QRS",subtitle:"subtitle_gN8",description:"description_VKr","checkbox-container":"checkbox-container_ety",checkboxContainer:"checkbox-container_ety","checkbox-label":"checkbox-label_YsL",checkboxLabel:"checkbox-label_YsL",checkbox:"checkbox_OCf",divider:"divider_agt","button-container":"button-container_vXF",buttonContainer:"button-container_vXF",button:"button_b9w","dialog-button":"dialog-button_iCQ",dialogButton:"dialog-button_iCQ"};function fIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return fIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fIe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var mIe,pIe=new Se("BEGIN");!function(e){e[e.Welcome=0]="Welcome",e[e.Preface=1]="Preface",e[e.TutorialConfirmation=2]="TutorialConfirmation"}(mIe||(mIe={}));var vIe=function(t){var n=t.focusKey,r=hIe((0,i.useState)(mIe.Welcome),2),o=r[0],a=r[1],l=(0,i.useCallback)((function(e){return a(e?mIe.Preface:mIe.TutorialConfirmation)}),[]),s=(0,i.useCallback)((function(e){e?a(mIe.Welcome):ru(!1)}),[]),c=(0,i.useCallback)((function(){return ru(!0)}),[]);return(0,e.jsx)($r,{focusKey:n,theme:uIe,className:dIe.tutorialIntroPanel,contentClassName:dIe.content,children:(0,e.jsxs)(Fn,{initialFocused:pIe,children:[o===mIe.Welcome&&(0,e.jsx)(gIe,{onContinue:l}),o===mIe.Preface&&(0,e.jsx)(yIe,{onContinue:c}),o===mIe.TutorialConfirmation&&(0,e.jsx)(bIe,{onContinue:s})]})})},gIe=function(t){var n=t.onContinue,r=hIe((0,i.useState)(!0),2),o=r[0],a=r[1],l=(0,i.useCallback)((function(){n(o)}),[o,n]);return(0,e.jsxs)("div",{className:Oe()(dIe.wrapper,dIe.wide),children:[(0,e.jsxs)("div",{className:dIe.imageLayout,children:[(0,e.jsx)("img",{src:"Media/Game/Milestones/Cityscape01.svg",className:dIe.image}),(0,e.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dIe.logo})]}),(0,e.jsx)("div",{className:dIe.title,children:(0,e.jsx)(Ks.Tutorials.INTRO_TITLE,{})}),(0,e.jsx)("div",{className:dIe.subtitle,children:(0,e.jsx)(Ks.Tutorials.INTRO_SUBTITLE,{})}),(0,e.jsx)("div",{className:dIe.description,children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Tutorials.INTRO,{})})}),(0,e.jsx)(ml,{focusKey:pIe,theme:Ad,className:dIe.button,onSelect:l,children:(0,e.jsx)(Ks.Tutorials.BEGIN_WITH_TUTORIALS,{})}),(0,e.jsxs)(Or,{className:dIe.checkboxContainer,children:[(0,e.jsx)(pp,{checked:o,onChange:a,className:dIe.checkbox}),(0,e.jsx)("div",{className:dIe.checkboxLabel,children:(0,e.jsx)(Ks.Tutorials.ENABLE_TUTORIALS_CONFIRM,{})})]})]})},yIe=function(t){var n=t.onContinue,r=(0,i.useCallback)((function(){return n(!0)}),[n]);return(0,e.jsxs)("div",{className:dIe.wrapper,children:[(0,e.jsxs)("div",{className:dIe.imageLayout,children:[(0,e.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dIe.logo}),(0,e.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dIe.chirper})]}),(0,e.jsx)("div",{className:dIe.divider}),(0,e.jsx)("div",{className:dIe.description,children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Tutorials.BEFORE_STARTING,{})})}),(0,e.jsx)(ml,{theme:Ad,className:dIe.button,onSelect:r,children:(0,e.jsx)(Ks.Tutorials.BEFORE_STARTING_CONFIRM,{})})]})},bIe=function(t){var n=t.onContinue,r=(0,i.useCallback)((function(){return n(!1)}),[n]),o=(0,i.useCallback)((function(){return n(!0)}),[n]),a=cr();return(0,e.jsxs)("div",{className:dIe.wrapper,children:[(0,e.jsxs)("div",{className:dIe.imageLayout,children:[(0,e.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dIe.logo}),(0,e.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dIe.chirper})]}),(0,e.jsx)("div",{className:dIe.divider}),(0,e.jsx)("div",{className:dIe.description,children:(0,e.jsx)(fI,{renderer:VI,children:a?(0,e.jsx)(Ks.Tutorials.DISABLE_CONFIRMATION_TEXT_GAMEPAD,{}):(0,e.jsx)(Ks.Tutorials.DISABLE_CONFIRMATION_TEXT,{})})}),(0,e.jsxs)("div",{className:dIe.buttonContainer,children:[(0,e.jsx)(ml,{theme:Ad,className:Oe()(dIe.button,dIe.dialogButton),onSelect:r,children:(0,e.jsx)(Ks.Common.YES,{})}),(0,e.jsx)(ml,{theme:Ad,className:Oe()(dIe.button,dIe.dialogButton,Ad.negative),onSelect:o,children:(0,e.jsx)(Ks.Common.NO,{})})]})]})},xIe=new Se("BEGIN"),_Ie=function(t){var n=t.focusKey;return(0,e.jsx)($r,{focusKey:n,theme:uIe,className:dIe.tutorialIntroPanel,contentClassName:dIe.content,children:(0,e.jsx)(Fn,{initialFocused:xIe,children:(0,e.jsxs)("div",{className:dIe.wrapper,children:[(0,e.jsxs)("div",{className:dIe.imageLayout,children:[(0,e.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dIe.logo}),(0,e.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dIe.chirper})]}),(0,e.jsx)("div",{className:dIe.divider}),(0,e.jsx)("div",{className:dIe.description,children:(0,e.jsx)(fI,{children:(0,e.jsx)(Ks.Tutorials.TODO_INTRO,{})})}),(0,e.jsx)(ml,{theme:Ad,className:dIe.button,onSelect:iu,children:(0,e.jsx)(Ks.Tutorials.TODO_INTRO_CONFIRM,{})})]})})})},jIe=new Se("BEGIN"),EIe=function(t){var n=t.focusKey,r=cr(),o=(0,i.useCallback)((function(){wa(Oa.newGame),ou()}),[]);return(0,e.jsx)($r,{focusKey:n,theme:uIe,className:dIe.tutorialIntroPanel,contentClassName:dIe.content,children:(0,e.jsx)(Fn,{initialFocused:jIe,children:(0,e.jsxs)("div",{className:Oe()(dIe.wrapper,dIe.wide),children:[(0,e.jsxs)("div",{className:dIe.imageLayout,children:[(0,e.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dIe.logo}),(0,e.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dIe.chirper})]}),(0,e.jsx)("div",{className:dIe.divider}),(0,e.jsx)("div",{className:dIe.description,children:(0,e.jsx)(fI,{renderer:VI,children:r?(0,e.jsx)(Ks.Tutorials.TODO_OUTRO_GAMEPAD,{}):(0,e.jsx)(Ks.Tutorials.TODO_OUTRO,{})})}),(0,e.jsxs)("div",{className:dIe.buttonContainer,children:[(0,e.jsx)(ml,{theme:Ad,className:Oe()(dIe.button,dIe.dialogButton),onSelect:ou,children:(0,e.jsx)(Ks.Tutorials.TODO_OUTRO_CONTINUE,{})}),(0,e.jsx)(ml,{theme:Ad,className:Oe()(dIe.button,dIe.dialogButton,Ad.negative),onSelect:o,children:(0,e.jsx)(Ks.Tutorials.TODO_OUTRO_NEW_CITY,{})})]})]})})})};const OIe={"foldout-item":"foldout-item_EBr foldout-item_wOF",foldoutItem:"foldout-item_EBr foldout-item_wOF",category:"category_Zf1",header:"header_h0B header_8H_ item-mouse-states_Fmi item-focused_FuT","header-content":"header-content_owU header-content_wUX",headerContent:"header-content_owU header-content_wUX",icon:"icon_pQQ icon_I32",toggle:"toggle_NYV toggle_yQv"},TIe="advisor-panel_dXi",IIe="scrollable_jAA";var SIe=function(t){var n=t.expanded,r=t.className,i=t.focusKey,o=t.onClose,a=t.onToggle,l=C(Hc),s=C(Uc);return(0,e.jsx)(SV,{isFocusRoot:!0,onClose:o,expanded:n,onToggleExpanded:a,focusKey:i,headerText:(0,e.jsx)(Ks.Tutorials.ADVISOR_TITLE,{}),transitionSounds:en,className:Oe()(TIe,r),children:(0,e.jsx)(Fn,{children:(0,e.jsx)(mf,{className:IIe,children:l.filter((function(e){return!s||e.shown&&!e.locked})).map((function(t,n){return(0,e.jsx)(wIe,{category:t,showAll:!s},n)}))})})})},wIe=function(t){var n=t.category,r=t.showAll;return(0,e.jsx)(Ave,{initialExpanded:!0,header:(0,e.jsx)(Lve,{children:(0,e.jsx)(Ks.Tutorials.TITLE,{hash:n.name})}),theme:OIe,type:"Category",children:n.children.filter((function(e){return(r||e.shown)&&!e.locked})).map((function(t,n){return t.type===du.Tutorial?(0,e.jsx)(PIe,{item:t,showAll:r},n):(0,e.jsx)(NIe,{item:t,showAll:r},n)}))})},NIe=function(t){var n=t.item,r=t.type,o=void 0===r?"Group":r,a=t.nesting,l=void 0===a?1:a,s=t.showAll,c=(0,i.useMemo)((function(){return l+1}),[l]);return(0,e.jsx)(Ave,{header:(0,e.jsx)(Lve,{icon:n.icon&&(0,e.jsx)("img",{src:n.icon}),children:(0,e.jsx)(Ks.Tutorials.TITLE,{hash:n.name})}),theme:OIe,nesting:l,type:o,children:n.children.filter((function(e){return(s||e.shown)&&!e.locked})).map((function(t,n){return t.type===du.Tutorial?(0,e.jsx)(PIe,{item:t,showAll:s,nesting:c},n):(0,e.jsx)(NIe,{item:t,showAll:s,nesting:c},n)}))})},PIe=function(t){var n=t.item,r=t.type,o=void 0===r?"Item":r,a=t.nesting,l=void 0===a?1:a,s=t.showAll,c=M(zc,n.entity),u=C(Qn),d=(0,i.useMemo)((function(){return l+1}),[l]),f=(0,i.useCallback)((function(){(null==c?void 0:c.active)?Qc(ii):Jc(n.entity,ii,!0)}),[n.entity,null==c?void 0:c.active]);return(0,e.jsx)(e.Fragment,{children:c&&AIe(c,u)?(0,e.jsx)(Ave,{header:(0,e.jsx)(Lve,{icon:n.icon&&(0,e.jsx)("img",{src:n.icon}),children:(0,e.jsx)(Ks.Tutorials.TITLE,{hash:n.name})}),theme:OIe,nesting:l,type:o,onSelect:c.phases.length>1?void 0:f,children:c.phases.length>1?c.phases.filter((function(e){return s||e.shown})).map((function(t,n){return(0,e.jsx)(CIe,{tutorial:c,phase:t,nesting:d},n)})):void 0}):void 0})},CIe=function(t){var n=t.tutorial,r=t.phase,o=t.nesting,a=(0,i.useCallback)((function(){(null==r?void 0:r.active)?Qc(ii):Jc(n.entity,r.entity,!0)}),[n,r]),l=n.phases.findIndex((function(e){return c(e.entity,r.entity)})),s=n.phases.findIndex((function(e){var t;return null===(t=e.trigger)||void 0===t?void 0:t.phaseBranching})),u=s>=0&&l>s?r.isBranch?o+1:o+2:o;return(0,e.jsx)(Ave,{header:(0,e.jsx)(Lve,{icon:(0,e.jsx)("img",{src:"Media/Game/Icons/TutorialPhase.svg"}),children:(0,e.jsx)(Ks.Tutorials.TITLE,{hash:r.name})}),theme:OIe,nesting:u,onSelect:a,className:Oe()((null==r?void 0:r.active)&&"selected")})},AIe=function(e,t){switch(t){case Yn.gamepad:var n;return!(null===(n=e.filters)||void 0===n?void 0:n.includes("KeyboardAndMouse"));case Yn.keyboardAndMouse:var r;return!(null===(r=e.filters)||void 0===r?void 0:r.includes("Gamepad"));default:return!1}};const LIe={enter:"enter_wwI","enter-active":"enter-active_p_T",enterActive:"enter-active_p_T",exit:"exit_rZO","exit-active":"exit-active_vTx",exitActive:"exit-active_vTx"},MIe={"panel-content":"panel-content_p59",panelContent:"panel-content_p59","tutorial-layout":"tutorial-layout_dTO tutorial-layout_iuN",tutorialLayout:"tutorial-layout_dTO tutorial-layout_iuN",image:"image_e92 image_NyN",columns:"columns_WiK columns_ITy",scrollable:"scrollable_pas scrollable_ErH"};var RIe=function(t){var n=t.tutorial,r=t.phase,i=t.className,o=t.expanded,a=t.onToggle,l=t.onClose,s=(null==n?void 0:n.completed)||(null==n?void 0:n.advisorActivation)||!(null==n?void 0:n.mandatory);return(0,e.jsx)(SV,{isFocusRoot:!0,headerText:r&&(0,e.jsx)(Ks.Tutorials.TITLE,{hash:r.name}),theme:B6,expanded:o,transition:LIe,transitionSounds:en,className:Oe()(MIe.tutorialCard,i),contentClassName:MIe.panelContent,onToggleExpanded:a,onClose:s?l:void 0,children:n&&r&&(0,e.jsx)(dS,{pagesVisible:!0,tutorial:n,phase:r,theme:MIe,scrollable:!0})})};const kIe={"tutorial-center-card":"tutorial-center-card_j6a",tutorialCenterCard:"tutorial-center-card_j6a",image:"image_khW image_NyN"};var DIe=function(t){var n=t.tutorial,r=t.phase,i=t.className,o=t.onClose,a=(null==n?void 0:n.completed)||(null==n?void 0:n.advisorActivation)||!(null==n?void 0:n.mandatory);return(0,e.jsx)($r,{header:n&&(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Tutorials.TITLE,{hash:n.name})}),theme:B6,transitionSounds:en,className:Oe()(kIe.tutorialCenterCard,i),onClose:a?o:void 0,children:n&&r&&(0,e.jsx)(dS,{theme:kIe,tutorial:n,phase:r,pagesVisible:!1})})};const UIe={toggle:"toggle_Tm5"},FIe="tutorial-list-panel_lGU",GIe="header_GVY",VIe="content_oLZ tutorial-layout_iuN",BIe="hints_enS tutorial-layout_iuN",HIe="hints-content_Mmn",KIe="item_GYF",WIe="selected_txY",zIe="checkbox_y4W",YIe="title_SfK",XIe="label_nNX",qIe="play-button_Zaj",$Ie="completed_tbu",QIe="play-icon_Bax";var ZIe=function(t){var n=t.list,r=t.className,o=t.expanded,a=t.onToggle,s=t.focusKey,u=C(Yc),d=C(Vc),f=(0,i.useMemo)((function(){var e,t;return null==n?void 0:n.hints.filter((function(e){return null!=e&&e.completed})).sort((function(n,r){return(null!==(e=null==n?void 0:n.priority)&&void 0!==e?e:0)-(null!==(t=null==r?void 0:r.priority)&&void 0!==t?t:0)}))}),[null==n?void 0:n.hints]),h=(0,i.useMemo)((function(){return{Back:function(){Wc(!1)}}}),[]),m=C(Kc),p=cr();return Jr(!m||!p),(0,e.jsx)(Tn,{actions:h,children:(0,e.jsx)(SV,{isFocusRoot:!0,expanded:o,focusKey:s,headerText:n&&(0,e.jsx)(Ks.Tutorials.TITLE,{hash:n.name}),theme:B6,onToggleExpanded:a,transition:LIe,transitionSounds:en,className:Oe()(FIe,r),children:(0,e.jsxs)(Fn,{children:[(0,e.jsxs)("div",{className:VIe,children:[(0,e.jsx)("div",{className:GIe,children:(0,e.jsx)(Ks.Tutorials.TASKS,{})}),null==n?void 0:n.tutorials.map((function(t){var n,r=null==t||null===(n=t.alternatives)||void 0===n?void 0:n.some((function(e){return c(e,d)})),i=null==t||!c(t.entity,d)&&!r&&!(t.active||t.completed);return null!=t&&(0,e.jsx)(JIe,{tutorial:t,active:c(t.entity,null==u?void 0:u.entity),disabled:i},l(t.entity))}))]}),f&&f.length>0&&(0,e.jsx)(eSe,{activeTutorial:u,hints:f})]})})})},JIe=function(t){var n=t.tutorial,r=t.disabled,o=void 0!==r&&r,a=t.active,l=void 0!==a&&a,s=t.hint,c=void 0!==s&&s,u=(0,i.useCallback)((function(){return!l&&Jc(n.entity,ii,!1)}),[l,n.entity]);return(0,e.jsxs)(ml,{disabled:o,className:Oe()(KIe,n.completed&&$Ie,l&&WIe),onSelect:u,children:[(0,e.jsx)("div",{className:Oe()(qIe,o&&"disabled"),children:(0,e.jsx)(ll,{src:"Media/Radio/Play.svg",className:QIe})}),(0,e.jsxs)("div",{className:YIe,children:[(0,e.jsx)("div",{className:XIe,children:(0,e.jsx)(Ks.Tutorials.TITLE,{hash:n.name})}),!c&&(0,e.jsx)(pp,{focusKey:Te,checked:n.completed,disabled:o,theme:UIe,className:zIe})]})]})},eSe=function(t){var n=t.activeTutorial,r=t.hints;return(0,e.jsxs)("div",{className:BIe,children:[(0,e.jsx)("div",{className:GIe,children:(0,e.jsx)(Ks.Tutorials.HINTS_TITLE,{})}),(0,e.jsx)(mf,{className:HIe,children:r.map((function(t){return t&&(0,e.jsx)(JIe,{hint:!0,tutorial:t,active:c(null==n?void 0:n.entity,t.entity)},l(t.entity))}))})]})},tSe=function(t){var n=t.onClose,r=t.className;return(0,e.jsx)($r,{onClose:n,header:(0,e.jsx)(Tl,{children:(0,e.jsx)(Ks.Tutorials.LIST_REMINDER_TITLE,{})}),theme:B6,transitionSounds:en,className:Oe()(kIe.tutorialCenterCard,r),children:(0,e.jsx)(fS,{image:"Media/Tutorials/ReminderPanel.png",description:(0,e.jsx)(Ks.Tutorials.LIST_REMINDER_DESCRIPTION,{}),nextVisible:!0,handleActivateNextPhase:n})})};const nSe={"top-right-layout":"top-right-layout_sSC",topRightLayout:"top-right-layout_sSC","top-right-panel":"top-right-panel_A2r",topRightPanel:"top-right-panel_A2r","list-panel":"list-panel_MBq top-right-panel_A2r",listPanel:"list-panel_MBq top-right-panel_A2r","advisor-panel":"advisor-panel_mrr top-right-panel_A2r",advisorPanel:"advisor-panel_mrr top-right-panel_A2r","card-panel":"card-panel_UGb top-right-panel_A2r",cardPanel:"card-panel_UGb top-right-panel_A2r","center-layout":"center-layout_Uqg",centerLayout:"center-layout_Uqg","tutorial-renderer":"tutorial-renderer_wve",tutorialRenderer:"tutorial-renderer_wve"};function rSe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function iSe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return rSe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return rSe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var oSe=function(t){var n=t.className,r=t.tutorialListFocusKey,o=C(Gc),a=C(Yc),l=C(Xc),s=(null==l?void 0:l.type)===fu.Card,u=(null==l?void 0:l.type)===fu.CenterCard,d=C(Fc),f=C(qc),h=C($c),m=C(Da),p=C(Bc),v=(0,i.useMemo)((function(){if(null!==o){if(null!==a)return!o.tutorials.find((function(e){return c(e.entity,a.entity)}))&&!o.hints.find((function(e){return c(e.entity,a.entity)}));if(!c(p,ii))return!o.tutorials.find((function(e){return c(e.entity,p)}))&&!o.hints.find((function(e){return c(e.entity,p)}))}return!1}),[a,o,p]),g=m===Ia.Center||m===Ia.Right,y=iSe((0,i.useState)(!1),2),b=y[0],x=y[1],_=iSe((0,i.useState)(!1),2),j=_[0],E=_[1],O=iSe((0,i.useState)(!1),2),T=O[0],I=O[1],S=(0,i.useCallback)((function(e){x(e),e&&(E(!1),I(!1)),e&&!ni(Ra,La.InfoviewMenu)&&Va()}),[]),w=(0,i.useCallback)((function(e){E(e),e&&(x(!1),I(!1)),e&&!ni(Ra,La.InfoviewMenu)&&Va()}),[]),N=(0,i.useCallback)((function(e){I(e),e&&(x(!1),E(!1)),e&&!ni(Ra,La.InfoviewMenu)&&Va()}),[]),P=!(null===o||d||v||f||h),A=C(hu),L=(0,i.useMemo)((function(){return!g&&!T&&!b&&(j||s)}),[b,g,j,s,T]),M=(0,i.useMemo)((function(){return!g&&!b&&(!s||!L||!s&&T)}),[b,g,L,s,T]),R=(0,i.useMemo)((function(){return!g&&(!L||!s)&&(!M||!P)&&A}),[A,g,L,M,s,P]),k=iSe(aSe(a,o),2),D=k[0],U=k[1];return(0,e.jsxs)("div",{className:Oe()(nSe.tutorialRenderer,n),children:[(0,e.jsxs)("div",{className:nSe.topRightLayout,children:[(0,e.jsx)(D0,{in:A,children:(0,e.jsx)(SIe,{focusKey:"AdvisorPanel",expanded:R,onToggle:S,onClose:mu,className:nSe.advisorPanel})}),(0,e.jsx)(D0,{in:P,children:(0,e.jsx)(ZIe,{focusKey:r,list:o,expanded:M,onToggle:N,className:nSe.listPanel})}),(0,e.jsx)(D0,{in:s,children:(0,e.jsx)(RIe,{tutorial:a,phase:l,expanded:L,onToggle:w,onClose:nu,className:nSe.cardPanel})})]}),(0,e.jsxs)("div",{className:nSe.centerLayout,children:[(0,e.jsx)(D0,{in:u,children:(0,e.jsx)(DIe,{tutorial:a,phase:l,onClose:nu,className:nSe.phasePanel})}),(0,e.jsx)(D0,{in:D,children:(0,e.jsx)(tSe,{onClose:U,className:nSe.phasePanel})})]})]})},aSe=function(e,t){var n=iSe((0,i.useState)(0),2),r=n[0],o=n[1],a=C(qc),l=C(Sa)!==Oa.main;return(0,i.useEffect)((function(){if(!e&&t&&t.intro&&!a){if(!l){var n=0,r=performance.now(),i=function(e){var t=e-r;r=e,o((function(e){return e+t})),n=window.requestAnimationFrame(i)};return n=window.requestAnimationFrame(i),function(){return window.cancelAnimationFrame(n)}}}else o(0)}),[e,t,a,l]),[r>6e4,(0,i.useCallback)((function(){o(0)}),[])]};const lSe={enter:"enter_iKV enter_kO6","enter-active":"enter-active_qll enter-active_lrI",enterActive:"enter-active_qll enter-active_lrI",exit:"exit_pg6 exit_Von","exit-active":"exit-active_feg exit-active_jtN",exitActive:"exit-active_feg exit-active_jtN"},sSe="upgrades-grid_RYy",cSe="content_TtB",uSe="row_KSZ",dSe="item_jVa item-hover_WK8 item-active_Spn",fSe="thumbnail_aLl",hSe="not-enough-money_YuH",mSe="highlight_hy5",pSe="lock_W9x",vSe="already-built_J1f",gSe="not-enough-money-badge_pBb",ySe="page-indicators_Oap",bSe="page-indicator_y1n";function xSe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _Se(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||ESe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function jSe(e){return function(e){if(Array.isArray(e))return xSe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||ESe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function ESe(e,t){if(e){if("string"==typeof e)return xSe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?xSe(e,t):void 0}}var OSe=function(t){var n,r=t.className,i=t.upgrades,o=t.selectedUpgrade,a=t.onSelectUpgrade,s=HN(a),u=Math.ceil(i.length/9),d=M6(i,9,o),f=h6(i,9,d);return su(null===(n=TS.value)||void 0===n?void 0:n.upgradeGrid),EI((0,e.jsxs)("div",{className:Oe()(sSe,r),children:[(0,e.jsx)("div",{className:cSe,children:(0,e.jsx)(Mn,{focused:l(o),onChange:s,children:(0,e.jsx)("div",{className:uSe,children:f.map((function(t){return(0,e.jsx)(TSe,{upgrade:t,selected:c(t.entity,o),onSelect:a},l(t.entity))}))})})}),(0,e.jsx)("div",{className:ySe,children:u>1&&jSe(Array(u).keys()).map((function(t){return(0,e.jsx)("div",{onClick:function(){return a(i[9*t].entity)},className:Oe()(bSe,t===d&&"selected")},t)}))})]}))},TSe=function(t){var n=t.upgrade,r=t.selected,o=t.onSelect,a=_Se((0,i.useState)(!1),2),s=a[0],c=a[1],u=(0,i.useContext)(K8),d=C(b3),f=(0,i.useCallback)((function(){return o(n.entity)}),[n.entity,o]),h=(0,i.useCallback)((function(){return u&&u.showDetails(n.entity)}),[n.entity,u]),m=(0,i.useCallback)((function(){return u&&u.hideDetails(n.entity)}),[n.entity,u]),p=!(n.locked||n.uniquePlaced)&&null!=n.constructionCost&&("number"==typeof n.constructionCost.value?d<n.constructionCost.value:d<n.constructionCost.value.x),v=cr()&&s;return(0,i.useEffect)((function(){null!=u&&(v?u.showDetails(n.entity):u.hideDetails(n.entity))}),[n.entity,u,v]),(0,e.jsx)(Jh,{onFocusChange:c,children:(0,e.jsx)(xO,{tooltip:!u&&(0,e.jsx)(Ks.Assets.NAME,{hash:n.name}),children:(0,e.jsxs)(ml,{focusKey:l(n.entity),selected:r,className:Oe()(dSe,p&&hSe),onClick:f,disabled:n.locked||n.uniquePlaced,onMouseOver:h,onMouseLeave:m,children:[(0,e.jsx)("img",{src:n.icon,onError:tl,className:fSe}),n.uniquePlaced&&(0,e.jsx)("img",{src:"Media/Game/Icons/AlreadyBuilt.svg",className:vSe}),p&&(0,e.jsx)("img",{src:"Media/Game/Icons/NoMoney.svg",className:gSe}),n.highlight&&(0,e.jsx)(TF,{className:mSe}),n.locked&&(0,e.jsx)(YN,{className:pSe})]})})})};const ISe="asset-panel_BKG",SSe="gamepad-active_dUD",wSe="detail-container_J4D",NSe="detail-panel_qkF",PSe="title-bar_L4S title-bar_I7O child-opacity-transition_nkS",CSe="title_vx4 title_qub";function ASe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function LSe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ASe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ASe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var MSe,RSe=function(t){var n=t.focusKey,r=t.className,o=t.onClose;nn(en);var a=cr(),l=LSe((0,i.useState)(!1),2),s=l[0],u=l[1],d=C(Mq),f=C(E4),h=M(_4,d),m=(0,i.useCallback)((function(e){T4(d,e)}),[d]),p=(0,i.useCallback)((function(){c(f,ii)?o():(a&&o(),I4())}),[a,o,f]),v=LSe((0,i.useState)(ii),2),g=v[0],y=v[1],b=!c(g,ii),x=(0,i.useMemo)((function(){return{showDetails:function(e){return y(e)},hideDetails:function(e){return y((function(t){return c(t,e)?ii:t}))}}}),[]);return(0,i.useEffect)((function(){if(a&&b){var e=Jn.subscribe((function(e){e&&y(ii)}));return function(){return e.dispose()}}}),[a,b]),(0,i.useEffect)((function(){a&&(s?h.length>0&&T4(d,h[0].entity):I4())}),[s,a,d,h]),(0,e.jsx)(Jh,{onFocusChange:u,children:(0,e.jsx)(wn,{onAction:p,children:(0,e.jsx)($t,{styles:H8,children:(0,e.jsxs)(Tr,{focusKey:n,className:r,children:[(0,e.jsx)("div",{className:wSe,children:(0,e.jsx)(nO,{children:b&&(0,e.jsx)($t,{styles:lSe,children:(0,e.jsx)(u6,{entity:g,className:NSe,upgrade:!0})},"details")})}),(0,e.jsx)(K8.Provider,{value:x,children:(0,e.jsx)($r,{className:Oe()(ISe,a&&SSe),header:(0,e.jsx)("div",{className:PSe,children:(0,e.jsx)("div",{className:CSe,children:(0,e.jsx)(Ks.UpgradesMenu.TITLE,{})})}),children:(0,e.jsx)(OSe,{upgrades:h,selectedUpgrade:f,onSelectUpgrade:m})})})]})})})})};function kSe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function DSe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return kSe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return kSe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e[e.none=0]="none",e[e.toolbar=1]="toolbar",e[e.toolOptions=2]="toolOptions",e[e.assetMenu=3]="assetMenu",e[e.upgradesMenu=4]="upgradesMenu",e[e.mapTilePurchase=5]="mapTilePurchase",e[e.selectedInfo=6]="selectedInfo",e[e.tutorialIntro=7]="tutorialIntro",e[e.tutorialListIntro=8]="tutorialListIntro",e[e.tutorialListOutro=9]="tutorialListOutro",e[e.tutorialList=10]="tutorialList",e[e.signatureUnlocks=11]="signatureUnlocks",e[e.milestoneUnlocks=12]="milestoneUnlocks",e[e.activeTool=13]="activeTool"}(MSe||(MSe={}));var USe=function(t){var n,r=t.focusKey,o=DSe((0,i.useState)(!1),2),a=o[0],l=o[1],s=C(Kp),d=!c(C(fD),ii),f=IG(),h=DSe((0,i.useState)(!1),2),m=h[0],p=h[1];(0,i.useEffect)((function(){f||p(!1)}),[f]);var v=C(Ra),g=ni(v,La.InfoviewMenu),y=C(SM),b=C(Vq),x=C(R3),_=!c(x,ii),j=C(V8),E=!_&&j.length>0,O=C(fR),T=cr(),I=C(ka),S=C(Fc),w=C(Yc),N=C(qc)&&null===w,P=C($c),L=C(hu),R=aS(),k=C(Kc),D=C(Uc),U=k&&D;(0,i.useEffect)((function(){!D&&U&&eu()}),[D,U]);var F=sEe(),G=C(v_e),V=function(){var e=sEe(),t=C(Mq),n=M(_4,t),r=C(v_e);return e&&n&&n.length>0&&!r}(),B=C(Mq),H=DSe((0,i.useState)(!1),2),K=H[0],W=H[1],z=A(ai,FSe,!1),Y=z&&!I&&!F&&!g,X=z&&!g&&!Y;(0,i.useEffect)((function(){V||W(!1)}),[V]);var q=(0,i.useRef)(B);F&&(q.current=B);var $=C(Sa);XZ(!((E||_||S||N||P)&&$!==Oa.freeCamera));var Q,Z,J,ee,te=V&&(O.id===VR||K),ne=(Q=C(zu),(0,i.useCallback)((function(){u(Q)?wa(Oa.saveGame):dd()}),[Q])),re=(Z=(0,i.useContext)(Rl),J=C(pd),ee=C(Du),(0,i.useCallback)((function(){ee&&(J?fd(!1):Z.showDialog((0,e.jsx)(SN,{title:(0,e.jsx)(Ks.Common.WARNING,{}),message:(0,e.jsx)(Ks.GameListScreen.CONFIRM_UNSAVED_MESSAGE,{}),onConfirm:fd,dismissable:!0})))}),[Z,J,ee])),ie=(0,i.useMemo)((function(){return{"Tool Options":!m&&f?function(){p((function(e){return!e}))}:null,"Upgrades Menu":te?function(){W((function(e){return!e}))}:null,"Move Horizontal":te?function(e){W(e>0)}:null,Quicksave:ne,Quickload:re}}),[re,ne,m,f,te]),oe=(0,i.useCallback)((function(){return p(!1)}),[]),ae=(0,i.useCallback)((function(){return W(!1)}),[]),le=(0,i.useCallback)((function(){return Xq()}),[]),se=(0,i.useCallback)((function(){return li(ii)}),[]);nD();var ce,ue=function(){var e=C(fR);return rD(C(_R),e,"Crosshair")}();return ce=S?MSe.tutorialIntro:N?MSe.tutorialListIntro:P?MSe.tutorialListOutro:U?MSe.tutorialList:_?MSe.milestoneUnlocks:E?MSe.signatureUnlocks:null!=v?v.__Type:L?"AdvisorPanel":f&&m?MSe.toolOptions:F&&G?MSe.none:F&&!K?MSe.selectedInfo:V&&K?MSe.upgradesMenu:y?MSe.mapTilePurchase:d?MSe.assetMenu:O.id!==VR?MSe.activeTool:MSe.toolbar,(0,e.jsx)(Jh,{onFocusChange:l,children:(0,e.jsx)(ppe,{children:(0,e.jsx)(cIe,{children:(0,e.jsx)(Tn,{actions:ie,children:(0,e.jsx)(Rc,{children:(0,e.jsx)("div",{className:Oe()(Bge.gameMainScreen,T&&!I&&ue,f&&Bge.toolOptionsVisible),children:(0,e.jsx)(FL,{children:(0,e.jsxs)(Ze,{focusKey:r,focused:ce,activation:Ue.Always,debugName:"GameMainScreen",children:[(0,e.jsxs)("div",{className:Bge.mainContainer,children:[(!T||X)&&(0,e.jsx)("div",{className:Bge.infoMenuLayout,children:(0,e.jsx)($ge,{miniPanelVisible:X})}),(0,e.jsx)("div",{className:Bge.infoLayout,children:(0,e.jsx)(D0,{in:F,children:(0,e.jsx)(oEe,{focusKey:O.id===VR?MSe.selectedInfo:Te,className:Bge.selectedInfoPanel,onClose:le})})}),(0,e.jsx)("div",{className:Bge.infoLayout,children:(0,e.jsx)(D0,{in:Y,children:(0,e.jsx)(dse,{className:Bge.infoviewMenu,onClose:se})})}),(0,e.jsxs)("div",{className:Bge.toolLayout,children:[(0,e.jsx)("div",{className:Bge.toolSideColumn,children:(0,e.jsx)(D0,{in:f,children:(0,e.jsx)(TG,{focusKey:MSe.toolOptions,onClose:oe})})}),(0,e.jsxs)("div",{className:Bge.toolMainColumn,children:[(0,e.jsx)(D0,{in:d,children:(0,e.jsx)(V6,{focusKey:MSe.assetMenu,onClose:yD,className:Bge.toolPanel})}),(0,e.jsx)(D0,{in:V,children:(0,e.jsx)(RSe,{focusKey:MSe.upgradesMenu,className:Bge.toolPanel,onClose:ae})}),(0,e.jsx)(D0,{in:y,children:(0,e.jsx)(nye,{focusKey:MSe.mapTilePurchase,className:Bge.mapTilePurchasePanel,onClose:kM})})]}),(0,e.jsx)("div",{className:Bge.toolSideColumn})]}),(0,e.jsx)(nO,{children:v&&(0,e.jsx)(He,{focusKey:v.__Type,children:(0,e.jsx)(zge,{panel:v})},v.__Type)}),(0,e.jsx)(CG,{className:Bge.bpIndicator}),!T&&(0,e.jsxs)("div",{className:Bge.pauseMenuLayout,children:[R&&(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_ADVISOR,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_ADVISOR,{}),children:(0,e.jsx)(F8,{src:"Media/Glyphs/Advisor.svg",className:Bge.advisorMenuToggle,selected:L,onSelect:mu})}),(0,e.jsx)(bS,{uiTag:null===(n=TS.value)||void 0===n?void 0:n.pauseMenuButton,children:(0,e.jsx)(jL,{title:(0,e.jsx)(Ks.Main.TOOLTIP_TITLE_PAUSE_MENU,{}),description:(0,e.jsx)(Ks.Main.TOOLTIP_DESCRIPTION_PAUSE_MENU,{}),children:(0,e.jsx)(F8,{src:"Media/Glyphs/Gear.svg",onSelect:Ca})})})]})]}),(0,e.jsx)(rIe,{focusKey:MSe.toolbar}),(0,e.jsx)(D0,{in:F&&null!==b,children:F&&b&&(0,e.jsx)(tbe,{onClose:le,developerInfoSection:b})}),(0,e.jsx)("div",{className:Oe()(Bge.pauseOverlay,s&&Bge.paused)}),S&&(0,e.jsx)(el,{children:(0,e.jsx)(vIe,{focusKey:MSe.tutorialIntro})}),N&&(0,e.jsx)(el,{children:(0,e.jsx)(_Ie,{focusKey:MSe.tutorialListIntro})}),P&&(0,e.jsx)(el,{children:(0,e.jsx)(EIe,{focusKey:MSe.tutorialListOutro})}),E&&(0,e.jsx)(el,{children:(0,e.jsx)(Vye,{focusKey:MSe.signatureUnlocks,entities:j,onClose:B8})}),_&&(0,e.jsx)(el,{children:(0,e.jsx)(Pye,{focusKey:MSe.milestoneUnlocks,milestone:x,onClose:k3})}),a&&T&&(0,e.jsx)(DS,{className:Bge.actionHints}),(0,e.jsx)(oSe,{className:Bge.tutorialsRenderer,tutorialListFocusKey:MSe.tutorialList})]})})})})})})})})};function FSe(e,t){return null!=t}function GSe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var VSe=function(t){var n=t.children,r=C(II),o=(0,i.useMemo)((function(){return{"Switch User":function(){Jt(Qt.selectItem),PI()}}}),[]);return(0,e.jsx)(Tn,{actions:o,disabled:!r,children:n})};const BSe="credits-renderer_BaD",HSe="line_hIW",KSe="image-line_lv2",WSe="image_idP";function zSe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function YSe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||qSe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function XSe(e){return function(e){if(Array.isArray(e))return zSe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||qSe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function qSe(e,t){if(e){if("string"==typeof e)return zSe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?zSe(e,t):void 0}}var $Se=function(t){var n=t.lines,r=t.images,o=t.onComplete,a=(0,i.useRef)(null),l=(0,i.useMemo)((function(){return[[null,JT.None,[]]].concat(XSe(n),[[null,JT.None,[]]])}),[n]),s=function(e,t){var n=qd(),r=(0,i.useCallback)((function(r,i){var o=YSe(r,3),a=(o[0],o[1]),l=o[2];return 0===i?700*n:i===e.length-1?920*n:l.length>0?(rwe(a,l,t)+80)*n:QSe[a]*n}),[n,e.length,t]);return function(e,t,n){return(0,i.useMemo)((function(){var r=function(e,t){for(var n=[],r=0,i=0;i<t;++i){var o=r;r+=e(i),n.push({x:o,y:r})}return n}((function(n){return e(t[n],n)}),t.length);return{getRenderedRange:function(e,i){var o=at(QX(r,e)-n,0,t.length),a=at(QX(r,i+e)+n,o,t.length);return{offset:r[o].x,startIndex:o,endIndex:a}},getTotalSize:function(){return r[r.length-1].y}}}),[t,n,e])}(r,e,1)}(l,r),c=function(t,n){var r=qd();return(0,i.useCallback)((function(i){if(0===i)return(0,e.jsx)("div",{style:ewe},"start");if(i===t.length-1)return(0,e.jsx)("div",{style:twe},"end");var o=YSe(t[i],3),a=o[0],l=o[1],s=o[2];if(s.length>0){var c=rwe(l,s,n);return(0,e.jsx)("div",{className:KSe,style:{height:(c+80)*r},children:s.map((function(t,i){var o=iwe(l,t,n);return(0,e.jsx)("img",{src:t,width:o.x*r,height:o.y*r,className:WSe},i)}))},i)}return(0,e.jsx)("div",{className:JSe[l],style:{height:QSe[l]*r},children:a},i)}),[n,t,r])}(l,r),u=XX(a,s,"vertical",void 0,c),d=u.list,f=u.onScroll,h=qd(),m=(0,i.useMemo)((function(){return performance.now()}),[]);return(0,i.useEffect)((function(){if(a.current){var e=0,t=function(n){if(a.current){var r=(n-m)/1e3,i=Math.round(100*r*h),l=a.current.scrollHeight-a.current.offsetHeight;a.current.scrollTop=i,f(),i<l?e=window.requestAnimationFrame(t):o()}};return e=window.requestAnimationFrame(t),function(){return window.cancelAnimationFrame(e)}}}),[f,o,h,m]),(0,e.jsx)("div",{ref:a,className:BSe,onScroll:f,children:d})},QSe=[32,160,80,68,32,32,32],ZSe=[240,720,480,312,240,240,240];var JSe=[HSe,"h1_z8F","h2_xgG","h3_LtF",HSe,HSe,HSe],ewe=nwe(700),twe=nwe(920);function nwe(e){return{height:"".concat(e,"rem")}}function rwe(e,t,n){var r=0,i=!0,o=!1,a=void 0;try{for(var l,s=t[Symbol.iterator]();!(i=(l=s.next()).done);i=!0){var c=l.value;r=Math.max(r,iwe(e,c,n).y)}}catch(e){o=!0,a=e}finally{try{i||null==s.return||s.return()}finally{if(o)throw a}}return r}function iwe(e,t,n){var r=n.get(t),i=ZSe[e];if(null!=r&&r.width>0&&r.height>0){var o=Math.sqrt(i*i/(r.width*r.height));return{x:o*r.width,y:o*r.height}}return{x:ZSe[e],y:ZSe[e]}}const owe="content_qY6 child-opacity-transition_nkS";function awe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function lwe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return awe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return awe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var swe=i.forwardRef((function(t,n){var r,o,a,l,s,c=t.focusKey,u=t.className,d=t.onClose,f=C(nd),h=(r=f,o=lwe((0,i.useState)(null),2),a=o[0],l=o[1],s=Array.isArray(r)?r:[r],(0,i.useEffect)((function(){var e=0,t=[],n=s.map((function(n,r){return function(e,t){var n=new XMLHttpRequest;return n.open("GET",e),n.onload=function(){var e=new u0,r=mI(n.responseText,!0,!0,250,150).map((function(t){return e.render(t)}));t(r)},n.send(),function(){n.abort()}}(n,(function(n){t[r]=n,++e===s.length&&l(t.flat())}))}));return function(){n.forEach((function(e){return e()}))}}),[s.join(" ")]),a),m=function(e){var t=lwe((0,i.useState)(null),2),n=t[0],r=t[1];return(0,i.useEffect)((function(){var t=0,n=new Map,i=function(){++t===n.size&&r(n)};if(null!=e){var o=!0,a=!1,l=void 0;try{for(var s,c=e[Symbol.iterator]();!(o=(s=c.next()).done);o=!0){var u=lwe(s.value,3)[2],d=!0,f=!1,h=void 0;try{for(var m,p=u[Symbol.iterator]();!(d=(m=p.next()).done);d=!0){var v=m.value;if(!n.has(v)){var g=new Image;g.src=v,g.addEventListener("load",i),g.addEventListener("error",i),n.set(v,g)}}}catch(e){f=!0,h=e}finally{try{d||null==p.return||p.return()}finally{if(f)throw h}}}}catch(e){a=!0,l=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw l}}}return 0===n.size&&r(n),function(){var e=!0,t=!1,r=void 0;try{for(var o,a=n.values()[Symbol.iterator]();!(e=(o=a.next()).done);e=!0){var l=o.value;l.removeEventListener("load",i),l.removeEventListener("error",i)}}catch(e){t=!0,r=e}finally{try{e||null==a.return||a.return()}finally{if(t)throw r}}}}),[e]),n}(h);return(0,e.jsx)(RP,{ref:n,focusKey:c,title:(0,e.jsx)(Ks.Menu.CREDITS,{}),className:u,onClose:d,children:(0,e.jsx)("div",{className:owe,children:(null==h?void 0:h.length)&&null!=m&&(0,e.jsx)($Se,{lines:h,images:m,onComplete:d})})})}));const cwe="user-switch-prompt_UJI",uwe="avatar_MH0",dwe="label_deh";function fwe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hwe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return fwe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fwe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var mwe="Media/AvatarFallback.svg",pwe=function(t){var n=t.className,r=cr(),o=C(SI),a=C(wI),l=hwe(function(e){var t=hwe((0,i.useState)(null),2),n=t[0],r=t[1];(0,i.useEffect)((function(){return r((function(t){return e!==t?null:e}))}),[e]);var o=null!==e&&e!==n?e:mwe,a=(0,i.useCallback)((function(){return e!==mwe&&r(e)}),[e]);return[o,a]}(o),2),s=l[0],c=l[1];return(0,e.jsxs)(ml,{focusKey:Te,className:Oe()(cwe,n),onSelect:PI,children:[(0,e.jsx)("img",{src:s||void 0,onError:c,className:uwe}),(0,e.jsx)("div",{className:dwe,children:u(a)?(0,e.jsx)(Ks.Menu.SWITCH_USER,{}):a}),r&&(0,e.jsx)(DS,{specifiedActions:["Switch User"],labels:!1})]})};const vwe="menu-ui_I8X menu-theme_k91",gwe="content-container_DDJ",ywe="content_fc3",bwe="action-hints_qUT child-opacity-transition_nkS",xwe="version_VJt",_we="corner_Uxw",jwe="bp-indicator_E_n",Ewe="user-switch-prompt_m_H";function Owe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Twe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Iwe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Owe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Owe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}const Swe="engagement-screen_EQg";var wwe=function(){var t=Nwe();return(0,e.jsx)(HS,{className:Swe,disabled:!0,children:t})},Nwe=function(){var t=cr(),n=xs((0,e.jsx)(Ks.Overlay.ENGAGEMENT_PROMPT_KEYBOARD,{})),r=xs((0,e.jsx)(Ks.Overlay.ENGAGEMENT_PROMPT_GAMEPAD,{}));return(0,i.useMemo)((function(){return t?Pwe(r,"<KEY>",(0,e.jsx)(FS,{path:"<Gamepad>/buttonSouth"})):n}),[t,r,n])},Pwe=function(t,n,r){var i=t.indexOf(n);return i>=0?(0,e.jsxs)(e.Fragment,{children:[t.substring(0,i),r,t.substring(i+n.length)]}):t};const Cwe="overlay-action_CD_",Awe="action-hints_TjM";var Lwe=function(t){var n=t.displayButtonHints,r=void 0===n||n,i=t.text,o=t.className;return(0,e.jsxs)("div",{className:Oe()(Cwe,o),children:[r?(0,e.jsx)(DS,{className:Awe}):null,i]})};const Mwe="overlay-actions_epi";var Rwe=function(t){var n=t.className,r=t.children;return(0,e.jsx)("div",{className:Oe()(Mwe,n),children:r})};const kwe="overlay-content_AYd",Dwe="content_HTa";var Uwe=function(t){var n=t.actions,r=t.className,i=t.children;return(0,e.jsxs)("div",{className:Oe()(kwe,r),children:[(0,e.jsx)("div",{className:Dwe,children:i}),n&&n]})};const Fwe="overlay-text_AzR";var Gwe,Vwe=function(t){var n=t.className,r=t.children;return(0,e.jsx)("div",{className:Oe()(Fwe,n),children:r})},Bwe=function(){return(0,e.jsx)(Uwe,{actions:(0,e.jsx)(Rwe,{children:(0,e.jsx)(Lwe,{})}),children:(0,e.jsx)(Vwe,{children:(0,e.jsx)(Ks.Overlay.CONTROLLER_DISCONNECTED,{})})})},Hwe=function(){return(0,e.jsx)(Uwe,{actions:(0,e.jsx)(Rwe,{children:(0,e.jsx)(Lwe,{})}),children:(0,e.jsxs)(Vwe,{children:[(0,e.jsx)(Ks.Overlay.CONTROLLER_PAIRING_CHANGED,{}),(0,e.jsx)(Ks.Overlay.SWITCH_USER,{})]})})},Kwe="overlay";!function(e){e[e.None=0]="None",e[e.Splash1=1]="Splash1",e[e.Splash2=2]="Splash2",e[e.Splash3=3]="Splash3",e[e.Wait=4]="Wait",e[e.UserLoggedOut=5]="UserLoggedOut",e[e.ControllerDisconnected=6]="ControllerDisconnected",e[e.ControllerPairingChanged=7]="ControllerPairingChanged",e[e.Engagement=8]="Engagement",e[e.Loading=9]="Loading",e[e.CorruptSaveData=10]="CorruptSaveData",e[e.Validation=11]="Validation"}(Gwe||(Gwe={}));var Wwe=E(Kwe,"activeScreen"),zwe=E(Kwe,"progress"),Ywe=E(Kwe,"hintMessages"),Xwe=E(Kwe,"corruptDataMessages");const qwe="title_oqw",$we="messages_v_4",Qwe="message_LOu";var Zwe=function(){var t=C(Xwe),n=(0,i.useRef)(null),r=qd();return(0,i.useEffect)((function(){var e=performance.now(),t=0,i=function(o){if(n.current){var a=n.current.scrollHeight;n.current.scrollTop=.08*(o-e)*r%(a/2),t=window.requestAnimationFrame(i)}};return t=window.requestAnimationFrame(i),function(){return window.cancelAnimationFrame(t)}}),[r]),(0,e.jsxs)(Uwe,{actions:(0,e.jsx)(Rwe,{children:(0,e.jsx)(Lwe,{displayButtonHints:!1,text:(0,e.jsx)(Ks.Overlay.PRESS_ANY_KEY_ACTION,{})})}),children:[(0,e.jsxs)(Vwe,{children:[(0,e.jsx)(Ks.Overlay.CORRUPT_SAVE_DATA,{}),(0,e.jsx)("div",{className:qwe,children:(0,e.jsx)(Ks.Overlay.DELETED_ITEMS,{})})]}),(0,e.jsx)("div",{ref:n,className:$we,children:null==t?void 0:t.map((function(t,n){return(0,e.jsx)("div",{className:Qwe,children:t},n)}))})]})},Jwe={tension:30,friction:10},eNe=function(t){var n=t.size,r=t.lineWidth,o=t.progress,a=t.progressColors,l=t.className,s=at(V$(Jwe,o[0],0),.01,1),c=at(V$(Jwe,o[1],0),.01,1),u=at(V$(Jwe,o[2],0),.01,1),d=o.length>0?o.reduce((function(e,t){return e+t}))/o.length:0,f=qd(),h=n*f,m=Math.ceil(h),p=(0,i.useRef)(null);return(0,i.useEffect)((function(){if(p.current){var e=p.current.getContext("2d");e.clearRect(0,0,m,m);var t=.5*m-r*f,n=.5*m;e.lineCap="round",e.lineWidth=r*f;for(var i=[s,c,u],o=0;o<i.length;++o){e.beginPath();var l=o*Math.PI;e.arc(n,n,t,l,l+2*i[o]*Math.PI),e.strokeStyle=a[o],e.stroke(),t-=(r+2)*f}}}),[m,r,a,f,s,c,u]),(0,e.jsx)("div",{children:(0,e.jsx)("canvas",{ref:p,width:m,height:m,className:l,style:{width:h,height:h,opacity:at(20*d,0,1)}})})};const tNe="overlay-loading_xAc",nNe="title_xw2",rNe="progress_xKD",iNe="hint_KWz";function oNe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function aNe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,l=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){l=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(l)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return oNe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return oNe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var lNe=["#E1F8FF","#84E2FF","#12C8FF"],sNe=function(){var t=C(zwe),n=C(Ywe),r=aNe((0,i.useState)(0),2),o=r[0],a=r[1];return(0,i.useEffect)((function(){a(Math.floor(Math.random()*n.length));var e=window.setInterval((function(){a(Math.floor(Math.random()*n.length))}),1e4);return function(){window.clearInterval(e)}}),[n.length]),(0,e.jsxs)("div",{className:tNe,children:[(0,e.jsx)("div",{className:nNe,children:(0,e.jsx)(Ks.Loading.LOADING_TITLE,{})}),(0,e.jsx)(eNe,{progress:t,progressColors:lNe,size:128,lineWidth:8,className:rNe}),(0,e.jsx)("div",{className:iNe,children:n.length>o&&(0,e.jsx)(Ss,{id:n[o]})})]})};const cNe={enter:"enter_Hgx","enter-active":"enter-active_hYc",enterActive:"enter-active_hYc",exit:"exit_mhm","exit-active":"exit-active_via",exitActive:"exit-active_via"},uNe="logo-screen_KLI",dNe="logo_IpH",fNe="content_sOm";var hNe=function(t){var n=t.children;return(0,e.jsx)($t,{styles:cNe,children:(0,e.jsxs)("div",{className:uNe,children:[(0,e.jsx)("img",{src:"Media/Menu/GameLogo.svg",className:dNe}),(0,e.jsx)("div",{className:fNe,children:n})]})})},mNe=function(){return(0,e.jsx)(Uwe,{children:(0,e.jsxs)(Vwe,{children:[(0,e.jsx)(Ks.Overlay.USER_LOGGED_OUT,{}),(0,e.jsx)(Ks.Overlay.PLEASE_LOG_IN,{})]})})},pNe=function(){return(0,e.jsx)(Uwe,{actions:(0,e.jsx)(Rwe,{children:(0,e.jsx)(Lwe,{})}),children:(0,e.jsx)(Vwe,{children:(0,e.jsx)(Ks.Overlay.VALIDATION,{})})})},vNe=function(){return(0,e.jsx)(Uwe,{children:(0,e.jsx)(Vwe,{children:(0,e.jsx)(Ks.Overlay.PLEASE_WAIT,{})})})};const gNe={"splash-screen":"splash-screen_vso",splashScreen:"splash-screen_vso","step-container":"step-container_CQz",stepContainer:"step-container_CQz",enter:"enter_A2e","enter-active":"enter-active_IRn",enterActive:"enter-active_IRn",exit:"exit_qYD","exit-active":"exit-active_Fge",exitActive:"exit-active_Fge",logo:"logo_ceO",splashLogoScale:"splashLogoScale_CGf","colossal-logo":"colossal-logo_gge logo_ceO",colossalLogo:"colossal-logo_gge logo_ceO","paradox-logo":"paradox-logo_FKO logo_ceO",paradoxLogo:"paradox-logo_FKO logo_ceO","sega-logo":"sega-logo_yCR logo_ceO",segaLogo:"sega-logo_yCR logo_ceO"};var yNe=function(t){var n=t.screen;return(0,e.jsx)($t,{styles:cNe,children:(0,e.jsx)("div",{className:gNe.splashScreen,children:(0,e.jsx)(nO,{skipInitial:!1,children:(0,e.jsx)($t,{styles:gNe,children:(0,e.jsxs)("div",{className:gNe.stepContainer,children:[n===Gwe.Splash1&&(0,e.jsx)("img",{src:"Media/Menu/ParadoxLogo.svg",className:gNe.paradoxLogo}),n===Gwe.Splash2&&(0,e.jsx)("img",{src:"Media/Menu/ColossalLogo.svg",className:gNe.colossalLogo}),n===Gwe.Splash3&&(0,e.jsx)("img",{src:"Media/Menu/SegaLogo.svg",className:gNe.segaLogo})]})},n)})})})};const bNe={"overlay-ui":"overlay-ui_UIz",overlayUi:"overlay-ui_UIz","exit-active":"exit-active_iXm",exitActive:"exit-active_iXm"};var xNe=function(){var t=C(Wwe),n=t!==Gwe.None;return nw(),(0,e.jsx)(D0,{in:n,children:(0,e.jsx)($t,{styles:bNe,children:(0,e.jsx)("div",{className:bNe.overlayUi,children:(0,e.jsx)(nO,{children:_Ne(t)})})})})};function _Ne(t){switch(t){case Gwe.Splash1:case Gwe.Splash2:case Gwe.Splash3:return(0,e.jsx)(yNe,{screen:t},"splashScreen");case Gwe.None:return null;default:return(0,e.jsx)(hNe,{children:(0,e.jsx)(nO,{children:jNe(t)})},"logoScreen")}}function jNe(t){switch(t){case Gwe.Loading:return(0,e.jsx)(sNe,{},Gwe[Gwe.Loading]);case Gwe.Engagement:return(0,e.jsx)(wwe,{},Gwe[Gwe.Engagement]);case Gwe.Wait:return(0,e.jsx)(vNe,{},Gwe[Gwe.Wait]);case Gwe.Validation:return(0,e.jsx)(pNe,{},Gwe[Gwe.Validation]);case Gwe.ControllerDisconnected:return(0,e.jsx)(Bwe,{},Gwe[Gwe.ControllerDisconnected]);case Gwe.ControllerPairingChanged:return(0,e.jsx)(Hwe,{},Gwe[Gwe.ControllerPairingChanged]);case Gwe.UserLoggedOut:return(0,e.jsx)(mNe,{},Gwe[Gwe.UserLoggedOut]);case Gwe.CorruptSaveData:return(0,e.jsx)(Zwe,{},Gwe[Gwe.CorruptSaveData]);default:return null}}var ENe={Menu:function(){var t=Iwe((0,i.useState)(!1),2),n=t[0],r=t[1],o=cr(),a=C(ku),l=C(Ru),s=C(II),c=(0,i.useCallback)((function(){return id(Cu.Menu)}),[]),u=(0,i.useContext)(Rl);return(0,i.useEffect)((function(){var t=ee.subscribe((function(t){u.showDialog((0,e.jsx)(TN,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Twe(e,t,n[t])}))}return e}({},t)))}));return function(){return t.dispose()}}),[u]),(0,e.jsx)(I0,{children:(0,e.jsx)(VSe,{children:(0,e.jsxs)("div",{className:vwe,children:[(0,e.jsxs)("div",{className:gwe,children:[(0,e.jsx)("div",{className:ywe,children:(0,e.jsx)(Jh,{onFocusChange:r,children:(0,e.jsx)(Ze,{focused:l,activation:Ue.Always,children:(0,e.jsxs)(nO,{children:[l===Cu.Menu&&(0,e.jsx)(JJ,{focusKey:Cu.Menu},Cu.Menu),l===Cu.NewGame&&(0,e.jsx)(x2,{focusKey:Cu.NewGame,onClose:c},Cu.NewGame),l===Cu.LoadGame&&(0,e.jsx)(m8,{focusKey:Cu.LoadGame,onClose:c},Cu.LoadGame),l===Cu.Options&&(0,e.jsx)(XA,{focusKey:Cu.Options,onClose:c},Cu.Options),l===Cu.Credits&&(0,e.jsx)(swe,{focusKey:Cu.Credits,onClose:c},Cu.Credits)]})})})}),o&&(0,e.jsx)(DS,{disabled:!n,className:bwe})]}),(0,e.jsx)("div",{className:xwe,children:a}),(0,e.jsxs)("div",{className:_we,children:[s&&(0,e.jsx)(pwe,{className:Ewe}),(0,e.jsx)(CG,{className:jwe})]})]})})})},Game:function(){var t=C(Sa),n=t!==Oa.main&&t!==Oa.freeCamera,r=kk();XZ(!n);var o=(0,i.useContext)(Rl);(0,i.useEffect)((function(){var t=ee.subscribe((function(t){o.showDialog((0,e.jsx)(TN,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){GSe(e,t,n[t])}))}return e}({},t)))}));return function(){return t.dispose()}}),[o]);var a=C($u);return(0,i.useEffect)((function(){!n&&a&&Ca()}),[n,a]),(0,e.jsx)(QZ,{children:(0,e.jsx)(_u,{children:(0,e.jsx)(Tn,{actions:r,children:(0,e.jsx)(Ze,{focused:t,activation:Ue.Always,debugName:"GameUI",children:(0,e.jsxs)(nO,{children:[!n&&(0,e.jsx)(USe,{focusKey:Oa.main}),n&&(0,e.jsx)(sL,{children:(0,e.jsxs)(nO,{children:[t===Oa.pauseMenu&&(0,e.jsx)(L0,{focusKey:Oa.pauseMenu,onClose:Pa},Oa.pauseMenu),t===Oa.saveGame&&(0,e.jsx)(j5,{focusKey:Oa.saveGame,onClose:Ca},Oa.saveGame),t===Oa.newGame&&(0,e.jsx)(x2,{focusKey:Oa.newGame,onClose:Ca},Oa.newGame),t===Oa.loadGame&&(0,e.jsx)(m8,{focusKey:Oa.loadGame,onClose:Ca,requireConfirmation:!0},Oa.loadGame),t===Oa.options&&(0,e.jsx)(XA,{focusKey:Oa.options,onClose:Ca},Oa.options)]})},"pause"),t===Oa.freeCamera&&(0,e.jsx)(L8,{focusKey:Oa.freeCamera,onClose:Pa},Oa.freeCamera)]})})})})})},Editor:function(){var t=YZ((0,i.useState)(HZ.main),2),n=t[0],r=t[1],o=n!==HZ.main,a=(0,i.useCallback)((function(){r((function(e){return e!==HZ.pauseMenu?HZ.pauseMenu:HZ.main}))}),[]),l=(0,i.useCallback)((function(){return r(HZ.main)}),[]),s=(0,i.useCallback)((function(){return r(HZ.pauseMenu)}),[]),c=(0,i.useMemo)((function(){return{}}),[]),u=(0,i.useContext)(Rl);(0,i.useEffect)((function(){var t=ee.subscribe((function(t){u.showDialog((0,e.jsx)(TN,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zZ(e,t,n[t])}))}return e}({},t)))}));return function(){return t.dispose()}}),[u]);var d=(0,i.useCallback)((function(){u.showDialog((0,e.jsx)(SN,{message:(0,e.jsx)(Ks.Common.DIALOG_MESSAGE,{hash:"ProgressLoss"}),onConfirm:ad}))}),[u]);return(0,e.jsx)(Tn,{actions:c,children:(0,e.jsxs)(Ze,{focused:n,activation:Ue.Always,children:[(0,e.jsx)(KZ,{focusKey:HZ.main,onPauseMenuToggle:a}),(0,e.jsx)(nO,{children:o&&(0,e.jsx)(sL,{children:(0,e.jsxs)(nO,{children:[n===HZ.pauseMenu&&(0,e.jsx)(VN,{focusKey:HZ.pauseMenu,onSelectScreen:r,onClose:l,onNewMap:d},HZ.pauseMenu),n===HZ.options&&(0,e.jsx)(XA,{focusKey:HZ.options,onClose:s},HZ.options)]})},"pause")})]})})},None:null},ONe=function(){var t=C(Y)||"None",n=ENe[t];return(0,e.jsxs)(cw,{children:["None"!==t&&(0,e.jsx)(tw,{activeUiClassName:t.toLowerCase(),children:n&&(0,e.jsx)(n,{})}),(0,e.jsx)(xNe,{},"overlayUI")]})};a().whenReady.then((function(){var n=function(n){var o;n&&(i.dispose(),(0,t.s)((o=document.createElement("div"),o.className=r,document.body.appendChild(o),o)).render((0,e.jsx)(ONe,{})))},i=z.subscribe(n);n(i.value)}))})()})();